=== modified file '.bzrignore'
--- .bzrignore	2010-04-01 04:41:18 +0000
+++ .bzrignore	2009-10-07 15:48:32 +0000
@@ -67,4 +67,3 @@
 bzrlib/_*.so
 bzrlib/_*.pyd
 ./.ccache
-.testrepository

=== removed file '.testr.conf'
--- .testr.conf	2010-02-28 10:08:29 +0000
+++ .testr.conf	1970-01-01 00:00:00 +0000
@@ -1,3 +0,0 @@
-[DEFAULT]
-test_command=./bzr selftest --subunit $IDOPTION
-test_id_option=--load-list $IDFILE

=== modified file 'INSTALL'
--- INSTALL	2010-01-29 10:36:23 +0000
+++ INSTALL	2007-08-16 00:54:00 +0000
@@ -43,6 +43,5 @@
   python setup.py install
 
 For more information on installation, see
-<http://wiki.bazaar.canonical.com/InstallationFaq>
-or write to bazaar@lists.canonical.com, or ask a question at
-<https://answers.launchpad.net/bzr/>.
+http://bazaar-vcs.org/InstallationFaq
+or write to bazaar@lists.canonical.com.

=== removed file 'MANIFEST.in'
--- MANIFEST.in	2010-01-13 16:23:07 +0000
+++ MANIFEST.in	1970-01-01 00:00:00 +0000
@@ -1,3 +0,0 @@
-include bzr README setup.py
-recursive-include bzrlib *.py *.pyx *.pxd *.txt *.c *.h
-recursive-include tools *.py *.sh

=== modified file 'Makefile'
--- Makefile	2010-04-06 06:59:03 +0000
+++ Makefile	2009-12-07 18:12:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,10 +39,7 @@
 check: docs check-nodocs
 
 check-nodocs: extensions
-	# Generate a stream for PQM to watch.
-	$(PYTHON) -Werror -O ./bzr selftest --subunit $(tests) | tee selftest.log
-	# Check that there were no errors reported.
-	subunit-stats < selftest.log
+	$(PYTHON) -Werror -O ./bzr selftest -1v $(tests)
 
 # Run Python style checker (apt-get install pyflakes)
 #
@@ -202,6 +199,7 @@
 
 # translate txt docs to html
 derived_txt_files = \
+	doc/en/user-reference/bzr_man.txt \
 	doc/en/release-notes/NEWS.txt
 txt_all = \
 	doc/en/tutorials/tutorial.txt \
@@ -298,6 +296,9 @@
 %.html: %.txt
 	$(rst2html) --stylesheet=../../default.css $< $@
 
+doc/en/user-reference/bzr_man.txt: $(MAN_DEPENDENCIES)
+	$(PYTHON) tools/generate_docs.py -o $@ rstx
+
 doc/en/release-notes/NEWS.txt: NEWS
 	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"
 
@@ -409,7 +410,7 @@
 
 ### Packaging Targets ###
 
-.PHONY: dist check-dist-tarball
+.PHONY: dist dist-upload-escudero check-dist-tarball
 
 # build a distribution source tarball
 #
@@ -437,3 +438,18 @@
 	tar Cxz $$tmpdir -f $$tarball && \
 	$(MAKE) -C $$tmpdir/bzr-$$version check && \
 	rm -rf $$tmpdir
+
+
+# upload previously built tarball to the download directory on bazaar-vcs.org,
+# and verify that it can be downloaded ok.
+dist-upload-escudero:
+	version=`./bzr version --short` && \
+	tarball=../bzr-$$version.tar.gz && \
+	scp $$tarball $$tarball.sig \
+	    escudero.ubuntu.com:/srv/bazaar.canonical.com/www/releases/src \
+		&& \
+	echo verifying over http... && \
+	curl http://bazaar-vcs.org/releases/src/bzr-$$version.tar.gz \
+		| diff -s - $$tarball && \
+	curl http://bazaar-vcs.org/releases/src/bzr-$$version.tar.gz.sig \
+		| diff -s - $$tarball.sig 

=== modified file 'NEWS'
--- NEWS	2010-05-06 07:48:22 +0000
+++ NEWS	2010-01-07 03:03:01 +0000
@@ -5,784 +5,18 @@
 .. contents:: List of Releases
    :depth: 1
 
-bzr 2.2b3
-#########
-
-:2.2b3: NOT RELEASED YET
-
-Compatibility Breaks
-********************
-
-New Features
-************
-
-* ``bzr commit`` accepts ``-p`` (for "patch") as a shorter name for
-  ``--show-diff``.
-  (Parth Malwankar, #571467)
-  
-* ``bzr ignore`` now supports a ``--default-rules`` option that displays
-  the default ignore rules used by bzr. The flag ``--old-default-rules``
-  is no longer supported by ``ignore``.
-  (Parth Malwankar, #538703)
-
-* ``bzr pack`` now supports a ``--clean-obsolete-packs`` option that
-  can save disk space by deleting obsolete pack files created during the
-  pack operation.
-  (Parth Malwankar, #304320)
-
-Bug Fixes
-*********
-
-* ``.bazaar``, ``.bazaar/bazaar.conf`` and ``.bzr.log`` inherit user and
-  group ownership from the containing directory. This allow bzr to work
-  better with sudo.
-  (Martin <gzlist@googlemail.com>, Parth Malwankar, #376388)
-
-* ``bzr log --exclude-common-ancestry -r X..Y`` displays the revisions that
-  are part of Y ancestry but not part of X ancestry (aka the graph
-  difference).
-  (Vincent Ladeuil, #320119)
-
-* ``bzr selftest --parallel=fork`` wait for its children avoiding zombies.
-  (Vincent Ladeuil, #566670)
-
-* ``bzr selftest`` should not use ui.note() since it's not unicode safe.
-  (Vincent Ladeuil, #563997)
-
-* Don't mention --no-strict when we just issue the warning about unclean trees.
-  (Vincent Ladeuil, #401599)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
-* Reduce peak memory by one copy of compressed text.
-  (John Arbash Meinel, #566940)
-
-* Show the filenames when a file rename fails so that the error will be
-  more comprehensible.
-  (Martin Pool, #491763)
-
-Improvements
-************
-
-* ``append_revisions_only`` will now be interpreted as a boolean and a
-  warning emitted if illegal values are used. Note that for projects
-  that needs to maintain compatibility with previsous bzr versions,
-  only 'True' and 'False' strings must be used (previous versions of
-  bzr will interpret all strings differing from 'True'
-  (case-sensitive) as false.
-  (Brian de Alwis, Vincent Ladeuil)
-
-* ``Config.get_user_option_as_bool`` will now warn if a value cannot
-  be interpreted as a boolean.
-  (Vincent Ladeuil)
-
-Documentation
-*************
-
-API Changes
-***********
-
-* Added ``bzrlib.merge.PerFileMerger``, a more convenient way to write
-  some kinds of ``merge_file_content`` hook functions.
-  (Andrew Bennetts)
-  
-* `BzrDir`, `Branch`, `Repository` and `WorkingTree` now all support `user_url`,
-  `user_transport`, `control_url` and `control_transport` members pointing
-  respectively to the directory containing the ``.bzr`` control directory, 
-  and to the directory within ``.bzr`` used for the particular component.
-  All of them inherit from `ControlComponent` which provides default
-  implementations.
-  (Martin Pool)
-
-Internals
-*********
-
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
-* Permit bzr to run under ``python -OO`` which reduces the size of bytecode
-  files loaded from disk. To ensure docstrings needed for help are never
-  stripped, the prefix ``__doc__ =`` should now be used.
-  (Martin <gzlist@googlemail.com>)
-
-Testing
-*******
-
-* Added ``bzrlib.tests.matchers`` as a place to put matchers, along with
-  our first in-tree matcher. See the module docstring for details.
-  (Robert Collins)
-
-* ``bzr selftest --parallel=subprocess`` now works correctly on win32.
-   (Gordon Tyler, #551332)
-
-* Workaround ``Crypto.Random`` check leading to spurious test
-  failures on Lucid, FreeBSD and gentoo.  
-  (Vincent Ladeuil, #528436)
-
-bzr 2.2b2
-#########
-
-:2.2b2: 2010-04-16
-
-This is a somewhat early second beta of the 2.2 series, to fix a python2.4
-incompatibility in the 2.2b1 release.  It also includes a swag of
-performance, usability and correctness improvements: test feedback on all
-of these would be welcome.
-
-
-New Features
-************
-
-* ``bzr diff`` now supports a --format option, which can be used to 
-  select alternative diff formats. (Jelmer Vernooij, #555994)
-
-Bug Fixes
-*********
-
-* ``bzr dpush``, ``bzr push`` and ``bzr send`` will now issue a warning
-  instead of failing when dirty trees are involved. The corresponding
-  ``dpush_strict``, ``push_strict`` and ``send_strict`` should be set to
-  True explicitly to get the previous behaviour.  
-  (Vincent Ladeuil, #519319)
-
-* ``bzr export`` to tar file does not fail if any parent directory
-  contains unicode characters. This works around upstream Python bug
-  http://bugs.python.org/issue8396 .
-  (Parth Malwankar, #413406)
-
-* ``bzr switch`` does not die if a ConfigurableFileMerger is used.
-  (Aaron Bentley, #559436)
-
-* ``bzr update`` when a pending merge in the working tree has been merged
-  into the master branch will no longer claim that old commits have become
-  pending merges. (Robert Collins, #562079)
-
-* ``bzrlib.mutabletree.MutableTree.commit`` will now support a passed in
-  config as in previous versions of bzrlib. (Robert Collins)
-
-* Fix glitch in the warning about unclean trees display.
-  (Vincent Ladeuil, #562665)
-
-* Fixed Python2.4 incompatibilities in the bzr2.2b1 source tarball.
-  (Martin Pool)
-
-* Help messages generated by ``RegistryOption.from_kwargs`` list the
-  switches in alphabetical order, rather than in an undefined order.
-  (Martin von Gagern, #559409)
-
-* Make sure the ``ExecutablePath`` and ``InterpreterPath`` are set in
-  Apport crash reports, to avoid "This problem report applies to a program
-  which is not installed any more" error.
-  (Martin Pool, James Westby, #528114)
-
-* Reset ``siginterrupt`` flag to False every time we handle a signal
-  installed with ``set_signal_handler(..., restart_syscall=True)`` (from
-  ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
-  (Andrew Bennetts)
-
-* When invoked with a range revision, ``bzr log`` doesn't show revisions
-  that are not part of the Y revisions ancestry anymore when invoked with
-  -rX..Y.
-  (Vincent Ladeuil, #474807)
-
-* Properly handle ``param_name`` attribute for ``ListOption``.
-  (Martin von Gagern, 387117)
-
-Improvements
-************
-
-* ``bzr commit`` will prompt before using a commit message that was
-  generated by a template and not edited by the user.
-  (Robert Collins, #530265)
-
-* ``bzr diff`` read-locks the trees and branches only once, saving about
-  10-20ms on ``bzr diff`` in a bzr.dev tree.
-  (Andrew Bennetts)
-
-* ``bzr missing`` read-locks the branches only once.
-  (Andrew Bennetts)
-  
-* ``bzr pull`` locks the branches and tree only once.
-  (Andrew Bennetts)
-  
-* Index lookups in pack repositories search recently hit pack files first.  
-  In repositories with many pack files this can greatly reduce the
-  number of files accessed, the number of bytes read, and the number of
-  read calls.  An incremental pull via plain HTTP takes half the time and
-  bytes for a moderately large repository.  (Andrew Bennetts)
-
-* Index lookups only re-order the indexes when the hit files aren't
-  already first. Reduces the cost of reordering
-  (John Arbash Meinel, #562429)
-
-* Less code is loaded at startup.  (Cold-cache start time is about 10-20%
-  less.)
-  (Martin Pool, #553017)
-
-API Changes
-***********
-
-* ``bzrlib.diff.get_trees_and_branches_to_diff`` is deprecated.  Use
-  ``get_trees_and_branches_to_diff_locked`` instead.
-  (Andrew Bennetts)
-  
-Internals
-*********
-
-* ``bzrlib.commands.Command.run_direct`` is no longer needed - the pre
-  2.1 method of calling run() to perform testing or direct use via the API
-  is now possible again. As part of this, the _operation attribute on
-  Command is now transient and only exists for the duration of ``run()``.
-  (Robert Collins)
-
-bzr 2.2.0b1
-###########
-
-:2.2.0b1: 2010-04-01
-
-Compatibility Breaks
-********************
-
-* BTreeGraphIndex can now take an offset to indicate that the data starts
-  somewhere other than then beginning of the file. (John Arbash Meinel)
-
-* Deleted very old hidden commands ``versionedfile-list``,
-  ``weave-plan-merge``, ``weave-merge-text``.
-  (Martin Pool)
-
-* ``Repository.get_inventory_sha1()`` and ``Repository.get_revision_xml()`` 
-  have been removed. (Jelmer Vernooij)
-
-* ``Repository.get_revision_inventory()`` has been removed in favor of
-  ``Repository.get_inventory()``. (Jelmer Vernooij)
-
-* All test servers have been moved out of the bzrlib.transport hierarchy to
-  bzrlib.tests.test_server *except* for MemoryServer, ChrootServer and
-  PathFilteringServer. ``bzrlib`` users may encounter test failures that can
-  be fixed by updating the related imports from ``bzrlib.transport.xxx`` to
-  ``bzrlib.tests.test_server``.
-  (Vincent Ladeuil)
-
-* ``BranchReferenceFormat.initialize()`` now takes an optional name argument
-  as its second parameter, for consistency with the initialize() method of
-  other formats. (Jelmer Vernooij)
-
-New Features
-************
-
-* Added ``bzr remove-branch`` command that can remove a local or remote 
-  branch. (Jelmer Vernooij, #276295)
-
-* ``bzr export`` now takes an optional argument ``--per-file-timestamps``
-  to set file mtimes to the last timestamp of the last revision in which
-  they were changed rather than the current time. (Jelmer Vernooij)
-
-* If the Apport crash-reporting tool is available, bzr crashes are now
-  stored into the ``/var/crash`` apport spool directory, and the user is
-  invited to report them to the developers from there, either
-  automatically or by running ``apport-bug``.  No information is sent
-  without specific permission from the user.  (Martin Pool, #515052)
-
-* Parsing of command lines, for example in ``diff --using``, no longer
-  treats backslash as an escape character on Windows.   (Gordon Tyler,
-  #392248)
-
-* Plugins can be disabled by defining ``BZR_DISABLE_PLUGINS`` as
-  a list of plugin names separated by ':' (';' on windows).
-  (Vincent Ladeuil, #411413)
-
-* Plugins can be loaded from arbitrary locations by defining
-  ``BZR_PLUGINS_AT`` as a list of name@path separated by ':' (';' on
-  windows). This takes precedence over ``BZR_PLUGIN_PATH`` for the
-  specified plugins. This is targeted at plugin developers for punctual
-  needs and *not* intended to replace ``BZR_PLUGIN_PATH``.  
-  (Vincent Ladeuil, #82693)
-
-* Tag names can now be determined automatically by ``automatic_tag_name`` 
-  hooks on ``Branch`` if they are not specified on the command line.
-  (Jelmer Vernooij)
-
-* Tree-shape conflicts can be resolved by providing ``--take-this`` and
-  ``--take-other`` to the ``bzr resolve`` command. Just marking the conflict
-  as resolved is still accessible via the ``--done`` default action.
-  (Vincent Ladeuil)
-
-* Merges can be proposed on Launchpad with the new lp-propose-merge command.
-  (Aaron Bentley, Jonathan Lange)
-
-Bug Fixes
-*********
-
-* Added docstring for ``Tree.iter_changes``
-  (John Arbash Meinel, #304182)
-
-* Allow additional arguments to
-  ``RemoteRepository.add_inventory_by_delta()``. (Jelmer Vernooij, #532631)
-
-* Allow exporting a single file using ``bzr export``.
-  (Michal Junák, #511987)
-
-* Allow syscalls to automatically restart when ``TextUIFactory``'s
-  SIGWINCH handler is invoked, avoiding ``EINTR`` errors during blocking
-  IO, which are often poorly handled by Python's libraries and parts of
-  bzrlib.  (Andrew Bennetts, #496813)
-
-* Avoid infinite recursion when probing for apport.
-  (Vincent Ladeuil, #516934)
-
-* Avoid ``malloc(0)`` in ``patiencediff``, which is non-portable.
-  (Martin Pool, #331095)
-
-* Avoid truncating svn URLs.
-  (Martin Pool, Martin von Gagern, #545185)
-
-* ``bzr add`` will not add conflict related files unless explicitly required.
-  (Vincent Ladeuil, #322767, #414589)
-
-* ``bzr dump-btree`` now works on ``*.cix`` and ``*.six`` files.  Those
-  indices do not have reference lists, so ``dump-btree`` will simply show
-  ``None`` instead.  (Andrew Bennetts, #488607)
-
-* ``bzr help`` will no longer trigger the get_missing_command hook when
-  doing a topic lookup. This avoids prompting (like 'no command plugins/loom,
-  did you mean log?') when getting help. In future we may trigger the hook 
-  deliberately when no help topics match from any help index.
-  (Robert Collins, #396261)
-
-* ``bzr log -n0 -r..A.B.C`` should not crash but just consider the None
-  revspec as representing the first revision of the branch.
-  (Vincent Ladeuil, #519862)
-
-* ``bzr remove-tree`` can now remove multiple working trees.
-  (Jared Hance, Andrew Bennetts, #253137)
-
-* ``bzr resolve --take-this`` and ``--take-other`` now correctly renames
-  the kept file on content conflicts where one side deleted the file.
-  (Vincent Ladeuil, #529968)
-
-* ``bzr upgrade`` now creates the ``backup.bzr`` directory with the same
-  permissions as ``.bzr`` directory on a POSIX OS.
-  (Parth Malwankar, #262450)
-
-* ``bzr upgrade`` now names backup directory as ``backup.bzr.~N~`` instead
-  of ``backup.bzr``. This directory is ignored by bzr commands such as
-  ``add``.
-  (Parth Malwankar, #335033, #300001)
-
-* Cope with non-utf8 characters inside ``.bzrignore``.
-  (Jason Spashett, #183504)
-
-* Correctly interpret "451 Rename/move failure: Directory not empty" from
-  ftp servers while trying to take a lock.
-  (Martin Pool, #528722)
-
-* DirStateRevisionTree.kind() was returning wrong result when 'kind'
-  changes occured between the workingtree and one of its parents.
-  (Vincent Ladeuil, #535547)
-
-* Fix ``log`` to better check ancestors even if merged revisions are involved.
-  (Vincent Ladeuil, #476293)
-
-* Loading a plugin from a given path with ``BZR_PLUGINS_AT`` doesn't depend
-  on os.lisdir() order and is now reliable.
-  (Vincent Ladeuil, #552922).
-
-* Many IO operations that returned ``EINTR`` were retried even if it
-  wasn't safe to do so via careless use of ``until_no_eintr``.  Bazaar now
-  only retries operations that are safe to retry, and in some cases has
-  switched to operations that can be retried (e.g. ``sock.send`` rather than
-  ``sock.sendall``).
-  (Andrew Bennetts, Martin <gzlist@googlemail.com>, #496813)
-
-* Path conflicts now support --take-this and --take-other even when a
-  deletion is involved.
-  (Vincent Ladeuil, #531967)
-
-* Network transfer amounts and rates are now displayed in SI units according
-  to the Ubuntu Units Policy <https://wiki.ubuntu.com/UnitsPolicy>.
-  (Gordon Tyler, #514399)
-
-* Support kind markers for socket and fifo filesystem objects. This
-  prevents ``bzr status --short`` from crashing when those files are
-  present.  (John Arbash Meinel, #303275)
-
-* ``bzr mkdir DIR`` will not create DIR unless DIR's parent is a versioned
-   directory. (Parth Malwankar, #138600)
-
-* SSH child processes will now ignore SIGQUIT on nix systems so breaking into
-  the debugger won't kill the session.
-  (Martin <gzlist@googlemail.com>, #162502)
-
-* Tolerate patches with leading noise in ``bzr-handle-patch``.
-  (Toshio Kuratomi, Martin Pool, #502076)
-
-* ``update -r`` now supports updating to revisions that are not on
-  mainline (i.e. it supports dotted revisions).
-  (Parth Malwankar, #517800)
-
-* Use first apparent author not committer in GNU Changelog format.
-  (Martin von Gagern, #513322)
-
-API Changes
-***********
-
-* ``bzrlib.merge_directive._BaseMergeDirective`` has been renamed to 
-  ``bzrlib.merge_directive.BaseMergeDirective`` and is now public.
-  (Jelmer Vernooij)
-
-* ``BranchFormat.initialize`` now takes an optional ``name`` of the colocated 
-  branch to create. (Jelmer Vernooij)
-
-* ``BzrDir.get_branch_transport`` now takes an optional ``name`` of the 
-  colocated branch to open. (Jelmer Vernooij)
-
-* Added ``bzrlib.osutils.set_signal_handler``, a convenience function that
-  can set a signal handler and call ``signal.siginterrupt(signum,
-  False)`` for it, if the platform and Python version supports it.
-  (Andrew Bennetts, #496813)
-
-* New ``bzrlib.initialize`` is recommended for programs using bzrlib to 
-  run when starting up; it sets up several things that previously needed
-  to be done separately.
-  (Martin Pool, #507710)
-
-* Exporters now support a ``per_file_timestamps`` argument to write out the 
-  timestamp of the commit in which a file revision was introduced.
-  (Jelmer Vernooij)
-
-* New method ``BzrDir.list_branches()`` that returns a sequence of branches 
-  present in a control directory. (Jelmer Vernooij)
-
-* New method ``Repository.get_known_graph_ancestry()``. 
-  (Jelmer Vernooij, #495502)
-
-* New transport methods ``readlink``, ``symlink`` and ``hardlink``.
-  (Neil Santos)
-
-* Remove unused ``CommandFailed`` exception.
-  (Martin Pool)
-
-Internals
-*********
-
-* ``bzrlib.branchbuilder.BranchBuilder.build_snapshot`` now accepts a
-  ``message_callback`` in the same way that commit does. (Robert Collins)
-
-* ``bzrlib.builtins.Commit.run`` raises ``bzrlib.errors.BoundBranchOutOfDate``
-  rather than ``bzrlib.errors.BzrCommandError`` when the bound branch is out
-  of date. (Gary van der Merwe)
-
-* ``bzrlib.commands.run_bzr`` is more extensible: callers can supply the
-  functions to load or disable plugins if they wish to use a different
-  plugin mechanism; the --help, --version and no-command name code paths
-  now use the generic pluggable command lookup infrastructure.
-  (Robert Collins)
-
-* ``bzrlib.errors.BoundBranchOutOfDate`` has a new field ``extra_help``
-  which can be set to add extra help to the error. (Gary van der Merwe)
-
-* New method ``Branch.automatic_tag_name`` that can be used to find the
-  tag name for a particular revision automatically. (Jelmer Vernooij)
-
-* The methods ``BzrDir.create_branch()``, ``BzrDir.destroy_branch()`` and 
-  ``BzrDir.open_branch()`` now take an optional ``name`` argument. 
-  (Jelmer Vernooij)
-
-Testing
-*******
-
-* bzr now has a ``.testr.conf`` file in its source tree configured
-  appropriately for running tests with Testrepository
-  (``https://launchpad.net/testrepository``). (Robert Collins)
-
-* Documentation about testing with ``subunit`` has been tweaked.
-  (Robert Collins)
-
-* Known failures has been added for resolve --take-other on ParentLoop
-  conflicts. This reflects bug #537956 without fixing it.
-  (Vincent Ladeuil)
-
-* New ``bzrlib.tests.test_import_tariff`` can make assertions about what
-  Python modules are loaded, to guard against startup time or library
-  dependency regressions.
-  (Martin Pool)
-
-* PQM will now run with subunit output. To analyze a PQM error use
-  tribunal, or cat log | subunit-filter | subunit2pyunit. (Robert Collins)
-
-* Stop sending apport crash files to ``.cache`` in the directory from
-  which ``bzr selftest`` was run.  (Martin Pool, #422350)
-
-* Tests no longer fail if "close() called during concurrent
-  operation on the same file object" occurs when closing the log file
-  (which can happen if a thread tries to write to the log file at the
-  wrong moment).  An warning will be written to ``stderr`` when this
-  happens, and another warning will be written if the log file could not
-  be closed after retrying 100 times.  (Andrew Bennetts, #531746)
-
-bzr 2.1.2
-#########
-
-:2.1.2: NOT RELEASED YET
-
-Bug Fixes
-*********
-
-* ``bzr switch`` does not die if a ConfigurableFileMerger is used.
-  (Aaron Bentley, #559436)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
-* Reset ``siginterrupt`` flag to False every time we handle a signal
-  installed with ``set_signal_handler(..., restart_syscall=True)`` (from
-  ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
-  (Andrew Bennetts)
-
-Internals
-*********
-
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
-
-bzr 2.1.1
-#########
-
-:2.1.1: 2010-03-24
-
-This is a small bugfix release.  Upgrading is recommended for anyone
-running 2.1.0 or earlier.
-
-Bug Fixes
-*********
-
-* Allow syscalls to automatically restart when ``TextUIFactory``'s
-  SIGWINCH handler is invoked, avoiding ``EINTR`` errors during blocking
-  IO, which are often poorly handled by Python's libraries and parts of
-  bzrlib.  (Andrew Bennetts, #496813)
-
-* Avoid ``malloc(0)`` in ``patiencediff``, which is non-portable.
-  (Martin Pool, #331095)
-
-* Fix plugin packaging on Windows. (Ian Clatworthy, #524162)
-
-* Fix stub sftp test server to call os.getcwdu().
-  (Vincent Ladeuil, #526221, #526353)
-
-* Fixed CHM generation by moving the NEWS section template into
-  a separate file. (Ian Clatworthy, #524184)
-
-* Merge correctly when this_tree is not a WorkingTree.  (Aaron Bentley)
-
-* Register SIGWINCH handler only when creating a ``TextUIFactory``; avoids
-  problems importing bzrlib from a non-main thread.
-  (Elliot Murphy, #521989)
-
-* Repositories accessed via a smart server now reject being stacked on a
-  repository in an incompatible format, as is the case when accessing them
-  via other methods.  This was causing fetches from those repositories via
-  a smart server (e.g. using ``bzr branch``) to receive invalid data.
-  (Andrew Bennetts, #562380)
-
-* Standardize the error handling when creating a new ``StaticTuple``
-  (problems will raise TypeError). (Matt Nordhoff, #457979)
-
-* Warn if pyrex is too old to compile the new ``SimpleSet`` and
-  ``StaticTuple`` extensions, rather than having the build fail randomly.
-  (John Arbash Meinel, #449776)
-
-Documentation
-*************
-
-* Added a link to the Desktop Guide. (Ian Clatworthy)
-
-* Added What's New in Bazaar 2.1 document. (Ian Clatworthy)
-
-* Drop Google Analytics from the core docs as they caused problems
-  in the CHM files. (Ian Clatworthy, #502010)
-
-API Changes
-***********
-
-* Added ``bzrlib.osutils.set_signal_handler``, a convenience function that
-  can set a signal handler and call ``signal.siginterrupt(signum,
-  False)`` for it, if the platform and Python version supports it.
-  (Andrew Bennetts, #496813)
-
-
-bzr 2.1.0
-#########
-
-:Codename: Strasbourg
-:2.1.0: 2010-02-11
-
-This release marks our second long-term-stable series. The Bazaar team
-has decided that we will continue to make bugfix-only 2.0.x and 2.1.x
-releases, along with 2.2 development releases. 
-
-This is a fairly incremental update, focusing on polish and bugfixing.
-There are no changes for supported disk formats. Key updates include
-reduced memory consumption for many operations, a new per-file merge
-hook, ignore patterns can now include '!' to exclude files, globbing
-support for all commands on Windows, and support for addressing home
-directories via ``bzr+ssh://host/~/`` syntax.
-
-Users are encouraged to upgrade from the 2.0 stable series.
-
-Bug Fixes
-*********
-
-* Don't require testtools to use sftp.
-  (Vincent Ladeuil, #516183)
-
-* Fix "AttributeError in Inter1and2Helper" during fetch.
-  (Martin Pool, #513432)
-
-* ``bzr update`` performs the two merges in a more logical order and will stop
-  when it encounters conflicts.  
-  (Gerard Krol, #113809)
-
-* Give a better error message when doing ``bzr bind`` in an already bound
-  branch.  (Neil Martinsen-Burrell, #513063)
-
-* Ignore ``KeyError`` from ``remove_index`` during ``_abort_write_group``
-  in a pack repository, which can happen harmlessly if the abort occurs during
-  finishing the write group.  Also use ``bzrlib.cleanup`` so that any
-  other errors that occur while aborting the individual packs won't be
-  hidden by secondary failures when removing the corresponding indices.
-  (Andrew Bennetts, #423015)
-
-* Set the mtime of files exported to a directory by ``bzr export`` all to
-  the same value to avoid confusing ``make`` and other date-based build
-  systems. (Robert Collins, #515631)
-
-Improvements
-************
-
-* Fetching into experimental formats will now print a warning. (Jelmer
-  Vernooij)
-
-API Changes
-***********
-
-* ``Repository.deserialise_inventory`` has been renamed to 
-  ``Repository._deserialise_inventory`` to indicate it is private.
-  (Jelmer Vernooij)
-
-* ``Repository.get_inventory_xml`` has been renamed to 
-  ``Repository._get_inventory_xml`` to indicate it is private. 
-  (Jelmer Vernooij)
-
-* ``Repository.serialise_inventory`` has been renamed to 
-  ``Repository._serialise_inventory`` to indicate it is private.
-
-* Using the ``bzrlib.chk_map`` module from within multiple threads at the
-  same time was broken due to race conditions with a module level page
-  cache. This shows up as a KeyError in the ``bzrlib.lru_cache`` code with
-  ``bzrlib.chk_map`` in the backtrace, and can be triggered without using
-  the same high level objects such as ``bzrlib.repository.Repository``
-  from different threads. chk_map now uses a thread local cache which may
-  increase memory pressure on processes using threads.
-  (Robert Collins, John Arbash Meinel, #514090)
-
-* The new ``merge_file_content`` should now be ok with tests to avoid
-  regressions.
-  (Vincent Ladeuil, #515597)
-
-Internals
-*********
-
-* Use ``bzrlib.cleanup`` rather than less robust ``try``/``finally``
-  blocks in several places in ``bzrlib.merge``.  This avoids masking prior
-  errors when errors like ``ImmortalPendingDeletion`` occur during cleanup
-  in ``do_merge``.
-  (Andrew Bennetts, #517275)
-
-API Changes
-***********
-
-* The ``remove_index`` method of
-  ``bzrlib.repofmt.pack_repo.AggregateIndex`` no longer takes a ``pack``
-  argument.  This argument was always ignored.
-  (Andrew Bennetts, #423015)
-
-bzr 2.1.0rc2
-############
-
-:Codename: after the bubbles
-:2.1.0rc2: 2010-01-29
-
-This is a quick-turn-around to update a small issue with our new per-file
-merge hook. We expect no major changes from this to the final 2.1.0.
-
-API Changes
-***********
-
-* The new ``merge_file_content`` hook point has been altered to provide a
-  better API where state for extensions can be stored rather than the
-  too-simple function based approach. This fixes a performance regression
-  where branch configuration would be parsed per-file during merge. As
-  part of this the included news_merger has been refactored into a base
-  helper class ``bzrlib.merge.ConfigurableFileMerger``.
-  (Robert Collins, John Arbash Meinel, #513822)
-
-
-bzr 2.1.0rc1
-############
+bzr 2.1.0rc1 (not released yet)
+###############################
 
 :Codename: the 'new' stable
-:2.1.0rc1: 2009-01-21
-
-This is the first stable release candidate for Bazaar's 2.1 series. From
-this point onwards, the 2.1 series will be considered stable (as the 2.0
-series) and only bugfixes are expected to be incorporated. The dozen or so
-bugfixes in the 2.0.4 release are also included in this release (along
-with more than 15 more bugfixes). Some of the interesting features are
-support for per-file merge hooks, ``bzr unshelve --preview``, support
-for using ! in ignore files to exclude files from being ignored, a small
-memory leak was squashed, and many ``ObjectNotLocked`` errors were fixed.
-This looks to be a very good start for a new stable series.
-
+:2.1.0rc1: 2009-01-06 (expected)
+
+Compatibility Breaks
+********************
 
 New Features
 ************
 
-* Add bug information to log output when available.
-  (Neil Martinsen-Burrell, Guillermo Gonzalez, #251729)
-
-* Added ``merge_file_content`` hook point to ``Merger``, allowing plugins
-  to register custom merge logic, e.g. to provide smarter merging for
-  particular files.
-
-* Bazaar now includes the ``news_merge`` plugin.  It is disabled by
-  default, to enable it add a ``news_merge_files`` option to your
-  configuration.  Consult ``bzr help news_merge`` for more information.
-  (Andrew Bennetts)
-  
-* ``bzr branch`` now takes a ``--bind`` option. This lets you
-  branch and bind all in one command. (Ian Clatworthy)
-
-* ``bzr switch`` now takes a ``--revision`` option, to allow switching to
-  a specific revision of a branch. (Daniel Watkins, #183559)
-
-* ``bzr unshelve --preview`` can now be used to show how a patch on the
-  shelf would be applied to the working tree.
-  (Guilherme Salgado, #308122)
-
 * ``bzr update`` now takes a ``--revision`` argument. This lets you
   change the revision of the working tree to any revision in the
   ancestry of the current or master branch. (Matthieu Moy, Mark Hammond,
@@ -792,29 +26,26 @@
   transferred for the current command. This information is always logged
   to ``.bzr.log`` for later inspection. (John Arbash Meinel)
 
-* New ignore patterns.  Patterns prefixed with '!' are exceptions to 
-  ignore patterns and take precedence over regular ignores.  Such 
-  exceptions are used to specify files that should be versioned which 
-  would otherwise be ignored.  Patterns prefixed with '!!' act as regular 
-  ignore patterns, but have highest precedence, even over the '!' 
-  exception patterns. (John Whitley, #428031)
-
-* The ``supress_warnings`` configuration option has been introduced to disable
-  various warnings (it currently only supports the ``format_deprecation``
-  warning). The new option can be set in any of the following locations:
-  ``bazaar.conf``, ``locations.conf`` and/or ``branch.conf``.
+* The ``suppress_warnings`` configuration option has been introduced and
+  accept the ``format_deprecation`` value to disable the corresponding
+  warning for repositories. It can be set to in either ``bazaar.conf``,
+  ``locations.conf`` or ``branch.conf``.
   (Ted Gould, Matthew Fuller, Vincent Ladeuil)
 
+
 Bug Fixes
 *********
 
-* Always show a message if an OS error occurs while trying to run a
-  user-specified commit message editor.
-  (Martin Pool, #504842)
+* ``bzr export dir`` now requests all file content as a record stream,
+  rather than requsting the file content one file-at-a-time. This can make
+  exporting over the network significantly faster (54min => 9min in one
+  case). (John Arbash Meinel, #343218)
 
-* ``bzr diff`` will now use the epoch when it is unable to determine 
-  the timestamp of a file, if the revision it was introduced in is a
-  ghost. (Jelmer Vernooij, #295611)
+* ``bzr serve`` no longer slowly leaks memory. The compiled
+  ``bzrlib.bencode.Encoder()`` class was using ``__del__`` to cleanup and
+  free resources, and it should have been using ``__dealloc__``.
+  This will likely have an impact on any other process that is serving for
+  an extended period of time.  (John Arbash Meinel, #494406)
 
 * ``bzr switch -b`` can now create branches that are located using directory
   services such as ``lp:``, even when the branch name doesn't contain a
@@ -823,65 +54,27 @@
 * ``bzr unshelve`` has improved messages about what it is doing.
   (Neil Martinsen-Burrell, #496917)
 
-* Concurrent autopacking is more resilient to already-renamed pack files.
-  If we find that a file we are about to obsolete is already obsoleted, we
-  do not try to rename it, and we leave the file in ``obsolete_packs``.
-  The code is also fault tolerant if a file goes missing, assuming that
-  another process already removed the file.
-  (John Arbash Meinel, Gareth White, #507557)
-
-* Fix "Too many concurrent requests" in reconcile when network connection
-  fails.  (Andrew Bennetts, #503878)
-
-* Fixed a side effect mutation of ``RemoteBzrDirFormat._network_name``
-  that caused some tests to fail when run in a non-default order.
-  Probably no user impact.  (Martin Pool, #504102)
-
-* Fixed ``ObjectNotLocked`` error in ``bzr cat -rbranch:../foo FILE``.
-  (Andrew Bennetts, #506274)
-
-* FTP transports support Unicode paths by encoding/decoding them as utf8.
-  (Vincent Ladeuil, #472161)
+* Check for SIGINT (Ctrl-C) and other signals immediately if ``readdir``
+  returns ``EINTR`` by calling ``PyErr_CheckSignals``.  This affected the
+  optional ``_readdir_pyx`` extension.  (Andrew Bennetts, #495023)
+
+* Give a clearer message if the lockdir disappears after being apparently
+  successfully taken.  (Martin Pool, #498378)
 
 * Listen to the SIGWINCH signal to update the terminal width.
   (Vincent Ladeuil, #316357)
 
-* Progress bars are now hidden when ``--quiet`` is given.
-  (Martin Pool, #320035)
-
-* ``SilentUIFactory`` now supports ``make_output_stream`` and discards
-  whatever is written to it.  This un-breaks some plugin tests that
-  depended on this behaviour.
-  (Martin Pool, #499757)
-
-* When operations update the working tree, all affected files should end
-  up with the same mtime. (eg. when versioning a generated file, if you
-  update the source and the generated file together, the generated file
-  should appear up-to-date.)
-  (John Arbash Meinel, Martin <gzlist>, #488724)
+* The 2a format wasn't properly restarting autopacks when something
+  changed underneath it (like another autopack). Now concurrent
+  autopackers will properly succeed. (John Arbash Meinel, #495000)
 
 Improvements
 ************
 
-* Added ``add_cleanup`` and ``cleanup_now`` to ``bzrlib.command.Command``.
-  All the builtin commands now use ``add_cleanup`` rather than
-  ``try``/``finally`` blocks where applicable as it is simpler and more
-  robust.  (Andrew Bennetts)
-
-* All except a small number of storage formats are now hidden, making
-  the help for numerous commands far more digestible. (Ian Clatworthy)
-
-* Attempts to open a shared repository as a branch (e.g. ``bzr branch
-  path/to/repo``) will now include "location is a repository" as a hint in
-  the error message.  (Brian de Alwis, Andrew Bennetts, #440952)
-
 * Push will now inform the user when they are trying to push to a foreign 
   VCS for which roundtripping is not supported, and will suggest them to 
   use dpush. (Jelmer Vernooij)
 
-* The version of bzr being run is now written to the log file.
-  (__monty__, #257170)
-
 * Transport network activity indicator is shown more of the time when
   Bazaar is doing network IO.
   (Martin Pool)
@@ -889,47 +82,18 @@
 Documentation
 *************
 
-* Add documentation on creating merges with more than one parent.
-  (Neil Martinsen-Burrell, #481526)
-
-* Better explain the --uncommitted option of merge.
-  (Neil Martinsen-Burrell, #505088)
-
-* Improve discussion of pending merges in the documentation for
-  ``revert``.  (Neil Martinsen-Burrell, #505093)
-
-* Improved help for ``bzr send``. 
-  (Martin Pool, Bojan Nikolic)
-
 * There is a System Administrator's Guide in ``doc/en/admin-guide``,
   including discussions of installation, relevant plugins, security and 
-  backup. (Neil Martinsen-Burrell)
-
-* The ``conflicts`` help topic has been renamed to ``conflict-types``.
-  (Ian Clatworthy)
-
-* The User Reference is now presented as a series of topics.
-  Many of the included topics have link and format tweaks applied.
-  (Ian Clatworthy)
+  backup.
 
 API Changes
 ***********
 
-* Added ``cachedproperty`` decorator to ``bzrlib.decorators``.
-  (Andrew Bennetts)
-
 * Many test features were renamed from ``FooFeature`` to ``foo_feature``
   to be consistent with instances being lower case and classes being
   CamelCase. For the features that were more likely to be used, we added a
   deprecation thunk, but not all. (John Arbash Meinel)
 
-* Merger classes (such as ``Merge3Merger``) now expect a ``this_branch``
-  parameter in their constructors, and provide ``this_branch`` as an
-  attribute. (Andrew Bennetts)
-  
-* The Branch hooks pre_change_branch_tip no longer masks exceptions raised
-  by plugins - the original exceptions are now preserved. (Robert Collins)
-
 * The Transport ``Server.tearDown`` method is now renamed to
   ``stop_server`` and ``setUp`` to ``start_server`` for consistency with
   our normal naming pattern, and to avoid confusion with Python's
@@ -941,10 +105,6 @@
 Internals
 *********
 
-* Added ``BzrDir.open_branchV3`` smart server request, which can receive
-  a string of details (such as "location is a repository") as part of a
-  ``nobranch`` response.  (Andrew Bennetts, #440952)
-  
 * New helper osutils.UnicodeOrBytesToBytesWriter which encodes unicode
   objects but passes str objects straight through. This is used for
   selftest but may be useful for diff and other operations that generate
@@ -969,116 +129,24 @@
   testtools less than 0.9.2 will cause bzr to error while loading the test
   suite. (Robert Collins)
 
-* Shell-like tests now support the command "mv" for moving files.  The
-  syntax for ``mv file1 file2``, ``mv dir1 dir2`` and ``mv file dir`` is
-  supported.  (Neil Martinsen-Burrell)
-
 * The test progress bar no longer distinguishes tests that 'errored' from
   tests that 'failed' - they're all just failures.
   (Martin Pool)
 
-bzr 2.0.6
-#########
-
-:2.0.6: NOT RELEASED YET
-
-Bug Fixes
-*********
-
-* Additional merges after an unrelated branch has been merged with its
-  history no longer crash when deleted files are involved.
-  (Vincent Ladeuil, John Arbash Meinel, #375898)
-
-* ``bzr revert`` now only takes write lock on working tree, instead of on 
-  both working tree and branch.
-  (Danny van Heumen, #498409)
-
-* ``bzr upgrade`` now creates the ``backup.bzr`` directory with the same
-  permissions as ``.bzr`` directory on a POSIX OS.
-  (Parth Malwankar, #262450)
-
-* Repositories accessed via a smart server now reject being stacked on a
-  repository in an incompatible format, as is the case when accessing them
-  via other methods.  This was causing fetches from those repositories via
-  a smart server (e.g. using ``bzr branch``) to receive invalid data.
-  (Andrew Bennetts, #562380)
-
-bzr 2.0.5
-#########
-
-:2.0.5: 2010-03-23
-
-This fifth release in our 2.0 series addresses several user-inconvenience
-bugs.  None are critical, but upgrading is recommended for all users on
-earlier 2.0 releases.
-
-Bug Fixes
-*********
-
-* Avoid ``malloc(0)`` in ``patiencediff``, which is non-portable.
-  (Martin Pool, #331095)
-
-* Concurrent autopacking is more resilient to already-renamed pack files.
-  If we find that a file we are about to obsolete is already obsoleted, we
-  do not try to rename it, and we leave the file in ``obsolete_packs``.
-  The code is also fault tolerant if a file goes missing, assuming that
-  another process already removed the file.
-  (John Arbash Meinel, Gareth White, #507557)
-
-* Cope with the lockdir ``held/info`` file being empty, which seems to
-  happen fairly often if the process is suddenly interrupted while taking
-  a lock.
-  (Martin Pool, #185103)
-
-* Give the warning about potentially slow cross-format fetches much
-  earlier on in the fetch operation.  Don't show this message during
-  upgrades, and show the correct format indication for remote
-  repositories.
-  (Martin Pool, #456077, #515356, #513157)
-
-* Handle renames correctly when there are files or directories that 
-  differ only in case.  (Chris Jones, Martin Pool, #368931)
-
-* If ``bzr push --create-prefix`` triggers an unexpected ``NoSuchFile``
-  error, report that error rather than failing with an unhelpful
-  ``UnboundLocalError``.
-  (Andrew Bennetts, #423563)
-
-* Running ``bzr`` command without any arguments now shows bzr
-  version number along with rest of the help text.
-  (Parth Malwankar, #369501)
-
-* Use osutils.O_NOINHERIT for some files on win32 to avoid PermissionDenied
-  errors.
-  (Inada Naoki, #524560)
-
-Documentation
-*************
-
-* Added ``location-alias`` help topic.
-  (Andrew Bennetts, #337834)
-
-* Fixed CHM generation by moving the NEWS section template into
-  a separate file. (Ian Clatworthy, #524184)
-
-
-bzr 2.0.4
-#########
-
-:Codename: smooth sailing
-:2.0.4: 2010-01-21
-
-The fourth bugfix-only release in the 2.0 series contains more than a
-dozen bugfixes relative to 2.0.3. The primary focus is on handling
-interruptions and concurrent operations more cleanly, there is also a fair
-improvement to ``bzr export`` when exporting a remote branch.
-
-
-Bug Fixes
-*********
-
-* ``bzr annotate`` on another branch with ``-r branch:...`` no longer
-  fails with an ``ObjectNotLocked`` error.  (Andrew Bennetts, #496590)
+bzr 2.0.4 (not released yet)
+############################
+
+:Codename:
+:2.0.4: smooth sailing
+
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Bug Fixes
+*********
 
 * ``bzr export dir`` now requests all file content as a record stream,
   rather than requsting the file content one file-at-a-time. This can make
@@ -1095,55 +163,32 @@
   returns ``EINTR`` by calling ``PyErr_CheckSignals``.  This affected the
   optional ``_readdir_pyx`` extension.  (Andrew Bennetts, #495023)
 
-* Concurrent autopacks will no longer lose a newly created pack file.
-  There was a race condition, where if the reload happened at the right
-  time, the second packer would forget the name of the newly added pack
-  file. (John Arbash Meinel, Gareth White, #507566)
-
 * Give a clearer message if the lockdir disappears after being apparently
   successfully taken.  (Martin Pool, #498378)
 
-* Give a warning when fetching between repositories (local or remote) with
-  sufficiently different formats that the content will need to be
-  serialized (ie ``InterDifferingSerializer`` or ``inventory-deltas``), so
-  the user has a clue that upgrading could make it faster.
-  (Martin Pool, #456077)
-
-* If we fail to open ``~/.bzr.log`` write a clear message to stderr rather
-  than using ``warning()``. The log file is opened before logging is set
-  up, and it leads to very confusing: 'no handlers for "bzr"' messages for
-  users, rather than something nicer.
-  (John Arbash Meinel, Barry Warsaw, #503886)
-
-* Refuse to build with any Pyrex 0.9.4 release, as they have known bugs.
-  (Martin Pool, John Arbash Meinel, #449372)
-
-* ``setup.py bdist_rpm`` now properly finds extra files needed for the
-  build. (there is still the distutils bug
-  http://bugs.python.org/issue644744) (Joe Julian, #175839)
-
 * The 2a format wasn't properly restarting autopacks when something
   changed underneath it (like another autopack). Now concurrent
   autopackers will properly succeed. (John Arbash Meinel, #495000)
 
-* ``TreeTransform`` can now handle when a delta says that the file id for
-  the tree root changes. Rather than trying to rename your working
-  directory, or failing early saying that you can't have multiple
-  tree roots. This also fixes revert, update, and pull when the root id
-  changes.  (John Arbash Meinel, #494269, #504390)
-
 * ``_update_current_block`` no longer suppresses exceptions, so ^C at just
   the right time will get propagated, rather than silently failing to move
   the block pointer. (John Arbash Meinel, Gareth White, #495023)
 
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+Internals
+*********
+
 Testing
 *******
 
-* We have a new ``test_source`` that ensures all pyrex ``cdef`` functions
-  handle exceptions somehow. (Possibly by setting ``# cannot_raise``
-  rather than an ``except ?:`` clause.) This should help prevent bugs like
-  bug #495023. (John Arbash Meinel)
-
 
 bzr 2.1.0b4
 ###########
@@ -1204,7 +249,7 @@
   and issues a warning.
   (Gioele Barabucci, #73073)
 
-* ``bzr ignore /`` no longer causes an IndexError. (Gorden Tyler, #456036)
+* ``bzr ignore /`` no longer causes an IndexError. (Gorder Tyler, #456036)
 
 * ``bzr log -n0 -rN`` should not return revisions beyond its merged revisions.
   (#325618, #484109, Marius Kruger)
@@ -1386,8 +431,6 @@
 
 * Fix for shell completion and short options.  (Benoît PIERRE)
 
-* Fix ``bzr --profile-imports`` with Python 2.6.  (Martin Pool)
-
 * Hooks daughter classes should always call the base constructor.
   (Alexander Belchenko, Vincent Ladeuil, #389648) 
 
@@ -1455,9 +498,6 @@
 * ``--parallel=fork`` is now compatible with --subunit.
   (Robert Collins, Vincent Ladeuil, #419776)
 
-* Reporting of failures shows test ids not descriptions and thus shows
-  parameterised tests correctly. (Robert Collins)
-
 * TestNotApplicable is now handled within the TestCase.run method rather
   than being looked for within ``ExtendedTestResult.addError``. This
   provides better handling with other ``TestResult`` objects, degrading to
@@ -12542,5 +11582,37 @@
   diff, status, etc.
 
 
+bzr ?.?.? (not released yet)
+############################
+
+:Codename: template
+:2.0.2: ???
+
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Bug Fixes
+*********
+
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
+
+
 ..
-   vim: tw=74 ft=rst ff=unix encoding=utf-8
+   vim: tw=74 ft=rst ff=unix

=== removed file 'NEWS-template.txt'
--- NEWS-template.txt	2010-02-19 07:13:45 +0000
+++ NEWS-template.txt	1970-01-01 00:00:00 +0000
@@ -1,31 +0,0 @@
-bzr ?.?.?
-#########
-
-:Codename: Nirvana
-:2.x.y: NOT RELEASED YET
-
-Compatibility Breaks
-********************
-
-New Features
-************
-
-Bug Fixes
-*********
-
-Improvements
-************
-
-Documentation
-*************
-
-API Changes
-***********
-
-Internals
-*********
-
-Testing
-*******
-
-

=== modified file 'README'
--- README	2010-01-29 14:09:05 +0000
+++ README	2009-10-06 07:41:02 +0000
@@ -3,24 +3,25 @@
 =================
 
 Bazaar (``bzr``) is a decentralized revision control system, designed to be
-easy for developers and end users alike.  Bazaar is part of the GNU project to
-develop a complete free operating system <http://www.gnu.org/>, and a project
-of Canonical <http://www.canonical.com/>.
-
-Ready-to-install packages are available for most popular operating systems from
-<http://wiki.bazaar.canonical.com/Download/> or you can install from source by
-following the instructions in the INSTALL file.
-
-To learn how to use Bazaar, see the official documentation in the `doc`
-directory or at <http://doc.bazaar.canonical.com/en/>.
+easy for developers and end users alike.  Bazaar is part of the GNU project
+to develop a complete free operating system.
+
+To install Bazaar, follow the instructions given at
+http://bazaar-vcs.org/Download. Ready-to-install packages are available
+for most popular operating systems or you can install from source.
+
+To learn how to use Bazaar, see the official documentation at:
+
+    http://doc.bazaar-vcs.org/en/
 
 For additional training materials including screencasts and slides,
 visit our community wiki documentation page at:
 
-    http://wiki.bazaar.canonical.com/Documentation/
+    http://bazaar-vcs.org/Documentation/
 
-Bazaar is Free Software, and is released under the GNU General Public License,
-version 2 or later.
+Bazaar is written in Python, and is sponsored by Canonical Limited, the
+founders of Ubuntu and Launchpad. Bazaar is Free Software, and is released
+under the GNU General Public License.
 
 Bazaar highlights
 =================

=== removed file 'README_BDIST_RPM'
--- README_BDIST_RPM	2010-01-10 02:25:31 +0000
+++ README_BDIST_RPM	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-There is a bug in disttools for distributions who's rpmbuild compresses 
-the man pages. This causes an error building the final packages as it's 
-expecting bzr.1 and not finding it, but finding bzr.1.gz that's unpackaged.
-
-This bug is known to affect Fedora, RHEL, and Centos distributions.
-
-There is a preliminary patch at http://bugs.python.org/issue644744 that
-fixes this issue with disttools.

=== removed directory 'apport'
=== removed file 'apport/README'
--- apport/README	2010-04-08 04:34:03 +0000
+++ apport/README	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-Bazaar supports semi-automatic bug reporting through Apport
-<https://launchpad.net/apport/>.
-
-If apport is not installed, an exception is printed to stderr in the usual way.
-
-For this to work properly it's suggested that two files be installed when a
-package of bzr is installed:
-
-``bzr.conf``
-    into ``/etc/apport/crashdb.conf.d``
-
-``source_bzr.py`` 
-    into ``/usr/share/apport/package-hooks``

=== removed file 'apport/bzr-crashdb.conf'
--- apport/bzr-crashdb.conf	2010-04-08 04:34:03 +0000
+++ apport/bzr-crashdb.conf	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-bzr = {
-	# most bzr bugs are upstream bugs; file them there
-	'impl': 'launchpad',
-	'project': 'bzr',
-	'bug_pattern_base': 'http://people.canonical.com/~pitti/bugpatterns',
-}

=== removed file 'apport/source_bzr.py'
--- apport/source_bzr.py	2010-04-08 04:34:03 +0000
+++ apport/source_bzr.py	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-'''apport package hook for Bazaar'''
-
-# Copyright (c) 2009, 2010 Canonical Ltd.
-# Author: Matt Zimmerman <mdz@canonical.com>
-#         and others
-
-from apport.hookutils import *
-import os
-
-bzr_log = os.path.expanduser('~/.bzr.log')
-dot_bzr = os.path.expanduser('~/.bazaar')
-
-def _add_log_tail(report):
-    # may have already been added in-process
-    if 'BzrLogTail' in report:
-        return
-
-    bzr_log_lines = open(bzr_log).readlines()
-    bzr_log_lines.reverse()
-
-    bzr_log_tail = []
-    blanks = 0
-    for line in bzr_log_lines:
-        if line == '\n':
-            blanks += 1
-        bzr_log_tail.append(line)
-        if blanks >= 2: 
-            break
-
-    bzr_log_tail.reverse()
-    report['BzrLogTail'] = ''.join(bzr_log_tail)
-
-
-def add_info(report):
-    _add_log_tail(report)
-    if 'BzrPlugins' not in report:
-        # may already be present in-process
-        report['BzrPlugins'] = command_output(['bzr', 'plugins', '-v'])
-        
-    # by default assume bzr crashes are upstream bugs; this relies on
-    # having a bzr entry under /etc/apport/crashdb.conf.d/
-    report['CrashDB'] = 'bzr'
-
-    # these may contain some sensitive info (smtp_passwords)
-    # TODO: strip that out and attach the rest
-
-    #attach_file_if_exists(report,
-    #	os.path.join(dot_bzr, 'bazaar.conf', 'BzrConfig')
-    #attach_file_if_exists(report,
-    #	os.path.join(dot_bzr, 'locations.conf', 'BzrLocations')
-
-        
-# vim: expandtab shiftwidth=4

=== modified file 'bzr'
--- bzr	2010-04-23 08:51:52 +0000
+++ bzr	2009-12-15 19:59:00 +0000
@@ -1,6 +1,6 @@
 #! /usr/bin/env python
 
-# Copyright (C) 2005, 2006, 2007, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,8 +23,11 @@
 import warnings
 
 # update this on each release
-_script_version = (2, 2, 0)
+_script_version = (2, 1, 0)
 
+if __doc__ is None:
+    print "bzr does not support python -OO."
+    sys.exit(2)
 try:
     version_info = sys.version_info
 except AttributeError:
@@ -135,12 +138,16 @@
 
 
 if __name__ == '__main__':
-    bzrlib.initialize()
+    bzrlib.trace.enable_default_logging()
     exit_val = bzrlib.commands.main()
 
     if profiling:
         profile_imports.log_stack_info(sys.stderr)
 
+    # run anything registered by atexit, because it won't be run in the normal
+    # way
+    sys.exitfunc()
+
     # By this point we really have completed everything we want to do, and
     # there's no point doing any additional cleanup.  Abruptly exiting here
     # stops any background threads getting into trouble as code is unloaded,
@@ -148,7 +155,18 @@
     # are just about to be discarded anyhow.  This does mean that atexit hooks
     # won't run but we don't use them.  Also file buffers won't be flushed,
     # but our policy is to always close files from a finally block. -- mbp 20070215
-    sys.exitfunc()
+    try:
+        sys.stdout.flush()
+        sys.stderr.flush()
+    except IOError, e:
+        import errno
+        if e.errno in [errno.EINVAL, errno.EPIPE]:
+            pass
+        else:
+            raise
+    if bzrlib.trace._trace_file:
+        # this is also _bzr_log
+        bzrlib.trace._trace_file.flush()
     os._exit(exit_val)
 else:
     raise ImportError("The bzr script cannot be imported.")

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2010-04-22 10:20:40 +0000
+++ bzrlib/__init__.py	2009-12-15 19:59:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -35,7 +35,7 @@
 IGNORE_FILENAME = ".bzrignore"
 
 
-__copyright__ = "Copyright 2005-2010 Canonical Ltd."
+__copyright__ = "Copyright 2005, 2006, 2007, 2008, 2009 Canonical Ltd."
 
 # same format as sys.version_info: "A tuple containing the five components of
 # the version number: major, minor, micro, releaselevel, and serial. All
@@ -44,10 +44,10 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 2, 0, 'dev', 1)
+version_info = (2, 1, 0, 'dev', 5)
 
-# API compatibility version
-api_minimum_version = (2, 2, 0)
+# API compatibility version: bzrlib is currently API compatible with 1.15.
+api_minimum_version = (2, 1, 0)
 
 
 def _format_version_tuple(version_info):
@@ -68,7 +68,7 @@
     >>> print _format_version_tuple((1, 1, 1, 'candidate', 2))
     1.1.1rc2
     >>> print bzrlib._format_version_tuple((2, 1, 0, 'beta', 1))
-    2.1b1
+    2.1.0b1
     >>> print _format_version_tuple((1, 4, 0))
     1.4.0
     >>> print _format_version_tuple((1, 4))
@@ -100,8 +100,6 @@
     elif release_type == 'dev':
         sub_string = 'dev' + str(sub)
     elif release_type in ('alpha', 'beta'):
-        if version_info[2] == 0:
-            main_version = '%d.%d' % version_info[:2]
         sub_string = release_type[0] + str(sub)
     elif release_type == 'candidate':
         sub_string = 'rc' + str(sub)
@@ -118,52 +116,3 @@
 def test_suite():
     import tests
     return tests.test_suite()
-
-
-def initialize(
-    setup_ui=True,
-    stdin=None, stdout=None, stderr=None):
-    """Set up everything needed for normal use of bzrlib.
-
-    Most applications that embed bzrlib, including bzr itself, should call
-    this function to initialize various subsystems.  
-
-    More options may be added in future so callers should use named arguments.
-
-    :param setup_ui: If true (default) use a terminal UI; otherwise 
-        something else must be put into `bzrlib.ui.ui_factory`.
-    :param stdin, stdout, stderr: If provided, use these for terminal IO;
-        otherwise use the files in `sys`.
-    """
-    # TODO: mention this in a guide to embedding bzrlib
-    #
-    # NB: This function tweaks so much global state it's hard to test it in
-    # isolation within the same interpreter.  It's not reached on normal
-    # in-process run_bzr calls.  If it's broken, we expect that
-    # TestRunBzrSubprocess may fail.
-    
-    import atexit
-    import bzrlib.trace
-
-    bzrlib.trace.enable_default_logging()
-    atexit.register(bzrlib.trace._flush_stdout_stderr)
-    atexit.register(bzrlib.trace._flush_trace)
-
-    import bzrlib.ui
-    if stdin is None:
-        stdin = sys.stdin
-    if stdout is None:
-        stdout = sys.stdout
-    if stderr is None:
-        stderr = sys.stderr
-
-    if setup_ui:
-        bzrlib.ui.ui_factory = bzrlib.ui.make_ui_for_terminal(
-            stdin, stdout, stderr)
-
-    if bzrlib.version_info[3] == 'final':
-        from bzrlib.symbol_versioning import suppress_deprecation_warnings
-        suppress_deprecation_warnings(override=True)
-
-    import bzrlib.osutils
-    atexit.register(osutils.report_extension_load_failures)

=== modified file 'bzrlib/_annotator_pyx.pyx'
--- bzrlib/_annotator_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_annotator_pyx.pyx	2009-07-08 17:09:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -83,14 +83,7 @@
     return 0
 
 
-cdef PyObject *_next_tuple_entry(object tpl, Py_ssize_t *pos): # cannot_raise
-    """Return the next entry from this tuple.
-
-    :param tpl: The tuple we are investigating, *must* be a PyTuple
-    :param pos: The last item we found. Will be updated to the new position.
-    
-    This cannot raise an exception, as it does no error checking.
-    """
+cdef PyObject *_next_tuple_entry(object tpl, Py_ssize_t *pos):
     pos[0] = pos[0] + 1
     if pos[0] >= PyTuple_GET_SIZE(tpl):
         return NULL

=== modified file 'bzrlib/_bencode_pyx.pyx'
--- bzrlib/_bencode_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_bencode_pyx.pyx	2010-01-04 02:25:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007,2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/_btree_serializer_py.py'
--- bzrlib/_btree_serializer_py.py	2010-02-17 17:11:16 +0000
+++ bzrlib/_btree_serializer_py.py	2009-11-07 00:28:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/_btree_serializer_pyx.pyx'
--- bzrlib/_btree_serializer_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_btree_serializer_pyx.pyx	2009-10-12 20:07:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -65,7 +65,7 @@
 
 
 # TODO: Find some way to import this from _dirstate_helpers
-cdef void* _my_memrchr(void *s, int c, size_t n): # cannot_raise
+cdef void* _my_memrchr(void *s, int c, size_t n):
     # memrchr seems to be a GNU extension, so we have to implement it ourselves
     # It is not present in any win32 standard library
     cdef char *pos

=== modified file 'bzrlib/_chk_map_py.py'
--- bzrlib/_chk_map_py.py	2010-02-17 17:11:16 +0000
+++ bzrlib/_chk_map_py.py	2009-10-21 21:27:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/_chk_map_pyx.pyx'
--- bzrlib/_chk_map_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_chk_map_pyx.pyx	2009-10-21 21:27:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -82,7 +82,7 @@
 _unknown = None
 
 # We shouldn't just copy this from _dirstate_helpers_pyx
-cdef void* _my_memrchr(void *s, int c, size_t n): # cannot_raise
+cdef void* _my_memrchr(void *s, int c, size_t n):
     # memrchr seems to be a GNU extension, so we have to implement it ourselves
     cdef char *pos
     cdef char *start

=== modified file 'bzrlib/_dirstate_helpers_pyx.pyx'
--- bzrlib/_dirstate_helpers_pyx.pyx	2010-02-23 07:43:11 +0000
+++ bzrlib/_dirstate_helpers_pyx.pyx	2010-01-05 04:08:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2010 Canonical Ltd
+# Copyright (C) 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -119,7 +119,7 @@
     # void *memrchr(void *s, int c, size_t len)
 
 
-cdef void* _my_memrchr(void *s, int c, size_t n): # cannot_raise
+cdef void* _my_memrchr(void *s, int c, size_t n):
     # memrchr seems to be a GNU extension, so we have to implement it ourselves
     cdef char *pos
     cdef char *start
@@ -156,16 +156,16 @@
         return None
     return <char*>found - <char*>_s
 
-
 cdef object safe_string_from_size(char *s, Py_ssize_t size):
     if size < 0:
+        # XXX: On 64-bit machines the <int> cast causes a C compiler warning.
         raise AssertionError(
-            'tried to create a string with an invalid size: %d'
-            % (size))
+            'tried to create a string with an invalid size: %d @0x%x'
+            % (size, <int>s))
     return PyString_FromStringAndSize(s, size)
 
 
-cdef int _is_aligned(void *ptr): # cannot_raise
+cdef int _is_aligned(void *ptr):
     """Is this pointer aligned to an integer size offset?
 
     :return: 1 if this pointer is aligned, 0 otherwise.
@@ -173,7 +173,7 @@
     return ((<intptr_t>ptr) & ((sizeof(int))-1)) == 0
 
 
-cdef int _cmp_by_dirs(char *path1, int size1, char *path2, int size2): # cannot_raise
+cdef int _cmp_by_dirs(char *path1, int size1, char *path2, int size2):
     cdef unsigned char *cur1
     cdef unsigned char *cur2
     cdef unsigned char *end1
@@ -295,7 +295,7 @@
 
 
 cdef int _cmp_path_by_dirblock_intern(char *path1, int path1_len,
-                                      char *path2, int path2_len): # cannot_raise
+                                      char *path2, int path2_len):
     """Compare two paths by what directory they are in.
 
     see ``_cmp_path_by_dirblock`` for details.
@@ -768,7 +768,7 @@
     state._dirblock_state = DirState.IN_MEMORY_UNMODIFIED
 
 
-cdef int minikind_from_mode(int mode): # cannot_raise
+cdef int minikind_from_mode(int mode):
     # in order of frequency:
     if S_ISREG(mode):
         return c"f"
@@ -915,8 +915,7 @@
     return link_or_sha1
 
 
-# TODO: Do we want to worry about exceptions here?
-cdef char _minikind_from_string(object string) except? -1:
+cdef char _minikind_from_string(object string):
     """Convert a python string to a char."""
     return PyString_AsString(string)[0]
 
@@ -954,7 +953,7 @@
     raise KeyError(PyString_FromStringAndSize(_minikind, 1))
 
 
-cdef int _versioned_minikind(char minikind): # cannot_raise
+cdef int _versioned_minikind(char minikind):
     """Return non-zero if minikind is in fltd"""
     return (minikind == c'f' or
             minikind == c'd' or
@@ -1374,7 +1373,7 @@
     def iter_changes(self):
         return self
 
-    cdef int _gather_result_for_consistency(self, result) except -1:
+    cdef void _gather_result_for_consistency(self, result):
         """Check a result we will yield to make sure we are consistent later.
         
         This gathers result's parents into a set to output later.
@@ -1382,7 +1381,7 @@
         :param result: A result tuple.
         """
         if not self.partial or not result[0]:
-            return 0
+            return
         self.seen_ids.add(result[0])
         new_path = result[1][1]
         if new_path:
@@ -1392,7 +1391,6 @@
             # Add the root directory which parent_directories does not
             # provide.
             self.search_specific_file_parents.add('')
-        return 0
 
     cdef int _update_current_block(self) except -1:
         if (self.block_index < len(self.state._dirblocks) and

=== modified file 'bzrlib/_groupcompress_pyx.pyx'
--- bzrlib/_groupcompress_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_groupcompress_pyx.pyx	2009-11-06 18:05:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -279,8 +279,7 @@
 
 
 cdef unsigned char *_decode_copy_instruction(unsigned char *bytes,
-    unsigned char cmd, unsigned int *offset,
-    unsigned int *length) nogil: # cannot_raise
+    unsigned char cmd, unsigned int *offset, unsigned int *length) nogil:
     """Decode a copy instruction from the next few bytes.
 
     A copy instruction is a variable number of bytes, so we will parse the

=== modified file 'bzrlib/_knit_load_data_pyx.pyx'
--- bzrlib/_knit_load_data_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_knit_load_data_pyx.pyx	2009-06-22 12:52:39 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -97,12 +97,11 @@
         self.end_str = NULL
         self.history_len = 0
 
-    cdef int validate(self) except -1:
+    cdef void validate(self):
         if not PyDict_CheckExact(self.cache):
             raise TypeError('kndx._cache must be a python dict')
         if not PyList_CheckExact(self.history):
             raise TypeError('kndx._history must be a python list')
-        return 0
 
     cdef object process_options(self, char *option_str, char *end):
         """Process the options string into a list."""

=== modified file 'bzrlib/_known_graph_py.py'
--- bzrlib/_known_graph_py.py	2010-02-17 17:11:16 +0000
+++ bzrlib/_known_graph_py.py	2009-11-30 17:25:22 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/_known_graph_pyx.pyx'
--- bzrlib/_known_graph_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_known_graph_pyx.pyx	2009-11-30 17:25:22 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -703,7 +703,7 @@
             self._revno_first, self._revno_second, self._revno_last,
             self.is_first_child, self.seen_by_child)
 
-    cdef int has_pending_parents(self): # cannot_raise
+    cdef int has_pending_parents(self):
         if self.left_pending_parent is not None or self.pending_parents:
             return 1
         return 0

=== modified file 'bzrlib/_patiencediff_c.c'
--- bzrlib/_patiencediff_c.c	2010-03-11 04:33:41 +0000
+++ bzrlib/_patiencediff_c.c	2009-10-29 06:11:23 +0000
@@ -1,5 +1,5 @@
 /*
- Copyright (C) 2007, 2010 Canonical Ltd
+ Copyright (C) 2007 Canonical Ltd
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
@@ -46,12 +46,6 @@
 #define SENTINEL -1
 
 
-/* malloc returns NULL on some platforms if you try to allocate nothing,
- * causing <https://bugs.edge.launchpad.net/bzr/+bug/511267> and
- * <https://bugs.edge.launchpad.net/bzr/+bug/331095>.  On glibc it passes, but
- * let's make it fail to aid testing. */
-#define guarded_malloc(x) ( (x) ? malloc(x) : NULL )
-
 enum {
     OP_EQUAL = 0,
     OP_INSERT,
@@ -189,8 +183,7 @@
     while (hsize < bsize + 1)
         hsize *= 2;
 
-    /* can't be 0 */
-    hashtable = (struct bucket *) guarded_malloc(sizeof(struct bucket) * hsize);
+    hashtable = (struct bucket *)malloc(sizeof(struct bucket) * hsize);
     if (hashtable == NULL) {
         PyErr_NoMemory();
         return 0;
@@ -467,7 +460,7 @@
     last_a_pos = alo - 1;
     last_b_pos = blo - 1;
 
-    lcs = (struct matching_line *)guarded_malloc(sizeof(struct matching_line) * (bhi - blo));
+    lcs = (struct matching_line *)malloc(sizeof(struct matching_line) * (bhi - blo));
     if (lcs == NULL)
         return 0;
 
@@ -627,15 +620,13 @@
     if (!equate_lines(&hashtable, a, b, asize, bsize))
         goto error;
 
-    if (bsize > 0) {
-        matches = (struct matching_line *)guarded_malloc(sizeof(struct matching_line) * bsize);
-        if (matches == NULL)
-            goto error;
+    matches = (struct matching_line *)malloc(sizeof(struct matching_line) * bsize);
+    if (matches == NULL)
+        goto error;
 
-        backpointers = (Py_ssize_t *)guarded_malloc(sizeof(Py_ssize_t) * bsize * 4);
-        if (backpointers == NULL)
-            goto error;
-    }
+    backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * bsize * 4);
+    if (backpointers == NULL)
+        goto error;
 
     nmatches = unique_lcs(matches, &hashtable, backpointers, a, b, 0, 0, asize, bsize);
 
@@ -701,19 +692,13 @@
         goto error;
 
     matches.count = 0;
-
-    if (bsize > 0) {
-        matches.matches = (struct matching_block *)guarded_malloc(sizeof(struct matching_block) * bsize);
-        if (matches.matches == NULL)
-            goto error;
-
-        backpointers = (Py_ssize_t *)guarded_malloc(sizeof(Py_ssize_t) * bsize * 4);
-        if (backpointers == NULL)
-            goto error;
-    } else {
-        matches.matches = NULL;
-        backpointers = NULL;
-    }
+    matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * bsize);
+    if (matches.matches == NULL)
+        goto error;
+
+    backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * bsize * 4);
+    if (backpointers == NULL)
+        goto error;
 
     res = recurse_matches(&matches, &hashtable, backpointers,
                           a, b, alo, blo, ahi, bhi, maxrecursion);
@@ -780,15 +765,11 @@
             return NULL;
         }
 
-        if (self->bsize > 0) {
-            self->backpointers = (Py_ssize_t *)guarded_malloc(sizeof(Py_ssize_t) * self->bsize * 4);
-            if (self->backpointers == NULL) {
-                Py_DECREF(self);
-                PyErr_NoMemory();
-                return NULL;
-            }
-        } else {
-            self->backpointers = NULL;
+        self->backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * self->bsize * 4);
+        if (self->backpointers == NULL) {
+            Py_DECREF(self);
+            PyErr_NoMemory();
+            return NULL;
         }
 
     }
@@ -831,13 +812,9 @@
     struct matching_blocks matches;
 
     matches.count = 0;
-    if (self->bsize > 0) {
-        matches.matches = (struct matching_block *)
-            guarded_malloc(sizeof(struct matching_block) * self->bsize);
-        if (matches.matches == NULL)
-            return PyErr_NoMemory();
-    } else
-        matches.matches = NULL;
+    matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * self->bsize);
+    if (matches.matches == NULL)
+        return PyErr_NoMemory();
 
     res = recurse_matches(&matches, &self->hashtable, self->backpointers,
                           self->a, self->b, 0, 0,
@@ -923,7 +900,7 @@
     struct matching_blocks matches;
 
     matches.count = 0;
-    matches.matches = (struct matching_block *)guarded_malloc(sizeof(struct matching_block) * (self->bsize + 1));
+    matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * (self->bsize + 1));
     if (matches.matches == NULL)
         return PyErr_NoMemory();
 
@@ -1036,7 +1013,7 @@
         return NULL;
 
     matches.count = 0;
-    matches.matches = (struct matching_block *)guarded_malloc(sizeof(struct matching_block) * (self->bsize + 1));
+    matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * (self->bsize + 1));
     if (matches.matches == NULL)
         return PyErr_NoMemory();
 
@@ -1054,7 +1031,7 @@
     matches.count++;
 
     ncodes = 0;
-    codes = (struct opcode *)guarded_malloc(sizeof(struct opcode) * matches.count * 2);
+    codes = (struct opcode *)malloc(sizeof(struct opcode) * matches.count * 2);
     if (codes == NULL) {
         free(matches.matches);
         return PyErr_NoMemory();
@@ -1275,7 +1252,3 @@
     PyModule_AddObject(m, "PatienceSequenceMatcher_c",
                        (PyObject *)&PatienceSequenceMatcherType);
 }
-
-
-/* vim: sw=4 et 
- */

=== modified file 'bzrlib/_readdir_py.py'
--- bzrlib/_readdir_py.py	2010-04-30 11:03:59 +0000
+++ bzrlib/_readdir_py.py	2009-03-23 14:59:43 +0000
@@ -17,6 +17,7 @@
 """Python implementation of readdir interface."""
 
 
+import os
 import stat
 
 

=== modified file 'bzrlib/_readdir_pyx.pyx'
--- bzrlib/_readdir_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_readdir_pyx.pyx	2009-12-23 02:19:04 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/_rio_pyx.pyx'
--- bzrlib/_rio_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_rio_pyx.pyx	2009-05-15 02:36:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -49,7 +49,7 @@
 
 from bzrlib.rio import Stanza
 
-cdef int _valid_tag_char(char c): # cannot_raise
+cdef int _valid_tag_char(char c):
     return (c == c'_' or c == c'-' or 
             (c >= c'a' and c <= c'z') or
             (c >= c'A' and c <= c'Z') or

=== modified file 'bzrlib/_simple_set_pyx.pxd'
--- bzrlib/_simple_set_pyx.pxd	2010-02-17 17:11:16 +0000
+++ bzrlib/_simple_set_pyx.pxd	2009-10-09 16:49:45 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -88,4 +88,4 @@
 cdef api int SimpleSet_Discard(object self, object key) except -1
 cdef api PyObject *SimpleSet_Get(SimpleSet self, object key) except? NULL
 cdef api Py_ssize_t SimpleSet_Size(object self) except -1
-cdef api int SimpleSet_Next(object self, Py_ssize_t *pos, PyObject **key) except -1
+cdef api int SimpleSet_Next(object self, Py_ssize_t *pos, PyObject **key)

=== modified file 'bzrlib/_simple_set_pyx.pyx'
--- bzrlib/_simple_set_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_simple_set_pyx.pyx	2009-10-14 15:57:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -540,8 +540,7 @@
     return _check_self(self)._used
 
 
-cdef api int SimpleSet_Next(object self, Py_ssize_t *pos,
-                            PyObject **key) except -1:
+cdef api int SimpleSet_Next(object self, Py_ssize_t *pos, PyObject **key):
     """Walk over items in a SimpleSet.
 
     :param pos: should be initialized to 0 by the caller, and will be updated
@@ -568,8 +567,7 @@
     return 1
 
 
-cdef int SimpleSet_traverse(SimpleSet self, visitproc visit,
-                            void *arg) except -1:
+cdef int SimpleSet_traverse(SimpleSet self, visitproc visit, void *arg):
     """This is an implementation of 'tp_traverse' that hits the whole table.
 
     Cython/Pyrex don't seem to let you define a tp_traverse, and they only

=== modified file 'bzrlib/_static_tuple_c.c'
--- bzrlib/_static_tuple_c.c	2010-02-23 07:43:11 +0000
+++ bzrlib/_static_tuple_c.c	2009-10-27 14:07:16 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2009, 2010 Canonical Ltd
+/* Copyright (C) 2009 Canonical Ltd
  * 
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -140,6 +140,10 @@
 StaticTuple_New(Py_ssize_t size)
 {
     StaticTuple *stuple;
+    if (size < 0) {
+        PyErr_BadInternalCall();
+        return NULL;
+    }
 
     if (size < 0 || size > 255) {
         /* Too big or too small */
@@ -276,14 +280,6 @@
         return NULL;
     }
     len = PyTuple_GET_SIZE(args);
-    if (len < 0 || len > 255) {
-        /* Check the length here so we can raise a TypeError instead of
-         * StaticTuple_New's ValueError.
-         */
-        PyErr_SetString(PyExc_TypeError, "StaticTuple(...)"
-            " takes from 0 to 255 items");
-        return NULL;
-    }
     self = (StaticTuple *)StaticTuple_New(len);
     if (self == NULL) {
         return NULL;

=== modified file 'bzrlib/_static_tuple_c.pxd'
--- bzrlib/_static_tuple_c.pxd	2010-02-17 17:11:16 +0000
+++ bzrlib/_static_tuple_c.pxd	2009-10-21 21:27:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/_static_tuple_py.py'
--- bzrlib/_static_tuple_py.py	2010-02-23 07:43:11 +0000
+++ bzrlib/_static_tuple_py.py	2009-11-28 21:54:08 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -34,15 +34,15 @@
 
     def __init__(self, *args):
         """Create a new 'StaticTuple'"""
-        num_keys = len(args)
-        if num_keys < 0 or num_keys > 255:
-            raise TypeError('StaticTuple(...) takes from 0 to 255 items')
         for bit in args:
             if type(bit) not in (str, StaticTuple, unicode, int, long, float,
                                  None.__class__, bool):
                 raise TypeError('StaticTuple can only point to'
                     ' StaticTuple, str, unicode, int, long, float, bool, or'
                     ' None not %s' % (type(bit),))
+        num_keys = len(args)
+        if num_keys < 0 or num_keys > 255:
+            raise ValueError('must have 1 => 256 key bits')
         # We don't need to pass args to tuple.__init__, because that was
         # already handled in __new__.
         tuple.__init__(self)

=== modified file 'bzrlib/_walkdirs_win32.pyx'
--- bzrlib/_walkdirs_win32.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_walkdirs_win32.pyx	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -109,7 +109,7 @@
                                  wcslen(data.cFileName))
 
 
-cdef int _get_mode_bits(WIN32_FIND_DATAW *data): # cannot_raise
+cdef int _get_mode_bits(WIN32_FIND_DATAW *data):
     cdef int mode_bits
 
     mode_bits = 0100666 # writeable file, the most common
@@ -121,13 +121,13 @@
     return mode_bits
 
 
-cdef __int64 _get_size(WIN32_FIND_DATAW *data): # cannot_raise
+cdef __int64 _get_size(WIN32_FIND_DATAW *data):
     # Pyrex casts a DWORD into a PyLong anyway, so it is safe to do << 32
     # on a DWORD
     return ((<__int64>data.nFileSizeHigh) << 32) + data.nFileSizeLow
 
 
-cdef double _ftime_to_timestamp(FILETIME *ft): # cannot_raise
+cdef double _ftime_to_timestamp(FILETIME *ft):
     """Convert from a FILETIME struct into a floating point timestamp.
 
     The fields of a FILETIME structure are the hi and lo part
@@ -147,7 +147,7 @@
     return (val * 1.0e-7) - 11644473600.0
 
 
-cdef int _should_skip(WIN32_FIND_DATAW *data): # cannot_raise
+cdef int _should_skip(WIN32_FIND_DATAW *data):
     """Is this '.' or '..' so we should skip it?"""
     if (data.cFileName[0] != c'.'):
         return 0

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2010-04-30 11:03:59 +0000
+++ bzrlib/add.py	2009-04-04 02:50:01 +0000
@@ -16,11 +16,15 @@
 
 """Helper functions for adding files to working trees."""
 
+import errno
+import os
 import sys
 
 import bzrlib.bzrdir
+import bzrlib.errors as errors
 import bzrlib.osutils
 from bzrlib.symbol_versioning import *
+from bzrlib.workingtree import WorkingTree
 
 
 class AddAction(object):

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/atomicfile.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2004, 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,6 +16,7 @@
 
 
 import os
+import sys
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -59,7 +60,7 @@
 
         self.realfilename = filename
 
-        flags = os.O_EXCL | os.O_CREAT | os.O_WRONLY | osutils.O_NOINHERIT
+        flags = os.O_EXCL | os.O_CREAT | os.O_WRONLY
         if mode == 'wb':
             flags |= osutils.O_BINARY
         elif mode != 'wt':

=== modified file 'bzrlib/benchmarks/bench_dirstate.py'
--- bzrlib/benchmarks/bench_dirstate.py	2010-02-17 17:11:16 +0000
+++ bzrlib/benchmarks/bench_dirstate.py	2009-12-22 17:05:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/benchmarks/bench_knit.py'
--- bzrlib/benchmarks/bench_knit.py	2010-01-25 17:48:22 +0000
+++ bzrlib/benchmarks/bench_knit.py	2009-08-11 03:26:03 +0000
@@ -61,12 +61,20 @@
 
     def setup_load_data_c(self):
         self.requireFeature(CompiledKnitFeature)
+        orig = knit._load_data
+        def reset():
+            knit._load_data = orig
+        self.addCleanup(reset)
         from bzrlib._knit_load_data_pyx import _load_data_c
-        self.overrideAttr(knit, '_load_data', _load_data_c)
+        knit._load_data = _load_data_c
 
     def setup_load_data_py(self):
+        orig = knit._load_data
+        def reset():
+            knit._load_data = orig
+        self.addCleanup(reset)
         from bzrlib._knit_load_data_py import _load_data_py
-        self.overrideAttr(knit, '_load_data', _load_data_py)
+        knit._load_data = _load_data_py
 
     def test_read_50k_index_c(self):
         self.setup_load_data_c()

=== modified file 'bzrlib/benchmarks/tree_creator/kernel_like.py'
--- bzrlib/benchmarks/tree_creator/kernel_like.py	2010-03-25 09:39:03 +0000
+++ bzrlib/benchmarks/tree_creator/kernel_like.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -48,8 +48,7 @@
         if self._url is not None:
             b = bzrdir.BzrDir.create_branch_convenience(self._url)
             d = bzrdir.BzrDir.create(root)
-            bzrlib.branch.BranchReferenceFormat().initialize(d,
-                target_branch=b)
+            bzrlib.branch.BranchReferenceFormat().initialize(d, b)
             tree = d.create_workingtree()
         else:
             tree = bzrdir.BzrDir.create_standalone_workingtree(root)

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2010-04-28 09:40:23 +0000
+++ bzrlib/branch.py	2009-12-17 10:01:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,12 +63,23 @@
 BZR_BRANCH_FORMAT_6 = "Bazaar Branch Format 6 (bzr 0.15)\n"
 
 
-class Branch(bzrdir.ControlComponent):
+# TODO: Maybe include checks for common corruption of newlines, etc?
+
+# TODO: Some operations like log might retrieve the same revisions
+# repeatedly to calculate deltas.  We could perhaps have a weakref
+# cache in memory to make this faster.  In general anything can be
+# cached in memory between lock and unlock operations. .. nb thats
+# what the transaction identity map provides
+
+
+######################################################################
+# branch objects
+
+class Branch(object):
     """Branch holding a history of revisions.
 
-    :ivar base:
-        Base directory/url of the branch; using control_url and
-        control_transport is more standardized.
+    base
+        Base directory/url of the branch.
 
     hooks: An instance of BranchHooks.
     """
@@ -76,14 +87,6 @@
     # - RBC 20060112
     base = None
 
-    @property
-    def control_transport(self):
-        return self._transport
-
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
     def __init__(self, *ignored, **ignored_too):
         self.tags = self._format.make_tags(self)
         self._revision_history_cache = None
@@ -104,7 +107,7 @@
         """Activate the branch/repository from url as a fallback repository."""
         repo = self._get_fallback_repository(url)
         if repo.has_same_location(self.repository):
-            raise errors.UnstackableLocationError(self.user_url, url)
+            raise errors.UnstackableLocationError(self.base, url)
         self.repository.add_fallback_repository(repo)
 
     def break_lock(self):
@@ -164,13 +167,13 @@
         """
         control = bzrdir.BzrDir.open(base, _unsupported,
                                      possible_transports=possible_transports)
-        return control.open_branch(unsupported=_unsupported)
+        return control.open_branch(_unsupported)
 
     @staticmethod
-    def open_from_transport(transport, name=None, _unsupported=False):
+    def open_from_transport(transport, _unsupported=False):
         """Open the branch rooted at transport"""
         control = bzrdir.BzrDir.open_from_transport(transport, _unsupported)
-        return control.open_branch(name=name, unsupported=_unsupported)
+        return control.open_branch(_unsupported)
 
     @staticmethod
     def open_containing(url, possible_transports=None):
@@ -214,9 +217,9 @@
     def _get_fallback_repository(self, url):
         """Get the repository we fallback to at url."""
         url = urlutils.join(self.base, url)
-        a_branch = Branch.open(url,
+        a_bzrdir = bzrdir.BzrDir.open(url,
             possible_transports=[self.bzrdir.root_transport])
-        return a_branch.repository
+        return a_bzrdir.open_branch().repository
 
     def _get_tags_bytes(self):
         """Get the bytes of a serialised tags dict.
@@ -417,8 +420,6 @@
             * 'include' - the stop revision is the last item in the result
             * 'with-merges' - include the stop revision and all of its
               merged revisions in the result
-            * 'with-merges-without-common-ancestry' - filter out revisions 
-              that are in both ancestries
         :param direction: either 'reverse' or 'forward':
             * reverse means return the start_revision_id first, i.e.
               start at the most recent revision and go backwards in history
@@ -446,16 +447,14 @@
         # start_revision_id.
         if self._merge_sorted_revisions_cache is None:
             last_revision = self.last_revision()
-            known_graph = self.repository.get_known_graph_ancestry(
-                [last_revision])
+            last_key = (last_revision,)
+            known_graph = self.repository.revisions.get_known_graph_ancestry(
+                [last_key])
             self._merge_sorted_revisions_cache = known_graph.merge_sort(
-                last_revision)
+                last_key)
         filtered = self._filter_merge_sorted_revisions(
             self._merge_sorted_revisions_cache, start_revision_id,
             stop_revision_id, stop_rule)
-        # Make sure we don't return revisions that are not part of the
-        # start_revision_id ancestry.
-        filtered = self._filter_start_non_ancestors(filtered)
         if direction == 'reverse':
             return filtered
         if direction == 'forward':
@@ -498,18 +497,6 @@
                        node.end_of_merge)
                 if rev_id == stop_revision_id:
                     return
-        elif stop_rule == 'with-merges-without-common-ancestry':
-            # We want to exclude all revisions that are already part of the
-            # stop_revision_id ancestry.
-            graph = self.repository.get_graph()
-            ancestors = graph.find_unique_ancestors(start_revision_id,
-                                                    [stop_revision_id])
-            for node in rev_iter:
-                rev_id = node.key[-1]
-                if rev_id not in ancestors:
-                    continue
-                yield (rev_id, node.merge_depth, node.revno,
-                       node.end_of_merge)
         elif stop_rule == 'with-merges':
             stop_rev = self.repository.get_revision(stop_revision_id)
             if stop_rev.parent_ids:
@@ -538,51 +525,6 @@
         else:
             raise ValueError('invalid stop_rule %r' % stop_rule)
 
-    def _filter_start_non_ancestors(self, rev_iter):
-        # If we started from a dotted revno, we want to consider it as a tip
-        # and don't want to yield revisions that are not part of its
-        # ancestry. Given the order guaranteed by the merge sort, we will see
-        # uninteresting descendants of the first parent of our tip before the
-        # tip itself.
-        first = rev_iter.next()
-        (rev_id, merge_depth, revno, end_of_merge) = first
-        yield first
-        if not merge_depth:
-            # We start at a mainline revision so by definition, all others
-            # revisions in rev_iter are ancestors
-            for node in rev_iter:
-                yield node
-
-        clean = False
-        whitelist = set()
-        pmap = self.repository.get_parent_map([rev_id])
-        parents = pmap.get(rev_id, [])
-        if parents:
-            whitelist.update(parents)
-        else:
-            # If there is no parents, there is nothing of interest left
-
-            # FIXME: It's hard to test this scenario here as this code is never
-            # called in that case. -- vila 20100322
-            return
-
-        for (rev_id, merge_depth, revno, end_of_merge) in rev_iter:
-            if not clean:
-                if rev_id in whitelist:
-                    pmap = self.repository.get_parent_map([rev_id])
-                    parents = pmap.get(rev_id, [])
-                    whitelist.remove(rev_id)
-                    whitelist.update(parents)
-                    if merge_depth == 0:
-                        # We've reached the mainline, there is nothing left to
-                        # filter
-                        clean = True
-                else:
-                    # A revision that is not part of the ancestry of our
-                    # starting revision.
-                    continue
-            yield (rev_id, merge_depth, revno, end_of_merge)
-
     def leave_lock_in_place(self):
         """Tell this branch object not to release the physical lock when this
         object is unlocked.
@@ -605,11 +547,11 @@
         :param other: The branch to bind to
         :type other: Branch
         """
-        raise errors.UpgradeRequired(self.user_url)
+        raise errors.UpgradeRequired(self.base)
 
     def set_append_revisions_only(self, enabled):
         if not self._format.supports_set_append_revisions_only():
-            raise errors.UpgradeRequired(self.user_url)
+            raise errors.UpgradeRequired(self.base)
         if enabled:
             value = 'True'
         else:
@@ -663,7 +605,7 @@
     def get_old_bound_location(self):
         """Return the URL of the branch we used to be bound to
         """
-        raise errors.UpgradeRequired(self.user_url)
+        raise errors.UpgradeRequired(self.base)
 
     def get_commit_builder(self, parents, config=None, timestamp=None,
                            timezone=None, committer=None, revprops=None,
@@ -747,7 +689,7 @@
             stacking.
         """
         if not self._format.supports_stacking():
-            raise errors.UnstackableBranchFormat(self._format, self.user_url)
+            raise errors.UnstackableBranchFormat(self._format, self.base)
         # XXX: Changing from one fallback repository to another does not check
         # that all the data you need is present in the new fallback.
         # Possibly it should.
@@ -904,7 +846,7 @@
 
     def unbind(self):
         """Older format branches cannot bind or unbind."""
-        raise errors.UpgradeRequired(self.user_url)
+        raise errors.UpgradeRequired(self.base)
 
     def last_revision(self):
         """Return last revision id, or NULL_REVISION."""
@@ -1070,7 +1012,7 @@
         try:
             return urlutils.join(self.base[:-1], parent)
         except errors.InvalidURLJoin, e:
-            raise errors.InaccessibleParent(parent, self.user_url)
+            raise errors.InaccessibleParent(parent, self.base)
 
     def _get_parent_location(self):
         raise NotImplementedError(self._get_parent_location)
@@ -1161,7 +1103,15 @@
         params = ChangeBranchTipParams(
             self, old_revno, new_revno, old_revid, new_revid)
         for hook in hooks:
-            hook(params)
+            try:
+                hook(params)
+            except errors.TipChangeRejected:
+                raise
+            except Exception:
+                exc_info = sys.exc_info()
+                hook_name = Branch.hooks.get_hook_name(hook)
+                raise errors.HookFailed(
+                    'pre_change_branch_tip', hook_name, exc_info)
 
     @needs_write_lock
     def update(self):
@@ -1375,8 +1325,7 @@
         if lightweight:
             format = self._get_checkout_format()
             checkout = format.initialize_on_transport(t)
-            from_branch = BranchReferenceFormat().initialize(checkout, 
-                target_branch=self)
+            from_branch = BranchReferenceFormat().initialize(checkout, self)
         else:
             format = self._get_checkout_format()
             checkout_branch = bzrdir.BzrDir.create_branch_convenience(
@@ -1424,18 +1373,6 @@
     def supports_tags(self):
         return self._format.supports_tags()
 
-    def automatic_tag_name(self, revision_id):
-        """Try to automatically find the tag name for a revision.
-
-        :param revision_id: Revision id of the revision.
-        :return: A tag name or None if no tag name could be determined.
-        """
-        for hook in Branch.hooks['automatic_tag_name']:
-            ret = hook(self, revision_id)
-            if ret is not None:
-                return ret
-        return None
-
     def _check_if_descendant_or_diverged(self, revision_a, revision_b, graph,
                                          other_branch):
         """Ensure that revision_b is a descendant of revision_a.
@@ -1505,14 +1442,14 @@
         return not (self == other)
 
     @classmethod
-    def find_format(klass, a_bzrdir, name=None):
+    def find_format(klass, a_bzrdir):
         """Return the format for the branch object in a_bzrdir."""
         try:
-            transport = a_bzrdir.get_branch_transport(None, name=name)
+            transport = a_bzrdir.get_branch_transport(None)
             format_string = transport.get_bytes("format")
             return klass._formats[format_string]
         except errors.NoSuchFile:
-            raise errors.NotBranchError(path=transport.base, bzrdir=a_bzrdir)
+            raise errors.NotBranchError(path=transport.base)
         except KeyError:
             raise errors.UnknownFormatError(format=format_string, kind='branch')
 
@@ -1554,29 +1491,20 @@
         """Return the short format description for this format."""
         raise NotImplementedError(self.get_format_description)
 
-    def _run_post_branch_init_hooks(self, a_bzrdir, name, branch):
-        hooks = Branch.hooks['post_branch_init']
-        if not hooks:
-            return
-        params = BranchInitHookParams(self, a_bzrdir, name, branch)
-        for hook in hooks:
-            hook(params)
-
-    def _initialize_helper(self, a_bzrdir, utf8_files, name=None,
-                           lock_type='metadir', set_format=True):
+    def _initialize_helper(self, a_bzrdir, utf8_files, lock_type='metadir',
+                           set_format=True):
         """Initialize a branch in a bzrdir, with specified files
 
         :param a_bzrdir: The bzrdir to initialize the branch in
         :param utf8_files: The files to create as a list of
             (filename, content) tuples
-        :param name: Name of colocated branch to create, if any
         :param set_format: If True, set the format with
             self.get_format_string.  (BzrBranch4 has its format set
             elsewhere)
         :return: a branch in this format
         """
-        mutter('creating branch %r in %s', self, a_bzrdir.user_url)
-        branch_transport = a_bzrdir.get_branch_transport(self, name=name)
+        mutter('creating branch %r in %s', self, a_bzrdir.transport.base)
+        branch_transport = a_bzrdir.get_branch_transport(self)
         lock_map = {
             'metadir': ('lock', lockdir.LockDir),
             'branch4': ('branch-lock', lockable_files.TransportLock),
@@ -1603,15 +1531,10 @@
         finally:
             if lock_taken:
                 control_files.unlock()
-        branch = self.open(a_bzrdir, name, _found=True)
-        self._run_post_branch_init_hooks(a_bzrdir, name, branch)
-        return branch
+        return self.open(a_bzrdir, _found=True)
 
-    def initialize(self, a_bzrdir, name=None):
-        """Create a branch of this format in a_bzrdir.
-        
-        :param name: Name of the colocated branch to create.
-        """
+    def initialize(self, a_bzrdir):
+        """Create a branch of this format in a_bzrdir."""
         raise NotImplementedError(self.initialize)
 
     def is_supported(self):
@@ -1647,11 +1570,10 @@
         """
         raise NotImplementedError(self.network_name)
 
-    def open(self, a_bzrdir, name=None, _found=False, ignore_fallbacks=False):
+    def open(self, a_bzrdir, _found=False, ignore_fallbacks=False):
         """Return the branch object for a_bzrdir
 
         :param a_bzrdir: A BzrDir that contains a branch.
-        :param name: Name of colocated branch to open
         :param _found: a private parameter, do not use it. It is used to
             indicate if format probing has already be done.
         :param ignore_fallbacks: when set, no fallback branches will be opened
@@ -1765,23 +1687,6 @@
             "multiple hooks installed for transform_fallback_location, "
             "all are called with the url returned from the previous hook."
             "The order is however undefined.", (1, 9), None))
-        self.create_hook(HookPoint('automatic_tag_name',
-            "Called to determine an automatic tag name for a revision."
-            "automatic_tag_name is called with (branch, revision_id) and "
-            "should return a tag name or None if no tag name could be "
-            "determined. The first non-None tag name returned will be used.",
-            (2, 2), None))
-        self.create_hook(HookPoint('post_branch_init',
-            "Called after new branch initialization completes. "
-            "post_branch_init is called with a "
-            "bzrlib.branch.BranchInitHookParams. "
-            "Note that init, branch and checkout (both heavyweight and "
-            "lightweight) will all trigger this hook.", (2, 2), None))
-        self.create_hook(HookPoint('post_switch',
-            "Called after a checkout switches branch. "
-            "post_switch is called with a "
-            "bzrlib.branch.SwitchHookParams.", (2, 2), None))
-
 
 
 # install the default hooks into the Branch class.
@@ -1826,84 +1731,6 @@
             self.old_revno, self.old_revid, self.new_revno, self.new_revid)
 
 
-class BranchInitHookParams(object):
-    """Object holding parameters passed to *_branch_init hooks.
-
-    There are 4 fields that hooks may wish to access:
-
-    :ivar format: the branch format
-    :ivar bzrdir: the BzrDir where the branch will be/has been initialized
-    :ivar name: name of colocated branch, if any (or None)
-    :ivar branch: the branch created
-
-    Note that for lightweight checkouts, the bzrdir and format fields refer to
-    the checkout, hence they are different from the corresponding fields in
-    branch, which refer to the original branch.
-    """
-
-    def __init__(self, format, a_bzrdir, name, branch):
-        """Create a group of BranchInitHook parameters.
-
-        :param format: the branch format
-        :param a_bzrdir: the BzrDir where the branch will be/has been
-            initialized
-        :param name: name of colocated branch, if any (or None)
-        :param branch: the branch created
-
-        Note that for lightweight checkouts, the bzrdir and format fields refer
-        to the checkout, hence they are different from the corresponding fields
-        in branch, which refer to the original branch.
-        """
-        self.format = format
-        self.bzrdir = a_bzrdir
-        self.name = name
-        self.branch = branch
-
-    def __eq__(self, other):
-        return self.__dict__ == other.__dict__
-
-    def __repr__(self):
-        if self.branch:
-            return "<%s of %s>" % (self.__class__.__name__, self.branch)
-        else:
-            return "<%s of format:%s bzrdir:%s>" % (
-                self.__class__.__name__, self.branch,
-                self.format, self.bzrdir)
-
-
-class SwitchHookParams(object):
-    """Object holding parameters passed to *_switch hooks.
-
-    There are 4 fields that hooks may wish to access:
-
-    :ivar control_dir: BzrDir of the checkout to change
-    :ivar to_branch: branch that the checkout is to reference
-    :ivar force: skip the check for local commits in a heavy checkout
-    :ivar revision_id: revision ID to switch to (or None)
-    """
-
-    def __init__(self, control_dir, to_branch, force, revision_id):
-        """Create a group of SwitchHook parameters.
-
-        :param control_dir: BzrDir of the checkout to change
-        :param to_branch: branch that the checkout is to reference
-        :param force: skip the check for local commits in a heavy checkout
-        :param revision_id: revision ID to switch to (or None)
-        """
-        self.control_dir = control_dir
-        self.to_branch = to_branch
-        self.force = force
-        self.revision_id = revision_id
-
-    def __eq__(self, other):
-        return self.__dict__ == other.__dict__
-
-    def __repr__(self):
-        return "<%s for %s to (%s, %s)>" % (self.__class__.__name__,
-            self.control_dir, self.to_branch,
-            self.revision_id)
-
-
 class BzrBranchFormat4(BranchFormat):
     """Bzr branch format 4.
 
@@ -1916,12 +1743,12 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 4"
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('revision-history', ''),
                       ('branch-name', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files, name=name,
+        return self._initialize_helper(a_bzrdir, utf8_files,
                                        lock_type='branch4', set_format=False)
 
     def __init__(self):
@@ -1932,7 +1759,7 @@
         """The network name for this format is the control dirs disk label."""
         return self._matchingbzrdir.get_format_string()
 
-    def open(self, a_bzrdir, name=None, _found=False, ignore_fallbacks=False):
+    def open(self, a_bzrdir, _found=False, ignore_fallbacks=False):
         """See BranchFormat.open()."""
         if not _found:
             # we are being called directly and must probe.
@@ -1940,7 +1767,6 @@
         return BzrBranch(_format=self,
                          _control_files=a_bzrdir._control_files,
                          a_bzrdir=a_bzrdir,
-                         name=name,
                          _repository=a_bzrdir.open_repository())
 
     def __str__(self):
@@ -1961,25 +1787,24 @@
         """
         return self.get_format_string()
 
-    def open(self, a_bzrdir, name=None, _found=False, ignore_fallbacks=False):
+    def open(self, a_bzrdir, _found=False, ignore_fallbacks=False):
         """See BranchFormat.open()."""
         if not _found:
-            format = BranchFormat.find_format(a_bzrdir, name=name)
+            format = BranchFormat.find_format(a_bzrdir)
             if format.__class__ != self.__class__:
                 raise AssertionError("wrong format %r found for %r" %
                     (format, self))
-        transport = a_bzrdir.get_branch_transport(None, name=name)
         try:
+            transport = a_bzrdir.get_branch_transport(None)
             control_files = lockable_files.LockableFiles(transport, 'lock',
                                                          lockdir.LockDir)
             return self._branch_class()(_format=self,
                               _control_files=control_files,
-                              name=name,
                               a_bzrdir=a_bzrdir,
                               _repository=a_bzrdir.find_repository(),
                               ignore_fallbacks=ignore_fallbacks)
         except errors.NoSuchFile:
-            raise errors.NotBranchError(path=transport.base, bzrdir=a_bzrdir)
+            raise errors.NotBranchError(path=transport.base)
 
     def __init__(self):
         super(BranchFormatMetadir, self).__init__()
@@ -2014,12 +1839,12 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 5"
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('revision-history', ''),
                       ('branch-name', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files, name)
+        return self._initialize_helper(a_bzrdir, utf8_files)
 
     def supports_tags(self):
         return False
@@ -2047,13 +1872,13 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 6"
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
                       ('branch.conf', ''),
                       ('tags', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files, name)
+        return self._initialize_helper(a_bzrdir, utf8_files)
 
     def make_tags(self, branch):
         """See bzrlib.branch.BranchFormat.make_tags()."""
@@ -2077,14 +1902,14 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 8"
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
                       ('branch.conf', ''),
                       ('tags', ''),
                       ('references', '')
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files, name)
+        return self._initialize_helper(a_bzrdir, utf8_files)
 
     def __init__(self):
         super(BzrBranchFormat8, self).__init__()
@@ -2113,13 +1938,13 @@
     This format was introduced in bzr 1.6.
     """
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
                       ('branch.conf', ''),
                       ('tags', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files, name)
+        return self._initialize_helper(a_bzrdir, utf8_files)
 
     def _branch_class(self):
         return BzrBranch7
@@ -2167,22 +1992,20 @@
         transport = a_bzrdir.get_branch_transport(None)
         location = transport.put_bytes('location', to_branch.base)
 
-    def initialize(self, a_bzrdir, name=None, target_branch=None):
+    def initialize(self, a_bzrdir, target_branch=None):
         """Create a branch of this format in a_bzrdir."""
         if target_branch is None:
             # this format does not implement branch itself, thus the implicit
             # creation contract must see it as uninitializable
             raise errors.UninitializableFormat(self)
-        mutter('creating branch reference in %s', a_bzrdir.user_url)
-        branch_transport = a_bzrdir.get_branch_transport(self, name=name)
+        mutter('creating branch reference in %s', a_bzrdir.transport.base)
+        branch_transport = a_bzrdir.get_branch_transport(self)
         branch_transport.put_bytes('location',
-            target_branch.bzrdir.user_url)
+            target_branch.bzrdir.root_transport.base)
         branch_transport.put_bytes('format', self.get_format_string())
-        branch = self.open(
-            a_bzrdir, name, _found=True,
+        return self.open(
+            a_bzrdir, _found=True,
             possible_transports=[target_branch.bzrdir.root_transport])
-        self._run_post_branch_init_hooks(a_bzrdir, name, branch)
-        return branch
 
     def __init__(self):
         super(BranchReferenceFormat, self).__init__()
@@ -2194,18 +2017,17 @@
         def clone(to_bzrdir, revision_id=None,
             repository_policy=None):
             """See Branch.clone()."""
-            return format.initialize(to_bzrdir, target_branch=a_branch)
+            return format.initialize(to_bzrdir, a_branch)
             # cannot obey revision_id limits when cloning a reference ...
             # FIXME RBC 20060210 either nuke revision_id for clone, or
             # emit some sort of warning/error to the caller ?!
         return clone
 
-    def open(self, a_bzrdir, name=None, _found=False, location=None,
+    def open(self, a_bzrdir, _found=False, location=None,
              possible_transports=None, ignore_fallbacks=False):
         """Return the branch that the branch reference in a_bzrdir points at.
 
         :param a_bzrdir: A BzrDir that contains a branch.
-        :param name: Name of colocated branch to open, if any
         :param _found: a private parameter, do not use it. It is used to
             indicate if format probing has already be done.
         :param ignore_fallbacks: when set, no fallback branches will be opened
@@ -2216,7 +2038,7 @@
         :param possible_transports: An optional reusable transports list.
         """
         if not _found:
-            format = BranchFormat.find_format(a_bzrdir, name=name)
+            format = BranchFormat.find_format(a_bzrdir)
             if format.__class__ != self.__class__:
                 raise AssertionError("wrong format %r found for %r" %
                     (format, self))
@@ -2224,8 +2046,7 @@
             location = self.get_reference(a_bzrdir)
         real_bzrdir = bzrdir.BzrDir.open(
             location, possible_transports=possible_transports)
-        result = real_bzrdir.open_branch(name=name, 
-            ignore_fallbacks=ignore_fallbacks)
+        result = real_bzrdir.open_branch(ignore_fallbacks=ignore_fallbacks)
         # this changes the behaviour of result.clone to create a new reference
         # rather than a copy of the content of the branch.
         # I did not use a proxy object because that needs much more extensive
@@ -2277,20 +2098,17 @@
     :ivar repository: Repository for this branch.
     :ivar base: The url of the base directory for this branch; the one
         containing the .bzr directory.
-    :ivar name: Optional colocated branch name as it exists in the control
-        directory.
     """
 
     def __init__(self, _format=None,
-                 _control_files=None, a_bzrdir=None, name=None,
-                 _repository=None, ignore_fallbacks=False):
+                 _control_files=None, a_bzrdir=None, _repository=None,
+                 ignore_fallbacks=False):
         """Create new branch object at a particular location."""
         if a_bzrdir is None:
             raise ValueError('a_bzrdir must be supplied')
         else:
             self.bzrdir = a_bzrdir
         self._base = self.bzrdir.transport.clone('..').base
-        self.name = name
         # XXX: We should be able to just do
         #   self.base = self.bzrdir.root_transport.base
         # but this does not quite work yet -- mbp 20080522
@@ -2303,11 +2121,7 @@
         Branch.__init__(self)
 
     def __str__(self):
-        if self.name is None:
-            return '%s(%s)' % (self.__class__.__name__, self.user_url)
-        else:
-            return '%s(%s,%s)' % (self.__class__.__name__, self.user_url,
-                self.name)
+        return '%s(%r)' % (self.__class__.__name__, self.base)
 
     __repr__ = __str__
 
@@ -2528,7 +2342,7 @@
         return result
 
     def get_stacked_on_url(self):
-        raise errors.UnstackableBranchFormat(self._format, self.user_url)
+        raise errors.UnstackableBranchFormat(self._format, self.base)
 
     def set_push_location(self, location):
         """See Branch.set_push_location."""
@@ -2724,7 +2538,7 @@
         if _mod_revision.is_null(last_revision):
             return
         if last_revision not in self._lefthand_history(revision_id):
-            raise errors.AppendRevisionsOnlyViolation(self.user_url)
+            raise errors.AppendRevisionsOnlyViolation(self.base)
 
     def _gen_revision_history(self):
         """Generate the revision history from last revision
@@ -2830,7 +2644,7 @@
         if branch_location is None:
             return Branch.reference_parent(self, file_id, path,
                                            possible_transports)
-        branch_location = urlutils.join(self.user_url, branch_location)
+        branch_location = urlutils.join(self.base, branch_location)
         return Branch.open(branch_location,
                            possible_transports=possible_transports)
 
@@ -2882,8 +2696,8 @@
         return stacked_url
 
     def _get_append_revisions_only(self):
-        return self.get_config(
-            ).get_user_option_as_bool('append_revisions_only')
+        value = self.get_config().get_user_option('append_revisions_only')
+        return value == 'True'
 
     @needs_write_lock
     def generate_revision_history(self, revision_id, last_rev=None,
@@ -2951,7 +2765,7 @@
     """
 
     def get_stacked_on_url(self):
-        raise errors.UnstackableBranchFormat(self._format, self.user_url)
+        raise errors.UnstackableBranchFormat(self._format, self.base)
 
 
 ######################################################################
@@ -3044,7 +2858,7 @@
         :param verbose: Requests more detailed display of what was checked,
             if any.
         """
-        note('checked branch %s format %s', self.branch.user_url,
+        note('checked branch %s format %s', self.branch.base,
             self.branch._format)
         for error in self.errors:
             note('found error:%s', error)
@@ -3379,7 +3193,7 @@
         if local and not bound_location:
             raise errors.LocalRequiresBoundBranch()
         master_branch = None
-        if not local and bound_location and self.source.user_url != bound_location:
+        if not local and bound_location and self.source.base != bound_location:
             # not pulling from master, so we need to update master.
             master_branch = self.target.get_master_branch(possible_transports)
             master_branch.lock_write()

=== modified file 'bzrlib/branchbuilder.py'
--- bzrlib/branchbuilder.py	2010-02-27 12:27:33 +0000
+++ bzrlib/branchbuilder.py	2009-08-05 02:12:22 +0000
@@ -103,11 +103,11 @@
         finally:
             tree.unlock()
 
-    def _do_commit(self, tree, message=None, message_callback=None, **kwargs):
+    def _do_commit(self, tree, message=None, **kwargs):
         reporter = commit.NullCommitReporter()
-        if message is None and message_callback is None:
+        if message is None:
             message = u'commit %d' % (self._branch.revno() + 1,)
-        return tree.commit(message, message_callback=message_callback,
+        return tree.commit(message,
             reporter=reporter,
             **kwargs)
 
@@ -162,7 +162,7 @@
 
     def build_snapshot(self, revision_id, parent_ids, actions,
         message=None, timestamp=None, allow_leftmost_as_ghost=False,
-        committer=None, timezone=None, message_callback=None):
+        committer=None, timezone=None):
         """Build a commit, shaped in a specific way.
 
         :param revision_id: The handle for the new commit, can be None
@@ -175,8 +175,6 @@
             ('rename', ('orig-path', 'new-path'))
         :param message: An optional commit message, if not supplied, a default
             commit message will be written.
-        :param message_callback: A message callback to use for the commit, as
-            per mutabletree.commit.
         :param timestamp: If non-None, set the timestamp of the commit to this
             value.
         :param timezone: An optional timezone for timestamp.
@@ -246,8 +244,7 @@
             for file_id, content in new_contents.iteritems():
                 tree.put_file_bytes_non_atomic(file_id, content)
             return self._do_commit(tree, message=message, rev_id=revision_id,
-                timestamp=timestamp, timezone=timezone, committer=committer,
-                message_callback=message_callback)
+                timestamp=timestamp, timezone=timezone, committer=committer)
         finally:
             tree.unlock()
 

=== modified file 'bzrlib/btree_index.py'
--- bzrlib/btree_index.py	2010-03-25 12:32:24 +0000
+++ bzrlib/btree_index.py	2009-11-07 01:58:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -567,7 +567,7 @@
                     else:
                         # yield keys
                         for value in key_dict.itervalues():
-                            yield (self, ) + tuple(value)
+                            yield (self, ) + value
             else:
                 yield (self, ) + key_dict
 
@@ -647,8 +647,7 @@
     memory except when very large walks are done.
     """
 
-    def __init__(self, transport, name, size, unlimited_cache=False,
-                 offset=0):
+    def __init__(self, transport, name, size, unlimited_cache=False):
         """Create a B+Tree index object on the index name.
 
         :param transport: The transport to read data for the index from.
@@ -661,8 +660,6 @@
         :param unlimited_cache: If set to True, then instead of using an
             LRUCache with size _NODE_CACHE_SIZE, we will use a dict and always
             cache all leaf nodes.
-        :param offset: The start of the btree index data isn't byte 0 of the
-            file. Instead it starts at some point later.
         """
         self._transport = transport
         self._name = name
@@ -670,7 +667,6 @@
         self._file = None
         self._recommended_pages = self._compute_recommended_pages()
         self._root_node = None
-        self._base_offset = offset
         # Default max size is 100,000 leave values
         self._leaf_value_cache = None # lru_cache.LRUCache(100*1000)
         if unlimited_cache:
@@ -1498,9 +1494,8 @@
         # list of (offset, length) regions of the file that should, evenually
         # be read in to data_ranges, either from 'bytes' or from the transport
         ranges = []
-        base_offset = self._base_offset
         for index in nodes:
-            offset = (index * _PAGE_SIZE)
+            offset = index * _PAGE_SIZE
             size = _PAGE_SIZE
             if index == 0:
                 # Root node - special case
@@ -1510,11 +1505,9 @@
                     # The only case where we don't know the size, is for very
                     # small indexes. So we read the whole thing
                     bytes = self._transport.get_bytes(self._name)
-                    num_bytes = len(bytes)
-                    self._size = num_bytes - base_offset
+                    self._size = len(bytes)
                     # the whole thing should be parsed out of 'bytes'
-                    ranges = [(start, min(_PAGE_SIZE, num_bytes - start))
-                        for start in xrange(base_offset, num_bytes, _PAGE_SIZE)]
+                    ranges.append((0, len(bytes)))
                     break
             else:
                 if offset > self._size:
@@ -1522,13 +1515,13 @@
                                          ' of the file %s > %s'
                                          % (offset, self._size))
                 size = min(size, self._size - offset)
-            ranges.append((base_offset + offset, size))
+            ranges.append((offset, size))
         if not ranges:
             return
         elif bytes is not None:
             # already have the whole file
-            data_ranges = [(start, bytes[start:start+size])
-                           for start, size in ranges]
+            data_ranges = [(start, bytes[start:start+_PAGE_SIZE])
+                           for start in xrange(0, len(bytes), _PAGE_SIZE)]
         elif self._file is None:
             data_ranges = self._transport.readv(self._name, ranges)
         else:
@@ -1537,7 +1530,6 @@
                 self._file.seek(offset)
                 data_ranges.append((offset, self._file.read(size)))
         for offset, data in data_ranges:
-            offset -= base_offset
             if offset == 0:
                 # extract the header
                 offset, data = self._parse_header_from_bytes(data)

=== modified file 'bzrlib/bugtracker.py'
--- bzrlib/bugtracker.py	2010-04-30 11:03:59 +0000
+++ bzrlib/bugtracker.py	2009-06-10 03:31:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from bzrlib import registry
+from bzrlib import registry, help_topics
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import errors, urlutils
@@ -39,12 +39,12 @@
 
 _bugs_help = \
 """When making a commit, metadata about bugs fixed by that change can be
-recorded by using the ``--fixes`` option. For each bug marked as fixed, an
+recorded by using the --fixes option. For each bug marked as fixed, an
 entry is included in the 'bugs' revision property stating '<url> <status>'.
 (The only ``status`` value currently supported is ``fixed.``)
 
-The ``--fixes`` option allows you to specify a bug tracker and a bug identifier
-rather than a full URL. This looks like::
+The --fixes option allows you to specify a bug tracker and a bug identifier
+rather than a full URL. This looks like
 
     bzr commit --fixes <tracker>:<id>
 
@@ -56,13 +56,10 @@
 use this feature, you just need to know the tracker identifier to use.
 These are the bugtrackers that are built in:
 
-  ============================ ============ ============
-  URL                          Abbreviation Example
-  ============================ ============ ============
-  https://bugs.launchpad.net/  lp           lp:12345
-  http://bugs.debian.org/      deb          deb:12345
-  http://bugzilla.gnome.org/   gnome        gnome:12345
-  ============================ ============ ============
+     URL                          | Abbreviation | Example
+     https://bugs.launchpad.net/  | lp           | lp:12345
+     http://bugs.debian.org/      | deb          | deb:12345
+     http://bugzilla.gnome.org/   | gnome        | gnome:12345
 
 For the bug trackers not listed above configuration is required.
 Support for generating the URLs for any project using Bugzilla or Trac
@@ -85,11 +82,11 @@
 
 Use ``bzr commit --fixes lp:2`` to record that this commit fixes bug 2.
 
-bugzilla_<tracker>_url
-----------------------
+bugzilla_<tracker_abbreviation>_url
+-----------------------------------
 
 If present, the location of the Bugzilla bug tracker referred to by
-<tracker>. This option can then be used together with ``bzr commit
+<tracker_abbreviation>. This option can then be used together with ``bzr commit
 --fixes`` to mark bugs in that tracker as being fixed by that commit. For
 example::
 
@@ -98,11 +95,11 @@
 would allow ``bzr commit --fixes squid:1234`` to mark Squid's bug 1234 as
 fixed.
 
-trac_<tracker>_url
-------------------
+trac_<tracker_abbrevation>_url
+------------------------------
 
 If present, the location of the Trac instance referred to by
-<tracker>. This option can then be used together with ``bzr commit
+<tracker_abbreviation>. This option can then be used together with ``bzr commit
 --fixes`` to mark bugs in that tracker as being fixed by that commit. For
 example::
 
@@ -111,11 +108,11 @@
 would allow ``bzr commit --fixes twisted:1234`` to mark Twisted's bug 1234 as
 fixed.
 
-bugtracker_<tracker>_url
-------------------------
+bugtracker_<tracker_abbrevation>_url
+------------------------------------
 
 If present, the location of a generic bug tracker instance referred to by
-<tracker>. The location must contain an ``{id}`` placeholder,
+<tracker_abbreviation>. The location must contain an ``{id}`` placeholder,
 which will be replaced by a specific bug ID. This option can then be used
 together with ``bzr commit --fixes`` to mark bugs in that tracker as being
 fixed by that commit. For example::

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-05-03 09:07:50 +0000
+++ bzrlib/builtins.py	2009-12-23 05:42:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,17 +54,12 @@
     )
 from bzrlib.branch import Branch
 from bzrlib.conflicts import ConflictList
-from bzrlib.transport import memory
 from bzrlib.revisionspec import RevisionSpec, RevisionInfo
 from bzrlib.smtp_connection import SMTPConnection
 from bzrlib.workingtree import WorkingTree
 """)
 
-from bzrlib.commands import (
-    Command,
-    builtin_command_registry,
-    display_command,
-    )
+from bzrlib.commands import Command, display_command
 from bzrlib.option import (
     ListOption,
     Option,
@@ -239,7 +234,7 @@
 # opens the branch?)
 
 class cmd_status(Command):
-    __doc__ = """Display status summary.
+    """Display status summary.
 
     This reports on versioned and unknown files, reporting them
     grouped by state.  Possible states are:
@@ -332,7 +327,7 @@
 
 
 class cmd_cat_revision(Command):
-    __doc__ = """Write out metadata for a revision.
+    """Write out metadata for a revision.
 
     The revision to print can either be specified by a specific
     revision identifier, or you can use --revision.
@@ -344,14 +339,6 @@
     # cat-revision is more for frontends so should be exact
     encoding = 'strict'
 
-    def print_revision(self, revisions, revid):
-        stream = revisions.get_record_stream([(revid,)], 'unordered', True)
-        record = stream.next()
-        if record.storage_kind == 'absent':
-            raise errors.NoSuchRevision(revisions, revid)
-        revtext = record.get_bytes_as('fulltext')
-        self.outf.write(revtext.decode('utf-8'))
-
     @display_command
     def run(self, revision_id=None, revision=None):
         if revision_id is not None and revision is not None:
@@ -362,35 +349,26 @@
                                          ' --revision or a revision_id')
         b = WorkingTree.open_containing(u'.')[0].branch
 
-        revisions = b.repository.revisions
-        if revisions is None:
-            raise errors.BzrCommandError('Repository %r does not support '
-                'access to raw revision texts')
+        # TODO: jam 20060112 should cat-revision always output utf-8?
+        if revision_id is not None:
+            revision_id = osutils.safe_revision_id(revision_id, warn=False)
+            try:
+                self.outf.write(b.repository.get_revision_xml(revision_id).decode('utf-8'))
+            except errors.NoSuchRevision:
+                msg = "The repository %s contains no revision %s." % (b.repository.base,
+                    revision_id)
+                raise errors.BzrCommandError(msg)
+        elif revision is not None:
+            for rev in revision:
+                if rev is None:
+                    raise errors.BzrCommandError('You cannot specify a NULL'
+                                                 ' revision.')
+                rev_id = rev.as_revision_id(b)
+                self.outf.write(b.repository.get_revision_xml(rev_id).decode('utf-8'))
 
-        b.repository.lock_read()
-        try:
-            # TODO: jam 20060112 should cat-revision always output utf-8?
-            if revision_id is not None:
-                revision_id = osutils.safe_revision_id(revision_id, warn=False)
-                try:
-                    self.print_revision(revisions, revision_id)
-                except errors.NoSuchRevision:
-                    msg = "The repository %s contains no revision %s." % (
-                        b.repository.base, revision_id)
-                    raise errors.BzrCommandError(msg)
-            elif revision is not None:
-                for rev in revision:
-                    if rev is None:
-                        raise errors.BzrCommandError(
-                            'You cannot specify a NULL revision.')
-                    rev_id = rev.as_revision_id(b)
-                    self.print_revision(revisions, rev_id)
-        finally:
-            b.repository.unlock()
-        
 
 class cmd_dump_btree(Command):
-    __doc__ = """Dump the contents of a btree index file to stdout.
+    """Dump the contents of a btree index file to stdout.
 
     PATH is a btree index file, it can be any URL. This includes things like
     .bzr/repository/pack-names, or .bzr/repository/indices/a34b3a...ca4a4.iix
@@ -460,18 +438,13 @@
         for node in bt.iter_all_entries():
             # Node is made up of:
             # (index, key, value, [references])
-            try:
-                refs = node[3]
-            except IndexError:
-                refs_as_tuples = None
-            else:
-                refs_as_tuples = static_tuple.as_tuples(refs)
+            refs_as_tuples = static_tuple.as_tuples(node[3])
             as_tuple = (tuple(node[1]), node[2], refs_as_tuples)
             self.outf.write('%s\n' % (as_tuple,))
 
 
 class cmd_remove_tree(Command):
-    __doc__ = """Remove the working tree from a given branch/checkout.
+    """Remove the working tree from a given branch/checkout.
 
     Since a lightweight checkout is little more than a working tree
     this will refuse to run against one.
@@ -479,40 +452,38 @@
     To re-create the working tree, use "bzr checkout".
     """
     _see_also = ['checkout', 'working-trees']
-    takes_args = ['location*']
+    takes_args = ['location?']
     takes_options = [
         Option('force',
                help='Remove the working tree even if it has '
                     'uncommitted changes.'),
         ]
 
-    def run(self, location_list, force=False):
-        if not location_list:
-            location_list=['.']
-
-        for location in location_list:
-            d = bzrdir.BzrDir.open(location)
-            
-            try:
-                working = d.open_workingtree()
-            except errors.NoWorkingTree:
-                raise errors.BzrCommandError("No working tree to remove")
-            except errors.NotLocalUrl:
-                raise errors.BzrCommandError("You cannot remove the working tree"
-                                             " of a remote path")
-            if not force:
-                if (working.has_changes()):
-                    raise errors.UncommittedChanges(working)
-
-            if working.user_url != working.branch.user_url:
-                raise errors.BzrCommandError("You cannot remove the working tree"
-                                             " from a lightweight checkout")
-
-            d.destroy_workingtree()
+    def run(self, location='.', force=False):
+        d = bzrdir.BzrDir.open(location)
+
+        try:
+            working = d.open_workingtree()
+        except errors.NoWorkingTree:
+            raise errors.BzrCommandError("No working tree to remove")
+        except errors.NotLocalUrl:
+            raise errors.BzrCommandError("You cannot remove the working tree"
+                                         " of a remote path")
+        if not force:
+            if (working.has_changes()):
+                raise errors.UncommittedChanges(working)
+
+        working_path = working.bzrdir.root_transport.base
+        branch_path = working.branch.bzrdir.root_transport.base
+        if working_path != branch_path:
+            raise errors.BzrCommandError("You cannot remove the working tree"
+                                         " from a lightweight checkout")
+
+        d.destroy_workingtree()
 
 
 class cmd_revno(Command):
-    __doc__ = """Show current revision number.
+    """Show current revision number.
 
     This is equal to the number of revisions on this branch.
     """
@@ -531,24 +502,28 @@
                 wt.lock_read()
             except (errors.NoWorkingTree, errors.NotLocalUrl):
                 raise errors.NoWorkingTree(location)
-            self.add_cleanup(wt.unlock)
-            revid = wt.last_revision()
             try:
-                revno_t = wt.branch.revision_id_to_dotted_revno(revid)
-            except errors.NoSuchRevision:
-                revno_t = ('???',)
-            revno = ".".join(str(n) for n in revno_t)
+                revid = wt.last_revision()
+                try:
+                    revno_t = wt.branch.revision_id_to_dotted_revno(revid)
+                except errors.NoSuchRevision:
+                    revno_t = ('???',)
+                revno = ".".join(str(n) for n in revno_t)
+            finally:
+                wt.unlock()
         else:
             b = Branch.open_containing(location)[0]
             b.lock_read()
-            self.add_cleanup(b.unlock)
-            revno = b.revno()
-        self.cleanup_now()
+            try:
+                revno = b.revno()
+            finally:
+                b.unlock()
+
         self.outf.write(str(revno) + '\n')
 
 
 class cmd_revision_info(Command):
-    __doc__ = """Show revision number and revision id for a given revision identifier.
+    """Show revision number and revision id for a given revision identifier.
     """
     hidden = True
     takes_args = ['revision_info*']
@@ -571,46 +546,49 @@
             wt = WorkingTree.open_containing(directory)[0]
             b = wt.branch
             wt.lock_read()
-            self.add_cleanup(wt.unlock)
         except (errors.NoWorkingTree, errors.NotLocalUrl):
             wt = None
             b = Branch.open_containing(directory)[0]
             b.lock_read()
-            self.add_cleanup(b.unlock)
-        revision_ids = []
-        if revision is not None:
-            revision_ids.extend(rev.as_revision_id(b) for rev in revision)
-        if revision_info_list is not None:
-            for rev_str in revision_info_list:
-                rev_spec = RevisionSpec.from_string(rev_str)
-                revision_ids.append(rev_spec.as_revision_id(b))
-        # No arguments supplied, default to the last revision
-        if len(revision_ids) == 0:
-            if tree:
-                if wt is None:
-                    raise errors.NoWorkingTree(directory)
-                revision_ids.append(wt.last_revision())
+        try:
+            revision_ids = []
+            if revision is not None:
+                revision_ids.extend(rev.as_revision_id(b) for rev in revision)
+            if revision_info_list is not None:
+                for rev_str in revision_info_list:
+                    rev_spec = RevisionSpec.from_string(rev_str)
+                    revision_ids.append(rev_spec.as_revision_id(b))
+            # No arguments supplied, default to the last revision
+            if len(revision_ids) == 0:
+                if tree:
+                    if wt is None:
+                        raise errors.NoWorkingTree(directory)
+                    revision_ids.append(wt.last_revision())
+                else:
+                    revision_ids.append(b.last_revision())
+
+            revinfos = []
+            maxlen = 0
+            for revision_id in revision_ids:
+                try:
+                    dotted_revno = b.revision_id_to_dotted_revno(revision_id)
+                    revno = '.'.join(str(i) for i in dotted_revno)
+                except errors.NoSuchRevision:
+                    revno = '???'
+                maxlen = max(maxlen, len(revno))
+                revinfos.append([revno, revision_id])
+        finally:
+            if wt is None:
+                b.unlock()
             else:
-                revision_ids.append(b.last_revision())
-
-        revinfos = []
-        maxlen = 0
-        for revision_id in revision_ids:
-            try:
-                dotted_revno = b.revision_id_to_dotted_revno(revision_id)
-                revno = '.'.join(str(i) for i in dotted_revno)
-            except errors.NoSuchRevision:
-                revno = '???'
-            maxlen = max(maxlen, len(revno))
-            revinfos.append([revno, revision_id])
-
-        self.cleanup_now()
+                wt.unlock()
+
         for ri in revinfos:
             self.outf.write('%*s %s\n' % (maxlen, ri[0], ri[1]))
 
 
 class cmd_add(Command):
-    __doc__ = """Add specified files or directories.
+    """Add specified files or directories.
 
     In non-recursive mode, all the named items are added, regardless
     of whether they were previously ignored.  A warning is given if
@@ -682,11 +660,13 @@
 
         if base_tree:
             base_tree.lock_read()
-            self.add_cleanup(base_tree.unlock)
-        tree, file_list = tree_files_for_add(file_list)
-        added, ignored = tree.smart_add(file_list, not
-            no_recurse, action=action, save=not dry_run)
-        self.cleanup_now()
+        try:
+            tree, file_list = tree_files_for_add(file_list)
+            added, ignored = tree.smart_add(file_list, not
+                no_recurse, action=action, save=not dry_run)
+        finally:
+            if base_tree is not None:
+                base_tree.unlock()
         if len(ignored) > 0:
             if verbose:
                 for glob in sorted(ignored.keys()):
@@ -696,7 +676,7 @@
 
 
 class cmd_mkdir(Command):
-    __doc__ = """Create a new versioned directory.
+    """Create a new versioned directory.
 
     This is equivalent to creating the directory and then adding it.
     """
@@ -706,19 +686,14 @@
 
     def run(self, dir_list):
         for d in dir_list:
+            os.mkdir(d)
             wt, dd = WorkingTree.open_containing(d)
-            base = os.path.dirname(dd)
-            id = wt.path2id(base)
-            if id != None:
-                os.mkdir(d)
-                wt.add([dd])
-                self.outf.write('added %s\n' % d)
-            else:
-                raise errors.NotVersionedError(path=base)
+            wt.add([dd])
+            self.outf.write('added %s\n' % d)
 
 
 class cmd_relpath(Command):
-    __doc__ = """Show path of a file relative to root"""
+    """Show path of a file relative to root"""
 
     takes_args = ['filename']
     hidden = True
@@ -733,7 +708,7 @@
 
 
 class cmd_inventory(Command):
-    __doc__ = """Show inventory of the current working copy or a revision.
+    """Show inventory of the current working copy or a revision.
 
     It is possible to limit the output to a particular entry
     type using the --kind option.  For example: --kind file.
@@ -761,28 +736,30 @@
         revision = _get_one_revision('inventory', revision)
         work_tree, file_list = tree_files(file_list)
         work_tree.lock_read()
-        self.add_cleanup(work_tree.unlock)
-        if revision is not None:
-            tree = revision.as_tree(work_tree.branch)
-
-            extra_trees = [work_tree]
-            tree.lock_read()
-            self.add_cleanup(tree.unlock)
-        else:
-            tree = work_tree
-            extra_trees = []
-
-        if file_list is not None:
-            file_ids = tree.paths2ids(file_list, trees=extra_trees,
-                                      require_versioned=True)
-            # find_ids_across_trees may include some paths that don't
-            # exist in 'tree'.
-            entries = sorted((tree.id2path(file_id), tree.inventory[file_id])
-                             for file_id in file_ids if file_id in tree)
-        else:
-            entries = tree.inventory.entries()
-
-        self.cleanup_now()
+        try:
+            if revision is not None:
+                tree = revision.as_tree(work_tree.branch)
+
+                extra_trees = [work_tree]
+                tree.lock_read()
+            else:
+                tree = work_tree
+                extra_trees = []
+
+            if file_list is not None:
+                file_ids = tree.paths2ids(file_list, trees=extra_trees,
+                                          require_versioned=True)
+                # find_ids_across_trees may include some paths that don't
+                # exist in 'tree'.
+                entries = sorted((tree.id2path(file_id), tree.inventory[file_id])
+                                 for file_id in file_ids if file_id in tree)
+            else:
+                entries = tree.inventory.entries()
+        finally:
+            tree.unlock()
+            if tree is not work_tree:
+                work_tree.unlock()
+
         for path, entry in entries:
             if kind and kind != entry.kind:
                 continue
@@ -794,7 +771,7 @@
 
 
 class cmd_mv(Command):
-    __doc__ = """Move or rename a file.
+    """Move or rename a file.
 
     :Usage:
         bzr mv OLDNAME NEWNAME
@@ -834,8 +811,10 @@
             raise errors.BzrCommandError("missing file argument")
         tree, rel_names = tree_files(names_list, canonicalize=False)
         tree.lock_tree_write()
-        self.add_cleanup(tree.unlock)
-        self._run(tree, names_list, rel_names, after)
+        try:
+            self._run(tree, names_list, rel_names, after)
+        finally:
+            tree.unlock()
 
     def run_auto(self, names_list, after, dry_run):
         if names_list is not None and len(names_list) > 1:
@@ -846,8 +825,10 @@
                                          ' --auto.')
         work_tree, file_list = tree_files(names_list, default_branch='.')
         work_tree.lock_tree_write()
-        self.add_cleanup(work_tree.unlock)
-        rename_map.RenameMap.guess_renames(work_tree, dry_run)
+        try:
+            rename_map.RenameMap.guess_renames(work_tree, dry_run)
+        finally:
+            work_tree.unlock()
 
     def _run(self, tree, names_list, rel_names, after):
         into_existing = osutils.isdir(names_list[-1])
@@ -931,7 +912,7 @@
 
 
 class cmd_pull(Command):
-    __doc__ = """Turn this branch into a mirror of another branch.
+    """Turn this branch into a mirror of another branch.
 
     By default, this command only works on branches that have not diverged.
     Branches are considered diverged if the destination branch's most recent 
@@ -986,14 +967,10 @@
         try:
             tree_to = WorkingTree.open_containing(directory)[0]
             branch_to = tree_to.branch
-            tree_to.lock_write()
-            self.add_cleanup(tree_to.unlock)
         except errors.NoWorkingTree:
             tree_to = None
             branch_to = Branch.open_containing(directory)[0]
-            branch_to.lock_write()
-            self.add_cleanup(branch_to.unlock)
-
+        
         if local and not branch_to.get_bound_location():
             raise errors.LocalRequiresBoundBranch()
 
@@ -1029,36 +1006,44 @@
         else:
             branch_from = Branch.open(location,
                 possible_transports=possible_transports)
-            branch_from.lock_read()
-            self.add_cleanup(branch_from.unlock)
 
             if branch_to.get_parent() is None or remember:
                 branch_to.set_parent(branch_from.base)
 
-        if revision is not None:
-            revision_id = revision.as_revision_id(branch_from)
-
-        if tree_to is not None:
-            view_info = _get_view_info_for_change_reporter(tree_to)
-            change_reporter = delta._ChangeReporter(
-                unversioned_filter=tree_to.is_ignored,
-                view_info=view_info)
-            result = tree_to.pull(
-                branch_from, overwrite, revision_id, change_reporter,
-                possible_transports=possible_transports, local=local)
-        else:
-            result = branch_to.pull(
-                branch_from, overwrite, revision_id, local=local)
-
-        result.report(self.outf)
-        if verbose and result.old_revid != result.new_revid:
-            log.show_branch_change(
-                branch_to, self.outf, result.old_revno,
-                result.old_revid)
+        if branch_from is not branch_to:
+            branch_from.lock_read()
+        try:
+            if revision is not None:
+                revision_id = revision.as_revision_id(branch_from)
+
+            branch_to.lock_write()
+            try:
+                if tree_to is not None:
+                    view_info = _get_view_info_for_change_reporter(tree_to)
+                    change_reporter = delta._ChangeReporter(
+                        unversioned_filter=tree_to.is_ignored,
+                        view_info=view_info)
+                    result = tree_to.pull(
+                        branch_from, overwrite, revision_id, change_reporter,
+                        possible_transports=possible_transports, local=local)
+                else:
+                    result = branch_to.pull(
+                        branch_from, overwrite, revision_id, local=local)
+
+                result.report(self.outf)
+                if verbose and result.old_revid != result.new_revid:
+                    log.show_branch_change(
+                        branch_to, self.outf, result.old_revno,
+                        result.old_revid)
+            finally:
+                branch_to.unlock()
+        finally:
+            if branch_from is not branch_to:
+                branch_from.unlock()
 
 
 class cmd_push(Command):
-    __doc__ = """Update a mirror of this branch.
+    """Update a mirror of this branch.
 
     The target branch will not have its working tree populated because this
     is both expensive, and is not supported on remote file systems.
@@ -1125,17 +1110,26 @@
         # Get the source branch
         (tree, br_from,
          _unused) = bzrdir.BzrDir.open_containing_tree_or_branch(directory)
+        if strict is None:
+            strict = br_from.get_config().get_user_option_as_bool('push_strict')
+        if strict is None: strict = True # default value
         # Get the tip's revision_id
         revision = _get_one_revision('push', revision)
         if revision is not None:
             revision_id = revision.in_history(br_from).rev_id
         else:
             revision_id = None
-        if tree is not None and revision_id is None:
-            tree.check_changed_or_out_of_date(
-                strict, 'push_strict',
-                more_error='Use --no-strict to force the push.',
-                more_warning='Uncommitted changes will not be pushed.')
+        if strict and tree is not None and revision_id is None:
+            if (tree.has_changes()):
+                raise errors.UncommittedChanges(
+                    tree, more='Use --no-strict to force the push.')
+            if tree.last_revision() != tree.branch.last_revision():
+                # The tree has lost sync with its branch, there is little
+                # chance that the user is aware of it but he can still force
+                # the push with --no-strict
+                raise errors.OutOfDateTree(
+                    tree, more='Use --no-strict to force the push.')
+
         # Get the stacked_on branch, if any
         if stacked_on is not None:
             stacked_on = urlutils.normalize_url(stacked_on)
@@ -1173,7 +1167,7 @@
 
 
 class cmd_branch(Command):
-    __doc__ = """Create a new branch that is a copy of an existing branch.
+    """Create a new branch that is a copy of an existing branch.
 
     If the TO_LOCATION is omitted, the last component of the FROM_LOCATION will
     be used.  In other words, "branch ../foo/bar" will attempt to create ./bar.
@@ -1206,87 +1200,82 @@
                     ' directory exists, but does not already'
                     ' have a control directory.  This flag will'
                     ' allow branch to proceed.'),
-        Option('bind',
-            help="Bind new branch to from location."),
         ]
     aliases = ['get', 'clone']
 
     def run(self, from_location, to_location=None, revision=None,
             hardlink=False, stacked=False, standalone=False, no_tree=False,
-            use_existing_dir=False, switch=False, bind=False):
+            use_existing_dir=False, switch=False):
         from bzrlib import switch as _mod_switch
         from bzrlib.tag import _merge_tags_if_possible
         accelerator_tree, br_from = bzrdir.BzrDir.open_tree_or_branch(
             from_location)
         revision = _get_one_revision('branch', revision)
         br_from.lock_read()
-        self.add_cleanup(br_from.unlock)
-        if revision is not None:
-            revision_id = revision.as_revision_id(br_from)
-        else:
-            # FIXME - wt.last_revision, fallback to branch, fall back to
-            # None or perhaps NULL_REVISION to mean copy nothing
-            # RBC 20060209
-            revision_id = br_from.last_revision()
-        if to_location is None:
-            to_location = urlutils.derive_to_location(from_location)
-        to_transport = transport.get_transport(to_location)
         try:
-            to_transport.mkdir('.')
-        except errors.FileExists:
-            if not use_existing_dir:
-                raise errors.BzrCommandError('Target directory "%s" '
-                    'already exists.' % to_location)
+            if revision is not None:
+                revision_id = revision.as_revision_id(br_from)
             else:
-                try:
-                    bzrdir.BzrDir.open_from_transport(to_transport)
-                except errors.NotBranchError:
-                    pass
+                # FIXME - wt.last_revision, fallback to branch, fall back to
+                # None or perhaps NULL_REVISION to mean copy nothing
+                # RBC 20060209
+                revision_id = br_from.last_revision()
+            if to_location is None:
+                to_location = urlutils.derive_to_location(from_location)
+            to_transport = transport.get_transport(to_location)
+            try:
+                to_transport.mkdir('.')
+            except errors.FileExists:
+                if not use_existing_dir:
+                    raise errors.BzrCommandError('Target directory "%s" '
+                        'already exists.' % to_location)
                 else:
-                    raise errors.AlreadyBranchError(to_location)
-        except errors.NoSuchFile:
-            raise errors.BzrCommandError('Parent of "%s" does not exist.'
-                                         % to_location)
-        try:
-            # preserve whatever source format we have.
-            dir = br_from.bzrdir.sprout(to_transport.base, revision_id,
-                                        possible_transports=[to_transport],
-                                        accelerator_tree=accelerator_tree,
-                                        hardlink=hardlink, stacked=stacked,
-                                        force_new_repo=standalone,
-                                        create_tree_if_local=not no_tree,
-                                        source_branch=br_from)
-            branch = dir.open_branch()
-        except errors.NoSuchRevision:
-            to_transport.delete_tree('.')
-            msg = "The branch %s has no revision %s." % (from_location,
-                revision)
-            raise errors.BzrCommandError(msg)
-        _merge_tags_if_possible(br_from, branch)
-        # If the source branch is stacked, the new branch may
-        # be stacked whether we asked for that explicitly or not.
-        # We therefore need a try/except here and not just 'if stacked:'
-        try:
-            note('Created new stacked branch referring to %s.' %
-                branch.get_stacked_on_url())
-        except (errors.NotStacked, errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat), e:
-            note('Branched %d revision(s).' % branch.revno())
-        if bind:
-            # Bind to the parent
-            parent_branch = Branch.open(from_location)
-            branch.bind(parent_branch)
-            note('New branch bound to %s' % from_location)
-        if switch:
-            # Switch to the new branch
-            wt, _ = WorkingTree.open_containing('.')
-            _mod_switch.switch(wt.bzrdir, branch)
-            note('Switched to branch: %s',
-                urlutils.unescape_for_display(branch.base, 'utf-8'))
+                    try:
+                        bzrdir.BzrDir.open_from_transport(to_transport)
+                    except errors.NotBranchError:
+                        pass
+                    else:
+                        raise errors.AlreadyBranchError(to_location)
+            except errors.NoSuchFile:
+                raise errors.BzrCommandError('Parent of "%s" does not exist.'
+                                             % to_location)
+            try:
+                # preserve whatever source format we have.
+                dir = br_from.bzrdir.sprout(to_transport.base, revision_id,
+                                            possible_transports=[to_transport],
+                                            accelerator_tree=accelerator_tree,
+                                            hardlink=hardlink, stacked=stacked,
+                                            force_new_repo=standalone,
+                                            create_tree_if_local=not no_tree,
+                                            source_branch=br_from)
+                branch = dir.open_branch()
+            except errors.NoSuchRevision:
+                to_transport.delete_tree('.')
+                msg = "The branch %s has no revision %s." % (from_location,
+                    revision)
+                raise errors.BzrCommandError(msg)
+            _merge_tags_if_possible(br_from, branch)
+            # If the source branch is stacked, the new branch may
+            # be stacked whether we asked for that explicitly or not.
+            # We therefore need a try/except here and not just 'if stacked:'
+            try:
+                note('Created new stacked branch referring to %s.' %
+                    branch.get_stacked_on_url())
+            except (errors.NotStacked, errors.UnstackableBranchFormat,
+                errors.UnstackableRepositoryFormat), e:
+                note('Branched %d revision(s).' % branch.revno())
+            if switch:
+                # Switch to the new branch
+                wt, _ = WorkingTree.open_containing('.')
+                _mod_switch.switch(wt.bzrdir, branch)
+                note('Switched to branch: %s',
+                    urlutils.unescape_for_display(branch.base, 'utf-8'))
+        finally:
+            br_from.unlock()
 
 
 class cmd_checkout(Command):
-    __doc__ = """Create a new checkout of an existing branch.
+    """Create a new checkout of an existing branch.
 
     If BRANCH_LOCATION is omitted, checkout will reconstitute a working tree for
     the branch found in '.'. This is useful if you have removed the working tree
@@ -1355,7 +1344,7 @@
 
 
 class cmd_renames(Command):
-    __doc__ = """Show list of renamed files.
+    """Show list of renamed files.
     """
     # TODO: Option to show renames between two historical versions.
 
@@ -1367,27 +1356,31 @@
     def run(self, dir=u'.'):
         tree = WorkingTree.open_containing(dir)[0]
         tree.lock_read()
-        self.add_cleanup(tree.unlock)
-        new_inv = tree.inventory
-        old_tree = tree.basis_tree()
-        old_tree.lock_read()
-        self.add_cleanup(old_tree.unlock)
-        old_inv = old_tree.inventory
-        renames = []
-        iterator = tree.iter_changes(old_tree, include_unchanged=True)
-        for f, paths, c, v, p, n, k, e in iterator:
-            if paths[0] == paths[1]:
-                continue
-            if None in (paths):
-                continue
-            renames.append(paths)
-        renames.sort()
-        for old_name, new_name in renames:
-            self.outf.write("%s => %s\n" % (old_name, new_name))
+        try:
+            new_inv = tree.inventory
+            old_tree = tree.basis_tree()
+            old_tree.lock_read()
+            try:
+                old_inv = old_tree.inventory
+                renames = []
+                iterator = tree.iter_changes(old_tree, include_unchanged=True)
+                for f, paths, c, v, p, n, k, e in iterator:
+                    if paths[0] == paths[1]:
+                        continue
+                    if None in (paths):
+                        continue
+                    renames.append(paths)
+                renames.sort()
+                for old_name, new_name in renames:
+                    self.outf.write("%s => %s\n" % (old_name, new_name))
+            finally:
+                old_tree.unlock()
+        finally:
+            tree.unlock()
 
 
 class cmd_update(Command):
-    __doc__ = """Update a tree to have the latest code committed to its branch.
+    """Update a tree to have the latest code committed to its branch.
 
     This will perform a merge into the working tree, and may generate
     conflicts. If you have any local changes, you will still
@@ -1420,60 +1413,60 @@
         else:
             tree.lock_tree_write()
             branch_location = tree.branch.base
-        self.add_cleanup(tree.unlock)
         # get rid of the final '/' and be ready for display
-        branch_location = urlutils.unescape_for_display(
-            branch_location.rstrip('/'),
-            self.outf.encoding)
-        existing_pending_merges = tree.get_parent_ids()[1:]
-        if master is None:
-            old_tip = None
-        else:
-            # may need to fetch data into a heavyweight checkout
-            # XXX: this may take some time, maybe we should display a
-            # message
-            old_tip = branch.update(possible_transports)
-        if revision is not None:
-            revision_id = revision[0].as_revision_id(branch)
-        else:
-            revision_id = branch.last_revision()
-        if revision_id == _mod_revision.ensure_null(tree.last_revision()):
-            revno = branch.revision_id_to_dotted_revno(revision_id)
-            note("Tree is up to date at revision %s of branch %s" %
-                ('.'.join(map(str, revno)), branch_location))
-            return 0
-        view_info = _get_view_info_for_change_reporter(tree)
-        change_reporter = delta._ChangeReporter(
-            unversioned_filter=tree.is_ignored,
-            view_info=view_info)
+        branch_location = urlutils.unescape_for_display(branch_location[:-1],
+                                                        self.outf.encoding)
         try:
-            conflicts = tree.update(
-                change_reporter,
-                possible_transports=possible_transports,
-                revision=revision_id,
-                old_tip=old_tip)
-        except errors.NoSuchRevision, e:
-            raise errors.BzrCommandError(
-                                  "branch has no revision %s\n"
-                                  "bzr update --revision only works"
-                                  " for a revision in the branch history"
-                                  % (e.revision))
-        revno = tree.branch.revision_id_to_dotted_revno(
-            _mod_revision.ensure_null(tree.last_revision()))
-        note('Updated to revision %s of branch %s' %
-             ('.'.join(map(str, revno)), branch_location))
-        parent_ids = tree.get_parent_ids()
-        if parent_ids[1:] and parent_ids[1:] != existing_pending_merges:
-            note('Your local commits will now show as pending merges with '
-                 "'bzr status', and can be committed with 'bzr commit'.")
-        if conflicts != 0:
-            return 1
-        else:
-            return 0
+            existing_pending_merges = tree.get_parent_ids()[1:]
+            if master is None:
+                old_tip = None
+            else:
+                # may need to fetch data into a heavyweight checkout
+                # XXX: this may take some time, maybe we should display a
+                # message
+                old_tip = branch.update(possible_transports)
+            if revision is not None:
+                revision_id = revision[0].as_revision_id(branch)
+            else:
+                revision_id = branch.last_revision()
+            if revision_id == _mod_revision.ensure_null(tree.last_revision()):
+                revno = branch.revision_id_to_revno(revision_id)
+                note("Tree is up to date at revision %d of branch %s" %
+                    (revno, branch_location))
+                return 0
+            view_info = _get_view_info_for_change_reporter(tree)
+            change_reporter = delta._ChangeReporter(
+                unversioned_filter=tree.is_ignored,
+                view_info=view_info)
+            try:
+                conflicts = tree.update(
+                    change_reporter,
+                    possible_transports=possible_transports,
+                    revision=revision_id,
+                    old_tip=old_tip)
+            except errors.NoSuchRevision, e:
+                raise errors.BzrCommandError(
+                                      "branch has no revision %s\n"
+                                      "bzr update --revision only works"
+                                      " for a revision in the branch history"
+                                      % (e.revision))
+            revno = tree.branch.revision_id_to_revno(
+                _mod_revision.ensure_null(tree.last_revision()))
+            note('Updated to revision %d of branch %s' %
+                 (revno, branch_location))
+            if tree.get_parent_ids()[1:] != existing_pending_merges:
+                note('Your local commits will now show as pending merges with '
+                     "'bzr status', and can be committed with 'bzr commit'.")
+            if conflicts != 0:
+                return 1
+            else:
+                return 0
+        finally:
+            tree.unlock()
 
 
 class cmd_info(Command):
-    __doc__ = """Show information about a working tree, branch or repository.
+    """Show information about a working tree, branch or repository.
 
     This command will show all known locations and formats associated to the
     tree, branch or repository.
@@ -1517,7 +1510,7 @@
 
 
 class cmd_remove(Command):
-    __doc__ = """Remove files or directories.
+    """Remove files or directories.
 
     This makes bzr stop tracking changes to the specified files. bzr will delete
     them if they can easily be recovered using revert. If no options or
@@ -1546,32 +1539,34 @@
             file_list = [f for f in file_list]
 
         tree.lock_write()
-        self.add_cleanup(tree.unlock)
-        # Heuristics should probably all move into tree.remove_smart or
-        # some such?
-        if new:
-            added = tree.changes_from(tree.basis_tree(),
-                specific_files=file_list).added
-            file_list = sorted([f[0] for f in added], reverse=True)
-            if len(file_list) == 0:
-                raise errors.BzrCommandError('No matching files.')
-        elif file_list is None:
-            # missing files show up in iter_changes(basis) as
-            # versioned-with-no-kind.
-            missing = []
-            for change in tree.iter_changes(tree.basis_tree()):
-                # Find paths in the working tree that have no kind:
-                if change[1][1] is not None and change[6][1] is None:
-                    missing.append(change[1][1])
-            file_list = sorted(missing, reverse=True)
-            file_deletion_strategy = 'keep'
-        tree.remove(file_list, verbose=verbose, to_file=self.outf,
-            keep_files=file_deletion_strategy=='keep',
-            force=file_deletion_strategy=='force')
+        try:
+            # Heuristics should probably all move into tree.remove_smart or
+            # some such?
+            if new:
+                added = tree.changes_from(tree.basis_tree(),
+                    specific_files=file_list).added
+                file_list = sorted([f[0] for f in added], reverse=True)
+                if len(file_list) == 0:
+                    raise errors.BzrCommandError('No matching files.')
+            elif file_list is None:
+                # missing files show up in iter_changes(basis) as
+                # versioned-with-no-kind.
+                missing = []
+                for change in tree.iter_changes(tree.basis_tree()):
+                    # Find paths in the working tree that have no kind:
+                    if change[1][1] is not None and change[6][1] is None:
+                        missing.append(change[1][1])
+                file_list = sorted(missing, reverse=True)
+                file_deletion_strategy = 'keep'
+            tree.remove(file_list, verbose=verbose, to_file=self.outf,
+                keep_files=file_deletion_strategy=='keep',
+                force=file_deletion_strategy=='force')
+        finally:
+            tree.unlock()
 
 
 class cmd_file_id(Command):
-    __doc__ = """Print file_id of a particular file or directory.
+    """Print file_id of a particular file or directory.
 
     The file_id is assigned when the file is first added and remains the
     same through all revisions where the file exists, even when it is
@@ -1593,7 +1588,7 @@
 
 
 class cmd_file_path(Command):
-    __doc__ = """Print path of file_ids to a file or directory.
+    """Print path of file_ids to a file or directory.
 
     This prints one line for each directory down to the target,
     starting at the branch root.
@@ -1615,7 +1610,7 @@
 
 
 class cmd_reconcile(Command):
-    __doc__ = """Reconcile bzr metadata in a branch.
+    """Reconcile bzr metadata in a branch.
 
     This can correct data mismatches that may have been caused by
     previous ghost operations or bzr upgrades. You should only
@@ -1643,7 +1638,7 @@
 
 
 class cmd_revision_history(Command):
-    __doc__ = """Display the list of revision ids on a branch."""
+    """Display the list of revision ids on a branch."""
 
     _see_also = ['log']
     takes_args = ['location?']
@@ -1659,7 +1654,7 @@
 
 
 class cmd_ancestry(Command):
-    __doc__ = """List all revisions merged into this branch."""
+    """List all revisions merged into this branch."""
 
     _see_also = ['log', 'revision-history']
     takes_args = ['location?']
@@ -1684,7 +1679,7 @@
 
 
 class cmd_init(Command):
-    __doc__ = """Make a directory into a versioned branch.
+    """Make a directory into a versioned branch.
 
     Use this to create an empty branch, or before importing an
     existing project.
@@ -1793,7 +1788,7 @@
 
 
 class cmd_init_repository(Command):
-    __doc__ = """Create a shared repository for branches to share storage space.
+    """Create a shared repository for branches to share storage space.
 
     New branches created under the repository directory will store their
     revisions in the repository, not in the branch directory.  For branches
@@ -1853,7 +1848,7 @@
 
 
 class cmd_diff(Command):
-    __doc__ = """Show differences in the working tree, between revisions or branches.
+    """Show differences in the working tree, between revisions or branches.
 
     If no arguments are given, all changes for the current tree are listed.
     If files are given, only the changes in those files are listed.
@@ -1945,19 +1940,14 @@
             help='Use this command to compare files.',
             type=unicode,
             ),
-        RegistryOption('format',
-            help='Diff format to use.',
-            lazy_registry=('bzrlib.diff', 'format_registry'),
-            value_switches=False, title='Diff format'),
         ]
     aliases = ['di', 'dif']
     encoding_type = 'exact'
 
     @display_command
     def run(self, revision=None, file_list=None, diff_options=None,
-            prefix=None, old=None, new=None, using=None, format=None):
-        from bzrlib.diff import (get_trees_and_branches_to_diff_locked,
-            show_diff_trees)
+            prefix=None, old=None, new=None, using=None):
+        from bzrlib.diff import get_trees_and_branches_to_diff, show_diff_trees
 
         if (prefix is None) or (prefix == '0'):
             # diff -p0 format
@@ -1977,24 +1967,19 @@
             raise errors.BzrCommandError('bzr diff --revision takes exactly'
                                          ' one or two revision specifiers')
 
-        if using is not None and format is not None:
-            raise errors.BzrCommandError('--using and --format are mutually '
-                'exclusive.')
-
         (old_tree, new_tree,
          old_branch, new_branch,
-         specific_files, extra_trees) = get_trees_and_branches_to_diff_locked(
-            file_list, revision, old, new, self.add_cleanup, apply_view=True)
+         specific_files, extra_trees) = get_trees_and_branches_to_diff(
+            file_list, revision, old, new, apply_view=True)
         return show_diff_trees(old_tree, new_tree, sys.stdout,
                                specific_files=specific_files,
                                external_diff_options=diff_options,
                                old_label=old_label, new_label=new_label,
-                               extra_trees=extra_trees, using=using,
-                               format_cls=format)
+                               extra_trees=extra_trees, using=using)
 
 
 class cmd_deleted(Command):
-    __doc__ = """List files deleted in the working tree.
+    """List files deleted in the working tree.
     """
     # TODO: Show files deleted since a previous revision, or
     # between two revisions.
@@ -2009,21 +1994,25 @@
     def run(self, show_ids=False):
         tree = WorkingTree.open_containing(u'.')[0]
         tree.lock_read()
-        self.add_cleanup(tree.unlock)
-        old = tree.basis_tree()
-        old.lock_read()
-        self.add_cleanup(old.unlock)
-        for path, ie in old.inventory.iter_entries():
-            if not tree.has_id(ie.file_id):
-                self.outf.write(path)
-                if show_ids:
-                    self.outf.write(' ')
-                    self.outf.write(ie.file_id)
-                self.outf.write('\n')
+        try:
+            old = tree.basis_tree()
+            old.lock_read()
+            try:
+                for path, ie in old.inventory.iter_entries():
+                    if not tree.has_id(ie.file_id):
+                        self.outf.write(path)
+                        if show_ids:
+                            self.outf.write(' ')
+                            self.outf.write(ie.file_id)
+                        self.outf.write('\n')
+            finally:
+                old.unlock()
+        finally:
+            tree.unlock()
 
 
 class cmd_modified(Command):
-    __doc__ = """List files modified in working tree.
+    """List files modified in working tree.
     """
 
     hidden = True
@@ -2046,7 +2035,7 @@
 
 
 class cmd_added(Command):
-    __doc__ = """List files added in working tree.
+    """List files added in working tree.
     """
 
     hidden = True
@@ -2061,28 +2050,32 @@
     def run(self, null=False):
         wt = WorkingTree.open_containing(u'.')[0]
         wt.lock_read()
-        self.add_cleanup(wt.unlock)
-        basis = wt.basis_tree()
-        basis.lock_read()
-        self.add_cleanup(basis.unlock)
-        basis_inv = basis.inventory
-        inv = wt.inventory
-        for file_id in inv:
-            if file_id in basis_inv:
-                continue
-            if inv.is_root(file_id) and len(basis_inv) == 0:
-                continue
-            path = inv.id2path(file_id)
-            if not os.access(osutils.abspath(path), os.F_OK):
-                continue
-            if null:
-                self.outf.write(path + '\0')
-            else:
-                self.outf.write(osutils.quotefn(path) + '\n')
+        try:
+            basis = wt.basis_tree()
+            basis.lock_read()
+            try:
+                basis_inv = basis.inventory
+                inv = wt.inventory
+                for file_id in inv:
+                    if file_id in basis_inv:
+                        continue
+                    if inv.is_root(file_id) and len(basis_inv) == 0:
+                        continue
+                    path = inv.id2path(file_id)
+                    if not os.access(osutils.abspath(path), os.F_OK):
+                        continue
+                    if null:
+                        self.outf.write(path + '\0')
+                    else:
+                        self.outf.write(osutils.quotefn(path) + '\n')
+            finally:
+                basis.unlock()
+        finally:
+            wt.unlock()
 
 
 class cmd_root(Command):
-    __doc__ = """Show the tree root directory.
+    """Show the tree root directory.
 
     The root is the nearest enclosing directory with a .bzr control
     directory."""
@@ -2112,7 +2105,7 @@
 
 
 class cmd_log(Command):
-    __doc__ = """Show historical log for a branch or subset of a branch.
+    """Show historical log for a branch or subset of a branch.
 
     log is bzr's default tool for exploring the history of a branch.
     The branch to use is taken from the first parameter. If no parameters
@@ -2229,10 +2222,13 @@
     :Tips & tricks:
 
       GUI tools and IDEs are often better at exploring history than command
-      line tools: you may prefer qlog or viz from qbzr or bzr-gtk, the
-      bzr-explorer shell, or the Loggerhead web interface.  See the Plugin
-      Guide <http://doc.bazaar.canonical.com/plugins/en/> and
-      <http://wiki.bazaar.canonical.com/IDEIntegration>.  
+      line tools. You may prefer qlog or glog from the QBzr and Bzr-Gtk packages
+      respectively for example. (TortoiseBzr uses qlog for displaying logs.) See
+      http://bazaar-vcs.org/BzrPlugins and http://bazaar-vcs.org/IDEIntegration.
+
+      Web interfaces are often better at exploring history than command line
+      tools, particularly for branches on servers. You may prefer Loggerhead
+      or one of its alternatives. See http://bazaar-vcs.org/WebInterface.
 
       You may find it useful to add the aliases below to ``bazaar.conf``::
 
@@ -2299,10 +2295,6 @@
                    help='Show changes made in each revision as a patch.'),
             Option('include-merges',
                    help='Show merged revisions like --levels 0 does.'),
-            Option('exclude-common-ancestry',
-                   help='Display only the revisions that are not part'
-                   ' of both ancestries (require -rX..Y)'
-                   )
             ]
     encoding_type = 'replace'
 
@@ -2318,19 +2310,13 @@
             message=None,
             limit=None,
             show_diff=False,
-            include_merges=False,
-            exclude_common_ancestry=False,
-            ):
+            include_merges=False):
         from bzrlib.log import (
             Logger,
             make_log_request_dict,
             _get_info_for_log_files,
             )
         direction = (forward and 'forward') or 'reverse'
-        if (exclude_common_ancestry
-            and (revision is None or len(revision) != 2)):
-            raise errors.BzrCommandError(
-                '--exclude-common-ancestry requires -r with two revisions')
         if include_merges:
             if levels is None:
                 levels = 0
@@ -2349,90 +2335,91 @@
 
         file_ids = []
         filter_by_dir = False
-        if file_list:
-            # find the file ids to log and check for directory filtering
-            b, file_info_list, rev1, rev2 = _get_info_for_log_files(
-                revision, file_list)
-            self.add_cleanup(b.unlock)
-            for relpath, file_id, kind in file_info_list:
-                if file_id is None:
-                    raise errors.BzrCommandError(
-                        "Path unknown at end or start of revision range: %s" %
-                        relpath)
-                # If the relpath is the top of the tree, we log everything
-                if relpath == '':
-                    file_ids = []
-                    break
+        b = None
+        try:
+            if file_list:
+                # find the file ids to log and check for directory filtering
+                b, file_info_list, rev1, rev2 = _get_info_for_log_files(
+                    revision, file_list)
+                for relpath, file_id, kind in file_info_list:
+                    if file_id is None:
+                        raise errors.BzrCommandError(
+                            "Path unknown at end or start of revision range: %s" %
+                            relpath)
+                    # If the relpath is the top of the tree, we log everything
+                    if relpath == '':
+                        file_ids = []
+                        break
+                    else:
+                        file_ids.append(file_id)
+                    filter_by_dir = filter_by_dir or (
+                        kind in ['directory', 'tree-reference'])
+            else:
+                # log everything
+                # FIXME ? log the current subdir only RBC 20060203
+                if revision is not None \
+                        and len(revision) > 0 and revision[0].get_branch():
+                    location = revision[0].get_branch()
                 else:
-                    file_ids.append(file_id)
-                filter_by_dir = filter_by_dir or (
-                    kind in ['directory', 'tree-reference'])
-        else:
-            # log everything
-            # FIXME ? log the current subdir only RBC 20060203
-            if revision is not None \
-                    and len(revision) > 0 and revision[0].get_branch():
-                location = revision[0].get_branch()
-            else:
-                location = '.'
-            dir, relpath = bzrdir.BzrDir.open_containing(location)
-            b = dir.open_branch()
-            b.lock_read()
-            self.add_cleanup(b.unlock)
-            rev1, rev2 = _get_revision_range(revision, b, self.name())
-
-        # Decide on the type of delta & diff filtering to use
-        # TODO: add an --all-files option to make this configurable & consistent
-        if not verbose:
-            delta_type = None
-        else:
-            delta_type = 'full'
-        if not show_diff:
-            diff_type = None
-        elif file_ids:
-            diff_type = 'partial'
-        else:
-            diff_type = 'full'
-
-        # Build the log formatter
-        if log_format is None:
-            log_format = log.log_formatter_registry.get_default(b)
-        # Make a non-encoding output to include the diffs - bug 328007
-        unencoded_output = ui.ui_factory.make_output_stream(encoding_type='exact')
-        lf = log_format(show_ids=show_ids, to_file=self.outf,
-                        to_exact_file=unencoded_output,
-                        show_timezone=timezone,
-                        delta_format=get_verbosity_level(),
-                        levels=levels,
-                        show_advice=levels is None)
-
-        # Choose the algorithm for doing the logging. It's annoying
-        # having multiple code paths like this but necessary until
-        # the underlying repository format is faster at generating
-        # deltas or can provide everything we need from the indices.
-        # The default algorithm - match-using-deltas - works for
-        # multiple files and directories and is faster for small
-        # amounts of history (200 revisions say). However, it's too
-        # slow for logging a single file in a repository with deep
-        # history, i.e. > 10K revisions. In the spirit of "do no
-        # evil when adding features", we continue to use the
-        # original algorithm - per-file-graph - for the "single
-        # file that isn't a directory without showing a delta" case.
-        partial_history = revision and b.repository._format.supports_chks
-        match_using_deltas = (len(file_ids) != 1 or filter_by_dir
-            or delta_type or partial_history)
-
-        # Build the LogRequest and execute it
-        if len(file_ids) == 0:
-            file_ids = None
-        rqst = make_log_request_dict(
-            direction=direction, specific_fileids=file_ids,
-            start_revision=rev1, end_revision=rev2, limit=limit,
-            message_search=message, delta_type=delta_type,
-            diff_type=diff_type, _match_using_deltas=match_using_deltas,
-            exclude_common_ancestry=exclude_common_ancestry,
-            )
-        Logger(b, rqst).show(lf)
+                    location = '.'
+                dir, relpath = bzrdir.BzrDir.open_containing(location)
+                b = dir.open_branch()
+                b.lock_read()
+                rev1, rev2 = _get_revision_range(revision, b, self.name())
+
+            # Decide on the type of delta & diff filtering to use
+            # TODO: add an --all-files option to make this configurable & consistent
+            if not verbose:
+                delta_type = None
+            else:
+                delta_type = 'full'
+            if not show_diff:
+                diff_type = None
+            elif file_ids:
+                diff_type = 'partial'
+            else:
+                diff_type = 'full'
+
+            # Build the log formatter
+            if log_format is None:
+                log_format = log.log_formatter_registry.get_default(b)
+            # Make a non-encoding output to include the diffs - bug 328007
+            unencoded_output = ui.ui_factory.make_output_stream(encoding_type='exact')
+            lf = log_format(show_ids=show_ids, to_file=self.outf,
+                            to_exact_file=unencoded_output,
+                            show_timezone=timezone,
+                            delta_format=get_verbosity_level(),
+                            levels=levels,
+                            show_advice=levels is None)
+
+            # Choose the algorithm for doing the logging. It's annoying
+            # having multiple code paths like this but necessary until
+            # the underlying repository format is faster at generating
+            # deltas or can provide everything we need from the indices.
+            # The default algorithm - match-using-deltas - works for
+            # multiple files and directories and is faster for small
+            # amounts of history (200 revisions say). However, it's too
+            # slow for logging a single file in a repository with deep
+            # history, i.e. > 10K revisions. In the spirit of "do no
+            # evil when adding features", we continue to use the
+            # original algorithm - per-file-graph - for the "single
+            # file that isn't a directory without showing a delta" case.
+            partial_history = revision and b.repository._format.supports_chks
+            match_using_deltas = (len(file_ids) != 1 or filter_by_dir
+                or delta_type or partial_history)
+
+            # Build the LogRequest and execute it
+            if len(file_ids) == 0:
+                file_ids = None
+            rqst = make_log_request_dict(
+                direction=direction, specific_fileids=file_ids,
+                start_revision=rev1, end_revision=rev2, limit=limit,
+                message_search=message, delta_type=delta_type,
+                diff_type=diff_type, _match_using_deltas=match_using_deltas)
+            Logger(b, rqst).show(lf)
+        finally:
+            if b is not None:
+                b.unlock()
 
 
 def _get_revision_range(revisionspec_list, branch, command_name):
@@ -2456,11 +2443,7 @@
             raise errors.BzrCommandError(
                 "bzr %s doesn't accept two revisions in different"
                 " branches." % command_name)
-        if start_spec.spec is None:
-            # Avoid loading all the history.
-            rev1 = RevisionInfo(branch, None, None)
-        else:
-            rev1 = start_spec.in_history(branch)
+        rev1 = start_spec.in_history(branch)
         # Avoid loading all of history when we know a missing
         # end of range means the last revision ...
         if end_spec.spec is None:
@@ -2495,7 +2478,7 @@
 
 
 class cmd_touching_revisions(Command):
-    __doc__ = """Return revision-ids which affected a particular file.
+    """Return revision-ids which affected a particular file.
 
     A more user-friendly interface is "bzr log FILE".
     """
@@ -2509,14 +2492,16 @@
         file_id = tree.path2id(relpath)
         b = tree.branch
         b.lock_read()
-        self.add_cleanup(b.unlock)
-        touching_revs = log.find_touching_revisions(b, file_id)
-        for revno, revision_id, what in touching_revs:
-            self.outf.write("%6d %s\n" % (revno, what))
+        try:
+            touching_revs = log.find_touching_revisions(b, file_id)
+            for revno, revision_id, what in touching_revs:
+                self.outf.write("%6d %s\n" % (revno, what))
+        finally:
+            b.unlock()
 
 
 class cmd_ls(Command):
-    __doc__ = """List files in a tree.
+    """List files in a tree.
     """
 
     _see_also = ['status', 'cat']
@@ -2585,55 +2570,57 @@
                 note("Ignoring files outside view. View is %s" % view_str)
 
         tree.lock_read()
-        self.add_cleanup(tree.unlock)
-        for fp, fc, fkind, fid, entry in tree.list_files(include_root=False,
-            from_dir=relpath, recursive=recursive):
-            # Apply additional masking
-            if not all and not selection[fc]:
-                continue
-            if kind is not None and fkind != kind:
-                continue
-            if apply_view:
-                try:
-                    if relpath:
-                        fullpath = osutils.pathjoin(relpath, fp)
-                    else:
-                        fullpath = fp
-                    views.check_path_in_view(tree, fullpath)
-                except errors.FileOutsideView:
-                    continue
+        try:
+            for fp, fc, fkind, fid, entry in tree.list_files(include_root=False,
+                from_dir=relpath, recursive=recursive):
+                # Apply additional masking
+                if not all and not selection[fc]:
+                    continue
+                if kind is not None and fkind != kind:
+                    continue
+                if apply_view:
+                    try:
+                        if relpath:
+                            fullpath = osutils.pathjoin(relpath, fp)
+                        else:
+                            fullpath = fp
+                        views.check_path_in_view(tree, fullpath)
+                    except errors.FileOutsideView:
+                        continue
 
-            # Output the entry
-            if prefix:
-                fp = osutils.pathjoin(prefix, fp)
-            kindch = entry.kind_character()
-            outstring = fp + kindch
-            ui.ui_factory.clear_term()
-            if verbose:
-                outstring = '%-8s %s' % (fc, outstring)
-                if show_ids and fid is not None:
-                    outstring = "%-50s %s" % (outstring, fid)
-                self.outf.write(outstring + '\n')
-            elif null:
-                self.outf.write(fp + '\0')
-                if show_ids:
-                    if fid is not None:
-                        self.outf.write(fid)
-                    self.outf.write('\0')
-                self.outf.flush()
-            else:
-                if show_ids:
-                    if fid is not None:
-                        my_id = fid
-                    else:
-                        my_id = ''
-                    self.outf.write('%-50s %s\n' % (outstring, my_id))
-                else:
+                # Output the entry
+                if prefix:
+                    fp = osutils.pathjoin(prefix, fp)
+                kindch = entry.kind_character()
+                outstring = fp + kindch
+                ui.ui_factory.clear_term()
+                if verbose:
+                    outstring = '%-8s %s' % (fc, outstring)
+                    if show_ids and fid is not None:
+                        outstring = "%-50s %s" % (outstring, fid)
                     self.outf.write(outstring + '\n')
+                elif null:
+                    self.outf.write(fp + '\0')
+                    if show_ids:
+                        if fid is not None:
+                            self.outf.write(fid)
+                        self.outf.write('\0')
+                    self.outf.flush()
+                else:
+                    if show_ids:
+                        if fid is not None:
+                            my_id = fid
+                        else:
+                            my_id = ''
+                        self.outf.write('%-50s %s\n' % (outstring, my_id))
+                    else:
+                        self.outf.write(outstring + '\n')
+        finally:
+            tree.unlock()
 
 
 class cmd_unknowns(Command):
-    __doc__ = """List unknown files.
+    """List unknown files.
     """
 
     hidden = True
@@ -2646,7 +2633,7 @@
 
 
 class cmd_ignore(Command):
-    __doc__ = """Ignore specified files or patterns.
+    """Ignore specified files or patterns.
 
     See ``bzr help patterns`` for details on the syntax of patterns.
 
@@ -2660,19 +2647,6 @@
     After adding, editing or deleting that file either indirectly by
     using this command or directly by using an editor, be sure to commit
     it.
-    
-    Bazaar also supports a global ignore file ~/.bazaar/ignore. On Windows
-    the global ignore file can be found in the application data directory as
-    C:\\Documents and Settings\\<user>\\Application Data\\Bazaar\\2.0\\ignore.
-    Global ignores are not touched by this command. The global ignore file
-    can be edited directly using an editor.
-
-    Patterns prefixed with '!' are exceptions to ignore patterns and take
-    precedence over regular ignores.  Such exceptions are used to specify
-    files that should be versioned which would otherwise be ignored.
-    
-    Patterns prefixed with '!!' act as regular ignore patterns, but have
-    precedence over the '!' exception patterns.
 
     Note: ignore patterns containing shell wildcards must be quoted from
     the shell on Unix.
@@ -2682,14 +2656,10 @@
 
             bzr ignore ./Makefile
 
-        Ignore .class files in all directories...::
+        Ignore class files in all directories::
 
             bzr ignore "*.class"
 
-        ...but do not ignore "special.class"::
-
-            bzr ignore "!special.class"
-
         Ignore .o files under the lib directory::
 
             bzr ignore "lib/**/*.o"
@@ -2701,32 +2671,25 @@
         Ignore everything but the "debian" toplevel directory::
 
             bzr ignore "RE:(?!debian/).*"
-        
-        Ignore everything except the "local" toplevel directory,
-        but always ignore "*~" autosave files, even under local/::
-        
-            bzr ignore "*"
-            bzr ignore "!./local"
-            bzr ignore "!!*~"
     """
 
     _see_also = ['status', 'ignored', 'patterns']
     takes_args = ['name_pattern*']
     takes_options = [
-        Option('default-rules',
-               help='Display the default ignore rules that bzr uses.')
+        Option('old-default-rules',
+               help='Write out the ignore rules bzr < 0.9 always used.')
         ]
 
-    def run(self, name_pattern_list=None, default_rules=None):
+    def run(self, name_pattern_list=None, old_default_rules=None):
         from bzrlib import ignores
-        if default_rules is not None:
-            # dump the default rules and exit
-            for pattern in ignores.USER_DEFAULTS:
-                self.outf.write("%s\n" % pattern)
+        if old_default_rules is not None:
+            # dump the rules and exit
+            for pattern in ignores.OLD_DEFAULTS:
+                print pattern
             return
         if not name_pattern_list:
             raise errors.BzrCommandError("ignore requires at least one "
-                "NAME_PATTERN or --default-rules.")
+                                  "NAME_PATTERN or --old-default-rules")
         name_pattern_list = [globbing.normalize_pattern(p)
                              for p in name_pattern_list]
         for name_pattern in name_pattern_list:
@@ -2744,17 +2707,17 @@
             if id is not None:
                 filename = entry[0]
                 if ignored.match(filename):
-                    matches.append(filename)
+                    matches.append(filename.encode('utf-8'))
         tree.unlock()
         if len(matches) > 0:
-            self.outf.write("Warning: the following files are version controlled and"
-                  " match your ignore pattern:\n%s"
-                  "\nThese files will continue to be version controlled"
-                  " unless you 'bzr remove' them.\n" % ("\n".join(matches),))
+            print "Warning: the following files are version controlled and" \
+                  " match your ignore pattern:\n%s" \
+                  "\nThese files will continue to be version controlled" \
+                  " unless you 'bzr remove' them." % ("\n".join(matches),)
 
 
 class cmd_ignored(Command):
-    __doc__ = """List ignored files and the patterns that matched them.
+    """List ignored files and the patterns that matched them.
 
     List all the ignored files and the ignore pattern that caused the file to
     be ignored.
@@ -2771,17 +2734,19 @@
     def run(self):
         tree = WorkingTree.open_containing(u'.')[0]
         tree.lock_read()
-        self.add_cleanup(tree.unlock)
-        for path, file_class, kind, file_id, entry in tree.list_files():
-            if file_class != 'I':
-                continue
-            ## XXX: Slightly inefficient since this was already calculated
-            pat = tree.is_ignored(path)
-            self.outf.write('%-50s %s\n' % (path, pat))
+        try:
+            for path, file_class, kind, file_id, entry in tree.list_files():
+                if file_class != 'I':
+                    continue
+                ## XXX: Slightly inefficient since this was already calculated
+                pat = tree.is_ignored(path)
+                self.outf.write('%-50s %s\n' % (path, pat))
+        finally:
+            tree.unlock()
 
 
 class cmd_lookup_revision(Command):
-    __doc__ = """Lookup the revision-id from a revision-number
+    """Lookup the revision-id from a revision-number
 
     :Examples:
         bzr lookup-revision 33
@@ -2794,14 +2759,13 @@
         try:
             revno = int(revno)
         except ValueError:
-            raise errors.BzrCommandError("not a valid revision-number: %r"
-                                         % revno)
-        revid = WorkingTree.open_containing(u'.')[0].branch.get_rev_id(revno)
-        self.outf.write("%s\n" % revid)
+            raise errors.BzrCommandError("not a valid revision-number: %r" % revno)
+
+        print WorkingTree.open_containing(u'.')[0].branch.get_rev_id(revno)
 
 
 class cmd_export(Command):
-    __doc__ = """Export current or past revision to a destination directory or archive.
+    """Export current or past revision to a destination directory or archive.
 
     If no revision is specified this exports the last committed revision.
 
@@ -2839,12 +2803,9 @@
         Option('root',
                type=str,
                help="Name of the root directory inside the exported file."),
-        Option('per-file-timestamps',
-               help='Set modification time of files to that of the last '
-                    'revision in which it was changed.'),
         ]
     def run(self, dest, branch_or_subdir=None, revision=None, format=None,
-        root=None, filters=False, per_file_timestamps=False):
+        root=None, filters=False):
         from bzrlib.export import export
 
         if branch_or_subdir is None:
@@ -2857,14 +2818,13 @@
 
         rev_tree = _get_one_revision_tree('export', revision, branch=b, tree=tree)
         try:
-            export(rev_tree, dest, format, root, subdir, filtered=filters,
-                   per_file_timestamps=per_file_timestamps)
+            export(rev_tree, dest, format, root, subdir, filtered=filters)
         except errors.NoSuchExportFormat, e:
             raise errors.BzrCommandError('Unsupported export format: %s' % e.format)
 
 
 class cmd_cat(Command):
-    __doc__ = """Write the contents of a file as of a given revision to standard output.
+    """Write the contents of a file as of a given revision to standard output.
 
     If no revision is nominated, the last revision is used.
 
@@ -2891,17 +2851,17 @@
         tree, branch, relpath = \
             bzrdir.BzrDir.open_containing_tree_or_branch(filename)
         branch.lock_read()
-        self.add_cleanup(branch.unlock)
-        return self._run(tree, branch, relpath, filename, revision,
-                         name_from_revision, filters)
+        try:
+            return self._run(tree, branch, relpath, filename, revision,
+                             name_from_revision, filters)
+        finally:
+            branch.unlock()
 
     def _run(self, tree, b, relpath, filename, revision, name_from_revision,
         filtered):
         if tree is None:
             tree = b.basis_tree()
         rev_tree = _get_one_revision_tree('cat', revision, branch=b)
-        rev_tree.lock_read()
-        self.add_cleanup(rev_tree.unlock)
 
         old_file_id = rev_tree.path2id(relpath)
 
@@ -2942,24 +2902,22 @@
             chunks = content.splitlines(True)
             content = filtered_output_bytes(chunks, filters,
                 ContentFilterContext(relpath, rev_tree))
-            self.cleanup_now()
             self.outf.writelines(content)
         else:
-            self.cleanup_now()
             self.outf.write(content)
 
 
 class cmd_local_time_offset(Command):
-    __doc__ = """Show the offset in seconds from GMT to local time."""
+    """Show the offset in seconds from GMT to local time."""
     hidden = True
     @display_command
     def run(self):
-        self.outf.write("%s\n" % osutils.local_time_offset())
+        print osutils.local_time_offset()
 
 
 
 class cmd_commit(Command):
-    __doc__ = """Commit changes into a new revision.
+    """Commit changes into a new revision.
 
     An explanatory message needs to be given for each commit. This is
     often done by using the --message option (getting the message from the
@@ -3073,7 +3031,7 @@
                          "the master branch until a normal commit "
                          "is performed."
                     ),
-             Option('show-diff', short_name='p',
+             Option('show-diff',
                     help='When no message is supplied, show the diff along'
                     ' with the status summary in the message editor.'),
              ]
@@ -3159,37 +3117,29 @@
                     '(use --file "%(f)s" to take commit message from that file)'
                     % { 'f': message })
                 ui.ui_factory.show_warning(warning_msg)
-            if '\r' in message:
-                message = message.replace('\r\n', '\n')
-                message = message.replace('\r', '\n')
-            if file:
-                raise errors.BzrCommandError(
-                    "please specify either --message or --file")
 
         def get_message(commit_obj):
             """Callback to get commit message"""
-            if file:
-                my_message = codecs.open(
-                    file, 'rt', osutils.get_user_encoding()).read()
-            elif message is not None:
-                my_message = message
-            else:
-                # No message supplied: make one up.
-                # text is the status of the tree
-                text = make_commit_message_template_encoded(tree,
+            my_message = message
+            if my_message is not None and '\r' in my_message:
+                my_message = my_message.replace('\r\n', '\n')
+                my_message = my_message.replace('\r', '\n')
+            if my_message is None and not file:
+                t = make_commit_message_template_encoded(tree,
                         selected_list, diff=show_diff,
                         output_encoding=osutils.get_user_encoding())
-                # start_message is the template generated from hooks
-                # XXX: Warning - looks like hooks return unicode,
-                # make_commit_message_template_encoded returns user encoding.
-                # We probably want to be using edit_commit_message instead to
-                # avoid this.
                 start_message = generate_commit_message_template(commit_obj)
-                my_message = edit_commit_message_encoded(text,
+                my_message = edit_commit_message_encoded(t,
                     start_message=start_message)
                 if my_message is None:
                     raise errors.BzrCommandError("please specify a commit"
                         " message with either --message or --file")
+            elif my_message and file:
+                raise errors.BzrCommandError(
+                    "please specify either --message or --file")
+            if file:
+                my_message = codecs.open(file, 'rt',
+                                         osutils.get_user_encoding()).read()
             if my_message == "":
                 raise errors.BzrCommandError("empty commit message specified")
             return my_message
@@ -3207,6 +3157,8 @@
                         timezone=offset,
                         exclude=safe_relpath_files(tree, exclude))
         except PointlessCommit:
+            # FIXME: This should really happen before the file is read in;
+            # perhaps prepare the commit; get the message; then actually commit
             raise errors.BzrCommandError("No changes to commit."
                               " Use --unchanged to commit anyhow.")
         except ConflictsInTree:
@@ -3217,15 +3169,14 @@
             raise errors.BzrCommandError("Commit refused because there are"
                               " unknown files in the working tree.")
         except errors.BoundBranchOutOfDate, e:
-            e.extra_help = ("\n"
-                'To commit to master branch, run update and then commit.\n'
-                'You can also pass --local to commit to continue working '
-                'disconnected.')
-            raise
+            raise errors.BzrCommandError(str(e) + "\n"
+            'To commit to master branch, run update and then commit.\n'
+            'You can also pass --local to commit to continue working '
+            'disconnected.')
 
 
 class cmd_check(Command):
-    __doc__ = """Validate working tree structure, branch consistency and repository history.
+    """Validate working tree structure, branch consistency and repository history.
 
     This command checks various invariants about branch and repository storage
     to detect data corruption or bzr bugs.
@@ -3295,7 +3246,7 @@
 
 
 class cmd_upgrade(Command):
-    __doc__ = """Upgrade branch storage to current format.
+    """Upgrade branch storage to current format.
 
     The check command or bzr developers may sometimes advise you to run
     this command. When the default format has changed you may also be warned
@@ -3319,7 +3270,7 @@
 
 
 class cmd_whoami(Command):
-    __doc__ = """Show or set bzr user id.
+    """Show or set bzr user id.
 
     :Examples:
         Show the email of the current user::
@@ -3369,7 +3320,7 @@
 
 
 class cmd_nick(Command):
-    __doc__ = """Print or set the branch nickname.
+    """Print or set the branch nickname.
 
     If unset, the tree root directory name is used as the nickname.
     To print the current nickname, execute with no argument.
@@ -3389,11 +3340,11 @@
 
     @display_command
     def printme(self, branch):
-        self.outf.write('%s\n' % branch.nick)
+        print branch.nick
 
 
 class cmd_alias(Command):
-    __doc__ = """Set/unset and display aliases.
+    """Set/unset and display aliases.
 
     :Examples:
         Show the current aliases::
@@ -3463,7 +3414,7 @@
 
 
 class cmd_selftest(Command):
-    __doc__ = """Run internal test suite.
+    """Run internal test suite.
 
     If arguments are given, they are regular expressions that say which tests
     should run.  Tests matching any expression are run, and other tests are
@@ -3513,14 +3464,14 @@
     def get_transport_type(typestring):
         """Parse and return a transport specifier."""
         if typestring == "sftp":
-            from bzrlib.tests import stub_sftp
-            return stub_sftp.SFTPAbsoluteServer
+            from bzrlib.transport.sftp import SFTPAbsoluteServer
+            return SFTPAbsoluteServer
         if typestring == "memory":
-            from bzrlib.tests import test_server
-            return memory.MemoryServer
+            from bzrlib.transport.memory import MemoryServer
+            return MemoryServer
         if typestring == "fakenfs":
-            from bzrlib.tests import test_server
-            return test_server.FakeNFSServer
+            from bzrlib.transport.fakenfs import FakeNFSServer
+            return FakeNFSServer
         msg = "No known transport type %s. Supported types are: sftp\n" %\
             (typestring)
         raise errors.BzrCommandError(msg)
@@ -3610,11 +3561,6 @@
                 raise errors.BzrCommandError("subunit not available. subunit "
                     "needs to be installed to use --subunit.")
             self.additional_selftest_args['runner_class'] = SubUnitBzrRunner
-            # On Windows, disable automatic conversion of '\n' to '\r\n' in
-            # stdout, which would corrupt the subunit stream. 
-            if sys.platform == "win32" and sys.stdout.fileno() >= 0:
-                import msvcrt
-                msvcrt.setmode(sys.stdout.fileno(), os.O_BINARY)
         if parallel:
             self.additional_selftest_args.setdefault(
                 'suite_decorators', []).append(parallel)
@@ -3624,34 +3570,37 @@
             verbose = not is_quiet()
             # TODO: should possibly lock the history file...
             benchfile = open(".perf_history", "at", buffering=1)
-            self.add_cleanup(benchfile.close)
         else:
             test_suite_factory = None
             benchfile = None
-        selftest_kwargs = {"verbose": verbose,
-                          "pattern": pattern,
-                          "stop_on_failure": one,
-                          "transport": transport,
-                          "test_suite_factory": test_suite_factory,
-                          "lsprof_timed": lsprof_timed,
-                          "lsprof_tests": lsprof_tests,
-                          "bench_history": benchfile,
-                          "matching_tests_first": first,
-                          "list_only": list_only,
-                          "random_seed": randomize,
-                          "exclude_pattern": exclude,
-                          "strict": strict,
-                          "load_list": load_list,
-                          "debug_flags": debugflag,
-                          "starting_with": starting_with
-                          }
-        selftest_kwargs.update(self.additional_selftest_args)
-        result = selftest(**selftest_kwargs)
+        try:
+            selftest_kwargs = {"verbose": verbose,
+                              "pattern": pattern,
+                              "stop_on_failure": one,
+                              "transport": transport,
+                              "test_suite_factory": test_suite_factory,
+                              "lsprof_timed": lsprof_timed,
+                              "lsprof_tests": lsprof_tests,
+                              "bench_history": benchfile,
+                              "matching_tests_first": first,
+                              "list_only": list_only,
+                              "random_seed": randomize,
+                              "exclude_pattern": exclude,
+                              "strict": strict,
+                              "load_list": load_list,
+                              "debug_flags": debugflag,
+                              "starting_with": starting_with
+                              }
+            selftest_kwargs.update(self.additional_selftest_args)
+            result = selftest(**selftest_kwargs)
+        finally:
+            if benchfile is not None:
+                benchfile.close()
         return int(not result)
 
 
 class cmd_version(Command):
-    __doc__ = """Show version of bzr."""
+    """Show version of bzr."""
 
     encoding_type = 'replace'
     takes_options = [
@@ -3668,17 +3617,17 @@
 
 
 class cmd_rocks(Command):
-    __doc__ = """Statement of optimism."""
+    """Statement of optimism."""
 
     hidden = True
 
     @display_command
     def run(self):
-        self.outf.write("It sure does!\n")
+        print "It sure does!"
 
 
 class cmd_find_merge_base(Command):
-    __doc__ = """Find and print a base revision for merging two branches."""
+    """Find and print a base revision for merging two branches."""
     # TODO: Options to specify revisions on either side, as if
     #       merging only part of the history.
     takes_args = ['branch', 'other']
@@ -3691,20 +3640,24 @@
         branch1 = Branch.open_containing(branch)[0]
         branch2 = Branch.open_containing(other)[0]
         branch1.lock_read()
-        self.add_cleanup(branch1.unlock)
-        branch2.lock_read()
-        self.add_cleanup(branch2.unlock)
-        last1 = ensure_null(branch1.last_revision())
-        last2 = ensure_null(branch2.last_revision())
-
-        graph = branch1.repository.get_graph(branch2.repository)
-        base_rev_id = graph.find_unique_lca(last1, last2)
-
-        self.outf.write('merge base is revision %s\n' % base_rev_id)
+        try:
+            branch2.lock_read()
+            try:
+                last1 = ensure_null(branch1.last_revision())
+                last2 = ensure_null(branch2.last_revision())
+
+                graph = branch1.repository.get_graph(branch2.repository)
+                base_rev_id = graph.find_unique_lca(last1, last2)
+
+                print 'merge base is revision %s' % base_rev_id
+            finally:
+                branch2.unlock()
+        finally:
+            branch1.unlock()
 
 
 class cmd_merge(Command):
-    __doc__ = """Perform a three-way merge.
+    """Perform a three-way merge.
 
     The source of the merge can be specified either in the form of a branch,
     or in the form of a path to a file containing a merge directive generated
@@ -3739,12 +3692,7 @@
     committed to record the result of the merge.
 
     merge refuses to run if there are any uncommitted changes, unless
-    --force is given. The --force option can also be used to create a
-    merge revision which has more than two parents.
-
-    If one would like to merge changes from the working tree of the other
-    branch without merging any committed revisions, the --uncommitted option
-    can be given.
+    --force is given.
 
     To select only some changes to merge, use "merge -i", which will prompt
     you to apply each diff hunk and file change, similar to "shelve".
@@ -3765,13 +3713,6 @@
         To apply a merge directive contained in /tmp/merge::
 
             bzr merge /tmp/merge
-
-        To create a merge revision with three parents from two branches
-        feature1a and feature1b:
-
-            bzr merge ../feature1a
-            bzr merge ../feature1b --force
-            bzr commit -m 'revision with three parents'
     """
 
     encoding_type = 'exact'
@@ -3835,76 +3776,82 @@
         view_info = _get_view_info_for_change_reporter(tree)
         change_reporter = delta._ChangeReporter(
             unversioned_filter=tree.is_ignored, view_info=view_info)
-        pb = ui.ui_factory.nested_progress_bar()
-        self.add_cleanup(pb.finished)
-        tree.lock_write()
-        self.add_cleanup(tree.unlock)
-        if location is not None:
-            try:
-                mergeable = bundle.read_mergeable_from_url(location,
-                    possible_transports=possible_transports)
-            except errors.NotABundle:
-                mergeable = None
+        cleanups = []
+        try:
+            pb = ui.ui_factory.nested_progress_bar()
+            cleanups.append(pb.finished)
+            tree.lock_write()
+            cleanups.append(tree.unlock)
+            if location is not None:
+                try:
+                    mergeable = bundle.read_mergeable_from_url(location,
+                        possible_transports=possible_transports)
+                except errors.NotABundle:
+                    mergeable = None
+                else:
+                    if uncommitted:
+                        raise errors.BzrCommandError('Cannot use --uncommitted'
+                            ' with bundles or merge directives.')
+
+                    if revision is not None:
+                        raise errors.BzrCommandError(
+                            'Cannot use -r with merge directives or bundles')
+                    merger, verified = _mod_merge.Merger.from_mergeable(tree,
+                       mergeable, pb)
+
+            if merger is None and uncommitted:
+                if revision is not None and len(revision) > 0:
+                    raise errors.BzrCommandError('Cannot use --uncommitted and'
+                        ' --revision at the same time.')
+                merger = self.get_merger_from_uncommitted(tree, location, pb,
+                                                          cleanups)
+                allow_pending = False
+
+            if merger is None:
+                merger, allow_pending = self._get_merger_from_branch(tree,
+                    location, revision, remember, possible_transports, pb)
+
+            merger.merge_type = merge_type
+            merger.reprocess = reprocess
+            merger.show_base = show_base
+            self.sanity_check_merger(merger)
+            if (merger.base_rev_id == merger.other_rev_id and
+                merger.other_rev_id is not None):
+                note('Nothing to do.')
+                return 0
+            if pull:
+                if merger.interesting_files is not None:
+                    raise errors.BzrCommandError('Cannot pull individual files')
+                if (merger.base_rev_id == tree.last_revision()):
+                    result = tree.pull(merger.other_branch, False,
+                                       merger.other_rev_id)
+                    result.report(self.outf)
+                    return 0
+            if merger.this_basis is None:
+                raise errors.BzrCommandError(
+                    "This branch has no commits."
+                    " (perhaps you would prefer 'bzr pull')")
+            if preview:
+                return self._do_preview(merger, cleanups)
+            elif interactive:
+                return self._do_interactive(merger, cleanups)
             else:
-                if uncommitted:
-                    raise errors.BzrCommandError('Cannot use --uncommitted'
-                        ' with bundles or merge directives.')
-
-                if revision is not None:
-                    raise errors.BzrCommandError(
-                        'Cannot use -r with merge directives or bundles')
-                merger, verified = _mod_merge.Merger.from_mergeable(tree,
-                   mergeable, None)
-
-        if merger is None and uncommitted:
-            if revision is not None and len(revision) > 0:
-                raise errors.BzrCommandError('Cannot use --uncommitted and'
-                    ' --revision at the same time.')
-            merger = self.get_merger_from_uncommitted(tree, location, None)
-            allow_pending = False
-
-        if merger is None:
-            merger, allow_pending = self._get_merger_from_branch(tree,
-                location, revision, remember, possible_transports, None)
-
-        merger.merge_type = merge_type
-        merger.reprocess = reprocess
-        merger.show_base = show_base
-        self.sanity_check_merger(merger)
-        if (merger.base_rev_id == merger.other_rev_id and
-            merger.other_rev_id is not None):
-            note('Nothing to do.')
-            return 0
-        if pull:
-            if merger.interesting_files is not None:
-                raise errors.BzrCommandError('Cannot pull individual files')
-            if (merger.base_rev_id == tree.last_revision()):
-                result = tree.pull(merger.other_branch, False,
-                                   merger.other_rev_id)
-                result.report(self.outf)
-                return 0
-        if merger.this_basis is None:
-            raise errors.BzrCommandError(
-                "This branch has no commits."
-                " (perhaps you would prefer 'bzr pull')")
-        if preview:
-            return self._do_preview(merger)
-        elif interactive:
-            return self._do_interactive(merger)
-        else:
-            return self._do_merge(merger, change_reporter, allow_pending,
-                                  verified)
-
-    def _get_preview(self, merger):
+                return self._do_merge(merger, change_reporter, allow_pending,
+                                      verified)
+        finally:
+            for cleanup in reversed(cleanups):
+                cleanup()
+
+    def _get_preview(self, merger, cleanups):
         tree_merger = merger.make_merger()
         tt = tree_merger.make_preview_transform()
-        self.add_cleanup(tt.finalize)
+        cleanups.append(tt.finalize)
         result_tree = tt.get_preview_tree()
         return result_tree
 
-    def _do_preview(self, merger):
+    def _do_preview(self, merger, cleanups):
         from bzrlib.diff import show_diff_trees
-        result_tree = self._get_preview(merger)
+        result_tree = self._get_preview(merger, cleanups)
         show_diff_trees(merger.this_tree, result_tree, self.outf,
                         old_label='', new_label='')
 
@@ -3920,7 +3867,7 @@
         else:
             return 0
 
-    def _do_interactive(self, merger):
+    def _do_interactive(self, merger, cleanups):
         """Perform an interactive merge.
 
         This works by generating a preview tree of the merge, then using
@@ -3928,7 +3875,7 @@
         and the preview tree.
         """
         from bzrlib import shelf_ui
-        result_tree = self._get_preview(merger)
+        result_tree = self._get_preview(merger, cleanups)
         writer = bzrlib.option.diff_writer_registry.get()
         shelver = shelf_ui.Shelver(merger.this_tree, result_tree, destroy=True,
                                    reporter=shelf_ui.ApplyReporter(),
@@ -4002,12 +3949,14 @@
             allow_pending = True
         return merger, allow_pending
 
-    def get_merger_from_uncommitted(self, tree, location, pb):
+    def get_merger_from_uncommitted(self, tree, location, pb, cleanups):
         """Get a merger for uncommitted changes.
 
         :param tree: The tree the merger should apply to.
         :param location: The location containing uncommitted changes.
         :param pb: The progress bar to use for showing progress.
+        :param cleanups: A list of operations to perform to clean up the
+            temporary directories, unfinalized objects, etc.
         """
         location = self._select_branch_location(tree, location)[0]
         other_tree, other_path = WorkingTree.open_containing(location)
@@ -4065,7 +4014,7 @@
 
 
 class cmd_remerge(Command):
-    __doc__ = """Redo a merge.
+    """Redo a merge.
 
     Use this if you want to try a different merge technique while resolving
     conflicts.  Some merge techniques are better than others, and remerge
@@ -4096,63 +4045,67 @@
 
     def run(self, file_list=None, merge_type=None, show_base=False,
             reprocess=False):
-        from bzrlib.conflicts import restore
         if merge_type is None:
             merge_type = _mod_merge.Merge3Merger
         tree, file_list = tree_files(file_list)
         tree.lock_write()
-        self.add_cleanup(tree.unlock)
-        parents = tree.get_parent_ids()
-        if len(parents) != 2:
-            raise errors.BzrCommandError("Sorry, remerge only works after normal"
-                                         " merges.  Not cherrypicking or"
-                                         " multi-merges.")
-        repository = tree.branch.repository
-        interesting_ids = None
-        new_conflicts = []
-        conflicts = tree.conflicts()
-        if file_list is not None:
-            interesting_ids = set()
-            for filename in file_list:
-                file_id = tree.path2id(filename)
-                if file_id is None:
-                    raise errors.NotVersionedError(filename)
-                interesting_ids.add(file_id)
-                if tree.kind(file_id) != "directory":
-                    continue
+        try:
+            parents = tree.get_parent_ids()
+            if len(parents) != 2:
+                raise errors.BzrCommandError("Sorry, remerge only works after normal"
+                                             " merges.  Not cherrypicking or"
+                                             " multi-merges.")
+            repository = tree.branch.repository
+            interesting_ids = None
+            new_conflicts = []
+            conflicts = tree.conflicts()
+            if file_list is not None:
+                interesting_ids = set()
+                for filename in file_list:
+                    file_id = tree.path2id(filename)
+                    if file_id is None:
+                        raise errors.NotVersionedError(filename)
+                    interesting_ids.add(file_id)
+                    if tree.kind(file_id) != "directory":
+                        continue
 
-                for name, ie in tree.inventory.iter_entries(file_id):
-                    interesting_ids.add(ie.file_id)
-            new_conflicts = conflicts.select_conflicts(tree, file_list)[0]
-        else:
-            # Remerge only supports resolving contents conflicts
-            allowed_conflicts = ('text conflict', 'contents conflict')
-            restore_files = [c.path for c in conflicts
-                             if c.typestring in allowed_conflicts]
-        _mod_merge.transform_tree(tree, tree.basis_tree(), interesting_ids)
-        tree.set_conflicts(ConflictList(new_conflicts))
-        if file_list is not None:
-            restore_files = file_list
-        for filename in restore_files:
+                    for name, ie in tree.inventory.iter_entries(file_id):
+                        interesting_ids.add(ie.file_id)
+                new_conflicts = conflicts.select_conflicts(tree, file_list)[0]
+            else:
+                # Remerge only supports resolving contents conflicts
+                allowed_conflicts = ('text conflict', 'contents conflict')
+                restore_files = [c.path for c in conflicts
+                                 if c.typestring in allowed_conflicts]
+            _mod_merge.transform_tree(tree, tree.basis_tree(), interesting_ids)
+            tree.set_conflicts(ConflictList(new_conflicts))
+            if file_list is not None:
+                restore_files = file_list
+            for filename in restore_files:
+                try:
+                    restore(tree.abspath(filename))
+                except errors.NotConflicted:
+                    pass
+            # Disable pending merges, because the file texts we are remerging
+            # have not had those merges performed.  If we use the wrong parents
+            # list, we imply that the working tree text has seen and rejected
+            # all the changes from the other tree, when in fact those changes
+            # have not yet been seen.
+            pb = ui.ui_factory.nested_progress_bar()
+            tree.set_parent_ids(parents[:1])
             try:
-                restore(tree.abspath(filename))
-            except errors.NotConflicted:
-                pass
-        # Disable pending merges, because the file texts we are remerging
-        # have not had those merges performed.  If we use the wrong parents
-        # list, we imply that the working tree text has seen and rejected
-        # all the changes from the other tree, when in fact those changes
-        # have not yet been seen.
-        tree.set_parent_ids(parents[:1])
-        try:
-            merger = _mod_merge.Merger.from_revision_ids(None, tree, parents[1])
-            merger.interesting_ids = interesting_ids
-            merger.merge_type = merge_type
-            merger.show_base = show_base
-            merger.reprocess = reprocess
-            conflicts = merger.do_merge()
+                merger = _mod_merge.Merger.from_revision_ids(pb,
+                                                             tree, parents[1])
+                merger.interesting_ids = interesting_ids
+                merger.merge_type = merge_type
+                merger.show_base = show_base
+                merger.reprocess = reprocess
+                conflicts = merger.do_merge()
+            finally:
+                tree.set_parent_ids(parents)
+                pb.finished()
         finally:
-            tree.set_parent_ids(parents)
+            tree.unlock()
         if conflicts > 0:
             return 1
         else:
@@ -4160,7 +4113,7 @@
 
 
 class cmd_revert(Command):
-    __doc__ = """Revert files to a previous revision.
+    """Revert files to a previous revision.
 
     Giving a list of files will revert only those files.  Otherwise, all files
     will be reverted.  If the revision is not specified with '--revision', the
@@ -4185,23 +4138,22 @@
     created as above.  Directories containing unknown files will not be
     deleted.
 
-    The working tree contains a list of revisions that have been merged but
-    not yet committed. These revisions will be included as additional parents
-    of the next commit.  Normally, using revert clears that list as well as
-    reverting the files.  If any files are specified, revert leaves the list
-    of uncommitted merges alone and reverts only the files.  Use ``bzr revert
-    .`` in the tree root to revert all files but keep the recorded merges,
-    and ``bzr revert --forget-merges`` to clear the pending merge list without
+    The working tree contains a list of pending merged revisions, which will
+    be included as parents in the next commit.  Normally, revert clears that
+    list as well as reverting the files.  If any files are specified, revert
+    leaves the pending merge list alone and reverts only the files.  Use "bzr
+    revert ." in the tree root to revert all files but keep the merge record,
+    and "bzr revert --forget-merges" to clear the pending merge list without
     reverting any files.
 
-    Using "bzr revert --forget-merges", it is possible to apply all of the
-    changes from a branch in a single revision.  To do this, perform the merge
-    as desired.  Then doing revert with the "--forget-merges" option will keep
-    the content of the tree as it was, but it will clear the list of pending
-    merges.  The next commit will then contain all of the changes that are
-    present in the other branch, but without any other parent revisions.
-    Because this technique forgets where these changes originated, it may
-    cause additional conflicts on later merges involving the same source and
+    Using "bzr revert --forget-merges", it is possible to apply the changes
+    from an arbitrary merge as a single revision.  To do this, perform the
+    merge as desired.  Then doing revert with the "--forget-merges" option will
+    keep the content of the tree as it was, but it will clear the list of
+    pending merges.  The next commit will then contain all of the changes that
+    would have been in the merge, but without any mention of the other parent
+    revisions.  Because this technique forgets where these changes originated,
+    it may cause additional conflicts on later merges involving the source and
     target branches.
     """
 
@@ -4217,22 +4169,28 @@
     def run(self, revision=None, no_backup=False, file_list=None,
             forget_merges=None):
         tree, file_list = tree_files(file_list)
-        tree.lock_tree_write()
-        self.add_cleanup(tree.unlock)
-        if forget_merges:
-            tree.set_parent_ids(tree.get_parent_ids()[:1])
-        else:
-            self._revert_tree_to_revision(tree, revision, file_list, no_backup)
+        tree.lock_write()
+        try:
+            if forget_merges:
+                tree.set_parent_ids(tree.get_parent_ids()[:1])
+            else:
+                self._revert_tree_to_revision(tree, revision, file_list, no_backup)
+        finally:
+            tree.unlock()
 
     @staticmethod
     def _revert_tree_to_revision(tree, revision, file_list, no_backup):
         rev_tree = _get_one_revision_tree('revert', revision, tree=tree)
-        tree.revert(file_list, rev_tree, not no_backup, None,
-            report_changes=True)
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            tree.revert(file_list, rev_tree, not no_backup, pb,
+                report_changes=True)
+        finally:
+            pb.finished()
 
 
 class cmd_assert_fail(Command):
-    __doc__ = """Test reporting of assertion failures"""
+    """Test reporting of assertion failures"""
     # intended just for use in testing
 
     hidden = True
@@ -4242,7 +4200,7 @@
 
 
 class cmd_help(Command):
-    __doc__ = """Show help on a command or other topic.
+    """Show help on a command or other topic.
     """
 
     _see_also = ['topics']
@@ -4261,7 +4219,7 @@
 
 
 class cmd_shell_complete(Command):
-    __doc__ = """Show appropriate completions for context.
+    """Show appropriate completions for context.
 
     For a list of all available commands, say 'bzr shell-complete'.
     """
@@ -4276,7 +4234,7 @@
 
 
 class cmd_missing(Command):
-    __doc__ = """Show unmerged/unpulled revisions between two branches.
+    """Show unmerged/unpulled revisions between two branches.
 
     OTHER_BRANCH may be local or remote.
 
@@ -4360,9 +4318,6 @@
             restrict = 'remote'
 
         local_branch = Branch.open_containing(u".")[0]
-        local_branch.lock_read()
-        self.add_cleanup(local_branch.unlock)
-
         parent = local_branch.get_parent()
         if other_branch is None:
             other_branch = parent
@@ -4377,9 +4332,6 @@
         remote_branch = Branch.open(other_branch)
         if remote_branch.base == local_branch.base:
             remote_branch = local_branch
-        else:
-            remote_branch.lock_read()
-            self.add_cleanup(remote_branch.unlock)
 
         local_revid_range = _revision_range_to_revid_range(
             _get_revision_range(my_revision, local_branch,
@@ -4389,102 +4341,92 @@
             _get_revision_range(revision,
                 remote_branch, self.name()))
 
-        local_extra, remote_extra = find_unmerged(
-            local_branch, remote_branch, restrict,
-            backward=not reverse,
-            include_merges=include_merges,
-            local_revid_range=local_revid_range,
-            remote_revid_range=remote_revid_range)
-
-        if log_format is None:
-            registry = log.log_formatter_registry
-            log_format = registry.get_default(local_branch)
-        lf = log_format(to_file=self.outf,
-                        show_ids=show_ids,
-                        show_timezone='original')
-
-        status_code = 0
-        if local_extra and not theirs_only:
-            message("You have %d extra revision(s):\n" %
-                len(local_extra))
-            for revision in iter_log_revisions(local_extra,
-                                local_branch.repository,
-                                verbose):
-                lf.log_revision(revision)
-            printed_local = True
-            status_code = 1
-        else:
-            printed_local = False
-
-        if remote_extra and not mine_only:
-            if printed_local is True:
-                message("\n\n\n")
-            message("You are missing %d revision(s):\n" %
-                len(remote_extra))
-            for revision in iter_log_revisions(remote_extra,
-                                remote_branch.repository,
-                                verbose):
-                lf.log_revision(revision)
-            status_code = 1
-
-        if mine_only and not local_extra:
-            # We checked local, and found nothing extra
-            message('This branch is up to date.\n')
-        elif theirs_only and not remote_extra:
-            # We checked remote, and found nothing extra
-            message('Other branch is up to date.\n')
-        elif not (mine_only or theirs_only or local_extra or
-                  remote_extra):
-            # We checked both branches, and neither one had extra
-            # revisions
-            message("Branches are up to date.\n")
-        self.cleanup_now()
+        local_branch.lock_read()
+        try:
+            remote_branch.lock_read()
+            try:
+                local_extra, remote_extra = find_unmerged(
+                    local_branch, remote_branch, restrict,
+                    backward=not reverse,
+                    include_merges=include_merges,
+                    local_revid_range=local_revid_range,
+                    remote_revid_range=remote_revid_range)
+
+                if log_format is None:
+                    registry = log.log_formatter_registry
+                    log_format = registry.get_default(local_branch)
+                lf = log_format(to_file=self.outf,
+                                show_ids=show_ids,
+                                show_timezone='original')
+
+                status_code = 0
+                if local_extra and not theirs_only:
+                    message("You have %d extra revision(s):\n" %
+                        len(local_extra))
+                    for revision in iter_log_revisions(local_extra,
+                                        local_branch.repository,
+                                        verbose):
+                        lf.log_revision(revision)
+                    printed_local = True
+                    status_code = 1
+                else:
+                    printed_local = False
+
+                if remote_extra and not mine_only:
+                    if printed_local is True:
+                        message("\n\n\n")
+                    message("You are missing %d revision(s):\n" %
+                        len(remote_extra))
+                    for revision in iter_log_revisions(remote_extra,
+                                        remote_branch.repository,
+                                        verbose):
+                        lf.log_revision(revision)
+                    status_code = 1
+
+                if mine_only and not local_extra:
+                    # We checked local, and found nothing extra
+                    message('This branch is up to date.\n')
+                elif theirs_only and not remote_extra:
+                    # We checked remote, and found nothing extra
+                    message('Other branch is up to date.\n')
+                elif not (mine_only or theirs_only or local_extra or
+                          remote_extra):
+                    # We checked both branches, and neither one had extra
+                    # revisions
+                    message("Branches are up to date.\n")
+            finally:
+                remote_branch.unlock()
+        finally:
+            local_branch.unlock()
         if not status_code and parent is None and other_branch is not None:
             local_branch.lock_write()
-            self.add_cleanup(local_branch.unlock)
-            # handle race conditions - a parent might be set while we run.
-            if local_branch.get_parent() is None:
-                local_branch.set_parent(remote_branch.base)
+            try:
+                # handle race conditions - a parent might be set while we run.
+                if local_branch.get_parent() is None:
+                    local_branch.set_parent(remote_branch.base)
+            finally:
+                local_branch.unlock()
         return status_code
 
 
 class cmd_pack(Command):
-    __doc__ = """Compress the data within a repository.
-
-    This operation compresses the data within a bazaar repository. As
-    bazaar supports automatic packing of repository, this operation is
-    normally not required to be done manually.
-
-    During the pack operation, bazaar takes a backup of existing repository
-    data, i.e. pack files. This backup is eventually removed by bazaar
-    automatically when it is safe to do so. To save disk space by removing
-    the backed up pack files, the --clean-obsolete-packs option may be
-    used.
-
-    Warning: If you use --clean-obsolete-packs and your machine crashes
-    during or immediately after repacking, you may be left with a state
-    where the deletion has been written to disk but the new packs have not
-    been. In this case the repository may be unusable.
-    """
+    """Compress the data within a repository."""
 
     _see_also = ['repositories']
     takes_args = ['branch_or_repo?']
-    takes_options = [
-        Option('clean-obsolete-packs', 'Delete obsolete packs to save disk space.'),
-        ]
 
-    def run(self, branch_or_repo='.', clean_obsolete_packs=False):
+    def run(self, branch_or_repo='.'):
         dir = bzrdir.BzrDir.open_containing(branch_or_repo)[0]
         try:
             branch = dir.open_branch()
             repository = branch.repository
         except errors.NotBranchError:
             repository = dir.open_repository()
-        repository.pack(clean_obsolete_packs=clean_obsolete_packs)
+        repository.pack()
 
 
 class cmd_plugins(Command):
-    __doc__ = """List the installed plugins.
+    """List the installed plugins.
 
     This command displays the list of installed plugins including
     version of plugin and a short description of each.
@@ -4497,10 +4439,10 @@
     adding new commands, providing additional network transports and
     customizing log output.
 
-    See the Bazaar Plugin Guide <http://doc.bazaar.canonical.com/plugins/en/>
-    for further information on plugins including where to find them and how to
-    install them. Instructions are also provided there on how to write new
-    plugins using the Python programming language.
+    See the Bazaar web site, http://bazaar-vcs.org, for further
+    information on plugins including where to find them and how to
+    install them. Instructions are also provided there on how to
+    write new plugins using the Python programming language.
     """
     takes_options = ['verbose']
 
@@ -4521,15 +4463,15 @@
                 doc = '(no description)'
             result.append((name_ver, doc, plugin.path()))
         for name_ver, doc, path in sorted(result):
-            self.outf.write("%s\n" % name_ver)
-            self.outf.write("   %s\n" % doc)
+            print name_ver
+            print '   ', doc
             if verbose:
-                self.outf.write("   %s\n" % path)
-            self.outf.write("\n")
+                print '   ', path
+            print
 
 
 class cmd_testament(Command):
-    __doc__ = """Show testament (signing-form) of a revision."""
+    """Show testament (signing-form) of a revision."""
     takes_options = [
             'revision',
             Option('long', help='Produce long-format testament.'),
@@ -4548,20 +4490,22 @@
         else:
             b = Branch.open(branch)
         b.lock_read()
-        self.add_cleanup(b.unlock)
-        if revision is None:
-            rev_id = b.last_revision()
-        else:
-            rev_id = revision[0].as_revision_id(b)
-        t = testament_class.from_revision(b.repository, rev_id)
-        if long:
-            sys.stdout.writelines(t.as_text_lines())
-        else:
-            sys.stdout.write(t.as_short_text())
+        try:
+            if revision is None:
+                rev_id = b.last_revision()
+            else:
+                rev_id = revision[0].as_revision_id(b)
+            t = testament_class.from_revision(b.repository, rev_id)
+            if long:
+                sys.stdout.writelines(t.as_text_lines())
+            else:
+                sys.stdout.write(t.as_short_text())
+        finally:
+            b.unlock()
 
 
 class cmd_annotate(Command):
-    __doc__ = """Show the origin of each line in a file.
+    """Show the origin of each line in a file.
 
     This prints out the given file with an annotation on the left side
     indicating which revision, author and date introduced the change.
@@ -4589,32 +4533,34 @@
             bzrdir.BzrDir.open_containing_tree_or_branch(filename)
         if wt is not None:
             wt.lock_read()
-            self.add_cleanup(wt.unlock)
         else:
             branch.lock_read()
-            self.add_cleanup(branch.unlock)
-        tree = _get_one_revision_tree('annotate', revision, branch=branch)
-        tree.lock_read()
-        self.add_cleanup(tree.unlock)
-        if wt is not None:
-            file_id = wt.path2id(relpath)
-        else:
-            file_id = tree.path2id(relpath)
-        if file_id is None:
-            raise errors.NotVersionedError(filename)
-        file_version = tree.inventory[file_id].revision
-        if wt is not None and revision is None:
-            # If there is a tree and we're not annotating historical
-            # versions, annotate the working tree's content.
-            annotate_file_tree(wt, file_id, self.outf, long, all,
-                show_ids=show_ids)
-        else:
-            annotate_file(branch, file_version, file_id, long, all, self.outf,
-                          show_ids=show_ids)
+        try:
+            tree = _get_one_revision_tree('annotate', revision, branch=branch)
+            if wt is not None:
+                file_id = wt.path2id(relpath)
+            else:
+                file_id = tree.path2id(relpath)
+            if file_id is None:
+                raise errors.NotVersionedError(filename)
+            file_version = tree.inventory[file_id].revision
+            if wt is not None and revision is None:
+                # If there is a tree and we're not annotating historical
+                # versions, annotate the working tree's content.
+                annotate_file_tree(wt, file_id, self.outf, long, all,
+                    show_ids=show_ids)
+            else:
+                annotate_file(branch, file_version, file_id, long, all, self.outf,
+                              show_ids=show_ids)
+        finally:
+            if wt is not None:
+                wt.unlock()
+            else:
+                branch.unlock()
 
 
 class cmd_re_sign(Command):
-    __doc__ = """Create a digital signature for an existing revision."""
+    """Create a digital signature for an existing revision."""
     # TODO be able to replace existing ones.
 
     hidden = True # is this right ?
@@ -4628,8 +4574,10 @@
             raise errors.BzrCommandError('You must supply either --revision or a revision_id')
         b = WorkingTree.open_containing(u'.')[0].branch
         b.lock_write()
-        self.add_cleanup(b.unlock)
-        return self._run(b, revision_id_list, revision)
+        try:
+            return self._run(b, revision_id_list, revision)
+        finally:
+            b.unlock()
 
     def _run(self, b, revision_id_list, revision):
         import bzrlib.gpg as gpg
@@ -4680,8 +4628,7 @@
 
 
 class cmd_bind(Command):
-    __doc__ = """Convert the current branch into a checkout of the supplied branch.
-    If no branch is supplied, rebind to the last bound location.
+    """Convert the current branch into a checkout of the supplied branch.
 
     Once converted into a checkout, commits must succeed on the master branch
     before they will be applied to the local branch.
@@ -4705,11 +4652,8 @@
                     'This format does not remember old locations.')
             else:
                 if location is None:
-                    if b.get_bound_location() is not None:
-                        raise errors.BzrCommandError('Branch is already bound')
-                    else:
-                        raise errors.BzrCommandError('No location supplied '
-                            'and no previous location known')
+                    raise errors.BzrCommandError('No location supplied and no '
+                        'previous location known')
         b_other = Branch.open(location)
         try:
             b.bind(b_other)
@@ -4721,7 +4665,7 @@
 
 
 class cmd_unbind(Command):
-    __doc__ = """Convert the current checkout into a regular branch.
+    """Convert the current checkout into a regular branch.
 
     After unbinding, the local branch is considered independent and subsequent
     commits will be local only.
@@ -4738,7 +4682,7 @@
 
 
 class cmd_uncommit(Command):
-    __doc__ = """Remove the last committed revision.
+    """Remove the last committed revision.
 
     --verbose will print out what is being removed.
     --dry-run will go through all the motions, but not actually
@@ -4785,11 +4729,16 @@
 
         if tree is not None:
             tree.lock_write()
-            self.add_cleanup(tree.unlock)
         else:
             b.lock_write()
-            self.add_cleanup(b.unlock)
-        return self._run(b, tree, dry_run, verbose, revision, force, local=local)
+        try:
+            return self._run(b, tree, dry_run, verbose, revision, force,
+                             local=local)
+        finally:
+            if tree is not None:
+                tree.unlock()
+            else:
+                b.unlock()
 
     def _run(self, b, tree, dry_run, verbose, revision, force, local=False):
         from bzrlib.log import log_formatter, show_log
@@ -4827,36 +4776,35 @@
                  end_revision=last_revno)
 
         if dry_run:
-            self.outf.write('Dry-run, pretending to remove'
-                            ' the above revisions.\n')
+            print 'Dry-run, pretending to remove the above revisions.'
+            if not force:
+                val = raw_input('Press <enter> to continue')
         else:
-            self.outf.write('The above revision(s) will be removed.\n')
-
-        if not force:
-            if not ui.ui_factory.get_boolean('Are you sure'):
-                self.outf.write('Canceled')
-                return 0
+            print 'The above revision(s) will be removed.'
+            if not force:
+                val = raw_input('Are you sure [y/N]? ')
+                if val.lower() not in ('y', 'yes'):
+                    print 'Canceled'
+                    return 0
 
         mutter('Uncommitting from {%s} to {%s}',
                last_rev_id, rev_id)
         uncommit(b, tree=tree, dry_run=dry_run, verbose=verbose,
                  revno=revno, local=local)
-        self.outf.write('You can restore the old tip by running:\n'
-             '  bzr pull . -r revid:%s\n' % last_rev_id)
+        note('You can restore the old tip by running:\n'
+             '  bzr pull . -r revid:%s', last_rev_id)
 
 
 class cmd_break_lock(Command):
-    __doc__ = """Break a dead lock on a repository, branch or working directory.
+    """Break a dead lock on a repository, branch or working directory.
 
     CAUTION: Locks should only be broken when you are sure that the process
     holding the lock has been stopped.
 
-    You can get information on what locks are open via the 'bzr info
-    [location]' command.
+    You can get information on what locks are open via the 'bzr info' command.
 
     :Examples:
         bzr break-lock
-        bzr break-lock bzr+ssh://example.com/bzr/foo
     """
     takes_args = ['location?']
 
@@ -4871,7 +4819,7 @@
 
 
 class cmd_wait_until_signalled(Command):
-    __doc__ = """Test helper for test_start_and_stop_bzr_subprocess_send_signal.
+    """Test helper for test_start_and_stop_bzr_subprocess_send_signal.
 
     This just prints a line to signal when it is ready, then blocks on stdin.
     """
@@ -4885,7 +4833,7 @@
 
 
 class cmd_serve(Command):
-    __doc__ = """Run the bzr server."""
+    """Run the bzr server."""
 
     aliases = ['server']
 
@@ -4951,7 +4899,7 @@
 
 
 class cmd_join(Command):
-    __doc__ = """Combine a tree into its containing tree.
+    """Combine a tree into its containing tree.
 
     This command requires the target tree to be in a rich-root format.
 
@@ -4997,7 +4945,7 @@
 
 
 class cmd_split(Command):
-    __doc__ = """Split a subdirectory of a tree into a separate tree.
+    """Split a subdirectory of a tree into a separate tree.
 
     This command will produce a target tree in a format that supports
     rich roots, like 'rich-root' or 'rich-root-pack'.  These formats cannot be
@@ -5023,7 +4971,7 @@
 
 
 class cmd_merge_directive(Command):
-    __doc__ = """Generate a merge directive for auto-merge tools.
+    """Generate a merge directive for auto-merge tools.
 
     A directive requests a merge to be performed, and also provides all the
     information necessary to do so.  This means it must either include a
@@ -5122,7 +5070,7 @@
 
 
 class cmd_send(Command):
-    __doc__ = """Mail or create a merge-directive for submitting changes.
+    """Mail or create a merge-directive for submitting changes.
 
     A merge directive provides many things needed for requesting merges:
 
@@ -5134,32 +5082,18 @@
       directly from the merge directive, without retrieving data from a
       branch.
 
-    `bzr send` creates a compact data set that, when applied using bzr
-    merge, has the same effect as merging from the source branch.  
-    
-    By default the merge directive is self-contained and can be applied to any
-    branch containing submit_branch in its ancestory without needing access to
-    the source branch.
-    
-    If --no-bundle is specified, then Bazaar doesn't send the contents of the
-    revisions, but only a structured request to merge from the
-    public_location.  In that case the public_branch is needed and it must be
-    up-to-date and accessible to the recipient.  The public_branch is always
-    included if known, so that people can check it later.
-
-    The submit branch defaults to the parent of the source branch, but can be
-    overridden.  Both submit branch and public branch will be remembered in
-    branch.conf the first time they are used for a particular branch.  The
-    source branch defaults to that containing the working directory, but can
-    be changed using --from.
-
-    In order to calculate those changes, bzr must analyse the submit branch.
-    Therefore it is most efficient for the submit branch to be a local mirror.
-    If a public location is known for the submit_branch, that location is used
-    in the merge directive.
-
-    The default behaviour is to send the merge directive by mail, unless -o is
-    given, in which case it is sent to a file.
+    If --no-bundle is specified, then public_branch is needed (and must be
+    up-to-date), so that the receiver can perform the merge using the
+    public_branch.  The public_branch is always included if known, so that
+    people can check it later.
+
+    The submit branch defaults to the parent, but can be overridden.  Both
+    submit branch and public branch will be remembered if supplied.
+
+    If a public_branch is known for the submit_branch, that public submit
+    branch is used in the merge instructions.  This means that a local mirror
+    can be used as your actual submit branch, once you have set public_branch
+    for that mirror.
 
     Mail is sent using your preferred mail program.  This should be transparent
     on Windows (it uses MAPI).  On Linux, it requires the xdg-email utility.
@@ -5185,10 +5119,6 @@
 
     The merge directives created by bzr send may be applied using bzr merge or
     bzr pull by specifying a file containing a merge directive as the location.
-
-    bzr send makes extensive use of public locations to map local locations into
-    URLs that can be used by other people.  See `bzr help configuration` to
-    set them, and use `bzr info` to display them.
     """
 
     encoding_type = 'exact'
@@ -5210,7 +5140,7 @@
                short_name='f',
                type=unicode),
         Option('output', short_name='o',
-               help='Write merge directive to this file or directory; '
+               help='Write merge directive to this file; '
                     'use - for stdout.',
                type=unicode),
         Option('strict',
@@ -5239,7 +5169,7 @@
 
 
 class cmd_bundle_revisions(cmd_send):
-    __doc__ = """Create a merge-directive for submitting changes.
+    """Create a merge-directive for submitting changes.
 
     A merge directive provides many things needed for requesting merges:
 
@@ -5312,7 +5242,7 @@
 
 
 class cmd_tag(Command):
-    __doc__ = """Create, remove or modify a tag naming a revision.
+    """Create, remove or modify a tag naming a revision.
 
     Tags give human-meaningful names to revisions.  Commands that take a -r
     (--revision) option can be given -rtag:X, where X is any previously
@@ -5326,15 +5256,10 @@
 
     To rename a tag (change the name but keep it on the same revsion), run ``bzr
     tag new-name -r tag:old-name`` and then ``bzr tag --delete oldname``.
-
-    If no tag name is specified it will be determined through the 
-    'automatic_tag_name' hook. This can e.g. be used to automatically tag
-    upstream releases by reading configure.ac. See ``bzr help hooks`` for
-    details.
     """
 
     _see_also = ['commit', 'tags']
-    takes_args = ['tag_name?']
+    takes_args = ['tag_name']
     takes_options = [
         Option('delete',
             help='Delete this tag rather than placing it.',
@@ -5350,7 +5275,7 @@
         'revision',
         ]
 
-    def run(self, tag_name=None,
+    def run(self, tag_name,
             delete=None,
             directory='.',
             force=None,
@@ -5358,34 +5283,29 @@
             ):
         branch, relpath = Branch.open_containing(directory)
         branch.lock_write()
-        self.add_cleanup(branch.unlock)
-        if delete:
-            if tag_name is None:
-                raise errors.BzrCommandError("No tag specified to delete.")
-            branch.tags.delete_tag(tag_name)
-            self.outf.write('Deleted tag %s.\n' % tag_name)
-        else:
-            if revision:
-                if len(revision) != 1:
-                    raise errors.BzrCommandError(
-                        "Tags can only be placed on a single revision, "
-                        "not on a range")
-                revision_id = revision[0].as_revision_id(branch)
+        try:
+            if delete:
+                branch.tags.delete_tag(tag_name)
+                self.outf.write('Deleted tag %s.\n' % tag_name)
             else:
-                revision_id = branch.last_revision()
-            if tag_name is None:
-                tag_name = branch.automatic_tag_name(revision_id)
-                if tag_name is None:
-                    raise errors.BzrCommandError(
-                        "Please specify a tag name.")
-            if (not force) and branch.tags.has_tag(tag_name):
-                raise errors.TagAlreadyExists(tag_name)
-            branch.tags.set_tag(tag_name, revision_id)
-            self.outf.write('Created tag %s.\n' % tag_name)
+                if revision:
+                    if len(revision) != 1:
+                        raise errors.BzrCommandError(
+                            "Tags can only be placed on a single revision, "
+                            "not on a range")
+                    revision_id = revision[0].as_revision_id(branch)
+                else:
+                    revision_id = branch.last_revision()
+                if (not force) and branch.tags.has_tag(tag_name):
+                    raise errors.TagAlreadyExists(tag_name)
+                branch.tags.set_tag(tag_name, revision_id)
+                self.outf.write('Created tag %s.\n' % tag_name)
+        finally:
+            branch.unlock()
 
 
 class cmd_tags(Command):
-    __doc__ = """List tags.
+    """List tags.
 
     This command shows a table of tag names and the revisions they reference.
     """
@@ -5420,46 +5340,47 @@
             return
 
         branch.lock_read()
-        self.add_cleanup(branch.unlock)
-        if revision:
-            graph = branch.repository.get_graph()
-            rev1, rev2 = _get_revision_range(revision, branch, self.name())
-            revid1, revid2 = rev1.rev_id, rev2.rev_id
-            # only show revisions between revid1 and revid2 (inclusive)
-            tags = [(tag, revid) for tag, revid in tags if
-                graph.is_between(revid, revid1, revid2)]
-        if sort == 'alpha':
-            tags.sort()
-        elif sort == 'time':
-            timestamps = {}
-            for tag, revid in tags:
-                try:
-                    revobj = branch.repository.get_revision(revid)
-                except errors.NoSuchRevision:
-                    timestamp = sys.maxint # place them at the end
-                else:
-                    timestamp = revobj.timestamp
-                timestamps[revid] = timestamp
-            tags.sort(key=lambda x: timestamps[x[1]])
-        if not show_ids:
-            # [ (tag, revid), ... ] -> [ (tag, dotted_revno), ... ]
-            for index, (tag, revid) in enumerate(tags):
-                try:
-                    revno = branch.revision_id_to_dotted_revno(revid)
-                    if isinstance(revno, tuple):
-                        revno = '.'.join(map(str, revno))
-                except errors.NoSuchRevision:
-                    # Bad tag data/merges can lead to tagged revisions
-                    # which are not in this branch. Fail gracefully ...
-                    revno = '?'
-                tags[index] = (tag, revno)
-        self.cleanup_now()
+        try:
+            if revision:
+                graph = branch.repository.get_graph()
+                rev1, rev2 = _get_revision_range(revision, branch, self.name())
+                revid1, revid2 = rev1.rev_id, rev2.rev_id
+                # only show revisions between revid1 and revid2 (inclusive)
+                tags = [(tag, revid) for tag, revid in tags if
+                    graph.is_between(revid, revid1, revid2)]
+            if sort == 'alpha':
+                tags.sort()
+            elif sort == 'time':
+                timestamps = {}
+                for tag, revid in tags:
+                    try:
+                        revobj = branch.repository.get_revision(revid)
+                    except errors.NoSuchRevision:
+                        timestamp = sys.maxint # place them at the end
+                    else:
+                        timestamp = revobj.timestamp
+                    timestamps[revid] = timestamp
+                tags.sort(key=lambda x: timestamps[x[1]])
+            if not show_ids:
+                # [ (tag, revid), ... ] -> [ (tag, dotted_revno), ... ]
+                for index, (tag, revid) in enumerate(tags):
+                    try:
+                        revno = branch.revision_id_to_dotted_revno(revid)
+                        if isinstance(revno, tuple):
+                            revno = '.'.join(map(str, revno))
+                    except errors.NoSuchRevision:
+                        # Bad tag data/merges can lead to tagged revisions
+                        # which are not in this branch. Fail gracefully ...
+                        revno = '?'
+                    tags[index] = (tag, revno)
+        finally:
+            branch.unlock()
         for tag, revspec in tags:
             self.outf.write('%-20s %s\n' % (tag, revspec))
 
 
 class cmd_reconfigure(Command):
-    __doc__ = """Reconfigure the type of a bzr directory.
+    """Reconfigure the type of a bzr directory.
 
     A target configuration must be specified.
 
@@ -5550,7 +5471,7 @@
 
 
 class cmd_switch(Command):
-    __doc__ = """Set the branch of a checkout and update.
+    """Set the branch of a checkout and update.
 
     For lightweight checkouts, this changes the branch being referenced.
     For heavyweight checkouts, this checks that there are no local commits
@@ -5572,26 +5493,18 @@
     that of the master.
     """
 
-    takes_args = ['to_location?']
+    takes_args = ['to_location']
     takes_options = [Option('force',
                         help='Switch even if local commits will be lost.'),
-                     'revision',
                      Option('create-branch', short_name='b',
                         help='Create the target branch from this one before'
                              ' switching to it.'),
-                    ]
+                     ]
 
-    def run(self, to_location=None, force=False, create_branch=False,
-            revision=None):
+    def run(self, to_location, force=False, create_branch=False):
         from bzrlib import switch
         tree_location = '.'
-        revision = _get_one_revision('switch', revision)
         control_dir = bzrdir.BzrDir.open_containing(tree_location)[0]
-        if to_location is None:
-            if revision is None:
-                raise errors.BzrCommandError('You must supply either a'
-                                             ' revision or a location')
-            to_location = '.'
         try:
             branch = control_dir.open_branch()
             had_explicit_nick = branch.get_config().has_explicit_nickname()
@@ -5611,6 +5524,13 @@
             to_branch = branch.bzrdir.sprout(to_location,
                                  possible_transports=[branch.bzrdir.root_transport],
                                  source_branch=branch).open_branch()
+            # try:
+            #     from_branch = control_dir.open_branch()
+            # except errors.NotBranchError:
+            #     raise BzrCommandError('Cannot create a branch from this'
+            #         ' location when we cannot open this branch')
+            # from_branch.bzrdir.sprout(
+            pass
         else:
             try:
                 to_branch = Branch.open(to_location)
@@ -5618,9 +5538,7 @@
                 this_url = self._get_branch_location(control_dir)
                 to_branch = Branch.open(
                     urlutils.join(this_url, '..', to_location))
-        if revision is not None:
-            revision = revision.as_revision_id(to_branch)
-        switch.switch(control_dir, to_branch, force, revision_id=revision)
+        switch.switch(control_dir, to_branch, force)
         if had_explicit_nick:
             branch = control_dir.open_branch() #get the new branch!
             branch.nick = to_branch.nick
@@ -5646,7 +5564,7 @@
 
 
 class cmd_view(Command):
-    __doc__ = """Manage filtered views.
+    """Manage filtered views.
 
     Views provide a mask over the tree so that users can focus on
     a subset of a tree when doing their work. After creating a view,
@@ -5800,7 +5718,7 @@
 
 
 class cmd_hooks(Command):
-    __doc__ = """Show hooks."""
+    """Show hooks."""
 
     hidden = True
 
@@ -5819,33 +5737,8 @@
                     self.outf.write("    <no hooks installed>\n")
 
 
-class cmd_remove_branch(Command):
-    __doc__ = """Remove a branch.
-
-    This will remove the branch from the specified location but 
-    will keep any working tree or repository in place.
-
-    :Examples:
-
-      Remove the branch at repo/trunk::
-
-        bzr remove-branch repo/trunk
-
-    """
-
-    takes_args = ["location?"]
-
-    aliases = ["rmbranch"]
-
-    def run(self, location=None):
-        if location is None:
-            location = "."
-        branch = Branch.open_containing(location)[0]
-        branch.bzrdir.destroy_branch()
-        
-
 class cmd_shelve(Command):
-    __doc__ = """Temporarily set aside some changes from the current tree.
+    """Temporarily set aside some changes from the current tree.
 
     Shelve allows you to temporarily put changes you've made "on the shelf",
     ie. out of the way, until a later time when you can bring them back from
@@ -5905,22 +5798,24 @@
     def run_for_list(self):
         tree = WorkingTree.open_containing('.')[0]
         tree.lock_read()
-        self.add_cleanup(tree.unlock)
-        manager = tree.get_shelf_manager()
-        shelves = manager.active_shelves()
-        if len(shelves) == 0:
-            note('No shelved changes.')
-            return 0
-        for shelf_id in reversed(shelves):
-            message = manager.get_metadata(shelf_id).get('message')
-            if message is None:
-                message = '<no message>'
-            self.outf.write('%3d: %s\n' % (shelf_id, message))
-        return 1
+        try:
+            manager = tree.get_shelf_manager()
+            shelves = manager.active_shelves()
+            if len(shelves) == 0:
+                note('No shelved changes.')
+                return 0
+            for shelf_id in reversed(shelves):
+                message = manager.get_metadata(shelf_id).get('message')
+                if message is None:
+                    message = '<no message>'
+                self.outf.write('%3d: %s\n' % (shelf_id, message))
+            return 1
+        finally:
+            tree.unlock()
 
 
 class cmd_unshelve(Command):
-    __doc__ = """Restore shelved changes.
+    """Restore shelved changes.
 
     By default, the most recently shelved changes are restored. However if you
     specify a shelf by id those changes will be restored instead.  This works
@@ -5934,8 +5829,6 @@
             enum_switch=False, value_switches=True,
             apply="Apply changes and remove from the shelf.",
             dry_run="Show changes, but do not apply or remove them.",
-            preview="Instead of unshelving the changes, show the diff that "
-                    "would result from unshelving.",
             delete_only="Delete changes without applying them.",
             keep="Apply changes but don't delete them.",
         )
@@ -5952,7 +5845,7 @@
 
 
 class cmd_clean_tree(Command):
-    __doc__ = """Remove unwanted files from working tree.
+    """Remove unwanted files from working tree.
 
     By default, only unknown files, not ignored files, are deleted.  Versioned
     files are never deleted.
@@ -5986,7 +5879,7 @@
 
 
 class cmd_reference(Command):
-    __doc__ = """list, view and set branch locations for nested trees.
+    """list, view and set branch locations for nested trees.
 
     If no arguments are provided, lists the branch locations for nested trees.
     If one argument is provided, display the branch location for that tree.
@@ -6032,15 +5925,17 @@
             self.outf.write('%s %s\n' % (path, location))
 
 
-def _register_lazy_builtins():
-    # register lazy builtins from other modules; called at startup and should
-    # be only called once.
-    for (name, aliases, module_name) in [
-        ('cmd_bundle_info', [], 'bzrlib.bundle.commands'),
-        ('cmd_dpush', [], 'bzrlib.foreign'),
-        ('cmd_version_info', [], 'bzrlib.cmd_version_info'),
-        ('cmd_resolve', ['resolved'], 'bzrlib.conflicts'),
-        ('cmd_conflicts', [], 'bzrlib.conflicts'),
-        ('cmd_sign_my_commits', [], 'bzrlib.sign_my_commits'),
-        ]:
-        builtin_command_registry.register_lazy(name, aliases, module_name)
+# these get imported and then picked up by the scan for cmd_*
+# TODO: Some more consistent way to split command definitions across files;
+# we do need to load at least some information about them to know of
+# aliases.  ideally we would avoid loading the implementation until the
+# details were needed.
+from bzrlib.cmd_version_info import cmd_version_info
+from bzrlib.conflicts import cmd_resolve, cmd_conflicts, restore
+from bzrlib.bundle.commands import (
+    cmd_bundle_info,
+    )
+from bzrlib.foreign import cmd_dpush
+from bzrlib.sign_my_commits import cmd_sign_my_commits
+from bzrlib.weave_commands import cmd_versionedfile_list, \
+        cmd_weave_plan_merge, cmd_weave_merge_text

=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/bundle/__init__.py	2009-11-28 00:48:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/bundle/apply_bundle.py'
--- bzrlib/bundle/apply_bundle.py	2010-02-10 17:52:08 +0000
+++ bzrlib/bundle/apply_bundle.py	2009-10-06 14:40:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -52,7 +52,7 @@
         pp = ProgressPhase("Merge phase", 6, pb)
         pp.next_phase()
         install_bundle(tree.branch.repository, reader)
-        merger = Merger(tree.branch, this_tree=tree,
+        merger = Merger(tree.branch, this_tree=tree, pb=pb,
                         change_reporter=change_reporter)
         merger.pp = pp
         merger.pp.next_phase()

=== modified file 'bzrlib/bundle/commands.py'
--- bzrlib/bundle/commands.py	2010-04-02 19:12:58 +0000
+++ bzrlib/bundle/commands.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -41,7 +41,7 @@
 
 
 class cmd_bundle_info(Command):
-    __doc__ = """Output interesting stats about a bundle"""
+    """Output interesting stats about a bundle"""
 
     hidden = True
     takes_args = ['location']
@@ -54,7 +54,7 @@
         from bzrlib import osutils
         term_encoding = osutils.get_terminal_encoding()
         bundle_info = read_mergeable_from_url(location)
-        if isinstance(bundle_info, merge_directive.BaseMergeDirective):
+        if isinstance(bundle_info, merge_directive._BaseMergeDirective):
             bundle_file = StringIO(bundle_info.get_raw_bundle())
             bundle_info = read_bundle(bundle_file)
         else:

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-04-28 07:03:38 +0000
+++ bzrlib/bzrdir.py	2010-01-06 04:53:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,7 +29,6 @@
 
 import os
 import sys
-import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -86,42 +85,9 @@
     registry,
     symbol_versioning,
     )
-    
-    
-class ControlComponent(object):
-    """Abstract base class for control directory components.
-    
-    This provides interfaces that are common across bzrdirs, 
-    repositories, branches, and workingtree control directories.
-    
-    They all expose two urls and transports: the *user* URL is the 
-    one that stops above the control directory (eg .bzr) and that 
-    should normally be used in messages, and the *control* URL is
-    under that in eg .bzr/checkout and is used to read the control
-    files.
-    
-    This can be used as a mixin and is intended to fit with 
-    foreign formats.
-    """
-    
-    @property
-    def control_transport(self):
-        raise NotImplementedError
-   
-    @property
-    def control_url(self):
-        return self.control_transport.base
-    
-    @property
-    def user_transport(self):
-        raise NotImplementedError
-        
-    @property
-    def user_url(self):
-        return self.user_transport.base
-    
-
-class BzrDir(ControlComponent):
+
+
+class BzrDir(object):
     """A .bzr control diretory.
 
     BzrDir instances let you create or open any of the things that can be
@@ -294,8 +260,8 @@
                 # copied, and finally if we are copying up to a specific
                 # revision_id then we can use the pending-ancestry-result which
                 # does not require traversing all of history to describe it.
-                if (result_repo.user_url == result.user_url
-                    and not require_stacking and
+                if (result_repo.bzrdir.root_transport.base ==
+                    result.root_transport.base and not require_stacking and
                     revision_id is not None):
                     fetch_spec = graph.PendingAncestryResult(
                         [revision_id], local_repo)
@@ -388,15 +354,6 @@
                 for subdir in sorted(subdirs, reverse=True):
                     pending.append(current_transport.clone(subdir))
 
-    def list_branches(self):
-        """Return a sequence of all branches local to this control directory.
-
-        """
-        try:
-            return [self.open_branch()]
-        except errors.NotBranchError:
-            return []
-
     @staticmethod
     def find_branches(transport):
         """Find all branches under a transport.
@@ -414,38 +371,35 @@
             except errors.NoRepositoryPresent:
                 pass
             else:
-                return False, ([], repository)
-            return True, (bzrdir.list_branches(), None)
-        ret = []
-        for branches, repo in BzrDir.find_bzrdirs(transport,
-                                                  evaluate=evaluate):
+                return False, (None, repository)
+            try:
+                branch = bzrdir.open_branch()
+            except errors.NotBranchError:
+                return True, (None, None)
+            else:
+                return True, (branch, None)
+        branches = []
+        for branch, repo in BzrDir.find_bzrdirs(transport, evaluate=evaluate):
             if repo is not None:
-                ret.extend(repo.find_branches())
-            if branches is not None:
-                ret.extend(branches)
-        return ret
+                branches.extend(repo.find_branches())
+            if branch is not None:
+                branches.append(branch)
+        return branches
 
     def destroy_repository(self):
         """Destroy the repository in this BzrDir"""
         raise NotImplementedError(self.destroy_repository)
 
-    def create_branch(self, name=None):
+    def create_branch(self):
         """Create a branch in this BzrDir.
 
-        :param name: Name of the colocated branch to create, None for
-            the default branch.
-
         The bzrdir's format will control what branch format is created.
         For more control see BranchFormatXX.create(a_bzrdir).
         """
         raise NotImplementedError(self.create_branch)
 
-    def destroy_branch(self, name=None):
-        """Destroy a branch in this BzrDir.
-        
-        :param name: Name of the branch to destroy, None for the default 
-            branch.
-        """
+    def destroy_branch(self):
+        """Destroy the branch in this BzrDir"""
         raise NotImplementedError(self.destroy_branch)
 
     @staticmethod
@@ -491,7 +445,7 @@
             stop = False
             stack_on = config.get_default_stack_on()
             if stack_on is not None:
-                stack_on_pwd = found_bzrdir.user_url
+                stack_on_pwd = found_bzrdir.root_transport.base
                 stop = True
             # does it have a repository ?
             try:
@@ -499,8 +453,8 @@
             except errors.NoRepositoryPresent:
                 repository = None
             else:
-                if (found_bzrdir.user_url != self.user_url 
-                    and not repository.is_shared()):
+                if ((found_bzrdir.root_transport.base !=
+                     self.root_transport.base) and not repository.is_shared()):
                     # Don't look higher, can't use a higher shared repo.
                     repository = None
                     stop = True
@@ -620,25 +574,18 @@
 
         :return: Tuple with old path name and new path name
         """
-        def name_gen(base='backup.bzr'):
-            counter = 1
-            name = "%s.~%d~" % (base, counter)
-            while self.root_transport.has(name):
-                counter += 1
-                name = "%s.~%d~" % (base, counter)
-            return name
-
-        backup_dir=name_gen()
         pb = ui.ui_factory.nested_progress_bar()
         try:
             # FIXME: bug 300001 -- the backup fails if the backup directory
             # already exists, but it should instead either remove it or make
             # a new backup directory.
             #
+            # FIXME: bug 262450 -- the backup directory should have the same
+            # permissions as the .bzr directory (probably a bug in copy_tree)
             old_path = self.root_transport.abspath('.bzr')
-            new_path = self.root_transport.abspath(backup_dir)
+            new_path = self.root_transport.abspath('backup.bzr')
             ui.ui_factory.note('making backup of %s\n  to %s' % (old_path, new_path,))
-            self.root_transport.copy_tree('.bzr', backup_dir)
+            self.root_transport.copy_tree('.bzr', 'backup.bzr')
             return (old_path, new_path)
         finally:
             pb.finished()
@@ -702,7 +649,7 @@
             if stop:
                 return result
             next_transport = found_bzrdir.root_transport.clone('..')
-            if (found_bzrdir.user_url == next_transport.base):
+            if (found_bzrdir.root_transport.base == next_transport.base):
                 # top of the file system
                 return None
             # find the next containing bzrdir
@@ -725,7 +672,7 @@
                 repository = found_bzrdir.open_repository()
             except errors.NoRepositoryPresent:
                 return None, False
-            if found_bzrdir.user_url == self.user_url:
+            if found_bzrdir.root_transport.base == self.root_transport.base:
                 return repository, True
             elif repository.is_shared():
                 return repository, True
@@ -746,7 +693,7 @@
         """
         return None
 
-    def get_branch_transport(self, branch_format, name=None):
+    def get_branch_transport(self, branch_format):
         """Get the transport for use by branch format in this BzrDir.
 
         Note that bzr dirs that do not support format strings will raise
@@ -847,19 +794,9 @@
         :param _transport: the transport this dir is based at.
         """
         self._format = _format
-        # these are also under the more standard names of 
-        # control_transport and user_transport
         self.transport = _transport.clone('.bzr')
         self.root_transport = _transport
         self._mode_check_done = False
-        
-    @property 
-    def user_transport(self):
-        return self.root_transport
-        
-    @property
-    def control_transport(self):
-        return self.transport
 
     def is_control_filename(self, filename):
         """True if filename is the name of a path which is reserved for bzrdir's.
@@ -940,8 +877,7 @@
         BzrDir._check_supported(format, _unsupported)
         return format.open(transport, _found=True)
 
-    def open_branch(self, name=None, unsupported=False,
-                    ignore_fallbacks=False):
+    def open_branch(self, unsupported=False, ignore_fallbacks=False):
         """Open the branch object at this BzrDir if one is present.
 
         If unsupported is True, then no longer supported branch formats can
@@ -1085,7 +1021,7 @@
         """
         raise NotImplementedError(self.open_workingtree)
 
-    def has_branch(self, name=None):
+    def has_branch(self):
         """Tell if this bzrdir contains a branch.
 
         Note: if you're going to open the branch, you should just go ahead
@@ -1093,7 +1029,7 @@
         branch and discards it, and that's somewhat expensive.)
         """
         try:
-            self.open_branch(name)
+            self.open_branch()
             return True
         except errors.NotBranchError:
             return False
@@ -1373,52 +1309,11 @@
         self.create_hook(hooks.HookPoint('pre_open',
             "Invoked before attempting to open a BzrDir with the transport "
             "that the open will use.", (1, 14), None))
-        self.create_hook(hooks.HookPoint('post_repo_init',
-            "Invoked after a repository has been initialized. "
-            "post_repo_init is called with a "
-            "bzrlib.bzrdir.RepoInitHookParams.",
-            (2, 2), None))
 
 # install the default hooks
 BzrDir.hooks = BzrDirHooks()
 
 
-class RepoInitHookParams(object):
-    """Object holding parameters passed to *_repo_init hooks.
-
-    There are 4 fields that hooks may wish to access:
-
-    :ivar repository: Repository created
-    :ivar format: Repository format
-    :ivar bzrdir: The bzrdir for the repository
-    :ivar shared: The repository is shared
-    """
-
-    def __init__(self, repository, format, a_bzrdir, shared):
-        """Create a group of RepoInitHook parameters.
-
-        :param repository: Repository created
-        :param format: Repository format
-        :param bzrdir: The bzrdir for the repository
-        :param shared: The repository is shared
-        """
-        self.repository = repository
-        self.format = format
-        self.bzrdir = a_bzrdir
-        self.shared = shared
-
-    def __eq__(self, other):
-        return self.__dict__ == other.__dict__
-
-    def __repr__(self):
-        if self.repository:
-            return "<%s for %s>" % (self.__class__.__name__,
-                self.repository)
-        else:
-            return "<%s for %s>" % (self.__class__.__name__,
-                self.bzrdir)
-
-
 class BzrDirPreSplitOut(BzrDir):
     """A common class for the all-in-one formats."""
 
@@ -1463,11 +1358,11 @@
             tree.clone(result)
         return result
 
-    def create_branch(self, name=None):
+    def create_branch(self):
         """See BzrDir.create_branch."""
-        return self._format.get_branch_format().initialize(self, name=name)
+        return self._format.get_branch_format().initialize(self)
 
-    def destroy_branch(self, name=None):
+    def destroy_branch(self):
         """See BzrDir.destroy_branch."""
         raise errors.UnsupportedOperation(self.destroy_branch, self)
 
@@ -1529,10 +1424,8 @@
         raise errors.UnsupportedOperation(self.destroy_workingtree_metadata,
                                           self)
 
-    def get_branch_transport(self, branch_format, name=None):
+    def get_branch_transport(self, branch_format):
         """See BzrDir.get_branch_transport()."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         if branch_format is None:
             return self.transport
         try:
@@ -1571,13 +1464,12 @@
             format = BzrDirFormat.get_default_format()
         return not isinstance(self._format, format.__class__)
 
-    def open_branch(self, name=None, unsupported=False,
-                    ignore_fallbacks=False):
+    def open_branch(self, unsupported=False, ignore_fallbacks=False):
         """See BzrDir.open_branch."""
         from bzrlib.branch import BzrBranchFormat4
         format = BzrBranchFormat4()
         self._check_supported(format, unsupported)
-        return format.open(self, name, _found=True)
+        return format.open(self, _found=True)
 
     def sprout(self, url, revision_id=None, force_new_repo=False,
                possible_transports=None, accelerator_tree=None,
@@ -1700,14 +1592,12 @@
         """See BzrDir.can_convert_format()."""
         return True
 
-    def create_branch(self, name=None):
+    def create_branch(self):
         """See BzrDir.create_branch."""
-        return self._format.get_branch_format().initialize(self, name=name)
+        return self._format.get_branch_format().initialize(self)
 
-    def destroy_branch(self, name=None):
+    def destroy_branch(self):
         """See BzrDir.create_branch."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         self.transport.delete_tree('branch')
 
     def create_repository(self, shared=False):
@@ -1756,10 +1646,8 @@
         format = BranchFormat.find_format(self)
         return format.get_reference(self)
 
-    def get_branch_transport(self, branch_format, name=None):
+    def get_branch_transport(self, branch_format):
         """See BzrDir.get_branch_transport()."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         # XXX: this shouldn't implicitly create the directory if it's just
         # promising to get a transport -- mbp 20090727
         if branch_format is None:
@@ -1836,11 +1724,13 @@
                 return True
         except errors.NoRepositoryPresent:
             pass
-        for branch in self.list_branches():
-            if not isinstance(branch._format,
+        try:
+            if not isinstance(self.open_branch()._format,
                               format.get_branch_format().__class__):
                 # the branch needs an upgrade.
                 return True
+        except errors.NotBranchError:
+            pass
         try:
             my_wt = self.open_workingtree(recommend_upgrade=False)
             if not isinstance(my_wt._format,
@@ -1851,13 +1741,11 @@
             pass
         return False
 
-    def open_branch(self, name=None, unsupported=False,
-                    ignore_fallbacks=False):
+    def open_branch(self, unsupported=False, ignore_fallbacks=False):
         """See BzrDir.open_branch."""
         format = self.find_branch_format()
         self._check_supported(format, unsupported)
-        return format.open(self, name=name,
-            _found=True, ignore_fallbacks=ignore_fallbacks)
+        return format.open(self, _found=True, ignore_fallbacks=ignore_fallbacks)
 
     def open_repository(self, unsupported=False):
         """See BzrDir.open_repository."""
@@ -1895,8 +1783,6 @@
     Once a format is deprecated, just deprecate the initialize and open
     methods on the format class. Do not deprecate the object, as the
     object will be created every system load.
-
-    :cvar colocated_branches: Whether this formats supports colocated branches.
     """
 
     _default_format = None
@@ -1919,10 +1805,6 @@
 
     _lock_file_name = 'branch-lock'
 
-    colocated_branches = False
-    """Whether co-located branches are supported for this control dir format.
-    """
-
     # _lock_class must be set in subclasses to the lock type, typ.
     # TransportLock or LockDir
 
@@ -2727,17 +2609,12 @@
     def convert(self, to_convert, pb):
         """See Converter.convert()."""
         self.bzrdir = to_convert
-        if pb is not None:
-            warnings.warn("pb parameter to convert() is deprecated")
-        self.pb = ui.ui_factory.nested_progress_bar()
-        try:
-            ui.ui_factory.note('starting upgrade from format 4 to 5')
-            if isinstance(self.bzrdir.transport, local.LocalTransport):
-                self.bzrdir.get_workingtree_transport(None).delete('stat-cache')
-            self._convert_to_weaves()
-            return BzrDir.open(self.bzrdir.user_url)
-        finally:
-            self.pb.finished()
+        self.pb = pb
+        ui.ui_factory.note('starting upgrade from format 4 to 5')
+        if isinstance(self.bzrdir.transport, local.LocalTransport):
+            self.bzrdir.get_workingtree_transport(None).delete('stat-cache')
+        self._convert_to_weaves()
+        return BzrDir.open(self.bzrdir.root_transport.base)
 
     def _convert_to_weaves(self):
         ui.ui_factory.note('note: upgrade may be faster if all store files are ungzipped first')
@@ -2984,13 +2861,10 @@
     def convert(self, to_convert, pb):
         """See Converter.convert()."""
         self.bzrdir = to_convert
-        pb = ui.ui_factory.nested_progress_bar()
-        try:
-            ui.ui_factory.note('starting upgrade from format 5 to 6')
-            self._convert_to_prefixed()
-            return BzrDir.open(self.bzrdir.user_url)
-        finally:
-            pb.finished()
+        self.pb = pb
+        ui.ui_factory.note('starting upgrade from format 5 to 6')
+        self._convert_to_prefixed()
+        return BzrDir.open(self.bzrdir.root_transport.base)
 
     def _convert_to_prefixed(self):
         from bzrlib.store import TransportStore
@@ -3029,7 +2903,7 @@
         from bzrlib.repofmt.weaverepo import RepositoryFormat7
         from bzrlib.branch import BzrBranchFormat5
         self.bzrdir = to_convert
-        self.pb = ui.ui_factory.nested_progress_bar()
+        self.pb = pb
         self.count = 0
         self.total = 20 # the steps we know about
         self.garbage_inventories = []
@@ -3115,8 +2989,7 @@
             'branch-format',
             BzrDirMetaFormat1().get_format_string(),
             mode=self.file_mode)
-        self.pb.finished()
-        return BzrDir.open(self.bzrdir.user_url)
+        return BzrDir.open(self.bzrdir.root_transport.base)
 
     def make_lock(self, name):
         """Make a lock for the new control dir name."""
@@ -3157,7 +3030,7 @@
     def convert(self, to_convert, pb):
         """See Converter.convert()."""
         self.bzrdir = to_convert
-        self.pb = ui.ui_factory.nested_progress_bar()
+        self.pb = pb
         self.count = 0
         self.total = 1
         self.step('checking repository format')
@@ -3171,7 +3044,11 @@
                 ui.ui_factory.note('starting repository conversion')
                 converter = CopyConverter(self.target_format.repository_format)
                 converter.convert(repo, pb)
-        for branch in self.bzrdir.list_branches():
+        try:
+            branch = self.bzrdir.open_branch()
+        except errors.NotBranchError:
+            pass
+        else:
             # TODO: conversions of Branch and Tree should be done by
             # InterXFormat lookups/some sort of registry.
             # Avoid circular imports
@@ -3219,7 +3096,6 @@
                 isinstance(self.target_format.workingtree_format,
                     workingtree_4.WorkingTreeFormat6)):
                 workingtree_4.Converter4or5to6().convert(tree)
-        self.pb.finished()
         return to_convert
 
 
@@ -3232,10 +3108,6 @@
 
     def __init__(self):
         BzrDirMetaFormat1.__init__(self)
-        # XXX: It's a bit ugly that the network name is here, because we'd
-        # like to believe that format objects are stateless or at least
-        # immutable,  However, we do at least avoid mutating the name after
-        # it's returned.  See <https://bugs.edge.launchpad.net/bzr/+bug/504102>
         self._network_name = None
 
     def __repr__(self):
@@ -3384,11 +3256,12 @@
         args.append(self._serialize_NoneString(repo_format_name))
         args.append(self._serialize_NoneTrueFalse(make_working_trees))
         args.append(self._serialize_NoneTrueFalse(shared_repo))
-        request_network_name = self._network_name or \
+        if self._network_name is None:
+            self._network_name = \
             BzrDirFormat.get_default_format().network_name()
         try:
             response = client.call('BzrDirFormat.initialize_ex_1.16',
-                request_network_name, path, *args)
+                self.network_name(), path, *args)
         except errors.UnknownSmartMethod:
             client._medium._remember_remote_is_before((1,16))
             local_dir_format = BzrDirMetaFormat1()
@@ -3644,7 +3517,7 @@
                 experimental_pairs.append((key, help))
             else:
                 output += wrapped(key, help, info)
-        output += "\nSee :doc:`formats-help` for more about storage formats."
+        output += "\nSee ``bzr help formats`` for more about storage formats."
         other_output = ""
         if len(experimental_pairs) > 0:
             other_output += "Experimental formats are shown below.\n\n"
@@ -3663,7 +3536,7 @@
             other_output += \
                 "\nNo deprecated formats are available.\n\n"
         other_output += \
-                "\nSee :doc:`formats-help` for more about storage formats."
+            "\nSee ``bzr help formats`` for more about storage formats."
 
         if topic == 'other-formats':
             return other_output
@@ -3703,7 +3576,7 @@
             try:
                 stack_on = urlutils.rebase_url(self._stack_on,
                     self._stack_on_pwd,
-                    branch.user_url)
+                    branch.bzrdir.root_transport.base)
             except errors.InvalidRebaseURLs:
                 stack_on = self._get_full_stack_on()
         try:
@@ -3838,21 +3711,18 @@
 format_registry.register('weave', BzrDirFormat6,
     'Pre-0.8 format.  Slower than knit and does not'
     ' support checkouts or shared repositories.',
-    hidden=True,
     deprecated=True)
 format_registry.register_metadir('metaweave',
     'bzrlib.repofmt.weaverepo.RepositoryFormat7',
     'Transitional format in 0.8.  Slower than knit.',
     branch_format='bzrlib.branch.BzrBranchFormat5',
     tree_format='bzrlib.workingtree.WorkingTreeFormat3',
-    hidden=True,
     deprecated=True)
 format_registry.register_metadir('knit',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
     'Format using knits.  Recommended for interoperation with bzr <= 0.14.',
     branch_format='bzrlib.branch.BzrBranchFormat5',
     tree_format='bzrlib.workingtree.WorkingTreeFormat3',
-    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
@@ -3862,7 +3732,6 @@
     # this uses bzrlib.workingtree.WorkingTreeFormat4 because importing
     # directly from workingtree_4 triggers a circular import.
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate-tags',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
@@ -3871,7 +3740,6 @@
         ' Incompatible with bzr < 0.15.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     deprecated=True)
 format_registry.register_metadir('rich-root',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit4',
@@ -3879,7 +3747,6 @@
         ' bzr < 1.0.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate-with-subtree',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit3',
@@ -3896,7 +3763,9 @@
     help='New in 0.92: Pack-based format with data compatible with '
         'dirstate-tags format repositories. Interoperates with '
         'bzr repositories before 0.92 but cannot be read by bzr < 0.92. '
-        ,
+        'Previously called knitpack-experimental.  '
+        'For more information, see '
+        'http://doc.bazaar-vcs.org/latest/developers/packrepo.html.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
     )
@@ -3905,7 +3774,9 @@
     help='New in 0.92: Pack-based format with data compatible with '
         'dirstate-with-subtree format repositories. Interoperates with '
         'bzr repositories before 0.92 but cannot be read by bzr < 0.92. '
-        ,
+        'Previously called knitpack-experimental.  '
+        'For more information, see '
+        'http://doc.bazaar-vcs.org/latest/developers/packrepo.html.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
     hidden=True,
@@ -3917,7 +3788,6 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     )
 format_registry.register_metadir('1.6',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5',
@@ -3926,7 +3796,6 @@
          'not present locally.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     )
 format_registry.register_metadir('1.6.1-rich-root',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5RichRoot',
@@ -3934,7 +3803,6 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     )
 format_registry.register_metadir('1.9',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
@@ -3943,7 +3811,6 @@
          'performance for most operations.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     )
 format_registry.register_metadir('1.9-rich-root',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6RichRoot',
@@ -3951,7 +3818,6 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
     )
 format_registry.register_metadir('1.14',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
@@ -3973,13 +3839,12 @@
         'to and from rich-root-pack (and anything compatible with '
         'rich-root-pack) format repositories. Repositories and branches in '
         'this format can only be read by bzr.dev. Please read '
-        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
+        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
     alias=True,
-    hidden=True,
     )
 format_registry.register_metadir('development-subtree',
     'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment2Subtree',
@@ -3987,12 +3852,11 @@
         'from pack-0.92-subtree (and anything compatible with '
         'pack-0.92-subtree) format repositories. Repositories and branches in '
         'this format can only be read by bzr.dev. Please read '
-        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
+        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
-    hidden=True,
     alias=False, # Restore to being an alias when an actual development subtree format is added
                  # This current non-alias status is simply because we did not introduce a
                  # chk based subtree format.
@@ -4003,7 +3867,7 @@
     'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK1',
     help='pack-1.9 with 255-way hashed CHK inv, group compress, rich roots '
         'Please read '
-        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
+        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
@@ -4015,7 +3879,7 @@
     'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK2',
     help='pack-1.9 with 255-way hashed CHK inv, bencode revision, group compress, '
         'rich roots. Please read '
-        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
+        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
@@ -4042,7 +3906,6 @@
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     alias=True,
-    hidden=True,
     help='Same as 2a.')
 
 # The current format that is made on 'bzr init'.

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2010-04-30 11:35:43 +0000
+++ bzrlib/check.py	2009-09-18 01:06:10 +0000
@@ -46,9 +46,13 @@
   indicating that the revision was found/not found.
 """
 
-from bzrlib import errors
+from bzrlib import errors, osutils
+from bzrlib import repository as _mod_repository
+from bzrlib import revision
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
+from bzrlib.errors import BzrCheckError
+from bzrlib.repository import Repository
 from bzrlib.revision import NULL_REVISION
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note
@@ -188,8 +192,8 @@
 
     def _report_repo_results(self, verbose):
         note('checked repository %s format %s',
-            self.repository.user_url,
-            self.repository._format)
+             self.repository.bzrdir.root_transport,
+             self.repository._format)
         note('%6d revisions', self.checked_rev_cnt)
         note('%6d file-ids', len(self.checked_weaves))
         if verbose:
@@ -447,7 +451,7 @@
             if do_repo or do_branch or do_tree:
                 if do_repo:
                     note("Checking repository at '%s'."
-                         % (repo.user_url,))
+                         % (repo.bzrdir.root_transport.base,))
                 result = repo.check(None, callback_refs=needed_refs,
                     check_repo=do_repo)
                 result.report_results(verbose)

=== modified file 'bzrlib/chk_map.py'
--- bzrlib/chk_map.py	2010-04-21 20:33:10 +0000
+++ bzrlib/chk_map.py	2009-11-02 17:27:52 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,7 +38,6 @@
 """
 
 import heapq
-import threading
 
 from bzrlib import lazy_import
 lazy_import.lazy_import(globals(), """
@@ -60,31 +59,11 @@
 # If each line is 50 bytes, and you have 255 internal pages, with 255-way fan
 # out, it takes 3.1MB to cache the layer.
 _PAGE_CACHE_SIZE = 4*1024*1024
-# Per thread caches for 2 reasons:
-# - in the server we may be serving very different content, so we get less
-#   cache thrashing.
-# - we avoid locking on every cache lookup.
-_thread_caches = threading.local()
-# The page cache.
-_thread_caches.page_cache = None
-
-def _get_cache():
-    """Get the per-thread page cache.
-
-    We need a function to do this because in a new thread the _thread_caches
-    threading.local object does not have the cache initialized yet.
-    """
-    page_cache = getattr(_thread_caches, 'page_cache', None)
-    if page_cache is None:
-        # We are caching bytes so len(value) is perfectly accurate
-        page_cache = lru_cache.LRUSizeCache(_PAGE_CACHE_SIZE)
-        _thread_caches.page_cache = page_cache
-    return page_cache
-
+# We are caching bytes so len(value) is perfectly accurate
+_page_cache = lru_cache.LRUSizeCache(_PAGE_CACHE_SIZE)
 
 def clear_cache():
-    _get_cache().clear()
-
+    _page_cache.clear()
 
 # If a ChildNode falls below this many bytes, we check for a remap
 _INTERESTING_NEW_SIZE = 50
@@ -182,11 +161,11 @@
 
     def _read_bytes(self, key):
         try:
-            return _get_cache()[key]
+            return _page_cache[key]
         except KeyError:
             stream = self._store.get_record_stream([key], 'unordered', True)
             bytes = stream.next().get_bytes_as('fulltext')
-            _get_cache()[key] = bytes
+            _page_cache[key] = bytes
             return bytes
 
     def _dump_tree(self, include_keys=False):
@@ -692,12 +671,13 @@
         the key/value pairs.
     """
 
-    __slots__ = ('_common_serialised_prefix',)
+    __slots__ = ('_common_serialised_prefix', '_serialise_key')
 
     def __init__(self, search_key_func=None):
         Node.__init__(self)
         # All of the keys in this leaf node share this common prefix
         self._common_serialised_prefix = None
+        self._serialise_key = '\x00'.join
         if search_key_func is None:
             self._search_key_func = _search_key_plain
         else:
@@ -887,8 +867,6 @@
                 raise AssertionError('%r must be known' % self._search_prefix)
             return self._search_prefix, [("", self)]
 
-    _serialise_key = '\x00'.join
-
     def serialise(self, store):
         """Serialise the LeafNode to store.
 
@@ -923,7 +901,7 @@
         bytes = ''.join(lines)
         if len(bytes) != self._current_size():
             raise AssertionError('Invalid _current_size')
-        _get_cache().add(self._key, bytes)
+        _page_cache.add(self._key, bytes)
         return [self._key]
 
     def refs(self):
@@ -1165,7 +1143,7 @@
             found_keys = set()
             for key in keys:
                 try:
-                    bytes = _get_cache()[key]
+                    bytes = _page_cache[key]
                 except KeyError:
                     continue
                 else:
@@ -1196,7 +1174,7 @@
                     prefix, node_key_filter = keys[record.key]
                     node_and_filters.append((node, node_key_filter))
                     self._items[prefix] = node
-                    _get_cache().add(record.key, bytes)
+                    _page_cache.add(record.key, bytes)
                 for info in node_and_filters:
                     yield info
 
@@ -1322,7 +1300,7 @@
             lines.append(serialised[prefix_len:])
         sha1, _, _ = store.add_lines((None,), (), lines)
         self._key = StaticTuple("sha1:" + sha1,).intern()
-        _get_cache().add(self._key, ''.join(lines))
+        _page_cache.add(self._key, ''.join(lines))
         yield self._key
 
     def _search_key(self, key):
@@ -1511,11 +1489,11 @@
         self._state = None
 
     def _read_nodes_from_store(self, keys):
-        # We chose not to use _get_cache(), because we think in
-        # terms of records to be yielded. Also, we expect to touch each page
-        # only 1 time during this code. (We may want to evaluate saving the
-        # raw bytes into the page cache, which would allow a working tree
-        # update after the fetch to not have to read the bytes again.)
+        # We chose not to use _page_cache, because we think in terms of records
+        # to be yielded. Also, we expect to touch each page only 1 time during
+        # this code. (We may want to evaluate saving the raw bytes into the
+        # page cache, which would allow a working tree update after the fetch
+        # to not have to read the bytes again.)
         as_st = StaticTuple.from_sequence
         stream = self._store.get_record_stream(keys, 'unordered', True)
         for record in stream:

=== modified file 'bzrlib/chk_serializer.py'
--- bzrlib/chk_serializer.py	2010-02-17 17:11:16 +0000
+++ bzrlib/chk_serializer.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/clean_tree.py'
--- bzrlib/clean_tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/clean_tree.py	2009-03-23 14:59:43 +0000
@@ -15,10 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+import errno
 import os
 import shutil
+import sys
 
-from bzrlib.osutils import isdir
+from bzrlib.osutils import has_symlinks, isdir
 from bzrlib.trace import note
 from bzrlib.workingtree import WorkingTree
 

=== modified file 'bzrlib/cleanup.py'
--- bzrlib/cleanup.py	2010-03-03 22:59:21 +0000
+++ bzrlib/cleanup.py	2009-10-26 06:23:14 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,9 +31,9 @@
 If you want to be certain that the first, and only the first, error is raised,
 then use::
 
-    operation = OperationWithCleanups(do_something)
+    operation = OperationWithCleanups(lambda operation: do_something())
     operation.add_cleanup(cleanup_something)
-    operation.run_simple()
+    operation.run()
 
 This is more inconvenient (because you need to make every try block a
 function), but will ensure that the first error encountered is the one raised,
@@ -91,14 +91,13 @@
 
     where `some_func` is::
 
-        def some_func(operation, args, ...):
+        def some_func(operation, args, ...)
             do_something()
             operation.add_cleanup(something)
             # etc
 
     Note that the first argument passed to `some_func` will be the
-    OperationWithCleanups object.  To invoke `some_func` without that, use
-    `run_simple` instead of `run`.
+    OperationWithCleanups object.
     """
 
     def __init__(self, func):
@@ -117,14 +116,6 @@
         return _do_with_cleanups(
             self.cleanups, self.func, self, *args, **kwargs)
 
-    def run_simple(self, *args, **kwargs):
-        return _do_with_cleanups(
-            self.cleanups, self.func, *args, **kwargs)
-
-    def cleanup_now(self):
-        _run_cleanups(self.cleanups)
-        self.cleanups.clear()
-
 
 def _do_with_cleanups(cleanup_funcs, func, *args, **kwargs):
     """Run `func`, then call all the cleanup_funcs.

=== modified file 'bzrlib/cmd_version_info.py'
--- bzrlib/cmd_version_info.py	2010-04-02 19:12:58 +0000
+++ bzrlib/cmd_version_info.py	2009-11-16 02:26:32 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -48,7 +48,7 @@
 
 
 class cmd_version_info(Command):
-    __doc__ = """Show version information about this tree.
+    """Show version information about this tree.
 
     You can use this command to add information about version into
     source code of an application. The output can be in one of the

=== removed file 'bzrlib/cmdline.py'
--- bzrlib/cmdline.py	2010-03-01 09:02:18 +0000
+++ bzrlib/cmdline.py	1970-01-01 00:00:00 +0000
@@ -1,160 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Unicode-compatible command-line splitter for all platforms."""
-
-import re
-
-
-_whitespace_match = re.compile(u'\s', re.UNICODE).match
-
-
-class _PushbackSequence(object):
-    def __init__(self, orig):
-        self._iter = iter(orig)
-        self._pushback_buffer = []
-
-    def next(self):
-        if len(self._pushback_buffer) > 0:
-            return self._pushback_buffer.pop()
-        else:
-            return self._iter.next()
-
-    def pushback(self, char):
-        self._pushback_buffer.append(char)
-
-    def __iter__(self):
-        return self
-
-
-class _Whitespace(object):
-    def process(self, next_char, context):
-        if _whitespace_match(next_char):
-            if len(context.token) > 0:
-                return None
-            else:
-                return self
-        elif next_char in context.allowed_quote_chars:
-            context.quoted = True
-            return _Quotes(next_char, self)
-        elif next_char == u'\\':
-            return _Backslash(self)
-        else:
-            context.token.append(next_char)
-            return _Word()
-
-
-class _Quotes(object):
-    def __init__(self, quote_char, exit_state):
-        self.quote_char = quote_char
-        self.exit_state = exit_state
-
-    def process(self, next_char, context):
-        if next_char == u'\\':
-            return _Backslash(self)
-        elif next_char == self.quote_char:
-            return self.exit_state
-        else:
-            context.token.append(next_char)
-            return self
-
-
-class _Backslash(object):
-    # See http://msdn.microsoft.com/en-us/library/bb776391(VS.85).aspx
-    def __init__(self, exit_state):
-        self.exit_state = exit_state
-        self.count = 1
-
-    def process(self, next_char, context):
-        if next_char == u'\\':
-            self.count += 1
-            return self
-        elif next_char in context.allowed_quote_chars:
-            # 2N backslashes followed by a quote are N backslashes
-            context.token.append(u'\\' * (self.count/2))
-            # 2N+1 backslashes follwed by a quote are N backslashes followed by
-            # the quote which should not be processed as the start or end of
-            # the quoted arg
-            if self.count % 2 == 1:
-                # odd number of \ escapes the quote
-                context.token.append(next_char)
-            else:
-                # let exit_state handle next_char
-                context.seq.pushback(next_char)
-            self.count = 0
-            return self.exit_state
-        else:
-            # N backslashes not followed by a quote are just N backslashes
-            if self.count > 0:
-                context.token.append(u'\\' * self.count)
-                self.count = 0
-            # let exit_state handle next_char
-            context.seq.pushback(next_char)
-            return self.exit_state
-
-    def finish(self, context):
-        if self.count > 0:
-            context.token.append(u'\\' * self.count)
-
-
-class _Word(object):
-    def process(self, next_char, context):
-        if _whitespace_match(next_char):
-            return None
-        elif next_char in context.allowed_quote_chars:
-            return _Quotes(next_char, self)
-        elif next_char == u'\\':
-            return _Backslash(self)
-        else:
-            context.token.append(next_char)
-            return self
-
-
-class Splitter(object):
-    def __init__(self, command_line, single_quotes_allowed):
-        self.seq = _PushbackSequence(command_line)
-        self.allowed_quote_chars = u'"'
-        if single_quotes_allowed:
-            self.allowed_quote_chars += u"'"
-
-    def __iter__(self):
-        return self
-
-    def next(self):
-        quoted, token = self._get_token()
-        if token is None:
-            raise StopIteration
-        return quoted, token
-
-    def _get_token(self):
-        self.quoted = False
-        self.token = []
-        state = _Whitespace()
-        for next_char in self.seq:
-            state = state.process(next_char, self)
-            if state is None:
-                break
-        if not state is None and not getattr(state, 'finish', None) is None:
-            state.finish(self)
-        result = u''.join(self.token)
-        if not self.quoted and result == '':
-            result = None
-        return self.quoted, result
-
-
-def split(unsplit, single_quotes_allowed=True):
-    splitter = Splitter(unsplit, single_quotes_allowed=single_quotes_allowed)
-    return [arg for quoted, arg in splitter]

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2010-04-16 07:56:51 +0000
+++ bzrlib/commands.py	2009-12-18 17:59:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,6 +15,9 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+# TODO: probably should say which arguments are candidates for glob
+# expansion on windows and do that at the command level.
+
 # TODO: Define arguments by objects, rather than just using names.
 # Those objects can specify the expected type of the argument, which
 # would help with validation and shell completion.  They could also provide
@@ -22,6 +25,9 @@
 
 # TODO: Specific "examples" property on commands for consistent formatting.
 
+# TODO: "--profile=cum", to change sort order.  Is there any value in leaving
+# the profile output behind so it can be interactively examined?
+
 import os
 import sys
 
@@ -34,8 +40,6 @@
 
 import bzrlib
 from bzrlib import (
-    cleanup,
-    cmdline,
     debug,
     errors,
     option,
@@ -49,12 +53,12 @@
 from bzrlib.hooks import HookPoint, Hooks
 # Compatibility - Option used to be in commands.
 from bzrlib.option import Option
-from bzrlib.plugin import disable_plugins, load_plugins
 from bzrlib import registry
 from bzrlib.symbol_versioning import (
     deprecated_function,
     deprecated_in,
     deprecated_method,
+    suppress_deprecation_warnings,
     )
 
 
@@ -72,22 +76,6 @@
 
 
 class CommandRegistry(registry.Registry):
-    """Special registry mapping command names to command classes.
-    
-    :ivar overridden_registry: Look in this registry for commands being
-        overridden by this registry.  This can be used to tell plugin commands
-        about the builtin they're decorating.
-    """
-
-    def __init__(self):
-        registry.Registry.__init__(self)
-        self.overridden_registry = None
-        # map from aliases to the real command that implements the name
-        self._alias_dict = {}
-
-    def get(self, command_name):
-        real_name = self._alias_dict.get(command_name, command_name)
-        return registry.Registry.get(self, real_name)
 
     @staticmethod
     def _get_name(command_name):
@@ -109,12 +97,7 @@
         try:
             previous = self.get(k_unsquished)
         except KeyError:
-            previous = None
-            if self.overridden_registry:
-                try:
-                    previous = self.overridden_registry.get(k_unsquished)
-                except KeyError:
-                    pass
+            previous = _builtin_commands().get(k_unsquished)
         info = CommandInfo.from_command(cmd)
         try:
             registry.Registry.register(self, k_unsquished, cmd,
@@ -125,8 +108,6 @@
                 sys.modules[cmd.__module__])
             trace.warning('Previously this command was registered from %r' %
                 sys.modules[previous.__module__])
-        for a in cmd.aliases:
-            self._alias_dict[a] = k_unsquished
         return previous
 
     def register_lazy(self, command_name, aliases, module_name):
@@ -139,20 +120,12 @@
         key = self._get_name(command_name)
         registry.Registry.register_lazy(self, key, module_name, command_name,
                                         info=CommandInfo(aliases))
-        for a in aliases:
-            self._alias_dict[a] = key
 
 
 plugin_cmds = CommandRegistry()
-builtin_command_registry = CommandRegistry()
-plugin_cmds.overridden_registry = builtin_command_registry
 
 
 def register_command(cmd, decorate=False):
-    """Register a plugin command.
-
-    Should generally be avoided in favor of lazy registration. 
-    """
     global plugin_cmds
     return plugin_cmds.register(cmd, decorate)
 
@@ -165,24 +138,9 @@
     return cmd[4:].replace('_','-')
 
 
-@deprecated_function(deprecated_in((2, 2, 0)))
 def _builtin_commands():
-    """Return a dict of {name: cmd_class} for builtin commands.
-
-    :deprecated: Use the builtin_command_registry registry instead
-    """
-    # return dict(name: cmd_class)
-    return dict(builtin_command_registry.items())
-
-
-def _register_builtin_commands():
-    if builtin_command_registry.keys():
-        # only load once
-        return
     import bzrlib.builtins
-    for cmd_class in _scan_module_for_commands(bzrlib.builtins).values():
-        builtin_command_registry.register(cmd_class)
-    bzrlib.builtins._register_lazy_builtins()
+    return _scan_module_for_commands(bzrlib.builtins)
 
 
 def _scan_module_for_commands(module):
@@ -195,10 +153,7 @@
 
 
 def _list_bzr_commands(names):
-    """Find commands from bzr's core and plugins.
-    
-    This is not the public interface, just the default hook called by all_command_names.
-    """
+    """Find commands from bzr's core and plugins."""
     # to eliminate duplicates
     names.update(builtin_command_names())
     names.update(plugin_command_names())
@@ -222,7 +177,7 @@
     Use of all_command_names() is encouraged rather than builtin_command_names
     and/or plugin_command_names.
     """
-    return builtin_command_registry.keys()
+    return _builtin_commands().keys()
 
 
 def plugin_command_names():
@@ -230,6 +185,23 @@
     return plugin_cmds.keys()
 
 
+@deprecated_function(deprecated_in((1, 17, 0)))
+def get_all_cmds(plugins_override=False):
+    """Return canonical name and class for most commands.
+    
+    NB: This does not return all commands since the introduction of
+    command hooks, and returning the class is not sufficient to 
+    get correctly setup commands, which is why it is deprecated.
+
+    Use 'all_command_names' + 'get_cmd_object' instead.
+    """
+    d = _builtin_commands()
+    if plugins_override:
+        d.update(plugin_cmds.iteritems())
+    for k, v in d.iteritems():
+        yield k,v
+
+
 def get_cmd_object(cmd_name, plugins_override=True):
     """Return the command object for a command.
 
@@ -242,13 +214,11 @@
         raise errors.BzrCommandError('unknown command "%s"' % cmd_name)
 
 
-def _get_cmd_object(cmd_name, plugins_override=True, check_missing=True):
+def _get_cmd_object(cmd_name, plugins_override=True):
     """Get a command object.
 
     :param cmd_name: The name of the command.
     :param plugins_override: Allow plugins to override builtins.
-    :param check_missing: Look up commands not found in the regular index via
-        the get_missing_command hook.
     :return: A Command object instance
     :raises KeyError: If no command is found.
     """
@@ -264,7 +234,7 @@
             # We've found a non-plugin command, don't permit it to be
             # overridden.
             break
-    if cmd is None and check_missing:
+    if cmd is None:
         for hook in Command.hooks['get_missing_command']:
             cmd = hook(cmd_name)
             if cmd is not None:
@@ -306,12 +276,15 @@
 
 def _get_bzr_command(cmd_or_None, cmd_name):
     """Get a command from bzr's core."""
+    cmds = _builtin_commands()
     try:
-        cmd_class = builtin_command_registry.get(cmd_name)
+        return cmds[cmd_name]()
     except KeyError:
         pass
-    else:
-        return cmd_class()
+    # look for any command which claims this as an alias
+    for real_cmd_name, cmd_class in cmds.iteritems():
+        if cmd_name in cmd_class.aliases:
+            return cmd_class()
     return cmd_or_None
 
 
@@ -411,29 +384,6 @@
             warn("No help message set for %r" % self)
         # List of standard options directly supported
         self.supported_std_options = []
-        self._setup_run()
-
-    def add_cleanup(self, cleanup_func, *args, **kwargs):
-        """Register a function to call after self.run returns or raises.
-
-        Functions will be called in LIFO order.
-        """
-        self._operation.add_cleanup(cleanup_func, *args, **kwargs)
-
-    def cleanup_now(self):
-        """Execute and empty pending cleanup functions immediately.
-
-        After cleanup_now all registered cleanups are forgotten.  add_cleanup
-        may be called again after cleanup_now; these cleanups will be called
-        after self.run returns or raises (or when cleanup_now is next called).
-
-        This is useful for releasing expensive or contentious resources (such
-        as write locks) before doing further work that does not require those
-        resources (such as writing results to self.outf). Note though, that
-        as it releases all resources, this may release locks that the command
-        wants to hold, so use should be done with care.
-        """
-        self._operation.cleanup_now()
 
     @deprecated_method(deprecated_in((2, 1, 0)))
     def _maybe_expand_globs(self, file_list):
@@ -561,9 +511,8 @@
                         # so don't create a real link
                         see_also_links.append(item)
                     else:
-                        # Use a Sphinx link for this entry
-                        link_text = ":doc:`%s <%s-help>`" % (item, item)
-                        see_also_links.append(link_text)
+                        # Use a reST link for this entry
+                        see_also_links.append("`%s`_" % (item,))
                 see_also = see_also_links
             result += ':See also: '
             result += ', '.join(see_also) + '\n'
@@ -652,6 +601,10 @@
 
     def run_argv_aliases(self, argv, alias_argv=None):
         """Parse the command line and run with extra aliases in alias_argv."""
+        if argv is None:
+            warn("Passing None for [] is deprecated from bzrlib 0.10",
+                 DeprecationWarning, stacklevel=2)
+            argv = []
         args, opts = parse_args(self, argv, alias_argv)
 
         # Process the standard options
@@ -684,29 +637,6 @@
 
         return self.run(**all_cmd_args)
 
-    def _setup_run(self):
-        """Wrap the defined run method on self with a cleanup.
-
-        This is called by __init__ to make the Command be able to be run
-        by just calling run(), as it could be before cleanups were added.
-
-        If a different form of cleanups are in use by your Command subclass,
-        you can override this method.
-        """
-        class_run = self.run
-        def run(*args, **kwargs):
-            self._operation = cleanup.OperationWithCleanups(class_run)
-            try:
-                return self._operation.run_simple(*args, **kwargs)
-            finally:
-                del self._operation
-        self.run = run
-
-    @deprecated_method(deprecated_in((2, 2, 0)))
-    def run_direct(self, *args, **kwargs):
-        """Deprecated thunk from bzrlib 2.1."""
-        return self.run(*args, **kwargs)
-
     def run(self):
         """Actually run the command.
 
@@ -716,17 +646,6 @@
         Return 0 or None if the command was successful, or a non-zero
         shell error code if not.  It's OK for this method to allow
         an exception to raise up.
-
-        This method is automatically wrapped by Command.__init__ with a 
-        cleanup operation, stored as self._operation. This can be used
-        via self.add_cleanup to perform automatic cleanups at the end of
-        run().
-
-        The argument for run are assembled by introspection. So for instance,
-        if your command takes an argument files, you would declare::
-
-            def run(self, files=None):
-                pass
         """
         raise NotImplementedError('no implementation of command %r'
                                   % self.name())
@@ -949,9 +868,9 @@
     return ret
 
 
-@deprecated_function(deprecated_in((2, 2, 0)))
 def shlex_split_unicode(unsplit):
-    return cmdline.split(unsplit)
+    import shlex
+    return [u.decode('utf-8') for u in shlex.split(unsplit.encode('utf-8'))]
 
 
 def get_alias(cmd, config=None):
@@ -969,25 +888,19 @@
         config = bzrlib.config.GlobalConfig()
     alias = config.get_alias(cmd)
     if (alias):
-        return cmdline.split(alias)
+        return shlex_split_unicode(alias)
     return None
 
 
-def run_bzr(argv, load_plugins=load_plugins, disable_plugins=disable_plugins):
+def run_bzr(argv):
     """Execute a command.
 
-    :param argv: The command-line arguments, without the program name from
-        argv[0] These should already be decoded. All library/test code calling
-        run_bzr should be passing valid strings (don't need decoding).
-    :param load_plugins: What function to call when triggering plugin loading.
-        This function should take no arguments and cause all plugins to be
-        loaded.
-    :param disable_plugins: What function to call when disabling plugin
-        loading. This function should take no arguments and cause all plugin
-        loading to be prohibited (so that code paths in your application that
-        know about some plugins possibly being present will fail to import
-        those plugins even if they are installed.)
-    :return: Returns a command exit code or raises an exception.
+    argv
+       The command-line arguments, without the program name from argv[0]
+       These should already be decoded. All library/test code calling
+       run_bzr should be passing valid strings (don't need decoding).
+
+    Returns a command status or raises an exception.
 
     Special master options: these must come before the command because
     they control how the command is interpreted.
@@ -1014,7 +927,6 @@
     --concurrency
         Specify the number of processes that can be run concurrently (selftest).
     """
-    trace.mutter("bazaar version: " + bzrlib.__version__)
     argv = list(argv)
     trace.mutter("bzr arguments: %r", argv)
 
@@ -1058,20 +970,24 @@
 
     debug.set_debug_flags_from_config()
 
+    argv = argv_copy
+    if (not argv):
+        from bzrlib.builtins import cmd_help
+        cmd_help().run_argv_aliases([])
+        return 0
+
+    if argv[0] == '--version':
+        from bzrlib.builtins import cmd_version
+        cmd_version().run_argv_aliases([])
+        return 0
+
     if not opt_no_plugins:
+        from bzrlib.plugin import load_plugins
         load_plugins()
     else:
+        from bzrlib.plugin import disable_plugins
         disable_plugins()
 
-    argv = argv_copy
-    if (not argv):
-        get_cmd_object('help').run_argv_aliases([])
-        return 0
-
-    if argv[0] == '--version':
-        get_cmd_object('version').run_argv_aliases([])
-        return 0
-
     alias_argv = None
 
     if not opt_no_aliases:
@@ -1155,12 +1071,25 @@
         "bzr plugin-provider-db check")
 
 
-
-def _specified_or_unicode_argv(argv):
-    # For internal or testing use, argv can be passed.  Otherwise, get it from
-    # the process arguments in a unicode-safe way.
+def main(argv=None):
+    """Main entry point of command-line interface.
+
+    :param argv: list of unicode command-line arguments similar to sys.argv.
+        argv[0] is script name usually, it will be ignored.
+        Don't pass here sys.argv because this list contains plain strings
+        and not unicode; pass None instead.
+
+    :return: exit code of bzr command.
+    """
+    import bzrlib.ui
+    bzrlib.ui.ui_factory = bzrlib.ui.make_ui_for_terminal(
+        sys.stdin, sys.stdout, sys.stderr)
+
+    # Is this a final release version? If so, we should suppress warnings
+    if bzrlib.version_info[3] == 'final':
+        suppress_deprecation_warnings(override=True)
     if argv is None:
-        return osutils.get_unicode_argv()
+        argv = osutils.get_unicode_argv()
     else:
         new_argv = []
         try:
@@ -1172,27 +1101,12 @@
                     new_argv.append(a.decode('ascii'))
         except UnicodeDecodeError:
             raise errors.BzrError("argv should be list of unicode strings.")
-        return new_argv
-
-
-def main(argv=None):
-    """Main entry point of command-line interface.
-
-    Typically `bzrlib.initialize` should be called first.
-
-    :param argv: list of unicode command-line arguments similar to sys.argv.
-        argv[0] is script name usually, it will be ignored.
-        Don't pass here sys.argv because this list contains plain strings
-        and not unicode; pass None instead.
-
-    :return: exit code of bzr command.
-    """
-    argv = _specified_or_unicode_argv(argv)
-    _register_builtin_commands()
+        argv = new_argv
     ret = run_bzr_catch_errors(argv)
     bzrlib.ui.ui_factory.log_transport_activity(
         display=('bytes' in debug.debug_flags))
     trace.mutter("return code %d", ret)
+    osutils.report_extension_load_failures()
     return ret
 
 
@@ -1202,7 +1116,6 @@
     This function assumed that that UI layer is setup, that symbol deprecations
     are already applied, and that unicode decoding has already been performed on argv.
     """
-    # done here so that they're covered for every test run
     install_bzr_command_hooks()
     return exception_to_return_code(run_bzr, argv)
 
@@ -1213,7 +1126,6 @@
     This is used for the test suite, and might be useful for other programs
     that want to wrap the commandline interface.
     """
-    # done here so that they're covered for every test run
     install_bzr_command_hooks()
     try:
         return run_bzr(argv)
@@ -1242,7 +1154,7 @@
         if topic and topic.startswith(self.prefix):
             topic = topic[len(self.prefix):]
         try:
-            cmd = _get_cmd_object(topic, check_missing=False)
+            cmd = _get_cmd_object(topic)
         except KeyError:
             return []
         else:
@@ -1269,3 +1181,7 @@
             yield provider
 
 command_providers_registry = ProvidersRegistry()
+
+
+if __name__ == '__main__':
+    sys.exit(main(sys.argv))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2010-04-30 11:35:43 +0000
+++ bzrlib/commit.py	2009-10-15 02:53:30 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -49,12 +49,20 @@
 # TODO: Change the parameter 'rev_id' to 'revision_id' to be consistent with
 # the rest of the code; add a deprecation of the old name.
 
+import os
+import re
+import sys
+import time
+
+from cStringIO import StringIO
+
 from bzrlib import (
     debug,
     errors,
     revision,
     trace,
     tree,
+    xml_serializer,
     )
 from bzrlib.branch import Branch
 from bzrlib.cleanup import OperationWithCleanups
@@ -64,13 +72,20 @@
                            StrictCommitFailed
                            )
 from bzrlib.osutils import (get_user_encoding,
-                            is_inside_any,
+                            kind_marker, isdir,isfile, is_inside_any,
+                            is_inside_or_parent_of_any,
                             minimum_path_selection,
+                            quotefn, sha_file, split_lines,
                             splitpath,
                             )
-from bzrlib.trace import mutter, note, is_quiet
+from bzrlib.testament import Testament
+from bzrlib.trace import mutter, note, warning, is_quiet
 from bzrlib.inventory import Inventory, InventoryEntry, make_entry
 from bzrlib import symbol_versioning
+from bzrlib.symbol_versioning import (deprecated_passed,
+        deprecated_function,
+        DEPRECATED_PARAMETER)
+from bzrlib.workingtree import WorkingTree
 from bzrlib.urlutils import unescape_for_display
 import bzrlib.ui
 
@@ -132,12 +147,6 @@
 
     def completed(self, revno, rev_id):
         self._note('Committed revision %d.', revno)
-        # self._note goes to the console too; so while we want to log the
-        # rev_id, we can't trivially only log it. (See bug 526425). Long
-        # term we should rearrange the reporting structure, but for now
-        # we just mutter seperately. We mutter the revid and revno together
-        # so that concurrent bzr invocations won't lead to confusion.
-        mutter('Committed revid %s as revno %d.', rev_id, revno)
 
     def deleted(self, path):
         self._note('deleted %s', path)
@@ -227,9 +236,6 @@
             commit.
         """
         operation = OperationWithCleanups(self._commit)
-        self.revprops = revprops or {}
-        # XXX: Can be set on __init__ or passed in - this is a bit ugly.
-        self.config = config or self.config
         return operation.run(
                message=message,
                timestamp=timestamp,
@@ -240,17 +246,19 @@
                allow_pointless=allow_pointless,
                strict=strict,
                verbose=verbose,
+               revprops=revprops,
                working_tree=working_tree,
                local=local,
                reporter=reporter,
+               config=config,
                message_callback=message_callback,
                recursive=recursive,
                exclude=exclude,
                possible_master_transports=possible_master_transports)
 
     def _commit(self, operation, message, timestamp, timezone, committer,
-            specific_files, rev_id, allow_pointless, strict, verbose,
-            working_tree, local, reporter, message_callback, recursive,
+            specific_files, rev_id, allow_pointless, strict, verbose, revprops,
+            working_tree, local, reporter, config, message_callback, recursive,
             exclude, possible_master_transports):
         mutter('preparing to commit')
 
@@ -291,6 +299,7 @@
             self.specific_files = None
             
         self.allow_pointless = allow_pointless
+        self.revprops = revprops
         self.message_callback = message_callback
         self.timestamp = timestamp
         self.timezone = timezone
@@ -362,7 +371,7 @@
         # Collect the changes
         self._set_progress_stage("Collecting changes", counter=True)
         self.builder = self.branch.get_commit_builder(self.parents,
-            self.config, timestamp, timezone, committer, self.revprops, rev_id)
+            self.config, timestamp, timezone, committer, revprops, rev_id)
 
         try:
             self.builder.will_record_deletes()

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2010-04-24 09:08:27 +0000
+++ bzrlib/config.py	2009-12-17 10:01:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2007, 2008 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
 #            and others
 #
@@ -193,15 +193,7 @@
             interpreted as a boolean. Returns True or False otherwise.
         """
         s = self._get_user_option(option_name)
-        if s is None:
-            # The option doesn't exist
-            return None
-        val = ui.bool_from_string(s)
-        if val is None:
-            # The value can't be interpreted as a boolean
-            trace.warning('Value "%s" is not a boolean for "%s"',
-                          s, option_name)
-        return val
+        return ui.bool_from_string(s)
 
     def get_user_option_as_list(self, option_name):
         """Get a generic option as a list - no special process, no default.
@@ -518,9 +510,7 @@
         self._write_config_file()
 
     def _write_config_file(self):
-        path = self._get_filename()
-        f = open(path, 'wb')
-        osutils.copy_ownership_from_path(path)
+        f = open(self._get_filename(), 'wb')
         self._get_parser().write(f)
         f.close()
 
@@ -820,7 +810,6 @@
             os.mkdir(parent_dir)
         trace.mutter('creating config directory: %r', path)
         os.mkdir(path)
-        osutils.copy_ownership_from_path(path)
 
 
 def config_dir():
@@ -877,16 +866,12 @@
 
     This doesn't implicitly create it.
 
-    On Windows it's in the config directory; elsewhere it's /var/crash
-    which may be monitored by apport.  It can be overridden by
-    $APPORT_CRASH_DIR.
+    On Windows it's in the config directory; elsewhere in the XDG cache directory.
     """
     if sys.platform == 'win32':
         return osutils.pathjoin(config_dir(), 'Crash')
     else:
-        # XXX: hardcoded in apport_python_hook.py; therefore here too -- mbp
-        # 2010-01-31
-        return os.environ.get('APPORT_CRASH_DIR', '/var/crash')
+        return osutils.pathjoin(xdg_cache_dir(), 'crash')
 
 
 def xdg_cache_dir():
@@ -1417,7 +1402,7 @@
 
 
 class PlainTextCredentialStore(CredentialStore):
-    __doc__ = """Plain text credential store for the authentication.conf file"""
+    """Plain text credential store for the authentication.conf file."""
 
     def decode_password(self, credentials):
         """See CredentialStore.decode_password."""

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2010-04-30 11:35:43 +0000
+++ bzrlib/conflicts.py	2009-12-10 17:03:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+# TODO: Move this into builtins
+
 # TODO: 'bzr resolve' should accept a directory name and work from that
 # point down
 
@@ -25,27 +27,21 @@
 
 from bzrlib import (
     builtins,
-    cleanup,
     commands,
     errors,
     osutils,
     rio,
     trace,
-    transform,
-    workingtree,
     )
 """)
-from bzrlib import (
-    option,
-    registry,
-    )
+from bzrlib.option import Option
 
 
 CONFLICT_SUFFIXES = ('.THIS', '.BASE', '.OTHER')
 
 
 class cmd_conflicts(commands.Command):
-    __doc__ = """List files with conflicts.
+    """List files with conflicts.
 
     Merge will do its best to combine the changes in two branches, but there
     are some kinds of problems only a human can fix.  When it encounters those,
@@ -59,13 +55,14 @@
     Use bzr resolve when you have fixed a problem.
     """
     takes_options = [
-            option.Option('text',
-                          help='List paths of files with text conflicts.'),
+            Option('text',
+                   help='List paths of files with text conflicts.'),
         ]
-    _see_also = ['resolve', 'conflict-types']
+    _see_also = ['resolve']
 
     def run(self, text=False):
-        wt = workingtree.WorkingTree.open_containing(u'.')[0]
+        from bzrlib.workingtree import WorkingTree
+        wt = WorkingTree.open_containing(u'.')[0]
         for conflict in wt.conflicts():
             if text:
                 if conflict.typestring != 'text conflict':
@@ -75,30 +72,8 @@
                 self.outf.write(str(conflict) + '\n')
 
 
-resolve_action_registry = registry.Registry()
-
-
-resolve_action_registry.register(
-    'done', 'done', 'Marks the conflict as resolved' )
-resolve_action_registry.register(
-    'take-this', 'take_this',
-    'Resolve the conflict preserving the version in the working tree' )
-resolve_action_registry.register(
-    'take-other', 'take_other',
-    'Resolve the conflict taking the merged version into account' )
-resolve_action_registry.default_key = 'done'
-
-class ResolveActionOption(option.RegistryOption):
-
-    def __init__(self):
-        super(ResolveActionOption, self).__init__(
-            'action', 'How to resolve the conflict.',
-            value_switches=True,
-            registry=resolve_action_registry)
-
-
 class cmd_resolve(commands.Command):
-    __doc__ = """Mark a conflict as resolved.
+    """Mark a conflict as resolved.
 
     Merge will do its best to combine the changes in two branches, but there
     are some kinds of problems only a human can fix.  When it encounters those,
@@ -112,33 +87,20 @@
     aliases = ['resolved']
     takes_args = ['file*']
     takes_options = [
-            option.Option('all', help='Resolve all conflicts in this tree.'),
-            ResolveActionOption(),
+            Option('all', help='Resolve all conflicts in this tree.'),
             ]
     _see_also = ['conflicts']
-    def run(self, file_list=None, all=False, action=None):
+    def run(self, file_list=None, all=False):
+        from bzrlib.workingtree import WorkingTree
         if all:
             if file_list:
                 raise errors.BzrCommandError("If --all is specified,"
                                              " no FILE may be provided")
-            tree = workingtree.WorkingTree.open_containing('.')[0]
-            if action is None:
-                action = 'done'
+            tree = WorkingTree.open_containing('.')[0]
+            resolve(tree)
         else:
             tree, file_list = builtins.tree_files(file_list)
             if file_list is None:
-                if action is None:
-                    # FIXME: There is a special case here related to the option
-                    # handling that could be clearer and easier to discover by
-                    # providing an --auto action (bug #344013 and #383396) and
-                    # make it mandatory instead of implicit and active only
-                    # when no file_list is provided -- vila 091229
-                    action = 'auto'
-            else:
-                if action is None:
-                    action = 'done'
-        if action == 'auto':
-            if file_list is None:
                 un_resolved, resolved = tree.auto_resolve()
                 if len(un_resolved) > 0:
                     trace.note('%d conflict(s) auto-resolved.', len(resolved))
@@ -150,16 +112,10 @@
                     trace.note('All conflicts resolved.')
                     return 0
             else:
-                # FIXME: This can never occur but the block above needs some
-                # refactoring to transfer tree.auto_resolve() to
-                # conflict.auto(tree) --vila 091242
-                pass
-        else:
-            resolve(tree, file_list, action=action)
-
-
-def resolve(tree, paths=None, ignore_misses=False, recursive=False,
-            action='done'):
+                resolve(tree, file_list)
+
+
+def resolve(tree, paths=None, ignore_misses=False, recursive=False):
     """Resolve some or all of the conflicts in a working tree.
 
     :param paths: If None, resolve all conflicts.  Otherwise, select only
@@ -169,29 +125,24 @@
         recursive commands like revert, this should be True.  For commands
         or applications wishing finer-grained control, like the resolve
         command, this should be False.
-    :param ignore_misses: If False, warnings will be printed if the supplied
-        paths do not have conflicts.
-    :param action: How the conflict should be resolved,
+    :ignore_misses: If False, warnings will be printed if the supplied paths
+        do not have conflicts.
     """
     tree.lock_tree_write()
     try:
         tree_conflicts = tree.conflicts()
         if paths is None:
             new_conflicts = ConflictList()
-            to_process = tree_conflicts
+            selected_conflicts = tree_conflicts
         else:
-            new_conflicts, to_process = tree_conflicts.select_conflicts(
-                tree, paths, ignore_misses, recursive)
-        for conflict in to_process:
-            try:
-                conflict._do(action, tree)
-                conflict.cleanup(tree)
-            except NotImplementedError:
-                new_conflicts.append(conflict)
+            new_conflicts, selected_conflicts = \
+                tree_conflicts.select_conflicts(tree, paths, ignore_misses,
+                    recursive)
         try:
             tree.set_conflicts(new_conflicts)
         except errors.UnsupportedOperation:
             pass
+        selected_conflicts.remove_files(tree)
     finally:
         tree.unlock()
 
@@ -286,7 +237,12 @@
         for conflict in self:
             if not conflict.has_files:
                 continue
-            conflict.cleanup(tree)
+            for suffix in CONFLICT_SUFFIXES:
+                try:
+                    osutils.delete_any(tree.abspath(conflict.path+suffix))
+                except OSError, e:
+                    if e.errno != errno.ENOENT:
+                        raise
 
     def select_conflicts(self, tree, paths, ignore_misses=False,
                          recurse=False):
@@ -345,7 +301,6 @@
 class Conflict(object):
     """Base class for all types of conflict"""
 
-    # FIXME: cleanup should take care of that ? -- vila 091229
     has_files = False
 
     def __init__(self, path, file_id=None):
@@ -400,47 +355,6 @@
         else:
             return None, conflict.typestring
 
-    def _do(self, action, tree):
-        """Apply the specified action to the conflict.
-
-        :param action: The method name to call.
-
-        :param tree: The tree passed as a parameter to the method.
-        """
-        meth = getattr(self, 'action_%s' % action, None)
-        if meth is None:
-            raise NotImplementedError(self.__class__.__name__ + '.' + action)
-        meth(tree)
-
-    def associated_filenames(self):
-        """The names of the files generated to help resolve the conflict."""
-        raise NotImplementedError(self.associated_filenames)
-
-    def cleanup(self, tree):
-        for fname in self.associated_filenames():
-            try:
-                osutils.delete_any(tree.abspath(fname))
-            except OSError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-
-    def action_done(self, tree):
-        """Mark the conflict as solved once it has been handled."""
-        # This method does nothing but simplifies the design of upper levels.
-        pass
-
-    def action_take_this(self, tree):
-        raise NotImplementedError(self.action_take_this)
-
-    def action_take_other(self, tree):
-        raise NotImplementedError(self.action_take_other)
-
-    def _resolve_with_cleanups(self, tree, *args, **kwargs):
-        tt = transform.TreeTransform(tree)
-        op = cleanup.OperationWithCleanups(self._resolve)
-        op.add_cleanup(tt.finalize)
-        op.run_simple(tt, *args, **kwargs)
-
 
 class PathConflict(Conflict):
     """A conflict was encountered merging file paths"""
@@ -450,7 +364,6 @@
     format = 'Path conflict: %(path)s / %(conflict_path)s'
 
     rformat = '%(class)s(%(path)r, %(conflict_path)r, %(file_id)r)'
-
     def __init__(self, path, conflict_path=None, file_id=None):
         Conflict.__init__(self, path, file_id)
         self.conflict_path = conflict_path
@@ -461,100 +374,9 @@
             s.add('conflict_path', self.conflict_path)
         return s
 
-    def associated_filenames(self):
-        # No additional files have been generated here
-        return []
-
-    def _resolve(self, tt, file_id, path, winner):
-        """Resolve the conflict.
-
-        :param tt: The TreeTransform where the conflict is resolved.
-        :param file_id: The retained file id.
-        :param path: The retained path.
-        :param winner: 'this' or 'other' indicates which side is the winner.
-        """
-        path_to_create = None
-        if winner == 'this':
-            if self.path == '<deleted>':
-                return # Nothing to do
-            if self.conflict_path == '<deleted>':
-                path_to_create = self.path
-                revid = tt._tree.get_parent_ids()[0]
-        elif winner == 'other':
-            if self.conflict_path == '<deleted>':
-                return  # Nothing to do
-            if self.path == '<deleted>':
-                path_to_create = self.conflict_path
-                # FIXME: If there are more than two parents we may need to
-                # iterate. Taking the last parent is the safer bet in the mean
-                # time. -- vila 20100309
-                revid = tt._tree.get_parent_ids()[-1]
-        else:
-            # Programmer error
-            raise AssertionError('bad winner: %r' % (winner,))
-        if path_to_create is not None:
-            tid = tt.trans_id_tree_path(path_to_create)
-            transform.create_from_tree(
-                tt, tt.trans_id_tree_path(path_to_create),
-                self._revision_tree(tt._tree, revid), file_id)
-            tt.version_file(file_id, tid)
-
-        # Adjust the path for the retained file id
-        tid = tt.trans_id_file_id(file_id)
-        parent_tid = tt.get_tree_parent(tid)
-        tt.adjust_path(path, parent_tid, tid)
-        tt.apply()
-
-    def _revision_tree(self, tree, revid):
-        return tree.branch.repository.revision_tree(revid)
-
-    def _infer_file_id(self, tree):
-        # Prior to bug #531967, file_id wasn't always set, there may still be
-        # conflict files in the wild so we need to cope with them
-        # Establish which path we should use to find back the file-id
-        possible_paths = []
-        for p in (self.path, self.conflict_path):
-            if p == '<deleted>':
-                # special hard-coded path 
-                continue
-            if p is not None:
-                possible_paths.append(p)
-        # Search the file-id in the parents with any path available
-        file_id = None
-        for revid in tree.get_parent_ids():
-            revtree = self._revision_tree(tree, revid)
-            for p in possible_paths:
-                file_id = revtree.path2id(p)
-                if file_id is not None:
-                    return revtree, file_id
-        return None, None
-
-    def action_take_this(self, tree):
-        if self.file_id is not None:
-            self._resolve_with_cleanups(tree, self.file_id, self.path,
-                                        winner='this')
-        else:
-            # Prior to bug #531967 we need to find back the file_id and restore
-            # the content from there
-            revtree, file_id = self._infer_file_id(tree)
-            tree.revert([revtree.id2path(file_id)],
-                        old_tree=revtree, backups=False)
-
-    def action_take_other(self, tree):
-        if self.file_id is not None:
-            self._resolve_with_cleanups(tree, self.file_id,
-                                        self.conflict_path,
-                                        winner='other')
-        else:
-            # Prior to bug #531967 we need to find back the file_id and restore
-            # the content from there
-            revtree, file_id = self._infer_file_id(tree)
-            tree.revert([revtree.id2path(file_id)],
-                        old_tree=revtree, backups=False)
-
 
 class ContentsConflict(PathConflict):
-    """The files are of different types (or both binary), or not present"""
+    """The files are of different types, or not present"""
 
     has_files = True
 
@@ -562,47 +384,7 @@
 
     format = 'Contents conflict in %(path)s'
 
-    def associated_filenames(self):
-        return [self.path + suffix for suffix in ('.BASE', '.OTHER')]
-
-    def _resolve(self, tt, suffix_to_remove):
-        """Resolve the conflict.
-
-        :param tt: The TreeTransform where the conflict is resolved.
-        :param suffix_to_remove: Either 'THIS' or 'OTHER'
-
-        The resolution is symmetric, when taking THIS, OTHER is deleted and
-        item.THIS is renamed into item and vice-versa.
-        """
-        try:
-            # Delete 'item.THIS' or 'item.OTHER' depending on
-            # suffix_to_remove
-            tt.delete_contents(
-                tt.trans_id_tree_path(self.path + '.' + suffix_to_remove))
-        except errors.NoSuchFile:
-            # There are valid cases where 'item.suffix_to_remove' either
-            # never existed or was already deleted (including the case
-            # where the user deleted it)
-            pass
-        # Rename 'item.suffix_to_remove' (note that if
-        # 'item.suffix_to_remove' has been deleted, this is a no-op)
-        this_tid = tt.trans_id_file_id(self.file_id)
-        parent_tid = tt.get_tree_parent(this_tid)
-        tt.adjust_path(self.path, parent_tid, this_tid)
-        tt.apply()
-
-    def action_take_this(self, tree):
-        self._resolve_with_cleanups(tree, 'OTHER')
-
-    def action_take_other(self, tree):
-        self._resolve_with_cleanups(tree, 'THIS')
-
-
-# FIXME: TextConflict is about a single file-id, there never is a conflict_path
-# attribute so we shouldn't inherit from PathConflict but simply from Conflict
-
-# TODO: There should be a base revid attribute to better inform the user about
-# how the conflicts were generated.
+
 class TextConflict(PathConflict):
     """The merge algorithm could not resolve all differences encountered."""
 
@@ -612,9 +394,6 @@
 
     format = 'Text conflict in %(path)s'
 
-    def associated_filenames(self):
-        return [self.path + suffix for suffix in CONFLICT_SUFFIXES]
-
 
 class HandledConflict(Conflict):
     """A path problem that has been provisionally resolved.
@@ -635,10 +414,6 @@
         s.add('action', self.action)
         return s
 
-    def associated_filenames(self):
-        # Nothing has been generated here
-        return []
-
 
 class HandledPathConflict(HandledConflict):
     """A provisionally-resolved path problem involving two paths.
@@ -685,49 +460,21 @@
 
     format = 'Conflict adding file %(conflict_path)s.  %(action)s %(path)s.'
 
-    def action_take_this(self, tree):
-        tree.remove([self.conflict_path], force=True, keep_files=False)
-        tree.rename_one(self.path, self.conflict_path)
-
-    def action_take_other(self, tree):
-        tree.remove([self.path], force=True, keep_files=False)
-
 
 class ParentLoop(HandledPathConflict):
     """An attempt to create an infinitely-looping directory structure.
     This is rare, but can be produced like so:
 
     tree A:
-      mv foo bar
+      mv foo/bar
     tree B:
-      mv bar foo
+      mv bar/foo
     merge A and B
     """
 
     typestring = 'parent loop'
 
-    format = 'Conflict moving %(path)s into %(conflict_path)s. %(action)s.'
-
-    def action_take_this(self, tree):
-        # just acccept bzr proposal
-        pass
-
-    def action_take_other(self, tree):
-        # FIXME: We shouldn't have to manipulate so many paths here (and there
-        # is probably a bug or two...)
-        base_path = osutils.basename(self.path)
-        conflict_base_path = osutils.basename(self.conflict_path)
-        tt = transform.TreeTransform(tree)
-        try:
-            p_tid = tt.trans_id_file_id(self.file_id)
-            parent_tid = tt.get_tree_parent(p_tid)
-            cp_tid = tt.trans_id_file_id(self.conflict_file_id)
-            cparent_tid = tt.get_tree_parent(cp_tid)
-            tt.adjust_path(base_path, cparent_tid, cp_tid)
-            tt.adjust_path(conflict_base_path, parent_tid, p_tid)
-            tt.apply()
-        finally:
-            tt.finalize()
+    format = 'Conflict moving %(conflict_path)s into %(path)s.  %(action)s.'
 
 
 class UnversionedParent(HandledConflict):
@@ -741,34 +488,18 @@
     format = 'Conflict because %(path)s is not versioned, but has versioned'\
              ' children.  %(action)s.'
 
-    # FIXME: We silently do nothing to make tests pass, but most probably the
-    # conflict shouldn't exist (the long story is that the conflict is
-    # generated with another one that can be resolved properly) -- vila 091224
-    def action_take_this(self, tree):
-        pass
-
-    def action_take_other(self, tree):
-        pass
-
 
 class MissingParent(HandledConflict):
     """An attempt to add files to a directory that is not present.
     Typically, the result of a merge where THIS deleted the directory and
     the OTHER added a file to it.
-    See also: DeletingParent (same situation, THIS and OTHER reversed)
+    See also: DeletingParent (same situation, reversed THIS and OTHER)
     """
 
     typestring = 'missing parent'
 
     format = 'Conflict adding files to %(path)s.  %(action)s.'
 
-    def action_take_this(self, tree):
-        tree.remove([self.path], force=True, keep_files=False)
-
-    def action_take_other(self, tree):
-        # just acccept bzr proposal
-        pass
-
 
 class DeletingParent(HandledConflict):
     """An attempt to add files to a directory that is not present.
@@ -781,19 +512,9 @@
     format = "Conflict: can't delete %(path)s because it is not empty.  "\
              "%(action)s."
 
-    # FIXME: It's a bit strange that the default action is not coherent with
-    # MissingParent from the *user* pov.
-
-    def action_take_this(self, tree):
-        # just acccept bzr proposal
-        pass
-
-    def action_take_other(self, tree):
-        tree.remove([self.path], force=True, keep_files=False)
-
 
 class NonDirectoryParent(HandledConflict):
-    """An attempt to add files to a directory that is not a directory or
+    """An attempt to add files to a directory that is not a director or
     an attempt to change the kind of a directory with files.
     """
 
@@ -802,27 +523,6 @@
     format = "Conflict: %(path)s is not a directory, but has files in it."\
              "  %(action)s."
 
-    # FIXME: .OTHER should be used instead of .new when the conflict is created
-
-    def action_take_this(self, tree):
-        # FIXME: we should preserve that path when the conflict is generated !
-        if self.path.endswith('.new'):
-            conflict_path = self.path[:-(len('.new'))]
-            tree.remove([self.path], force=True, keep_files=False)
-            tree.add(conflict_path)
-        else:
-            raise NotImplementedError(self.action_take_this)
-
-    def action_take_other(self, tree):
-        # FIXME: we should preserve that path when the conflict is generated !
-        if self.path.endswith('.new'):
-            conflict_path = self.path[:-(len('.new'))]
-            tree.remove([conflict_path], force=True, keep_files=False)
-            tree.rename_one(self.path, conflict_path)
-        else:
-            raise NotImplementedError(self.action_take_other)
-
-
 ctype = {}
 
 
@@ -832,6 +532,7 @@
     for conflict_type in conflict_types:
         ctype[conflict_type.typestring] = conflict_type
 
+
 register_types(ContentsConflict, TextConflict, PathConflict, DuplicateID,
                DuplicateEntry, ParentLoop, UnversionedParent, MissingParent,
                DeletingParent, NonDirectoryParent)

=== modified file 'bzrlib/crash.py'
--- bzrlib/crash.py	2010-04-08 04:34:03 +0000
+++ bzrlib/crash.py	2009-08-20 05:47:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,32 +16,10 @@
 
 
 """Handling and reporting crashes.
-
-A crash is an exception propagated up almost to the top level of Bazaar.
-
-If we have apport <https://launchpad.net/apport/>, we store a report of the
-crash using apport into it's /var/crash spool directory, from where the user
-can either manually send it to Launchpad.  In some cases (at least Ubuntu
-development releases), Apport may pop up a window asking if they want
-to send it.
-
-Without apport, we just write a crash report to stderr and the user can report
-this manually if the wish.
-
-We never send crash data across the network without user opt-in.
-
-In principle apport can run on any platform though as of Feb 2010 there seem
-to be some portability bugs.
-
-To force this off in bzr turn set APPORT_DISABLE in the environment or 
--Dno_apport.
 """
 
 # for interactive testing, try the 'bzr assert-fail' command 
 # or see http://code.launchpad.net/~mbp/bzr/bzr-fail
-#
-# to test with apport it's useful to set
-# export APPORT_IGNORE_OBSOLETE_PACKAGES=1
 
 import os
 import platform
@@ -61,23 +39,20 @@
 
 
 def report_bug(exc_info, stderr):
-    if ('no_apport' in debug.debug_flags) or \
-        os.environ.get('APPORT_DISABLE', None):
-        return report_bug_legacy(exc_info, stderr)
-    try:
-        if report_bug_to_apport(exc_info, stderr):
-            # wrote a file; if None then report the old way
+    if 'no_apport' not in debug.debug_flags:
+        try:
+            report_bug_to_apport(exc_info, stderr)
             return
-    except ImportError, e:
-        trace.mutter("couldn't find apport bug-reporting library: %s" % e)
-        pass
-    except Exception, e:
-        # this should only happen if apport is installed but it didn't
-        # work, eg because of an io error writing the crash file
-        stderr.write("bzr: failed to report crash using apport:\n "
-            "    %r\n" % e)
-        pass
-    return report_bug_legacy(exc_info, stderr)
+        except ImportError, e:
+            trace.mutter("couldn't find apport bug-reporting library: %s" % e)
+            pass
+        except Exception, e:
+            # this should only happen if apport is installed but it didn't
+            # work, eg because of an io error writing the crash file
+            sys.stderr.write("bzr: failed to report crash using apport:\n "
+                "    %r\n" % e)
+            pass
+    report_bug_legacy(exc_info, stderr)
 
 
 def report_bug_legacy(exc_info, err_file):
@@ -106,55 +81,47 @@
 
 def report_bug_to_apport(exc_info, stderr):
     """Report a bug to apport for optional automatic filing.
-
-    :returns: The name of the crash file, or None if we didn't write one.
     """
-    # this function is based on apport_package_hook.py, but omitting some of the
+    # this is based on apport_package_hook.py, but omitting some of the
     # Ubuntu-specific policy about what to report and when
 
-    # if the import fails, the exception will be caught at a higher level and
-    # we'll report the error by other means
+    # if this fails its caught at a higher level; we don't want to open the
+    # crash file unless apport can be loaded.
     import apport
 
-    crash_filename = _write_apport_report_to_file(exc_info)
-
-    if crash_filename is None:
-        stderr.write("\n"
-            "apport is set to ignore crashes in this version of bzr.\n"
-            )
-    else:
-        trace.print_exception(exc_info, stderr)
-        stderr.write("\n"
-            "You can report this problem to Bazaar's developers by running\n"
-            "    apport-bug %s\n"
-            "if a bug-reporting window does not automatically appear.\n"
-            % (crash_filename))
-        # XXX: on Windows, Mac, and other platforms where we might have the
-        # apport libraries but not have an apport always running, we could
-        # synchronously file now
-
-    return crash_filename
-
-
-def _write_apport_report_to_file(exc_info):
+    crash_file = _open_crash_file()
+    try:
+        _write_apport_report_to_file(exc_info, crash_file)
+    finally:
+        crash_file.close()
+
+    stderr.write("bzr: ERROR: %s.%s: %s\n" 
+        "\n"
+        "*** Bazaar has encountered an internal error.  This probably indicates a\n"
+        "    bug in Bazaar.  You can help us fix it by filing a bug report at\n"
+        "        https://bugs.launchpad.net/bzr/+filebug\n"
+        "    attaching the crash file\n"
+        "        %s\n"
+        "    and including a description of the problem.\n"
+        "\n"
+        "    The crash file is plain text and you can inspect or edit it to remove\n"
+        "    private information.\n"
+        % (exc_info[0].__module__, exc_info[0].__name__, exc_info[1],
+           crash_file.name))
+
+
+def _write_apport_report_to_file(exc_info, crash_file):
     import traceback
     from apport.report import Report
 
     exc_type, exc_object, exc_tb = exc_info
 
     pr = Report()
-    # add_proc_info gives you the memory map of the process, which is not so
-    # useful for Bazaar but does tell you what binary libraries are loaded.
-    # More importantly it sets the ExecutablePath, InterpreterPath, etc.
-    pr.add_proc_info()
+    # add_proc_info gives you the memory map of the process: this seems rarely
+    # useful for Bazaar and it does make the report harder to scan, though it
+    # does tell you what binary modules are loaded.
+    # pr.add_proc_info()
     pr.add_user_info()
-
-    # Package and SourcePackage are needed so that apport will report about even
-    # non-packaged versions of bzr; also this reports on their packaged
-    # dependencies which is useful.
-    pr['SourcePackage'] = 'bzr'
-    pr['Package'] = 'bzr'
-
     pr['CommandLine'] = pprint.pformat(sys.argv)
     pr['BzrVersion'] = bzrlib.__version__
     pr['PythonVersion'] = bzrlib._format_version_tuple(sys.version_info)
@@ -166,91 +133,22 @@
     pr['PythonLoadedModules'] = _format_module_list()
     pr['BzrDebugFlags'] = pprint.pformat(debug.debug_flags)
 
-    # actually we'd rather file directly against the upstream product, but
-    # apport does seem to count on there being one in there; we might need to
-    # redirect it elsewhere anyhow
-    pr['SourcePackage'] = 'bzr'
-    pr['Package'] = 'bzr'
-
-    # tell apport to file directly against the bzr package using 
-    # <https://bugs.edge.launchpad.net/bzr/+bug/391015>
-    #
-    # XXX: unfortunately apport may crash later if the crashdb definition
-    # file isn't present
-    pr['CrashDb'] = 'bzr'
-
     tb_file = StringIO()
     traceback.print_exception(exc_type, exc_object, exc_tb, file=tb_file)
     pr['Traceback'] = tb_file.getvalue()
 
-    _attach_log_tail(pr)
-
-    # We want to use the 'bzr' crashdb so that it gets sent directly upstream,
-    # which is a reasonable default for most internal errors.  However, if we
-    # set it here then apport will crash later if it doesn't know about that
-    # crashdb.  Instead, we rely on the bzr package installing both a
-    # source hook telling crashes to go to this crashdb, and a crashdb
-    # configuration describing it.
-
-    # these may contain some sensitive info (smtp_passwords)
-    # TODO: strip that out and attach the rest
-    #
-    #attach_file_if_exists(report,
-    #   os.path.join(dot_bzr, 'bazaar.conf', 'BzrConfig')
-    #attach_file_if_exists(report,
-    #   os.path.join(dot_bzr, 'locations.conf', 'BzrLocations')
-    
-    # strip username, hostname, etc
-    pr.anonymize()
-
-    if pr.check_ignored():
-        # eg configured off in ~/.apport-ignore.xml
-        return None
-    else:
-        crash_file_name, crash_file = _open_crash_file()
-        pr.write(crash_file)
-        crash_file.close()
-        return crash_file_name
-
-
-def _attach_log_tail(pr):
-    try:
-        bzr_log = open(trace._get_bzr_log_filename(), 'rt')
-    except (IOError, OSError), e:
-        pr['BzrLogTail'] = repr(e)
-        return
-    try:
-        lines = bzr_log.readlines()
-        pr['BzrLogTail'] = ''.join(lines[-40:])
-    finally:
-        bzr_log.close()
+    pr.write(crash_file)
 
 
 def _open_crash_file():
     crash_dir = config.crash_dir()
+    # user-readable only, just in case the contents are sensitive.
     if not osutils.isdir(crash_dir):
-        # on unix this should be /var/crash and should already exist; on
-        # Windows or if it's manually configured it might need to be created,
-        # and then it should be private
-        os.makedirs(crash_dir, mode=0600)
-    date_string = time.strftime('%Y-%m-%dT%H:%M', time.gmtime())
-    # XXX: getuid doesn't work on win32, but the crash directory is per-user
-    if sys.platform == 'win32':
-        user_part = ''
-    else:
-        user_part = '.%d' % os.getuid()
-    filename = osutils.pathjoin(
-        crash_dir,
-        'bzr%s.%s.crash' % (
-            user_part,
-            date_string))
-    # be careful here that people can't play tmp-type symlink mischief in the
-    # world-writable directory
-    return filename, os.fdopen(
-        os.open(filename, 
-            os.O_WRONLY|os.O_CREAT|os.O_EXCL,
-            0600),
-        'w')
+        os.makedirs(crash_dir, mode=0700)
+    filename = 'bzr-%s-%s.crash' % (
+        osutils.compact_date(time.time()),
+        os.getpid(),)
+    return open(osutils.pathjoin(crash_dir, filename), 'wt')
 
 
 def _format_plugin_list():

=== modified file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	2010-02-17 17:11:16 +0000
+++ bzrlib/decorators.py	2009-10-15 02:19:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -253,80 +253,3 @@
     global needs_read_lock, needs_write_lock
     needs_read_lock = _pretty_needs_read_lock
     needs_write_lock = _pretty_needs_write_lock
-
-
-# This implementation of cachedproperty is copied from Launchpad's
-# canonical.launchpad.cachedproperty module (with permission from flacoste)
-# -- spiv & vila 100120
-def cachedproperty(attrname_or_fn):
-    """A decorator for methods that makes them properties with their return
-    value cached.
-
-    The value is cached on the instance, using the attribute name provided.
-
-    If you don't provide a name, the mangled name of the property is used.
-
-    >>> class CachedPropertyTest(object):
-    ...
-    ...     @cachedproperty('_foo_cache')
-    ...     def foo(self):
-    ...         print 'foo computed'
-    ...         return 23
-    ...
-    ...     @cachedproperty
-    ...     def bar(self):
-    ...         print 'bar computed'
-    ...         return 69
-
-    >>> cpt = CachedPropertyTest()
-    >>> getattr(cpt, '_foo_cache', None) is None
-    True
-    >>> cpt.foo
-    foo computed
-    23
-    >>> cpt.foo
-    23
-    >>> cpt._foo_cache
-    23
-    >>> cpt.bar
-    bar computed
-    69
-    >>> cpt._bar_cached_value
-    69
-
-    """
-    if isinstance(attrname_or_fn, basestring):
-        attrname = attrname_or_fn
-        return _CachedPropertyForAttr(attrname)
-    else:
-        fn = attrname_or_fn
-        attrname = '_%s_cached_value' % fn.__name__
-        return _CachedProperty(attrname, fn)
-
-
-class _CachedPropertyForAttr(object):
-
-    def __init__(self, attrname):
-        self.attrname = attrname
-
-    def __call__(self, fn):
-        return _CachedProperty(self.attrname, fn)
-
-
-class _CachedProperty(object):
-
-    def __init__(self, attrname, fn):
-        self.fn = fn
-        self.attrname = attrname
-        self.marker = object()
-
-    def __get__(self, inst, cls=None):
-        if inst is None:
-            return self
-        cachedresult = getattr(inst, self.attrname, self.marker)
-        if cachedresult is self.marker:
-            result = self.fn(inst)
-            setattr(inst, self.attrname, result)
-            return result
-        else:
-            return cachedresult

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2010-04-30 11:35:43 +0000
+++ bzrlib/delta.py	2009-10-29 05:54:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,9 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from bzrlib import (
+    errors,
     osutils,
     )
-from bzrlib.trace import is_quiet
+from bzrlib.inventory import InventoryEntry
+from bzrlib.trace import mutter, is_quiet
+from bzrlib.symbol_versioning import deprecated_function
 
 
 class TreeDelta(object):
@@ -104,11 +107,112 @@
                 return True
         return False
 
+
+    def show(self, to_file, show_ids=False, show_unchanged=False,
+             short_status=False, indent='',
+             filter=None):
+        """Output this delta in status-like form to to_file.
+
+        :param to_file: A file-like object where the output is displayed.
+
+        :param show_ids: Output the file ids if True.
+
+        :param show_unchanged: Output the unchanged files if True.
+
+        :param short_status: Single-line status if True.
+
+        :param indent: Added at the beginning of all output lines (for merged
+            revisions).
+
+        :param filter: A callable receiving a path and a file id and
+            returning True if the path should be displayed.
+        """
+
+        def decorate_path(path, kind, meta_modified=None):
+            if kind == 'directory':
+                path += '/'
+            elif kind == 'symlink':
+                path += '@'
+            if meta_modified:
+                path += '*'
+            return path
+
+        def show_more_renamed(item):
+            (oldpath, file_id, kind,
+             text_modified, meta_modified, newpath) = item
+            dec_new_path = decorate_path(newpath, kind, meta_modified)
+            to_file.write(' => %s' % dec_new_path)
+            if text_modified or meta_modified:
+                extra_modified.append((newpath, file_id, kind,
+                                       text_modified, meta_modified))
+
+        def show_more_kind_changed(item):
+            (path, file_id, old_kind, new_kind) = item
+            to_file.write(' (%s => %s)' % (old_kind, new_kind))
+
+        def show_path(path, file_id, kind, meta_modified,
+                      default_format, with_file_id_format):
+            dec_path = decorate_path(path, kind, meta_modified)
+            if show_ids:
+                to_file.write(with_file_id_format % dec_path)
+            else:
+                to_file.write(default_format % dec_path)
+
+        def show_list(files, long_status_name, short_status_letter,
+                      default_format='%s', with_file_id_format='%-30s',
+                      show_more=None):
+            if files:
+                header_shown = False
+                if short_status:
+                    prefix = short_status_letter
+                else:
+                    prefix = ''
+                prefix = indent + prefix + '  '
+
+                for item in files:
+                    path, file_id, kind = item[:3]
+                    if (filter is not None and not filter(path, file_id)):
+                        continue
+                    if not header_shown and not short_status:
+                        to_file.write(indent + long_status_name + ':\n')
+                        header_shown = True
+                    meta_modified = None
+                    if len(item) == 5:
+                        meta_modified = item[4]
+
+                    to_file.write(prefix)
+                    show_path(path, file_id, kind, meta_modified,
+                              default_format, with_file_id_format)
+                    if show_more is not None:
+                        show_more(item)
+                    if show_ids:
+                        to_file.write(' %s' % file_id)
+                    to_file.write('\n')
+
+        show_list(self.removed, 'removed', 'D')#
+        show_list(self.added, 'added', 'A')
+        extra_modified = []
+        # Reorder self.renamed tuples so that all lists share the same
+        # order for their 3 first fields and that they also begin like
+        # the self.modified tuples
+        renamed = [(p, i, k, tm, mm, np)
+                   for  p, np, i, k, tm, mm  in self.renamed]
+        show_list(renamed, 'renamed', 'R', with_file_id_format='%s',
+                  show_more=show_more_renamed)
+        show_list(self.kind_changed, 'kind changed', 'K',
+                  with_file_id_format='%s',
+                  show_more=show_more_kind_changed)
+        show_list(self.modified + extra_modified, 'modified', 'M')
+        if show_unchanged:
+            show_list(self.unchanged, 'unchanged', 'S')
+
+        show_list(self.unversioned, 'unknown', ' ')
+
     def get_changes_as_text(self, show_ids=False, show_unchanged=False,
-                            short_status=False):
+             short_status=False):
         import StringIO
         output = StringIO.StringIO()
-        report_delta(output, self, short_status, show_ids, show_unchanged)
+        self.show(output, show_ids, show_unchanged, short_status)
         return output.getvalue()
 
 
@@ -289,6 +393,7 @@
         self.output("%s%s%s %s%s", rename, self.modified_map[modified], exe,
                     old_path, path)
 
+
 def report_changes(change_iterator, reporter):
     """Report the changes from a change iterator.
 
@@ -332,105 +437,3 @@
         versioned_change = versioned_change_map[versioned]
         reporter.report(file_id, path, versioned_change, renamed, modified,
                         exe_change, kind)
-
-def report_delta(to_file, delta, short_status=False, show_ids=False, 
-         show_unchanged=False, indent='', filter=None):
-    """Output this delta in status-like form to to_file.
-
-    :param to_file: A file-like object where the output is displayed.
-
-    :param delta: A TreeDelta containing the changes to be displayed
-
-    :param short_status: Single-line status if True.
-
-    :param show_ids: Output the file ids if True.
-
-    :param show_unchanged: Output the unchanged files if True.
-
-    :param indent: Added at the beginning of all output lines (for merged
-        revisions).
-
-    :param filter: A callable receiving a path and a file id and
-        returning True if the path should be displayed.
-    """
-
-    def decorate_path(path, kind, meta_modified=None):
-        if kind == 'directory':
-            path += '/'
-        elif kind == 'symlink':
-            path += '@'
-        if meta_modified:
-            path += '*'
-        return path
-
-    def show_more_renamed(item):
-        (oldpath, file_id, kind,
-         text_modified, meta_modified, newpath) = item
-        dec_new_path = decorate_path(newpath, kind, meta_modified)
-        to_file.write(' => %s' % dec_new_path)
-        if text_modified or meta_modified:
-            extra_modified.append((newpath, file_id, kind,
-                                   text_modified, meta_modified))
-
-    def show_more_kind_changed(item):
-        (path, file_id, old_kind, new_kind) = item
-        to_file.write(' (%s => %s)' % (old_kind, new_kind))
-
-    def show_path(path, file_id, kind, meta_modified,
-                  default_format, with_file_id_format):
-        dec_path = decorate_path(path, kind, meta_modified)
-        if show_ids:
-            to_file.write(with_file_id_format % dec_path)
-        else:
-            to_file.write(default_format % dec_path)
-
-    def show_list(files, long_status_name, short_status_letter,
-                  default_format='%s', with_file_id_format='%-30s',
-                  show_more=None):
-        if files:
-            header_shown = False
-            if short_status:
-                prefix = short_status_letter
-            else:
-                prefix = ''
-            prefix = indent + prefix + '  '
-
-            for item in files:
-                path, file_id, kind = item[:3]
-                if (filter is not None and not filter(path, file_id)):
-                    continue
-                if not header_shown and not short_status:
-                    to_file.write(indent + long_status_name + ':\n')
-                    header_shown = True
-                meta_modified = None
-                if len(item) == 5:
-                    meta_modified = item[4]
-
-                to_file.write(prefix)
-                show_path(path, file_id, kind, meta_modified,
-                          default_format, with_file_id_format)
-                if show_more is not None:
-                    show_more(item)
-                if show_ids:
-                    to_file.write(' %s' % file_id)
-                to_file.write('\n')
-
-    show_list(delta.removed, 'removed', 'D')
-    show_list(delta.added, 'added', 'A')
-    extra_modified = []
-    # Reorder delta.renamed tuples so that all lists share the same
-    # order for their 3 first fields and that they also begin like
-    # the delta.modified tuples
-    renamed = [(p, i, k, tm, mm, np)
-               for  p, np, i, k, tm, mm  in delta.renamed]
-    show_list(renamed, 'renamed', 'R', with_file_id_format='%s',
-              show_more=show_more_renamed)
-    show_list(delta.kind_changed, 'kind changed', 'K',
-              with_file_id_format='%s',
-              show_more=show_more_kind_changed)
-    show_list(delta.modified + extra_modified, 'modified', 'M')
-    if show_unchanged:
-        show_list(delta.unchanged, 'unchanged', 'S')
-
-    show_list(delta.unversioned, 'unknown', ' ')
-

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-04-30 11:35:43 +0000
+++ bzrlib/diff.py	2009-12-03 07:36:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd.
+# Copyright (C) 2004, 2005, 2006 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,7 @@
 import difflib
 import os
 import re
+import shutil
 import string
 import sys
 
@@ -30,8 +31,7 @@
 from bzrlib import (
     branch as _mod_branch,
     bzrdir,
-    cmdline,
-    cleanup,
+    commands,
     errors,
     osutils,
     patiencediff,
@@ -43,12 +43,8 @@
 from bzrlib.workingtree import WorkingTree
 """)
 
-from bzrlib.registry import (
-    Registry,
-    )
 from bzrlib.symbol_versioning import (
     deprecated_function,
-    deprecated_in,
     )
 from bzrlib.trace import mutter, note, warning
 
@@ -290,7 +286,6 @@
                         new_abspath, e)
 
 
-@deprecated_function(deprecated_in((2, 2, 0)))
 def get_trees_and_branches_to_diff(path_list, revision_specs, old_url, new_url,
                                    apply_view=True):
     """Get the trees and specific files to diff given a list of paths.
@@ -315,44 +310,7 @@
     :returns:
         a tuple of (old_tree, new_tree, old_branch, new_branch,
         specific_files, extra_trees) where extra_trees is a sequence of
-        additional trees to search in for file-ids.  The trees and branches
-        are not locked.
-    """
-    op = cleanup.OperationWithCleanups(get_trees_and_branches_to_diff_locked)
-    return op.run_simple(path_list, revision_specs, old_url, new_url,
-            op.add_cleanup, apply_view=apply_view)
-    
-
-def get_trees_and_branches_to_diff_locked(
-    path_list, revision_specs, old_url, new_url, add_cleanup, apply_view=True):
-    """Get the trees and specific files to diff given a list of paths.
-
-    This method works out the trees to be diff'ed and the files of
-    interest within those trees.
-
-    :param path_list:
-        the list of arguments passed to the diff command
-    :param revision_specs:
-        Zero, one or two RevisionSpecs from the diff command line,
-        saying what revisions to compare.
-    :param old_url:
-        The url of the old branch or tree. If None, the tree to use is
-        taken from the first path, if any, or the current working tree.
-    :param new_url:
-        The url of the new branch or tree. If None, the tree to use is
-        taken from the first path, if any, or the current working tree.
-    :param add_cleanup:
-        a callable like Command.add_cleanup.  get_trees_and_branches_to_diff
-        will register cleanups that must be run to unlock the trees, etc.
-    :param apply_view:
-        if True and a view is set, apply the view or check that the paths
-        are within it
-    :returns:
-        a tuple of (old_tree, new_tree, old_branch, new_branch,
-        specific_files, extra_trees) where extra_trees is a sequence of
-        additional trees to search in for file-ids.  The trees and branches
-        will be read-locked until the cleanups registered via the add_cleanup
-        param are run.
+        additional trees to search in for file-ids.
     """
     # Get the old and new revision specs
     old_revision_spec = None
@@ -381,21 +339,12 @@
         default_location = path_list[0]
         other_paths = path_list[1:]
 
-    def lock_tree_or_branch(wt, br):
-        if wt is not None:
-            wt.lock_read()
-            add_cleanup(wt.unlock)
-        elif br is not None:
-            br.lock_read()
-            add_cleanup(br.unlock)
-
     # Get the old location
     specific_files = []
     if old_url is None:
         old_url = default_location
     working_tree, branch, relpath = \
         bzrdir.BzrDir.open_containing_tree_or_branch(old_url)
-    lock_tree_or_branch(working_tree, branch)
     if consider_relpath and relpath != '':
         if working_tree is not None and apply_view:
             views.check_path_in_view(working_tree, relpath)
@@ -409,7 +358,6 @@
     if new_url != old_url:
         working_tree, branch, relpath = \
             bzrdir.BzrDir.open_containing_tree_or_branch(new_url)
-        lock_tree_or_branch(working_tree, branch)
         if consider_relpath and relpath != '':
             if working_tree is not None and apply_view:
                 views.check_path_in_view(working_tree, relpath)
@@ -463,22 +411,25 @@
                     old_label='a/', new_label='b/',
                     extra_trees=None,
                     path_encoding='utf8',
-                    using=None,
-                    format_cls=None):
+                    using=None):
     """Show in text form the changes from one tree to another.
 
-    :param to_file: The output stream.
-    :param specific_files:Include only changes to these files - None for all
-        changes.
-    :param external_diff_options: If set, use an external GNU diff and pass 
-        these options.
-    :param extra_trees: If set, more Trees to use for looking up file ids
-    :param path_encoding: If set, the path will be encoded as specified, 
-        otherwise is supposed to be utf8
-    :param format_cls: Formatter class (DiffTree subclass)
+    to_file
+        The output stream.
+
+    specific_files
+        Include only changes to these files - None for all changes.
+
+    external_diff_options
+        If set, use an external GNU diff and pass these options.
+
+    extra_trees
+        If set, more Trees to use for looking up file ids
+
+    path_encoding
+        If set, the path will be encoded as specified, otherwise is supposed
+        to be utf8
     """
-    if format_cls is None:
-        format_cls = DiffTree
     old_tree.lock_read()
     try:
         if extra_trees is not None:
@@ -486,10 +437,10 @@
                 tree.lock_read()
         new_tree.lock_read()
         try:
-            differ = format_cls.from_trees_options(old_tree, new_tree, to_file,
-                                                   path_encoding,
-                                                   external_diff_options,
-                                                   old_label, new_label, using)
+            differ = DiffTree.from_trees_options(old_tree, new_tree, to_file,
+                                                 path_encoding,
+                                                 external_diff_options,
+                                                 old_label, new_label, using)
             return differ.show_diff(specific_files, extra_trees)
         finally:
             new_tree.unlock()
@@ -502,10 +453,7 @@
 
 def _patch_header_date(tree, file_id, path):
     """Returns a timestamp suitable for use in a patch header."""
-    try:
-        mtime = tree.get_file_mtime(file_id, path)
-    except errors.FileTimestampUnavailable:
-        mtime = 0
+    mtime = tree.get_file_mtime(file_id, path)
     return timestamp.format_patch_date(mtime)
 
 
@@ -732,7 +680,7 @@
     @classmethod
     def from_string(klass, command_string, old_tree, new_tree, to_file,
                     path_encoding='utf-8'):
-        command_template = cmdline.split(command_string)
+        command_template = commands.shlex_split_unicode(command_string)
         if '@' not in command_string:
             command_template.extend(['@old_path', '@new_path'])
         return klass(command_template, old_tree, new_tree, to_file,
@@ -797,14 +745,10 @@
                 target.close()
         finally:
             source.close()
-        try:
-            mtime = tree.get_file_mtime(file_id)
-        except errors.FileTimestampUnavailable:
-            pass
-        else:
-            os.utime(full_path, (mtime, mtime))
         if not allow_write:
             osutils.make_readonly(full_path)
+        mtime = tree.get_file_mtime(file_id)
+        os.utime(full_path, (mtime, mtime))
         return full_path
 
     def _prepare_files(self, file_id, old_path, new_path, force_temp=False,
@@ -932,7 +876,7 @@
     def show_diff(self, specific_files, extra_trees=None):
         """Write tree diff to self.to_file
 
-        :param specific_files: the specific files to compare (recursive)
+        :param sepecific_files: the specific files to compare (recursive)
         :param extra_trees: extra trees to use for mapping paths to file_ids
         """
         try:
@@ -1028,7 +972,3 @@
             if error_path is None:
                 error_path = old_path
             raise errors.NoDiffFound(error_path)
-
-
-format_registry = Registry()
-format_registry.register('default', DiffTree)

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2010-01-13 23:06:42 +0000
+++ bzrlib/dirstate.py	2009-11-08 19:29:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1997,8 +1997,6 @@
                 entry_index, present = self._find_entry_index(key, block)
                 if present:
                     entry = self._dirblocks[block_index][1][entry_index]
-                    # TODO: We might want to assert that entry[0][2] ==
-                    #       fileid_utf8.
                     if entry[1][tree_index][0] in 'fdlt':
                         # this is the result we are looking for: the
                         # real home of this file_id in this tree.
@@ -2356,6 +2354,8 @@
         self.update_minimal(('', '', new_id), 'd',
             path_utf8='', packed_stat=entry[1][0][4])
         self._dirblock_state = DirState.IN_MEMORY_MODIFIED
+        if self._id_index is not None:
+            self._id_index.setdefault(new_id, set()).add(entry[0])
 
     def set_parent_trees(self, trees, ghosts):
         """Set the parent trees for the dirstate.
@@ -3013,13 +3013,6 @@
             if absent_positions == tree_count:
                 raise AssertionError(
                     "entry %r has no data for any tree." % (entry,))
-        if self._id_index is not None:
-            for file_id, entry_keys in self._id_index.iteritems():
-                for entry_key in entry_keys:
-                    if entry_key[2] != file_id:
-                        raise AssertionError(
-                            'file_id %r did not match entry key %s'
-                            % (file_id, entry_key))
 
     def _wipe_state(self):
         """Forget all state information about the dirstate."""

=== modified file 'bzrlib/doc_generate/autodoc_man.py'
--- bzrlib/doc_generate/autodoc_man.py	2010-02-23 07:43:11 +0000
+++ bzrlib/doc_generate/autodoc_man.py	2009-11-04 12:25:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -241,7 +241,7 @@
 .br
 log10 = log --short -r -10..-1
 .SH "SEE ALSO"
-.UR http://www.bazaar.canonical.com/
-.BR http://www.bazaar.canonical.com/
+.UR http://www.bazaar-vcs.org/
+.BR http://www.bazaar-vcs.org/
 """
 

=== modified file 'bzrlib/doc_generate/autodoc_rstx.py'
--- bzrlib/doc_generate/autodoc_rstx.py	2010-02-17 17:11:16 +0000
+++ bzrlib/doc_generate/autodoc_rstx.py	2009-09-09 14:35:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006-2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Generate reStructuredText source for the User Reference Manual.
+"""Generate ReStructuredText source for the User Reference Manual.
 Loosely based on the manpage generator autodoc_man.py.
 
 Written by the Bazaar community.
@@ -31,6 +31,14 @@
 import bzrlib.osutils
 
 
+# Set this to True to generate a file per topic.
+# This probably ought to be an option. The files probably
+# ought to be prefixed with their section name as well so
+# there's zero risk of clashing with a standard sphinx
+# topic (like search.html).
+FILE_PER_TOPIC = False
+
+
 def get_filename(options):
     """Provides name of manual"""
     return "%s_man.txt" % (options.bzr_name)
@@ -66,7 +74,8 @@
         output_dir=topic_dir))
     result.append(_get_section(registry, SECT_LIST, "Lists",
         output_dir=topic_dir))
-    result.append(_get_commands_section(registry, output_dir=topic_dir))
+    result.append(_get_commands_section(registry))
+    #result.append(_get_section(registry, SECT_PLUGIN, "Standard Plug-ins"))
     return "\n".join(result)
 
 
@@ -77,65 +86,72 @@
     If output_dir is not None, topics are dumped into text files there
     during processing, as well as being included in the return result.
     """
-    file_per_topic = output_dir is not None
-    lines = [title, hdg_level1 * len(title), ""]
-    if file_per_topic:
-        lines.extend([".. toctree::", "   :maxdepth: 1", ""])
-
     topics = sorted(registry.get_topics_for_section(section))
+    lines = [title, hdg_level1 * len(title), ""]
+
+    # docutils treats section heading as implicit link target.
+    # But in some cases topic and heading are different, e.g.:
+    #
+    # `bugs' vs. `Bug Trackers'
+    # `working-tree' vs. `Working Trees'
+    #
+    # So for building proper cross-reference between topic names
+    # and corresponding sections in document, we need provide
+    # simple glue in the form:
+    #
+    # .. _topic: `heading`_
+    links_glue = []
+
     for topic in topics:
         help = registry.get_detail(topic)
-        heading, text = help.split("\n", 1)
+        heading,text = help.split("\n", 1)
+        lines.append(heading)
         if not text.startswith(hdg_level2):
-            underline = hdg_level2 * len(heading)
-            help = "%s\n%s\n\n%s\n\n" % (heading, underline, text)
-        else:
-            help = "%s\n%s\n\n" % (heading, text)
-        if file_per_topic:
-            topic_id = _dump_text(output_dir, topic, help)
-            lines.append("   %s" % topic_id)
-        else:
-            lines.append(help)
+            lines.append(hdg_level2 * len(heading))
+        lines.append(text)
+        lines.append('')
+        # check that topic match heading
+        if topic != heading.lower():
+            links_glue.append((topic, heading))
+        # dump the text if requested
+        if output_dir is not None:
+            out_file = bzrlib.osutils.pathjoin(output_dir, topic + ".txt")
+            _dump_text(out_file, help)
+
+    # provide links glue for topics that don't match headings
+    lines.extend([".. _%s: `%s`_" % i for i in links_glue])
+    lines.append('')
 
     return "\n" + "\n".join(lines) + "\n"
 
 
+def _dump_text(filename, text):
+    """Dump text to filename."""
+    if not FILE_PER_TOPIC:
+        return
+    f =  open(filename, "w")
+    f.writelines(text)
+    f.close()
+
+
 def _get_commands_section(registry, title="Commands", hdg_level1="#",
-        hdg_level2="=", output_dir=None):
+                          hdg_level2="="):
     """Build the commands reference section of the manual."""
-    file_per_topic = output_dir is not None
     lines = [title, hdg_level1 * len(title), ""]
-    if file_per_topic:
-        lines.extend([".. toctree::", "   :maxdepth: 1", ""])
-
     cmds = sorted(bzrlib.commands.builtin_command_names())
     for cmd_name in cmds:
         cmd_object = bzrlib.commands.get_cmd_object(cmd_name)
         if cmd_object.hidden:
             continue
         heading = cmd_name
-        underline = hdg_level2 * len(heading)
         text = cmd_object.get_help_text(plain=False, see_also_as_links=True)
-        help = "%s\n%s\n\n%s\n\n" % (heading, underline, text)
-        if file_per_topic:
-            topic_id = _dump_text(output_dir, cmd_name, help)
-            lines.append("   %s" % topic_id)
-        else:
-            lines.append(help)
-
+        lines.append(heading)
+        lines.append(hdg_level2 * len(heading))
+        lines.append(text)
+        lines.append('')
     return "\n" + "\n".join(lines) + "\n"
 
 
-def _dump_text(output_dir, topic, text):
-    """Dump text for a topic to a file."""
-    topic_id = "%s-%s" % (topic, "help")
-    filename = bzrlib.osutils.pathjoin(output_dir, topic_id + ".txt")
-    f =  open(filename, "w")
-    f.writelines(text)
-    f.close()
-    return topic_id
-
-
 ##
 # TEMPLATES
 
@@ -178,8 +194,8 @@
 
 The following web sites provide further information on Bazaar:
 
-:Home page:                     http://bazaar.canonical.com/
-:Official docs:                 http://doc.bazaar.canonical.com/
+:Home page:                     http://www.bazaar-vcs.org/
+:Official docs:                 http://doc.bazaar-vcs.org/
 :Launchpad:                     https://launchpad.net/bzr/
 """
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-04-21 11:27:04 +0000
+++ bzrlib/errors.py	2009-12-25 13:47:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -702,32 +702,11 @@
 # TODO: Probably this behavior of should be a common superclass
 class NotBranchError(PathError):
 
-    _fmt = 'Not a branch: "%(path)s"%(detail)s.'
+    _fmt = 'Not a branch: "%(path)s".'
 
-    def __init__(self, path, detail=None, bzrdir=None):
+    def __init__(self, path):
        import bzrlib.urlutils as urlutils
-       path = urlutils.unescape_for_display(path, 'ascii')
-       if detail is not None:
-           detail = ': ' + detail
-       self.detail = detail
-       self.bzrdir = bzrdir
-       PathError.__init__(self, path=path)
-
-    def _format(self):
-        # XXX: Ideally self.detail would be a property, but Exceptions in
-        # Python 2.4 have to be old-style classes so properties don't work.
-        # Instead we override _format.
-        if self.detail is None:
-            if self.bzrdir is not None:
-                try:
-                    self.bzrdir.open_repository()
-                except NoRepositoryPresent:
-                    self.detail = ''
-                else:
-                    self.detail = ': location is a repository'
-            else:
-                self.detail = ''
-        return PathError._format(self)
+       self.path = urlutils.unescape_for_display(path, 'ascii')
 
 
 class NoSubmitBranch(PathError):
@@ -1179,7 +1158,7 @@
 
 class InvalidRevisionSpec(BzrError):
 
-    _fmt = ("Requested revision: '%(spec)s' does not exist in branch:"
+    _fmt = ("Requested revision: %(spec)r does not exist in branch:"
             " %(branch)s%(extra)s")
 
     def __init__(self, spec, branch, extra=None):
@@ -1268,8 +1247,8 @@
 class AmbiguousBase(BzrError):
 
     def __init__(self, bases):
-        symbol_versioning.warn("BzrError AmbiguousBase has been deprecated "
-            "as of bzrlib 0.8.", DeprecationWarning, stacklevel=2)
+        warn("BzrError AmbiguousBase has been deprecated as of bzrlib 0.8.",
+                DeprecationWarning)
         msg = ("The correct base is unclear, because %s are all equally close"
                 % ", ".join(bases))
         BzrError.__init__(self, msg)
@@ -1297,13 +1276,12 @@
 class BoundBranchOutOfDate(BzrError):
 
     _fmt = ("Bound branch %(branch)s is out of date with master branch"
-            " %(master)s.%(extra_help)s")
+            " %(master)s.")
 
     def __init__(self, branch, master):
         BzrError.__init__(self)
         self.branch = branch
         self.master = master
-        self.extra_help = ''
 
 
 class CommitToDoubleBoundBranch(BzrError):
@@ -2176,7 +2154,7 @@
 
     def __init__(self, repo):
         BzrError.__init__(self)
-        self.repo_path = repo.user_url
+        self.repo_path = repo.bzrdir.root_transport.base
 
 
 class InconsistentDelta(BzrError):
@@ -2754,7 +2732,7 @@
 
     def __init__(self, bzrdir):
         import bzrlib.urlutils as urlutils
-        display_url = urlutils.unescape_for_display(bzrdir.user_url,
+        display_url = urlutils.unescape_for_display(bzrdir.root_transport.base,
                                                     'ascii')
         BzrError.__init__(self, bzrdir=bzrdir, display_url=display_url)
 
@@ -2835,7 +2813,7 @@
             more = ' ' + more
         import bzrlib.urlutils as urlutils
         display_url = urlutils.unescape_for_display(
-            tree.user_url, 'ascii')
+            tree.bzrdir.root_transport.base, 'ascii')
         BzrError.__init__(self, tree=tree, display_url=display_url, more=more)
 
 
@@ -2964,18 +2942,12 @@
 class HookFailed(BzrError):
     """Raised when a pre_change_branch_tip hook function fails anything other
     than TipChangeRejected.
-
-    Note that this exception is no longer raised, and the import is only left
-    to be nice to code which might catch it in a plugin.
     """
 
     _fmt = ("Hook '%(hook_name)s' during %(hook_stage)s failed:\n"
             "%(traceback_text)s%(exc_value)s")
 
-    def __init__(self, hook_stage, hook_name, exc_info, warn=True):
-        if warn:
-            symbol_versioning.warn("BzrError HookFailed has been deprecated "
-                "as of bzrlib 2.1.", DeprecationWarning, stacklevel=2)
+    def __init__(self, hook_stage, hook_name, exc_info):
         import traceback
         self.hook_stage = hook_stage
         self.hook_name = hook_name
@@ -3115,22 +3087,3 @@
     def __init__(self, source_branch, target_branch):
         self.source_branch = source_branch
         self.target_branch = target_branch
-
-
-class FileTimestampUnavailable(BzrError):
-
-    _fmt = "The filestamp for %(path)s is not available."
-
-    internal_error = True
-
-    def __init__(self, path):
-        self.path = path
-
-
-class NoColocatedBranchSupport(BzrError):
-
-    _fmt = ("%(bzrdir)r does not support co-located branches.")
-
-    def __init__(self, bzrdir):
-        self.bzrdir = bzrdir
-

=== modified file 'bzrlib/export/__init__.py'
--- bzrlib/export/__init__.py	2010-03-25 09:39:03 +0000
+++ bzrlib/export/__init__.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,6 +19,7 @@
 Such as non-controlled directories, tarfiles, zipfiles, etc.
 """
 
+from bzrlib.trace import mutter
 import os
 import bzrlib.errors as errors
 
@@ -54,16 +55,14 @@
 
     When requesting a specific type of export, load the respective path.
     """
-    def _loader(tree, dest, root, subdir, filtered, per_file_timestamps):
+    def _loader(tree, dest, root, subdir, filtered):
         mod = __import__(module, globals(), locals(), [funcname])
         func = getattr(mod, funcname)
-        return func(tree, dest, root, subdir, filtered=filtered,
-                    per_file_timestamps=per_file_timestamps)
+        return func(tree, dest, root, subdir, filtered=filtered)
     register_exporter(scheme, extensions, _loader)
 
 
-def export(tree, dest, format=None, root=None, subdir=None, filtered=False,
-           per_file_timestamps=False):
+def export(tree, dest, format=None, root=None, subdir=None, filtered=False):
     """Export the given Tree to the specific destination.
 
     :param tree: A Tree (such as RevisionTree) to export
@@ -82,9 +81,6 @@
         a directory to start exporting from.
     :param filtered: If True, content filtering is applied to the
                      files exported.
-    :param per_file_timestamps: Whether to use the timestamp stored in the 
-        tree rather than now(). This will do a revision lookup 
-        for every file so will be significantly slower.
     """
     global _exporters, _exporter_extensions
 
@@ -103,8 +99,7 @@
         raise errors.NoSuchExportFormat(format)
     tree.lock_read()
     try:
-        return _exporters[format](tree, dest, root, subdir, filtered=filtered,
-                                  per_file_timestamps=per_file_timestamps)
+        return _exporters[format](tree, dest, root, subdir, filtered=filtered)
     finally:
         tree.unlock()
 
@@ -143,23 +138,14 @@
     """Iter the entries for tree suitable for exporting.
 
     :param tree: A tree object.
-    :param subdir: None or the path of an entry to start exporting from.
+    :param subdir: None or the path of a directory to start exporting from.
     """
     inv = tree.inventory
     if subdir is None:
-        subdir_object = None
+        subdir_id = None
     else:
         subdir_id = inv.path2id(subdir)
-        if subdir_id is not None:
-            subdir_object = inv[subdir_id]
-        # XXX: subdir is path not an id, so NoSuchId isn't proper error
-        else:
-            raise errors.NoSuchId(tree, subdir)
-    if subdir_object is not None and subdir_object.kind != 'directory':
-        yield subdir_object.name, subdir_object
-        return
-    else:
-        entries = inv.iter_entries(subdir_object)
+    entries = inv.iter_entries(subdir_id)
     if subdir is None:
         entries.next() # skip root
     for entry in entries:

=== modified file 'bzrlib/export/dir_exporter.py'
--- bzrlib/export/dir_exporter.py	2010-03-08 02:23:17 +0000
+++ bzrlib/export/dir_exporter.py	2009-12-18 05:38:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,11 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Export a bzrlib.tree.Tree to a new or empty directory."""
+"""Export a Tree to a non-versioned directory.
+"""
 
 import errno
 import os
-import time
+import StringIO
 
 from bzrlib import errors, osutils
 from bzrlib.export import _export_iter_entries
@@ -29,15 +30,17 @@
 from bzrlib.trace import mutter
 
 
-def dir_exporter(tree, dest, root, subdir, filtered=False,
-                 per_file_timestamps=False):
+def dir_exporter(tree, dest, root, subdir, filtered=False):
     """Export this tree to a new directory.
 
-    `dest` should either not exist or should be empty. If it does not exist it
-    will be created holding the contents of this tree.
+    `dest` should not exist, and will be created holding the
+    contents of this tree.
+
+    TODO: To handle subdirectories we need to create the
+           directories first.
 
     :note: If the export fails, the destination directory will be
-           left in an incompletely exported state: export is not transactional.
+           left in a half-assed state.
     """
     mutter('export version %r', tree)
     try:
@@ -76,7 +79,6 @@
     # The data returned here can be in any order, but we've already created all
     # the directories
     flags = os.O_CREAT | os.O_TRUNC | os.O_WRONLY | getattr(os, 'O_BINARY', 0)
-    now = time.time()
     for (relpath, executable), chunks in tree.iter_files_bytes(to_fetch):
         if filtered:
             filters = tree._content_filter_stack(relpath)
@@ -92,8 +94,3 @@
             out.writelines(chunks)
         finally:
             out.close()
-        if per_file_timestamps:
-            mtime = tree.get_file_mtime(tree.path2id(relpath), relpath)
-        else:
-            mtime = now
-        os.utime(fullpath, (mtime, mtime))

=== modified file 'bzrlib/export/tar_exporter.py'
--- bzrlib/export/tar_exporter.py	2010-04-14 10:12:22 +0000
+++ bzrlib/export/tar_exporter.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,12 +17,13 @@
 """Export a Tree to a non-versioned directory.
 """
 
+import os
 import StringIO
 import sys
 import tarfile
 import time
 
-from bzrlib import export, osutils
+from bzrlib import errors, export, osutils
 from bzrlib.export import _export_iter_entries
 from bzrlib.filters import (
     ContentFilterContext,
@@ -31,8 +32,7 @@
 from bzrlib.trace import mutter
 
 
-def tar_exporter(tree, dest, root, subdir, compression=None, filtered=False,
-                 per_file_timestamps=False):
+def tar_exporter(tree, dest, root, subdir, compression=None, filtered=False):
     """Export this tree to a new tar file.
 
     `dest` will be created holding the contents of this tree; if it
@@ -48,21 +48,11 @@
     else:
         if root is None:
             root = export.get_root_name(dest)
-
-        # tarfile.open goes on to do 'os.getcwd() + dest' for opening
-        # the tar file. With dest being unicode, this throws UnicodeDecodeError
-        # unless we encode dest before passing it on. This works around
-        # upstream python bug http://bugs.python.org/issue8396
-        # (fixed in Python 2.6.5 and 2.7b1)
-        ball = tarfile.open(dest.encode(osutils._fs_enc), 'w:' + compression)
-
+        ball = tarfile.open(dest, 'w:' + compression)
     for dp, ie in _export_iter_entries(tree, subdir):
         filename = osutils.pathjoin(root, dp).encode('utf8')
         item = tarfile.TarInfo(filename)
-        if per_file_timestamps:
-            item.mtime = tree.get_file_mtime(ie.file_id, dp)
-        else:
-            item.mtime = now
+        item.mtime = now
         if ie.kind == "file":
             item.type = tarfile.REGTYPE
             if tree.is_executable(ie.file_id):
@@ -99,13 +89,9 @@
     ball.close()
 
 
-def tgz_exporter(tree, dest, root, subdir, filtered=False,
-                 per_file_timestamps=False):
-    tar_exporter(tree, dest, root, subdir, compression='gz',
-                 filtered=filtered, per_file_timestamps=per_file_timestamps)
-
-
-def tbz_exporter(tree, dest, root, subdir, filtered=False,
-                 per_file_timestamps=False):
-    tar_exporter(tree, dest, root, subdir, compression='bz2',
-                 filtered=filtered, per_file_timestamps=per_file_timestamps)
+def tgz_exporter(tree, dest, root, subdir, filtered=False):
+    tar_exporter(tree, dest, root, subdir, compression='gz', filtered=filtered)
+
+
+def tbz_exporter(tree, dest, root, subdir, filtered=False):
+    tar_exporter(tree, dest, root, subdir, compression='bz2', filtered=filtered)

=== modified file 'bzrlib/export/zip_exporter.py'
--- bzrlib/export/zip_exporter.py	2010-03-08 02:23:17 +0000
+++ bzrlib/export/zip_exporter.py	2009-11-25 00:14:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -42,8 +42,7 @@
 _DIR_ATTR = stat.S_IFDIR | ZIP_DIRECTORY_BIT
 
 
-def zip_exporter(tree, dest, root, subdir, filtered=False,
-                 per_file_timestamps=False):
+def zip_exporter(tree, dest, root, subdir, filtered=False):
     """ Export this tree to a new zip file.
 
     `dest` will be created holding the contents of this tree; if it
@@ -63,15 +62,11 @@
 
             # zipfile.ZipFile switches all paths to forward
             # slashes anyway, so just stick with that.
-            if per_file_timestamps:
-                mtime = tree.get_file_mtime(ie.file_id, dp)
-            else:
-                mtime = now
             filename = osutils.pathjoin(root, dp).encode('utf8')
             if ie.kind == "file":
                 zinfo = zipfile.ZipInfo(
                             filename=filename,
-                            date_time=mtime)
+                            date_time=now)
                 zinfo.compress_type = compression
                 zinfo.external_attr = _FILE_ATTR
                 if filtered:
@@ -89,14 +84,14 @@
                 # not just empty files.
                 zinfo = zipfile.ZipInfo(
                             filename=filename + '/',
-                            date_time=mtime)
+                            date_time=now)
                 zinfo.compress_type = compression
                 zinfo.external_attr = _DIR_ATTR
                 zipf.writestr(zinfo,'')
             elif ie.kind == "symlink":
                 zinfo = zipfile.ZipInfo(
                             filename=(filename + '.lnk'),
-                            date_time=mtime)
+                            date_time=now)
                 zinfo.compress_type = compression
                 zinfo.external_attr = _FILE_ATTR
                 zipf.writestr(zinfo, ie.symlink_target)

=== modified file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2010-04-30 11:03:59 +0000
+++ bzrlib/externalcommand.py	2009-03-23 14:59:43 +0000
@@ -20,8 +20,10 @@
 
 
 import os
+import sys
 
 from bzrlib.commands import Command
+from bzrlib.osutils import pathjoin
 
 
 class ExternalCommand(Command):

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2010-04-30 11:35:43 +0000
+++ bzrlib/fetch.py	2009-12-01 22:34:04 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,6 +28,8 @@
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (
+    graph as _mod_graph,
+    static_tuple,
     tsort,
     versionedfile,
     )
@@ -35,6 +37,7 @@
 import bzrlib
 from bzrlib import (
     errors,
+    symbol_versioning,
     ui,
     )
 from bzrlib.revision import NULL_REVISION
@@ -49,13 +52,20 @@
     """
 
     def __init__(self, to_repository, from_repository, last_revision=None,
-        find_ghosts=True, fetch_spec=None):
+        pb=None, find_ghosts=True, fetch_spec=None):
         """Create a repo fetcher.
 
         :param last_revision: If set, try to limit to the data this revision
             references.
         :param find_ghosts: If True search the entire history for ghosts.
+        :param pb: ProgressBar object to use; deprecated and ignored.
+            This method will just create one on top of the stack.
         """
+        if pb is not None:
+            symbol_versioning.warn(
+                symbol_versioning.deprecated_in((1, 14, 0))
+                % "pb parameter to RepoFetcher.__init__")
+            # and for simplicity it is in fact ignored
         # repository.fetch has the responsibility for short-circuiting
         # attempts to copy between a repository and itself.
         self.to_repository = to_repository
@@ -244,9 +254,7 @@
         root_id_order.sort(key=operator.itemgetter(0))
         # Create a record stream containing the roots to create.
         if len(revs) > 100:
-            # XXX: not covered by tests, should have a flag to always run
-            # this. -- mbp 20100129
-            graph = self.source_repo.get_known_graph_ancestry(revs)
+            graph = _get_rich_root_heads_graph(self.source_repo, revs)
         new_roots_stream = _new_root_data_stream(
             root_id_order, rev_id_to_root_id, parent_map, self.source, graph)
         return [('texts', new_roots_stream)]
@@ -254,7 +262,11 @@
 
 def _get_rich_root_heads_graph(source_repo, revision_ids):
     """Get a Graph object suitable for asking heads() for new rich roots."""
-    return 
+    st = static_tuple.StaticTuple
+    revision_keys = [st(r_id).intern() for r_id in revision_ids]
+    known_graph = source_repo.revisions.get_known_graph_ancestry(
+                    revision_keys)
+    return _mod_graph.GraphThunkIdsToKeys(known_graph)
 
 
 def _new_root_data_stream(

=== modified file 'bzrlib/foreign.py'
--- bzrlib/foreign.py	2010-04-28 10:33:44 +0000
+++ bzrlib/foreign.py	2009-10-27 21:54:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -225,6 +225,29 @@
         """Get the default mapping for this repository."""
         raise NotImplementedError(self.get_default_mapping)
 
+    def get_inventory_xml(self, revision_id):
+        """See Repository.get_inventory_xml()."""
+        return self.serialise_inventory(self.get_inventory(revision_id))
+
+    def get_inventory_sha1(self, revision_id):
+        """Get the sha1 for the XML representation of an inventory.
+
+        :param revision_id: Revision id of the inventory for which to return
+         the SHA1.
+        :return: XML string
+        """
+
+        return osutils.sha_string(self.get_inventory_xml(revision_id))
+
+    def get_revision_xml(self, revision_id):
+        """Return the XML representation of a revision.
+
+        :param revision_id: Revision for which to return the XML.
+        :return: XML string
+        """
+        return self._serializer.write_revision_to_string(
+            self.get_revision(revision_id))
+
 
 class ForeignBranch(Branch):
     """Branch that exists in a foreign version control system."""
@@ -259,7 +282,7 @@
 
 
 class cmd_dpush(Command):
-    __doc__ = """Push into a different VCS without any custom bzr metadata.
+    """Push into a different VCS without any custom bzr metadata.
 
     This will afterwards rebase the local branch on the remote
     branch unless the --no-rebase option is used, in which case 
@@ -296,11 +319,20 @@
         except NoWorkingTree:
             source_branch = Branch.open(directory)
             source_wt = None
-        if source_wt is not None:
-            source_wt.check_changed_or_out_of_date(
-                strict, 'dpush_strict',
-                more_error='Use --no-strict to force the push.',
-                more_warning='Uncommitted changes will not be pushed.')
+        if strict is None:
+            strict = source_branch.get_config(
+                ).get_user_option_as_bool('dpush_strict')
+        if strict is None: strict = True # default value
+        if strict and source_wt is not None:
+            if (source_wt.has_changes()):
+                raise errors.UncommittedChanges(
+                    source_wt, more='Use --no-strict to force the push.')
+            if source_wt.last_revision() != source_wt.branch.last_revision():
+                # The tree has lost sync with its branch, there is little
+                # chance that the user is aware of it but he can still force
+                # the push with --no-strict
+                raise errors.OutOfDateTree(
+                    source_wt, more='Use --no-strict to force the push.')
         stored_loc = source_branch.get_push_location()
         if location is None:
             if stored_loc is None:

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2010-02-17 17:11:16 +0000
+++ bzrlib/globbing.py	2009-11-11 21:38:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2008 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -215,40 +215,6 @@
                 return patterns[match.lastindex -1]
         return None
 
-class ExceptionGlobster(object):
-    """A Globster that supports exception patterns.
-    
-    Exceptions are ignore patterns prefixed with '!'.  Exception
-    patterns take precedence over regular patterns and cause a 
-    matching filename to return None from the match() function.  
-    Patterns using a '!!' prefix are highest precedence, and act 
-    as regular ignores. '!!' patterns are useful to establish ignores
-    that apply under paths specified by '!' exception patterns.
-    """
-    
-    def __init__(self,patterns):
-        ignores = [[], [], []]
-        for p in patterns:
-            if p.startswith(u'!!'):
-                ignores[2].append(p[2:])
-            elif p.startswith(u'!'):
-                ignores[1].append(p[1:])
-            else:
-                ignores[0].append(p)
-        self._ignores = [Globster(i) for i in ignores]
-        
-    def match(self, filename):
-        """Searches for a pattern that matches the given filename.
-
-        :return A matching pattern or None if there is no matching pattern.
-        """
-        double_neg = self._ignores[2].match(filename)
-        if double_neg:
-            return "!!%s" % double_neg
-        elif self._ignores[1].match(filename):
-            return None
-        else:
-            return self._ignores[0].match(filename)
 
 class _OrderedGlobster(Globster):
     """A Globster that keeps pattern order."""
@@ -278,7 +244,8 @@
 
     Doesn't normalize regular expressions - they may contain escapes.
     """
-    if not (pattern.startswith('RE:') or pattern.startswith('!RE:')):
+
+    if not pattern.startswith('RE:'):
         pattern = _slashes.sub('/', pattern)
     if len(pattern) > 1:
         pattern = pattern.rstrip('/')

=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2010-04-10 01:22:00 +0000
+++ bzrlib/graph.py	2009-11-30 03:16:22 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1685,18 +1685,12 @@
     def __init__(self, graph):
         self._graph = graph
 
-    def topo_sort(self):
-        return [r for (r,) in self._graph.topo_sort()]
-
     def heads(self, ids):
         """See Graph.heads()"""
         as_keys = [(i,) for i in ids]
         head_keys = self._graph.heads(as_keys)
         return set([h[0] for h in head_keys])
 
-    def merge_sort(self, tip_revision):
-        return self._graph.merge_sort((tip_revision,))
-
 
 _counters = [0,0,0,0,0,0,0]
 try:

=== modified file 'bzrlib/groupcompress.py'
--- bzrlib/groupcompress.py	2010-04-22 19:05:14 +0000
+++ bzrlib/groupcompress.py	2009-12-01 03:35:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1631,7 +1631,6 @@
         keys_to_add = []
         def flush():
             bytes = self._compressor.flush().to_bytes()
-            self._compressor = GroupCompressor()
             index, start, length = self._access.add_raw_records(
                 [(None, len(bytes))], bytes)[0]
             nodes = []
@@ -1640,6 +1639,7 @@
             self._index.add_records(nodes, random_id=random_id)
             self._unadded_refs = {}
             del keys_to_add[:]
+            self._compressor = GroupCompressor()
 
         last_prefix = None
         max_fulltext_len = 0

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2010-04-30 11:03:59 +0000
+++ bzrlib/help.py	2009-12-02 15:24:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,6 +30,7 @@
     help_topics,
     osutils,
     plugin,
+    symbol_versioning,
     )
 
 

=== modified file 'bzrlib/help_topics/__init__.py'
--- bzrlib/help_topics/__init__.py	2010-03-02 10:21:39 +0000
+++ bzrlib/help_topics/__init__.py	2009-12-07 18:50:45 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -269,17 +269,14 @@
   bzr+ssh://remote@shell.example.com/~/myproject/trunk
 
 would refer to ``/home/remote/myproject/trunk``.
-
-Many commands that accept URLs also accept location aliases too.  See
-::doc:`location-alias-help`.
 """
 
     return out
 
 
 _basic_help = \
-"""Bazaar %s -- a free distributed version-control tool
-http://www.bazaar.canonical.com/
+"""Bazaar -- a free distributed version-control tool
+http://bazaar-vcs.org/
 
 Basic commands:
   bzr init           makes this directory a versioned branch
@@ -302,14 +299,14 @@
   bzr help init      more help on e.g. init command
   bzr help commands  list all commands
   bzr help topics    list all help topics
-""" % bzrlib.__version__
+"""
 
 
 _global_options = \
 """Global Options
 
 These options may be used with any command, and may appear in front of any
-command.  (e.g. ``bzr --profile help``).
+command.  (e.g. "bzr --profile help").
 
 --version      Print the version number. Must be supplied before the command.
 --no-aliases   Do not process command aliases when running this command.
@@ -328,11 +325,9 @@
                will be a pickle.
 --coverage     Generate line coverage report in the specified directory.
 
-See http://doc.bazaar.canonical.com/developers/profiling.html for more
-information on profiling.
-
+See doc/developers/profiling.txt for more information on profiling.
 A number of debug flags are also available to assist troubleshooting and
-development.  See :doc:`debug-flags-help`.
+development.  See `bzr help debug-flags`.
 """
 
 _standard_options = \
@@ -406,13 +401,13 @@
 end. Checkouts also work on the local file system, so that all that matters is
 file permissions.
 
-You can change the master of a checkout by using the "switch" command (see
-"help switch").  This will change the location that the commits are sent to.
-The "bind" command can also be used to turn a normal branch into a heavy
-checkout. If you would like to convert your heavy checkout into a normal
-branch so that every commit is local, you can use the "unbind" command. To see
-whether or not a branch is bound or not you can use the "info" command. If the
-branch is bound it will tell you the location of the bound branch.
+You can change the master of a checkout by using the "bind" command (see "help
+bind"). This will change the location that the commits are sent to. The bind
+command can also be used to turn a branch into a heavy checkout. If you
+would like to convert your heavy checkout into a normal branch so that every
+commit is local, you can use the "unbind" command. To see whether or not a
+branch is bound or not you can use the "info" command. If the branch is bound
+it will tell you the location of the bound branch.
 
 Related commands::
 
@@ -422,10 +417,8 @@
   commit      Make a commit that is sent to the master branch. If you have
               a heavy checkout then the --local option will commit to the
               checkout without sending the commit to the master
-  switch      Change the master branch that the commits in the checkout will
+  bind        Change the master branch that the commits in the checkout will
               be sent to
-  bind        Turn a standalone branch into a heavy checkout so that any
-              commits will be sent to the master branch
   unbind      Turn a heavy checkout into a standalone branch so that any
               commits are only made locally
   info        Displays whether a branch is bound or unbound. If the branch is
@@ -525,19 +518,11 @@
 branch history is stored), but multiple branches may share the same
 repository (a shared repository). Branches can be copied and merged.
 
-In addition, one branch may be bound to another one.  Binding to another
-branch indicates that commits which happen in this branch must also 
-happen in the other branch.  Bazaar ensures consistency by not allowing 
-commits when the two branches are out of date.  In order for a commit 
-to succeed, it may be necessary to update the current branch using 
-``bzr update``.
-
 Related commands::
 
   init    Change a directory into a versioned branch.
   branch  Create a new branch that is a copy of an existing branch.
   merge   Perform a three-way merge.
-  bind    Bind a branch to another one.
 """
 
 
@@ -662,7 +647,7 @@
 differences.
 """
 
-_branches_out_of_sync = """Branches Out of Sync
+_branches_out_of_sync = """Branches out of sync
 
 When reconfiguring a checkout, tree or branch into a lightweight checkout,
 a local branch must be destroyed.  (For checkouts, this is the local branch
@@ -697,20 +682,18 @@
 project owner to upgrade.
 
 
-.. note::
-
-   Some of the older formats have two variants:
-   a plain one and a rich-root one. The latter include an additional
-   field about the root of the tree. There is no performance cost
-   for using a rich-root format but you cannot easily merge changes
-   from a rich-root format into a plain format. As a consequence,
-   moving a project to a rich-root format takes some co-ordination
-   in that all contributors need to upgrade their repositories
-   around the same time. 2a and all future formats will be
-   implicitly rich-root.
-
-See :doc:`current-formats-help` for the complete list of
-currently supported formats. See :doc:`other-formats-help` for
+Note: Some of the older formats have two variants:
+a plain one and a rich-root one. The latter include an additional
+field about the root of the tree. There is no performance cost
+for using a rich-root format but you cannot easily merge changes
+from a rich-root format into a plain format. As a consequence,
+moving a project to a rich-root format takes some co-ordination
+in that all contributors need to upgrade their repositories
+around the same time. 2a and all future formats will be
+implicitly rich-root.
+
+See ``bzr help current-formats`` for the complete list of
+currently supported formats. See ``bzr help other-formats`` for
 descriptions of any available experimental and deprecated formats.
 """
 
@@ -759,14 +742,14 @@
                         'Information on configuring authentication')
 topic_registry.register('configuration', _load_from_file,
                         'Details on the configuration settings available')
-topic_registry.register('conflict-types', _load_from_file,
+topic_registry.register('conflicts', _load_from_file,
                         'Types of conflicts and what to do about them')
 topic_registry.register('debug-flags', _load_from_file,
                         'Options to show or record debug information')
-topic_registry.register('location-alias', _load_from_file,
-                        'Aliases for remembered locations')
 topic_registry.register('log-formats', _load_from_file,
                         'Details on the logging formats available')
+topic_registry.register('diverged-branches', _load_from_file,
+                        'How to fix diverged branches')
 
 
 # Register concept topics.
@@ -780,9 +763,6 @@
 topic_registry.register('content-filters', _load_from_file,
                         'Conversion of content into/from working trees',
                         SECT_CONCEPT)
-topic_registry.register('diverged-branches', _load_from_file,
-                        'How to fix diverged branches',
-                        SECT_CONCEPT)
 topic_registry.register('eol', _load_from_file,
                         'Information on end-of-line handling',
                         SECT_CONCEPT)
@@ -876,7 +856,6 @@
 
 def help_as_plain_text(text):
     """Minimal converter of reStructuredText to plain text."""
-    import re
     lines = text.splitlines()
     result = []
     for line in lines:
@@ -884,7 +863,5 @@
             line = line[1:]
         elif line.endswith('::'):
             line = line[:-1]
-        # Map :doc:`xxx-help` to ``bzr help xxx``
-        line = re.sub(":doc:`(.+)-help`", r'``bzr help \1``', line)
         result.append(line)
     return "\n".join(result) + "\n"

=== modified file 'bzrlib/help_topics/en/authentication.txt'
--- bzrlib/help_topics/en/authentication.txt	2010-03-09 22:43:38 +0000
+++ bzrlib/help_topics/en/authentication.txt	2008-05-09 16:40:21 +0000
@@ -58,10 +58,10 @@
 against a host. But, by using ``.htaccess`` files, for example, it is possible
 to define several (``user, realm, password``) for a given ``host``. So what is
 really needed is (``user``, ``password``, ``host``, ``path``). The ``realm`` is
-not taken into account in the definitions, but will displayed if bzr prompts
-you for a password.
+not taken into account in the defitions, but will displayed if bzr prompts you
+for a password.
 
-``HTTP proxy`` can be handled as ``HTTP`` (or ``HTTPS``) by explicitly
+``HTTP proxy`` can be handled as ``HTTP`` (or ``HTTPS``) by explicitely
 specifying the appropriate port.
 
 To take all schemes into account, the password will be deduced from a set of
@@ -110,8 +110,10 @@
 File format
 -----------
 
-The general rules for :doc:`configuration files <configuration-help>`
-apply except for the variable policies.
+The general rules for `configuration files`_ apply except for the variable
+policies.
+
+.. _configuration files: #configuration-settings
 
 Each section describes an authentication definition.
 
@@ -165,7 +167,7 @@
 Source hosting provider
 ~~~~~~~~~~~~~~~~~~~~~~~
 
-In the shp.net (fictitious) domain, each project has its own site::
+In the shp.net (fictious) domain, each project has its own site::
 
         [shpnet domain]
         # we use sftp, but ssh is the scheme used for authentication

=== modified file 'bzrlib/help_topics/en/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2010-04-23 07:15:23 +0000
+++ bzrlib/help_topics/en/configuration.txt	2009-12-15 20:32:34 +0000
@@ -98,67 +98,25 @@
 used literally, they will be substituted by the corresponding,
 platform specific, values.
 
-The examples below use ':' as the separator, windows users
+Examples:
+^^^^^^^^^
+
+The examples below uses ':' as the separator, windows users
 should use ';'.
 
-Overriding the default user plugin directory::
-
-  BZR_PLUGIN_PATH='/path/to/my/other/plugins'
-
-Disabling the site directory while retaining the user directory::
-
-  BZR_PLUGIN_PATH='-site:+user'
-
-Disabling all plugins (better achieved with --no-plugins)::
-
-  BZR_PLUGIN_PATH='-user:-core:-site'
-
-Overriding the default site plugin directory::
-
-  BZR_PLUGIN_PATH='/path/to/my/site/plugins:-site':+user
-
-BZR_DISABLE_PLUGINS
-~~~~~~~~~~~~~~~~~~~
-
-Under special circumstances (mostly when trying to diagnose a
-bug), it's better to disable a plugin (or several) rather than
-uninstalling them completely. Such plugins can be specified in
-the ``BZR_DISABLE_PLUGINS`` environment variable.
-
-In that case, ``bzr`` will stop loading the specified plugins and
-will raise an import error if they are explicitly imported (by
-another plugin that depends on them for example).
-
-Disabling ``myplugin`` and ``yourplugin`` is achieved by::
-
-  BZR_DISABLE_PLUGINS='myplugin:yourplugin'
-
-BZR_PLUGINS_AT
-~~~~~~~~~~~~~~
-
-When adding a new feature or working on a bug in a plugin,
-developers often need to use a specific version of a given
-plugin. Since python requires that the directory containing the
-code is named like the plugin itself this make it impossible to
-use arbitrary directory names (using a two-level directory scheme
-is inconvenient). ``BZR_PLUGINS_AT`` allows such directories even
-if they don't appear in ``BZR_PLUGIN_PATH`` .
-
-Plugins specified in this environment variable takes precedence
-over the ones in ``BZR_PLUGIN_PATH``.
-
-The variable specified a list of ``plugin_name@plugin path``,
-``plugin_name`` being the name of the plugin as it appears in
-python module paths, ``plugin_path`` being the path to the
-directory containing the plugin code itself
-(i.e. ``plugins/myplugin`` not ``plugins``).  Use ':' as the list
-separator, use ';' on windows.
-
-Example:
-~~~~~~~~
-
-Using a specific version of ``myplugin``:
-``BZR_PLUGINS_AT='myplugin@/home/me/bugfixes/123456-myplugin``
+Overriding the default user plugin directory:
+``BZR_PLUGIN_PATH='/path/to/my/other/plugins'``
+
+Disabling the site directory while retaining the user directory:
+``BZR_PLUGIN_PATH='-site:+user'``
+
+Disabling all plugins (better achieved with --no-plugins):
+``BZR_PLUGIN_PATH='-user:-core:-site'``
+
+Overriding the default site plugin directory:
+``BZR_PLUGIN_PATH='/path/to/my/site/plugins:-site':+user``
+
+
 
 BZRPATH
 ~~~~~~~
@@ -314,7 +272,7 @@
 variable policies which don't apply.
 
 For more information on the possible uses of the authentication configuration
-file see :doc:`authentication-help`.
+file see `Authentication Settings`_.
 
 
 Common variable options
@@ -495,11 +453,9 @@
 ~~~~~~~~~~~~~~~~~~~~~
 
 If set to "True" then revisions can only be appended to the log, not
-removed.  A branch with this setting enabled can only pull from another
-branch if the other branch's log is a longer version of its own.  This is
-normally set by ``bzr init --append-revisions-only``. If you set it
-manually, use either 'True' or 'False' (case-sensitive) to maintain
-compatibility with previous bzr versions (older than 2.2).
+removed.  A branch with this setting enabled can only pull from
+another branch if the other branch's log is a longer version of its
+own.  This is normally set by ``bzr init --append-revisions-only``.
 
 parent_location
 ~~~~~~~~~~~~~~~

=== renamed file 'bzrlib/help_topics/en/conflict-types.txt' => 'bzrlib/help_topics/en/conflicts.txt'
--- bzrlib/help_topics/en/conflict-types.txt	2010-02-04 13:29:34 +0000
+++ bzrlib/help_topics/en/conflicts.txt	2009-12-10 17:03:48 +0000
@@ -1,61 +1,18 @@
-Conflict Types
-==============
+Conflicts Types
+===============
 
 Some operations, like merge, revert and pull, modify the contents of your
 working tree.  These modifications are programmatically generated, and so they
-may conflict with the current state of your working tree. 
-
-When conflicts are present in your working tree (as shown by ``bzr
-conflicts``), you should resolve them and then inform bzr that the conflicts
-have been resolved.
-
-Resolving conflicts is sometimes not obvious. Either because the user that
-should resolve them is not the one responsible for their occurrence, as is the
-case when merging other people's work or because some conflicts are presented
-in a way that is not easy to understand.
-
-Bazaar tries to avoid conflicts ; its aim is to ask you to resolve the
-conflict if and only if there's an actual conceptual conflict in the source
-tree.  Because Bazaar doesn't understand the real meaning of the files being
-versioned, it can, when faced with ambiguities, fall short in either direction
-trying to resolve the conflict itself. Many kinds of changes can be combined
-programmatically, but sometimes only a human can determine the right thing to
-do.
-
-When Bazaar generates a conflict, it adds information into the working tree to
-present the conflicting versions, and it's up to you to find the correct
-resolution.
-
-Whatever the conflict is, resolving it is roughly done in two steps::
-
-- modify the working tree content so that the conflicted item is now in the
-  state you want to keep,
-
-- inform Bazaar that the conflict is now solved and ask to cleanup any
-  remaining generated information (``bzr resolve <item>``).
-
-For most conflict types, there are some obvious ways to modify the working
-tree and put it into the desired state. For some types of conflicts, Bazaar
-itself already made a choice, when possible.
-
-Yet, whether Bazaar makes a choice or not, there are some other simple but
-different ways to resolve the conflict.
+may conflict with the current state of your working tree. Many kinds of changes
+can be combined programmatically, but sometimes only a human can determine the
+right thing to do.  When this happens Bazaar will inform you that there is a
+conflict and then ask you to resolve it.  The command to tell Bazaar a conflict
+is resolved is ``resolve``, but you must perform some action before you can do
+this.
 
 Each type of conflict is explained below, and the action which must be done to
 resolve the conflict is outlined.
 
-Various actions are available depending on the kind of conflict, for some of
-these actions, Bazaar can provide some help. In the end you should at least
-inform Bazaar that you're done with the conflict with::
-
-  ``bzr resolve FILE --action=done'
-
-Note that this is the default action when a single file is involved so you can
-simply use::
-
-   ``bzr resolve FILE``
-
-See ``bzr help resolve`` for more details.
 
 Text conflicts
 --------------
@@ -97,12 +54,8 @@
 you are done editing, the file should look like it never had a conflict, and be
 ready to commit.
 
-When you have resolved text conflicts, just run ``bzr resolve --auto``, and
-Bazaar will auto-detect which conflicts you have resolved.
-
-When the conflict is resolved, Bazaar deletes the previously generated
-``.BASE``, ``.THIS`` and ``.OTHER`` files if they are still present in the
-working tree.
+When you have resolved text conflicts, just run "bzr resolve", and Bazaar will
+auto-detect which conflicts you have resolved.
 
 Content conflicts
 -----------------
@@ -111,29 +64,20 @@
 
   Contents conflict in FILE
 
-This conflict happens when there are conflicting changes in the working tree
-and the merge source, but the conflicted items are not text files.  They may
-be binary files, or symlinks, or directories.  It can even happen with files
-that are deleted on one side, and modified on the other.
+This conflict happens when there are conflicting changes in the target tree and
+the merge source, but the conflicted items are not text files.  They may be
+binary files, or symlinks, or directories.  It can even happen with files that
+are deleted on one side, and modified on the other.
 
 Like text conflicts, Bazaar will emit THIS, OTHER and BASE files.  (They may be
 regular files, symlinks or directories).  But it will not include a "main copy"
 of the file with herringbone conflict markers.  It will appear that the "main
 copy" has been renamed to THIS or OTHER.
 
-To resolve that kind of conflict, you should rebuild FILE from either version
-or a combination of both.
-
-``bzr resolve`` recognizes the following actions:
-
-- ``--action=take-this`` will issue ``bzr mv FILE.THIS FILE``,
-- ``--action=take-other`` will issue ``bzr mv FILE.OTHER FILE``,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Any action will also delete the previously generated ``.BASE``, ``.THIS`` and
-``.OTHER`` files if they are still present in the working tree.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
+To resolve this, use "bzr mv" to rename the file back to its normal name, and
+combine the changes manually.  When you are satisfied, run "bzr resolve
+FILE".  Bazaar cannot auto-detect when conflicts of this kind have been
+resolved.
 
 Tag conflicts
 -------------
@@ -151,13 +95,12 @@
 To resolve the conflict, you must apply the correct tags to either the target
 branch or the source branch as appropriate.  Use "bzr tags --show-ids -d
 SOURCE_URL" to see the tags in the source branch.  If you want to make the
-target branch's tags match the source branch, then in the target branch do
+target branch's tags match the source branch, then in the target branch do 
 ``bzr tag --force -r revid:REVISION_ID CONFLICTING_TAG`` for each of the
 CONFLICTING_TAGs, where REVISION_ID comes from the list of tags in the source
-branch.  You need not call "bzr resolve" after doing this.  To resolve in
-favor of the target branch, you need to similarly use ``tag --force`` in the
-source branch.  (Note that pulling or pushing using --overwrite will overwrite
-all tags as well.)
+branch.  You need not call "bzr resolve" after doing this.  To resolve in favor of the target branch, you need to similarly use ``tag --force`` in the source
+branch.  (Note that pulling or pushing using --overwrite will overwrite all
+tags as well.)
 
 Duplicate paths
 ---------------
@@ -167,20 +110,10 @@
   Conflict adding file FILE.  Moved existing file to FILE.moved.
 
 Sometimes Bazaar will attempt to create a file using a pathname that has
-already been used.  The existing file will be renamed to "FILE.moved".  
-
-To resolve that kind of conflict, you should rebuild FILE from either version
-or a combination of both.
-
-``bzr resolve`` recognizes the following actions::
-
-- ``--action=take-this`` will issue ``bzr rm FILE ; bzr mv FILE.moved FILE``,
-- ``--action=take-other`` will issue ``bzr rm FILE.moved``,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Note that you must get rid of FILE.moved before using ``--action=done``.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
+already been used.  The existing file will be renamed to "FILE.moved".  If
+you wish, you can rename either one of these files, or combine their contents.
+When you are satisfied, you can run "bzr resolve FILE" to mark the conflict as
+resolved.
 
 Unversioned parent
 ------------------
@@ -204,46 +137,26 @@
 
   Conflict adding files to FILE.  Created directory.
 
-This happens when a directory has been deleted in the target, but has new
-children in the source.  This is similar to the "unversioned parent" conflict,
-except that the parent directory does not *exist*, instead of just being
-unversioned.  In this situation, Bazaar will create the missing parent.
-Resolving this issue depends very much on the particular scenario.
-
-To resolve that kind of conflict, you should either remove or rename the
-children or the directory or a combination of both.
-
-``bzr resolve`` recognizes the following actions::
-
-- ``--action=take-this`` will issue ``bzr rm directory`` including the children,
-- ``--action=take-other`` will acknowledge Bazaar choice to keep the children
-  and restoring the directory,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
+This happens when a file has been deleted in the target, but has new children
+in the source.  This is similar to the "unversioned parent" conflict, except
+that the parent directory does not *exist*, instead of just being unversioned.
+In this situation, Bazaar will create the missing parent.  Resolving this issue
+depends very much on the particular scenario.  You may wish to rename or delete
+either the file or the directory.  When you are satisfied, you can run "bzr
+resolve FILE" to mark the conflict as resolved.
 
 Deleting parent
 ---------------
 
 Typical message::
 
-  Conflict: can't delete DIR because it is not empty.  Not deleting.
+  Conflict: can't delete FILE because it is not empty.  Not deleting.
 
 This is the opposite of "missing parent".  A directory is deleted in the
 source, but has new children in the target.  Bazaar will retain the directory.
-Resolving this issue depends very much on the particular scenario.
-
-To resolve that kind of conflict, you should either remove or rename the
-children or the directory or a combination of both.
-
-``bzr resolve`` recognizes the following actions::
-
-- ``--action=take-this`` will acknowledge Bazaar choice to keep the directory,
-- ``--action=take-other`` will issue ``bzr rm directory`` including the 
-  children,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
+Resolving this issue depends very much on the particular scenario.  You may
+wish to rename or delete either the file or the directory.  When you are
+satisfied, you can run "bzr resolve FILE" to mark the conflict as resolved.
 
 Path conflict
 -------------
@@ -253,19 +166,9 @@
   Path conflict: PATH1 / PATH2
 
 This happens when the source and target have each modified the name or parent
-directory of a file.  Bazaar will use the path elements from the source.
-
-To resolve that kind of conflict, you just have to decide what name should be
-retained for the file involved.
-
-``bzr resolve`` recognizes the following actions::
-
-- ``--action=take-this`` will revert Bazaar choice and keep ``PATH1`` by
-  issuing ``bzr mv PATH2 PATH1``,
-- ``--action=take-other`` will acknowledge Bazaar choice of keeping ``PATH2``,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
+directory of a file.  Bazaar will use the path elements from the source.  You
+can rename the file, and once you have, run "bzr resolve FILE" to mark the
+conflict as resolved.
 
 Parent loop
 -----------
@@ -279,64 +182,42 @@
 For example::
 
   $ bzr init
-  $ bzr mkdir white
-  $ bzr mkdir black
+  $ bzr mkdir a
+  $ bzr mkdir b
   $ bzr commit -m "BASE"
   $ bzr branch . ../other
-  $ bzr mv white black
+  $ bzr mv a b
   $ bzr commit -m "THIS"
-  $ bzr mv ../other/black ../other/white
+  $ bzr mv ../other/b ../other/a
   $ bzr commit ../other -m "OTHER"
   $ bzr merge ../other
 
-In this situation, Bazaar will cancel the move, and leave ``white`` in
-``black``.  To resolve that kind of conflict, you just have to decide what
-name should be retained for the directories involved.
-
-``bzr resolve`` recognizes the following actions::
-
-- ``--action=take-this`` will acknowledge Bazaar choice of leaving ``white`` 
-  in ``black``,
-- ``--action=take-other`` will revert Bazaar choice and move ``black`` in
-  ``white`` by issuing ``bzr mv black/white white ; bzr mv black white``,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
+In this situation, Bazaar will cancel the move, and leave "a" in "b".
+You can rename the directories if you like, and once you have, run "bzr resolve
+FILE" to mark the conflict as resolved.
 
 Non-directory parent
 --------------------
 
 Typical message::
 
-  Conflict: foo.new is not a directory, but has files in it.
+  Conflict: FILE.new is not a directory, but has files in it.
   Created directory.
 
 This happens when one side has added files to a directory, and the other side
 has changed the directory into a file or symlink.  For example::
 
   $ bzr init
-  $ bzr mkdir foo
+  $ bzr mkdir a
   $ bzr commit -m "BASE"
   $ bzr branch . ../other
-  $ rmdir foo
-  $ touch foo
+  $ rmdir a
+  $ touch a
   $ bzr commit -m "THIS"
-  $ bzr mkdir ../other/foo/bar
+  $ bzr mkdir ../other/a/b
   $ bzr commit ../other -m "OTHER"
   $ bzr merge ../other
 
-To resolve that kind of conflict, you have to decide what name should be
-retained for the file, directory or symlink involved.
-
-``bzr resolve`` recognizes the following actions::
-
-- ``--action=take-this`` will issue ``bzr rm --force foo.new`` and 
-  ``bzr add foo``,
-- ``--action=take-other`` will issue ``bzr rm --force foo`` and 
-  ``bzr mv foo.new foo``,
-- ``--action=done`` will just mark the conflict as resolved.
-
-Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
 MalformedTransform
 ------------------

=== modified file 'bzrlib/help_topics/en/content-filters.txt'
--- bzrlib/help_topics/en/content-filters.txt	2010-01-03 03:33:10 +0000
+++ bzrlib/help_topics/en/content-filters.txt	2009-02-25 06:41:51 +0000
@@ -65,8 +65,8 @@
 Note: ``bzr commit`` does not implicitly apply write converters after
 comitting files. If this makes sense for a given plugin providing
 a content filter, the plugin can usually achieve this effect by using a
-``start_commit`` or ``post_commit`` hook say. See :doc:`hooks-help`
-for more information on hooks.
+``start_commit`` or ``post_commit`` hook say. See ``bzr help hooks`` and
+`Using hooks`_ in the Bazaar User Guide for more information on hooks.
 
 
 Refreshing your working tree

=== removed file 'bzrlib/help_topics/en/location-alias.txt'
--- bzrlib/help_topics/en/location-alias.txt	2010-02-11 07:18:20 +0000
+++ bzrlib/help_topics/en/location-alias.txt	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-Location aliases
-================
-
-Bazaar defines several aliases for locations associated with a branch.  These
-can be used with most commands that expect a location, such as `bzr push`.
-
-The aliases are::
-
-  :parent    the parent of this branch
-  :submit    the submit branch for this branch
-  :public    the public location of this branch
-  :bound     the branch this branch is bound to, for bound branches
-  :push      the saved location used for `bzr push` with no arguments
-  :this      this branch
-
-For example, to push to the parent location::
-
-    bzr push :parent
-

=== modified file 'bzrlib/help_topics/en/log-formats.txt'
--- bzrlib/help_topics/en/log-formats.txt	2010-01-03 01:41:00 +0000
+++ bzrlib/help_topics/en/log-formats.txt	2009-02-09 08:19:18 +0000
@@ -1,4 +1,4 @@
-Log Formats
+Log formats
 ===========
 
 A log format controls how information about each revision is displayed.

=== modified file 'bzrlib/help_topics/en/patterns.txt'
--- bzrlib/help_topics/en/patterns.txt	2010-01-02 07:36:36 +0000
+++ bzrlib/help_topics/en/patterns.txt	2008-06-25 07:17:14 +0000
@@ -23,6 +23,3 @@
 patterns are identified by a 'RE:' prefix followed by the regular
 expression.  Regular expression patterns may not include named or
 numbered groups.
-
-Ignore patterns may be prefixed with '!', which means that a filename
-matched by that pattern will not be ignored.

=== modified file 'bzrlib/help_topics/en/rules.txt'
--- bzrlib/help_topics/en/rules.txt	2010-01-03 03:33:10 +0000
+++ bzrlib/help_topics/en/rules.txt	2009-04-26 03:04:30 +0000
@@ -16,9 +16,8 @@
 
 Preferences like these are useful for commands and plugins wishing to
 provide custom behaviour for selected files.  For more information on 
-end of line conversion see :doc:`eol-help`.
-Keyword support is provided by the `keywords plugin
-<http://doc.bazaar.canonical.com/plugins/en/keywords-plugin.html>`_.
+end of line conversion see ``bzr help eol``.  Keyword support is provided
+by the bzr-keywords plugin (http://launchpad.net/bzr-keywords).
 
 Files
 -----
@@ -32,9 +31,7 @@
 Patterns are ordered and searching stops as soon as one matches.
 As a consequence, more explicit patterns should be placed towards
 the top of the file. Rule patterns use exactly the same conventions
-as ignore patterns. See :doc:`patterns-help` for details.
-
-.. note::
-
-   Patterns containing square brackets or spaces should be
-   surrounded in quotes to ensure they are correctly parsed.
+as ignore patterns. See ``bzr help patterns`` for details.
+
+Note: Patterns containing square brackets or spaces should be
+surrounded in quotes to ensure they are correctly parsed.

=== removed directory 'bzrlib/help_topics/es'
=== added directory 'bzrlib/help_topics/es'
=== renamed file 'bzrlib/help_topics/es/conflict-types.txt' => 'bzrlib/help_topics/es/conflicts.txt'
=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-04-30 11:03:59 +0000
+++ bzrlib/hooks.py	2009-09-01 12:29:54 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 """Support for plugin hooking logic."""
 from bzrlib import registry
 from bzrlib.lazy_import import lazy_import
+from bzrlib.symbol_versioning import deprecated_method
 lazy_import(globals(), """
 import textwrap
 
@@ -44,8 +45,6 @@
     'bzrlib.info', 'InfoHooks')
 known_hooks.register_lazy(('bzrlib.lock', 'Lock.hooks'), 'bzrlib.lock',
     'LockHooks')
-known_hooks.register_lazy(('bzrlib.merge', 'Merger.hooks'), 'bzrlib.merge',
-    'MergeHooks')
 known_hooks.register_lazy(('bzrlib.msgeditor', 'hooks'), 'bzrlib.msgeditor',
     'MessageEditorHooks')
 known_hooks.register_lazy(('bzrlib.mutabletree', 'MutableTree.hooks'),
@@ -58,7 +57,7 @@
     ('bzrlib.version_info_formats.format_rio', 'RioVersionInfoBuilder.hooks'),
     'bzrlib.version_info_formats.format_rio', 'RioVersionInfoBuilderHooks')
 known_hooks.register_lazy(
-    ('bzrlib.merge_directive', 'BaseMergeDirective.hooks'),
+    ('bzrlib.merge_directive', '_BaseMergeDirective.hooks'),
     'bzrlib.merge_directive', 'MergeDirectiveHooks')
 
 
@@ -278,7 +277,7 @@
 
 See `Using hooks`_ in the User Guide for examples.
 
-.. _Using hooks: ../user-guide/hooks.html
+.. _Using hooks: ../user-guide/index.html#using-hooks
 
 The class that contains each hook is given before the hooks it supplies. For
 instance, BranchHooks as the class is the hooks class for

=== modified file 'bzrlib/identitymap.py'
--- bzrlib/identitymap.py	2010-04-30 11:03:59 +0000
+++ bzrlib/identitymap.py	2009-03-23 14:59:43 +0000
@@ -20,6 +20,7 @@
 
 from bzrlib import (
     errors,
+    osutils,
     )
 
 

=== modified file 'bzrlib/ignores.py'
--- bzrlib/ignores.py	2010-04-30 07:54:33 +0000
+++ bzrlib/ignores.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,7 +25,65 @@
     globbing,
     )
 
-from trace import warning
+# This was the full ignore list for bzr 0.8
+# please keep these sorted (in C locale order) to aid merging
+OLD_DEFAULTS = [
+    '#*#',
+    '*$',
+    '*,v',
+    '*.BAK',
+    '*.a',
+    '*.bak',
+    '*.elc',
+    '*.exe',
+    '*.la',
+    '*.lo',
+    '*.o',
+    '*.obj',
+    '*.orig',
+    '*.py[oc]',
+    '*.so',
+    '*.tmp',
+    '*~',
+    '.#*',
+    '.*.sw[nop]',
+    '.*.tmp',
+    # Our setup tests dump .python-eggs in the bzr source tree root
+    './.python-eggs',
+    '.DS_Store',
+    '.arch-ids',
+    '.arch-inventory',
+    '.bzr.log',
+    '.del-*',
+    '.git',
+    '.hg',
+    '.jamdeps'
+    '.libs',
+    '.make.state',
+    '.sconsign*',
+    '.svn',
+    '.sw[nop]',    # vim editing nameless file
+    '.tmp*',
+    'BitKeeper',
+    'CVS',
+    'CVS.adm',
+    'RCS',
+    'SCCS',
+    'TAGS',
+    '_darcs',
+    'aclocal.m4',
+    'autom4te*',
+    'config.h',
+    'config.h.in',
+    'config.log',
+    'config.status',
+    'config.sub',
+    'stamp-h',
+    'stamp-h.in',
+    'stamp-h1',
+    '{arch}',
+]
+
 
 # ~/.bazaar/ignore will be filled out using
 # this ignore list, if it does not exist
@@ -42,34 +100,10 @@
 ]
 
 
-
 def parse_ignore_file(f):
-    """Read in all of the lines in the file and turn it into an ignore list
-    
-    Continue in the case of utf8 decoding errors, and emit a warning when 
-    such and error is found. Optimise for the common case -- no decoding 
-    errors.
-    """
+    """Read in all of the lines in the file and turn it into an ignore list"""
     ignored = set()
-    ignore_file = f.read()
-    try:
-        # Try and parse whole ignore file at once.
-        unicode_lines = ignore_file.decode('utf8').split('\n')
-    except UnicodeDecodeError:
-        # Otherwise go though line by line and pick out the 'good'
-        # decodable lines
-        lines = ignore_file.split('\n')
-        unicode_lines = []
-        for line_number, line in enumerate(lines):
-            try:
-                unicode_lines.append(line.decode('utf-8'))
-            except UnicodeDecodeError:
-                # report error about line (idx+1)
-                warning('.bzrignore: On Line #%d, malformed utf8 character. '
-                        'Ignoring line.' % (line_number+1))
-
-    # Append each line to ignore list if it's not a comment line
-    for line in unicode_lines:
+    for line in f.read().decode('utf8').split('\n'):
         line = line.rstrip('\r\n')
         if not line or line.startswith('#'):
             continue
@@ -176,11 +210,10 @@
 
 
 def tree_ignores_add_patterns(tree, name_pattern_list):
-    """Add more ignore patterns to the ignore file in a tree.
-    If ignore file does not exist then it will be created.
-    The ignore file will be automatically added under version control.
+    """Retrieve a list of ignores from the ignore file in a tree.
 
-    :param tree: Working tree to update the ignore list.
+    :param tree: Tree to retrieve the ignore list from.
+    :return:
     """
     ifn = tree.abspath(bzrlib.IGNORE_FILENAME)
     if tree.has_filename(ifn):
@@ -207,5 +240,5 @@
     finally:
         f.close()
 
-    if not tree.path2id(bzrlib.IGNORE_FILENAME):
-        tree.add([bzrlib.IGNORE_FILENAME])
+    if not tree.path2id('.bzrignore'):
+        tree.add(['.bzrignore'])

=== modified file 'bzrlib/index.py'
--- bzrlib/index.py	2010-04-14 05:06:53 +0000
+++ bzrlib/index.py	2009-12-02 17:59:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -382,7 +382,7 @@
     suitable for production use. :XXX
     """
 
-    def __init__(self, transport, name, size, unlimited_cache=False, offset=0):
+    def __init__(self, transport, name, size, unlimited_cache=False):
         """Open an index called name on transport.
 
         :param transport: A bzrlib.transport.Transport.
@@ -394,8 +394,6 @@
             avoided by having it supplied. If size is None, then bisection
             support will be disabled and accessing the index will just stream
             all the data.
-        :param offset: Instead of starting the index data at offset 0, start it
-            at an arbitrary offset.
         """
         self._transport = transport
         self._name = name
@@ -418,7 +416,6 @@
         self._size = size
         # The number of bytes we've read so far in trying to process this file
         self._bytes_read = 0
-        self._base_offset = offset
 
     def __eq__(self, other):
         """Equal when self and other were created with the same parameters."""
@@ -447,10 +444,6 @@
             mutter('Reading entire index %s', self._transport.abspath(self._name))
         if stream is None:
             stream = self._transport.get(self._name)
-            if self._base_offset != 0:
-                # This is wasteful, but it is better than dealing with
-                # adjusting all the offsets, etc.
-                stream = StringIO(stream.read()[self._base_offset:])
         self._read_prefix(stream)
         self._expected_elements = 3 + self._key_length
         line_count = 0
@@ -1197,22 +1190,11 @@
             self._buffer_all()
             return
 
-        base_offset = self._base_offset
-        if base_offset != 0:
-            # Rewrite the ranges for the offset
-            readv_ranges = [(start+base_offset, size)
-                            for start, size in readv_ranges]
         readv_data = self._transport.readv(self._name, readv_ranges, True,
-            self._size + self._base_offset)
+            self._size)
         # parse
         for offset, data in readv_data:
-            offset -= base_offset
             self._bytes_read += len(data)
-            if offset < 0:
-                # transport.readv() expanded to extra data which isn't part of
-                # this index
-                data = data[-offset:]
-                offset = 0
             if offset == 0 and len(data) == self._size:
                 # We read the whole range, most likely because the
                 # Transport upcast our readv ranges into one long request
@@ -1245,15 +1227,10 @@
     static data.
 
     Queries against the combined index will be made against the first index,
-    and then the second and so on. The order of indices can thus influence
+    and then the second and so on. The order of index's can thus influence
     performance significantly. For example, if one index is on local disk and a
     second on a remote server, the local disk index should be before the other
     in the index list.
-    
-    Also, queries tend to need results from the same indices as previous
-    queries.  So the indices will be reordered after every query to put the
-    indices that had the result(s) of that query first (while otherwise
-    preserving the relative ordering).
     """
 
     def __init__(self, indices, reload_func=None):
@@ -1266,13 +1243,6 @@
         """
         self._indices = indices
         self._reload_func = reload_func
-        # Sibling indices are other CombinedGraphIndex that we should call
-        # _move_to_front_by_name on when we auto-reorder ourself.
-        self._sibling_indices = []
-        # A list of names that corresponds to the instances in self._indices,
-        # so _index_names[0] is always the name for _indices[0], etc.  Sibling
-        # indices must all use the same set of names as each other.
-        self._index_names = [None] * len(self._indices)
 
     def __repr__(self):
         return "%s(%s)" % (
@@ -1301,17 +1271,13 @@
 
     has_key = _has_key_from_parent_map
 
-    def insert_index(self, pos, index, name=None):
+    def insert_index(self, pos, index):
         """Insert a new index in the list of indices to query.
 
         :param pos: The position to insert the index.
         :param index: The index to insert.
-        :param name: a name for this index, e.g. a pack name.  These names can
-            be used to reflect index reorderings to related CombinedGraphIndex
-            instances that use the same names.  (see set_sibling_indices)
         """
         self._indices.insert(pos, index)
-        self._index_names.insert(pos, name)
 
     def iter_all_entries(self):
         """Iterate over all keys within the index
@@ -1342,28 +1308,22 @@
         value and are only reported once.
 
         :param keys: An iterable providing the keys to be retrieved.
-        :return: An iterable of (index, key, reference_lists, value). There is
-            no defined order for the result iteration - it will be in the most
+        :return: An iterable of (index, key, reference_lists, value). There is no
+            defined order for the result iteration - it will be in the most
             efficient order for the index.
         """
         keys = set(keys)
-        hit_indices = []
         while True:
             try:
                 for index in self._indices:
                     if not keys:
-                        break
-                    index_hit = False
+                        return
                     for node in index.iter_entries(keys):
                         keys.remove(node[1])
                         yield node
-                        index_hit = True
-                    if index_hit:
-                        hit_indices.append(index)
-                break
+                return
             except errors.NoSuchFile:
                 self._reload_or_raise()
-        self._move_to_front(hit_indices)
 
     def iter_entries_prefix(self, keys):
         """Iterate over keys within the index using prefix matching.
@@ -1389,89 +1349,17 @@
         if not keys:
             return
         seen_keys = set()
-        hit_indices = []
         while True:
             try:
                 for index in self._indices:
-                    index_hit = False
                     for node in index.iter_entries_prefix(keys):
                         if node[1] in seen_keys:
                             continue
                         seen_keys.add(node[1])
                         yield node
-                        index_hit = True
-                    if index_hit:
-                        hit_indices.append(index)
-                break
+                return
             except errors.NoSuchFile:
                 self._reload_or_raise()
-        self._move_to_front(hit_indices)
-
-    def _move_to_front(self, hit_indices):
-        """Rearrange self._indices so that hit_indices are first.
-
-        Order is maintained as much as possible, e.g. the first unhit index
-        will be the first index in _indices after the hit_indices, and the
-        hit_indices will be present in exactly the order they are passed to
-        _move_to_front.
-
-        _move_to_front propagates to all objects in self._sibling_indices by
-        calling _move_to_front_by_name.
-        """
-        if self._indices[:len(hit_indices)] == hit_indices:
-            # The 'hit_indices' are already at the front (and in the same
-            # order), no need to re-order
-            return
-        hit_names = self._move_to_front_by_index(hit_indices)
-        for sibling_idx in self._sibling_indices:
-            sibling_idx._move_to_front_by_name(hit_names)
-
-    def _move_to_front_by_index(self, hit_indices):
-        """Core logic for _move_to_front.
-        
-        Returns a list of names corresponding to the hit_indices param.
-        """
-        indices_info = zip(self._index_names, self._indices)
-        if 'index' in debug.debug_flags:
-            mutter('CombinedGraphIndex reordering: currently %r, promoting %r',
-                   indices_info, hit_indices)
-        hit_names = []
-        unhit_names = []
-        new_hit_indices = []
-        unhit_indices = []
-
-        for offset, (name, idx) in enumerate(indices_info):
-            if idx in hit_indices:
-                hit_names.append(name)
-                new_hit_indices.append(idx)
-                if len(new_hit_indices) == len(hit_indices):
-                    # We've found all of the hit entries, everything else is
-                    # unhit
-                    unhit_names.extend(self._index_names[offset+1:])
-                    unhit_indices.extend(self._indices[offset+1:])
-                    break
-            else:
-                unhit_names.append(name)
-                unhit_indices.append(idx)
-
-        self._indices = new_hit_indices + unhit_indices
-        self._index_names = hit_names + unhit_names
-        if 'index' in debug.debug_flags:
-            mutter('CombinedGraphIndex reordered: %r', self._indices)
-        return hit_names
-
-    def _move_to_front_by_name(self, hit_names):
-        """Moves indices named by 'hit_names' to front of the search order, as
-        described in _move_to_front.
-        """
-        # Translate names to index instances, and then call
-        # _move_to_front_by_index.
-        indices_info = zip(self._index_names, self._indices)
-        hit_indices = []
-        for name, idx in indices_info:
-            if name in hit_names:
-                hit_indices.append(idx)
-        self._move_to_front_by_index(hit_indices)
 
     def find_ancestry(self, keys, ref_list_num):
         """Find the complete ancestry for the given set of keys.
@@ -1484,7 +1372,6 @@
             we care about.
         :return: (parent_map, missing_keys)
         """
-        # XXX: make this call _move_to_front?
         missing_keys = set()
         parent_map = {}
         keys_to_lookup = set(keys)
@@ -1570,11 +1457,6 @@
                          ' Raising original exception.')
             raise exc_type, exc_value, exc_traceback
 
-    def set_sibling_indices(self, sibling_combined_graph_indices):
-        """Set the CombinedGraphIndex objects to reorder after reordering self.
-        """
-        self._sibling_indices = sibling_combined_graph_indices
-
     def validate(self):
         """Validate that everything in the index can be accessed."""
         while True:

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2010-04-30 11:35:43 +0000
+++ bzrlib/info.py	2009-11-03 09:32:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,11 +17,13 @@
 __all__ = ['show_bzrdir_info']
 
 from cStringIO import StringIO
+import os
 import time
 import sys
 
 from bzrlib import (
     bzrdir,
+    diff,
     errors,
     hooks as _mod_hooks,
     osutils,
@@ -78,9 +80,9 @@
 
 def gather_location_info(repository, branch=None, working=None):
     locs = {}
-    repository_path = repository.user_url
+    repository_path = repository.bzrdir.root_transport.base
     if branch is not None:
-        branch_path = branch.user_url
+        branch_path = branch.bzrdir.root_transport.base
         master_path = branch.get_bound_location()
         if master_path is None:
             master_path = branch_path
@@ -88,7 +90,7 @@
         branch_path = None
         master_path = None
     if working:
-        working_path = working.user_url
+        working_path = working.bzrdir.root_transport.base
         if working_path != branch_path:
             locs['light checkout root'] = working_path
         if master_path != branch_path:
@@ -418,8 +420,8 @@
         if branch is None and tree is not None:
             phrase = "branchless tree"
         else:
-            if (tree is not None and tree.user_url !=
-                branch.user_url):
+            if (tree is not None and tree.bzrdir.root_transport.base !=
+                branch.bzrdir.root_transport.base):
                 independence = ''
                 phrase = "Lightweight checkout"
             elif branch.get_bound_location() is not None:
@@ -444,7 +446,8 @@
     """
     candidates  = []
     if (branch is not None and tree is not None and
-        branch.user_url != tree.user_url):
+        branch.bzrdir.root_transport.base !=
+        tree.bzrdir.root_transport.base):
         branch = None
         repository = None
     non_aliases = set(bzrdir.format_registry.keys())

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2010-02-17 17:11:16 +0000
+++ bzrlib/inventory.py	2009-11-13 19:19:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2010-02-23 07:43:11 +0000
+++ bzrlib/knit.py	2009-11-30 21:21:07 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -73,7 +73,6 @@
     trace,
     tsort,
     tuned_gzip,
-    ui,
     )
 """)
 from bzrlib import (
@@ -1756,7 +1755,7 @@
         :return: An iterator over (line, key).
         """
         if pb is None:
-            pb = ui.ui_factory.nested_progress_bar()
+            pb = progress.DummyProgress()
         keys = set(keys)
         total = len(keys)
         done = False

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2010-04-16 07:56:51 +0000
+++ bzrlib/lock.py	2009-10-07 08:17:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -84,7 +84,7 @@
         return self.lock_url == other.lock_url and self.details == other.details
 
     def __repr__(self):
-        return '%s(%s, %s)' % (self.__class__.__name__,
+        return '%s(%s%s)' % (self.__class__.__name__,
                              self.lock_url, self.details)
 
 
@@ -200,7 +200,7 @@
 
             self._open(self.filename, 'rb+')
             # reserve a slot for this lock - even if the lockf call fails,
-            # at this point unlock() will be called, because self.f is set.
+            # at thisi point unlock() will be called, because self.f is set.
             # TODO: make this fully threadsafe, if we decide we care.
             _fcntl_WriteLock._open_locks.add(self.filename)
             try:

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2010-04-30 11:03:59 +0000
+++ bzrlib/lockable_files.py	2009-10-15 02:11:18 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from cStringIO import StringIO
+
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import codecs
@@ -32,6 +34,10 @@
 from bzrlib.decorators import (
     only_raises,
     )
+from bzrlib.symbol_versioning import (
+    deprecated_in,
+    deprecated_method,
+    )
 
 
 # XXX: The tracking here of lock counts and whether the lock is held is

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2010-03-03 22:59:21 +0000
+++ bzrlib/lockdir.py	2010-01-04 02:25:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -252,7 +252,7 @@
         if info is None:
             raise LockFailed(self, "lock was renamed into place, but "
                 "now is missing!")
-        if info.get('nonce') != self.nonce:
+        if info['nonce'] != self.nonce:
             self._trace("rename succeeded, "
                 "but lock is still held by someone else")
             raise LockContention(self)
@@ -430,7 +430,7 @@
     def peek(self):
         """Check if the lock is held by anyone.
 
-        If it is held, this returns the lock info structure as a dict
+        If it is held, this returns the lock info structure as a rio Stanza,
         which contains some information about the current lock holder.
         Otherwise returns None.
         """
@@ -459,14 +459,8 @@
         return s.to_string()
 
     def _parse_info(self, info_bytes):
-        stanza = rio.read_stanza(osutils.split_lines(info_bytes))
-        if stanza is None:
-            # see bug 185013; we fairly often end up with the info file being
-            # empty after an interruption; we could log a message here but
-            # there may not be much we can say
-            return {}
-        else:
-            return stanza.as_dict()
+        # TODO: Handle if info_bytes is empty
+        return rio.read_stanza(osutils.split_lines(info_bytes)).as_dict()
 
     def attempt_lock(self):
         """Take the lock; fail if it's already held.
@@ -540,22 +534,19 @@
                     deadline_str = time.strftime('%H:%M:%S',
                                                  time.localtime(deadline))
                 lock_url = self.transport.abspath(self.path)
-                # See <https://bugs.edge.launchpad.net/bzr/+bug/250451>
-                # the URL here is sometimes not one that is useful to the
-                # user, perhaps being wrapped in a lp-%d or chroot decorator,
-                # especially if this error is issued from the server.
                 self._report_function('%s %s\n'
-                    '%s\n' # held by
-                    '%s\n' # locked ... ago
-                    'Will continue to try until %s, unless '
-                    'you press Ctrl-C.\n'
-                    'See "bzr help break-lock" for more.',
-                    start,
-                    formatted_info[0],
-                    formatted_info[1],
-                    formatted_info[2],
-                    deadline_str,
-                    )
+                                      '%s\n' # held by
+                                      '%s\n' # locked ... ago
+                                      'Will continue to try until %s, unless '
+                                      'you press Ctrl-C\n'
+                                      'If you\'re sure that it\'s not being '
+                                      'modified, use bzr break-lock %s',
+                                      start,
+                                      formatted_info[0],
+                                      formatted_info[1],
+                                      formatted_info[2],
+                                      deadline_str,
+                                      lock_url)
 
             if (max_attempts is not None) and (attempt_count >= max_attempts):
                 self._trace("exceeded %d attempts")
@@ -617,16 +608,11 @@
     def _format_lock_info(self, info):
         """Turn the contents of peek() into something for the user"""
         lock_url = self.transport.abspath(self.path)
-        start_time = info.get('start_time')
-        if start_time is None:
-            time_ago = '(unknown)'
-        else:
-            time_ago = format_delta(time.time() - int(info['start_time']))
+        delta = time.time() - int(info['start_time'])
         return [
             'lock %s' % (lock_url,),
-            'held by %s on host %s [process #%s]' %
-                tuple([info.get(x, '<unknown>') for x in ['user', 'hostname', 'pid']]),
-            'locked %s' % (time_ago,),
+            'held by %(user)s on host %(hostname)s [process #%(pid)s]' % info,
+            'locked %s' % (format_delta(delta),),
             ]
 
     def validate_token(self, token):

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2010-04-14 12:30:17 +0000
+++ bzrlib/log.py	2009-12-09 05:47:32 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -88,10 +88,6 @@
     re_compile_checked,
     terminal_width,
     )
-from bzrlib.symbol_versioning import (
-    deprecated_function,
-    deprecated_in,
-    )
 
 
 def find_touching_revisions(branch, file_id):
@@ -109,7 +105,7 @@
     last_path = None
     revno = 1
     for revision_id in branch.revision_history():
-        this_inv = branch.repository.get_inventory(revision_id)
+        this_inv = branch.repository.get_revision_inventory(revision_id)
         if file_id in this_inv:
             this_ie = this_inv[file_id]
             this_path = this_inv.id2path(file_id)
@@ -220,18 +216,14 @@
     'direction': 'reverse',
     'levels': 1,
     'generate_tags': True,
-    'exclude_common_ancestry': False,
     '_match_using_deltas': True,
     }
 
 
 def make_log_request_dict(direction='reverse', specific_fileids=None,
-                          start_revision=None, end_revision=None, limit=None,
-                          message_search=None, levels=1, generate_tags=True,
-                          delta_type=None,
-                          diff_type=None, _match_using_deltas=True,
-                          exclude_common_ancestry=False,
-                          ):
+    start_revision=None, end_revision=None, limit=None,
+    message_search=None, levels=1, generate_tags=True, delta_type=None,
+    diff_type=None, _match_using_deltas=True):
     """Convenience function for making a logging request dictionary.
 
     Using this function may make code slightly safer by ensuring
@@ -275,9 +267,6 @@
       algorithm used for matching specific_fileids. This parameter
       may be removed in the future so bzrlib client code should NOT
       use it.
-
-    :param exclude_common_ancestry: Whether -rX..Y should be interpreted as a
-      range operator or as a graph difference.
     """
     return {
         'direction': direction,
@@ -290,7 +279,6 @@
         'generate_tags': generate_tags,
         'delta_type': delta_type,
         'diff_type': diff_type,
-        'exclude_common_ancestry': exclude_common_ancestry,
         # Add 'private' attributes for features that may be deprecated
         '_match_using_deltas': _match_using_deltas,
     }
@@ -316,7 +304,7 @@
 
 
 class Logger(object):
-    """An object that generates, formats and displays a log."""
+    """An object the generates, formats and displays a log."""
 
     def __init__(self, branch, rqst):
         """Create a Logger.
@@ -463,12 +451,9 @@
         generate_merge_revisions = rqst.get('levels') != 1
         delayed_graph_generation = not rqst.get('specific_fileids') and (
                 rqst.get('limit') or self.start_rev_id or self.end_rev_id)
-        view_revisions = _calc_view_revisions(
-            self.branch, self.start_rev_id, self.end_rev_id,
-            rqst.get('direction'),
-            generate_merge_revisions=generate_merge_revisions,
-            delayed_graph_generation=delayed_graph_generation,
-            exclude_common_ancestry=rqst.get('exclude_common_ancestry'))
+        view_revisions = _calc_view_revisions(self.branch, self.start_rev_id,
+            self.end_rev_id, rqst.get('direction'), generate_merge_revisions,
+            delayed_graph_generation=delayed_graph_generation)
 
         # Apply the other filters
         return make_log_rev_iterator(self.branch, view_revisions,
@@ -481,10 +466,8 @@
         # Note that we always generate the merge revisions because
         # filter_revisions_touching_file_id() requires them ...
         rqst = self.rqst
-        view_revisions = _calc_view_revisions(
-            self.branch, self.start_rev_id, self.end_rev_id,
-            rqst.get('direction'), generate_merge_revisions=True,
-            exclude_common_ancestry=rqst.get('exclude_common_ancestry'))
+        view_revisions = _calc_view_revisions(self.branch, self.start_rev_id,
+            self.end_rev_id, rqst.get('direction'), True)
         if not isinstance(view_revisions, list):
             view_revisions = list(view_revisions)
         view_revisions = _filter_revisions_touching_file_id(self.branch,
@@ -495,43 +478,29 @@
 
 
 def _calc_view_revisions(branch, start_rev_id, end_rev_id, direction,
-                         generate_merge_revisions,
-                         delayed_graph_generation=False,
-                         exclude_common_ancestry=False,
-                         ):
+    generate_merge_revisions, delayed_graph_generation=False):
     """Calculate the revisions to view.
 
     :return: An iterator of (revision_id, dotted_revno, merge_depth) tuples OR
              a list of the same tuples.
     """
-    if (exclude_common_ancestry and start_rev_id == end_rev_id):
-        raise errors.BzrCommandError(
-            '--exclude-common-ancestry requires two different revisions')
-    if direction not in ('reverse', 'forward'):
-        raise ValueError('invalid direction %r' % direction)
     br_revno, br_rev_id = branch.last_revision_info()
     if br_revno == 0:
         return []
 
-    if (end_rev_id and start_rev_id == end_rev_id
-        and (not generate_merge_revisions
-             or not _has_merges(branch, end_rev_id))):
-        # If a single revision is requested, check we can handle it
-        iter_revs = _generate_one_revision(branch, end_rev_id, br_rev_id,
-                                           br_revno)
-    elif not generate_merge_revisions:
-        # If we only want to see linear revisions, we can iterate ...
-        iter_revs = _generate_flat_revisions(branch, start_rev_id, end_rev_id,
-                                             direction)
-        if direction == 'forward':
-            iter_revs = reversed(iter_revs)
+    # If a single revision is requested, check we can handle it
+    generate_single_revision = (end_rev_id and start_rev_id == end_rev_id and
+        (not generate_merge_revisions or not _has_merges(branch, end_rev_id)))
+    if generate_single_revision:
+        return _generate_one_revision(branch, end_rev_id, br_rev_id, br_revno)
+
+    # If we only want to see linear revisions, we can iterate ...
+    if not generate_merge_revisions:
+        return _generate_flat_revisions(branch, start_rev_id, end_rev_id,
+            direction)
     else:
-        iter_revs = _generate_all_revisions(branch, start_rev_id, end_rev_id,
-                                            direction, delayed_graph_generation,
-                                            exclude_common_ancestry)
-        if direction == 'forward':
-            iter_revs = _rebase_merge_depth(reverse_by_depth(list(iter_revs)))
-    return iter_revs
+        return _generate_all_revisions(branch, start_rev_id, end_rev_id,
+            direction, delayed_graph_generation)
 
 
 def _generate_one_revision(branch, rev_id, br_rev_id, br_revno):
@@ -555,56 +524,40 @@
         except _StartNotLinearAncestor:
             raise errors.BzrCommandError('Start revision not found in'
                 ' left-hand history of end revision.')
+    if direction == 'forward':
+        result = reversed(result)
     return result
 
 
 def _generate_all_revisions(branch, start_rev_id, end_rev_id, direction,
-                            delayed_graph_generation,
-                            exclude_common_ancestry=False):
+    delayed_graph_generation):
     # On large trees, generating the merge graph can take 30-60 seconds
     # so we delay doing it until a merge is detected, incrementally
     # returning initial (non-merge) revisions while we can.
-
-    # The above is only true for old formats (<= 0.92), for newer formats, a
-    # couple of seconds only should be needed to load the whole graph and the
-    # other graph operations needed are even faster than that -- vila 100201
     initial_revisions = []
     if delayed_graph_generation:
         try:
-            for rev_id, revno, depth in  _linear_view_revisions(
-                branch, start_rev_id, end_rev_id):
+            for rev_id, revno, depth in \
+                _linear_view_revisions(branch, start_rev_id, end_rev_id):
                 if _has_merges(branch, rev_id):
-                    # The end_rev_id can be nested down somewhere. We need an
-                    # explicit ancestry check. There is an ambiguity here as we
-                    # may not raise _StartNotLinearAncestor for a revision that
-                    # is an ancestor but not a *linear* one. But since we have
-                    # loaded the graph to do the check (or calculate a dotted
-                    # revno), we may as well accept to show the log...  We need
-                    # the check only if start_rev_id is not None as all
-                    # revisions have _mod_revision.NULL_REVISION as an ancestor
-                    # -- vila 20100319
-                    graph = branch.repository.get_graph()
-                    if (start_rev_id is not None
-                        and not graph.is_ancestor(start_rev_id, end_rev_id)):
-                        raise _StartNotLinearAncestor()
-                    # Since we collected the revisions so far, we need to
-                    # adjust end_rev_id.
                     end_rev_id = rev_id
                     break
                 else:
                     initial_revisions.append((rev_id, revno, depth))
             else:
                 # No merged revisions found
-                return initial_revisions
+                if direction == 'reverse':
+                    return initial_revisions
+                elif direction == 'forward':
+                    return reversed(initial_revisions)
+                else:
+                    raise ValueError('invalid direction %r' % direction)
         except _StartNotLinearAncestor:
             # A merge was never detected so the lower revision limit can't
             # be nested down somewhere
             raise errors.BzrCommandError('Start revision not found in'
                 ' history of end revision.')
 
-    # We exit the loop above because we encounter a revision with merges, from
-    # this revision, we need to switch to _graph_view_revisions.
-
     # A log including nested merges is required. If the direction is reverse,
     # we rebase the initial merge depths so that the development line is
     # shown naturally, i.e. just like it is for linear logging. We can easily
@@ -612,9 +565,15 @@
     # indented at the end seems slightly nicer in that case.
     view_revisions = chain(iter(initial_revisions),
         _graph_view_revisions(branch, start_rev_id, end_rev_id,
-                              rebase_initial_depths=(direction == 'reverse'),
-                              exclude_common_ancestry=exclude_common_ancestry))
-    return view_revisions
+        rebase_initial_depths=direction == 'reverse'))
+    if direction == 'reverse':
+        return view_revisions
+    elif direction == 'forward':
+        # Forward means oldest first, adjusting for depth.
+        view_revisions = reverse_by_depth(list(view_revisions))
+        return _rebase_merge_depth(view_revisions)
+    else:
+        raise ValueError('invalid direction %r' % direction)
 
 
 def _has_merges(branch, rev_id):
@@ -638,8 +597,6 @@
         else:
             # not obvious
             return False
-    # if either start or end is not specified then we use either the first or
-    # the last revision and *they* are obvious ancestors.
     return True
 
 
@@ -678,8 +635,7 @@
 
 
 def _graph_view_revisions(branch, start_rev_id, end_rev_id,
-                          rebase_initial_depths=True,
-                          exclude_common_ancestry=False):
+    rebase_initial_depths=True):
     """Calculate revisions to view including merges, newest to oldest.
 
     :param branch: the branch
@@ -689,13 +645,9 @@
       revision is found?
     :return: An iterator of (revision_id, dotted_revno, merge_depth) tuples.
     """
-    if exclude_common_ancestry:
-        stop_rule = 'with-merges-without-common-ancestry'
-    else:
-        stop_rule = 'with-merges'
     view_revisions = branch.iter_merge_sorted_revisions(
         start_revision_id=end_rev_id, stop_revision_id=start_rev_id,
-        stop_rule=stop_rule)
+        stop_rule="with-merges")
     if not rebase_initial_depths:
         for (rev_id, merge_depth, revno, end_of_merge
              ) in view_revisions:
@@ -712,16 +664,11 @@
                 depth_adjustment = merge_depth
             if depth_adjustment:
                 if merge_depth < depth_adjustment:
-                    # From now on we reduce the depth adjustement, this can be
-                    # surprising for users. The alternative requires two passes
-                    # which breaks the fast display of the first revision
-                    # though.
                     depth_adjustment = merge_depth
                 merge_depth -= depth_adjustment
             yield rev_id, '.'.join(map(str, revno)), merge_depth
 
 
-@deprecated_function(deprecated_in((2, 2, 0)))
 def calculate_view_revisions(branch, start_revision, end_revision, direction,
         specific_fileid, generate_merge_revisions):
     """Calculate the revisions to view.
@@ -729,6 +676,9 @@
     :return: An iterator of (revision_id, dotted_revno, merge_depth) tuples OR
              a list of the same tuples.
     """
+    # This method is no longer called by the main code path.
+    # It is retained for API compatibility and may be deprecated
+    # soon. IGC 20090116
     start_rev_id, end_rev_id = _get_revision_limits(branch, start_revision,
         end_revision)
     view_revisions = list(_calc_view_revisions(branch, start_rev_id, end_rev_id,
@@ -1084,7 +1034,6 @@
     return mainline_revs, rev_nos, start_rev_id, end_rev_id
 
 
-@deprecated_function(deprecated_in((2, 2, 0)))
 def _filter_revision_range(view_revisions, start_rev_id, end_rev_id):
     """Filter view_revisions based on revision ranges.
 
@@ -1099,6 +1048,8 @@
 
     :return: The filtered view_revisions.
     """
+    # This method is no longer called by the main code path.
+    # It may be removed soon. IGC 20090127
     if start_rev_id or end_rev_id:
         revision_ids = [r for r, n, d in view_revisions]
         if start_rev_id:
@@ -1210,13 +1161,15 @@
     return result
 
 
-@deprecated_function(deprecated_in((2, 2, 0)))
 def get_view_revisions(mainline_revs, rev_nos, branch, direction,
                        include_merges=True):
     """Produce an iterator of revisions to show
     :return: an iterator of (revision_id, revno, merge_depth)
     (if there is no revno for a revision, None is supplied)
     """
+    # This method is no longer called by the main code path.
+    # It is retained for API compatibility and may be deprecated
+    # soon. IGC 20090127
     if not include_merges:
         revision_ids = mainline_revs[1:]
         if direction == 'reverse':
@@ -1340,8 +1293,8 @@
     preferred_levels = 0
 
     def __init__(self, to_file, show_ids=False, show_timezone='original',
-                 delta_format=None, levels=None, show_advice=False,
-                 to_exact_file=None):
+            delta_format=None, levels=None, show_advice=False,
+            to_exact_file=None):
         """Create a LogFormatter.
 
         :param to_file: the file to output to
@@ -1452,8 +1405,7 @@
         """
         # Revision comes directly from a foreign repository
         if isinstance(rev, foreign.ForeignRevision):
-            return self._format_properties(
-                rev.mapping.vcs.show_foreign_revid(rev.foreign_revid))
+            return rev.mapping.vcs.show_foreign_revid(rev.foreign_revid)
 
         # Imported foreign revision revision ids always contain :
         if not ":" in rev.revision_id:
@@ -1546,10 +1498,9 @@
         to_file = self.to_file
         to_file.write("%s%s\n" % (indent, ('\n' + indent).join(lines)))
         if revision.delta is not None:
-            # Use the standard status output to display changes
-            from bzrlib.delta import report_delta
-            report_delta(to_file, revision.delta, short_status=False, 
-                         show_ids=self.show_ids, indent=indent)
+            # We don't respect delta_format for compatibility
+            revision.delta.show(to_file, self.show_ids, indent=indent,
+                                short_status=False)
         if revision.diff is not None:
             to_file.write(indent + 'diff:\n')
             to_file.flush()
@@ -1618,11 +1569,8 @@
                 to_file.write(indent + offset + '%s\n' % (l,))
 
         if revision.delta is not None:
-            # Use the standard status output to display changes
-            from bzrlib.delta import report_delta
-            report_delta(to_file, revision.delta, 
-                         short_status=self.delta_format==1, 
-                         show_ids=self.show_ids, indent=indent + offset)
+            revision.delta.show(to_file, self.show_ids, indent=indent + offset,
+                                short_status=self.delta_format==1)
         if revision.diff is not None:
             self.show_diff(self.to_exact_file, revision.diff, '      ')
         to_file.write('\n')
@@ -1703,7 +1651,7 @@
                                self.show_timezone,
                                date_fmt='%Y-%m-%d',
                                show_offset=False)
-        committer_str = revision.rev.get_apparent_authors()[0].replace (' <', '  <')
+        committer_str = revision.rev.committer.replace (' <', '  <')
         to_file.write('%s  %s\n\n' % (date_str,committer_str))
 
         if revision.delta is not None and revision.delta.has_changed():
@@ -2032,21 +1980,6 @@
 
 properties_handler_registry = registry.Registry()
 
-# Use the properties handlers to print out bug information if available
-def _bugs_properties_handler(revision):
-    if revision.properties.has_key('bugs'):
-        bug_lines = revision.properties['bugs'].split('\n')
-        bug_rows = [line.split(' ', 1) for line in bug_lines]
-        fixed_bug_urls = [row[0] for row in bug_rows if
-                          len(row) > 1 and row[1] == 'fixed']
-
-        if fixed_bug_urls:
-            return {'fixes bug(s)': ' '.join(fixed_bug_urls)}
-    return {}
-
-properties_handler_registry.register('bugs_properties_handler',
-                                     _bugs_properties_handler)
-
 
 # adapters which revision ids to log are filtered. When log is called, the
 # log_rev_iterator is adapted through each of these factory methods.

=== modified file 'bzrlib/mail_client.py'
--- bzrlib/mail_client.py	2010-04-23 08:51:52 +0000
+++ bzrlib/mail_client.py	2009-09-24 19:51:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -89,7 +89,7 @@
 
 
 class Editor(MailClient):
-    __doc__ = """DIY mail client that uses commit message editor"""
+    """DIY mail client that uses commit message editor"""
 
     supports_body = True
 
@@ -230,13 +230,13 @@
 
 
 class ExternalMailClient(BodyExternalMailClient):
-    __doc__ = """An external mail client."""
+    """An external mail client."""
 
     supports_body = False
 
 
 class Evolution(BodyExternalMailClient):
-    __doc__ = """Evolution mail client."""
+    """Evolution mail client."""
 
     _client_commands = ['evolution']
 
@@ -258,7 +258,7 @@
 
 
 class Mutt(BodyExternalMailClient):
-    __doc__ = """Mutt mail client."""
+    """Mutt mail client."""
 
     _client_commands = ['mutt']
 
@@ -286,7 +286,7 @@
 
 
 class Thunderbird(BodyExternalMailClient):
-    __doc__ = """Mozilla Thunderbird (or Icedove)
+    """Mozilla Thunderbird (or Icedove)
 
     Note that Thunderbird 1.5 is buggy and does not support setting
     "to" simultaneously with including a attachment.
@@ -321,7 +321,7 @@
 
 
 class KMail(ExternalMailClient):
-    __doc__ = """KDE mail client."""
+    """KDE mail client."""
 
     _client_commands = ['kmail']
 
@@ -341,7 +341,7 @@
 
 
 class Claws(ExternalMailClient):
-    __doc__ = """Claws mail client."""
+    """Claws mail client."""
 
     supports_body = True
 
@@ -387,7 +387,7 @@
 
 
 class XDGEmail(BodyExternalMailClient):
-    __doc__ = """xdg-email attempts to invoke the user's preferred mail client"""
+    """xdg-email attempts to invoke the user's preferred mail client"""
 
     _client_commands = ['xdg-email']
 
@@ -409,7 +409,7 @@
 
 
 class EmacsMail(ExternalMailClient):
-    __doc__ = """Call emacsclient to have a mail buffer.
+    """Call emacsclient to have a mail buffer.
 
     This only work for emacs >= 22.1 due to recent -e/--eval support.
 
@@ -519,7 +519,7 @@
 
 
 class MAPIClient(BodyExternalMailClient):
-    __doc__ = """Default Windows mail client launched using MAPI."""
+    """Default Windows mail client launched using MAPI."""
 
     def _compose(self, prompt, to, subject, attach_path, mime_subtype,
                  extension, body=None):
@@ -540,7 +540,7 @@
 
 
 class MailApp(BodyExternalMailClient):
-    __doc__ = """Use MacOS X's Mail.app for sending email messages.
+    """Use MacOS X's Mail.app for sending email messages.
 
     Although it would be nice to use appscript, it's not installed
     with the shipped Python installations.  We instead build an
@@ -599,7 +599,7 @@
 
 
 class DefaultMail(MailClient):
-    __doc__ = """Default mail handling.  Tries XDGEmail (or MAPIClient on Windows),
+    """Default mail handling.  Tries XDGEmail (or MAPIClient on Windows),
     falls back to Editor"""
 
     supports_body = True

=== modified file 'bzrlib/memorytree.py'
--- bzrlib/memorytree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/memorytree.py	2009-04-09 20:23:07 +0000
@@ -25,9 +25,10 @@
 from bzrlib import (
     errors,
     mutabletree,
+    osutils,
     revision as _mod_revision,
     )
-from bzrlib.decorators import needs_read_lock
+from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.osutils import sha_file
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.transport.memory import MemoryTransport

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-05-03 04:08:50 +0000
+++ bzrlib/merge.py	2009-12-18 08:22:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,19 +14,17 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-import warnings
 
 from bzrlib import (
     branch as _mod_branch,
     conflicts as _mod_conflicts,
     debug,
-    decorators,
     errors,
     graph as _mod_graph,
-    hooks,
     merge3,
     osutils,
     patiencediff,
+    progress,
     revision as _mod_revision,
     textfile,
     trace,
@@ -36,7 +34,6 @@
     ui,
     versionedfile
     )
-from bzrlib.cleanup import OperationWithCleanups
 from bzrlib.symbol_versioning import (
     deprecated_in,
     deprecated_method,
@@ -46,218 +43,14 @@
 
 def transform_tree(from_tree, to_tree, interesting_ids=None):
     from_tree.lock_tree_write()
-    operation = OperationWithCleanups(merge_inner)
-    operation.add_cleanup(from_tree.unlock)
-    operation.run_simple(from_tree.branch, to_tree, from_tree,
-        ignore_zero=True, interesting_ids=interesting_ids, this_tree=from_tree)
-
-
-class MergeHooks(hooks.Hooks):
-
-    def __init__(self):
-        hooks.Hooks.__init__(self)
-        self.create_hook(hooks.HookPoint('merge_file_content',
-            "Called with a bzrlib.merge.Merger object to create a per file "
-            "merge object when starting a merge. "
-            "Should return either None or a subclass of "
-            "``bzrlib.merge.AbstractPerFileMerger``. "
-            "Such objects will then be called per file "
-            "that needs to be merged (including when one "
-            "side has deleted the file and the other has changed it). "
-            "See the AbstractPerFileMerger API docs for details on how it is "
-            "used by merge.",
-            (2, 1), None))
-
-
-class AbstractPerFileMerger(object):
-    """PerFileMerger objects are used by plugins extending merge for bzrlib.
-
-    See ``bzrlib.plugins.news_merge.news_merge`` for an example concrete class.
-    
-    :ivar merger: The Merge3Merger performing the merge.
-    """
-
-    def __init__(self, merger):
-        """Create a PerFileMerger for use with merger."""
-        self.merger = merger
-
-    def merge_contents(self, merge_params):
-        """Attempt to merge the contents of a single file.
-        
-        :param merge_params: A bzrlib.merge.MergeHookParams
-        :return : A tuple of (status, chunks), where status is one of
-            'not_applicable', 'success', 'conflicted', or 'delete'.  If status
-            is 'success' or 'conflicted', then chunks should be an iterable of
-            strings for the new file contents.
-        """
-        return ('not applicable', None)
-
-
-class PerFileMerger(AbstractPerFileMerger):
-    """Merge individual files when self.file_matches returns True.
-
-    This class is intended to be subclassed.  The file_matches and
-    merge_matching methods should be overridden with concrete implementations.
-    """
-
-    def file_matches(self, params):
-        """Return True if merge_matching should be called on this file.
-
-        Only called with merges of plain files with no clear winner.
-
-        Subclasses must override this.
-        """
-        raise NotImplementedError(self.file_matches)
-
-    def get_filename(self, params, tree):
-        """Lookup the filename (i.e. basename, not path), given a Tree (e.g.
-        self.merger.this_tree) and a MergeHookParams.
-        """
-        return osutils.basename(tree.id2path(params.file_id))
-
-    def get_filepath(self, params, tree):
-        """Calculate the path to the file in a tree.
-
-        :param params: A MergeHookParams describing the file to merge
-        :param tree: a Tree, e.g. self.merger.this_tree.
-        """
-        return tree.id2path(params.file_id)
-
-    def merge_contents(self, params):
-        """Merge the contents of a single file."""
-        # Check whether this custom merge logic should be used.
-        if (
-            # OTHER is a straight winner, rely on default merge.
-            params.winner == 'other' or
-            # THIS and OTHER aren't both files.
-            not params.is_file_merge() or
-            # The filename doesn't match *.xml
-            not self.file_matches(params)):
-            return 'not_applicable', None
-        return self.merge_matching(params)
-
-    def merge_matching(self, params):
-        """Merge the contents of a single file that has matched the criteria
-        in PerFileMerger.merge_contents (is a conflict, is a file,
-        self.file_matches is True).
-
-        Subclasses must override this.
-        """
-        raise NotImplementedError(self.merge_matching)
-
-
-class ConfigurableFileMerger(PerFileMerger):
-    """Merge individual files when configured via a .conf file.
-
-    This is a base class for concrete custom file merging logic. Concrete
-    classes should implement ``merge_text``.
-
-    See ``bzrlib.plugins.news_merge.news_merge`` for an example concrete class.
-    
-    :ivar affected_files: The configured file paths to merge.
-
-    :cvar name_prefix: The prefix to use when looking up configuration
-        details. <name_prefix>_merge_files describes the files targeted by the
-        hook for example.
-        
-    :cvar default_files: The default file paths to merge when no configuration
-        is present.
-    """
-
-    name_prefix = None
-    default_files = None
-
-    def __init__(self, merger):
-        super(ConfigurableFileMerger, self).__init__(merger)
-        self.affected_files = None
-        self.default_files = self.__class__.default_files or []
-        self.name_prefix = self.__class__.name_prefix
-        if self.name_prefix is None:
-            raise ValueError("name_prefix must be set.")
-
-    def file_matches(self, params):
-        """Check whether the file should call the merge hook.
-
-        <name_prefix>_merge_files configuration variable is a list of files
-        that should use the hook.
-        """
-        affected_files = self.affected_files
-        if affected_files is None:
-            config = self.merger.this_branch.get_config()
-            # Until bzr provides a better policy for caching the config, we
-            # just add the part we're interested in to the params to avoid
-            # reading the config files repeatedly (bazaar.conf, location.conf,
-            # branch.conf).
-            config_key = self.name_prefix + '_merge_files'
-            affected_files = config.get_user_option_as_list(config_key)
-            if affected_files is None:
-                # If nothing was specified in the config, use the default.
-                affected_files = self.default_files
-            self.affected_files = affected_files
-        if affected_files:
-            filepath = self.get_filepath(params, self.merger.this_tree)
-            if filepath in affected_files:
-                return True
-        return False
-
-    def merge_matching(self, params):
-        return self.merge_text(params)
-
-    def merge_text(self, params):
-        """Merge the byte contents of a single file.
-
-        This is called after checking that the merge should be performed in
-        merge_contents, and it should behave as per
-        ``bzrlib.merge.AbstractPerFileMerger.merge_contents``.
-        """
-        raise NotImplementedError(self.merge_text)
-
-
-class MergeHookParams(object):
-    """Object holding parameters passed to merge_file_content hooks.
-
-    There are some fields hooks can access:
-
-    :ivar file_id: the file ID of the file being merged
-    :ivar trans_id: the transform ID for the merge of this file
-    :ivar this_kind: kind of file_id in 'this' tree
-    :ivar other_kind: kind of file_id in 'other' tree
-    :ivar winner: one of 'this', 'other', 'conflict'
-    """
-
-    def __init__(self, merger, file_id, trans_id, this_kind, other_kind,
-            winner):
-        self._merger = merger
-        self.file_id = file_id
-        self.trans_id = trans_id
-        self.this_kind = this_kind
-        self.other_kind = other_kind
-        self.winner = winner
-
-    def is_file_merge(self):
-        """True if this_kind and other_kind are both 'file'."""
-        return self.this_kind == 'file' and self.other_kind == 'file'
-
-    @decorators.cachedproperty
-    def base_lines(self):
-        """The lines of the 'base' version of the file."""
-        return self._merger.get_lines(self._merger.base_tree, self.file_id)
-
-    @decorators.cachedproperty
-    def this_lines(self):
-        """The lines of the 'this' version of the file."""
-        return self._merger.get_lines(self._merger.this_tree, self.file_id)
-
-    @decorators.cachedproperty
-    def other_lines(self):
-        """The lines of the 'other' version of the file."""
-        return self._merger.get_lines(self._merger.other_tree, self.file_id)
+    try:
+        merge_inner(from_tree.branch, to_tree, from_tree, ignore_zero=True,
+                    interesting_ids=interesting_ids, this_tree=from_tree)
+    finally:
+        from_tree.unlock()
 
 
 class Merger(object):
-
-    hooks = MergeHooks()
-
     def __init__(self, this_branch, other_tree=None, base_tree=None,
                  this_tree=None, pb=None, change_reporter=None,
                  recurse='down', revision_graph=None):
@@ -278,8 +71,9 @@
         self.interesting_files = None
         self.show_base = False
         self.reprocess = False
-        if pb is not None:
-            warnings.warn("pb parameter to Merger() is deprecated and ignored")
+        if pb is None:
+            pb = progress.DummyProgress()
+        self._pb = pb
         self.pp = None
         self.recurse = recurse
         self.change_reporter = change_reporter
@@ -495,7 +289,6 @@
     def _add_parent(self):
         new_parents = self.this_tree.get_parent_ids() + [self.other_rev_id]
         new_parent_trees = []
-        operation = OperationWithCleanups(self.this_tree.set_parent_trees)
         for revision_id in new_parents:
             try:
                 tree = self.revision_tree(revision_id)
@@ -503,9 +296,14 @@
                 tree = None
             else:
                 tree.lock_read()
-                operation.add_cleanup(tree.unlock)
             new_parent_trees.append((revision_id, tree))
-        operation.run_simple(new_parent_trees, allow_leftmost_as_ghost=True)
+        try:
+            self.this_tree.set_parent_trees(new_parent_trees,
+                                            allow_leftmost_as_ghost=True)
+        finally:
+            for _revision_id, tree in new_parent_trees:
+                if tree is not None:
+                    tree.unlock()
 
     def set_other(self, other_revision, possible_transports=None):
         """Set the revision and tree to merge from.
@@ -634,7 +432,7 @@
                   'other_tree': self.other_tree,
                   'interesting_ids': self.interesting_ids,
                   'interesting_files': self.interesting_files,
-                  'this_branch': self.this_branch,
+                  'pp': self.pp,
                   'do_merge': False}
         if self.merge_type.requires_base:
             kwargs['base_tree'] = self.base_tree
@@ -658,12 +456,11 @@
         if self._is_criss_cross and getattr(self.merge_type,
                                             'supports_lca_trees', False):
             kwargs['lca_trees'] = self._lca_trees
-        return self.merge_type(pb=None,
+        return self.merge_type(pb=self._pb,
                                change_reporter=self.change_reporter,
                                **kwargs)
 
-    def _do_merge_to(self):
-        merge = self.make_merger()
+    def _do_merge_to(self, merge):
         if self.other_branch is not None:
             self.other_branch.update_references(self.this_branch)
         merge.do_merge()
@@ -683,19 +480,26 @@
                     sub_tree.branch.repository.revision_tree(base_revision)
                 sub_merge.base_rev_id = base_revision
                 sub_merge.do_merge()
-        return merge
 
     def do_merge(self):
-        operation = OperationWithCleanups(self._do_merge_to)
         self.this_tree.lock_tree_write()
-        operation.add_cleanup(self.this_tree.unlock)
-        if self.base_tree is not None:
-            self.base_tree.lock_read()
-            operation.add_cleanup(self.base_tree.unlock)
-        if self.other_tree is not None:
-            self.other_tree.lock_read()
-            operation.add_cleanup(self.other_tree.unlock)
-        merge = operation.run_simple()
+        try:
+            if self.base_tree is not None:
+                self.base_tree.lock_read()
+            try:
+                if self.other_tree is not None:
+                    self.other_tree.lock_read()
+                try:
+                    merge = self.make_merger()
+                    self._do_merge_to(merge)
+                finally:
+                    if self.other_tree is not None:
+                        self.other_tree.unlock()
+            finally:
+                if self.base_tree is not None:
+                    self.base_tree.unlock()
+        finally:
+            self.this_tree.unlock()
         if len(merge.cooked_conflicts) == 0:
             if not self.ignore_zero and not trace.is_quiet():
                 trace.note("All changes applied successfully.")
@@ -736,24 +540,22 @@
 
     def __init__(self, working_tree, this_tree, base_tree, other_tree,
                  interesting_ids=None, reprocess=False, show_base=False,
-                 pb=None, pp=None, change_reporter=None,
+                 pb=progress.DummyProgress(), pp=None, change_reporter=None,
                  interesting_files=None, do_merge=True,
-                 cherrypick=False, lca_trees=None, this_branch=None):
+                 cherrypick=False, lca_trees=None):
         """Initialize the merger object and perform the merge.
 
         :param working_tree: The working tree to apply the merge to
         :param this_tree: The local tree in the merge operation
         :param base_tree: The common tree in the merge operation
         :param other_tree: The other tree to merge changes from
-        :param this_branch: The branch associated with this_tree.  Defaults to
-            this_tree.branch if not supplied.
         :param interesting_ids: The file_ids of files that should be
             participate in the merge.  May not be combined with
             interesting_files.
         :param: reprocess If True, perform conflict-reduction processing.
         :param show_base: If True, show the base revision in text conflicts.
             (incompatible with reprocess)
-        :param pb: ignored
+        :param pb: A Progress bar
         :param pp: A ProgressPhase object
         :param change_reporter: An object that should report changes made
         :param interesting_files: The tree-relative paths of files that should
@@ -770,14 +572,11 @@
         if interesting_files is not None and interesting_ids is not None:
             raise ValueError(
                 'specify either interesting_ids or interesting_files')
-        if this_branch is None:
-            this_branch = this_tree.branch
         self.interesting_ids = interesting_ids
         self.interesting_files = interesting_files
         self.this_tree = working_tree
         self.base_tree = base_tree
         self.other_tree = other_tree
-        self.this_branch = this_branch
         self._raw_conflicts = []
         self.cooked_conflicts = []
         self.reprocess = reprocess
@@ -788,47 +587,51 @@
         # making sure we haven't missed any corner cases.
         # if lca_trees is None:
         #     self._lca_trees = [self.base_tree]
+        self.pb = pb
+        self.pp = pp
         self.change_reporter = change_reporter
         self.cherrypick = cherrypick
+        if self.pp is None:
+            self.pp = progress.ProgressPhase("Merge phase", 3, self.pb)
         if do_merge:
             self.do_merge()
-        if pp is not None:
-            warnings.warn("pp argument to Merge3Merger is deprecated")
-        if pb is not None:
-            warnings.warn("pb argument to Merge3Merger is deprecated")
 
     def do_merge(self):
-        operation = OperationWithCleanups(self._do_merge)
         self.this_tree.lock_tree_write()
-        operation.add_cleanup(self.this_tree.unlock)
         self.base_tree.lock_read()
-        operation.add_cleanup(self.base_tree.unlock)
         self.other_tree.lock_read()
-        operation.add_cleanup(self.other_tree.unlock)
-        operation.run()
-
-    def _do_merge(self, operation):
-        self.tt = transform.TreeTransform(self.this_tree, None)
-        operation.add_cleanup(self.tt.finalize)
-        self._compute_transform()
-        results = self.tt.apply(no_conflicts=True)
-        self.write_modified(results)
         try:
-            self.this_tree.add_conflicts(self.cooked_conflicts)
-        except errors.UnsupportedOperation:
-            pass
+            self.tt = transform.TreeTransform(self.this_tree, self.pb)
+            try:
+                self.pp.next_phase()
+                self._compute_transform()
+                self.pp.next_phase()
+                results = self.tt.apply(no_conflicts=True)
+                self.write_modified(results)
+                try:
+                    self.this_tree.add_conflicts(self.cooked_conflicts)
+                except errors.UnsupportedOperation:
+                    pass
+            finally:
+                self.tt.finalize()
+        finally:
+            self.other_tree.unlock()
+            self.base_tree.unlock()
+            self.this_tree.unlock()
+            self.pb.clear()
 
     def make_preview_transform(self):
-        operation = OperationWithCleanups(self._make_preview_transform)
         self.base_tree.lock_read()
-        operation.add_cleanup(self.base_tree.unlock)
         self.other_tree.lock_read()
-        operation.add_cleanup(self.other_tree.unlock)
-        return operation.run_simple()
-
-    def _make_preview_transform(self):
         self.tt = transform.TransformPreview(self.this_tree)
-        self._compute_transform()
+        try:
+            self.pp.next_phase()
+            self._compute_transform()
+            self.pp.next_phase()
+        finally:
+            self.other_tree.unlock()
+            self.base_tree.unlock()
+            self.pb.clear()
         return self.tt
 
     def _compute_transform(self):
@@ -840,15 +643,12 @@
             resolver = self._lca_multi_way
         child_pb = ui.ui_factory.nested_progress_bar()
         try:
-            factories = Merger.hooks['merge_file_content']
-            hooks = [factory(self) for factory in factories] + [self]
-            self.active_hooks = [hook for hook in hooks if hook is not None]
             for num, (file_id, changed, parents3, names3,
                       executable3) in enumerate(entries):
                 child_pb.update('Preparing file merge', num, len(entries))
                 self._merge_names(file_id, parents3, names3, resolver=resolver)
                 if changed:
-                    file_status = self._do_merge_contents(file_id)
+                    file_status = self.merge_contents(file_id)
                 else:
                     file_status = 'unmodified'
                 self._merge_executable(file_id,
@@ -856,6 +656,7 @@
         finally:
             child_pb.finished()
         self.fix_root()
+        self.pp.next_phase()
         child_pb = ui.ui_factory.nested_progress_bar()
         try:
             fs_conflicts = transform.resolve_conflicts(self.tt, child_pb,
@@ -1059,6 +860,7 @@
                         continue
                 else:
                     raise AssertionError('unhandled kind: %s' % other_ie.kind)
+                # XXX: We need to handle kind == 'symlink'
 
             # If we have gotten this far, that means something has changed
             result.append((file_id, content_changed,
@@ -1086,38 +888,21 @@
         other_root = self.tt.trans_id_file_id(other_root_file_id)
         if other_root == self.tt.root:
             return
+        try:
+            self.tt.final_kind(other_root)
+        except errors.NoSuchFile:
+            return
         if self.other_tree.inventory.root.file_id in self.this_tree.inventory:
-            # the other tree's root is a non-root in the current tree (as when
-            # a previously unrelated branch is merged into another)
+            # the other tree's root is a non-root in the current tree
             return
-        try:
-            self.tt.final_kind(other_root)
-            other_root_is_present = True
-        except errors.NoSuchFile:
-            # other_root doesn't have a physical representation. We still need
-            # to move any references to the actual root of the tree.
-            other_root_is_present = False
-        # 'other_tree.inventory.root' is not present in this tree. We are
-        # calling adjust_path for children which *want* to be present with a
-        # correct place to go.
-        for thing, child in self.other_tree.inventory.root.children.iteritems():
+        self.reparent_children(self.other_tree.inventory.root, self.tt.root)
+        self.tt.cancel_creation(other_root)
+        self.tt.cancel_versioning(other_root)
+
+    def reparent_children(self, ie, target):
+        for thing, child in ie.children.iteritems():
             trans_id = self.tt.trans_id_file_id(child.file_id)
-            if not other_root_is_present:
-                # FIXME: Make final_kind returns None instead of raising
-                # NoSuchFile to avoid the ugly construct below -- vila 20100402
-                try:
-                    self.tt.final_kind(trans_id)
-                    # The item exist in the final tree and has a defined place
-                    # to go already.
-                    continue
-                except errors.NoSuchFile, e:
-                    pass
-            # Move the item into the root
-            self.tt.adjust_path(self.tt.final_name(trans_id),
-                                self.tt.root, trans_id)
-        if other_root_is_present:
-            self.tt.cancel_creation(other_root)
-            self.tt.cancel_versioning(other_root)
+            self.tt.adjust_path(self.tt.final_name(trans_id), target, trans_id)
 
     def write_modified(self, results):
         modified_hashes = {}
@@ -1155,7 +940,7 @@
     @staticmethod
     def executable(tree, file_id):
         """Determine the executability of a file-id (used as a key method)."""
-        if not tree.has_id(file_id):
+        if file_id not in tree:
             return None
         if tree.kind(file_id) != "file":
             return False
@@ -1164,24 +949,22 @@
     @staticmethod
     def kind(tree, file_id):
         """Determine the kind of a file-id (used as a key method)."""
-        if not tree.has_id(file_id):
+        if file_id not in tree:
             return None
         return tree.kind(file_id)
 
     @staticmethod
     def _three_way(base, other, this):
+        #if base == other, either they all agree, or only THIS has changed.
         if base == other:
-            # if 'base == other', either they all agree, or only 'this' has
-            # changed.
             return 'this'
         elif this not in (base, other):
-            # 'this' is neither 'base' nor 'other', so both sides changed
             return 'conflict'
+        # "Ambiguous clean merge" -- both sides have made the same change.
         elif this == other:
-            # "Ambiguous clean merge" -- both sides have made the same change.
             return "this"
+        # this == base: only other has changed.
         else:
-            # this == base: only other has changed.
             return "other"
 
     @staticmethod
@@ -1231,11 +1014,10 @@
                 # only has an lca value
                 return 'other'
 
-        # At this point, the lcas disagree, and the tip disagree
+        # At this point, the lcas disagree, and the tips disagree
         return 'conflict'
 
     @staticmethod
-    @deprecated_method(deprecated_in((2, 2, 0)))
     def scalar_three_way(this_tree, base_tree, other_tree, file_id, key):
         """Do a three-way test on a scalar.
         Return "this", "other" or "conflict", depending whether a value wins.
@@ -1256,7 +1038,7 @@
 
     def merge_names(self, file_id):
         def get_entry(tree):
-            if tree.has_id(file_id):
+            if file_id in tree.inventory:
                 return tree.inventory[file_id]
             else:
                 return None
@@ -1291,27 +1073,27 @@
                 parent_id_winner = "other"
         if name_winner == "this" and parent_id_winner == "this":
             return
-        if name_winner == 'conflict' or parent_id_winner == 'conflict':
-            # Creating helpers (.OTHER or .THIS) here cause problems down the
-            # road if a ContentConflict needs to be created so we should not do
-            # that
-            trans_id = self.tt.trans_id_file_id(file_id)
-            self._raw_conflicts.append(('path conflict', trans_id, file_id,
-                                        this_parent, this_name,
-                                        other_parent, other_name))
+        if name_winner == "conflict":
+            trans_id = self.tt.trans_id_file_id(file_id)
+            self._raw_conflicts.append(('name conflict', trans_id,
+                                        this_name, other_name))
+        if parent_id_winner == "conflict":
+            trans_id = self.tt.trans_id_file_id(file_id)
+            self._raw_conflicts.append(('parent conflict', trans_id,
+                                        this_parent, other_parent))
         if other_name is None:
             # it doesn't matter whether the result was 'other' or
             # 'conflict'-- if there's no 'other', we leave it alone.
             return
+        # if we get here, name_winner and parent_winner are set to safe values.
+        trans_id = self.tt.trans_id_file_id(file_id)
         parent_id = parents[self.winner_idx[parent_id_winner]]
         if parent_id is not None:
-            # if we get here, name_winner and parent_winner are set to safe
-            # values.
+            parent_trans_id = self.tt.trans_id_file_id(parent_id)
             self.tt.adjust_path(names[self.winner_idx[name_winner]],
-                                self.tt.trans_id_file_id(parent_id),
-                                self.tt.trans_id_file_id(file_id))
+                                parent_trans_id, trans_id)
 
-    def _do_merge_contents(self, file_id):
+    def merge_contents(self, file_id):
         """Performs a merge on file_id contents."""
         def contents_pair(tree):
             if file_id not in tree:
@@ -1325,6 +1107,18 @@
                 contents = None
             return kind, contents
 
+        def contents_conflict():
+            trans_id = self.tt.trans_id_file_id(file_id)
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            if file_id in self.this_tree.inventory:
+                self.tt.unversion_file(trans_id)
+                if file_id in self.this_tree:
+                    self.tt.delete_contents(trans_id)
+            file_group = self._dump_conflicts(name, parent_id, file_id,
+                                              set_version=True)
+            self._raw_conflicts.append(('contents conflict', file_group))
+
         # See SPOT run.  run, SPOT, run.
         # So we're not QUITE repeating ourselves; we do tricky things with
         # file kind...
@@ -1346,115 +1140,63 @@
         if winner == 'this':
             # No interesting changes introduced by OTHER
             return "unmodified"
-        # We have a hypothetical conflict, but if we have files, then we
-        # can try to merge the content
         trans_id = self.tt.trans_id_file_id(file_id)
-        params = MergeHookParams(self, file_id, trans_id, this_pair[0],
-            other_pair[0], winner)
-        hooks = self.active_hooks
-        hook_status = 'not_applicable'
-        for hook in hooks:
-            hook_status, lines = hook.merge_contents(params)
-            if hook_status != 'not_applicable':
-                # Don't try any more hooks, this one applies.
-                break
-        result = "modified"
-        if hook_status == 'not_applicable':
-            # This is a contents conflict, because none of the available
-            # functions could merge it.
-            result = None
-            name = self.tt.final_name(trans_id)
-            parent_id = self.tt.final_parent(trans_id)
-            if self.this_tree.has_id(file_id):
-                self.tt.unversion_file(trans_id)
-            file_group = self._dump_conflicts(name, parent_id, file_id,
-                                              set_version=True)
-            self._raw_conflicts.append(('contents conflict', file_group))
-        elif hook_status == 'success':
-            self.tt.create_file(lines, trans_id)
-        elif hook_status == 'conflicted':
-            # XXX: perhaps the hook should be able to provide
-            # the BASE/THIS/OTHER files?
-            self.tt.create_file(lines, trans_id)
-            self._raw_conflicts.append(('text conflict', trans_id))
-            name = self.tt.final_name(trans_id)
-            parent_id = self.tt.final_parent(trans_id)
-            self._dump_conflicts(name, parent_id, file_id)
-        elif hook_status == 'delete':
-            self.tt.unversion_file(trans_id)
-            result = "deleted"
-        elif hook_status == 'done':
-            # The hook function did whatever it needs to do directly, no
-            # further action needed here.
-            pass
-        else:
-            raise AssertionError('unknown hook_status: %r' % (hook_status,))
-        if not self.this_tree.has_id(file_id) and result == "modified":
-            self.tt.version_file(file_id, trans_id)
-        # The merge has been performed, so the old contents should not be
-        # retained.
-        try:
-            self.tt.delete_contents(trans_id)
-        except errors.NoSuchFile:
-            pass
-        return result
-
-    def _default_other_winner_merge(self, merge_hook_params):
-        """Replace this contents with other."""
-        file_id = merge_hook_params.file_id
-        trans_id = merge_hook_params.trans_id
-        file_in_this = self.this_tree.has_id(file_id)
-        if self.other_tree.has_id(file_id):
-            # OTHER changed the file
-            wt = self.this_tree
-            if wt.supports_content_filtering():
-                # We get the path from the working tree if it exists.
-                # That fails though when OTHER is adding a file, so
-                # we fall back to the other tree to find the path if
-                # it doesn't exist locally.
-                try:
-                    filter_tree_path = wt.id2path(file_id)
-                except errors.NoSuchId:
-                    filter_tree_path = self.other_tree.id2path(file_id)
-            else:
-                # Skip the id2path lookup for older formats
-                filter_tree_path = None
-            transform.create_from_tree(self.tt, trans_id,
-                             self.other_tree, file_id,
-                             filter_tree_path=filter_tree_path)
-            return 'done', None
-        elif file_in_this:
-            # OTHER deleted the file
-            return 'delete', None
-        else:
-            raise AssertionError(
-                'winner is OTHER, but file_id %r not in THIS or OTHER tree'
-                % (file_id,))
-
-    def merge_contents(self, merge_hook_params):
-        """Fallback merge logic after user installed hooks."""
-        # This function is used in merge hooks as the fallback instance.
-        # Perhaps making this function and the functions it calls be a 
-        # a separate class would be better.
-        if merge_hook_params.winner == 'other':
+        if winner == 'other':
             # OTHER is a straight winner, so replace this contents with other
-            return self._default_other_winner_merge(merge_hook_params)
-        elif merge_hook_params.is_file_merge():
-            # THIS and OTHER are both files, so text merge.  Either
-            # BASE is a file, or both converted to files, so at least we
-            # have agreement that output should be a file.
-            try:
-                self.text_merge(merge_hook_params.file_id,
-                    merge_hook_params.trans_id)
-            except errors.BinaryFile:
-                return 'not_applicable', None
-            return 'done', None
+            file_in_this = file_id in self.this_tree
+            if file_in_this:
+                # Remove any existing contents
+                self.tt.delete_contents(trans_id)
+            if file_id in self.other_tree:
+                # OTHER changed the file
+                wt = self.this_tree
+                if wt.supports_content_filtering():
+                    # We get the path from the working tree if it exists.
+                    # That fails though when OTHER is adding a file, so
+                    # we fall back to the other tree to find the path if
+                    # it doesn't exist locally.
+                    try:
+                        filter_tree_path = wt.id2path(file_id)
+                    except errors.NoSuchId:
+                        filter_tree_path = self.other_tree.id2path(file_id)
+                else:
+                    # Skip the id2path lookup for older formats
+                    filter_tree_path = None
+                transform.create_from_tree(self.tt, trans_id,
+                                 self.other_tree, file_id,
+                                 filter_tree_path=filter_tree_path)
+                if not file_in_this:
+                    self.tt.version_file(file_id, trans_id)
+                return "modified"
+            elif file_in_this:
+                # OTHER deleted the file
+                self.tt.unversion_file(trans_id)
+                return "deleted"
         else:
-            return 'not_applicable', None
+            # We have a hypothetical conflict, but if we have files, then we
+            # can try to merge the content
+            if this_pair[0] == 'file' and other_pair[0] == 'file':
+                # THIS and OTHER are both files, so text merge.  Either
+                # BASE is a file, or both converted to files, so at least we
+                # have agreement that output should be a file.
+                try:
+                    self.text_merge(file_id, trans_id)
+                except errors.BinaryFile:
+                    return contents_conflict()
+                if file_id not in self.this_tree:
+                    self.tt.version_file(file_id, trans_id)
+                try:
+                    self.tt.tree_kind(trans_id)
+                    self.tt.delete_contents(trans_id)
+                except errors.NoSuchFile:
+                    pass
+                return "modified"
+            else:
+                return contents_conflict()
 
     def get_lines(self, tree, file_id):
         """Return the lines in a file, or an empty list."""
-        if tree.has_id(file_id):
+        if file_id in tree:
             return tree.get_file(file_id).readlines()
         else:
             return []
@@ -1463,7 +1205,7 @@
         """Perform a three-way text merge on a file_id"""
         # it's possible that we got here with base as a different type.
         # if so, we just want two-way text conflicts.
-        if self.base_tree.has_id(file_id) and \
+        if file_id in self.base_tree and \
             self.base_tree.kind(file_id) == "file":
             base_lines = self.get_lines(self.base_tree, file_id)
         else:
@@ -1532,7 +1274,7 @@
         versioned = False
         file_group = []
         for suffix, tree, lines in data:
-            if tree.has_id(file_id):
+            if file_id in tree:
                 trans_id = self._conflict_file(name, parent_id, tree, file_id,
                                                suffix, lines, filter_tree_path)
                 file_group.append(trans_id)
@@ -1582,11 +1324,11 @@
         if winner == "this":
             executability = this_executable
         else:
-            if self.other_tree.has_id(file_id):
+            if file_id in self.other_tree:
                 executability = other_executable
-            elif self.this_tree.has_id(file_id):
+            elif file_id in self.this_tree:
                 executability = this_executable
-            elif self.base_tree_has_id(file_id):
+            elif file_id in self.base_tree:
                 executability = base_executable
         if executability is not None:
             trans_id = self.tt.trans_id_file_id(file_id)
@@ -1594,32 +1336,20 @@
 
     def cook_conflicts(self, fs_conflicts):
         """Convert all conflicts into a form that doesn't depend on trans_id"""
+        name_conflicts = {}
         self.cooked_conflicts.extend(transform.cook_conflicts(
                 fs_conflicts, self.tt))
         fp = transform.FinalPaths(self.tt)
         for conflict in self._raw_conflicts:
             conflict_type = conflict[0]
-            if conflict_type == 'path conflict':
-                (trans_id, file_id,
-                this_parent, this_name,
-                other_parent, other_name) = conflict[1:]
-                if this_parent is None or this_name is None:
-                    this_path = '<deleted>'
-                else:
-                    parent_path =  fp.get_path(
-                        self.tt.trans_id_file_id(this_parent))
-                    this_path = osutils.pathjoin(parent_path, this_name)
-                if other_parent is None or other_name is None:
-                    other_path = '<deleted>'
-                else:
-                    parent_path =  fp.get_path(
-                        self.tt.trans_id_file_id(other_parent))
-                    other_path = osutils.pathjoin(parent_path, other_name)
-                c = _mod_conflicts.Conflict.factory(
-                    'path conflict', path=this_path,
-                    conflict_path=other_path,
-                    file_id=file_id)
-            elif conflict_type == 'contents conflict':
+            if conflict_type in ('name conflict', 'parent conflict'):
+                trans_id = conflict[1]
+                conflict_args = conflict[2:]
+                if trans_id not in name_conflicts:
+                    name_conflicts[trans_id] = {}
+                transform.unique_add(name_conflicts[trans_id], conflict_type,
+                                     conflict_args)
+            if conflict_type == 'contents conflict':
                 for trans_id in conflict[1]:
                     file_id = self.tt.final_file_id(trans_id)
                     if file_id is not None:
@@ -1631,14 +1361,40 @@
                         break
                 c = _mod_conflicts.Conflict.factory(conflict_type,
                                                     path=path, file_id=file_id)
-            elif conflict_type == 'text conflict':
+                self.cooked_conflicts.append(c)
+            if conflict_type == 'text conflict':
                 trans_id = conflict[1]
                 path = fp.get_path(trans_id)
                 file_id = self.tt.final_file_id(trans_id)
                 c = _mod_conflicts.Conflict.factory(conflict_type,
                                                     path=path, file_id=file_id)
+                self.cooked_conflicts.append(c)
+
+        for trans_id, conflicts in name_conflicts.iteritems():
+            try:
+                this_parent, other_parent = conflicts['parent conflict']
+                if this_parent == other_parent:
+                    raise AssertionError()
+            except KeyError:
+                this_parent = other_parent = \
+                    self.tt.final_file_id(self.tt.final_parent(trans_id))
+            try:
+                this_name, other_name = conflicts['name conflict']
+                if this_name == other_name:
+                    raise AssertionError()
+            except KeyError:
+                this_name = other_name = self.tt.final_name(trans_id)
+            other_path = fp.get_path(trans_id)
+            if this_parent is not None and this_name is not None:
+                this_parent_path = \
+                    fp.get_path(self.tt.trans_id_file_id(this_parent))
+                this_path = osutils.pathjoin(this_parent_path, this_name)
             else:
-                raise AssertionError('bad conflict type: %r' % (conflict,))
+                this_path = "<deleted>"
+            file_id = self.tt.final_file_id(trans_id)
+            c = _mod_conflicts.Conflict.factory('path conflict', path=this_path,
+                                                conflict_path=other_path,
+                                                file_id=file_id)
             self.cooked_conflicts.append(c)
         self.cooked_conflicts.sort(key=_mod_conflicts.Conflict.sort_key)
 
@@ -1759,7 +1515,7 @@
                 other_rev_id=None,
                 interesting_files=None,
                 this_tree=None,
-                pb=None,
+                pb=progress.DummyProgress(),
                 change_reporter=None):
     """Primary interface for merging.
 

=== modified file 'bzrlib/merge3.py'
--- bzrlib/merge3.py	2010-04-26 13:51:08 +0000
+++ bzrlib/merge3.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,11 +18,10 @@
 # mbp: "you know that thing where cvs gives you conflict markers?"
 # s: "i hate that."
 
-from bzrlib import (
-    errors,
-    patiencediff,
-    textfile,
-    )
+
+from bzrlib.errors import CantReprocessAndShowBase
+import bzrlib.patiencediff
+from bzrlib.textfile import check_text_lines
 
 
 def intersect(ra, rb):
@@ -67,24 +66,10 @@
     Given BASE, OTHER, THIS, tries to produce a combined text
     incorporating the changes from both BASE->OTHER and BASE->THIS.
     All three will typically be sequences of lines."""
-
-    def __init__(self, base, a, b, is_cherrypick=False, allow_objects=False):
-        """Constructor.
-
-        :param base: lines in BASE
-        :param a: lines in A
-        :param b: lines in B
-        :param is_cherrypick: flag indicating if this merge is a cherrypick.
-            When cherrypicking b => a, matches with b and base do not conflict.
-        :param allow_objects: if True, do not require that base, a and b are
-            plain Python strs.  Also prevents BinaryFile from being raised.
-            Lines can be any sequence of comparable and hashable Python
-            objects.
-        """
-        if not allow_objects:
-            textfile.check_text_lines(base)
-            textfile.check_text_lines(a)
-            textfile.check_text_lines(b)
+    def __init__(self, base, a, b, is_cherrypick=False):
+        check_text_lines(base)
+        check_text_lines(a)
+        check_text_lines(b)
         self.base = base
         self.a = a
         self.b = b
@@ -108,7 +93,7 @@
             elif self.a[0].endswith('\r'):
                 newline = '\r'
         if base_marker and reprocess:
-            raise errors.CantReprocessAndShowBase()
+            raise CantReprocessAndShowBase()
         if name_a:
             start_marker = start_marker + ' ' + name_a
         if name_b:
@@ -299,7 +284,7 @@
     def _refine_cherrypick_conflict(self, zstart, zend, astart, aend, bstart, bend):
         """When cherrypicking b => a, ignore matches with b and base."""
         # Do not emit regions which match, only regions which do not match
-        matches = patiencediff.PatienceSequenceMatcher(None,
+        matches = bzrlib.patiencediff.PatienceSequenceMatcher(None,
             self.base[zstart:zend], self.b[bstart:bend]).get_matching_blocks()
         last_base_idx = 0
         last_b_idx = 0
@@ -349,7 +334,7 @@
             type, iz, zmatch, ia, amatch, ib, bmatch = region
             a_region = self.a[ia:amatch]
             b_region = self.b[ib:bmatch]
-            matches = patiencediff.PatienceSequenceMatcher(
+            matches = bzrlib.patiencediff.PatienceSequenceMatcher(
                     None, a_region, b_region).get_matching_blocks()
             next_a = ia
             next_b = ib
@@ -380,9 +365,9 @@
         """
 
         ia = ib = 0
-        amatches = patiencediff.PatienceSequenceMatcher(
+        amatches = bzrlib.patiencediff.PatienceSequenceMatcher(
                 None, self.base, self.a).get_matching_blocks()
-        bmatches = patiencediff.PatienceSequenceMatcher(
+        bmatches = bzrlib.patiencediff.PatienceSequenceMatcher(
                 None, self.base, self.b).get_matching_blocks()
         len_a = len(amatches)
         len_b = len(bmatches)
@@ -435,9 +420,9 @@
 
     def find_unconflicted(self):
         """Return a list of ranges in base that are not conflicted."""
-        am = patiencediff.PatienceSequenceMatcher(
+        am = bzrlib.patiencediff.PatienceSequenceMatcher(
                 None, self.base, self.a).get_matching_blocks()
-        bm = patiencediff.PatienceSequenceMatcher(
+        bm = bzrlib.patiencediff.PatienceSequenceMatcher(
                 None, self.base, self.b).get_matching_blocks()
 
         unc = []

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2010-03-13 02:49:14 +0000
+++ bzrlib/merge_directive.py	2009-11-28 00:48:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -64,20 +64,10 @@
             " provided to the next.", (1, 15, 0), False))
 
 
-class BaseMergeDirective(object):
-    """A request to perform a merge into a branch.
-
-    This is the base class that all merge directive implementations 
-    should derive from.
-
-    :cvar multiple_output_files: Whether or not this merge directive 
-        stores a set of revisions in more than one file
-    """
+class _BaseMergeDirective(object):
 
     hooks = MergeDirectiveHooks()
 
-    multiple_output_files = False
-
     def __init__(self, revision_id, testament_sha1, time, timezone,
                  target_branch, patch=None, source_branch=None, message=None,
                  bundle=None):
@@ -102,27 +92,6 @@
         self.source_branch = source_branch
         self.message = message
 
-    def to_lines(self):
-        """Serialize as a list of lines
-
-        :return: a list of lines
-        """
-        raise NotImplementedError(self.to_lines)
-
-    def to_files(self):
-        """Serialize as a set of files.
-
-        :return: List of tuples with filename and contents as lines
-        """
-        raise NotImplementedError(self.to_files)
-
-    def get_raw_bundle(self):
-        """Return the bundle for this merge directive.
-
-        :return: bundle text or None if there is no bundle
-        """
-        return None
-
     def _to_lines(self, base_revision=False):
         """Serialize as a list of lines
 
@@ -142,13 +111,6 @@
         lines.append('# \n')
         return lines
 
-    def write_to_directory(self, path):
-        """Write this merge directive to a series of files in a directory.
-
-        :param path: Filesystem path to write to
-        """
-        raise NotImplementedError(self.write_to_directory)
-
     @classmethod
     def from_objects(klass, repository, revision_id, time, timezone,
                  target_branch, patch_type='bundle',
@@ -341,7 +303,7 @@
                                           basename, body)
 
 
-class MergeDirective(BaseMergeDirective):
+class MergeDirective(_BaseMergeDirective):
 
     """A request to perform a merge into a branch.
 
@@ -376,7 +338,7 @@
         :param source_branch: A public location to merge the revision from
         :param message: The message to use when committing this merge
         """
-        BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
+        _BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
             timezone, target_branch, patch, source_branch, message)
         if patch_type not in (None, 'diff', 'bundle'):
             raise ValueError(patch_type)
@@ -466,7 +428,7 @@
         return None, self.revision_id, 'inapplicable'
 
 
-class MergeDirective2(BaseMergeDirective):
+class MergeDirective2(_BaseMergeDirective):
 
     _format_string = 'Bazaar merge directive format 2 (Bazaar 0.90)'
 
@@ -475,7 +437,7 @@
                  bundle=None, base_revision_id=None):
         if source_branch is None and bundle is None:
             raise errors.NoMergeSource()
-        BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
+        _BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
             timezone, target_branch, patch, source_branch, message)
         self.bundle = bundle
         self.base_revision_id = base_revision_id

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2010-04-30 11:03:59 +0000
+++ bzrlib/missing.py	2009-08-17 18:52:01 +0000
@@ -18,6 +18,8 @@
 
 from bzrlib import (
     log,
+    repository as _mod_repository,
+    tsort,
     )
 import bzrlib.revision as _mod_revision
 

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2010-04-30 11:35:43 +0000
+++ bzrlib/msgeditor.py	2009-11-17 23:05:04 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 """Commit message editor support."""
 
 import codecs
+import errno
 import os
 from subprocess import call
 import sys
@@ -26,8 +27,6 @@
     config,
     osutils,
     trace,
-    transport,
-    ui,
     )
 from bzrlib.errors import BzrError, BadCommitMessageEncoding
 from bzrlib.hooks import HookPoint, Hooks
@@ -64,14 +63,22 @@
             ## mutter("trying editor: %r", (edargs +[filename]))
             x = call(edargs + [filename])
         except OSError, e:
-            if candidate_source is not None:
-                # We tried this editor because some user configuration (an
-                # environment variable or config file) said to try it.  Let
-                # the user know their configuration is broken.
-                trace.warning(
-                    'Could not start editor "%s" (specified by %s): %s\n'
-                    % (candidate, candidate_source, str(e)))
-            continue
+            # We're searching for an editor, so catch safe errors and continue
+            # errno 193 is ERROR_BAD_EXE_FORMAT on Windows. Python2.4 uses the
+            # winerror for errno. Python2.5+ use errno ENOEXEC and set winerror
+            # to 193. However, catching 193 here should be fine. Other
+            # platforms aren't likely to have that high of an error. And even
+            # if they do, it is still reasonable to fall back to the next
+            # editor.
+            if e.errno in (errno.ENOENT, errno.EACCES, errno.ENOEXEC, 193):
+                if candidate_source is not None:
+                    # We tried this editor because some user configuration (an
+                    # environment variable or config file) said to try it.  Let
+                    # the user know their configuration is broken.
+                    trace.warning(
+                        'Could not start editor "%s" (specified by %s): %s\n'
+                        % (candidate, candidate_source, str(e)))
+                continue
             raise
         if x == 0:
             return True
@@ -140,21 +147,10 @@
     try:
         msgfilename, hasinfo = _create_temp_file_with_commit_template(
                                     infotext, ignoreline, start_message)
-        if not msgfilename:
-            return None
-        basename = osutils.basename(msgfilename)
-        msg_transport = transport.get_transport(osutils.dirname(msgfilename))
-        reference_content = msg_transport.get_bytes(basename)
-        if not _run_editor(msgfilename):
-            return None
-        edited_content = msg_transport.get_bytes(basename)
-        if edited_content == reference_content:
-            if not ui.ui_factory.get_boolean(
-                "Commit message was not edited, use anyway"):
-                # Returning "" makes cmd_commit raise 'empty commit message
-                # specified' which is a reasonable error, given the user has
-                # rejected using the unedited template.
-                return ""
+
+        if not msgfilename or not _run_editor(msgfilename):
+            return None
+
         started = False
         msg = []
         lastline, nlines = 0, 0

=== modified file 'bzrlib/mutabletree.py'
--- bzrlib/mutabletree.py	2010-04-22 14:18:17 +0000
+++ bzrlib/mutabletree.py	2009-10-06 14:40:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -258,44 +258,6 @@
             return False
 
     @needs_read_lock
-    def check_changed_or_out_of_date(self, strict, opt_name,
-                                     more_error, more_warning):
-        """Check the tree for uncommitted changes and branch synchronization.
-
-        If strict is None and not set in the config files, a warning is issued.
-        If strict is True, an error is raised.
-        If strict is False, no checks are done and no warning is issued.
-
-        :param strict: True, False or None, searched in branch config if None.
-
-        :param opt_name: strict option name to search in config file.
-
-        :param more_error: Details about how to avoid the check.
-
-        :param more_warning: Details about what is happening.
-        """
-        if strict is None:
-            strict = self.branch.get_config().get_user_option_as_bool(opt_name)
-        if strict is not False:
-            err_class = None
-            if (self.has_changes()):
-                err_class = errors.UncommittedChanges
-            elif self.last_revision() != self.branch.last_revision():
-                # The tree has lost sync with its branch, there is little
-                # chance that the user is aware of it but he can still force
-                # the action with --no-strict
-                err_class = errors.OutOfDateTree
-            if err_class is not None:
-                if strict is None:
-                    err = err_class(self, more=more_warning)
-                    # We don't want to interrupt the user if he expressed no
-                    # preference about strict.
-                    trace.warning('%s', err._format())
-                else:
-                    err = err_class(self, more=more_error)
-                    raise err
-
-    @needs_read_lock
     def last_revision(self):
         """Return the revision id of the last commit performed in this tree.
 
@@ -418,8 +380,6 @@
 
         if not file_list:
             # no paths supplied: add the entire tree.
-            # FIXME: this assumes we are running in a working tree subdir :-/
-            # -- vila 20100208
             file_list = [u'.']
         # mutter("smart add of %r")
         inv = self.inventory
@@ -427,14 +387,6 @@
         ignored = {}
         dirs_to_add = []
         user_dirs = set()
-        conflicts_related = set()
-        # Not all mutable trees can have conflicts
-        if getattr(self, 'conflicts', None) is not None:
-            # Collect all related files without checking whether they exist or
-            # are versioned. It's cheaper to do that once for all conflicts
-            # than trying to find the relevant conflict for each added file.
-            for c in self.conflicts():
-                conflicts_related.update(c.associated_filenames())
 
         # validate user file paths and convert all paths to tree
         # relative : it's cheaper to make a tree relative path an abspath
@@ -501,13 +453,6 @@
             if illegalpath_re.search(directory.raw_path):
                 trace.warning("skipping %r (contains \\n or \\r)" % abspath)
                 continue
-            if directory.raw_path in conflicts_related:
-                # If the file looks like one generated for a conflict, don't
-                # add it.
-                trace.warning(
-                    'skipping %s (generated to help resolve conflicts)',
-                    abspath)
-                continue
 
             if parent_ie is not None:
                 versioned = directory.base_path in parent_ie.children

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2010-04-20 08:47:38 +0000
+++ bzrlib/option.py	2009-08-18 08:10:44 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -276,7 +276,7 @@
         parser.add_option(action='callback',
                           callback=self._optparse_callback,
                           type='string', metavar=self.argname.upper(),
-                          help=self.help, dest=self._param_name, default=[],
+                          help=self.help, default=[],
                           *option_strings)
 
     def _optparse_callback(self, option, opt, value, parser):
@@ -361,10 +361,10 @@
 
         name, help, value_switches and enum_switch are passed to the
         RegistryOption constructor.  Any other keyword arguments are treated
-        as values for the option, and their value is treated as the help.
+        as values for the option, and they value is treated as the help.
         """
         reg = _mod_registry.Registry()
-        for name, switch_help in sorted(kwargs.items()):
+        for name, switch_help in kwargs.iteritems():
             name = name.replace('_', '-')
             reg.register(name, name, help=switch_help)
             if not value_switches:

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-05-03 06:25:46 +0000
+++ bzrlib/osutils.py	2009-12-23 00:15:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,13 +17,15 @@
 import os
 import re
 import stat
-from stat import S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE
+from stat import (S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE,
+                  S_ISCHR, S_ISBLK, S_ISFIFO, S_ISSOCK)
 import sys
 import time
-import codecs
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
+import codecs
 from datetime import datetime
 import errno
 from ntpath import (abspath as _nt_abspath,
@@ -37,7 +39,7 @@
 from shutil import (
     rmtree,
     )
-import socket
+import signal
 import subprocess
 import tempfile
 from tempfile import (
@@ -48,16 +50,10 @@
 from bzrlib import (
     cache_utf8,
     errors,
-    trace,
     win32utils,
     )
 """)
 
-from bzrlib.symbol_versioning import (
-    deprecated_function,
-    deprecated_in,
-    )
-
 # sha and md5 modules are deprecated in python2.6 but hashlib is available as
 # of 2.5
 if sys.version_info < (2, 5):
@@ -89,11 +85,8 @@
 # be opened in binary mode, rather than text mode.
 # On other platforms, O_BINARY doesn't exist, because
 # they always open in binary mode, so it is okay to
-# OR with 0 on those platforms.
-# O_NOINHERIT and O_TEXT exists only on win32 too.
+# OR with 0 on those platforms
 O_BINARY = getattr(os, 'O_BINARY', 0)
-O_TEXT = getattr(os, 'O_TEXT', 0)
-O_NOINHERIT = getattr(os, 'O_NOINHERIT', 0)
 
 
 def get_unicode_argv():
@@ -186,9 +179,7 @@
     try:
         return _kind_marker_map[kind]
     except KeyError:
-        # Slightly faster than using .get(, '') when the common case is that
-        # kind will be found
-        return ''
+        raise errors.BzrError('invalid file kind %r' % kind)
 
 
 lexists = getattr(os.path, 'lexists', None)
@@ -211,17 +202,13 @@
     :param old: The old path, to rename from
     :param new: The new path, to rename to
     :param rename_func: The potentially non-atomic rename function
-    :param unlink_func: A way to delete the target file if the full rename
-        succeeds
+    :param unlink_func: A way to delete the target file if the full rename succeeds
     """
+
     # sftp rename doesn't allow overwriting, so play tricks:
     base = os.path.basename(new)
     dirname = os.path.dirname(new)
-    # callers use different encodings for the paths so the following MUST
-    # respect that. We rely on python upcasting to unicode if new is unicode
-    # and keeping a str if not.
-    tmp_name = 'tmp.%s.%.9f.%d.%s' % (base, time.time(),
-                                      os.getpid(), rand_chars(10))
+    tmp_name = u'tmp.%s.%.9f.%d.%s' % (base, time.time(), os.getpid(), rand_chars(10))
     tmp_name = pathjoin(dirname, tmp_name)
 
     # Rename the file out of the way, but keep track if it didn't exist
@@ -360,14 +347,6 @@
     return _win32_fixdrive(tempfile.mkdtemp(*args, **kwargs).replace('\\', '/'))
 
 
-def _add_rename_error_details(e, old, new):
-    new_e = OSError(e.errno, "failed to rename %s to %s: %s"
-        % (old, new, e.strerror))
-    new_e.filename = old
-    new_e.to_filename = new
-    return new_e
-
-
 def _win32_rename(old, new):
     """We expect to be able to atomically replace 'new' with old.
 
@@ -375,7 +354,7 @@
     and then deleted.
     """
     try:
-        fancy_rename(old, new, rename_func=_wrapped_rename, unlink_func=os.unlink)
+        fancy_rename(old, new, rename_func=os.rename, unlink_func=os.unlink)
     except OSError, e:
         if e.errno in (errno.EPERM, errno.EACCES, errno.EBUSY, errno.EINVAL):
             # If we try to rename a non-existant file onto cwd, we get
@@ -386,16 +365,6 @@
         raise
 
 
-def _wrapped_rename(old, new):
-    """Rename a file or directory"""
-    try:
-        os.rename(old, new)
-    except (IOError, OSError), e:
-        # this is eventually called by all rename-like functions, so should 
-        # catch all of them
-        raise _add_rename_error_details(e, old, new)
-
-
 def _mac_getcwd():
     return unicodedata.normalize('NFC', os.getcwdu())
 
@@ -406,8 +375,8 @@
 realpath = _posix_realpath
 pathjoin = os.path.join
 normpath = os.path.normpath
-rename = _wrapped_rename # overridden below on win32
 getcwd = os.getcwdu
+rename = os.rename
 dirname = os.path.dirname
 basename = os.path.basename
 split = os.path.split
@@ -688,7 +657,7 @@
 def sha_file_by_name(fname):
     """Calculate the SHA1 of a file by reading the full text"""
     s = sha()
-    f = os.open(fname, os.O_RDONLY | O_BINARY | O_NOINHERIT)
+    f = os.open(fname, os.O_RDONLY | O_BINARY)
     try:
         while True:
             b = os.read(f, 1<<16)
@@ -1147,7 +1116,7 @@
 
 
 def relpath(base, path):
-    """Return path relative to base, or raise PathNotChild exception.
+    """Return path relative to base, or raise exception.
 
     The path may be either an absolute path or a path relative to the
     current working directory.
@@ -1155,9 +1124,6 @@
     os.path.commonprefix (python2.4) has a bad bug that it works just
     on string prefixes, assuming that '/u' is a prefix of '/u2'.  This
     avoids that problem.
-
-    NOTE: `base` should not have a trailing slash otherwise you'll get
-    PathNotChild exceptions regardless of `path`.
     """
 
     if len(base) < MIN_ABS_PATHLENGTH:
@@ -1374,42 +1340,6 @@
     normalized_filename = _inaccessible_normalized_filename
 
 
-def set_signal_handler(signum, handler, restart_syscall=True):
-    """A wrapper for signal.signal that also calls siginterrupt(signum, False)
-    on platforms that support that.
-
-    :param restart_syscall: if set, allow syscalls interrupted by a signal to
-        automatically restart (by calling `signal.siginterrupt(signum,
-        False)`).  May be ignored if the feature is not available on this
-        platform or Python version.
-    """
-    try:
-        import signal
-        siginterrupt = signal.siginterrupt
-    except ImportError:
-        # This python implementation doesn't provide signal support, hence no
-        # handler exists
-        return None
-    except AttributeError:
-        # siginterrupt doesn't exist on this platform, or for this version
-        # of Python.
-        siginterrupt = lambda signum, flag: None
-    if restart_syscall:
-        def sig_handler(*args):
-            # Python resets the siginterrupt flag when a signal is
-            # received.  <http://bugs.python.org/issue8354>
-            # As a workaround for some cases, set it back the way we want it.
-            siginterrupt(signum, False)
-            # Now run the handler function passed to set_signal_handler.
-            handler(*args)
-    else:
-        sig_handler = handler
-    old_handler = signal.signal(signum, sig_handler)
-    if restart_syscall:
-        siginterrupt(signum, False)
-    return old_handler
-
-
 default_terminal_width = 80
 """The default terminal width for ttys.
 
@@ -1504,23 +1434,12 @@
     if width is not None:
         os.environ['COLUMNS'] = str(width)
 
-
-_registered_sigwinch = False
-def watch_sigwinch():
-    """Register for SIGWINCH, once and only once.
-
-    Do nothing if the signal module is not available.
-    """
-    global _registered_sigwinch
-    if not _registered_sigwinch:
-        try:
-            import signal
-            if getattr(signal, "SIGWINCH", None) is not None:
-                set_signal_handler(signal.SIGWINCH, _terminal_size_changed)
-        except ImportError:
-            # python doesn't provide signal support, nothing we can do about it
-            pass
-        _registered_sigwinch = True
+if sys.platform == 'win32':
+    # Martin (gz) mentioned WINDOW_BUFFER_SIZE_RECORD from ReadConsoleInput but
+    # I've no idea how to plug that in the current design -- vila 20091216
+    pass
+else:
+    signal.signal(signal.SIGWINCH, _terminal_size_changed)
 
 
 def supports_executable():
@@ -1846,28 +1765,6 @@
             real_handlers[kind](abspath, relpath)
 
 
-def copy_ownership_from_path(dst, src=None):
-    """Copy usr/grp ownership from src file/dir to dst file/dir.
-
-    If src is None, the containing directory is used as source. If chown
-    fails, the error is ignored and a warning is printed.
-    """
-    chown = getattr(os, 'chown', None)
-    if chown is None:
-        return
-
-    if src == None:
-        src = os.path.dirname(dst)
-        if src == '':
-            src = '.'
-
-    try:
-        s = os.stat(src)
-        chown(dst, s.st_uid, s.st_gid)
-    except OSError, e:
-        trace.warning("Unable to copy ownership from '%s' to '%s': IOError: %s." % (src, dst, e))
-
-
 def path_prefix_key(path):
     """Generate a prefix-order path key for path.
 
@@ -1973,82 +1870,40 @@
         return socket.gethostname().decode(get_user_encoding())
 
 
-# We must not read/write any more than 64k at a time from/to a socket so we
-# don't risk "no buffer space available" errors on some platforms.  Windows in
-# particular is likely to throw WSAECONNABORTED or WSAENOBUFS if given too much
-# data at once.
-MAX_SOCKET_CHUNK = 64 * 1024
-
-def read_bytes_from_socket(sock, report_activity=None,
-        max_read_size=MAX_SOCKET_CHUNK):
-    """Read up to max_read_size of bytes from sock and notify of progress.
-
-    Translates "Connection reset by peer" into file-like EOF (return an
-    empty string rather than raise an error), and repeats the recv if
-    interrupted by a signal.
-    """
-    while 1:
-        try:
-            bytes = sock.recv(max_read_size)
-        except socket.error, e:
-            eno = e.args[0]
-            if eno == getattr(errno, "WSAECONNRESET", errno.ECONNRESET):
-                # The connection was closed by the other side.  Callers expect
-                # an empty string to signal end-of-stream.
-                return ""
-            elif eno == errno.EINTR:
-                # Retry the interrupted recv.
-                continue
-            raise
-        else:
-            if report_activity is not None:
-                report_activity(len(bytes), 'read')
-            return bytes
-
-
-def recv_all(socket, count):
+def recv_all(socket, bytes):
     """Receive an exact number of bytes.
 
     Regular Socket.recv() may return less than the requested number of bytes,
-    depending on what's in the OS buffer.  MSG_WAITALL is not available
+    dependning on what's in the OS buffer.  MSG_WAITALL is not available
     on all platforms, but this should work everywhere.  This will return
     less than the requested amount if the remote end closes.
 
     This isn't optimized and is intended mostly for use in testing.
     """
     b = ''
-    while len(b) < count:
-        new = read_bytes_from_socket(socket, None, count - len(b))
+    while len(b) < bytes:
+        new = until_no_eintr(socket.recv, bytes - len(b))
         if new == '':
             break # eof
         b += new
     return b
 
 
-def send_all(sock, bytes, report_activity=None):
+def send_all(socket, bytes, report_activity=None):
     """Send all bytes on a socket.
- 
-    Breaks large blocks in smaller chunks to avoid buffering limitations on
-    some platforms, and catches EINTR which may be thrown if the send is
-    interrupted by a signal.
-
-    This is preferred to socket.sendall(), because it avoids portability bugs
-    and provides activity reporting.
- 
+
+    Regular socket.sendall() can give socket error 10053 on Windows.  This
+    implementation sends no more than 64k at a time, which avoids this problem.
+
     :param report_activity: Call this as bytes are read, see
         Transport._report_activity
     """
-    sent_total = 0
-    byte_count = len(bytes)
-    while sent_total < byte_count:
-        try:
-            sent = sock.send(buffer(bytes, sent_total, MAX_SOCKET_CHUNK))
-        except socket.error, e:
-            if e.args[0] != errno.EINTR:
-                raise
-        else:
-            sent_total += sent
-            report_activity(sent, 'write')
+    chunk_size = 2**16
+    for pos in xrange(0, len(bytes), chunk_size):
+        block = bytes[pos:pos+chunk_size]
+        if report_activity is not None:
+            report_activity(len(block), 'write')
+        until_no_eintr(socket.sendall, block)
 
 
 def dereference_path(path):
@@ -2125,18 +1980,7 @@
 
 
 def until_no_eintr(f, *a, **kw):
-    """Run f(*a, **kw), retrying if an EINTR error occurs.
-    
-    WARNING: you must be certain that it is safe to retry the call repeatedly
-    if EINTR does occur.  This is typically only true for low-level operations
-    like os.read.  If in any doubt, don't use this.
-
-    Keep in mind that this is not a complete solution to EINTR.  There is
-    probably code in the Python standard library and other dependencies that
-    may encounter EINTR if a signal arrives (and there is signal handler for
-    that signal).  So this function can reduce the impact for IO that bzrlib
-    directly controls, but it is not a complete solution.
-    """
+    """Run f(*a, **kw), retrying if an EINTR error occurs."""
     # Borrowed from Twisted's twisted.python.util.untilConcludes function.
     while True:
         try:
@@ -2146,7 +1990,6 @@
                 continue
             raise
 
-
 def re_compile_checked(re_string, flags=0, where=""):
     """Return a compiled re, or raise a sensible error.
 
@@ -2259,46 +2102,3 @@
         else:
             data, _ = self.encode(object, self.errors)
             self.stream.write(data)
-
-if sys.platform == 'win32':
-    def open_file(filename, mode='r', bufsize=-1):
-        """This function is used to override the ``open`` builtin.
-        
-        But it uses O_NOINHERIT flag so the file handle is not inherited by
-        child processes.  Deleting or renaming a closed file opened with this
-        function is not blocking child processes.
-        """
-        writing = 'w' in mode
-        appending = 'a' in mode
-        updating = '+' in mode
-        binary = 'b' in mode
-
-        flags = O_NOINHERIT
-        # see http://msdn.microsoft.com/en-us/library/yeby3zcb%28VS.71%29.aspx
-        # for flags for each modes.
-        if binary:
-            flags |= O_BINARY
-        else:
-            flags |= O_TEXT
-
-        if writing:
-            if updating:
-                flags |= os.O_RDWR
-            else:
-                flags |= os.O_WRONLY
-            flags |= os.O_CREAT | os.O_TRUNC
-        elif appending:
-            if updating:
-                flags |= os.O_RDWR
-            else:
-                flags |= os.O_WRONLY
-            flags |= os.O_CREAT | os.O_APPEND
-        else: #reading
-            if updating:
-                flags |= os.O_RDWR
-            else:
-                flags |= os.O_RDONLY
-
-        return os.fdopen(os.open(filename, flags), mode, bufsize)
-else:
-    open_file = open

=== modified file 'bzrlib/pack.py'
--- bzrlib/pack.py	2010-03-15 06:54:44 +0000
+++ bzrlib/pack.py	2009-07-02 03:48:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -203,7 +203,7 @@
         result = self._string.readline()
         if self._string.tell() == self._string_length and result[-1] != '\n':
             raise errors.BzrError('short readline in the readvfile hunk: %r'
-                % (result, ))
+                % (readline, ))
         return result
 
 

=== modified file 'bzrlib/patches.py'
--- bzrlib/patches.py	2010-02-25 06:17:27 +0000
+++ bzrlib/patches.py	2009-11-03 15:45:56 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Aaron Bentley, Canonical Ltd
+# Copyright (C) 2004 - 2006, 2008 Aaron Bentley, Canonical Ltd
 # <aaron.bentley@utoronto.ca>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -250,13 +250,7 @@
         return shift
 
 
-def iter_hunks(iter_lines, allow_dirty=False):
-    '''
-    :arg iter_lines: iterable of lines to parse for hunks
-    :kwarg allow_dirty: If True, when we encounter something that is not
-        a hunk header when we're looking for one, assume the rest of the lines
-        are not part of the patch (comments or other junk).  Default False
-    '''
+def iter_hunks(iter_lines):
     hunk = None
     for line in iter_lines:
         if line == "\n":
@@ -266,15 +260,7 @@
             continue
         if hunk is not None:
             yield hunk
-        try:
-            hunk = hunk_from_header(line)
-        except MalformedHunkHeader:
-            if allow_dirty:
-                # If the line isn't a hunk header, then we've reached the end
-                # of this patch and there's "junk" at the end.  Ignore the
-                # rest of this patch.
-                return
-            raise
+        hunk = hunk_from_header(line)
         orig_size = 0
         mod_size = 0
         while orig_size < hunk.orig_range or mod_size < hunk.mod_range:
@@ -353,12 +339,7 @@
                     pos += 1
 
 
-def parse_patch(iter_lines, allow_dirty=False):
-    '''
-    :arg iter_lines: iterable of lines to parse
-    :kwarg allow_dirty: If True, allow the patch to have trailing junk.
-        Default False
-    '''
+def parse_patch(iter_lines):
     iter_lines = iter_lines_handle_nl(iter_lines)
     try:
         (orig_name, mod_name) = get_patch_names(iter_lines)
@@ -366,29 +347,15 @@
         return BinaryPatch(e.orig_name, e.mod_name)
     else:
         patch = Patch(orig_name, mod_name)
-        for hunk in iter_hunks(iter_lines, allow_dirty):
+        for hunk in iter_hunks(iter_lines):
             patch.hunks.append(hunk)
         return patch
 
 
-def iter_file_patch(iter_lines, allow_dirty=False):
-    '''
-    :arg iter_lines: iterable of lines to parse for patches
-    :kwarg allow_dirty: If True, allow comments and other non-patch text
-        before the first patch.  Note that the algorithm here can only find
-        such text before any patches have been found.  Comments after the
-        first patch are stripped away in iter_hunks() if it is also passed
-        allow_dirty=True.  Default False.
-    '''
-    ### FIXME: Docstring is not quite true.  We allow certain comments no
-    # matter what, If they startwith '===', '***', or '#' Someone should
-    # reexamine this logic and decide if we should include those in
-    # allow_dirty or restrict those to only being before the patch is found
-    # (as allow_dirty does).
+def iter_file_patch(iter_lines):
     regex = re.compile(binary_files_re)
     saved_lines = []
     orig_range = 0
-    beginning = True
     for line in iter_lines:
         if line.startswith('=== ') or line.startswith('*** '):
             continue
@@ -398,12 +365,7 @@
             if line.startswith('-') or line.startswith(' '):
                 orig_range -= 1
         elif line.startswith('--- ') or regex.match(line):
-            if allow_dirty and beginning:
-                # Patches can have "junk" at the beginning
-                # Stripping junk from the end of patches is handled when we
-                # parse the patch
-                beginning = False
-            elif len(saved_lines) > 0:
+            if len(saved_lines) > 0:
                 yield saved_lines
             saved_lines = []
         elif line.startswith('@@'):
@@ -435,15 +397,8 @@
         yield last_line
 
 
-def parse_patches(iter_lines, allow_dirty=False):
-    '''
-    :arg iter_lines: iterable of lines to parse for patches
-    :kwarg allow_dirty: If True, allow text that's not part of the patch at
-        selected places.  This includes comments before and after a patch
-        for instance.  Default False.
-    '''
-    return [parse_patch(f.__iter__(), allow_dirty) for f in
-                        iter_file_patch(iter_lines, allow_dirty)]
+def parse_patches(iter_lines):
+    return [parse_patch(f.__iter__()) for f in iter_file_patch(iter_lines)]
 
 
 def difference_index(atext, btext):

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2010-04-06 07:22:31 +0000
+++ bzrlib/plugin.py	2009-09-04 15:36:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,11 +60,14 @@
 
 DEFAULT_PLUGIN_PATH = None
 _loaded = False
-_plugins_disabled = False
-
-
-def are_plugins_disabled():
-    return _plugins_disabled
+
+@deprecated_function(deprecated_in((2, 0, 0)))
+def get_default_plugin_path():
+    """Get the DEFAULT_PLUGIN_PATH"""
+    global DEFAULT_PLUGIN_PATH
+    if DEFAULT_PLUGIN_PATH is None:
+        DEFAULT_PLUGIN_PATH = osutils.pathjoin(config.config_dir(), 'plugins')
+    return DEFAULT_PLUGIN_PATH
 
 
 def disable_plugins():
@@ -72,8 +75,6 @@
 
     Future calls to load_plugins() will be ignored.
     """
-    global _plugins_disabled
-    _plugins_disabled = True
     load_plugins([])
 
 
@@ -91,19 +92,6 @@
     if path is None:
         path = get_standard_plugins_path()
     _mod_plugins.__path__ = path
-    PluginImporter.reset()
-    # Set up a blacklist for disabled plugins
-    disabled_plugins = os.environ.get('BZR_DISABLE_PLUGINS', None)
-    if disabled_plugins is not None:
-        for name in disabled_plugins.split(os.pathsep):
-            PluginImporter.blacklist.add('bzrlib.plugins.' + name)
-    # Set up a the specific paths for plugins
-    specific_plugins = os.environ.get('BZR_PLUGINS_AT', None)
-    if specific_plugins is not None:
-        for spec in specific_plugins.split(os.pathsep):
-            plugin_name, plugin_path = spec.split('@')
-            PluginImporter.specific_paths[
-                'bzrlib.plugins.%s' % plugin_name] = plugin_path
     return path
 
 
@@ -192,12 +180,12 @@
     paths = []
     for p in env_paths + defaults:
         if p.startswith('+'):
-            # Resolve references if they are known
+            # Resolve reference if they are known
             try:
                 p = refs[p[1:]]
             except KeyError:
-                # Leave them untouched so user can still use paths starting
-                # with '+'
+                # Leave them untouched otherwise, user may have paths starting
+                # with '+'...
                 pass
         _append_new_path(paths, p)
 
@@ -215,7 +203,7 @@
     files (and whatever other extensions are used in the platform,
     such as *.pyd).
 
-    load_from_path() provides the underlying mechanism and is called with
+    load_from_dirs() provides the underlying mechanism and is called with
     the default directory list to provide the normal behaviour.
 
     :param path: The list of paths to search for plugins.  By default,
@@ -244,11 +232,6 @@
 
     The python module path for bzrlib.plugins will be modified to be 'dirs'.
     """
-    # Explicitly load the plugins with a specific path
-    for fullname, path in PluginImporter.specific_paths.iteritems():
-        name = fullname[len('bzrlib.plugins.'):]
-        _load_plugin_module(name, path)
-
     # We need to strip the trailing separators here as well as in the
     # set_plugins_path function because calling code can pass anything in to
     # this function, and since it sets plugins.__path__, it should set it to
@@ -268,99 +251,70 @@
 load_from_dirs = load_from_path
 
 
-def _find_plugin_module(dir, name):
-    """Check if there is a valid python module that can be loaded as a plugin.
-
-    :param dir: The directory where the search is performed.
-    :param path: An existing file path, either a python file or a package
-        directory.
-
-    :return: (name, path, description) name is the module name, path is the
-        file to load and description is the tuple returned by
-        imp.get_suffixes().
-    """
-    path = osutils.pathjoin(dir, name)
-    if os.path.isdir(path):
-        # Check for a valid __init__.py file, valid suffixes depends on -O and
-        # can be .py, .pyc and .pyo
-        for suffix, mode, kind in imp.get_suffixes():
-            if kind not in (imp.PY_SOURCE, imp.PY_COMPILED):
-                # We don't recognize compiled modules (.so, .dll, etc)
-                continue
-            init_path = osutils.pathjoin(path, '__init__' + suffix)
-            if os.path.isfile(init_path):
-                return name, init_path, (suffix, mode, kind)
-    else:
-        for suffix, mode, kind in imp.get_suffixes():
-            if name.endswith(suffix):
-                # Clean up the module name
-                name = name[:-len(suffix)]
-                if kind == imp.C_EXTENSION and name.endswith('module'):
-                    name = name[:-len('module')]
-                return name, path, (suffix, mode, kind)
-    # There is no python module here
-    return None, None, (None, None, None)
-
-
-def _load_plugin_module(name, dir):
-    """Load plugin name from dir.
-
-    :param name: The plugin name in the bzrlib.plugins namespace.
-    :param dir: The directory the plugin is loaded from for error messages.
-    """
-    if ('bzrlib.plugins.%s' % name) in PluginImporter.blacklist:
-        return
-    try:
-        exec "import bzrlib.plugins.%s" % name in {}
-    except KeyboardInterrupt:
-        raise
-    except errors.IncompatibleAPI, e:
-        trace.warning("Unable to load plugin %r. It requested API version "
-            "%s of module %s but the minimum exported version is %s, and "
-            "the maximum is %s" %
-            (name, e.wanted, e.api, e.minimum, e.current))
-    except Exception, e:
-        trace.warning("%s" % e)
-        if re.search('\.|-| ', name):
-            sanitised_name = re.sub('[-. ]', '_', name)
-            if sanitised_name.startswith('bzr_'):
-                sanitised_name = sanitised_name[len('bzr_'):]
-            trace.warning("Unable to load %r in %r as a plugin because the "
-                    "file path isn't a valid module name; try renaming "
-                    "it to %r." % (name, dir, sanitised_name))
-        else:
-            trace.warning('Unable to load plugin %r from %r' % (name, dir))
-        trace.log_exception_quietly()
-        if 'error' in debug.debug_flags:
-            trace.print_exception(sys.exc_info(), sys.stderr)
-
-
 def load_from_dir(d):
     """Load the plugins in directory d.
 
     d must be in the plugins module path already.
-    This function is called once for each directory in the module path.
     """
+    # Get the list of valid python suffixes for __init__.py?
+    # this includes .py, .pyc, and .pyo (depending on if we are running -O)
+    # but it doesn't include compiled modules (.so, .dll, etc)
+    valid_suffixes = [suffix for suffix, mod_type, flags in imp.get_suffixes()
+                              if flags in (imp.PY_SOURCE, imp.PY_COMPILED)]
+    package_entries = ['__init__'+suffix for suffix in valid_suffixes]
     plugin_names = set()
-    for p in os.listdir(d):
-        name, path, desc = _find_plugin_module(d, p)
-        if name is not None:
-            if name == '__init__':
-                # We do nothing with the __init__.py file in directories from
-                # the bzrlib.plugins module path, we may want to, one day
-                # -- vila 20100316.
-                continue # We don't load __init__.py in the plugins dirs
-            elif getattr(_mod_plugins, name, None) is not None:
-                # The module has already been loaded from another directory
-                # during a previous call.
-                # FIXME: There should be a better way to report masked plugins
-                # -- vila 20100316
-                trace.mutter('Plugin name %s already loaded', name)
+    for f in os.listdir(d):
+        path = osutils.pathjoin(d, f)
+        if os.path.isdir(path):
+            for entry in package_entries:
+                # This directory should be a package, and thus added to
+                # the list
+                if os.path.isfile(osutils.pathjoin(path, entry)):
+                    break
+            else: # This directory is not a package
+                continue
+        else:
+            for suffix_info in imp.get_suffixes():
+                if f.endswith(suffix_info[0]):
+                    f = f[:-len(suffix_info[0])]
+                    if suffix_info[2] == imp.C_EXTENSION and f.endswith('module'):
+                        f = f[:-len('module')]
+                    break
             else:
-                plugin_names.add(name)
+                continue
+        if f == '__init__':
+            continue # We don't load __init__.py again in the plugin dir
+        elif getattr(_mod_plugins, f, None):
+            trace.mutter('Plugin name %s already loaded', f)
+        else:
+            # trace.mutter('add plugin name %s', f)
+            plugin_names.add(f)
 
     for name in plugin_names:
-        _load_plugin_module(name, d)
+        try:
+            exec "import bzrlib.plugins.%s" % name in {}
+        except KeyboardInterrupt:
+            raise
+        except errors.IncompatibleAPI, e:
+            trace.warning("Unable to load plugin %r. It requested API version "
+                "%s of module %s but the minimum exported version is %s, and "
+                "the maximum is %s" %
+                (name, e.wanted, e.api, e.minimum, e.current))
+        except Exception, e:
+            trace.warning("%s" % e)
+            ## import pdb; pdb.set_trace()
+            if re.search('\.|-| ', name):
+                sanitised_name = re.sub('[-. ]', '_', name)
+                if sanitised_name.startswith('bzr_'):
+                    sanitised_name = sanitised_name[len('bzr_'):]
+                trace.warning("Unable to load %r in %r as a plugin because the "
+                        "file path isn't a valid module name; try renaming "
+                        "it to %r." % (name, d, sanitised_name))
+            else:
+                trace.warning('Unable to load plugin %r from %r' % (name, d))
+            trace.log_exception_quietly()
+            if 'error' in debug.debug_flags:
+                trace.print_exception(sys.exc_info(), sys.stderr)
 
 
 def plugins():
@@ -523,77 +477,3 @@
         return version_string
 
     __version__ = property(_get__version__)
-
-
-class _PluginImporter(object):
-    """An importer tailored to bzr specific needs.
-
-    This is a singleton that takes care of:
-    - disabled plugins specified in 'blacklist',
-    - plugins that needs to be loaded from specific directories.
-    """
-
-    def __init__(self):
-        self.reset()
-
-    def reset(self):
-        self.blacklist = set()
-        self.specific_paths = {}
-
-    def find_module(self, fullname, parent_path=None):
-        """Search a plugin module.
-
-        Disabled plugins raise an import error, plugins with specific paths
-        returns a specific loader.
-
-        :return: None if the plugin doesn't need special handling, self
-            otherwise.
-        """
-        if not fullname.startswith('bzrlib.plugins.'):
-            return None
-        if fullname in self.blacklist:
-            raise ImportError('%s is disabled' % fullname)
-        if fullname in self.specific_paths:
-            return self
-        return None
-
-    def load_module(self, fullname):
-        """Load a plugin from a specific directory."""
-        # We are called only for specific paths
-        plugin_path = self.specific_paths[fullname]
-        loading_path = None
-        package = False
-        if os.path.isdir(plugin_path):
-            for suffix, mode, kind in imp.get_suffixes():
-                if kind not in (imp.PY_SOURCE, imp.PY_COMPILED):
-                    # We don't recognize compiled modules (.so, .dll, etc)
-                    continue
-                init_path = osutils.pathjoin(plugin_path, '__init__' + suffix)
-                if os.path.isfile(init_path):
-                    loading_path = init_path
-                    package = True
-                    break
-        else:
-            for suffix, mode, kind in imp.get_suffixes():
-                if plugin_path.endswith(suffix):
-                    loading_path = plugin_path
-                    break
-        if loading_path is None:
-            raise ImportError('%s cannot be loaded from %s'
-                              % (fullname, plugin_path))
-        f = open(loading_path, mode)
-        try:
-            mod = imp.load_module(fullname, f, loading_path,
-                                  (suffix, mode, kind))
-            if package:
-                # The plugin can contain modules, so be ready
-                mod.__path__ = [plugin_path]
-            mod.__package__ = fullname
-            return mod
-        finally:
-            f.close()
-
-
-# Install a dedicated importer for plugins requiring special handling
-PluginImporter = _PluginImporter()
-sys.meta_path.append(PluginImporter)

=== modified file 'bzrlib/plugins/launchpad/__init__.py'
--- bzrlib/plugins/launchpad/__init__.py	2010-04-02 19:12:58 +0000
+++ bzrlib/plugins/launchpad/__init__.py	2009-12-17 04:35:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 - 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,7 +17,7 @@
 """Launchpad.net integration plugin for Bazaar."""
 
 # The XMLRPC server address can be overridden by setting the environment
-# variable $BZR_LP_XMLRPC_URL
+# variable $BZR_LP_XMLRPL_URL
 
 # see http://bazaar-vcs.org/Specs/BranchRegistrationTool
 
@@ -32,11 +32,7 @@
     )
 """)
 
-from bzrlib import bzrdir
-from bzrlib.commands import (
-        Command,
-        register_command,
-)
+from bzrlib.commands import Command, Option, register_command
 from bzrlib.directory_service import directories
 from bzrlib.errors import (
     BzrCommandError,
@@ -46,14 +42,10 @@
     NotBranchError,
     )
 from bzrlib.help_topics import topic_registry
-from bzrlib.option import (
-        Option,
-        ListOption,
-)
 
 
 class cmd_register_branch(Command):
-    __doc__ = """Register a branch with launchpad.net.
+    """Register a branch with launchpad.net.
 
     This command lists a bzr branch in the directory of branches on
     launchpad.net.  Registration allows the branch to be associated with
@@ -161,7 +153,7 @@
 
 
 class cmd_launchpad_open(Command):
-    __doc__ = """Open a Launchpad branch page in your web browser."""
+    """Open a Launchpad branch page in your web browser."""
 
     aliases = ['lp-open']
     takes_options = [
@@ -211,7 +203,7 @@
 
 
 class cmd_launchpad_login(Command):
-    __doc__ = """Show or set the Launchpad user ID.
+    """Show or set the Launchpad user ID.
 
     When communicating with Launchpad, some commands need to know your
     Launchpad user ID.  This command can be used to set or show the
@@ -267,7 +259,7 @@
 
 # XXX: cmd_launchpad_mirror is untested
 class cmd_launchpad_mirror(Command):
-    __doc__ = """Ask Launchpad to mirror a branch now."""
+    """Ask Launchpad to mirror a branch now."""
 
     aliases = ['lp-mirror']
     takes_args = ['location?']
@@ -285,67 +277,6 @@
 register_command(cmd_launchpad_mirror)
 
 
-class cmd_lp_propose_merge(Command):
-    __doc__ = """Propose merging a branch on Launchpad.
-
-    This will open your usual editor to provide the initial comment.  When it
-    has created the proposal, it will open it in your default web browser.
-
-    The branch will be proposed to merge into SUBMIT_BRANCH.  If SUBMIT_BRANCH
-    is not supplied, the remembered submit branch will be used.  If no submit
-    branch is remembered, the development focus will be used.
-
-    By default, the SUBMIT_BRANCH's review team will be requested to review
-    the merge proposal.  This can be overriden by specifying --review (-R).
-    The parameter the launchpad account name of the desired reviewer.  This
-    may optionally be followed by '=' and the review type.  For example:
-
-      bzr lp-propose-merge --review jrandom --review review-team=qa
-
-    This will propose a merge,  request "jrandom" to perform a review of
-    unspecified type, and request "review-team" to perform a "qa" review.
-    """
-
-    takes_options = [Option('staging',
-                            help='Propose the merge on staging.'),
-                     Option('message', short_name='m', type=unicode,
-                            help='Commit message.'),
-                     ListOption('review', short_name='R', type=unicode,
-                            help='Requested reviewer and optional type.')]
-
-    takes_args = ['submit_branch?']
-
-    aliases = ['lp-submit', 'lp-propose']
-
-    def run(self, submit_branch=None, review=None, staging=False,
-            message=None):
-        from bzrlib.plugins.launchpad import lp_propose
-        tree, branch, relpath = bzrdir.BzrDir.open_containing_tree_or_branch(
-            '.')
-        if review is None:
-            reviews = None
-        else:
-            reviews = []
-            for review in review:
-                if '=' in review:
-                    reviews.append(review.split('=', 2))
-                else:
-                    reviews.append((review, ''))
-            if submit_branch is None:
-                submit_branch = branch.get_submit_branch()
-        if submit_branch is None:
-            target = None
-        else:
-            target = _mod_branch.Branch.open(submit_branch)
-        proposer = lp_propose.Proposer(tree, branch, target, message,
-                                       reviews, staging)
-        proposer.check_proposal()
-        proposer.create_proposal()
-
-
-register_command(cmd_lp_propose_merge)
-
-
 def _register_directory():
     directories.register_lazy('lp:', 'bzrlib.plugins.launchpad.lp_directory',
                               'LaunchpadDirectory',

=== modified file 'bzrlib/plugins/launchpad/lp_api.py'
--- bzrlib/plugins/launchpad/lp_api.py	2010-03-05 08:55:12 +0000
+++ bzrlib/plugins/launchpad/lp_api.py	2009-12-17 03:40:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,15 +22,11 @@
 
 
 import os
-import re
 
 from bzrlib import (
-    branch,
     config,
     errors,
     osutils,
-    trace,
-    transport,
     )
 from bzrlib.plugins.launchpad.lp_registration import (
     InvalidLaunchpadInstance,
@@ -116,149 +112,6 @@
     return launchpad
 
 
-class LaunchpadBranch(object):
-    """Provide bzr and lp API access to a Launchpad branch."""
-
-    def __init__(self, lp_branch, bzr_url, bzr_branch=None, check_update=True):
-        """Constructor.
-
-        :param lp_branch: The Launchpad branch.
-        :param bzr_url: The URL of the Bazaar branch.
-        :param bzr_branch: An instance of the Bazaar branch.
-        """
-        self.bzr_url = bzr_url
-        self._bzr = bzr_branch
-        self._push_bzr = None
-        self._check_update = check_update
-        self.lp = lp_branch
-
-    @property
-    def bzr(self):
-        """Return the bzr branch for this branch."""
-        if self._bzr is None:
-            self._bzr = branch.Branch.open(self.bzr_url)
-        return self._bzr
-
-    @property
-    def push_bzr(self):
-        """Return the push branch for this branch."""
-        if self._push_bzr is None:
-            self._push_bzr = branch.Branch.open(self.lp.bzr_identity)
-        return self._push_bzr
-
-    @staticmethod
-    def plausible_launchpad_url(url):
-        """Is 'url' something that could conceivably be pushed to LP?
-
-        :param url: A URL that may refer to a Launchpad branch.
-        :return: A boolean.
-        """
-        if url is None:
-            return False
-        if url.startswith('lp:'):
-            return True
-        regex = re.compile('([a-z]*\+)*(bzr\+ssh|http)'
-                           '://bazaar.*.launchpad.net')
-        return bool(regex.match(url))
-
-    @staticmethod
-    def candidate_urls(bzr_branch):
-        """Iterate through related URLs that might be Launchpad URLs.
-
-        :param bzr_branch: A Bazaar branch to find URLs from.
-        :return: a generator of URL strings.
-        """
-        url = bzr_branch.get_public_branch()
-        if url is not None:
-            yield url
-        url = bzr_branch.get_push_location()
-        if url is not None:
-            yield url
-        yield bzr_branch.base
-
-    @staticmethod
-    def tweak_url(url, launchpad):
-        """Adjust a URL to work with staging, if needed."""
-        if str(launchpad._root_uri) != STAGING_SERVICE_ROOT:
-            return url
-        if url is None:
-            return None
-        return url.replace('bazaar.launchpad.net',
-                           'bazaar.staging.launchpad.net')
-
-    @classmethod
-    def from_bzr(cls, launchpad, bzr_branch):
-        """Find a Launchpad branch from a bzr branch."""
-        check_update = True
-        for url in cls.candidate_urls(bzr_branch):
-            url = cls.tweak_url(url, launchpad)
-            if not cls.plausible_launchpad_url(url):
-                continue
-            lp_branch = launchpad.branches.getByUrl(url=url)
-            if lp_branch is not None:
-                break
-        else:
-            lp_branch = cls.create_now(launchpad, bzr_branch)
-            check_update = False
-        return cls(lp_branch, bzr_branch.base, bzr_branch, check_update)
-
-    @classmethod
-    def create_now(cls, launchpad, bzr_branch):
-        """Create a Bazaar branch on Launchpad for the supplied branch."""
-        url = cls.tweak_url(bzr_branch.get_push_location(), launchpad)
-        if not cls.plausible_launchpad_url(url):
-            raise errors.BzrError('%s is not registered on Launchpad' %
-                                  bzr_branch.base)
-        bzr_branch.create_clone_on_transport(transport.get_transport(url))
-        lp_branch = launchpad.branches.getByUrl(url=url)
-        if lp_branch is None:
-            raise errors.BzrError('%s is not registered on Launchpad' % url)
-        return lp_branch
-
-    def get_dev_focus(self):
-        """Return the 'LaunchpadBranch' for the dev focus of this one."""
-        lp_branch = self.lp
-        if lp_branch.project is None:
-            raise errors.BzrError('%s has no product.' %
-                                  lp_branch.bzr_identity)
-        dev_focus = lp_branch.project.development_focus.branch
-        if dev_focus is None:
-            raise errors.BzrError('%s has no development focus.' %
-                                  lp_branch.bzr_identity)
-        return LaunchpadBranch(dev_focus, dev_focus.bzr_identity)
-
-    def update_lp(self):
-        """Update the Launchpad copy of this branch."""
-        if not self._check_update:
-            return
-        self.bzr.lock_read()
-        try:
-            if self.lp.last_scanned_id is not None:
-                if self.bzr.last_revision() == self.lp.last_scanned_id:
-                    trace.note('%s is already up-to-date.' %
-                               self.lp.bzr_identity)
-                    return
-                graph = self.bzr.repository.get_graph()
-                if not graph.is_ancestor(self.lp.last_scanned_id,
-                                         self.bzr.last_revision()):
-                    raise errors.DivergedBranches(self.bzr, self.push_bzr)
-                trace.note('Pushing to %s' % self.lp.bzr_identity)
-            self.bzr.push(self.push_bzr)
-        finally:
-            self.bzr.unlock()
-
-    def find_lca_tree(self, other):
-        """Find the revision tree for the LCA of this branch and other.
-
-        :param other: Another LaunchpadBranch
-        :return: The RevisionTree of the LCA of this branch and other.
-        """
-        graph = self.bzr.repository.get_graph(other.bzr.repository)
-        lca = graph.find_unique_lca(self.bzr.last_revision(),
-                                    other.bzr.last_revision())
-        return self.bzr.repository.revision_tree(lca)
-
-
 def load_branch(launchpad, branch):
     """Return the launchpadlib Branch object corresponding to 'branch'.
 

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2010-03-30 11:05:14 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2009-07-03 14:24:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,13 +17,14 @@
 
 """Directory lookup that uses Launchpad."""
 
-from urlparse import urlsplit
+from urlparse import urlsplit, urlunsplit
 import xmlrpclib
 
 from bzrlib import (
     debug,
     errors,
     trace,
+    urlutils,
     )
 from bzrlib.transport import (
     get_transport,

=== removed file 'bzrlib/plugins/launchpad/lp_propose.py'
--- bzrlib/plugins/launchpad/lp_propose.py	2010-04-26 13:51:08 +0000
+++ bzrlib/plugins/launchpad/lp_propose.py	1970-01-01 00:00:00 +0000
@@ -1,211 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-
-import urlparse
-import webbrowser
-
-from bzrlib import (
-    errors,
-    hooks,
-    msgeditor,
-)
-from bzrlib.plugins.launchpad import (
-    lp_api,
-    lp_registration,
-)
-
-from lazr.restfulclient import errors as restful_errors
-
-
-class ProposeMergeHooks(hooks.Hooks):
-    """Hooks for proposing a merge on Launchpad."""
-
-    def __init__(self):
-        hooks.Hooks.__init__(self)
-        self.create_hook(
-            hooks.HookPoint(
-                'get_prerequisite',
-                "Return the prerequisite branch for proposing as merge.",
-                (2, 1), None),
-        )
-        self.create_hook(
-            hooks.HookPoint(
-                'merge_proposal_body',
-                "Return an initial body for the merge proposal message.",
-                (2, 1), None),
-        )
-
-
-class Proposer(object):
-
-    hooks = ProposeMergeHooks()
-
-    def __init__(self, tree, source_branch, target_branch, message, reviews,
-                 staging=False):
-        """Constructor.
-
-        :param tree: The working tree for the source branch.
-        :param source_branch: The branch to propose for merging.
-        :param target_branch: The branch to merge into.
-        :param message: The commit message to use.  (May be None.)
-        :param reviews: A list of tuples of reviewer, review type.
-        :param staging: If True, propose the merge against staging instead of
-            production.
-        """
-        self.tree = tree
-        if staging:
-            lp_instance = 'staging'
-        else:
-            lp_instance = 'edge'
-        service = lp_registration.LaunchpadService(lp_instance=lp_instance)
-        self.launchpad = lp_api.login(service)
-        self.source_branch = lp_api.LaunchpadBranch.from_bzr(
-            self.launchpad, source_branch)
-        if target_branch is None:
-            self.target_branch = self.source_branch.get_dev_focus()
-        else:
-            self.target_branch = lp_api.LaunchpadBranch.from_bzr(
-                self.launchpad, target_branch)
-        self.commit_message = message
-        if reviews == []:
-            target_reviewer = self.target_branch.lp.reviewer
-            if target_reviewer is None:
-                raise errors.BzrCommandError('No reviewer specified')
-            self.reviews = [(target_reviewer, '')]
-        else:
-            self.reviews = [(self.launchpad.people[reviewer], review_type)
-                            for reviewer, review_type in
-                            reviews]
-
-    def get_comment(self, prerequisite_branch):
-        """Determine the initial comment for the merge proposal."""
-        info = ["Source: %s\n" % self.source_branch.lp.bzr_identity]
-        info.append("Target: %s\n" % self.target_branch.lp.bzr_identity)
-        if prerequisite_branch is not None:
-            info.append("Prereq: %s\n" % prerequisite_branch.lp.bzr_identity)
-        for rdata in self.reviews:
-            uniquename = "%s (%s)" % (rdata[0].display_name, rdata[0].name)
-            info.append('Reviewer: %s, type "%s"\n' % (uniquename, rdata[1]))
-        self.source_branch.bzr.lock_read()
-        try:
-            self.target_branch.bzr.lock_read()
-            try:
-                body = self.get_initial_body()
-            finally:
-                self.target_branch.bzr.unlock()
-        finally:
-            self.source_branch.bzr.unlock()
-        initial_comment = msgeditor.edit_commit_message(''.join(info),
-                                                        start_message=body)
-        return initial_comment.strip().encode('utf-8')
-
-    def get_initial_body(self):
-        """Get a body for the proposal for the user to modify.
-
-        :return: a str or None.
-        """
-        def list_modified_files():
-            lca_tree = self.source_branch.find_lca_tree(
-                self.target_branch)
-            source_tree = self.source_branch.bzr.basis_tree()
-            files = modified_files(lca_tree, source_tree)
-            return list(files)
-        target_loc = ('bzr+ssh://bazaar.launchpad.net/%s' %
-                       self.target_branch.lp.unique_name)
-        body = None
-        for hook in self.hooks['merge_proposal_body']:
-            body = hook({
-                'tree': self.tree,
-                'target_branch': target_loc,
-                'modified_files_callback': list_modified_files,
-                'old_body': body,
-            })
-        return body
-
-    def check_proposal(self):
-        """Check that the submission is sensible."""
-        if self.source_branch.lp.self_link == self.target_branch.lp.self_link:
-            raise errors.BzrCommandError(
-                'Source and target branches must be different.')
-        for mp in self.source_branch.lp.landing_targets:
-            if mp.queue_status in ('Merged', 'Rejected'):
-                continue
-            if mp.target_branch.self_link == self.target_branch.lp.self_link:
-                raise errors.BzrCommandError(
-                    'There is already a branch merge proposal: %s' %
-                    canonical_url(mp))
-
-    def _get_prerequisite_branch(self):
-        hooks = self.hooks['get_prerequisite']
-        prerequisite_branch = None
-        for hook in hooks:
-            prerequisite_branch = hook(
-                {'launchpad': self.launchpad,
-                 'source_branch': self.source_branch,
-                 'target_branch': self.target_branch,
-                 'prerequisite_branch': prerequisite_branch})
-        return prerequisite_branch
-
-    def create_proposal(self):
-        """Perform the submission."""
-        prerequisite_branch = self._get_prerequisite_branch()
-        if prerequisite_branch is None:
-            prereq = None
-        else:
-            prereq = prerequisite_branch.lp
-            prerequisite_branch.update_lp()
-        self.source_branch.update_lp()
-        reviewers = []
-        review_types = []
-        for reviewer, review_type in self.reviews:
-            review_types.append(review_type)
-            reviewers.append(reviewer.self_link)
-        initial_comment = self.get_comment(prerequisite_branch)
-        try:
-            mp = self.source_branch.lp.createMergeProposal(
-                target_branch=self.target_branch.lp,
-                prerequisite_branch=prereq,
-                initial_comment=initial_comment,
-                commit_message=self.commit_message, reviewers=reviewers,
-                review_types=review_types)
-        except restful_errors.HTTPError, e:
-            error_lines = []
-            for line in e.content.splitlines():
-                if line.startswith('Traceback (most recent call last):'):
-                    break
-                error_lines.append(line)
-            raise Exception(''.join(error_lines))
-        else:
-            webbrowser.open(canonical_url(mp))
-
-
-def modified_files(old_tree, new_tree):
-    """Return a list of paths in the new tree with modified contents."""
-    for f, (op, path), c, v, p, n, (ok, k), e in new_tree.iter_changes(
-        old_tree):
-        if c and k == 'file':
-            yield str(path)
-
-
-def canonical_url(object):
-    """Return the canonical URL for a branch."""
-    scheme, netloc, path, params, query, fragment = urlparse.urlparse(
-        str(object.self_link))
-    path = '/'.join(path.split('/')[2:])
-    netloc = netloc.replace('api.', 'code.')
-    return urlparse.urlunparse((scheme, netloc, path, params, query,
-                                fragment))

=== modified file 'bzrlib/plugins/launchpad/lp_registration.py'
--- bzrlib/plugins/launchpad/lp_registration.py	2010-02-23 07:43:11 +0000
+++ bzrlib/plugins/launchpad/lp_registration.py	2009-12-09 09:20:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -81,7 +81,7 @@
 class LaunchpadService(object):
     """A service to talk to Launchpad via XMLRPC.
 
-    See http://wiki.bazaar.canonical.com/Specs/LaunchpadRpc for the methods we can call.
+    See http://bazaar-vcs.org/Specs/LaunchpadRpc for the methods we can call.
     """
 
     LAUNCHPAD_DOMAINS = {

=== modified file 'bzrlib/plugins/launchpad/test_lp_api.py'
--- bzrlib/plugins/launchpad/test_lp_api.py	2010-03-05 08:55:12 +0000
+++ bzrlib/plugins/launchpad/test_lp_api.py	2009-12-17 04:35:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,7 +39,9 @@
 
     def patch(self, obj, name, value):
         """Temporarily set the 'name' attribute of 'obj' to 'value'."""
-        self.overrideAttr(obj, name, value)
+        real_value = getattr(obj, name)
+        setattr(obj, name, value)
+        self.addCleanup(setattr, obj, name, real_value)
 
     def test_get_launchpadlib_version(self):
         # parse_launchpadlib_version returns a tuple of a version number of

=== modified file 'bzrlib/plugins/launchpad/test_lp_directory.py'
--- bzrlib/plugins/launchpad/test_lp_directory.py	2010-02-23 07:43:11 +0000
+++ bzrlib/plugins/launchpad/test_lp_directory.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -216,7 +216,7 @@
         directories.remove('lp:')
         directories.register('lp:', FooService, 'Map lp URLs to local urls')
         self.addCleanup(_register_directory)
-        self.addCleanup(directories.remove, 'lp:')
+        self.addCleanup(lambda: directories.remove('lp:'))
         transport = get_transport('lp:///apt')
         branch = Branch.open_from_transport(transport)
         self.assertEqual(target_branch.base, branch.base)

=== modified file 'bzrlib/plugins/launchpad/test_lp_open.py'
--- bzrlib/plugins/launchpad/test_lp_open.py	2010-02-17 17:11:16 +0000
+++ bzrlib/plugins/launchpad/test_lp_open.py	2009-12-08 10:04:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/plugins/netrc_credential_store/__init__.py'
--- bzrlib/plugins/netrc_credential_store/__init__.py	2010-04-23 08:51:52 +0000
+++ bzrlib/plugins/netrc_credential_store/__init__.py	2009-04-10 18:56:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-__doc__ = """Use ~/.netrc as a credential store for authentication.conf."""
+"""Use ~/.netrc as a credential store for authentication.conf."""
 
 # Since we are a built-in plugin we share the bzrlib version
 from bzrlib import version_info

=== removed directory 'bzrlib/plugins/news_merge'
=== removed file 'bzrlib/plugins/news_merge/README'
--- bzrlib/plugins/news_merge/README	2010-01-20 16:05:28 +0000
+++ bzrlib/plugins/news_merge/README	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-A plugin for merging bzr's NEWS file.
-
-This plugin is activated via configuration variables, see 'bzr help news_merge'.
-
-This hook can resolve conflicts where both sides add entries at the same place.
-If it encounters a more difficult conflict it gives up and bzr will fallback to
-the default merge algorithm.

=== removed file 'bzrlib/plugins/news_merge/__init__.py'
--- bzrlib/plugins/news_merge/__init__.py	2010-05-03 04:08:50 +0000
+++ bzrlib/plugins/news_merge/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,65 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-__doc__ = """Merge hook for bzr's NEWS file.
-
-To enable this plugin, add a section to your branch.conf or location.conf
-like::
-
-    [/home/user/code/bzr]
-    news_merge_files = NEWS
-
-The news_merge_files config option takes a list of file paths, separated by
-commas.
-
-Limitations:
-
-* if there's a conflict in more than just bullet points, this doesn't yet know
-  how to resolve that, so bzr will fallback to the default line-based merge.
-"""
-
-# Since we are a built-in plugin we share the bzrlib version
-from bzrlib import version_info
-
-# Put most of the code in a separate module that we lazy-import to keep the
-# overhead of this plugin as minimal as possible.
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
-from bzrlib.plugins.news_merge import news_merge as _mod_news_merge
-""")
-
-from bzrlib.merge import Merger
-
-
-def news_merge_hook(merger):
-    """Merger.merge_file_content hook for bzr-format NEWS files."""
-    return _mod_news_merge.NewsMerger(merger)
-
-
-def install_hook():
-    Merger.hooks.install_named_hook(
-        'merge_file_content', news_merge_hook, 'NEWS file merge')
-install_hook()
-
-
-def load_tests(basic_tests, module, loader):
-    testmod_names = [
-        'tests',
-        ]
-    basic_tests.addTest(loader.loadTestsFromModuleNames(
-            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
-    return basic_tests
-

=== removed file 'bzrlib/plugins/news_merge/news_merge.py'
--- bzrlib/plugins/news_merge/news_merge.py	2010-04-20 01:53:31 +0000
+++ bzrlib/plugins/news_merge/news_merge.py	1970-01-01 00:00:00 +0000
@@ -1,76 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Merge logic for news_merge plugin."""
-
-
-from bzrlib.plugins.news_merge.parser import simple_parse_lines
-from bzrlib import merge, merge3
-
-
-class NewsMerger(merge.ConfigurableFileMerger):
-    """Merge bzr NEWS files."""
-
-    name_prefix = "news"
-
-    def merge_text(self, params):
-        """Perform a simple 3-way merge of a bzr NEWS file.
-        
-        Each section of a bzr NEWS file is essentially an ordered set of bullet
-        points, so we can simply take a set of bullet points, determine which
-        bullets to add and which to remove, sort, and reserialize.
-        """
-        # Transform the different versions of the NEWS file into a bunch of
-        # text lines where each line matches one part of the overall
-        # structure, e.g. a heading or bullet.
-        this_lines = list(simple_parse_lines(params.this_lines))
-        other_lines = list(simple_parse_lines(params.other_lines))
-        base_lines = list(simple_parse_lines(params.base_lines))
-        m3 = merge3.Merge3(base_lines, this_lines, other_lines,
-            allow_objects=True)
-        result_chunks = []
-        for group in m3.merge_groups():
-            if group[0] == 'conflict':
-                _, base, a, b = group
-                # Are all the conflicting lines bullets?  If so, we can merge
-                # this.
-                for line_set in [base, a, b]:
-                    for line in line_set:
-                        if line[0] != 'bullet':
-                            # Something else :(
-                            # Maybe the default merge can cope.
-                            return 'not_applicable', None
-                # Calculate additions and deletions.
-                new_in_a = set(a).difference(base)
-                new_in_b = set(b).difference(base)
-                all_new = new_in_a.union(new_in_b)
-                deleted_in_a = set(base).difference(a)
-                deleted_in_b = set(base).difference(b)
-                # Combine into the final set of bullet points.
-                final = all_new.difference(deleted_in_a).difference(
-                    deleted_in_b)
-                # Sort, and emit.
-                final = sorted(final, key=sort_key)
-                result_chunks.extend(final)
-            else:
-                result_chunks.extend(group[1])
-        # Transform the merged elements back into real blocks of lines.
-        result_lines = '\n\n'.join(chunk[1] for chunk in result_chunks)
-        return 'success', result_lines
-
-
-def sort_key(chunk):
-    return chunk[1].replace('`', '').lower()

=== removed file 'bzrlib/plugins/news_merge/parser.py'
--- bzrlib/plugins/news_merge/parser.py	2010-04-19 05:41:54 +0000
+++ bzrlib/plugins/news_merge/parser.py	1970-01-01 00:00:00 +0000
@@ -1,69 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Simple parser for bzr's NEWS file.
-
-Simple as this is, it's a bit over-powered for news_merge's needs, which only
-cares about 'bullet' and 'everything else'.
-
-This module can be run as a standalone Python program; pass it a filename and
-it will print the parsed form of a file (a series of 2-tuples, see
-simple_parse's docstring).
-"""
-
-
-def simple_parse_lines(lines):
-    """Same as simple_parse, but takes an iterable of strs rather than a single
-    str.
-    """
-    return simple_parse(''.join(lines))
-
-
-def simple_parse(content):
-    """Returns blocks, where each block is a 2-tuple (kind, text).
-    
-    :kind: one of 'heading', 'release', 'section', 'empty' or 'text'.
-    :text: a str, including newlines.
-    """
-    blocks = content.split('\n\n')
-    for block in blocks:
-        if block.startswith('###'):
-            # First line is ###...: Top heading
-            yield 'heading', block
-            continue
-        last_line = block.rsplit('\n', 1)[-1]
-        if last_line.startswith('###'):
-            # last line is ###...: 2nd-level heading
-            yield 'release', block
-        elif last_line.startswith('***'):
-            # last line is ***...: 3rd-level heading
-            yield 'section', block
-        elif block.startswith('* '):
-            # bullet
-            yield 'bullet', block
-        elif block.strip() == '':
-            # empty
-            yield 'empty', block
-        else:
-            # plain text
-            yield 'text', block
-
-
-if __name__ == '__main__':
-    import sys
-    content = open(sys.argv[1], 'rb').read()
-    for result in simple_parse(content):
-        print result

=== removed directory 'bzrlib/plugins/news_merge/tests'
=== removed file 'bzrlib/plugins/news_merge/tests/__init__.py'
--- bzrlib/plugins/news_merge/tests/__init__.py	2010-01-20 16:05:28 +0000
+++ bzrlib/plugins/news_merge/tests/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-# Copyright (C) 2010 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-def load_tests(basic_tests, module, loader):
-    testmod_names = [
-        'test_news_merge',
-        ]
-    basic_tests.addTest(loader.loadTestsFromModuleNames(
-            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
-    return basic_tests

=== removed file 'bzrlib/plugins/news_merge/tests/test_news_merge.py'
--- bzrlib/plugins/news_merge/tests/test_news_merge.py	2010-01-29 08:28:47 +0000
+++ bzrlib/plugins/news_merge/tests/test_news_merge.py	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-# Copyright (C) 2010 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-# FIXME: This is totally incomplete but I'm only the patch pilot :-)
-# -- vila 100120
-# Note that the single test from this file is now in
-# test_merge.TestConfigurableFileMerger -- rbc 20100129.
-
-from bzrlib import (
-    option,
-    tests,
-    )
-from bzrlib.merge import Merger
-from bzrlib.plugins import news_merge

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2010-04-30 11:03:59 +0000
+++ bzrlib/progress.py	2009-10-15 02:19:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,7 +27,12 @@
 import os
 
 
+from bzrlib import (
+    errors,
+    )
+from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import (
+    deprecated_function,
     deprecated_in,
     deprecated_method,
     )
@@ -179,6 +184,33 @@
             self.ui_factory.clear_term()
 
 
+@deprecated_function(deprecated_in((1, 16, 0)))
+def ProgressBar(to_file=None, **kwargs):
+    """Construct a progress bar.
+
+    Deprecated; ask the ui_factory for a progress task instead.
+    """
+    if to_file is None:
+        to_file = sys.stderr
+    requested_bar_type = os.environ.get('BZR_PROGRESS_BAR')
+    # An value of '' or not set reverts to standard processing
+    if requested_bar_type in (None, ''):
+        if _supports_progress(to_file):
+            return TTYProgressBar(to_file=to_file, **kwargs)
+        else:
+            return DummyProgress(to_file=to_file, **kwargs)
+    else:
+        # Minor sanitation to prevent spurious errors
+        requested_bar_type = requested_bar_type.lower().strip()
+        # TODO: jam 20060710 Arguably we shouldn't raise an exception
+        #       but should instead just disable progress bars if we
+        #       don't recognize the type
+        if requested_bar_type not in _progress_bar_types:
+            raise errors.InvalidProgressBarType(requested_bar_type,
+                                                _progress_bar_types.keys())
+        return _progress_bar_types[requested_bar_type](to_file=to_file, **kwargs)
+
+
 # NOTE: This is also deprecated; you should provide a ProgressView instead.
 class _BaseProgressBar(object):
 
@@ -226,15 +258,16 @@
         self.to_messages_file.write(fmt_string % args)
         self.to_messages_file.write('\n')
 
-
-class DummyProgress(object):
+    @deprecated_function(deprecated_in((1, 16, 0)))
+    def child_progress(self, **kwargs):
+        return ChildProgress(**kwargs)
+
+
+class DummyProgress(_BaseProgressBar):
     """Progress-bar standin that does nothing.
 
-    This was previously often constructed by application code if no progress
-    bar was explicitly passed in.  That's no longer recommended: instead, just
-    create a progress task from the ui_factory.  This class can be used in
-    test code that needs to fake a progress task for some reason.
-    """
+    This can be used as the default argument for methods that
+    take an optional progress indicator."""
 
     def tick(self):
         pass
@@ -255,6 +288,264 @@
         return DummyProgress(**kwargs)
 
 
+class DotsProgressBar(_BaseProgressBar):
+
+    @deprecated_function(deprecated_in((1, 16, 0)))
+    def __init__(self, **kwargs):
+        _BaseProgressBar.__init__(self, **kwargs)
+        self.last_msg = None
+        self.need_nl = False
+
+    def tick(self):
+        self.update()
+
+    def update(self, msg=None, current_cnt=None, total_cnt=None):
+        if msg and msg != self.last_msg:
+            if self.need_nl:
+                self.to_file.write('\n')
+            self.to_file.write(msg + ': ')
+            self.last_msg = msg
+        self.need_nl = True
+        self.to_file.write('.')
+
+    def clear(self):
+        if self.need_nl:
+            self.to_file.write('\n')
+        self.need_nl = False
+
+    def child_update(self, message, current, total):
+        self.tick()
+
+
+class TTYProgressBar(_BaseProgressBar):
+    """Progress bar display object.
+
+    Several options are available to control the display.  These can
+    be passed as parameters to the constructor or assigned at any time:
+
+    show_pct
+        Show percentage complete.
+    show_spinner
+        Show rotating baton.  This ticks over on every update even
+        if the values don't change.
+    show_eta
+        Show predicted time-to-completion.
+    show_bar
+        Show bar graph.
+    show_count
+        Show numerical counts.
+
+    The output file should be in line-buffered or unbuffered mode.
+    """
+    SPIN_CHARS = r'/-\|'
+
+    @deprecated_function(deprecated_in((1, 16, 0)))
+    def __init__(self, **kwargs):
+        from bzrlib.osutils import terminal_width
+        _BaseProgressBar.__init__(self, **kwargs)
+        self.spin_pos = 0
+        self.width = terminal_width()
+        self.last_updates = []
+        self._max_last_updates = 10
+        self.child_fraction = 0
+        self._have_output = False
+
+    def throttle(self, old_msg):
+        """Return True if the bar was updated too recently"""
+        # time.time consistently takes 40/4000 ms = 0.01 ms.
+        # time.clock() is faster, but gives us CPU time, not wall-clock time
+        now = time.time()
+        if self.start_time is not None and (now - self.start_time) < 1:
+            return True
+        if old_msg != self.last_msg:
+            return False
+        interval = now - self.last_update
+        # if interval > 0
+        if interval < self.MIN_PAUSE:
+            return True
+
+        self.last_updates.append(now - self.last_update)
+        # Don't let the queue grow without bound
+        self.last_updates = self.last_updates[-self._max_last_updates:]
+        self.last_update = now
+        return False
+
+    def tick(self):
+        self.update(self.last_msg, self.last_cnt, self.last_total,
+                    self.child_fraction)
+
+    def child_update(self, message, current, total):
+        if current is not None and total != 0:
+            child_fraction = float(current) / total
+            if self.last_cnt is None:
+                pass
+            elif self.last_cnt + child_fraction <= self.last_total:
+                self.child_fraction = child_fraction
+        if self.last_msg is None:
+            self.last_msg = ''
+        self.tick()
+
+    def update(self, msg, current_cnt=None, total_cnt=None,
+            child_fraction=0):
+        """Update and redraw progress bar.
+        """
+        if msg is None:
+            msg = self.last_msg
+
+        if total_cnt is None:
+            total_cnt = self.last_total
+
+        if current_cnt < 0:
+            current_cnt = 0
+
+        if current_cnt > total_cnt:
+            total_cnt = current_cnt
+
+        ## # optional corner case optimisation
+        ## # currently does not seem to fire so costs more than saved.
+        ## # trivial optimal case:
+        ## # NB if callers are doing a clear and restore with
+        ## # the saved values, this will prevent that:
+        ## # in that case add a restore method that calls
+        ## # _do_update or some such
+        ## if (self.last_msg == msg and
+        ##     self.last_cnt == current_cnt and
+        ##     self.last_total == total_cnt and
+        ##     self.child_fraction == child_fraction):
+        ##     return
+
+        if msg is None:
+            msg = ''
+
+        old_msg = self.last_msg
+        # save these for the tick() function
+        self.last_msg = msg
+        self.last_cnt = current_cnt
+        self.last_total = total_cnt
+        self.child_fraction = child_fraction
+
+        # each function call takes 20ms/4000 = 0.005 ms,
+        # but multiple that by 4000 calls -> starts to cost.
+        # so anything to make this function call faster
+        # will improve base 'diff' time by up to 0.1 seconds.
+        if self.throttle(old_msg):
+            return
+
+        if self.show_eta and self.start_time and self.last_total:
+            eta = get_eta(self.start_time, self.last_cnt + self.child_fraction,
+                    self.last_total, last_updates = self.last_updates)
+            eta_str = " " + str_tdelta(eta)
+        else:
+            eta_str = ""
+
+        if self.show_spinner:
+            spin_str = self.SPIN_CHARS[self.spin_pos % 4] + ' '
+        else:
+            spin_str = ''
+
+        # always update this; it's also used for the bar
+        self.spin_pos += 1
+
+        if self.show_pct and self.last_total and self.last_cnt:
+            pct = 100.0 * ((self.last_cnt + self.child_fraction) / self.last_total)
+            pct_str = ' (%5.1f%%)' % pct
+        else:
+            pct_str = ''
+
+        if not self.show_count:
+            count_str = ''
+        elif self.last_cnt is None:
+            count_str = ''
+        elif self.last_total is None:
+            count_str = ' %i' % (self.last_cnt)
+        else:
+            # make both fields the same size
+            t = '%i' % (self.last_total)
+            c = '%*i' % (len(t), self.last_cnt)
+            count_str = ' ' + c + '/' + t
+
+        if self.show_bar:
+            # progress bar, if present, soaks up all remaining space
+            cols = self.width - 1 - len(self.last_msg) - len(spin_str) - len(pct_str) \
+                   - len(eta_str) - len(count_str) - 3
+
+            if self.last_total:
+                # number of markers highlighted in bar
+                markers = int(round(float(cols) *
+                              (self.last_cnt + self.child_fraction) / self.last_total))
+                bar_str = '[' + ('=' * markers).ljust(cols) + '] '
+            elif False:
+                # don't know total, so can't show completion.
+                # so just show an expanded spinning thingy
+                m = self.spin_pos % cols
+                ms = (' ' * m + '*').ljust(cols)
+
+                bar_str = '[' + ms + '] '
+            else:
+                bar_str = ''
+        else:
+            bar_str = ''
+
+        m = spin_str + bar_str + self.last_msg + count_str \
+            + pct_str + eta_str
+        self.to_file.write('\r%-*.*s' % (self.width - 1, self.width - 1, m))
+        self._have_output = True
+        #self.to_file.flush()
+
+    def clear(self):
+        if self._have_output:
+            self.to_file.write('\r%s\r' % (' ' * (self.width - 1)))
+        self._have_output = False
+        #self.to_file.flush()
+
+
+
+# DEPRECATED
+class ChildProgress(_BaseProgressBar):
+    """A progress indicator that pushes its data to the parent"""
+
+    @deprecated_function(deprecated_in((1, 16, 0)))
+    def __init__(self, _stack, **kwargs):
+        _BaseProgressBar.__init__(self, _stack=_stack, **kwargs)
+        self.parent = _stack.top()
+        self.current = None
+        self.total = None
+        self.child_fraction = 0
+        self.message = None
+
+    def update(self, msg, current_cnt=None, total_cnt=None):
+        self.current = current_cnt
+        if total_cnt is not None:
+            self.total = total_cnt
+        self.message = msg
+        self.child_fraction = 0
+        self.tick()
+
+    def child_update(self, message, current, total):
+        if current is None or total == 0:
+            self.child_fraction = 0
+        else:
+            self.child_fraction = float(current) / total
+        self.tick()
+
+    def tick(self):
+        if self.current is None:
+            count = None
+        else:
+            count = self.current+self.child_fraction
+            if count > self.total:
+                if __debug__:
+                    mutter('clamping count of %d to %d' % (count, self.total))
+                count = self.total
+        self.parent.child_update(self.message, count, self.total)
+
+    def clear(self):
+        pass
+
+    def note(self, *args, **kwargs):
+        self.parent.note(*args, **kwargs)
+
+
 def str_tdelta(delt):
     if delt is None:
         return "-:--:--"
@@ -311,3 +602,10 @@
         else:
             self.cur_phase += 1
         self.pb.update(self.message, self.cur_phase, self.total)
+
+
+_progress_bar_types = {}
+_progress_bar_types['dummy'] = DummyProgress
+_progress_bar_types['none'] = DummyProgress
+_progress_bar_types['tty'] = TTYProgressBar
+_progress_bar_types['dots'] = DotsProgressBar

=== modified file 'bzrlib/push.py'
--- bzrlib/push.py	2010-04-30 11:03:59 +0000
+++ bzrlib/push.py	2009-12-25 13:47:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,8 @@
 """UI helper for the push command."""
 
 from bzrlib import (
+    builtins,
+    branch,
     bzrdir,
     errors,
     revision as _mod_revision,
@@ -108,12 +110,6 @@
                     "\nYou may supply --create-prefix to create all"
                     " leading parent directories."
                     % location)
-            # This shouldn't occur (because create_prefix is true, so
-            # create_clone_on_transport should be catching NoSuchFile and
-            # creating the missing directories) but if it does the original
-            # NoSuchFile error will be more informative than an
-            # UnboundLocalError for br_to.
-            raise
         except errors.TooManyRedirections:
             raise errors.BzrCommandError("Too many redirections trying "
                                          "to make %s." % location)

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2010-04-30 11:35:43 +0000
+++ bzrlib/reconcile.py	2009-09-24 04:54:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,11 +27,12 @@
 
 
 from bzrlib import (
-    cleanup,
     errors,
     ui,
+    repository,
+    repofmt,
     )
-from bzrlib.trace import mutter
+from bzrlib.trace import mutter, note
 from bzrlib.tsort import topo_sort
 from bzrlib.versionedfile import AdapterFactory, FulltextContentFactory
 
@@ -96,7 +97,7 @@
     def _reconcile_repository(self):
         self.repo = self.bzrdir.find_repository()
         ui.ui_factory.note('Reconciling repository %s' %
-            self.repo.user_url)
+            self.repo.bzrdir.root_transport.base)
         self.pb.update("Reconciling repository", 0, 1)
         repo_reconciler = self.repo.reconcile(thorough=True)
         self.inconsistent_parents = repo_reconciler.inconsistent_parents
@@ -119,16 +120,15 @@
         self.branch = a_branch
 
     def reconcile(self):
-        operation = cleanup.OperationWithCleanups(self._reconcile)
-        self.add_cleanup = operation.add_cleanup
-        operation.run_simple()
-
-    def _reconcile(self):
         self.branch.lock_write()
-        self.add_cleanup(self.branch.unlock)
-        self.pb = ui.ui_factory.nested_progress_bar()
-        self.add_cleanup(self.pb.finished)
-        self._reconcile_steps()
+        try:
+            self.pb = ui.ui_factory.nested_progress_bar()
+            try:
+                self._reconcile_steps()
+            finally:
+                self.pb.finished()
+        finally:
+            self.branch.unlock()
 
     def _reconcile_steps(self):
         self._reconcile_revision_history()
@@ -192,16 +192,15 @@
         garbage_inventories: The number of inventory objects without revisions
                              that were garbage collected.
         """
-        operation = cleanup.OperationWithCleanups(self._reconcile)
-        self.add_cleanup = operation.add_cleanup
-        operation.run_simple()
-
-    def _reconcile(self):
         self.repo.lock_write()
-        self.add_cleanup(self.repo.unlock)
-        self.pb = ui.ui_factory.nested_progress_bar()
-        self.add_cleanup(self.pb.finished)
-        self._reconcile_steps()
+        try:
+            self.pb = ui.ui_factory.nested_progress_bar()
+            try:
+                self._reconcile_steps()
+            finally:
+                self.pb.finished()
+        finally:
+            self.repo.unlock()
 
     def _reconcile_steps(self):
         """Perform the steps to reconcile this repository."""
@@ -503,21 +502,23 @@
         collection = self.repo._pack_collection
         collection.ensure_loaded()
         collection.lock_names()
-        self.add_cleanup(collection._unlock_names)
-        packs = collection.all_packs()
-        all_revisions = self.repo.all_revision_ids()
-        total_inventories = len(list(
-            collection.inventory_index.combined_index.iter_all_entries()))
-        if len(all_revisions):
-            new_pack =  self.repo._reconcile_pack(collection, packs,
-                ".reconcile", all_revisions, self.pb)
-            if new_pack is not None:
+        try:
+            packs = collection.all_packs()
+            all_revisions = self.repo.all_revision_ids()
+            total_inventories = len(list(
+                collection.inventory_index.combined_index.iter_all_entries()))
+            if len(all_revisions):
+                new_pack =  self.repo._reconcile_pack(collection, packs,
+                    ".reconcile", all_revisions, self.pb)
+                if new_pack is not None:
+                    self._discard_and_save(packs)
+            else:
+                # only make a new pack when there is data to copy.
                 self._discard_and_save(packs)
-        else:
-            # only make a new pack when there is data to copy.
-            self._discard_and_save(packs)
-        self.garbage_inventories = total_inventories - len(list(
-            collection.inventory_index.combined_index.iter_all_entries()))
+            self.garbage_inventories = total_inventories - len(list(
+                collection.inventory_index.combined_index.iter_all_entries()))
+        finally:
+            collection._unlock_names()
 
     def _discard_and_save(self, packs):
         """Discard some packs from the repository.

=== modified file 'bzrlib/reconfigure.py'
--- bzrlib/reconfigure.py	2010-04-23 00:44:15 +0000
+++ bzrlib/reconfigure.py	2009-10-06 14:40:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -82,13 +82,14 @@
             self.repository = None
             self.local_repository = None
         else:
-            if (self.repository.user_url == self.bzrdir.user_url):
+            if (self.repository.bzrdir.root_transport.base ==
+                self.bzrdir.root_transport.base):
                 self.local_repository = self.repository
             else:
                 self.local_repository = None
         try:
             branch = self.bzrdir.open_branch()
-            if branch.user_url == bzrdir.user_url:
+            if branch.bzrdir.root_transport.base == bzrdir.root_transport.base:
                 self.local_branch = branch
                 self.referenced_branch = None
             else:
@@ -216,8 +217,8 @@
             if not want_reference:
                 self._create_repository = True
         else:
-            if want_reference and (
-                self.repository.user_url == self.bzrdir.user_url):
+            if want_reference and (self.repository.bzrdir.root_transport.base
+                                   == self.bzrdir.root_transport.base):
                 if not self.repository.is_shared():
                     self._destroy_repository = True
         if self.referenced_branch is None:
@@ -343,7 +344,7 @@
             if self._create_reference:
                 reference_branch.repository.fetch(self.repository)
             elif self.local_branch is not None and not self._destroy_branch:
-                up = self.local_branch.user_transport.clone('..')
+                up = self.local_branch.bzrdir.root_transport.clone('..')
                 up_bzrdir = bzrdir.BzrDir.open_containing_from_transport(up)[0]
                 new_repo = up_bzrdir.find_repository()
                 new_repo.fetch(self.repository)
@@ -367,7 +368,7 @@
             local_branch = self.local_branch
         if self._create_reference:
             format = branch.BranchReferenceFormat().initialize(self.bzrdir,
-                target_branch=reference_branch)
+                reference_branch)
         if self._destroy_tree:
             self.bzrdir.destroy_workingtree()
         if self._create_tree:

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2010-05-03 04:08:50 +0000
+++ bzrlib/remote.py	2009-12-15 20:32:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,10 +27,8 @@
     lock,
     lockdir,
     repository,
-    repository as _mod_repository,
     revision,
     revision as _mod_revision,
-    static_tuple,
     symbol_versioning,
 )
 from bzrlib.branch import BranchReferenceFormat
@@ -116,9 +114,6 @@
 
         self._probe_bzrdir()
 
-    def __repr__(self):
-        return '%s(%r)' % (self.__class__.__name__, self._client)
-
     def _probe_bzrdir(self):
         medium = self._client._medium
         path = self._path_for_remote_call(self._client)
@@ -244,14 +239,12 @@
         self._ensure_real()
         self._real_bzrdir.destroy_repository()
 
-    def create_branch(self, name=None):
+    def create_branch(self):
         # as per meta1 formats - just delegate to the format object which may
         # be parameterised.
-        real_branch = self._format.get_branch_format().initialize(self,
-            name=name)
+        real_branch = self._format.get_branch_format().initialize(self)
         if not isinstance(real_branch, RemoteBranch):
-            result = RemoteBranch(self, self.find_repository(), real_branch,
-                                  name=name)
+            result = RemoteBranch(self, self.find_repository(), real_branch)
         else:
             result = real_branch
         # BzrDir.clone_on_transport() uses the result of create_branch but does
@@ -263,10 +256,10 @@
         self._next_open_branch_result = result
         return result
 
-    def destroy_branch(self, name=None):
+    def destroy_branch(self):
         """See BzrDir.destroy_branch"""
         self._ensure_real()
-        self._real_bzrdir.destroy_branch(name=name)
+        self._real_bzrdir.destroy_branch()
         self._next_open_branch_result = None
 
     def create_workingtree(self, revision_id=None, from_branch=None):
@@ -291,40 +284,28 @@
     def _get_branch_reference(self):
         path = self._path_for_remote_call(self._client)
         medium = self._client._medium
-        candidate_calls = [
-            ('BzrDir.open_branchV3', (2, 1)),
-            ('BzrDir.open_branchV2', (1, 13)),
-            ('BzrDir.open_branch', None),
-            ]
-        for verb, required_version in candidate_calls:
-            if required_version and medium._is_remote_before(required_version):
-                continue
+        if not medium._is_remote_before((1, 13)):
             try:
-                response = self._call(verb, path)
+                response = self._call('BzrDir.open_branchV2', path)
+                if response[0] not in ('ref', 'branch'):
+                    raise errors.UnexpectedSmartServerResponse(response)
+                return response
             except errors.UnknownSmartMethod:
-                if required_version is None:
-                    raise
-                medium._remember_remote_is_before(required_version)
-            else:
-                break
-        if verb == 'BzrDir.open_branch':
-            if response[0] != 'ok':
-                raise errors.UnexpectedSmartServerResponse(response)
-            if response[1] != '':
-                return ('ref', response[1])
-            else:
-                return ('branch', '')
-        if response[0] not in ('ref', 'branch'):
+                medium._remember_remote_is_before((1, 13))
+        response = self._call('BzrDir.open_branch', path)
+        if response[0] != 'ok':
             raise errors.UnexpectedSmartServerResponse(response)
-        return response
+        if response[1] != '':
+            return ('ref', response[1])
+        else:
+            return ('branch', '')
 
     def _get_tree_branch(self):
         """See BzrDir._get_tree_branch()."""
         return None, self.open_branch()
 
-    def open_branch(self, name=None, unsupported=False,
-                    ignore_fallbacks=False):
-        if unsupported:
+    def open_branch(self, _unsupported=False, ignore_fallbacks=False):
+        if _unsupported:
             raise NotImplementedError('unsupported flag support not implemented yet.')
         if self._next_open_branch_result is not None:
             # See create_branch for details.
@@ -335,14 +316,14 @@
         if response[0] == 'ref':
             # a branch reference, use the existing BranchReference logic.
             format = BranchReferenceFormat()
-            return format.open(self, name=name, _found=True,
-                location=response[1], ignore_fallbacks=ignore_fallbacks)
+            return format.open(self, _found=True, location=response[1],
+                ignore_fallbacks=ignore_fallbacks)
         branch_format_name = response[1]
         if not branch_format_name:
             branch_format_name = None
         format = RemoteBranchFormat(network_name=branch_format_name)
         return RemoteBranch(self, self.find_repository(), format=format,
-            setup_stacking=not ignore_fallbacks, name=name)
+            setup_stacking=not ignore_fallbacks)
 
     def _open_repo_v1(self, path):
         verb = 'BzrDir.find_repository'
@@ -425,9 +406,9 @@
         """Return the path to be used for this bzrdir in a remote call."""
         return client.remote_path_from_transport(self.root_transport)
 
-    def get_branch_transport(self, branch_format, name=None):
+    def get_branch_transport(self, branch_format):
         self._ensure_real()
-        return self._real_bzrdir.get_branch_transport(branch_format, name=name)
+        return self._real_bzrdir.get_branch_transport(branch_format)
 
     def get_repository_transport(self, repository_format):
         self._ensure_real()
@@ -643,8 +624,7 @@
         return self._custom_format._serializer
 
 
-class RemoteRepository(_RpcHelper, lock._RelockDebugMixin,
-    bzrdir.ControlComponent):
+class RemoteRepository(_RpcHelper, lock._RelockDebugMixin):
     """Repository accessed over rpc.
 
     For the moment most operations are performed using local transport-backed
@@ -693,17 +673,6 @@
         # Additional places to query for data.
         self._fallback_repositories = []
 
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
-    @property
-    def control_transport(self):
-        # XXX: Normally you shouldn't directly get at the remote repository
-        # transport, but I'm not sure it's worth making this method
-        # optional -- mbp 2010-04-21
-        return self.bzrdir.get_repository_transport(None)
-        
     def __str__(self):
         return "%s(%s)" % (self.__class__.__name__, self.base)
 
@@ -917,15 +886,6 @@
         parents_provider = self._make_parents_provider(other_repository)
         return graph.Graph(parents_provider)
 
-    @needs_read_lock
-    def get_known_graph_ancestry(self, revision_ids):
-        """Return the known graph for a set of revision ids and their ancestors.
-        """
-        st = static_tuple.StaticTuple
-        revision_keys = [st(r_id).intern() for r_id in revision_ids]
-        known_graph = self.revisions.get_known_graph_ancestry(revision_keys)
-        return graph.GraphThunkIdsToKeys(known_graph)
-
     def gather_stats(self, revid=None, committers=None):
         """See Repository.gather_stats()."""
         path = self.bzrdir._path_for_remote_call(self._client)
@@ -1240,37 +1200,25 @@
             # state, so always add a lock here. If a caller passes us a locked
             # repository, they are responsible for unlocking it later.
             repository.lock_read()
-        self._check_fallback_repository(repository)
         self._fallback_repositories.append(repository)
         # If self._real_repository was parameterised already (e.g. because a
         # _real_branch had its get_stacked_on_url method called), then the
         # repository to be added may already be in the _real_repositories list.
         if self._real_repository is not None:
-            fallback_locations = [repo.user_url for repo in
+            fallback_locations = [repo.bzrdir.root_transport.base for repo in
                 self._real_repository._fallback_repositories]
-            if repository.user_url not in fallback_locations:
+            if repository.bzrdir.root_transport.base not in fallback_locations:
                 self._real_repository.add_fallback_repository(repository)
 
-    def _check_fallback_repository(self, repository):
-        """Check that this repository can fallback to repository safely.
-
-        Raise an error if not.
-
-        :param repository: A repository to fallback to.
-        """
-        return _mod_repository.InterRepository._assert_same_model(
-            self, repository)
-
     def add_inventory(self, revid, inv, parents):
         self._ensure_real()
         return self._real_repository.add_inventory(revid, inv, parents)
 
     def add_inventory_by_delta(self, basis_revision_id, delta, new_revision_id,
-            parents, basis_inv=None, propagate_caches=False):
+                               parents):
         self._ensure_real()
         return self._real_repository.add_inventory_by_delta(basis_revision_id,
-            delta, new_revision_id, parents, basis_inv=basis_inv,
-            propagate_caches=propagate_caches)
+            delta, new_revision_id, parents)
 
     def add_revision(self, rev_id, rev, inv=None, config=None):
         self._ensure_real()
@@ -1535,9 +1483,13 @@
         return self._real_repository.get_signature_text(revision_id)
 
     @needs_read_lock
-    def _get_inventory_xml(self, revision_id):
-        self._ensure_real()
-        return self._real_repository._get_inventory_xml(revision_id)
+    def get_inventory_xml(self, revision_id):
+        self._ensure_real()
+        return self._real_repository.get_inventory_xml(revision_id)
+
+    def deserialise_inventory(self, revision_id, xml):
+        self._ensure_real()
+        return self._real_repository.deserialise_inventory(revision_id, xml)
 
     def reconcile(self, other=None, thorough=False):
         self._ensure_real()
@@ -1619,13 +1571,13 @@
         return self._real_repository.inventories
 
     @needs_write_lock
-    def pack(self, hint=None, clean_obsolete_packs=False):
+    def pack(self, hint=None):
         """Compress the data within the repository.
 
         This is not currently implemented within the smart server.
         """
         self._ensure_real()
-        return self._real_repository.pack(hint=hint, clean_obsolete_packs=clean_obsolete_packs)
+        return self._real_repository.pack(hint=hint)
 
     @property
     def revisions(self):
@@ -2059,29 +2011,26 @@
     def network_name(self):
         return self._network_name
 
-    def open(self, a_bzrdir, name=None, ignore_fallbacks=False):
-        return a_bzrdir.open_branch(name=name, 
-            ignore_fallbacks=ignore_fallbacks)
+    def open(self, a_bzrdir, ignore_fallbacks=False):
+        return a_bzrdir.open_branch(ignore_fallbacks=ignore_fallbacks)
 
-    def _vfs_initialize(self, a_bzrdir, name):
+    def _vfs_initialize(self, a_bzrdir):
         # Initialisation when using a local bzrdir object, or a non-vfs init
         # method is not available on the server.
         # self._custom_format is always set - the start of initialize ensures
         # that.
         if isinstance(a_bzrdir, RemoteBzrDir):
             a_bzrdir._ensure_real()
-            result = self._custom_format.initialize(a_bzrdir._real_bzrdir,
-                name)
+            result = self._custom_format.initialize(a_bzrdir._real_bzrdir)
         else:
             # We assume the bzrdir is parameterised; it may not be.
-            result = self._custom_format.initialize(a_bzrdir, name)
+            result = self._custom_format.initialize(a_bzrdir)
         if (isinstance(a_bzrdir, RemoteBzrDir) and
             not isinstance(result, RemoteBranch)):
-            result = RemoteBranch(a_bzrdir, a_bzrdir.find_repository(), result,
-                                  name=name)
+            result = RemoteBranch(a_bzrdir, a_bzrdir.find_repository(), result)
         return result
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         # 1) get the network name to use.
         if self._custom_format:
             network_name = self._custom_format.network_name()
@@ -2093,23 +2042,20 @@
             network_name = reference_format.network_name()
         # Being asked to create on a non RemoteBzrDir:
         if not isinstance(a_bzrdir, RemoteBzrDir):
-            return self._vfs_initialize(a_bzrdir, name=name)
+            return self._vfs_initialize(a_bzrdir)
         medium = a_bzrdir._client._medium
         if medium._is_remote_before((1, 13)):
-            return self._vfs_initialize(a_bzrdir, name=name)
+            return self._vfs_initialize(a_bzrdir)
         # Creating on a remote bzr dir.
         # 2) try direct creation via RPC
         path = a_bzrdir._path_for_remote_call(a_bzrdir._client)
-        if name is not None:
-            # XXX JRV20100304: Support creating colocated branches
-            raise errors.NoColocatedBranchSupport(self)
         verb = 'BzrDir.create_branch'
         try:
             response = a_bzrdir._call(verb, path, network_name)
         except errors.UnknownSmartMethod:
             # Fallback - use vfs methods
             medium._remember_remote_is_before((1, 13))
-            return self._vfs_initialize(a_bzrdir, name=name)
+            return self._vfs_initialize(a_bzrdir)
         if response[0] != 'ok':
             raise errors.UnexpectedSmartServerResponse(response)
         # Turn the response into a RemoteRepository object.
@@ -2123,7 +2069,7 @@
                 a_bzrdir._client)
         remote_repo = RemoteRepository(repo_bzrdir, repo_format)
         remote_branch = RemoteBranch(a_bzrdir, remote_repo,
-            format=format, setup_stacking=False, name=name)
+            format=format, setup_stacking=False)
         # XXX: We know this is a new branch, so it must have revno 0, revid
         # NULL_REVISION. Creating the branch locked would make this be unable
         # to be wrong; here its simply very unlikely to be wrong. RBC 20090225
@@ -2156,7 +2102,7 @@
     """
 
     def __init__(self, remote_bzrdir, remote_repository, real_branch=None,
-        _client=None, format=None, setup_stacking=True, name=None):
+        _client=None, format=None, setup_stacking=True):
         """Create a RemoteBranch instance.
 
         :param real_branch: An optional local implementation of the branch
@@ -2168,7 +2114,6 @@
         :param setup_stacking: If True make an RPC call to determine the
             stacked (or not) status of the branch. If False assume the branch
             is not stacked.
-        :param name: Colocated branch name
         """
         # We intentionally don't call the parent class's __init__, because it
         # will try to assign to self.tags, which is a property in this subclass.
@@ -2193,9 +2138,7 @@
             self._real_branch = None
         # Fill out expected attributes of branch for bzrlib API users.
         self._clear_cached_state()
-        # TODO: deprecate self.base in favor of user_url
-        self.base = self.bzrdir.user_url
-        self._name = name
+        self.base = self.bzrdir.root_transport.base
         self._control_files = None
         self._lock_mode = None
         self._lock_token = None
@@ -2266,7 +2209,7 @@
                     'to use vfs implementation')
             self.bzrdir._ensure_real()
             self._real_branch = self.bzrdir._real_bzrdir.open_branch(
-                ignore_fallbacks=self._real_ignore_fallbacks, name=self._name)
+                ignore_fallbacks=self._real_ignore_fallbacks)
             if self.repository._real_repository is None:
                 # Give the remote repository the matching real repo.
                 real_repo = self._real_branch.repository
@@ -2880,13 +2823,8 @@
         raise NoSuchRevision(find('branch'), err.error_args[0])
     elif err.error_verb == 'nosuchrevision':
         raise NoSuchRevision(find('repository'), err.error_args[0])
-    elif err.error_verb == 'nobranch':
-        if len(err.error_args) >= 1:
-            extra = err.error_args[0]
-        else:
-            extra = None
-        raise errors.NotBranchError(path=find('bzrdir').root_transport.base,
-            detail=extra)
+    elif err.error_tuple == ('nobranch',):
+        raise errors.NotBranchError(path=find('bzrdir').root_transport.base)
     elif err.error_verb == 'norepository':
         raise errors.NoRepositoryPresent(find('bzrdir'))
     elif err.error_verb == 'LockContention':

=== modified file 'bzrlib/repofmt/groupcompress_repo.py'
--- bzrlib/repofmt/groupcompress_repo.py	2010-02-10 02:17:15 +0000
+++ bzrlib/repofmt/groupcompress_repo.py	2010-01-04 02:25:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,6 +29,7 @@
     knit,
     osutils,
     pack,
+    remote,
     revision as _mod_revision,
     trace,
     ui,
@@ -704,11 +705,10 @@
                 self._remove_pack_from_memory(pack)
         # record the newly available packs and stop advertising the old
         # packs
-        to_be_obsoleted = []
-        for _, packs in pack_operations:
-            to_be_obsoleted.extend(packs)
-        result = self._save_pack_names(clear_obsolete_packs=True,
-                                       obsolete_packs=to_be_obsoleted)
+        result = self._save_pack_names(clear_obsolete_packs=True)
+        # Move the old packs out of the way now they are no longer referenced.
+        for revision_count, packs in pack_operations:
+            self._obsolete_packs(packs)
         return result
 
 
@@ -881,7 +881,7 @@
             if basis_tree is not None:
                 basis_tree.unlock()
 
-    def _deserialise_inventory(self, revision_id, bytes):
+    def deserialise_inventory(self, revision_id, bytes):
         return inventory.CHKInventory.deserialise(self.chk_bytes, bytes,
             (revision_id,))
 
@@ -903,7 +903,7 @@
     def _iter_inventory_xmls(self, revision_ids, ordering):
         # Without a native 'xml' inventory, this method doesn't make sense.
         # However older working trees, and older bundles want it - so we supply
-        # it allowing _get_inventory_xml to work. Bundles currently use the
+        # it allowing get_inventory_xml to work. Bundles currently use the
         # serializer directly; this also isn't ideal, but there isn't an xml
         # iteration interface offered at all for repositories. We could make
         # _iter_inventory_xmls be part of the contract, even if kept private.

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2010-04-26 13:51:08 +0000
+++ bzrlib/repofmt/knitrepo.py	2009-08-14 11:11:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,7 +24,6 @@
     lockdir,
     osutils,
     revision as _mod_revision,
-    trace,
     transactions,
     versionedfile,
     xml5,
@@ -43,6 +42,7 @@
     RepositoryFormat,
     RootCommitBuilder,
     )
+from bzrlib.trace import mutter, mutter_callsite
 
 
 class _KnitParentsProvider(object):
@@ -342,7 +342,7 @@
         :param shared: If true the repository will be initialized as a shared
                        repository.
         """
-        trace.mutter('creating repository in %s.', a_bzrdir.transport.base)
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
         dirs = ['knits']
         files = []
         utf8_files = [('format', self.get_format_string())]
@@ -360,7 +360,6 @@
         result.revisions.get_parent_map([('A',)])
         result.signatures.get_parent_map([('A',)])
         result.unlock()
-        self._run_post_repo_init_hooks(result, a_bzrdir, shared)
         return result
 
     def open(self, a_bzrdir, _found=False, _override_transport=None):
@@ -445,7 +444,6 @@
     repository_class = KnitRepository
     _commit_builder_class = RootCommitBuilder
     rich_root_data = True
-    experimental = True
     supports_tree_reference = True
     @property
     def _serializer(self):

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2010-04-22 17:08:27 +0000
+++ bzrlib/repofmt/pack_repo.py	2010-01-04 06:56:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,7 +24,6 @@
 
 from bzrlib import (
     chk_map,
-    cleanup,
     debug,
     graph,
     osutils,
@@ -587,6 +586,26 @@
                                              flush_func=flush_func)
         self.add_callback = None
 
+    def replace_indices(self, index_to_pack, indices):
+        """Replace the current mappings with fresh ones.
+
+        This should probably not be used eventually, rather incremental add and
+        removal of indices. It has been added during refactoring of existing
+        code.
+
+        :param index_to_pack: A mapping from index objects to
+            (transport, name) tuples for the pack file data.
+        :param indices: A list of indices.
+        """
+        # refresh the revision pack map dict without replacing the instance.
+        self.index_to_pack.clear()
+        self.index_to_pack.update(index_to_pack)
+        # XXX: API break - clearly a 'replace' method would be good?
+        self.combined_index._indices[:] = indices
+        # the current add nodes callback for the current writable index if
+        # there is one.
+        self.add_callback = None
+
     def add_index(self, index, pack):
         """Add index to the aggregate, which is an index for Pack pack.
 
@@ -599,7 +618,7 @@
         # expose it to the index map
         self.index_to_pack[index] = pack.access_tuple()
         # put it at the front of the linear index list
-        self.combined_index.insert_index(0, index, pack.name)
+        self.combined_index.insert_index(0, index)
 
     def add_writable_index(self, index, pack):
         """Add an index which is able to have data added to it.
@@ -625,18 +644,16 @@
         self.data_access.set_writer(None, None, (None, None))
         self.index_to_pack.clear()
         del self.combined_index._indices[:]
-        del self.combined_index._index_names[:]
         self.add_callback = None
 
-    def remove_index(self, index):
+    def remove_index(self, index, pack):
         """Remove index from the indices used to answer queries.
 
         :param index: An index from the pack parameter.
+        :param pack: A Pack instance.
         """
         del self.index_to_pack[index]
-        pos = self.combined_index._indices.index(index)
-        del self.combined_index._indices[pos]
-        del self.combined_index._index_names[pos]
+        self.combined_index._indices.remove(index)
         if (self.add_callback is not None and
             getattr(index, 'add_nodes', None) == self.add_callback):
             self.add_callback = None
@@ -1398,20 +1415,11 @@
         self.inventory_index = AggregateIndex(self.reload_pack_names, flush)
         self.text_index = AggregateIndex(self.reload_pack_names, flush)
         self.signature_index = AggregateIndex(self.reload_pack_names, flush)
-        all_indices = [self.revision_index, self.inventory_index,
-                self.text_index, self.signature_index]
         if use_chk_index:
             self.chk_index = AggregateIndex(self.reload_pack_names, flush)
-            all_indices.append(self.chk_index)
         else:
             # used to determine if we're using a chk_index elsewhere.
             self.chk_index = None
-        # Tell all the CombinedGraphIndex objects about each other, so they can
-        # share hints about which pack names to search first.
-        all_combined = [agg_idx.combined_index for agg_idx in all_indices]
-        for combined_idx in all_combined:
-            combined_idx.set_sibling_indices(
-                set(all_combined).difference([combined_idx]))
         # resumed packs
         self._resumed_packs = []
 
@@ -1537,11 +1545,10 @@
                 self._remove_pack_from_memory(pack)
         # record the newly available packs and stop advertising the old
         # packs
-        to_be_obsoleted = []
-        for _, packs in pack_operations:
-            to_be_obsoleted.extend(packs)
-        result = self._save_pack_names(clear_obsolete_packs=True,
-                                       obsolete_packs=to_be_obsoleted)
+        result = self._save_pack_names(clear_obsolete_packs=True)
+        # Move the old packs out of the way now they are no longer referenced.
+        for revision_count, packs in pack_operations:
+            self._obsolete_packs(packs)
         return result
 
     def _flush_new_pack(self):
@@ -1560,7 +1567,7 @@
         """Is the collection already packed?"""
         return not (self.repo._format.pack_compresses or (len(self._names) > 1))
 
-    def pack(self, hint=None, clean_obsolete_packs=False):
+    def pack(self, hint=None):
         """Pack the pack collection totally."""
         self.ensure_loaded()
         total_packs = len(self._names)
@@ -1582,9 +1589,6 @@
                 pack_operations[-1][1].append(pack)
         self._execute_pack_operations(pack_operations, OptimisingPacker)
 
-        if clean_obsolete_packs:
-            self._clear_obsolete_packs()
-
     def plan_autopack_combinations(self, existing_packs, pack_distribution):
         """Plan a pack operation.
 
@@ -1784,13 +1788,8 @@
         :param return: None.
         """
         for pack in packs:
-            try:
-                pack.pack_transport.rename(pack.file_name(),
-                    '../obsolete_packs/' + pack.file_name())
-            except (errors.PathError, errors.TransportError), e:
-                # TODO: Should these be warnings or mutters?
-                mutter("couldn't rename obsolete pack, skipping it:\n%s"
-                       % (e,))
+            pack.pack_transport.rename(pack.file_name(),
+                '../obsolete_packs/' + pack.file_name())
             # TODO: Probably needs to know all possible indices for this pack
             # - or maybe list the directory and move all indices matching this
             # name whether we recognize it or not?
@@ -1798,12 +1797,8 @@
             if self.chk_index is not None:
                 suffixes.append('.cix')
             for suffix in suffixes:
-                try:
-                    self._index_transport.rename(pack.name + suffix,
-                        '../obsolete_packs/' + pack.name + suffix)
-                except (errors.PathError, errors.TransportError), e:
-                    mutter("couldn't rename obsolete index, skipping it:\n%s"
-                           % (e,))
+                self._index_transport.rename(pack.name + suffix,
+                    '../obsolete_packs/' + pack.name + suffix)
 
     def pack_distribution(self, total_revisions):
         """Generate a list of the number of revisions to put in each pack.
@@ -1835,22 +1830,14 @@
         self._remove_pack_indices(pack)
         self.packs.remove(pack)
 
-    def _remove_pack_indices(self, pack, ignore_missing=False):
-        """Remove the indices for pack from the aggregated indices.
-        
-        :param ignore_missing: Suppress KeyErrors from calling remove_index.
-        """
-        for index_type in Pack.index_definitions.keys():
-            attr_name = index_type + '_index'
-            aggregate_index = getattr(self, attr_name)
-            if aggregate_index is not None:
-                pack_index = getattr(pack, attr_name)
-                try:
-                    aggregate_index.remove_index(pack_index)
-                except KeyError:
-                    if ignore_missing:
-                        continue
-                    raise
+    def _remove_pack_indices(self, pack):
+        """Remove the indices for pack from the aggregated indices."""
+        self.revision_index.remove_index(pack.revision_index, pack)
+        self.inventory_index.remove_index(pack.inventory_index, pack)
+        self.text_index.remove_index(pack.text_index, pack)
+        self.signature_index.remove_index(pack.signature_index, pack)
+        if self.chk_index is not None:
+            self.chk_index.remove_index(pack.chk_index, pack)
 
     def reset(self):
         """Clear all cached data."""
@@ -1889,7 +1876,6 @@
         disk_nodes = set()
         for index, key, value in self._iter_disk_pack_index():
             disk_nodes.add((key, value))
-        orig_disk_nodes = set(disk_nodes)
 
         # do a two-way diff against our original content
         current_nodes = set()
@@ -1908,7 +1894,7 @@
         disk_nodes.difference_update(deleted_nodes)
         disk_nodes.update(new_nodes)
 
-        return disk_nodes, deleted_nodes, new_nodes, orig_disk_nodes
+        return disk_nodes, deleted_nodes, new_nodes
 
     def _syncronize_pack_names_from_disk_nodes(self, disk_nodes):
         """Given the correct set of pack files, update our saved info.
@@ -1954,7 +1940,7 @@
                 added.append(name)
         return removed, added, modified
 
-    def _save_pack_names(self, clear_obsolete_packs=False, obsolete_packs=None):
+    def _save_pack_names(self, clear_obsolete_packs=False):
         """Save the list of packs.
 
         This will take out the mutex around the pack names list for the
@@ -1964,16 +1950,12 @@
 
         :param clear_obsolete_packs: If True, clear out the contents of the
             obsolete_packs directory.
-        :param obsolete_packs: Packs that are obsolete once the new pack-names
-            file has been written.
         :return: A list of the names saved that were not previously on disk.
         """
-        already_obsolete = []
         self.lock_names()
         try:
             builder = self._index_builder_class()
-            (disk_nodes, deleted_nodes, new_nodes,
-             orig_disk_nodes) = self._diff_pack_names()
+            disk_nodes, deleted_nodes, new_nodes = self._diff_pack_names()
             # TODO: handle same-name, index-size-changes here -
             # e.g. use the value from disk, not ours, *unless* we're the one
             # changing it.
@@ -1981,25 +1963,14 @@
                 builder.add_node(key, value)
             self.transport.put_file('pack-names', builder.finish(),
                 mode=self.repo.bzrdir._get_file_mode())
+            # move the baseline forward
             self._packs_at_load = disk_nodes
             if clear_obsolete_packs:
-                to_preserve = None
-                if obsolete_packs:
-                    to_preserve = set([o.name for o in obsolete_packs])
-                already_obsolete = self._clear_obsolete_packs(to_preserve)
+                self._clear_obsolete_packs()
         finally:
             self._unlock_names()
         # synchronise the memory packs list with what we just wrote:
         self._syncronize_pack_names_from_disk_nodes(disk_nodes)
-        if obsolete_packs:
-            # TODO: We could add one more condition here. "if o.name not in
-            #       orig_disk_nodes and o != the new_pack we haven't written to
-            #       disk yet. However, the new pack object is not easily
-            #       accessible here (it would have to be passed through the
-            #       autopacking code, etc.)
-            obsolete_packs = [o for o in obsolete_packs
-                              if o.name not in already_obsolete]
-            self._obsolete_packs(obsolete_packs)
         return [new_node[0][0] for new_node in new_nodes]
 
     def reload_pack_names(self):
@@ -2020,12 +1991,8 @@
         if first_read:
             return True
         # out the new value.
-        (disk_nodes, deleted_nodes, new_nodes,
-         orig_disk_nodes) = self._diff_pack_names()
-        # _packs_at_load is meant to be the explicit list of names in
-        # 'pack-names' at then start. As such, it should not contain any
-        # pending names that haven't been written out yet.
-        self._packs_at_load = orig_disk_nodes
+        disk_nodes, _, _ = self._diff_pack_names()
+        self._packs_at_load = disk_nodes
         (removed, added,
          modified) = self._syncronize_pack_names_from_disk_nodes(disk_nodes)
         if removed or added or modified:
@@ -2040,28 +2007,15 @@
             raise
         raise errors.RetryAutopack(self.repo, False, sys.exc_info())
 
-    def _clear_obsolete_packs(self, preserve=None):
+    def _clear_obsolete_packs(self):
         """Delete everything from the obsolete-packs directory.
-
-        :return: A list of pack identifiers (the filename without '.pack') that
-            were found in obsolete_packs.
         """
-        found = []
         obsolete_pack_transport = self.transport.clone('obsolete_packs')
-        if preserve is None:
-            preserve = set()
         for filename in obsolete_pack_transport.list_dir('.'):
-            name, ext = osutils.splitext(filename)
-            if ext == '.pack':
-                found.append(name)
-            if name in preserve:
-                continue
             try:
                 obsolete_pack_transport.delete(filename)
             except (errors.PathError, errors.TransportError), e:
-                warning("couldn't delete obsolete pack, skipping it:\n%s"
-                        % (e,))
-        return found
+                warning("couldn't delete obsolete pack, skipping it:\n%s" % (e,))
 
     def _start_write_group(self):
         # Do not permit preparation for writing if we're not in a 'write lock'.
@@ -2094,21 +2048,24 @@
         # FIXME: just drop the transient index.
         # forget what names there are
         if self._new_pack is not None:
-            operation = cleanup.OperationWithCleanups(self._new_pack.abort)
-            operation.add_cleanup(setattr, self, '_new_pack', None)
-            # If we aborted while in the middle of finishing the write
-            # group, _remove_pack_indices could fail because the indexes are
-            # already gone.  But they're not there we shouldn't fail in this
-            # case, so we pass ignore_missing=True.
-            operation.add_cleanup(self._remove_pack_indices, self._new_pack,
-                ignore_missing=True)
-            operation.run_simple()
+            try:
+                self._new_pack.abort()
+            finally:
+                # XXX: If we aborted while in the middle of finishing the write
+                # group, _remove_pack_indices can fail because the indexes are
+                # already gone.  If they're not there we shouldn't fail in this
+                # case.  -- mbp 20081113
+                self._remove_pack_indices(self._new_pack)
+                self._new_pack = None
         for resumed_pack in self._resumed_packs:
-            operation = cleanup.OperationWithCleanups(resumed_pack.abort)
-            # See comment in previous finally block.
-            operation.add_cleanup(self._remove_pack_indices, resumed_pack,
-                ignore_missing=True)
-            operation.run_simple()
+            try:
+                resumed_pack.abort()
+            finally:
+                # See comment in previous finally block.
+                try:
+                    self._remove_pack_indices(resumed_pack)
+                except KeyError:
+                    pass
         del self._resumed_packs[:]
 
     def _remove_resumed_pack_indices(self):
@@ -2378,13 +2335,13 @@
         raise NotImplementedError(self.dont_leave_lock_in_place)
 
     @needs_write_lock
-    def pack(self, hint=None, clean_obsolete_packs=False):
+    def pack(self, hint=None):
         """Compress the data within the repository.
 
         This will pack all the data to a single pack. In future it may
         recompress deltas or do other such expensive operations.
         """
-        self._pack_collection.pack(hint=hint, clean_obsolete_packs=clean_obsolete_packs)
+        self._pack_collection.pack(hint=hint)
 
     @needs_write_lock
     def reconcile(self, other=None, thorough=False):
@@ -2546,9 +2503,7 @@
         utf8_files = [('format', self.get_format_string())]
 
         self._upload_blank_content(a_bzrdir, dirs, files, utf8_files, shared)
-        repository = self.open(a_bzrdir=a_bzrdir, _found=True)
-        self._run_post_repo_init_hooks(repository, a_bzrdir, shared)
-        return repository
+        return self.open(a_bzrdir=a_bzrdir, _found=True)
 
     def open(self, a_bzrdir, _found=False, _override_transport=None):
         """See RepositoryFormat.open().
@@ -2617,7 +2572,6 @@
     repository_class = KnitPackRepository
     _commit_builder_class = PackRootCommitBuilder
     rich_root_data = True
-    experimental = True
     supports_tree_reference = True
     @property
     def _serializer(self):
@@ -2891,7 +2845,6 @@
     repository_class = KnitPackRepository
     _commit_builder_class = PackRootCommitBuilder
     rich_root_data = True
-    experimental = True
     supports_tree_reference = True
     supports_external_lookups = True
     # What index classes to use

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2010-04-28 07:03:38 +0000
+++ bzrlib/repofmt/weaverepo.py	2009-09-16 17:19:07 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,7 +39,6 @@
     lockdir,
     osutils,
     revision as _mod_revision,
-    trace,
     urlutils,
     versionedfile,
     weave,
@@ -54,6 +53,7 @@
     RepositoryFormat,
     )
 from bzrlib.store.text import TextStore
+from bzrlib.trace import mutter
 from bzrlib.tuned_gzip import GzipFile, bytes_to_gzip
 from bzrlib.versionedfile import (
     AbsentContentFactory,
@@ -106,8 +106,7 @@
     def _all_possible_ids(self):
         """Return all the possible revisions that we could find."""
         if 'evil' in debug.debug_flags:
-            trace.mutter_callsite(
-                3, "_all_possible_ids scales with size of history.")
+            mutter_callsite(3, "_all_possible_ids scales with size of history.")
         return [key[-1] for key in self.inventories.keys()]
 
     @needs_read_lock
@@ -177,7 +176,7 @@
         :param new_value: True to restore the default, False to disable making
                           working trees.
         """
-        raise errors.RepositoryUpgradeRequired(self.user_url)
+        raise errors.RepositoryUpgradeRequired(self.bzrdir.root_transport.base)
 
     def make_working_trees(self):
         """Returns the policy for making working trees on new branches."""
@@ -200,8 +199,7 @@
     def _all_possible_ids(self):
         """Return all the possible revisions that we could find."""
         if 'evil' in debug.debug_flags:
-            trace.mutter_callsite(
-                3, "_all_possible_ids scales with size of history.")
+            mutter_callsite(3, "_all_possible_ids scales with size of history.")
         return [key[-1] for key in self.inventories.keys()]
 
     @needs_read_lock
@@ -288,7 +286,7 @@
         weavefile.write_weave_v5(weave.Weave(), sio)
         empty_weave = sio.getvalue()
 
-        trace.mutter('creating repository in %s.', a_bzrdir.transport.base)
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
 
         # FIXME: RBC 20060125 don't peek under the covers
         # NB: no need to escape relative paths that are url safe.
@@ -304,9 +302,7 @@
                 mode=a_bzrdir._get_file_mode())
         finally:
             control_files.unlock()
-        repository = self.open(a_bzrdir, _found=True)
-        self._run_post_repo_init_hooks(repository, a_bzrdir, shared)
-        return repository
+        return self.open(a_bzrdir, _found=True)
 
     def open(self, a_bzrdir, _found=False):
         """See RepositoryFormat.open()."""
@@ -528,7 +524,7 @@
         weavefile.write_weave_v5(weave.Weave(), sio)
         empty_weave = sio.getvalue()
 
-        trace.mutter('creating repository in %s.', a_bzrdir.transport.base)
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
         dirs = ['revision-store', 'weaves']
         files = [('inventory.weave', StringIO(empty_weave)),
                  ]

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2010-04-28 07:03:38 +0000
+++ bzrlib/repository.py	2009-12-17 10:01:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -40,9 +40,7 @@
     lru_cache,
     osutils,
     revision as _mod_revision,
-    static_tuple,
     symbol_versioning,
-    trace,
     tsort,
     ui,
     versionedfile,
@@ -864,7 +862,7 @@
 # Repositories
 
 
-class Repository(_RelockDebugMixin, bzrdir.ControlComponent):
+class Repository(_RelockDebugMixin):
     """Repository holding history for one or more branches.
 
     The repository holds and retrieves historical information including
@@ -1028,7 +1026,7 @@
 
         :seealso: add_inventory, for the contract.
         """
-        inv_lines = self._serializer.write_inventory_to_lines(inv)
+        inv_lines = self._serialise_inventory_to_lines(inv)
         return self._inventory_add_lines(revision_id, parents,
             inv_lines, check_content=False)
 
@@ -1241,7 +1239,7 @@
         """Check a single text from this repository."""
         if kind == 'inventories':
             rev_id = record.key[0]
-            inv = self._deserialise_inventory(rev_id,
+            inv = self.deserialise_inventory(rev_id,
                 record.get_bytes_as('fulltext'))
             if last_object is not None:
                 delta = inv._make_delta(last_object)
@@ -1291,10 +1289,11 @@
 
         :param _format: The format of the repository on disk.
         :param a_bzrdir: The BzrDir of the repository.
+
+        In the future we will have a single api for all stores for
+        getting file texts, inventories and revisions, then
+        this construct will accept instances of those things.
         """
-        # In the future we will have a single api for all stores for
-        # getting file texts, inventories and revisions, then
-        # this construct will accept instances of those things.
         super(Repository, self).__init__()
         self._format = _format
         # the following are part of the public API for Repository:
@@ -1315,14 +1314,6 @@
         # rather copying them?
         self._safe_to_return_from_cache = False
 
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
-    @property
-    def control_transport(self):
-        return self._transport
-
     def __repr__(self):
         if self._fallback_repositories:
             return '%s(%r, fallback_repositories=%r)' % (
@@ -1476,7 +1467,7 @@
 
         # now gather global repository information
         # XXX: This is available for many repos regardless of listability.
-        if self.user_transport.listable():
+        if self.bzrdir.root_transport.listable():
             # XXX: do we want to __define len__() ?
             # Maybe the versionedfiles object should provide a different
             # method to get the number of keys.
@@ -1492,7 +1483,10 @@
         :param using: If True, list only branches using this repository.
         """
         if using and not self.is_shared():
-            return self.bzrdir.list_branches()
+            try:
+                return [self.bzrdir.open_branch()]
+            except errors.NotBranchError:
+                return []
         class Evaluator(object):
 
             def __init__(self):
@@ -1507,19 +1501,22 @@
                     except errors.NoRepositoryPresent:
                         pass
                     else:
-                        return False, ([], repository)
+                        return False, (None, repository)
                 self.first_call = False
-                value = (bzrdir.list_branches(), None)
+                try:
+                    value = (bzrdir.open_branch(), None)
+                except errors.NotBranchError:
+                    value = (None, None)
                 return True, value
 
-        ret = []
-        for branches, repository in bzrdir.BzrDir.find_bzrdirs(
-                self.user_transport, evaluate=Evaluator()):
-            if branches is not None:
-                ret.extend(branches)
+        branches = []
+        for branch, repository in bzrdir.BzrDir.find_bzrdirs(
+                self.bzrdir.root_transport, evaluate=Evaluator()):
+            if branch is not None:
+                branches.append(branch)
             if not using and repository is not None:
-                ret.extend(repository.find_branches())
-        return ret
+                branches.extend(repository.find_branches())
+        return branches
 
     @needs_read_lock
     def search_missing_revision_ids(self, other, revision_id=None, find_ghosts=True):
@@ -1903,6 +1900,23 @@
                 rev = self._serializer.read_revision_from_string(text)
                 yield (revid, rev)
 
+    @needs_read_lock
+    def get_revision_xml(self, revision_id):
+        # TODO: jam 20070210 This shouldn't be necessary since get_revision
+        #       would have already do it.
+        # TODO: jam 20070210 Just use _serializer.write_revision_to_string()
+        # TODO: this can't just be replaced by:
+        # return self._serializer.write_revision_to_string(
+        #     self.get_revision(revision_id))
+        # as cStringIO preservers the encoding unlike write_revision_to_string
+        # or some other call down the path.
+        rev = self.get_revision(revision_id)
+        rev_tmp = cStringIO.StringIO()
+        # the current serializer..
+        self._serializer.write_revision(rev, rev_tmp)
+        rev_tmp.seek(0)
+        return rev_tmp.getvalue()
+
     def get_deltas_for_revisions(self, revisions, specific_fileids=None):
         """Produce a generator of revision deltas.
 
@@ -2150,10 +2164,14 @@
         """
         selected_keys = set((revid,) for revid in revision_ids)
         w = _inv_weave or self.inventories
-        return self._find_file_ids_from_xml_inventory_lines(
-            w.iter_lines_added_or_present_in_keys(
-                selected_keys, pb=None),
-            selected_keys)
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            return self._find_file_ids_from_xml_inventory_lines(
+                w.iter_lines_added_or_present_in_keys(
+                    selected_keys, pb=pb),
+                selected_keys)
+        finally:
+            pb.finished()
 
     def iter_files_bytes(self, desired_files):
         """Iterate through file versions.
@@ -2369,7 +2387,7 @@
         """single-document based inventory iteration."""
         inv_xmls = self._iter_inventory_xmls(revision_ids, ordering)
         for text, revision_id in inv_xmls:
-            yield self._deserialise_inventory(revision_id, text)
+            yield self.deserialise_inventory(revision_id, text)
 
     def _iter_inventory_xmls(self, revision_ids, ordering):
         if ordering is None:
@@ -2407,7 +2425,7 @@
                         next_key = None
                         break
 
-    def _deserialise_inventory(self, revision_id, xml):
+    def deserialise_inventory(self, revision_id, xml):
         """Transform the xml into an inventory object.
 
         :param revision_id: The expected revision id of the inventory.
@@ -2421,12 +2439,18 @@
                 result.revision_id, revision_id))
         return result
 
+    def serialise_inventory(self, inv):
+        return self._serializer.write_inventory_to_string(inv)
+
+    def _serialise_inventory_to_lines(self, inv):
+        return self._serializer.write_inventory_to_lines(inv)
+
     def get_serializer_format(self):
         return self._serializer.format_num
 
     @needs_read_lock
-    def _get_inventory_xml(self, revision_id):
-        """Get serialized inventory as a string."""
+    def get_inventory_xml(self, revision_id):
+        """Get inventory XML as a file object."""
         texts = self._iter_inventory_xmls([revision_id], 'unordered')
         try:
             text, revision_id = texts.next()
@@ -2434,6 +2458,12 @@
             raise errors.HistoryMissing(self, 'inventory', revision_id)
         return text
 
+    @needs_read_lock
+    def get_inventory_sha1(self, revision_id):
+        """Return the sha1 hash of the inventory entry
+        """
+        return self.get_revision(revision_id).inventory_sha1
+
     def get_rev_id_for_revno(self, revno, known_pair):
         """Return the revision id of a revno, given a later (revno, revid)
         pair in the same history.
@@ -2490,6 +2520,22 @@
             else:
                 next_id = parents[0]
 
+    @needs_read_lock
+    def get_revision_inventory(self, revision_id):
+        """Return inventory of a past revision."""
+        # TODO: Unify this with get_inventory()
+        # bzr 0.0.6 and later imposes the constraint that the inventory_id
+        # must be the same as its revision, so this is trivial.
+        if revision_id is None:
+            # This does not make sense: if there is no revision,
+            # then it is the current tree inventory surely ?!
+            # and thus get_root_id() is something that looks at the last
+            # commit on the branch, and the get_root_id is an inventory check.
+            raise NotImplementedError
+            # return Inventory(self.get_root_id())
+        else:
+            return self.get_inventory(revision_id)
+
     def is_shared(self):
         """Return True if this repository is flagged as a shared repository."""
         raise NotImplementedError(self.is_shared)
@@ -2529,7 +2575,7 @@
             return RevisionTree(self, Inventory(root_id=None),
                                 _mod_revision.NULL_REVISION)
         else:
-            inv = self.get_inventory(revision_id)
+            inv = self.get_revision_inventory(revision_id)
             return RevisionTree(self, inv, revision_id)
 
     def revision_trees(self, revision_ids):
@@ -2588,7 +2634,7 @@
             keys = tsort.topo_sort(parent_map)
         return [None] + list(keys)
 
-    def pack(self, hint=None, clean_obsolete_packs=False):
+    def pack(self, hint=None):
         """Compress the data within the repository.
 
         This operation only makes sense for some repository types. For other
@@ -2604,9 +2650,6 @@
             obtained from the result of commit_write_group(). Out of
             date hints are simply ignored, because concurrent operations
             can obsolete them rapidly.
-
-        :param clean_obsolete_packs: Clean obsolete packs immediately after
-            the pack operation.
         """
 
     def get_transaction(self):
@@ -2637,15 +2680,6 @@
     def _make_parents_provider(self):
         return self
 
-    @needs_read_lock
-    def get_known_graph_ancestry(self, revision_ids):
-        """Return the known graph for a set of revision ids and their ancestors.
-        """
-        st = static_tuple.StaticTuple
-        revision_keys = [st(r_id).intern() for r_id in revision_ids]
-        known_graph = self.revisions.get_known_graph_ancestry(revision_keys)
-        return graph.GraphThunkIdsToKeys(known_graph)
-
     def get_graph(self, other_repository=None):
         """Return the graph walker for this repository format"""
         parents_provider = self._make_parents_provider()
@@ -3050,11 +3084,9 @@
     pack_compresses = False
     # Does the repository inventory storage understand references to trees?
     supports_tree_reference = None
-    # Is the format experimental ?
-    experimental = False
 
-    def __repr__(self):
-        return "%s()" % self.__class__.__name__
+    def __str__(self):
+        return "<%s>" % self.__class__.__name__
 
     def __eq__(self, other):
         # format objects are generally stateless
@@ -3178,15 +3210,6 @@
         """
         raise NotImplementedError(self.open)
 
-    def _run_post_repo_init_hooks(self, repository, a_bzrdir, shared):
-        from bzrlib.bzrdir import BzrDir, RepoInitHookParams
-        hooks = BzrDir.hooks['post_repo_init']
-        if not hooks:
-            return
-        params = RepoInitHookParams(repository, self, a_bzrdir, shared)
-        for hook in hooks:
-            hook(params)
-
 
 class MetaDirRepositoryFormat(RepositoryFormat):
     """Common base class for the new repositories using the metadir layout."""
@@ -3397,21 +3420,15 @@
 
         :param revision_id: if None all content is copied, if NULL_REVISION no
                             content is copied.
-        :param pb: ignored.
+        :param pb: optional progress bar to use for progress reports. If not
+                   provided a default one will be created.
         :return: None.
         """
-        ui.ui_factory.warn_experimental_format_fetch(self)
-        from bzrlib.fetch import RepoFetcher
-        # See <https://launchpad.net/bugs/456077> asking for a warning here
-        if self.source._format.network_name() != self.target._format.network_name():
-            ui.ui_factory.show_user_warning('cross_format_fetch',
-                from_format=self.source._format,
-                to_format=self.target._format)
-        f = RepoFetcher(to_repository=self.target,
+        f = _mod_fetch.RepoFetcher(to_repository=self.target,
                                from_repository=self.source,
                                last_revision=revision_id,
                                fetch_spec=fetch_spec,
-                               find_ghosts=find_ghosts)
+                               pb=pb, find_ghosts=find_ghosts)
 
     def _walk_to_common_revisions(self, revision_ids):
         """Walk out from revision_ids in source to revisions target has.
@@ -3991,18 +4008,12 @@
         """See InterRepository.fetch()."""
         if fetch_spec is not None:
             raise AssertionError("Not implemented yet...")
-        ui.ui_factory.warn_experimental_format_fetch(self)
         if (not self.source.supports_rich_root()
             and self.target.supports_rich_root()):
             self._converting_to_rich_root = True
             self._revision_id_to_root_id = {}
         else:
             self._converting_to_rich_root = False
-        # See <https://launchpad.net/bugs/456077> asking for a warning here
-        if self.source._format.network_name() != self.target._format.network_name():
-            ui.ui_factory.show_user_warning('cross_format_fetch',
-                from_format=self.source._format,
-                to_format=self.target._format)
         revision_ids = self.target.search_missing_revision_ids(self.source,
             revision_id, find_ghosts=find_ghosts).get_keys()
         if not revision_ids:
@@ -4077,33 +4088,37 @@
         :param to_convert: The disk object to convert.
         :param pb: a progress bar to use for progress information.
         """
-        pb = ui.ui_factory.nested_progress_bar()
+        self.pb = pb
         self.count = 0
         self.total = 4
         # this is only useful with metadir layouts - separated repo content.
         # trigger an assertion if not such
         repo._format.get_format_string()
         self.repo_dir = repo.bzrdir
-        pb.update('Moving repository to repository.backup')
+        self.step('Moving repository to repository.backup')
         self.repo_dir.transport.move('repository', 'repository.backup')
         backup_transport =  self.repo_dir.transport.clone('repository.backup')
         repo._format.check_conversion_target(self.target_format)
         self.source_repo = repo._format.open(self.repo_dir,
             _found=True,
             _override_transport=backup_transport)
-        pb.update('Creating new repository')
+        self.step('Creating new repository')
         converted = self.target_format.initialize(self.repo_dir,
                                                   self.source_repo.is_shared())
         converted.lock_write()
         try:
-            pb.update('Copying content')
+            self.step('Copying content')
             self.source_repo.copy_content_into(converted)
         finally:
             converted.unlock()
-        pb.update('Deleting old repository content')
+        self.step('Deleting old repository content')
         self.repo_dir.transport.delete_tree('repository.backup')
         ui.ui_factory.note('repository converted')
-        pb.finished()
+
+    def step(self, message):
+        """Update the pb by a step."""
+        self.count +=1
+        self.pb.update(message, self.count, self.total)
 
 
 _unescape_map = {
@@ -4601,10 +4616,8 @@
 
     def _get_convertable_inventory_stream(self, revision_ids,
                                           delta_versus_null=False):
-        # The two formats are sufficiently different that there is no fast
-        # path, so we need to send just inventorydeltas, which any
-        # sufficiently modern client can insert into any repository.
-        # The StreamSink code expects to be able to
+        # The source is using CHKs, but the target either doesn't or it has a
+        # different serializer.  The StreamSink code expects to be able to
         # convert on the target, so we need to put bytes-on-the-wire that can
         # be converted.  That means inventory deltas (if the remote is <1.19,
         # RemoteStreamSink will fallback to VFS to insert the deltas).

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2010-02-23 07:43:11 +0000
+++ bzrlib/revision.py	2009-11-30 12:24:55 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,6 +28,7 @@
     symbol_versioning,
     )
 from bzrlib.osutils import contains_whitespace
+from bzrlib.progress import DummyProgress
 
 NULL_REVISION="null:"
 CURRENT_REVISION="current:"

=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2010-02-17 17:11:16 +0000
+++ bzrlib/revisionspec.py	2009-10-27 14:04:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/revisiontree.py	2009-10-15 02:19:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,7 +20,9 @@
 
 from bzrlib import (
     errors,
+    osutils,
     revision,
+    symbol_versioning,
     tree,
     )
 
@@ -101,10 +103,7 @@
 
     def get_file_mtime(self, file_id, path=None):
         ie = self._inventory[file_id]
-        try:
-            revision = self._repository.get_revision(ie.revision)
-        except errors.NoSuchRevision:
-            raise errors.FileTimestampUnavailable(self.id2path(file_id))
+        revision = self._repository.get_revision(ie.revision)
         return revision.timestamp
 
     def is_executable(self, file_id, path=None):

=== modified file 'bzrlib/rules.py'
--- bzrlib/rules.py	2010-02-02 06:30:43 +0000
+++ bzrlib/rules.py	2009-05-07 05:08:46 +0000
@@ -21,7 +21,7 @@
 
 from bzrlib import (
     config,
-    cmdline,
+    commands,
     errors,
     globbing,
     osutils,
@@ -81,7 +81,8 @@
         self.pattern_to_section = {}
         for s in sections:
             if s.startswith(FILE_PREFS_PREFIX):
-                file_patterns = cmdline.split(s[FILE_PREFS_PREFIX_LEN:])
+                file_patterns = commands.shlex_split_unicode(
+                    s[FILE_PREFS_PREFIX_LEN:])
                 patterns.extend(file_patterns)
                 for fp in file_patterns:
                     self.pattern_to_section[fp] = s

=== modified file 'bzrlib/send.py'
--- bzrlib/send.py	2010-04-22 14:18:17 +0000
+++ bzrlib/send.py	2009-10-06 14:40:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,12 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-import os
 import time
 
 from bzrlib import (
     bzrdir,
     errors,
+    merge_directive,
     osutils,
     registry,
     trace,
@@ -110,11 +110,20 @@
             if len(revision) == 2:
                 base_revision_id = revision[0].as_revision_id(branch)
         if revision_id is None:
-            if tree is not None:
-                tree.check_changed_or_out_of_date(
-                    strict, 'send_strict',
-                    more_error='Use --no-strict to force the send.',
-                    more_warning='Uncommitted changes will not be sent.')
+            if strict is None:
+                strict = branch.get_config(
+                    ).get_user_option_as_bool('send_strict')
+            if strict is None: strict = True # default value
+            if strict and tree is not None:
+                if (tree.has_changes()):
+                    raise errors.UncommittedChanges(
+                        tree, more='Use --no-strict to force the send.')
+                if tree.last_revision() != tree.branch.last_revision():
+                    # The tree has lost sync with its branch, there is little
+                    # chance that the user is aware of it but he can still force
+                    # the send with --no-strict
+                    raise errors.OutOfDateTree(
+                        tree, more='Use --no-strict to force the send.')
             revision_id = branch.last_revision()
         if revision_id == NULL_REVISION:
             raise errors.BzrCommandError('No revisions to submit.')
@@ -126,36 +135,21 @@
             directive.compose_merge_request(mail_client, mail_to, body,
                                             branch, tree)
         else:
-            if directive.multiple_output_files:
-                if output == '-':
-                    raise errors.BzrCommandError('- not supported for '
-                        'merge directives that use more than one output file.')
-                if not os.path.exists(output):
-                    os.mkdir(output, 0755)
-                for (filename, lines) in directive.to_files():
-                    path = os.path.join(output, filename)
-                    outfile = open(path, 'wb')
-                    try:
-                        outfile.writelines(lines)
-                    finally:
-                        outfile.close()
+            if output == '-':
+                outfile = to_file
             else:
-                if output == '-':
-                    outfile = to_file
-                else:
-                    outfile = open(output, 'wb')
-                try:
-                    outfile.writelines(directive.to_lines())
-                finally:
-                    if outfile is not to_file:
-                        outfile.close()
+                outfile = open(output, 'wb')
+            try:
+                outfile.writelines(directive.to_lines())
+            finally:
+                if outfile is not to_file:
+                    outfile.close()
     finally:
         branch.unlock()
 
 
 def _send_4(branch, revision_id, submit_branch, public_branch,
             no_patch, no_bundle, message, base_revision_id):
-    from bzrlib import merge_directive
     return merge_directive.MergeDirective2.from_objects(
         branch.repository, revision_id, time.time(),
         osutils.local_time_offset(), submit_branch,
@@ -177,7 +171,6 @@
             patch_type = 'diff'
         else:
             patch_type = None
-    from bzrlib import merge_directive
     return merge_directive.MergeDirective.from_objects(
         branch.repository, revision_id, time.time(),
         osutils.local_time_offset(), submit_branch,

=== modified file 'bzrlib/serializer.py'
--- bzrlib/serializer.py	2010-02-17 17:11:16 +0000
+++ bzrlib/serializer.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/shelf.py'
--- bzrlib/shelf.py	2010-04-30 11:03:59 +0000
+++ bzrlib/shelf.py	2009-09-11 07:55:48 +0000
@@ -23,8 +23,11 @@
     errors,
     merge,
     merge3,
+    osutils,
     pack,
     transform,
+    ui,
+    workingtree,
 )
 
 

=== modified file 'bzrlib/shelf_ui.py'
--- bzrlib/shelf_ui.py	2010-01-15 05:33:28 +0000
+++ bzrlib/shelf_ui.py	2009-12-15 17:57:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,6 +22,7 @@
 
 from bzrlib import (
     builtins,
+    commands,
     delta,
     diff,
     errors,
@@ -382,18 +383,16 @@
     """Unshelve changes into a working tree."""
 
     @classmethod
-    def from_args(klass, shelf_id=None, action='apply', directory='.',
-                  write_diff_to=None):
+    def from_args(klass, shelf_id=None, action='apply', directory='.'):
         """Create an unshelver from commandline arguments.
 
-        The returned shelver will have a tree that is locked and should
+        The returned shelver wil have a tree that is locked and should
         be unlocked.
 
         :param shelf_id: Integer id of the shelf, as a string.
         :param action: action to perform.  May be 'apply', 'dry-run',
-            'delete', 'preview'.
+            'delete'.
         :param directory: The directory to unshelve changes into.
-        :param write_diff_to: See Unshelver.__init__().
         """
         tree, path = workingtree.WorkingTree.open_containing(directory)
         tree.lock_tree_write()
@@ -411,14 +410,9 @@
             apply_changes = True
             delete_shelf = True
             read_shelf = True
-            show_diff = False
             if action == 'dry-run':
                 apply_changes = False
                 delete_shelf = False
-            elif action == 'preview':
-                apply_changes = False
-                delete_shelf = False
-                show_diff = True
             elif action == 'delete-only':
                 apply_changes = False
                 read_shelf = False
@@ -429,11 +423,10 @@
             tree.unlock()
             raise
         return klass(tree, manager, shelf_id, apply_changes, delete_shelf,
-                     read_shelf, show_diff, write_diff_to)
+                     read_shelf)
 
     def __init__(self, tree, manager, shelf_id, apply_changes=True,
-                 delete_shelf=True, read_shelf=True, show_diff=False,
-                 write_diff_to=None):
+                 delete_shelf=True, read_shelf=True):
         """Constructor.
 
         :param tree: The working tree to unshelve into.
@@ -443,11 +436,6 @@
             working tree.
         :param delete_shelf: If True, delete the changes from the shelf.
         :param read_shelf: If True, read the changes from the shelf.
-        :param show_diff: If True, show the diff that would result from
-            unshelving the changes.
-        :param write_diff_to: A file-like object where the diff will be
-            written to. If None, ui.ui_factory.make_output_stream() will
-            be used.
         """
         self.tree = tree
         manager = tree.get_shelf_manager()
@@ -456,8 +444,6 @@
         self.apply_changes = apply_changes
         self.delete_shelf = delete_shelf
         self.read_shelf = read_shelf
-        self.show_diff = show_diff
-        self.write_diff_to = write_diff_to
 
     def run(self):
         """Perform the unshelving operation."""
@@ -471,14 +457,16 @@
                 if unshelver.message is not None:
                     trace.note('Message: %s' % unshelver.message)
                 change_reporter = delta._ChangeReporter()
-                merger = unshelver.make_merger(None)
-                merger.change_reporter = change_reporter
-                if self.apply_changes:
-                    merger.do_merge()
-                elif self.show_diff:
-                    self.write_diff(merger)
-                else:
-                    self.show_changes(merger)
+                task = ui.ui_factory.nested_progress_bar()
+                try:
+                    merger = unshelver.make_merger(task)
+                    merger.change_reporter = change_reporter
+                    if self.apply_changes:
+                        merger.do_merge()
+                    else:
+                        self.show_changes(merger)
+                finally:
+                    task.finished()
             if self.delete_shelf:
                 self.manager.delete_shelf(self.shelf_id)
                 trace.note('Deleted changes with id "%d".' % self.shelf_id)
@@ -486,16 +474,6 @@
             for cleanup in reversed(cleanups):
                 cleanup()
 
-    def write_diff(self, merger):
-        """Write this operation's diff to self.write_diff_to."""
-        tree_merger = merger.make_merger()
-        tt = tree_merger.make_preview_transform()
-        new_tree = tt.get_preview_tree()
-        if self.write_diff_to is None:
-            self.write_diff_to = ui.ui_factory.make_output_stream()
-        diff.show_diff_trees(merger.this_tree, new_tree, self.write_diff_to)
-        tt.finalize()
-
     def show_changes(self, merger):
         """Show the changes that this operation specifies."""
         tree_merger = merger.make_merger()

=== modified file 'bzrlib/shellcomplete.py'
--- bzrlib/shellcomplete.py	2010-02-17 17:11:16 +0000
+++ bzrlib/shellcomplete.py	2009-11-02 22:24:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/sign_my_commits.py'
--- bzrlib/sign_my_commits.py	2010-04-23 08:51:52 +0000
+++ bzrlib/sign_my_commits.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,7 +30,7 @@
 
 
 class cmd_sign_my_commits(Command):
-    __doc__ = """Sign all commits by a given committer.
+    """Sign all commits by a given committer.
 
     If location is not specified the local tree is used.
     If committer is not specified the default committer is used.

=== modified file 'bzrlib/smart/bzrdir.py'
--- bzrlib/smart/bzrdir.py	2010-04-23 00:44:15 +0000
+++ bzrlib/smart/bzrdir.py	2009-09-22 00:34:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -88,8 +88,8 @@
         try:
             self._bzrdir = BzrDir.open_from_transport(
                 self.transport_from_client_path(path))
-        except errors.NotBranchError, e:
-            return FailedSmartServerResponse(('nobranch',))
+        except errors.NotBranchError:
+            return FailedSmartServerResponse(('nobranch', ))
         return self.do_bzrdir_request(*args)
 
     def _boolean_to_yes_no(self, a_boolean):
@@ -110,7 +110,7 @@
         """Get the relative path for repository from current_transport."""
         # the relpath of the bzrdir in the found repository gives us the
         # path segments to pop-out.
-        relpath = repository.user_transport.relpath(
+        relpath = repository.bzrdir.root_transport.relpath(
             current_transport.base)
         if len(relpath):
             segments = ['..'] * len(relpath.split('/'))
@@ -465,8 +465,8 @@
                 return SuccessfulSmartServerResponse(('ok', ''))
             else:
                 return SuccessfulSmartServerResponse(('ok', reference_url))
-        except errors.NotBranchError, e:
-            return FailedSmartServerResponse(('nobranch',))
+        except errors.NotBranchError:
+            return FailedSmartServerResponse(('nobranch', ))
 
 
 class SmartServerRequestOpenBranchV2(SmartServerRequestBzrDir):
@@ -481,39 +481,5 @@
                 return SuccessfulSmartServerResponse(('branch', format))
             else:
                 return SuccessfulSmartServerResponse(('ref', reference_url))
-        except errors.NotBranchError, e:
-            return FailedSmartServerResponse(('nobranch',))
-
-
-class SmartServerRequestOpenBranchV3(SmartServerRequestBzrDir):
-
-    def do_bzrdir_request(self):
-        """Open a branch at path and return the reference or format.
-        
-        This version introduced in 2.1.
-
-        Differences to SmartServerRequestOpenBranchV2:
-          * can return 2-element ('nobranch', extra), where 'extra' is a string
-            with an explanation like 'location is a repository'.  Previously
-            a 'nobranch' response would never have more than one element.
-        """
-        try:
-            reference_url = self._bzrdir.get_branch_reference()
-            if reference_url is None:
-                br = self._bzrdir.open_branch(ignore_fallbacks=True)
-                format = br._format.network_name()
-                return SuccessfulSmartServerResponse(('branch', format))
-            else:
-                return SuccessfulSmartServerResponse(('ref', reference_url))
-        except errors.NotBranchError, e:
-            # Stringify the exception so that its .detail attribute will be
-            # filled out.
-            str(e)
-            resp = ('nobranch',)
-            detail = e.detail
-            if detail:
-                if detail.startswith(': '):
-                    detail = detail[2:]
-                resp += (detail,)
-            return FailedSmartServerResponse(resp)
-
+        except errors.NotBranchError:
+            return FailedSmartServerResponse(('nobranch', ))

=== modified file 'bzrlib/smart/client.py'
--- bzrlib/smart/client.py	2010-02-17 17:11:16 +0000
+++ bzrlib/smart/client.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006-2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,9 +36,6 @@
         else:
             self._headers = dict(headers)
 
-    def __repr__(self):
-        return '%s(%r)' % (self.__class__.__name__, self._medium)
-
     def _send_request(self, protocol_version, method, args, body=None,
                       readv_body=None, body_stream=None):
         encoder, response_handler = self._construct_protocol(

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2010-05-03 04:08:50 +0000
+++ bzrlib/smart/medium.py	2009-12-21 17:00:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,14 +24,15 @@
 bzrlib/transport/smart/__init__.py.
 """
 
+import errno
 import os
+import socket
 import sys
 import urllib
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import atexit
-import socket
 import thread
 import weakref
 
@@ -46,13 +47,14 @@
 from bzrlib.smart import client, protocol, request, vfs
 from bzrlib.transport import ssh
 """)
+#usually already imported, and getting IllegalScoperReplacer on it here.
 from bzrlib import osutils
 
-# Throughout this module buffer size parameters are either limited to be at
-# most _MAX_READ_SIZE, or are ignored and _MAX_READ_SIZE is used instead.
-# For this module's purposes, MAX_SOCKET_CHUNK is a reasonable size for reads
-# from non-sockets as well.
-_MAX_READ_SIZE = osutils.MAX_SOCKET_CHUNK
+# We must not read any more than 64k at a time so we don't risk "no buffer
+# space available" errors on some platforms.  Windows in particular is likely
+# to give error 10053 or 10055 if we read more than 64k from a socket.
+_MAX_READ_SIZE = 64 * 1024
+
 
 def _get_protocol_factory_for_bytes(bytes):
     """Determine the right protocol factory for 'bytes'.
@@ -274,9 +276,9 @@
     def _serve_one_request_unguarded(self, protocol):
         while protocol.next_read_size():
             # We can safely try to read large chunks.  If there is less data
-            # than MAX_SOCKET_CHUNK ready, the socket will just return a
-            # short read immediately rather than block.
-            bytes = self.read_bytes(osutils.MAX_SOCKET_CHUNK)
+            # than _MAX_READ_SIZE ready, the socket wil just return a short
+            # read immediately rather than block.
+            bytes = self.read_bytes(_MAX_READ_SIZE)
             if bytes == '':
                 self.finished = True
                 return
@@ -285,13 +287,13 @@
         self._push_back(protocol.unused_data)
 
     def _read_bytes(self, desired_count):
-        return osutils.read_bytes_from_socket(
-            self.socket, self._report_activity)
+        return _read_bytes_from_socket(
+            self.socket.recv, desired_count, self._report_activity)
 
     def terminate_due_to_error(self):
         # TODO: This should log to a server log file, but no such thing
         # exists yet.  Andrew Bennetts 2006-09-29.
-        self.socket.close()
+        osutils.until_no_eintr(self.socket.close)
         self.finished = True
 
     def _write_out(self, bytes):
@@ -332,27 +334,27 @@
             bytes_to_read = protocol.next_read_size()
             if bytes_to_read == 0:
                 # Finished serving this request.
-                self._out.flush()
+                osutils.until_no_eintr(self._out.flush)
                 return
             bytes = self.read_bytes(bytes_to_read)
             if bytes == '':
                 # Connection has been closed.
                 self.finished = True
-                self._out.flush()
+                osutils.until_no_eintr(self._out.flush)
                 return
             protocol.accept_bytes(bytes)
 
     def _read_bytes(self, desired_count):
-        return self._in.read(desired_count)
+        return osutils.until_no_eintr(self._in.read, desired_count)
 
     def terminate_due_to_error(self):
         # TODO: This should log to a server log file, but no such thing
         # exists yet.  Andrew Bennetts 2006-09-29.
-        self._out.close()
+        osutils.until_no_eintr(self._out.close)
         self.finished = True
 
     def _write_out(self, bytes):
-        self._out.write(bytes)
+        osutils.until_no_eintr(self._out.write, bytes)
 
 
 class SmartClientMediumRequest(object):
@@ -607,16 +609,10 @@
             # which is newer than a previously supplied older-than version.
             # This indicates that some smart verb call is not guarded
             # appropriately (it should simply not have been tried).
-            trace.mutter(
+            raise AssertionError(
                 "_remember_remote_is_before(%r) called, but "
                 "_remember_remote_is_before(%r) was called previously."
-                , version_tuple, self._remote_version_is_before)
-            if 'hpss' in debug.debug_flags:
-                ui.ui_factory.show_warning(
-                    "_remember_remote_is_before(%r) called, but "
-                    "_remember_remote_is_before(%r) was called previously."
-                    % (version_tuple, self._remote_version_is_before))
-            return
+                % (version_tuple, self._remote_version_is_before))
         self._remote_version_is_before = version_tuple
 
     def protocol_version(self):
@@ -715,10 +711,6 @@
     """A client medium using simple pipes.
 
     This client does not manage the pipes: it assumes they will always be open.
-
-    Note that if readable_pipe.read might raise IOError or OSError with errno
-    of EINTR, it must be safe to retry the read.  Plain CPython fileobjects
-    (such as used for sys.stdin) are safe.
     """
 
     def __init__(self, readable_pipe, writeable_pipe, base):
@@ -728,12 +720,12 @@
 
     def _accept_bytes(self, bytes):
         """See SmartClientStreamMedium.accept_bytes."""
-        self._writeable_pipe.write(bytes)
+        osutils.until_no_eintr(self._writeable_pipe.write, bytes)
         self._report_activity(len(bytes), 'write')
 
     def _flush(self):
         """See SmartClientStreamMedium._flush()."""
-        self._writeable_pipe.flush()
+        osutils.until_no_eintr(self._writeable_pipe.flush)
 
     def _read_bytes(self, count):
         """See SmartClientStreamMedium._read_bytes."""
@@ -757,9 +749,6 @@
         self._password = password
         self._port = port
         self._username = username
-        # for the benefit of progress making a short description of this
-        # transport
-        self._scheme = 'bzr+ssh'
         # SmartClientStreamMedium stores the repr of this object in its
         # _DebugCounter so we have to store all the values used in our repr
         # method before calling the super init.
@@ -769,31 +758,30 @@
         self._vendor = vendor
         self._write_to = None
         self._bzr_remote_path = bzr_remote_path
+        # for the benefit of progress making a short description of this
+        # transport
+        self._scheme = 'bzr+ssh'
 
     def __repr__(self):
-        if self._port is None:
-            maybe_port = ''
-        else:
-            maybe_port = ':%s' % self._port
-        return "%s(%s://%s@%s%s/)" % (
+        return "%s(connected=%r, username=%r, host=%r, port=%r)" % (
             self.__class__.__name__,
-            self._scheme,
+            self._connected,
             self._username,
             self._host,
-            maybe_port)
+            self._port)
 
     def _accept_bytes(self, bytes):
         """See SmartClientStreamMedium.accept_bytes."""
         self._ensure_connection()
-        self._write_to.write(bytes)
+        osutils.until_no_eintr(self._write_to.write, bytes)
         self._report_activity(len(bytes), 'write')
 
     def disconnect(self):
         """See SmartClientMedium.disconnect()."""
         if not self._connected:
             return
-        self._read_from.close()
-        self._write_to.close()
+        osutils.until_no_eintr(self._read_from.close)
+        osutils.until_no_eintr(self._write_to.close)
         self._ssh_connection.close()
         self._connected = False
 
@@ -822,7 +810,7 @@
         if not self._connected:
             raise errors.MediumNotConnected(self)
         bytes_to_read = min(count, _MAX_READ_SIZE)
-        bytes = self._read_from.read(bytes_to_read)
+        bytes = osutils.until_no_eintr(self._read_from.read, bytes_to_read)
         self._report_activity(len(bytes), 'read')
         return bytes
 
@@ -852,7 +840,7 @@
         """See SmartClientMedium.disconnect()."""
         if not self._connected:
             return
-        self._socket.close()
+        osutils.until_no_eintr(self._socket.close)
         self._socket = None
         self._connected = False
 
@@ -906,8 +894,8 @@
         """See SmartClientMedium.read_bytes."""
         if not self._connected:
             raise errors.MediumNotConnected(self)
-        return osutils.read_bytes_from_socket(
-            self._socket, self._report_activity)
+        return _read_bytes_from_socket(
+            self._socket.recv, count, self._report_activity)
 
 
 class SmartClientStreamMediumRequest(SmartClientMediumRequest):
@@ -950,3 +938,19 @@
         self._medium._flush()
 
 
+def _read_bytes_from_socket(sock, desired_count, report_activity):
+    # We ignore the desired_count because on sockets it's more efficient to
+    # read large chunks (of _MAX_READ_SIZE bytes) at a time.
+    try:
+        bytes = osutils.until_no_eintr(sock, _MAX_READ_SIZE)
+    except socket.error, e:
+        if len(e.args) and e.args[0] in (errno.ECONNRESET, 10054):
+            # The connection was closed by the other side.  Callers expect an
+            # empty string to signal end-of-stream.
+            bytes = ''
+        else:
+            raise
+    else:
+        report_activity(len(bytes), 'read')
+    return bytes
+

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2010-03-26 04:26:55 +0000
+++ bzrlib/smart/protocol.py	2009-12-21 17:00:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -62,13 +62,7 @@
 
 def _encode_tuple(args):
     """Encode the tuple args to a bytestream."""
-    joined = '\x01'.join(args) + '\n'
-    if type(joined) is unicode:
-        # XXX: We should fix things so this never happens!  -AJB, 20100304
-        mutter('response args contain unicode, should be only bytes: %r',
-               joined)
-        joined = joined.encode('ascii')
-    return joined
+    return '\x01'.join(args) + '\n'
 
 
 class Requester(object):

=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2010-03-25 07:34:15 +0000
+++ bzrlib/smart/repository.py	2009-09-03 00:33:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,6 +20,7 @@
 import os
 import Queue
 import sys
+import tarfile
 import tempfile
 import threading
 
@@ -29,7 +30,6 @@
     graph,
     osutils,
     pack,
-    ui,
     versionedfile,
     )
 from bzrlib.bzrdir import BzrDir
@@ -675,7 +675,6 @@
             temp.close()
 
     def _tarball_of_dir(self, dirname, compression, ofile):
-        import tarfile
         filename = os.path.basename(ofile.name)
         tarball = tarfile.open(fileobj=ofile, name=filename,
             mode='w|' + compression)

=== modified file 'bzrlib/smart/request.py'
--- bzrlib/smart/request.py	2010-02-17 17:11:16 +0000
+++ bzrlib/smart/request.py	2009-12-21 17:00:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -561,9 +561,6 @@
     'BzrDir.open_branchV2', 'bzrlib.smart.bzrdir',
     'SmartServerRequestOpenBranchV2')
 request_handlers.register_lazy(
-    'BzrDir.open_branchV3', 'bzrlib.smart.bzrdir',
-    'SmartServerRequestOpenBranchV3')
-request_handlers.register_lazy(
     'delete', 'bzrlib.smart.vfs', 'DeleteRequest')
 request_handlers.register_lazy(
     'get', 'bzrlib.smart.vfs', 'GetRequest')

=== modified file 'bzrlib/smart/server.py'
--- bzrlib/smart/server.py	2010-03-05 07:27:58 +0000
+++ bzrlib/smart/server.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -138,8 +138,6 @@
                         if e.args[0] != errno.EBADF:
                             trace.warning("listening socket error: %s", e)
                     else:
-                        if self._should_terminate:
-                            break
                         self.serve_conn(conn, thread_name_suffix)
             except KeyboardInterrupt:
                 # dont log when CTRL-C'd.
@@ -238,6 +236,91 @@
 SmartTCPServer.hooks = SmartServerHooks()
 
 
+class SmartTCPServer_for_testing(SmartTCPServer):
+    """Server suitable for use by transport tests.
+
+    This server is backed by the process's cwd.
+    """
+
+    def __init__(self, thread_name_suffix=''):
+        SmartTCPServer.__init__(self, None)
+        self.client_path_extra = None
+        self.thread_name_suffix = thread_name_suffix
+
+    def get_backing_transport(self, backing_transport_server):
+        """Get a backing transport from a server we are decorating."""
+        return transport.get_transport(backing_transport_server.get_url())
+
+    def start_server(self, backing_transport_server=None,
+              client_path_extra='/extra/'):
+        """Set up server for testing.
+
+        :param backing_transport_server: backing server to use.  If not
+            specified, a LocalURLServer at the current working directory will
+            be used.
+        :param client_path_extra: a path segment starting with '/' to append to
+            the root URL for this server.  For instance, a value of '/foo/bar/'
+            will mean the root of the backing transport will be published at a
+            URL like `bzr://127.0.0.1:nnnn/foo/bar/`, rather than
+            `bzr://127.0.0.1:nnnn/`.  Default value is `extra`, so that tests
+            by default will fail unless they do the necessary path translation.
+        """
+        if not client_path_extra.startswith('/'):
+            raise ValueError(client_path_extra)
+        from bzrlib.transport.chroot import ChrootServer
+        if backing_transport_server is None:
+            from bzrlib.transport.local import LocalURLServer
+            backing_transport_server = LocalURLServer()
+        self.chroot_server = ChrootServer(
+            self.get_backing_transport(backing_transport_server))
+        self.chroot_server.start_server()
+        self.backing_transport = transport.get_transport(
+            self.chroot_server.get_url())
+        self.root_client_path = self.client_path_extra = client_path_extra
+        self.start_background_thread(self.thread_name_suffix)
+
+    def stop_server(self):
+        self.stop_background_thread()
+        self.chroot_server.stop_server()
+
+    def get_url(self):
+        url = super(SmartTCPServer_for_testing, self).get_url()
+        return url[:-1] + self.client_path_extra
+
+    def get_bogus_url(self):
+        """Return a URL which will fail to connect"""
+        return 'bzr://127.0.0.1:1/'
+
+
+class ReadonlySmartTCPServer_for_testing(SmartTCPServer_for_testing):
+    """Get a readonly server for testing."""
+
+    def get_backing_transport(self, backing_transport_server):
+        """Get a backing transport from a server we are decorating."""
+        url = 'readonly+' + backing_transport_server.get_url()
+        return transport.get_transport(url)
+
+
+class SmartTCPServer_for_testing_v2_only(SmartTCPServer_for_testing):
+    """A variation of SmartTCPServer_for_testing that limits the client to
+    using RPCs in protocol v2 (i.e. bzr <= 1.5).
+    """
+
+    def get_url(self):
+        url = super(SmartTCPServer_for_testing_v2_only, self).get_url()
+        url = 'bzr-v2://' + url[len('bzr://'):]
+        return url
+
+
+class ReadonlySmartTCPServer_for_testing_v2_only(SmartTCPServer_for_testing_v2_only):
+    """Get a readonly server for testing."""
+
+    def get_backing_transport(self, backing_transport_server):
+        """Get a backing transport from a server we are decorating."""
+        url = 'readonly+' + backing_transport_server.get_url()
+        return transport.get_transport(url)
+
+
 def _local_path_for_transport(transport):
     """Return a local path for transport, if reasonably possible.
     

=== modified file 'bzrlib/smart/vfs.py'
--- bzrlib/smart/vfs.py	2010-02-17 17:11:16 +0000
+++ bzrlib/smart/vfs.py	2009-10-23 04:22:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/static_tuple.py'
--- bzrlib/static_tuple.py	2010-02-17 17:11:16 +0000
+++ bzrlib/static_tuple.py	2009-11-28 21:54:08 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2010-04-30 11:35:43 +0000
+++ bzrlib/status.py	2009-12-02 15:24:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,64 +20,20 @@
     delta as _mod_delta,
     log,
     osutils,
+    tree,
     tsort,
     revision as _mod_revision,
     )
 import bzrlib.errors as errors
+from bzrlib.osutils import is_inside_any
+from bzrlib.symbol_versioning import (deprecated_function,
+        )
 from bzrlib.trace import mutter, warning
 
 # TODO: when showing single-line logs, truncate to the width of the terminal
 # if known, but only if really going to the terminal (not into a file)
 
 
-def report_changes(to_file, old, new, specific_files, 
-                   show_short_reporter, show_long_callback, 
-                   short=False, want_unchanged=False, 
-                   want_unversioned=False, show_ids=False):
-    """Display summary of changes.
-
-    This compares two trees with regards to a list of files, and delegates 
-    the display to underlying elements.
-
-    For short output, it creates an iterator on all changes, and lets a given
-    reporter display these changes.
-
-    For stantard output, it creates a delta of the changes, and forwards it
-    to a callback
-
-    :param to_file: If set, write to this file (default stdout.)
-    :param old: Start tree for the comparison
-    :param end: End tree for the comparison
-    :param specific_files: If set, a list of filenames whose status should be
-        shown.  It is an error to give a filename that is not in the working
-        tree, or in the working inventory or in the basis inventory.
-    :param show_short_reporter: Reporter in charge of display for short output
-    :param show_long_callback: Callback in charge of display for normal output
-    :param short: If True, gives short SVN-style status lines.
-    :param want_unchanged: Deprecated parameter. If set, includes unchanged
-        files.
-    :param show_ids: If set, includes each file's id.
-    :param want_unversioned: If False, only shows versioned files.
-    """
-
-    if short:
-        changes = new.iter_changes(old, want_unchanged, specific_files,
-            require_versioned=False, want_unversioned=want_unversioned)
-        _mod_delta.report_changes(changes, show_short_reporter)
-        
-    else:
-        delta = new.changes_from(old, want_unchanged=want_unchanged,
-                              specific_files=specific_files,
-                              want_unversioned=want_unversioned)
-        # filter out unknown files. We may want a tree method for
-        # this
-        delta.unversioned = [unversioned for unversioned in
-            delta.unversioned if not new.is_ignored(unversioned[0])]
-        show_long_callback(to_file, delta, 
-                           show_ids=show_ids,
-                           show_unchanged=want_unchanged)
-
-
 def show_tree_status(wt, show_unchanged=None,
                      specific_files=None,
                      show_ids=False,
@@ -86,8 +42,7 @@
                      revision=None,
                      short=False,
                      verbose=False,
-                     versioned=False,
-                     show_long_callback=_mod_delta.report_delta):
+                     versioned=False):
     """Display summary of changes.
 
     By default this compares the working tree to a previous revision.
@@ -116,8 +71,6 @@
     :param verbose: If True, show all merged revisions, not just
         the merge tips
     :param versioned: If True, only shows versioned files.
-    :param show_long_callback: A callback: message = show_long_callback(to_file, delta, 
-        show_ids, show_unchanged, indent, filter), only used with the long output
     """
     if show_unchanged is not None:
         warn("show_tree_status with show_unchanged has been deprecated "
@@ -153,29 +106,24 @@
             specific_files, nonexistents \
                 = _filter_nonexistent(specific_files, old, new)
             want_unversioned = not versioned
-
-            # Reporter used for short outputs
-            reporter = _mod_delta._ChangeReporter(output_file=to_file,
-                unversioned_filter=new.is_ignored)
-            report_changes(to_file, old, new, specific_files, 
-                           reporter, show_long_callback, 
-                           short=short, want_unchanged=show_unchanged, 
-                           want_unversioned=want_unversioned, show_ids=show_ids)
-
-            # show the ignored files among specific files (i.e. show the files
-            # identified from input that we choose to ignore). 
-            if specific_files is not None:
-                # Ignored files is sorted because specific_files is already sorted
-                ignored_files = [specific for specific in
-                    specific_files if new.is_ignored(specific)]
-                if len(ignored_files) > 0 and not short:
-                    to_file.write("ignored:\n")
-                    prefix = ' '
-                else:
-                    prefix = 'I  '
-                for ignored_file in ignored_files:
-                    to_file.write("%s %s\n" % (prefix, ignored_file))
-
+            if short:
+                changes = new.iter_changes(old, show_unchanged, specific_files,
+                    require_versioned=False, want_unversioned=want_unversioned)
+                reporter = _mod_delta._ChangeReporter(output_file=to_file,
+                    unversioned_filter=new.is_ignored)
+                _mod_delta.report_changes(changes, reporter)
+            else:
+                delta = new.changes_from(old, want_unchanged=show_unchanged,
+                                      specific_files=specific_files,
+                                      want_unversioned=want_unversioned)
+                # filter out unknown files. We may want a tree method for
+                # this
+                delta.unversioned = [unversioned for unversioned in
+                    delta.unversioned if not new.is_ignored(unversioned[0])]
+                delta.show(to_file,
+                           show_ids=show_ids,
+                           show_unchanged=show_unchanged,
+                           short_status=False)
             # show the new conflicts only for now. XXX: get them from the
             # delta.
             conflicts = new.conflicts()

=== modified file 'bzrlib/switch.py'
--- bzrlib/switch.py	2010-05-03 04:08:50 +0000
+++ bzrlib/switch.py	2009-06-19 21:16:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd.
+# Copyright (C) 2006, 2007 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,26 +17,17 @@
 # Original author: David Allouche
 
 from bzrlib import errors, merge, revision
-from bzrlib.branch import Branch
+from bzrlib.branch import Branch, BranchFormat, BranchReferenceFormat
+from bzrlib.bzrdir import BzrDir
 from bzrlib.trace import note
 
 
-def _run_post_switch_hooks(control_dir, to_branch, force, revision_id):
-    from bzrlib.branch import SwitchHookParams
-    hooks = Branch.hooks['post_switch']
-    if not hooks:
-        return
-    params = SwitchHookParams(control_dir, to_branch, force, revision_id)
-    for hook in hooks:
-        hook(params)
-
-def switch(control_dir, to_branch, force=False, quiet=False, revision_id=None):
+def switch(control_dir, to_branch, force=False, quiet=False):
     """Switch the branch associated with a checkout.
 
     :param control_dir: BzrDir of the checkout to change
     :param to_branch: branch that the checkout is to reference
     :param force: skip the check for local commits in a heavy checkout
-    :param revision_id: revision ID to switch to.
     """
     _check_pending_merges(control_dir, force)
     try:
@@ -45,8 +36,8 @@
         source_repository = to_branch.repository
     _set_branch_location(control_dir, to_branch, force)
     tree = control_dir.open_workingtree()
-    _update(tree, source_repository, quiet, revision_id)
-    _run_post_switch_hooks(control_dir, to_branch, force, revision_id)
+    _update(tree, source_repository, quiet)
+
 
 def _check_pending_merges(control, force=False):
     """Check that there are no outstanding pending merges before switching.
@@ -127,7 +118,7 @@
     return False
 
 
-def _update(tree, source_repository, quiet=False, revision_id=None):
+def _update(tree, source_repository, quiet=False):
     """Update a working tree to the latest revision of its branch.
 
     :param tree: the working tree
@@ -136,14 +127,12 @@
     tree.lock_tree_write()
     try:
         to_branch = tree.branch
-        if revision_id is None:
-            revision_id = to_branch.last_revision()
-        if tree.last_revision() == revision_id:
+        if tree.last_revision() == to_branch.last_revision():
             if not quiet:
                 note("Tree is up to date at revision %d.", to_branch.revno())
             return
         base_tree = source_repository.revision_tree(tree.last_revision())
-        merge.Merge3Merger(tree, tree, base_tree, to_branch.repository.revision_tree(revision_id))
+        merge.Merge3Merger(tree, tree, base_tree, to_branch.basis_tree())
         tree.set_last_revision(to_branch.last_revision())
         if not quiet:
             note('Updated to revision %d.' % to_branch.revno())

=== modified file 'bzrlib/tag.py'
--- bzrlib/tag.py	2010-03-25 09:39:03 +0000
+++ bzrlib/tag.py	2009-06-10 03:56:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,6 +26,8 @@
 # called tags* are ctags files... mbp 20070220.
 
 
+from warnings import warn
+
 from bzrlib import (
     bencode,
     errors,
@@ -251,4 +253,3 @@
 
 def _merge_tags_if_possible(from_branch, to_branch):
     from_branch.tags.merge_to(to_branch.tags)
-

=== modified file 'bzrlib/tests/TestUtil.py'
--- bzrlib/tests/TestUtil.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/TestUtil.py	2009-12-05 09:04:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006 Canonical Ltd
 #       Author: Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-05-06 07:48:22 +0000
+++ bzrlib/tests/__init__.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Testing framework extensions"""
 
 # TODO: Perhaps there should be an API to find out if bzr running under the
 # test suite -- some plugins might want to avoid making intrusive changes if
@@ -102,17 +101,13 @@
     deprecated_passed,
     )
 import bzrlib.trace
-from bzrlib.transport import (
-    get_transport,
-    memory,
-    pathfilter,
-    )
+from bzrlib.transport import get_transport, pathfilter
 import bzrlib.transport
+from bzrlib.transport.local import LocalURLServer
+from bzrlib.transport.memory import MemoryServer
+from bzrlib.transport.readonly import ReadonlyServer
 from bzrlib.trace import mutter, note
-from bzrlib.tests import (
-    test_server,
-    TestUtil,
-    )
+from bzrlib.tests import TestUtil
 from bzrlib.tests.http_server import HttpServer
 from bzrlib.tests.TestUtil import (
                           TestSuite,
@@ -129,12 +124,7 @@
 # shown frame is the test code, not our assertXYZ.
 __unittest = 1
 
-default_transport = test_server.LocalURLServer
-
-
-_unitialized_attr = object()
-"""A sentinel needed to act as a default value in a method signature."""
-
+default_transport = LocalURLServer
 
 # Subunit result codes, defined here to prevent a hard dependency on subunit.
 SUBUNIT_SEEK_SET = 0
@@ -247,9 +237,6 @@
                 '%d non-main threads were left active in the end.\n'
                 % (TestCase._active_threads - 1))
 
-    def getDescription(self, test):
-        return test.id()
-
     def _extractBenchmarkTime(self, testCase, details=None):
         """Add a benchmark time for the current test case."""
         if details and 'benchtime' in details:
@@ -490,13 +477,13 @@
         return self._shortened_test_description(test)
 
     def report_error(self, test, err):
-        self.stream.write('ERROR: %s\n    %s\n' % (
+        ui.ui_factory.note('ERROR: %s\n    %s\n' % (
             self._test_description(test),
             err[1],
             ))
 
     def report_failure(self, test, err):
-        self.stream.write('FAIL: %s\n    %s\n' % (
+        ui.ui_factory.note('FAIL: %s\n    %s\n' % (
             self._test_description(test),
             err[1],
             ))
@@ -707,6 +694,10 @@
     """
 
 
+class CommandFailed(Exception):
+    pass
+
+
 class StringIOWrapper(object):
     """A wrapper around cStringIO which just adds an encoding attribute.
 
@@ -856,12 +847,12 @@
         Tests that want to use debug flags can just set them in the
         debug_flags set during setup/teardown.
         """
-        # Start with a copy of the current debug flags we can safely modify.
-        self.overrideAttr(debug, 'debug_flags', set(debug.debug_flags))
+        self._preserved_debug_flags = set(debug.debug_flags)
         if 'allow_debug' not in selftest_debug_flags:
             debug.debug_flags.clear()
         if 'disable_lock_checks' not in selftest_debug_flags:
             debug.debug_flags.add('strict_locks')
+        self.addCleanup(self._restore_debug_flags)
 
     def _clear_hooks(self):
         # prevent hooks affecting tests
@@ -888,7 +879,11 @@
     def _silenceUI(self):
         """Turn off UI for duration of test"""
         # by default the UI is off; tests can turn it on if they want it.
-        self.overrideAttr(ui, 'ui_factory', ui.SilentUIFactory())
+        saved = ui.ui_factory
+        def _restore():
+            ui.ui_factory = saved
+        ui.ui_factory = ui.SilentUIFactory()
+        self.addCleanup(_restore)
 
     def _check_locks(self):
         """Check that all lock take/release actions have been paired."""
@@ -923,7 +918,7 @@
             self._lock_check_thorough = False
         else:
             self._lock_check_thorough = True
-
+            
         self.addCleanup(self._check_locks)
         _mod_lock.Lock.hooks.install_named_hook('lock_acquired',
                                                 self._lock_acquired, None)
@@ -1045,8 +1040,7 @@
         if t.base.endswith('/work/'):
             # we have safety net/test root/work
             t = t.clone('../..')
-        elif isinstance(transport_server,
-                        test_server.SmartTCPServer_for_testing):
+        elif isinstance(transport_server, server.SmartTCPServer_for_testing):
             # The smart server adds a path similar to work, which is traversed
             # up from by the client. But the server is chrooted - the actual
             # backing transport is not escaped from, and VFS requests to the
@@ -1207,10 +1201,6 @@
             raise AssertionError('pattern "%s" found in "%s"'
                     % (needle_re, haystack))
 
-    def assertContainsString(self, haystack, needle):
-        if haystack.find(needle) == -1:
-            self.fail("string %r not found in '''%s'''" % (needle, haystack))
-
     def assertSubset(self, sublist, superlist):
         """Assert that every entry in sublist is present in superlist."""
         missing = set(sublist) - set(superlist)
@@ -1313,14 +1303,6 @@
             f.close()
         self.assertEqualDiff(content, s)
 
-    def assertDocstring(self, expected_docstring, obj):
-        """Fail if obj does not have expected_docstring"""
-        if __doc__ is None:
-            # With -OO the docstring should be None instead
-            self.assertIs(obj.__doc__, None)
-        else:
-            self.assertEqual(expected_docstring, obj.__doc__)
-
     def failUnlessExists(self, path):
         """Fail unless path or paths, which may be abs or relative, exist."""
         if not isinstance(path, basestring):
@@ -1494,25 +1476,6 @@
         """
         self._cleanups.append((callable, args, kwargs))
 
-    def overrideAttr(self, obj, attr_name, new=_unitialized_attr):
-        """Overrides an object attribute restoring it after the test.
-
-        :param obj: The object that will be mutated.
-
-        :param attr_name: The attribute name we want to preserve/override in
-            the object.
-
-        :param new: The optional value we want to set the attribute to.
-
-        :returns: The actual attr value.
-        """
-        value = getattr(obj, attr_name)
-        # The actual value is captured by the call below
-        self.addCleanup(setattr, obj, attr_name, value)
-        if new is not _unitialized_attr:
-            setattr(obj, attr_name, new)
-        return value
-
     def _cleanEnvironment(self):
         new_env = {
             'BZR_HOME': None, # Don't inherit BZR_HOME to all the tests.
@@ -1528,8 +1491,6 @@
             'BZR_PROGRESS_BAR': None,
             'BZR_LOG': None,
             'BZR_PLUGIN_PATH': None,
-            'BZR_DISABLE_PLUGINS': None,
-            'BZR_PLUGINS_AT': None,
             'BZR_CONCURRENCY': None,
             # Make sure that any text ui tests are consistent regardless of
             # the environment the test case is run in; you may want tests that
@@ -1556,23 +1517,22 @@
             'ftp_proxy': None,
             'FTP_PROXY': None,
             'BZR_REMOTE_PATH': None,
-            # Generally speaking, we don't want apport reporting on crashes in
-            # the test envirnoment unless we're specifically testing apport,
-            # so that it doesn't leak into the real system environment.  We
-            # use an env var so it propagates to subprocesses.
-            'APPORT_DISABLE': '1',
         }
-        self._old_env = {}
+        self.__old_env = {}
         self.addCleanup(self._restoreEnvironment)
         for name, value in new_env.iteritems():
             self._captureVar(name, value)
 
     def _captureVar(self, name, newvalue):
         """Set an environment variable, and reset it when finished."""
-        self._old_env[name] = osutils.set_or_unset_env(name, newvalue)
+        self.__old_env[name] = osutils.set_or_unset_env(name, newvalue)
+
+    def _restore_debug_flags(self):
+        debug.debug_flags.clear()
+        debug.debug_flags.update(self._preserved_debug_flags)
 
     def _restoreEnvironment(self):
-        for name, value in self._old_env.iteritems():
+        for name, value in self.__old_env.iteritems():
             osutils.set_or_unset_env(name, value)
 
     def _restoreHooks(self):
@@ -1682,33 +1642,7 @@
                 unicodestr = log_contents.decode('utf8', 'replace')
                 log_contents = unicodestr.encode('utf8')
             if not keep_log_file:
-                close_attempts = 0
-                max_close_attempts = 100
-                first_close_error = None
-                while close_attempts < max_close_attempts:
-                    close_attempts += 1
-                    try:
-                        self._log_file.close()
-                    except IOError, ioe:
-                        if ioe.errno is None:
-                            # No errno implies 'close() called during
-                            # concurrent operation on the same file object', so
-                            # retry.  Probably a thread is trying to write to
-                            # the log file.
-                            if first_close_error is None:
-                                first_close_error = ioe
-                            continue
-                        raise
-                    else:
-                        break
-                if close_attempts > 1:
-                    sys.stderr.write(
-                        'Unable to close log file on first attempt, '
-                        'will retry: %s\n' % (first_close_error,))
-                    if close_attempts == max_close_attempts:
-                        sys.stderr.write(
-                            'Unable to close log file after %d attempts.\n'
-                            % (max_close_attempts,))
+                self._log_file.close()
                 self._log_file = None
                 # Permit multiple calls to get_log until we clean it up in
                 # finishLogFile
@@ -2100,7 +2034,11 @@
 
         Tests that expect to provoke LockContention errors should call this.
         """
-        self.overrideAttr(bzrlib.lockdir, '_DEFAULT_TIMEOUT_SECONDS', 0)
+        orig_timeout = bzrlib.lockdir._DEFAULT_TIMEOUT_SECONDS
+        def resetTimeout():
+            bzrlib.lockdir._DEFAULT_TIMEOUT_SECONDS = orig_timeout
+        self.addCleanup(resetTimeout)
+        bzrlib.lockdir._DEFAULT_TIMEOUT_SECONDS = 0
 
     def make_utf8_encoded_stringio(self, encoding_type=None):
         """Return a StringIOWrapper instance, that will encode Unicode
@@ -2120,7 +2058,9 @@
         request_handlers = request.request_handlers
         orig_method = request_handlers.get(verb)
         request_handlers.remove(verb)
-        self.addCleanup(request_handlers.register, verb, orig_method)
+        def restoreVerb():
+            request_handlers.register(verb, orig_method)
+        self.addCleanup(restoreVerb)
 
 
 class CapturedCall(object):
@@ -2217,7 +2157,7 @@
         if self.__readonly_server is None:
             if self.transport_readonly_server is None:
                 # readonly decorator requested
-                self.__readonly_server = test_server.ReadonlyServer()
+                self.__readonly_server = ReadonlyServer()
             else:
                 # explicit readonly transport.
                 self.__readonly_server = self.create_transport_readonly_server()
@@ -2246,7 +2186,7 @@
         is no means to override it.
         """
         if self.__vfs_server is None:
-            self.__vfs_server = memory.MemoryServer()
+            self.__vfs_server = MemoryServer()
             self.start_server(self.__vfs_server)
         return self.__vfs_server
 
@@ -2409,7 +2349,7 @@
         return made_control.create_repository(shared=shared)
 
     def make_smart_server(self, path):
-        smart_server = test_server.SmartTCPServer_for_testing()
+        smart_server = server.SmartTCPServer_for_testing()
         self.start_server(smart_server, self.get_server())
         remote_transport = get_transport(smart_server.get_url()).clone(path)
         return remote_transport
@@ -2433,7 +2373,10 @@
     def setUp(self):
         super(TestCaseWithMemoryTransport, self).setUp()
         self._make_test_root()
-        self.addCleanup(os.chdir, os.getcwdu())
+        _currentdir = os.getcwdu()
+        def _leaveDirectory():
+            os.chdir(_currentdir)
+        self.addCleanup(_leaveDirectory)
         self.makeAndChdirToTestDir()
         self.overrideEnvironmentForTesting()
         self.__readonly_server = None
@@ -2442,7 +2385,7 @@
 
     def setup_smart_server_with_call_log(self):
         """Sets up a smart server as the transport server with a call log."""
-        self.transport_server = test_server.SmartTCPServer_for_testing
+        self.transport_server = server.SmartTCPServer_for_testing
         self.hpss_calls = []
         import traceback
         # Skip the current stack down to the caller of
@@ -2661,7 +2604,7 @@
             # We can only make working trees locally at the moment.  If the
             # transport can't support them, then we keep the non-disk-backed
             # branch and create a local checkout.
-            if self.vfs_transport_factory is test_server.LocalURLServer:
+            if self.vfs_transport_factory is LocalURLServer:
                 # the branch is colocated on disk, we cannot create a checkout.
                 # hopefully callers will expect this.
                 local_controldir= bzrdir.BzrDir.open(self.get_vfs_only_url(relpath))
@@ -2727,7 +2670,7 @@
 
     def setUp(self):
         super(ChrootedTestCase, self).setUp()
-        if not self.vfs_transport_factory == memory.MemoryServer:
+        if not self.vfs_transport_factory == MemoryServer:
             self.transport_readonly_server = HttpServer
 
 
@@ -3201,19 +3144,6 @@
     return result
 
 
-def workaround_zealous_crypto_random():
-    """Crypto.Random want to help us being secure, but we don't care here.
-
-    This workaround some test failure related to the sftp server. Once paramiko
-    stop using the controversial API in Crypto.Random, we may get rid of it.
-    """
-    try:
-        from Crypto.Random import atfork
-        atfork()
-    except ImportError:
-        pass
-
-
 def fork_for_tests(suite):
     """Take suite and start up one runner per CPU by forking()
 
@@ -3234,7 +3164,7 @@
             try:
                 ProtocolTestCase.run(self, result)
             finally:
-                os.waitpid(self.pid, 0)
+                os.waitpid(self.pid, os.WNOHANG)
 
     test_blocks = partition_tests(suite, concurrency)
     for process_tests in test_blocks:
@@ -3243,7 +3173,6 @@
         c2pread, c2pwrite = os.pipe()
         pid = os.fork()
         if pid == 0:
-            workaround_zealous_crypto_random()
             try:
                 os.close(c2pread)
                 # Leave stderr and stdout open so we can see test noise
@@ -3618,7 +3547,7 @@
 # appear prefixed ('bzrlib.' is "replaced" by 'bzrlib.').
 test_prefix_alias_registry.register('bzrlib', 'bzrlib')
 
-# Obvious highest levels prefixes, feel free to add your own via a plugin
+# Obvious higest levels prefixes, feel free to add your own via a plugin
 test_prefix_alias_registry.register('bd', 'bzrlib.doc')
 test_prefix_alias_registry.register('bu', 'bzrlib.utils')
 test_prefix_alias_registry.register('bt', 'bzrlib.tests')
@@ -3634,7 +3563,6 @@
         'bzrlib.tests.commands',
         'bzrlib.tests.per_branch',
         'bzrlib.tests.per_bzrdir',
-        'bzrlib.tests.per_bzrdir_colo',
         'bzrlib.tests.per_foreign_vcs',
         'bzrlib.tests.per_interrepository',
         'bzrlib.tests.per_intertree',
@@ -3680,7 +3608,6 @@
         'bzrlib.tests.test_chunk_writer',
         'bzrlib.tests.test_clean_tree',
         'bzrlib.tests.test_cleanup',
-        'bzrlib.tests.test_cmdline',
         'bzrlib.tests.test_commands',
         'bzrlib.tests.test_commit',
         'bzrlib.tests.test_commit_merge',
@@ -3720,7 +3647,6 @@
         'bzrlib.tests.test_identitymap',
         'bzrlib.tests.test_ignores',
         'bzrlib.tests.test_index',
-        'bzrlib.tests.test_import_tariff',
         'bzrlib.tests.test_info',
         'bzrlib.tests.test_inv',
         'bzrlib.tests.test_inventory_delta',
@@ -3734,7 +3660,6 @@
         'bzrlib.tests.test_lru_cache',
         'bzrlib.tests.test_lsprof',
         'bzrlib.tests.test_mail_client',
-        'bzrlib.tests.test_matchers',
         'bzrlib.tests.test_memorytree',
         'bzrlib.tests.test_merge',
         'bzrlib.tests.test_merge3',
@@ -3820,14 +3745,10 @@
 
 
 def _test_suite_modules_to_doctest():
-    """Return the list of modules to doctest."""
-    if __doc__ is None:
-        # GZ 2009-03-31: No docstrings with -OO so there's nothing to doctest
-        return []
+    """Return the list of modules to doctest."""   
     return [
         'bzrlib',
         'bzrlib.branchbuilder',
-        'bzrlib.decorators',
         'bzrlib.export',
         'bzrlib.inventory',
         'bzrlib.iterablefile',
@@ -4198,30 +4119,21 @@
     should really use a different feature.
     """
 
-    def __init__(self, dep_version, module, name,
-                 replacement_name, replacement_module=None):
+    def __init__(self, module, name, this_name, dep_version):
         super(_CompatabilityThunkFeature, self).__init__()
         self._module = module
-        if replacement_module is None:
-            replacement_module = module
-        self._replacement_module = replacement_module
         self._name = name
-        self._replacement_name = replacement_name
+        self._this_name = this_name
         self._dep_version = dep_version
         self._feature = None
 
     def _ensure(self):
         if self._feature is None:
-            depr_msg = self._dep_version % ('%s.%s'
-                                            % (self._module, self._name))
-            use_msg = ' Use %s.%s instead.' % (self._replacement_module,
-                                               self._replacement_name)
-            symbol_versioning.warn(depr_msg + use_msg, DeprecationWarning)
-            # Import the new feature and use it as a replacement for the
-            # deprecated one.
-            mod = __import__(self._replacement_module, {}, {},
-                             [self._replacement_name])
-            self._feature = getattr(mod, self._replacement_name)
+            msg = (self._dep_version % self._this_name) + (
+                   ' Use %s.%s instead.' % (self._module, self._name))
+            symbol_versioning.warn(msg, DeprecationWarning)
+            mod = __import__(self._module, {}, {}, [self._name])
+            self._feature = getattr(mod, self._name)
 
     def _probe(self):
         self._ensure()
@@ -4253,16 +4165,15 @@
         if self.available(): # Make sure the probe has been done
             return self._module
         return None
-
+    
     def feature_name(self):
         return self.module_name
 
 
 # This is kept here for compatibility, it is recommended to use
 # 'bzrlib.tests.feature.paramiko' instead
-ParamikoFeature = _CompatabilityThunkFeature(
-    deprecated_in((2,1,0)),
-    'bzrlib.tests.features', 'ParamikoFeature', 'paramiko')
+ParamikoFeature = _CompatabilityThunkFeature('bzrlib.tests.features',
+    'paramiko', 'bzrlib.tests.ParamikoFeature', deprecated_in((2,1,0)))
 
 
 def probe_unicode_in_user_encoding():
@@ -4429,27 +4340,9 @@
 CaseInsensitiveFilesystemFeature = _CaseInsensitiveFilesystemFeature()
 
 
-class _CaseSensitiveFilesystemFeature(Feature):
-
-    def _probe(self):
-        if CaseInsCasePresFilenameFeature.available():
-            return False
-        elif CaseInsensitiveFilesystemFeature.available():
-            return False
-        else:
-            return True
-
-    def feature_name(self):
-        return 'case-sensitive filesystem'
-
-# new coding style is for feature instances to be lowercase
-case_sensitive_filesystem_feature = _CaseSensitiveFilesystemFeature()
-
-
 # Kept for compatibility, use bzrlib.tests.features.subunit instead
-SubUnitFeature = _CompatabilityThunkFeature(
-    deprecated_in((2,1,0)),
-    'bzrlib.tests.features', 'SubUnitFeature', 'subunit')
+SubUnitFeature = _CompatabilityThunkFeature('bzrlib.tests.features', 'subunit',
+    'bzrlib.tests.SubUnitFeature', deprecated_in((2,1,0)))
 # Only define SubUnitBzrRunner if subunit is available.
 try:
     from subunit import TestProtocolClient
@@ -4462,27 +4355,3 @@
             return result
 except ImportError:
     pass
-
-class _PosixPermissionsFeature(Feature):
-
-    def _probe(self):
-        def has_perms():
-            # create temporary file and check if specified perms are maintained.
-            import tempfile
-
-            write_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
-            f = tempfile.mkstemp(prefix='bzr_perms_chk_')
-            fd, name = f
-            os.close(fd)
-            os.chmod(name, write_perms)
-
-            read_perms = os.stat(name).st_mode & 0777
-            os.unlink(name)
-            return (write_perms == read_perms)
-
-        return (os.name == 'posix') and has_perms()
-
-    def feature_name(self):
-        return 'POSIX permissions support'
-
-posix_permissions_feature = _PosixPermissionsFeature()

=== modified file 'bzrlib/tests/blackbox/__init__.py'
--- bzrlib/tests/blackbox/__init__.py	2010-04-26 13:51:08 +0000
+++ bzrlib/tests/blackbox/__init__.py	2009-04-29 20:31:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,7 +23,7 @@
 """
 
 
-from bzrlib import tests
+from bzrlib.tests import TestCaseWithTransport
 
 
 def load_tests(basic_tests, module, loader):
@@ -95,7 +95,6 @@
                      'bzrlib.tests.blackbox.test_revno',
                      'bzrlib.tests.blackbox.test_revision_history',
                      'bzrlib.tests.blackbox.test_revision_info',
-                     'bzrlib.tests.blackbox.test_rmbranch',
                      'bzrlib.tests.blackbox.test_selftest',
                      'bzrlib.tests.blackbox.test_send',
                      'bzrlib.tests.blackbox.test_serve',
@@ -123,7 +122,7 @@
     return suite
 
 
-class ExternalBase(tests.TestCaseWithTransport):
+class ExternalBase(TestCaseWithTransport):
 
     def check_output(self, output, *args):
         """Verify that the expected output matches what bzr says.

=== modified file 'bzrlib/tests/blackbox/test_add.py'
--- bzrlib/tests/blackbox/test_add.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/blackbox/test_add.py	2009-11-08 00:05:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,28 +19,32 @@
 
 import os
 
-from bzrlib import (
-    osutils,
-    tests,
+from bzrlib import osutils
+from bzrlib.tests import (
+    condition_isinstance,
+    split_suite_by_condition,
+    multiply_tests,
+    SymlinkFeature
     )
+from bzrlib.tests.blackbox import ExternalBase
 
 
 def load_tests(standard_tests, module, loader):
     """Parameterize tests for view-aware vs not."""
-    to_adapt, result = tests.split_suite_by_condition(
-        standard_tests, tests.condition_isinstance(TestAdd))
+    to_adapt, result = split_suite_by_condition(
+        standard_tests, condition_isinstance(TestAdd))
     scenarios = [
         ('pre-views', {'branch_tree_format': 'pack-0.92'}),
         ('view-aware', {'branch_tree_format': 'development6-rich-root'}),
         ]
-    return tests.multiply_tests(to_adapt, scenarios, result)
-
-
-class TestAdd(tests.TestCaseWithTransport):
+    return multiply_tests(to_adapt, scenarios, result)
+
+
+class TestAdd(ExternalBase):
 
     def make_branch_and_tree(self, dir):
-        return super(TestAdd, self).make_branch_and_tree(
-            dir, format=self.branch_tree_format)
+        return ExternalBase.make_branch_and_tree(self, dir,
+            format=self.branch_tree_format)
 
     def test_add_reports(self):
         """add command prints the names of added files."""
@@ -111,6 +115,7 @@
 
         eq = self.assertEqual
         ass = self.assertTrue
+        chdir = os.chdir
 
         t = self.make_branch_and_tree('.')
         b = t.branch
@@ -125,15 +130,17 @@
 
         # add with no arguments in a subdirectory gets only files below that
         # subdirectory
-        self.run_bzr('add', working_dir='src')
-        self.assertEquals('README\n',
-                          self.run_bzr('unknowns', working_dir='src')[0])
+        chdir('src')
+        self.run_bzr('add')
+        self.assertEquals(self.run_bzr('unknowns')[0], 'README\n')
         # reopen to see the new changes
-        t = t.bzrdir.open_workingtree('src')
+        t = t.bzrdir.open_workingtree()
         versioned = [path for path, entry in t.iter_entries_by_dir()]
-        self.assertEquals(versioned, ['', 'src', 'src/foo.c'])
+        self.assertEquals(versioned,
+            ['', 'src', 'src/foo.c'])
 
         # add from the parent directory should pick up all file names
+        chdir('..')
         self.run_bzr('add')
         self.assertEquals(self.run_bzr('unknowns')[0], '')
         self.run_bzr('check')
@@ -204,7 +211,7 @@
         self.assertContainsRe(err, r'ERROR:.*\.bzr.*control file')
 
     def test_add_via_symlink(self):
-        self.requireFeature(tests.SymlinkFeature)
+        self.requireFeature(SymlinkFeature)
         self.make_branch_and_tree('source')
         self.build_tree(['source/top.txt'])
         os.symlink('source', 'link')
@@ -212,7 +219,7 @@
         self.assertEquals(out, 'adding top.txt\n')
 
     def test_add_symlink_to_abspath(self):
-        self.requireFeature(tests.SymlinkFeature)
+        self.requireFeature(SymlinkFeature)
         self.make_branch_and_tree('tree')
         os.symlink(osutils.abspath('target'), 'tree/link')
         out = self.run_bzr(['add', 'tree/link'])[0]

=== modified file 'bzrlib/tests/blackbox/test_annotate.py'
--- bzrlib/tests/blackbox/test_annotate.py	2010-03-24 14:15:01 +0000
+++ bzrlib/tests/blackbox/test_annotate.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -29,7 +29,6 @@
 from bzrlib.branch import Branch
 from bzrlib.config import extract_email_address
 from bzrlib.tests import TestCaseWithTransport
-from bzrlib.urlutils import joinpath
 
 
 class TestAnnotate(TestCaseWithTransport):
@@ -140,7 +139,7 @@
         out, err = self.run_bzr('annotate hello.txt -r 10',
                                 retcode=3)
         self.assertEqual('', out)
-        self.assertContainsRe(err, "Requested revision: '10' does not exist")
+        self.assertContainsRe(err, 'Requested revision: \'10\' does not exist')
 
     def test_annotate_cmd_two_revisions(self):
         out, err = self.run_bzr('annotate hello.txt -r1..2',
@@ -154,27 +153,14 @@
 class TestSimpleAnnotate(TestCaseWithTransport):
     """Annotate tests with no complex setup."""
 
-    def _setup_edited_file(self, relpath='.'):
+    def _setup_edited_file(self):
         """Create a tree with a locally edited file."""
-        tree = self.make_branch_and_tree(relpath)
-        file_relpath = joinpath(relpath, 'file')
-        self.build_tree_contents([(file_relpath, 'foo\ngam\n')])
+        tree = self.make_branch_and_tree('.')
+        self.build_tree_contents([('file', 'foo\ngam\n')])
         tree.add('file')
         tree.commit('add file', committer="test@host", rev_id="rev1")
-        self.build_tree_contents([(file_relpath, 'foo\nbar\ngam\n')])
+        self.build_tree_contents([('file', 'foo\nbar\ngam\n')])
         tree.branch.get_config().set_user_option('email', 'current@host2')
-        return tree
-
-    def test_annotate_cmd_revspec_branch(self):
-        tree = self._setup_edited_file('trunk')
-        tree.branch.create_checkout(self.get_url('work'), lightweight=True)
-        os.chdir('work')
-        out, err = self.run_bzr('annotate file -r branch:../trunk')
-        self.assertEqual('', err)
-        self.assertEqual(
-            '1   test@ho | foo\n'
-            '            | gam\n',
-            out)
 
     def test_annotate_edited_file(self):
         tree = self._setup_edited_file()

=== modified file 'bzrlib/tests/blackbox/test_bound_branches.py'
--- bzrlib/tests/blackbox/test_bound_branches.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/blackbox/test_bound_branches.py	2009-09-17 11:54:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,18 +22,17 @@
 
 from bzrlib import (
     bzrdir,
-    errors,
-    tests,
+    errors
     )
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import (BzrDir, BzrDirFormat, BzrDirMetaFormat1)
 from bzrlib.osutils import getcwd
-from bzrlib.tests import script
+from bzrlib.tests import TestCaseWithTransport
 import bzrlib.urlutils as urlutils
 from bzrlib.workingtree import WorkingTree
 
 
-class TestLegacyFormats(tests.TestCaseWithTransport):
+class TestLegacyFormats(TestCaseWithTransport):
 
     def setUp(self):
         super(TestLegacyFormats, self).setUp()
@@ -62,7 +61,7 @@
                          'upgrade your branch at %s/.\n' % cwd, err)
 
 
-class TestBoundBranches(tests.TestCaseWithTransport):
+class TestBoundBranches(TestCaseWithTransport):
 
     def create_branches(self):
         base_tree = self.make_branch_and_tree('base')
@@ -421,24 +420,3 @@
         # both the local and master should have been updated.
         self.check_revno(4)
         self.check_revno(4, '../base')
-
-
-class TestBind(script.TestCaseWithTransportAndScript):
-
-    def test_bind_when_bound(self):
-        self.run_script("""
-$ bzr init trunk
-$ bzr init copy
-$ cd copy
-$ bzr bind ../trunk
-$ bzr bind
-2>bzr: ERROR: Branch is already bound
-""")
-
-    def test_bind_before_bound(self):
-        self.run_script("""
-$ bzr init trunk
-$ cd trunk
-$ bzr bind
-2>bzr: ERROR: No location supplied and no previous location known
-""")

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2010-04-22 17:08:27 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2009-11-27 00:34:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,7 +31,6 @@
 from bzrlib.tests import (
     KnownFailure,
     HardlinkFeature,
-    test_server,
     )
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.urlutils import local_path_to_url, strip_trailing_slash
@@ -210,43 +209,6 @@
         self.assertEqual('', out)
         self.assertEqual('bzr: ERROR: Already a branch: "b".\n', err)
 
-    def test_branch_bind(self):
-        self.example_branch('a')
-        out, err = self.run_bzr('branch a b --bind')
-        self.assertEndsWith(err, "New branch bound to a\n")
-        b = branch.Branch.open('b')
-        self.assertEndsWith(b.get_bound_location(), '/a/')
-
-    def test_branch_with_post_branch_init_hook(self):
-        calls = []
-        branch.Branch.hooks.install_named_hook('post_branch_init',
-            calls.append, None)
-        self.assertLength(0, calls)
-        self.example_branch('a')
-        self.assertLength(1, calls)
-        self.run_bzr('branch a b')
-        self.assertLength(2, calls)
-
-    def test_checkout_with_post_branch_init_hook(self):
-        calls = []
-        branch.Branch.hooks.install_named_hook('post_branch_init',
-            calls.append, None)
-        self.assertLength(0, calls)
-        self.example_branch('a')
-        self.assertLength(1, calls)
-        self.run_bzr('checkout a b')
-        self.assertLength(2, calls)
-
-    def test_lightweight_checkout_with_post_branch_init_hook(self):
-        calls = []
-        branch.Branch.hooks.install_named_hook('post_branch_init',
-            calls.append, None)
-        self.assertLength(0, calls)
-        self.example_branch('a')
-        self.assertLength(1, calls)
-        self.run_bzr('checkout --lightweight a b')
-        self.assertLength(2, calls)
-
 
 class TestBranchStacked(ExternalBase):
     """Tests for branch --stacked"""
@@ -339,7 +301,8 @@
 
     def test_branch_stacked_from_smart_server(self):
         # We can branch stacking on a smart server
-        self.transport_server = test_server.SmartTCPServer_for_testing
+        from bzrlib.smart.server import SmartTCPServer_for_testing
+        self.transport_server = SmartTCPServer_for_testing
         trunk = self.make_branch('mainline', format='1.9')
         out, err = self.run_bzr(
             ['branch', '--stacked', self.get_url('mainline'), 'shallow'])
@@ -355,8 +318,6 @@
             '  Packs 5 (adds stacking support, requires bzr 1.6)\n'
             'Source branch format does not support stacking, using format:\n'
             '  Branch format 7\n'
-            'Doing on-the-fly conversion from RepositoryFormatKnitPack1() to RepositoryFormatKnitPack5().\n'
-            'This may take some time. Upgrade the repositories to the same format for better performance.\n'
             'Created new stacked branch referring to %s.\n' % (trunk.base,),
             err)
 
@@ -370,8 +331,6 @@
             '  Packs 5 rich-root (adds stacking support, requires bzr 1.6.1)\n'
             'Source branch format does not support stacking, using format:\n'
             '  Branch format 7\n'
-            'Doing on-the-fly conversion from RepositoryFormatKnitPack4() to RepositoryFormatKnitPack5RichRoot().\n'
-            'This may take some time. Upgrade the repositories to the same format for better performance.\n'
             'Created new stacked branch referring to %s.\n' % (trunk.base,),
             err)
 

=== modified file 'bzrlib/tests/blackbox/test_break_lock.py'
--- bzrlib/tests/blackbox/test_break_lock.py	2010-03-25 09:39:03 +0000
+++ bzrlib/tests/blackbox/test_break_lock.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,7 @@
         local_branch.bind(self.master_branch)
         checkoutdir = bzrlib.bzrdir.BzrDir.create('checkout')
         bzrlib.branch.BranchReferenceFormat().initialize(
-            checkoutdir, target_branch=local_branch)
+            checkoutdir, local_branch)
         self.wt = checkoutdir.create_workingtree()
 
     def test_break_lock_help(self):

=== modified file 'bzrlib/tests/blackbox/test_cat.py'
--- bzrlib/tests/blackbox/test_cat.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/blackbox/test_cat.py	2009-09-18 09:09:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -20,9 +20,9 @@
 """
 
 import os
+import sys
 
 from bzrlib import tests
-from bzrlib.transport import memory
 
 
 class TestCat(tests.TestCaseWithTransport):
@@ -128,18 +128,6 @@
         out, err = self.run_bzr_subprocess(['cat', url])
         self.assertEqual('contents of README\n', out)
 
-    def test_cat_branch_revspec(self):
-        wt = self.make_branch_and_tree('a')
-        self.build_tree(['a/README'])
-        wt.add('README')
-        wt.commit('Making sure there is a basis_tree available')
-        wt = self.make_branch_and_tree('b')
-        os.chdir('b')
-
-        out, err = self.run_bzr_subprocess(
-            ['cat', '-r', 'branch:../a', 'README'])
-        self.assertEqual('contents of a/README\n', out)
-
     def test_cat_filters(self):
         wt = self.make_branch_and_tree('.')
         self.build_tree(['README'])
@@ -196,6 +184,6 @@
         self.assertEqual('contents of README\n', out)
 
     def test_cat_nonexistent_branch(self):
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = tests.MemoryServer
         self.run_bzr_error(['^bzr: ERROR: Not a branch'],
                            ['cat', self.get_url()])

=== modified file 'bzrlib/tests/blackbox/test_cat_revision.py'
--- bzrlib/tests/blackbox/test_cat_revision.py	2010-02-15 20:23:34 +0000
+++ bzrlib/tests/blackbox/test_cat_revision.py	2009-03-23 14:59:43 +0000
@@ -36,16 +36,11 @@
         wt.commit('Commit two', rev_id='a@r-0-2')
         wt.commit('Commit three', rev_id='a@r-0-3')
 
-        r.lock_read()
-        try:
-            revs = {}
-            for i in (1, 2, 3):
-                revid = "a@r-0-%d" % i
-                stream = r.revisions.get_record_stream([(revid,)], 'unordered', 
-                                                       False) 
-                revs[i] = stream.next().get_bytes_as('fulltext')
-        finally:
-            r.unlock()
+        revs = {
+            1:r.get_revision_xml('a@r-0-1'),
+            2:r.get_revision_xml('a@r-0-2'),
+            3:r.get_revision_xml('a@r-0-3'),
+        }
 
         self.check_output(revs[1], 'cat-revision a@r-0-1')
         self.check_output(revs[2], 'cat-revision a@r-0-2')

=== modified file 'bzrlib/tests/blackbox/test_checkout.py'
--- bzrlib/tests/blackbox/test_checkout.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_checkout.py	2009-12-01 06:07:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2010-04-07 22:22:27 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2009-12-07 10:38:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -343,31 +343,22 @@
         trunk = self.make_branch_and_tree('trunk')
 
         u1 = trunk.branch.create_checkout('u1')
-        self.build_tree_contents([('u1/hosts', 'initial contents\n')])
+        self.build_tree_contents([('u1/hosts', 'initial contents')])
         u1.add('hosts')
         self.run_bzr('commit -m add-hosts u1')
 
         u2 = trunk.branch.create_checkout('u2')
-        self.build_tree_contents([('u2/hosts', 'altered in u2\n')])
+        self.build_tree_contents([('u2/hosts', 'altered in u2')])
         self.run_bzr('commit -m checkin-from-u2 u2')
 
         # make an offline commits
-        self.build_tree_contents([('u1/hosts', 'first offline change in u1\n')])
+        self.build_tree_contents([('u1/hosts', 'first offline change in u1')])
         self.run_bzr('commit -m checkin-offline --local u1')
 
         # now try to pull in online work from u2, and then commit our offline
         # work as a merge
         # retcode 1 as we expect a text conflict
         self.run_bzr('update u1', retcode=1)
-        self.assertFileEqual('''\
-<<<<<<< TREE
-first offline change in u1
-=======
-altered in u2
->>>>>>> MERGE-SOURCE
-''',
-                             'u1/hosts')
-
         self.run_bzr('resolved u1/hosts')
         # add a text change here to represent resolving the merge conflicts in
         # favour of a new version of the file not identical to either the u1
@@ -675,38 +666,28 @@
         self.assertContainsRe(err,
             r'^bzr: ERROR: Cannot lock.*readonly transport')
 
-    def setup_editor(self):
+    def test_commit_hook_template(self):
         # Test that commit template hooks work
+        def restoreDefaults():
+            msgeditor.hooks['commit_message_template'] = []
+            osutils.set_or_unset_env('BZR_EDITOR', default_editor)
         if sys.platform == "win32":
             f = file('fed.bat', 'w')
             f.write('@rem dummy fed')
             f.close()
-            osutils.set_or_unset_env('BZR_EDITOR', "fed.bat")
+            default_editor = osutils.set_or_unset_env('BZR_EDITOR', "fed.bat")
         else:
             f = file('fed.sh', 'wb')
             f.write('#!/bin/sh\n')
             f.close()
             os.chmod('fed.sh', 0755)
-            osutils.set_or_unset_env('BZR_EDITOR', "./fed.sh")
-
-    def setup_commit_with_template(self):
-        self.setup_editor()
+            default_editor = osutils.set_or_unset_env('BZR_EDITOR', "./fed.sh")
+        self.addCleanup(restoreDefaults)
         msgeditor.hooks.install_named_hook("commit_message_template",
                 lambda commit_obj, msg: "save me some typing\n", None)
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/hello.txt'])
         tree.add('hello.txt')
-        return tree
-
-    def test_commit_hook_template_accepted(self):
-        tree = self.setup_commit_with_template()
-        out, err = self.run_bzr("commit tree/hello.txt", stdin="y\n")
+        out, err = self.run_bzr("commit tree/hello.txt")
         last_rev = tree.branch.repository.get_revision(tree.last_revision())
         self.assertEqual('save me some typing\n', last_rev.message)
-
-    def test_commit_hook_template_rejected(self):
-        tree = self.setup_commit_with_template()
-        expected = tree.last_revision()
-        out, err = self.run_bzr_error(["empty commit message"],
-            "commit tree/hello.txt", stdin="n\n")
-        self.assertEqual(expected, tree.last_revision())

=== modified file 'bzrlib/tests/blackbox/test_conflicts.py'
--- bzrlib/tests/blackbox/test_conflicts.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/blackbox/test_conflicts.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,22 +14,21 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import os
+
 from bzrlib import (
-    conflicts,
-    tests,
-    workingtree,
+    conflicts
     )
+from bzrlib.workingtree import WorkingTree
+from bzrlib.tests.blackbox import ExternalBase
 
 # FIXME: These don't really look at the output of the conflict commands, just
 # the number of lines - there should be more examination.
 
-class TestConflictsBase(tests.TestCaseWithTransport):
+class TestConflicts(ExternalBase):
 
     def setUp(self):
-        super(TestConflictsBase, self).setUp()
-        self.make_tree_with_conflicts()
-
-    def make_tree_with_conflicts(self):
+        super(ExternalBase, self).setUp()
         a_tree = self.make_branch_and_tree('a')
         self.build_tree_contents([
             ('a/myfile', 'contentsa\n'),
@@ -54,48 +53,45 @@
         a_tree.rename_one('mydir', 'mydir3')
         a_tree.commit(message='change')
         a_tree.merge_from_branch(b_tree.branch)
-
-    def run_bzr(self, cmd, working_dir='a', **kwargs):
-        return super(TestConflictsBase, self).run_bzr(
-            cmd, working_dir=working_dir, **kwargs)
-
-
-class TestConflicts(TestConflictsBase):
+        os.chdir('a')
 
     def test_conflicts(self):
-        out, err = self.run_bzr('conflicts')
-        self.assertEqual(3, len(out.splitlines()))
+        conflicts, errs = self.run_bzr('conflicts')
+        self.assertEqual(3, len(conflicts.splitlines()))
 
     def test_conflicts_text(self):
-        out, err = self.run_bzr('conflicts --text')
-        self.assertEqual(['my_other_file', 'myfile'], out.splitlines())
-
-
-class TestResolve(TestConflictsBase):
+        conflicts = self.run_bzr('conflicts --text')[0].splitlines()
+        self.assertEqual(['my_other_file', 'myfile'], conflicts)
 
     def test_resolve(self):
         self.run_bzr('resolve myfile')
-        out, err = self.run_bzr('conflicts')
-        self.assertEqual(2, len(out.splitlines()))
+        conflicts, errs = self.run_bzr('conflicts')
+        self.assertEqual(2, len(conflicts.splitlines()))
         self.run_bzr('resolve my_other_file')
         self.run_bzr('resolve mydir2')
-        out, err = self.run_bzr('conflicts')
-        self.assertEqual(0, len(out.splitlines()))
+        conflicts, errs = self.run_bzr('conflicts')
+        self.assertEqual(len(conflicts.splitlines()), 0)
 
     def test_resolve_all(self):
         self.run_bzr('resolve --all')
-        out, err = self.run_bzr('conflicts')
-        self.assertEqual(0, len(out.splitlines()))
+        conflicts, errs = self.run_bzr('conflicts')
+        self.assertEqual(len(conflicts.splitlines()), 0)
 
     def test_resolve_in_subdir(self):
         """resolve when run from subdirectory should handle relative paths"""
-        self.build_tree(["a/subdir/"])
-        self.run_bzr("resolve ../myfile", working_dir='a/subdir')
-        self.run_bzr("resolve ../a/myfile", working_dir='b')
-        wt = workingtree.WorkingTree.open_containing('b')[0]
-        conflicts = wt.conflicts()
-        self.assertEqual(True, conflicts.is_empty(),
-                         "tree still contains conflicts: %r" % conflicts)
+        orig_dir = os.getcwdu()
+        try:
+            os.mkdir("subdir")
+            os.chdir("subdir")
+            self.run_bzr("resolve ../myfile")
+            os.chdir("../../b")
+            self.run_bzr("resolve ../a/myfile")
+            wt = WorkingTree.open_containing('.')[0]
+            conflicts = wt.conflicts()
+            if not conflicts.is_empty():
+                self.fail("tree still contains conflicts: %r" % conflicts)
+        finally:
+            os.chdir(orig_dir)
 
     def test_auto_resolve(self):
         """Text conflicts can be resolved automatically"""
@@ -106,10 +102,11 @@
         self.assertEqual(tree.kind('file_id'), 'file')
         file_conflict = conflicts.TextConflict('file', file_id='file_id')
         tree.set_conflicts(conflicts.ConflictList([file_conflict]))
-        note = self.run_bzr('resolve', retcode=1, working_dir='tree')[1]
+        os.chdir('tree')
+        note = self.run_bzr('resolve', retcode=1)[1]
         self.assertContainsRe(note, '0 conflict\\(s\\) auto-resolved.')
         self.assertContainsRe(note,
             'Remaining conflicts:\nText conflict in file')
-        self.build_tree_contents([('tree/file', 'a\n')])
-        note = self.run_bzr('resolve', working_dir='tree')[1]
+        self.build_tree_contents([('file', 'a\n')])
+        note = self.run_bzr('resolve')[1]
         self.assertContainsRe(note, 'All conflicts resolved.')

=== modified file 'bzrlib/tests/blackbox/test_debug.py'
--- bzrlib/tests/blackbox/test_debug.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_debug.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	2010-04-05 21:56:39 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2009-09-18 08:50:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,10 +25,6 @@
     tests,
     workingtree,
     )
-from bzrlib.diff import (
-    DiffTree,
-    format_registry as diff_format_registry,
-    )
 
 
 def subst_dates(string):
@@ -136,10 +132,6 @@
         out, err = self.run_bzr('diff -r 1..23..123', retcode=3,
             error_regexes=('one or two revision specifiers',))
 
-    def test_diff_using_and_format(self):
-        out, err = self.run_bzr('diff --format=default --using=mydi', retcode=3,
-            error_regexes=('are mutually exclusive',))
-
     def test_diff_nonexistent_revision(self):
         out, err = self.run_bzr('diff -r 123', retcode=3,
             error_regexes=("Requested revision: '123' does not "
@@ -305,22 +297,6 @@
         output = self.run_bzr('diff -r 1.. branch1', retcode=1)
         self.assertContainsRe(output[0], '\n\\-original line\n\\+repo line\n')
 
-    def test_custom_format(self):
-        class BooDiffTree(DiffTree):
-
-            def show_diff(self, specific_files, extra_trees=None):
-                self.to_file.write("BOO!\n")
-                return super(BooDiffTree, self).show_diff(specific_files,
-                    extra_trees)
-
-        diff_format_registry.register("boo", BooDiffTree, 
-            "Scary diff format")
-        self.addCleanup(diff_format_registry.remove, "boo")
-        self.make_example_branch()
-        self.build_tree_contents([('hello', 'hello world!\n')])
-        output = self.run_bzr('diff --format=boo', retcode=1)
-        self.assertTrue("BOO!" in output[0])
-
 
 class TestCheckoutDiff(TestDiff):
 

=== modified file 'bzrlib/tests/blackbox/test_dpush.py'
--- bzrlib/tests/blackbox/test_dpush.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_dpush.py	2009-10-02 14:35:30 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -153,6 +153,20 @@
         conf.set_user_option('dpush_strict', value)
 
     _default_command = ['dpush', '../to']
+    _default_pushed_revid = False # Doesn't aplly for dpush
+
+    def assertPushSucceeds(self, args, pushed_revid=None):
+        self.run_bzr(self._default_command + args,
+                     working_dir=self._default_wd)
+        if pushed_revid is None:
+            # dpush change the revids, so we need to get back to it
+            branch_from = branch.Branch.open(self._default_wd)
+            pushed_revid = branch_from.last_revision()
+        branch_to = branch.Branch.open('to')
+        repo_to = branch_to.repository
+        self.assertTrue(repo_to.has_revision(pushed_revid))
+        self.assertEqual(branch_to.last_revision(), pushed_revid)
+
 
 
 class TestDpushStrictWithoutChanges(TestDpushStrictMixin,

=== modified file 'bzrlib/tests/blackbox/test_dump_btree.py'
--- bzrlib/tests/blackbox/test_dump_btree.py	2010-03-25 09:39:03 +0000
+++ bzrlib/tests/blackbox/test_dump_btree.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -78,16 +78,3 @@
             'test2\0key3\0ref\0entry3\0value3\n'
             '\n',
             out)
-
-    def test_dump_btree_no_refs_smoke(self):
-        # A BTree index with no ref lists (such as *.cix) can be dumped without
-        # errors.
-        builder = btree_index.BTreeBuilder(
-            reference_lists=0, key_elements=2)
-        builder.add_node(('test', 'key1'), 'value')
-        out_f = builder.finish()
-        try:
-            self.build_tree_contents([('test.btree', out_f.read())])
-        finally:
-            out_f.close()
-        out, err = self.run_bzr('dump-btree test.btree')

=== modified file 'bzrlib/tests/blackbox/test_exceptions.py'
--- bzrlib/tests/blackbox/test_exceptions.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_exceptions.py	2009-12-22 23:09:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_export.py'
--- bzrlib/tests/blackbox/test_export.py	2010-04-19 04:10:53 +0000
+++ bzrlib/tests/blackbox/test_export.py	2009-11-25 00:14:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -85,15 +85,6 @@
         self.assertEqual(['test/' + fname.encode('utf8')],
                          sorted(ball.getnames()))
 
-    def test_tar_export_unicode_basedir(self):
-        """Test for bug #413406"""
-        basedir = u'\N{euro sign}'
-        os.mkdir(basedir)
-        os.chdir(basedir)
-        self.run_bzr(['init', 'branch'])
-        os.chdir('branch')
-        self.run_bzr(['export', '--format', 'tgz', u'test.tar.gz'])
-
     def test_zip_export(self):
         tree = self.make_branch_and_tree('zip')
         self.build_tree(['zip/a'])
@@ -302,14 +293,3 @@
         tree.commit('more setup')
         out, err = self.run_bzr('export exported branch/subdir')
         self.assertEqual(['foo.txt'], os.listdir('exported'))
-
-    def test_dir_export_per_file_timestamps(self):
-        tree = self.example_branch()
-        self.build_tree_contents([('branch/har', 'foo')])
-        tree.add('har')
-        # Earliest allowable date on FAT32 filesystems is 1980-01-01
-        tree.commit('setup', timestamp=315532800)
-        self.run_bzr('export --per-file-timestamps t branch')
-        har_st = os.stat('t/har')
-        self.assertEquals(315532800, har_st.st_mtime)
-

=== modified file 'bzrlib/tests/blackbox/test_filesystem_cicp.py'
--- bzrlib/tests/blackbox/test_filesystem_cicp.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_filesystem_cicp.py	2009-08-26 09:06:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,8 +19,6 @@
 
 import os
 
-from bzrlib import (osutils,
-    )
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.tests import CaseInsCasePresFilenameFeature, KnownFailure
 from bzrlib.osutils import canonical_relpath, pathjoin
@@ -91,7 +89,7 @@
         self.build_tree(['MixedCase'])
         self.check_output('adding MixedCase\n', 'add MixedCase')
         # 'accidently' rename the file on disk
-        osutils.rename('MixedCase', 'mixedcase')
+        os.rename('MixedCase', 'mixedcase')
         self.check_empty_output('add mixedcase')
 
     def test_re_add_dir(self):
@@ -105,7 +103,7 @@
                           'adding MixedCaseParent/MixedCase\n',
                           'add MixedCaseParent')
         # 'accidently' rename the directory on disk
-        osutils.rename('MixedCaseParent', 'mixedcaseparent')
+        os.rename('MixedCaseParent', 'mixedcaseparent')
         self.check_empty_output('add mixedcaseparent')
 
     def test_add_not_found(self):
@@ -132,7 +130,7 @@
         wt = self._make_mixed_case_tree()
         self.run_bzr('add')
         self.run_bzr('ci -m message')
-        osutils.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/NewCamelCase')
+        os.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/NewCamelCase')
 
         # In this case we can specify the incorrect case for the destination,
         # as we use --after, so the file-system is sniffed.
@@ -159,7 +157,7 @@
         # Remove the source and create a destination file on disk with a different case.
         # bzr should report that the filename is already versioned.
         os.unlink('CamelCaseParent/CamelCase')
-        osutils.rename('lowercaseparent/lowercase', 'lowercaseparent/LOWERCASE')
+        os.rename('lowercaseparent/lowercase', 'lowercaseparent/LOWERCASE')
         ex = 'bzr: ERROR: Could not move CamelCase => lowercase: lowercaseparent/lowercase is already versioned.\n'
         self.check_error_output(3, ex, 'mv --after camelcaseparent/camelcase LOWERCASEPARENT/LOWERCASE')
 
@@ -175,7 +173,7 @@
         wt = self._make_mixed_case_tree()
         self.run_bzr('add')
         self.run_bzr('ci -m message')
-        osutils.rename('CamelCaseParent', 'NewCamelCaseParent')
+        os.rename('CamelCaseParent', 'NewCamelCaseParent')
 
         # In this case we can specify the incorrect case for the destination,
         # as we use --after, so the file-system is sniffed.
@@ -201,7 +199,7 @@
 
         # perform a mv to the new case - we must ensure the file-system has the
         # new case first.
-        osutils.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/camelCase')
+        os.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/camelCase')
         self.check_output('CamelCaseParent/CamelCase => CamelCaseParent/camelCase\n',
                           'mv --after camelcaseparent/camelcase camelcaseparent/camelCase')
         # bzr should not have renamed the file to a different case

=== modified file 'bzrlib/tests/blackbox/test_filtered_view_ops.py'
--- bzrlib/tests/blackbox/test_filtered_view_ops.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_filtered_view_ops.py	2009-12-14 15:51:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_help.py'
--- bzrlib/tests/blackbox/test_help.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_help.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -105,23 +105,8 @@
         self.assertEquals(dash_help, qmark_cmds)
 
     def test_hidden(self):
-        help_commands = self.run_bzr('help commands')[0]
-        help_hidden = self.run_bzr('help hidden-commands')[0]
-
-        def extract_cmd_names(help_output):
-            # keep only the command names to avoid matching on help text (there
-            # is a high risk to fail a test when a plugin get installed
-            # otherwise)
-            cmds = []
-            for line in help_output.split('\n'):
-                if line.startswith(' '):
-                    continue # help on more than one line
-                cmd = line.split(' ')[0]
-                if line:
-                    cmds.append(cmd)
-            return cmds
-        commands = extract_cmd_names(help_commands)
-        hidden = extract_cmd_names(help_hidden)
+        commands = self.run_bzr('help commands')[0]
+        hidden = self.run_bzr('help hidden-commands')[0]
         self.assertTrue('commit' in commands)
         self.assertTrue('commit' not in hidden)
         self.assertTrue('rocks' in hidden)

=== modified file 'bzrlib/tests/blackbox/test_ignore.py'
--- bzrlib/tests/blackbox/test_ignore.py	2010-04-22 12:45:03 +0000
+++ bzrlib/tests/blackbox/test_ignore.py	2009-10-23 10:41:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -106,14 +106,12 @@
         """'ignore' with no arguments returns an error"""
         self.make_branch_and_tree('.')
         self.run_bzr_error(('bzr: ERROR: ignore requires at least one '
-                            'NAME_PATTERN or --default-rules.\n',),
+                            'NAME_PATTERN or --old-default-rules\n',),
                            'ignore')
 
-    def test_ignore_default_rules(self):
-        out, err = self.run_bzr(['ignore', '--default-rules'])
-        reference_set = set(ignores.USER_DEFAULTS)
-        output_set = set(out.rstrip().split('\n'))
-        self.assertEqual(reference_set, output_set)
+    def test_ignore_old_defaults(self):
+        out, err = self.run_bzr('ignore --old-default-rules')
+        self.assertContainsRe(out, 'CVS')
         self.assertEqual('', err)
 
     def test_ignore_versioned_file(self):

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2010-04-14 09:57:01 +0000
+++ bzrlib/tests/blackbox/test_info.py	2009-09-17 11:54:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,21 +25,22 @@
     errors,
     info,
     osutils,
-    tests,
     upgrade,
     urlutils,
     )
-from bzrlib.transport import memory
-
-
-class TestInfo(tests.TestCaseWithTransport):
+from bzrlib.osutils import format_date
+from bzrlib.tests import TestSkipped, MemoryServer
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestInfo(ExternalBase):
 
     def setUp(self):
-        super(TestInfo, self).setUp()
-        self._repo_strings = "2a"
+        ExternalBase.setUp(self)
+        self._repo_strings = "2a or development-subtree"
 
     def test_info_non_existing(self):
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = MemoryServer
         location = self.get_url()
         out, err = self.run_bzr('info '+location, retcode=3)
         self.assertEqual(out, '')
@@ -126,7 +127,7 @@
         self.assertEqual('', err)
         tree1.commit('commit one')
         rev = branch1.repository.get_revision(branch1.revision_history()[0])
-        datestring_first = osutils.format_date(rev.timestamp, rev.timezone)
+        datestring_first = format_date(rev.timestamp, rev.timezone)
 
         # Branch standalone with push location
         branch2 = branch1.bzrdir.sprout('branch').open_branch()
@@ -212,8 +213,8 @@
          0 added
          0 removed
          0 renamed
-         0 unknown
-         1 ignored
+         1 unknown
+         0 ignored
          0 versioned subdirectories
 
 Branch history:
@@ -314,7 +315,7 @@
         tree1.add('b')
         tree1.commit('commit two')
         rev = branch1.repository.get_revision(branch1.revision_history()[-1])
-        datestring_last = osutils.format_date(rev.timestamp, rev.timezone)
+        datestring_last = format_date(rev.timestamp, rev.timezone)
 
         # Out of date branched standalone branch will not be detected
         out, err = self.run_bzr('info -v branch')
@@ -380,8 +381,8 @@
          0 added
          0 removed
          0 renamed
-         0 unknown
-         1 ignored
+         1 unknown
+         0 ignored
          0 versioned subdirectories
 
 Branch history:
@@ -568,7 +569,7 @@
         tree2.add('a')
         tree2.commit('commit one')
         rev = repo.get_revision(branch2.revision_history()[0])
-        datestring_first = osutils.format_date(rev.timestamp, rev.timezone)
+        datestring_first = format_date(rev.timestamp, rev.timezone)
         out, err = self.run_bzr('info tree/lightcheckout --verbose')
         self.assertEqualDiff(
 """Lightweight checkout (format: %s)
@@ -687,7 +688,7 @@
 
         # Out of date lightweight checkout
         rev = repo.get_revision(branch1.revision_history()[-1])
-        datestring_last = osutils.format_date(rev.timestamp, rev.timezone)
+        datestring_last = format_date(rev.timestamp, rev.timezone)
         out, err = self.run_bzr('info tree/lightcheckout --verbose')
         self.assertEqualDiff(
 """Lightweight checkout (format: %s)
@@ -843,7 +844,7 @@
         tree1.add('a')
         tree1.commit('commit one')
         rev = repo.get_revision(branch1.revision_history()[0])
-        datestring_first = osutils.format_date(rev.timestamp, rev.timezone)
+        datestring_first = format_date(rev.timestamp, rev.timezone)
         out, err = self.run_bzr('info -v repo/branch1')
         self.assertEqualDiff(
 """Repository tree (format: knit)
@@ -1228,8 +1229,7 @@
         # Do a light checkout of the heavy one
         transport.mkdir('tree/lightcheckout')
         lco_dir = bzrdir.BzrDirMetaFormat1().initialize('tree/lightcheckout')
-        branch.BranchReferenceFormat().initialize(lco_dir,
-            target_branch=co_branch)
+        branch.BranchReferenceFormat().initialize(lco_dir, co_branch)
         lco_dir.create_workingtree()
         lco_tree = lco_dir.open_workingtree()
 
@@ -1325,7 +1325,7 @@
 
     def test_info_locking_oslocks(self):
         if sys.platform == "win32":
-            self.skip("don't use oslocks on win32 in unix manner")
+            raise TestSkipped("don't use oslocks on win32 in unix manner")
         # This test tests old (all-in-one, OS lock using) behaviour which
         # simply cannot work on windows (and is indeed why we changed our
         # design. As such, don't try to remove the thisFailsStrictLockCheck

=== modified file 'bzrlib/tests/blackbox/test_init.py'
--- bzrlib/tests/blackbox/test_init.py	2010-04-23 07:15:23 +0000
+++ bzrlib/tests/blackbox/test_init.py	2009-11-08 02:23:13 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -196,7 +196,7 @@
     def test_init_append_revisions_only(self):
         self.run_bzr('init --dirstate-tags normal_branch6')
         branch = _mod_branch.Branch.open('normal_branch6')
-        self.assertEqual(None, branch._get_append_revisions_only())
+        self.assertEqual(False, branch._get_append_revisions_only())
         self.run_bzr('init --append-revisions-only --dirstate-tags branch6')
         branch = _mod_branch.Branch.open('branch6')
         self.assertEqual(True, branch._get_append_revisions_only())

=== modified file 'bzrlib/tests/blackbox/test_join.py'
--- bzrlib/tests/blackbox/test_join.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_join.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,13 +17,7 @@
 
 import os
 
-from bzrlib import (
-    bzrdir,
-    osutils,
-    repository,
-    tests,
-    workingtree,
-    )
+from bzrlib import bzrdir, repository, tests, workingtree
 
 
 class TestJoin(tests.TestCaseWithTransport):
@@ -56,7 +50,7 @@
     def test_join_error(self):
         base_tree, sub_tree = self.make_trees()
         os.mkdir('tree/subtree2')
-        osutils.rename('tree/subtree', 'tree/subtree2/subtree')
+        os.rename('tree/subtree', 'tree/subtree2/subtree')
         self.run_bzr_error(
             ('Cannot join .*subtree.  Parent directory is not versioned',),
              'join tree/subtree2/subtree')

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2010-04-14 12:30:17 +0000
+++ bzrlib/tests/blackbox/test_log.py	2009-11-01 03:45:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,24 +17,22 @@
 
 """Black-box tests for bzr log."""
 
-from itertools import izip
 import os
 import re
 
 from bzrlib import (
-    branchbuilder,
-    errors,
-    log,
     osutils,
     tests,
     )
-from bzrlib.tests import (
-    script,
-    test_log,
-    )
-
-
-class TestLog(tests.TestCaseWithTransport, test_log.TestLogMixin):
+from bzrlib.tests import test_log
+
+
+class TestLog(tests.TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestLog, self).setUp()
+        self.timezone = 0 # UTC
+        self.timestamp = 1132617600 # Mon 2005-11-22 00:00:00 +0000
 
     def make_minimal_branch(self, path='.', format=None):
         tree = self.make_branch_and_tree(path, format=format)
@@ -65,254 +63,174 @@
         tree.commit(message='merge')
         return tree
 
-
-class TestLogWithLogCatcher(TestLog):
-
-    def setUp(self):
-        super(TestLogWithLogCatcher, self).setUp()
-        # Capture log formatter creations
-        class MyLogFormatter(test_log.LogCatcher):
-
-            def __new__(klass, *args, **kwargs):
-                self.log_catcher = test_log.LogCatcher(*args, **kwargs)
-                # Always return our own log formatter
-                return self.log_catcher
-
-        def getme(branch):
-                # Always return our own log formatter class hijacking the
-                # default behavior (which requires setting up a config
-                # variable)
-            return MyLogFormatter
-        self.overrideAttr(log.log_formatter_registry, 'get_default', getme)
-
-    def get_captured_revisions(self):
-        return self.log_catcher.revisions
-
-    def assertLogRevnos(self, args, expected_revnos, working_dir='.'):
-        self.run_bzr(['log'] + args, working_dir=working_dir)
-        self.assertEqual(expected_revnos,
-                         [r.revno for r in self.get_captured_revisions()])
-
-    def assertLogRevnosAndDepths(self, args, expected_revnos_and_depths,
-                                working_dir='.'):
-        self.run_bzr(['log'] + args, working_dir=working_dir)
-        self.assertEqual(expected_revnos_and_depths,
-                         [(r.revno, r.merge_depth)
-                           for r in self.get_captured_revisions()])
-
-
-class TestLogRevSpecs(TestLogWithLogCatcher):
-
-    def test_log_no_revspec(self):
-        self.make_linear_branch()
-        self.assertLogRevnos([], ['3', '2', '1'])
+    def assertRevnos(self, log, must_have=(), must_not_have=()):
+        """Check if revnos are in or not in the log output"""
+        for revno in must_have:
+            self.assertTrue(('revno: %s\n' % revno) in log,
+                'Does not contain expected revno %s' % revno)
+        for revno in must_not_have:
+            self.assertFalse(('revno: %s\n' % revno) in log,
+                'Contains unexpected revno %s' % revno)
+
+    def commit_options(self):
+        """Use some mostly fixed values for commits to simplify tests.
+
+        Tests can use this function to get some commit attributes. The time
+        stamp is incremented at each commit.
+        """
+        self.timestamp += 1 # 1 second between each commit
+        return dict(committer='Lorem Ipsum <joe@foo.com>',
+                 timezone=self.timezone,
+                 timestamp=self.timestamp,
+                 )
+
+    def check_log(self, expected, args, working_dir='level0'):
+        out, err = self.run_bzr(['log', '--timezone', 'utc'] + args,
+                                working_dir=working_dir)
+        self.assertEqual('', err)
+        self.assertEqualDiff(expected, test_log.normalize_log(out))
+
+
+class TestLogRevSpecs(TestLog):
 
     def test_log_null_end_revspec(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r1..'], ['3', '2', '1'])
+        log = self.run_bzr(['log'])[0]
+        self.assertTrue('revno: 1\n' in log)
+        self.assertTrue('revno: 2\n' in log)
+        self.assertTrue('revno: 3\n' in log)
+        self.assertTrue('message:\n  message1\n' in log)
+        self.assertTrue('message:\n  message2\n' in log)
+        self.assertTrue('message:\n  message3\n' in log)
+
+        full_log = self.run_bzr(['log'])[0]
+        log = self.run_bzr("log -r 1..")[0]
+        self.assertEqualDiff(log, full_log)
 
     def test_log_null_begin_revspec(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r..3'], ['3', '2', '1'])
+        full_log = self.run_bzr(['log'])[0]
+        log = self.run_bzr("log -r ..3")[0]
+        self.assertEqualDiff(full_log, log)
 
     def test_log_null_both_revspecs(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r..'], ['3', '2', '1'])
+        full_log = self.run_bzr(['log'])[0]
+        log = self.run_bzr("log -r ..")[0]
+        self.assertEqualDiff(full_log, log)
+
+    def test_log_zero_revspec(self):
+        self.make_minimal_branch()
+        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
+                           ['log', '-r0'])
+
+    def test_log_zero_begin_revspec(self):
+        self.make_linear_branch()
+        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
+                           ['log', '-r0..2'])
+
+    def test_log_zero_end_revspec(self):
+        self.make_linear_branch()
+        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
+                           ['log', '-r-2..0'])
 
     def test_log_negative_begin_revspec_full_log(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r-3..'], ['3', '2', '1'])
+        full_log = self.run_bzr(['log'])[0]
+        log = self.run_bzr("log -r -3..")[0]
+        self.assertEqualDiff(full_log, log)
 
     def test_log_negative_both_revspec_full_log(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r-3..-1'], ['3', '2', '1'])
+        full_log = self.run_bzr(['log'])[0]
+        log = self.run_bzr("log -r -3..-1")[0]
+        self.assertEqualDiff(full_log, log)
 
     def test_log_negative_both_revspec_partial(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r-3..-2'], ['2', '1'])
+        log = self.run_bzr("log -r -3..-2")[0]
+        self.assertTrue('revno: 1\n' in log)
+        self.assertTrue('revno: 2\n' in log)
+        self.assertTrue('revno: 3\n' not in log)
 
     def test_log_negative_begin_revspec(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r-2..'], ['3', '2'])
+        log = self.run_bzr("log -r -2..")[0]
+        self.assertTrue('revno: 1\n' not in log)
+        self.assertTrue('revno: 2\n' in log)
+        self.assertTrue('revno: 3\n' in log)
 
     def test_log_positive_revspecs(self):
         self.make_linear_branch()
-        self.assertLogRevnos(['-r1..3'], ['3', '2', '1'])
+        full_log = self.run_bzr(['log'])[0]
+        log = self.run_bzr("log -r 1..3")[0]
+        self.assertEqualDiff(full_log, log)
 
     def test_log_dotted_revspecs(self):
         self.make_merged_branch()
-        self.assertLogRevnos(['-n0', '-r1..1.1.1'], ['1.1.1', '1'])
-
-    def test_log_limit(self):
-        tree = self.make_branch_and_tree('.')
-        # We want more commits than our batch size starts at
-        for pos in range(10):
-            tree.commit("%s" % pos)
-        self.assertLogRevnos(['--limit', '2'], ['10', '9'])
-
-    def test_log_limit_short(self):
-        self.make_linear_branch()
-        self.assertLogRevnos(['-l', '2'], ['3', '2'])
-
-    def test_log_change_revno(self):
-        self.make_linear_branch()
-        self.assertLogRevnos(['-c1'], ['1'])
-
-
-class TestLogMergedLinearAncestry(TestLogWithLogCatcher):
-
-    def setUp(self):
-        super(TestLogMergedLinearAncestry, self).setUp()
-        # FIXME: Using a MemoryTree would be even better here (but until we
-        # stop calling run_bzr, there is no point) --vila 100118.
-        builder = branchbuilder.BranchBuilder(self.get_transport())
-        builder.start_series()
-        # mainline
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'root-id', 'directory', ''))])
-        builder.build_snapshot('2', ['1'], [])
-        # branch
-        builder.build_snapshot('1.1.1', ['1'], [])
-        # merge branch into mainline
-        builder.build_snapshot('3', ['2', '1.1.1'], [])
-        # new commits in branch
-        builder.build_snapshot('1.1.2', ['1.1.1'], [])
-        builder.build_snapshot('1.1.3', ['1.1.2'], [])
-        # merge branch into mainline
-        builder.build_snapshot('4', ['3', '1.1.3'], [])
-        # merge mainline into branch
-        builder.build_snapshot('1.1.4', ['1.1.3', '4'], [])
-        # merge branch into mainline
-        builder.build_snapshot('5', ['4', '1.1.4'], [])
-        builder.finish_series()
-
-    def test_n0(self):
-        self.assertLogRevnos(['-n0', '-r1.1.1..1.1.4'],
-                             ['1.1.4', '4', '1.1.3', '1.1.2', '3', '1.1.1'])
-    def test_n0_forward(self):
-        self.assertLogRevnos(['-n0', '-r1.1.1..1.1.4', '--forward'],
-                             ['3', '1.1.1', '4', '1.1.2', '1.1.3', '1.1.4'])
-
-    def test_n1(self):
-        # starting from 1.1.4 we follow the left-hand ancestry
-        self.assertLogRevnos(['-n1', '-r1.1.1..1.1.4'],
-                             ['1.1.4', '1.1.3', '1.1.2', '1.1.1'])
-
-    def test_n1_forward(self):
-        self.assertLogRevnos(['-n1', '-r1.1.1..1.1.4', '--forward'],
-                             ['1.1.1', '1.1.2', '1.1.3', '1.1.4'])
-
-
-class Test_GenerateAllRevisions(TestLogWithLogCatcher):
-
-    def setUp(self):
-        super(Test_GenerateAllRevisions, self).setUp()
-        builder = self.make_branch_with_many_merges()
-        b = builder.get_branch()
-        b.lock_read()
-        self.addCleanup(b.unlock)
-        self.branch = b
-
-    def make_branch_with_many_merges(self, path='.', format=None):
-        builder = branchbuilder.BranchBuilder(self.get_transport())
-        builder.start_series()
-        # The graph below may look a bit complicated (and it may be but I've
-        # banged my head enough on it) but the bug requires at least dotted
-        # revnos *and* merged revisions below that.
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'root-id', 'directory', ''))])
-        builder.build_snapshot('2', ['1'], [])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2.1.1', ['2'], [])
-        builder.build_snapshot('3', ['2', '1.1.1'], [])
-        builder.build_snapshot('2.1.2', ['2.1.1'], [])
-        builder.build_snapshot('2.2.1', ['2.1.1'], [])
-        builder.build_snapshot('2.1.3', ['2.1.2', '2.2.1'], [])
-        builder.build_snapshot('4', ['3', '2.1.3'], [])
-        builder.build_snapshot('5', ['4', '2.1.2'], [])
-        builder.finish_series()
-        return builder
-
-    def test_not_an_ancestor(self):
-        self.assertRaises(errors.BzrCommandError,
-                          log._generate_all_revisions,
-                          self.branch, '1.1.1', '2.1.3', 'reverse',
-                          delayed_graph_generation=True)
-
-    def test_wrong_order(self):
-        self.assertRaises(errors.BzrCommandError,
-                          log._generate_all_revisions,
-                          self.branch, '5', '2.1.3', 'reverse',
-                          delayed_graph_generation=True)
-
-    def test_no_start_rev_id_with_end_rev_id_being_a_merge(self):
-        revs = log._generate_all_revisions(
-            self.branch, None, '2.1.3',
-            'reverse', delayed_graph_generation=True)
-
-
-class TestLogRevSpecsWithPaths(TestLogWithLogCatcher):
-
-    def test_log_revno_n_path_wrong_namespace(self):
+        log = self.run_bzr("log -n0 -r 1..1.1.1")[0]
+        self.assertRevnos(log, (1, '1.1.1'), (2, 3, '1.1.2', 4))
+
+    def test_log_reversed_revspecs(self):
+        self.make_linear_branch()
+        self.run_bzr_error(('bzr: ERROR: Start revision must be older than '
+                            'the end revision.\n',),
+                           ['log', '-r3..1'])
+
+    def test_log_reversed_dotted_revspecs(self):
+        self.make_merged_branch()
+        self.run_bzr_error(('bzr: ERROR: Start revision not found in '
+                            'left-hand history of end revision.\n',),
+                           "log -r 1.1.1..1")
+
+    def test_log_revno_n_path(self):
         self.make_linear_branch('branch1')
         self.make_linear_branch('branch2')
-        # There is no guarantee that a path exist between two arbitrary
-        # revisions.
-        self.run_bzr("log -r revno:2:branch1..revno:3:branch2", retcode=3)
-
-    def test_log_revno_n_path_correct_order(self):
-        self.make_linear_branch('branch2')
-        self.assertLogRevnos(['-rrevno:1:branch2..revno:3:branch2'],
-                             ['3', '2','1'])
-
-    def test_log_revno_n_path(self):
-        self.make_linear_branch('branch2')
-        self.assertLogRevnos(['-rrevno:1:branch2'],
-                             ['1'])
-        rev_props = self.log_catcher.revisions[0].rev.properties
-        self.assertEqual('branch2', rev_props['branch-nick'])
-
-
-class TestLogErrors(TestLog):
-
-    def test_log_zero_revspec(self):
-        self.make_minimal_branch()
-        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
-                           ['log', '-r0'])
-
-    def test_log_zero_begin_revspec(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
-                           ['log', '-r0..2'])
-
-    def test_log_zero_end_revspec(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
-                           ['log', '-r-2..0'])
+        # Swapped revisions
+        self.run_bzr("log -r revno:2:branch1..revno:3:branch2", retcode=3)[0]
+        # Correct order
+        log = self.run_bzr("log -r revno:1:branch2..revno:3:branch2")[0]
+        full_log = self.run_bzr(['log'], working_dir='branch2')[0]
+        self.assertEqualDiff(full_log, log)
+        log = self.run_bzr("log -r revno:1:branch2")[0]
+        self.assertTrue('revno: 1\n' in log)
+        self.assertTrue('revno: 2\n' not in log)
+        self.assertTrue('branch nick: branch2\n' in log)
+        self.assertTrue('branch nick: branch1\n' not in log)
 
     def test_log_nonexistent_revno(self):
         self.make_minimal_branch()
-        self.run_bzr_error(["bzr: ERROR: Requested revision: '1234' "
-                            "does not exist in branch:"],
-                           ['log', '-r1234'])
+        (out, err) = self.run_bzr_error(
+            ["bzr: ERROR: Requested revision: '1234' "
+             "does not exist in branch:"],
+            ['log', '-r1234'])
 
     def test_log_nonexistent_dotted_revno(self):
         self.make_minimal_branch()
-        self.run_bzr_error(["bzr: ERROR: Requested revision: '123.123' "
-                            "does not exist in branch:"],
-                           ['log',  '-r123.123'])
+        (out, err) = self.run_bzr_error(
+            ["bzr: ERROR: Requested revision: '123.123' "
+             "does not exist in branch:"],
+            ['log',  '-r123.123'])
+
+    def test_log_change_revno(self):
+        self.make_linear_branch()
+        expected_log = self.run_bzr("log -r 1")[0]
+        log = self.run_bzr("log -c 1")[0]
+        self.assertEqualDiff(expected_log, log)
 
     def test_log_change_nonexistent_revno(self):
         self.make_minimal_branch()
-        self.run_bzr_error(["bzr: ERROR: Requested revision: '1234' "
-                            "does not exist in branch:"],
-                           ['log',  '-c1234'])
+        (out, err) = self.run_bzr_error(
+            ["bzr: ERROR: Requested revision: '1234' "
+             "does not exist in branch:"],
+            ['log',  '-c1234'])
 
     def test_log_change_nonexistent_dotted_revno(self):
         self.make_minimal_branch()
-        self.run_bzr_error(["bzr: ERROR: Requested revision: '123.123' "
-                            "does not exist in branch:"],
-                           ['log', '-c123.123'])
+        (out, err) = self.run_bzr_error(
+            ["bzr: ERROR: Requested revision: '123.123' "
+             "does not exist in branch:"],
+            ['log', '-c123.123'])
 
     def test_log_change_single_revno_only(self):
         self.make_minimal_branch()
@@ -334,52 +252,6 @@
                               'Path unknown at end or start of revision range: '
                               'does-not-exist')
 
-    def test_log_reversed_revspecs(self):
-        self.make_linear_branch()
-        self.run_bzr_error(('bzr: ERROR: Start revision must be older than '
-                            'the end revision.\n',),
-                           ['log', '-r3..1'])
-
-    def test_log_reversed_dotted_revspecs(self):
-        self.make_merged_branch()
-        self.run_bzr_error(('bzr: ERROR: Start revision not found in '
-                            'left-hand history of end revision.\n',),
-                           "log -r 1.1.1..1")
-
-    def test_log_bad_message_re(self):
-        """Bad --message argument gives a sensible message
-        
-        See https://bugs.launchpad.net/bzr/+bug/251352
-        """
-        self.make_minimal_branch()
-        out, err = self.run_bzr(['log', '-m', '*'], retcode=3)
-        self.assertEqual("bzr: ERROR: Invalid regular expression"
-            " in log message filter"
-            ": '*'"
-            ": nothing to repeat\n", err)
-        self.assertEqual('', out)
-
-    def test_log_unsupported_timezone(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: Unsupported timezone format "foo", '
-                            'options are "utc", "original", "local".'],
-                           ['log', '--timezone', 'foo'])
-
-    def test_log_exclude_ancestry_no_range(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: --exclude-common-ancestry'
-                            ' requires -r with two revisions'],
-                           ['log', '--exclude-common-ancestry'])
-
-    def test_log_exclude_ancestry_single_revision(self):
-        self.make_merged_branch()
-        self.run_bzr_error(['bzr: ERROR: --exclude-common-ancestry'
-                            ' requires two different revisions'],
-                           ['log', '--exclude-common-ancestry',
-                            '-r1.1.1..1.1.1'])
-
-class TestLogTags(TestLog):
-
     def test_log_with_tags(self):
         tree = self.make_linear_branch(format='dirstate-tags')
         branch = tree.branch
@@ -410,6 +282,52 @@
         log = self.run_bzr("log -n0 -r3.1.1", working_dir='branch2')[0]
         self.assertContainsRe(log, r'tags: tag1')
 
+    def test_log_limit(self):
+        tree = self.make_branch_and_tree('.')
+        # We want more commits than our batch size starts at
+        for pos in range(10):
+            tree.commit("%s" % pos)
+        log = self.run_bzr("log --limit 2")[0]
+        self.assertNotContainsRe(log, r'revno: 1\n')
+        self.assertNotContainsRe(log, r'revno: 2\n')
+        self.assertNotContainsRe(log, r'revno: 3\n')
+        self.assertNotContainsRe(log, r'revno: 4\n')
+        self.assertNotContainsRe(log, r'revno: 5\n')
+        self.assertNotContainsRe(log, r'revno: 6\n')
+        self.assertNotContainsRe(log, r'revno: 7\n')
+        self.assertNotContainsRe(log, r'revno: 8\n')
+        self.assertContainsRe(log, r'revno: 9\n')
+        self.assertContainsRe(log, r'revno: 10\n')
+
+    def test_log_limit_short(self):
+        self.make_linear_branch()
+        log = self.run_bzr("log -l 2")[0]
+        self.assertNotContainsRe(log, r'revno: 1\n')
+        self.assertContainsRe(log, r'revno: 2\n')
+        self.assertContainsRe(log, r'revno: 3\n')
+
+    def test_log_bad_message_re(self):
+        """Bad --message argument gives a sensible message
+        
+        See https://bugs.launchpad.net/bzr/+bug/251352
+        """
+        self.make_minimal_branch()
+        out, err = self.run_bzr(['log', '-m', '*'], retcode=3)
+        self.assertEqual("bzr: ERROR: Invalid regular expression"
+            " in log message filter"
+            ": '*'"
+            ": nothing to repeat\n", err)
+        self.assertEqual('', out)
+
+
+class TestLogTimeZone(TestLog):
+
+    def test_log_unsupported_timezone(self):
+        self.make_linear_branch()
+        self.run_bzr_error(['bzr: ERROR: Unsupported timezone format "foo", '
+                            'options are "utc", "original", "local".'],
+                           ['log', '--timezone', 'foo'])
+
 
 class TestLogVerbose(TestLog):
 
@@ -446,7 +364,7 @@
         self.assertUseLongDeltaFormat(['log', '--long', '-vv'])
 
 
-class TestLogMerges(TestLogWithLogCatcher):
+class TestLogMerges(TestLog):
 
     def setUp(self):
         super(TestLogMerges, self).setUp()
@@ -454,40 +372,101 @@
 
     def make_branches_with_merges(self):
         level0 = self.make_branch_and_tree('level0')
-        self.wt_commit(level0, 'in branch level0')
+        level0.commit(message='in branch level0', **self.commit_options())
+
         level1 = level0.bzrdir.sprout('level1').open_workingtree()
-        self.wt_commit(level1, 'in branch level1')
+        level1.commit(message='in branch level1', **self.commit_options())
+
         level2 = level1.bzrdir.sprout('level2').open_workingtree()
-        self.wt_commit(level2, 'in branch level2')
+        level2.commit(message='in branch level2', **self.commit_options())
+
         level1.merge_from_branch(level2.branch)
-        self.wt_commit(level1, 'merge branch level2')
+        level1.commit(message='merge branch level2', **self.commit_options())
+
         level0.merge_from_branch(level1.branch)
-        self.wt_commit(level0, 'merge branch level1')
+        level0.commit(message='merge branch level1', **self.commit_options())
 
     def test_merges_are_indented_by_level(self):
-        self.run_bzr(['log', '-n0'], working_dir='level0')
-        revnos_and_depth = [(r.revno, r.merge_depth)
-                            for r in self.get_captured_revisions()]
-        self.assertEqual([('2', 0), ('1.1.2', 1), ('1.2.1', 2), ('1.1.1', 1),
-                          ('1', 0)],
-                         [(r.revno, r.merge_depth)
-                            for r in self.get_captured_revisions()])
+        expected = """\
+------------------------------------------------------------
+revno: 2 [merge]
+committer: Lorem Ipsum <test@example.com>
+branch nick: level0
+timestamp: Just now
+message:
+  merge branch level1
+    ------------------------------------------------------------
+    revno: 1.1.2 [merge]
+    committer: Lorem Ipsum <test@example.com>
+    branch nick: level1
+    timestamp: Just now
+    message:
+      merge branch level2
+        ------------------------------------------------------------
+        revno: 1.2.1
+        committer: Lorem Ipsum <test@example.com>
+        branch nick: level2
+        timestamp: Just now
+        message:
+          in branch level2
+    ------------------------------------------------------------
+    revno: 1.1.1
+    committer: Lorem Ipsum <test@example.com>
+    branch nick: level1
+    timestamp: Just now
+    message:
+      in branch level1
+------------------------------------------------------------
+revno: 1
+committer: Lorem Ipsum <test@example.com>
+branch nick: level0
+timestamp: Just now
+message:
+  in branch level0
+"""
+        self.check_log(expected, ['-n0'])
 
     def test_force_merge_revisions_off(self):
-        self.assertLogRevnos(['-n1'], ['2', '1'], working_dir='level0')
+        expected = """\
+------------------------------------------------------------
+revno: 2 [merge]
+committer: Lorem Ipsum <test@example.com>
+branch nick: level0
+timestamp: Just now
+message:
+  merge branch level1
+------------------------------------------------------------
+revno: 1
+committer: Lorem Ipsum <test@example.com>
+branch nick: level0
+timestamp: Just now
+message:
+  in branch level0
+"""
+        self.check_log(expected, ['--long', '-n1'])
 
     def test_force_merge_revisions_on(self):
-        self.assertLogRevnos(['-n0'], ['2', '1.1.2', '1.2.1', '1.1.1', '1'],
-                             working_dir='level0')
+        expected = """\
+    2 Lorem Ipsum\t2005-11-22 [merge]
+      merge branch level1
+
+          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
+                merge branch level2
+
+              1.2.1 Lorem Ipsum\t2005-11-22
+                    in branch level2
+
+          1.1.1 Lorem Ipsum\t2005-11-22
+                in branch level1
+
+    1 Lorem Ipsum\t2005-11-22
+      in branch level0
+
+"""
+        self.check_log(expected, ['--short', '-n0'])
 
     def test_include_merges(self):
         # Confirm --include-merges gives the same output as -n0
-        self.assertLogRevnos(['--include-merges'],
-                             ['2', '1.1.2', '1.2.1', '1.1.1', '1'],
-                             working_dir='level0')
-        self.assertLogRevnos(['--include-merges'],
-                             ['2', '1.1.2', '1.2.1', '1.1.1', '1'],
-                             working_dir='level0')
         out_im, err_im = self.run_bzr('log --include-merges',
                                       working_dir='level0')
         out_n0, err_n0 = self.run_bzr('log -n0', working_dir='level0')
@@ -496,34 +475,84 @@
         self.assertEqual(out_im, out_n0)
 
     def test_force_merge_revisions_N(self):
-        self.assertLogRevnos(['-n2'],
-                             ['2', '1.1.2', '1.1.1', '1'],
-                             working_dir='level0')
+        expected = """\
+    2 Lorem Ipsum\t2005-11-22 [merge]
+      merge branch level1
+
+          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
+                merge branch level2
+
+          1.1.1 Lorem Ipsum\t2005-11-22
+                in branch level1
+
+    1 Lorem Ipsum\t2005-11-22
+      in branch level0
+
+"""
+        self.check_log(expected, ['--short', '-n2'])
 
     def test_merges_single_merge_rev(self):
-        self.assertLogRevnosAndDepths(['-n0', '-r1.1.2'],
-                                      [('1.1.2', 0), ('1.2.1', 1)],
-                                      working_dir='level0')
+        expected = """\
+------------------------------------------------------------
+revno: 1.1.2 [merge]
+committer: Lorem Ipsum <test@example.com>
+branch nick: level1
+timestamp: Just now
+message:
+  merge branch level2
+    ------------------------------------------------------------
+    revno: 1.2.1
+    committer: Lorem Ipsum <test@example.com>
+    branch nick: level2
+    timestamp: Just now
+    message:
+      in branch level2
+"""
+        self.check_log(expected, ['-n0', '-r1.1.2'])
 
     def test_merges_partial_range(self):
-        self.assertLogRevnosAndDepths(
-                ['-n0', '-r1.1.1..1.1.2'],
-                [('1.1.2', 0), ('1.2.1', 1), ('1.1.1', 0)],
-                working_dir='level0')
+        expected = """\
+------------------------------------------------------------
+revno: 1.1.2 [merge]
+committer: Lorem Ipsum <test@example.com>
+branch nick: level1
+timestamp: Just now
+message:
+  merge branch level2
+    ------------------------------------------------------------
+    revno: 1.2.1
+    committer: Lorem Ipsum <test@example.com>
+    branch nick: level2
+    timestamp: Just now
+    message:
+      in branch level2
+------------------------------------------------------------
+revno: 1.1.1
+committer: Lorem Ipsum <test@example.com>
+branch nick: level1
+timestamp: Just now
+message:
+  in branch level1
+"""
+        self.check_log(expected, ['-n0', '-r1.1.1..1.1.2'])
 
     def test_merges_partial_range_ignore_before_lower_bound(self):
         """Dont show revisions before the lower bound's merged revs"""
-        self.assertLogRevnosAndDepths(
-                ['-n0', '-r1.1.2..2'],
-                [('2', 0), ('1.1.2', 1), ('1.2.1', 2)],
-                working_dir='level0')
-
-
-class TestLogDiff(TestLogWithLogCatcher):
-
-    # FIXME: We need specific tests for each LogFormatter about how the diffs
-    # are displayed: --long indent them by depth, --short use a fixed
-    # indent and --line does't display them. -- vila 10019
+        expected = """\
+    2 Lorem Ipsum\t2005-11-22 [merge]
+      merge branch level1
+
+          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
+                merge branch level2
+
+              1.2.1 Lorem Ipsum\t2005-11-22
+                    in branch level2
+
+"""
+        self.check_log(expected, ['--short', '-n0', '-r1.1.2..2'])
+
+
+class TestLogDiff(TestLog):
 
     def setUp(self):
         super(TestLogDiff, self).setUp()
@@ -534,90 +563,143 @@
         self.build_tree(['level0/file1', 'level0/file2'])
         level0.add('file1')
         level0.add('file2')
-        self.wt_commit(level0, 'in branch level0')
+        level0.commit(message='in branch level0', **self.commit_options())
 
         level1 = level0.bzrdir.sprout('level1').open_workingtree()
         self.build_tree_contents([('level1/file2', 'hello\n')])
-        self.wt_commit(level1, 'in branch level1')
+        level1.commit(message='in branch level1', **self.commit_options())
         level0.merge_from_branch(level1.branch)
-        self.wt_commit(level0, 'merge branch level1')
+        level0.commit(message='merge branch level1', **self.commit_options())
 
-    def _diff_file1_revno1(self):
-        return """=== added file 'file1'
+    def test_log_show_diff_long_with_merges(self):
+        out,err = self.run_bzr('log -p -n0')
+        self.assertEqual('', err)
+        log = test_log.normalize_log(out)
+        expected = """\
+------------------------------------------------------------
+revno: 2 [merge]
+committer: Lorem Ipsum <test@example.com>
+branch nick: level0
+timestamp: Just now
+message:
+  merge branch level1
+diff:
+=== modified file 'file2'
+--- file2\t2005-11-22 00:00:01 +0000
++++ file2\t2005-11-22 00:00:02 +0000
+@@ -1,1 +1,1 @@
+-contents of level0/file2
++hello
+    ------------------------------------------------------------
+    revno: 1.1.1
+    committer: Lorem Ipsum <test@example.com>
+    branch nick: level1
+    timestamp: Just now
+    message:
+      in branch level1
+    diff:
+    === modified file 'file2'
+    --- file2\t2005-11-22 00:00:01 +0000
+    +++ file2\t2005-11-22 00:00:02 +0000
+    @@ -1,1 +1,1 @@
+    -contents of level0/file2
+    +hello
+------------------------------------------------------------
+revno: 1
+committer: Lorem Ipsum <test@example.com>
+branch nick: level0
+timestamp: Just now
+message:
+  in branch level0
+diff:
+=== added file 'file1'
 --- file1\t1970-01-01 00:00:00 +0000
-+++ file1\t2005-11-22 00:00:00 +0000
++++ file1\t2005-11-22 00:00:01 +0000
 @@ -0,0 +1,1 @@
 +contents of level0/file1
 
-"""
-
-    def _diff_file2_revno2(self):
-        return """=== modified file 'file2'
---- file2\t2005-11-22 00:00:00 +0000
-+++ file2\t2005-11-22 00:00:01 +0000
-@@ -1,1 +1,1 @@
--contents of level0/file2
-+hello
-
-"""
-
-    def _diff_file2_revno1_1_1(self):
-        return """=== modified file 'file2'
---- file2\t2005-11-22 00:00:00 +0000
-+++ file2\t2005-11-22 00:00:01 +0000
-@@ -1,1 +1,1 @@
--contents of level0/file2
-+hello
-
-"""
-
-    def _diff_file2_revno1(self):
-        return """=== added file 'file2'
+=== added file 'file2'
 --- file2\t1970-01-01 00:00:00 +0000
-+++ file2\t2005-11-22 00:00:00 +0000
++++ file2\t2005-11-22 00:00:01 +0000
 @@ -0,0 +1,1 @@
 +contents of level0/file2
-
-"""
-
-    def assertLogRevnosAndDiff(self, args, expected,
-                            working_dir='.'):
-        self.run_bzr(['log', '-p'] + args, working_dir=working_dir)
-        expected_revnos_and_depths = [
-            (revno, depth) for revno, depth, diff in expected]
-        # Check the revnos and depths first to make debugging easier
-        self.assertEqual(expected_revnos_and_depths,
-                         [(r.revno, r.merge_depth)
-                           for r in self.get_captured_revisions()])
-        # Now check the diffs, adding the revno  in case of failure
-        fmt = 'In revno %s\n%s'
-        for expected_rev, actual_rev in izip(expected,
-                                             self.get_captured_revisions()):
-            revno, depth, expected_diff = expected_rev
-            actual_diff = actual_rev.diff
-            self.assertEqualDiff(fmt % (revno, expected_diff),
-                                 fmt % (revno, actual_diff))
-
-    def test_log_diff_with_merges(self):
-        self.assertLogRevnosAndDiff(
-            ['-n0'],
-            [('2', 0, self._diff_file2_revno2()),
-             ('1.1.1', 1, self._diff_file2_revno1_1_1()),
-             ('1', 0, self._diff_file1_revno1()
-              + self._diff_file2_revno1())],
-            working_dir='level0')
-
-
-    def test_log_diff_file1(self):
-        self.assertLogRevnosAndDiff(['-n0', 'file1'],
-                                    [('1', 0, self._diff_file1_revno1())],
-                                    working_dir='level0')
-
-    def test_log_diff_file2(self):
-        self.assertLogRevnosAndDiff(['-n1', 'file2'],
-                                    [('2', 0, self._diff_file2_revno2()),
-                                     ('1', 0, self._diff_file2_revno1())],
-                                    working_dir='level0')
+"""
+        self.check_log(expected, ['-p', '-n0'])
+
+    def test_log_show_diff_short(self):
+        expected = """\
+    2 Lorem Ipsum\t2005-11-22 [merge]
+      merge branch level1
+      === modified file 'file2'
+      --- file2\t2005-11-22 00:00:01 +0000
+      +++ file2\t2005-11-22 00:00:02 +0000
+      @@ -1,1 +1,1 @@
+      -contents of level0/file2
+      +hello
+
+    1 Lorem Ipsum\t2005-11-22
+      in branch level0
+      === added file 'file1'
+      --- file1\t1970-01-01 00:00:00 +0000
+      +++ file1\t2005-11-22 00:00:01 +0000
+      @@ -0,0 +1,1 @@
+      +contents of level0/file1
+\x20\x20\x20\x20\x20\x20
+      === added file 'file2'
+      --- file2\t1970-01-01 00:00:00 +0000
+      +++ file2\t2005-11-22 00:00:01 +0000
+      @@ -0,0 +1,1 @@
+      +contents of level0/file2
+
+Use --include-merges or -n0 to see merged revisions.
+"""
+        self.check_log(expected, ['-p', '--short'])
+
+    def test_log_show_diff_line(self):
+        # Not supported by this formatter so expect plain output
+        expected = """\
+2: Lorem Ipsum 2005-11-22 [merge] merge branch level1
+1: Lorem Ipsum 2005-11-22 in branch level0
+"""
+        self.check_log(expected, ['-p', '--line'])
+
+    def test_log_show_diff_file1(self):
+        """Only the diffs for the given file are to be shown"""
+        expected = """\
+    1 Lorem Ipsum\t2005-11-22
+      in branch level0
+      === added file 'file1'
+      --- file1\t1970-01-01 00:00:00 +0000
+      +++ file1\t2005-11-22 00:00:01 +0000
+      @@ -0,0 +1,1 @@
+      +contents of level0/file1
+
+"""
+        self.check_log(expected, ['-p', '--short', 'file1'])
+
+    def test_log_show_diff_file2(self):
+        """Only the diffs for the given file are to be shown"""
+        expected = """\
+    2 Lorem Ipsum\t2005-11-22 [merge]
+      merge branch level1
+      === modified file 'file2'
+      --- file2\t2005-11-22 00:00:01 +0000
+      +++ file2\t2005-11-22 00:00:02 +0000
+      @@ -1,1 +1,1 @@
+      -contents of level0/file2
+      +hello
+
+    1 Lorem Ipsum\t2005-11-22
+      in branch level0
+      === added file 'file2'
+      --- file2\t1970-01-01 00:00:00 +0000
+      +++ file2\t2005-11-22 00:00:01 +0000
+      @@ -0,0 +1,1 @@
+      +contents of level0/file2
+
+Use --include-merges or -n0 to see merged revisions.
+"""
+        self.check_log(expected, ['-p', '--short', 'file2'])
 
 
 class TestLogUnicodeDiff(TestLog):
@@ -666,12 +748,15 @@
 
     def setUp(self):
         super(TestLogEncodings, self).setUp()
-        self.overrideAttr(osutils, '_cached_user_encoding')
+        self.user_encoding = osutils._cached_user_encoding
+        def restore():
+            osutils._cached_user_encoding = self.user_encoding
+        self.addCleanup(restore)
 
     def create_branch(self):
         bzr = self.run_bzr
         bzr('init')
-        self.build_tree_contents([('a', 'some stuff\n')])
+        open('a', 'wb').write('some stuff\n')
         bzr('add a')
         bzr(['commit', '-m', self._message])
 
@@ -740,7 +825,7 @@
         self.assertEquals(-1, stdout.find(test_in_cp1251))
 
 
-class TestLogFile(TestLogWithLogCatcher):
+class TestLogFile(tests.TestCaseWithTransport):
 
     def test_log_local_branch_file(self):
         """We should be able to log files in local treeless branches"""
@@ -775,29 +860,51 @@
             tree.commit('remove file1')
         os.chdir('parent')
 
-    # FIXME: It would be good to parametrize the following tests against all
-    # formatters. But the revisions selection is not *currently* part of the
-    # LogFormatter contract, so using LogCatcher is sufficient -- vila 100118
-    def test_log_file1(self):
-        self.prepare_tree()
-        self.assertLogRevnos(['-n0', 'file1'], ['1'])
-
-    def test_log_file2(self):
-        self.prepare_tree()
-        # file2 full history
-        self.assertLogRevnos(['-n0', 'file2'], ['4', '3.1.1', '2'])
-        # file2 in a merge revision
-        self.assertLogRevnos(['-n0', '-r3.1.1', 'file2'], ['3.1.1'])
-        # file2 in a mainline revision
-        self.assertLogRevnos(['-n0', '-r4', 'file2'], ['4', '3.1.1'])
-        # file2 since a revision
-        self.assertLogRevnos(['-n0', '-r3..', 'file2'], ['4', '3.1.1'])
-        # file2 up to a revision
-        self.assertLogRevnos(['-n0', '-r..3', 'file2'], ['2'])
-
-    def test_log_file3(self):
-        self.prepare_tree()
-        self.assertLogRevnos(['-n0', 'file3'], ['3'])
+    def test_log_file(self):
+        """The log for a particular file should only list revs for that file"""
+        self.prepare_tree()
+        log = self.run_bzr('log -n0 file1')[0]
+        self.assertContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
+        self.assertNotContainsRe(log, 'revno: 4 ')
+        log = self.run_bzr('log -n0 file2')[0]
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertContainsRe(log, 'revno: 3.1.1\n')
+        self.assertContainsRe(log, 'revno: 4 ')
+        log = self.run_bzr('log -n0 file3')[0]
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertContainsRe(log, 'revno: 3\n')
+        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
+        self.assertNotContainsRe(log, 'revno: 4 ')
+        log = self.run_bzr('log -n0 -r3.1.1 file2')[0]
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertContainsRe(log, 'revno: 3.1.1\n')
+        self.assertNotContainsRe(log, 'revno: 4 ')
+        log = self.run_bzr('log -n0 -r4 file2')[0]
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertContainsRe(log, 'revno: 3.1.1\n')
+        self.assertContainsRe(log, 'revno: 4 ')
+        log = self.run_bzr('log -n0 -r3.. file2')[0]
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertContainsRe(log, 'revno: 3.1.1\n')
+        self.assertContainsRe(log, 'revno: 4 ')
+        log = self.run_bzr('log -n0 -r..3 file2')[0]
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
+        self.assertNotContainsRe(log, 'revno: 4 ')
 
     def test_log_file_historical_missing(self):
         # Check logging a deleted file gives an error if the
@@ -811,13 +918,25 @@
         # Check logging a deleted file is ok if the file existed
         # at the end the revision range
         self.prepare_tree(complex=True)
-        self.assertLogRevnos(['-n0', '-r..4', 'file2'], ['4', '3.1.1', '2'])
+        log, err = self.run_bzr('log -n0 -r..4 file2')
+        self.assertEquals('', err)
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertContainsRe(log, 'revno: 3.1.1\n')
+        self.assertContainsRe(log, 'revno: 4 ')
 
     def test_log_file_historical_start(self):
         # Check logging a deleted file is ok if the file existed
         # at the start of the revision range
         self.prepare_tree(complex=True)
-        self.assertLogRevnos(['file1'], ['1'])
+        log, err = self.run_bzr('log file1')
+        self.assertEquals('', err)
+        self.assertContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertNotContainsRe(log, 'revno: 3\n')
+        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
+        self.assertNotContainsRe(log, 'revno: 4 ')
 
     def test_log_file_renamed(self):
         """File matched against revision range, not current tree."""
@@ -829,10 +948,79 @@
         self.assertContainsRe(err, err_msg)
 
         # Check we can see a renamed file if we give the right end revision
-        self.assertLogRevnos(['-r..4', 'file3'], ['3'])
-
-
-class TestLogMultiple(TestLogWithLogCatcher):
+        log, err = self.run_bzr('log -r..4 file3')
+        self.assertEquals('', err)
+        self.assertNotContainsRe(log, 'revno: 1\n')
+        self.assertNotContainsRe(log, 'revno: 2\n')
+        self.assertContainsRe(log, 'revno: 3\n')
+        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
+        self.assertNotContainsRe(log, 'revno: 4 ')
+
+    def test_line_log_file(self):
+        """The line log for a file should only list relevant mainline revs"""
+        # Note: this also implicitly  covers the short logging case.
+        # We test using --line in preference to --short because matching
+        # revnos in the output of --line is more reliable.
+        self.prepare_tree()
+
+        # full history of file1
+        log = self.run_bzr('log --line file1')[0]
+        self.assertContainsRe(log, '^1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
+
+        # full history of file2
+        log = self.run_bzr('log --line file2')[0]
+        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
+        self.assertContainsRe(log, '^2:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertContainsRe(log, '^4:', re.MULTILINE)
+
+        # full history of file3
+        log = self.run_bzr('log --line file3')[0]
+        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
+        self.assertContainsRe(log, '^3:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
+
+        # file in a merge revision
+        log = self.run_bzr('log --line -r3.1.1 file2')[0]
+        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
+        self.assertContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
+
+        # file in a mainline revision
+        log = self.run_bzr('log --line -r4 file2')[0]
+        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertContainsRe(log, '^4:', re.MULTILINE)
+
+        # file since a revision
+        log = self.run_bzr('log --line -r3.. file2')[0]
+        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertContainsRe(log, '^4:', re.MULTILINE)
+
+        # file up to a revision
+        log = self.run_bzr('log --line -r..3 file2')[0]
+        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
+        self.assertContainsRe(log, '^2:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
+        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
+
+
+class TestLogMultiple(tests.TestCaseWithTransport):
 
     def prepare_tree(self):
         tree = self.make_branch_and_tree('parent')
@@ -861,35 +1049,42 @@
         tree.commit(message='merge child branch')
         os.chdir('parent')
 
+    def assertRevnos(self, paths_str, expected_revnos):
+        # confirm the revision numbers in log --line output are those expected
+        out, err = self.run_bzr('log --line -n0 %s' % (paths_str,))
+        self.assertEqual('', err)
+        revnos = [s.split(':', 1)[0].lstrip() for s in out.splitlines()]
+        self.assertEqual(expected_revnos, revnos)
+
     def test_log_files(self):
         """The log for multiple file should only list revs for those files"""
         self.prepare_tree()
-        self.assertLogRevnos(['file1', 'file2', 'dir1/dir2/file3'],
-                             ['6', '5.1.1', '3', '2', '1'])
+        self.assertRevnos('file1 file2 dir1/dir2/file3',
+            ['6', '5.1.1', '3', '2', '1'])
 
     def test_log_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
-        self.assertLogRevnos(['dir1'], ['5', '3'])
+        self.assertRevnos('dir1', ['5', '3'])
 
     def test_log_nested_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
-        self.assertLogRevnos(['dir1/dir2'], ['3'])
+        self.assertRevnos('dir1/dir2', ['3'])
 
     def test_log_in_nested_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
         os.chdir("dir1")
-        self.assertLogRevnos(['.'], ['5', '3'])
+        self.assertRevnos('.', ['5', '3'])
 
     def test_log_files_and_directories(self):
         """Logging files and directories together should be fine."""
         self.prepare_tree()
-        self.assertLogRevnos(['file4', 'dir1/dir2'], ['4', '3'])
+        self.assertRevnos('file4 dir1/dir2', ['4', '3'])
 
     def test_log_files_and_dirs_in_nested_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
         os.chdir("dir1")
-        self.assertLogRevnos(['dir2', 'file5'], ['5', '3'])
+        self.assertRevnos('dir2 file5', ['5', '3'])

=== modified file 'bzrlib/tests/blackbox/test_ls.py'
--- bzrlib/tests/blackbox/test_ls.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_ls.py	2009-11-30 00:33:52 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_merge.py'
--- bzrlib/tests/blackbox/test_merge.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_merge.py	2009-12-10 17:16:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_mv.py'
--- bzrlib/tests/blackbox/test_mv.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_mv.py	2009-11-17 01:08:08 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_nick.py'
--- bzrlib/tests/blackbox/test_nick.py	2010-03-01 16:17:57 +0000
+++ bzrlib/tests/blackbox/test_nick.py	2009-03-23 14:59:43 +0000
@@ -30,11 +30,11 @@
         self.make_branch_and_tree('me.dev')
         os.chdir('me.dev')
         nick = self.run_bzr('nick')[0]
-        self.assertEqual('me.dev\n', nick)
+        self.assertEqual(nick, 'me.dev\n')
         # set the nickname
         self.run_bzr("nick moo")
         nick = self.run_bzr('nick')[0]
-        self.assertEqual('moo\n', nick)
+        self.assertEqual(nick, 'moo\n')
 
     def test_autonick_urlencoded(self):
         # https://bugs.launchpad.net/bzr/+bug/66857 -- nick was printed
@@ -42,30 +42,30 @@
         self.make_branch_and_tree('!repo')
         os.chdir('!repo')
         nick = self.run_bzr('nick')[0]
-        self.assertEqual('!repo\n', nick)
+        self.assertEqual(nick, '!repo\n')
 
     def test_bound_nick(self):
         """Check that nick works well for checkouts."""
         base = self.make_branch_and_tree('base')
         child = self.make_branch_and_tree('child')
         os.chdir('child')
-        self.assertEqual('child', self.run_bzr('nick')[0][:-1])
-        self.assertEqual(False,
-                         child.branch.get_config().has_explicit_nickname())
+        self.assertEqual(self.run_bzr('nick')[0][:-1], 'child')
+        self.assertEqual(child.branch.get_config().has_explicit_nickname(),
+            False)
         self.run_bzr('bind ../base')
-        self.assertEqual(base.branch.nick, self.run_bzr('nick')[0][:-1])
-        self.assertEqual(False,
-                         child.branch.get_config().has_explicit_nickname())
+        self.assertEqual(self.run_bzr('nick')[0][:-1], base.branch.nick)
+        self.assertEqual(child.branch.get_config().has_explicit_nickname(),
+            False)
 
         self.run_bzr('unbind')
         self.run_bzr("nick explicit_nick")
-        self.assertEqual("explicit_nick", self.run_bzr('nick')[0][:-1])
-        self.assertEqual("explicit_nick",
-                         child.branch.get_config()._get_explicit_nickname())
+        self.assertEqual(self.run_bzr('nick')[0][:-1], "explicit_nick")
+        self.assertEqual(child.branch.get_config()._get_explicit_nickname(),
+            "explicit_nick")
         self.run_bzr('bind ../base')
-        self.assertEqual(base.branch.nick, self.run_bzr('nick')[0][:-1])
-        self.assertEqual(base.branch.nick,
-                         child.branch.get_config()._get_explicit_nickname())
+        self.assertEqual(self.run_bzr('nick')[0][:-1], base.branch.nick)
+        self.assertEqual(child.branch.get_config()._get_explicit_nickname(),
+            base.branch.nick)
 
     def test_boundless_nick(self):
         """Nick defaults to implicit local nick when bound branch is AWOL"""
@@ -73,8 +73,8 @@
         child = self.make_branch_and_tree('child')
         os.chdir('child')
         self.run_bzr('bind ../base')
-        self.assertEqual(base.branch.nick, self.run_bzr('nick')[0][:-1])
-        self.assertEqual(False,
-                         child.branch.get_config().has_explicit_nickname())
+        self.assertEqual(self.run_bzr('nick')[0][:-1], base.branch.nick)
+        self.assertEqual(child.branch.get_config().has_explicit_nickname(),
+            False)
         osutils.rmtree('../base')
-        self.assertEqual('child', self.run_bzr('nick')[0][:-1])
+        self.assertEqual(self.run_bzr('nick')[0][:-1], 'child')

=== modified file 'bzrlib/tests/blackbox/test_non_ascii.py'
--- bzrlib/tests/blackbox/test_non_ascii.py	2010-04-20 14:44:01 +0000
+++ bzrlib/tests/blackbox/test_non_ascii.py	2009-08-20 04:09:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,13 +38,17 @@
 
     def setUp(self):
         super(TestNonAscii, self).setUp()
-        self._check_can_encode_paths()
+        self._orig_encoding = osutils._cached_user_encoding
 
-        self.overrideAttr(osutils, '_cached_user_encoding', self.encoding)
+        osutils._cached_user_encoding = self.encoding
         email = self.info['committer'] + ' <joe@foo.com>'
         os.environ['BZR_EMAIL'] = email.encode(osutils.get_user_encoding())
         self.create_base()
 
+    def tearDown(self):
+        osutils._cached_user_encoding = self._orig_encoding
+        super(TestNonAscii, self).tearDown()
+
     def run_bzr_decode(self, args, encoding=None, fail=False, retcode=None,
                        working_dir=None):
         """Run bzr and decode the output into a particular encoding.
@@ -94,7 +98,7 @@
                     ' using encoding "%s"'
                     % (path, fs_enc))
 
-    def _check_can_encode_paths(self):
+    def create_base(self):
         fs_enc = osutils._fs_enc
         terminal_enc = osutils.get_terminal_encoding()
         fname = self.info['filename']
@@ -114,7 +118,6 @@
                     ' (even though it is valid in filesystem encoding "%s")'
                     % (thing, terminal_enc, fs_enc))
 
-    def create_base(self):
         wt = self.make_branch_and_tree('.')
         self.build_tree_contents([('a', 'foo\n')])
         wt.add('a')
@@ -125,7 +128,6 @@
         wt.add('b')
         wt.commit(self.info['message'])
 
-        fname = self.info['filename']
         self.build_tree_contents([(fname, 'unicode filename\n')])
         wt.add(fname)
         wt.commit(u'And a unicode file\n')

=== modified file 'bzrlib/tests/blackbox/test_outside_wt.py'
--- bzrlib/tests/blackbox/test_outside_wt.py	2010-01-25 15:55:48 +0000
+++ bzrlib/tests/blackbox/test_outside_wt.py	2009-09-19 16:14:10 +0000
@@ -36,7 +36,7 @@
         tmp_dir = osutils.realpath(osutils.mkdtemp())
         # We expect a read-to-root attempt to occur.
         self.permit_url('file:///')
-        self.addCleanup(osutils.rmtree, tmp_dir)
+        self.addCleanup(lambda: osutils.rmtree(tmp_dir))
         out, err = self.run_bzr('log', retcode=3, working_dir=tmp_dir)
         self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n'
                          % (tmp_dir,),
@@ -57,7 +57,7 @@
         # false and may cause test failures).
         # Watch out for tricky test dir (on OSX /tmp -> /private/tmp)
         tmp_dir = osutils.realpath(osutils.mkdtemp())
-        self.addCleanup(osutils.rmtree, tmp_dir)
+        self.addCleanup(lambda: osutils.rmtree(tmp_dir))
         # We expect a read-to-root attempt to occur.
         self.permit_url('file:///')
         expected_error = u'bzr: ERROR: Not a branch: "%s/branch2/".\n' % tmp_dir

=== modified file 'bzrlib/tests/blackbox/test_pack.py'
--- bzrlib/tests/blackbox/test_pack.py	2010-04-26 13:51:08 +0000
+++ bzrlib/tests/blackbox/test_pack.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,31 +16,11 @@
 #
 
 """Tests of the 'bzr pack' command."""
-import os
-
-from bzrlib import tests
-
-
-class TestPack(tests.TestCaseWithTransport):
-
-    def _make_versioned_file(self, path, line_prefix='line', total_lines=10):
-        self._make_file(path, line_prefix, total_lines, versioned=True)
-
-    def _make_file(self, path, line_prefix, total_lines, versioned):
-        text=''
-        for i in range(total_lines):
-            text += line_prefix + str(i+1) + "\n"
-
-        open(path, 'w').write(text)
-        if versioned:
-            self.run_bzr(['add', path])
-            self.run_bzr(['ci', '-m', '"' + path + '"'])
-
-    def _update_file(self, path, text, checkin=True):
-        """append text to file 'path' and check it in"""
-        open(path, 'a').write(text)
-        if checkin:
-            self.run_bzr(['ci', path, '-m', '"' + path + '"'])
+
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestPack(ExternalBase):
 
     def test_pack_silent(self):
         """pack command has no intrinsic output."""
@@ -62,22 +42,3 @@
         out, err = self.run_bzr('pack repository')
         self.assertEqual('', out)
         self.assertEqual('', err)
-
-    def test_pack_clean_obsolete_packs(self):
-        """Ensure --clean-obsolete-packs removes obsolete pack files
-        """
-        wd = 'foobar0'
-        wt = self.make_branch_and_tree(wd)
-        transport = wt.branch.repository.bzrdir.transport
-        os.chdir(wd)
-
-        # do multiple commits to ensure that obsolete packs are created
-        # by 'bzr pack'
-        self._make_versioned_file('file0.txt')
-        for i in range(5):
-            self._update_file('file0.txt', 'HELLO %d\n' % i)
-
-        out, err = self.run_bzr(['pack', '--clean-obsolete-packs'])
-
-        pack_names = transport.list_dir('repository/obsolete_packs')
-        self.assertTrue(len(pack_names) == 0)

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2009-06-15 06:47:14 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,18 +20,13 @@
 import os
 import sys
 
-from bzrlib import (
-    debug,
-    remote,
-    urlutils,
-    )
-
 from bzrlib.branch import Branch
 from bzrlib.directory_service import directories
 from bzrlib.osutils import pathjoin
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.uncommit import uncommit
 from bzrlib.workingtree import WorkingTree
+from bzrlib import urlutils
 
 
 class TestPull(ExternalBase):
@@ -343,7 +338,7 @@
             def look_up(self, name, url):
                 return 'source'
         directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(directories.remove, 'foo:')
+        self.addCleanup(lambda: directories.remove('foo:'))
         self.run_bzr('pull foo:bar -d target')
         self.assertEqual(source_last, target.last_revision())
 
@@ -395,61 +390,4 @@
         self.assertLength(18, self.hpss_calls)
         remote = Branch.open('stacked')
         self.assertEndsWith(remote.get_stacked_on_url(), '/parent')
-    
-    def test_pull_cross_format_warning(self):
-        """You get a warning for probably slow cross-format pulls.
-        """
-        # this is assumed to be going through InterDifferingSerializer
-        from_tree = self.make_branch_and_tree('from', format='2a')
-        to_tree = self.make_branch_and_tree('to', format='1.14-rich-root')
-        from_tree.commit(message='first commit')
-        out, err = self.run_bzr(['pull', '-d', 'to', 'from'])
-        self.assertContainsRe(err,
-            "(?m)Doing on-the-fly conversion")
-
-    def test_pull_cross_format_warning_no_IDS(self):
-        """You get a warning for probably slow cross-format pulls.
-        """
-        # this simulates what would happen across the network, where
-        # interdifferingserializer is not active
-
-        debug.debug_flags.add('IDS_never')
-        # TestCase take care of restoring them
-
-        from_tree = self.make_branch_and_tree('from', format='2a')
-        to_tree = self.make_branch_and_tree('to', format='1.14-rich-root')
-        from_tree.commit(message='first commit')
-        out, err = self.run_bzr(['pull', '-d', 'to', 'from'])
-        self.assertContainsRe(err,
-            "(?m)Doing on-the-fly conversion")
-
-    def test_pull_cross_format_from_network(self):
-        self.setup_smart_server_with_call_log()
-        from_tree = self.make_branch_and_tree('from', format='2a')
-        to_tree = self.make_branch_and_tree('to', format='1.14-rich-root')
-        self.assertIsInstance(from_tree.branch, remote.RemoteBranch)
-        from_tree.commit(message='first commit')
-        out, err = self.run_bzr(['pull', '-d', 'to',
-            from_tree.branch.bzrdir.root_transport.base])
-        self.assertContainsRe(err,
-            "(?m)Doing on-the-fly conversion")
-
-    def test_pull_to_experimental_format_warning(self):
-        """You get a warning for pulling into experimental formats.
-        """
-        from_tree = self.make_branch_and_tree('from', format='development-subtree')
-        to_tree = self.make_branch_and_tree('to', format='development-subtree')
-        from_tree.commit(message='first commit')
-        out, err = self.run_bzr(['pull', '-d', 'to', 'from'])
-        self.assertContainsRe(err,
-            "(?m)Fetching into experimental format")
-
-    def test_pull_cross_to_experimental_format_warning(self):
-        """You get a warning for pulling into experimental formats.
-        """
-        from_tree = self.make_branch_and_tree('from', format='2a')
-        to_tree = self.make_branch_and_tree('to', format='development-subtree')
-        from_tree.commit(message='first commit')
-        out, err = self.run_bzr(['pull', '-d', 'to', 'from'])
-        self.assertContainsRe(err,
-            "(?m)Fetching into experimental format")
+

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_push.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -35,7 +35,6 @@
     blackbox,
     http_server,
     test_foreign,
-    test_server,
     )
 from bzrlib.transport import memory
 
@@ -661,35 +660,21 @@
     _default_wd = 'local'
     _default_errors = ['Working tree ".*/local/" has uncommitted '
                        'changes \(See bzr status\)\.',]
-    _default_additional_error = 'Use --no-strict to force the push.\n'
-    _default_additional_warning = 'Uncommitted changes will not be pushed.'
-
+    _default_pushed_revid = 'modified'
 
     def assertPushFails(self, args):
-        out, err = self.run_bzr_error(self._default_errors,
-                                      self._default_command + args,
-                                      working_dir=self._default_wd, retcode=3)
-        self.assertContainsRe(err, self._default_additional_error)
+        self.run_bzr_error(self._default_errors, self._default_command + args,
+                           working_dir=self._default_wd, retcode=3)
 
-    def assertPushSucceeds(self, args, with_warning=False, revid_to_push=None):
-        if with_warning:
-            error_regexes = self._default_errors
-        else:
-            error_regexes = []
-        out, err = self.run_bzr(self._default_command + args,
-                                working_dir=self._default_wd,
-                                error_regexes=error_regexes)
-        if with_warning:
-            self.assertContainsRe(err, self._default_additional_warning)
-        else:
-            self.assertNotContainsRe(err, self._default_additional_warning)
-        branch_from = branch.Branch.open(self._default_wd)
-        if revid_to_push is None:
-            revid_to_push = branch_from.last_revision()
-        branch_to = branch.Branch.open('to')
-        repo_to = branch_to.repository
-        self.assertTrue(repo_to.has_revision(revid_to_push))
-        self.assertEqual(revid_to_push, branch_to.last_revision())
+    def assertPushSucceeds(self, args, pushed_revid=None):
+        self.run_bzr(self._default_command + args,
+                     working_dir=self._default_wd)
+        if pushed_revid is None:
+            pushed_revid = self._default_pushed_revid
+        tree_to = workingtree.WorkingTree.open('to')
+        repo_to = tree_to.branch.repository
+        self.assertTrue(repo_to.has_revision(pushed_revid))
+        self.assertEqual(tree_to.branch.last_revision_info()[1], pushed_revid)
 
 
 
@@ -756,12 +741,13 @@
         self._default_wd = 'checkout'
         self._default_errors = ["Working tree is out of date, please run"
                                 " 'bzr update'\.",]
+        self._default_pushed_revid = 'modified-in-local'
 
     def test_push_default(self):
-        self.assertPushSucceeds([], with_warning=True)
+        self.assertPushFails([])
 
     def test_push_with_revision(self):
-        self.assertPushSucceeds(['-r', 'revid:added'], revid_to_push='added')
+        self.assertPushSucceeds(['-r', 'revid:added'], pushed_revid='added')
 
     def test_push_no_strict(self):
         self.assertPushSucceeds(['--no-strict'])
@@ -775,7 +761,7 @@
 
     def test_push_bogus_config_var_ignored(self):
         self.set_config_push_strict("I don't want you to be strict")
-        self.assertPushSucceeds([], with_warning=True)
+        self.assertPushFails([])
 
     def test_push_no_strict_command_line_override_config(self):
         self.set_config_push_strict('yES')

=== modified file 'bzrlib/tests/blackbox/test_re_sign.py'
--- bzrlib/tests/blackbox/test_re_sign.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/blackbox/test_re_sign.py	2009-03-23 14:59:43 +0000
@@ -21,15 +21,13 @@
 
 import os
 
-from bzrlib import (
-    gpg,
-    tests,
-    )
+import bzrlib.gpg
 from bzrlib.bzrdir import BzrDir
 from bzrlib.testament import Testament
-
-
-class ReSign(tests.TestCaseInTempDir):
+from bzrlib.tests import TestCaseInTempDir
+
+
+class ReSign(TestCaseInTempDir):
 
     def monkey_patch_gpg(self):
         """Monkey patch the gpg signing strategy to be a loopback.
@@ -37,8 +35,15 @@
         This also registers the cleanup, so that we will revert to
         the original gpg strategy when done.
         """
+        self._oldstrategy = bzrlib.gpg.GPGStrategy
+
         # monkey patch gpg signing mechanism
-        self.overrideAttr(gpg, 'GPGStrategy', gpg.LoopbackGPGStrategy)
+        bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
+
+        self.addCleanup(self._fix_gpg_strategy)
+
+    def _fix_gpg_strategy(self):
+        bzrlib.gpg.GPGStrategy = self._oldstrategy
 
     def setup_tree(self):
         wt = BzrDir.create_standalone_workingtree('.')

=== modified file 'bzrlib/tests/blackbox/test_reconcile.py'
--- bzrlib/tests/blackbox/test_reconcile.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/blackbox/test_reconcile.py	2009-03-23 14:59:43 +0000
@@ -17,15 +17,27 @@
 """Black box tests for the reconcile command."""
 
 
-from bzrlib import (
-    bzrdir,
-    inventory,
-    repository,
-    tests,
-    )
-
-
-class TrivialTest(tests.TestCaseWithTransport):
+import bzrlib
+import bzrlib.bzrdir as bzrdir
+from bzrlib.inventory import Inventory
+import bzrlib.repository as repository
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests import TestUIFactory
+from bzrlib.transport import get_transport
+import bzrlib.ui as ui
+
+
+class TrivialTest(TestCaseWithTransport):
+
+    def setUp(self):
+        super(TrivialTest, self).setUp()
+        self.old_format = bzrdir.BzrDirFormat.get_default_format()
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
+        ui.ui_factory = TestUIFactory()
+
+    def restoreDefaults(self):
+        ui.ui_factory = self.old_ui_factory
 
     def test_trivial_reconcile(self):
         t = bzrdir.BzrDir.create_standalone_workingtree('.')
@@ -48,7 +60,7 @@
         t = bzrdir.BzrDir.create_standalone_workingtree('.')
         # an empty inventory with no revision will trigger reconciliation.
         repo = t.branch.repository
-        inv = inventory.Inventory(revision_id='missing')
+        inv = Inventory(revision_id='missing')
         inv.root.revision='missing'
         repo.lock_write()
         repo.start_write_group()

=== modified file 'bzrlib/tests/blackbox/test_remerge.py'
--- bzrlib/tests/blackbox/test_remerge.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_remerge.py	2009-12-10 23:11:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_remove_tree.py'
--- bzrlib/tests/blackbox/test_remove_tree.py	2009-11-16 05:57:00 +0000
+++ bzrlib/tests/blackbox/test_remove_tree.py	2009-09-08 16:45:11 +0000
@@ -43,12 +43,6 @@
         self.run_bzr('remove-tree branch1')
         self.failIfExists('branch1/foo')
 
-    def test_remove_tree_multiple_branch_explicit(self):
-        self.tree.bzrdir.sprout('branch2')
-        self.run_bzr('remove-tree branch1 branch2')
-        self.failIfExists('branch1/foo')
-        self.failIfExists('branch2/foo')
-
     def test_remove_tree_sprouted_branch(self):
         self.tree.bzrdir.sprout('branch2')
         self.failUnlessExists('branch2/foo')

=== removed file 'bzrlib/tests/blackbox/test_rmbranch.py'
--- bzrlib/tests/blackbox/test_rmbranch.py	2010-03-22 10:11:00 +0000
+++ bzrlib/tests/blackbox/test_rmbranch.py	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-
-"""Black-box tests for bzr rmbranch."""
-
-from bzrlib import (
-    bzrdir,
-    )
-from bzrlib.tests.blackbox import (
-    ExternalBase,
-    )
-
-
-class TestRemoveBranch(ExternalBase):
-
-    def example_branch(self, path='.'):
-        tree = self.make_branch_and_tree(path)
-        self.build_tree_contents([(path + '/hello', 'foo')])
-        tree.add('hello')
-        tree.commit(message='setup')
-        self.build_tree_contents([(path + '/goodbye', 'baz')])
-        tree.add('goodbye')
-        tree.commit(message='setup')
-
-    def test_remove_local(self):
-        # Remove a local branch.
-        self.example_branch('a')
-        self.run_bzr('rmbranch a')
-        dir = bzrdir.BzrDir.open('a')
-        self.assertFalse(dir.has_branch())
-        self.failUnlessExists('a/hello')
-        self.failUnlessExists('a/goodbye')
-
-    def test_no_branch(self):
-        # No branch in the current directory. 
-        self.make_repository('a')
-        self.run_bzr_error(['Not a branch'],
-            'rmbranch a')
-
-    def test_no_arg(self):
-        # location argument defaults to current directory
-        self.example_branch('a')
-        self.run_bzr('rmbranch', working_dir='a')
-        dir = bzrdir.BzrDir.open('a')
-        self.assertFalse(dir.has_branch())

=== modified file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	2010-04-18 08:51:37 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2009-12-22 15:37:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,14 +16,19 @@
 
 """UI tests for the test framework."""
 
+import bzrlib.transport
 from bzrlib import (
     benchmarks,
     tests,
     )
+from bzrlib.errors import ParamikoNotPresent
 from bzrlib.tests import (
-    features,
-    )
-from bzrlib.transport import memory
+                          features,
+                          TestCase,
+                          TestCaseInTempDir,
+                          TestSkipped,
+                          )
+
 
 class SelfTestPatch:
 
@@ -46,7 +51,7 @@
             tests.selftest = original_selftest
 
 
-class TestOptionsWritingToDisk(tests.TestCaseInTempDir, SelfTestPatch):
+class TestOptionsWritingToDisk(TestCaseInTempDir, SelfTestPatch):
 
     def test_benchmark_runs_benchmark_tests(self):
         """selftest --benchmark should change the suite factory."""
@@ -64,7 +69,7 @@
         self.assertEqual(0, len(lines))
 
 
-class TestOptions(tests.TestCase, SelfTestPatch):
+class TestOptions(TestCase, SelfTestPatch):
 
     def test_load_list(self):
         params = self.get_params_passed_to_core('selftest --load-list foo')
@@ -74,16 +79,17 @@
         # Test that we can pass a transport to the selftest core - sftp
         # version.
         self.requireFeature(features.paramiko)
-        from bzrlib.tests import stub_sftp
         params = self.get_params_passed_to_core('selftest --transport=sftp')
-        self.assertEqual(stub_sftp.SFTPAbsoluteServer,
+        self.assertEqual(bzrlib.transport.sftp.SFTPAbsoluteServer,
             params[1]["transport"])
 
     def test_transport_set_to_memory(self):
         # Test that we can pass a transport to the selftest core - memory
         # version.
+        import bzrlib.transport.memory
         params = self.get_params_passed_to_core('selftest --transport=memory')
-        self.assertEqual(memory.MemoryServer, params[1]["transport"])
+        self.assertEqual(bzrlib.transport.memory.MemoryServer,
+            params[1]["transport"])
 
     def test_parameters_passed_to_core(self):
         params = self.get_params_passed_to_core('selftest --list-only')

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_send.py	2009-11-28 00:48:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 # Authors: Aaron Bentley
 #
 # This program is free software; you can redistribute it and/or modify
@@ -26,7 +26,6 @@
     tests,
     )
 from bzrlib.bundle import serializer
-from bzrlib.transport import memory
 
 
 def load_tests(standard_tests, module, loader):
@@ -281,7 +280,7 @@
         self.assertEqual('rev3', md.revision_id)
 
     def test_nonexistant_branch(self):
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = tests.MemoryServer
         location = self.get_url('absentdir/')
         out, err = self.run_bzr(["send", "--from", location], retcode=3)
         self.assertEqual(out, '')
@@ -307,8 +306,6 @@
     _default_sent_revs = ['local']
     _default_errors = ['Working tree ".*/local/" has uncommitted '
                        'changes \(See bzr status\)\.',]
-    _default_additional_error = 'Use --no-strict to force the send.\n'
-    _default_additional_warning = 'Uncommitted changes will not be sent.'
 
     def set_config_send_strict(self, value):
         # set config var (any of bazaar.conf, locations.conf, branch.conf
@@ -317,23 +314,14 @@
         conf.set_user_option('send_strict', value)
 
     def assertSendFails(self, args):
-        out, err = self.run_send(args, rc=3, err_re=self._default_errors)
-        self.assertContainsRe(err, self._default_additional_error)
+        self.run_send(args, rc=3, err_re=self._default_errors)
 
-    def assertSendSucceeds(self, args, revs=None, with_warning=False):
-        if with_warning:
-            err_re = self._default_errors
-        else:
-            err_re = []
+    def assertSendSucceeds(self, args, revs=None):
         if revs is None:
             revs = self._default_sent_revs
-        out, err = self.run_send(args, err_re=err_re)
-        bundling_revs = 'Bundling %d revision(s).\n' % len(revs)
-        if with_warning:
-            self.assertContainsRe(err, self._default_additional_warning)
-            self.assertEndsWith(err, bundling_revs)
-        else:
-            self.assertEquals(bundling_revs, err)
+        out, err = self.run_send(args)
+        self.assertEquals(
+            'Bundling %d revision(s).\n' % len(revs), err)
         md = merge_directive.MergeDirective.from_lines(StringIO(out))
         self.assertEqual('parent', md.base_revision_id)
         br = serializer.read_bundle(StringIO(md.get_raw_bundle()))
@@ -407,7 +395,7 @@
         self._default_sent_revs = ['modified-in-local', 'local']
 
     def test_send_default(self):
-        self.assertSendSucceeds([], with_warning=True)
+        self.assertSendFails([])
 
     def test_send_with_revision(self):
         self.assertSendSucceeds(['-r', 'revid:local'], revs=['local'])
@@ -423,9 +411,11 @@
         self.assertSendFails([])
         self.assertSendSucceeds(['--no-strict'])
 
+
     def test_send_bogus_config_var_ignored(self):
         self.set_config_send_strict("I'm unsure")
-        self.assertSendSucceeds([], with_warning=True)
+        self.assertSendFails([])
+
 
     def test_send_no_strict_command_line_override_config(self):
         self.set_config_send_strict('true')

=== modified file 'bzrlib/tests/blackbox/test_serve.py'
--- bzrlib/tests/blackbox/test_serve.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_serve.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_shared_repository.py'
--- bzrlib/tests/blackbox/test_shared_repository.py	2010-03-25 18:02:45 +0000
+++ bzrlib/tests/blackbox/test_shared_repository.py	2009-09-23 23:58:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 
 import os
 
-from bzrlib.bzrdir import BzrDir, BzrDirMetaFormat1
+from bzrlib.bzrdir import BzrDir
 import bzrlib.errors as errors
 from bzrlib.tests import TestCaseInTempDir
 
@@ -120,28 +120,3 @@
         # become necessary for this use case. Please do not adjust this number
         # upwards without agreement from bzr's network support maintainers.
         self.assertLength(15, self.hpss_calls)
-
-    def test_notification_on_branch_from_repository(self):
-        out, err = self.run_bzr("init-repository -q a")
-        self.assertEqual(out, "")
-        self.assertEqual(err, "")
-        dir = BzrDir.open('a')
-        dir.open_repository() # there is a repository there
-        e = self.assertRaises(errors.NotBranchError, dir.open_branch)
-        self.assertContainsRe(str(e), "location is a repository")
-
-    def test_notification_on_branch_from_nonrepository(self):
-        fmt = BzrDirMetaFormat1()
-        t = self.get_transport()
-        t.mkdir('a')
-        dir = fmt.initialize_on_transport(t.clone('a'))
-        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
-        e = self.assertRaises(errors.NotBranchError, dir.open_branch)
-        self.assertNotContainsRe(str(e), "location is a repository")
-
-    def test_init_repo_with_post_repo_init_hook(self):
-        calls = []
-        BzrDir.hooks.install_named_hook('post_repo_init', calls.append, None)
-        self.assertLength(0, calls)
-        self.run_bzr("init-repository a")
-        self.assertLength(1, calls)

=== modified file 'bzrlib/tests/blackbox/test_shelve.py'
--- bzrlib/tests/blackbox/test_shelve.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_shelve.py	2009-12-11 05:48:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_sign_my_commits.py'
--- bzrlib/tests/blackbox/test_sign_my_commits.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/blackbox/test_sign_my_commits.py	2009-03-23 14:59:43 +0000
@@ -19,15 +19,13 @@
 
 import os
 
-from bzrlib import (
-    gpg,
-    tests,
-    )
+import bzrlib.gpg
 from bzrlib.testament import Testament
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.workingtree import WorkingTree
 
 
-class SignMyCommits(tests.TestCaseWithTransport):
+class SignMyCommits(TestCaseWithTransport):
 
     def monkey_patch_gpg(self):
         """Monkey patch the gpg signing strategy to be a loopback.
@@ -35,8 +33,15 @@
         This also registers the cleanup, so that we will revert to
         the original gpg strategy when done.
         """
+        self._oldstrategy = bzrlib.gpg.GPGStrategy
+
         # monkey patch gpg signing mechanism
-        self.overrideAttr(gpg, 'GPGStrategy', gpg.LoopbackGPGStrategy)
+        bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
+
+        self.addCleanup(self._fix_gpg_strategy)
+
+    def _fix_gpg_strategy(self):
+        bzrlib.gpg.GPGStrategy = self._oldstrategy
 
     def setup_tree(self, location='.'):
         wt = self.make_branch_and_tree(location)

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2010-04-07 21:34:13 +0000
+++ bzrlib/tests/blackbox/test_status.py	2009-07-08 14:37:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -472,39 +472,6 @@
         self.assertEqual("working tree is out of date, run 'bzr update'\n",
                          err)
 
-    def test_status_on_ignored(self):
-        """Tests branch status on an unversioned file which is considered ignored.
-
-        See https://bugs.launchpad.net/bzr/+bug/40103
-        """
-        tree = self.make_branch_and_tree('.')
-
-        self.build_tree(['test1.c', 'test1.c~', 'test2.c~'])
-        result = self.run_bzr('status')[0]
-        self.assertContainsRe(result, "unknown:\n  test1.c\n")
-        short_result = self.run_bzr('status --short')[0]
-        self.assertContainsRe(short_result, "\?   test1.c\n")
-
-        result = self.run_bzr('status test1.c')[0]
-        self.assertContainsRe(result, "unknown:\n  test1.c\n")
-        short_result = self.run_bzr('status --short test1.c')[0]
-        self.assertContainsRe(short_result, "\?   test1.c\n")
-
-        result = self.run_bzr('status test1.c~')[0]
-        self.assertContainsRe(result, "ignored:\n  test1.c~\n")
-        short_result = self.run_bzr('status --short test1.c~')[0]
-        self.assertContainsRe(short_result, "I   test1.c~\n")
-
-        result = self.run_bzr('status test1.c~ test2.c~')[0]
-        self.assertContainsRe(result, "ignored:\n  test1.c~\n  test2.c~\n")
-        short_result = self.run_bzr('status --short test1.c~ test2.c~')[0]
-        self.assertContainsRe(short_result, "I   test1.c~\nI   test2.c~\n")
-
-        result = self.run_bzr('status test1.c test1.c~ test2.c~')[0]
-        self.assertContainsRe(result, "unknown:\n  test1.c\nignored:\n  test1.c~\n  test2.c~\n")
-        short_result = self.run_bzr('status --short test1.c test1.c~ test2.c~')[0]
-        self.assertContainsRe(short_result, "\?   test1.c\nI   test1.c~\nI   test2.c~\n")
-
     def test_status_write_lock(self):
         """Test that status works without fetching history and
         having a write lock.
@@ -531,8 +498,7 @@
     def make_branch_and_tree(self, relpath):
         source = self.make_branch(pathjoin('..', relpath))
         checkout = bzrdir.BzrDirMetaFormat1().initialize(relpath)
-        bzrlib.branch.BranchReferenceFormat().initialize(checkout,
-            target_branch=source)
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout, source)
         return checkout.create_workingtree()
 
 
@@ -629,28 +595,11 @@
         result2 = self.run_bzr("status -SV -r 0..")[0]
         self.assertEquals(result2, result)
 
-    def assertStatusContains(self, pattern, short=False):
+    def assertStatusContains(self, pattern):
         """Run status, and assert it contains the given pattern"""
-        if short:
-            result = self.run_bzr("status --short")[0]
-        else:
-            result = self.run_bzr("status")[0]
+        result = self.run_bzr("status --short")[0]
         self.assertContainsRe(result, pattern)
 
-    def test_kind_change_plain(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['file'])
-        tree.add('file')
-        tree.commit('added file')
-        unlink('file')
-        self.build_tree(['file/'])
-        self.assertStatusContains('kind changed:\n  file \(file => directory\)')
-        tree.rename_one('file', 'directory')
-        self.assertStatusContains('renamed:\n  file/ => directory/\n' \
-                                  'modified:\n  directory/\n')
-        rmdir('directory')
-        self.assertStatusContains('removed:\n  file\n')
-
     def test_kind_change_short(self):
         tree = self.make_branch_and_tree('.')
         self.build_tree(['file'])
@@ -658,14 +607,11 @@
         tree.commit('added file')
         unlink('file')
         self.build_tree(['file/'])
-        self.assertStatusContains('K  file => file/',
-                                   short=True)
+        self.assertStatusContains('K  file => file/')
         tree.rename_one('file', 'directory')
-        self.assertStatusContains('RK  file => directory/',
-                                   short=True)
+        self.assertStatusContains('RK  file => directory/')
         rmdir('directory')
-        self.assertStatusContains('RD  file => directory',
-                                   short=True)
+        self.assertStatusContains('RD  file => directory')
 
     def test_status_illegal_revision_specifiers(self):
         out, err = self.run_bzr('status -r 1..23..123', retcode=3)

=== modified file 'bzrlib/tests/blackbox/test_switch.py'
--- bzrlib/tests/blackbox/test_switch.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_switch.py	2009-12-11 17:04:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -20,7 +20,6 @@
 
 import os
 
-from bzrlib import osutils
 from bzrlib.workingtree import WorkingTree
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.directory_service import directories
@@ -28,15 +27,6 @@
 
 class TestSwitch(ExternalBase):
 
-    def _create_sample_tree(self):
-        tree = self.make_branch_and_tree('branch-1')
-        self.build_tree(['branch-1/file-1', 'branch-1/file-2'])
-        tree.add('file-1')
-        tree.commit('rev1')
-        tree.add('file-2')
-        tree.commit('rev2')
-        return tree
-
     def test_switch_up_to_date_light_checkout(self):
         self.make_branch_and_tree('branch')
         self.run_bzr('branch branch branch2')
@@ -145,30 +135,10 @@
         self.assertEqual(branchb_id, checkout.last_revision())
         self.assertEqual(tree2.branch.base, checkout.branch.get_bound_location())
 
-    def test_switch_revision(self):
-        tree = self._create_sample_tree()
-        checkout = tree.branch.create_checkout('checkout', lightweight=True)
-        self.run_bzr(['switch', 'branch-1', '-r1'], working_dir='checkout')
-        self.failUnlessExists('checkout/file-1')
-        self.failIfExists('checkout/file-2')
-
-    def test_switch_only_revision(self):
-        tree = self._create_sample_tree()
-        checkout = tree.branch.create_checkout('checkout', lightweight=True)
-        self.failUnlessExists('checkout/file-1')
-        self.failUnlessExists('checkout/file-2')
-        self.run_bzr(['switch', '-r1'], working_dir='checkout')
-        self.failUnlessExists('checkout/file-1')
-        self.failIfExists('checkout/file-2')
-        # Check that we don't accept a range
-        self.run_bzr_error(
-            ['bzr switch --revision takes exactly one revision identifier'],
-            ['switch', '-r0..2'], working_dir='checkout')
-
     def prepare_lightweight_switch(self):
         branch = self.make_branch('branch')
         branch.create_checkout('tree', lightweight=True)
-        osutils.rename('branch', 'branch1')
+        os.rename('branch', 'branch1')
 
     def test_switch_lightweight_after_branch_moved(self):
         self.prepare_lightweight_switch()
@@ -227,28 +197,3 @@
         tree = WorkingTree.open('tree')
         self.assertEndsWith(tree.branch.base, 'foo-branch2/')
 
-    def test_switch_with_post_switch_hook(self):
-        from bzrlib import branch as _mod_branch
-        calls = []
-        _mod_branch.Branch.hooks.install_named_hook('post_switch',
-            calls.append, None)
-        self.make_branch_and_tree('branch')
-        self.run_bzr('branch branch branch2')
-        self.run_bzr('checkout branch checkout')
-        os.chdir('checkout')
-        self.assertLength(0, calls)
-        out, err = self.run_bzr('switch ../branch2')
-        self.assertLength(1, calls)
-
-    def test_switch_lightweight_co_with_post_switch_hook(self):
-        from bzrlib import branch as _mod_branch
-        calls = []
-        _mod_branch.Branch.hooks.install_named_hook('post_switch',
-            calls.append, None)
-        self.make_branch_and_tree('branch')
-        self.run_bzr('branch branch branch2')
-        self.run_bzr('checkout --lightweight branch checkout')
-        os.chdir('checkout')
-        self.assertLength(0, calls)
-        out, err = self.run_bzr('switch ../branch2')
-        self.assertLength(1, calls)

=== modified file 'bzrlib/tests/blackbox/test_tags.py'
--- bzrlib/tests/blackbox/test_tags.py	2010-03-24 14:16:15 +0000
+++ bzrlib/tests/blackbox/test_tags.py	2009-08-20 04:09:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,10 +16,7 @@
 
 """Tests for commands related to tags"""
 
-from bzrlib import (
-    bzrdir,
-    tag,
-    )
+from bzrlib import bzrdir
 from bzrlib.branch import (
     Branch,
     )
@@ -50,18 +47,6 @@
         self.assertContainsRe(err,
             "Tags can only be placed on a single revision")
 
-    def test_no_tag_name(self):
-        out, err = self.run_bzr('tag -d branch', retcode=3)
-        self.assertContainsRe(err, 'Please specify a tag name.')
-
-    def test_automatic_tag_name(self):
-        def get_tag_name(branch, revid):
-            return "mytag"
-        Branch.hooks.install_named_hook('automatic_tag_name',
-            get_tag_name, 'get tag name')
-        out, err = self.run_bzr('tag -d branch')
-        self.assertContainsRe(out, 'Created tag mytag.')
-
     def test_tag_current_rev(self):
         t = self.make_branch_and_tree('branch')
         t.commit(allow_pointless=True, message='initial commit',
@@ -88,10 +73,6 @@
         # ... but can if you use --force
         out, err = self.run_bzr('tag -d branch NEWTAG --force')
 
-    def test_tag_delete_requires_name(self):
-        out, err = self.run_bzr('tag -d branch', retcode=3)
-        self.assertContainsRe(err, 'Please specify a tag name\\.')
-
     def test_branch_push_pull_merge_copies_tags(self):
         t = self.make_branch_and_tree('branch1')
         t.commit(allow_pointless=True, message='initial commit',

=== modified file 'bzrlib/tests/blackbox/test_too_much.py'
--- bzrlib/tests/blackbox/test_too_much.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_too_much.py	2009-12-02 15:24:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_uncommit.py'
--- bzrlib/tests/blackbox/test_uncommit.py	2010-03-01 16:18:43 +0000
+++ bzrlib/tests/blackbox/test_uncommit.py	2009-10-06 14:40:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,7 +22,6 @@
 from bzrlib.bzrdir import BzrDirMetaFormat1
 from bzrlib.errors import BzrError, BoundBranchOutOfDate
 from bzrlib.tests import TestCaseWithTransport
-from bzrlib.tests.script import ScriptRunner
 
 
 class TestUncommit(TestCaseWithTransport):
@@ -217,17 +216,10 @@
     def test_uncommit_shows_log_with_revision_id(self):
         wt = self.create_simple_tree()
 
-        script = ScriptRunner()
-        script.run_script(self, """
-$ cd tree
-$ bzr uncommit --force 
-    2 ...
-      second commit
-...
-The above revision(s) will be removed.
-You can restore the old tip by running:
-  bzr pull . -r revid:a2
-""")
+        out, err = self.run_bzr('uncommit --force', working_dir='tree')
+        self.assertContainsRe(out, r'second commit')
+        self.assertContainsRe(err, r'You can restore the old tip by running')
+        self.assertContainsRe(err, r'bzr pull . -r revid:a2')
 
     def test_uncommit_octopus_merge(self):
         # Check that uncommit keeps the pending merges in the same order

=== modified file 'bzrlib/tests/blackbox/test_update.py'
--- bzrlib/tests/blackbox/test_update.py	2010-04-14 04:48:00 +0000
+++ bzrlib/tests/blackbox/test_update.py	2009-12-23 06:31:19 +0000
@@ -1,4 +1,5 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2009 Canonical Ltd
+# -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -170,9 +171,9 @@
         # get all three files and a pending merge.
         out, err = self.run_bzr('update checkout')
         self.assertEqual('', out)
-        self.assertEqualDiff("""+N  file_b
+        self.assertEqualDiff("""+N  file
 All changes applied successfully.
-+N  file
++N  file_b
 All changes applied successfully.
 Updated to revision 1 of branch %s
 Your local commits will now show as pending merges with 'bzr status', and can be committed with 'bzr commit'.
@@ -195,8 +196,7 @@
 
         self.build_tree(['checkout1/'])
         checkout_dir = bzrdir.BzrDirMetaFormat1().initialize('checkout1')
-        branch.BranchReferenceFormat().initialize(checkout_dir,
-            target_branch=master.branch)
+        branch.BranchReferenceFormat().initialize(checkout_dir, master.branch)
         checkout1 = checkout_dir.create_workingtree('m1')
 
         # Create a second branch, with an extra commit
@@ -241,48 +241,10 @@
         tree.commit('empty commit')
         self.run_bzr('update checkout')
 
-    def test_update_with_merge_merged_to_master(self):
-        # Test that 'bzr update' works correctly when you have
-        # an update in the master tree, and a [lightweight or otherwise]
-        # checkout which has merge a revision merged to master already.
-        master = self.make_branch_and_tree('master')
-        self.build_tree(['master/file'])
-        master.add(['file'])
-        master.commit('one', rev_id='m1')
-
-        self.build_tree(['checkout1/'])
-        checkout_dir = bzrdir.BzrDirMetaFormat1().initialize('checkout1')
-        branch.BranchReferenceFormat().initialize(checkout_dir,
-            target_branch=master.branch)
-        checkout1 = checkout_dir.create_workingtree('m1')
-
-        # Create a second branch, with an extra commit
-        other = master.bzrdir.sprout('other').open_workingtree()
-        self.build_tree(['other/file2'])
-        other.add(['file2'])
-        other.commit('other2', rev_id='o2')
-
-        # Merge the other branch into checkout -  'start reviewing a patch'
-        checkout1.merge_from_branch(other.branch)
-        self.assertEqual(['o2'], checkout1.get_parent_ids()[1:])
-
-        # Create a new commit in the master branch - 'someone else lands its'
-        master.merge_from_branch(other.branch)
-        master.commit('f3', rev_id='m2')
-
-        # This should not report about local commits being pending
-        # merges, because they were real merges (but are now gone).
-        # It should perhaps report on them.
-        out, err = self.run_bzr('update', working_dir='checkout1')
-        self.assertEqual('', out)
-        self.assertEqualDiff('''All changes applied successfully.
-Updated to revision 2 of branch %s
-''' % osutils.pathjoin(self.test_dir, 'master',),
-                         err)
-        # The pending merges should still be there
-        self.assertEqual([], checkout1.get_parent_ids()[1:])
-
     def test_update_dash_r(self):
+        # Test that 'bzr update' works correctly when you have
+        # an update in the master tree, and a lightweight checkout
+        # which has merged another branch
         master = self.make_branch_and_tree('master')
         os.chdir('master')
         self.build_tree(['./file1'])
@@ -304,36 +266,31 @@
         self.assertEquals(['m1'], master.get_parent_ids())
 
     def test_update_dash_r_outside_history(self):
-        """Ensure that we can update -r to dotted revisions.
-        """
+        # Test that 'bzr update' works correctly when you have
+        # an update in the master tree, and a lightweight checkout
+        # which has merged another branch
         master = self.make_branch_and_tree('master')
         self.build_tree(['master/file1'])
         master.add(['file1'])
         master.commit('one', rev_id='m1')
 
-        # Create a second branch, with extra commits
+        # Create a second branch, with an extra commit
         other = master.bzrdir.sprout('other').open_workingtree()
-        self.build_tree(['other/file2', 'other/file3'])
+        self.build_tree(['other/file2'])
         other.add(['file2'])
         other.commit('other2', rev_id='o2')
-        other.add(['file3'])
-        other.commit('other3', rev_id='o3')
 
         os.chdir('master')
         self.run_bzr('merge ../other')
         master.commit('merge', rev_id='merge')
 
-        # Switch to o2. file3 was added only in o3 and should be deleted.
-        out, err = self.run_bzr('update -r revid:o2')
-        self.assertContainsRe(err, '-D\s+file3')
-        self.assertContainsRe(err, 'All changes applied successfully\.')
-        self.assertContainsRe(err, 'Updated to revision 1.1.1 of branch .*')
-
-        # Switch back to latest
-        out, err = self.run_bzr('update')
-        self.assertContainsRe(err, '\+N\s+file3')
-        self.assertContainsRe(err, 'All changes applied successfully\.')
-        self.assertContainsRe(err, 'Updated to revision 2 of branch .*')
+        out, err = self.run_bzr('update -r revid:o2',
+                                retcode=3)
+        self.assertEqual('', out)
+        self.assertEqual('bzr: ERROR: branch has no revision o2\n'
+                         'bzr update --revision only works'
+                         ' for a revision in the branch history\n',
+                         err)
 
     def test_update_dash_r_in_master(self):
         # Test that 'bzr update' works correctly when you have
@@ -358,62 +315,3 @@
 2>All changes applied successfully.
 2>Updated to revision 2 of branch .../master
 ''')
-
-    def test_update_checkout_prevent_double_merge(self):
-        """"Launchpad bug 113809 in bzr "update performs two merges"
-        https://launchpad.net/bugs/113809"""
-        master = self.make_branch_and_tree('master')
-        self.build_tree_contents([('master/file', 'initial contents\n')])
-        master.add(['file'])
-        master.commit('one', rev_id='m1')
-
-        checkout = master.branch.create_checkout('checkout')
-        lightweight = checkout.branch.create_checkout('lightweight',
-                                                      lightweight=True)
-
-        # time to create a mess
-        # add a commit to the master
-        self.build_tree_contents([('master/file', 'master\n')])
-        master.commit('two', rev_id='m2')
-        self.build_tree_contents([('master/file', 'master local changes\n')])
-
-        # local commit on the checkout
-        self.build_tree_contents([('checkout/file', 'checkout\n')])
-        checkout.commit('tree', rev_id='c2', local=True)
-        self.build_tree_contents([('checkout/file',
-                                   'checkout local changes\n')])
-
-        # lightweight 
-        self.build_tree_contents([('lightweight/file',
-                                   'lightweight local changes\n')])
-
-        # now update (and get conflicts)
-        out, err = self.run_bzr('update lightweight', retcode=1)
-        self.assertEqual('', out)
-        # NB: these conflicts are actually in the source code
-        self.assertFileEqual('''\
-<<<<<<< TREE
-lightweight local changes
-=======
-checkout
->>>>>>> MERGE-SOURCE
-''',
-                             'lightweight/file')
-
-        # resolve it
-        self.build_tree_contents([('lightweight/file',
-                                   'lightweight+checkout\n')])
-        self.run_bzr('resolve lightweight/file')
-
-        # check we get the second conflict
-        out, err = self.run_bzr('update lightweight', retcode=1)
-        self.assertEqual('', out)
-        # NB: these conflicts are actually in the source code
-        self.assertFileEqual('''\
-<<<<<<< TREE
-lightweight+checkout
-=======
-master
->>>>>>> MERGE-SOURCE
-''',
-                             'lightweight/file')

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2010-04-16 07:56:51 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2009-08-21 02:10:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,17 +15,18 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 """Black box tests for the upgrade ui."""
+
 import os
-import stat
 
 from bzrlib import (
     bzrdir,
     repository,
+    ui,
     )
 from bzrlib.tests import (
-    features,
     TestCaseInTempDir,
     TestCaseWithTransport,
+    TestUIFactory,
     )
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.transport import get_transport
@@ -38,8 +39,14 @@
 
     def setUp(self):
         super(TestWithUpgradableBranches, self).setUp()
-        self.addCleanup(bzrdir.BzrDirFormat._set_default_format,
-                        bzrdir.BzrDirFormat.get_default_format())
+        self.old_format = bzrdir.BzrDirFormat.get_default_format()
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
+        ui.ui_factory = TestUIFactory()
+
+    def restoreDefaults(self):
+        ui.ui_factory = self.old_ui_factory
+        bzrdir.BzrDirFormat._set_default_format(self.old_format)
 
     def make_current_format_branch_and_checkout(self):
         current_tree = self.make_branch_and_tree('current_format_branch',
@@ -104,18 +111,17 @@
         url = get_transport(self.get_url('format_5_branch')).base
         # check --format takes effect
         bzrdir.BzrDirFormat._set_default_format(bzrdir.BzrDirFormat5())
-        backup_dir = 'backup.bzr.~1~'
         (out, err) = self.run_bzr(
             ['upgrade', '--format=metaweave', url])
         self.assertEqualDiff("""starting upgrade of %s
 making backup of %s.bzr
-  to %s%s
+  to %sbackup.bzr
 starting upgrade from format 5 to 6
 adding prefixes to weaves
 adding prefixes to revision-store
 starting upgrade from format 6 to metadir
 finished
-""" % (url, url, url, backup_dir), out)
+""" % (url, url, url), out)
         self.assertEqualDiff("", err)
         self.assertTrue(isinstance(
             bzrdir.BzrDir.open(self.get_url('format_5_branch'))._format,
@@ -128,16 +134,15 @@
         url = get_transport(self.get_url('metadir_weave_branch')).base
         # check --format takes effect
         bzrdir.BzrDirFormat._set_default_format(bzrdir.BzrDirFormat5())
-        backup_dir = 'backup.bzr.~1~'
         (out, err) = self.run_bzr(
             ['upgrade', '--format=knit', url])
         self.assertEqualDiff("""starting upgrade of %s
 making backup of %s.bzr
-  to %s%s
+  to %sbackup.bzr
 starting repository conversion
 repository converted
 finished
-""" % (url, url, url, backup_dir), out)
+""" % (url, url, url), out)
         self.assertEqualDiff("", err)
         converted_dir = bzrdir.BzrDir.open(self.get_url('metadir_weave_branch'))
         self.assertTrue(isinstance(converted_dir._format,
@@ -149,62 +154,33 @@
         self.run_bzr('init-repository --format=metaweave repo')
         self.run_bzr('upgrade --format=knit repo')
 
-    def test_upgrade_permission_check(self):
-        """'backup.bzr' should retain permissions of .bzr. Bug #262450"""
-        self.requireFeature(features.posix_permissions_feature)
-        old_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
-        backup_dir = 'backup.bzr.~1~'
-        self.run_bzr('init --format=1.6')
-        os.chmod('.bzr', old_perms)
-        self.run_bzr('upgrade')
-        new_perms = os.stat(backup_dir).st_mode & 0777
-        self.assertTrue(new_perms == old_perms)
-
-
-    def test_upgrade_with_existing_backup_dir(self):
-        self.make_format_5_branch()
-        transport = get_transport(self.get_url('format_5_branch'))
-        url = transport.base
-        bzrdir.BzrDirFormat._set_default_format(bzrdir.BzrDirFormat5())
-        backup_dir1 = 'backup.bzr.~1~'
-        backup_dir2 = 'backup.bzr.~2~'
-        # explicitly create backup_dir1. bzr should create the .~2~ directory
-        # as backup
-        transport.mkdir(backup_dir1)
-        (out, err) = self.run_bzr(
-            ['upgrade', '--format=metaweave', url])
-        self.assertEqualDiff("""starting upgrade of %s
-making backup of %s.bzr
-  to %s%s
-starting upgrade from format 5 to 6
-adding prefixes to weaves
-adding prefixes to revision-store
-starting upgrade from format 6 to metadir
-finished
-""" % (url, url, url, backup_dir2), out)
-        self.assertEqualDiff("", err)
-        self.assertTrue(isinstance(
-            bzrdir.BzrDir.open(self.get_url('format_5_branch'))._format,
-            bzrdir.BzrDirMetaFormat1))
-        self.assertTrue(transport.has(backup_dir2))
 
 class SFTPTests(TestCaseWithSFTPServer):
     """Tests for upgrade over sftp."""
 
+    def setUp(self):
+        super(SFTPTests, self).setUp()
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
+
+        ui.ui_factory = TestUIFactory()
+
+    def restoreDefaults(self):
+        ui.ui_factory = self.old_ui_factory
+
     def test_upgrade_url(self):
         self.run_bzr('init --format=weave')
         t = get_transport(self.get_url())
         url = t.base
         out, err = self.run_bzr(['upgrade', '--format=knit', url])
-        backup_dir = 'backup.bzr.~1~'
         self.assertEqualDiff("""starting upgrade of %s
 making backup of %s.bzr
-  to %s%s
+  to %sbackup.bzr
 starting upgrade from format 6 to metadir
 starting repository conversion
 repository converted
 finished
-""" % (url, url, url,backup_dir), out)
+""" % (url, url, url), out)
         self.assertEqual('', err)
 
 

=== modified file 'bzrlib/tests/blackbox/test_versioning.py'
--- bzrlib/tests/blackbox/test_versioning.py	2010-03-02 15:49:51 +0000
+++ bzrlib/tests/blackbox/test_versioning.py	2009-08-28 05:00:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,29 +29,16 @@
 from bzrlib.workingtree import WorkingTree
 
 
-class TestMkdir(TestCaseWithTransport):
-
-    def test_mkdir_fails_cleanly(self):
-        """'mkdir' fails cleanly when no working tree is available.
-        https://bugs.edge.launchpad.net/bzr/+bug/138600
-        """
-        # Since there is a safety working tree above us, we create a bare repo
-        # here locally.
-        shared_repo = self.make_repository('.')
-        self.run_bzr(['mkdir', 'abc'], retcode=3)
-        self.failIfExists('abc')
-
-
 class TestVersioning(TestCaseInTempDir):
 
     def test_mkdir(self):
         """Basic 'bzr mkdir' operation"""
 
         self.run_bzr('init')
-        self.run_bzr(['mkdir', 'foo'])
+        self.run_bzr('mkdir foo')
         self.assert_(os.path.isdir('foo'))
 
-        self.run_bzr(['mkdir', 'foo'], retcode=3)
+        self.run_bzr('mkdir foo', retcode=3)
 
         wt = WorkingTree.open('.')
 
@@ -67,12 +54,12 @@
         """'bzr mkdir' operation in subdirectory"""
 
         self.run_bzr('init')
-        self.run_bzr(['mkdir', 'dir'])
+        self.run_bzr('mkdir dir')
         self.assert_(os.path.isdir('dir'))
 
         os.chdir('dir')
         self.log('Run mkdir in subdir')
-        self.run_bzr(['mkdir', 'subdir'])
+        self.run_bzr('mkdir subdir')
         self.assert_(os.path.isdir('subdir'))
         os.chdir('..')
 
@@ -99,7 +86,7 @@
         self.run_bzr('init')
         os.chdir('../..')
 
-        self.run_bzr(['mkdir', 'dir', 'a/dir', 'a/b/dir'])
+        self.run_bzr('mkdir dir a/dir a/b/dir')
         self.failUnless(os.path.isdir('dir'))
         self.failUnless(os.path.isdir('a/dir'))
         self.failUnless(os.path.isdir('a/b/dir'))

=== modified file 'bzrlib/tests/commands/__init__.py'
--- bzrlib/tests/commands/__init__.py	2010-04-15 08:50:40 +0000
+++ bzrlib/tests/commands/__init__.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -41,7 +41,6 @@
         'bzrlib.tests.commands.test_pull',
         'bzrlib.tests.commands.test_push',
         'bzrlib.tests.commands.test_update',
-        'bzrlib.tests.commands.test_revert',
         ]
     # add the tests for the sub modules
     suite.addTests(loader.loadTestsFromModuleNames(testmod_names))

=== modified file 'bzrlib/tests/commands/test_branch.py'
--- bzrlib/tests/commands/test_branch.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_branch.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/commands/test_cat.py'
--- bzrlib/tests/commands/test_cat.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_cat.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,9 +25,15 @@
 
     def setUp(self):
         super(TestCat, self).setUp()
+
+        def restore_stdout():
+            sys.stdout = self._stdout_orig
+
         # Redirect sys.stdout as this is what cat uses
         self.outf = StringIOWrapper()
-        self.overrideAttr(sys, 'stdout', self.outf)
+        self._stdout_orig = sys.stdout
+        sys.stdout = self.outf
+        self.addCleanup(restore_stdout)
 
     def test_cat(self):
         # FIXME: sftp raises ReadError instead of NoSuchFile when probing for

=== modified file 'bzrlib/tests/commands/test_checkout.py'
--- bzrlib/tests/commands/test_checkout.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_checkout.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/commands/test_commit.py'
--- bzrlib/tests/commands/test_commit.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_commit.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -53,7 +53,8 @@
         # commit do not provide a directory parameter, we have to change dir
         # manually
         os.chdir('local')
-        self.assertRaises(errors.BoundBranchOutOfDate, commit.run,
+        # cmd_commit translates BoundBranchOutOfDate into BzrCommandError
+        self.assertRaises(errors.BzrCommandError, commit.run,
                           message=u'empty commit', unchanged=True)
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_init.py'
--- bzrlib/tests/commands/test_init.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_init.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/commands/test_init_repository.py'
--- bzrlib/tests/commands/test_init_repository.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_init_repository.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/commands/test_merge.py'
--- bzrlib/tests/commands/test_merge.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_merge.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,3 +36,4 @@
         cmd.outf = StringIOWrapper()
         cmd.run(self.get_url('branch1'), directory='branch2')
         self.assertEquals(1, len(self.connections))
+

=== modified file 'bzrlib/tests/commands/test_missing.py'
--- bzrlib/tests/commands/test_missing.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_missing.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/commands/test_pull.py'
--- bzrlib/tests/commands/test_pull.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_pull.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/commands/test_push.py'
--- bzrlib/tests/commands/test_push.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_push.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== removed file 'bzrlib/tests/commands/test_revert.py'
--- bzrlib/tests/commands/test_revert.py	2010-04-16 07:56:51 +0000
+++ bzrlib/tests/commands/test_revert.py	1970-01-01 00:00:00 +0000
@@ -1,61 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-import os
-from bzrlib import (
-    branch,
-    builtins,
-    errors,
-    lock,
-    )
-from bzrlib.tests import (
-    transport_util,
-    TestCaseInTempDir,
-    )
-
-
-class TestRevert(TestCaseInTempDir):
-
-    def setUp(self):
-        super(TestRevert, self).setUp()
-
-    def test_revert_tree_write_lock_and_branch_read_lock(self):
-
-        # install lock hooks to find out about cmd_revert's locking actions
-        locks_acquired = []
-        locks_released = []
-        lock.Lock.hooks.install_named_hook('lock_acquired',
-            locks_acquired.append, None)
-        lock.Lock.hooks.install_named_hook('lock_released',
-            locks_released.append, None)
-
-        # execute the revert command (There is nothing to actually revert,
-        # but locks are acquired either way.)
-        revert = builtins.cmd_revert()
-        revert.run()
-
-        # make sure that only one lock is acquired and released.
-        self.assertLength(1, locks_acquired)
-        self.assertLength(1, locks_released)
-
-        # make sure that the nonces are the same, since otherwise
-        # this would not be the same lock.
-        self.assertEqual(locks_acquired[0].details, locks_released[0].details)
-
-        # make sure that the locks are checkout locks.
-        self.assertEndsWith(locks_acquired[0].lock_url, "/checkout/lock")
-        self.assertEndsWith(locks_released[0].lock_url, "/checkout/lock")
-

=== modified file 'bzrlib/tests/commands/test_update.py'
--- bzrlib/tests/commands/test_update.py	2010-04-09 03:58:14 +0000
+++ bzrlib/tests/commands/test_update.py	2009-12-14 15:51:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/features.py'
--- bzrlib/tests/features.py	2010-03-18 06:25:23 +0000
+++ bzrlib/tests/features.py	2009-12-22 15:39:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,50 +14,14 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-import os
-import stat
 
 from bzrlib import tests
 from bzrlib.symbol_versioning import deprecated_in
 
 
 apport = tests.ModuleAvailableFeature('apport')
+ApportFeature = tests._CompatabilityThunkFeature('bzrlib.tests.features',
+    'ApportFeature', 'bzrlib.tests.features.apport', deprecated_in((2,1,0)))
 paramiko = tests.ModuleAvailableFeature('paramiko')
 pycurl = tests.ModuleAvailableFeature('pycurl')
 subunit = tests.ModuleAvailableFeature('subunit')
-
-
-class _PosixPermissionsFeature(tests.Feature):
-
-    def _probe(self):
-        def has_perms():
-            # create temporary file and check if specified perms are maintained.
-            import tempfile
-
-            write_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
-            f = tempfile.mkstemp(prefix='bzr_perms_chk_')
-            fd, name = f
-            os.close(fd)
-            os.chmod(name, write_perms)
-
-            read_perms = os.stat(name).st_mode & 0777
-            os.unlink(name)
-            return (write_perms == read_perms)
-
-        return (os.name == 'posix') and has_perms()
-
-    def feature_name(self):
-        return 'POSIX permissions support'
-
-
-posix_permissions_feature = _PosixPermissionsFeature()
-
-
-class _ChownFeature(tests.Feature):
-    """os.chown is supported"""
-
-    def _probe(self):
-        return os.name == 'posix' and hasattr(os, 'chown')
-
-chown_feature = _ChownFeature()
-

=== modified file 'bzrlib/tests/ftp_server/__init__.py'
--- bzrlib/tests/ftp_server/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/ftp_server/__init__.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/ftp_server/medusa_based.py'
--- bzrlib/tests/ftp_server/medusa_based.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/ftp_server/medusa_based.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,8 +33,8 @@
 from bzrlib import (
     tests,
     trace,
+    transport,
     )
-from bzrlib.tests import test_server
 
 
 class test_filesystem(medusa.filesys.os_filesystem):
@@ -210,11 +210,9 @@
         trace.mutter('ftp_server %s: %s', type, message)
 
 
-class FTPTestServer(test_server.TestServer):
+class FTPTestServer(transport.Server):
     """Common code for FTP server facilities."""
 
-    no_unicode_support = True
-
     def __init__(self):
         self._root = None
         self._ftp_server = None
@@ -236,8 +234,8 @@
         self.logs.append(message)
 
     def start_server(self, vfs_server=None):
-        if not (vfs_server is None or isinstance(vfs_server,
-                                                 test_server.LocalURLServer)):
+        from bzrlib.transport.local import LocalURLServer
+        if not (vfs_server is None or isinstance(vfs_server, LocalURLServer)):
             raise AssertionError(
                 "FTPServer currently assumes local transport, got %s" % vfs_server)
         self._root = os.getcwdu()

=== modified file 'bzrlib/tests/ftp_server/pyftpdlib_based.py'
--- bzrlib/tests/ftp_server/pyftpdlib_based.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/ftp_server/pyftpdlib_based.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,8 +29,8 @@
 from bzrlib import (
     osutils,
     trace,
+    transport,
     )
-from bzrlib.tests import test_server
 
 
 class AnonymousWithWriteAccessAuthorizer(ftpserver.DummyAuthorizer):
@@ -50,15 +50,14 @@
 
     def listdir(self, path):
         """List the content of a directory."""
+        # FIXME: need tests with unicode paths
         return [osutils.safe_utf8(s) for s in os.listdir(path)]
 
     def fs2ftp(self, fspath):
-        p = ftpserver.AbstractedFS.fs2ftp(self, osutils.safe_unicode(fspath))
+        p = ftpserver.AbstractedFS.fs2ftp(self, fspath)
+        # FIXME: need tests with unicode paths
         return osutils.safe_utf8(p)
 
-    def ftp2fs(self, ftppath):
-        p = osutils.safe_unicode(ftppath)
-        return ftpserver.AbstractedFS.ftp2fs(self, p)
 
 class BzrConformingFTPHandler(ftpserver.FTPHandler):
 
@@ -133,7 +132,7 @@
         self.addr = self.socket.getsockname()
 
 
-class FTPTestServer(test_server.TestServer):
+class FTPTestServer(transport.Server):
     """Common code for FTP server facilities."""
 
     def __init__(self):
@@ -158,8 +157,8 @@
         self.logs.append(message)
 
     def start_server(self, vfs_server=None):
-        if not (vfs_server is None or isinstance(vfs_server,
-                                                 test_server.LocalURLServer)):
+        from bzrlib.transport.local import LocalURLServer
+        if not (vfs_server is None or isinstance(vfs_server, LocalURLServer)):
             raise AssertionError(
                 "FTPServer currently assumes local transport, got %s"
                 % vfs_server)

=== modified file 'bzrlib/tests/http_server.py'
--- bzrlib/tests/http_server.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/http_server.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,7 +31,6 @@
 import urlparse
 
 from bzrlib import transport
-from bzrlib.tests import test_server
 from bzrlib.transport import local
 
 
@@ -531,9 +530,8 @@
         """
         # XXX: TODO: make the server back onto vfs_server rather than local
         # disk.
-        if not (backing_transport_server is None
-                or isinstance(backing_transport_server,
-                              test_server.LocalURLServer)):
+        if not (backing_transport_server is None or \
+                isinstance(backing_transport_server, local.LocalURLServer)):
             raise AssertionError(
                 "HTTPServer currently assumes local transport, got %s" % \
                 backing_transport_server)

=== modified file 'bzrlib/tests/http_utils.py'
--- bzrlib/tests/http_utils.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/http_utils.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== removed file 'bzrlib/tests/matchers.py'
--- bzrlib/tests/matchers.py	2010-05-06 11:08:10 +0000
+++ bzrlib/tests/matchers.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Matchers for bzrlib.
-
-Primarily test support, Matchers are used by self.assertThat in the bzrlib
-test suite. A matcher is a stateful test helper which can be used to determine
-if a passed object 'matches', much like a regex. If the object does not match
-the mismatch can be described in a human readable fashion. assertThat then
-raises if a mismatch occurs, showing the description as the assertion error.
-
-Matchers are designed to be more reusable and composable than layered
-assertions in Test Case objects, so they are recommended for new testing work.
-"""
-
-__all__ = [
-    'ReturnsUnlockable',
-    ]
-
-from testtools.matchers import Mismatch, Matcher
-
-
-class ReturnsUnlockable(Matcher):
-    """A matcher that checks for the pattern we want lock* methods to have:
-
-    They should return an object with an unlock() method.
-    Calling that method should unlock the original object.
-
-    :ivar lockable_thing: The object which can be locked that will be
-        inspected.
-    """
-
-    def __init__(self, lockable_thing):
-        Matcher.__init__(self)
-        self.lockable_thing = lockable_thing
-
-    def __str__(self):
-        return ('ReturnsUnlockable(lockable_thing=%s)' % 
-            self.lockable_thing)
-
-    def match(self, lock_method):
-        lock_method().unlock()
-        if self.lockable_thing.is_locked():
-            return _IsLocked(self.lockable_thing)
-        return None
-
-
-class _IsLocked(Mismatch):
-    """Something is locked."""
-
-    def __init__(self, lockable_thing):
-        self.lockable_thing = lockable_thing
-
-    def describe(self):
-        return "%s is locked" % self.lockable_thing

=== modified file 'bzrlib/tests/per_branch/__init__.py'
--- bzrlib/tests/per_branch/__init__.py	2010-04-01 12:53:53 +0000
+++ bzrlib/tests/per_branch/__init__.py	2009-08-17 06:17:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 # Authors: Robert Collins <robert.collins@canonical.com>
 #          and others
 #
@@ -32,9 +32,14 @@
                            _legacy_formats,
                            )
 from bzrlib.remote import RemoteBranchFormat, RemoteBzrDirFormat
-from bzrlib.tests import test_server
+from bzrlib.smart.server import (
+    ReadonlySmartTCPServer_for_testing,
+    ReadonlySmartTCPServer_for_testing_v2_only,
+    SmartTCPServer_for_testing,
+    SmartTCPServer_for_testing_v2_only,
+    )
 from bzrlib.tests.per_bzrdir.test_bzrdir import TestCaseWithBzrDir
-from bzrlib.transport import memory
+from bzrlib.transport.memory import MemoryServer
 
 
 def make_scenarios(transport_server, transport_readonly_server,
@@ -61,7 +66,7 @@
 
 
 class TestCaseWithBranch(TestCaseWithBzrDir):
-    """This helper will be parameterised in each per_branch test."""
+    """This helper will be parameterised in each branch_implementation test."""
 
     def setUp(self):
         super(TestCaseWithBranch, self).setUp()
@@ -143,18 +148,18 @@
     # Add RemoteBranch tests, which need a special server.
     remote_branch_format = RemoteBranchFormat()
     scenarios.extend(make_scenarios(
-        test_server.SmartTCPServer_for_testing,
-        test_server.ReadonlySmartTCPServer_for_testing,
+        SmartTCPServer_for_testing,
+        ReadonlySmartTCPServer_for_testing,
         [(remote_branch_format, remote_branch_format._matchingbzrdir)],
-        memory.MemoryServer,
+        MemoryServer,
         name_suffix='-default'))
     # Also add tests for RemoteBranch with HPSS protocol v2 (i.e. bzr <1.6)
     # server.
     scenarios.extend(make_scenarios(
-        test_server.SmartTCPServer_for_testing_v2_only,
-        test_server.ReadonlySmartTCPServer_for_testing_v2_only,
+        SmartTCPServer_for_testing_v2_only,
+        ReadonlySmartTCPServer_for_testing_v2_only,
         [(remote_branch_format, remote_branch_format._matchingbzrdir)],
-        memory.MemoryServer,
+        MemoryServer,
         name_suffix='-v2'))
     return scenarios
 

=== modified file 'bzrlib/tests/per_branch/test_bound_sftp.py'
--- bzrlib/tests/per_branch/test_bound_sftp.py	2010-02-11 09:27:55 +0000
+++ bzrlib/tests/per_branch/test_bound_sftp.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Robey Pointer <robey@lag.net>, Canonical Ltd
+# Copyright (C) 2005 Robey Pointer <robey@lag.net>, Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,32 +19,39 @@
 
 import os
 
+import bzrlib
 from bzrlib import (
-    branch,
     bzrdir,
-    errors,
-    tests,
     )
-from bzrlib.tests import test_server
-from bzrlib.transport import memory
-
-
-class BoundSFTPBranch(tests.TestCaseWithTransport):
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import (BzrDir,
+                           BzrDirFormat,
+                           BzrDirFormat6,
+                           BzrDirMetaFormat1,
+                           )
+import bzrlib.errors as errors
+from bzrlib.tests import TestSkipped
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.transport.local import LocalURLServer
+from bzrlib.transport.memory import MemoryServer
+
+
+class BoundSFTPBranch(TestCaseWithTransport):
 
     def setUp(self):
-        tests.TestCaseWithTransport.setUp(self)
-        self.vfs_transport_factory = memory.MemoryServer
-        if self.transport_server is test_server.LocalURLServer:
+        TestCaseWithTransport.setUp(self)
+        self.vfs_transport_factory = MemoryServer
+        if self.transport_server is LocalURLServer:
             self.transport_server = None
 
     def create_branches(self):
         self.build_tree(['base/', 'base/a', 'base/b'])
         format = bzrdir.format_registry.make_bzrdir('knit')
         try:
-            wt_base = bzrdir.BzrDir.create_standalone_workingtree(
+            wt_base = BzrDir.create_standalone_workingtree(
                 self.get_url('base'), format=format)
         except errors.NotLocalUrl:
-            raise tests.TestSkipped('Not a local URL')
+            raise TestSkipped('Not a local URL')
 
         b_base = wt_base.branch
 
@@ -53,7 +60,7 @@
         wt_base.commit('first', rev_id='r@b-1')
 
         wt_child = b_base.bzrdir.sprout('child').open_workingtree()
-        self.sftp_base = branch.Branch.open(self.get_url('base'))
+        self.sftp_base = Branch.open(self.get_url('base'))
         wt_child.branch.bind(self.sftp_base)
         # check the branch histories are ready for using in tests.
         self.assertEqual(['r@b-1'], b_base.revision_history())
@@ -63,10 +70,9 @@
     def test_simple_binding(self):
         self.build_tree(['base/', 'base/a', 'base/b', 'child/'])
         try:
-            wt_base = bzrdir.BzrDir.create_standalone_workingtree(
-                self.get_url('base'))
+            wt_base = BzrDir.create_standalone_workingtree(self.get_url('base'))
         except errors.NotLocalUrl:
-            raise tests.TestSkipped('Not a local URL')
+            raise TestSkipped('Not a local URL')
 
         wt_base.add('a')
         wt_base.add('b')
@@ -77,12 +83,11 @@
         # may not be bindable-from, and we want to test the side effects etc
         # of bondage.
         format = bzrdir.format_registry.make_bzrdir('knit')
-        b_child = bzrdir.BzrDir.create_branch_convenience(
-            'child', format=format)
+        b_child = BzrDir.create_branch_convenience('child', format=format)
         self.assertEqual(None, b_child.get_bound_location())
         self.assertEqual(None, b_child.get_master_branch())
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
+        sftp_b_base = Branch.open(self.get_url('base'))
         b_child.bind(sftp_b_base)
         self.assertEqual(sftp_b_base.base, b_child.get_bound_location())
         # the bind must not have given b_child history:
@@ -120,7 +125,7 @@
         self.assertRaises(errors.BoundBranchOutOfDate,
                 wt_child.commit, 'child', rev_id='r@c-2')
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
+        sftp_b_base = Branch.open(self.get_url('base'))
 
         # This is all that cmd_update does
         wt_child.pull(sftp_b_base, overwrite=False)
@@ -165,7 +170,7 @@
         self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
         self.assertEqual(['r@b-1', 'r@b-2'], b_base.revision_history())
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
+        sftp_b_base = Branch.open(self.get_url('base'))
         self.assertRaises(errors.DivergedBranches,
                 wt_child.branch.bind, sftp_b_base)
 
@@ -176,8 +181,8 @@
 
         b_base.bzrdir.sprout('newbase')
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
-        sftp_b_newbase = branch.Branch.open(self.get_url('newbase'))
+        sftp_b_base = Branch.open(self.get_url('base'))
+        sftp_b_newbase = Branch.open(self.get_url('newbase'))
 
         sftp_b_base.bind(sftp_b_newbase)
 
@@ -203,7 +208,7 @@
         b_base.bzrdir.open_workingtree().commit('base', rev_id='r@b-2')
         self.assertEqual(['r@b-1', 'r@b-2'], b_base.revision_history())
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
+        sftp_b_base = Branch.open(self.get_url('base'))
 
         self.assertRaises(errors.DivergedBranches,
                 wt_child.branch.bind, sftp_b_base)
@@ -231,7 +236,7 @@
         self.assertEqual(['r@b-1', 'r@b-2'], b_base.revision_history())
         self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
+        sftp_b_base = Branch.open(self.get_url('base'))
         wt_child.branch.bind(sftp_b_base)
 
         self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
@@ -260,7 +265,7 @@
         self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
         self.assertEqual(['r@b-1'], b_base.revision_history())
 
-        sftp_b_base = branch.Branch.open(self.get_url('base'))
+        sftp_b_base = Branch.open(self.get_url('base'))
         wt_child.branch.bind(sftp_b_base)
 
         self.assertEqual(['r@b-1'], b_base.revision_history())

=== modified file 'bzrlib/tests/per_branch/test_branch.py'
--- bzrlib/tests/per_branch/test_branch.py	2010-04-21 04:12:25 +0000
+++ bzrlib/tests/per_branch/test_branch.py	2009-08-20 04:09:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,31 +16,43 @@
 
 """Tests for branch implementations - tests a branch format."""
 
+import os
+import sys
+
 from bzrlib import (
-    branch as _mod_branch,
+    branch,
     bzrdir,
-    delta as _mod_delta,
     errors,
     gpg,
     merge,
     urlutils,
     transactions,
-    transport,
     remote,
     repository,
-    revision,
     tests,
     )
+from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.delta import TreeDelta
+from bzrlib.errors import (FileExists,
+                           NoSuchRevision,
+                           NoSuchFile,
+                           UninitializableFormat,
+                           NotBranchError,
+                           )
+from bzrlib.osutils import getcwd
+import bzrlib.revision
 from bzrlib.symbol_versioning import deprecated_in
-from bzrlib.tests import (
-    http_server,
-    per_branch,
-    )
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 from bzrlib.tests.http_server import HttpServer
-from bzrlib.transport import memory
-
-
-class TestTestCaseWithBranch(per_branch.TestCaseWithBranch):
+from bzrlib.tests.per_branch import TestCaseWithBranch
+from bzrlib.trace import mutter
+from bzrlib.transport import get_transport
+from bzrlib.transport.memory import MemoryServer
+from bzrlib.upgrade import upgrade
+from bzrlib.workingtree import WorkingTree
+
+
+class TestTestCaseWithBranch(TestCaseWithBranch):
 
     def test_branch_format_matches_bzrdir_branch_format(self):
         bzrdir_branch_format = self.bzrdir_format.get_branch_format()
@@ -53,7 +65,7 @@
             branch._format.__class__)
 
 
-class TestBranch(per_branch.TestCaseWithBranch):
+class TestBranch(TestCaseWithBranch):
 
     def test_create_tree_with_merge(self):
         tree = self.create_tree_with_merge()
@@ -116,10 +128,10 @@
         tree_a.commit('rev2', rev_id='rev2')
 
         delta = tree_a.branch.get_revision_delta(1)
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([('foo', 'file1', 'file')], delta.added)
         delta = tree_a.branch.get_revision_delta(2)
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([('vla', 'file2', 'file')], delta.added)
 
     def get_unbalanced_tree_pair(self):
@@ -174,7 +186,7 @@
 
     def test_clone_branch_nickname(self):
         # test the nick name is preserved always
-        raise tests.TestSkipped('XXX branch cloning is not yet tested.')
+        raise TestSkipped('XXX branch cloning is not yet tested.')
 
     def test_clone_branch_parent(self):
         # test the parent is preserved always
@@ -346,14 +358,14 @@
         explicit nickname is set.  That is, an explicit nickname always
         overrides the implicit one.
         """
-        t = transport.get_transport(self.get_url())
+        t = get_transport(self.get_url())
         branch = self.make_branch('bzr.dev')
         # The nick will be 'bzr.dev', because there is no explicit nick set.
         self.assertEqual(branch.nick, 'bzr.dev')
         # Move the branch to a different directory, 'bzr.ab'.  Now that branch
         # will report its nick as 'bzr.ab'.
         t.move('bzr.dev', 'bzr.ab')
-        branch = _mod_branch.Branch.open(self.get_url('bzr.ab'))
+        branch = Branch.open(self.get_url('bzr.ab'))
         self.assertEqual(branch.nick, 'bzr.ab')
         # Set the branch nick explicitly.  This will ensure there's a branch
         # config file in the branch.
@@ -364,7 +376,7 @@
         # "Aaron's branch", regardless of directory name.
         self.assertEqual(branch.nick, "Aaron's branch")
         t.move('bzr.ab', 'integration')
-        branch = _mod_branch.Branch.open(self.get_url('integration'))
+        branch = Branch.open(self.get_url('integration'))
         self.assertEqual(branch.nick, "Aaron's branch")
         branch.nick = u"\u1234"
         self.assertEqual(branch.nick, u"\u1234")
@@ -379,23 +391,6 @@
         self.assertEqual(committed.properties["branch-nick"],
                          "My happy branch")
 
-    def test_create_colocated(self):
-        try:
-            repo = self.make_repository('.', shared=True)
-        except errors.IncompatibleFormat:
-            return
-        self.assertEquals(0, len(repo.bzrdir.list_branches()))
-        try:
-            child_branch1 = self.branch_format.initialize(repo.bzrdir, 
-                name='branch1')
-        except (errors.UninitializableFormat, errors.NoColocatedBranchSupport):
-            # branch references are not default init'able and
-            # not all bzrdirs support colocated branches.
-            return
-        self.assertEquals(1, len(repo.bzrdir.list_branches()))
-        self.branch_format.initialize(repo.bzrdir, name='branch2')
-        self.assertEquals(2, len(repo.bzrdir.list_branches()))
-
     def test_create_open_branch_uses_repository(self):
         try:
             repo = self.make_repository('.', shared=True)
@@ -411,7 +406,7 @@
             return
         self.assertEqual(repo.bzrdir.root_transport.base,
                          child_branch.repository.bzrdir.root_transport.base)
-        child_branch = _mod_branch.Branch.open(self.get_url('child'))
+        child_branch = branch.Branch.open(self.get_url('child'))
         self.assertEqual(repo.bzrdir.root_transport.base,
                          child_branch.repository.bzrdir.root_transport.base)
 
@@ -440,7 +435,7 @@
     def test_generate_revision_history_NULL_REVISION(self):
         tree = self.make_branch_and_tree('.')
         rev1 = tree.commit('foo')
-        tree.branch.generate_revision_history(revision.NULL_REVISION)
+        tree.branch.generate_revision_history(bzrlib.revision.NULL_REVISION)
         self.assertEqual([], tree.branch.revision_history())
 
     def test_create_checkout(self):
@@ -458,8 +453,10 @@
         self.assertEqual('rev2', branch_a.last_revision())
         self.assertEqual(checkout_c.branch.base, branch_a.base)
 
+        os.mkdir('d')
         checkout_d = branch_a.create_checkout('d', lightweight=True)
         self.assertEqual('rev2', checkout_d.last_revision())
+        os.mkdir('e')
         checkout_e = branch_a.create_checkout('e')
         self.assertEqual('rev2', checkout_e.last_revision())
 
@@ -468,7 +465,7 @@
         tree_a = self.make_branch_and_tree('a')
         rev_id = tree_a.commit('put some content in the branch')
         # open the branch via a readonly transport
-        source_branch = _mod_branch.Branch.open(self.get_readonly_url('a'))
+        source_branch = bzrlib.branch.Branch.open(self.get_readonly_url('a'))
         # sanity check that the test will be valid
         self.assertRaises((errors.LockError, errors.TransportNotPossible),
             source_branch.lock_write)
@@ -480,7 +477,7 @@
         tree_a = self.make_branch_and_tree('a')
         rev_id = tree_a.commit('put some content in the branch')
         # open the branch via a readonly transport
-        source_branch = _mod_branch.Branch.open(self.get_readonly_url('a'))
+        source_branch = bzrlib.branch.Branch.open(self.get_readonly_url('a'))
         # sanity check that the test will be valid
         self.assertRaises((errors.LockError, errors.TransportNotPossible),
             source_branch.lock_write)
@@ -497,7 +494,7 @@
         self.assertEquals(br.revision_history(), [])
 
 
-class TestBranchFormat(per_branch.TestCaseWithBranch):
+class TestBranchFormat(TestCaseWithBranch):
 
     def test_branch_format_network_name(self):
         br = self.make_branch('.')
@@ -514,12 +511,12 @@
             real_branch = br._real_branch
             self.assertEqual(real_branch._format.network_name(), network_name)
         else:
-            registry = _mod_branch.network_format_registry
+            registry = branch.network_format_registry
             looked_up_format = registry.get(network_name)
             self.assertEqual(format.__class__, looked_up_format.__class__)
 
 
-class ChrootedTests(per_branch.TestCaseWithBranch):
+class ChrootedTests(TestCaseWithBranch):
     """A support class that provides readonly urls outside the local namespace.
 
     This is done by checking if self.transport_server is a MemoryServer. if it
@@ -529,22 +526,18 @@
 
     def setUp(self):
         super(ChrootedTests, self).setUp()
-        if not self.vfs_transport_factory == memory.MemoryServer:
+        if not self.vfs_transport_factory == MemoryServer:
             self.transport_readonly_server = HttpServer
 
     def test_open_containing(self):
-        self.assertRaises(errors.NotBranchError,
-                          _mod_branch.Branch.open_containing,
+        self.assertRaises(NotBranchError, Branch.open_containing,
                           self.get_readonly_url(''))
-        self.assertRaises(errors.NotBranchError,
-                          _mod_branch.Branch.open_containing,
+        self.assertRaises(NotBranchError, Branch.open_containing,
                           self.get_readonly_url('g/p/q'))
         branch = self.make_branch('.')
-        branch, relpath = _mod_branch.Branch.open_containing(
-            self.get_readonly_url(''))
+        branch, relpath = Branch.open_containing(self.get_readonly_url(''))
         self.assertEqual('', relpath)
-        branch, relpath = _mod_branch.Branch.open_containing(
-            self.get_readonly_url('g/p/q'))
+        branch, relpath = Branch.open_containing(self.get_readonly_url('g/p/q'))
         self.assertEqual('g/p/q', relpath)
 
 
@@ -571,24 +564,24 @@
     def unlock(self):
         self._calls.append('ul')
 
-    @_mod_branch.needs_read_lock
+    @needs_read_lock
     def do_with_read(self):
         return 1
 
-    @_mod_branch.needs_read_lock
+    @needs_read_lock
     def except_with_read(self):
         raise RuntimeError
 
-    @_mod_branch.needs_write_lock
+    @needs_write_lock
     def do_with_write(self):
         return 2
 
-    @_mod_branch.needs_write_lock
+    @needs_write_lock
     def except_with_write(self):
         raise RuntimeError
 
 
-class TestDecorators(tests.TestCase):
+class TestDecorators(TestCase):
 
     def test_needs_read_lock(self):
         branch = TestDecorator()
@@ -611,7 +604,7 @@
         self.assertEqual(['lw', 'ul'], branch._calls)
 
 
-class TestBranchPushLocations(per_branch.TestCaseWithBranch):
+class TestBranchPushLocations(TestCaseWithBranch):
 
     def test_get_push_location_unset(self):
         self.assertEqual(None, self.get_branch().get_push_location())
@@ -632,7 +625,7 @@
         self.assertEqual('foo', branch.get_push_location())
 
 
-class TestChildSubmitFormats(per_branch.TestCaseWithBranch):
+class TestChildSubmitFormats(TestCaseWithBranch):
 
     def test_get_child_submit_format_default(self):
         self.assertEqual(None, self.get_branch().get_child_submit_format())
@@ -644,7 +637,7 @@
         self.assertEqual('10', branch.get_child_submit_format())
 
 
-class TestFormat(per_branch.TestCaseWithBranch):
+class TestFormat(TestCaseWithBranch):
     """Tests for the format itself."""
 
     def test_get_reference(self):
@@ -684,10 +677,10 @@
             # they may not be initializable.
             return
         # supported formats must be able to init and open
-        t = transport.get_transport(self.get_url())
-        readonly_t = transport.get_transport(self.get_readonly_url())
+        t = get_transport(self.get_url())
+        readonly_t = get_transport(self.get_readonly_url())
         made_branch = self.make_branch('.')
-        self.failUnless(isinstance(made_branch, _mod_branch.Branch))
+        self.failUnless(isinstance(made_branch, branch.Branch))
 
         # find it via bzrdir opening:
         opened_control = bzrdir.BzrDir.open(readonly_t.base)
@@ -698,7 +691,7 @@
                         self.branch_format.__class__))
 
         # find it via Branch.open
-        opened_branch = _mod_branch.Branch.open(readonly_t.base)
+        opened_branch = branch.Branch.open(readonly_t.base)
         self.failUnless(isinstance(opened_branch, made_branch.__class__))
         self.assertEqual(made_branch._format.__class__,
                          opened_branch._format.__class__)
@@ -711,7 +704,7 @@
                          opened_control.find_branch_format())
 
 
-class TestBound(per_branch.TestCaseWithBranch):
+class TestBound(TestCaseWithBranch):
 
     def test_bind_unbind(self):
         branch = self.make_branch('1')
@@ -749,14 +742,14 @@
             raise tests.TestNotApplicable('Format does not support binding')
 
 
-class TestStrict(per_branch.TestCaseWithBranch):
+class TestStrict(TestCaseWithBranch):
 
     def test_strict_history(self):
         tree1 = self.make_branch_and_tree('tree1')
         try:
             tree1.branch.set_append_revisions_only(True)
         except errors.UpgradeRequired:
-            raise tests.TestSkipped('Format does not support strict history')
+            raise TestSkipped('Format does not support strict history')
         tree1.commit('empty commit')
         tree2 = tree1.bzrdir.sprout('tree2').open_workingtree()
         tree2.commit('empty commit 2')
@@ -774,7 +767,7 @@
         tree2.pull(tree3.branch)
 
 
-class TestIgnoreFallbacksParameter(per_branch.TestCaseWithBranch):
+class TestIgnoreFallbacksParameter(TestCaseWithBranch):
 
     def make_branch_with_fallback(self):
         fallback = self.make_branch('fallback')
@@ -796,7 +789,7 @@
         self.assertLength(1, reopened.repository._fallback_repositories)
 
 
-class TestReferenceLocation(per_branch.TestCaseWithBranch):
+class TestReferenceLocation(TestCaseWithBranch):
 
     def test_reference_parent(self):
         tree = self.make_branch_and_tree('tree')
@@ -804,7 +797,7 @@
         subtree.set_root_id('subtree-id')
         try:
             tree.add_reference(subtree)
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Tree cannot hold references.')
         reference_parent = tree.branch.reference_parent('subtree-id',
                                                         'subtree')
@@ -816,7 +809,7 @@
         subtree.set_root_id('subtree-id')
         try:
             tree.add_reference(subtree)
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Tree cannot hold references.')
         reference_parent = tree.branch.reference_parent('subtree-id',
             'subtree', possible_transports=[subtree.bzrdir.root_transport])
@@ -825,7 +818,7 @@
         branch = self.make_branch('branch')
         try:
             path, loc = branch.get_reference_info('file-id')
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         self.assertIs(None, path)
         self.assertIs(None, loc)
@@ -835,7 +828,7 @@
         try:
             branch.set_reference_info('file-id', 'path/to/location',
                                       'path/to/file')
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
 
     def test_set_get_reference_info(self):
@@ -843,10 +836,10 @@
         try:
             branch.set_reference_info('file-id', 'path/to/file',
                                       'path/to/location')
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         # Create a new instance to ensure storage is permanent
-        branch = _mod_branch.Branch.open('branch')
+        branch = Branch.open('branch')
         tree_path, branch_location = branch.get_reference_info('file-id')
         self.assertEqual('path/to/location', branch_location)
 
@@ -855,7 +848,7 @@
         try:
             branch.set_reference_info('file-id', 'path/to/file',
                                       'path/to/location')
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         branch.set_reference_info('file-id', None, None)
         tree_path, branch_location = branch.get_reference_info('file-id')
@@ -866,7 +859,7 @@
         branch = self.make_branch('branch')
         try:
             tree_path, branch_location = branch.get_reference_info('file-id')
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         self.assertIs(None, tree_path)
         self.assertIs(None, branch_location)
@@ -877,7 +870,7 @@
         try:
             e = self.assertRaises(ValueError, branch.set_reference_info,
                                   'file-id', 'path', None)
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         self.assertEqual('tree_path must be None when branch_location is'
                          ' None.', str(e))
@@ -892,7 +885,7 @@
         try:
             branch.set_reference_info(file_id, 'path/to/file',
                                       reference_location)
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         return branch
 
@@ -908,7 +901,7 @@
         try:
             branch.set_reference_info('file-id', 'path/to/file',
             '../reference_branch')
-        except errors.UnsupportedOperation:
+        except bzrlib.errors.UnsupportedOperation:
             raise tests.TestNotApplicable('Branch cannot hold references.')
         referenced_branch = self.make_branch('reference_branch')
         parent = branch.reference_parent('file-id', 'path/to/file')
@@ -988,16 +981,3 @@
         merger.do_merge()
         self.assertEqual('../branch/reference',
                          tree.branch.get_reference_info('file-id')[1])
-
-
-class TestBranchControlComponent(per_branch.TestCaseWithBranch):
-    """Branch implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        br = self.make_branch('branch')
-        self.assertIsInstance(br.user_url, str)
-        self.assertEqual(br.user_url, br.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(br.control_url.find(br.user_url), 0)
-        self.assertEqual(br.control_url, br.control_transport.base)

=== modified file 'bzrlib/tests/per_branch/test_break_lock.py'
--- bzrlib/tests/per_branch/test_break_lock.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_break_lock.py	2009-07-17 10:38:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,20 +16,31 @@
 
 """Tests for branch break-lock behaviour."""
 
-from  bzrlib import (
-    errors,
-    ui,
-    tests,
+from cStringIO import StringIO
+
+import bzrlib
+import bzrlib.errors as errors
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestNotApplicable
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+from bzrlib.ui import (
+    CannedInputUIFactory,
     )
-from bzrlib.tests import per_branch
-
-
-class TestBreakLock(per_branch.TestCaseWithBranch):
+
+
+class TestBreakLock(TestCaseWithBranch):
 
     def setUp(self):
         super(TestBreakLock, self).setUp()
         self.unused_branch = self.make_branch('branch')
         self.branch = self.unused_branch.bzrdir.open_branch()
+        # we want a UI factory that accepts canned input for the tests:
+        # while SilentUIFactory still accepts stdin, we need to customise
+        # ours
+        self.old_factory = bzrlib.ui.ui_factory
+        self.addCleanup(self.restoreFactory)
+
+    def restoreFactory(self):
+        bzrlib.ui.ui_factory = self.old_factory
 
     def test_unlocked(self):
         # break lock when nothing is locked should just return
@@ -44,15 +55,13 @@
         token = self.branch.repository.lock_write()
         if token is None:
             self.branch.repository.unlock()
-            raise tests.TestNotApplicable(
-                'Repository does not use physical locks.')
+            raise TestNotApplicable('Repository does not use physical locks.')
         self.branch.repository.leave_lock_in_place()
         self.branch.repository.unlock()
         other_instance = self.branch.repository.bzrdir.open_repository()
         if not other_instance.get_physical_lock_status():
-            raise tests.TestNotApplicable(
-                'Repository does not lock persistently.')
-        ui.ui_factory = ui.CannedInputUIFactory([True])
+            raise TestNotApplicable("Repository does not lock persistently.")
+        bzrlib.ui.ui_factory = CannedInputUIFactory([True])
         try:
             self.unused_branch.break_lock()
         except NotImplementedError:
@@ -64,7 +73,7 @@
     def test_locked(self):
         # break_lock when locked should unlock the branch and repo
         self.branch.lock_write()
-        ui.ui_factory = ui.CannedInputUIFactory([True, True])
+        bzrlib.ui.ui_factory = CannedInputUIFactory([True, True])
         try:
             self.unused_branch.break_lock()
         except NotImplementedError:
@@ -83,7 +92,7 @@
             # this branch does not support binding.
             return
         master.lock_write()
-        ui.ui_factory = ui.CannedInputUIFactory([True, True])
+        bzrlib.ui.ui_factory = CannedInputUIFactory([True, True])
         try:
             self.unused_branch.break_lock()
         except NotImplementedError:

=== modified file 'bzrlib/tests/per_branch/test_commit.py'
--- bzrlib/tests/per_branch/test_commit.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_commit.py	2009-07-10 05:49:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,21 +16,19 @@
 
 """Tests for the contract of commit on branches."""
 
-from bzrlib import (
-    branch,
-    delta,
-    errors,
-    revision,
-    transport,
-    )
-from bzrlib.tests import per_branch
-
-
-class TestCommit(per_branch.TestCaseWithBranch):
+from bzrlib.branch import Branch
+from bzrlib import errors
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+from bzrlib.revision import NULL_REVISION
+from bzrlib.transport import get_transport
+from bzrlib.delta import TreeDelta
+
+
+class TestCommit(TestCaseWithBranch):
 
     def test_commit_nicks(self):
         """Nicknames are committed to the revision"""
-        transport.get_transport(self.get_url()).mkdir('bzr.dev')
+        get_transport(self.get_url()).mkdir('bzr.dev')
         wt = self.make_branch_and_tree('bzr.dev')
         branch = wt.branch
         branch.nick = "My happy branch"
@@ -40,11 +38,11 @@
                          "My happy branch")
 
 
-class TestCommitHook(per_branch.TestCaseWithBranch):
+class TestCommitHook(TestCaseWithBranch):
 
     def setUp(self):
         self.hook_calls = []
-        super(TestCommitHook, self).setUp()
+        TestCaseWithBranch.setUp(self)
 
     def capture_post_commit_hook(self, local, master, old_revno,
         old_revid, new_revno, new_revid):
@@ -70,16 +68,16 @@
 
     def test_post_commit_to_origin(self):
         tree = self.make_branch_and_memory_tree('branch')
-        branch.Branch.hooks.install_named_hook(
-            'post_commit', self.capture_post_commit_hook, None)
+        Branch.hooks.install_named_hook('post_commit',
+            self.capture_post_commit_hook, None)
         tree.lock_write()
         tree.add('')
         revid = tree.commit('a revision')
         # should have had one notification, from origin, and
         # have the branch locked at notification time.
         self.assertEqual([
-            ('post_commit', None, tree.branch.base, 0, revision.NULL_REVISION,
-             1, revid, None, True)
+            ('post_commit', None, tree.branch.base, 0, NULL_REVISION, 1, revid,
+             None, True)
             ],
             self.hook_calls)
         tree.unlock()
@@ -92,15 +90,15 @@
         except errors.UpgradeRequired:
             # cant bind this format, the test is irrelevant.
             return
-        branch.Branch.hooks.install_named_hook(
-            'post_commit', self.capture_post_commit_hook, None)
+        Branch.hooks.install_named_hook('post_commit',
+            self.capture_post_commit_hook, None)
         tree.lock_write()
         tree.add('')
         revid = tree.commit('a revision')
         # with a bound branch, local is set.
         self.assertEqual([
-            ('post_commit', tree.branch.base, master.base, 0,
-             revision.NULL_REVISION, 1, revid, True, True)
+            ('post_commit', tree.branch.base, master.base, 0, NULL_REVISION,
+             1, revid, True, True)
             ],
             self.hook_calls)
         tree.unlock()
@@ -110,8 +108,8 @@
         tree.lock_write()
         tree.add('')
         revid = tree.commit('first revision')
-        branch.Branch.hooks.install_named_hook(
-            'post_commit', self.capture_post_commit_hook, None)
+        Branch.hooks.install_named_hook('post_commit',
+            self.capture_post_commit_hook, None)
         revid2 = tree.commit('second revision')
         # having committed from up the branch, we should get the
         # before and after revnos and revids correctly.
@@ -123,26 +121,26 @@
         tree.unlock()
 
     def test_pre_commit_passes(self):
-        empty_delta = delta.TreeDelta()
-        root_delta = delta.TreeDelta()
+        empty_delta = TreeDelta()
+        root_delta = TreeDelta()
         tree = self.make_branch_and_memory_tree('branch')
         tree.lock_write()
         tree.add('')
         root_delta.added = [('', tree.path2id(''), 'directory')]
-        branch.Branch.hooks.install_named_hook(
-            "pre_commit", self.capture_pre_commit_hook, None)
+        Branch.hooks.install_named_hook("pre_commit",
+            self.capture_pre_commit_hook, None)
         revid1 = tree.commit('first revision')
         revid2 = tree.commit('second revision')
         self.assertEqual([
-            ('pre_commit', 0, revision.NULL_REVISION, 1, revid1, root_delta),
+            ('pre_commit', 0, NULL_REVISION, 1, revid1, root_delta),
             ('pre_commit', 1, revid1, 2, revid2, empty_delta)
             ],
             self.hook_calls)
         tree.unlock()
 
     def test_pre_commit_fails(self):
-        empty_delta = delta.TreeDelta()
-        root_delta = delta.TreeDelta()
+        empty_delta = TreeDelta()
+        root_delta = TreeDelta()
         tree = self.make_branch_and_memory_tree('branch')
         tree.lock_write()
         tree.add('')
@@ -152,9 +150,9 @@
                       old_revno, old_revid, new_revno, new_revid,
                       tree_delta, future_tree):
             raise PreCommitException(new_revid)
-        branch.Branch.hooks.install_named_hook(
-            "pre_commit", self.capture_pre_commit_hook, None)
-        branch.Branch.hooks.install_named_hook("pre_commit", hook_func, None)
+        Branch.hooks.install_named_hook("pre_commit",
+            self.capture_pre_commit_hook, None)
+        Branch.hooks.install_named_hook("pre_commit", hook_func, None)
         revids = [None, None, None]
         # this commit will raise an exception
         # so the commit is rolled back and revno unchanged
@@ -162,16 +160,16 @@
         # we have to record the revid to use in assertEqual later
         revids[0] = str(err)
         # unregister all pre_commit hooks
-        branch.Branch.hooks["pre_commit"] = []
+        Branch.hooks["pre_commit"] = []
         # and re-register the capture hook
-        branch.Branch.hooks.install_named_hook(
-            "pre_commit", self.capture_pre_commit_hook, None)
+        Branch.hooks.install_named_hook("pre_commit",
+            self.capture_pre_commit_hook, None)
         # now these commits should go through
         for i in range(1, 3):
             revids[i] = tree.commit('message')
         self.assertEqual([
-            ('pre_commit', 0, revision.NULL_REVISION, 1, revids[0], root_delta),
-            ('pre_commit', 0, revision.NULL_REVISION, 1, revids[1], root_delta),
+            ('pre_commit', 0, NULL_REVISION, 1, revids[0], root_delta),
+            ('pre_commit', 0, NULL_REVISION, 1, revids[1], root_delta),
             ('pre_commit', 1, revids[1], 2, revids[2], empty_delta)
             ],
             self.hook_calls)
@@ -204,13 +202,13 @@
             tree.unversion(['to_be_unversioned_id'])
             tree.mkdir('added_dir', 'added_dir_id')
             # start to capture pre_commit delta
-            branch.Branch.hooks.install_named_hook(
-                "pre_commit", self.capture_pre_commit_hook, None)
+            Branch.hooks.install_named_hook("pre_commit",
+                self.capture_pre_commit_hook, None)
             revid2 = tree.commit('second revision')
         finally:
             tree.unlock()
 
-        expected_delta = delta.TreeDelta()
+        expected_delta = TreeDelta()
         expected_delta.added = [('added_dir', 'added_dir_id', 'directory')]
         expected_delta.removed = [('to_be_unversioned',
                                    'to_be_unversioned_id', 'directory')]

=== modified file 'bzrlib/tests/per_branch/test_create_checkout.py'
--- bzrlib/tests/per_branch/test_create_checkout.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_create_checkout.py	2009-07-10 05:49:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,10 +19,11 @@
 from bzrlib import (
     branch,
     )
-from bzrlib.tests import per_branch
-
-
-class TestCreateCheckout(per_branch.TestCaseWithBranch):
+from bzrlib.remote import RemoteBranch
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+
+
+class TestCreateCheckout(TestCaseWithBranch):
 
     def test_checkout_format(self):
         """Make sure the new checkout uses the desired branch format."""

=== modified file 'bzrlib/tests/per_branch/test_create_clone.py'
--- bzrlib/tests/per_branch/test_create_clone.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_create_clone.py	2009-08-20 04:09:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,16 +16,14 @@
 
 """Tests for branch.create_clone behaviour."""
 
-from bzrlib import (
-    branch,
-    errors,
-    remote,
-    tests,
-    )
-from bzrlib.tests import per_branch
-
-
-class TestCreateClone(per_branch.TestCaseWithBranch):
+from bzrlib.branch import Branch
+from bzrlib import errors
+from bzrlib import remote
+from bzrlib import tests
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+
+
+class TestCreateClone(TestCaseWithBranch):
 
     def test_create_clone_on_transport_missing_parent_dir(self):
         tree = self.make_branch_and_tree('source')
@@ -131,8 +129,8 @@
         source = tree.branch
         target_transport = self.get_transport('target')
         self.hook_calls = []
-        branch.Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', self.assertBranchHookBranchIsStacked, None)
+        Branch.hooks.install_named_hook("pre_change_branch_tip",
+            self.assertBranchHookBranchIsStacked, None)
         result = tree.branch.create_clone_on_transport(target_transport,
             stacked_on=trunk.base)
         self.assertEqual(revid, result.last_revision())

=== modified file 'bzrlib/tests/per_branch/test_hooks.py'
--- bzrlib/tests/per_branch/test_hooks.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_branch/test_hooks.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,16 +16,15 @@
 
 """Tests that branch classes implement hook callouts correctly."""
 
-from bzrlib import (
-    branch as _mod_branch,
-    errors,
-    remote,
-    revision,
-    tests,
-    )
-from bzrlib.tests import test_server
-
-class ChangeBranchTipTestCase(tests.TestCaseWithMemoryTransport):
+from bzrlib.branch import Branch, ChangeBranchTipParams
+from bzrlib.errors import HookFailed, TipChangeRejected
+from bzrlib.remote import RemoteBranch
+from bzrlib.revision import NULL_REVISION
+from bzrlib.smart import server
+from bzrlib.tests import TestCaseWithMemoryTransport
+
+
+class ChangeBranchTipTestCase(TestCaseWithMemoryTransport):
     """Base TestCase for testing pre/post_change_branch_tip hooks."""
 
     def install_logging_hook(self, prefix):
@@ -34,7 +33,7 @@
         :returns: the list that the calls will be appended to.
         """
         hook_calls = []
-        _mod_branch.Branch.hooks.install_named_hook(
+        Branch.hooks.install_named_hook(
             prefix + '_change_branch_tip', hook_calls.append, None)
         return hook_calls
 
@@ -54,7 +53,7 @@
         pre=False):
         if hook_calls is None:
             hook_calls = self.hook_calls
-        if isinstance(branch, remote.RemoteBranch):
+        if isinstance(branch, RemoteBranch):
             # For a remote branch, both the server and the client will raise
             # this hook, and we see both in the test environment. The remote
             # instance comes in between the clients - the client doe pre, the
@@ -73,7 +72,7 @@
 
     def setUp(self):
         self.hook_calls = []
-        super(TestSetRevisionHistoryHook, self).setUp()
+        TestCaseWithMemoryTransport.setUp(self)
 
     def capture_set_rh_hook(self, branch, rev_history):
         """Capture post set-rh hook calls to self.hook_calls.
@@ -85,8 +84,8 @@
 
     def test_set_rh_empty_history(self):
         branch = self.make_branch('source')
-        _mod_branch.Branch.hooks.install_named_hook(
-            'set_rh', self.capture_set_rh_hook, None)
+        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
+                                        None)
         branch.set_revision_history([])
         expected_params = ('set_rh', branch, [], True)
         self.assertHookCalls(expected_params, branch)
@@ -99,8 +98,8 @@
         tree.commit('empty commit', rev_id='foo')
         tree.unlock()
         branch = tree.branch
-        _mod_branch.Branch.hooks.install_named_hook(
-            'set_rh', self.capture_set_rh_hook, None)
+        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
+                                        None)
         # some branches require that their history be set to a revision in the
         # repository
         branch.set_revision_history(['f\xc2\xb5'])
@@ -109,23 +108,23 @@
 
     def test_set_rh_branch_is_locked(self):
         branch = self.make_branch('source')
-        _mod_branch.Branch.hooks.install_named_hook(
-            'set_rh', self.capture_set_rh_hook, None)
+        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
+                                        None)
         branch.set_revision_history([])
         expected_params = ('set_rh', branch, [], True)
         self.assertHookCalls(expected_params, branch)
 
     def test_set_rh_calls_all_hooks_no_errors(self):
         branch = self.make_branch('source')
-        _mod_branch.Branch.hooks.install_named_hook(
-            'set_rh', self.capture_set_rh_hook, None)
-        _mod_branch.Branch.hooks.install_named_hook(
-            'set_rh', self.capture_set_rh_hook, None)
+        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
+                                        None)
+        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
+                                        None)
         branch.set_revision_history([])
         expected_calls = [('set_rh', branch, [], True),
             ('set_rh', branch, [], True),
             ]
-        if isinstance(branch, remote.RemoteBranch):
+        if isinstance(branch, RemoteBranch):
             # For a remote branch, both the server and the client will raise
             # set_rh, and the server will do so first because that is where
             # the change takes place.
@@ -135,23 +134,22 @@
             self.assertEqual(expected_calls, self.hook_calls)
 
 
-class TestOpen(tests.TestCaseWithMemoryTransport):
+class TestOpen(TestCaseWithMemoryTransport):
 
     def capture_hook(self, branch):
         self.hook_calls.append(branch)
 
     def install_hook(self):
         self.hook_calls = []
-        _mod_branch.Branch.hooks.install_named_hook(
-            'open', self.capture_hook, None)
+        Branch.hooks.install_named_hook('open', self.capture_hook, None)
 
     def test_create(self):
         self.install_hook()
         b = self.make_branch('.')
-        if isinstance(b, remote.RemoteBranch):
+        if isinstance(b, RemoteBranch):
             # RemoteBranch creation:
-            if (self.transport_readonly_server
-                == test_server.ReadonlySmartTCPServer_for_testing_v2_only):
+            if (self.transport_readonly_server ==
+                server.ReadonlySmartTCPServer_for_testing_v2_only):
                 # Older servers:
                 self.assertEqual(3, len(self.hook_calls))
                 # creates the branch via the VFS (for older servers)
@@ -172,8 +170,8 @@
     def test_open(self):
         branch_url = self.make_branch('.').bzrdir.root_transport.base
         self.install_hook()
-        b = _mod_branch.Branch.open(branch_url)
-        if isinstance(b, remote.RemoteBranch):
+        b = Branch.open(branch_url)
+        if isinstance(b, RemoteBranch):
             self.assertEqual(3, len(self.hook_calls))
             # open_branchV2 RPC
             self.assertRealBranch(self.hook_calls[0])
@@ -187,8 +185,8 @@
     def assertRealBranch(self, b):
         # Branches opened on the server don't have comparable URLs, so we just
         # assert that it is not a RemoteBranch.
-        self.assertIsInstance(b, _mod_branch.Branch)
-        self.assertFalse(isinstance(b, remote.RemoteBranch))
+        self.assertIsInstance(b, Branch)
+        self.assertFalse(isinstance(b, RemoteBranch))
 
 
 class TestPreChangeBranchTip(ChangeBranchTipTestCase):
@@ -205,32 +203,35 @@
         def assertBranchAtRevision1(params):
             self.assertEquals(
                 (1, 'revid-one'), params.branch.last_revision_info())
-        _mod_branch.Branch.hooks.install_named_hook(
+        Branch.hooks.install_named_hook(
             'pre_change_branch_tip', assertBranchAtRevision1, None)
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
 
     def test_hook_failure_prevents_change(self):
-        """If a hook raises an exception, the change does not take effect."""
+        """If a hook raises an exception, the change does not take effect.
+
+        Also, a HookFailed exception will be raised.
+        """
         branch = self.make_branch_with_revision_ids(
             'one-\xc2\xb5', 'two-\xc2\xb5')
         class PearShapedError(Exception):
             pass
         def hook_that_raises(params):
             raise PearShapedError()
-        _mod_branch.Branch.hooks.install_named_hook(
+        Branch.hooks.install_named_hook(
             'pre_change_branch_tip', hook_that_raises, None)
         hook_failed_exc = self.assertRaises(
-            PearShapedError,
-            branch.set_last_revision_info, 0, revision.NULL_REVISION)
+            HookFailed, branch.set_last_revision_info, 0, NULL_REVISION)
+        self.assertIsInstance(hook_failed_exc.exc_value, PearShapedError)
         # The revision info is unchanged.
         self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
 
     def test_empty_history(self):
         branch = self.make_branch('source')
         hook_calls = self.install_logging_hook('pre')
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
-        expected_params = _mod_branch.ChangeBranchTipParams(
-            branch, 0, 0, revision.NULL_REVISION, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
+        expected_params = ChangeBranchTipParams(
+            branch, 0, 0, NULL_REVISION, NULL_REVISION)
         self.assertHookCalls(expected_params, branch, hook_calls, pre=True)
 
     def test_nonempty_history(self):
@@ -241,7 +242,7 @@
             'one-\xc2\xb5', 'two-\xc2\xb5')
         hook_calls = self.install_logging_hook('pre')
         branch.set_last_revision_info(1, 'one-\xc2\xb5')
-        expected_params = _mod_branch.ChangeBranchTipParams(
+        expected_params = ChangeBranchTipParams(
             branch, 2, 1, 'two-\xc2\xb5', 'one-\xc2\xb5')
         self.assertHookCalls(expected_params, branch, hook_calls, pre=True)
 
@@ -249,9 +250,9 @@
         branch = self.make_branch('source')
         def assertBranchIsLocked(params):
             self.assertTrue(params.branch.is_locked())
-        _mod_branch.Branch.hooks.install_named_hook(
+        Branch.hooks.install_named_hook(
             'pre_change_branch_tip', assertBranchIsLocked, None)
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
 
     def test_calls_all_hooks_no_errors(self):
         """If multiple hooks are registered, all are called (if none raise
@@ -261,9 +262,9 @@
         hook_calls_1 = self.install_logging_hook('pre')
         hook_calls_2 = self.install_logging_hook('pre')
         self.assertIsNot(hook_calls_1, hook_calls_2)
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
         # Both hooks are called.
-        if isinstance(branch, remote.RemoteBranch):
+        if isinstance(branch, RemoteBranch):
             count = 2
         else:
             count = 1
@@ -278,12 +279,11 @@
         branch = self.make_branch_with_revision_ids(
             'one-\xc2\xb5', 'two-\xc2\xb5')
         def hook_that_rejects(params):
-            raise errors.TipChangeRejected('rejection message')
-        _mod_branch.Branch.hooks.install_named_hook(
+            raise TipChangeRejected('rejection message')
+        Branch.hooks.install_named_hook(
             'pre_change_branch_tip', hook_that_rejects, None)
         self.assertRaises(
-            errors.TipChangeRejected,
-            branch.set_last_revision_info, 0, revision.NULL_REVISION)
+            TipChangeRejected, branch.set_last_revision_info, 0, NULL_REVISION)
         # The revision info is unchanged.
         self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
 
@@ -301,17 +301,17 @@
         branch = self.make_branch_with_revision_ids('revid-one')
         def assertBranchAtRevision1(params):
             self.assertEquals(
-                (0, revision.NULL_REVISION), params.branch.last_revision_info())
-        _mod_branch.Branch.hooks.install_named_hook(
+                (0, NULL_REVISION), params.branch.last_revision_info())
+        Branch.hooks.install_named_hook(
             'post_change_branch_tip', assertBranchAtRevision1, None)
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
 
     def test_empty_history(self):
         branch = self.make_branch('source')
         hook_calls = self.install_logging_hook('post')
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
-        expected_params = _mod_branch.ChangeBranchTipParams(
-            branch, 0, 0, revision.NULL_REVISION, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
+        expected_params = ChangeBranchTipParams(
+            branch, 0, 0, NULL_REVISION, NULL_REVISION)
         self.assertHookCalls(expected_params, branch, hook_calls)
 
     def test_nonempty_history(self):
@@ -322,7 +322,7 @@
             'one-\xc2\xb5', 'two-\xc2\xb5')
         hook_calls = self.install_logging_hook('post')
         branch.set_last_revision_info(1, 'one-\xc2\xb5')
-        expected_params = _mod_branch.ChangeBranchTipParams(
+        expected_params = ChangeBranchTipParams(
             branch, 2, 1, 'two-\xc2\xb5', 'one-\xc2\xb5')
         self.assertHookCalls(expected_params, branch, hook_calls)
 
@@ -331,9 +331,9 @@
         branch = self.make_branch('source')
         def assertBranchIsLocked(params):
             self.assertTrue(params.branch.is_locked())
-        _mod_branch.Branch.hooks.install_named_hook(
+        Branch.hooks.install_named_hook(
             'post_change_branch_tip', assertBranchIsLocked, None)
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
 
     def test_calls_all_hooks_no_errors(self):
         """If multiple hooks are registered, all are called (if none raise
@@ -343,9 +343,9 @@
         hook_calls_1 = self.install_logging_hook('post')
         hook_calls_2 = self.install_logging_hook('post')
         self.assertIsNot(hook_calls_1, hook_calls_2)
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
         # Both hooks are called.
-        if isinstance(branch, remote.RemoteBranch):
+        if isinstance(branch, RemoteBranch):
             count = 2
         else:
             count = 1
@@ -377,7 +377,7 @@
         """
         # Check for the number of invocations expected. One invocation is
         # local, one is remote (if the branch is remote).
-        if smart_enabled and isinstance(branch, remote.RemoteBranch):
+        if smart_enabled and isinstance(branch, RemoteBranch):
             length = 2
         else:
             length = 1
@@ -391,12 +391,12 @@
 
     def test_set_last_revision_info(self):
         branch = self.make_branch('')
-        branch.set_last_revision_info(0, revision.NULL_REVISION)
+        branch.set_last_revision_info(0, NULL_REVISION)
         self.assertPreAndPostHooksWereInvoked(branch, True)
 
     def test_generate_revision_history(self):
         branch = self.make_branch('')
-        branch.generate_revision_history(revision.NULL_REVISION)
+        branch.generate_revision_history(NULL_REVISION)
         # NB: for HPSS protocols < v3, the server does not invoke branch tip
         # change events on generate_revision_history, as the change is done
         # directly by the client over the VFS.

=== modified file 'bzrlib/tests/per_branch/test_http.py'
--- bzrlib/tests/per_branch/test_http.py	2010-02-11 09:27:55 +0000
+++ bzrlib/tests/per_branch/test_http.py	2009-07-10 10:46:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,17 +16,16 @@
 
 """Test branches with inaccessible parents."""
 
-from bzrlib import (
-    branch,
-    errors,
-    )
-from bzrlib.tests import (
-    per_branch,
-    test_server,
-    )
-
-
-class InaccessibleParentTests(per_branch.TestCaseWithBranch):
+import os
+
+from bzrlib import branch, errors
+from bzrlib.tests.http_server import HttpServer
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+from bzrlib.transport.local import LocalURLServer
+from bzrlib.transport.chroot import TestingChrootServer
+
+
+class InaccessibleParentTests(TestCaseWithBranch):
     """Tests with branches with "inaccessible" parents.
 
     An "inaccessible" parent location is one that cannot be represented, e.g. if
@@ -37,8 +36,8 @@
 
     def setUp(self):
         super(InaccessibleParentTests, self).setUp()
-        if self.transport_server in (test_server.LocalURLServer, None):
-            self.transport_readonly_server = test_server.TestingChrootServer
+        if self.transport_server in (LocalURLServer, None):
+            self.transport_readonly_server = TestingChrootServer
 
     def get_branch_with_invalid_parent(self):
         """Get a branch whose get_parent will raise InaccessibleParent."""

=== modified file 'bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py'
--- bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2010-04-28 07:10:36 +0000
+++ bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2009-12-03 23:34:38 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,287 +19,178 @@
 from bzrlib import (
     errors,
     revision,
-    tests,
     )
 
-from bzrlib.tests import per_branch
-
-
-class TestIterMergeSortedRevisionsSimpleGraph(per_branch.TestCaseWithBranch):
-
-    def setUp(self):
-        super(TestIterMergeSortedRevisionsSimpleGraph, self).setUp()
-        builder = self.make_builder_with_merges('.')
-        self.branch = builder.get_branch()
-        self.branch.lock_read()
-        self.addCleanup(self.branch.unlock)
-
-    def make_builder_with_merges(self, relpath):
-        try:
-            builder = self.make_branch_builder(relpath)
-        except (errors.TransportNotPossible, errors.UninitializableFormat):
-            raise tests.TestNotApplicable('format not directly constructable')
-        builder.start_series()
-        # 1
-        # |\
-        # 2 |
-        # | |
-        # | 1.1.1
-        # |/
-        # 3
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2', ['1'], [])
-        builder.build_snapshot('3', ['2', '1.1.1'], [])
-        builder.finish_series()
-        return builder
-
-    def assertIterRevids(self, expected, *args, **kwargs):
-        # We don't care about depths and revnos here, only about returning the
-        # right revids.
-        revids = [revid for (revid, depth, revno, eom) in
-                  self.branch.iter_merge_sorted_revisions(*args, **kwargs)]
-        self.assertEqual(expected, revids)
+from bzrlib.tests.per_branch import TestCaseWithBranch
+
+
+class TestIterMergeSortedRevisions(TestCaseWithBranch):
 
     def test_merge_sorted(self):
-        self.assertIterRevids(['3', '1.1.1', '2', '1'])
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ('rev-1', 0, (1,), True),
+            ], list(the_branch.iter_merge_sorted_revisions()))
 
     def test_merge_sorted_range(self):
-        self.assertIterRevids(['1.1.1'],
-                              start_revision_id='1.1.1', stop_revision_id='1')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-1.1.1', stop_revision_id='rev-1')))
 
     def test_merge_sorted_range_start_only(self):
-        self.assertIterRevids(['1.1.1', '1'],
-                              start_revision_id='1.1.1')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ('rev-1', 0, (1,), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-1.1.1')))
 
     def test_merge_sorted_range_stop_exclude(self):
-        self.assertIterRevids(['3', '1.1.1', '2'], stop_revision_id='1')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-1')))
 
     def test_merge_sorted_range_stop_include(self):
-        self.assertIterRevids(['3', '1.1.1', '2'],
-                              stop_revision_id='2', stop_rule='include')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-2', stop_rule='include')))
 
     def test_merge_sorted_range_stop_with_merges(self):
-        self.assertIterRevids(['3', '1.1.1'],
-                              stop_revision_id='3', stop_rule='with-merges')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-3', stop_rule='with-merges')))
 
     def test_merge_sorted_range_stop_with_merges_can_show_non_parents(self):
-        # 1.1.1 gets logged before the end revision is reached.
-        # so it is returned even though 1.1.1 is not a parent of 2.
-        self.assertIterRevids(['3', '1.1.1', '2'],
-                              stop_revision_id='2', stop_rule='with-merges')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        # rev-1.1.1 gets logged before the end revision is reached.
+        # so it is returned even though rev-1.1.1 is not a parent of rev-2.
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-2', stop_rule='with-merges')))
 
     def test_merge_sorted_range_stop_with_merges_ignore_non_parents(self):
-        # 2 is not a parent of 1.1.1 so it must not be returned
-        self.assertIterRevids(['3', '1.1.1'],
-                              stop_revision_id='1.1.1', stop_rule='with-merges')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        # rev-2 is not a parent of rev-1.1.1 so it must not be returned
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-1.1.1', stop_rule='with-merges')))
 
     def test_merge_sorted_single_stop_exclude(self):
         # from X..X exclusive is an empty result
-        self.assertIterRevids([], start_revision_id='3', stop_revision_id='3')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-3', stop_revision_id='rev-3')))
 
     def test_merge_sorted_single_stop_include(self):
         # from X..X inclusive is [X]
-        self.assertIterRevids(['3'],
-                              start_revision_id='3', stop_revision_id='3',
-                              stop_rule='include')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-3', stop_revision_id='rev-3',
+                stop_rule='include')))
 
     def test_merge_sorted_single_stop_with_merges(self):
-        self.assertIterRevids(['3', '1.1.1'],
-                              start_revision_id='3', stop_revision_id='3',
-                              stop_rule='with-merges')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-3', stop_revision_id='rev-3',
+                stop_rule='with-merges')))
 
     def test_merge_sorted_forward(self):
-        self.assertIterRevids(['1', '2', '1.1.1', '3'], direction='forward')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-1', 0, (1,), True),
+            ('rev-2', 0, (2,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-3', 0, (3,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                direction='forward')))
 
     def test_merge_sorted_range_forward(self):
-        self.assertIterRevids(['1.1.1'],
-                              start_revision_id='1.1.1', stop_revision_id='1',
-                              direction='forward')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-2', 0, (2,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-1.1.1', stop_revision_id='rev-1',
+                direction='forward')))
 
     def test_merge_sorted_range_start_only_forward(self):
-        self.assertIterRevids(['1', '1.1.1'],
-                              start_revision_id='1.1.1', direction='forward')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-1', 0, (1,), True),
+            ('rev-2', 0, (2,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                start_revision_id='rev-1.1.1', direction='forward')))
 
     def test_merge_sorted_range_stop_exclude_forward(self):
-        self.assertIterRevids(['2', '1.1.1', '3'],
-                              stop_revision_id='1', direction='forward')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-2', 0, (2,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-3', 0, (3,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-1', direction='forward')))
 
     def test_merge_sorted_range_stop_include_forward(self):
-        self.assertIterRevids(['2', '1.1.1', '3'],
-                              stop_revision_id='2', stop_rule='include',
-                              direction='forward')
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-2', 0, (2,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-3', 0, (3,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-2', stop_rule='include',
+                direction='forward')))
 
     def test_merge_sorted_range_stop_with_merges_forward(self):
-        self.assertIterRevids(['1.1.1', '3'],
-                              stop_revision_id='3', stop_rule='with-merges',
-                              direction='forward')
-
-
-class TestIterMergeSortedRevisionsBushyGraph(per_branch.TestCaseWithBranch):
-
-    def make_branch_builder(self, relpath):
-        try:
-            builder = super(TestIterMergeSortedRevisionsBushyGraph,
-                            self).make_branch_builder(relpath)
-        except (errors.TransportNotPossible, errors.UninitializableFormat):
-            raise tests.TestNotApplicable('format not directly constructable')
-        return builder
-
-    def make_branch_with_embedded_merges(self, relpath='.'):
-        builder = self.make_branch_builder(relpath)
-        # 1
-        # |\
-        # | 1.1.1
-        # | /
-        # 2
-        # | \
-        # 3 |
-        # | |
-        # | 2.1.1
-        # | |    \
-        # | 2.1.2 |
-        # | |     |
-        # | |   2.2.1
-        # | |  /
-        # | 2.1.3
-        # |/
-        # 4
-        builder.start_series()
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2', ['1', '1.1.1'], [])
-        builder.build_snapshot('2.1.1', ['2'], [])
-        builder.build_snapshot('2.1.2', ['2.1.1'], [])
-        builder.build_snapshot('2.2.1', ['2.1.1'], [])
-        builder.build_snapshot('2.1.3', ['2.1.2', '2.2.1'], [])
-        builder.build_snapshot('3', ['2'], [])
-        builder.build_snapshot('4', ['3', '2.1.3'], [])
-        builder.finish_series()
-        br = builder.get_branch()
-        br.lock_read()
-        self.addCleanup(br.unlock)
-        return br
-
-    def make_branch_with_different_depths_merges(self, relpath='.'):
-        builder = self.make_branch_builder(relpath)
-        # 1
-        # |\
-        # | 1.1.1
-        # | /
-        # 2
-        # | \
-        # 3 |
-        # | |
-        # | 2.1.1
-        # | |    \
-        # | 2.1.2 |
-        # | |     |
-        # | |     2.2.1
-        # | |    /
-        # | 2.1.3
-        # |/
-        # 4
-        builder.start_series()
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('2', ['1'], [])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('1.1.2', ['1.1.1'], [])
-        builder.build_snapshot('1.2.1', ['1.1.1'], [])
-        builder.build_snapshot('1.2.2', ['1.2.1'], [])
-        builder.build_snapshot('1.3.1', ['1.2.1'], [])
-        builder.build_snapshot('1.3.2', ['1.3.1'], [])
-        builder.build_snapshot('1.4.1', ['1.3.1'], [])
-        builder.build_snapshot('1.3.3', ['1.3.2', '1.4.11'], [])
-        builder.build_snapshot('1.2.3', ['1.2.2', '1.3.3'], [])
-        builder.build_snapshot('2.1.1', ['2'], [])
-        builder.build_snapshot('2.1.2', ['2.1.1'], [])
-        builder.build_snapshot('2.2.1', ['2.1.1'], [])
-        builder.build_snapshot('2.1.3', ['2.1.2', '2.2.1'], [])
-        builder.build_snapshot('3', ['2',  '1.2.3'], [])
-        # .. to bring them all and ... bind them
-        builder.build_snapshot('4', ['3', '2.1.3'],
-                               [])
-        builder.finish_series()
-        br = builder.get_branch()
-        br.lock_read()
-        self.addCleanup(br.unlock)
-        return br
-
-    def make_branch_with_alternate_ancestries(self, relpath='.'):
-        # See test_merge_sorted_exclude_ancestry below for the difference with
-        # bt.test_log.TestLogExcludeAncestry.
-        # make_branch_with_alternate_ancestries and
-        # test_merge_sorted_exclude_ancestry
-        # See the FIXME in assertLogRevnos there too.
-        builder = self.make_branch_builder(relpath)
-        # 1
-        # |\
-        # | 1.1.1
-        # | /| \
-        # 2  |  |
-        # |  |  1.2.1
-        # |  | /
-        # |  1.1.2
-        # | /
-        # 3
-        builder.start_series()
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2', ['1', '1.1.1'], [])
-        builder.build_snapshot('1.2.1', ['1.1.1'], [])
-        builder.build_snapshot('1.1.2', ['1.1.1', '1.2.1'], [])
-        builder.build_snapshot('3', ['2', '1.1.2'], [])
-        builder.finish_series()
-        br = builder.get_branch()
-        br.lock_read()
-        self.addCleanup(br.unlock)
-        return br
-
-    def assertIterRevids(self, expected, branch, *args, **kwargs):
-        # We don't care about depths and revnos here, only about returning the
-        # right revids.
-        revs = list(branch.iter_merge_sorted_revisions(*args, **kwargs))
-        revids = [revid for (revid, depth, revno, eom) in revs]
-        self.assertEqual(expected, revids)
-
-    def test_merge_sorted_starting_at_embedded_merge(self):
-        branch = self.make_branch_with_embedded_merges()
-        self.assertIterRevids(['4', '2.1.3', '2.2.1', '2.1.2', '2.1.1',
-                               '3', '2', '1.1.1', '1'],
-                              branch)
-        # 3 and 2.1.2 are not part of 2.2.1 ancestry and should not appear
-        self.assertIterRevids(['2.2.1', '2.1.1', '2', '1.1.1', '1'],
-                              branch, start_revision_id='2.2.1',
-                              stop_rule='with-merges')
-
-    def test_merge_sorted_with_different_depths_merge(self):
-        branch = self.make_branch_with_different_depths_merges()
-        self.assertIterRevids(['4', '2.1.3', '2.2.1', '2.1.2', '2.1.1',
-                               '3',
-                               '1.2.3', '1.3.3', '1.3.2', '1.3.1',
-                               '1.2.2', '1.2.1', '1.1.1',
-                               '2', '1'],
-                              branch)
-        # 3 (and its descendants) and 2.1.2 are not part of 2.2.1 ancestry and
-        # should not appear
-        self.assertIterRevids(['2.2.1', '2.1.1', '2', '1'],
-                              branch, start_revision_id='2.2.1',
-                              stop_rule='with-merges')
-
-    def test_merge_sorted_exclude_ancestry(self):
-        branch = self.make_branch_with_alternate_ancestries()
-        self.assertIterRevids(['3', '1.1.2', '1.2.1', '2', '1.1.1', '1'],
-                              branch)
-        # '2' is not part of the ancestry even if merge_sort order will make it
-        # appear before 1.1.1
-        self.assertIterRevids(['1.1.2', '1.2.1'],
-                              branch,
-                              stop_rule='with-merges-without-common-ancestry',
-                              start_revision_id='1.1.2',
-                              stop_revision_id='1.1.1')
-
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        self.assertEqual([
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-3', 0, (3,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-3', stop_rule='with-merges',
+                direction='forward')))

=== modified file 'bzrlib/tests/per_branch/test_locking.py'
--- bzrlib/tests/per_branch/test_locking.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_locking.py	2009-10-15 02:11:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,21 +16,18 @@
 
 """Test locks across all branch implemenations"""
 
-from bzrlib import (
-    branch as _mod_branch,
-    errors,
-    tests,
-    )
-from bzrlib.tests import (
-    lock_helpers,
-    per_branch,
-    )
-
-
-class TestBranchLocking(per_branch.TestCaseWithBranch):
+from bzrlib import errors
+from bzrlib.branch import BzrBranchFormat4
+from bzrlib.bzrdir import RemoteBzrDirFormat
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.lock_helpers import TestPreventLocking, LockWrapper
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+
+
+class TestBranchLocking(TestCaseWithBranch):
 
     def setUp(self):
-        super(TestBranchLocking, self).setUp()
+        TestCaseWithBranch.setUp(self)
         self.reduceLockdirTimeout()
 
     def get_instrumented_branch(self):
@@ -40,8 +37,8 @@
         # not there. But assuming it has them lets us test the exact
         # lock/unlock order.
         self.locks = []
-        b = lock_helpers.LockWrapper(self.locks, self.get_branch(), 'b')
-        b.repository = lock_helpers.LockWrapper(self.locks, b.repository, 'r')
+        b = LockWrapper(self.locks, self.get_branch(), 'b')
+        b.repository = LockWrapper(self.locks, b.repository, 'r')
         bcf = b.control_files
         rcf = getattr(b.repository, 'control_files', None)
         if rcf is None:
@@ -50,18 +47,16 @@
             # Look out for branch types that reuse their control files
             self.combined_control = bcf is rcf
         try:
-            b.control_files = lock_helpers.LockWrapper(
-                self.locks, b.control_files, 'bc')
+            b.control_files = LockWrapper(self.locks, b.control_files, 'bc')
         except AttributeError:
             # RemoteBranch seems to trigger this.
-            raise tests.TestSkipped(
-                'Could not instrument branch control files.')
+            raise TestSkipped("Could not instrument branch control files.")
         if self.combined_control:
             # instrument the repository control files too to ensure its worked
             # with correctly. When they are not shared, we trust the repository
             # API and only instrument the repository itself.
-            b.repository.control_files = lock_helpers.LockWrapper(
-                self.locks, b.repository.control_files, 'rc')
+            b.repository.control_files = \
+                LockWrapper(self.locks, b.repository.control_files, 'rc')
         return b
 
     def test_01_lock_read(self):
@@ -144,7 +139,7 @@
         try:
             self.assertTrue(b.is_locked())
             self.assertTrue(b.repository.is_locked())
-            self.assertLogsError(lock_helpers.TestPreventLocking, b.unlock)
+            self.assertLogsError(TestPreventLocking, b.unlock)
             if self.combined_control:
                 self.assertTrue(b.is_locked())
             else:
@@ -188,7 +183,7 @@
         try:
             self.assertTrue(b.is_locked())
             self.assertTrue(b.repository.is_locked())
-            self.assertLogsError(lock_helpers.TestPreventLocking, b.unlock)
+            self.assertLogsError(TestPreventLocking, b.unlock)
             self.assertTrue(b.is_locked())
             self.assertTrue(b.repository.is_locked())
 
@@ -221,7 +216,7 @@
         b = self.get_instrumented_branch()
         b.repository.disable_lock_read()
 
-        self.assertRaises(lock_helpers.TestPreventLocking, b.lock_read)
+        self.assertRaises(TestPreventLocking, b.lock_read)
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
 
@@ -234,7 +229,7 @@
         b = self.get_instrumented_branch()
         b.repository.disable_lock_write()
 
-        self.assertRaises(lock_helpers.TestPreventLocking, b.lock_write)
+        self.assertRaises(TestPreventLocking, b.lock_write)
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
 
@@ -247,7 +242,7 @@
         b = self.get_instrumented_branch()
         b.control_files.disable_lock_read()
 
-        self.assertRaises(lock_helpers.TestPreventLocking, b.lock_read)
+        self.assertRaises(TestPreventLocking, b.lock_read)
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
 
@@ -271,7 +266,7 @@
         b = self.get_instrumented_branch()
         b.control_files.disable_lock_write()
 
-        self.assertRaises(lock_helpers.TestPreventLocking, b.lock_write)
+        self.assertRaises(TestPreventLocking, b.lock_write)
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
         if self.combined_control:
@@ -498,7 +493,7 @@
         branch.unlock()
 
     def test_lock_write_locks_repo_too(self):
-        if isinstance(self.branch_format, _mod_branch.BzrBranchFormat4):
+        if isinstance(self.branch_format, BzrBranchFormat4):
             # Branch format 4 is combined with the repository, so this test
             # doesn't apply.
             return

=== modified file 'bzrlib/tests/per_branch/test_parent.py'
--- bzrlib/tests/per_branch/test_parent.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_branch/test_parent.py	2009-11-08 03:00:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_branch/test_pull.py'
--- bzrlib/tests/per_branch/test_pull.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_pull.py	2009-07-10 05:49:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,17 +18,15 @@
 
 import os
 
-from bzrlib import (
-    branch,
-    bzrdir,
-    errors,
-    memorytree,
-    revision,
-    )
-from bzrlib.tests import per_branch
-
-
-class TestPull(per_branch.TestCaseWithBranch):
+from bzrlib.branch import Branch, BzrBranchFormat5
+from bzrlib.bzrdir import BzrDir
+from bzrlib import errors
+from bzrlib.memorytree import MemoryTree
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+
+
+class TestPull(TestCaseWithBranch):
 
     def test_pull_convergence_simple(self):
         # when revisions are pulled, the left-most accessible parents must
@@ -147,11 +145,11 @@
                          tree_a.branch.revision_history())
 
 
-class TestPullHook(per_branch.TestCaseWithBranch):
+class TestPullHook(TestCaseWithBranch):
 
     def setUp(self):
         self.hook_calls = []
-        super(TestPullHook, self).setUp()
+        TestCaseWithBranch.setUp(self)
 
     def capture_post_pull_hook(self, result):
         """Capture post pull hook calls to self.hook_calls.
@@ -175,14 +173,14 @@
     def test_post_pull_empty_history(self):
         target = self.make_branch('target')
         source = self.make_branch('source')
-        branch.Branch.hooks.install_named_hook(
-            'post_pull', self.capture_post_pull_hook, None)
+        Branch.hooks.install_named_hook('post_pull',
+            self.capture_post_pull_hook, None)
         target.pull(source)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
         self.assertEqual([
-            ('post_pull', source, None, target.base, 0, revision.NULL_REVISION,
-             0, revision.NULL_REVISION, True, None, True)
+            ('post_pull', source, None, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, None, True)
             ],
             self.hook_calls)
 
@@ -201,18 +199,17 @@
             # remotebranches can't be bound.  Let's instead make a new local
             # branch of the default type, which does allow binding.
             # See https://bugs.launchpad.net/bzr/+bug/112020
-            local = bzrdir.BzrDir.create_branch_convenience('local2')
+            local = BzrDir.create_branch_convenience('local2')
             local.bind(target)
         source = self.make_branch('source')
-        branch.Branch.hooks.install_named_hook(
-            'post_pull', self.capture_post_pull_hook, None)
+        Branch.hooks.install_named_hook('post_pull',
+            self.capture_post_pull_hook, None)
         local.pull(source)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
         self.assertEqual([
-            ('post_pull', source, local.base, target.base, 0,
-             revision.NULL_REVISION, 0, revision.NULL_REVISION,
-             True, True, True)
+            ('post_pull', source, local.base, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, True, True)
             ],
             self.hook_calls)
 
@@ -223,10 +220,10 @@
         rev1 = target.commit('rev 1')
         target.unlock()
         sourcedir = target.bzrdir.clone(self.get_url('source'))
-        source = memorytree.MemoryTree.create_on_branch(sourcedir.open_branch())
+        source = MemoryTree.create_on_branch(sourcedir.open_branch())
         rev2 = source.commit('rev 2')
-        branch.Branch.hooks.install_named_hook(
-            'post_pull', self.capture_post_pull_hook, None)
+        Branch.hooks.install_named_hook('post_pull',
+            self.capture_post_pull_hook, None)
         target.branch.pull(source.branch)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.

=== modified file 'bzrlib/tests/per_branch/test_push.py'
--- bzrlib/tests/per_branch/test_push.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_branch/test_push.py	2009-09-24 05:31:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,25 +26,22 @@
     check,
     debug,
     errors,
-    memorytree,
     push,
     repository,
-    revision,
     tests,
-    transport,
-    )
-from bzrlib.smart import (
-    client,
-    server,
-    repository as _mod_smart_repo,
-    )
-from bzrlib.tests import (
-    per_branch,
-    test_server,
-    )
-
-
-class TestPush(per_branch.TestCaseWithBranch):
+    )
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import BzrDir
+from bzrlib.memorytree import MemoryTree
+from bzrlib.revision import NULL_REVISION
+from bzrlib.smart import client, server
+from bzrlib.smart.repository import SmartServerRepositoryGetParentMap
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+from bzrlib.transport import get_transport
+from bzrlib.transport.local import LocalURLServer
+
+
+class TestPush(TestCaseWithBranch):
 
     def test_push_convergence_simple(self):
         # when revisions are pushed, the left-most accessible parents must
@@ -151,11 +148,10 @@
         try:
             tree = a_branch.bzrdir.create_workingtree()
         except errors.NotLocalUrl:
-            if self.vfs_transport_factory is test_server.LocalURLServer:
+            if self.vfs_transport_factory is LocalURLServer:
                 # the branch is colocated on disk, we cannot create a checkout.
                 # hopefully callers will expect this.
-                local_controldir= bzrdir.BzrDir.open(
-                    self.get_vfs_only_url('repo/tree'))
+                local_controldir= bzrdir.BzrDir.open(self.get_vfs_only_url('repo/tree'))
                 tree = local_controldir.create_workingtree()
             else:
                 tree = a_branch.create_checkout('repo/tree', lightweight=True)
@@ -227,7 +223,7 @@
         push._show_push_branch(trunk, 'rev-2', self.get_url('remote'), output)
         # Push rev-3 onto "remote".  If "remote" not stacked and is missing the
         # fulltext record for f-id @ rev-1, then this will fail.
-        remote_branch = branch.Branch.open(self.get_url('remote'))
+        remote_branch = Branch.open(self.get_url('remote'))
         trunk.push(remote_branch)
         check.check_dwim(remote_branch.base, False, True, True)
 
@@ -279,17 +275,22 @@
     def disableOptimisticGetParentMap(self):
         # Tweak some class variables to stop remote get_parent_map calls asking
         # for or receiving more data than the caller asked for.
-        self.overrideAttr(repository.InterRepository,
-                          '_walk_to_common_revisions_batch_size', 1)
-        self.overrideAttr(_mod_smart_repo.SmartServerRepositoryGetParentMap,
-                          'no_extra_results', True)
-
-
-class TestPushHook(per_branch.TestCaseWithBranch):
+        old_flag = SmartServerRepositoryGetParentMap.no_extra_results
+        inter_class = repository.InterRepository
+        old_batch_size = inter_class._walk_to_common_revisions_batch_size
+        inter_class._walk_to_common_revisions_batch_size = 1
+        SmartServerRepositoryGetParentMap.no_extra_results = True
+        def reset_values():
+            SmartServerRepositoryGetParentMap.no_extra_results = old_flag
+            inter_class._walk_to_common_revisions_batch_size = old_batch_size
+        self.addCleanup(reset_values)
+
+
+class TestPushHook(TestCaseWithBranch):
 
     def setUp(self):
         self.hook_calls = []
-        super(TestPushHook, self).setUp()
+        TestCaseWithBranch.setUp(self)
 
     def capture_post_push_hook(self, result):
         """Capture post push hook calls to self.hook_calls.
@@ -313,14 +314,14 @@
     def test_post_push_empty_history(self):
         target = self.make_branch('target')
         source = self.make_branch('source')
-        branch.Branch.hooks.install_named_hook(
-            'post_push', self.capture_post_push_hook, None)
+        Branch.hooks.install_named_hook('post_push',
+                                        self.capture_post_push_hook, None)
         source.push(target)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
         self.assertEqual([
-            ('post_push', source, None, target.base, 0, revision.NULL_REVISION,
-             0, revision.NULL_REVISION, True, None, True)
+            ('post_push', source, None, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, None, True)
             ],
             self.hook_calls)
 
@@ -339,18 +340,17 @@
             # remotebranches can't be bound.  Let's instead make a new local
             # branch of the default type, which does allow binding.
             # See https://bugs.launchpad.net/bzr/+bug/112020
-            local = bzrdir.BzrDir.create_branch_convenience('local2')
+            local = BzrDir.create_branch_convenience('local2')
             local.bind(target)
         source = self.make_branch('source')
-        branch.Branch.hooks.install_named_hook(
-            'post_push', self.capture_post_push_hook, None)
+        Branch.hooks.install_named_hook('post_push',
+                                        self.capture_post_push_hook, None)
         source.push(local)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
         self.assertEqual([
-            ('post_push', source, local.base, target.base, 0,
-             revision.NULL_REVISION, 0, revision.NULL_REVISION,
-             True, True, True)
+            ('post_push', source, local.base, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, True, True)
             ],
             self.hook_calls)
 
@@ -361,10 +361,10 @@
         rev1 = target.commit('rev 1')
         target.unlock()
         sourcedir = target.bzrdir.clone(self.get_url('source'))
-        source = memorytree.MemoryTree.create_on_branch(sourcedir.open_branch())
+        source = MemoryTree.create_on_branch(sourcedir.open_branch())
         rev2 = source.commit('rev 2')
-        branch.Branch.hooks.install_named_hook(
-            'post_push', self.capture_post_push_hook, None)
+        Branch.hooks.install_named_hook('post_push',
+                                        self.capture_post_push_hook, None)
         source.branch.push(target.branch)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
@@ -375,7 +375,7 @@
             self.hook_calls)
 
 
-class EmptyPushSmartEffortTests(per_branch.TestCaseWithBranch):
+class EmptyPushSmartEffortTests(TestCaseWithBranch):
     """Tests that a push of 0 revisions should make a limited number of smart
     protocol RPCs.
     """
@@ -393,7 +393,7 @@
         super(EmptyPushSmartEffortTests, self).setUp()
         # Create a smart server that publishes whatever the backing VFS server
         # does.
-        self.smart_server = test_server.SmartTCPServer_for_testing()
+        self.smart_server = server.SmartTCPServer_for_testing()
         self.start_server(self.smart_server, self.get_server())
         # Make two empty branches, 'empty' and 'target'.
         self.empty_branch = self.make_branch('empty')
@@ -409,12 +409,12 @@
     def test_empty_branch_api(self):
         """The branch_obj.push API should make a limited number of HPSS calls.
         """
-        t = transport.get_transport(self.smart_server.get_url()).clone('target')
-        target = branch.Branch.open_from_transport(t)
+        transport = get_transport(self.smart_server.get_url()).clone('target')
+        target = Branch.open_from_transport(transport)
         self.empty_branch.push(target)
         self.assertEqual(
             ['BzrDir.open_2.1',
-             'BzrDir.open_branchV3',
+             'BzrDir.open_branchV2',
              'BzrDir.find_repositoryV3',
              'Branch.get_stacked_on_url',
              'Branch.lock_write',
@@ -437,11 +437,11 @@
         self.assertTrue(len(self.hpss_calls) <= 9, self.hpss_calls)
 
 
-class TestLossyPush(per_branch.TestCaseWithBranch):
+class TestLossyPush(TestCaseWithBranch):
 
     def setUp(self):
         self.hook_calls = []
-        super(TestLossyPush, self).setUp()
+        TestCaseWithBranch.setUp(self)
 
     def test_lossy_push_raises_same_vcs(self):
         target = self.make_branch('target')

=== modified file 'bzrlib/tests/per_branch/test_revision_history.py'
--- bzrlib/tests/per_branch/test_revision_history.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_revision_history.py	2009-07-10 05:49:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,10 +21,10 @@
     errors,
     revision as _mod_revision,
     )
-from bzrlib.tests import per_branch
-
-
-class TestLastRevision(per_branch.TestCaseWithBranch):
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+
+
+class TestLastRevision(TestCaseWithBranch):
     """Tests for the last_revision property of the branch.
     """
 
@@ -47,7 +47,7 @@
         ##         br.set_last_revision_info, 4, 'current:')
 
 
-class TestRevisionHistoryCaching(per_branch.TestCaseWithBranch):
+class TestRevisionHistoryCaching(TestCaseWithBranch):
     """Tests for the caching of branches' revision_history.
 
     When locked, branches should avoid regenerating or rereading
@@ -201,7 +201,7 @@
             branch.unlock()
 
 
-class TestRevisionHistory(per_branch.TestCaseWithBranch):
+class TestRevisionHistory(TestCaseWithBranch):
 
     def test_parent_ghost(self):
         tree = self.make_branch_and_tree('tree')

=== modified file 'bzrlib/tests/per_branch/test_tags.py'
--- bzrlib/tests/per_branch/test_tags.py	2010-03-12 02:14:56 +0000
+++ bzrlib/tests/per_branch/test_tags.py	2009-07-10 10:46:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,26 +20,29 @@
 1:1 with Branch implementations so can be tested from here.
 """
 
-from bzrlib import (
-    branch,
-    bzrdir,
-    errors,
-    repository,
-    tests,
-    )
-from bzrlib.tests import per_branch
-
-
-class TestBranchTags(per_branch.TestCaseWithBranch):
+import os
+import re
+import sys
+
+import bzrlib
+from bzrlib import bzrdir, errors, repository
+from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
+from bzrlib.trace import mutter
+from bzrlib.workingtree import WorkingTree
+
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+
+
+class TestBranchTags(TestCaseWithBranch):
 
     def setUp(self):
-        super(TestBranchTags, self).setUp()
+        TestCaseWithBranch.setUp(self)
         # formats that don't support tags can skip the rest of these
         # tests...
         branch = self.make_branch('probe')
         if not branch._format.supports_tags():
-            raise tests.TestSkipped(
-                "format %s doesn't support tags" % branch._format)
+            raise TestSkipped("format %s doesn't support tags" % branch._format)
 
     def test_tags_initially_empty(self):
         b = self.make_branch('b')
@@ -51,7 +54,7 @@
         b.tags.set_tag('tag-name', 'target-revid-1')
         b.tags.set_tag('other-name', 'target-revid-2')
         # then reopen the branch and see they're still there
-        b = branch.Branch.open('b')
+        b = Branch.open('b')
         self.assertEqual(b.tags.get_tag_dict(),
             {'tag-name': 'target-revid-1',
              'other-name': 'target-revid-2',
@@ -68,7 +71,7 @@
         b.tags.set_tag('tag-name', 'target-revid-1')
         b.tags.set_tag('other-name', 'target-revid-2')
         # then reopen the branch and check reverse map id->tags list
-        b = branch.Branch.open('b')
+        b = Branch.open('b')
         self.assertEqual(b.tags.get_reverse_tag_dict(),
             {'target-revid-1': ['tag-name'],
              'target-revid-2': ['other-name'],
@@ -144,15 +147,15 @@
         b1.tags.merge_to(b2.tags)
 
 
-class TestUnsupportedTags(per_branch.TestCaseWithBranch):
+class TestUnsupportedTags(TestCaseWithBranch):
     """Formats that don't support tags should give reasonable errors."""
 
     def setUp(self):
-        super(TestUnsupportedTags, self).setUp()
+        TestCaseWithBranch.setUp(self)
         branch = self.make_branch('probe')
         if branch._format.supports_tags():
-            raise tests.TestSkipped("Format %s declares that tags are supported"
-                                    % branch._format)
+            raise TestSkipped("Format %s declares that tags are supported"
+                              % branch._format)
             # it's covered by TestBranchTags
 
     def test_tag_methods_raise(self):
@@ -171,54 +174,3 @@
         b1 = self.make_branch('b1')
         b2 = self.make_branch('b2')
         b1.tags.merge_to(b2.tags)
-
-
-class AutomaticTagNameTests(per_branch.TestCaseWithBranch):
-
-    def setUp(self):
-        super(AutomaticTagNameTests, self).setUp()
-        if isinstance(self.branch_format, branch.BranchReferenceFormat):
-            # This test could in principle apply to BranchReferenceFormat, but
-            # make_branch_builder doesn't support it.
-            raise tests.TestSkipped(
-                "BranchBuilder can't make reference branches.")
-        self.builder = self.make_branch_builder('.')
-        self.builder.build_snapshot('foo', None,
-            [('add', ('', None, 'directory', None))],
-            message='foo')
-        self.branch = self.builder.get_branch()
-        if not self.branch._format.supports_tags():
-            raise tests.TestSkipped(
-                "format %s doesn't support tags" % self.branch._format)
-
-    def test_no_functions(self):
-        rev = self.branch.last_revision()
-        self.assertEquals(None, self.branch.automatic_tag_name(rev))
-
-    def test_returns_tag_name(self):
-        def get_tag_name(br, revid):
-            return "foo"
-        branch.Branch.hooks.install_named_hook('automatic_tag_name',
-            get_tag_name, 'get tag name foo')
-        self.assertEquals("foo", self.branch.automatic_tag_name(
-            self.branch.last_revision()))
-    
-    def test_uses_first_return(self):
-        get_tag_name_1 = lambda br, revid: "foo1"
-        get_tag_name_2 = lambda br, revid: "foo2"
-        branch.Branch.hooks.install_named_hook('automatic_tag_name',
-            get_tag_name_1, 'tagname1')
-        branch.Branch.hooks.install_named_hook('automatic_tag_name',
-            get_tag_name_2, 'tagname2')
-        self.assertEquals("foo1", self.branch.automatic_tag_name(
-            self.branch.last_revision()))
-
-    def test_ignores_none(self):
-        get_tag_name_1 = lambda br, revid: None
-        get_tag_name_2 = lambda br, revid: "foo2"
-        branch.Branch.hooks.install_named_hook('automatic_tag_name',
-            get_tag_name_1, 'tagname1')
-        branch.Branch.hooks.install_named_hook('automatic_tag_name',
-            get_tag_name_2, 'tagname2')
-        self.assertEquals("foo2", self.branch.automatic_tag_name(
-            self.branch.last_revision()))

=== modified file 'bzrlib/tests/per_branch/test_uncommit.py'
--- bzrlib/tests/per_branch/test_uncommit.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_uncommit.py	2009-07-10 05:49:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,19 +19,17 @@
 Note that uncommit currently is not a branch method; it should be.
 """
 
-from bzrlib import (
-    branch,
-    errors,
-    uncommit,
-    )
-from bzrlib.tests import per_branch
-
-
-class TestUncommitHook(per_branch.TestCaseWithBranch):
+from bzrlib.branch import Branch
+from bzrlib import errors
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
+from bzrlib.uncommit import uncommit
+
+
+class TestUncommitHook(TestCaseWithBranch):
 
     def setUp(self):
         self.hook_calls = []
-        super(TestUncommitHook, self).setUp()
+        TestCaseWithBranch.setUp(self)
 
     def capture_post_uncommit_hook(self, local, master, old_revno,
         old_revid, new_revno, new_revid):
@@ -55,9 +53,9 @@
         tree.add('')
         revid = tree.commit('a revision')
         tree.unlock()
-        branch.Branch.hooks.install_named_hook('post_uncommit',
+        Branch.hooks.install_named_hook('post_uncommit',
             self.capture_post_uncommit_hook, None)
-        uncommit.uncommit(tree.branch)
+        uncommit(tree.branch)
         # with nothing left we should still get a notification, and
         # have the branch locked at notification time.
         self.assertEqual([
@@ -78,9 +76,9 @@
         tree.add('')
         revid = tree.commit('a revision')
         tree.unlock()
-        branch.Branch.hooks.install_named_hook(
-            'post_uncommit', self.capture_post_uncommit_hook, None)
-        uncommit.uncommit(tree.branch)
+        Branch.hooks.install_named_hook('post_uncommit',
+            self.capture_post_uncommit_hook, None)
+        uncommit(tree.branch)
         # with nothing left we should still get a notification, and
         # have the branch locked at notification time.
         self.assertEqual([
@@ -97,9 +95,9 @@
         revid2 = tree.commit('second revision')
         revid3 = tree.commit('third revision')
         tree.unlock()
-        branch.Branch.hooks.install_named_hook(
-            'post_uncommit', self.capture_post_uncommit_hook, None)
-        uncommit.uncommit(tree.branch, revno=2)
+        Branch.hooks.install_named_hook('post_uncommit',
+            self.capture_post_uncommit_hook, None)
+        uncommit(tree.branch, revno=2)
         # having uncommitted from up the branch, we should get the
         # before and after revnos and revids correctly.
         self.assertEqual([

=== modified file 'bzrlib/tests/per_branch/test_update.py'
--- bzrlib/tests/per_branch/test_update.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_update.py	2009-07-10 05:49:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,13 +19,13 @@
     errors,
     revision as _mod_revision,
     )
-from bzrlib.tests import per_branch
+from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
 
 
 """Tests for branch.update()"""
 
 
-class TestUpdate(per_branch.TestCaseWithBranch):
+class TestUpdate(TestCaseWithBranch):
 
     def test_update_unbound_works(self):
         b = self.make_branch('.')
@@ -69,7 +69,7 @@
         self.assertEqual(['bar'], child_tree.branch.revision_history())
 
 
-class TestUpdateRevisions(per_branch.TestCaseWithBranch):
+class TestUpdateRevisions(TestCaseWithBranch):
 
     def test_accepts_graph(self):
         # An implementation may not use it, but it should allow a 'graph' to be

=== modified file 'bzrlib/tests/per_bzrdir/__init__.py'
--- bzrlib/tests/per_bzrdir/__init__.py	2010-02-11 09:21:45 +0000
+++ bzrlib/tests/per_bzrdir/__init__.py	2009-07-10 06:45:04 +0000
@@ -26,12 +26,11 @@
 
 from bzrlib.bzrdir import BzrDirFormat
 from bzrlib.tests import (
-    default_transport,
-    multiply_tests,
-    test_server,
-    TestCaseWithTransport,
-    )
-from bzrlib.transport import memory
+                          default_transport,
+                          multiply_tests,
+                          TestCaseWithTransport,
+                          )
+from bzrlib.transport.memory import MemoryServer
 
 
 def make_scenarios(vfs_factory, transport_server, transport_readonly_server,
@@ -89,20 +88,26 @@
         None,
         formats)
     # This will always add scenarios using the smart server.
+    from bzrlib.smart.server import (
+        ReadonlySmartTCPServer_for_testing,
+        ReadonlySmartTCPServer_for_testing_v2_only,
+        SmartTCPServer_for_testing,
+        SmartTCPServer_for_testing_v2_only,
+        )
     from bzrlib.remote import RemoteBzrDirFormat
     # test the remote server behaviour when backed with a MemoryTransport
     # Once for the current version
     scenarios.extend(make_scenarios(
-        memory.MemoryServer,
-        test_server.SmartTCPServer_for_testing,
-        test_server.ReadonlySmartTCPServer_for_testing,
+        MemoryServer,
+        SmartTCPServer_for_testing,
+        ReadonlySmartTCPServer_for_testing,
         [(RemoteBzrDirFormat())],
         name_suffix='-default'))
     # And once with < 1.6 - the 'v2' protocol.
     scenarios.extend(make_scenarios(
-        memory.MemoryServer,
-        test_server.SmartTCPServer_for_testing_v2_only,
-        test_server.ReadonlySmartTCPServer_for_testing_v2_only,
+        MemoryServer,
+        SmartTCPServer_for_testing_v2_only,
+        ReadonlySmartTCPServer_for_testing_v2_only,
         [(RemoteBzrDirFormat())],
         name_suffix='-v2'))
     # add the tests for the sub modules

=== modified file 'bzrlib/tests/per_bzrdir/test_bzrdir.py'
--- bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-04-21 04:02:42 +0000
+++ bzrlib/tests/per_bzrdir/test_bzrdir.py	2009-11-18 17:10:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,6 +21,7 @@
 from itertools import izip
 import os
 from stat import S_ISDIR
+import sys
 
 import bzrlib.branch
 from bzrlib import (
@@ -247,7 +248,7 @@
         try:
             bzrdir.destroy_branch()
         except (errors.UnsupportedOperation, errors.TransportNotPossible):
-            raise TestNotApplicable('Format does not support destroying branch')
+            raise TestNotApplicable('Format does not support destroying tree')
         self.assertRaises(errors.NotBranchError, bzrdir.open_branch)
         bzrdir.create_branch()
         bzrdir.open_branch()
@@ -523,7 +524,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_branch)
+                referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -626,7 +627,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_branch)
+                referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -691,7 +692,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_branch)
+                referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -966,7 +967,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_branch)
+                referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -986,7 +987,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_tree.branch)
+                referenced_tree.branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1012,7 +1013,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_tree.branch)
+                referenced_tree.branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1077,7 +1078,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_branch)
+                referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1103,7 +1104,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                target_branch=referenced_branch)
+                referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1175,13 +1176,6 @@
             # because the default open will not open them and
             # they may not be initializable.
             return
-        # for remote formats, there must be no prior assumption about the
-        # network name to use - it's possible that this may somehow have got
-        # in through an unisolated test though - see
-        # <https://bugs.edge.launchpad.net/bzr/+bug/504102>
-        self.assertEquals(getattr(self.bzrdir_format,
-            '_network_name', None),
-            None)
         # supported formats must be able to init and open
         t = get_transport(self.get_url())
         readonly_t = get_transport(self.get_readonly_url())
@@ -1425,26 +1419,6 @@
         self.failUnless(isinstance(opened_branch, made_branch.__class__))
         self.failUnless(isinstance(opened_branch._format, made_branch._format.__class__))
 
-    def test_list_branches(self):
-        if not self.bzrdir_format.is_supported():
-            # unsupported formats are not loopback testable
-            # because the default open will not open them and
-            # they may not be initializable.
-            return
-        t = get_transport(self.get_url())
-        made_control = self.bzrdir_format.initialize(t.base)
-        made_repo = made_control.create_repository()
-        made_branch = made_control.create_branch()
-        branches = made_control.list_branches()
-        self.assertEquals(1, len(branches))
-        self.assertEquals(made_branch.base, branches[0].base)
-        try:
-            made_control.destroy_branch()
-        except errors.UnsupportedOperation:
-            pass # Not all bzrdirs support destroying directories
-        else:
-            self.assertEquals([], made_control.list_branches())
-
     def test_create_repository(self):
         # a bzrdir can construct a repository for itself.
         if not self.bzrdir_format.is_supported():
@@ -1816,6 +1790,17 @@
 
 class TestBreakLock(TestCaseWithBzrDir):
 
+    def setUp(self):
+        super(TestBreakLock, self).setUp()
+        # we want a UI factory that accepts canned input for the tests:
+        # while SilentUIFactory still accepts stdin, we need to customise
+        # ours
+        self.old_factory = bzrlib.ui.ui_factory
+        self.addCleanup(self.restoreFactory)
+
+    def restoreFactory(self):
+        bzrlib.ui.ui_factory = self.old_factory
+
     def test_break_lock_empty(self):
         # break lock on an empty bzrdir should work silently.
         dir = self.make_bzrdir('.')
@@ -1858,7 +1843,7 @@
         thisdir = self.make_bzrdir('this')
         try:
             bzrlib.branch.BranchReferenceFormat().initialize(
-                thisdir, target_branch=master)
+                thisdir, master)
         except errors.IncompatibleFormat:
             return
         unused_repo = thisdir.create_repository()
@@ -1971,15 +1956,3 @@
         self.assertRaises(errors.NoRepositoryPresent,
                           made_control.find_repository)
 
-
-class TestBzrDirControlComponent(TestCaseWithBzrDir):
-    """BzrDir implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        bd = self.make_bzrdir('bd')
-        self.assertIsInstance(bd.user_url, str)
-        self.assertEqual(bd.user_url, bd.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(bd.control_url.find(bd.user_url), 0)
-        self.assertEqual(bd.control_url, bd.control_transport.base)

=== removed directory 'bzrlib/tests/per_bzrdir_colo'
=== removed file 'bzrlib/tests/per_bzrdir_colo/__init__.py'
--- bzrlib/tests/per_bzrdir_colo/__init__.py	2010-04-12 00:34:15 +0000
+++ bzrlib/tests/per_bzrdir_colo/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,56 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-
-"""BzrDir implementation tests for colocated branch support.
-
-These tests check the conformance of the colocated branches support.
-All bzrdir formats are tested - those that do not suppport colocated branches 
-have the test_unsupported tests run; the others have the test_supported tests
-run.
-"""
-
-from bzrlib.bzrdir import BzrDirFormat
-from bzrlib.tests import (
-    default_transport,
-    multiply_tests,
-    )
-from bzrlib.tests.per_bzrdir import (
-    TestCaseWithBzrDir,
-    make_scenarios,
-    )
-
-
-def load_tests(standard_tests, module, loader):
-    colo_supported_formats = []
-    colo_unsupported_formats = []
-    for format in BzrDirFormat.known_formats():
-        if format.colocated_branches:
-            colo_supported_formats.append(format)
-        else:
-            colo_unsupported_formats.append(format)
-    supported_scenarios = make_scenarios(default_transport, None, None,
-        colo_supported_formats)
-    unsupported_scenarios = make_scenarios(default_transport, None, None,
-        colo_unsupported_formats)
-    result = loader.suiteClass()
-    supported_tests = loader.loadTestsFromModuleNames([
-        'bzrlib.tests.per_bzrdir_colo.test_supported'])
-    unsupported_tests = loader.loadTestsFromModuleNames([
-        'bzrlib.tests.per_bzrdir_colo.test_unsupported'])
-    multiply_tests(supported_tests, supported_scenarios, result)
-    multiply_tests(unsupported_tests, unsupported_scenarios, result)
-    return result

=== removed file 'bzrlib/tests/per_bzrdir_colo/test_supported.py'
--- bzrlib/tests/per_bzrdir_colo/test_supported.py	2010-04-11 19:45:48 +0000
+++ bzrlib/tests/per_bzrdir_colo/test_supported.py	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr directories that support colocated branches."""
-
-import bzrlib.branch
-from bzrlib import errors
-from bzrlib.tests import (
-    TestNotApplicable,
-    )
-from bzrlib.transport import (
-    get_transport,
-    )
-
-from bzrlib.tests.per_bzrdir_colo import (
-    TestCaseWithBzrDir,
-    )
-
-
-class TestColocatedBranchSupport(TestCaseWithBzrDir):
-
-    def test_destroy_colocated_branch(self):
-        branch = self.make_branch('branch')
-        bzrdir = branch.bzrdir
-        colo_branch = bzrdir.create_branch('colo')
-        bzrdir.destroy_branch("colo")
-        self.assertRaises(errors.NotBranchError, bzrdir.open_branch, 
-                          "colo")
-
-    def test_create_colo_branch(self):
-        # a bzrdir can construct a branch and repository for itself.
-        if not self.bzrdir_format.is_supported():
-            # unsupported formats are not loopback testable
-            # because the default open will not open them and
-            # they may not be initializable.
-            raise TestNotApplicable('Control dir format not supported')
-        t = get_transport(self.get_url())
-        try:
-            made_control = self.bzrdir_format.initialize(t.base)
-        except errors.UninitializableFormat:
-            raise TestNotApplicable('Control dir does not support creating '
-                'new branches.')
-        made_repo = made_control.create_repository()
-        made_branch = made_control.create_branch("colo")
-        self.failUnless(isinstance(made_branch, bzrlib.branch.Branch))
-        self.assertEqual(made_control, made_branch.bzrdir)

=== removed file 'bzrlib/tests/per_bzrdir_colo/test_unsupported.py'
--- bzrlib/tests/per_bzrdir_colo/test_unsupported.py	2010-04-11 19:40:23 +0000
+++ bzrlib/tests/per_bzrdir_colo/test_unsupported.py	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bazaar control directories that do not support colocated branches.
-
-Colocated branch support is optional, and when it is not supported the methods 
-and attributes colocated branch support added should fail in known ways.
-"""
-
-from bzrlib import errors
-from bzrlib.tests import (
-    TestNotApplicable,
-    )
-from bzrlib.transport import (
-    get_transport,
-    )
-
-from bzrlib.tests.per_bzrdir_colo import (
-    TestCaseWithBzrDir,
-    )
-
-
-class TestNoColocatedSupport(TestCaseWithBzrDir):
-
-    def test_destroy_colocated_branch(self):
-        branch = self.make_branch('branch')
-        # Colocated branches should not be supported *or* 
-        # destroy_branch should not be supported at all
-        self.assertRaises(
-            (errors.NoColocatedBranchSupport, errors.UnsupportedOperation),
-            branch.bzrdir.destroy_branch, 'colo')
-
-    def test_create_colo_branch(self):
-        # a bzrdir can construct a branch and repository for itself.
-        if not self.bzrdir_format.is_supported():
-            # unsupported formats are not loopback testable
-            # because the default open will not open them and
-            # they may not be initializable.
-            raise TestNotApplicable('Control dir format not supported')
-        t = get_transport(self.get_url())
-        made_control = self.bzrdir_format.initialize(t.base)
-        made_repo = made_control.create_repository()
-        self.assertRaises(errors.NoColocatedBranchSupport, 
-            made_control.create_branch, "colo")
-
-

=== modified file 'bzrlib/tests/per_foreign_vcs/__init__.py'
--- bzrlib/tests/per_foreign_vcs/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_foreign_vcs/__init__.py	2009-11-12 22:57:55 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_foreign_vcs/test_repository.py'
--- bzrlib/tests/per_foreign_vcs/test_repository.py	2010-03-03 22:59:21 +0000
+++ bzrlib/tests/per_foreign_vcs/test_repository.py	2009-11-27 03:25:07 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_interbranch/test_push.py'
--- bzrlib/tests/per_interbranch/test_push.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_interbranch/test_push.py	2009-08-20 04:09:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -40,7 +40,7 @@
     TestCaseWithInterBranch,
     )
 from bzrlib.transport import get_transport
-from bzrlib.tests import test_server
+from bzrlib.transport.local import LocalURLServer
 
 
 # These tests are based on similar tests in 
@@ -155,7 +155,7 @@
         try:
             tree = a_branch.bzrdir.create_workingtree()
         except errors.NotLocalUrl:
-            if self.vfs_transport_factory is test_server.LocalURLServer:
+            if self.vfs_transport_factory is LocalURLServer:
                 # the branch is colocated on disk, we cannot create a checkout.
                 # hopefully callers will expect this.
                 local_controldir = bzrdir.BzrDir.open(self.get_vfs_only_url('repo/tree'))
@@ -255,6 +255,7 @@
         builder.build_snapshot('third', ['second'], [])
         builder.build_snapshot('fourth', ['third'], [])
         builder.finish_series()
+        local = builder.get_branch()
         local = branch.Branch.open(self.get_vfs_only_url('local'))
         # Initial push of three revisions
         remote_bzrdir = local.bzrdir.sprout(
@@ -280,10 +281,15 @@
     def disableOptimisticGetParentMap(self):
         # Tweak some class variables to stop remote get_parent_map calls asking
         # for or receiving more data than the caller asked for.
-        self.overrideAttr(repository.InterRepository,
-                          '_walk_to_common_revisions_batch_size', 1)
-        self.overrideAttr(SmartServerRepositoryGetParentMap,
-                            'no_extra_results', True)
+        old_flag = SmartServerRepositoryGetParentMap.no_extra_results
+        inter_class = repository.InterRepository
+        old_batch_size = inter_class._walk_to_common_revisions_batch_size
+        inter_class._walk_to_common_revisions_batch_size = 1
+        SmartServerRepositoryGetParentMap.no_extra_results = True
+        def reset_values():
+            SmartServerRepositoryGetParentMap.no_extra_results = old_flag
+            inter_class._walk_to_common_revisions_batch_size = old_batch_size
+        self.addCleanup(reset_values)
 
 
 class TestPushHook(TestCaseWithInterBranch):

=== modified file 'bzrlib/tests/per_interrepository/test_fetch.py'
--- bzrlib/tests/per_interrepository/test_fetch.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/per_interrepository/test_fetch.py	2009-10-02 02:40:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -515,7 +515,7 @@
         from_tree.commit('foo', rev_id='foo-id')
         to_repo = self.make_to_repository('to')
         to_repo.fetch(from_tree.branch.repository)
-        recorded_inv_sha1 = to_repo.get_revision('foo-id').inventory_sha1
+        recorded_inv_sha1 = to_repo.get_inventory_sha1('foo-id')
         to_repo.lock_read()
         self.addCleanup(to_repo.unlock)
         stream = to_repo.inventories.get_record_stream([('foo-id',)],

=== modified file 'bzrlib/tests/per_intertree/__init__.py'
--- bzrlib/tests/per_intertree/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_intertree/__init__.py	2009-11-12 23:10:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_merger.py'
--- bzrlib/tests/per_merger.py	2010-03-05 08:55:12 +0000
+++ bzrlib/tests/per_merger.py	2009-12-18 06:54:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,6 @@
 
 import os
 
-from bzrlib.conflicts import TextConflict
 from bzrlib import (
     errors,
     merge as _mod_merge,
@@ -29,7 +28,6 @@
     multiply_tests,
     TestCaseWithTransport,
     )
-from bzrlib.tests.test_merge_core import MergeBuilder
 from bzrlib.transform import TreeTransform
 
 
@@ -46,7 +44,7 @@
 class TestMergeImplementation(TestCaseWithTransport):
 
     def do_merge(self, target_tree, source_tree, **kwargs):
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             target_tree, source_tree.last_revision(),
             other_branch=source_tree.branch)
         merger.merge_type=self.merge_type
@@ -142,8 +140,7 @@
         this_tree = branch.bzrdir.create_workingtree()
         this_tree.lock_write()
         self.addCleanup(this_tree.unlock)
-        other_tree = this_tree.bzrdir.sprout('other',
-                                             'OTHER-id').open_workingtree()
+        other_tree = this_tree.bzrdir.sprout('other', 'OTHER-id').open_workingtree()
         self.do_merge(this_tree, other_tree)
         if self.merge_type is _mod_merge.LCAMerger:
             self.expectFailure("lca merge doesn't track deleted lines",
@@ -175,7 +172,7 @@
         deletiondir = transform._deletiondir
         transform.finalize()
         return (limbodir, deletiondir)
-
+    
     def test_merge_with_existing_limbo(self):
         wt = self.make_branch_and_tree('this')
         (limbodir, deletiondir) =  self.get_limbodir_deletiondir(wt)
@@ -191,213 +188,4 @@
         self.assertRaises(errors.LockError, wt.unlock)
 
 
-class TestHookMergeFileContent(TestCaseWithTransport):
-    """Tests that the 'merge_file_content' hook is invoked."""
-
-    def setUp(self):
-        TestCaseWithTransport.setUp(self)
-        self.hook_log = []
-
-    def install_hook_inactive(self):
-        def inactive_factory(merger):
-            # This hook is never active
-            self.hook_log.append(('inactive',))
-            return None
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', inactive_factory, 'test hook (inactive)')
-
-    def install_hook_noop(self):
-        test = self
-        class HookNA(_mod_merge.AbstractPerFileMerger):
-            def merge_contents(self, merge_params):
-                # This hook unconditionally does nothing.
-                test.hook_log.append(('no-op',))
-                return 'not_applicable', None
-        def hook_na_factory(merger):
-            return HookNA(merger)
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', hook_na_factory, 'test hook (no-op)')
-
-    def install_hook_success(self):
-        test = self
-        class HookSuccess(_mod_merge.AbstractPerFileMerger):
-            def merge_contents(self, merge_params):
-                test.hook_log.append(('success',))
-                if merge_params.file_id == '1':
-                    return 'success', ['text-merged-by-hook']
-                return 'not_applicable', None
-        def hook_success_factory(merger):
-            return HookSuccess(merger)
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', hook_success_factory, 'test hook (success)')
-
-    def install_hook_conflict(self):
-        test = self
-        class HookConflict(_mod_merge.AbstractPerFileMerger):
-            def merge_contents(self, merge_params):
-                test.hook_log.append(('conflict',))
-                if merge_params.file_id == '1':
-                    return ('conflicted',
-                        ['text-with-conflict-markers-from-hook'])
-                return 'not_applicable', None
-        def hook_conflict_factory(merger):
-            return HookConflict(merger)
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', hook_conflict_factory, 'test hook (delete)')
-
-    def install_hook_delete(self):
-        test = self
-        class HookDelete(_mod_merge.AbstractPerFileMerger):
-            def merge_contents(self, merge_params):
-                test.hook_log.append(('delete',))
-                if merge_params.file_id == '1':
-                    return 'delete', None
-                return 'not_applicable', None
-        def hook_delete_factory(merger):
-            return HookDelete(merger)
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', hook_delete_factory, 'test hook (delete)')
-
-    def install_hook_log_lines(self):
-        """Install a hook that saves the get_lines for the this, base and other
-        versions of the file.
-        """
-        test = self
-        class HookLogLines(_mod_merge.AbstractPerFileMerger):
-            def merge_contents(self, merge_params):
-                test.hook_log.append((
-                    'log_lines',
-                    merge_params.this_lines,
-                    merge_params.other_lines,
-                    merge_params.base_lines,
-                    ))
-                return 'not_applicable', None
-        def hook_log_lines_factory(merger):
-            return HookLogLines(merger)
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', hook_log_lines_factory,
-            'test hook (log_lines)')
-
-    def make_merge_builder(self):
-        builder = MergeBuilder(self.test_base_dir)
-        self.addCleanup(builder.cleanup)
-        return builder
-
-    def create_file_needing_contents_merge(self, builder, file_id):
-        builder.add_file(file_id, builder.tree_root, "name1", "text1", True)
-        builder.change_contents(file_id, other="text4", this="text3")
-
-    def test_change_vs_change(self):
-        """Hook is used for (changed, changed)"""
-        self.install_hook_success()
-        builder = self.make_merge_builder()
-        builder.add_file("1", builder.tree_root, "name1", "text1", True)
-        builder.change_contents("1", other="text4", this="text3")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(conflicts, [])
-        self.assertEqual(
-            builder.this.get_file('1').read(), 'text-merged-by-hook')
-
-    def test_change_vs_deleted(self):
-        """Hook is used for (changed, deleted)"""
-        self.install_hook_success()
-        builder = self.make_merge_builder()
-        builder.add_file("1", builder.tree_root, "name1", "text1", True)
-        builder.change_contents("1", this="text2")
-        builder.remove_file("1", other=True)
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(conflicts, [])
-        self.assertEqual(
-            builder.this.get_file('1').read(), 'text-merged-by-hook')
-
-    def test_result_can_be_delete(self):
-        """A hook's result can be the deletion of a file."""
-        self.install_hook_delete()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(conflicts, [])
-        self.assertRaises(errors.NoSuchId, builder.this.id2path, '1')
-        self.assertEqual([], list(builder.this.list_files()))
-
-    def test_result_can_be_conflict(self):
-        """A hook's result can be a conflict."""
-        self.install_hook_conflict()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(conflicts, [TextConflict('name1', file_id='1')])
-        # The hook still gets to set the file contents in this case, so that it
-        # can insert custom conflict markers.
-        self.assertEqual(
-            builder.this.get_file('1').read(),
-            'text-with-conflict-markers-from-hook')
-
-    def test_can_access_this_other_and_base_versions(self):
-        """The hook function can call params.merger.get_lines to access the
-        THIS/OTHER/BASE versions of the file.
-        """
-        self.install_hook_log_lines()
-        builder = self.make_merge_builder()
-        builder.add_file("1", builder.tree_root, "name1", "text1", True)
-        builder.change_contents("1", this="text2", other="text3")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(
-            [('log_lines', ['text2'], ['text3'], ['text1'])], self.hook_log)
-
-    def test_chain_when_not_active(self):
-        """When a hook function returns None, merging still works."""
-        self.install_hook_inactive()
-        self.install_hook_success()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(conflicts, [])
-        self.assertEqual(
-            builder.this.get_file('1').read(), 'text-merged-by-hook')
-        self.assertEqual([('inactive',), ('success',)], self.hook_log)
-
-    def test_chain_when_not_applicable(self):
-        """When a hook function returns not_applicable, the next function is
-        tried (when one exists).
-        """
-        self.install_hook_noop()
-        self.install_hook_success()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual(conflicts, [])
-        self.assertEqual(
-            builder.this.get_file('1').read(), 'text-merged-by-hook')
-        self.assertEqual([('no-op',), ('success',)], self.hook_log)
-
-    def test_chain_stops_after_success(self):
-        """When a hook function returns success, no later functions are tried.
-        """
-        self.install_hook_success()
-        self.install_hook_noop()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual([('success',)], self.hook_log)
-
-    def test_chain_stops_after_conflict(self):
-        """When a hook function returns conflict, no later functions are tried.
-        """
-        self.install_hook_conflict()
-        self.install_hook_noop()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual([('conflict',)], self.hook_log)
-
-    def test_chain_stops_after_delete(self):
-        """When a hook function returns delete, no later functions are tried.
-        """
-        self.install_hook_delete()
-        self.install_hook_noop()
-        builder = self.make_merge_builder()
-        self.create_file_needing_contents_merge(builder, "1")
-        conflicts = builder.merge(self.merge_type)
-        self.assertEqual([('delete',)], self.hook_log)
 

=== modified file 'bzrlib/tests/per_pack_repository.py'
--- bzrlib/tests/per_pack_repository.py	2010-03-18 05:24:02 +0000
+++ bzrlib/tests/per_pack_repository.py	2010-01-04 02:25:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -45,6 +45,7 @@
 from bzrlib.repofmt.groupcompress_repo import RepositoryFormat2a
 from bzrlib.smart import (
     client,
+    server,
     )
 from bzrlib.tests import (
     TestCase,
@@ -53,10 +54,10 @@
     TestSkipped,
     )
 from bzrlib.transport import (
+    fakenfs,
+    memory,
     get_transport,
-    memory,
     )
-from bzrlib.tests import test_server
 from bzrlib.tests.per_repository import TestCaseWithRepository
 
 
@@ -239,7 +240,7 @@
 
     def test_commit_write_group_returns_new_pack_names(self):
         # This test doesn't need real disk.
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = tests.MemoryServer
         format = self.get_format()
         repo = self.make_repository('foo', format=format)
         repo.lock_write()
@@ -276,7 +277,7 @@
     def test_fail_obsolete_deletion(self):
         # failing to delete obsolete packs is not fatal
         format = self.get_format()
-        server = test_server.FakeNFSServer()
+        server = fakenfs.FakeNFSServer()
         self.start_server(server)
         transport = get_transport(server.get_url())
         bzrdir = self.get_format().initialize_on_transport(transport)
@@ -288,23 +289,6 @@
         repo._pack_collection._clear_obsolete_packs()
         self.assertTrue(repo_transport.has('obsolete_packs/.nfsblahblah'))
 
-    def test_pack_collection_sets_sibling_indices(self):
-        """The CombinedGraphIndex objects in the pack collection are all
-        siblings of each other, so that search-order reorderings will be copied
-        to each other.
-        """
-        repo = self.make_repository('repo')
-        pack_coll = repo._pack_collection
-        indices = set([pack_coll.revision_index, pack_coll.inventory_index,
-                pack_coll.text_index, pack_coll.signature_index])
-        if pack_coll.chk_index is not None:
-            indices.add(pack_coll.chk_index)
-        combined_indices = set(idx.combined_index for idx in indices)
-        for combined_index in combined_indices:
-            self.assertEqual(
-                combined_indices.difference([combined_index]),
-                combined_index._sibling_indices)
-
     def test_pack_after_two_commits_packs_everything(self):
         format = self.get_format()
         tree = self.make_branch_and_tree('.', format=format)
@@ -606,6 +590,10 @@
     def prepare_for_break_lock(self):
         # Setup the global ui factory state so that a break-lock method call
         # will find usable input in the input stream.
+        old_factory = ui.ui_factory
+        def restoreFactory():
+            ui.ui_factory = old_factory
+        self.addCleanup(restoreFactory)
         ui.ui_factory = ui.CannedInputUIFactory([True])
 
     def test_break_lock_breaks_physical_lock(self):
@@ -1084,7 +1072,7 @@
         super(TestSmartServerAutopack, self).setUp()
         # Create a smart server that publishes whatever the backing VFS server
         # does.
-        self.smart_server = test_server.SmartTCPServer_for_testing()
+        self.smart_server = server.SmartTCPServer_for_testing()
         self.start_server(self.smart_server, self.get_server())
         # Log all HPSS calls into self.hpss_calls.
         client._SmartClient.hooks.install_named_hook(

=== modified file 'bzrlib/tests/per_repository/__init__.py'
--- bzrlib/tests/per_repository/__init__.py	2010-02-11 09:21:45 +0000
+++ bzrlib/tests/per_repository/__init__.py	2009-07-22 17:22:06 +0000
@@ -32,14 +32,19 @@
     weaverepo,
     )
 from bzrlib.remote import RemoteBzrDirFormat, RemoteRepositoryFormat
+from bzrlib.smart.server import (
+    ReadonlySmartTCPServer_for_testing,
+    ReadonlySmartTCPServer_for_testing_v2_only,
+    SmartTCPServer_for_testing,
+    SmartTCPServer_for_testing_v2_only,
+    )
 from bzrlib.tests import (
-    default_transport,
-    multiply_scenarios,
-    multiply_tests,
-    test_server,
-    )
+                          default_transport,
+                          multiply_scenarios,
+                          multiply_tests,
+                          )
 from bzrlib.tests.per_bzrdir.test_bzrdir import TestCaseWithBzrDir
-from bzrlib.transport import memory
+from bzrlib.transport.memory import MemoryServer
 
 
 def formats_to_scenarios(formats, transport_server, transport_readonly_server,
@@ -86,14 +91,14 @@
         None)
     format_scenarios.extend(formats_to_scenarios(
         [('-default', RemoteRepositoryFormat())],
-        test_server.SmartTCPServer_for_testing,
-        test_server.ReadonlySmartTCPServer_for_testing,
-        memory.MemoryServer))
+        SmartTCPServer_for_testing,
+        ReadonlySmartTCPServer_for_testing,
+        MemoryServer))
     format_scenarios.extend(formats_to_scenarios(
         [('-v2', RemoteRepositoryFormat())],
-        test_server.SmartTCPServer_for_testing_v2_only,
-        test_server.ReadonlySmartTCPServer_for_testing_v2_only,
-        memory.MemoryServer))
+        SmartTCPServer_for_testing_v2_only,
+        ReadonlySmartTCPServer_for_testing_v2_only,
+        MemoryServer))
     return format_scenarios
 
 

=== modified file 'bzrlib/tests/per_repository/test_break_lock.py'
--- bzrlib/tests/per_repository/test_break_lock.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_repository/test_break_lock.py	2009-06-23 08:43:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,20 +16,33 @@
 
 """Tests for repository break-lock."""
 
-from bzrlib import (
-    errors,
-    ui,
+from cStringIO import StringIO
+
+import bzrlib
+import bzrlib.errors as errors
+from bzrlib.tests.per_repository.test_repository import TestCaseWithRepository
+from bzrlib.transport import get_transport
+from bzrlib.workingtree import WorkingTree
+from bzrlib.ui import (
+    CannedInputUIFactory,
     )
-from bzrlib.tests import per_repository
-
-
-class TestBreakLock(per_repository.TestCaseWithRepository):
+
+
+class TestBreakLock(TestCaseWithRepository):
 
     def setUp(self):
         super(TestBreakLock, self).setUp()
         self.unused_repo = self.make_repository('.')
         self.repo = self.unused_repo.bzrdir.open_repository()
-        ui.ui_factory = ui.CannedInputUIFactory([True])
+        # we want a UI factory that accepts canned input for the tests:
+        # while SilentUIFactory still accepts stdin, we need to customise
+        # ours
+        self.old_factory = bzrlib.ui.ui_factory
+        self.addCleanup(self.restoreFactory)
+        bzrlib.ui.ui_factory = CannedInputUIFactory([True])
+
+    def restoreFactory(self):
+        bzrlib.ui.ui_factory = self.old_factory
 
     def test_unlocked(self):
         # break lock when nothing is locked should just return

=== modified file 'bzrlib/tests/per_repository/test_check.py'
--- bzrlib/tests/per_repository/test_check.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_repository/test_check.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_repository/test_check_reconcile.py'
--- bzrlib/tests/per_repository/test_check_reconcile.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_repository/test_check_reconcile.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_repository/test_commit_builder.py'
--- bzrlib/tests/per_repository/test_commit_builder.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_repository/test_commit_builder.py	2009-11-19 15:06:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,21 +16,24 @@
 
 """Tests for repository commit builder."""
 
+from copy import copy
+import errno
 import os
+import sys
 
 from bzrlib import (
     errors,
-    graph,
     inventory,
     osutils,
     repository,
     revision as _mod_revision,
     tests,
     )
-from bzrlib.tests import per_repository
-
-
-class TestCommitBuilder(per_repository.TestCaseWithRepository):
+from bzrlib.graph import Graph
+from bzrlib.tests.per_repository import test_repository
+
+
+class TestCommitBuilder(test_repository.TestCaseWithRepository):
 
     def test_get_commit_builder(self):
         branch = self.make_branch('.')
@@ -921,8 +924,8 @@
         # (closest to a public per-file graph API we have today)
         tree.lock_read()
         self.addCleanup(tree.unlock)
-        g = dict(graph.Graph(tree.branch.repository.texts).iter_ancestry([tip]))
-        self.assertEqual(expected_graph, g)
+        graph = dict(Graph(tree.branch.repository.texts).iter_ancestry([tip]))
+        self.assertEqual(expected_graph, graph)
 
     def test_last_modified_revision_after_content_file_changes(self):
         # altering a file changes the last modified.

=== modified file 'bzrlib/tests/per_repository/test_fileid_involved.py'
--- bzrlib/tests/per_repository/test_fileid_involved.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_repository/test_fileid_involved.py	2009-09-09 02:14:12 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,6 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import os
 import sys
 import time
 
@@ -22,12 +23,15 @@
     remote,
     revision as _mod_revision,
     tests,
-    transform,
     )
-from bzrlib.tests import per_repository
-
-
-class FileIdInvolvedBase(per_repository.TestCaseWithRepository):
+from bzrlib.errors import IllegalPath, NonAsciiRevisionId
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.per_repository.test_repository import TestCaseWithRepository
+from bzrlib.transform import TreeTransform
+from bzrlib.workingtree import WorkingTree
+
+
+class FileIdInvolvedBase(TestCaseWithRepository):
 
     def touch(self, tree, filename):
         # use the trees transport to not depend on the tree's location or type.
@@ -77,13 +81,13 @@
                                  'c-funky<file-id>quiji%bo'])
         try:
             main_wt.commit("Commit one", rev_id="rev-A")
-        except errors.IllegalPath:
+        except IllegalPath:
             # TODO: jam 20060701 Consider raising a different exception
             #       newer formats do support this, and nothin can done to
             #       correct this test - its not a bug.
             if sys.platform == 'win32':
-                raise tests.TestSkipped('Old repository formats do not'
-                                        ' support file ids with <> on win32')
+                raise TestSkipped('Old repository formats do not'
+                                  ' support file ids with <> on win32')
             # This is not a known error condition
             raise
 
@@ -239,9 +243,9 @@
         revision_id = u'r\xe9v-a'.encode('utf8')
         try:
             main_wt.commit('a', rev_id=revision_id)
-        except errors.NonAsciiRevisionId:
-            raise tests.TestSkipped('non-ascii revision ids not supported by %s'
-                                    % self.repository_format)
+        except NonAsciiRevisionId:
+            raise TestSkipped('non-ascii revision ids not supported by %s'
+                              % self.repository_format)
 
         repo = main_wt.branch.repository
         repo.lock_read()
@@ -271,13 +275,13 @@
                                  'c-funky<file-id>quiji\'"%bo'])
         try:
             main_wt.commit("Commit one", rev_id="rev-A")
-        except errors.IllegalPath:
+        except IllegalPath:
             # TODO: jam 20060701 Consider raising a different exception
             #       newer formats do support this, and nothin can done to
             #       correct this test - its not a bug.
             if sys.platform == 'win32':
-                raise tests.TestSkipped('Old repository formats do not'
-                                        ' support file ids with <> on win32')
+                raise TestSkipped('Old repository formats do not'
+                                  ' support file ids with <> on win32')
             # This is not a known error condition
             raise
 
@@ -316,7 +320,7 @@
         self.assertSubset(l2, l1)
 
 
-class FileIdInvolvedWGhosts(per_repository.TestCaseWithRepository):
+class FileIdInvolvedWGhosts(TestCaseWithRepository):
 
     def create_branch_with_ghost_text(self):
         builder = self.make_branch_builder('ghost')
@@ -348,7 +352,7 @@
         if isinstance(repo, remote.RemoteRepository):
             # We can't easily disable the checks in a remote repo.
             repo.abort_write_group()
-            raise tests.TestSkipped(
+            raise TestSkipped(
                 "repository format does not support storing revisions with "
                 "missing texts.")
         pack_coll = getattr(repo, '_pack_collection', None)
@@ -404,7 +408,7 @@
     unmark a file as executable.
     """
     file_id = wt.path2id(path)
-    tt = transform.TreeTransform(wt)
+    tt = TreeTransform(wt)
     try:
         tt.set_executability(executable, tt.trans_id_tree_file_id(file_id))
         tt.apply()

=== modified file 'bzrlib/tests/per_repository/test_repository.py'
--- bzrlib/tests/per_repository/test_repository.py	2010-04-21 04:53:33 +0000
+++ bzrlib/tests/per_repository/test_repository.py	2009-11-11 22:46:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,37 +19,45 @@
 from cStringIO import StringIO
 import re
 
+import bzrlib
 from bzrlib import (
-    branch as _mod_branch,
     bzrdir,
-    delta as _mod_delta,
     errors,
     gpg,
     graph,
     info,
-    inventory,
     osutils,
     remote,
     repository,
-    revision as _mod_revision,
-    tests,
-    transport,
-    upgrade,
-    versionedfile,
-    workingtree,
     xml_serializer,
     )
-from bzrlib.repofmt import (
-    pack_repo,
-    weaverepo,
-    )
+from bzrlib.branch import BzrBranchFormat6
+from bzrlib.delta import TreeDelta
+from bzrlib.inventory import CommonInventory, Inventory, InventoryDirectory
+from bzrlib.repofmt.pack_repo import (
+    RepositoryFormatKnitPack5RichRootBroken,
+    )
+from bzrlib.repofmt.weaverepo import (
+    RepositoryFormat5,
+    RepositoryFormat6,
+    RepositoryFormat7,
+    )
+from bzrlib.revision import NULL_REVISION, Revision
+from bzrlib.smart import server
 from bzrlib.tests import (
-    per_repository,
-    test_server,
+    KnownFailure,
+    TestCaseWithTransport,
+    TestNotApplicable,
+    TestSkipped,
     )
-
-
-class TestRepositoryMakeBranchAndTree(per_repository.TestCaseWithRepository):
+from bzrlib.tests.per_repository import TestCaseWithRepository
+from bzrlib.transport import get_transport
+from bzrlib.transport.fakevfat import FakeVFATServer
+from bzrlib.upgrade import upgrade
+from bzrlib.workingtree import WorkingTree
+
+
+class TestRepositoryMakeBranchAndTree(TestCaseWithRepository):
 
     def test_repository_format(self):
         # make sure the repository on tree.branch is of the desired format,
@@ -61,7 +69,7 @@
             self.repository_format.__class__)
 
 
-class TestRepository(per_repository.TestCaseWithRepository):
+class TestRepository(TestCaseWithRepository):
 
     def assertFormatAttribute(self, attribute, allowed_values):
         """Assert that the format has an attribute 'attribute'."""
@@ -84,9 +92,6 @@
         """Test the _fetch_reconcile attribute."""
         self.assertFormatAttribute('_fetch_reconcile', (True, False))
 
-    def test_attribute_format_experimental(self):
-        self.assertFormatAttribute('experimental', (True, False))
-
     def test_attribute_format_pack_compresses(self):
         self.assertFormatAttribute('pack_compresses', (True, False))
 
@@ -94,7 +99,8 @@
         """Test the existence of the inventories attribute."""
         tree = self.make_branch_and_tree('tree')
         repo = tree.branch.repository
-        self.assertIsInstance(repo.inventories, versionedfile.VersionedFiles)
+        self.assertIsInstance(repo.inventories,
+            bzrlib.versionedfile.VersionedFiles)
 
     def test_attribute_inventories_basics(self):
         """Test basic aspects of the inventories attribute."""
@@ -110,7 +116,7 @@
         tree = self.make_branch_and_tree('tree')
         repo = tree.branch.repository
         self.assertIsInstance(repo.revisions,
-            versionedfile.VersionedFiles)
+            bzrlib.versionedfile.VersionedFiles)
 
     def test_attribute_revision_store_basics(self):
         """Test the basic behaviour of the revisions attribute."""
@@ -144,7 +150,7 @@
         tree = self.make_branch_and_tree('tree')
         repo = tree.branch.repository
         self.assertIsInstance(repo.signatures,
-            versionedfile.VersionedFiles)
+            bzrlib.versionedfile.VersionedFiles)
 
     def test_attribute_text_store_basics(self):
         """Test the basic behaviour of the text store."""
@@ -160,8 +166,7 @@
             try:
                 rev_key = (tree.commit("foo"),)
             except errors.IllegalPath:
-                raise tests.TestNotApplicable(
-                    'file_id %r cannot be stored on this'
+                raise TestNotApplicable('file_id %r cannot be stored on this'
                     ' platform for this repo format' % (file_id,))
             if repo._format.rich_root_data:
                 root_commit = (tree.get_root_id(),) + rev_key
@@ -207,7 +212,7 @@
         tree = self.make_branch_and_tree('tree')
         repo = tree.branch.repository
         self.assertIsInstance(repo.texts,
-            versionedfile.VersionedFiles)
+            bzrlib.versionedfile.VersionedFiles)
 
     def test_exposed_versioned_files_are_marked_dirty(self):
         repo = self.make_repository('.')
@@ -256,7 +261,7 @@
         invs = tree.branch.repository.iter_inventories(revs)
         for rev_id, inv in zip(revs, invs):
             self.assertEqual(rev_id, inv.revision_id)
-            self.assertIsInstance(inv, inventory.CommonInventory)
+            self.assertIsInstance(inv, CommonInventory)
 
     def test_supports_rich_root(self):
         tree = self.make_branch_and_tree('a')
@@ -281,8 +286,8 @@
             # they may not be initializable.
             return
         # supported formats must be able to init and open
-        t = transport.get_transport(self.get_url())
-        readonly_t = transport.get_transport(self.get_readonly_url())
+        t = get_transport(self.get_url())
+        readonly_t = get_transport(self.get_readonly_url())
         made_control = self.bzrdir_format.initialize(t.base)
         made_repo = self.repository_format.initialize(made_control)
         self.assertEqual(made_control, made_repo.bzrdir)
@@ -341,7 +346,7 @@
             # because the default open will not open them and
             # they may not be initializable.
             return
-        t = transport.get_transport(self.get_url())
+        t = get_transport(self.get_url())
         made_control = self.bzrdir_format.initialize(t.base)
         made_repo = made_control.create_repository()
         # Check that we have a repository object.
@@ -355,7 +360,7 @@
             # because the default open will not open them and
             # they may not be initializable.
             return
-        t = transport.get_transport(self.get_url())
+        t = get_transport(self.get_url())
         made_control = self.bzrdir_format.initialize(t.base)
         try:
             made_repo = made_control.create_repository(shared=True)
@@ -376,7 +381,7 @@
         tree.lock_read()
         try:
             self.assertEqual('revision-1', tree.inventory.root.revision)
-            expected = inventory.InventoryDirectory('fixed-root', '', None)
+            expected = InventoryDirectory('fixed-root', '', None)
             expected.revision = 'revision-1'
             self.assertEqual([('', 'V', 'directory', 'fixed-root', expected)],
                              list(tree.list_files(include_root=True)))
@@ -390,7 +395,7 @@
             self.assertEqual([], list(tree.list_files(include_root=True)))
         finally:
             tree.unlock()
-        tree = wt.branch.repository.revision_tree(_mod_revision.NULL_REVISION)
+        tree = wt.branch.repository.revision_tree(NULL_REVISION)
         tree.lock_read()
         try:
             self.assertEqual([], list(tree.list_files(include_root=True)))
@@ -407,10 +412,10 @@
         tree_a.commit('rev2', rev_id='rev2')
 
         delta = tree_a.branch.repository.get_revision_delta('rev1')
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([('foo', 'file1', 'file')], delta.added)
         delta = tree_a.branch.repository.get_revision_delta('rev2')
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([('vla', 'file2', 'file')], delta.added)
 
     def test_get_revision_delta_filtered(self):
@@ -426,7 +431,7 @@
         # Test multiple files
         delta = tree_a.branch.repository.get_revision_delta('rev1',
             specific_fileids=['foo-id', 'baz-id'])
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([
             ('baz', 'baz-id', 'file'),
             ('foo', 'foo-id', 'file'),
@@ -434,7 +439,7 @@
         # Test a directory
         delta = tree_a.branch.repository.get_revision_delta('rev1',
             specific_fileids=['bar-id'])
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([
             ('bar', 'bar-id', 'directory'),
             ('bar/b1', 'b1-id', 'file'),
@@ -443,7 +448,7 @@
         # Test a file in a directory
         delta = tree_a.branch.repository.get_revision_delta('rev1',
             specific_fileids=['b2-id'])
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([
             ('bar', 'bar-id', 'directory'),
             ('bar/b2', 'b2-id', 'file'),
@@ -451,25 +456,24 @@
         # Try another revision
         delta = tree_a.branch.repository.get_revision_delta('rev2',
                 specific_fileids=['b3-id'])
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([
             ('bar', 'bar-id', 'directory'),
             ('bar/b3', 'b3-id', 'file'),
             ], delta.added)
         delta = tree_a.branch.repository.get_revision_delta('rev2',
                 specific_fileids=['foo-id'])
-        self.assertIsInstance(delta, _mod_delta.TreeDelta)
+        self.assertIsInstance(delta, TreeDelta)
         self.assertEqual([], delta.added)
 
     def test_clone_bzrdir_repository_revision(self):
         # make a repository with some revisions,
         # and clone it, this should not have unreferenced revisions.
         # also: test cloning with a revision id of NULL_REVISION -> empty repo.
-        raise tests.TestSkipped('revision limiting is not implemented yet.')
+        raise TestSkipped('revision limiting is not implemented yet.')
 
     def test_clone_repository_basis_revision(self):
-        raise tests.TestSkipped(
-            'the use of a basis should not add noise data to the result.')
+        raise TestSkipped('the use of a basis should not add noise data to the result.')
 
     def test_clone_shared_no_tree(self):
         # cloning a shared repository keeps it shared
@@ -510,13 +514,13 @@
             # This gives metadir branches something they can convert to.
             # it would be nice to have a 'latest' vs 'default' concept.
             format = bzrdir.format_registry.make_bzrdir('dirstate-with-subtree')
-            upgrade.upgrade(repo.bzrdir.root_transport.base, format=format)
+            upgrade(repo.bzrdir.root_transport.base, format=format)
         except errors.UpToDateFormat:
             # this is in the most current format already.
             return
         except errors.BadConversionTarget, e:
-            raise tests.TestSkipped(str(e))
-        wt = workingtree.WorkingTree.open(wt.basedir)
+            raise TestSkipped(str(e))
+        wt = WorkingTree.open(wt.basedir)
         new_signature = wt.branch.repository.get_signature_text('A')
         self.assertEqual(old_signature, new_signature)
 
@@ -604,16 +608,16 @@
             return # local conversion to/from RemoteObjects is irrelevant.
         if self.repository_format.get_format_description() \
             == "Repository format 4":
-            raise tests.TestSkipped('Cannot convert format-4 to itself')
+            raise TestSkipped('Cannot convert format-4 to itself')
         self.build_tree_contents(_upgrade_dir_template)
-        old_repodir = bzrdir.BzrDir.open_unsupported('.')
+        old_repodir = bzrlib.bzrdir.BzrDir.open_unsupported('.')
         old_repo_format = old_repodir.open_repository()._format
         format = self.repository_format._matchingbzrdir
         try:
             format.repository_format = self.repository_format
         except AttributeError:
             pass
-        upgrade.upgrade('.', format)
+        upgrade('.', format)
 
     def test_pointless_commit(self):
         tree = self.make_branch_and_tree('.')
@@ -724,25 +728,6 @@
         self.assertTrue('ghost' not in parents)
         self.assertEqual(parents['rev2'], ('rev1', 'ghost'))
 
-    def test_get_known_graph_ancestry(self):
-        tree = self.make_branch_and_tree('here')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        # A
-        # |\
-        # | B
-        # |/
-        # C
-        tree.commit('initial commit', rev_id='A')
-        tree_other = tree.bzrdir.sprout('there').open_workingtree()
-        tree_other.commit('another', rev_id='B')
-        tree.merge_from_branch(tree_other.branch)
-        tree.commit('another', rev_id='C')
-        kg = tree.branch.repository.get_known_graph_ancestry(
-            ['C'])
-        self.assertEqual(['C'], list(kg.heads(['A', 'B', 'C'])))
-        self.assertEqual(['A', 'B', 'C'], list(kg.topo_sort()))
-
     def test_parent_map_type(self):
         tree = self.make_branch_and_tree('here')
         tree.lock_write()
@@ -750,8 +735,7 @@
         tree.commit('initial commit', rev_id='rev1')
         tree.commit('next commit', rev_id='rev2')
         graph = tree.branch.repository.get_graph()
-        parents = graph.get_parent_map(
-            [_mod_revision.NULL_REVISION, 'rev1', 'rev2'])
+        parents = graph.get_parent_map([NULL_REVISION, 'rev1', 'rev2'])
         for value in parents.values():
             self.assertIsInstance(value, tuple)
 
@@ -779,18 +763,17 @@
         self.addCleanup(repo.unlock)
         repo.start_write_group()
         self.addCleanup(repo.abort_write_group)
-        inv = inventory.Inventory(revision_id='A')
+        inv = Inventory(revision_id='A')
         inv.root.revision = 'A'
         repo.add_inventory('A', inv, [])
-        repo.add_revision('A', _mod_revision.Revision(
-                'A', committer='A', timestamp=0,
-                inventory_sha1='', timezone=0, message='A'))
+        repo.add_revision('A', Revision('A', committer='A', timestamp=0,
+                          inventory_sha1='', timezone=0, message='A'))
         repo.add_signature_text('A', 'This might be a signature')
         self.assertEqual('This might be a signature',
                          repo.get_signature_text('A'))
 
     def test_add_revision_inventory_sha1(self):
-        inv = inventory.Inventory(revision_id='A')
+        inv = Inventory(revision_id='A')
         inv.root.revision = 'A'
         inv.root.file_id = 'fixed-root'
         # Insert the inventory on its own to an identical repository, to get
@@ -808,9 +791,8 @@
         repo.start_write_group()
         root_id = inv.root.file_id
         repo.texts.add_lines(('fixed-root', 'A'), [], [])
-        repo.add_revision('A', _mod_revision.Revision(
-                'A', committer='B', timestamp=0,
-                timezone=0, message='C'), inv=inv)
+        repo.add_revision('A', Revision('A', committer='B', timestamp=0,
+                          timezone=0, message='C'), inv=inv)
         repo.commit_write_group()
         repo.unlock()
         repo.lock_read()
@@ -843,25 +825,24 @@
         """Make a RemoteRepository object backed by a real repository that will
         be created at the given path."""
         repo = self.make_repository(path, shared=shared)
-        smart_server = test_server.SmartTCPServer_for_testing()
+        smart_server = server.SmartTCPServer_for_testing()
         self.start_server(smart_server, self.get_server())
-        remote_transport = transport.get_transport(
-            smart_server.get_url()).clone(path)
+        remote_transport = get_transport(smart_server.get_url()).clone(path)
         remote_bzrdir = bzrdir.BzrDir.open_from_transport(remote_transport)
         remote_repo = remote_bzrdir.open_repository()
         return remote_repo
 
     def test_sprout_from_hpss_preserves_format(self):
         """repo.sprout from a smart server preserves the repository format."""
-        if self.repository_format == weaverepo.RepositoryFormat7():
-            raise tests.TestNotApplicable(
+        if self.repository_format == RepositoryFormat7():
+            raise TestNotApplicable(
                 "Cannot fetch weaves over smart protocol.")
         remote_repo = self.make_remote_repository('remote')
         local_bzrdir = self.make_bzrdir('local')
         try:
             local_repo = remote_repo.sprout(local_bzrdir)
         except errors.TransportNotPossible:
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 "Cannot lock_read old formats like AllInOne over HPSS.")
         remote_backing_repo = bzrdir.BzrDir.open(
             self.get_vfs_only_url('remote')).open_repository()
@@ -870,18 +851,17 @@
     def test_sprout_branch_from_hpss_preserves_repo_format(self):
         """branch.sprout from a smart server preserves the repository format.
         """
-        weave_formats = [weaverepo.RepositoryFormat5(),
-                         weaverepo.RepositoryFormat6(),
-                         weaverepo.RepositoryFormat7()]
+        weave_formats = [RepositoryFormat5(), RepositoryFormat6(),
+                         RepositoryFormat7()]
         if self.repository_format in weave_formats:
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 "Cannot fetch weaves over smart protocol.")
         remote_repo = self.make_remote_repository('remote')
         remote_branch = remote_repo.bzrdir.create_branch()
         try:
             local_bzrdir = remote_branch.bzrdir.sprout('local')
         except errors.TransportNotPossible:
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 "Cannot lock_read old formats like AllInOne over HPSS.")
         local_repo = local_bzrdir.open_repository()
         remote_backing_repo = bzrdir.BzrDir.open(
@@ -892,11 +872,10 @@
         """branch.sprout from a smart server preserves the repository format of
         a branch from a shared repository.
         """
-        weave_formats = [weaverepo.RepositoryFormat5(),
-                         weaverepo.RepositoryFormat6(),
-                         weaverepo.RepositoryFormat7()]
+        weave_formats = [RepositoryFormat5(), RepositoryFormat6(),
+                         RepositoryFormat7()]
         if self.repository_format in weave_formats:
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 "Cannot fetch weaves over smart protocol.")
         # Make a shared repo
         remote_repo = self.make_remote_repository('remote', shared=True)
@@ -915,16 +894,15 @@
         try:
             local_bzrdir = remote_branch.bzrdir.sprout('local')
         except errors.TransportNotPossible:
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 "Cannot lock_read old formats like AllInOne over HPSS.")
         local_repo = local_bzrdir.open_repository()
         self.assertEqual(remote_backing_repo._format, local_repo._format)
 
     def test_clone_to_hpss(self):
-        pre_metadir_formats = [weaverepo.RepositoryFormat5(),
-                               weaverepo.RepositoryFormat6()]
+        pre_metadir_formats = [RepositoryFormat5(), RepositoryFormat6()]
         if self.repository_format in pre_metadir_formats:
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 "Cannot lock pre_metadir_formats remotely.")
         remote_transport = self.make_smart_server('remote')
         local_branch = self.make_branch('local')
@@ -941,20 +919,18 @@
         try:
             repo = self.make_repository('repo', shared=True)
         except errors.IncompatibleFormat:
-            raise tests.TestNotApplicable('Cannot make a shared repository')
+            raise TestNotApplicable('Cannot make a shared repository')
         if isinstance(repo.bzrdir, bzrdir.BzrDirPreSplitOut):
-            raise tests.KnownFailure(
-                "pre metadir branches do not upgrade on push "
+            raise KnownFailure("pre metadir branches do not upgrade on push "
                 "with stacking policy")
-        if isinstance(repo._format,
-                      pack_repo.RepositoryFormatKnitPack5RichRootBroken):
-            raise tests.TestNotApplicable("unsupported format")
+        if isinstance(repo._format, RepositoryFormatKnitPack5RichRootBroken):
+            raise TestNotApplicable("unsupported format")
         # Make a source branch in 'repo' in an unstackable branch format
         bzrdir_format = self.repository_format._matchingbzrdir
         transport = self.get_transport('repo/branch')
         transport.mkdir('.')
         target_bzrdir = bzrdir_format.initialize_on_transport(transport)
-        branch = _mod_branch.BzrBranchFormat6().initialize(target_bzrdir)
+        branch = BzrBranchFormat6().initialize(target_bzrdir)
         # Ensure that stack_on will be stackable and match the serializer of
         # repo.
         if isinstance(repo, remote.RemoteRepository):
@@ -1035,7 +1011,7 @@
         try:
             repo = self.make_repository_and_foo_bar(shared=True)
         except errors.IncompatibleFormat:
-            raise tests.TestNotApplicable
+            raise TestNotApplicable
         branches = repo.find_branches(using=True)
         self.assertContainsRe(branches[-1].base, 'repository/foo/$')
         # in some formats, creating a repo creates a branch
@@ -1069,7 +1045,7 @@
         try:
             repo.set_make_working_trees(True)
         except errors.RepositoryUpgradeRequired, e:
-            raise tests.TestNotApplicable('Format does not support this flag.')
+            raise TestNotApplicable('Format does not support this flag.')
         self.assertTrue(repo.make_working_trees())
 
     def test_set_get_make_working_trees_false(self):
@@ -1077,11 +1053,11 @@
         try:
             repo.set_make_working_trees(False)
         except errors.RepositoryUpgradeRequired, e:
-            raise tests.TestNotApplicable('Format does not support this flag.')
+            raise TestNotApplicable('Format does not support this flag.')
         self.assertFalse(repo.make_working_trees())
 
 
-class TestRepositoryLocking(per_repository.TestCaseWithRepository):
+class TestRepositoryLocking(TestCaseWithRepository):
 
     def test_leave_lock_in_place(self):
         repo = self.make_repository('r')
@@ -1142,7 +1118,7 @@
         repo.unlock()
 
 
-class TestCaseWithComplexRepository(per_repository.TestCaseWithRepository):
+class TestCaseWithComplexRepository(TestCaseWithRepository):
 
     def setUp(self):
         super(TestCaseWithComplexRepository, self).setUp()
@@ -1172,8 +1148,7 @@
         try:
             tree_a.commit('rev3', rev_id='rev3', allow_pointless=True)
         except errors.RevisionNotPresent:
-            raise tests.TestNotApplicable(
-                "Cannot test with ghosts for this format.")
+            raise TestNotApplicable("Cannot test with ghosts for this format.")
         # add another reference to a ghost, and a second ghost.
         tree_a.add_parent_tree_id('ghost1')
         tree_a.add_parent_tree_id('ghost2')
@@ -1233,7 +1208,7 @@
             repo.unlock()
 
 
-class TestCaseWithCorruptRepository(per_repository.TestCaseWithRepository):
+class TestCaseWithCorruptRepository(TestCaseWithRepository):
 
     def setUp(self):
         super(TestCaseWithCorruptRepository, self).setUp()
@@ -1242,31 +1217,36 @@
         repo = self.make_repository('inventory_with_unnecessary_ghost')
         repo.lock_write()
         repo.start_write_group()
-        inv = inventory.Inventory(revision_id = 'ghost')
+        inv = Inventory(revision_id = 'ghost')
         inv.root.revision = 'ghost'
         if repo.supports_rich_root():
             root_id = inv.root.file_id
             repo.texts.add_lines((root_id, 'ghost'), [], [])
         sha1 = repo.add_inventory('ghost', inv, [])
-        rev = _mod_revision.Revision(
-            timestamp=0, timezone=None, committer="Foo Bar <foo@example.com>",
-            message="Message", inventory_sha1=sha1, revision_id='ghost')
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='ghost')
         rev.parent_ids = ['the_ghost']
         try:
             repo.add_revision('ghost', rev)
         except (errors.NoSuchRevision, errors.RevisionNotPresent):
-            raise tests.TestNotApplicable(
-                "Cannot test with ghosts for this format.")
+            raise TestNotApplicable("Cannot test with ghosts for this format.")
 
-        inv = inventory.Inventory(revision_id = 'the_ghost')
+        inv = Inventory(revision_id = 'the_ghost')
         inv.root.revision = 'the_ghost'
         if repo.supports_rich_root():
             root_id = inv.root.file_id
             repo.texts.add_lines((root_id, 'the_ghost'), [], [])
         sha1 = repo.add_inventory('the_ghost', inv, [])
-        rev = _mod_revision.Revision(
-            timestamp=0, timezone=None, committer="Foo Bar <foo@example.com>",
-            message="Message", inventory_sha1=sha1, revision_id='the_ghost')
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='the_ghost')
         rev.parent_ids = []
         repo.add_revision('the_ghost', rev)
         # check its setup usefully
@@ -1299,7 +1279,7 @@
 
 # FIXME: document why this is a TestCaseWithTransport rather than a
 #        TestCaseWithRepository
-class TestEscaping(tests.TestCaseWithTransport):
+class TestEscaping(TestCaseWithTransport):
     """Test that repositories can be stored correctly on VFAT transports.
 
     Makes sure we have proper escaping of invalid characters, etc.
@@ -1313,9 +1293,10 @@
     def test_on_vfat(self):
         # dont bother with remote repository testing, because this test is
         # about local disk layout/support.
-        if isinstance(self.repository_format, remote.RemoteRepositoryFormat):
+        from bzrlib.remote import RemoteRepositoryFormat
+        if isinstance(self.repository_format, RemoteRepositoryFormat):
             return
-        self.transport_server = test_server.FakeVFATServer
+        self.transport_server = FakeVFATServer
         FOO_ID = 'foo<:>ID'
         REV_ID = 'revid-1'
         # this makes a default format repository always, which is wrong:
@@ -1340,20 +1321,4 @@
         wt.add('file1')
         wt.commit('file1', rev_id='rev1')
         fileobj = StringIO()
-        wt.branch.repository.create_bundle(
-            'rev1', _mod_revision.NULL_REVISION, fileobj)
-
-
-
-
-class TestRepositoryControlComponent(per_repository.TestCaseWithRepository):
-    """Repository implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        repo = self.make_repository('repo')
-        self.assertIsInstance(repo.user_url, str)
-        self.assertEqual(repo.user_url, repo.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(repo.control_url.find(repo.user_url), 0)
-        self.assertEqual(repo.control_url, repo.control_transport.base)
+        wt.branch.repository.create_bundle('rev1', NULL_REVISION, fileobj)

=== modified file 'bzrlib/tests/per_repository/test_write_group.py'
--- bzrlib/tests/per_repository/test_write_group.py	2010-02-11 09:27:55 +0000
+++ bzrlib/tests/per_repository/test_write_group.py	2009-10-15 02:11:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,24 +19,21 @@
 import sys
 
 from bzrlib import (
-    branch,
     bzrdir,
     errors,
     graph,
     memorytree,
     osutils,
     remote,
-    tests,
     versionedfile,
     )
-from bzrlib.tests import (
-    per_repository,
-    test_server,
-    )
-from bzrlib.transport import memory
-
-
-class TestWriteGroup(per_repository.TestCaseWithRepository):
+from bzrlib.branch import BzrBranchFormat7
+from bzrlib.transport import local, memory
+from bzrlib.tests import TestNotApplicable
+from bzrlib.tests.per_repository import TestCaseWithRepository
+
+
+class TestWriteGroup(TestCaseWithRepository):
 
     def test_start_write_group_unlocked_needs_write_lock(self):
         repo = self.make_repository('.')
@@ -117,7 +114,7 @@
         repo.unlock()
 
     def test_abort_write_group_does_not_raise_when_suppressed(self):
-        if self.transport_server is test_server.LocalURLServer:
+        if self.transport_server is local.LocalURLServer:
             self.transport_server = None
         self.vfs_transport_factory = memory.MemoryServer
         repo = self.make_repository('repo')
@@ -134,7 +131,7 @@
         self.assertEqual(None, repo.abort_write_group(suppress_errors=True))
 
 
-class TestGetMissingParentInventories(per_repository.TestCaseWithRepository):
+class TestGetMissingParentInventories(TestCaseWithRepository):
 
     def test_empty_get_missing_parent_inventories(self):
         """A new write group has no missing parent inventories."""
@@ -186,8 +183,8 @@
         else:
             repo = self.make_repository(relpath)
         if not repo._format.supports_external_lookups:
-            raise tests.TestNotApplicable('format not stackable')
-        repo.bzrdir._format.set_branch_format(branch.BzrBranchFormat7())
+            raise TestNotApplicable('format not stackable')
+        repo.bzrdir._format.set_branch_format(BzrBranchFormat7())
         return repo
 
     def reopen_repo_and_resume_write_group(self, repo):
@@ -337,7 +334,7 @@
         repo = self.make_repository('test-repo')
         if (not repo._format.supports_external_lookups or
             isinstance(repo, remote.RemoteRepository)):
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 'only valid for direct connections to resumable repos')
         # log calls to get_missing_parent_inventories, so that we can assert it
         # is called with the correct parameters
@@ -364,7 +361,7 @@
         self.assertEqual([True], call_log)
 
 
-class TestResumeableWriteGroup(per_repository.TestCaseWithRepository):
+class TestResumeableWriteGroup(TestCaseWithRepository):
 
     def make_write_locked_repo(self, relpath='repo'):
         repo = self.make_repository(relpath)
@@ -387,7 +384,7 @@
             wg_tokens = repo.suspend_write_group()
         except errors.UnsuspendableWriteGroup:
             repo.abort_write_group()
-            raise tests.TestNotApplicable(reason)
+            raise TestNotApplicable(reason)
 
     def test_suspend_write_group(self):
         repo = self.make_write_locked_repo()

=== modified file 'bzrlib/tests/per_repository_chk/__init__.py'
--- bzrlib/tests/per_repository_chk/__init__.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/per_repository_chk/__init__.py	2009-09-08 06:25:26 +0000
@@ -27,6 +27,7 @@
     repository,
     remote,
     )
+from bzrlib.bzrdir import BzrDir
 from bzrlib.repofmt.pack_repo import (
     RepositoryFormatKnitPack5,
     )
@@ -35,6 +36,7 @@
     )
 from bzrlib.tests import (
     multiply_tests,
+    TestSuite,
     )
 from bzrlib.tests.per_repository import (
     all_repository_format_scenarios,

=== modified file 'bzrlib/tests/per_repository_reference/__init__.py'
--- bzrlib/tests/per_repository_reference/__init__.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/per_repository_reference/__init__.py	2009-07-15 17:51:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,7 +23,6 @@
 """
 
 from bzrlib import (
-    errors,
     repository,
     remote,
     )
@@ -67,22 +66,6 @@
             self.repository_format.__class__)
 
 
-class TestIncompatibleStacking(TestCaseWithRepository):
-
-    def test_add_fallback_repository_rejects_incompatible(self):
-        # Repository.add_fallback_repository raises IncompatibleRepositories if
-        # you take two repositories in different serializations and try to
-        # stack them.
-        if self.make_repository('test')._format.supports_chks:
-            different_fmt = '1.9'
-        else:
-            different_fmt = '2a'
-        repo = self.make_repository('repo', format=different_fmt)
-        referring = self.make_repository('referring')
-        self.assertRaises(errors.IncompatibleRepositories,
-                referring.add_fallback_repository, repo)
-
-
 def external_reference_test_scenarios():
     """Generate test scenarios for repositories supporting external references.
     """

=== modified file 'bzrlib/tests/per_repository_reference/test_break_lock.py'
--- bzrlib/tests/per_repository_reference/test_break_lock.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/per_repository_reference/test_break_lock.py	2009-06-23 08:43:05 +0000
@@ -16,13 +16,14 @@
 
 """Tests for break_lock on a repository with external references."""
 
-from bzrlib import (
-    errors,
-    ui,
-    )
+import bzrlib.ui
+from bzrlib import errors
 from bzrlib.tests.per_repository_reference import (
     TestCaseWithExternalReferenceRepository,
     )
+from bzrlib.ui import (
+    CannedInputUIFactory,
+    )
 
 
 class TestBreakLock(TestCaseWithExternalReferenceRepository):
@@ -41,6 +42,8 @@
             # 'lock_write' has not taken a physical mutex out.
             repo.unlock()
             return
-        ui.ui_factory = ui.CannedInputUIFactory([True])
+        self.old_factory = bzrlib.ui.ui_factory
+        self.addCleanup(self.restoreFactory)
+        bzrlib.ui.ui_factory = CannedInputUIFactory([True])
         unused_repo.break_lock()
         self.assertRaises(errors.LockBroken, repo.unlock)

=== modified file 'bzrlib/tests/per_repository_reference/test_check.py'
--- bzrlib/tests/per_repository_reference/test_check.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_repository_reference/test_check.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_repository_reference/test_default_stacking.py'
--- bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/per_repository_reference/test_default_stacking.py	2009-06-10 03:56:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,6 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+from bzrlib.smart import server
 from bzrlib.tests.per_repository import TestCaseWithRepository
 
 

=== modified file 'bzrlib/tests/per_transport.py'
--- bzrlib/tests/per_transport.py	2010-03-05 05:30:19 +0000
+++ bzrlib/tests/per_transport.py	2009-10-05 12:50:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -52,7 +52,6 @@
     TestNotApplicable,
     multiply_tests,
     )
-from bzrlib.tests import test_server
 from bzrlib.tests.test_transport import TestTransportImplementation
 from bzrlib.transport import (
     ConnectedTransport,
@@ -171,7 +170,8 @@
         self.assertEqual(True, t.has_any(['b', 'b', 'b']))
 
     def test_has_root_works(self):
-        if self.transport_server is test_server.SmartTCPServer_for_testing:
+        from bzrlib.smart import server
+        if self.transport_server is server.SmartTCPServer_for_testing:
             raise TestNotApplicable(
                 "SmartTCPServer_for_testing intentionally does not allow "
                 "access to /.")
@@ -1083,52 +1083,6 @@
         subdir.stat('./file')
         subdir.stat('.')
 
-    def test_hardlink(self):
-        from stat import ST_NLINK
-
-        t = self.get_transport()
-
-        source_name = "original_target"
-        link_name = "target_link"
-
-        self.build_tree([source_name], transport=t)
-
-        try:
-            t.hardlink(source_name, link_name)
-
-            self.failUnless(t.has(source_name))
-            self.failUnless(t.has(link_name))
-
-            st = t.stat(link_name)
-            self.failUnlessEqual(st[ST_NLINK], 2)
-        except TransportNotPossible:
-            raise TestSkipped("Transport %s does not support hardlinks." %
-                              self._server.__class__)
-
-    def test_symlink(self):
-        from stat import S_ISLNK
-
-        t = self.get_transport()
-
-        source_name = "original_target"
-        link_name = "target_link"
-
-        self.build_tree([source_name], transport=t)
-
-        try:
-            t.symlink(source_name, link_name)
-
-            self.failUnless(t.has(source_name))
-            self.failUnless(t.has(link_name))
-
-            st = t.stat(link_name)
-            self.failUnless(S_ISLNK(st.st_mode))
-        except TransportNotPossible:
-            raise TestSkipped("Transport %s does not support symlinks." %
-                              self._server.__class__)
-        except IOError:
-            raise tests.KnownFailure("Paramiko fails to create symlinks during tests")
-
     def test_list_dir(self):
         # TODO: Test list_dir, just try once, and if it throws, stop testing
         t = self.get_transport()
@@ -1543,10 +1497,6 @@
                  u'\u65e5', # Kanji person
                 ]
 
-        no_unicode_support = getattr(self._server, 'no_unicode_support', False)
-        if no_unicode_support:
-            raise tests.KnownFailure("test server cannot handle unicode paths")
-
         try:
             self.build_tree(files, transport=t, line_endings='binary')
         except UnicodeError:

=== modified file 'bzrlib/tests/per_tree/__init__.py'
--- bzrlib/tests/per_tree/__init__.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_tree/__init__.py	2009-08-28 05:00:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -80,10 +80,10 @@
     basis = tree.basis_tree()
     tt = TransformPreview(basis)
     testcase.addCleanup(tt.finalize)
+    pp = progress.ProgressPhase('', 1, progress.DummyProgress())
     tree.lock_read()
     testcase.addCleanup(tree.unlock)
-    pp = None
-    transform._prepare_revert_transform(basis, tree, tt, None, False, None,
+    transform._prepare_revert_transform(basis, tree, tt, None, False, pp,
                                         basis, {})
     preview_tree = tt.get_preview_tree()
     preview_tree.set_parent_ids(tree.get_parent_ids())

=== modified file 'bzrlib/tests/per_tree/test_get_file_mtime.py'
--- bzrlib/tests/per_tree/test_get_file_mtime.py	2010-03-17 13:03:38 +0000
+++ bzrlib/tests/per_tree/test_get_file_mtime.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,7 +38,6 @@
         # file, working trees return the on-disk time.
         mtime_file_id = tree.get_file_mtime(file_id='one-id')
         self.assertIsInstance(mtime_file_id, (float, int))
-        self.failUnless(now - 5 < mtime_file_id < now + 5,
-                        'now: %f, mtime_file_id: %f' % (now, mtime_file_id ))
+        self.failUnless(now - 5 < mtime_file_id < now + 5)
         mtime_path = tree.get_file_mtime(file_id='one-id', path='one')
         self.assertEqual(mtime_file_id, mtime_path)

=== modified file 'bzrlib/tests/per_tree/test_get_file_with_stat.py'
--- bzrlib/tests/per_tree/test_get_file_with_stat.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_tree/test_get_file_with_stat.py	2009-11-18 15:47:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_tree/test_inv.py'
--- bzrlib/tests/per_tree/test_inv.py	2010-02-16 16:08:40 +0000
+++ bzrlib/tests/per_tree/test_inv.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,10 +23,7 @@
 from bzrlib import (
     tests,
     )
-from bzrlib.tests import (
-    features,
-    per_tree,
-    )
+from bzrlib.tests import per_tree
 from bzrlib.mutabletree import MutableTree
 from bzrlib.tests import SymlinkFeature, TestSkipped
 from bzrlib.transform import _PreviewTree
@@ -134,8 +131,6 @@
         work_tree.add(['dir', 'dir/file'])
         if commit:
             work_tree.commit('commit 1')
-        # XXX: this isn't actually guaranteed to return the class we want to
-        # test -- mbp 2010-02-12
         return work_tree
 
     def test_canonical_path(self):
@@ -168,21 +163,3 @@
         work_tree = self._make_canonical_test_tree()
         self.assertEqual('dir/None',
                          work_tree.get_canonical_inventory_path('Dir/None'))
-
-    def test_canonical_tree_name_mismatch(self):
-        # see <https://bugs.edge.launchpad.net/bzr/+bug/368931>
-        # some of the trees we want to use can only exist on a disk, not in
-        # memory - therefore we can only test this if the filesystem is
-        # case-sensitive.
-        self.requireFeature(tests.case_sensitive_filesystem_feature)
-        work_tree = self.make_branch_and_tree('.')
-        self.build_tree(['test/', 'test/file', 'Test'])
-        work_tree.add(['test/', 'test/file', 'Test'])
-
-        test_tree = self._convert_tree(work_tree)
-        test_tree.lock_read()
-        self.addCleanup(test_tree.unlock)
-
-        self.assertEqual(['test', 'test/file', 'Test', 'test/foo', 'Test/foo'],
-            test_tree.get_canonical_inventory_paths(
-                ['test', 'test/file', 'Test', 'test/foo', 'Test/foo']))

=== modified file 'bzrlib/tests/per_tree/test_iter_search_rules.py'
--- bzrlib/tests/per_tree/test_iter_search_rules.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_tree/test_iter_search_rules.py	2009-12-03 05:21:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_tree/test_path_content_summary.py'
--- bzrlib/tests/per_tree/test_path_content_summary.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_tree/test_path_content_summary.py	2009-11-10 19:38:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_tree/test_revision_tree.py'
--- bzrlib/tests/per_tree/test_revision_tree.py	2010-03-10 09:26:51 +0000
+++ bzrlib/tests/per_tree/test_revision_tree.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,14 +16,11 @@
 
 """Tests for Tree.revision_tree."""
 
-from bzrlib import (
-    errors,
-    tests,
-    )
-from bzrlib.tests import per_tree
-
-
-class TestRevisionTree(per_tree.TestCaseWithTree):
+from bzrlib import errors
+from bzrlib.tests.per_tree import TestCaseWithTree
+
+
+class TestRevisionTree(TestCaseWithTree):
 
     def create_tree_no_parents_no_content(self):
         tree = self.make_branch_and_tree('.')

=== modified file 'bzrlib/tests/per_uifactory/__init__.py'
--- bzrlib/tests/per_uifactory/__init__.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_uifactory/__init__.py	2010-01-05 15:52:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -56,12 +56,6 @@
     the concrete subclasses should be.
     """
 
-    def test_be_quiet(self):
-        self.factory.be_quiet(True)
-        self.assertEquals(True, self.factory.is_quiet())
-        self.factory.be_quiet(False)
-        self.assertEquals(False, self.factory.is_quiet())
-
     def test_note(self):
         self.factory.note("a note to the user")
         self._check_note("a note to the user")
@@ -82,9 +76,12 @@
         self._check_show_warning(msg)
 
     def test_make_output_stream(self):
-        # All UIs must now be able to at least accept output, even if they
-        # just discard it.
-        output_stream = self.factory.make_output_stream()
+        # at the moment this is only implemented on text uis; i'm not sure
+        # what it should do elsewhere
+        try:
+            output_stream = self.factory.make_output_stream()
+        except NotImplementedError, e:
+            raise tests.TestSkipped(str(e))
         output_stream.write('hello!')
 
     def test_transport_activity(self):
@@ -137,7 +134,7 @@
 
     def _check_log_transport_activity_noarg(self):
         self.assertEqual('', self.stdout.getvalue())
-        self.assertContainsRe(self.stderr.getvalue(), r'\d+kB\s+\dkB/s |')
+        self.assertContainsRe(self.stderr.getvalue(), r'\d+KB\s+\dKB/s |')
         self.assertNotContainsRe(self.stderr.getvalue(), r'Transferred:')
 
     def _check_log_transport_activity_display(self):
@@ -170,7 +167,7 @@
 
             def __setattr__(self, name, value):
                 return setattr(self._sio, name, value)
-
+                
         # Remove 'TERM' == 'dumb' which causes us to *not* treat output as a
         # real terminal, even though isatty returns True
         self._captureVar('TERM', None)
@@ -181,11 +178,10 @@
 
     def _check_log_transport_activity_display(self):
         self.assertEqual('', self.stdout.getvalue())
-        # Displaying the result should write to the progress stream using
-        # base-10 units (see HACKING.txt).
+        # Displaying the result should write to the progress stream
         self.assertContainsRe(self.stderr.getvalue(),
-            r'Transferred: 7kB'
-            r' \(\d+\.\dkB/s r:2kB w:1kB u:4kB\)')
+            r'Transferred: 7KiB'
+            r' \(\d+\.\dK/s r:2K w:1K u:4K\)')
 
     def _check_log_transport_activity_display_no_bytes(self):
         self.assertEqual('', self.stdout.getvalue())

=== modified file 'bzrlib/tests/per_versionedfile.py'
--- bzrlib/tests/per_versionedfile.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_versionedfile.py	2009-10-26 06:44:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2009 Canonical Ltd
 #
 # Authors:
 #   Johan Rydberg <jrydberg@gnu.org>
@@ -734,10 +734,11 @@
         # the ordering here is to make a tree so that dumb searches have
         # more changes to muck up.
 
-        class InstrumentedProgress(progress.ProgressTask):
+        class InstrumentedProgress(progress.DummyProgress):
 
             def __init__(self):
-                progress.ProgressTask.__init__(self)
+
+                progress.DummyProgress.__init__(self)
                 self.updates = []
 
             def update(self, msg=None, current=None, total=None):
@@ -1469,7 +1470,7 @@
             transport.mkdir('.')
         files = self.factory(transport)
         if self.cleanup is not None:
-            self.addCleanup(self.cleanup, files)
+            self.addCleanup(lambda:self.cleanup(files))
         return files
 
     def get_simple_key(self, suffix):
@@ -2547,10 +2548,11 @@
         # the ordering here is to make a tree so that dumb searches have
         # more changes to muck up.
 
-        class InstrumentedProgress(progress.ProgressTask):
+        class InstrumentedProgress(progress.DummyProgress):
 
             def __init__(self):
-                progress.ProgressTask.__init__(self)
+
+                progress.DummyProgress.__init__(self)
                 self.updates = []
 
             def update(self, msg=None, current=None, total=None):

=== modified file 'bzrlib/tests/per_workingtree/__init__.py'
--- bzrlib/tests/per_workingtree/__init__.py	2010-04-01 12:53:53 +0000
+++ bzrlib/tests/per_workingtree/__init__.py	2009-08-04 04:36:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,7 +17,7 @@
 
 """WorkingTree implementation tests for bzr.
 
-This test the conformance of all the workingtre variations to the expected API.
+These test the conformance of all the workingtre variations to the expected API.
 Specific tests for individual formats are in the tests/test_workingtree file
 rather than in tests/per_workingtree/*.py.
 """

=== modified file 'bzrlib/tests/per_workingtree/test_break_lock.py'
--- bzrlib/tests/per_workingtree/test_break_lock.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/per_workingtree/test_break_lock.py	2009-07-17 10:38:41 +0000
@@ -18,10 +18,8 @@
 from cStringIO import StringIO
 import os
 
-from bzrlib import (
-    errors,
-    ui,
-    )
+import bzrlib
+import bzrlib.errors as errors
 from bzrlib.tests import TestNotApplicable
 from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
 
@@ -32,6 +30,11 @@
         super(TestBreakLock, self).setUp()
         self.unused_workingtree = self.make_branch_and_tree('.')
         self.workingtree = self.unused_workingtree.bzrdir.open_workingtree()
+        self.old_factory = bzrlib.ui.ui_factory
+        self.addCleanup(self.restoreFactory)
+
+    def restoreFactory(self):
+        bzrlib.ui.ui_factory = self.old_factory
 
     def test_unlocked(self):
         # break lock when nothing is locked should just return
@@ -45,14 +48,14 @@
         # if the workingtree isn't locked - and the easiest way
         # to see if that happened is to lock the repo.
         self.workingtree.branch.repository.lock_write()
-        ui.ui_factory = ui.CannedInputUIFactory([True])
+        bzrlib.ui.ui_factory = bzrlib.ui.CannedInputUIFactory([True])
         try:
             self.unused_workingtree.break_lock()
         except NotImplementedError:
             # workingtree does not support break_lock
             self.workingtree.branch.repository.unlock()
             return
-        if ui.ui_factory.responses == [True]:
+        if bzrlib.ui.ui_factory.responses == [True]:
             raise TestNotApplicable("repository does not physically lock.")
         self.assertRaises(errors.LockBroken,
             self.workingtree.branch.repository.unlock)
@@ -60,7 +63,7 @@
     def test_locked(self):
         # break_lock when locked should
         self.workingtree.lock_write()
-        ui.ui_factory = ui.CannedInputUIFactory([True, True, True])
+        bzrlib.ui.ui_factory = bzrlib.ui.CannedInputUIFactory([True, True, True])
         try:
             self.unused_workingtree.break_lock()
         except (NotImplementedError, errors.LockActive):

=== modified file 'bzrlib/tests/per_workingtree/test_commit.py'
--- bzrlib/tests/per_workingtree/test_commit.py	2010-04-01 12:53:53 +0000
+++ bzrlib/tests/per_workingtree/test_commit.py	2009-09-07 23:14:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -168,7 +168,7 @@
         tree_a.commit('change n in A')
 
         # Merging from A should introduce conflicts because 'n' was modified
-        # (in A) and removed (in B), so 'a' needs to be restored.
+        # and removed, so 'a' needs to be restored.
         num_conflicts = tree_b.merge_from_branch(tree_a.branch)
         self.assertEqual(3, num_conflicts)
         paths = [(path, ie.file_id)
@@ -505,9 +505,8 @@
 
 class TestCommitProgress(TestCaseWithWorkingTree):
 
-    def setUp(self):
-        super(TestCommitProgress, self).setUp()
-        ui.ui_factory = CapturingUIFactory()
+    def restoreDefaults(self):
+        ui.ui_factory = self.old_ui_factory
 
     def test_commit_progress_steps(self):
         # during commit we one progress update for every entry in the
@@ -526,6 +525,8 @@
         f.close()
         # set a progress bar that captures the calls so we can see what is
         # emitted
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
         factory = CapturingUIFactory()
         ui.ui_factory = factory
         # TODO RBC 20060421 it would be nice to merge the reporter output
@@ -547,6 +548,8 @@
         tree = self.make_branch_and_tree('.')
         # set a progress bar that captures the calls so we can see what is
         # emitted
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
         factory = CapturingUIFactory()
         ui.ui_factory = factory
         def a_hook(_, _2, _3, _4, _5, _6):
@@ -570,6 +573,8 @@
         tree = self.make_branch_and_tree('.')
         # set a progress bar that captures the calls so we can see what is
         # emitted
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
         factory = CapturingUIFactory()
         ui.ui_factory = factory
         def a_hook(_, _2, _3, _4, _5, _6, _7, _8):
@@ -616,6 +621,9 @@
                 mutabletree.MutableTree))
             open(tree.abspath("newfile"), 'w').write("data")
             params.mutable_tree.add(["newfile"])
+        def restoreDefaults():
+            mutabletree.MutableTree.hooks['post_commit'] = []
+        self.addCleanup(restoreDefaults)
         tree = self.make_branch_and_tree('.')
         mutabletree.MutableTree.hooks.install_named_hook(
             'post_commit',

=== modified file 'bzrlib/tests/per_workingtree/test_content_filters.py'
--- bzrlib/tests/per_workingtree/test_content_filters.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_workingtree/test_content_filters.py	2009-10-28 23:34:13 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -123,12 +123,16 @@
         # the easiest way currently given we don't have easy access to the
         # WorkingTree after it is created but before the filter stack is used
         # to populate content.
-        def new_stack(tree, path=None, file_id=None):
+        self.real_content_filter_stack = WorkingTree._content_filter_stack
+        def restore_real_content_filter_stack():
+            WorkingTree._content_filter_stack = self.real_content_filter_stack
+        self.addCleanup(restore_real_content_filter_stack)
+        def _content_filter_stack(tree, path=None, file_id=None):
             if path.endswith('.txt'):
                 return [ContentFilter(_swapcase, _swapcase)]
             else:
                 return []
-        self.overrideAttr(WorkingTree, '_content_filter_stack', new_stack)
+        WorkingTree._content_filter_stack = _content_filter_stack
 
     def assert_basis_content(self, expected_content, branch, file_id):
         # Note: We need to use try/finally here instead of addCleanup()

=== modified file 'bzrlib/tests/per_workingtree/test_eol_conversion.py'
--- bzrlib/tests/per_workingtree/test_eol_conversion.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/per_workingtree/test_eol_conversion.py	2009-07-10 07:14:02 +0000
@@ -67,8 +67,10 @@
 
     def prepare_tree(self, content, eol=None):
         """Prepare a working tree and commit some content."""
-        self.real_rules_searcher = self.overrideAttr(
-            WorkingTree, '_get_rules_searcher')
+        def restore_real_rules_searcher():
+            WorkingTree._get_rules_searcher = self.real_rules_searcher
+        self.real_rules_searcher = WorkingTree._get_rules_searcher
+        self.addCleanup(restore_real_rules_searcher)
         self.patch_rules_searcher(eol)
         t = self.make_branch_and_tree('tree1')
         self.build_tree_contents([('tree1/file1', content)])

=== modified file 'bzrlib/tests/per_workingtree/test_is_ignored.py'
--- bzrlib/tests/per_workingtree/test_is_ignored.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_workingtree/test_is_ignored.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -31,15 +31,11 @@
             ('.bzrignore', './rootdir\n'
                            'randomfile*\n'
                            '*bar\n'
-                           '!bazbar\n'
                            '?foo\n'
                            '*.~*\n'
                            'dir1/*f1\n'
                            'dir1/?f2\n'
-                           'RE:dir2/.*\.wombat\n'
                            'path/from/ro?t\n'
-                           '**/piffle.py\n'
-                           '!b/piffle.py\n'
                            'unicode\xc2\xb5\n' # u'\xb5'.encode('utf8')
                            'dos\r\n'
                            '\n' # empty line
@@ -62,12 +58,6 @@
         self.assertEqual("path/from/ro?t", tree.is_ignored('path/from/root'))
         self.assertEqual("path/from/ro?t", tree.is_ignored('path/from/roat'))
         self.assertEqual(None, tree.is_ignored('roat'))
-        
-        self.assertEqual('**/piffle.py', tree.is_ignored('piffle.py'))
-        self.assertEqual('**/piffle.py', tree.is_ignored('a/piffle.py'))
-        self.assertEqual(None, tree.is_ignored('b/piffle.py')) # exclusion
-        self.assertEqual('**/piffle.py', tree.is_ignored('foo/bar/piffle.py'))
-        self.assertEqual(None, tree.is_ignored('p/iffle.py'))
 
         self.assertEqual(u'unicode\xb5', tree.is_ignored(u'unicode\xb5'))
         self.assertEqual(u'unicode\xb5', tree.is_ignored(u'subdir/unicode\xb5'))
@@ -82,8 +72,6 @@
         self.assertEqual('*bar', tree.is_ignored(r'foo\nbar'))
         self.assertEqual('*bar', tree.is_ignored('bar'))
         self.assertEqual('*bar', tree.is_ignored('.bar'))
-        
-        self.assertEqual(None, tree.is_ignored('bazbar')) # exclusion
 
         self.assertEqual('?foo', tree.is_ignored('afoo'))
         self.assertEqual('?foo', tree.is_ignored('.foo'))
@@ -96,9 +84,6 @@
 
         self.assertEqual('dir1/?f2', tree.is_ignored('dir1/ff2'))
         self.assertEqual('dir1/?f2', tree.is_ignored('dir1/.f2'))
-        
-        self.assertEqual('RE:dir2/.*\.wombat', tree.is_ignored('dir2/foo.wombat'))
-        self.assertEqual(None, tree.is_ignored('dir2/foo'))
 
         # Blank lines and comments should be ignored
         self.assertEqual(None, tree.is_ignored(''))

=== modified file 'bzrlib/tests/per_workingtree/test_merge_from_branch.py'
--- bzrlib/tests/per_workingtree/test_merge_from_branch.py	2010-04-01 14:06:48 +0000
+++ bzrlib/tests/per_workingtree/test_merge_from_branch.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -20,14 +20,13 @@
 import os
 
 from bzrlib import (
-    branchbuilder,
     errors,
     merge
     )
-from bzrlib.tests import per_workingtree
-
-
-class TestMergeFromBranch(per_workingtree.TestCaseWithWorkingTree):
+from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
+
+
+class TestMergeFromBranch(TestCaseWithWorkingTree):
 
     def create_two_trees_for_merging(self):
         """Create two trees that can be merged from.
@@ -115,103 +114,3 @@
                 self.tt.create_file('qux', trans_id)
         this.merge_from_branch(other.branch, merge_type=QuxMerge)
         self.assertEqual('qux', this.get_file_text('foo-id'))
-
-
-class TestMergedBranch(per_workingtree.TestCaseWithWorkingTree):
-
-    def make_branch_builder(self, relpath, format=None):
-        if format is None:
-            format = self.bzrdir_format
-        builder = branchbuilder.BranchBuilder(self.get_transport(),
-                                              format=format)
-        return builder
-
-    def make_inner_branch(self):
-        bld_inner = self.make_branch_builder('inner')
-        bld_inner.start_series()
-        bld_inner.build_snapshot(
-            '1', None,
-            [('add', ('', 'inner-root-id', 'directory', '')),
-             ('add', ('dir', 'dir-id', 'directory', '')),
-             ('add', ('dir/file1', 'file1-id', 'file', 'file1 content\n')),
-             ('add', ('file3', 'file3-id', 'file', 'file3 content\n')),
-             ])
-        bld_inner.build_snapshot(
-            '3', ['1'], [('modify', ('file3-id', 'new file3 contents\n')),])
-        bld_inner.build_snapshot(
-            '2', ['1'],
-            [('add', ('dir/file2', 'file2-id', 'file', 'file2 content\n')),
-             ])
-        bld_inner.finish_series()
-        br = bld_inner.get_branch()
-        return br
-
-    def assertTreeLayout(self, expected, tree):
-        tree.lock_read()
-        try:
-            actual = [e[0] for e in tree.list_files()]
-            # list_files doesn't guarantee order
-            actual = sorted(actual)
-            self.assertEqual(expected, actual)
-        finally:
-            tree.unlock()
-
-    def make_outer_tree(self):
-        outer = self.make_branch_and_tree('outer')
-        self.build_tree_contents([('outer/foo', 'foo')])
-        outer.add('foo', 'foo-id')
-        outer.commit('added foo')
-        inner = self.make_inner_branch()
-        outer.merge_from_branch(inner, to_revision='1', from_revision='null:')
-        outer.commit('merge inner branch')
-        outer.mkdir('dir-outer', 'dir-outer-id')
-        outer.move(['dir', 'file3'], to_dir='dir-outer')
-        outer.commit('rename imported dir and file3 to dir-outer')
-        return outer, inner
-
-    def test_file1_deleted_in_dir(self):
-        outer, inner = self.make_outer_tree()
-        outer.remove(['dir-outer/dir/file1'], keep_files=False)
-        outer.commit('delete file1')
-        outer.merge_from_branch(inner)
-        outer.commit('merge the rest')
-        self.assertTreeLayout(['dir-outer',
-                               'dir-outer/dir',
-                               'dir-outer/dir/file2',
-                               'dir-outer/file3',
-                               'foo'],
-                              outer)
-
-    def test_file3_deleted_in_root(self):
-        # Reproduce bug #375898
-        outer, inner = self.make_outer_tree()
-        outer.remove(['dir-outer/file3'], keep_files=False)
-        outer.commit('delete file3')
-        outer.merge_from_branch(inner)
-        outer.commit('merge the rest')
-        self.assertTreeLayout(['dir-outer',
-                               'dir-outer/dir',
-                               'dir-outer/dir/file1',
-                               'dir-outer/dir/file2',
-                               'foo'],
-                              outer)
-
-
-    def test_file3_in_root_conflicted(self):
-        outer, inner = self.make_outer_tree()
-        outer.remove(['dir-outer/file3'], keep_files=False)
-        outer.commit('delete file3')
-        nb_conflicts = outer.merge_from_branch(inner, to_revision='3')
-        self.assertEqual(4, nb_conflicts)
-        self.assertTreeLayout(['dir-outer',
-                               'dir-outer/dir',
-                               'dir-outer/dir/file1',
-                               # Ideally th conflict helpers should be in
-                               # dir-outer/dir but since we can't easily find
-                               # back the file3 -> outer-dir/dir rename, root
-                               # is good enough -- vila 20100401
-                               'file3.BASE',
-                               'file3.OTHER',
-                               'foo'],
-                              outer)
-

=== modified file 'bzrlib/tests/per_workingtree/test_pull.py'
--- bzrlib/tests/per_workingtree/test_pull.py	2010-01-11 23:02:32 +0000
+++ bzrlib/tests/per_workingtree/test_pull.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -56,15 +56,3 @@
         tree_b.pull(tree_a.branch)
         self.assertFileEqual('contents of from/file\n', 'to/file')
 
-    def test_pull_changes_root_id(self):
-        tree = self.make_branch_and_tree('from')
-        tree.set_root_id('first_root_id')
-        self.build_tree(['from/file'])
-        tree.add(['file'])
-        tree.commit('first')
-        to_tree = tree.bzrdir.sprout('to').open_workingtree()
-        self.assertEqual('first_root_id', to_tree.get_root_id())
-        tree.set_root_id('second_root_id')
-        tree.commit('second')
-        to_tree.pull(tree.branch)
-        self.assertEqual('second_root_id', to_tree.get_root_id())

=== modified file 'bzrlib/tests/per_workingtree/test_readonly.py'
--- bzrlib/tests/per_workingtree/test_readonly.py	2010-01-25 15:55:48 +0000
+++ bzrlib/tests/per_workingtree/test_readonly.py	2009-07-10 07:14:02 +0000
@@ -60,9 +60,13 @@
 
     def set_dirs_readonly(self, basedir):
         """Set all directories readonly, and have it cleanup on test exit."""
-        self.addCleanup(self._set_all_dirs, basedir, readonly=False)
         self._set_all_dirs(basedir, readonly=True)
 
+        def cleanup():
+            self._set_all_dirs(basedir, readonly=False)
+
+        self.addCleanup(cleanup)
+
     def create_basic_tree(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])

=== modified file 'bzrlib/tests/per_workingtree/test_revision_tree.py'
--- bzrlib/tests/per_workingtree/test_revision_tree.py	2010-03-10 09:33:04 +0000
+++ bzrlib/tests/per_workingtree/test_revision_tree.py	2009-07-10 07:14:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,15 +23,11 @@
 so these tests are testing that when there is a cache, it performs correctly.
 """
 
-from bzrlib import (
-    branchbuilder,
-    errors,
-    tests,
-    )
-from bzrlib.tests import per_workingtree
-
-
-class TestRevisionTree(per_workingtree.TestCaseWithWorkingTree):
+from bzrlib import errors
+from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
+
+
+class TestRevisionTree(TestCaseWithWorkingTree):
 
     def test_get_zeroth_basis_tree_via_revision_tree(self):
         tree = self.make_branch_and_tree('.')
@@ -87,50 +83,3 @@
             return
         repository_revision_tree = tree.branch.repository.revision_tree(rev1)
         self.assertTreesEqual(repository_revision_tree, cached_revision_tree)
-
-
-class TestRevisionTreeKind(per_workingtree.TestCaseWithWorkingTree):
-
-    def make_branch_with_merged_deletions(self, relpath='tree'):
-        tree = self.make_branch_and_tree(relpath)
-        files = ['a', 'b/', 'b/c']
-        self.build_tree(files, line_endings='binary',
-                        transport=tree.bzrdir.root_transport)
-        tree.set_root_id('root-id')
-        tree.add(files, ['a-id', 'b-id', 'c-id'])
-        tree.commit('a, b and b/c', rev_id='base')
-        tree2 = tree.bzrdir.sprout(relpath + '2').open_workingtree()
-        # Delete 'a' in tree
-        tree.remove('a', keep_files=False)
-        tree.commit('remove a', rev_id='this')
-        # Delete 'c' in tree2
-        tree2.remove('b/c', keep_files=False)
-        tree2.remove('b', keep_files=False)
-        tree2.commit('remove b/c', rev_id='other')
-        # Merge tree2 into tree
-        tree.merge_from_branch(tree2.branch)
-        return tree
-
-    def test_kind_parent_tree(self):
-        tree = self.make_branch_with_merged_deletions()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        parents = tree.get_parent_ids()
-        self.assertEqual(['this', 'other'], parents)
-        basis = tree.revision_tree(parents[0])
-        basis.lock_read()
-        self.addCleanup(basis.unlock)
-        self.assertRaises(errors.NoSuchId, basis.kind, 'a-id')
-        self.assertEqual(['directory', 'file'],
-                         [basis.kind('b-id'), basis.kind('c-id')])
-        try:
-            other = tree.revision_tree(parents[1])
-        except errors.NoSuchRevisionInTree:
-            raise tests.TestNotApplicable(
-                'Tree type %s caches only the basis revision tree.'
-                % type(tree))
-        other.lock_read()
-        self.addCleanup(other.unlock)
-        self.assertRaises(errors.NoSuchId, other.kind, 'b-id')
-        self.assertRaises(errors.NoSuchId, other.kind, 'c-id')
-        self.assertEqual('file', other.kind('a-id'))

=== modified file 'bzrlib/tests/per_workingtree/test_set_root_id.py'
--- bzrlib/tests/per_workingtree/test_set_root_id.py	2010-01-13 23:06:42 +0000
+++ bzrlib/tests/per_workingtree/test_set_root_id.py	2009-09-11 07:55:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 
 import sys
 
-from bzrlib import errors, inventory
+from bzrlib import inventory
 from bzrlib.tests import TestSkipped
 from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
 
@@ -53,19 +53,3 @@
         # should still be retained
         tree = tree.bzrdir.open_workingtree()
         self.assertEqual(root_id, tree.get_root_id())
-        tree._validate()
-
-    def test_set_root_id(self):
-        tree = self.make_branch_and_tree('.')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        orig_root_id = tree.get_root_id()
-        self.assertNotEqual('custom-root-id', orig_root_id)
-        self.assertEqual('', tree.id2path(orig_root_id))
-        self.assertRaises(errors.NoSuchId, tree.id2path, 'custom-root-id')
-        tree.set_root_id('custom-root-id')
-        self.assertEqual('custom-root-id', tree.get_root_id())
-        self.assertEqual('custom-root-id', tree.path2id(''))
-        self.assertEqual('', tree.id2path('custom-root-id'))
-        self.assertRaises(errors.NoSuchId, tree.id2path, orig_root_id)
-        tree._validate()

=== modified file 'bzrlib/tests/per_workingtree/test_smart_add.py'
--- bzrlib/tests/per_workingtree/test_smart_add.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_workingtree/test_smart_add.py	2009-11-08 04:49:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,14 +27,15 @@
     tests,
     workingtree,
     )
-from bzrlib.tests import (
-    features,
-    test_smart_add,
-    per_workingtree,
+from bzrlib.add import (
+    AddAction,
+    AddFromBaseAction,
     )
-
-
-class TestSmartAddTree(per_workingtree.TestCaseWithWorkingTree):
+from bzrlib.tests.test_smart_add import AddCustomIDAction
+from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
+
+
+class TestSmartAddTree(TestCaseWithWorkingTree):
 
     def test_single_file(self):
         tree = self.make_branch_and_tree('tree')
@@ -204,8 +205,7 @@
 
     def test_custom_ids(self):
         sio = StringIO()
-        action = test_smart_add.AddCustomIDAction(to_file=sio,
-                                                  should_print=True)
+        action = AddCustomIDAction(to_file=sio, should_print=True)
         self.build_tree(['file1', 'dir1/', 'dir1/file2'])
 
         wt = self.make_branch_and_tree('.')
@@ -226,87 +226,60 @@
                          ], [(path, ie.file_id) for path, ie
                                 in wt.inventory.iter_entries()])
 
-
-class TestSmartAddConflictRelatedFiles(per_workingtree.TestCaseWithWorkingTree):
-
-    def make_tree_with_text_conflict(self):
-        tb = self.make_branch_and_tree('base')
-        self.build_tree_contents([('base/file', 'content in base')])
-        tb.add('file')
-        tb.commit('Adding file')
-
-        t1 = tb.bzrdir.sprout('t1').open_workingtree()
-
-        self.build_tree_contents([('base/file', 'content changed in base')])
-        tb.commit('Changing file in base')
-
-        self.build_tree_contents([('t1/file', 'content in t1')])
-        t1.commit('Changing file in t1')
-        t1.merge_from_branch(tb.branch)
-        return t1
-
-    def test_cant_add_generated_files_implicitly(self):
-        t = self.make_tree_with_text_conflict()
-        added, ignored = t.smart_add([t.basedir])
-        self.assertEqual(([], {}), (added, ignored))
-
-    def test_can_add_generated_files_explicitly(self):
-        fnames = ['file.%s' % s  for s in ('BASE', 'THIS', 'OTHER')]
-        t = self.make_tree_with_text_conflict()
-        added, ignored = t.smart_add([t.basedir + '/%s' % f for f in fnames])
-        self.assertEqual((fnames, {}), (added, ignored))
-
-
-class TestSmartAddTreeUnicode(per_workingtree.TestCaseWithWorkingTree):
-
-    _test_needs_features = [tests.UnicodeFilenameFeature]
-
-    def setUp(self):
-        super(TestSmartAddTreeUnicode, self).setUp()
-        self.build_tree([u'a\u030a'])
+    def make_unicode_containing_tree(self):
+        try:
+            self.build_tree([u'a\u030a'])
+        except UnicodeError:
+            raise tests.TestSkipped('Filesystem cannot create unicode filenames')
         self.wt = self.make_branch_and_tree('.')
-        self.overrideAttr(osutils, 'normalized_filename')
 
     def test_accessible_explicit(self):
+        self.make_unicode_containing_tree()
+        orig = osutils.normalized_filename
         osutils.normalized_filename = osutils._accessible_normalized_filename
-        if isinstance(self.workingtree_format, workingtree.WorkingTreeFormat2):
-            self.expectFailure(
-                'With WorkingTreeFormat2, smart_add requires'
-                ' normalized unicode filenames',
-                self.assertRaises, errors.NoSuchFile,
-                self.wt.smart_add, [u'a\u030a'])
-        else:
+        try:
             self.wt.smart_add([u'a\u030a'])
-        self.wt.lock_read()
-        self.addCleanup(self.wt.unlock)
-        self.assertEqual([('', 'directory'), (u'\xe5', 'file')],
-                         [(path, ie.kind) for path,ie in
-                          self.wt.inventory.iter_entries()])
+            self.wt.lock_read()
+            self.addCleanup(self.wt.unlock)
+            self.assertEqual([('', 'directory'), (u'\xe5', 'file')],
+                    [(path, ie.kind) for path,ie in
+                        self.wt.inventory.iter_entries()])
+        finally:
+            osutils.normalized_filename = orig
 
     def test_accessible_implicit(self):
+        self.make_unicode_containing_tree()
+        orig = osutils.normalized_filename
         osutils.normalized_filename = osutils._accessible_normalized_filename
-        if isinstance(self.workingtree_format, workingtree.WorkingTreeFormat2):
-            self.expectFailure(
-                'With WorkingTreeFormat2, smart_add requires'
-                ' normalized unicode filenames',
-                self.assertRaises, errors.NoSuchFile,
-                self.wt.smart_add, [])
-        else:
+        try:
             self.wt.smart_add([])
-        self.wt.lock_read()
-        self.addCleanup(self.wt.unlock)
-        self.assertEqual([('', 'directory'), (u'\xe5', 'file')],
-                         [(path, ie.kind) for path,ie
-                          in self.wt.inventory.iter_entries()])
+            self.wt.lock_read()
+            self.addCleanup(self.wt.unlock)
+            self.assertEqual([('', 'directory'), (u'\xe5', 'file')],
+                    [(path, ie.kind) for path,ie in
+                        self.wt.inventory.iter_entries()])
+        finally:
+            osutils.normalized_filename = orig
 
     def test_inaccessible_explicit(self):
+        self.make_unicode_containing_tree()
+        orig = osutils.normalized_filename
         osutils.normalized_filename = osutils._inaccessible_normalized_filename
-        self.assertRaises(errors.InvalidNormalization,
-                          self.wt.smart_add, [u'a\u030a'])
+        try:
+            self.assertRaises(errors.InvalidNormalization,
+                    self.wt.smart_add, [u'a\u030a'])
+        finally:
+            osutils.normalized_filename = orig
 
     def test_inaccessible_implicit(self):
+        self.make_unicode_containing_tree()
+        orig = osutils.normalized_filename
         osutils.normalized_filename = osutils._inaccessible_normalized_filename
-        # TODO: jam 20060701 In the future, this should probably
-        #       just ignore files that don't fit the normalization
-        #       rules, rather than exploding
-        self.assertRaises(errors.InvalidNormalization, self.wt.smart_add, [])
+        try:
+            # TODO: jam 20060701 In the future, this should probably
+            #       just ignore files that don't fit the normalization
+            #       rules, rather than exploding
+            self.assertRaises(errors.InvalidNormalization,
+                    self.wt.smart_add, [])
+        finally:
+            osutils.normalized_filename = orig

=== modified file 'bzrlib/tests/per_workingtree/test_workingtree.py'
--- bzrlib/tests/per_workingtree/test_workingtree.py	2010-04-21 09:41:26 +0000
+++ bzrlib/tests/per_workingtree/test_workingtree.py	2009-12-22 07:03:38 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #           and others
 #
@@ -23,7 +23,6 @@
 
 from bzrlib import (
     branch,
-    branchbuilder,
     bzrdir,
     errors,
     osutils,
@@ -236,7 +235,7 @@
         revid = b.revision_history()[0]
         self.log('first revision_id is {%s}' % revid)
 
-        inv = b.repository.get_inventory(revid)
+        inv = b.repository.get_revision_inventory(revid)
         self.log('contents of inventory: %r' % inv.entries())
 
         self.check_inventory_shape(inv,
@@ -423,8 +422,7 @@
         made_control = self.bzrdir_format.initialize('new')
         source.branch.repository.clone(made_control)
         source.branch.clone(made_control)
-        made_tree = self.workingtree_format.initialize(made_control,
-            revision_id='a')
+        made_tree = self.workingtree_format.initialize(made_control, revision_id='a')
         self.assertEqual(['a'], made_tree.get_parent_ids())
 
     def test_update_sets_last_revision(self):
@@ -448,8 +446,7 @@
         # current format
         self.build_tree(['checkout/', 'tree/file'])
         checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
-        branch.BranchReferenceFormat().initialize(checkout,
-            target_branch=main_branch)
+        branch.BranchReferenceFormat().initialize(checkout, main_branch)
         old_tree = self.workingtree_format.initialize(checkout)
         # now commit to 'tree'
         wt.add('file')
@@ -481,20 +478,6 @@
         self.assertEqual(wt.get_root_id(), checkout.get_root_id())
         self.assertNotEqual(None, wt.get_root_id())
 
-    def test_update_sets_updated_root_id(self):
-        wt = self.make_branch_and_tree('tree')
-        wt.set_root_id('first_root_id')
-        self.assertEqual('first_root_id', wt.get_root_id())
-        self.build_tree(['tree/file'])
-        wt.add(['file'])
-        wt.commit('first')
-        co = wt.branch.create_checkout('checkout')
-        wt.set_root_id('second_root_id')
-        wt.commit('second')
-        self.assertEqual('second_root_id', wt.get_root_id())
-        self.assertEqual(0, co.update())
-        self.assertEqual('second_root_id', co.get_root_id())
-
     def test_update_returns_conflict_count(self):
         # working tree formats from the meta-dir format and newer support
         # setting the last revision on a tree independently of that on the
@@ -516,8 +499,7 @@
         # current format
         self.build_tree(['checkout/', 'tree/file'])
         checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
-        branch.BranchReferenceFormat().initialize(checkout,
-            target_branch=main_branch)
+        branch.BranchReferenceFormat().initialize(checkout, main_branch)
         old_tree = self.workingtree_format.initialize(checkout)
         # now commit to 'tree'
         wt.add('file')
@@ -953,112 +935,6 @@
             os.link = real_os_link
 
 
-class TestWorkingTreeUpdate(TestCaseWithWorkingTree):
-
-    def make_diverged_master_branch(self):
-        """
-        B: wt.branch.last_revision()
-        M: wt.branch.get_master_branch().last_revision()
-        W: wt.last_revision()
-
-
-            1
-            |\
-          B-2 3
-            | |
-            4 5-M
-            |
-            W
-         """
-        builder = branchbuilder.BranchBuilder(
-            self.get_transport(),
-            format=self.workingtree_format._matchingbzrdir)
-        builder.start_series()
-        # mainline
-        builder.build_snapshot(
-            '1', None,
-            [('add', ('', 'root-id', 'directory', '')),
-             ('add', ('file1', 'file1-id', 'file', 'file1 content\n'))])
-        # branch
-        builder.build_snapshot('2', ['1'], [])
-        builder.build_snapshot(
-            '4', ['2'],
-            [('add', ('file4', 'file4-id', 'file', 'file4 content\n'))])
-        # master
-        builder.build_snapshot('3', ['1'], [])
-        builder.build_snapshot(
-            '5', ['3'],
-            [('add', ('file5', 'file5-id', 'file', 'file5 content\n'))])
-        builder.finish_series()
-        return builder, builder._branch.last_revision()
-
-    def make_checkout_and_master(self, builder, wt_path, master_path, wt_revid,
-                                 master_revid=None, branch_revid=None):
-        """Build a lightweight checkout and its master branch."""
-        if master_revid is None:
-            master_revid = wt_revid
-        if branch_revid is None:
-            branch_revid = master_revid
-        final_branch = builder.get_branch()
-        # The master branch
-        master = final_branch.bzrdir.sprout(master_path,
-                                            master_revid).open_branch()
-        # The checkout
-        wt = self.make_branch_and_tree(wt_path)
-        wt.pull(final_branch, stop_revision=wt_revid)
-        wt.branch.pull(final_branch, stop_revision=branch_revid, overwrite=True)
-        try:
-            wt.branch.bind(master)
-        except errors.UpgradeRequired:
-            raise TestNotApplicable(
-                "Can't bind %s" % wt.branch._format.__class__)
-        return wt, master
-
-    def test_update_remove_commit(self):
-        """Update should remove revisions when the branch has removed
-        some commits.
-
-        We want to revert 4, so that strating with the
-        make_diverged_master_branch() graph the final result should be
-        equivalent to:
-
-           1
-           |\
-           3 2
-           | |\
-        MB-5 | 4
-           |/
-           W
-
-        And the changes in 4 have been removed from the WT.
-        """
-        builder, tip = self.make_diverged_master_branch()
-        wt, master = self.make_checkout_and_master(
-            builder, 'checkout', 'master', '4',
-            master_revid=tip, branch_revid='2')
-        # First update the branch
-        old_tip = wt.branch.update()
-        self.assertEqual('2', old_tip)
-        # No conflicts should occur
-        self.assertEqual(0, wt.update(old_tip=old_tip))
-        # We are in sync with the master
-        self.assertEqual(tip, wt.branch.last_revision())
-        # We have the right parents ready to be committed
-        self.assertEqual(['5', '2'], wt.get_parent_ids())
-
-    def test_update_revision(self):
-        builder, tip = self.make_diverged_master_branch()
-        wt, master = self.make_checkout_and_master(
-            builder, 'checkout', 'master', '4',
-            master_revid=tip, branch_revid='2')
-        self.assertEqual(0, wt.update(revision='1'))
-        self.assertEqual('1', wt.last_revision())
-        self.assertEqual(tip, wt.branch.last_revision())
-        self.failUnlessExists('checkout/file1')
-        self.failIfExists('checkout/file4')
-        self.failIfExists('checkout/file5')
-
-
 class TestIllegalPaths(TestCaseWithWorkingTree):
 
     def test_bad_fs_path(self):
@@ -1091,16 +967,3 @@
         # We should display the relative path
         self.assertEqual('subdir/m\xb5', e.filename)
         self.assertEqual(osutils._fs_enc, e.fs_encoding)
-
-
-class TestControlComponent(TestCaseWithWorkingTree):
-    """WorkingTree implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        wt = self.make_branch_and_tree('wt')
-        self.assertIsInstance(wt.user_url, str)
-        self.assertEqual(wt.user_url, wt.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(wt.control_url.find(wt.user_url), 0)
-        self.assertEqual(wt.control_url, wt.control_transport.base)

=== modified file 'bzrlib/tests/script.py'
--- bzrlib/tests/script.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/script.py	2009-12-11 05:29:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -402,31 +402,6 @@
             retcode = 0
         return retcode, None, err
 
-    def do_mv(self, test_case, input, args):
-        err = None
-        def error(msg, src, dst):
-            return "mv: cannot move %s to %s: %s\n" % (src, dst, msg)
-
-        if not args or len(args) != 2:
-            raise SyntaxError("Usage: mv path1 path2")
-        src, dst = args
-        try:
-            real_dst = dst
-            if os.path.isdir(dst):
-                real_dst = os.path.join(dst, os.path.basename(src))
-            os.rename(src, real_dst)
-        except OSError, e:
-            if e.errno == errno.ENOENT:
-                err = error('No such file or directory', src, dst)
-            else:
-                raise
-        if err:
-            retcode = 1
-        else:
-            retcode = 0
-        return retcode, None, err
-
-
 
 class TestCaseWithMemoryTransportAndScript(tests.TestCaseWithMemoryTransport):
     """Helper class to experiment shell-like test and memory fs.

=== modified file 'bzrlib/tests/stub_sftp.py'
--- bzrlib/tests/stub_sftp.py	2010-03-11 04:33:41 +0000
+++ bzrlib/tests/stub_sftp.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009, 2010 Robey Pointer <robey@lag.net>, Canonical Ltd
+# Copyright (C) 2005 Robey Pointer <robey@lag.net>, Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,63 +20,51 @@
 """
 
 import os
-import paramiko
-import select
-import socket
+from paramiko import ServerInterface, SFTPServerInterface, SFTPServer, SFTPAttributes, \
+    SFTPHandle, SFTP_OK, AUTH_SUCCESSFUL, OPEN_SUCCEEDED
 import sys
-import threading
-import time
-
-from bzrlib import (
-    osutils,
-    trace,
-    urlutils,
-    )
-from bzrlib.transport import (
-    ssh,
-    )
-from bzrlib.tests import test_server
-
-
-class StubServer (paramiko.ServerInterface):
+
+from bzrlib.osutils import pathjoin
+from bzrlib.trace import mutter
+
+
+class StubServer (ServerInterface):
 
     def __init__(self, test_case):
-        paramiko.ServerInterface.__init__(self)
+        ServerInterface.__init__(self)
         self._test_case = test_case
 
     def check_auth_password(self, username, password):
         # all are allowed
         self._test_case.log('sftpserver - authorizing: %s' % (username,))
-        return paramiko.AUTH_SUCCESSFUL
+        return AUTH_SUCCESSFUL
 
     def check_channel_request(self, kind, chanid):
-        self._test_case.log(
-            'sftpserver - channel request: %s, %s' % (kind, chanid))
-        return paramiko.OPEN_SUCCEEDED
-
-
-class StubSFTPHandle (paramiko.SFTPHandle):
+        self._test_case.log('sftpserver - channel request: %s, %s' % (kind, chanid))
+        return OPEN_SUCCEEDED
+
+
+class StubSFTPHandle (SFTPHandle):
     def stat(self):
         try:
-            return paramiko.SFTPAttributes.from_stat(
-                os.fstat(self.readfile.fileno()))
+            return SFTPAttributes.from_stat(os.fstat(self.readfile.fileno()))
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
+            return SFTPServer.convert_errno(e.errno)
 
     def chattr(self, attr):
         # python doesn't have equivalents to fchown or fchmod, so we have to
         # use the stored filename
-        trace.mutter('Changing permissions on %s to %s', self.filename, attr)
+        mutter('Changing permissions on %s to %s', self.filename, attr)
         try:
-            paramiko.SFTPServer.set_file_attr(self.filename, attr)
+            SFTPServer.set_file_attr(self.filename, attr)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
-
-
-class StubSFTPServer (paramiko.SFTPServerInterface):
+            return SFTPServer.convert_errno(e.errno)
+
+
+class StubSFTPServer (SFTPServerInterface):
 
     def __init__(self, server, root, home=None):
-        paramiko.SFTPServerInterface.__init__(self, server)
+        SFTPServerInterface.__init__(self, server)
         # All paths are actually relative to 'root'.
         # this is like implementing chroot().
         self.root = root
@@ -125,10 +113,10 @@
 
     def chattr(self, path, attr):
         try:
-            paramiko.SFTPServer.set_file_attr(path, attr)
+            SFTPServer.set_file_attr(path, attr)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
-        return paramiko.SFTP_OK
+            return SFTPServer.convert_errno(e.errno)
+        return SFTP_OK
 
     def list_folder(self, path):
         path = self._realpath(path)
@@ -142,27 +130,26 @@
             else:
                 flist = os.listdir(path)
             for fname in flist:
-                attr = paramiko.SFTPAttributes.from_stat(
-                    os.stat(osutils.pathjoin(path, fname)))
+                attr = SFTPAttributes.from_stat(os.stat(pathjoin(path, fname)))
                 attr.filename = fname
                 out.append(attr)
             return out
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
+            return SFTPServer.convert_errno(e.errno)
 
     def stat(self, path):
         path = self._realpath(path)
         try:
-            return paramiko.SFTPAttributes.from_stat(os.stat(path))
+            return SFTPAttributes.from_stat(os.stat(path))
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
+            return SFTPServer.convert_errno(e.errno)
 
     def lstat(self, path):
         path = self._realpath(path)
         try:
-            return paramiko.SFTPAttributes.from_stat(os.lstat(path))
+            return SFTPAttributes.from_stat(os.lstat(path))
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
+            return SFTPServer.convert_errno(e.errno)
 
     def open(self, path, flags, attr):
         path = self._realpath(path)
@@ -175,11 +162,11 @@
                 # an odd default mode for files
                 fd = os.open(path, flags, 0666)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
+            return SFTPServer.convert_errno(e.errno)
 
         if (flags & os.O_CREAT) and (attr is not None):
             attr._flags &= ~attr.FLAG_PERMISSIONS
-            paramiko.SFTPServer.set_file_attr(path, attr)
+            SFTPServer.set_file_attr(path, attr)
         if flags & os.O_WRONLY:
             fstr = 'wb'
         elif flags & os.O_RDWR:
@@ -190,7 +177,7 @@
         try:
             f = os.fdopen(fd, fstr)
         except (IOError, OSError), e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
+            return SFTPServer.convert_errno(e.errno)
         fobj = StubSFTPHandle()
         fobj.filename = path
         fobj.readfile = f
@@ -202,8 +189,8 @@
         try:
             os.remove(path)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
-        return paramiko.SFTP_OK
+            return SFTPServer.convert_errno(e.errno)
+        return SFTP_OK
 
     def rename(self, oldpath, newpath):
         oldpath = self._realpath(oldpath)
@@ -211,8 +198,8 @@
         try:
             os.rename(oldpath, newpath)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
-        return paramiko.SFTP_OK
+            return SFTPServer.convert_errno(e.errno)
+        return SFTP_OK
 
     def mkdir(self, path, attr):
         path = self._realpath(path)
@@ -225,340 +212,18 @@
                 os.mkdir(path)
             if attr is not None:
                 attr._flags &= ~attr.FLAG_PERMISSIONS
-                paramiko.SFTPServer.set_file_attr(path, attr)
+                SFTPServer.set_file_attr(path, attr)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
-        return paramiko.SFTP_OK
+            return SFTPServer.convert_errno(e.errno)
+        return SFTP_OK
 
     def rmdir(self, path):
         path = self._realpath(path)
         try:
             os.rmdir(path)
         except OSError, e:
-            return paramiko.SFTPServer.convert_errno(e.errno)
-        return paramiko.SFTP_OK
+            return SFTPServer.convert_errno(e.errno)
+        return SFTP_OK
 
     # removed: chattr, symlink, readlink
     # (nothing in bzr's sftp transport uses those)
-
-# ------------- server test implementation --------------
-
-STUB_SERVER_KEY = """
------BEGIN RSA PRIVATE KEY-----
-MIICWgIBAAKBgQDTj1bqB4WmayWNPB+8jVSYpZYk80Ujvj680pOTh2bORBjbIAyz
-oWGW+GUjzKxTiiPvVmxFgx5wdsFvF03v34lEVVhMpouqPAYQ15N37K/ir5XY+9m/
-d8ufMCkjeXsQkKqFbAlQcnWMCRnOoPHS3I4vi6hmnDDeeYTSRvfLbW0fhwIBIwKB
-gBIiOqZYaoqbeD9OS9z2K9KR2atlTxGxOJPXiP4ESqP3NVScWNwyZ3NXHpyrJLa0
-EbVtzsQhLn6rF+TzXnOlcipFvjsem3iYzCpuChfGQ6SovTcOjHV9z+hnpXvQ/fon
-soVRZY65wKnF7IAoUwTmJS9opqgrN6kRgCd3DASAMd1bAkEA96SBVWFt/fJBNJ9H
-tYnBKZGw0VeHOYmVYbvMSstssn8un+pQpUm9vlG/bp7Oxd/m+b9KWEh2xPfv6zqU
-avNwHwJBANqzGZa/EpzF4J8pGti7oIAPUIDGMtfIcmqNXVMckrmzQ2vTfqtkEZsA
-4rE1IERRyiJQx6EJsz21wJmGV9WJQ5kCQQDwkS0uXqVdFzgHO6S++tjmjYcxwr3g
-H0CoFYSgbddOT6miqRskOQF3DZVkJT3kyuBgU2zKygz52ukQZMqxCb1fAkASvuTv
-qfpH87Qq5kQhNKdbbwbmd2NxlNabazPijWuphGTdW0VfJdWfklyS2Kr+iqrs/5wV
-HhathJt636Eg7oIjAkA8ht3MQ+XSl9yIJIS8gVpbPxSw5OMfw0PjVE7tBdQruiSc
-nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
------END RSA PRIVATE KEY-----
-"""
-
-
-class SocketListener(threading.Thread):
-
-    def __init__(self, callback):
-        threading.Thread.__init__(self)
-        self._callback = callback
-        self._socket = socket.socket()
-        self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
-        self._socket.bind(('localhost', 0))
-        self._socket.listen(1)
-        self.host, self.port = self._socket.getsockname()[:2]
-        self._stop_event = threading.Event()
-
-    def stop(self):
-        # called from outside this thread
-        self._stop_event.set()
-        # use a timeout here, because if the test fails, the server thread may
-        # never notice the stop_event.
-        self.join(5.0)
-        self._socket.close()
-
-    def run(self):
-        while True:
-            readable, writable_unused, exception_unused = \
-                select.select([self._socket], [], [], 0.1)
-            if self._stop_event.isSet():
-                return
-            if len(readable) == 0:
-                continue
-            try:
-                s, addr_unused = self._socket.accept()
-                # because the loopback socket is inline, and transports are
-                # never explicitly closed, best to launch a new thread.
-                threading.Thread(target=self._callback, args=(s,)).start()
-            except socket.error, x:
-                sys.excepthook(*sys.exc_info())
-                trace.warning('Socket error during accept() '
-                              'within unit test server thread: %r' % x)
-            except Exception, x:
-                # probably a failed test; unit test thread will log the
-                # failure/error
-                sys.excepthook(*sys.exc_info())
-                trace.warning(
-                    'Exception from within unit test server thread: %r' % x)
-
-
-class SocketDelay(object):
-    """A socket decorator to make TCP appear slower.
-
-    This changes recv, send, and sendall to add a fixed latency to each python
-    call if a new roundtrip is detected. That is, when a recv is called and the
-    flag new_roundtrip is set, latency is charged. Every send and send_all
-    sets this flag.
-
-    In addition every send, sendall and recv sleeps a bit per character send to
-    simulate bandwidth.
-
-    Not all methods are implemented, this is deliberate as this class is not a
-    replacement for the builtin sockets layer. fileno is not implemented to
-    prevent the proxy being bypassed.
-    """
-
-    simulated_time = 0
-    _proxied_arguments = dict.fromkeys([
-        "close", "getpeername", "getsockname", "getsockopt", "gettimeout",
-        "setblocking", "setsockopt", "settimeout", "shutdown"])
-
-    def __init__(self, sock, latency, bandwidth=1.0,
-                 really_sleep=True):
-        """
-        :param bandwith: simulated bandwith (MegaBit)
-        :param really_sleep: If set to false, the SocketDelay will just
-        increase a counter, instead of calling time.sleep. This is useful for
-        unittesting the SocketDelay.
-        """
-        self.sock = sock
-        self.latency = latency
-        self.really_sleep = really_sleep
-        self.time_per_byte = 1 / (bandwidth / 8.0 * 1024 * 1024)
-        self.new_roundtrip = False
-
-    def sleep(self, s):
-        if self.really_sleep:
-            time.sleep(s)
-        else:
-            SocketDelay.simulated_time += s
-
-    def __getattr__(self, attr):
-        if attr in SocketDelay._proxied_arguments:
-            return getattr(self.sock, attr)
-        raise AttributeError("'SocketDelay' object has no attribute %r" %
-                             attr)
-
-    def dup(self):
-        return SocketDelay(self.sock.dup(), self.latency, self.time_per_byte,
-                           self._sleep)
-
-    def recv(self, *args):
-        data = self.sock.recv(*args)
-        if data and self.new_roundtrip:
-            self.new_roundtrip = False
-            self.sleep(self.latency)
-        self.sleep(len(data) * self.time_per_byte)
-        return data
-
-    def sendall(self, data, flags=0):
-        if not self.new_roundtrip:
-            self.new_roundtrip = True
-            self.sleep(self.latency)
-        self.sleep(len(data) * self.time_per_byte)
-        return self.sock.sendall(data, flags)
-
-    def send(self, data, flags=0):
-        if not self.new_roundtrip:
-            self.new_roundtrip = True
-            self.sleep(self.latency)
-        bytes_sent = self.sock.send(data, flags)
-        self.sleep(bytes_sent * self.time_per_byte)
-        return bytes_sent
-
-
-class SFTPServer(test_server.TestServer):
-    """Common code for SFTP server facilities."""
-
-    def __init__(self, server_interface=StubServer):
-        self._original_vendor = None
-        self._homedir = None
-        self._server_homedir = None
-        self._listener = None
-        self._root = None
-        self._vendor = ssh.ParamikoVendor()
-        self._server_interface = server_interface
-        # sftp server logs
-        self.logs = []
-        self.add_latency = 0
-
-    def _get_sftp_url(self, path):
-        """Calculate an sftp url to this server for path."""
-        return 'sftp://foo:bar@%s:%d/%s' % (self._listener.host,
-                                            self._listener.port, path)
-
-    def log(self, message):
-        """StubServer uses this to log when a new server is created."""
-        self.logs.append(message)
-
-    def _run_server_entry(self, sock):
-        """Entry point for all implementations of _run_server.
-
-        If self.add_latency is > 0.000001 then sock is given a latency adding
-        decorator.
-        """
-        if self.add_latency > 0.000001:
-            sock = SocketDelay(sock, self.add_latency)
-        return self._run_server(sock)
-
-    def _run_server(self, s):
-        ssh_server = paramiko.Transport(s)
-        key_file = osutils.pathjoin(self._homedir, 'test_rsa.key')
-        f = open(key_file, 'w')
-        f.write(STUB_SERVER_KEY)
-        f.close()
-        host_key = paramiko.RSAKey.from_private_key_file(key_file)
-        ssh_server.add_server_key(host_key)
-        server = self._server_interface(self)
-        ssh_server.set_subsystem_handler('sftp', paramiko.SFTPServer,
-                                         StubSFTPServer, root=self._root,
-                                         home=self._server_homedir)
-        event = threading.Event()
-        ssh_server.start_server(event, server)
-        event.wait(5.0)
-
-    def start_server(self, backing_server=None):
-        # XXX: TODO: make sftpserver back onto backing_server rather than local
-        # disk.
-        if not (backing_server is None or
-                isinstance(backing_server, test_server.LocalURLServer)):
-            raise AssertionError(
-                'backing_server should not be %r, because this can only serve '
-                'the local current working directory.' % (backing_server,))
-        self._original_vendor = ssh._ssh_vendor_manager._cached_ssh_vendor
-        ssh._ssh_vendor_manager._cached_ssh_vendor = self._vendor
-        # FIXME: the following block should certainly just be self._homedir =
-        # osutils.getcwd() but that fails badly on Unix -- vila 20100224
-        if sys.platform == 'win32':
-            # Win32 needs to use the UNICODE api
-            self._homedir = os.getcwdu()
-        else:
-            # But Linux SFTP servers should just deal in bytestreams
-            self._homedir = os.getcwd()
-        if self._server_homedir is None:
-            self._server_homedir = self._homedir
-        self._root = '/'
-        if sys.platform == 'win32':
-            self._root = ''
-        self._listener = SocketListener(self._run_server_entry)
-        self._listener.setDaemon(True)
-        self._listener.start()
-
-    def stop_server(self):
-        self._listener.stop()
-        ssh._ssh_vendor_manager._cached_ssh_vendor = self._original_vendor
-
-    def get_bogus_url(self):
-        """See bzrlib.transport.Server.get_bogus_url."""
-        # this is chosen to try to prevent trouble with proxies, wierd dns, etc
-        # we bind a random socket, so that we get a guaranteed unused port
-        # we just never listen on that port
-        s = socket.socket()
-        s.bind(('localhost', 0))
-        return 'sftp://%s:%s/' % s.getsockname()
-
-
-class SFTPFullAbsoluteServer(SFTPServer):
-    """A test server for sftp transports, using absolute urls and ssh."""
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        homedir = self._homedir
-        if sys.platform != 'win32':
-            # Remove the initial '/' on all platforms but win32
-            homedir = homedir[1:]
-        return self._get_sftp_url(urlutils.escape(homedir))
-
-
-class SFTPServerWithoutSSH(SFTPServer):
-    """An SFTP server that uses a simple TCP socket pair rather than SSH."""
-
-    def __init__(self):
-        super(SFTPServerWithoutSSH, self).__init__()
-        self._vendor = ssh.LoopbackVendor()
-
-    def _run_server(self, sock):
-        # Re-import these as locals, so that they're still accessible during
-        # interpreter shutdown (when all module globals get set to None, leading
-        # to confusing errors like "'NoneType' object has no attribute 'error'".
-        class FakeChannel(object):
-            def get_transport(self):
-                return self
-            def get_log_channel(self):
-                return 'paramiko'
-            def get_name(self):
-                return '1'
-            def get_hexdump(self):
-                return False
-            def close(self):
-                pass
-
-        server = paramiko.SFTPServer(
-            FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
-            root=self._root, home=self._server_homedir)
-        try:
-            server.start_subsystem(
-                'sftp', None, ssh.SocketAsChannelAdapter(sock))
-        except socket.error, e:
-            if (len(e.args) > 0) and (e.args[0] == errno.EPIPE):
-                # it's okay for the client to disconnect abruptly
-                # (bug in paramiko 1.6: it should absorb this exception)
-                pass
-            else:
-                raise
-        except Exception, e:
-            # This typically seems to happen during interpreter shutdown, so
-            # most of the useful ways to report this error are won't work.
-            # Writing the exception type, and then the text of the exception,
-            # seems to be the best we can do.
-            import sys
-            sys.stderr.write('\nEXCEPTION %r: ' % (e.__class__,))
-            sys.stderr.write('%s\n\n' % (e,))
-        server.finish_subsystem()
-
-
-class SFTPAbsoluteServer(SFTPServerWithoutSSH):
-    """A test server for sftp transports, using absolute urls."""
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        homedir = self._homedir
-        if sys.platform != 'win32':
-            # Remove the initial '/' on all platforms but win32
-            homedir = homedir[1:]
-        return self._get_sftp_url(urlutils.escape(homedir))
-
-
-class SFTPHomeDirServer(SFTPServerWithoutSSH):
-    """A test server for sftp transports, using homedir relative urls."""
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        return self._get_sftp_url("~/")
-
-
-class SFTPSiblingAbsoluteServer(SFTPAbsoluteServer):
-    """A test server for sftp transports where only absolute paths will work.
-
-    It does this by serving from a deeply-nested directory that doesn't exist.
-    """
-
-    def start_server(self, backing_server=None):
-        self._server_homedir = '/dev/noone/runs/tests/here'
-        super(SFTPSiblingAbsoluteServer, self).start_server(backing_server)
-

=== modified file 'bzrlib/tests/test__annotator.py'
--- bzrlib/tests/test__annotator.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__annotator.py	2009-12-22 16:47:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__bencode.py'
--- bzrlib/tests/test__bencode.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__bencode.py	2009-12-23 04:19:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__chk_map.py'
--- bzrlib/tests/test__chk_map.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__chk_map.py	2009-12-22 16:28:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__chunks_to_lines.py'
--- bzrlib/tests/test__chunks_to_lines.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__chunks_to_lines.py	2009-12-22 17:14:45 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__dirstate_helpers.py'
--- bzrlib/tests/test__dirstate_helpers.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test__dirstate_helpers.py	2010-01-05 04:08:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -831,7 +831,11 @@
 
     def setUp(self):
         super(TestUpdateEntry, self).setUp()
-        self.overrideAttr(dirstate, 'update_entry', self.update_entry)
+        orig = dirstate.update_entry
+        def cleanup():
+            dirstate.update_entry = orig
+        self.addCleanup(cleanup)
+        dirstate.update_entry = self.update_entry
 
     def get_state_with_a(self):
         """Create a DirState tracking a single object named 'a'"""
@@ -1274,7 +1278,11 @@
 
     def setUp(self):
         super(TestProcessEntry, self).setUp()
-        self.overrideAttr(dirstate, '_process_entry', self._process_entry)
+        orig = dirstate._process_entry
+        def cleanup():
+            dirstate._process_entry = orig
+        self.addCleanup(cleanup)
+        dirstate._process_entry = self._process_entry
 
     def assertChangedFileIds(self, expected, tree):
         tree.lock_read()
@@ -1289,6 +1297,8 @@
         # This is a direct test of bug #495023, it relies on osutils.is_inside
         # getting called in an inner function. Which makes it a bit brittle,
         # but at least it does reproduce the bug.
+        def is_inside_raises(*args, **kwargs):
+            raise RuntimeError('stop this')
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/file', 'tree/dir/', 'tree/dir/sub',
                          'tree/dir2/', 'tree/dir2/sub2'])
@@ -1297,9 +1307,9 @@
         tree.lock_read()
         self.addCleanup(tree.unlock)
         basis_tree = tree.basis_tree()
-        def is_inside_raises(*args, **kwargs):
-            raise RuntimeError('stop this')
-        self.overrideAttr(osutils, 'is_inside', is_inside_raises)
+        orig = osutils.is_inside
+        self.addCleanup(setattr, osutils, 'is_inside', orig)
+        osutils.is_inside = is_inside_raises
         self.assertListRaises(RuntimeError, tree.iter_changes, basis_tree)
 
     def test_simple_changes(self):

=== modified file 'bzrlib/tests/test__groupcompress.py'
--- bzrlib/tests/test__groupcompress.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__groupcompress.py	2009-12-22 15:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__known_graph.py'
--- bzrlib/tests/test__known_graph.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__known_graph.py	2009-12-22 15:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__rio.py'
--- bzrlib/tests/test__rio.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__rio.py	2009-12-22 16:28:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__simple_set.py'
--- bzrlib/tests/test__simple_set.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__simple_set.py	2009-12-22 15:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test__static_tuple.py'
--- bzrlib/tests/test__static_tuple.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test__static_tuple.py	2009-12-22 16:28:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -77,9 +77,9 @@
     def test_create_bad_args(self):
         args_256 = ['a']*256
         # too many args
-        self.assertRaises(TypeError, self.module.StaticTuple, *args_256)
+        self.assertRaises(ValueError, self.module.StaticTuple, *args_256)
         args_300 = ['a']*300
-        self.assertRaises(TypeError, self.module.StaticTuple, *args_300)
+        self.assertRaises(ValueError, self.module.StaticTuple, *args_300)
         # not a string
         self.assertRaises(TypeError, self.module.StaticTuple, object())
 

=== modified file 'bzrlib/tests/test__walkdirs_win32.py'
--- bzrlib/tests/test__walkdirs_win32.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__walkdirs_win32.py	2009-12-21 18:03:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2010-04-23 07:15:23 +0000
+++ bzrlib/tests/test_branch.py	2009-09-04 13:43:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,68 +22,88 @@
 also see this file.
 """
 
-from cStringIO import StringIO
+from StringIO import StringIO
 
 from bzrlib import (
     branch as _mod_branch,
     bzrdir,
     config,
     errors,
-    tests,
     trace,
-    transport,
     urlutils,
     )
-
-
-class TestDefaultFormat(tests.TestCase):
+from bzrlib.branch import (
+    Branch,
+    BranchHooks,
+    BranchFormat,
+    BranchReferenceFormat,
+    BzrBranch5,
+    BzrBranchFormat5,
+    BzrBranchFormat6,
+    BzrBranchFormat7,
+    PullResult,
+    _run_with_write_locked_target,
+    )
+from bzrlib.bzrdir import (BzrDirMetaFormat1, BzrDirMeta1,
+                           BzrDir, BzrDirFormat)
+from bzrlib.errors import (NotBranchError,
+                           UnknownFormatError,
+                           UnknownHook,
+                           UnsupportedFormatError,
+                           )
+
+from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.transport import get_transport
+
+
+class TestDefaultFormat(TestCase):
 
     def test_default_format(self):
         # update this if you change the default branch format
-        self.assertIsInstance(_mod_branch.BranchFormat.get_default_format(),
-                _mod_branch.BzrBranchFormat7)
+        self.assertIsInstance(BranchFormat.get_default_format(),
+                BzrBranchFormat7)
 
     def test_default_format_is_same_as_bzrdir_default(self):
         # XXX: it might be nice if there was only one place the default was
         # set, but at the moment that's not true -- mbp 20070814 --
         # https://bugs.launchpad.net/bzr/+bug/132376
-        self.assertEqual(
-            _mod_branch.BranchFormat.get_default_format(),
-            bzrdir.BzrDirFormat.get_default_format().get_branch_format())
+        self.assertEqual(BranchFormat.get_default_format(),
+                BzrDirFormat.get_default_format().get_branch_format())
 
     def test_get_set_default_format(self):
         # set the format and then set it back again
-        old_format = _mod_branch.BranchFormat.get_default_format()
-        _mod_branch.BranchFormat.set_default_format(SampleBranchFormat())
+        old_format = BranchFormat.get_default_format()
+        BranchFormat.set_default_format(SampleBranchFormat())
         try:
             # the default branch format is used by the meta dir format
             # which is not the default bzrdir format at this point
-            dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
+            dir = BzrDirMetaFormat1().initialize('memory:///')
             result = dir.create_branch()
             self.assertEqual(result, 'A branch')
         finally:
-            _mod_branch.BranchFormat.set_default_format(old_format)
-        self.assertEqual(old_format,
-                         _mod_branch.BranchFormat.get_default_format())
-
-
-class TestBranchFormat5(tests.TestCaseWithTransport):
+            BranchFormat.set_default_format(old_format)
+        self.assertEqual(old_format, BranchFormat.get_default_format())
+
+
+class TestBranchFormat5(TestCaseWithTransport):
     """Tests specific to branch format 5"""
 
     def test_branch_format_5_uses_lockdir(self):
         url = self.get_url()
-        bdir = bzrdir.BzrDirMetaFormat1().initialize(url)
-        bdir.create_repository()
-        branch = bdir.create_branch()
+        bzrdir = BzrDirMetaFormat1().initialize(url)
+        bzrdir.create_repository()
+        branch = bzrdir.create_branch()
         t = self.get_transport()
         self.log("branch instance is %r" % branch)
-        self.assert_(isinstance(branch, _mod_branch.BzrBranch5))
+        self.assert_(isinstance(branch, BzrBranch5))
         self.assertIsDirectory('.', t)
         self.assertIsDirectory('.bzr/branch', t)
         self.assertIsDirectory('.bzr/branch/lock', t)
         branch.lock_write()
-        self.addCleanup(branch.unlock)
-        self.assertIsDirectory('.bzr/branch/lock/held', t)
+        try:
+            self.assertIsDirectory('.bzr/branch/lock/held', t)
+        finally:
+            branch.unlock()
 
     def test_set_push_location(self):
         from bzrlib.config import (locations_config_filename,
@@ -112,7 +132,7 @@
     # recursive section - that is, it appends the branch name.
 
 
-class SampleBranchFormat(_mod_branch.BranchFormat):
+class SampleBranchFormat(BranchFormat):
     """A sample format
 
     this format is initializable, unsupported to aid in testing the
@@ -123,20 +143,20 @@
         """See BzrBranchFormat.get_format_string()."""
         return "Sample branch format."
 
-    def initialize(self, a_bzrdir, name=None):
+    def initialize(self, a_bzrdir):
         """Format 4 branches cannot be created."""
-        t = a_bzrdir.get_branch_transport(self, name=name)
+        t = a_bzrdir.get_branch_transport(self)
         t.put_bytes('format', self.get_format_string())
         return 'A branch'
 
     def is_supported(self):
         return False
 
-    def open(self, transport, name=None, _found=False, ignore_fallbacks=False):
+    def open(self, transport, _found=False, ignore_fallbacks=False):
         return "opened branch."
 
 
-class TestBzrBranchFormat(tests.TestCaseWithTransport):
+class TestBzrBranchFormat(TestCaseWithTransport):
     """Tests for the BzrBranchFormat facility."""
 
     def test_find_format(self):
@@ -148,21 +168,21 @@
             dir = format._matchingbzrdir.initialize(url)
             dir.create_repository()
             format.initialize(dir)
-            found_format = _mod_branch.BranchFormat.find_format(dir)
+            found_format = BranchFormat.find_format(dir)
             self.failUnless(isinstance(found_format, format.__class__))
-        check_format(_mod_branch.BzrBranchFormat5(), "bar")
+        check_format(BzrBranchFormat5(), "bar")
 
     def test_find_format_not_branch(self):
         dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
-        self.assertRaises(errors.NotBranchError,
-                          _mod_branch.BranchFormat.find_format,
+        self.assertRaises(NotBranchError,
+                          BranchFormat.find_format,
                           dir)
 
     def test_find_format_unknown_format(self):
         dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         SampleBranchFormat().initialize(dir)
-        self.assertRaises(errors.UnknownFormatError,
-                          _mod_branch.BranchFormat.find_format,
+        self.assertRaises(UnknownFormatError,
+                          BranchFormat.find_format,
                           dir)
 
     def test_register_unregister_format(self):
@@ -172,17 +192,14 @@
         # make a branch
         format.initialize(dir)
         # register a format for it.
-        _mod_branch.BranchFormat.register_format(format)
+        BranchFormat.register_format(format)
         # which branch.Open will refuse (not supported)
-        self.assertRaises(errors.UnsupportedFormatError,
-                          _mod_branch.Branch.open, self.get_url())
+        self.assertRaises(UnsupportedFormatError, Branch.open, self.get_url())
         self.make_branch_and_tree('foo')
         # but open_downlevel will work
-        self.assertEqual(
-            format.open(dir),
-            bzrdir.BzrDir.open(self.get_url()).open_branch(unsupported=True))
+        self.assertEqual(format.open(dir), bzrdir.BzrDir.open(self.get_url()).open_branch(unsupported=True))
         # unregister the format
-        _mod_branch.BranchFormat.unregister_format(format)
+        BranchFormat.unregister_format(format)
         self.make_branch_and_tree('bar')
 
 
@@ -199,7 +216,7 @@
         raise NotImplementedError(self.get_class)
 
     def test_creation(self):
-        format = bzrdir.BzrDirMetaFormat1()
+        format = BzrDirMetaFormat1()
         format.set_branch_format(_mod_branch.BzrBranchFormat6())
         branch = self.make_branch('a', format=format)
         self.assertIsInstance(branch, self.get_class())
@@ -292,7 +309,7 @@
                          'locations.conf')
 
 
-class TestBranch6(TestBranch67, tests.TestCaseWithTransport):
+class TestBranch6(TestBranch67, TestCaseWithTransport):
 
     def get_class(self):
         return _mod_branch.BzrBranch6
@@ -313,7 +330,7 @@
         self.assertRaises(errors.UnstackableBranchFormat, branch.get_stacked_on_url)
 
 
-class TestBranch7(TestBranch67, tests.TestCaseWithTransport):
+class TestBranch7(TestBranch67, TestCaseWithTransport):
 
     def get_class(self):
         return _mod_branch.BzrBranch7
@@ -363,14 +380,13 @@
         self.assertTrue(branch.repository.has_revision(revid))
 
 
-class BzrBranch8(tests.TestCaseWithTransport):
+class BzrBranch8(TestCaseWithTransport):
 
     def make_branch(self, location, format=None):
         if format is None:
             format = bzrdir.format_registry.make_bzrdir('1.9')
             format.set_branch_format(_mod_branch.BzrBranchFormat8())
-        return tests.TestCaseWithTransport.make_branch(
-            self, location, format=format)
+        return TestCaseWithTransport.make_branch(self, location, format=format)
 
     def create_branch_with_reference(self):
         branch = self.make_branch('branch')
@@ -420,25 +436,24 @@
         branch.lock_write()
         branch.set_reference_info('file-id', 'path2', 'location2')
         branch.unlock()
-        doppelganger = _mod_branch.Branch.open('branch')
+        doppelganger = Branch.open('branch')
         doppelganger.set_reference_info('file-id', 'path3', 'location3')
         self.assertEqual(('path3', 'location3'),
                          branch.get_reference_info('file-id'))
 
-class TestBranchReference(tests.TestCaseWithTransport):
+class TestBranchReference(TestCaseWithTransport):
     """Tests for the branch reference facility."""
 
     def test_create_open_reference(self):
         bzrdirformat = bzrdir.BzrDirMetaFormat1()
-        t = transport.get_transport(self.get_url('.'))
+        t = get_transport(self.get_url('.'))
         t.mkdir('repo')
         dir = bzrdirformat.initialize(self.get_url('repo'))
         dir.create_repository()
         target_branch = dir.create_branch()
         t.mkdir('branch')
         branch_dir = bzrdirformat.initialize(self.get_url('branch'))
-        made_branch = _mod_branch.BranchReferenceFormat().initialize(
-            branch_dir, target_branch=target_branch)
+        made_branch = BranchReferenceFormat().initialize(branch_dir, target_branch)
         self.assertEqual(made_branch.base, target_branch.base)
         opened_branch = branch_dir.open_branch()
         self.assertEqual(opened_branch.base, target_branch.base)
@@ -455,110 +470,32 @@
             _mod_branch.BranchReferenceFormat().get_reference(checkout.bzrdir))
 
 
-class TestHooks(tests.TestCaseWithTransport):
+class TestHooks(TestCase):
 
     def test_constructor(self):
         """Check that creating a BranchHooks instance has the right defaults."""
-        hooks = _mod_branch.BranchHooks()
+        hooks = BranchHooks()
         self.assertTrue("set_rh" in hooks, "set_rh not in %s" % hooks)
         self.assertTrue("post_push" in hooks, "post_push not in %s" % hooks)
         self.assertTrue("post_commit" in hooks, "post_commit not in %s" % hooks)
         self.assertTrue("pre_commit" in hooks, "pre_commit not in %s" % hooks)
         self.assertTrue("post_pull" in hooks, "post_pull not in %s" % hooks)
-        self.assertTrue("post_uncommit" in hooks,
-                        "post_uncommit not in %s" % hooks)
+        self.assertTrue("post_uncommit" in hooks, "post_uncommit not in %s" % hooks)
         self.assertTrue("post_change_branch_tip" in hooks,
                         "post_change_branch_tip not in %s" % hooks)
-        self.assertTrue("post_branch_init" in hooks,
-                        "post_branch_init not in %s" % hooks)
-        self.assertTrue("post_switch" in hooks,
-                        "post_switch not in %s" % hooks)
 
     def test_installed_hooks_are_BranchHooks(self):
         """The installed hooks object should be a BranchHooks."""
         # the installed hooks are saved in self._preserved_hooks.
         self.assertIsInstance(self._preserved_hooks[_mod_branch.Branch][1],
-                              _mod_branch.BranchHooks)
-
-    def test_post_branch_init_hook(self):
-        calls = []
-        _mod_branch.Branch.hooks.install_named_hook('post_branch_init',
-            calls.append, None)
-        self.assertLength(0, calls)
-        branch = self.make_branch('a')
-        self.assertLength(1, calls)
-        params = calls[0]
-        self.assertIsInstance(params, _mod_branch.BranchInitHookParams)
-        self.assertTrue(hasattr(params, 'bzrdir'))
-        self.assertTrue(hasattr(params, 'branch'))
-
-    def test_post_switch_hook(self):
-        from bzrlib import switch
-        calls = []
-        _mod_branch.Branch.hooks.install_named_hook('post_switch',
-            calls.append, None)
-        tree = self.make_branch_and_tree('branch-1')
-        self.build_tree(['branch-1/file-1'])
-        tree.add('file-1')
-        tree.commit('rev1')
-        to_branch = tree.bzrdir.sprout('branch-2').open_branch()
-        self.build_tree(['branch-1/file-2'])
-        tree.add('file-2')
-        tree.remove('file-1')
-        tree.commit('rev2')
-        checkout = tree.branch.create_checkout('checkout')
-        self.assertLength(0, calls)
-        switch.switch(checkout.bzrdir, to_branch)
-        self.assertLength(1, calls)
-        params = calls[0]
-        self.assertIsInstance(params, _mod_branch.SwitchHookParams)
-        self.assertTrue(hasattr(params, 'to_branch'))
-        self.assertTrue(hasattr(params, 'revision_id'))
-
-
-class TestBranchOptions(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestBranchOptions, self).setUp()
-        self.branch = self.make_branch('.')
-        self.config = self.branch.get_config()
-
-    def check_append_revisions_only(self, expected_value, value=None):
-        """Set append_revisions_only in config and check its interpretation."""
-        if value is not None:
-            self.config.set_user_option('append_revisions_only', value)
-        self.assertEqual(expected_value,
-                         self.branch._get_append_revisions_only())
-
-    def test_valid_append_revisions_only(self):
-        self.assertEquals(None,
-                          self.config.get_user_option('append_revisions_only'))
-        self.check_append_revisions_only(None)
-        self.check_append_revisions_only(False, 'False')
-        self.check_append_revisions_only(True, 'True')
-        # The following values will cause compatibility problems on projects
-        # using older bzr versions (<2.2) but are accepted
-        self.check_append_revisions_only(False, 'false')
-        self.check_append_revisions_only(True, 'true')
-
-    def test_invalid_append_revisions_only(self):
-        """Ensure warning is noted on invalid settings"""
-        self.warnings = []
-        def warning(*args):
-            self.warnings.append(args[0] % args[1:])
-        self.overrideAttr(trace, 'warning', warning)
-        self.check_append_revisions_only(None, 'not-a-bool')
-        self.assertLength(1, self.warnings)
-        self.assertEqual(
-            'Value "not-a-bool" is not a boolean for "append_revisions_only"',
-            self.warnings[0])
-
-
-class TestPullResult(tests.TestCase):
+            BranchHooks)
+
+
+class TestPullResult(TestCase):
 
     def test_pull_result_to_int(self):
         # to support old code, the pull result can be used as an int
-        r = _mod_branch.PullResult()
+        r = PullResult()
         r.old_revno = 10
         r.new_revno = 20
         # this usage of results is not recommended for new code (because it
@@ -568,7 +505,7 @@
         self.assertEqual(a, "10 revisions pulled")
 
     def test_report_changed(self):
-        r = _mod_branch.PullResult()
+        r = PullResult()
         r.old_revid = "old-revid"
         r.old_revno = 10
         r.new_revid = "new-revid"
@@ -578,7 +515,7 @@
         self.assertEqual("Now on revision 20.\n", f.getvalue())
 
     def test_report_unchanged(self):
-        r = _mod_branch.PullResult()
+        r = PullResult()
         r.old_revid = "same-revid"
         r.new_revid = "same-revid"
         f = StringIO()
@@ -610,11 +547,11 @@
     """Helper for TestRunWithWriteLockedTarget."""
 
 
-class TestRunWithWriteLockedTarget(tests.TestCase):
+class TestRunWithWriteLockedTarget(TestCase):
     """Tests for _run_with_write_locked_target."""
 
     def setUp(self):
-        tests.TestCase.setUp(self)
+        TestCase.setUp(self)
         self._calls = []
 
     def func_that_returns_ok(self):
@@ -627,7 +564,7 @@
 
     def test_success_unlocks(self):
         lockable = _StubLockable(self._calls)
-        result = _mod_branch._run_with_write_locked_target(
+        result = _run_with_write_locked_target(
             lockable, self.func_that_returns_ok)
         self.assertEqual('ok', result)
         self.assertEqual(['lock_write', 'func called', 'unlock'], self._calls)
@@ -635,22 +572,19 @@
     def test_exception_unlocks_and_propagates(self):
         lockable = _StubLockable(self._calls)
         self.assertRaises(_ErrorFromCallable,
-                          _mod_branch._run_with_write_locked_target,
-                          lockable, self.func_that_raises)
+            _run_with_write_locked_target, lockable, self.func_that_raises)
         self.assertEqual(['lock_write', 'func called', 'unlock'], self._calls)
 
     def test_callable_succeeds_but_error_during_unlock(self):
         lockable = _StubLockable(self._calls, unlock_exc=_ErrorFromUnlock())
         self.assertRaises(_ErrorFromUnlock,
-                          _mod_branch._run_with_write_locked_target,
-                          lockable, self.func_that_returns_ok)
+            _run_with_write_locked_target, lockable, self.func_that_returns_ok)
         self.assertEqual(['lock_write', 'func called', 'unlock'], self._calls)
 
     def test_error_during_unlock_does_not_mask_original_error(self):
         lockable = _StubLockable(self._calls, unlock_exc=_ErrorFromUnlock())
         self.assertRaises(_ErrorFromCallable,
-                          _mod_branch._run_with_write_locked_target,
-                          lockable, self.func_that_raises)
+            _run_with_write_locked_target, lockable, self.func_that_raises)
         self.assertEqual(['lock_write', 'func called', 'unlock'], self._calls)
 
 

=== modified file 'bzrlib/tests/test_branchbuilder.py'
--- bzrlib/tests/test_branchbuilder.py	2010-02-27 12:27:33 +0000
+++ bzrlib/tests/test_branchbuilder.py	2009-05-07 05:08:46 +0000
@@ -171,15 +171,6 @@
         rev = branch.repository.get_revision(rev_id)
         self.assertEqual(u'Foo', rev.message)
 
-    def test_commit_message_callback(self):
-        builder = BranchBuilder(self.get_transport().clone('foo'))
-        rev_id = builder.build_snapshot(None, None,
-            [('add', (u'', None, 'directory', None))],
-            message_callback=lambda x:u'Foo')
-        branch = builder.get_branch()
-        rev = branch.repository.get_revision(rev_id)
-        self.assertEqual(u'Foo', rev.message)
-
     def test_modify_file(self):
         builder = self.build_a_rev()
         rev_id2 = builder.build_snapshot('B-id', None,

=== modified file 'bzrlib/tests/test_btree_index.py'
--- bzrlib/tests/test_btree_index.py	2010-03-25 17:09:53 +0000
+++ bzrlib/tests/test_btree_index.py	2009-12-22 15:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -59,7 +59,11 @@
 
     def setUp(self):
         TestCaseWithTransport.setUp(self)
-        self.overrideAttr(btree_index, '_RESERVED_HEADER_BYTES', 100)
+        self._original_header = btree_index._RESERVED_HEADER_BYTES
+        def restore():
+            btree_index._RESERVED_HEADER_BYTES = self._original_header
+        self.addCleanup(restore)
+        btree_index._RESERVED_HEADER_BYTES = 100
 
     def make_nodes(self, count, key_elements, reference_lists):
         """Generate count*key_elements sample nodes."""
@@ -99,7 +103,10 @@
 
     def shrink_page_size(self):
         """Shrink the default page size so that less fits in a page."""
-        self.overrideAttr(btree_index, '_PAGE_SIZE')
+        old_page_size = btree_index._PAGE_SIZE
+        def cleanup():
+            btree_index._PAGE_SIZE = old_page_size
+        self.addCleanup(cleanup)
         btree_index._PAGE_SIZE = 2048
 
 
@@ -611,21 +618,6 @@
         size = trans.put_file('index', stream)
         return btree_index.BTreeGraphIndex(trans, 'index', size)
 
-    def make_index_with_offset(self, ref_lists=1, key_elements=1, nodes=[],
-                               offset=0):
-        builder = btree_index.BTreeBuilder(key_elements=key_elements,
-                                           reference_lists=ref_lists)
-        builder.add_nodes(nodes)
-        transport = self.get_transport('')
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        size = len(content)
-        transport.put_bytes('index', (' '*offset)+content)
-        return btree_index.BTreeGraphIndex(transport, 'index', size=size,
-                                           offset=offset)
-
     def test_clear_cache(self):
         nodes = self.make_nodes(160, 2, 2)
         index = self.make_index(ref_lists=2, key_elements=2, nodes=nodes)
@@ -701,25 +693,6 @@
             transport._activity)
         self.assertEqual(1173, size)
 
-    def test_with_offset_no_size(self):
-        index = self.make_index_with_offset(key_elements=1, ref_lists=1,
-                                            offset=1234,
-                                            nodes=self.make_nodes(200, 1, 1))
-        index._size = None # throw away the size info
-        self.assertEqual(200, index.key_count())
-
-    def test_with_small_offset(self):
-        index = self.make_index_with_offset(key_elements=1, ref_lists=1,
-                                            offset=1234,
-                                            nodes=self.make_nodes(200, 1, 1))
-        self.assertEqual(200, index.key_count())
-
-    def test_with_large_offset(self):
-        index = self.make_index_with_offset(key_elements=1, ref_lists=1,
-                                            offset=123456,
-                                            nodes=self.make_nodes(200, 1, 1))
-        self.assertEqual(200, index.key_count())
-
     def test__read_nodes_no_size_one_page_reads_once(self):
         self.make_index(nodes=[(('key',), 'value', ())])
         trans = get_transport('trace+' + self.get_url())
@@ -1184,9 +1157,14 @@
 
 class TestBTreeNodes(BTreeTestCase):
 
+    def restore_parser(self):
+        btree_index._btree_serializer = self.saved_parser
+
     def setUp(self):
         BTreeTestCase.setUp(self)
-        self.overrideAttr(btree_index, '_btree_serializer', self.parse_btree)
+        self.saved_parser = btree_index._btree_serializer
+        self.addCleanup(self.restore_parser)
+        btree_index._btree_serializer = self.parse_btree
 
     def test_LeafNode_1_0(self):
         node_bytes = ("type=leaf\n"

=== modified file 'bzrlib/tests/test_bugtracker.py'
--- bzrlib/tests/test_bugtracker.py	2010-01-25 15:55:48 +0000
+++ bzrlib/tests/test_bugtracker.py	2009-03-23 14:59:43 +0000
@@ -41,7 +41,8 @@
         self.tracker_type = TestGetBugURL.TransientTracker
         self.tracker_type.log = []
         bugtracker.tracker_registry.register('transient', self.tracker_type)
-        self.addCleanup(bugtracker.tracker_registry.remove, 'transient')
+        self.addCleanup(lambda:
+                        bugtracker.tracker_registry.remove('transient'))
 
     def test_get_bug_url_for_transient_tracker(self):
         branch = self.make_branch('some_branch')
@@ -193,7 +194,7 @@
         """If asked for a valid tag, return a tracker instance that can map bug
         IDs to <base_url>/<bug_area> + <bug_id>."""
         bugtracker.tracker_registry.register('some', self.tracker)
-        self.addCleanup(bugtracker.tracker_registry.remove, 'some')
+        self.addCleanup(lambda: bugtracker.tracker_registry.remove('some'))
 
         branch = self.make_branch('some_branch')
         config = branch.get_config()

=== modified file 'bzrlib/tests/test_bundle.py'
--- bzrlib/tests/test_bundle.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_bundle.py	2010-01-06 04:48:59 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1039,7 +1039,7 @@
         bundle = read_bundle(self.create_bundle_text('null:', 'rev2')[0])
         repo = self.make_repository('repo', format='dirstate-with-subtree')
         bundle.install_revisions(repo)
-        inv_text = repo._get_inventory_xml('rev2')
+        inv_text = repo.get_inventory_xml('rev2')
         self.assertNotContainsRe(inv_text, 'format="5"')
         self.assertContainsRe(inv_text, 'format="7"')
 
@@ -1065,8 +1065,8 @@
 
     def test_inv_hash_across_serializers(self):
         repo = self.make_repo_with_installed_revisions()
-        recorded_inv_sha1 = repo.get_revision('rev2').inventory_sha1
-        xml = repo._get_inventory_xml('rev2')
+        recorded_inv_sha1 = repo.get_inventory_sha1('rev2')
+        xml = repo.get_inventory_xml('rev2')
         self.assertEqual(osutils.sha_string(xml), recorded_inv_sha1)
 
     def test_across_models_incompatible(self):
@@ -1820,7 +1820,7 @@
             def look_up(self, name, url):
                 return 'source'
         directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(directories.remove, 'foo:')
+        self.addCleanup(lambda: directories.remove('foo:'))
         self.build_tree_contents([('./foo:bar', out.getvalue())])
         self.assertRaises(errors.NotABundle, read_mergeable_from_url,
                           'foo:bar')
@@ -1850,7 +1850,7 @@
 class _DisconnectingTCPServer(object):
     """A TCP server that immediately closes any connection made to it."""
 
-    def start_server(self):
+    def setUp(self):
         self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
         self.sock.bind(('127.0.0.1', 0))
         self.sock.listen(1)

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2010-03-25 14:22:41 +0000
+++ bzrlib/tests/test_bzrdir.py	2009-09-17 11:54:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,7 +36,6 @@
     )
 import bzrlib.branch
 from bzrlib.errors import (NotBranchError,
-                           NoColocatedBranchSupport,
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
@@ -51,11 +50,9 @@
     http_utils,
     )
 from bzrlib.tests.test_http import TestWithTransport_pycurl
-from bzrlib.transport import (
-    get_transport,
-    memory,
-    )
+from bzrlib.transport import get_transport
 from bzrlib.transport.http._urllib import HttpTransport_urllib
+from bzrlib.transport.memory import MemoryServer
 from bzrlib.transport.nosmart import NoSmartTransportDecorator
 from bzrlib.transport.readonly import ReadonlyTransportDecorator
 from bzrlib.repofmt import knitrepo, weaverepo, pack_repo
@@ -148,7 +145,7 @@
         new = topics.get_detail('current-formats')
         rest = topics.get_detail('other-formats')
         experimental, deprecated = rest.split('Deprecated formats')
-        self.assertContainsRe(new, 'formats-help')
+        self.assertContainsRe(new, 'bzr help formats')
         self.assertContainsRe(new,
                 ':knit:\n    \(native\) \(default\) Format using knits\n')
         self.assertContainsRe(experimental,
@@ -207,10 +204,8 @@
         """See BzrDir.open_repository."""
         return SampleRepository(self)
 
-    def create_branch(self, name=None):
+    def create_branch(self):
         """See BzrDir.create_branch."""
-        if name is not None:
-            raise NoColocatedBranchSupport(self)
         return SampleBranch(self)
 
     def create_workingtree(self):
@@ -359,7 +354,7 @@
 
     def test_create_branch_convenience_root(self):
         """Creating a branch at the root of a fs should work."""
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = MemoryServer
         # outside a repo the default convenience output is a repo+branch_tree
         format = bzrdir.format_registry.make_bzrdir('knit')
         branch = bzrdir.BzrDir.create_branch_convenience(self.get_url(),
@@ -471,8 +466,7 @@
         # Make stackable source branch with an unstackable repo format.
         source_bzrdir = self.make_bzrdir('source')
         pack_repo.RepositoryFormatKnitPack1().initialize(source_bzrdir)
-        source_branch = bzrlib.branch.BzrBranchFormat7().initialize(
-            source_bzrdir)
+        source_branch = bzrlib.branch.BzrBranchFormat7().initialize(source_bzrdir)
         # Make a directory with a default stacking policy
         parent_bzrdir = self.make_bzrdir('parent')
         stacked_on = self.make_branch('parent/stacked-on', format='pack-0.92')
@@ -571,7 +565,7 @@
 
     def setUp(self):
         super(ChrootedTests, self).setUp()
-        if not self.vfs_transport_factory == memory.MemoryServer:
+        if not self.vfs_transport_factory == MemoryServer:
             self.transport_readonly_server = http_server.HttpServer
 
     def local_branch_path(self, branch):
@@ -1055,7 +1049,7 @@
 
     def setUp(self):
         super(NonLocalTests, self).setUp()
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = MemoryServer
 
     def test_create_branch_convenience(self):
         # outside a repo the default convenience output is a repo+branch_tree
@@ -1339,15 +1333,3 @@
         url = transport.base
         err = self.assertRaises(errors.BzrError, bzrdir.BzrDir.open, url)
         self.assertEqual('fail', err._preformatted_string)
-
-    def test_post_repo_init(self):
-        from bzrlib.bzrdir import RepoInitHookParams
-        calls = []
-        bzrdir.BzrDir.hooks.install_named_hook('post_repo_init',
-            calls.append, None)
-        self.make_repository('foo')
-        self.assertLength(1, calls)
-        params = calls[0]
-        self.assertIsInstance(params, RepoInitHookParams)
-        self.assertTrue(hasattr(params, 'bzrdir'))
-        self.assertTrue(hasattr(params, 'repository'))

=== modified file 'bzrlib/tests/test_chk_map.py'
--- bzrlib/tests/test_chk_map.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_chk_map.py	2009-10-21 20:53:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -905,7 +905,7 @@
         # Unmapping the new node will check the existing nodes to see if they
         # would fit.
         # Clear the page cache so we ensure we have to read all the children
-        chk_map.clear_cache()
+        chk_map._page_cache.clear()
         chkmap.unmap(('aad',))
         self.assertIsInstance(chkmap._root_node._items['aaa'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aab'], LeafNode)
@@ -945,12 +945,12 @@
         # Now clear the page cache, and only include 2 of the children in the
         # cache
         aab_key = chkmap._root_node._items['aab']
-        aab_bytes = chk_map._get_cache()[aab_key]
+        aab_bytes = chk_map._page_cache[aab_key]
         aac_key = chkmap._root_node._items['aac']
-        aac_bytes = chk_map._get_cache()[aac_key]
-        chk_map.clear_cache()
-        chk_map._get_cache()[aab_key] = aab_bytes
-        chk_map._get_cache()[aac_key] = aac_bytes
+        aac_bytes = chk_map._page_cache[aac_key]
+        chk_map._page_cache.clear()
+        chk_map._page_cache[aab_key] = aab_bytes
+        chk_map._page_cache[aac_key] = aac_bytes
 
         # Unmapping the new node will check the nodes from the page cache
         # first, and not have to read in 'aaa'

=== modified file 'bzrlib/tests/test_cleanup.py'
--- bzrlib/tests/test_cleanup.py	2010-03-03 22:59:21 +0000
+++ bzrlib/tests/test_cleanup.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== removed file 'bzrlib/tests/test_cmdline.py'
--- bzrlib/tests/test_cmdline.py	2010-03-01 09:02:18 +0000
+++ bzrlib/tests/test_cmdline.py	1970-01-01 00:00:00 +0000
@@ -1,93 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-
-from bzrlib import (
-    cmdline,
-    tests)
-
-class TestSplitter(tests.TestCase):
-
-    def assertAsTokens(self, expected, line, single_quotes_allowed=False):
-        s = cmdline.Splitter(line, single_quotes_allowed=single_quotes_allowed)
-        self.assertEqual(expected, list(s))
-
-    def test_simple(self):
-        self.assertAsTokens([(False, u'foo'), (False, u'bar'), (False, u'baz')],
-                            u'foo bar baz')
-
-    def test_ignore_multiple_spaces(self):
-        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'foo  bar')
-
-    def test_ignore_leading_space(self):
-        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'  foo bar')
-
-    def test_ignore_trailing_space(self):
-        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'foo bar  ')
-
-    def test_posix_quotations(self):
-        self.assertAsTokens([(True, u'foo bar')], u"'foo bar'",
-            single_quotes_allowed=True)
-        self.assertAsTokens([(True, u'foo bar')], u"'fo''o b''ar'",
-            single_quotes_allowed=True)
-        self.assertAsTokens([(True, u'foo bar')], u'"fo""o b""ar"',
-            single_quotes_allowed=True)
-        self.assertAsTokens([(True, u'foo bar')], u'"fo"\'o b\'"ar"',
-            single_quotes_allowed=True)
-
-    def test_nested_quotations(self):
-        self.assertAsTokens([(True, u'foo"" bar')], u"\"foo\\\"\\\" bar\"")
-        self.assertAsTokens([(True, u'foo\'\' bar')], u"\"foo'' bar\"")
-        self.assertAsTokens([(True, u'foo\'\' bar')], u"\"foo'' bar\"",
-            single_quotes_allowed=True)
-        self.assertAsTokens([(True, u'foo"" bar')], u"'foo\"\" bar'",
-            single_quotes_allowed=True)
-
-    def test_empty_result(self):
-        self.assertAsTokens([], u'')
-        self.assertAsTokens([], u'    ')
-
-    def test_quoted_empty(self):
-        self.assertAsTokens([(True, '')], u'""')
-        self.assertAsTokens([(False, u"''")], u"''")
-        self.assertAsTokens([(True, '')], u"''", single_quotes_allowed=True)
-
-    def test_unicode_chars(self):
-        self.assertAsTokens([(False, u'f\xb5\xee'), (False, u'\u1234\u3456')],
-                             u'f\xb5\xee \u1234\u3456')
-
-    def test_newline_in_quoted_section(self):
-        self.assertAsTokens([(True, u'foo\nbar\nbaz\n')], u'"foo\nbar\nbaz\n"')
-        self.assertAsTokens([(True, u'foo\nbar\nbaz\n')], u"'foo\nbar\nbaz\n'",
-            single_quotes_allowed=True)
-
-    def test_escape_chars(self):
-        self.assertAsTokens([(False, u'foo\\bar')], u'foo\\bar')
-
-    def test_escape_quote(self):
-        self.assertAsTokens([(True, u'foo"bar')], u'"foo\\"bar"')
-        self.assertAsTokens([(True, u'foo\\"bar')], u'"foo\\\\\\"bar"')
-        self.assertAsTokens([(True, u'foo\\bar')], u'"foo\\\\"bar"')
-
-    def test_double_escape(self):
-        self.assertAsTokens([(True, u'foo\\\\bar')], u'"foo\\\\bar"')
-        self.assertAsTokens([(False, u'foo\\\\bar')], u"foo\\\\bar")
-
-    def test_multiple_quoted_args(self):
-        self.assertAsTokens([(True, u'x x'), (True, u'y y')],
-            u'"x x" "y y"')
-        self.assertAsTokens([(True, u'x x'), (True, u'y y')],
-            u'"x x" \'y y\'', single_quotes_allowed=True)

=== modified file 'bzrlib/tests/test_commands.py'
--- bzrlib/tests/test_commands.py	2010-04-22 18:36:13 +0000
+++ bzrlib/tests/test_commands.py	2009-05-23 21:01:51 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,7 +24,6 @@
     config,
     errors,
     option,
-    symbol_versioning,
     tests,
     )
 from bzrlib.commands import display_command
@@ -65,7 +64,7 @@
     @staticmethod
     def get_command(options):
         class cmd_foo(commands.Command):
-            __doc__ = 'Bar'
+            'Bar'
 
             takes_options = options
 
@@ -112,7 +111,7 @@
 
     def test_unicode(self):
         my_config = self._get_config("[ALIASES]\n"
-            u'iam=whoami "Erik B\u00e5gfors <erik@bagfors.nu>"\n')
+            u"iam=whoami 'Erik B\u00e5gfors <erik@bagfors.nu>'\n")
         self.assertEqual([u'whoami', u'Erik B\u00e5gfors <erik@bagfors.nu>'],
                           commands.get_alias("iam", config=my_config))
 
@@ -120,35 +119,38 @@
 class TestSeeAlso(tests.TestCase):
     """Tests for the see also functional of Command."""
 
-    @staticmethod
-    def _get_command_with_see_also(see_also):
-        class ACommand(commands.Command):
-            __doc__ = """A sample command."""
-            _see_also = see_also
-        return ACommand()
-
     def test_default_subclass_no_see_also(self):
-        command = self._get_command_with_see_also([])
+        class ACommand(commands.Command):
+            """A sample command."""
+        command = ACommand()
         self.assertEqual([], command.get_see_also())
 
     def test__see_also(self):
         """When _see_also is defined, it sets the result of get_see_also()."""
-        command = self._get_command_with_see_also(['bar', 'foo'])
+        class ACommand(commands.Command):
+            _see_also = ['bar', 'foo']
+        command = ACommand()
         self.assertEqual(['bar', 'foo'], command.get_see_also())
 
     def test_deduplication(self):
         """Duplicates in _see_also are stripped out."""
-        command = self._get_command_with_see_also(['foo', 'foo'])
+        class ACommand(commands.Command):
+            _see_also = ['foo', 'foo']
+        command = ACommand()
         self.assertEqual(['foo'], command.get_see_also())
 
     def test_sorted(self):
         """_see_also is sorted by get_see_also."""
-        command = self._get_command_with_see_also(['foo', 'bar'])
+        class ACommand(commands.Command):
+            _see_also = ['foo', 'bar']
+        command = ACommand()
         self.assertEqual(['bar', 'foo'], command.get_see_also())
 
     def test_additional_terms(self):
         """Additional terms can be supplied and are deduped and sorted."""
-        command = self._get_command_with_see_also(['foo', 'bar'])
+        class ACommand(commands.Command):
+            _see_also = ['foo', 'bar']
+        command = ACommand()
         self.assertEqual(['bar', 'foo', 'gam'],
             command.get_see_also(['gam', 'bar', 'gam']))
 
@@ -208,13 +210,14 @@
         commands.Command.hooks.install_named_hook(
             "extend_command", hook_calls.append, None)
         # create a command, should not fire
-        class cmd_test_extend_command_hook(commands.Command):
-            __doc__ = """A sample command."""
+        class ACommand(commands.Command):
+            """A sample command."""
+        cmd = ACommand()
         self.assertEqual([], hook_calls)
         # -- as a builtin
         # register the command class, should not fire
         try:
-            commands.builtin_command_registry.register(cmd_test_extend_command_hook)
+            builtins.cmd_test_extend_command_hook = ACommand
             self.assertEqual([], hook_calls)
             # and ask for the object, should fire
             cmd = commands.get_cmd_object('test-extend-command-hook')
@@ -224,7 +227,7 @@
             self.assertSubset([cmd], hook_calls)
             del hook_calls[:]
         finally:
-            commands.builtin_command_registry.remove('test-extend-command-hook')
+            del builtins.cmd_test_extend_command_hook
         # -- as a plugin lazy registration
         try:
             # register the command class, should not fire
@@ -246,7 +249,7 @@
         commands.install_bzr_command_hooks()
         hook_calls = []
         class ACommand(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
         def get_cmd(cmd_or_None, cmd_name):
             hook_calls.append(('called', cmd_or_None, cmd_name))
             if cmd_name in ('foo', 'info'):
@@ -273,45 +276,32 @@
 
 class TestGetMissingCommandHook(tests.TestCase):
 
-    def hook_missing(self):
-        """Hook get_missing_command for testing."""
-        self.hook_calls = []
+    def test_fires_on_get_cmd_object(self):
+        # The get_missing_command(cmd) hook fires when commands are delivered to the
+        # ui.
+        hook_calls = []
         class ACommand(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
         def get_missing_cmd(cmd_name):
-            self.hook_calls.append(('called', cmd_name))
+            hook_calls.append(('called', cmd_name))
             if cmd_name in ('foo', 'info'):
                 return ACommand()
         commands.Command.hooks.install_named_hook(
             "get_missing_command", get_missing_cmd, None)
-        self.ACommand = ACommand
-
-    def test_fires_on_get_cmd_object(self):
-        # The get_missing_command(cmd) hook fires when commands are delivered to the
-        # ui.
-        self.hook_missing()
         # create a command directly, should not fire
-        self.cmd = self.ACommand()
-        self.assertEqual([], self.hook_calls)
+        cmd = ACommand()
+        self.assertEqual([], hook_calls)
         # ask by name, should fire and give us our command
         cmd = commands.get_cmd_object('foo')
-        self.assertEqual([('called', 'foo')], self.hook_calls)
-        self.assertIsInstance(cmd, self.ACommand)
-        del self.hook_calls[:]
+        self.assertEqual([('called', 'foo')], hook_calls)
+        self.assertIsInstance(cmd, ACommand)
+        del hook_calls[:]
         # ask by a name that is supplied by a builtin - the hook should not
         # fire and we still get our object.
         commands.install_bzr_command_hooks()
         cmd = commands.get_cmd_object('info')
         self.assertNotEqual(None, cmd)
-        self.assertEqual(0, len(self.hook_calls))
-
-    def test_skipped_on_HelpCommandIndex_get_topics(self):
-        # The get_missing_command(cmd_name) hook is not fired when
-        # looking up help topics.
-        self.hook_missing()
-        topic = commands.HelpCommandIndex()
-        topics = topic.get_topics('foo')
-        self.assertEqual([], self.hook_calls)
+        self.assertEqual(0, len(hook_calls))
 
 
 class TestListCommandHook(tests.TestCase):
@@ -333,10 +323,3 @@
         cmds = list(commands.all_command_names())
         self.assertEqual(['called'], hook_calls)
         self.assertSubset(['foo', 'bar'], cmds)
-
-class TestDeprecations(tests.TestCase):
-
-    def test_shlex_split_unicode_deprecation(self):
-        res = self.applyDeprecated(
-                symbol_versioning.deprecated_in((2, 2, 0)),
-                commands.shlex_split_unicode, 'whatever')

=== modified file 'bzrlib/tests/test_commit.py'
--- bzrlib/tests/test_commit.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_commit.py	2009-10-29 05:54:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -274,7 +274,7 @@
         try:
             self.check_inventory_shape(wt.read_working_inventory(),
                                        ['a/', 'a/hello', 'a/b/'])
-            self.check_inventory_shape(b.repository.get_inventory(r3),
+            self.check_inventory_shape(b.repository.get_revision_inventory(r3),
                                        ['a/', 'a/hello', 'a/b/'])
         finally:
             wt.unlock()
@@ -289,7 +289,7 @@
         finally:
             wt.unlock()
 
-        inv = b.repository.get_inventory(r4)
+        inv = b.repository.get_revision_inventory(r4)
         eq(inv['hello-id'].revision, r4)
         eq(inv['a-id'].revision, r1)
         eq(inv['b-id'].revision, r3)

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2010-04-23 07:15:23 +0000
+++ bzrlib/tests/test_config.py	2009-12-22 23:09:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -406,16 +406,9 @@
         get_bool = conf.get_user_option_as_bool
         self.assertEqual(True, get_bool('a_true_bool'))
         self.assertEqual(False, get_bool('a_false_bool'))
-        warnings = []
-        def warning(*args):
-            warnings.append(args[0] % args[1:])
-        self.overrideAttr(trace, 'warning', warning)
-        msg = 'Value "%s" is not a boolean for "%s"'
         self.assertIs(None, get_bool('an_invalid_bool'))
-        self.assertEquals(msg % ('maybe', 'an_invalid_bool'), warnings[0])
-        warnings = []
         self.assertIs(None, get_bool('not_defined_in_this_config'))
-        self.assertEquals([], warnings)
+
 
     def test_get_user_option_as_list(self):
         conf, parser = self.make_config_parser("""
@@ -1677,8 +1670,11 @@
             'password ignored in section \[ssh with password\]')
 
     def test_uses_fallback_stores(self):
-        self.overrideAttr(config, 'credential_store_registry',
-                          config.CredentialStoreRegistry())
+        self._old_cs_registry = config.credential_store_registry
+        def restore():
+            config.credential_store_registry = self._old_cs_registry
+        self.addCleanup(restore)
+        config.credential_store_registry = config.CredentialStoreRegistry()
         store = StubCredentialStore()
         store.add_credentials("http", "example.com", "joe", "secret")
         config.credential_store_registry.register("stub", store, fallback=True)

=== modified file 'bzrlib/tests/test_conflicts.py'
--- bzrlib/tests/test_conflicts.py	2010-04-06 10:12:42 +0000
+++ bzrlib/tests/test_conflicts.py	2010-01-04 14:56:59 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,34 +18,11 @@
 import os
 
 from bzrlib import (
-    branchbuilder,
     bzrdir,
     conflicts,
     errors,
-    option,
     tests,
-    workingtree,
     )
-from bzrlib.tests import script
-
-
-def load_tests(standard_tests, module, loader):
-    result = loader.suiteClass()
-
-    sp_tests, remaining_tests = tests.split_suite_by_condition(
-        standard_tests, tests.condition_isinstance((
-                TestParametrizedResolveConflicts,
-                )))
-    # Each test class defines its own scenarios. This is needed for
-    # TestResolvePathConflictBefore531967 that verifies that the same tests as
-    # TestResolvePathConflict still pass.
-    for test in tests.iter_suite_tests(sp_tests):
-        tests.apply_scenarios(test, test.scenarios(), result)
-
-    # No parametrization for the remaining tests
-    result.addTests(remaining_tests)
-
-    return result
 
 
 # TODO: Test commit with some added, and added-but-missing files
@@ -90,15 +67,15 @@
                                   ('hello.sploo.OTHER', 'yellowworld2'),
                                   ])
         tree.lock_read()
-        self.assertLength(6, list(tree.list_files()))
+        self.assertEqual(6, len(list(tree.list_files())))
         tree.unlock()
         tree_conflicts = tree.conflicts()
-        self.assertLength(2, tree_conflicts)
+        self.assertEqual(2, len(tree_conflicts))
         self.assertTrue('hello' in tree_conflicts[0].path)
         self.assertTrue('hello.sploo' in tree_conflicts[1].path)
         conflicts.restore('hello')
         conflicts.restore('hello.sploo')
-        self.assertLength(0, tree.conflicts())
+        self.assertEqual(0, len(tree.conflicts()))
         self.assertFileEqual('hello world2', 'hello')
         self.assertFalse(os.path.lexists('hello.sploo'))
         self.assertRaises(errors.NotConflicted, conflicts.restore, 'hello')
@@ -194,800 +171,3 @@
             if 'conflict_file_id' in stanza:
                 self.assertStartsWith(stanza['conflict_file_id'], u'\xeed')
 
-
-# FIXME: The shell-like tests should be converted to real whitebox tests... or
-# moved to a blackbox module -- vila 20100205
-
-# FIXME: test missing for multiple conflicts
-
-# FIXME: Tests missing for DuplicateID conflict type
-class TestResolveConflicts(script.TestCaseWithTransportAndScript):
-
-    preamble = None # The setup script set by daughter classes
-
-    def setUp(self):
-        super(TestResolveConflicts, self).setUp()
-        self.run_script(self.preamble)
-
-
-class TestResolveTextConflicts(TestResolveConflicts):
-    # TBC
-    pass
-
-
-def mirror_scenarios(base_scenarios):
-    """Return a list of mirrored scenarios.
-
-    Each scenario in base_scenarios is duplicated switching the roles of 'this'
-    and 'other'
-    """
-    scenarios = []
-    for common, (lname, ldict), (rname, rdict) in base_scenarios:
-        a = tests.multiply_scenarios([(lname, dict(_this=ldict))],
-                                     [(rname, dict(_other=rdict))])
-        b = tests.multiply_scenarios([(rname, dict(_this=rdict))],
-                                     [(lname, dict(_other=ldict))])
-        # Inject the common parameters in all scenarios
-        for name, d in a + b:
-            d.update(common)
-        scenarios.extend(a + b)
-    return scenarios
-
-
-# FIXME: Get rid of parametrized (in the class name) once we delete
-# TestResolveConflicts -- vila 20100308
-class TestParametrizedResolveConflicts(tests.TestCaseWithTransport):
-    """This class provides a base to test single conflict resolution.
-
-    Since all conflict objects are created with specific semantics for their
-    attributes, each class should implement the necessary functions and
-    attributes described below.
-
-    Each class should define the scenarios that create the expected (single)
-    conflict.
-
-    Each scenario describes:
-    * how to create 'base' tree (and revision)
-    * how to create 'left' tree (and revision, parent rev 'base')
-    * how to create 'right' tree (and revision, parent rev 'base')
-    * how to check that changes in 'base'->'left' have been taken
-    * how to check that changes in 'base'->'right' have been taken
-
-    From each base scenario, we generate two concrete scenarios where:
-    * this=left, other=right
-    * this=right, other=left
-
-    Then the test case verifies each concrete scenario by:
-    * creating a branch containing the 'base', 'this' and 'other' revisions
-    * creating a working tree for the 'this' revision
-    * performing the merge of 'other' into 'this'
-    * verifying the expected conflict was generated
-    * resolving with --take-this or --take-other, and running the corresponding
-      checks (for either 'base'->'this', or 'base'->'other')
-
-    :cvar _conflict_type: The expected class of the generated conflict.
-
-    :cvar _assert_conflict: A method receiving the working tree and the
-        conflict object and checking its attributes.
-
-    :cvar _base_actions: The branchbuilder actions to create the 'base'
-        revision.
-
-    :cvar _this: The dict related to 'base' -> 'this'. It contains at least:
-      * 'actions': The branchbuilder actions to create the 'this'
-          revision.
-      * 'check': how to check the changes after resolution with --take-this.
-
-    :cvar _other: The dict related to 'base' -> 'other'. It contains at least:
-      * 'actions': The branchbuilder actions to create the 'other'
-          revision.
-      * 'check': how to check the changes after resolution with --take-other.
-    """
-
-    # Set by daughter classes
-    _conflict_type = None
-    _assert_conflict = None
-
-    # Set by load_tests
-    _base_actions = None
-    _this = None
-    _other = None
-
-    @staticmethod
-    def scenarios():
-        """Return the scenario list for the conflict type defined by the class.
-
-        Each scenario is of the form:
-        (common, (left_name, left_dict), (right_name, right_dict))
-
-        * common is a dict
-
-        * left_name and right_name are the scenario names that will be combined
-
-        * left_dict and right_dict are the attributes specific to each half of
-          the scenario. They should include at least 'actions' and 'check' and
-          will be available as '_this' and '_other' test instance attributes.
-
-        Daughters classes are free to add their specific attributes as they see
-        fit in any of the three dicts.
-
-        This is a class method so that load_tests can find it.
-
-        '_base_actions' in the common dict, 'actions' and 'check' in the left
-        and right dicts use names that map to methods in the test classes. Some
-        prefixes are added to these names to get the correspong methods (see
-        _get_actions() and _get_check()). The motivation here is to avoid
-        collisions in the class namespace.
-        """
-        # Only concrete classes return actual scenarios
-        return []
-
-    def setUp(self):
-        super(TestParametrizedResolveConflicts, self).setUp()
-        builder = self.make_branch_builder('trunk')
-        builder.start_series()
-
-        # Create an empty trunk
-        builder.build_snapshot('start', None, [
-                ('add', ('', 'root-id', 'directory', ''))])
-        # Add a minimal base content
-        base_actions = self._get_actions(self._base_actions)()
-        builder.build_snapshot('base', ['start'], base_actions)
-        # Modify the base content in branch
-        actions_other = self._get_actions(self._other['actions'])()
-        builder.build_snapshot('other', ['base'], actions_other)
-        # Modify the base content in trunk
-        actions_this = self._get_actions(self._this['actions'])()
-        builder.build_snapshot('this', ['base'], actions_this)
-        # builder.get_branch() tip is now 'this'
-
-        builder.finish_series()
-        self.builder = builder
-
-    def _get_actions(self, name):
-        return getattr(self, 'do_%s' % name)
-
-    def _get_check(self, name):
-        return getattr(self, 'check_%s' % name)
-
-    def _merge_other_into_this(self):
-        b = self.builder.get_branch()
-        wt = b.bzrdir.sprout('branch').open_workingtree()
-        wt.merge_from_branch(b, 'other')
-        return wt
-
-    def assertConflict(self, wt):
-        confs = wt.conflicts()
-        self.assertLength(1, confs)
-        c = confs[0]
-        self.assertIsInstance(c, self._conflict_type)
-        self._assert_conflict(wt, c)
-
-    def _get_resolve_path_arg(self, wt, action):
-        raise NotImplementedError(self._get_resolve_path_arg)
-
-    def check_resolved(self, wt, action):
-        path = self._get_resolve_path_arg(wt, action)
-        conflicts.resolve(wt, [path], action=action)
-        # Check that we don't have any conflicts nor unknown left
-        self.assertLength(0, wt.conflicts())
-        self.assertLength(0, list(wt.unknowns()))
-
-    def test_resolve_taking_this(self):
-        wt = self._merge_other_into_this()
-        self.assertConflict(wt)
-        self.check_resolved(wt, 'take_this')
-        check_this = self._get_check(self._this['check'])
-        check_this()
-
-    def test_resolve_taking_other(self):
-        wt = self._merge_other_into_this()
-        self.assertConflict(wt)
-        self.check_resolved(wt, 'take_other')
-        check_other = self._get_check(self._other['check'])
-        check_other()
-
-
-class TestResolveContentsConflict(TestParametrizedResolveConflicts):
-
-    _conflict_type = conflicts.ContentsConflict,
-
-    # Set by load_tests from scenarios()
-    # path and file-id for the file involved in the conflict
-    _path = None
-    _file_id = None
-
-    @staticmethod
-    def scenarios():
-        base_scenarios = [
-            # File modified/deleted
-            (dict(_base_actions='create_file',
-                  _path='file', _file_id='file-id'),
-             ('file_modified',
-              dict(actions='modify_file', check='file_has_more_content')),
-             ('file_deleted',
-              dict(actions='delete_file', check='file_doesnt_exist')),),
-            ]
-        return mirror_scenarios(base_scenarios)
-
-    def do_create_file(self):
-        return [('add', ('file', 'file-id', 'file', 'trunk content\n'))]
-
-    def do_modify_file(self):
-        return [('modify', ('file-id', 'trunk content\nmore content\n'))]
-
-    def check_file_has_more_content(self):
-        self.assertFileEqual('trunk content\nmore content\n', 'branch/file')
-
-    def do_delete_file(self):
-        return [('unversion', 'file-id')]
-
-    def check_file_doesnt_exist(self):
-        self.failIfExists('branch/file')
-
-    def _get_resolve_path_arg(self, wt, action):
-        return self._path
-
-    def assertContentsConflict(self, wt, c):
-        self.assertEqual(self._file_id, c.file_id)
-        self.assertEqual(self._path, c.path)
-    _assert_conflict = assertContentsConflict
-
-
-class TestResolvePathConflict(TestParametrizedResolveConflicts):
-
-    _conflict_type = conflicts.PathConflict,
-
-    def do_nothing(self):
-        return []
-
-    @staticmethod
-    def scenarios():
-        # Each side dict additionally defines:
-        # - path path involved (can be '<deleted>')
-        # - file-id involved
-        base_scenarios = [
-            # File renamed/deleted
-            (dict(_base_actions='create_file'),
-             ('file_renamed',
-              dict(actions='rename_file', check='file_renamed',
-                   path='new-file', file_id='file-id')),
-             ('file_deleted',
-              dict(actions='delete_file', check='file_doesnt_exist',
-                   # PathConflicts deletion handling requires a special
-                   # hard-coded value
-                   path='<deleted>', file_id='file-id')),),
-            # File renamed/renamed differently
-            (dict(_base_actions='create_file'),
-             ('file_renamed',
-              dict(actions='rename_file', check='file_renamed',
-                   path='new-file', file_id='file-id')),
-             ('file_renamed2',
-              dict(actions='rename_file2', check='file_renamed2',
-                   path='new-file2', file_id='file-id')),),
-            # Dir renamed/deleted
-            (dict(_base_actions='create_dir'),
-             ('dir_renamed',
-              dict(actions='rename_dir', check='dir_renamed',
-                   path='new-dir', file_id='dir-id')),
-             ('dir_deleted',
-              dict(actions='delete_dir', check='dir_doesnt_exist',
-                   # PathConflicts deletion handling requires a special
-                   # hard-coded value
-                   path='<deleted>', file_id='dir-id')),),
-            # Dir renamed/renamed differently
-            (dict(_base_actions='create_dir'),
-             ('dir_renamed',
-              dict(actions='rename_dir', check='dir_renamed',
-                   path='new-dir', file_id='dir-id')),
-             ('dir_renamed2',
-              dict(actions='rename_dir2', check='dir_renamed2',
-                   path='new-dir2', file_id='dir-id')),),
-        ]
-        return mirror_scenarios(base_scenarios)
-
-    def do_create_file(self):
-        return [('add', ('file', 'file-id', 'file', 'trunk content\n'))]
-
-    def do_create_dir(self):
-        return [('add', ('dir', 'dir-id', 'directory', ''))]
-
-    def do_rename_file(self):
-        return [('rename', ('file', 'new-file'))]
-
-    def check_file_renamed(self):
-        self.failIfExists('branch/file')
-        self.failUnlessExists('branch/new-file')
-
-    def do_rename_file2(self):
-        return [('rename', ('file', 'new-file2'))]
-
-    def check_file_renamed2(self):
-        self.failIfExists('branch/file')
-        self.failUnlessExists('branch/new-file2')
-
-    def do_rename_dir(self):
-        return [('rename', ('dir', 'new-dir'))]
-
-    def check_dir_renamed(self):
-        self.failIfExists('branch/dir')
-        self.failUnlessExists('branch/new-dir')
-
-    def do_rename_dir2(self):
-        return [('rename', ('dir', 'new-dir2'))]
-
-    def check_dir_renamed2(self):
-        self.failIfExists('branch/dir')
-        self.failUnlessExists('branch/new-dir2')
-
-    def do_delete_file(self):
-        return [('unversion', 'file-id')]
-
-    def check_file_doesnt_exist(self):
-        self.failIfExists('branch/file')
-
-    def do_delete_dir(self):
-        return [('unversion', 'dir-id')]
-
-    def check_dir_doesnt_exist(self):
-        self.failIfExists('branch/dir')
-
-    def _get_resolve_path_arg(self, wt, action):
-        tpath = self._this['path']
-        opath = self._other['path']
-        if tpath == '<deleted>':
-            path = opath
-        else:
-            path = tpath
-        return path
-
-    def assertPathConflict(self, wt, c):
-        tpath = self._this['path']
-        tfile_id = self._this['file_id']
-        opath = self._other['path']
-        ofile_id = self._other['file_id']
-        self.assertEqual(tfile_id, ofile_id) # Sanity check
-        self.assertEqual(tfile_id, c.file_id)
-        self.assertEqual(tpath, c.path)
-        self.assertEqual(opath, c.conflict_path)
-    _assert_conflict = assertPathConflict
-
-
-class TestResolvePathConflictBefore531967(TestResolvePathConflict):
-    """Same as TestResolvePathConflict but a specific conflict object.
-    """
-
-    def assertPathConflict(self, c):
-        # We create a conflict object as it was created before the fix and
-        # inject it into the working tree, the test will exercise the
-        # compatibility code.
-        old_c = conflicts.PathConflict('<deleted>', self._item_path,
-                                       file_id=None)
-        wt.set_conflicts(conflicts.ConflictList([old_c]))
-
-
-class TestResolveDuplicateEntry(TestParametrizedResolveConflicts):
-
-    _conflict_type = conflicts.DuplicateEntry,
-
-    @staticmethod
-    def scenarios():
-        # Each side dict additionally defines:
-        # - path involved
-        # - file-id involved
-        base_scenarios = [
-            # File created with different file-ids
-            (dict(_base_actions='nothing'),
-             ('filea_created',
-              dict(actions='create_file_a', check='file_content_a',
-                   path='file', file_id='file-a-id')),
-             ('fileb_created',
-              dict(actions='create_file_b', check='file_content_b',
-                   path='file', file_id='file-b-id')),),
-            ]
-        return mirror_scenarios(base_scenarios)
-
-    def do_nothing(self):
-        return []
-
-    def do_create_file_a(self):
-        return [('add', ('file', 'file-a-id', 'file', 'file a content\n'))]
-
-    def check_file_content_a(self):
-        self.assertFileEqual('file a content\n', 'branch/file')
-
-    def do_create_file_b(self):
-        return [('add', ('file', 'file-b-id', 'file', 'file b content\n'))]
-
-    def check_file_content_b(self):
-        self.assertFileEqual('file b content\n', 'branch/file')
-
-    def _get_resolve_path_arg(self, wt, action):
-        return self._this['path']
-
-    def assertDuplicateEntry(self, wt, c):
-        tpath = self._this['path']
-        tfile_id = self._this['file_id']
-        opath = self._other['path']
-        ofile_id = self._other['file_id']
-        self.assertEqual(tpath, opath) # Sanity check
-        self.assertEqual(tfile_id, c.file_id)
-        self.assertEqual(tpath + '.moved', c.path)
-        self.assertEqual(tpath, c.conflict_path)
-    _assert_conflict = assertDuplicateEntry
-
-
-class TestResolveUnversionedParent(TestResolveConflicts):
-
-    # FIXME: Add the reverse tests: dir deleted in trunk, file added in branch
-
-    # FIXME: While this *creates* UnversionedParent conflicts, this really only
-    # tests MissingParent resolution :-/
-    preamble = """
-$ bzr init trunk
-$ cd trunk
-$ mkdir dir
-$ bzr add dir
-$ bzr commit -m 'Create trunk'
-
-$ echo 'trunk content' >dir/file
-$ bzr add dir/file
-$ bzr commit -m 'Add dir/file in trunk'
-
-$ bzr branch . -r 1 ../branch
-$ cd ../branch
-$ bzr rm dir
-$ bzr commit -m 'Remove dir in branch'
-
-$ bzr merge ../trunk
-2>+N  dir/
-2>+N  dir/file
-2>Conflict adding files to dir.  Created directory.
-2>Conflict because dir is not versioned, but has versioned children.  Versioned directory.
-2>2 conflicts encountered.
-"""
-
-    def test_take_this(self):
-        self.run_script("""
-$ bzr rm dir  --force
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_take_other(self):
-        self.run_script("""
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-
-class TestResolveMissingParent(TestResolveConflicts):
-
-    preamble = """
-$ bzr init trunk
-$ cd trunk
-$ mkdir dir
-$ echo 'trunk content' >dir/file
-$ bzr add
-$ bzr commit -m 'Create trunk'
-
-$ echo 'trunk content' >dir/file2
-$ bzr add dir/file2
-$ bzr commit -m 'Add dir/file2 in branch'
-
-$ bzr branch . -r 1 ../branch
-$ cd ../branch
-$ bzr rm dir/file --force
-$ bzr rm dir
-$ bzr commit -m 'Remove dir/file'
-
-$ bzr merge ../trunk
-2>+N  dir/
-2>+N  dir/file2
-2>Conflict adding files to dir.  Created directory.
-2>Conflict because dir is not versioned, but has versioned children.  Versioned directory.
-2>2 conflicts encountered.
-"""
-
-    def test_keep_them_all(self):
-        self.run_script("""
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_adopt_child(self):
-        self.run_script("""
-$ bzr mv dir/file2 file2
-$ bzr rm dir --force
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_kill_them_all(self):
-        self.run_script("""
-$ bzr rm dir --force
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_resolve_taking_this(self):
-        self.run_script("""
-$ bzr resolve --take-this dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_resolve_taking_other(self):
-        self.run_script("""
-$ bzr resolve --take-other dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-
-class TestResolveDeletingParent(TestResolveConflicts):
-
-    preamble = """
-$ bzr init trunk
-$ cd trunk
-$ mkdir dir
-$ echo 'trunk content' >dir/file
-$ bzr add
-$ bzr commit -m 'Create trunk'
-
-$ bzr rm dir/file --force
-$ bzr rm dir --force
-$ bzr commit -m 'Remove dir/file'
-
-$ bzr branch . -r 1 ../branch
-$ cd ../branch
-$ echo 'branch content' >dir/file2
-$ bzr add dir/file2
-$ bzr commit -m 'Add dir/file2 in branch'
-
-$ bzr merge ../trunk
-2>-D  dir/file
-2>Conflict: can't delete dir because it is not empty.  Not deleting.
-2>Conflict because dir is not versioned, but has versioned children.  Versioned directory.
-2>2 conflicts encountered.
-"""
-
-    def test_keep_them_all(self):
-        self.run_script("""
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_adopt_child(self):
-        self.run_script("""
-$ bzr mv dir/file2 file2
-$ bzr rm dir --force
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_kill_them_all(self):
-        self.run_script("""
-$ bzr rm dir --force
-$ bzr resolve dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_resolve_taking_this(self):
-        self.run_script("""
-$ bzr resolve --take-this dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_resolve_taking_other(self):
-        self.run_script("""
-$ bzr resolve --take-other dir
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-
-class TestResolveParentLoop(TestParametrizedResolveConflicts):
-
-    _conflict_type = conflicts.ParentLoop,
-
-    _this_args = None
-    _other_args = None
-
-    @staticmethod
-    def scenarios():
-        # Each side dict additionally defines:
-        # - dir_id: the directory being moved
-        # - target_id: The target directory
-        # - xfail: whether the test is expected to fail if the action is
-        #     involved as 'other'
-        base_scenarios = [
-            # Dirs moved into each other
-            (dict(_base_actions='create_dir1_dir2'),
-             ('dir1_into_dir2',
-              dict(actions='move_dir1_into_dir2', check='dir1_moved',
-                   dir_id='dir1-id', target_id='dir2-id', xfail=False)),
-             ('dir2_into_dir1',
-              dict(actions='move_dir2_into_dir1', check='dir2_moved',
-                   dir_id='dir2-id', target_id='dir1-id', xfail=False))),
-            # Subdirs moved into each other
-            (dict(_base_actions='create_dir1_4'),
-             ('dir1_into_dir4',
-              dict(actions='move_dir1_into_dir4', check='dir1_2_moved',
-                   dir_id='dir1-id', target_id='dir4-id', xfail=True)),
-             ('dir3_into_dir2',
-              dict(actions='move_dir3_into_dir2', check='dir3_4_moved',
-                   dir_id='dir3-id', target_id='dir2-id', xfail=True))),
-            ]
-        return mirror_scenarios(base_scenarios)
-
-    def do_create_dir1_dir2(self):
-        return [('add', ('dir1', 'dir1-id', 'directory', '')),
-                ('add', ('dir2', 'dir2-id', 'directory', '')),]
-
-    def do_move_dir1_into_dir2(self):
-        return [('rename', ('dir1', 'dir2/dir1'))]
-
-    def check_dir1_moved(self):
-        self.failIfExists('branch/dir1')
-        self.failUnlessExists('branch/dir2/dir1')
-
-    def do_move_dir2_into_dir1(self):
-        return [('rename', ('dir2', 'dir1/dir2'))]
-
-    def check_dir2_moved(self):
-        self.failIfExists('branch/dir2')
-        self.failUnlessExists('branch/dir1/dir2')
-
-    def do_create_dir1_4(self):
-        return [('add', ('dir1', 'dir1-id', 'directory', '')),
-                ('add', ('dir1/dir2', 'dir2-id', 'directory', '')),
-                ('add', ('dir3', 'dir3-id', 'directory', '')),
-                ('add', ('dir3/dir4', 'dir4-id', 'directory', '')),]
-
-    def do_move_dir1_into_dir4(self):
-        return [('rename', ('dir1', 'dir3/dir4/dir1'))]
-
-    def check_dir1_2_moved(self):
-        self.failIfExists('branch/dir1')
-        self.failUnlessExists('branch/dir3/dir4/dir1')
-        self.failUnlessExists('branch/dir3/dir4/dir1/dir2')
-
-    def do_move_dir3_into_dir2(self):
-        return [('rename', ('dir3', 'dir1/dir2/dir3'))]
-
-    def check_dir3_4_moved(self):
-        self.failIfExists('branch/dir3')
-        self.failUnlessExists('branch/dir1/dir2/dir3')
-        self.failUnlessExists('branch/dir1/dir2/dir3/dir4')
-
-    def _get_resolve_path_arg(self, wt, action):
-        # ParentLoop says: moving <conflict_path> into <path>. Cancelled move.
-        # But since <path> doesn't exist in the working tree, we need to use
-        # <conflict_path> instead, and that, in turn, is given by dir_id. Pfew.
-        return wt.id2path(self._other['dir_id'])
-
-    def assertParentLoop(self, wt, c):
-        self.assertEqual(self._other['dir_id'], c.file_id)
-        self.assertEqual(self._other['target_id'], c.conflict_file_id)
-        # The conflict paths are irrelevant (they are deterministic but not
-        # worth checking since they don't provide the needed information
-        # anyway)
-        if self._other['xfail']:
-            # It's a bit hackish to raise from here relying on being called for
-            # both tests but this avoid overriding test_resolve_taking_other
-            raise tests.KnownFailure(
-                "ParentLoop doesn't carry enough info to resolve --take-other")
-    _assert_conflict = assertParentLoop
-
-
-class TestResolveNonDirectoryParent(TestResolveConflicts):
-
-    preamble = """
-$ bzr init trunk
-$ cd trunk
-$ bzr mkdir foo
-$ bzr commit -m 'Create trunk'
-$ echo "Boing" >foo/bar
-$ bzr add foo/bar
-$ bzr commit -m 'Add foo/bar'
-
-$ bzr branch . -r 1 ../branch
-$ cd ../branch
-$ rm -r foo
-$ echo "Boo!" >foo
-$ bzr commit -m 'foo is now a file'
-
-$ bzr merge ../trunk
-2>+N  foo.new/bar
-2>RK  foo => foo.new/
-# FIXME: The message is misleading, foo.new *is* a directory when the message
-# is displayed -- vila 090916
-2>Conflict: foo.new is not a directory, but has files in it.  Created directory.
-2>1 conflicts encountered.
-"""
-
-    def test_take_this(self):
-        self.run_script("""
-$ bzr rm foo.new --force
-# FIXME: Isn't it weird that foo is now unkown even if foo.new has been put
-# aside ? -- vila 090916
-$ bzr add foo
-$ bzr resolve foo.new
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_take_other(self):
-        self.run_script("""
-$ bzr rm foo --force
-$ bzr mv foo.new foo
-$ bzr resolve foo
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_resolve_taking_this(self):
-        self.run_script("""
-$ bzr resolve --take-this foo.new
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-    def test_resolve_taking_other(self):
-        self.run_script("""
-$ bzr resolve --take-other foo.new
-$ bzr commit --strict -m 'No more conflicts nor unknown files'
-""")
-
-
-class TestMalformedTransform(script.TestCaseWithTransportAndScript):
-
-    def test_bug_430129(self):
-        # This is nearly like TestResolveNonDirectoryParent but with branch and
-        # trunk switched. As such it should certainly produce the same
-        # conflict.
-        self.run_script("""
-$ bzr init trunk
-$ cd trunk
-$ bzr mkdir foo
-$ bzr commit -m 'Create trunk'
-$ rm -r foo
-$ echo "Boo!" >foo
-$ bzr commit -m 'foo is now a file'
-
-$ bzr branch . -r 1 ../branch
-$ cd ../branch
-$ echo "Boing" >foo/bar
-$ bzr add foo/bar
-$ bzr commit -m 'Add foo/bar'
-
-$ bzr merge ../trunk
-2>bzr: ERROR: Tree transform is malformed [('unversioned executability', 'new-1')]
-""")
-
-
-class TestResolveActionOption(tests.TestCase):
-
-    def setUp(self):
-        super(TestResolveActionOption, self).setUp()
-        self.options = [conflicts.ResolveActionOption()]
-        self.parser = option.get_optparser(dict((o.name, o)
-                                                for o in self.options))
-
-    def parse(self, args):
-        return self.parser.parse_args(args)
-
-    def test_unknown_action(self):
-        self.assertRaises(errors.BadOptionValue,
-                          self.parse, ['--action', 'take-me-to-the-moon'])
-
-    def test_done(self):
-        opts, args = self.parse(['--action', 'done'])
-        self.assertEqual({'action':'done'}, opts)
-
-    def test_take_this(self):
-        opts, args = self.parse(['--action', 'take-this'])
-        self.assertEqual({'action': 'take_this'}, opts)
-        opts, args = self.parse(['--take-this'])
-        self.assertEqual({'action': 'take_this'}, opts)
-
-    def test_take_other(self):
-        opts, args = self.parse(['--action', 'take-other'])
-        self.assertEqual({'action': 'take_other'}, opts)
-        opts, args = self.parse(['--take-other'])
-        self.assertEqual({'action': 'take_other'}, opts)

=== modified file 'bzrlib/tests/test_crash.py'
--- bzrlib/tests/test_crash.py	2010-04-08 04:34:03 +0000
+++ bzrlib/tests/test_crash.py	2009-12-22 15:39:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,57 +18,31 @@
 from StringIO import StringIO
 import sys
 
-
-import os
-
-
 from bzrlib import (
-    config,
     crash,
-    osutils,
-    symbol_versioning,
     tests,
     )
 
 from bzrlib.tests import features
 
 
-class TestApportReporting(tests.TestCaseInTempDir):
+class TestApportReporting(tests.TestCase):
 
     _test_needs_features = [features.apport]
 
-    def test_apport_report(self):
-        crash_dir = osutils.joinpath((self.test_base_dir, 'crash'))
-        os.mkdir(crash_dir)
-        os.environ['APPORT_CRASH_DIR'] = crash_dir
-        self.assertEquals(crash_dir, config.crash_dir())
-
-        stderr = StringIO()
-
+    def test_apport_report_contents(self):
         try:
             raise AssertionError("my error")
         except AssertionError, e:
             pass
-
-        crash_filename = crash.report_bug_to_apport(sys.exc_info(),
-            stderr)
-
-        # message explaining the crash
-        self.assertContainsRe(stderr.getvalue(),
-            "    apport-bug %s" % crash_filename)
-
-        crash_file = open(crash_filename)
-        try:
-            report = crash_file.read()
-        finally:
-            crash_file.close()
-
-        self.assertContainsRe(report,
-            '(?m)^BzrVersion:') # should be in the traceback
+        outf = StringIO()
+        crash._write_apport_report_to_file(sys.exc_info(), outf)
+        report = outf.getvalue()
+
+        self.assertContainsRe(report, '(?m)^BzrVersion:')
+        # should be in the traceback
         self.assertContainsRe(report, 'my error')
         self.assertContainsRe(report, 'AssertionError')
-        # see https://bugs.launchpad.net/bzr/+bug/528114
-        self.assertContainsRe(report, 'ExecutablePath')
-        self.assertContainsRe(report, 'test_apport_report')
+        self.assertContainsRe(report, 'test_apport_report_contents')
         # should also be in there
         self.assertContainsRe(report, '(?m)^CommandLine:')

=== modified file 'bzrlib/tests/test_decorators.py'
--- bzrlib/tests/test_decorators.py	2010-04-23 08:51:52 +0000
+++ bzrlib/tests/test_decorators.py	2009-10-02 06:12:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -167,14 +167,14 @@
         """@needs_read_lock exposes underlying name and doc."""
         sam = create_decorator_sample(None)
         self.assertEqual('frob', sam.frob.__name__)
-        self.assertDocstring('Frob the sample object', sam.frob)
+        self.assertEqual('Frob the sample object', sam.frob.__doc__)
 
     def test_write_lock_passthrough(self):
         """@needs_write_lock exposes underlying name and doc."""
         sam = create_decorator_sample(None)
         self.assertEqual('bank', sam.bank.__name__)
-        self.assertDocstring('Bank the sample, but using bar and biz.',
-                             sam.bank)
+        self.assertEqual('Bank the sample, but using bar and biz.',
+                         sam.bank.__doc__)
 
     def test_argument_passthrough(self):
         """Test that arguments get passed around properly."""
@@ -208,8 +208,8 @@
                          my_function.func_code.co_name)
         self.assertEqual('(foo, bar, baz=None, biz=1)',
                          self.get_formatted_args(my_function))
-        self.assertDocstring(
-            'Just a function that supplies several arguments.', my_function)
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
 
     def test__fast_needs_read_lock(self):
         """Test the output of _fast_needs_read_lock."""
@@ -222,8 +222,8 @@
         self.assertEqual('read_locked', my_function.func_code.co_name)
         self.assertEqual('(self, *args, **kwargs)',
                          self.get_formatted_args(my_function))
-        self.assertDocstring(
-            'Just a function that supplies several arguments.', my_function)
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
 
     def test__pretty_needs_write_lock(self):
         """Test that _pretty_needs_write_lock generates a nice wrapper."""
@@ -237,8 +237,8 @@
                          my_function.func_code.co_name)
         self.assertEqual('(foo, bar, baz=None, biz=1)',
                          self.get_formatted_args(my_function))
-        self.assertDocstring(
-            'Just a function that supplies several arguments.', my_function)
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
 
     def test__fast_needs_write_lock(self):
         """Test the output of _fast_needs_write_lock."""
@@ -251,8 +251,8 @@
         self.assertEqual('write_locked', my_function.func_code.co_name)
         self.assertEqual('(self, *args, **kwargs)',
                          self.get_formatted_args(my_function))
-        self.assertDocstring(
-            'Just a function that supplies several arguments.', my_function)
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
 
     def test_use_decorators(self):
         """Test that you can switch the type of the decorators."""

=== modified file 'bzrlib/tests/test_delta.py'
--- bzrlib/tests/test_delta.py	2010-04-26 13:51:08 +0000
+++ bzrlib/tests/test_delta.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -221,7 +221,7 @@
 
     def show_string(self, delta, *args,  **kwargs):
         to_file = StringIO()
-        _mod_delta.report_delta(to_file, delta, *args, **kwargs)
+        delta.show(to_file, *args, **kwargs)
         return to_file.getvalue()
 
     def test_kind_change(self):
@@ -307,13 +307,13 @@
     def test_delta_show_short_status_no_filter(self):
         d, long_status, short_status = self._get_delta()
         out = StringIO()
-        _mod_delta.report_delta(out, d, short_status=True)
+        d.show(out, short_status=True)
         self.assertEquals(short_status, out.getvalue())
 
     def test_delta_show_long_status_no_filter(self):
         d, long_status, short_status = self._get_delta()
         out = StringIO()
-        _mod_delta.report_delta(out, d, short_status=False)
+        d.show(out, short_status=False)
         self.assertEquals(long_status, out.getvalue())
 
     def test_delta_show_no_filter(self):
@@ -321,7 +321,7 @@
         out = StringIO()
         def not_a_filter(path, file_id):
             return True
-        _mod_delta.report_delta(out, d, short_status=True, filter=not_a_filter)
+        d.show(out, short_status=True, filter=not_a_filter)
         self.assertEquals(short_status, out.getvalue())
 
     def test_delta_show_short_status_single_file_filter(self):
@@ -329,7 +329,7 @@
         out = StringIO()
         def only_f2(path, file_id):
             return path == 'f2'
-        _mod_delta.report_delta(out, d, short_status=True, filter=only_f2)
+        d.show(out, short_status=True, filter=only_f2)
         self.assertEquals("A  f2\n", out.getvalue())
 
     def test_delta_show_long_status_single_file_filter(self):
@@ -337,7 +337,7 @@
         out = StringIO()
         def only_f2(path, file_id):
             return path == 'f2'
-        _mod_delta.report_delta(out, d, short_status=False, filter=only_f2)
+        d.show(out, short_status=False, filter=only_f2)
         self.assertEquals("added:\n  f2\n", out.getvalue())
 
     def test_delta_show_short_status_single_file_id_filter(self):
@@ -345,6 +345,6 @@
         out = StringIO()
         def only_f2_id(path, file_id):
             return file_id == 'f2-id'
-        _mod_delta.report_delta(out, d, short_status=True, filter=only_f2_id)
+        d.show(out, short_status=True, filter=only_f2_id)
         self.assertEquals("A  f2\n", out.getvalue())
 

=== modified file 'bzrlib/tests/test_diff.py'
--- bzrlib/tests/test_diff.py	2010-04-20 14:04:54 +0000
+++ bzrlib/tests/test_diff.py	2009-12-22 15:50:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,28 +15,38 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import os
+import os.path
 from cStringIO import StringIO
+import errno
 import subprocess
 import sys
-import tempfile
+from tempfile import TemporaryFile
 
-from bzrlib import (
-    diff,
-    errors,
-    osutils,
-    patiencediff,
-    _patiencediff_py,
-    revision as _mod_revision,
-    revisionspec,
-    revisiontree,
-    tests,
-    transform,
+from bzrlib import tests
+from bzrlib.diff import (
+    DiffFromTool,
+    DiffPath,
+    DiffSymlink,
+    DiffTree,
+    DiffText,
+    external_diff,
+    internal_diff,
+    show_diff_trees,
+    get_trees_and_branches_to_diff,
     )
-from bzrlib.symbol_versioning import deprecated_in
-from bzrlib.tests import test_win32utils
-
-
-class _AttribFeature(tests.Feature):
+from bzrlib.errors import BinaryFile, NoDiff, ExecutableMissing
+import bzrlib.osutils as osutils
+import bzrlib.revision as _mod_revision
+import bzrlib.transform as transform
+import bzrlib.patiencediff
+import bzrlib._patiencediff_py
+from bzrlib.tests import (Feature, TestCase, TestCaseWithTransport,
+                          TestCaseInTempDir, TestSkipped)
+from bzrlib.revisiontree import RevisionTree
+from bzrlib.revisionspec import RevisionSpec
+
+
+class _AttribFeature(Feature):
 
     def _probe(self):
         if (sys.platform not in ('cygwin', 'win32')):
@@ -59,7 +69,7 @@
 
 def udiff_lines(old, new, allow_binary=False):
     output = StringIO()
-    diff.internal_diff('old', old, 'new', new, output, allow_binary)
+    internal_diff('old', old, 'new', new, output, allow_binary)
     output.seek(0, 0)
     return output.readlines()
 
@@ -69,18 +79,18 @@
         # StringIO has no fileno, so it tests a different codepath
         output = StringIO()
     else:
-        output = tempfile.TemporaryFile()
+        output = TemporaryFile()
     try:
-        diff.external_diff('old', old, 'new', new, output, diff_opts=['-u'])
-    except errors.NoDiff:
-        raise tests.TestSkipped('external "diff" not present to test')
+        external_diff('old', old, 'new', new, output, diff_opts=['-u'])
+    except NoDiff:
+        raise TestSkipped('external "diff" not present to test')
     output.seek(0, 0)
     lines = output.readlines()
     output.close()
     return lines
 
 
-class TestDiff(tests.TestCase):
+class TestDiff(TestCase):
 
     def test_add_nl(self):
         """diff generates a valid diff for patches that add a newline"""
@@ -122,12 +132,10 @@
             ## "Unterminated hunk header for patch:\n%s" % "".join(lines)
 
     def test_binary_lines(self):
-        empty = []
-        uni_lines = [1023 * 'a' + '\x00']
-        self.assertRaises(errors.BinaryFile, udiff_lines, uni_lines , empty)
-        self.assertRaises(errors.BinaryFile, udiff_lines, empty, uni_lines)
-        udiff_lines(uni_lines , empty, allow_binary=True)
-        udiff_lines(empty, uni_lines, allow_binary=True)
+        self.assertRaises(BinaryFile, udiff_lines, [1023 * 'a' + '\x00'], [])
+        self.assertRaises(BinaryFile, udiff_lines, [], [1023 * 'a' + '\x00'])
+        udiff_lines([1023 * 'a' + '\x00'], [], allow_binary=True)
+        udiff_lines([], [1023 * 'a' + '\x00'], allow_binary=True)
 
     def test_external_diff(self):
         lines = external_udiff_lines(['boo\n'], ['goo\n'])
@@ -163,7 +171,7 @@
         orig_path = os.environ['PATH']
         try:
             os.environ['PATH'] = ''
-            self.assertRaises(errors.NoDiff, diff.external_diff,
+            self.assertRaises(NoDiff, external_diff,
                               'old', ['boo\n'], 'new', ['goo\n'],
                               StringIO(), diff_opts=['-u'])
         finally:
@@ -172,8 +180,8 @@
     def test_internal_diff_default(self):
         # Default internal diff encoding is utf8
         output = StringIO()
-        diff.internal_diff(u'old_\xb5', ['old_text\n'],
-                           u'new_\xe5', ['new_text\n'], output)
+        internal_diff(u'old_\xb5', ['old_text\n'],
+                    u'new_\xe5', ['new_text\n'], output)
         lines = output.getvalue().splitlines(True)
         self.check_patch(lines)
         self.assertEquals(['--- old_\xc2\xb5\n',
@@ -187,9 +195,9 @@
 
     def test_internal_diff_utf8(self):
         output = StringIO()
-        diff.internal_diff(u'old_\xb5', ['old_text\n'],
-                           u'new_\xe5', ['new_text\n'], output,
-                           path_encoding='utf8')
+        internal_diff(u'old_\xb5', ['old_text\n'],
+                    u'new_\xe5', ['new_text\n'], output,
+                    path_encoding='utf8')
         lines = output.getvalue().splitlines(True)
         self.check_patch(lines)
         self.assertEquals(['--- old_\xc2\xb5\n',
@@ -203,9 +211,9 @@
 
     def test_internal_diff_iso_8859_1(self):
         output = StringIO()
-        diff.internal_diff(u'old_\xb5', ['old_text\n'],
-                           u'new_\xe5', ['new_text\n'], output,
-                           path_encoding='iso-8859-1')
+        internal_diff(u'old_\xb5', ['old_text\n'],
+                    u'new_\xe5', ['new_text\n'], output,
+                    path_encoding='iso-8859-1')
         lines = output.getvalue().splitlines(True)
         self.check_patch(lines)
         self.assertEquals(['--- old_\xb5\n',
@@ -219,26 +227,26 @@
 
     def test_internal_diff_no_content(self):
         output = StringIO()
-        diff.internal_diff(u'old', [], u'new', [], output)
+        internal_diff(u'old', [], u'new', [], output)
         self.assertEqual('', output.getvalue())
 
     def test_internal_diff_no_changes(self):
         output = StringIO()
-        diff.internal_diff(u'old', ['text\n', 'contents\n'],
-                           u'new', ['text\n', 'contents\n'],
-                           output)
+        internal_diff(u'old', ['text\n', 'contents\n'],
+                      u'new', ['text\n', 'contents\n'],
+                      output)
         self.assertEqual('', output.getvalue())
 
     def test_internal_diff_returns_bytes(self):
         import StringIO
         output = StringIO.StringIO()
-        diff.internal_diff(u'old_\xb5', ['old_text\n'],
-                            u'new_\xe5', ['new_text\n'], output)
+        internal_diff(u'old_\xb5', ['old_text\n'],
+                    u'new_\xe5', ['new_text\n'], output)
         self.failUnless(isinstance(output.getvalue(), str),
             'internal_diff should return bytestrings')
 
 
-class TestDiffFiles(tests.TestCaseInTempDir):
+class TestDiffFiles(TestCaseInTempDir):
 
     def test_external_diff_binary(self):
         """The output when using external diff should use diff's i18n error"""
@@ -257,7 +265,7 @@
         self.assertEqual(out.splitlines(True) + ['\n'], lines)
 
 
-class TestShowDiffTreesHelper(tests.TestCaseWithTransport):
+class TestShowDiffTreesHelper(TestCaseWithTransport):
     """Has a helper for running show_diff_trees"""
 
     def get_diff(self, tree1, tree2, specific_files=None, working_tree=None):
@@ -266,10 +274,9 @@
             extra_trees = (working_tree,)
         else:
             extra_trees = ()
-        diff.show_diff_trees(tree1, tree2, output,
-                             specific_files=specific_files,
-                             extra_trees=extra_trees, old_label='old/',
-                             new_label='new/')
+        show_diff_trees(tree1, tree2, output, specific_files=specific_files,
+                        extra_trees=extra_trees, old_label='old/',
+                        new_label='new/')
         return output.getvalue()
 
 
@@ -414,12 +421,12 @@
         tree.commit('one', rev_id='rev-1')
 
         self.build_tree_contents([('tree/file', 'new contents\n')])
-        d = self.get_diff(tree.basis_tree(), tree)
-        self.assertContainsRe(d, "=== modified file 'file'\n")
-        self.assertContainsRe(d, '--- old/file\t')
-        self.assertContainsRe(d, '\\+\\+\\+ new/file\t')
-        self.assertContainsRe(d, '-contents\n'
-                                 '\\+new contents\n')
+        diff = self.get_diff(tree.basis_tree(), tree)
+        self.assertContainsRe(diff, "=== modified file 'file'\n")
+        self.assertContainsRe(diff, '--- old/file\t')
+        self.assertContainsRe(diff, '\\+\\+\\+ new/file\t')
+        self.assertContainsRe(diff, '-contents\n'
+                                    '\\+new contents\n')
 
     def test_modified_file_in_renamed_dir(self):
         """Test when a file is modified in a renamed directory."""
@@ -431,15 +438,15 @@
 
         tree.rename_one('dir', 'other')
         self.build_tree_contents([('tree/other/file', 'new contents\n')])
-        d = self.get_diff(tree.basis_tree(), tree)
-        self.assertContainsRe(d, "=== renamed directory 'dir' => 'other'\n")
-        self.assertContainsRe(d, "=== modified file 'other/file'\n")
+        diff = self.get_diff(tree.basis_tree(), tree)
+        self.assertContainsRe(diff, "=== renamed directory 'dir' => 'other'\n")
+        self.assertContainsRe(diff, "=== modified file 'other/file'\n")
         # XXX: This is technically incorrect, because it used to be at another
         # location. What to do?
-        self.assertContainsRe(d, '--- old/dir/file\t')
-        self.assertContainsRe(d, '\\+\\+\\+ new/other/file\t')
-        self.assertContainsRe(d, '-contents\n'
-                                 '\\+new contents\n')
+        self.assertContainsRe(diff, '--- old/dir/file\t')
+        self.assertContainsRe(diff, '\\+\\+\\+ new/other/file\t')
+        self.assertContainsRe(diff, '-contents\n'
+                                    '\\+new contents\n')
 
     def test_renamed_directory(self):
         """Test when only a directory is only renamed."""
@@ -450,10 +457,10 @@
         tree.commit('one', rev_id='rev-1')
 
         tree.rename_one('dir', 'newdir')
-        d = self.get_diff(tree.basis_tree(), tree)
+        diff = self.get_diff(tree.basis_tree(), tree)
         # Renaming a directory should be a single "you renamed this dir" even
         # when there are files inside.
-        self.assertEqual(d, "=== renamed directory 'dir' => 'newdir'\n")
+        self.assertEqual("=== renamed directory 'dir' => 'newdir'\n", diff)
 
     def test_renamed_file(self):
         """Test when a file is only renamed."""
@@ -463,11 +470,11 @@
         tree.commit('one', rev_id='rev-1')
 
         tree.rename_one('file', 'newname')
-        d = self.get_diff(tree.basis_tree(), tree)
-        self.assertContainsRe(d, "=== renamed file 'file' => 'newname'\n")
+        diff = self.get_diff(tree.basis_tree(), tree)
+        self.assertContainsRe(diff, "=== renamed file 'file' => 'newname'\n")
         # We shouldn't have a --- or +++ line, because there is no content
         # change
-        self.assertNotContainsRe(d, '---')
+        self.assertNotContainsRe(diff, '---')
 
     def test_renamed_and_modified_file(self):
         """Test when a file is only renamed."""
@@ -478,12 +485,12 @@
 
         tree.rename_one('file', 'newname')
         self.build_tree_contents([('tree/newname', 'new contents\n')])
-        d = self.get_diff(tree.basis_tree(), tree)
-        self.assertContainsRe(d, "=== renamed file 'file' => 'newname'\n")
-        self.assertContainsRe(d, '--- old/file\t')
-        self.assertContainsRe(d, '\\+\\+\\+ new/newname\t')
-        self.assertContainsRe(d, '-contents\n'
-                                 '\\+new contents\n')
+        diff = self.get_diff(tree.basis_tree(), tree)
+        self.assertContainsRe(diff, "=== renamed file 'file' => 'newname'\n")
+        self.assertContainsRe(diff, '--- old/file\t')
+        self.assertContainsRe(diff, '\\+\\+\\+ new/newname\t')
+        self.assertContainsRe(diff, '-contents\n'
+                                    '\\+new contents\n')
 
 
     def test_internal_diff_exec_property(self):
@@ -508,18 +515,14 @@
         tree.rename_one('c', 'new-c')
         tree.rename_one('d', 'new-d')
 
-        d = self.get_diff(tree.basis_tree(), tree)
+        diff = self.get_diff(tree.basis_tree(), tree)
 
-        self.assertContainsRe(d, r"file 'a'.*\(properties changed:"
-                                  ".*\+x to -x.*\)")
-        self.assertContainsRe(d, r"file 'b'.*\(properties changed:"
-                                  ".*-x to \+x.*\)")
-        self.assertContainsRe(d, r"file 'c'.*\(properties changed:"
-                                  ".*\+x to -x.*\)")
-        self.assertContainsRe(d, r"file 'd'.*\(properties changed:"
-                                  ".*-x to \+x.*\)")
-        self.assertNotContainsRe(d, r"file 'e'")
-        self.assertNotContainsRe(d, r"file 'f'")
+        self.assertContainsRe(diff, r"file 'a'.*\(properties changed:.*\+x to -x.*\)")
+        self.assertContainsRe(diff, r"file 'b'.*\(properties changed:.*-x to \+x.*\)")
+        self.assertContainsRe(diff, r"file 'c'.*\(properties changed:.*\+x to -x.*\)")
+        self.assertContainsRe(diff, r"file 'd'.*\(properties changed:.*-x to \+x.*\)")
+        self.assertNotContainsRe(diff, r"file 'e'")
+        self.assertNotContainsRe(diff, r"file 'f'")
 
 
     def test_binary_unicode_filenames(self):
@@ -541,14 +544,14 @@
         tree.add([alpha], ['file-id'])
         tree.add([omega], ['file-id-2'])
         diff_content = StringIO()
-        diff.show_diff_trees(tree.basis_tree(), tree, diff_content)
-        d = diff_content.getvalue()
-        self.assertContainsRe(d, r"=== added file '%s'" % alpha_utf8)
-        self.assertContainsRe(d, "Binary files a/%s.*and b/%s.* differ\n"
-                              % (alpha_utf8, alpha_utf8))
-        self.assertContainsRe(d, r"=== added file '%s'" % omega_utf8)
-        self.assertContainsRe(d, r"--- a/%s" % (omega_utf8,))
-        self.assertContainsRe(d, r"\+\+\+ b/%s" % (omega_utf8,))
+        show_diff_trees(tree.basis_tree(), tree, diff_content)
+        diff = diff_content.getvalue()
+        self.assertContainsRe(diff, r"=== added file '%s'" % alpha_utf8)
+        self.assertContainsRe(
+            diff, "Binary files a/%s.*and b/%s.* differ\n" % (alpha_utf8, alpha_utf8))
+        self.assertContainsRe(diff, r"=== added file '%s'" % omega_utf8)
+        self.assertContainsRe(diff, r"--- a/%s" % (omega_utf8,))
+        self.assertContainsRe(diff, r"\+\+\+ b/%s" % (omega_utf8,))
 
     def test_unicode_filename(self):
         """Test when the filename are unicode."""
@@ -573,15 +576,15 @@
         tree.add(['add_'+alpha], ['file-id'])
         self.build_tree_contents([('tree/mod_'+alpha, 'contents_mod\n')])
 
-        d = self.get_diff(tree.basis_tree(), tree)
-        self.assertContainsRe(d,
+        diff = self.get_diff(tree.basis_tree(), tree)
+        self.assertContainsRe(diff,
                 "=== renamed file 'ren_%s' => 'ren_%s'\n"%(autf8, outf8))
-        self.assertContainsRe(d, "=== added file 'add_%s'"%autf8)
-        self.assertContainsRe(d, "=== modified file 'mod_%s'"%autf8)
-        self.assertContainsRe(d, "=== removed file 'del_%s'"%autf8)
-
-
-class DiffWasIs(diff.DiffPath):
+        self.assertContainsRe(diff, "=== added file 'add_%s'"%autf8)
+        self.assertContainsRe(diff, "=== modified file 'mod_%s'"%autf8)
+        self.assertContainsRe(diff, "=== removed file 'del_%s'"%autf8)
+
+
+class DiffWasIs(DiffPath):
 
     def diff(self, file_id, old_path, new_path, old_kind, new_kind):
         self.to_file.write('was: ')
@@ -591,17 +594,17 @@
         pass
 
 
-class TestDiffTree(tests.TestCaseWithTransport):
+class TestDiffTree(TestCaseWithTransport):
 
     def setUp(self):
-        super(TestDiffTree, self).setUp()
+        TestCaseWithTransport.setUp(self)
         self.old_tree = self.make_branch_and_tree('old-tree')
         self.old_tree.lock_write()
         self.addCleanup(self.old_tree.unlock)
         self.new_tree = self.make_branch_and_tree('new-tree')
         self.new_tree.lock_write()
         self.addCleanup(self.new_tree.unlock)
-        self.differ = diff.DiffTree(self.old_tree, self.new_tree, StringIO())
+        self.differ = DiffTree(self.old_tree, self.new_tree, StringIO())
 
     def test_diff_text(self):
         self.build_tree_contents([('old-tree/olddir/',),
@@ -612,7 +615,7 @@
                                   ('new-tree/newdir/newfile', 'new\n')])
         self.new_tree.add('newdir')
         self.new_tree.add('newdir/newfile', 'file-id')
-        differ = diff.DiffText(self.old_tree, self.new_tree, StringIO())
+        differ = DiffText(self.old_tree, self.new_tree, StringIO())
         differ.diff_text('file-id', None, 'old label', 'new label')
         self.assertEqual(
             '--- old label\n+++ new label\n@@ -1,1 +0,0 @@\n-old\n\n',
@@ -647,17 +650,17 @@
         self.assertContainsRe(self.differ.to_file.getvalue(), '\+contents')
 
     def test_diff_symlink(self):
-        differ = diff.DiffSymlink(self.old_tree, self.new_tree, StringIO())
+        differ = DiffSymlink(self.old_tree, self.new_tree, StringIO())
         differ.diff_symlink('old target', None)
         self.assertEqual("=== target was 'old target'\n",
                          differ.to_file.getvalue())
 
-        differ = diff.DiffSymlink(self.old_tree, self.new_tree, StringIO())
+        differ = DiffSymlink(self.old_tree, self.new_tree, StringIO())
         differ.diff_symlink(None, 'new target')
         self.assertEqual("=== target is 'new target'\n",
                          differ.to_file.getvalue())
 
-        differ = diff.DiffSymlink(self.old_tree, self.new_tree, StringIO())
+        differ = DiffSymlink(self.old_tree, self.new_tree, StringIO())
         differ.diff_symlink('old target', 'new target')
         self.assertEqual("=== target changed 'old target' => 'new target'\n",
                          differ.to_file.getvalue())
@@ -713,13 +716,13 @@
 
     def test_register_diff(self):
         self.create_old_new()
-        old_diff_factories = diff.DiffTree.diff_factories
-        diff.DiffTree.diff_factories=old_diff_factories[:]
-        diff.DiffTree.diff_factories.insert(0, DiffWasIs.from_diff_tree)
+        old_diff_factories = DiffTree.diff_factories
+        DiffTree.diff_factories=old_diff_factories[:]
+        DiffTree.diff_factories.insert(0, DiffWasIs.from_diff_tree)
         try:
-            differ = diff.DiffTree(self.old_tree, self.new_tree, StringIO())
+            differ = DiffTree(self.old_tree, self.new_tree, StringIO())
         finally:
-            diff.DiffTree.diff_factories = old_diff_factories
+            DiffTree.diff_factories = old_diff_factories
         differ.diff('file-id', 'olddir/oldfile', 'newdir/newfile')
         self.assertNotContainsRe(
             differ.to_file.getvalue(),
@@ -730,8 +733,8 @@
 
     def test_extra_factories(self):
         self.create_old_new()
-        differ = diff.DiffTree(self.old_tree, self.new_tree, StringIO(),
-                               extra_factories=[DiffWasIs.from_diff_tree])
+        differ = DiffTree(self.old_tree, self.new_tree, StringIO(),
+                            extra_factories=[DiffWasIs.from_diff_tree])
         differ.diff('file-id', 'olddir/oldfile', 'newdir/newfile')
         self.assertNotContainsRe(
             differ.to_file.getvalue(),
@@ -750,14 +753,14 @@
             '.*a-file(.|\n)*b-file')
 
 
-class TestPatienceDiffLib(tests.TestCase):
+class TestPatienceDiffLib(TestCase):
 
     def setUp(self):
         super(TestPatienceDiffLib, self).setUp()
-        self._unique_lcs = _patiencediff_py.unique_lcs_py
-        self._recurse_matches = _patiencediff_py.recurse_matches_py
+        self._unique_lcs = bzrlib._patiencediff_py.unique_lcs_py
+        self._recurse_matches = bzrlib._patiencediff_py.recurse_matches_py
         self._PatienceSequenceMatcher = \
-            _patiencediff_py.PatienceSequenceMatcher_py
+            bzrlib._patiencediff_py.PatienceSequenceMatcher_py
 
     def test_diff_unicode_string(self):
         a = ''.join([unichr(i) for i in range(4000, 4500, 3)])
@@ -1070,7 +1073,7 @@
                  'how are you today?\n']
         txt_b = ['hello there\n',
                  'how are you today?\n']
-        unified_diff = patiencediff.unified_diff
+        unified_diff = bzrlib.patiencediff.unified_diff
         psm = self._PatienceSequenceMatcher
         self.assertEquals(['--- \n',
                            '+++ \n',
@@ -1124,7 +1127,7 @@
                  'how are you today?\n']
         txt_b = ['hello there\n',
                  'how are you today?\n']
-        unified_diff = patiencediff.unified_diff
+        unified_diff = bzrlib.patiencediff.unified_diff
         psm = self._PatienceSequenceMatcher
         self.assertEquals(['--- a\t2008-08-08\n',
                            '+++ b\t2008-09-09\n',
@@ -1146,11 +1149,11 @@
 
     def setUp(self):
         super(TestPatienceDiffLib_c, self).setUp()
-        from bzrlib import _patiencediff_c
-        self._unique_lcs = _patiencediff_c.unique_lcs_c
-        self._recurse_matches = _patiencediff_c.recurse_matches_c
+        import bzrlib._patiencediff_c
+        self._unique_lcs = bzrlib._patiencediff_c.unique_lcs_c
+        self._recurse_matches = bzrlib._patiencediff_c.recurse_matches_c
         self._PatienceSequenceMatcher = \
-            _patiencediff_c.PatienceSequenceMatcher_c
+            bzrlib._patiencediff_c.PatienceSequenceMatcher_c
 
     def test_unhashable(self):
         """We should get a proper exception here."""
@@ -1166,12 +1169,12 @@
                                          None, ['valid'], ['valid', []])
 
 
-class TestPatienceDiffLibFiles(tests.TestCaseInTempDir):
+class TestPatienceDiffLibFiles(TestCaseInTempDir):
 
     def setUp(self):
         super(TestPatienceDiffLibFiles, self).setUp()
         self._PatienceSequenceMatcher = \
-            _patiencediff_py.PatienceSequenceMatcher_py
+            bzrlib._patiencediff_py.PatienceSequenceMatcher_py
 
     def test_patience_unified_diff_files(self):
         txt_a = ['hello there\n',
@@ -1182,7 +1185,7 @@
         open('a1', 'wb').writelines(txt_a)
         open('b1', 'wb').writelines(txt_b)
 
-        unified_diff_files = patiencediff.unified_diff_files
+        unified_diff_files = bzrlib.patiencediff.unified_diff_files
         psm = self._PatienceSequenceMatcher
         self.assertEquals(['--- a1\n',
                            '+++ b1\n',
@@ -1242,86 +1245,75 @@
 
     def setUp(self):
         super(TestPatienceDiffLibFiles_c, self).setUp()
-        from bzrlib import _patiencediff_c
+        import bzrlib._patiencediff_c
         self._PatienceSequenceMatcher = \
-            _patiencediff_c.PatienceSequenceMatcher_c
-
-
-class TestUsingCompiledIfAvailable(tests.TestCase):
+            bzrlib._patiencediff_c.PatienceSequenceMatcher_c
+
+
+class TestUsingCompiledIfAvailable(TestCase):
 
     def test_PatienceSequenceMatcher(self):
         if compiled_patiencediff_feature.available():
             from bzrlib._patiencediff_c import PatienceSequenceMatcher_c
             self.assertIs(PatienceSequenceMatcher_c,
-                          patiencediff.PatienceSequenceMatcher)
+                          bzrlib.patiencediff.PatienceSequenceMatcher)
         else:
             from bzrlib._patiencediff_py import PatienceSequenceMatcher_py
             self.assertIs(PatienceSequenceMatcher_py,
-                          patiencediff.PatienceSequenceMatcher)
+                          bzrlib.patiencediff.PatienceSequenceMatcher)
 
     def test_unique_lcs(self):
         if compiled_patiencediff_feature.available():
             from bzrlib._patiencediff_c import unique_lcs_c
             self.assertIs(unique_lcs_c,
-                          patiencediff.unique_lcs)
+                          bzrlib.patiencediff.unique_lcs)
         else:
             from bzrlib._patiencediff_py import unique_lcs_py
             self.assertIs(unique_lcs_py,
-                          patiencediff.unique_lcs)
+                          bzrlib.patiencediff.unique_lcs)
 
     def test_recurse_matches(self):
         if compiled_patiencediff_feature.available():
             from bzrlib._patiencediff_c import recurse_matches_c
             self.assertIs(recurse_matches_c,
-                          patiencediff.recurse_matches)
+                          bzrlib.patiencediff.recurse_matches)
         else:
             from bzrlib._patiencediff_py import recurse_matches_py
             self.assertIs(recurse_matches_py,
-                          patiencediff.recurse_matches)
-
-
-class TestDiffFromTool(tests.TestCaseWithTransport):
+                          bzrlib.patiencediff.recurse_matches)
+
+
+class TestDiffFromTool(TestCaseWithTransport):
 
     def test_from_string(self):
-        diff_obj = diff.DiffFromTool.from_string('diff', None, None, None)
+        diff_obj = DiffFromTool.from_string('diff', None, None, None)
         self.addCleanup(diff_obj.finish)
         self.assertEqual(['diff', '@old_path', '@new_path'],
             diff_obj.command_template)
 
     def test_from_string_u5(self):
-        diff_obj = diff.DiffFromTool.from_string('diff "-u 5"',
-                                                 None, None, None)
+        diff_obj = DiffFromTool.from_string('diff -u\\ 5', None, None, None)
         self.addCleanup(diff_obj.finish)
         self.assertEqual(['diff', '-u 5', '@old_path', '@new_path'],
                          diff_obj.command_template)
         self.assertEqual(['diff', '-u 5', 'old-path', 'new-path'],
                          diff_obj._get_command('old-path', 'new-path'))
 
-    def test_from_string_path_with_backslashes(self):
-        self.requireFeature(test_win32utils.BackslashDirSeparatorFeature)
-        tool = 'C:\\Tools\\Diff.exe'
-        diff_obj = diff.DiffFromTool.from_string(tool, None, None, None)
-        self.addCleanup(diff_obj.finish)
-        self.assertEqual(['C:\\Tools\\Diff.exe', '@old_path', '@new_path'],
-                         diff_obj.command_template)
-        self.assertEqual(['C:\\Tools\\Diff.exe', 'old-path', 'new-path'],
-                         diff_obj._get_command('old-path', 'new-path'))
-
     def test_execute(self):
         output = StringIO()
-        diff_obj = diff.DiffFromTool(['python', '-c',
-                                      'print "@old_path @new_path"'],
-                                     None, None, output)
+        diff_obj = DiffFromTool(['python', '-c',
+                                 'print "@old_path @new_path"'],
+                                None, None, output)
         self.addCleanup(diff_obj.finish)
         diff_obj._execute('old', 'new')
         self.assertEqual(output.getvalue().rstrip(), 'old new')
 
     def test_excute_missing(self):
-        diff_obj = diff.DiffFromTool(['a-tool-which-is-unlikely-to-exist'],
-                                     None, None, None)
+        diff_obj = DiffFromTool(['a-tool-which-is-unlikely-to-exist'],
+                                None, None, None)
         self.addCleanup(diff_obj.finish)
-        e = self.assertRaises(errors.ExecutableMissing, diff_obj._execute,
-                              'old', 'new')
+        e = self.assertRaises(ExecutableMissing, diff_obj._execute, 'old',
+                              'new')
         self.assertEqual('a-tool-which-is-unlikely-to-exist could not be found'
                          ' on this machine', str(e))
 
@@ -1337,9 +1329,9 @@
         basis_tree = tree.basis_tree()
         basis_tree.lock_read()
         self.addCleanup(basis_tree.unlock)
-        diff_obj = diff.DiffFromTool(['python', '-c',
-                                      'print "@old_path @new_path"'],
-                                     basis_tree, tree, output)
+        diff_obj = DiffFromTool(['python', '-c',
+                                 'print "@old_path @new_path"'],
+                                basis_tree, tree, output)
         diff_obj._prepare_files('file-id', 'file', 'file')
         # The old content should be readonly
         self.assertReadableByAttrib(diff_obj._root, 'old\\file',
@@ -1362,8 +1354,7 @@
         self.build_tree_contents([('tree/oldname2', 'oldcontent2')])
         tree.add('oldname', 'file-id')
         tree.add('oldname2', 'file2-id')
-        # Earliest allowable date on FAT32 filesystems is 1980-01-01
-        tree.commit('old tree', timestamp=315532800)
+        tree.commit('old tree', timestamp=0)
         tree.rename_one('oldname', 'newname')
         tree.rename_one('oldname2', 'newname2')
         self.build_tree_contents([('tree/newname', 'newcontent')])
@@ -1373,15 +1364,15 @@
         self.addCleanup(old_tree.unlock)
         tree.lock_read()
         self.addCleanup(tree.unlock)
-        diff_obj = diff.DiffFromTool(['python', '-c',
-                                      'print "@old_path @new_path"'],
-                                     old_tree, tree, output)
+        diff_obj = DiffFromTool(['python', '-c',
+                                 'print "@old_path @new_path"'],
+                                old_tree, tree, output)
         self.addCleanup(diff_obj.finish)
         self.assertContainsRe(diff_obj._root, 'bzr-diff-[^/]*')
         old_path, new_path = diff_obj._prepare_files('file-id', 'oldname',
                                                      'newname')
         self.assertContainsRe(old_path, 'old/oldname$')
-        self.assertEqual(315532800, os.stat(old_path).st_mtime)
+        self.assertEqual(0, os.stat(old_path).st_mtime)
         self.assertContainsRe(new_path, 'tree/newname$')
         self.assertFileEqual('oldcontent', old_path)
         self.assertFileEqual('newcontent', new_path)
@@ -1391,25 +1382,18 @@
         diff_obj._prepare_files('file2-id', 'oldname2', 'newname2')
 
 
-class TestGetTreesAndBranchesToDiffLocked(tests.TestCaseWithTransport):
-
-    def call_gtabtd(self, path_list, revision_specs, old_url, new_url):
-        """Call get_trees_and_branches_to_diff_locked.  Overridden by
-        TestGetTreesAndBranchesToDiff.
-        """
-        return diff.get_trees_and_branches_to_diff_locked(
-            path_list, revision_specs, old_url, new_url, self.addCleanup)
+class TestGetTreesAndBranchesToDiff(TestCaseWithTransport):
 
     def test_basic(self):
         tree = self.make_branch_and_tree('tree')
         (old_tree, new_tree,
          old_branch, new_branch,
-         specific_files, extra_trees) = self.call_gtabtd(
-             ['tree'], None, None, None)
+         specific_files, extra_trees) = \
+            get_trees_and_branches_to_diff(['tree'], None, None, None)
 
-        self.assertIsInstance(old_tree, revisiontree.RevisionTree)
-        self.assertEqual(_mod_revision.NULL_REVISION,
-                         old_tree.get_revision_id())
+        self.assertIsInstance(old_tree, RevisionTree)
+        #print dir (old_tree)
+        self.assertEqual(_mod_revision.NULL_REVISION, old_tree.get_revision_id())
         self.assertEqual(tree.basedir, new_tree.basedir)
         self.assertEqual(tree.branch.base, old_branch.base)
         self.assertEqual(tree.branch.base, new_branch.base)
@@ -1424,30 +1408,18 @@
         self.build_tree_contents([('tree/file', 'newcontent')])
         tree.commit('new tree', timestamp=0, rev_id="new-id")
 
-        revisions = [revisionspec.RevisionSpec.from_string('1'),
-                     revisionspec.RevisionSpec.from_string('2')]
+        revisions = [RevisionSpec.from_string('1'),
+                     RevisionSpec.from_string('2')]
         (old_tree, new_tree,
          old_branch, new_branch,
-         specific_files, extra_trees) = self.call_gtabtd(
-            ['tree'], revisions, None, None)
+         specific_files, extra_trees) = \
+            get_trees_and_branches_to_diff(['tree'], revisions, None, None)
 
-        self.assertIsInstance(old_tree, revisiontree.RevisionTree)
+        self.assertIsInstance(old_tree, RevisionTree)
         self.assertEqual("old-id", old_tree.get_revision_id())
-        self.assertIsInstance(new_tree, revisiontree.RevisionTree)
+        self.assertIsInstance(new_tree, RevisionTree)
         self.assertEqual("new-id", new_tree.get_revision_id())
         self.assertEqual(tree.branch.base, old_branch.base)
         self.assertEqual(tree.branch.base, new_branch.base)
         self.assertIs(None, specific_files)
         self.assertEqual(tree.basedir, extra_trees[0].basedir)
-
-
-class TestGetTreesAndBranchesToDiff(TestGetTreesAndBranchesToDiffLocked):
-    """Apply the tests for get_trees_and_branches_to_diff_locked to the
-    deprecated get_trees_and_branches_to_diff function.
-    """
-
-    def call_gtabtd(self, path_list, revision_specs, old_url, new_url):
-        return self.applyDeprecated(
-            deprecated_in((2, 2, 0)), diff.get_trees_and_branches_to_diff,
-            path_list, revision_specs, old_url, new_url)
-

=== modified file 'bzrlib/tests/test_directory_service.py'
--- bzrlib/tests/test_directory_service.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_directory_service.py	2009-11-10 04:58:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,7 +54,7 @@
 
     def test_get_transport(self):
         directories.register('foo:', FooService, 'Map foo URLs to http urls')
-        self.addCleanup(directories.remove, 'foo:')
+        self.addCleanup(lambda: directories.remove('foo:'))
         self.assertEqual(FooService.base + 'bar/',
                          get_transport('foo:bar').base)
 

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/test_dirstate.py	2009-08-17 03:33:56 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -64,8 +64,14 @@
     def setUp(self):
         tests.TestCaseWithTransport.setUp(self)
 
-        self.overrideAttr(osutils,
-                          '_selected_dir_reader', self._dir_reader_class())
+        # Save platform specific info and reset it
+        cur_dir_reader = osutils._selected_dir_reader
+
+        def restore():
+            osutils._selected_dir_reader = cur_dir_reader
+        self.addCleanup(restore)
+
+        osutils._selected_dir_reader = self._dir_reader_class()
 
     def create_empty_dirstate(self):
         """Return a locked but empty dirstate"""
@@ -867,23 +873,15 @@
         state = dirstate.DirState.initialize('dirstate')
         try:
             # check precondition to be sure the state does change appropriately.
-            root_entry = (('', '', 'TREE_ROOT'), [('d', '', 0, False, 'x'*32)])
-            self.assertEqual([root_entry], list(state._iter_entries()))
-            self.assertEqual(root_entry, state._get_entry(0, path_utf8=''))
-            self.assertEqual(root_entry,
-                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
-            self.assertEqual((None, None),
-                             state._get_entry(0, fileid_utf8='second-root-id'))
-            state.set_path_id('', 'second-root-id')
-            new_root_entry = (('', '', 'second-root-id'),
-                              [('d', '', 0, False, 'x'*32)])
-            expected_rows = [new_root_entry]
+            self.assertEqual(
+                [(('', '', 'TREE_ROOT'), [('d', '', 0, False,
+                   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx')])],
+                list(state._iter_entries()))
+            state.set_path_id('', 'foobarbaz')
+            expected_rows = [
+                (('', '', 'foobarbaz'), [('d', '', 0, False,
+                   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx')])]
             self.assertEqual(expected_rows, list(state._iter_entries()))
-            self.assertEqual(new_root_entry, state._get_entry(0, path_utf8=''))
-            self.assertEqual(new_root_entry, 
-                             state._get_entry(0, fileid_utf8='second-root-id'))
-            self.assertEqual((None, None),
-                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
             # should work across save too
             state.save()
         finally:
@@ -907,36 +905,21 @@
         state._validate()
         try:
             state.set_parent_trees([('parent-revid', rt)], ghosts=[])
-            root_entry = (('', '', 'TREE_ROOT'),
-                          [('d', '', 0, False, 'x'*32),
-                           ('d', '', 0, False, 'parent-revid')])
-            self.assertEqual(root_entry, state._get_entry(0, path_utf8=''))
-            self.assertEqual(root_entry,
-                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
-            self.assertEqual((None, None),
-                             state._get_entry(0, fileid_utf8='Asecond-root-id'))
-            state.set_path_id('', 'Asecond-root-id')
+            state.set_path_id('', 'foobarbaz')
             state._validate()
             # now see that it is what we expected
-            old_root_entry = (('', '', 'TREE_ROOT'),
-                              [('a', '', 0, False, ''),
-                               ('d', '', 0, False, 'parent-revid')])
-            new_root_entry = (('', '', 'Asecond-root-id'),
-                              [('d', '', 0, False, ''),
-                               ('a', '', 0, False, '')])
-            expected_rows = [new_root_entry, old_root_entry]
+            expected_rows = [
+                (('', '', 'TREE_ROOT'),
+                    [('a', '', 0, False, ''),
+                     ('d', '', 0, False, 'parent-revid'),
+                     ]),
+                (('', '', 'foobarbaz'),
+                    [('d', '', 0, False, ''),
+                     ('a', '', 0, False, ''),
+                     ]),
+                ]
             state._validate()
             self.assertEqual(expected_rows, list(state._iter_entries()))
-            self.assertEqual(new_root_entry, state._get_entry(0, path_utf8=''))
-            self.assertEqual(old_root_entry, state._get_entry(1, path_utf8=''))
-            self.assertEqual((None, None),
-                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
-            self.assertEqual(old_root_entry,
-                             state._get_entry(1, fileid_utf8='TREE_ROOT'))
-            self.assertEqual(new_root_entry,
-                             state._get_entry(0, fileid_utf8='Asecond-root-id'))
-            self.assertEqual((None, None),
-                             state._get_entry(1, fileid_utf8='Asecond-root-id'))
             # should work across save too
             state.save()
         finally:

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2010-04-22 18:36:13 +0000
+++ bzrlib/tests/test_errors.py	2009-08-21 02:37:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -542,7 +542,7 @@
             1/0
         except ZeroDivisionError:
             exc_info = sys.exc_info()
-        err = errors.HookFailed('hook stage', 'hook name', exc_info, warn=False)
+        err = errors.HookFailed('hook stage', 'hook name', exc_info)
         self.assertStartsWith(
             str(err), 'Hook \'hook name\' during hook stage failed:\n')
         self.assertEndsWith(
@@ -623,38 +623,6 @@
         self.assertEqual(
             'Repository dummy repo cannot suspend a write group.', str(err))
 
-    def test_not_branch_no_args(self):
-        err = errors.NotBranchError('path')
-        self.assertEqual('Not a branch: "path".', str(err))
-
-    def test_not_branch_bzrdir_with_repo(self):
-        bzrdir = self.make_repository('repo').bzrdir
-        err = errors.NotBranchError('path', bzrdir=bzrdir)
-        self.assertEqual(
-            'Not a branch: "path": location is a repository.', str(err))
-
-    def test_not_branch_bzrdir_without_repo(self):
-        bzrdir = self.make_bzrdir('bzrdir')
-        err = errors.NotBranchError('path', bzrdir=bzrdir)
-        self.assertEqual('Not a branch: "path".', str(err))
-
-    def test_not_branch_laziness(self):
-        real_bzrdir = self.make_bzrdir('path')
-        class FakeBzrDir(object):
-            def __init__(self):
-                self.calls = []
-            def open_repository(self):
-                self.calls.append('open_repository')
-                raise errors.NoRepositoryPresent(real_bzrdir)
-        fake_bzrdir = FakeBzrDir()
-        err = errors.NotBranchError('path', bzrdir=fake_bzrdir)
-        self.assertEqual([], fake_bzrdir.calls)
-        str(err)
-        self.assertEqual(['open_repository'], fake_bzrdir.calls)
-        # Stringifying twice doesn't try to open a repository twice.
-        str(err)
-        self.assertEqual(['open_repository'], fake_bzrdir.calls)
-
 
 class PassThroughError(errors.BzrError):
 
@@ -670,7 +638,7 @@
 
 
 class ErrorWithNoFormat(errors.BzrError):
-    __doc__ = """This class has a docstring but no format string."""
+    """This class has a docstring but no format string."""
 
 
 class TestErrorFormatting(TestCase):
@@ -708,8 +676,3 @@
             socket.error(13, 'Permission denied'))
         self.assertContainsRe(str(e),
             r'Cannot bind address "example\.com:22":.*Permission denied')
-
-    def test_file_timestamp_unavailable(self):            
-        e = errors.FileTimestampUnavailable("/path/foo")
-        self.assertEquals("The filestamp for /path/foo is not available.",
-            str(e))

=== modified file 'bzrlib/tests/test_export.py'
--- bzrlib/tests/test_export.py	2010-04-14 00:11:32 +0000
+++ bzrlib/tests/test_export.py	2009-07-29 13:46:55 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,11 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import os
-import time
+
 
 from bzrlib import (
     errors,
     export,
+    osutils,
     tests,
     )
 
@@ -61,63 +62,3 @@
         wt.commit('1')
         self.build_tree(['target/', 'target/foo'])
         self.assertRaises(errors.BzrError, export.export, wt, 'target', format="dir")
-
-    def test_dir_export_existing_single_file(self):
-        self.build_tree(['dir1/', 'dir1/dir2/', 'dir1/first', 'dir1/dir2/second'])
-        wtree = self.make_branch_and_tree('dir1')
-        wtree.add(['dir2', 'first', 'dir2/second'])
-        wtree.commit('1')
-        export.export(wtree, 'target1', format='dir', subdir='first')
-        self.failUnlessExists('target1/first')
-        export.export(wtree, 'target2', format='dir', subdir='dir2/second')
-        self.failUnlessExists('target2/second')
-        
-    def test_dir_export_files_same_timestamp(self):
-        builder = self.make_branch_builder('source')
-        builder.start_series()
-        builder.build_snapshot(None, None, [
-            ('add', ('', 'root-id', 'directory', '')),
-            ('add', ('a', 'a-id', 'file', 'content\n'))])
-        builder.build_snapshot(None, None, [
-            ('add', ('b', 'b-id', 'file', 'content\n'))])
-        builder.finish_series()
-        b = builder.get_branch()
-        b.lock_read()
-        self.addCleanup(b.unlock)
-        tree = b.basis_tree()
-        orig_iter_files_bytes = tree.iter_files_bytes
-        # Make iter_files_bytes slower, so we provoke mtime skew
-        def iter_files_bytes(to_fetch):
-            for thing in orig_iter_files_bytes(to_fetch):
-                yield thing
-                time.sleep(1)
-        tree.iter_files_bytes = iter_files_bytes
-        export.export(tree, 'target', format='dir')
-        t = self.get_transport('target')
-        st_a = t.stat('a')
-        st_b = t.stat('b')
-        # All files must be given the same mtime.
-        self.assertEqual(st_a.st_mtime, st_b.st_mtime)
-
-    def test_dir_export_files_per_file_timestamps(self):
-        builder = self.make_branch_builder('source')
-        builder.start_series()
-        # Earliest allowable date on FAT32 filesystems is 1980-01-01
-        a_time = time.mktime((1999, 12, 12, 0, 0, 0, 0, 0, 0))
-        b_time = time.mktime((1980, 01, 01, 0, 0, 0, 0, 0, 0))
-        builder.build_snapshot(None, None, [
-            ('add', ('', 'root-id', 'directory', '')),
-            ('add', ('a', 'a-id', 'file', 'content\n'))],
-            timestamp=a_time)
-        builder.build_snapshot(None, None, [
-            ('add', ('b', 'b-id', 'file', 'content\n'))],
-            timestamp=b_time)
-        builder.finish_series()
-        b = builder.get_branch()
-        b.lock_read()
-        self.addCleanup(b.unlock)
-        tree = b.basis_tree()
-        export.export(tree, 'target', format='dir', per_file_timestamps=True)
-        t = self.get_transport('target')
-        self.assertEqual(a_time, t.stat('a').st_mtime)
-        self.assertEqual(b_time, t.stat('b').st_mtime)

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2010-02-09 20:18:32 +0000
+++ bzrlib/tests/test_fetch.py	2009-07-10 06:46:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007, 2010 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,6 +31,7 @@
 from bzrlib.bzrdir import BzrDir
 from bzrlib.repofmt import knitrepo
 from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests.http_utils import TestCaseWithWebserver
 from bzrlib.tests.test_revision import make_branches
 from bzrlib.trace import mutter
 from bzrlib.upgrade import Convert
@@ -247,6 +248,88 @@
                     rev_id).get_file_text('this-file-id'), text)
 
 
+class TestHttpFetch(TestCaseWithWebserver):
+    # FIXME RBC 20060124 this really isn't web specific, perhaps an
+    # instrumented readonly transport? Can we do an instrumented
+    # adapter and use self.get_readonly_url ?
+
+    def test_fetch(self):
+        #highest indices a: 5, b: 7
+        br_a, br_b = make_branches(self)
+        br_rem_a = Branch.open(self.get_readonly_url('branch1'))
+        fetch_steps(self, br_rem_a, br_b, br_a)
+
+    def _count_log_matches(self, target, logs):
+        """Count the number of times the target file pattern was fetched in an http log"""
+        get_succeeds_re = re.compile(
+            '.*"GET .*%s HTTP/1.1" 20[06] - "-" "bzr/%s' %
+            (     target,                    bzrlib.__version__))
+        c = 0
+        for line in logs:
+            if get_succeeds_re.match(line):
+                c += 1
+        return c
+
+    def test_weaves_are_retrieved_once(self):
+        self.build_tree(("source/", "source/file", "target/"))
+        # This test depends on knit dasta storage.
+        wt = self.make_branch_and_tree('source', format='dirstate-tags')
+        branch = wt.branch
+        wt.add(["file"], ["id"])
+        wt.commit("added file")
+        open("source/file", 'w').write("blah\n")
+        wt.commit("changed file")
+        target = BzrDir.create_branch_and_repo("target/")
+        source = Branch.open(self.get_readonly_url("source/"))
+        target.fetch(source)
+        # this is the path to the literal file. As format changes
+        # occur it needs to be updated. FIXME: ask the store for the
+        # path.
+        self.log("web server logs are:")
+        http_logs = self.get_readonly_server().logs
+        self.log('\n'.join(http_logs))
+        # unfortunately this log entry is branch format specific. We could
+        # factor out the 'what files does this format use' to a method on the
+        # repository, which would let us to this generically. RBC 20060419
+        # RBC 20080408: Or perhaps we can assert that no files are fully read
+        # twice?
+        self.assertEqual(1, self._count_log_matches('/ce/id.kndx', http_logs))
+        self.assertEqual(1, self._count_log_matches('/ce/id.knit', http_logs))
+        self.assertEqual(1, self._count_log_matches('inventory.kndx', http_logs))
+        # this r-h check test will prevent regressions, but it currently already
+        # passes, before the patch to cache-rh is applied :[
+        self.assertTrue(1 >= self._count_log_matches('revision-history',
+                                                     http_logs))
+        self.assertTrue(1 >= self._count_log_matches('last-revision',
+                                                     http_logs))
+        # FIXME naughty poking in there.
+        self.get_readonly_server().logs = []
+        # check there is nothing more to fetch.  We take care to re-use the
+        # existing transport so that the request logs we're about to examine
+        # aren't cluttered with redundant probes for a smart server.
+        # XXX: Perhaps this further parameterisation: test http with smart
+        # server, and test http without smart server?
+        source = Branch.open(
+            self.get_readonly_url("source/"),
+            possible_transports=[source.bzrdir.root_transport])
+        target.fetch(source)
+        # should make just two requests
+        http_logs = self.get_readonly_server().logs
+        self.log("web server logs are:")
+        self.log('\n'.join(http_logs))
+        self.assertEqual(1, self._count_log_matches('branch-format', http_logs))
+        self.assertEqual(1, self._count_log_matches('branch/format', http_logs))
+        self.assertEqual(1, self._count_log_matches('repository/format',
+            http_logs))
+        self.assertEqual(1, self._count_log_matches('revisions.kndx',
+            http_logs))
+        self.assertTrue(1 >= self._count_log_matches('revision-history',
+                                                     http_logs))
+        self.assertTrue(1 >= self._count_log_matches('last-revision',
+                                                     http_logs))
+        self.assertLength(5, http_logs)
+
+
 class TestKnitToPackFetch(TestCaseWithTransport):
 
     def find_get_record_stream(self, calls, expected_count=1):
@@ -321,7 +404,11 @@
         source.inventories = versionedfile.RecordingVersionedFilesDecorator(
                         source.inventories)
         # XXX: This won't work in general, but for the dirstate format it does.
-        self.overrideAttr(target._format, '_fetch_uses_deltas', False)
+        old_fetch_uses_deltas_setting = target._format._fetch_uses_deltas
+        def restore():
+            target._format._fetch_uses_deltas = old_fetch_uses_deltas_setting
+        self.addCleanup(restore)
+        target._format._fetch_uses_deltas = False
         target.fetch(source, revision_id='rev-one')
         self.assertEqual(('get_record_stream', [('file-id', 'rev-one')],
                           target._format._fetch_order, True),

=== modified file 'bzrlib/tests/test_foreign.py'
--- bzrlib/tests/test_foreign.py	2010-04-23 00:44:15 +0000
+++ bzrlib/tests/test_foreign.py	2009-12-25 13:47:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -90,7 +90,6 @@
         self._format = _format
         self._base = a_bzrdir.transport.base
         self._ignore_fallbacks = False
-        self.bzrdir = a_bzrdir
         foreign.ForeignBranch.__init__(self, 
             DummyForeignVcsMapping(DummyForeignVcs()))
         branch.BzrBranch6.__init__(self, _format, _control_files, a_bzrdir, 
@@ -172,11 +171,11 @@
         super(DummyForeignVcsBranchFormat, self).__init__()
         self._matchingbzrdir = DummyForeignVcsDirFormat()
 
-    def open(self, a_bzrdir, name=None, _found=False):
+    def open(self, a_bzrdir, _found=False):
         if not _found:
             raise NotImplementedError
         try:
-            transport = a_bzrdir.get_branch_transport(None, name=name)
+            transport = a_bzrdir.get_branch_transport(None)
             control_files = lockable_files.LockableFiles(transport, 'lock',
                                                          lockdir.LockDir)
             return DummyForeignVcsBranch(_format=self,
@@ -244,9 +243,7 @@
         self._control_files = lockable_files.LockableFiles(self.transport,
             "lock", lockable_files.TransportLock)
 
-    def open_branch(self, name=None, unsupported=False, ignore_fallbacks=True):
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
+    def open_branch(self, ignore_fallbacks=True):
         return self._format.get_branch_format().open(self, _found=True)
 
     def cloning_metadir(self, stacked=False):

=== modified file 'bzrlib/tests/test_ftp_transport.py'
--- bzrlib/tests/test_ftp_transport.py	2010-02-27 01:34:49 +0000
+++ bzrlib/tests/test_ftp_transport.py	2009-07-22 07:48:27 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,20 +15,16 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from cStringIO import StringIO
-import ftplib
 import getpass
 import sys
 
 from bzrlib import (
     config,
-    errors,
     tests,
     transport,
     ui,
     )
 
-from bzrlib.transport import ftp
-
 from bzrlib.tests import ftp_server
 
 
@@ -134,17 +130,3 @@
         # stdin should be empty (the provided password have been consumed),
         # even if the password is empty, it's followed by a newline.
         ui.ui_factory.assert_all_input_consumed()
-
-
-class TestFTPErrorTranslation(tests.TestCase):
-
-    def test_translate_directory_not_empty(self):
-        # https://bugs.launchpad.net/bugs/528722
-        
-        t = ftp.FtpTransport("ftp://none/")
-
-        try:
-            raise ftplib.error_temp("Rename/move failure: Directory not empty")
-        except Exception, e:
-            e = self.assertRaises(errors.DirectoryNotEmpty,
-                t._translate_ftp_error, e, "/path")

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_globbing.py	2009-11-11 21:38:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -17,7 +17,6 @@
 
 from bzrlib.globbing import (
     Globster,
-    ExceptionGlobster,
     _OrderedGlobster,
     normalize_pattern
     )
@@ -308,30 +307,6 @@
             self.assertEqual(patterns[x],globster.match(filename))
         self.assertEqual(None,globster.match('foobar.300'))
 
-class TestExceptionGlobster(TestCase):
-
-    def test_exclusion_patterns(self):
-        """test that exception patterns are not matched"""
-        patterns = [ u'*', u'!./local', u'!./local/**/*', u'!RE:\.z.*',u'!!./.zcompdump' ]
-        globster = ExceptionGlobster(patterns)
-        self.assertEqual(u'*', globster.match('tmp/foo.txt'))
-        self.assertEqual(None, globster.match('local'))
-        self.assertEqual(None, globster.match('local/bin/wombat'))
-        self.assertEqual(None, globster.match('.zshrc'))
-        self.assertEqual(None, globster.match('.zfunctions/fiddle/flam'))
-        self.assertEqual(u'!!./.zcompdump', globster.match('.zcompdump'))
-
-    def test_exclusion_order(self):
-        """test that ordering of exclusion patterns does not matter"""
-        patterns = [ u'static/**/*.html', u'!static/**/versionable.html']
-        globster = ExceptionGlobster(patterns)
-        self.assertEqual(u'static/**/*.html', globster.match('static/foo.html'))
-        self.assertEqual(None, globster.match('static/versionable.html'))
-        self.assertEqual(None, globster.match('static/bar/versionable.html'))
-        globster = ExceptionGlobster(reversed(patterns))
-        self.assertEqual(u'static/**/*.html', globster.match('static/foo.html'))
-        self.assertEqual(None, globster.match('static/versionable.html'))
-        self.assertEqual(None, globster.match('static/bar/versionable.html'))
 
 class TestOrderedGlobster(TestCase):
 

=== modified file 'bzrlib/tests/test_graph.py'
--- bzrlib/tests/test_graph.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_graph.py	2009-11-30 03:16:22 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_groupcompress.py'
--- bzrlib/tests/test_groupcompress.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_groupcompress.py	2009-12-22 16:40:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_help.py'
--- bzrlib/tests/test_help.py	2010-04-23 08:51:52 +0000
+++ bzrlib/tests/test_help.py	2009-06-15 10:22:08 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -41,7 +41,7 @@
 
     def test_command_help_includes_see_also(self):
         class cmd_WithSeeAlso(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
             _see_also = ['foo', 'bar']
         cmd = cmd_WithSeeAlso()
         helptext = cmd.get_help_text()
@@ -56,7 +56,7 @@
     def test_get_help_text(self):
         """Commands have a get_help_text method which returns their help."""
         class cmd_Demo(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
         cmd = cmd_Demo()
         helptext = cmd.get_help_text()
         self.assertStartsWith(helptext,
@@ -67,7 +67,7 @@
 
     def test_command_with_additional_see_also(self):
         class cmd_WithSeeAlso(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
             _see_also = ['foo', 'bar']
         cmd = cmd_WithSeeAlso()
         helptext = cmd.get_help_text(['gam'])
@@ -81,7 +81,7 @@
 
     def test_command_only_additional_see_also(self):
         class cmd_WithSeeAlso(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
         cmd = cmd_WithSeeAlso()
         helptext = cmd.get_help_text(['gam'])
         self.assertEndsWith(
@@ -95,14 +95,14 @@
     def test_get_help_topic(self):
         """The help topic for a Command is its name()."""
         class cmd_foo_bar(commands.Command):
-            __doc__ = """A sample command."""
+            """A sample command."""
         cmd = cmd_foo_bar()
         self.assertEqual(cmd.name(), cmd.get_help_topic())
 
     def test_formatted_help_text(self):
         """Help text should be plain text by default."""
         class cmd_Demo(commands.Command):
-            __doc__ = """A sample command.
+            """A sample command.
 
             :Examples:
                 Example 1::
@@ -159,7 +159,7 @@
     def test_concise_help_text(self):
         """Concise help text excludes the descriptive sections."""
         class cmd_Demo(commands.Command):
-            __doc__ = """A sample command.
+            """A sample command.
  
             Blah blah blah.
 
@@ -206,7 +206,7 @@
     def test_help_custom_section_ordering(self):
         """Custom descriptive sections should remain in the order given."""
         class cmd_Demo(commands.Command):
-            __doc__ = """A sample command.
+            """A sample command.
  
             Blah blah blah.
 
@@ -252,7 +252,7 @@
     def test_help_text_custom_usage(self):
         """Help text may contain a custom usage section."""
         class cmd_Demo(commands.Command):
-            __doc__ = """A sample command.
+            """A sample command.
 
             :Usage:
                 cmd Demo [opts] args

=== modified file 'bzrlib/tests/test_hooks.py'
--- bzrlib/tests/test_hooks.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_hooks.py	2009-11-03 09:32:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2010-03-18 23:11:15 +0000
+++ bzrlib/tests/test_http.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -391,10 +391,10 @@
         self.assertEqual('http://example.com', url)
         self.assertEqual(0, len(f.credentials))
         url = http.extract_auth(
-            'http://user:pass@example.com/bzr/bzr.dev', f)
-        self.assertEqual('http://example.com/bzr/bzr.dev', url)
+            'http://user:pass@www.bazaar-vcs.org/bzr/bzr.dev', f)
+        self.assertEqual('http://www.bazaar-vcs.org/bzr/bzr.dev', url)
         self.assertEqual(1, len(f.credentials))
-        self.assertEqual([None, 'example.com', 'user', 'pass'],
+        self.assertEqual([None, 'www.bazaar-vcs.org', 'user', 'pass'],
                          f.credentials[0])
 
 
@@ -452,22 +452,26 @@
         # Import the module locally now that we now it's available.
         pycurl = features.pycurl.module
 
-        self.overrideAttr(pycurl, 'version_info',
-                          # Fake the pycurl version_info This was taken from
-                          # a windows pycurl without SSL (thanks to bialix)
-                          lambda : (2,
-                                    '7.13.2',
-                                    462082,
-                                    'i386-pc-win32',
-                                    2576,
-                                    None,
-                                    0,
-                                    None,
-                                    ('ftp', 'gopher', 'telnet',
-                                     'dict', 'ldap', 'http', 'file'),
-                                    None,
-                                    0,
-                                    None))
+        version_info_orig = pycurl.version_info
+        def restore():
+            pycurl.version_info = version_info_orig
+        self.addCleanup(restore)
+
+        # Fake the pycurl version_info This was taken from a windows pycurl
+        # without SSL (thanks to bialix)
+        pycurl.version_info = lambda : (2,
+                                        '7.13.2',
+                                        462082,
+                                        'i386-pc-win32',
+                                        2576,
+                                        None,
+                                        0,
+                                        None,
+                                        ('ftp', 'gopher', 'telnet',
+                                         'dict', 'ldap', 'http', 'file'),
+                                        None,
+                                        0,
+                                        None)
         self.assertRaises(errors.DependencyNotPresent, self._transport,
                           'https://launchpad.net')
 
@@ -1360,7 +1364,11 @@
 
 
 def install_redirected_request(test):
-    test.overrideAttr(_urllib2_wrappers, 'Request', RedirectedRequest)
+    test.original_class = _urllib2_wrappers.Request
+    def restore():
+        _urllib2_wrappers.Request = test.original_class
+    _urllib2_wrappers.Request = RedirectedRequest
+    test.addCleanup(restore)
 
 
 class TestHTTPSilentRedirections(http_utils.TestCaseWithRedirectedWebserver):

=== modified file 'bzrlib/tests/test_http_response.py'
--- bzrlib/tests/test_http_response.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_http_response.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_ignores.py'
--- bzrlib/tests/test_ignores.py	2009-12-26 21:31:56 +0000
+++ bzrlib/tests/test_ignores.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -34,8 +34,6 @@
                 '\n' # empty line
                 '#comment\n'
                 ' xx \n' # whitespace
-                '!RE:^\.z.*\n'
-                '!!./.zcompdump\n'
                 ))
         self.assertEqual(set(['./rootdir',
                           'randomfile*',
@@ -43,25 +41,11 @@
                           u'unicode\xb5',
                           'dos',
                           ' xx ',
-                          '!RE:^\.z.*',
-                          '!!./.zcompdump',
                          ]), ignored)
 
     def test_parse_empty(self):
         ignored = ignores.parse_ignore_file(StringIO(''))
         self.assertEqual(set([]), ignored)
-        
-    def test_parse_non_utf8(self):
-        """Lines with non utf 8 characters should be discarded."""
-        ignored = ignores.parse_ignore_file(StringIO(
-                'utf8filename_a\n'
-                'invalid utf8\x80\n'
-                'utf8filename_b\n'
-                ))
-        self.assertEqual(set([
-                        'utf8filename_a',
-                        'utf8filename_b',
-                       ]), ignored)
 
 
 class TestUserIgnores(TestCaseInTempDir):
@@ -144,9 +128,13 @@
     def setUp(self):
         TestCase.setUp(self)
 
+        orig = ignores._runtime_ignores
+        def restore():
+            ignores._runtime_ignores = orig
+        self.addCleanup(restore)
         # For the purposes of these tests, we must have no
         # runtime ignores
-        self.overrideAttr(ignores, '_runtime_ignores', set())
+        ignores._runtime_ignores = set()
 
     def test_add(self):
         """Test that we can add an entry to the list."""

=== removed file 'bzrlib/tests/test_import_tariff.py'
--- bzrlib/tests/test_import_tariff.py	2010-04-01 04:38:26 +0000
+++ bzrlib/tests/test_import_tariff.py	1970-01-01 00:00:00 +0000
@@ -1,105 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-
-"""Tests for how many modules are loaded in executing various commands."""
-
-from testtools import content
-
-from bzrlib.plugin import (
-    are_plugins_disabled,
-    )
-
-from bzrlib.tests import (
-    TestCaseWithTransport,
-    )
-
-
-class TestImportTariffs(TestCaseWithTransport):
-
-    """Check how many modules are loaded for some representative scenarios.
-
-    See the Testing Guide in the developer documentation for more explanation.
-    """
-
-    def run_command_check_imports(self, args, forbidden_imports):
-        """Run bzr ARGS in a subprocess and check its imports.
-
-        This is fairly expensive because we start a subprocess, so we aim to
-        cover representative rather than exhaustive cases.
-
-        :param forbidden_imports: List of fully-qualified Python module names
-            that should not be loaded while running this command.
-        """
-        # We use PYTHON_VERBOSE rather than --profile-importts because in
-        # experimentation the profile-imports output seems to not always show
-        # the modules you'd expect; this can be debugged but python -v seems
-        # more likely to always show everything.  And we use the environment
-        # variable rather than 'python -v' in the hope it will work even if
-        # bzr is frozen and python is not explicitly specified. -- mbp 20100208
-        #
-        # Normally we want test isolation from the real $HOME but here we
-        # explicitly do want to test against things installed there, therefore
-        # we pass it through.
-        env_changes = dict(PYTHONVERBOSE='1')
-        for name in ['BZR_HOME', 'BZR_PLUGIN_PATH', 'HOME',]:
-            env_changes[name] = self._old_env.get(name)
-        out, err = self.run_bzr_subprocess(args,
-            allow_plugins=(not are_plugins_disabled()),
-            env_changes=env_changes)
-
-        self.addDetail('subprocess_stderr', 
-            content.Content(content.ContentType("text", "plain"),
-                lambda:[err]))
-
-        bad_modules = []
-        for module_name in forbidden_imports:
-            if err.find("\nimport %s " % module_name) != -1:
-                bad_modules.append(module_name)
-
-        if bad_modules:
-            self.fail("command %r loaded forbidden modules %r" 
-                % (args, bad_modules))
-        return out, err
-
-    def test_import_tariffs_working(self):
-        # check some guaranteed-true and false imports to be sure we're
-        # measuring correctly
-        self.make_branch_and_tree('.')
-        self.run_command_check_imports(['st'],
-            ['nonexistentmodulename', 'anothernonexistentmodule'])
-        self.assertRaises(AssertionError,
-            self.run_command_check_imports,
-            ['st'],
-            ['bzrlib.tree'])
-
-    def test_simple_local(self):
-        # 'st' in a working tree shouldn't need many modules
-        self.make_branch_and_tree('.')
-        self.run_command_check_imports(['st'], [
-            'bzrlib.bundle.commands',
-            'bzrlib.cmd_version_info',
-            'bzrlib.foreign',
-            'bzrlib.remote',
-            'bzrlib.sign_my_commits',
-            'bzrlib.smart',
-            'smtplib',
-            'tarfile',
-            ])
-        # TODO: similar test for repository-only operations, checking we avoid
-        # loading wt-specific stuff
-        #
-        # See https://bugs.edge.launchpad.net/bzr/+bug/553017

=== modified file 'bzrlib/tests/test_index.py'
--- bzrlib/tests/test_index.py	2010-04-08 07:01:10 +0000
+++ bzrlib/tests/test_index.py	2009-11-07 01:58:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -388,17 +388,6 @@
         size = trans.put_file('index', stream)
         return GraphIndex(trans, 'index', size)
 
-    def make_index_with_offset(self, ref_lists=0, key_elements=1, nodes=[],
-                               offset=0):
-        builder = GraphIndexBuilder(ref_lists, key_elements=key_elements)
-        for key, value, references in nodes:
-            builder.add_node(key, value, references)
-        content = builder.finish().read()
-        size = len(content)
-        trans = self.get_transport()
-        trans.put_bytes('index', (' '*offset) + content)
-        return GraphIndex(trans, 'index', size, offset=offset)
-
     def test_clear_cache(self):
         index = self.make_index()
         # For now, we just want to make sure the api is available. As this is
@@ -410,26 +399,6 @@
         trans.put_bytes('name', "not an index\n")
         index = GraphIndex(trans, 'name', 13)
 
-    def test_with_offset(self):
-        nodes = self.make_nodes(200)
-        index = self.make_index_with_offset(offset=1234567, nodes=nodes)
-        self.assertEqual(200, index.key_count())
-
-    def test_buffer_all_with_offset(self):
-        nodes = self.make_nodes(200)
-        index = self.make_index_with_offset(offset=1234567, nodes=nodes)
-        index._buffer_all()
-        self.assertEqual(200, index.key_count())
-
-    def test_side_effect_buffering_with_offset(self):
-        nodes = self.make_nodes(20)
-        index = self.make_index_with_offset(offset=1234567, nodes=nodes)
-        index._transport.recommended_page_size = lambda:64*1024
-        subset_nodes = [nodes[0][0], nodes[10][0], nodes[19][0]]
-        entries = [n[1] for n in index.iter_entries(subset_nodes)]
-        self.assertEqual(sorted(subset_nodes), sorted(entries))
-        self.assertEqual(20, index.key_count())
-
     def test_open_sets_parsed_map_empty(self):
         index = self.make_index()
         self.assertEqual([], index._parsed_byte_map)
@@ -1380,50 +1349,6 @@
         self.assertListRaises(errors.NoSuchFile, index.iter_entries_prefix,
                                                  [('1',)])
 
-
-    def make_index_with_simple_nodes(self, name, num_nodes=1):
-        """Make an index named after 'name', with keys named after 'name' too.
-
-        Nodes will have a value of '' and no references.
-        """
-        nodes = [
-            (('index-%s-key-%s' % (name, n),), '', ())
-            for n in range(1, num_nodes+1)]
-        return self.make_index('index-%s' % name, 0, nodes=nodes)
-
-    def test_reorder_after_iter_entries(self):
-        # Four indices: [key1] in index1, [key2,key3] in index2, [] in index3,
-        # [key4] in index4.
-        index = CombinedGraphIndex([])
-        index.insert_index(0, self.make_index_with_simple_nodes('1'), '1')
-        index.insert_index(1, self.make_index_with_simple_nodes('2'), '2')
-        index.insert_index(2, self.make_index_with_simple_nodes('3'), '3')
-        index.insert_index(3, self.make_index_with_simple_nodes('4'), '4')
-        index1, index2, index3, index4 = index._indices
-        # Query a key from index4 and index2.
-        self.assertLength(2, list(index.iter_entries(
-            [('index-4-key-1',), ('index-2-key-1',)])))
-        # Now index2 and index4 should be moved to the front (and index1 should
-        # still be before index3).
-        self.assertEqual([index2, index4, index1, index3], index._indices)
-        self.assertEqual(['2', '4', '1', '3'], index._index_names)
-
-    def test_reorder_propagates_to_siblings(self):
-        # Two CombinedGraphIndex objects, with the same number of indicies with
-        # matching names.
-        cgi1 = CombinedGraphIndex([])
-        cgi2 = CombinedGraphIndex([])
-        cgi1.insert_index(0, self.make_index_with_simple_nodes('1-1'), 'one')
-        cgi1.insert_index(1, self.make_index_with_simple_nodes('1-2'), 'two')
-        cgi2.insert_index(0, self.make_index_with_simple_nodes('2-1'), 'one')
-        cgi2.insert_index(1, self.make_index_with_simple_nodes('2-2'), 'two')
-        index2_1, index2_2 = cgi2._indices
-        cgi1.set_sibling_indices([cgi2])
-        # Trigger a reordering in cgi1.  cgi2 will be reordered as well.
-        list(cgi1.iter_entries([('index-1-2-key-1',)]))
-        self.assertEqual([index2_2, index2_1], cgi2._indices)
-        self.assertEqual(['two', 'one'], cgi2._index_names)
-
     def test_validate_reloads(self):
         index, reload_counter = self.make_combined_index_with_missing()
         index.validate()

=== modified file 'bzrlib/tests/test_info.py'
--- bzrlib/tests/test_info.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_info.py	2009-04-08 16:33:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -143,11 +143,15 @@
                 # We don't require that experimental formats support checkouts
                 # or describe correctly in the UI.
                 continue
-            if bzrdir.format_registry.get_info(key).hidden:
-                continue
             expected = None
-            if key in ('pack-0.92',):
-                expected = 'pack-0.92'
+            if key in ('dirstate', 'dirstate-tags', 'dirstate-with-subtree',
+                'pack-0.92', 'pack-0.92-subtree', 'rich-root',
+                'rich-root-pack', '1.6', '1.6.1-rich-root',
+                '1.9', '1.9-rich-root'):
+                expected = '1.6 or 1.6.1-rich-root or ' \
+                    '1.9 or 1.9-rich-root or ' \
+                    'dirstate or dirstate-tags or pack-0.92 or'\
+                    ' rich-root or rich-root-pack'
             elif key in ('knit', 'metaweave'):
                 expected = 'knit or metaweave'
             elif key in ('1.14', '1.14-rich-root'):
@@ -163,10 +167,10 @@
             expected = None
             if key in ('dirstate', 'knit'):
                 expected = 'dirstate or knit'
-            elif key in ('1.14',):
-                expected = '1.14'
-            elif key in ('1.14-rich-root',):
-                expected = '1.14-rich-root'
+            elif key in ('1.9', '1.14'):
+                expected = '1.14 or 1.9'
+            elif key in ('1.9-rich-root', '1.14-rich-root'):
+                expected = '1.14-rich-root or 1.9-rich-root'
             self.assertBranchDescription(key, expected)
 
     def test_describe_repo_format(self):
@@ -178,10 +182,10 @@
             expected = None
             if key in ('dirstate', 'knit', 'dirstate-tags'):
                 expected = 'dirstate or dirstate-tags or knit'
-            elif key in ('1.14',):
-                expected = '1.14'
-            elif key in ('1.14-rich-root',):
-                expected = '1.14-rich-root'
+            elif key in ('1.9', '1.14'):
+                expected = '1.14 or 1.9'
+            elif key in ('1.9-rich-root', '1.14-rich-root'):
+                expected = '1.14-rich-root or 1.9-rich-root'
             self.assertRepoDescription(key, expected)
 
         format = bzrdir.format_registry.make_bzrdir('metaweave')

=== modified file 'bzrlib/tests/test_knit.py'
--- bzrlib/tests/test_knit.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_knit.py	2009-12-22 16:40:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -862,8 +862,12 @@
 
     def get_knit_index(self, transport, name, mode):
         mapper = ConstantMapper(name)
+        orig = knit._load_data
+        def reset():
+            knit._load_data = orig
+        self.addCleanup(reset)
         from bzrlib._knit_load_data_py import _load_data_py
-        self.overrideAttr(knit, '_load_data', _load_data_py)
+        knit._load_data = _load_data_py
         allow_writes = lambda: 'w' in mode
         return _KndxIndex(transport, mapper, lambda:None, allow_writes, lambda:True)
 
@@ -1298,11 +1302,14 @@
 
     def get_knit_index(self, transport, name, mode):
         mapper = ConstantMapper(name)
+        orig = knit._load_data
+        def reset():
+            knit._load_data = orig
+        self.addCleanup(reset)
         from bzrlib._knit_load_data_pyx import _load_data_c
-        self.overrideAttr(knit, '_load_data', _load_data_c)
+        knit._load_data = _load_data_c
         allow_writes = lambda: mode == 'w'
-        return _KndxIndex(transport, mapper, lambda:None,
-                          allow_writes, lambda:True)
+        return _KndxIndex(transport, mapper, lambda:None, allow_writes, lambda:True)
 
 
 class Test_KnitAnnotator(TestCaseWithMemoryTransport):

=== modified file 'bzrlib/tests/test_lazy_import.py'
--- bzrlib/tests/test_lazy_import.py	2010-01-25 15:55:48 +0000
+++ bzrlib/tests/test_lazy_import.py	2009-03-23 14:59:43 +0000
@@ -452,16 +452,17 @@
         self.actions = []
         InstrumentedImportReplacer.use_actions(self.actions)
 
-        sys.path.append(base_path)
-        self.addCleanup(sys.path.remove, base_path)
-
         original_import = __import__
         def instrumented_import(mod, scope1, scope2, fromlist):
             self.actions.append(('import', mod, fromlist))
             return original_import(mod, scope1, scope2, fromlist)
+
         def cleanup():
+            if base_path in sys.path:
+                sys.path.remove(base_path)
             __builtins__['__import__'] = original_import
         self.addCleanup(cleanup)
+        sys.path.append(base_path)
         __builtins__['__import__'] = instrumented_import
 
     def create_modules(self):

=== modified file 'bzrlib/tests/test_lockable_files.py'
--- bzrlib/tests/test_lockable_files.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_lockable_files.py	2010-01-06 04:48:59 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	2010-03-03 22:59:21 +0000
+++ bzrlib/tests/test_lockdir.py	2009-06-23 08:43:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -197,8 +197,9 @@
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
                          'Will continue to try until %s, unless '
-                         'you press Ctrl-C.\n'
-                         'See "bzr help break-lock" for more.',
+                         'you press Ctrl-C\n'
+                         'If you\'re sure that it\'s not being '
+                         'modified, use bzr break-lock %s',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -419,8 +420,9 @@
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
                          'Will continue to try until %s, unless '
-                         'you press Ctrl-C.\n'
-                         'See "bzr help break-lock" for more.',
+                         'you press Ctrl-C\n'
+                         'If you\'re sure that it\'s not being '
+                         'modified, use bzr break-lock %s',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -433,8 +435,9 @@
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
                          'Will continue to try until %s, unless '
-                         'you press Ctrl-C.\n'
-                         'See "bzr help break-lock" for more.',
+                         'you press Ctrl-C\n'
+                         'If you\'re sure that it\'s not being '
+                         'modified, use bzr break-lock %s',
                          self._logged_reports[1][0])
         args = self._logged_reports[1][1]
         self.assertEqual('Lock owner changed for', args[0])
@@ -666,25 +669,6 @@
         # no kibble
         check_dir(['held'])
 
-    def test_no_lockdir_info(self):
-        """We can cope with empty info files."""
-        # This seems like a fairly common failure case - see
-        # <https://bugs.edge.launchpad.net/bzr/+bug/185103> and all its dupes.
-        # Processes are often interrupted after opening the file
-        # before the actual contents are committed.
-        t = self.get_transport()
-        t.mkdir('test_lock')
-        t.mkdir('test_lock/held')
-        t.put_bytes('test_lock/held/info', '')
-        lf = LockDir(t, 'test_lock')
-        info = lf.peek()
-        formatted_info = lf._format_lock_info(info)
-        self.assertEquals(
-            ['lock %s' % t.abspath('test_lock'),
-             'held by <unknown> on host <unknown> [process #<unknown>]',
-             'locked (unknown)'],
-            formatted_info)
-
 
 class TestLockDirHooks(TestCaseWithTransport):
 

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2010-04-28 07:10:36 +0000
+++ bzrlib/tests/test_log.py	2009-12-03 19:54:38 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,37 +18,16 @@
 from cStringIO import StringIO
 
 from bzrlib import (
-    branchbuilder,
     errors,
     log,
     registry,
     revision,
     revisionspec,
-    symbol_versioning,
     tests,
     )
 
 
-class TestLogMixin(object):
-
-    def wt_commit(self, wt, message, **kwargs):
-        """Use some mostly fixed values for commits to simplify tests.
-
-        Tests can use this function to get some commit attributes. The time
-        stamp is incremented at each commit.
-        """
-        if getattr(self, 'timestamp', None) is None:
-            self.timestamp = 1132617600 # Mon 2005-11-22 00:00:00 +0000
-        else:
-            self.timestamp += 1 # 1 second between each commit
-        kwargs.setdefault('timestamp', self.timestamp)
-        kwargs.setdefault('timezone', 0) # UTC
-        kwargs.setdefault('committer', 'Joe Foo <joe@foo.com>')
-
-        return wt.commit(message, **kwargs)
-
-
-class TestCaseForLogFormatter(tests.TestCaseWithTransport, TestLogMixin):
+class TestCaseForLogFormatter(tests.TestCaseWithTransport):
 
     def setUp(self):
         super(TestCaseForLogFormatter, self).setUp()
@@ -62,7 +41,8 @@
         self.addCleanup(restore)
 
     def assertFormatterResult(self, result, branch, formatter_class,
-                              formatter_kwargs=None, show_log_kwargs=None):
+                              formatter_kwargs=None, show_log_kwargs=None,
+                              normalize=False):
         logfile = self.make_utf8_encoded_stringio()
         if formatter_kwargs is None:
             formatter_kwargs = {}
@@ -70,7 +50,10 @@
         if show_log_kwargs is None:
             show_log_kwargs = {}
         log.show_log(branch, formatter, **show_log_kwargs)
-        self.assertEqualDiff(result, logfile.getvalue())
+        log_content = logfile.getvalue()
+        if normalize:
+            log_content = normalize_log(log_content)
+        self.assertEqualDiff(result, log_content)
 
     def make_standard_commit(self, branch_nick, **kwargs):
         wt = self.make_branch_and_tree('.')
@@ -79,44 +62,44 @@
         self.build_tree(['a'])
         wt.add(['a'])
         wt.branch.nick = branch_nick
+        kwargs = dict(kwargs)
+        kwargs.setdefault('message', 'add a')
+        kwargs.setdefault('timestamp', 1132711707)
+        kwargs.setdefault('timezone', 36000)
         kwargs.setdefault('committer', 'Lorem Ipsum <test@example.com>')
         kwargs.setdefault('authors', ['John Doe <jdoe@example.com>'])
-        self.wt_commit(wt, 'add a', **kwargs)
+        wt.commit(**kwargs)
         return wt
 
-    def make_commits_with_trailing_newlines(self, wt):
-        """Helper method for LogFormatter tests"""
-        b = wt.branch
-        b.nick = 'test'
-        self.build_tree_contents([('a', 'hello moto\n')])
-        self.wt_commit(wt, 'simple log message', rev_id='a1')
-        self.build_tree_contents([('b', 'goodbye\n')])
-        wt.add('b')
-        self.wt_commit(wt, 'multiline\nlog\nmessage\n', rev_id='a2')
-
-        self.build_tree_contents([('c', 'just another manic monday\n')])
-        wt.add('c')
-        self.wt_commit(wt, 'single line with trailing newline\n', rev_id='a3')
-        return b
-
     def _prepare_tree_with_merges(self, with_tags=False):
         wt = self.make_branch_and_memory_tree('.')
         wt.lock_write()
         self.addCleanup(wt.unlock)
         wt.add('')
-        self.wt_commit(wt, 'rev-1', rev_id='rev-1')
-        self.wt_commit(wt, 'rev-merged', rev_id='rev-2a')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         wt.set_parent_ids(['rev-1', 'rev-2a'])
         wt.branch.set_last_revision_info(1, 'rev-1')
-        self.wt_commit(wt, 'rev-2', rev_id='rev-2b')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         if with_tags:
             branch = wt.branch
             branch.tags.set_tag('v0.2', 'rev-2b')
-            self.wt_commit(wt, 'rev-3', rev_id='rev-3')
+            wt.commit('rev-3', rev_id='rev-3',
+                      timestamp=1132586900, timezone=36000,
+                      committer='Jane Foo <jane@foo.com>')
             branch.tags.set_tag('v1.0rc1', 'rev-3')
             branch.tags.set_tag('v1.0', 'rev-3')
         return wt
 
+        
+
+
 class LogCatcher(log.LogFormatter):
     """Pull log messages into a list rather than displaying them.
 
@@ -125,14 +108,10 @@
     being dependent on the formatting.
     """
 
-    supports_merge_revisions = True
     supports_delta = True
-    supports_diff = True
-    preferred_levels = 0
 
-    def __init__(self, *args, **kwargs):
-        kwargs.update(dict(to_file=None))
-        super(LogCatcher, self).__init__(*args, **kwargs)
+    def __init__(self):
+        super(LogCatcher, self).__init__(to_file=None)
         self.revisions = []
 
     def log_revision(self, revision):
@@ -281,21 +260,62 @@
         self.checkDelta(logentry.delta, added=['file1', 'file2'])
 
 
+def make_commits_with_trailing_newlines(wt):
+    """Helper method for LogFormatter tests"""
+    b = wt.branch
+    b.nick='test'
+    open('a', 'wb').write('hello moto\n')
+    wt.add('a')
+    wt.commit('simple log message', rev_id='a1',
+              timestamp=1132586655.459960938, timezone=-6*3600,
+              committer='Joe Foo <joe@foo.com>')
+    open('b', 'wb').write('goodbye\n')
+    wt.add('b')
+    wt.commit('multiline\nlog\nmessage\n', rev_id='a2',
+              timestamp=1132586842.411175966, timezone=-6*3600,
+              committer='Joe Foo <joe@foo.com>',
+              authors=['Joe Bar <joe@bar.com>'])
+
+    open('c', 'wb').write('just another manic monday\n')
+    wt.add('c')
+    wt.commit('single line with trailing newline\n', rev_id='a3',
+              timestamp=1132587176.835228920, timezone=-6*3600,
+              committer = 'Joe Foo <joe@foo.com>')
+    return b
+
+
+def normalize_log(log):
+    """Replaces the variable lines of logs with fixed lines"""
+    author = 'author: Dolor Sit <test@example.com>'
+    committer = 'committer: Lorem Ipsum <test@example.com>'
+    lines = log.splitlines(True)
+    for idx,line in enumerate(lines):
+        stripped_line = line.lstrip()
+        indent = ' ' * (len(line) - len(stripped_line))
+        if stripped_line.startswith('author:'):
+            lines[idx] = indent + author + '\n'
+        elif stripped_line.startswith('committer:'):
+            lines[idx] = indent + committer + '\n'
+        elif stripped_line.startswith('timestamp:'):
+            lines[idx] = indent + 'timestamp: Just now\n'
+    return ''.join(lines)
+
+
 class TestShortLogFormatter(TestCaseForLogFormatter):
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = self.make_commits_with_trailing_newlines(wt)
+        b = make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
-    3 Joe Foo\t2005-11-22
+    3 Joe Foo\t2005-11-21
       single line with trailing newline
 
-    2 Joe Foo\t2005-11-22
+    2 Joe Bar\t2005-11-21
       multiline
       log
       message
 
-    1 Joe Foo\t2005-11-22
+    1 Joe Foo\t2005-11-21
       simple log message
 
 """,
@@ -328,17 +348,35 @@
             formatter_kwargs=dict(show_advice=True))
 
     def test_short_log_with_merges_and_range(self):
-        wt = self._prepare_tree_with_merges()
-        self.wt_commit(wt, 'rev-3a', rev_id='rev-3a')
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.commit('rev-2b', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-3a', rev_id='rev-3a',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         wt.branch.set_last_revision_info(2, 'rev-2b')
         wt.set_parent_ids(['rev-2b', 'rev-3a'])
-        self.wt_commit(wt, 'rev-3b', rev_id='rev-3b')
+        wt.commit('rev-3b', rev_id='rev-3b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         self.assertFormatterResult("""\
     3 Joe Foo\t2005-11-22 [merge]
       rev-3b
 
     2 Joe Foo\t2005-11-22 [merge]
-      rev-2
+      rev-2b
 
 """,
             wt.branch, log.ShortLogFormatter,
@@ -347,7 +385,7 @@
     def test_short_log_with_tags(self):
         wt = self._prepare_tree_with_merges(with_tags=True)
         self.assertFormatterResult("""\
-    3 Joe Foo\t2005-11-22 {v1.0, v1.0rc1}
+    3 Jane Foo\t2005-11-22 {v1.0, v1.0rc1}
       rev-3
 
     2 Joe Foo\t2005-11-22 {v0.2} [merge]
@@ -360,7 +398,21 @@
             wt.branch, log.ShortLogFormatter)
 
     def test_short_log_single_merge_revision(self):
-        wt = self._prepare_tree_with_merges()
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
         rev = revspec.in_history(wt.branch)
         self.assertFormatterResult("""\
@@ -375,7 +427,21 @@
 class TestShortLogFormatterWithMergeRevisions(TestCaseForLogFormatter):
 
     def test_short_merge_revs_log_with_merges(self):
-        wt = self._prepare_tree_with_merges()
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         # Note that the 1.1.1 indenting is in fact correct given that
         # the revision numbers are right justified within 5 characters
         # for mainline revnos and 9 characters for dotted revnos.
@@ -394,7 +460,21 @@
             formatter_kwargs=dict(levels=0))
 
     def test_short_merge_revs_log_single_merge_revision(self):
-        wt = self._prepare_tree_with_merges()
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
         rev = revspec.in_history(wt.branch)
         self.assertFormatterResult("""\
@@ -420,7 +500,7 @@
 revno: 1
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_verbose_log
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 added:
@@ -431,73 +511,79 @@
 
     def test_merges_are_indented_by_level(self):
         wt = self.make_branch_and_tree('parent')
-        self.wt_commit(wt, 'first post')
-        child_wt = wt.bzrdir.sprout('child').open_workingtree()
-        self.wt_commit(child_wt, 'branch 1')
-        smallerchild_wt = wt.bzrdir.sprout('smallerchild').open_workingtree()
-        self.wt_commit(smallerchild_wt, 'branch 2')
-        child_wt.merge_from_branch(smallerchild_wt.branch)
-        self.wt_commit(child_wt, 'merge branch 2')
-        wt.merge_from_branch(child_wt.branch)
-        self.wt_commit(wt, 'merge branch 1')
+        wt.commit('first post')
+        self.run_bzr('branch parent child')
+        self.run_bzr(['commit', '-m', 'branch 1', '--unchanged', 'child'])
+        self.run_bzr('branch child smallerchild')
+        self.run_bzr(['commit', '-m', 'branch 2', '--unchanged',
+            'smallerchild'])
+        os.chdir('child')
+        self.run_bzr('merge ../smallerchild')
+        self.run_bzr(['commit', '-m', 'merge branch 2'])
+        os.chdir('../parent')
+        self.run_bzr('merge ../child')
+        wt.commit('merge branch 1')
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
-committer: Joe Foo <joe@foo.com>
+committer: Lorem Ipsum <test@example.com>
 branch nick: parent
-timestamp: Tue 2005-11-22 00:00:04 +0000
+timestamp: Just now
 message:
   merge branch 1
     ------------------------------------------------------------
     revno: 1.1.2 [merge]
-    committer: Joe Foo <joe@foo.com>
+    committer: Lorem Ipsum <test@example.com>
     branch nick: child
-    timestamp: Tue 2005-11-22 00:00:03 +0000
+    timestamp: Just now
     message:
       merge branch 2
         ------------------------------------------------------------
         revno: 1.2.1
-        committer: Joe Foo <joe@foo.com>
+        committer: Lorem Ipsum <test@example.com>
         branch nick: smallerchild
-        timestamp: Tue 2005-11-22 00:00:02 +0000
+        timestamp: Just now
         message:
           branch 2
     ------------------------------------------------------------
     revno: 1.1.1
-    committer: Joe Foo <joe@foo.com>
+    committer: Lorem Ipsum <test@example.com>
     branch nick: child
-    timestamp: Tue 2005-11-22 00:00:01 +0000
+    timestamp: Just now
     message:
       branch 1
 ------------------------------------------------------------
 revno: 1
-committer: Joe Foo <joe@foo.com>
+committer: Lorem Ipsum <test@example.com>
 branch nick: parent
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Just now
 message:
   first post
 """,
             wt.branch, log.LongLogFormatter,
             formatter_kwargs=dict(levels=0),
-            show_log_kwargs=dict(verbose=True))
+            show_log_kwargs=dict(verbose=True),
+            normalize=True)
 
     def test_verbose_merge_revisions_contain_deltas(self):
         wt = self.make_branch_and_tree('parent')
         self.build_tree(['parent/f1', 'parent/f2'])
         wt.add(['f1','f2'])
-        self.wt_commit(wt, 'first post')
-        child_wt = wt.bzrdir.sprout('child').open_workingtree()
+        wt.commit('first post')
+        self.run_bzr('branch parent child')
         os.unlink('child/f1')
-        self.build_tree_contents([('child/f2', 'hello\n')])
-        self.wt_commit(child_wt, 'removed f1 and modified f2')
-        wt.merge_from_branch(child_wt.branch)
-        self.wt_commit(wt, 'merge branch 1')
+        file('child/f2', 'wb').write('hello\n')
+        self.run_bzr(['commit', '-m', 'removed f1 and modified f2',
+            'child'])
+        os.chdir('parent')
+        self.run_bzr('merge ../child')
+        wt.commit('merge branch 1')
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
-committer: Joe Foo <joe@foo.com>
+committer: Lorem Ipsum <test@example.com>
 branch nick: parent
-timestamp: Tue 2005-11-22 00:00:02 +0000
+timestamp: Just now
 message:
   merge branch 1
 removed:
@@ -506,9 +592,9 @@
   f2
     ------------------------------------------------------------
     revno: 1.1.1
-    committer: Joe Foo <joe@foo.com>
+    committer: Lorem Ipsum <test@example.com>
     branch nick: child
-    timestamp: Tue 2005-11-22 00:00:01 +0000
+    timestamp: Just now
     message:
       removed f1 and modified f2
     removed:
@@ -517,9 +603,9 @@
       f2
 ------------------------------------------------------------
 revno: 1
-committer: Joe Foo <joe@foo.com>
+committer: Lorem Ipsum <test@example.com>
 branch nick: parent
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Just now
 message:
   first post
 added:
@@ -528,24 +614,26 @@
 """,
             wt.branch, log.LongLogFormatter,
             formatter_kwargs=dict(levels=0),
-            show_log_kwargs=dict(verbose=True))
+            show_log_kwargs=dict(verbose=True),
+            normalize=True)
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = self.make_commits_with_trailing_newlines(wt)
+        b = make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 3
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Tue 2005-11-22 00:00:02 +0000
+timestamp: Mon 2005-11-21 09:32:56 -0600
 message:
   single line with trailing newline
 ------------------------------------------------------------
 revno: 2
+author: Joe Bar <joe@bar.com>
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Tue 2005-11-22 00:00:01 +0000
+timestamp: Mon 2005-11-21 09:27:22 -0600
 message:
   multiline
   log
@@ -554,7 +642,7 @@
 revno: 1
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Mon 2005-11-21 09:24:15 -0600
 message:
   simple log message
 """,
@@ -573,7 +661,7 @@
 author: John Doe <jdoe@example.com>, Jane Rey <jrey@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_author_log
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 """,
@@ -598,7 +686,7 @@
 author: John Doe <jdoe@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_properties_in_log
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 """,
@@ -616,7 +704,7 @@
             'trivial_custom_prop_handler',
             trivial_custom_prop_handler)
         self.assertFormatterResult("""\
-    1 John Doe\t2005-11-22
+    1 John Doe\t2005-11-23
       test_prop: test_value
       add a
 
@@ -673,7 +761,7 @@
 revno: 1
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_long_verbose_log
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 added:
@@ -687,19 +775,19 @@
         wt = self.make_branch_and_tree('parent')
         self.build_tree(['parent/f1', 'parent/f2'])
         wt.add(['f1','f2'])
-        self.wt_commit(wt, 'first post')
+        wt.commit('first post')
         child_wt = wt.bzrdir.sprout('child').open_workingtree()
         os.unlink('child/f1')
         self.build_tree_contents([('child/f2', 'hello\n')])
-        self.wt_commit(child_wt, 'removed f1 and modified f2')
+        child_wt.commit('removed f1 and modified f2')
         wt.merge_from_branch(child_wt.branch)
-        self.wt_commit(wt, 'merge branch 1')
+        wt.commit('merge branch 1')
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
-committer: Joe Foo <joe@foo.com>
+committer: Lorem Ipsum <test@example.com>
 branch nick: parent
-timestamp: Tue 2005-11-22 00:00:02 +0000
+timestamp: Just now
 message:
   merge branch 1
 removed:
@@ -708,9 +796,9 @@
   f2
 ------------------------------------------------------------
 revno: 1
-committer: Joe Foo <joe@foo.com>
+committer: Lorem Ipsum <test@example.com>
 branch nick: parent
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Just now
 message:
   first post
 added:
@@ -719,24 +807,26 @@
 """,
             wt.branch, log.LongLogFormatter,
             formatter_kwargs=dict(levels=1),
-            show_log_kwargs=dict(verbose=True))
+            show_log_kwargs=dict(verbose=True),
+            normalize=True)
 
     def test_long_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = self.make_commits_with_trailing_newlines(wt)
+        b = make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 3
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Tue 2005-11-22 00:00:02 +0000
+timestamp: Mon 2005-11-21 09:32:56 -0600
 message:
   single line with trailing newline
 ------------------------------------------------------------
 revno: 2
+author: Joe Bar <joe@bar.com>
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Tue 2005-11-22 00:00:01 +0000
+timestamp: Mon 2005-11-21 09:27:22 -0600
 message:
   multiline
   log
@@ -745,7 +835,7 @@
 revno: 1
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Mon 2005-11-21 09:24:15 -0600
 message:
   simple log message
 """,
@@ -763,7 +853,7 @@
 author: John Doe <jdoe@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_author_log
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 """,
@@ -788,7 +878,7 @@
 author: John Doe <jdoe@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_properties_in_log
-timestamp: Tue 2005-11-22 00:00:00 +0000
+timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 """,
@@ -807,17 +897,17 @@
                 committer='Line-Log-Formatter Tester <test@line.log>',
                 authors=[])
         self.assertFormatterResult("""\
-1: Line-Log-Formatte... 2005-11-22 add a
+1: Line-Log-Formatte... 2005-11-23 add a
 """,
             wt.branch, log.LineLogFormatter)
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = self.make_commits_with_trailing_newlines(wt)
+        b = make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
-3: Joe Foo 2005-11-22 single line with trailing newline
-2: Joe Foo 2005-11-22 multiline
-1: Joe Foo 2005-11-22 simple log message
+3: Joe Foo 2005-11-21 single line with trailing newline
+2: Joe Bar 2005-11-21 multiline
+1: Joe Foo 2005-11-21 simple log message
 """,
             b, log.LineLogFormatter)
 
@@ -834,7 +924,7 @@
     def test_line_log_with_tags(self):
         wt = self._prepare_tree_with_merges(with_tags=True)
         self.assertFormatterResult("""\
-3: Joe Foo 2005-11-22 {v1.0, v1.0rc1} rev-3
+3: Jane Foo 2005-11-22 {v1.0, v1.0rc1} rev-3
 2: Joe Foo 2005-11-22 [merge] {v0.2} rev-2
 1: Joe Foo 2005-11-22 rev-1
 """,
@@ -852,12 +942,26 @@
                 committer='Line-Log-Formatter Tester <test@line.log>',
                 authors=[])
         self.assertFormatterResult("""\
-1: Line-Log-Formatte... 2005-11-22 add a
+1: Line-Log-Formatte... 2005-11-23 add a
 """,
             wt.branch, log.LineLogFormatter)
 
     def test_line_merge_revs_log_single_merge_revision(self):
-        wt = self._prepare_tree_with_merges()
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
         rev = revspec.in_history(wt.branch)
         self.assertFormatterResult("""\
@@ -868,7 +972,21 @@
             show_log_kwargs=dict(start_revision=rev, end_revision=rev))
 
     def test_line_merge_revs_log_with_merges(self):
-        wt = self._prepare_tree_with_merges()
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
         self.assertFormatterResult("""\
 2: Joe Foo 2005-11-22 [merge] rev-2
   1.1.1: Joe Foo 2005-11-22 rev-merged
@@ -878,55 +996,14 @@
             formatter_kwargs=dict(levels=0))
 
 
-class TestGnuChangelogFormatter(TestCaseForLogFormatter):
-
-    def test_gnu_changelog(self):
-        wt = self.make_standard_commit('nicky', authors=[])
-        self.assertFormatterResult('''\
-2005-11-22  Lorem Ipsum  <test@example.com>
-
-\tadd a
-
-''',
-            wt.branch, log.GnuChangelogLogFormatter)
-
-    def test_with_authors(self):
-        wt = self.make_standard_commit('nicky',
-            authors=['Fooa Fooz <foo@example.com>',
-                     'Bari Baro <bar@example.com>'])
-        self.assertFormatterResult('''\
-2005-11-22  Fooa Fooz  <foo@example.com>
-
-\tadd a
-
-''',
-            wt.branch, log.GnuChangelogLogFormatter)
-
-    def test_verbose(self):
-        wt = self.make_standard_commit('nicky')
-        self.assertFormatterResult('''\
-2005-11-22  John Doe  <jdoe@example.com>
-
-\t* a:
-
-\tadd a
-
-''',
-            wt.branch, log.GnuChangelogLogFormatter,
-            show_log_kwargs=dict(verbose=True))
-
-class TestGetViewRevisions(tests.TestCaseWithTransport, TestLogMixin):
-
-    def _get_view_revisions(self, *args, **kwargs):
-        return self.applyDeprecated(symbol_versioning.deprecated_in((2, 2, 0)),
-                                    log.get_view_revisions, *args, **kwargs)
+class TestGetViewRevisions(tests.TestCaseWithTransport):
 
     def make_tree_with_commits(self):
         """Create a tree with well-known revision ids"""
         wt = self.make_branch_and_tree('tree1')
-        self.wt_commit(wt, 'commit one', rev_id='1')
-        self.wt_commit(wt, 'commit two', rev_id='2')
-        self.wt_commit(wt, 'commit three', rev_id='3')
+        wt.commit('commit one', rev_id='1')
+        wt.commit('commit two', rev_id='2')
+        wt.commit('commit three', rev_id='3')
         mainline_revs = [None, '1', '2', '3']
         rev_nos = {'1': 1, '2': 2, '3': 3}
         return mainline_revs, rev_nos, wt
@@ -935,9 +1012,9 @@
         """Create a tree with well-known revision ids and a merge"""
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
         tree2 = wt.bzrdir.sprout('tree2').open_workingtree()
-        self.wt_commit(tree2, 'four-a', rev_id='4a')
+        tree2.commit('four-a', rev_id='4a')
         wt.merge_from_branch(tree2.branch)
-        self.wt_commit(wt, 'four-b', rev_id='4b')
+        wt.commit('four-b', rev_id='4b')
         mainline_revs.append('4b')
         rev_nos['4b'] = 4
         # 4a: 3.1.1
@@ -991,11 +1068,11 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward'))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0)],
                          revisions)
-        revisions2 = list(self._get_view_revisions(
+        revisions2 = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward',
                 include_merges=False))
         self.assertEqual(revisions, revisions2)
@@ -1005,11 +1082,11 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse'))
         self.assertEqual([('3', '3', 0), ('2', '2', 0), ('1', '1', 0), ],
                          revisions)
-        revisions2 = list(self._get_view_revisions(
+        revisions2 = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse',
                 include_merges=False))
         self.assertEqual(revisions, revisions2)
@@ -1019,12 +1096,12 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_merges()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward'))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0),
                           ('4b', '4', 0), ('4a', '3.1.1', 1)],
                          revisions)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward',
                 include_merges=False))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0),
@@ -1036,12 +1113,12 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_merges()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse'))
         self.assertEqual([('4b', '4', 0), ('4a', '3.1.1', 1),
                           ('3', '3', 0), ('2', '2', 0), ('1', '1', 0)],
                          revisions)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse',
                 include_merges=False))
         self.assertEqual([('4b', '4', 0), ('3', '3', 0), ('2', '2', 0),
@@ -1053,19 +1130,20 @@
         mainline_revs, rev_nos, b = self.make_branch_with_many_merges()
         b.lock_read()
         self.addCleanup(b.unlock)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, b, 'forward'))
         expected = [('1', '1', 0), ('2', '2', 0), ('3c', '3', 0),
                     ('3b', '2.2.1', 1), ('3a', '2.1.1', 2), ('4b', '4', 0),
                     ('4a', '2.2.2', 1)]
         self.assertEqual(expected, revisions)
-        revisions = list(self._get_view_revisions(
+        revisions = list(log.get_view_revisions(
                 mainline_revs, rev_nos, b, 'forward',
                 include_merges=False))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3c', '3', 0),
                           ('4b', '4', 0)],
                          revisions)
 
+
     def test_file_id_for_range(self):
         mainline_revs, rev_nos, b = self.make_branch_with_many_merges()
         b.lock_read()
@@ -1076,9 +1154,7 @@
             return revspec.in_history(branch)
 
         def view_revs(start_rev, end_rev, file_id, direction):
-            revs = self.applyDeprecated(
-                symbol_versioning.deprecated_in((2, 2, 0)),
-                log.calculate_view_revisions,
+            revs = log.calculate_view_revisions(
                 b,
                 start_rev, # start_revision
                 end_rev, # end_revision
@@ -1090,21 +1166,15 @@
 
         rev_3a = rev_from_rev_id('3a', b)
         rev_4b = rev_from_rev_id('4b', b)
-        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1),
-                          ('3a', '2.1.1', 2)],
+        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1), ('3a', '2.1.1', 2)],
                           view_revs(rev_3a, rev_4b, 'f-id', 'reverse'))
         # Note: 3c still appears before 3a here because of depth-based sorting
-        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1),
-                          ('3a', '2.1.1', 2)],
+        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1), ('3a', '2.1.1', 2)],
                           view_revs(rev_3a, rev_4b, 'f-id', 'forward'))
 
 
 class TestGetRevisionsTouchingFileID(tests.TestCaseWithTransport):
 
-    def get_view_revisions(self, *args):
-        return self.applyDeprecated(symbol_versioning.deprecated_in((2, 2, 0)),
-                                    log.get_view_revisions, *args)
-
     def create_tree_with_single_merge(self):
         """Create a branch with a moderate layout.
 
@@ -1128,11 +1198,6 @@
         #       use it. Since 'log' only uses the tree in a readonly
         #       fashion, it seems a shame to regenerate an identical
         #       tree for each test.
-        # TODO: vila 20100122 One way to address the shame above will be to
-        #       create a memory tree during test parametrization and give a
-        #       *copy* of this tree to each test. Copying a memory tree ought
-        #       to be cheap, at least cheaper than creating them with such
-        #       complex setups.
         tree = self.make_branch_and_tree('tree')
         tree.lock_write()
         self.addCleanup(tree.unlock)
@@ -1213,10 +1278,12 @@
         mainline = tree.branch.revision_history()
         mainline.insert(0, None)
         revnos = dict((rev, idx+1) for idx, rev in enumerate(mainline))
-        view_revs_iter = self.get_view_revisions(
-            mainline, revnos, tree.branch, 'reverse', True)
+        view_revs_iter = log.get_view_revisions(mainline, revnos, tree.branch,
+                                                'reverse', True)
         actual_revs = log._filter_revisions_touching_file_id(
-            tree.branch, file_id, list(view_revs_iter))
+                            tree.branch,
+                            file_id,
+                            list(view_revs_iter))
         self.assertEqual(revisions, [r for r, revno, depth in actual_revs])
 
     def test_file_id_f1(self):
@@ -1274,42 +1341,41 @@
 
 class TestLogFormatter(tests.TestCase):
 
-    def setUp(self):
-        super(TestLogFormatter, self).setUp()
-        self.rev = revision.Revision('a-id')
-        self.lf = log.LogFormatter(None)
-
     def test_short_committer(self):
-        def assertCommitter(expected, committer):
-            self.rev.committer = committer
-            self.assertEqual(expected, self.lf.short_committer(self.rev))
-
-        assertCommitter('John Doe', 'John Doe <jdoe@example.com>')
-        assertCommitter('John Smith', 'John Smith <jsmith@example.com>')
-        assertCommitter('John Smith', 'John Smith')
-        assertCommitter('jsmith@example.com', 'jsmith@example.com')
-        assertCommitter('jsmith@example.com', '<jsmith@example.com>')
-        assertCommitter('John Smith', 'John Smith jsmith@example.com')
+        rev = revision.Revision('a-id')
+        rev.committer = 'John Doe <jdoe@example.com>'
+        lf = log.LogFormatter(None)
+        self.assertEqual('John Doe', lf.short_committer(rev))
+        rev.committer = 'John Smith <jsmith@example.com>'
+        self.assertEqual('John Smith', lf.short_committer(rev))
+        rev.committer = 'John Smith'
+        self.assertEqual('John Smith', lf.short_committer(rev))
+        rev.committer = 'jsmith@example.com'
+        self.assertEqual('jsmith@example.com', lf.short_committer(rev))
+        rev.committer = '<jsmith@example.com>'
+        self.assertEqual('jsmith@example.com', lf.short_committer(rev))
+        rev.committer = 'John Smith jsmith@example.com'
+        self.assertEqual('John Smith', lf.short_committer(rev))
 
     def test_short_author(self):
-        def assertAuthor(expected, author):
-            self.rev.properties['author'] = author
-            self.assertEqual(expected, self.lf.short_author(self.rev))
-
-        assertAuthor('John Smith', 'John Smith <jsmith@example.com>')
-        assertAuthor('John Smith', 'John Smith')
-        assertAuthor('jsmith@example.com', 'jsmith@example.com')
-        assertAuthor('jsmith@example.com', '<jsmith@example.com>')
-        assertAuthor('John Smith', 'John Smith jsmith@example.com')
-
-    def test_short_author_from_committer(self):
-        self.rev.committer = 'John Doe <jdoe@example.com>'
-        self.assertEqual('John Doe', self.lf.short_author(self.rev))
-
-    def test_short_author_from_authors(self):
-        self.rev.properties['authors'] = ('John Smith <jsmith@example.com>\n'
-                                          'Jane Rey <jrey@example.com>')
-        self.assertEqual('John Smith', self.lf.short_author(self.rev))
+        rev = revision.Revision('a-id')
+        rev.committer = 'John Doe <jdoe@example.com>'
+        lf = log.LogFormatter(None)
+        self.assertEqual('John Doe', lf.short_author(rev))
+        rev.properties['author'] = 'John Smith <jsmith@example.com>'
+        self.assertEqual('John Smith', lf.short_author(rev))
+        rev.properties['author'] = 'John Smith'
+        self.assertEqual('John Smith', lf.short_author(rev))
+        rev.properties['author'] = 'jsmith@example.com'
+        self.assertEqual('jsmith@example.com', lf.short_author(rev))
+        rev.properties['author'] = '<jsmith@example.com>'
+        self.assertEqual('jsmith@example.com', lf.short_author(rev))
+        rev.properties['author'] = 'John Smith jsmith@example.com'
+        self.assertEqual('John Smith', lf.short_author(rev))
+        del rev.properties['author']
+        rev.properties['authors'] = ('John Smith <jsmith@example.com>\n'
+                'Jane Rey <jrey@example.com>')
+        self.assertEqual('John Smith', lf.short_author(rev))
 
 
 class TestReverseByDepth(tests.TestCase):
@@ -1461,143 +1527,3 @@
         log.show_branch_change(tree.branch, s, 3, '3b')
         self.assertContainsRe(s.getvalue(), 'Removed Revisions:')
         self.assertNotContainsRe(s.getvalue(), 'Added Revisions:')
-
-
-
-class TestLogWithBugs(TestCaseForLogFormatter, TestLogMixin):
-
-    def setUp(self):
-        TestCaseForLogFormatter.setUp(self)
-        log.properties_handler_registry.register(
-            'bugs_properties_handler',
-            log._bugs_properties_handler)
-
-    def make_commits_with_bugs(self):
-        """Helper method for LogFormatter tests"""
-        tree = self.make_branch_and_tree(u'.')
-        self.build_tree(['a', 'b'])
-        tree.add('a')
-        self.wt_commit(tree, 'simple log message', rev_id='a1',
-                       revprops={'bugs': 'test://bug/id fixed'})
-        tree.add('b')
-        self.wt_commit(tree, 'multiline\nlog\nmessage\n', rev_id='a2',
-                       authors=['Joe Bar <joe@bar.com>'],
-                       revprops={'bugs': 'test://bug/id fixed\n'
-                                 'test://bug/2 fixed'})
-        return tree
-
-
-    def test_long_bugs(self):
-        tree = self.make_commits_with_bugs()
-        self.assertFormatterResult("""\
-------------------------------------------------------------
-revno: 2
-fixes bug(s): test://bug/id test://bug/2
-author: Joe Bar <joe@bar.com>
-committer: Joe Foo <joe@foo.com>
-branch nick: work
-timestamp: Tue 2005-11-22 00:00:01 +0000
-message:
-  multiline
-  log
-  message
-------------------------------------------------------------
-revno: 1
-fixes bug(s): test://bug/id
-committer: Joe Foo <joe@foo.com>
-branch nick: work
-timestamp: Tue 2005-11-22 00:00:00 +0000
-message:
-  simple log message
-""",
-            tree.branch, log.LongLogFormatter)
-
-    def test_short_bugs(self):
-        tree = self.make_commits_with_bugs()
-        self.assertFormatterResult("""\
-    2 Joe Bar\t2005-11-22
-      fixes bug(s): test://bug/id test://bug/2
-      multiline
-      log
-      message
-
-    1 Joe Foo\t2005-11-22
-      fixes bug(s): test://bug/id
-      simple log message
-
-""",
-            tree.branch, log.ShortLogFormatter)
-
-    def test_wrong_bugs_property(self):
-        tree = self.make_branch_and_tree(u'.')
-        self.build_tree(['foo'])
-        self.wt_commit(tree, 'simple log message', rev_id='a1',
-                       revprops={'bugs': 'test://bug/id invalid_value'})
-        self.assertFormatterResult("""\
-    1 Joe Foo\t2005-11-22
-      simple log message
-
-""",
-            tree.branch, log.ShortLogFormatter)
-
-    def test_bugs_handler_present(self):
-        self.properties_handler_registry.get('bugs_properties_handler')
-
-class TestLogExcludeAncestry(tests.TestCaseWithTransport):
-
-    def make_branch_with_alternate_ancestries(self, relpath='.'):
-        # See test_merge_sorted_exclude_ancestry below for the difference with
-        # bt.per_branch.test_iter_merge_sorted_revision.
-        # TestIterMergeSortedRevisionsBushyGraph. 
-        # make_branch_with_alternate_ancestries
-        # and test_merge_sorted_exclude_ancestry
-        # See the FIXME in assertLogRevnos too.
-        builder = branchbuilder.BranchBuilder(self.get_transport(relpath))
-        # 1
-        # |\
-        # 2 \
-        # |  |
-        # |  1.1.1
-        # |  | \
-        # |  |  1.2.1
-        # |  | /
-        # |  1.1.2
-        # | /
-        # 3
-        builder.start_series()
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2', ['1'], [])
-        builder.build_snapshot('1.2.1', ['1.1.1'], [])
-        builder.build_snapshot('1.1.2', ['1.1.1', '1.2.1'], [])
-        builder.build_snapshot('3', ['2', '1.1.2'], [])
-        builder.finish_series()
-        br = builder.get_branch()
-        br.lock_read()
-        self.addCleanup(br.unlock)
-        return br
-
-    def assertLogRevnos(self, expected_revnos, b, start, end,
-                        exclude_common_ancestry):
-        # FIXME: the layering in log makes it hard to test intermediate levels,
-        # I wish adding filters with their parameters were easier...
-        # -- vila 20100413
-        iter_revs = log._calc_view_revisions(
-            b, start, end, direction='reverse',
-            generate_merge_revisions=True,
-            exclude_common_ancestry=exclude_common_ancestry)
-        self.assertEqual(expected_revnos,
-                         [revid for revid, revno, depth in iter_revs])
-
-    def test_merge_sorted_exclude_ancestry(self):
-        b = self.make_branch_with_alternate_ancestries()
-        self.assertLogRevnos(['3', '1.1.2', '1.2.1', '1.1.1', '2', '1'],
-                             b, '1', '3', False)
-        # '2' is part of the '3' ancestry but not part of '1.1.1' ancestry so
-        # it should be mentioned even if merge_sort order will make it appear
-        # after 1.1.1
-        self.assertLogRevnos(['3', '1.1.2', '1.2.1', '2'],
-                             b, '1.1.1', '3', True)
-
-

=== removed file 'bzrlib/tests/test_matchers.py'
--- bzrlib/tests/test_matchers.py	2010-05-06 11:08:10 +0000
+++ bzrlib/tests/test_matchers.py	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests of bzrlib test matchers."""
-
-from testtools.matchers import *
-
-from bzrlib.tests import TestCase
-from bzrlib.tests.matchers import *
-
-
-class StubTree(object):
-    """Stubg for testing."""
-
-    def __init__(self, lock_status):
-        self._is_locked = lock_status
-
-    def __str__(self):
-        return u'I am da tree'
-
-    def is_locked(self):
-        return self._is_locked
-
-
-class FakeUnlockable(object):
-    """Something that can be unlocked."""
-
-    def unlock(self):
-        pass
-
-
-class TestReturnsUnlockable(TestCase):
-
-    def test___str__(self):
-        matcher = ReturnsUnlockable(StubTree(True))
-        self.assertEqual(
-            'ReturnsUnlockable(lockable_thing=I am da tree)',
-            str(matcher))
-
-    def test_match(self):
-        stub_tree = StubTree(False)
-        matcher = ReturnsUnlockable(stub_tree)
-        self.assertThat(matcher.match(lambda:FakeUnlockable()), Equals(None))
-
-    def test_mismatch(self):
-        stub_tree = StubTree(True)
-        matcher = ReturnsUnlockable(stub_tree)
-        mismatch = matcher.match(lambda:FakeUnlockable())
-        self.assertNotEqual(None, mismatch)
-        self.assertThat(mismatch.describe(), Equals("I am da tree is locked"))
-

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_merge.py	2009-12-22 23:09:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,11 +33,7 @@
 from bzrlib.errors import UnrelatedBranches, NoCommits
 from bzrlib.merge import transform_tree, merge_inner, _PlanMerge
 from bzrlib.osutils import pathjoin, file_kind
-from bzrlib.tests import (
-    TestCaseWithMemoryTransport,
-    TestCaseWithTransport,
-    test_merge_core,
-    )
+from bzrlib.tests import TestCaseWithTransport, TestCaseWithMemoryTransport
 from bzrlib.workingtree import WorkingTree
 
 
@@ -295,7 +291,8 @@
         tree_a.commit('commit 2')
         tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
         tree_b.rename_one('file_1', 'renamed')
-        merger = _mod_merge.Merger.from_uncommitted(tree_a, tree_b)
+        merger = _mod_merge.Merger.from_uncommitted(tree_a, tree_b,
+                                                    progress.DummyProgress())
         merger.merge_type = _mod_merge.Merge3Merger
         merger.do_merge()
         self.assertEqual(tree_a.get_parent_ids(), [tree_b.last_revision()])
@@ -309,11 +306,17 @@
         tree_a.commit('commit 2')
         tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
         tree_b.rename_one('file_1', 'renamed')
-        merger = _mod_merge.Merger.from_uncommitted(tree_a, tree_b)
+        merger = _mod_merge.Merger.from_uncommitted(tree_a, tree_b,
+                                                    progress.DummyProgress())
         merger.merge_type = _mod_merge.WeaveMerger
         merger.do_merge()
         self.assertEqual(tree_a.get_parent_ids(), [tree_b.last_revision()])
 
+    def test_Merger_defaults_to_DummyProgress(self):
+        branch = self.make_branch('branch')
+        merger = _mod_merge.Merger(branch, pb=None)
+        self.assertIsInstance(merger._pb, progress.DummyProgress)
+
     def prepare_cherrypick(self):
         """Prepare a pair of trees for cherrypicking tests.
 
@@ -340,7 +343,7 @@
 
     def test_weave_cherrypick(self):
         this_tree, other_tree = self.prepare_cherrypick()
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             this_tree, 'rev3b', 'rev2b', other_tree.branch)
         merger.merge_type = _mod_merge.WeaveMerger
         merger.do_merge()
@@ -348,14 +351,14 @@
 
     def test_weave_cannot_reverse_cherrypick(self):
         this_tree, other_tree = self.prepare_cherrypick()
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             this_tree, 'rev2b', 'rev3b', other_tree.branch)
         merger.merge_type = _mod_merge.WeaveMerger
         self.assertRaises(errors.CannotReverseCherrypick, merger.do_merge)
 
     def test_merge3_can_reverse_cherrypick(self):
         this_tree, other_tree = self.prepare_cherrypick()
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             this_tree, 'rev2b', 'rev3b', other_tree.branch)
         merger.merge_type = _mod_merge.Merge3Merger
         merger.do_merge()
@@ -373,7 +376,7 @@
         this_tree.lock_write()
         self.addCleanup(this_tree.unlock)
 
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             this_tree, 'rev3b', 'rev2b', other_tree.branch)
         merger.merge_type = _mod_merge.Merge3Merger
         merger.do_merge()
@@ -392,7 +395,7 @@
         other_tree.commit('rev2', rev_id='rev2b')
         this_tree.lock_write()
         self.addCleanup(this_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress,
             this_tree, 'rev2b', other_branch=other_tree.branch)
         merger.merge_type = _mod_merge.Merge3Merger
         tree_merger = merger.make_merger()
@@ -412,7 +415,7 @@
         other_tree.commit('rev2', rev_id='rev2b')
         this_tree.lock_write()
         self.addCleanup(this_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             this_tree, 'rev2b', other_branch=other_tree.branch)
         merger.merge_type = _mod_merge.Merge3Merger
         tree_merger = merger.make_merger()
@@ -442,7 +445,7 @@
         other_tree.commit('rev2', rev_id='rev2b')
         this_tree.lock_write()
         self.addCleanup(this_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             this_tree, 'rev2b', other_branch=other_tree.branch)
         merger.merge_type = _mod_merge.Merge3Merger
         tree_merger = merger.make_merger()
@@ -1198,7 +1201,7 @@
         mem_tree = memorytree.MemoryTree.create_on_branch(builder.get_branch())
         mem_tree.lock_write()
         self.addCleanup(mem_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             mem_tree, other_revision_id)
         merger.set_interesting_files(interesting_files)
         # It seems there is no matching function for set_interesting_ids
@@ -1978,7 +1981,7 @@
 
     def do_merge(self, builder, other_revision_id):
         wt = self.get_wt_from_builder(builder)
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, other_revision_id)
         merger.merge_type = _mod_merge.Merge3Merger
         return wt, merger.do_merge()
@@ -2244,7 +2247,7 @@
         wt.commit('D merges B & C', rev_id='D-id')
         self.assertEqual('barry', wt.id2path('foo-id'))
         # Check the output of the Merger object directly
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'F-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2300,7 +2303,7 @@
         wt.commit('F foo => bing', rev_id='F-id')
 
         # Check the output of the Merger object directly
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'E-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2351,7 +2354,7 @@
         list(wt.iter_changes(wt.basis_tree()))
         wt.commit('D merges B & C, makes it a file', rev_id='D-id')
 
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'E-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2566,7 +2569,7 @@
         wt.branch.set_last_revision_info(2, 'B-id')
         wt.commit('D', rev_id='D-id', recursive=None)
 
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'E-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2603,7 +2606,7 @@
         wt.branch.set_last_revision_info(2, 'B-id')
         wt.commit('D', rev_id='D-id', recursive=None)
 
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'E-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2643,7 +2646,7 @@
         wt.branch.set_last_revision_info(2, 'B-id')
         wt.commit('D', rev_id='D-id', recursive=None)
 
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'E-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2688,7 +2691,7 @@
         wt.branch.set_last_revision_info(2, 'B-id')
         wt.commit('D', rev_id='D-id', recursive=None)
 
-        merger = _mod_merge.Merger.from_revision_ids(None,
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
             wt, 'E-id')
         merger.merge_type = _mod_merge.Merge3Merger
         merge_obj = merger.make_merger()
@@ -2830,90 +2833,3 @@
             'bval', ['lca1val', 'lca2val', 'lca2val'], 'oval', 'tval')
         self.assertLCAMultiWay('conflict',
             'bval', ['lca1val', 'lca2val', 'lca3val'], 'oval', 'tval')
-
-
-class TestConfigurableFileMerger(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestConfigurableFileMerger, self).setUp()
-        self.calls = []
-
-    def get_merger_factory(self):
-        # Allows  the inner methods to access the test attributes
-        test = self
-
-        class FooMerger(_mod_merge.ConfigurableFileMerger):
-            name_prefix = "foo"
-            default_files = ['bar']
-
-            def merge_text(self, params):
-                test.calls.append('merge_text')
-                return ('not_applicable', None)
-
-        def factory(merger):
-            result = FooMerger(merger)
-            # Make sure we start with a clean slate
-            self.assertEqual(None, result.affected_files)
-            # Track the original merger
-            self.merger = result
-            return result
-
-        return factory
-
-    def _install_hook(self, factory):
-        _mod_merge.Merger.hooks.install_named_hook('merge_file_content',
-                                                   factory, 'test factory')
-
-    def make_builder(self):
-        builder = test_merge_core.MergeBuilder(self.test_base_dir)
-        self.addCleanup(builder.cleanup)
-        return builder
-
-    def make_text_conflict(self, file_name='bar'):
-        factory = self.get_merger_factory()
-        self._install_hook(factory)
-        builder = self.make_builder()
-        builder.add_file('bar-id', builder.tree_root, file_name, 'text1', True)
-        builder.change_contents('bar-id', other='text4', this='text3')
-        return builder
-
-    def make_kind_change(self):
-        factory = self.get_merger_factory()
-        self._install_hook(factory)
-        builder = self.make_builder()
-        builder.add_file('bar-id', builder.tree_root, 'bar', 'text1', True,
-                         this=False)
-        builder.add_dir('bar-dir', builder.tree_root, 'bar-id',
-                        base=False, other=False)
-        return builder
-
-    def test_uses_this_branch(self):
-        builder = self.make_text_conflict()
-        tt = builder.make_preview_transform()
-        self.addCleanup(tt.finalize)
-
-    def test_affected_files_cached(self):
-        """Ensures that the config variable is cached"""
-        builder = self.make_text_conflict()
-        conflicts = builder.merge()
-        # The hook should set the variable
-        self.assertEqual(['bar'], self.merger.affected_files)
-        self.assertEqual(1, len(conflicts))
-
-    def test_hook_called_for_text_conflicts(self):
-        builder = self.make_text_conflict()
-        conflicts = builder.merge()
-        # The hook should call the merge_text() method
-        self.assertEqual(['merge_text'], self.calls)
-
-    def test_hook_not_called_for_kind_change(self):
-        builder = self.make_kind_change()
-        conflicts = builder.merge()
-        # The hook should not call the merge_text() method
-        self.assertEqual([], self.calls)
-
-    def test_hook_not_called_for_other_files(self):
-        builder = self.make_text_conflict('foobar')
-        conflicts = builder.merge()
-        # The hook should not call the merge_text() method
-        self.assertEqual([], self.calls)

=== modified file 'bzrlib/tests/test_merge3.py'
--- bzrlib/tests/test_merge3.py	2010-04-26 13:51:08 +0000
+++ bzrlib/tests/test_merge3.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,11 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-from bzrlib import (
-    errors,
-    merge3,
-    tests,
-    )
+from bzrlib.tests import TestCaseInTempDir, TestCase
 from bzrlib.merge3 import Merge3
 from bzrlib.errors import CantReprocessAndShowBase, BinaryFile
 
@@ -95,13 +91,13 @@
 >>>>>>> TAO
 """)
 
-class TestMerge3(tests.TestCase):
+class TestMerge3(TestCase):
 
     def test_no_changes(self):
         """No conflicts because nothing changed"""
-        m3 = merge3.Merge3(['aaa', 'bbb'],
-                           ['aaa', 'bbb'],
-                           ['aaa', 'bbb'])
+        m3 = Merge3(['aaa', 'bbb'],
+                    ['aaa', 'bbb'],
+                    ['aaa', 'bbb'])
 
         self.assertEquals(m3.find_unconflicted(),
                           [(0, 2)])
@@ -119,9 +115,9 @@
                           [('unchanged', ['aaa', 'bbb'])])
 
     def test_front_insert(self):
-        m3 = merge3.Merge3(['zz'],
-                           ['aaa', 'bbb', 'zz'],
-                           ['zz'])
+        m3 = Merge3(['zz'],
+                    ['aaa', 'bbb', 'zz'],
+                    ['zz'])
 
         # todo: should use a sentinal at end as from get_matching_blocks
         # to match without zz
@@ -138,9 +134,9 @@
                            ('unchanged', ['zz'])])
 
     def test_null_insert(self):
-        m3 = merge3.Merge3([],
-                           ['aaa', 'bbb'],
-                           [])
+        m3 = Merge3([],
+                    ['aaa', 'bbb'],
+                    [])
         # todo: should use a sentinal at end as from get_matching_blocks
         # to match without zz
         self.assertEquals(list(m3.find_sync_regions()),
@@ -154,9 +150,9 @@
 
     def test_no_conflicts(self):
         """No conflicts because only one side changed"""
-        m3 = merge3.Merge3(['aaa', 'bbb'],
-                           ['aaa', '111', 'bbb'],
-                           ['aaa', 'bbb'])
+        m3 = Merge3(['aaa', 'bbb'],
+                    ['aaa', '111', 'bbb'],
+                    ['aaa', 'bbb'])
 
         self.assertEquals(m3.find_unconflicted(),
                           [(0, 1), (1, 2)])
@@ -172,33 +168,33 @@
                            ('unchanged', 1, 2),])
 
     def test_append_a(self):
-        m3 = merge3.Merge3(['aaa\n', 'bbb\n'],
-                           ['aaa\n', 'bbb\n', '222\n'],
-                           ['aaa\n', 'bbb\n'])
+        m3 = Merge3(['aaa\n', 'bbb\n'],
+                    ['aaa\n', 'bbb\n', '222\n'],
+                    ['aaa\n', 'bbb\n'])
 
         self.assertEquals(''.join(m3.merge_lines()),
                           'aaa\nbbb\n222\n')
 
     def test_append_b(self):
-        m3 = merge3.Merge3(['aaa\n', 'bbb\n'],
-                           ['aaa\n', 'bbb\n'],
-                           ['aaa\n', 'bbb\n', '222\n'])
+        m3 = Merge3(['aaa\n', 'bbb\n'],
+                    ['aaa\n', 'bbb\n'],
+                    ['aaa\n', 'bbb\n', '222\n'])
 
         self.assertEquals(''.join(m3.merge_lines()),
                           'aaa\nbbb\n222\n')
 
     def test_append_agreement(self):
-        m3 = merge3.Merge3(['aaa\n', 'bbb\n'],
-                           ['aaa\n', 'bbb\n', '222\n'],
-                           ['aaa\n', 'bbb\n', '222\n'])
+        m3 = Merge3(['aaa\n', 'bbb\n'],
+                    ['aaa\n', 'bbb\n', '222\n'],
+                    ['aaa\n', 'bbb\n', '222\n'])
 
         self.assertEquals(''.join(m3.merge_lines()),
                           'aaa\nbbb\n222\n')
 
     def test_append_clash(self):
-        m3 = merge3.Merge3(['aaa\n', 'bbb\n'],
-                           ['aaa\n', 'bbb\n', '222\n'],
-                           ['aaa\n', 'bbb\n', '333\n'])
+        m3 = Merge3(['aaa\n', 'bbb\n'],
+                    ['aaa\n', 'bbb\n', '222\n'],
+                    ['aaa\n', 'bbb\n', '333\n'])
 
         ml = m3.merge_lines(name_a='a',
                             name_b='b',
@@ -217,9 +213,9 @@
 ''')
 
     def test_insert_agreement(self):
-        m3 = merge3.Merge3(['aaa\n', 'bbb\n'],
-                           ['aaa\n', '222\n', 'bbb\n'],
-                           ['aaa\n', '222\n', 'bbb\n'])
+        m3 = Merge3(['aaa\n', 'bbb\n'],
+                    ['aaa\n', '222\n', 'bbb\n'],
+                    ['aaa\n', '222\n', 'bbb\n'])
 
         ml = m3.merge_lines(name_a='a',
                             name_b='b',
@@ -231,9 +227,9 @@
 
     def test_insert_clash(self):
         """Both try to insert lines in the same place."""
-        m3 = merge3.Merge3(['aaa\n', 'bbb\n'],
-                           ['aaa\n', '111\n', 'bbb\n'],
-                           ['aaa\n', '222\n', 'bbb\n'])
+        m3 = Merge3(['aaa\n', 'bbb\n'],
+                    ['aaa\n', '111\n', 'bbb\n'],
+                    ['aaa\n', '222\n', 'bbb\n'])
 
         self.assertEquals(m3.find_unconflicted(),
                           [(0, 1), (1, 2)])
@@ -271,9 +267,9 @@
 
     def test_replace_clash(self):
         """Both try to insert lines in the same place."""
-        m3 = merge3.Merge3(['aaa', '000', 'bbb'],
-                           ['aaa', '111', 'bbb'],
-                           ['aaa', '222', 'bbb'])
+        m3 = Merge3(['aaa', '000', 'bbb'],
+                    ['aaa', '111', 'bbb'],
+                    ['aaa', '222', 'bbb'])
 
         self.assertEquals(m3.find_unconflicted(),
                           [(0, 1), (2, 3)])
@@ -285,9 +281,9 @@
 
     def test_replace_multi(self):
         """Replacement with regions of different size."""
-        m3 = merge3.Merge3(['aaa', '000', '000', 'bbb'],
-                           ['aaa', '111', '111', '111', 'bbb'],
-                           ['aaa', '222', '222', '222', '222', 'bbb'])
+        m3 = Merge3(['aaa', '000', '000', 'bbb'],
+                    ['aaa', '111', '111', '111', 'bbb'],
+                    ['aaa', '222', '222', '222', '222', 'bbb'])
 
         self.assertEquals(m3.find_unconflicted(),
                           [(0, 1), (3, 4)])
@@ -300,7 +296,7 @@
 
     def test_merge_poem(self):
         """Test case from diff3 manual"""
-        m3 = merge3.Merge3(TZU, LAO, TAO)
+        m3 = Merge3(TZU, LAO, TAO)
         ml = list(m3.merge_lines('LAO', 'TAO'))
         self.log('merge result:')
         self.log(''.join(ml))
@@ -311,7 +307,7 @@
         base_text = ("a\n" * 20).splitlines(True)
         this_text = ("a\n"*10+"b\n" * 10).splitlines(True)
         other_text = ("a\n"*10+"c\n"+"b\n" * 8 + "c\n").splitlines(True)
-        m3 = merge3.Merge3(base_text, other_text, this_text)
+        m3 = Merge3(base_text, other_text, this_text)
         m_lines = m3.merge_lines('OTHER', 'THIS', reprocess=True)
         merged_text = "".join(list(m_lines))
         optimal_text = ("a\n" * 10 + "<<<<<<< OTHER\nc\n"
@@ -327,7 +323,7 @@
         base_text = add_newline("abcdefghijklm")
         this_text = add_newline("abcdefghijklmNOPQRSTUVWXYZ")
         other_text = add_newline("abcdefghijklm1OPQRSTUVWXY2")
-        m3 = merge3.Merge3(base_text, other_text, this_text)
+        m3 = Merge3(base_text, other_text, this_text)
         m_lines = m3.merge_lines('OTHER', 'THIS', reprocess=True)
         merged_text = "".join(list(m_lines))
         optimal_text = ''.join(add_newline("abcdefghijklm")
@@ -345,7 +341,7 @@
         base_text = add_newline("abacddefgghij")
         this_text = add_newline("abacddefgghijkalmontfprz")
         other_text = add_newline("abacddefgghijknlmontfprd")
-        m3 = merge3.Merge3(base_text, other_text, this_text)
+        m3 = Merge3(base_text, other_text, this_text)
         m_lines = m3.merge_lines('OTHER', 'THIS', reprocess=True)
         merged_text = "".join(list(m_lines))
         optimal_text = ''.join(add_newline("abacddefgghijk")
@@ -360,21 +356,20 @@
         base_text = ("a\n" * 20).splitlines(True)
         this_text = ("a\n"*10+"b\n" * 10).splitlines(True)
         other_text = ("a\n"*10+"c\n"+"b\n" * 8 + "c\n").splitlines(True)
-        m3 = merge3.Merge3(base_text, other_text, this_text)
+        m3 = Merge3(base_text, other_text, this_text)
         m_lines = m3.merge_lines('OTHER', 'THIS', reprocess=True,
                                  base_marker='|||||||')
         self.assertRaises(CantReprocessAndShowBase, list, m_lines)
 
     def test_binary(self):
-        self.assertRaises(BinaryFile, merge3.Merge3, ['\x00'], ['a'], ['b'])
+        self.assertRaises(BinaryFile, Merge3, ['\x00'], ['a'], ['b'])
 
     def test_dos_text(self):
         base_text = 'a\r\n'
         this_text = 'b\r\n'
         other_text = 'c\r\n'
-        m3 = merge3.Merge3(base_text.splitlines(True),
-                           other_text.splitlines(True),
-                           this_text.splitlines(True))
+        m3 = Merge3(base_text.splitlines(True), other_text.splitlines(True),
+                    this_text.splitlines(True))
         m_lines = m3.merge_lines('OTHER', 'THIS')
         self.assertEqual('<<<<<<< OTHER\r\nc\r\n=======\r\nb\r\n'
             '>>>>>>> THIS\r\n'.splitlines(True), list(m_lines))
@@ -383,9 +378,8 @@
         base_text = 'a\r'
         this_text = 'b\r'
         other_text = 'c\r'
-        m3 = merge3.Merge3(base_text.splitlines(True),
-                           other_text.splitlines(True),
-                           this_text.splitlines(True))
+        m3 = Merge3(base_text.splitlines(True), other_text.splitlines(True),
+                    this_text.splitlines(True))
         m_lines = m3.merge_lines('OTHER', 'THIS')
         self.assertEqual('<<<<<<< OTHER\rc\r=======\rb\r'
             '>>>>>>> THIS\r'.splitlines(True), list(m_lines))
@@ -395,17 +389,15 @@
         this_text = "a\n"
         other_text = "a\nb\nc\n"
         # When cherrypicking, lines in base are not part of the conflict
-        m3 = merge3.Merge3(base_text.splitlines(True),
-                           this_text.splitlines(True),
-                           other_text.splitlines(True), is_cherrypick=True)
+        m3 = Merge3(base_text.splitlines(True), this_text.splitlines(True),
+                    other_text.splitlines(True), is_cherrypick=True)
         m_lines = m3.merge_lines()
         self.assertEqualDiff('a\n<<<<<<<\n=======\nc\n>>>>>>>\n',
                              ''.join(m_lines))
 
         # This is not symmetric
-        m3 = merge3.Merge3(base_text.splitlines(True),
-                           other_text.splitlines(True),
-                           this_text.splitlines(True), is_cherrypick=True)
+        m3 = Merge3(base_text.splitlines(True), other_text.splitlines(True),
+                    this_text.splitlines(True), is_cherrypick=True)
         m_lines = m3.merge_lines()
         self.assertEqualDiff('a\n<<<<<<<\nb\nc\n=======\n>>>>>>>\n',
                              ''.join(m_lines))
@@ -415,9 +407,8 @@
         this_text = 'a\nb\nq\n'
         other_text = 'a\nb\nc\nd\nf\ne\ng\n'
         # When cherrypicking, lines in base are not part of the conflict
-        m3 = merge3.Merge3(base_text.splitlines(True),
-                           this_text.splitlines(True),
-                           other_text.splitlines(True), is_cherrypick=True)
+        m3 = Merge3(base_text.splitlines(True), this_text.splitlines(True),
+                    other_text.splitlines(True), is_cherrypick=True)
         m_lines = m3.merge_lines()
         self.assertEqualDiff('a\n'
                              'b\n'
@@ -431,26 +422,3 @@
                              'g\n'
                              '>>>>>>>\n',
                              ''.join(m_lines))
-
-    def test_allow_objects(self):
-        """Objects other than strs may be used with Merge3 when
-        allow_objects=True.
-        
-        merge_groups and merge_regions work with non-str input.  Methods that
-        return lines like merge_lines fail.
-        """
-        base = [(x,x) for x in 'abcde']
-        a = [(x,x) for x in 'abcdef']
-        b = [(x,x) for x in 'Zabcde']
-        m3 = merge3.Merge3(base, a, b, allow_objects=True)
-        self.assertEqual(
-            [('b', 0, 1),
-             ('unchanged', 0, 5),
-             ('a', 5, 6)],
-            list(m3.merge_regions()))
-        self.assertEqual(
-            [('b', [('Z', 'Z')]),
-             ('unchanged', [(x,x) for x in 'abcde']),
-             ('a', [('f', 'f')])],
-            list(m3.merge_groups()))
-

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_merge_core.py	2009-12-18 08:22:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -73,16 +73,6 @@
                 new_file(tt)
 
     def merge(self, merge_type=Merge3Merger, interesting_ids=None, **kwargs):
-        merger = self.make_merger(merge_type, interesting_ids, **kwargs)
-        merger.do_merge()
-        return merger.cooked_conflicts
-
-    def make_preview_transform(self):
-        merger = self.make_merger(Merge3Merger, None, this_revision_tree=True)
-        return merger.make_preview_transform()
-
-    def make_merger(self, merge_type, interesting_ids,
-            this_revision_tree=False, **kwargs):
         self.base_tt.apply()
         self.base.commit('base commit')
         for tt, wt in ((self.this_tt, self.this), (self.other_tt, self.other)):
@@ -99,15 +89,9 @@
                 raise AssertionError()
         self.this.branch.fetch(self.other.branch)
         other_basis = self.other.branch.basis_tree()
-        if this_revision_tree:
-            self.this.commit('message')
-            this_tree = self.this.basis_tree()
-        else:
-            this_tree = self.this
-        merger = merge_type(this_tree, self.this, self.base, other_basis,
-                            interesting_ids=interesting_ids, do_merge=False,
-                            this_branch=self.this.branch, **kwargs)
-        return merger
+        merger = merge_type(self.this, self.this, self.base, other_basis,
+                            interesting_ids=interesting_ids, **kwargs)
+        return merger.cooked_conflicts
 
     def list_transforms(self):
         return [self.this_tt, self.base_tt, self.other_tt]
@@ -130,11 +114,10 @@
                 tt.cancel_versioning(trans_id)
                 tt.set_executability(None, trans_id)
 
-    def add_dir(self, file_id, parent, name, this=True, base=True, other=True):
-        for option, tt in self.selected_transforms(this, base, other):
-            if option is True:
-                parent_id = tt.trans_id_file_id(parent)
-                tt.new_directory(name, parent_id, file_id)
+    def add_dir(self, file_id, parent, name):
+        for tt in self.list_transforms():
+            parent_id = tt.trans_id_file_id(parent)
+            tt.new_directory(name, parent_id, file_id)
 
     def change_name(self, id, base=None, this=None, other=None):
         for val, tt in ((base, self.base_tt), (this, self.this_tt),
@@ -768,20 +751,20 @@
     def test_from_revision_ids(self):
         this, other = self.set_up_trees()
         self.assertRaises(errors.NoSuchRevision, Merger.from_revision_ids,
-                          None, this, 'rev2b')
+                          progress.DummyProgress(), this, 'rev2b')
         this.lock_write()
         self.addCleanup(this.unlock)
-        merger = Merger.from_revision_ids(None, this,
+        merger = Merger.from_revision_ids(progress.DummyProgress(), this,
             'rev2b', other_branch=other.branch)
         self.assertEqual('rev2b', merger.other_rev_id)
         self.assertEqual('rev1', merger.base_rev_id)
-        merger = Merger.from_revision_ids(None, this,
+        merger = Merger.from_revision_ids(progress.DummyProgress(), this,
             'rev2b', 'rev2a', other_branch=other.branch)
         self.assertEqual('rev2a', merger.base_rev_id)
 
     def test_from_uncommitted(self):
         this, other = self.set_up_trees()
-        merger = Merger.from_uncommitted(this, other, None)
+        merger = Merger.from_uncommitted(this, other, progress.DummyProgress())
         self.assertIs(other, merger.other_tree)
         self.assertIs(None, merger.other_rev_id)
         self.assertEqual('rev2b', merger.base_rev_id)
@@ -800,16 +783,16 @@
         other.lock_read()
         self.addCleanup(other.unlock)
         merger, verified = Merger.from_mergeable(this, md,
-            None)
+            progress.DummyProgress())
         md.patch = None
         merger, verified = Merger.from_mergeable(this, md,
-            None)
+            progress.DummyProgress())
         self.assertEqual('inapplicable', verified)
         self.assertEqual('rev3', merger.other_rev_id)
         self.assertEqual('rev1', merger.base_rev_id)
         md.base_revision_id = 'rev2b'
         merger, verified = Merger.from_mergeable(this, md,
-            None)
+            progress.DummyProgress())
         self.assertEqual('rev2b', merger.base_rev_id)
 
     def test_from_mergeable_old_merge_directive(self):
@@ -819,6 +802,6 @@
         md = merge_directive.MergeDirective.from_objects(
             other.branch.repository, 'rev3', 0, 0, 'this')
         merger, verified = Merger.from_mergeable(this, md,
-            None)
+            progress.DummyProgress())
         self.assertEqual('rev3', merger.other_rev_id)
         self.assertEqual('rev1', merger.base_rev_id)

=== modified file 'bzrlib/tests/test_msgeditor.py'
--- bzrlib/tests/test_msgeditor.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_msgeditor.py	2009-11-17 23:05:04 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -360,6 +360,9 @@
             msgeditor.generate_commit_message_template(commit_obj))
 
     def test_generate_commit_message_template_hook(self):
+        def restoreDefaults():
+            msgeditor.hooks['commit_message_template'] = []
+        self.addCleanup(restoreDefaults)
         msgeditor.hooks.install_named_hook("commit_message_template",
                 lambda commit_obj, msg: "save me some typing\n", None)
         commit_obj = commit.Commit()

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2010-04-20 08:47:38 +0000
+++ bzrlib/tests/test_options.py	2009-05-23 21:01:51 +0000
@@ -318,13 +318,6 @@
         self.assertEqual('hello', name)
         self.assertEqual([], value)
 
-    def test_list_option_param_name(self):
-        """Test list options can have their param_name set."""
-        options = [option.ListOption('hello', type=str, param_name='greeting')]
-        opts, args = self.parse(
-            options, ['--hello=world', '--hello=sailor'])
-        self.assertEqual(['world', 'sailor'], opts.greeting)
-
 
 class TestOptionDefinitions(TestCase):
     """Tests for options in the Bazaar codebase."""

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-04-27 07:52:08 +0000
+++ bzrlib/tests/test_osutils.py	2009-12-22 17:09:13 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,7 +33,6 @@
     win32utils,
     )
 from bzrlib.tests import (
-    features,
     file_utils,
     test__walkdirs_win32,
     )
@@ -184,13 +183,6 @@
         shape = sorted(os.listdir('.'))
         self.assertEquals(['A', 'B'], shape)
 
-    def test_rename_error(self):
-        # We wrap os.rename to make it give an error including the filenames
-        # https://bugs.launchpad.net/bzr/+bug/491763
-        err = self.assertRaises(OSError, osutils.rename,
-            'nonexistent', 'target')
-        self.assertContainsString(str(err), 'nonexistent')
-
 
 class TestRandChars(tests.TestCase):
 
@@ -317,9 +309,7 @@
         self.assertEqual("/", osutils.kind_marker(osutils._directory_kind))
         self.assertEqual("@", osutils.kind_marker("symlink"))
         self.assertEqual("+", osutils.kind_marker("tree-reference"))
-        self.assertEqual("", osutils.kind_marker("fifo"))
-        self.assertEqual("", osutils.kind_marker("socket"))
-        self.assertEqual("", osutils.kind_marker("unknown"))
+        self.assertRaises(errors.BzrError, osutils.kind_marker, "unknown")
 
 
 class TestUmask(tests.TestCaseInTempDir):
@@ -1145,9 +1135,14 @@
             dirblock[:] = new_dirblock
 
     def _save_platform_info(self):
-        self.overrideAttr(win32utils, 'winver')
-        self.overrideAttr(osutils, '_fs_enc')
-        self.overrideAttr(osutils, '_selected_dir_reader')
+        cur_winver = win32utils.winver
+        cur_fs_enc = osutils._fs_enc
+        cur_dir_reader = osutils._selected_dir_reader
+        def restore():
+            win32utils.winver = cur_winver
+            osutils._fs_enc = cur_fs_enc
+            osutils._selected_dir_reader = cur_dir_reader
+        self.addCleanup(restore)
 
     def assertDirReaderIs(self, expected):
         """Assert the right implementation for _walkdirs_utf8 is chosen."""
@@ -1586,6 +1581,7 @@
         def cleanup():
             if 'BZR_TEST_ENV_VAR' in os.environ:
                 del os.environ['BZR_TEST_ENV_VAR']
+
         self.addCleanup(cleanup)
 
     def test_set(self):
@@ -1702,8 +1698,15 @@
 
     def setUp(self):
         tests.TestCaseInTempDir.setUp(self)
-        self.overrideAttr(osutils,
-                          '_selected_dir_reader', self._dir_reader_class())
+
+        # Save platform specific info and reset it
+        cur_dir_reader = osutils._selected_dir_reader
+
+        def restore():
+            osutils._selected_dir_reader = cur_dir_reader
+        self.addCleanup(restore)
+
+        osutils._selected_dir_reader = self._dir_reader_class()
 
     def _get_ascii_tree(self):
         tree = [
@@ -1856,7 +1859,10 @@
 
     def setUp(self):
         super(TestConcurrency, self).setUp()
-        self.overrideAttr(osutils, '_cached_local_concurrency')
+        orig = osutils._cached_local_concurrency
+        def restore():
+            osutils._cached_local_concurrency = orig
+        self.addCleanup(restore)
 
     def test_local_concurrency(self):
         concurrency = osutils.local_concurrency()
@@ -1889,7 +1895,12 @@
 
     def setUp(self):
         super(TestFailedToLoadExtension, self).setUp()
-        self.overrideAttr(osutils, '_extension_load_failures', [])
+        self.saved_failures = osutils._extension_load_failures[:]
+        del osutils._extension_load_failures[:]
+        self.addCleanup(self.restore_failures)
+
+    def restore_failures(self):
+        osutils._extension_load_failures = self.saved_failures
 
     def test_failure_to_load(self):
         self._try_loading()
@@ -1918,10 +1929,18 @@
 class TestTerminalWidth(tests.TestCase):
 
     def replace_stdout(self, new):
-        self.overrideAttr(sys, 'stdout', new)
+        orig_stdout = sys.stdout
+        def restore():
+            sys.stdout = orig_stdout
+        self.addCleanup(restore)
+        sys.stdout = new
 
     def replace__terminal_size(self, new):
-        self.overrideAttr(osutils, '_terminal_size', new)
+        orig__terminal_size = osutils._terminal_size
+        def restore():
+            osutils._terminal_size = orig__terminal_size
+        self.addCleanup(restore)
+        osutils._terminal_size = new
 
     def set_fake_tty(self):
 
@@ -1977,44 +1996,11 @@
             # We won't remove TIOCGWINSZ, because it doesn't exist anyway :)
             pass
         else:
-            self.overrideAttr(termios, 'TIOCGWINSZ')
+            def restore():
+                termios.TIOCGWINSZ = orig
+            self.addCleanup(restore)
             del termios.TIOCGWINSZ
         del os.environ['BZR_COLUMNS']
         del os.environ['COLUMNS']
         # Whatever the result is, if we don't raise an exception, it's ok.
         osutils.terminal_width()
-
-class TestCreationOps(tests.TestCaseInTempDir):
-    _test_needs_features = [features.chown_feature]
-
-    def setUp(self):
-        tests.TestCaseInTempDir.setUp(self)
-        self.overrideAttr(os, 'chown', self._dummy_chown)
-
-        # params set by call to _dummy_chown
-        self.path = self.uid = self.gid = None
-
-    def _dummy_chown(self, path, uid, gid):
-        self.path, self.uid, self.gid = path, uid, gid
-
-    def test_copy_ownership_from_path(self):
-        """copy_ownership_from_path test with specified src."""
-        ownsrc = '/'
-        f = open('test_file', 'wt')
-        osutils.copy_ownership_from_path('test_file', ownsrc)
-
-        s = os.stat(ownsrc)
-        self.assertEquals(self.path, 'test_file')
-        self.assertEquals(self.uid, s.st_uid)
-        self.assertEquals(self.gid, s.st_gid)
-
-    def test_copy_ownership_nonesrc(self):
-        """copy_ownership_from_path test with src=None."""
-        f = open('test_file', 'wt')
-        # should use parent dir for permissions
-        osutils.copy_ownership_from_path('test_file')
-
-        s = os.stat('..')
-        self.assertEquals(self.path, 'test_file')
-        self.assertEquals(self.uid, s.st_uid)
-        self.assertEquals(self.gid, s.st_gid)

=== modified file 'bzrlib/tests/test_osutils_encodings.py'
--- bzrlib/tests/test_osutils_encodings.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/test_osutils_encodings.py	2009-03-23 14:59:43 +0000
@@ -75,10 +75,12 @@
 
     def setUp(self):
         TestCase.setUp(self)
-        self.overrideAttr(sys, 'stdin')
-        self.overrideAttr(sys, 'stdout')
-        self.overrideAttr(sys, 'stderr')
-        self.overrideAttr(osutils, '_cached_user_encoding')
+        self._stdout = sys.stdout
+        self._stderr = sys.stderr
+        self._stdin = sys.stdin
+        self._user_encoding = osutils._cached_user_encoding
+
+        self.addCleanup(self._reset)
 
     def make_wrapped_streams(self,
                              stdout_encoding,
@@ -98,6 +100,12 @@
             fake_codec.add(stderr_encoding)
             fake_codec.add(stdin_encoding)
 
+    def _reset(self):
+        sys.stdout = self._stdout
+        sys.stderr = self._stderr
+        sys.stdin = self._stdin
+        osutils._cached_user_encoding = self._user_encoding
+
     def test_get_terminal_encoding(self):
         self.make_wrapped_streams('stdout_encoding',
                                   'stderr_encoding',
@@ -150,10 +158,18 @@
 
     def setUp(self):
         TestCase.setUp(self)
-        self.overrideAttr(locale, 'getpreferredencoding')
-        self.addCleanup(osutils.set_or_unset_env,
-                        'LANG', os.environ.get('LANG'))
-        self.overrideAttr(sys, 'stderr', StringIOWrapper())
+        self._stderr = sys.stderr
+        self._getpreferredencoding = locale.getpreferredencoding
+        self.addCleanup(self._reset)
+        sys.stderr = StringIOWrapper()
+        # save $LANG
+        self._LANG = os.environ.get('LANG')
+
+    def _reset(self):
+        locale.getpreferredencoding = self._getpreferredencoding
+        sys.stderr = self._stderr
+        # restore $LANG
+        osutils.set_or_unset_env('LANG', self._LANG)
 
     def test_get_user_encoding(self):
         def f():

=== modified file 'bzrlib/tests/test_patches.py'
--- bzrlib/tests/test_patches.py	2010-02-25 06:17:27 +0000
+++ bzrlib/tests/test_patches.py	2009-11-03 15:45:56 +0000
@@ -1,4 +1,5 @@
-# Copyright (C) 2005-2010 Aaron Bentley, Canonical Ltd
+# Copyright (C) 2004 - 2008 Aaron Bentley, Canonical Ltd
+# <aaron.bentley@utoronto.ca>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,14 +55,6 @@
         finally:
             datafile.close()
 
-    def test_parse_patches_leading_noise(self):
-        # https://bugs.edge.launchpad.net/bzr/+bug/502076
-        # https://code.edge.launchpad.net/~toshio/bzr/allow-dirty-patches/+merge/18854
-        lines = ["diff -pruN commands.py",
-            "--- orig/commands.py",
-            "+++ mod/dommands.py"]
-        bits = parse_patches(iter(lines), allow_dirty=True)
-
     def testValidPatchHeader(self):
         """Parse a valid patch header"""
         lines = "--- orig/commands.py\n+++ mod/dommands.py\n".split('\n')

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2010-04-20 22:38:03 +0000
+++ bzrlib/tests/test_plugins.py	2009-09-18 14:53:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,75 +20,41 @@
 # affects the global state of the process.  See bzrlib/plugins.py for more
 # comments.
 
-from cStringIO import StringIO
 import logging
 import os
+from StringIO import StringIO
 import sys
+import zipfile
 
-import bzrlib
 from bzrlib import (
     osutils,
     plugin,
-    plugins,
     tests,
-    trace,
-    )
-
+    )
+import bzrlib.plugin
+import bzrlib.plugins
+import bzrlib.commands
+import bzrlib.help
+from bzrlib.tests import (
+    TestCase,
+    TestCaseInTempDir,
+    TestUtil,
+    )
+from bzrlib.osutils import pathjoin, abspath, normpath
+
+
+PLUGIN_TEXT = """\
+import bzrlib.commands
+class cmd_myplug(bzrlib.commands.Command):
+    '''Just a simple test plugin.'''
+    aliases = ['mplg']
+    def run(self):
+        print 'Hello from my plugin'
+"""
 
 # TODO: Write a test for plugin decoration of commands.
 
-class TestPluginMixin(object):
-
-    def create_plugin(self, name, source=None, dir='.', file_name=None):
-        if source is None:
-            source = '''\
-"""This is the doc for %s"""
-''' % (name)
-        if file_name is None:
-            file_name = name + '.py'
-        # 'source' must not fail to load
-        path = osutils.pathjoin(dir, file_name)
-        f = open(path, 'w')
-        self.addCleanup(os.unlink, path)
-        try:
-            f.write(source + '\n')
-        finally:
-            f.close()
-
-    def create_plugin_package(self, name, dir=None, source=None):
-        if dir is None:
-            dir = name
-        if source is None:
-            source = '''\
-"""This is the doc for %s"""
-dir_source = '%s'
-''' % (name, dir)
-        os.makedirs(dir)
-        def cleanup():
-            # Workaround lazy import random? madness
-            osutils.rmtree(dir)
-        self.addCleanup(cleanup)
-        self.create_plugin(name, source, dir,
-                           file_name='__init__.py')
-
-    def _unregister_plugin(self, name):
-        """Remove the plugin from sys.modules and the bzrlib namespace."""
-        py_name = 'bzrlib.plugins.%s' % name
-        if py_name in sys.modules:
-            del sys.modules[py_name]
-        if getattr(bzrlib.plugins, name, None) is not None:
-            delattr(bzrlib.plugins, name)
-
-    def assertPluginUnknown(self, name):
-        self.failIf(getattr(bzrlib.plugins, name, None) is not None)
-        self.failIf('bzrlib.plugins.%s' % name in sys.modules)
-
-    def assertPluginKnown(self, name):
-        self.failUnless(getattr(bzrlib.plugins, name, None) is not None)
-        self.failUnless('bzrlib.plugins.%s' % name in sys.modules)
-
-
-class TestLoadingPlugins(tests.TestCaseInTempDir, TestPluginMixin):
+class TestLoadingPlugins(TestCaseInTempDir):
 
     activeattributes = {}
 
@@ -102,7 +68,8 @@
         # set a place for the plugins to record their loading, and at the same
         # time validate that the location the plugins should record to is
         # valid and correct.
-        self.__class__.activeattributes [tempattribute] = []
+        bzrlib.tests.test_plugins.TestLoadingPlugins.activeattributes \
+            [tempattribute] = []
         self.failUnless(tempattribute in self.activeattributes)
         # create two plugin directories
         os.mkdir('first')
@@ -132,12 +99,13 @@
         finally:
             # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
-            self._unregister_plugin('plugin')
-        self.assertPluginUnknown('plugin')
+            if 'bzrlib.plugins.plugin' in sys.modules:
+                del sys.modules['bzrlib.plugins.plugin']
+            if getattr(bzrlib.plugins, 'plugin', None):
+                del bzrlib.plugins.plugin
+        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
 
     def test_plugins_from_different_dirs_can_demand_load(self):
-        self.failIf('bzrlib.plugins.pluginone' in sys.modules)
-        self.failIf('bzrlib.plugins.plugintwo' in sys.modules)
         # This test tests that having two plugins in different
         # directories with different names allows them both to be loaded, when
         # we do a direct import statement.
@@ -175,8 +143,6 @@
 
         oldpath = bzrlib.plugins.__path__
         try:
-            self.failIf('bzrlib.plugins.pluginone' in sys.modules)
-            self.failIf('bzrlib.plugins.plugintwo' in sys.modules)
             bzrlib.plugins.__path__ = ['first', 'second']
             exec "import bzrlib.plugins.pluginone"
             self.assertEqual(['first'], self.activeattributes[tempattribute])
@@ -186,16 +152,18 @@
         finally:
             # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
-            self._unregister_plugin('pluginone')
-            self._unregister_plugin('plugintwo')
-        self.assertPluginUnknown('pluginone')
-        self.assertPluginUnknown('plugintwo')
+            if getattr(bzrlib.plugins, 'pluginone', None):
+                del bzrlib.plugins.pluginone
+            if getattr(bzrlib.plugins, 'plugintwo', None):
+                del bzrlib.plugins.plugintwo
+        self.failIf(getattr(bzrlib.plugins, 'pluginone', None))
+        self.failIf(getattr(bzrlib.plugins, 'plugintwo', None))
 
     def test_plugins_can_load_from_directory_with_trailing_slash(self):
         # This test tests that a plugin can load from a directory when the
         # directory in the path has a trailing slash.
         # check the plugin is not loaded already
-        self.assertPluginUnknown('ts_plugin')
+        self.failIf(getattr(bzrlib.plugins, 'ts_plugin', None))
         tempattribute = "trailing-slash"
         self.failIf(tempattribute in self.activeattributes)
         # set a place for the plugin to record its loading, and at the same
@@ -222,9 +190,11 @@
             bzrlib.plugin.load_from_path(['plugin_test'+os.sep])
             self.assertEqual(['plugin'], self.activeattributes[tempattribute])
         finally:
+            # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
-            self._unregister_plugin('ts_plugin')
-        self.assertPluginUnknown('ts_plugin')
+            if getattr(bzrlib.plugins, 'ts_plugin', None):
+                del bzrlib.plugins.ts_plugin
+        self.failIf(getattr(bzrlib.plugins, 'ts_plugin', None))
 
     def load_and_capture(self, name):
         """Load plugins from '.' capturing the output.
@@ -281,102 +251,105 @@
             "it to 'bad_plugin_name_'\.")
 
 
-class TestPlugins(tests.TestCaseInTempDir, TestPluginMixin):
+class TestPlugins(TestCaseInTempDir):
 
     def setup_plugin(self, source=""):
         # This test tests a new plugin appears in bzrlib.plugin.plugins().
         # check the plugin is not loaded already
-        self.assertPluginUnknown('plugin')
+        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
         # write a plugin that _cannot_ fail to load.
         file('plugin.py', 'w').write(source + '\n')
         self.addCleanup(self.teardown_plugin)
-        plugin.load_from_path(['.'])
+        bzrlib.plugin.load_from_path(['.'])
 
     def teardown_plugin(self):
-        self._unregister_plugin('plugin')
-        self.assertPluginUnknown('plugin')
+        # remove the plugin 'plugin'
+        if 'bzrlib.plugins.plugin' in sys.modules:
+            del sys.modules['bzrlib.plugins.plugin']
+        if getattr(bzrlib.plugins, 'plugin', None):
+            del bzrlib.plugins.plugin
+        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
 
     def test_plugin_appears_in_plugins(self):
         self.setup_plugin()
-        self.assertPluginKnown('plugin')
-        p = plugin.plugins()['plugin']
-        self.assertIsInstance(p, bzrlib.plugin.PlugIn)
-        self.assertEqual(p.module, plugins.plugin)
+        self.failUnless('plugin' in bzrlib.plugin.plugins())
+        self.failUnless(getattr(bzrlib.plugins, 'plugin', None))
+        plugins = bzrlib.plugin.plugins()
+        plugin = plugins['plugin']
+        self.assertIsInstance(plugin, bzrlib.plugin.PlugIn)
+        self.assertEqual(bzrlib.plugins.plugin, plugin.module)
 
     def test_trivial_plugin_get_path(self):
         self.setup_plugin()
-        p = plugin.plugins()['plugin']
+        plugins = bzrlib.plugin.plugins()
+        plugin = plugins['plugin']
         plugin_path = self.test_dir + '/plugin.py'
-        self.assertIsSameRealPath(plugin_path, osutils.normpath(p.path()))
+        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
 
     def test_plugin_get_path_py_not_pyc(self):
-        # first import creates plugin.pyc
-        self.setup_plugin()
+        self.setup_plugin()         # after first import there will be plugin.pyc
         self.teardown_plugin()
-        plugin.load_from_path(['.']) # import plugin.pyc
-        p = plugin.plugins()['plugin']
+        bzrlib.plugin.load_from_path(['.']) # import plugin.pyc
+        plugins = bzrlib.plugin.plugins()
+        plugin = plugins['plugin']
         plugin_path = self.test_dir + '/plugin.py'
-        self.assertIsSameRealPath(plugin_path, osutils.normpath(p.path()))
+        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
 
     def test_plugin_get_path_pyc_only(self):
-        # first import creates plugin.pyc (or plugin.pyo depending on __debug__)
-        self.setup_plugin()
+        self.setup_plugin()         # after first import there will be plugin.pyc
         self.teardown_plugin()
         os.unlink(self.test_dir + '/plugin.py')
-        plugin.load_from_path(['.']) # import plugin.pyc (or .pyo)
-        p = plugin.plugins()['plugin']
+        bzrlib.plugin.load_from_path(['.']) # import plugin.pyc
+        plugins = bzrlib.plugin.plugins()
+        plugin = plugins['plugin']
         if __debug__:
             plugin_path = self.test_dir + '/plugin.pyc'
         else:
             plugin_path = self.test_dir + '/plugin.pyo'
-        self.assertIsSameRealPath(plugin_path, osutils.normpath(p.path()))
+        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
 
     def test_no_test_suite_gives_None_for_test_suite(self):
         self.setup_plugin()
-        p = plugin.plugins()['plugin']
-        self.assertEqual(None, p.test_suite())
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual(None, plugin.test_suite())
 
     def test_test_suite_gives_test_suite_result(self):
         source = """def test_suite(): return 'foo'"""
         self.setup_plugin(source)
-        p = plugin.plugins()['plugin']
-        self.assertEqual('foo', p.test_suite())
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual('foo', plugin.test_suite())
 
     def test_no_load_plugin_tests_gives_None_for_load_plugin_tests(self):
         self.setup_plugin()
-        loader = tests.TestUtil.TestLoader()
-        p = plugin.plugins()['plugin']
-        self.assertEqual(None, p.load_plugin_tests(loader))
+        loader = TestUtil.TestLoader()
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual(None, plugin.load_plugin_tests(loader))
 
     def test_load_plugin_tests_gives_load_plugin_tests_result(self):
         source = """
 def load_tests(standard_tests, module, loader):
     return 'foo'"""
         self.setup_plugin(source)
-        loader = tests.TestUtil.TestLoader()
-        p = plugin.plugins()['plugin']
-        self.assertEqual('foo', p.load_plugin_tests(loader))
-
-    def check_version_info(self, expected, source='', name='plugin'):
-        self.setup_plugin(source)
-        self.assertEqual(expected, plugin.plugins()[name].version_info())
+        loader = TestUtil.TestLoader()
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual('foo', plugin.load_plugin_tests(loader))
 
     def test_no_version_info(self):
-        self.check_version_info(None)
+        self.setup_plugin()
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual(None, plugin.version_info())
 
     def test_with_version_info(self):
-        self.check_version_info((1, 2, 3, 'dev', 4),
-                                "version_info = (1, 2, 3, 'dev', 4)")
+        self.setup_plugin("version_info = (1, 2, 3, 'dev', 4)")
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual((1, 2, 3, 'dev', 4), plugin.version_info())
 
     def test_short_version_info_gets_padded(self):
         # the gtk plugin has version_info = (1,2,3) rather than the 5-tuple.
         # so we adapt it
-        self.check_version_info((1, 2, 3, 'final', 0),
-                                "version_info = (1, 2, 3)")
-
-    def check_version(self, expected, source=None, name='plugin'):
-        self.setup_plugin(source)
-        self.assertEqual(expected, plugins[name].__version__)
+        self.setup_plugin("version_info = (1, 2, 3)")
+        plugin = bzrlib.plugin.plugins()['plugin']
+        self.assertEqual((1, 2, 3, 'final', 0), plugin.version_info())
 
     def test_no_version_info___version__(self):
         self.setup_plugin()
@@ -434,7 +407,7 @@
         self.assertEqual("1.2.3.final.2", plugin.__version__)
 
 
-class TestPluginHelp(tests.TestCaseInTempDir):
+class TestPluginHelp(TestCaseInTempDir):
 
     def split_help_commands(self):
         help = {}
@@ -469,17 +442,8 @@
     def test_plugin_help_shows_plugin(self):
         # Create a test plugin
         os.mkdir('plugin_test')
-        f = open(osutils.pathjoin('plugin_test', 'myplug.py'), 'w')
-        f.write("""\
-from bzrlib import commands
-class cmd_myplug(commands.Command):
-    __doc__ = '''Just a simple test plugin.'''
-    aliases = ['mplg']
-    def run(self):
-        print 'Hello from my plugin'
-
-"""
-)
+        f = open(pathjoin('plugin_test', 'myplug.py'), 'w')
+        f.write(PLUGIN_TEXT)
         f.close()
 
         try:
@@ -611,12 +575,26 @@
 
     def setUp(self):
         super(TestLoadFromPath, self).setUp()
+        # Save the attributes that we're about to monkey-patch.
+        old_plugins_path = bzrlib.plugins.__path__
+        old_loaded = plugin._loaded
+        old_load_from_path = plugin.load_from_path
+
+        def restore():
+            bzrlib.plugins.__path__ = old_plugins_path
+            plugin._loaded = old_loaded
+            plugin.load_from_path = old_load_from_path
+
+        self.addCleanup(restore)
+
         # Change bzrlib.plugin to think no plugins have been loaded yet.
-        self.overrideAttr(bzrlib.plugins, '__path__', [])
-        self.overrideAttr(plugin, '_loaded', False)
+        bzrlib.plugins.__path__ = []
+        plugin._loaded = False
 
         # Monkey-patch load_from_path to stop it from actually loading anything.
-        self.overrideAttr(plugin, 'load_from_path', lambda dirs: None)
+        def load_from_path(dirs):
+            pass
+        plugin.load_from_path = load_from_path
 
     def test_set_plugins_path_with_args(self):
         plugin.set_plugins_path(['a', 'b'])
@@ -663,11 +641,18 @@
         self.assertEqual(path, bzrlib.plugins.__path__)
 
 
-class TestEnvPluginPath(tests.TestCase):
+class TestEnvPluginPath(tests.TestCaseInTempDir):
 
     def setUp(self):
         super(TestEnvPluginPath, self).setUp()
-        self.overrideAttr(plugin, 'DEFAULT_PLUGIN_PATH', None)
+        old_default = plugin.DEFAULT_PLUGIN_PATH
+
+        def restore():
+            plugin.DEFAULT_PLUGIN_PATH = old_default
+
+        self.addCleanup(restore)
+
+        plugin.DEFAULT_PLUGIN_PATH = None
 
         self.user = plugin.get_user_plugin_path()
         self.site = plugin.get_site_plugin_path()
@@ -716,13 +701,13 @@
         self.check_path([self.user, self.core, self.site],
                         ['+user', '+user'])
         # And only the first reference is kept (since the later references will
-        # only produce '<plugin> already loaded' mutters)
+        # onnly produce <plugin> already loaded mutters)
         self.check_path([self.user, self.core, self.site],
                         ['+user', '+user', '+core',
                          '+user', '+site', '+site',
                          '+core'])
 
-    def test_disable_overrides_enable(self):
+    def test_disable_overrides_disable(self):
         self.check_path([self.core, self.site], ['-user', '+user'])
 
     def test_disable_core(self):
@@ -755,141 +740,3 @@
     def test_bogus_references(self):
         self.check_path(['+foo', '-bar', self.core, self.site],
                         ['+foo', '-bar'])
-
-
-class TestDisablePlugin(tests.TestCaseInTempDir, TestPluginMixin):
-
-    def setUp(self):
-        super(TestDisablePlugin, self).setUp()
-        self.create_plugin_package('test_foo')
-        # Make sure we don't pollute the plugins namespace
-        self.overrideAttr(plugins, '__path__')
-        # Be paranoid in case a test fail
-        self.addCleanup(self._unregister_plugin, 'test_foo')
-
-    def test_cannot_import(self):
-        osutils.set_or_unset_env('BZR_DISABLE_PLUGINS', 'test_foo')
-        plugin.set_plugins_path(['.'])
-        try:
-            import bzrlib.plugins.test_foo
-        except ImportError:
-            pass
-        self.assertPluginUnknown('test_foo')
-
-    def test_regular_load(self):
-        self.overrideAttr(plugin, '_loaded', False)
-        plugin.load_plugins(['.'])
-        self.assertPluginKnown('test_foo')
-        self.assertDocstring("This is the doc for test_foo",
-                             bzrlib.plugins.test_foo)
-
-    def test_not_loaded(self):
-        self.warnings = []
-        def captured_warning(*args, **kwargs):
-            self.warnings.append((args, kwargs))
-        self.overrideAttr(trace, 'warning', captured_warning)
-        # Reset the flag that protect against double loading
-        self.overrideAttr(plugin, '_loaded', False)
-        osutils.set_or_unset_env('BZR_DISABLE_PLUGINS', 'test_foo')
-        plugin.load_plugins(['.'])
-        self.assertPluginUnknown('test_foo')
-        # Make sure we don't warn about the plugin ImportError since this has
-        # been *requested* by the user.
-        self.assertLength(0, self.warnings)
-
-
-class TestLoadPluginAt(tests.TestCaseInTempDir, TestPluginMixin):
-
-    def setUp(self):
-        super(TestLoadPluginAt, self).setUp()
-        # Make sure we don't pollute the plugins namespace
-        self.overrideAttr(plugins, '__path__')
-        # Be paranoid in case a test fail
-        self.addCleanup(self._unregister_plugin, 'test_foo')
-        # Reset the flag that protect against double loading
-        self.overrideAttr(plugin, '_loaded', False)
-        # Create the same plugin in two directories
-        self.create_plugin_package('test_foo', dir='non-standard-dir')
-        # The "normal" directory, we use 'standard' instead of 'plugins' to
-        # avoid depending on the precise naming.
-        self.create_plugin_package('test_foo', dir='standard/test_foo')
-
-    def assertTestFooLoadedFrom(self, path):
-        self.assertPluginKnown('test_foo')
-        self.assertDocstring('This is the doc for test_foo',
-                             bzrlib.plugins.test_foo)
-        self.assertEqual(path, bzrlib.plugins.test_foo.dir_source)
-
-    def test_regular_load(self):
-        plugin.load_plugins(['standard'])
-        self.assertTestFooLoadedFrom('standard/test_foo')
-
-    def test_import(self):
-        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
-        plugin.set_plugins_path(['standard'])
-        try:
-            import bzrlib.plugins.test_foo
-        except ImportError:
-            pass
-        self.assertTestFooLoadedFrom('non-standard-dir')
-
-    def test_loading(self):
-        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
-        plugin.load_plugins(['standard'])
-        self.assertTestFooLoadedFrom('non-standard-dir')
-
-    def test_compiled_loaded(self):
-        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
-        plugin.load_plugins(['standard'])
-        self.assertTestFooLoadedFrom('non-standard-dir')
-        self.assertEqual('non-standard-dir/__init__.py',
-                         bzrlib.plugins.test_foo.__file__)
-
-        # Try importing again now that the source has been compiled
-        self._unregister_plugin('test_foo')
-        plugin._loaded = False
-        plugin.load_plugins(['standard'])
-        self.assertTestFooLoadedFrom('non-standard-dir')
-        if __debug__:
-            suffix = 'pyc'
-        else:
-            suffix = 'pyo'
-        self.assertEqual('non-standard-dir/__init__.%s' % suffix,
-                         bzrlib.plugins.test_foo.__file__)
-
-    def test_submodule_loading(self):
-        # We create an additional directory under the one for test_foo
-        self.create_plugin_package('test_bar', dir='non-standard-dir/test_bar')
-        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
-        plugin.set_plugins_path(['standard'])
-        import bzrlib.plugins.test_foo
-        self.assertEqual('bzrlib.plugins.test_foo',
-                         bzrlib.plugins.test_foo.__package__)
-        import bzrlib.plugins.test_foo.test_bar
-        self.assertEqual('non-standard-dir/test_bar/__init__.py',
-                         bzrlib.plugins.test_foo.test_bar.__file__)
-
-    def test_loading_from___init__only(self):
-        # We rename the existing __init__.py file to ensure that we don't load
-        # a random file
-        init = 'non-standard-dir/__init__.py'
-        random = 'non-standard-dir/setup.py'
-        os.rename(init, random)
-        self.addCleanup(os.rename, random, init)
-        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
-        plugin.load_plugins(['standard'])
-        self.assertPluginUnknown('test_foo')
-
-    def test_loading_from_specific_file(self):
-        plugin_dir = 'non-standard-dir'
-        plugin_file_name = 'iamtestfoo.py'
-        plugin_path = osutils.pathjoin(plugin_dir, plugin_file_name)
-        source = '''\
-"""This is the doc for %s"""
-dir_source = '%s'
-''' % ('test_foo', plugin_path)
-        self.create_plugin('test_foo', source=source,
-                           dir=plugin_dir, file_name=plugin_file_name)
-        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@%s' % plugin_path)
-        plugin.load_plugins(['standard'])
-        self.assertTestFooLoadedFrom(plugin_path)

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_progress.py	2009-12-09 07:58:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/test_remote.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,14 +54,13 @@
     )
 from bzrlib.repofmt import groupcompress_repo, pack_repo
 from bzrlib.revision import NULL_REVISION
-from bzrlib.smart import medium
+from bzrlib.smart import server, medium
 from bzrlib.smart.client import _SmartClient
 from bzrlib.smart.repository import SmartServerRepositoryGetParentMap
 from bzrlib.tests import (
     condition_isinstance,
     split_suite_by_condition,
     multiply_tests,
-    test_server,
     )
 from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryTransport
@@ -76,9 +75,9 @@
         standard_tests, condition_isinstance(BasicRemoteObjectTests))
     smart_server_version_scenarios = [
         ('HPSS-v2',
-         {'transport_server': test_server.SmartTCPServer_for_testing_v2_only}),
+            {'transport_server': server.SmartTCPServer_for_testing_v2_only}),
         ('HPSS-v3',
-         {'transport_server': test_server.SmartTCPServer_for_testing})]
+            {'transport_server': server.SmartTCPServer_for_testing})]
     return multiply_tests(to_adapt, smart_server_version_scenarios, result)
 
 
@@ -135,10 +134,6 @@
         b = BzrDir.open_from_transport(self.transport).open_branch()
         self.assertStartsWith(str(b), 'RemoteBranch(')
 
-    def test_remote_bzrdir_repr(self):
-        b = BzrDir.open_from_transport(self.transport)
-        self.assertStartsWith(str(b), 'RemoteBzrDir(')
-
     def test_remote_branch_format_supports_stacking(self):
         t = self.transport
         self.make_branch('unstackable', format='pack-0.92')
@@ -418,12 +413,9 @@
         # Calling _remember_remote_is_before again with a lower value works.
         client_medium._remember_remote_is_before((1, 5))
         self.assertTrue(client_medium._is_remote_before((1, 5)))
-        # If you call _remember_remote_is_before with a higher value it logs a
-        # warning, and continues to remember the lower value.
-        self.assertNotContainsRe(self.get_log(), '_remember_remote_is_before')
-        client_medium._remember_remote_is_before((1, 9))
-        self.assertContainsRe(self.get_log(), '_remember_remote_is_before')
-        self.assertTrue(client_medium._is_remote_before((1, 5)))
+        # You cannot call _remember_remote_is_before with a larger value.
+        self.assertRaises(
+            AssertionError, client_medium._remember_remote_is_before, (1, 9))
 
 
 class TestBzrDirCloningMetaDir(TestRemote):
@@ -448,7 +440,7 @@
             'BzrDir.cloning_metadir', ('quack/', 'False'),
             'error', ('BranchReference',)),
         client.add_expected_call(
-            'BzrDir.open_branchV3', ('quack/',),
+            'BzrDir.open_branchV2', ('quack/',),
             'success', ('ref', self.get_url('referenced'))),
         a_bzrdir = RemoteBzrDir(transport, remote.RemoteBzrDirFormat(),
             _client=client)
@@ -531,28 +523,6 @@
         self.assertIsInstance(bd, RemoteBzrDir)
         self.assertFinished(client)
 
-    def test_backwards_compat_hpss_v2(self):
-        client, transport = self.make_fake_client_and_transport()
-        # Monkey-patch fake client to simulate real-world behaviour with v2
-        # server: upon first RPC call detect the protocol version, and because
-        # the version is 2 also do _remember_remote_is_before((1, 6)) before
-        # continuing with the RPC.
-        orig_check_call = client._check_call
-        def check_call(method, args):
-            client._medium._protocol_version = 2
-            client._medium._remember_remote_is_before((1, 6))
-            client._check_call = orig_check_call
-            client._check_call(method, args)
-        client._check_call = check_call
-        client.add_expected_call(
-            'BzrDir.open_2.1', ('quack/',), 'unknown', ('BzrDir.open_2.1',))
-        client.add_expected_call(
-            'BzrDir.open', ('quack/',), 'success', ('yes',))
-        bd = RemoteBzrDir(transport, remote.RemoteBzrDirFormat(),
-            _client=client, _force_probe=True)
-        self.assertIsInstance(bd, RemoteBzrDir)
-        self.assertFinished(client)
-
 
 class TestBzrDirOpenBranch(TestRemote):
 
@@ -561,7 +531,7 @@
         self.make_branch('.')
         a_dir = BzrDir.open(self.get_url('.'))
         self.reset_smart_call_log()
-        verb = 'BzrDir.open_branchV3'
+        verb = 'BzrDir.open_branchV2'
         self.disable_verb(verb)
         format = a_dir.open_branch()
         call_count = len([call for call in self.hpss_calls if
@@ -577,7 +547,7 @@
         transport = transport.clone('quack')
         client = FakeClient(transport.base)
         client.add_expected_call(
-            'BzrDir.open_branchV3', ('quack/',),
+            'BzrDir.open_branchV2', ('quack/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('quack/',),
@@ -602,7 +572,7 @@
             _client=client)
         self.assertRaises(errors.NotBranchError, bzrdir.open_branch)
         self.assertEqual(
-            [('call', 'BzrDir.open_branchV3', ('quack/',))],
+            [('call', 'BzrDir.open_branchV2', ('quack/',))],
             client._calls)
 
     def test__get_tree_branch(self):
@@ -632,7 +602,7 @@
         network_name = reference_format.network_name()
         branch_network_name = self.get_branch_format().network_name()
         client.add_expected_call(
-            'BzrDir.open_branchV3', ('~hello/',),
+            'BzrDir.open_branchV2', ('~hello/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('~hello/',),
@@ -1220,7 +1190,7 @@
         client = FakeClient(self.get_url())
         branch_network_name = self.get_branch_format().network_name()
         client.add_expected_call(
-            'BzrDir.open_branchV3', ('stacked/',),
+            'BzrDir.open_branchV2', ('stacked/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('stacked/',),
@@ -1248,19 +1218,19 @@
             len(branch.repository._real_repository._fallback_repositories))
 
     def test_get_stacked_on_real_branch(self):
-        base_branch = self.make_branch('base')
-        stacked_branch = self.make_branch('stacked')
+        base_branch = self.make_branch('base', format='1.6')
+        stacked_branch = self.make_branch('stacked', format='1.6')
         stacked_branch.set_stacked_on_url('../base')
         reference_format = self.get_repo_format()
         network_name = reference_format.network_name()
         client = FakeClient(self.get_url())
         branch_network_name = self.get_branch_format().network_name()
         client.add_expected_call(
-            'BzrDir.open_branchV3', ('stacked/',),
+            'BzrDir.open_branchV2', ('stacked/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('stacked/',),
-            'success', ('ok', '', 'yes', 'no', 'yes', network_name))
+            'success', ('ok', '', 'no', 'no', 'yes', network_name))
         # called twice, once from constructor and then again by us
         client.add_expected_call(
             'Branch.get_stacked_on_url', ('stacked/',),
@@ -2034,8 +2004,11 @@
         self.assertLength(1, self.hpss_calls)
 
     def disableExtraResults(self):
-        self.overrideAttr(SmartServerRepositoryGetParentMap,
-                          'no_extra_results', True)
+        old_flag = SmartServerRepositoryGetParentMap.no_extra_results
+        SmartServerRepositoryGetParentMap.no_extra_results = True
+        def reset_values():
+            SmartServerRepositoryGetParentMap.no_extra_results = old_flag
+        self.addCleanup(reset_values)
 
     def test_null_cached_missing_and_stop_key(self):
         self.setup_smart_server_with_call_log()
@@ -2100,7 +2073,7 @@
 
     def test_allows_new_revisions(self):
         """get_parent_map's results can be updated by commit."""
-        smart_server = test_server.SmartTCPServer_for_testing()
+        smart_server = server.SmartTCPServer_for_testing()
         self.start_server(smart_server)
         self.make_branch('branch')
         branch = Branch.open(smart_server.get_url() + '/branch')
@@ -2216,13 +2189,12 @@
         """
         # Make a repo with a fallback repo, both using a FakeClient.
         format = remote.response_tuple_to_repo_format(
-            ('yes', 'no', 'yes', self.get_repo_format().network_name()))
+            ('yes', 'no', 'yes', 'fake-network-name'))
         repo, client = self.setup_fake_client_and_repository('quack')
         repo._format = format
         fallback_repo, ignored = self.setup_fake_client_and_repository(
             'fallback')
         fallback_repo._client = client
-        fallback_repo._format = format
         repo.add_fallback_repository(fallback_repo)
         # First the client should ask the primary repo
         client.add_expected_call(
@@ -2649,7 +2621,7 @@
     """RemoteRepository.copy_content_into optimizations"""
 
     def test_copy_content_remote_to_local(self):
-        self.transport_server = test_server.SmartTCPServer_for_testing
+        self.transport_server = server.SmartTCPServer_for_testing
         src_repo = self.make_repository('repo1')
         src_repo = repository.Repository.open(self.get_url('repo1'))
         # At the moment the tarball-based copy_content_into can't write back
@@ -2803,15 +2775,6 @@
         expected_error = errors.NotBranchError(path=bzrdir.root_transport.base)
         self.assertEqual(expected_error, translated_error)
 
-    def test_nobranch_one_arg(self):
-        bzrdir = self.make_bzrdir('')
-        translated_error = self.translateTuple(
-            ('nobranch', 'extra detail'), bzrdir=bzrdir)
-        expected_error = errors.NotBranchError(
-            path=bzrdir.root_transport.base,
-            detail='extra detail')
-        self.assertEqual(expected_error, translated_error)
-
     def test_LockContention(self):
         translated_error = self.translateTuple(('LockContention',))
         expected_error = errors.LockContention('(remote lock)')
@@ -2968,7 +2931,7 @@
         stacked_branch = self.make_branch('stacked', format='1.9')
         stacked_branch.set_stacked_on_url('../base')
         # start a server looking at this
-        smart_server = test_server.SmartTCPServer_for_testing()
+        smart_server = server.SmartTCPServer_for_testing()
         self.start_server(smart_server)
         remote_bzrdir = BzrDir.open(smart_server.get_url() + '/stacked')
         # can get its branch and repository
@@ -3130,7 +3093,7 @@
         super(TestRemoteBranchEffort, self).setUp()
         # Create a smart server that publishes whatever the backing VFS server
         # does.
-        self.smart_server = test_server.SmartTCPServer_for_testing()
+        self.smart_server = server.SmartTCPServer_for_testing()
         self.start_server(self.smart_server, self.get_server())
         # Log all HPSS calls into self.hpss_calls.
         _SmartClient.hooks.install_named_hook(

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/test_repository.py	2010-01-04 06:56:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,10 +23,12 @@
 """
 
 from stat import S_ISDIR
+from StringIO import StringIO
 import sys
 
 import bzrlib
-from bzrlib.errors import (NoSuchFile,
+from bzrlib.errors import (NotBranchError,
+                           NoSuchFile,
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
@@ -34,25 +36,33 @@
     graph,
     tests,
     )
+from bzrlib.branchbuilder import BranchBuilder
 from bzrlib.btree_index import BTreeBuilder, BTreeGraphIndex
-from bzrlib.index import GraphIndex
+from bzrlib.index import GraphIndex, InMemoryGraphIndex
 from bzrlib.repository import RepositoryFormat
+from bzrlib.smart import server
 from bzrlib.tests import (
     TestCase,
     TestCaseWithTransport,
+    TestSkipped,
+    test_knit,
     )
 from bzrlib.transport import (
+    fakenfs,
     get_transport,
     )
+from bzrlib.transport.memory import MemoryServer
 from bzrlib import (
+    bencode,
     bzrdir,
     errors,
     inventory,
     osutils,
+    progress,
     repository,
     revision as _mod_revision,
+    symbol_versioning,
     upgrade,
-    versionedfile,
     workingtree,
     )
 from bzrlib.repofmt import (
@@ -454,7 +464,7 @@
         repo = self.make_repository('.',
                 format=bzrdir.format_registry.get('knit')())
         inv_xml = '<inventory format="5">\n</inventory>\n'
-        inv = repo._deserialise_inventory('test-rev-id', inv_xml)
+        inv = repo.deserialise_inventory('test-rev-id', inv_xml)
         self.assertEqual('test-rev-id', inv.root.revision)
 
     def test_deserialise_uses_global_revision_id(self):
@@ -466,9 +476,9 @@
         # Arguably, the deserialise_inventory should detect a mismatch, and
         # raise an error, rather than silently using one revision_id over the
         # other.
-        self.assertRaises(AssertionError, repo._deserialise_inventory,
+        self.assertRaises(AssertionError, repo.deserialise_inventory,
             'test-rev-id', inv_xml)
-        inv = repo._deserialise_inventory('other-rev-id', inv_xml)
+        inv = repo.deserialise_inventory('other-rev-id', inv_xml)
         self.assertEqual('other-rev-id', inv.root.revision)
 
     def test_supports_external_lookups(self):
@@ -1133,31 +1143,6 @@
         packs.ensure_loaded()
         return tree, r, packs, [rev1, rev2, rev3]
 
-    def test__clear_obsolete_packs(self):
-        packs = self.get_packs()
-        obsolete_pack_trans = packs.transport.clone('obsolete_packs')
-        obsolete_pack_trans.put_bytes('a-pack.pack', 'content\n')
-        obsolete_pack_trans.put_bytes('a-pack.rix', 'content\n')
-        obsolete_pack_trans.put_bytes('a-pack.iix', 'content\n')
-        obsolete_pack_trans.put_bytes('another-pack.pack', 'foo\n')
-        obsolete_pack_trans.put_bytes('not-a-pack.rix', 'foo\n')
-        res = packs._clear_obsolete_packs()
-        self.assertEqual(['a-pack', 'another-pack'], sorted(res))
-        self.assertEqual([], obsolete_pack_trans.list_dir('.'))
-
-    def test__clear_obsolete_packs_preserve(self):
-        packs = self.get_packs()
-        obsolete_pack_trans = packs.transport.clone('obsolete_packs')
-        obsolete_pack_trans.put_bytes('a-pack.pack', 'content\n')
-        obsolete_pack_trans.put_bytes('a-pack.rix', 'content\n')
-        obsolete_pack_trans.put_bytes('a-pack.iix', 'content\n')
-        obsolete_pack_trans.put_bytes('another-pack.pack', 'foo\n')
-        obsolete_pack_trans.put_bytes('not-a-pack.rix', 'foo\n')
-        res = packs._clear_obsolete_packs(preserve=set(['a-pack']))
-        self.assertEqual(['a-pack', 'another-pack'], sorted(res))
-        self.assertEqual(['a-pack.iix', 'a-pack.pack', 'a-pack.rix'],
-                         sorted(obsolete_pack_trans.list_dir('.')))
-
     def test__max_pack_count(self):
         """The maximum pack count is a function of the number of revisions."""
         # no revisions - one pack, so that we can have a revision free repo
@@ -1188,28 +1173,6 @@
         self.assertContainsRe(repr(packs),
             'RepositoryPackCollection(.*Repository(.*))')
 
-    def test__obsolete_packs(self):
-        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
-        names = packs.names()
-        pack = packs.get_pack_by_name(names[0])
-        # Schedule this one for removal
-        packs._remove_pack_from_memory(pack)
-        # Simulate a concurrent update by renaming the .pack file and one of
-        # the indices
-        packs.transport.rename('packs/%s.pack' % (names[0],),
-                               'obsolete_packs/%s.pack' % (names[0],))
-        packs.transport.rename('indices/%s.iix' % (names[0],),
-                               'obsolete_packs/%s.iix' % (names[0],))
-        # Now trigger the obsoletion, and ensure that all the remaining files
-        # are still renamed
-        packs._obsolete_packs([pack])
-        self.assertEqual([n + '.pack' for n in names[1:]],
-                         sorted(packs._pack_transport.list_dir('.')))
-        # names[0] should not be present in the index anymore
-        self.assertEqual(names[1:],
-            sorted(set([osutils.splitext(n)[0] for n in
-                        packs._index_transport.list_dir('.')])))
-
     def test_pack_distribution_zero(self):
         packs = self.get_packs()
         self.assertEqual([0], packs.pack_distribution(0))
@@ -1383,60 +1346,6 @@
         self.assertEqual({revs[-1]:(revs[-2],)}, r.get_parent_map([revs[-1]]))
         self.assertFalse(packs.reload_pack_names())
 
-    def test_reload_pack_names_preserves_pending(self):
-        # TODO: Update this to also test for pending-deleted names
-        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
-        # We will add one pack (via start_write_group + insert_record_stream),
-        # and remove another pack (via _remove_pack_from_memory)
-        orig_names = packs.names()
-        orig_at_load = packs._packs_at_load
-        to_remove_name = iter(orig_names).next()
-        r.start_write_group()
-        self.addCleanup(r.abort_write_group)
-        r.texts.insert_record_stream([versionedfile.FulltextContentFactory(
-            ('text', 'rev'), (), None, 'content\n')])
-        new_pack = packs._new_pack
-        self.assertTrue(new_pack.data_inserted())
-        new_pack.finish()
-        packs.allocate(new_pack)
-        packs._new_pack = None
-        removed_pack = packs.get_pack_by_name(to_remove_name)
-        packs._remove_pack_from_memory(removed_pack)
-        names = packs.names()
-        all_nodes, deleted_nodes, new_nodes, _ = packs._diff_pack_names()
-        new_names = set([x[0][0] for x in new_nodes])
-        self.assertEqual(names, sorted([x[0][0] for x in all_nodes]))
-        self.assertEqual(set(names) - set(orig_names), new_names)
-        self.assertEqual(set([new_pack.name]), new_names)
-        self.assertEqual([to_remove_name],
-                         sorted([x[0][0] for x in deleted_nodes]))
-        packs.reload_pack_names()
-        reloaded_names = packs.names()
-        self.assertEqual(orig_at_load, packs._packs_at_load)
-        self.assertEqual(names, reloaded_names)
-        all_nodes, deleted_nodes, new_nodes, _ = packs._diff_pack_names()
-        new_names = set([x[0][0] for x in new_nodes])
-        self.assertEqual(names, sorted([x[0][0] for x in all_nodes]))
-        self.assertEqual(set(names) - set(orig_names), new_names)
-        self.assertEqual(set([new_pack.name]), new_names)
-        self.assertEqual([to_remove_name],
-                         sorted([x[0][0] for x in deleted_nodes]))
-
-    def test_autopack_obsoletes_new_pack(self):
-        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
-        packs._max_pack_count = lambda x: 1
-        packs.pack_distribution = lambda x: [10]
-        r.start_write_group()
-        r.revisions.insert_record_stream([versionedfile.FulltextContentFactory(
-            ('bogus-rev',), (), None, 'bogus-content\n')])
-        # This should trigger an autopack, which will combine everything into a
-        # single pack file.
-        new_names = r.commit_write_group()
-        names = packs.names()
-        self.assertEqual(1, len(names))
-        self.assertEqual([names[0] + '.pack'],
-                         packs._pack_transport.list_dir('.'))
-
     def test_autopack_reloads_and_stops(self):
         tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
         # After we have determined what needs to be autopacked, trigger a
@@ -1454,38 +1363,6 @@
         self.assertEqual(tree.branch.repository._pack_collection.names(),
                          packs.names())
 
-    def test__save_pack_names(self):
-        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
-        names = packs.names()
-        pack = packs.get_pack_by_name(names[0])
-        packs._remove_pack_from_memory(pack)
-        packs._save_pack_names(obsolete_packs=[pack])
-        cur_packs = packs._pack_transport.list_dir('.')
-        self.assertEqual([n + '.pack' for n in names[1:]], sorted(cur_packs))
-        # obsolete_packs will also have stuff like .rix and .iix present.
-        obsolete_packs = packs.transport.list_dir('obsolete_packs')
-        obsolete_names = set([osutils.splitext(n)[0] for n in obsolete_packs])
-        self.assertEqual([pack.name], sorted(obsolete_names))
-
-    def test__save_pack_names_already_obsoleted(self):
-        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
-        names = packs.names()
-        pack = packs.get_pack_by_name(names[0])
-        packs._remove_pack_from_memory(pack)
-        # We are going to simulate a concurrent autopack by manually obsoleting
-        # the pack directly.
-        packs._obsolete_packs([pack])
-        packs._save_pack_names(clear_obsolete_packs=True,
-                               obsolete_packs=[pack])
-        cur_packs = packs._pack_transport.list_dir('.')
-        self.assertEqual([n + '.pack' for n in names[1:]], sorted(cur_packs))
-        # Note that while we set clear_obsolete_packs=True, it should not
-        # delete a pack file that we have also scheduled for obsoletion.
-        obsolete_packs = packs.transport.list_dir('obsolete_packs')
-        obsolete_names = set([osutils.splitext(n)[0] for n in obsolete_packs])
-        self.assertEqual([pack.name], sorted(obsolete_names))
-
-
 
 class TestPack(TestCaseWithTransport):
     """Tests for the Pack object."""

=== modified file 'bzrlib/tests/test_revert.py'
--- bzrlib/tests/test_revert.py	2010-01-11 22:27:17 +0000
+++ bzrlib/tests/test_revert.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -157,14 +157,3 @@
         self.failUnlessExists('dir/file1')
         self.failIfExists('dir/file2')
         self.assertEqual('dir-id', tree.path2id('dir'))
-
-    def test_revert_root_id_change(self):
-        tree = self.make_branch_and_tree('.')
-        tree.set_root_id('initial-root-id')
-        self.build_tree(['file1'])
-        tree.add(['file1'])
-        tree.commit('first')
-        tree.set_root_id('temp-root-id')
-        self.assertEqual('temp-root-id', tree.get_root_id())
-        tree.revert()
-        self.assertEqual('initial-root-id', tree.get_root_id())

=== modified file 'bzrlib/tests/test_revisionspec.py'
--- bzrlib/tests/test_revisionspec.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_revisionspec.py	2009-10-10 05:07:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_revisiontree.py'
--- bzrlib/tests/test_revisiontree.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_revisiontree.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -18,11 +18,9 @@
 """Tests for the RevisionTree class."""
 
 from bzrlib import (
-    errors,
     revision,
     )
 import bzrlib
-from bzrlib.inventory import ROOT_ID
 from bzrlib.tests import TestCaseWithTransport
 
 
@@ -61,9 +59,3 @@
         null_tree = self.t.branch.repository.revision_tree(
             revision.NULL_REVISION)
         self.assertIs(None, null_tree.inventory.root)
-
-    def test_get_file_mtime_ghost(self):
-        file_id = iter(self.rev_tree).next()
-        self.rev_tree.inventory[file_id].revision = 'ghostrev'
-        self.assertRaises(errors.FileTimestampUnavailable, 
-            self.rev_tree.get_file_mtime, file_id)

=== modified file 'bzrlib/tests/test_script.py'
--- bzrlib/tests/test_script.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_script.py	2009-11-08 20:28:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -407,43 +407,3 @@
 $ rm -r dir
 """)
         self.failIfExists('dir')
-
-
-class TestMv(script.TestCaseWithTransportAndScript):
-
-    def test_usage(self):
-        self.assertRaises(SyntaxError, self.run_script, '$ mv')
-        self.assertRaises(SyntaxError, self.run_script, '$ mv f')
-        self.assertRaises(SyntaxError, self.run_script, '$ mv f1 f2 f3')
-
-    def test_move_file(self):
-        self.run_script('$ echo content >file')
-        self.failUnlessExists('file')
-        self.run_script('$ mv file new_name')
-        self.failIfExists('file')
-        self.failUnlessExists('new_name')
-
-    def test_move_unknown_file(self):
-        self.assertRaises(AssertionError,
-                          self.run_script, '$ mv unknown does-not-exist')
-
-    def test_move_dir(self):
-        self.run_script("""
-$ mkdir dir
-$ echo content >dir/file
-""")
-        self.run_script('$ mv dir new_name')
-        self.failIfExists('dir')
-        self.failUnlessExists('new_name')
-        self.failUnlessExists('new_name/file')
-
-    def test_move_file_into_dir(self):
-        self.run_script("""
-$ mkdir dir
-$ echo content > file
-""")
-        self.run_script('$ mv file dir')
-        self.failUnlessExists('dir')
-        self.failIfExists('file')
-        self.failUnlessExists('dir/file')
-

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2010-04-22 18:36:13 +0000
+++ bzrlib/tests/test_selftest.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,12 +63,11 @@
 from bzrlib.tests import (
     features,
     test_lsprof,
-    test_server,
     test_sftp_transport,
     TestUtil,
     )
 from bzrlib.trace import note
-from bzrlib.transport import memory
+from bzrlib.transport.memory import MemoryServer, MemoryTransport
 from bzrlib.version import _get_bzr_source_tree
 
 
@@ -622,8 +621,9 @@
 
     def test_get_readonly_url_none(self):
         from bzrlib.transport import get_transport
+        from bzrlib.transport.memory import MemoryServer
         from bzrlib.transport.readonly import ReadonlyTransportDecorator
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = MemoryServer
         self.transport_readonly_server = None
         # calling get_readonly_transport() constructs a decorator on the url
         # for the server
@@ -638,8 +638,9 @@
     def test_get_readonly_url_http(self):
         from bzrlib.tests.http_server import HttpServer
         from bzrlib.transport import get_transport
+        from bzrlib.transport.local import LocalURLServer
         from bzrlib.transport.http import HttpTransportBase
-        self.transport_server = test_server.LocalURLServer
+        self.transport_server = LocalURLServer
         self.transport_readonly_server = HttpServer
         # calling get_readonly_transport() gives us a HTTP server instance.
         url = self.get_readonly_url()
@@ -676,13 +677,13 @@
 
     def setUp(self):
         super(TestTestCaseTransports, self).setUp()
-        self.vfs_transport_factory = memory.MemoryServer
+        self.vfs_transport_factory = MemoryServer
 
     def test_make_bzrdir_preserves_transport(self):
         t = self.get_transport()
         result_bzrdir = self.make_bzrdir('subdir')
         self.assertIsInstance(result_bzrdir.transport,
-                              memory.MemoryTransport)
+                              MemoryTransport)
         # should not be on disk, should only be in memory
         self.failIfExists('subdir')
 
@@ -753,7 +754,13 @@
     def _patch_get_bzr_source_tree(self):
         # Reading from the actual source tree breaks isolation, but we don't
         # want to assume that thats *all* that would happen.
-        self.overrideAttr(bzrlib.version, '_get_bzr_source_tree', lambda: None)
+        def _get_bzr_source_tree():
+            return None
+        orig_get_bzr_source_tree = bzrlib.version._get_bzr_source_tree
+        bzrlib.version._get_bzr_source_tree = _get_bzr_source_tree
+        def restore():
+            bzrlib.version._get_bzr_source_tree = orig_get_bzr_source_tree
+        self.addCleanup(restore)
 
     def test_assigned_benchmark_file_stores_date(self):
         self._patch_get_bzr_source_tree()
@@ -1050,7 +1057,7 @@
             '(?sm)^bzr selftest.*$'
             '.*'
             '^======================================================================\n'
-            '^FAIL: failing_test\n'
+            '^FAIL: unittest.FunctionTestCase \\(failing_test\\)\n'
             '^----------------------------------------------------------------------\n'
             'Traceback \\(most recent call last\\):\n'
             '  .*' # File .*, line .*, in failing_test' - but maybe not from .pyc
@@ -1194,10 +1201,14 @@
         # Reading from the actual source tree breaks isolation, but we don't
         # want to assume that thats *all* that would happen.
         self._get_source_tree_calls = []
-        def new_get():
+        def _get_bzr_source_tree():
             self._get_source_tree_calls.append("called")
             return None
-        self.overrideAttr(bzrlib.version, '_get_bzr_source_tree',  new_get)
+        orig_get_bzr_source_tree = bzrlib.version._get_bzr_source_tree
+        bzrlib.version._get_bzr_source_tree = _get_bzr_source_tree
+        def restore():
+            bzrlib.version._get_bzr_source_tree = orig_get_bzr_source_tree
+        self.addCleanup(restore)
 
     def test_bench_history(self):
         # tests that the running the benchmark passes bench_history into
@@ -1311,7 +1322,12 @@
         self.assertEqual(flags, bzrlib.debug.debug_flags)
 
     def change_selftest_debug_flags(self, new_flags):
-        self.overrideAttr(tests, 'selftest_debug_flags', set(new_flags))
+        orig_selftest_flags = tests.selftest_debug_flags
+        self.addCleanup(self._restore_selftest_debug_flags, orig_selftest_flags)
+        tests.selftest_debug_flags = set(new_flags)
+
+    def _restore_selftest_debug_flags(self, flags):
+        tests.selftest_debug_flags = flags
 
     def test_allow_debug_flag(self):
         """The -Eallow_debug flag prevents bzrlib.debug.debug_flags from being
@@ -1468,7 +1484,7 @@
         # permitted.
         # Manually set one up (TestCase doesn't and shouldn't provide magic
         # machinery)
-        transport_server = memory.MemoryServer()
+        transport_server = MemoryServer()
         transport_server.start_server()
         self.addCleanup(transport_server.stop_server)
         t = transport.get_transport(transport_server.get_url())
@@ -1556,7 +1572,7 @@
             result.calls)
 
     def test_start_server_registers_url(self):
-        transport_server = memory.MemoryServer()
+        transport_server = MemoryServer()
         # A little strict, but unlikely to be changed soon.
         self.assertEqual([], self._bzr_selftest_roots)
         self.start_server(transport_server)
@@ -1618,42 +1634,6 @@
         self.assertRaises(AssertionError,
             self.assertListRaises, _TestException, success_generator)
 
-    def test_overrideAttr_without_value(self):
-        self.test_attr = 'original' # Define a test attribute
-        obj = self # Make 'obj' visible to the embedded test
-        class Test(tests.TestCase):
-
-            def setUp(self):
-                tests.TestCase.setUp(self)
-                self.orig = self.overrideAttr(obj, 'test_attr')
-
-            def test_value(self):
-                self.assertEqual('original', self.orig)
-                self.assertEqual('original', obj.test_attr)
-                obj.test_attr = 'modified'
-                self.assertEqual('modified', obj.test_attr)
-
-        test = Test('test_value')
-        test.run(unittest.TestResult())
-        self.assertEqual('original', obj.test_attr)
-
-    def test_overrideAttr_with_value(self):
-        self.test_attr = 'original' # Define a test attribute
-        obj = self # Make 'obj' visible to the embedded test
-        class Test(tests.TestCase):
-
-            def setUp(self):
-                tests.TestCase.setUp(self)
-                self.orig = self.overrideAttr(obj, 'test_attr', new='modified')
-
-            def test_value(self):
-                self.assertEqual('original', self.orig)
-                self.assertEqual('modified', obj.test_attr)
-
-        test = Test('test_value')
-        test.run(unittest.TestResult())
-        self.assertEqual('original', obj.test_attr)
-
 
 # NB: Don't delete this; it's not actually from 0.11!
 @deprecated_function(deprecated_in((0, 11, 0)))
@@ -1803,7 +1783,8 @@
         # make_branch_and_tree has to use local branch and repositories
         # when the vfs transport and local disk are colocated, even if
         # a different transport is in use for url generation.
-        self.transport_server = test_server.FakeVFATServer
+        from bzrlib.transport.fakevfat import FakeVFATServer
+        self.transport_server = FakeVFATServer
         self.assertFalse(self.get_url('t1').startswith('file://'))
         tree = self.make_branch_and_tree('t1')
         base = tree.bzrdir.root_transport.base
@@ -1946,11 +1927,10 @@
 
     def test_transport_sftp(self):
         self.requireFeature(features.paramiko)
-        from bzrlib.tests import stub_sftp
-        self.check_transport_set(stub_sftp.SFTPAbsoluteServer)
+        self.check_transport_set(bzrlib.transport.sftp.SFTPAbsoluteServer)
 
     def test_transport_memory(self):
-        self.check_transport_set(memory.MemoryServer)
+        self.check_transport_set(bzrlib.transport.memory.MemoryServer)
 
 
 class TestSelftestWithIdList(tests.TestCaseInTempDir, SelfTestHelper):
@@ -2399,11 +2379,9 @@
 
 
 simple_thunk_feature = tests._CompatabilityThunkFeature(
-    deprecated_in((2, 1, 0)),
-    'bzrlib.tests.test_selftest',
-    'simple_thunk_feature','UnicodeFilename',
-    replacement_module='bzrlib.tests'
-    )
+    'bzrlib.tests', 'UnicodeFilename',
+    'bzrlib.tests.test_selftest.simple_thunk_feature',
+    deprecated_in((2,1,0)))
 
 class Test_CompatibilityFeature(tests.TestCase):
 
@@ -2414,7 +2392,7 @@
             simple_thunk_feature.available)
         self.assertEqual(tests.UnicodeFilename.available(), res)
 
-
+        
 class TestModuleAvailableFeature(tests.TestCase):
 
     def test_available_module(self):
@@ -2621,7 +2599,7 @@
         # Running bzr in blackbox mode, normal/expected/user errors should be
         # caught in the regular way and turned into an error message plus exit
         # code.
-        transport_server = memory.MemoryServer()
+        transport_server = MemoryServer()
         transport_server.start_server()
         self.addCleanup(transport_server.stop_server)
         url = transport_server.get_url()
@@ -2773,10 +2751,6 @@
         # Test that a plausible list of modules to doctest is returned
         # by _test_suite_modules_to_doctest.
         test_list = tests._test_suite_modules_to_doctest()
-        if __doc__ is None:
-            # When docstrings are stripped, there are no modules to doctest
-            self.assertEqual([], test_list)
-            return
         self.assertSubset([
             'bzrlib.timestamp',
             ],
@@ -2789,34 +2763,35 @@
         # test doubles that supply a few sample tests to load, and check they
         # are loaded.
         calls = []
-        def testmod_names():
+        def _test_suite_testmod_names():
             calls.append("testmod_names")
             return [
                 'bzrlib.tests.blackbox.test_branch',
                 'bzrlib.tests.per_transport',
                 'bzrlib.tests.test_selftest',
                 ]
-        self.overrideAttr(tests, '_test_suite_testmod_names', testmod_names)
-        def doctests():
+        original_testmod_names = tests._test_suite_testmod_names
+        def _test_suite_modules_to_doctest():
             calls.append("modules_to_doctest")
-            if __doc__ is None:
-                return []
             return ['bzrlib.timestamp']
-        self.overrideAttr(tests, '_test_suite_modules_to_doctest', doctests)
+        orig_modules_to_doctest = tests._test_suite_modules_to_doctest
+        def restore_names():
+            tests._test_suite_testmod_names = original_testmod_names
+            tests._test_suite_modules_to_doctest = orig_modules_to_doctest
+        self.addCleanup(restore_names)
+        tests._test_suite_testmod_names = _test_suite_testmod_names
+        tests._test_suite_modules_to_doctest = _test_suite_modules_to_doctest
         expected_test_list = [
             # testmod_names
             'bzrlib.tests.blackbox.test_branch.TestBranch.test_branch',
             ('bzrlib.tests.per_transport.TransportTests'
              '.test_abspath(LocalTransport,LocalURLServer)'),
             'bzrlib.tests.test_selftest.TestTestSuite.test_test_suite',
+            # modules_to_doctest
+            'bzrlib.timestamp.format_highres_date',
             # plugins can't be tested that way since selftest may be run with
             # --no-plugins
             ]
-        if __doc__ is not None:
-            expected_test_list.extend([
-                # modules_to_doctest
-                'bzrlib.timestamp.format_highres_date',
-                ])
         suite = tests.test_suite()
         self.assertEqual(set(["testmod_names", "modules_to_doctest"]),
             set(calls))

=== removed file 'bzrlib/tests/test_server.py'
--- bzrlib/tests/test_server.py	2010-02-11 09:21:45 +0000
+++ bzrlib/tests/test_server.py	1970-01-01 00:00:00 +0000
@@ -1,312 +0,0 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-from bzrlib import (
-    transport,
-    urlutils,
-    )
-from bzrlib.transport import (
-    chroot,
-    pathfilter,
-    )
-from bzrlib.smart import server
-
-
-class TestServer(transport.Server):
-    """A Transport Server dedicated to tests.
-
-    The TestServer interface provides a server for a given transport. We use
-    these servers as loopback testing tools. For any given transport the
-    Servers it provides must either allow writing, or serve the contents
-    of os.getcwdu() at the time start_server is called.
-
-    Note that these are real servers - they must implement all the things
-    that we want bzr transports to take advantage of.
-    """
-
-    def get_url(self):
-        """Return a url for this server.
-
-        If the transport does not represent a disk directory (i.e. it is
-        a database like svn, or a memory only transport, it should return
-        a connection to a newly established resource for this Server.
-        Otherwise it should return a url that will provide access to the path
-        that was os.getcwdu() when start_server() was called.
-
-        Subsequent calls will return the same resource.
-        """
-        raise NotImplementedError
-
-    def get_bogus_url(self):
-        """Return a url for this protocol, that will fail to connect.
-
-        This may raise NotImplementedError to indicate that this server cannot
-        provide bogus urls.
-        """
-        raise NotImplementedError
-
-
-class LocalURLServer(TestServer):
-    """A pretend server for local transports, using file:// urls.
-
-    Of course no actual server is required to access the local filesystem, so
-    this just exists to tell the test code how to get to it.
-    """
-
-    def start_server(self):
-        pass
-
-    def get_url(self):
-        """See Transport.Server.get_url."""
-        return urlutils.local_path_to_url('')
-
-
-class DecoratorServer(TestServer):
-    """Server for the TransportDecorator for testing with.
-
-    To use this when subclassing TransportDecorator, override override the
-    get_decorator_class method.
-    """
-
-    def start_server(self, server=None):
-        """See bzrlib.transport.Server.start_server.
-
-        :server: decorate the urls given by server. If not provided a
-        LocalServer is created.
-        """
-        if server is not None:
-            self._made_server = False
-            self._server = server
-        else:
-            self._made_server = True
-            self._server = LocalURLServer()
-            self._server.start_server()
-
-    def stop_server(self):
-        if self._made_server:
-            self._server.stop_server()
-
-    def get_decorator_class(self):
-        """Return the class of the decorators we should be constructing."""
-        raise NotImplementedError(self.get_decorator_class)
-
-    def get_url_prefix(self):
-        """What URL prefix does this decorator produce?"""
-        return self.get_decorator_class()._get_url_prefix()
-
-    def get_bogus_url(self):
-        """See bzrlib.transport.Server.get_bogus_url."""
-        return self.get_url_prefix() + self._server.get_bogus_url()
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        return self.get_url_prefix() + self._server.get_url()
-
-
-class BrokenRenameServer(DecoratorServer):
-    """Server for the BrokenRenameTransportDecorator for testing with."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import brokenrename
-        return brokenrename.BrokenRenameTransportDecorator
-
-
-class FakeNFSServer(DecoratorServer):
-    """Server for the FakeNFSTransportDecorator for testing with."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import fakenfs
-        return fakenfs.FakeNFSTransportDecorator
-
-
-class FakeVFATServer(DecoratorServer):
-    """A server that suggests connections through FakeVFATTransportDecorator
-
-    For use in testing.
-    """
-
-    def get_decorator_class(self):
-        from bzrlib.transport import fakevfat
-        return fakevfat.FakeVFATTransportDecorator
-
-
-class LogDecoratorServer(DecoratorServer):
-    """Server for testing."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import log
-        return log.TransportLogDecorator
-
-
-class NoSmartTransportServer(DecoratorServer):
-    """Server for the NoSmartTransportDecorator for testing with."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import nosmart
-        return nosmart.NoSmartTransportDecorator
-
-
-class ReadonlyServer(DecoratorServer):
-    """Server for the ReadonlyTransportDecorator for testing with."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import readonly
-        return readonly.ReadonlyTransportDecorator
-
-
-class TraceServer(DecoratorServer):
-    """Server for the TransportTraceDecorator for testing with."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import trace
-        return trace.TransportTraceDecorator
-
-
-class UnlistableServer(DecoratorServer):
-    """Server for the UnlistableTransportDecorator for testing with."""
-
-    def get_decorator_class(self):
-        from bzrlib.transport import unlistable
-        return unlistable.UnlistableTransportDecorator
-
-
-class TestingPathFilteringServer(pathfilter.PathFilteringServer):
-
-    def __init__(self):
-        """TestingPathFilteringServer is not usable until start_server
-        is called."""
-
-    def start_server(self, backing_server=None):
-        """Setup the Chroot on backing_server."""
-        if backing_server is not None:
-            self.backing_transport = transport.get_transport(
-                backing_server.get_url())
-        else:
-            self.backing_transport = transport.get_transport('.')
-        self.backing_transport.clone('added-by-filter').ensure_base()
-        self.filter_func = lambda x: 'added-by-filter/' + x
-        super(TestingPathFilteringServer, self).start_server()
-
-    def get_bogus_url(self):
-        raise NotImplementedError
-
-
-class TestingChrootServer(chroot.ChrootServer):
-
-    def __init__(self):
-        """TestingChrootServer is not usable until start_server is called."""
-        super(TestingChrootServer, self).__init__(None)
-
-    def start_server(self, backing_server=None):
-        """Setup the Chroot on backing_server."""
-        if backing_server is not None:
-            self.backing_transport = transport.get_transport(
-                backing_server.get_url())
-        else:
-            self.backing_transport = transport.get_transport('.')
-        super(TestingChrootServer, self).start_server()
-
-    def get_bogus_url(self):
-        raise NotImplementedError
-
-
-class SmartTCPServer_for_testing(server.SmartTCPServer):
-    """Server suitable for use by transport tests.
-
-    This server is backed by the process's cwd.
-    """
-
-    def __init__(self, thread_name_suffix=''):
-        super(SmartTCPServer_for_testing, self).__init__(None)
-        self.client_path_extra = None
-        self.thread_name_suffix = thread_name_suffix
-
-    def get_backing_transport(self, backing_transport_server):
-        """Get a backing transport from a server we are decorating."""
-        return transport.get_transport(backing_transport_server.get_url())
-
-    def start_server(self, backing_transport_server=None,
-              client_path_extra='/extra/'):
-        """Set up server for testing.
-
-        :param backing_transport_server: backing server to use.  If not
-            specified, a LocalURLServer at the current working directory will
-            be used.
-        :param client_path_extra: a path segment starting with '/' to append to
-            the root URL for this server.  For instance, a value of '/foo/bar/'
-            will mean the root of the backing transport will be published at a
-            URL like `bzr://127.0.0.1:nnnn/foo/bar/`, rather than
-            `bzr://127.0.0.1:nnnn/`.  Default value is `extra`, so that tests
-            by default will fail unless they do the necessary path translation.
-        """
-        if not client_path_extra.startswith('/'):
-            raise ValueError(client_path_extra)
-        from bzrlib.transport.chroot import ChrootServer
-        if backing_transport_server is None:
-            backing_transport_server = LocalURLServer()
-        self.chroot_server = ChrootServer(
-            self.get_backing_transport(backing_transport_server))
-        self.chroot_server.start_server()
-        self.backing_transport = transport.get_transport(
-            self.chroot_server.get_url())
-        self.root_client_path = self.client_path_extra = client_path_extra
-        self.start_background_thread(self.thread_name_suffix)
-
-    def stop_server(self):
-        self.stop_background_thread()
-        self.chroot_server.stop_server()
-
-    def get_url(self):
-        url = super(SmartTCPServer_for_testing, self).get_url()
-        return url[:-1] + self.client_path_extra
-
-    def get_bogus_url(self):
-        """Return a URL which will fail to connect"""
-        return 'bzr://127.0.0.1:1/'
-
-
-class ReadonlySmartTCPServer_for_testing(SmartTCPServer_for_testing):
-    """Get a readonly server for testing."""
-
-    def get_backing_transport(self, backing_transport_server):
-        """Get a backing transport from a server we are decorating."""
-        url = 'readonly+' + backing_transport_server.get_url()
-        return transport.get_transport(url)
-
-
-class SmartTCPServer_for_testing_v2_only(SmartTCPServer_for_testing):
-    """A variation of SmartTCPServer_for_testing that limits the client to
-    using RPCs in protocol v2 (i.e. bzr <= 1.5).
-    """
-
-    def get_url(self):
-        url = super(SmartTCPServer_for_testing_v2_only, self).get_url()
-        url = 'bzr-v2://' + url[len('bzr://'):]
-        return url
-
-
-class ReadonlySmartTCPServer_for_testing_v2_only(
-    SmartTCPServer_for_testing_v2_only):
-    """Get a readonly server for testing."""
-
-    def get_backing_transport(self, backing_transport_server):
-        """Get a backing transport from a server we are decorating."""
-        url = 'readonly+' + backing_transport_server.get_url()
-        return transport.get_transport(url)
-
-
-
-

=== modified file 'bzrlib/tests/test_sftp_transport.py'
--- bzrlib/tests/test_sftp_transport.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_sftp_transport.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Robey Pointer <robey@lag.net>
+# Copyright (C) 2005 Robey Pointer <robey@lag.net>
 # Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
@@ -46,7 +46,11 @@
 
 if features.paramiko.available():
     from bzrlib.transport import sftp as _mod_sftp
-    from bzrlib.tests import stub_sftp
+    from bzrlib.transport.sftp import (
+        SFTPAbsoluteServer,
+        SFTPHomeDirServer,
+        SFTPTransport,
+        )
 
 from bzrlib.workingtree import WorkingTree
 
@@ -56,9 +60,9 @@
     if getattr(testcase, '_get_remote_is_absolute', None) is None:
         testcase._get_remote_is_absolute = True
     if testcase._get_remote_is_absolute:
-        testcase.transport_server = stub_sftp.SFTPAbsoluteServer
+        testcase.transport_server = SFTPAbsoluteServer
     else:
-        testcase.transport_server = stub_sftp.SFTPHomeDirServer
+        testcase.transport_server = SFTPHomeDirServer
     testcase.transport_readonly_server = HttpServer
 
 
@@ -158,8 +162,7 @@
         self.requireFeature(features.paramiko)
 
     def test_parse_url_with_home_dir(self):
-        s = _mod_sftp.SFTPTransport(
-            'sftp://ro%62ey:h%40t@example.com:2222/~/relative')
+        s = SFTPTransport('sftp://ro%62ey:h%40t@example.com:2222/~/relative')
         self.assertEquals(s._host, 'example.com')
         self.assertEquals(s._port, 2222)
         self.assertEquals(s._user, 'robey')
@@ -167,7 +170,7 @@
         self.assertEquals(s._path, '/~/relative/')
 
     def test_relpath(self):
-        s = _mod_sftp.SFTPTransport('sftp://user@host.com/abs/path')
+        s = SFTPTransport('sftp://user@host.com/abs/path')
         self.assertRaises(errors.PathNotChild, s.relpath,
                           'sftp://user@host.com/~/rel/path/sub')
 
@@ -187,7 +190,8 @@
             ssh._ssh_vendor_manager._cached_ssh_vendor = orig_vendor
 
     def test_abspath_root_sibling_server(self):
-        server = stub_sftp.SFTPSiblingAbsoluteServer()
+        from bzrlib.transport.sftp import SFTPSiblingAbsoluteServer
+        server = SFTPSiblingAbsoluteServer()
         server.start_server()
         try:
             transport = get_transport(server.get_url())
@@ -251,13 +255,14 @@
 
     def setUp(self):
         super(SSHVendorConnection, self).setUp()
+        from bzrlib.transport.sftp import SFTPFullAbsoluteServer
 
         def create_server():
             """Just a wrapper so that when created, it will set _vendor"""
             # SFTPFullAbsoluteServer can handle any vendor,
             # it just needs to be set between the time it is instantiated
             # and the time .setUp() is called
-            server = stub_sftp.SFTPFullAbsoluteServer()
+            server = SFTPFullAbsoluteServer()
             server._vendor = self._test_vendor
             return server
         self._test_vendor = 'loopback'
@@ -297,17 +302,23 @@
     def setUp(self):
         self.requireFeature(features.paramiko)
         super(SSHVendorBadConnection, self).setUp()
+        import bzrlib.transport.ssh
 
         # open a random port, so we know nobody else is using it
         # but don't actually listen on the port.
         s = socket.socket()
         s.bind(('localhost', 0))
-        self.addCleanup(s.close)
         self.bogus_url = 'sftp://%s:%s/' % s.getsockname()
 
+        orig_vendor = bzrlib.transport.ssh._ssh_vendor_manager._cached_ssh_vendor
+        def reset():
+            bzrlib.transport.ssh._ssh_vendor_manager._cached_ssh_vendor = orig_vendor
+            s.close()
+        self.addCleanup(reset)
+
     def set_vendor(self, vendor):
-        from bzrlib.transport import ssh
-        self.overrideAttr(ssh._ssh_vendor_manager, '_cached_ssh_vendor', vendor)
+        import bzrlib.transport.ssh
+        bzrlib.transport.ssh._ssh_vendor_manager._cached_ssh_vendor = vendor
 
     def test_bad_connection_paramiko(self):
         """Test that a real connection attempt raises the right error"""
@@ -404,20 +415,21 @@
         self.requireFeature(features.paramiko)
 
     def test_delay(self):
+        from bzrlib.transport.sftp import SocketDelay
         sending = FakeSocket()
-        receiving = stub_sftp.SocketDelay(sending, 0.1, bandwidth=1000000,
-                                          really_sleep=False)
+        receiving = SocketDelay(sending, 0.1, bandwidth=1000000,
+                                really_sleep=False)
         # check that simulated time is charged only per round-trip:
-        t1 = stub_sftp.SocketDelay.simulated_time
+        t1 = SocketDelay.simulated_time
         receiving.send("connect1")
         self.assertEqual(sending.recv(1024), "connect1")
-        t2 = stub_sftp.SocketDelay.simulated_time
+        t2 = SocketDelay.simulated_time
         self.assertAlmostEqual(t2 - t1, 0.1)
         receiving.send("connect2")
         self.assertEqual(sending.recv(1024), "connect2")
         sending.send("hello")
         self.assertEqual(receiving.recv(1024), "hello")
-        t3 = stub_sftp.SocketDelay.simulated_time
+        t3 = SocketDelay.simulated_time
         self.assertAlmostEqual(t3 - t2, 0.1)
         sending.send("hello")
         self.assertEqual(receiving.recv(1024), "hello")
@@ -425,20 +437,21 @@
         self.assertEqual(receiving.recv(1024), "hello")
         sending.send("hello")
         self.assertEqual(receiving.recv(1024), "hello")
-        t4 = stub_sftp.SocketDelay.simulated_time
+        t4 = SocketDelay.simulated_time
         self.assertAlmostEqual(t4, t3)
 
     def test_bandwidth(self):
+        from bzrlib.transport.sftp import SocketDelay
         sending = FakeSocket()
-        receiving = stub_sftp.SocketDelay(sending, 0, bandwidth=8.0/(1024*1024),
-                                          really_sleep=False)
+        receiving = SocketDelay(sending, 0, bandwidth=8.0/(1024*1024),
+                                really_sleep=False)
         # check that simulated time is charged only per round-trip:
-        t1 = stub_sftp.SocketDelay.simulated_time
+        t1 = SocketDelay.simulated_time
         receiving.send("connect")
         self.assertEqual(sending.recv(1024), "connect")
         sending.send("a" * 100)
         self.assertEqual(receiving.recv(1024), "a" * 100)
-        t2 = stub_sftp.SocketDelay.simulated_time
+        t2 = SocketDelay.simulated_time
         self.assertAlmostEqual(t2 - t1, 100 + 7)
 
 

=== modified file 'bzrlib/tests/test_shelf.py'
--- bzrlib/tests/test_shelf.py	2010-01-13 23:06:42 +0000
+++ bzrlib/tests/test_shelf.py	2009-09-11 07:55:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -108,29 +108,6 @@
         creator.shelve_change(('rename', 'baz-id', 'foo/baz', 'bar/baz'))
         self.check_shelve_move(creator, tree)
 
-    def test_shelve_changed_root_id(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['foo'])
-        tree.set_root_id('first-root-id')
-        tree.add(['foo'], ['foo-id'])
-        tree.commit('foo')
-        tree.set_root_id('second-root-id')
-        tree.lock_tree_write()
-        self.addCleanup(tree.unlock)
-        creator = shelf.ShelfCreator(tree, tree.basis_tree())
-        self.addCleanup(creator.finalize)
-        self.expectFailure('shelf doesn\'t support shelving root changes yet',
-            self.assertEqual, [
-                ('delete file', 'first-root-id', 'directory', ''),
-                ('add file', 'second-root-id', 'directory', ''),
-                ('rename', 'foo-id', u'foo', u'foo'),
-                ], list(creator.iter_shelvable()))
-
-        self.assertEqual([('delete file', 'first-root-id', 'directory', ''),
-                          ('add file', 'second-root-id', 'directory', ''),
-                          ('rename', 'foo-id', u'foo', u'foo'),
-                         ], list(creator.iter_shelvable()))
-
     def assertShelvedFileEqual(self, expected_content, creator, file_id):
         s_trans_id = creator.shelf_transform.trans_id_file_id(file_id)
         shelf_file = creator.shelf_transform._limbo_name(s_trans_id)

=== modified file 'bzrlib/tests/test_shelf_ui.py'
--- bzrlib/tests/test_shelf_ui.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_shelf_ui.py	2009-12-16 15:56:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,6 @@
 from cStringIO import StringIO
 import os
 import sys
-from textwrap import dedent
 
 from bzrlib import (
     errors,
@@ -505,38 +504,6 @@
         self.assertFileEqual(LINES_AJ, 'tree/foo')
         self.assertEqual(1, tree.get_shelf_manager().last_shelf())
 
-    def test_unshelve_args_preview(self):
-        tree = self.create_tree_with_shelf()
-        write_diff_to = StringIO()
-        unshelver = shelf_ui.Unshelver.from_args(
-            directory='tree', action='preview', write_diff_to=write_diff_to)
-        try:
-            unshelver.run()
-        finally:
-            unshelver.tree.unlock()
-        # The changes were not unshelved.
-        self.assertFileEqual(LINES_AJ, 'tree/foo')
-        self.assertEqual(1, tree.get_shelf_manager().last_shelf())
-
-        # But the diff was written to write_diff_to.
-        diff = write_diff_to.getvalue()
-        expected = dedent("""\
-            @@ -1,4 +1,4 @@
-            -a
-            +z
-             b
-             c
-             d
-            @@ -7,4 +7,4 @@
-             g
-             h
-             i
-            -j
-            +y
-
-            """)
-        self.assertEqualDiff(expected, diff[-len(expected):])
-
     def test_unshelve_args_delete_only(self):
         tree = self.make_branch_and_tree('tree')
         manager = tree.get_shelf_manager()

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2010-03-02 22:25:58 +0000
+++ bzrlib/tests/test_smart.py	2009-10-29 00:16:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,45 +30,47 @@
 
 from bzrlib import (
     bencode,
-    branch as _mod_branch,
     bzrdir,
     errors,
     pack,
+    smart,
     tests,
-    transport,
     urlutils,
     versionedfile,
     )
-from bzrlib.smart import (
-    branch as smart_branch,
-    bzrdir as smart_dir,
-    repository as smart_repo,
-    packrepository as smart_packrepo,
-    request as smart_req,
-    server,
-    vfs,
-    )
-from bzrlib.tests import test_server
-from bzrlib.transport import (
-    chroot,
-    memory,
-    )
+from bzrlib.branch import Branch, BranchReferenceFormat
+import bzrlib.smart.branch
+import bzrlib.smart.bzrdir, bzrlib.smart.bzrdir as smart_dir
+import bzrlib.smart.packrepository
+import bzrlib.smart.repository
+import bzrlib.smart.vfs
+from bzrlib.smart.request import (
+    FailedSmartServerResponse,
+    SmartServerRequest,
+    SmartServerResponse,
+    SuccessfulSmartServerResponse,
+    )
+from bzrlib.tests import (
+    split_suite_by_re,
+    )
+from bzrlib.transport import chroot, get_transport, local, memory
 
 
 def load_tests(standard_tests, module, loader):
     """Multiply tests version and protocol consistency."""
     # FindRepository tests.
+    bzrdir_mod = bzrlib.smart.bzrdir
     scenarios = [
         ("find_repository", {
-            "_request_class": smart_dir.SmartServerRequestFindRepositoryV1}),
+            "_request_class":bzrdir_mod.SmartServerRequestFindRepositoryV1}),
         ("find_repositoryV2", {
-            "_request_class": smart_dir.SmartServerRequestFindRepositoryV2}),
+            "_request_class":bzrdir_mod.SmartServerRequestFindRepositoryV2}),
         ("find_repositoryV3", {
-            "_request_class": smart_dir.SmartServerRequestFindRepositoryV3}),
+            "_request_class":bzrdir_mod.SmartServerRequestFindRepositoryV3}),
         ]
-    to_adapt, result = tests.split_suite_by_re(standard_tests,
+    to_adapt, result = split_suite_by_re(standard_tests,
         "TestSmartServerRequestFindRepository")
-    v2_only, v1_and_2 = tests.split_suite_by_re(to_adapt,
+    v2_only, v1_and_2 = split_suite_by_re(to_adapt,
         "_v2")
     tests.multiply_tests(v1_and_2, scenarios, result)
     # The first scenario is only applicable to v1 protocols, it is deleted
@@ -89,7 +91,7 @@
             backing_transport = tests.TestCaseWithTransport.get_transport(self)
             self._chroot_server = chroot.ChrootServer(backing_transport)
             self.start_server(self._chroot_server)
-        t = transport.get_transport(self._chroot_server.get_url())
+        t = get_transport(self._chroot_server.get_url())
         if relpath is not None:
             t = t.clone(relpath)
         return t
@@ -106,7 +108,7 @@
         self.transport_server = self.make_transport_server
 
     def make_transport_server(self):
-        return test_server.SmartTCPServer_for_testing('-' + self.id())
+        return smart.server.SmartTCPServer_for_testing('-' + self.id())
 
     def get_smart_medium(self):
         """Get a smart medium to use in tests."""
@@ -121,11 +123,11 @@
             None, 'foo')]),('text', [
             versionedfile.FulltextContentFactory(('k2',), None, None, 'bar')])]
         fmt = bzrdir.format_registry.get('pack-0.92')().repository_format
-        bytes = smart_repo._stream_to_byte_stream(stream, fmt)
+        bytes = smart.repository._stream_to_byte_stream(stream, fmt)
         streams = []
         # Iterate the resulting iterable; checking that we get only one stream
         # out.
-        fmt, stream = smart_repo._byte_stream_to_stream(bytes)
+        fmt, stream = smart.repository._byte_stream_to_stream(bytes)
         for kind, substream in stream:
             streams.append((kind, list(substream)))
         self.assertLength(1, streams)
@@ -135,32 +137,32 @@
 class TestSmartServerResponse(tests.TestCase):
 
     def test__eq__(self):
-        self.assertEqual(smart_req.SmartServerResponse(('ok', )),
-            smart_req.SmartServerResponse(('ok', )))
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), 'body'),
-            smart_req.SmartServerResponse(('ok', ), 'body'))
-        self.assertNotEqual(smart_req.SmartServerResponse(('ok', )),
-            smart_req.SmartServerResponse(('notok', )))
-        self.assertNotEqual(smart_req.SmartServerResponse(('ok', ), 'body'),
-            smart_req.SmartServerResponse(('ok', )))
+        self.assertEqual(SmartServerResponse(('ok', )),
+            SmartServerResponse(('ok', )))
+        self.assertEqual(SmartServerResponse(('ok', ), 'body'),
+            SmartServerResponse(('ok', ), 'body'))
+        self.assertNotEqual(SmartServerResponse(('ok', )),
+            SmartServerResponse(('notok', )))
+        self.assertNotEqual(SmartServerResponse(('ok', ), 'body'),
+            SmartServerResponse(('ok', )))
         self.assertNotEqual(None,
-            smart_req.SmartServerResponse(('ok', )))
+            SmartServerResponse(('ok', )))
 
     def test__str__(self):
         """SmartServerResponses can be stringified."""
         self.assertEqual(
             "<SuccessfulSmartServerResponse args=('args',) body='body'>",
-            str(smart_req.SuccessfulSmartServerResponse(('args',), 'body')))
+            str(SuccessfulSmartServerResponse(('args',), 'body')))
         self.assertEqual(
             "<FailedSmartServerResponse args=('args',) body='body'>",
-            str(smart_req.FailedSmartServerResponse(('args',), 'body')))
+            str(FailedSmartServerResponse(('args',), 'body')))
 
 
 class TestSmartServerRequest(tests.TestCaseWithMemoryTransport):
 
     def test_translate_client_path(self):
         transport = self.get_transport()
-        request = smart_req.SmartServerRequest(transport, 'foo/')
+        request = SmartServerRequest(transport, 'foo/')
         self.assertEqual('./', request.translate_client_path('foo/'))
         self.assertRaises(
             errors.InvalidURLJoin, request.translate_client_path, 'foo/..')
@@ -176,7 +178,7 @@
     def test_translate_client_path_vfs(self):
         """VfsRequests receive escaped paths rather than raw UTF-8."""
         transport = self.get_transport()
-        request = vfs.VfsRequest(transport, 'foo/')
+        request = smart.vfs.VfsRequest(transport, 'foo/')
         e_acute = u'\N{LATIN SMALL LETTER E WITH ACUTE}'.encode('utf-8')
         escaped = urlutils.escape('foo/' + e_acute)
         self.assertEqual('./' + urlutils.escape(e_acute),
@@ -184,7 +186,7 @@
 
     def test_transport_from_client_path(self):
         transport = self.get_transport()
-        request = smart_req.SmartServerRequest(transport, 'foo/')
+        request = SmartServerRequest(transport, 'foo/')
         self.assertEqual(
             transport.base,
             request.transport_from_client_path('foo/').base)
@@ -201,7 +203,7 @@
         local_result = dir.cloning_metadir()
         request_class = smart_dir.SmartServerBzrDirRequestCloningMetaDir
         request = request_class(backing)
-        expected = smart_req.SuccessfulSmartServerResponse(
+        expected = SuccessfulSmartServerResponse(
             (local_result.network_name(),
             local_result.repository_format.network_name(),
             ('branch', local_result.get_branch_format().network_name())))
@@ -213,15 +215,14 @@
         referenced_branch = self.make_branch('referenced')
         dir = self.make_bzrdir('.')
         local_result = dir.cloning_metadir()
-        reference = _mod_branch.BranchReferenceFormat().initialize(
-            dir, target_branch=referenced_branch)
-        reference_url = _mod_branch.BranchReferenceFormat().get_reference(dir)
+        reference = BranchReferenceFormat().initialize(dir, referenced_branch)
+        reference_url = BranchReferenceFormat().get_reference(dir)
         # The server shouldn't try to follow the branch reference, so it's fine
         # if the referenced branch isn't reachable.
         backing.rename('referenced', 'moved')
         request_class = smart_dir.SmartServerBzrDirRequestCloningMetaDir
         request = request_class(backing)
-        expected = smart_req.FailedSmartServerResponse(('BranchReference',))
+        expected = FailedSmartServerResponse(('BranchReference',))
         self.assertEqual(expected, request.execute('', 'False'))
 
 
@@ -232,12 +233,12 @@
         """When there is a bzrdir present, the call succeeds."""
         backing = self.get_transport()
         self.make_bzrdir('.')
-        request_class = smart_dir.SmartServerRequestCreateRepository
+        request_class = bzrlib.smart.bzrdir.SmartServerRequestCreateRepository
         request = request_class(backing)
         reference_bzrdir_format = bzrdir.format_registry.get('pack-0.92')()
         reference_format = reference_bzrdir_format.repository_format
         network_name = reference_format.network_name()
-        expected = smart_req.SuccessfulSmartServerResponse(
+        expected = SuccessfulSmartServerResponse(
             ('ok', 'no', 'no', 'no', network_name))
         self.assertEqual(expected, request.execute('', network_name, 'True'))
 
@@ -250,7 +251,7 @@
         backing = self.get_transport()
         request = self._request_class(backing)
         self.make_bzrdir('.')
-        self.assertEqual(smart_req.SmartServerResponse(('norepository', )),
+        self.assertEqual(SmartServerResponse(('norepository', )),
             request.execute(''))
 
     def test_nonshared_repository(self):
@@ -262,7 +263,7 @@
         result = self._make_repository_and_result()
         self.assertEqual(result, request.execute(''))
         self.make_bzrdir('subdir')
-        self.assertEqual(smart_req.SmartServerResponse(('norepository', )),
+        self.assertEqual(SmartServerResponse(('norepository', )),
             request.execute('subdir'))
 
     def _make_repository_and_result(self, shared=False, format=None):
@@ -283,20 +284,19 @@
             external = 'yes'
         else:
             external = 'no'
-        if (smart_dir.SmartServerRequestFindRepositoryV3 ==
+        if (smart.bzrdir.SmartServerRequestFindRepositoryV3 ==
             self._request_class):
-            return smart_req.SuccessfulSmartServerResponse(
+            return SuccessfulSmartServerResponse(
                 ('ok', '', rich_root, subtrees, external,
                  repo._format.network_name()))
-        elif (smart_dir.SmartServerRequestFindRepositoryV2 ==
+        elif (smart.bzrdir.SmartServerRequestFindRepositoryV2 ==
             self._request_class):
             # All tests so far are on formats, and for non-external
             # repositories.
-            return smart_req.SuccessfulSmartServerResponse(
+            return SuccessfulSmartServerResponse(
                 ('ok', '', rich_root, subtrees, external))
         else:
-            return smart_req.SuccessfulSmartServerResponse(
-                ('ok', '', rich_root, subtrees))
+            return SuccessfulSmartServerResponse(('ok', '', rich_root, subtrees))
 
     def test_shared_repository(self):
         """When there is a shared repository, we get 'ok', 'relpath-to-repo'."""
@@ -305,13 +305,11 @@
         result = self._make_repository_and_result(shared=True)
         self.assertEqual(result, request.execute(''))
         self.make_bzrdir('subdir')
-        result2 = smart_req.SmartServerResponse(
-            result.args[0:1] + ('..', ) + result.args[2:])
+        result2 = SmartServerResponse(result.args[0:1] + ('..', ) + result.args[2:])
         self.assertEqual(result2,
             request.execute('subdir'))
         self.make_bzrdir('subdir/deeper')
-        result3 = smart_req.SmartServerResponse(
-            result.args[0:1] + ('../..', ) + result.args[2:])
+        result3 = SmartServerResponse(result.args[0:1] + ('../..', ) + result.args[2:])
         self.assertEqual(result3,
             request.execute('subdir/deeper'))
 
@@ -319,8 +317,7 @@
         """Test for the format attributes for rich root and subtree support."""
         backing = self.get_transport()
         request = self._request_class(backing)
-        result = self._make_repository_and_result(
-            format='dirstate-with-subtree')
+        result = self._make_repository_and_result(format='dirstate-with-subtree')
         # check the test will be valid
         self.assertEqual('yes', result.args[2])
         self.assertEqual('yes', result.args[3])
@@ -330,8 +327,7 @@
         """Test for the supports_external_lookups attribute."""
         backing = self.get_transport()
         request = self._request_class(backing)
-        result = self._make_repository_and_result(
-            format='dirstate-with-subtree')
+        result = self._make_repository_and_result(format='dirstate-with-subtree')
         # check the test will be valid
         self.assertEqual('no', result.args[4])
         self.assertEqual(result, request.execute(''))
@@ -348,7 +344,7 @@
         local_result = dir._get_config()._get_config_file().read()
         request_class = smart_dir.SmartServerBzrDirRequestConfigFile
         request = request_class(backing)
-        expected = smart_req.SuccessfulSmartServerResponse((), local_result)
+        expected = SuccessfulSmartServerResponse((), local_result)
         self.assertEqual(expected, request.execute(''))
 
     def test_missing(self):
@@ -356,7 +352,7 @@
         dir = self.make_bzrdir('.')
         request_class = smart_dir.SmartServerBzrDirRequestConfigFile
         request = request_class(backing)
-        expected = smart_req.SuccessfulSmartServerResponse((), '')
+        expected = SuccessfulSmartServerResponse((), '')
         self.assertEqual(expected, request.execute(''))
 
 
@@ -365,8 +361,8 @@
     def test_empty_dir(self):
         """Initializing an empty dir should succeed and do it."""
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestInitializeBzrDir(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('ok', )),
+        request = smart.bzrdir.SmartServerRequestInitializeBzrDir(backing)
+        self.assertEqual(SmartServerResponse(('ok', )),
             request.execute(''))
         made_dir = bzrdir.BzrDir.open_from_transport(backing)
         # no branch, tree or repository is expected with the current
@@ -378,21 +374,20 @@
     def test_missing_dir(self):
         """Initializing a missing directory should fail like the bzrdir api."""
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestInitializeBzrDir(backing)
+        request = smart.bzrdir.SmartServerRequestInitializeBzrDir(backing)
         self.assertRaises(errors.NoSuchFile,
             request.execute, 'subdir')
 
     def test_initialized_dir(self):
         """Initializing an extant bzrdir should fail like the bzrdir api."""
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestInitializeBzrDir(backing)
+        request = smart.bzrdir.SmartServerRequestInitializeBzrDir(backing)
         self.make_bzrdir('subdir')
         self.assertRaises(errors.FileExists,
             request.execute, 'subdir')
 
 
-class TestSmartServerRequestBzrDirInitializeEx(
-    tests.TestCaseWithMemoryTransport):
+class TestSmartServerRequestBzrDirInitializeEx(tests.TestCaseWithMemoryTransport):
     """Basic tests for BzrDir.initialize_ex_1.16 in the smart server.
 
     The main unit tests in test_bzrdir exercise the API comprehensively.
@@ -402,12 +397,11 @@
         """Initializing an empty dir should succeed and do it."""
         backing = self.get_transport()
         name = self.make_bzrdir('reference')._format.network_name()
-        request = smart_dir.SmartServerRequestBzrDirInitializeEx(backing)
-        self.assertEqual(
-            smart_req.SmartServerResponse(('', '', '', '', '', '', name,
-                                           'False', '', '', '')),
+        request = smart.bzrdir.SmartServerRequestBzrDirInitializeEx(backing)
+        self.assertEqual(SmartServerResponse(('', '', '', '', '', '', name,
+            'False', '', '', '')),
             request.execute(name, '', 'True', 'False', 'False', '', '', '', '',
-                            'False'))
+            'False'))
         made_dir = bzrdir.BzrDir.open_from_transport(backing)
         # no branch, tree or repository is expected with the current
         # default format.
@@ -419,7 +413,7 @@
         """Initializing a missing directory should fail like the bzrdir api."""
         backing = self.get_transport()
         name = self.make_bzrdir('reference')._format.network_name()
-        request = smart_dir.SmartServerRequestBzrDirInitializeEx(backing)
+        request = smart.bzrdir.SmartServerRequestBzrDirInitializeEx(backing)
         self.assertRaises(errors.NoSuchFile, request.execute, name,
             'subdir/dir', 'False', 'False', 'False', '', '', '', '', 'False')
 
@@ -427,76 +421,76 @@
         """Initializing an extant directory should fail like the bzrdir api."""
         backing = self.get_transport()
         name = self.make_bzrdir('reference')._format.network_name()
-        request = smart_dir.SmartServerRequestBzrDirInitializeEx(backing)
+        request = smart.bzrdir.SmartServerRequestBzrDirInitializeEx(backing)
         self.make_bzrdir('subdir')
         self.assertRaises(errors.FileExists, request.execute, name, 'subdir',
             'False', 'False', 'False', '', '', '', '', 'False')
 
 
 class TestSmartServerRequestOpenBzrDir(tests.TestCaseWithMemoryTransport):
-
+    
     def test_no_directory(self):
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBzrDir(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir(backing)
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('does-not-exist'))
 
     def test_empty_directory(self):
         backing = self.get_transport()
         backing.mkdir('empty')
-        request = smart_dir.SmartServerRequestOpenBzrDir(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir(backing)
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('empty'))
 
     def test_outside_root_client_path(self):
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBzrDir(backing,
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir(backing,
             root_client_path='root')
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('not-root'))
 
-
+    
 class TestSmartServerRequestOpenBzrDir_2_1(tests.TestCaseWithMemoryTransport):
-
+    
     def test_no_directory(self):
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBzrDir_2_1(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir_2_1(backing)
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('does-not-exist'))
 
     def test_empty_directory(self):
         backing = self.get_transport()
         backing.mkdir('empty')
-        request = smart_dir.SmartServerRequestOpenBzrDir_2_1(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir_2_1(backing)
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('empty'))
 
     def test_present_without_workingtree(self):
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBzrDir_2_1(backing)
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir_2_1(backing)
         self.make_bzrdir('.')
-        self.assertEqual(smart_req.SmartServerResponse(('yes', 'no')),
+        self.assertEqual(SmartServerResponse(('yes', 'no')),
             request.execute(''))
 
     def test_outside_root_client_path(self):
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBzrDir_2_1(backing,
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir_2_1(backing,
             root_client_path='root')
-        self.assertEqual(smart_req.SmartServerResponse(('no',)),
+        self.assertEqual(SmartServerResponse(('no',)),
             request.execute('not-root'))
 
-
+    
 class TestSmartServerRequestOpenBzrDir_2_1_disk(TestCaseWithChrootedTransport):
 
     def test_present_with_workingtree(self):
-        self.vfs_transport_factory = test_server.LocalURLServer
+        self.vfs_transport_factory = local.LocalURLServer
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBzrDir_2_1(backing)
+        request = smart.bzrdir.SmartServerRequestOpenBzrDir_2_1(backing)
         bd = self.make_bzrdir('.')
         bd.create_repository()
         bd.create_branch()
         bd.create_workingtree()
-        self.assertEqual(smart_req.SmartServerResponse(('yes', 'yes')),
+        self.assertEqual(SmartServerResponse(('yes', 'yes')),
             request.execute(''))
 
 
@@ -505,40 +499,31 @@
     def test_no_branch(self):
         """When there is no branch, ('nobranch', ) is returned."""
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranch(backing)
+        request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
         self.make_bzrdir('.')
-        self.assertEqual(smart_req.SmartServerResponse(('nobranch', )),
+        self.assertEqual(SmartServerResponse(('nobranch', )),
             request.execute(''))
 
     def test_branch(self):
         """When there is a branch, 'ok' is returned."""
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranch(backing)
+        request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
         self.make_branch('.')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', '')),
+        self.assertEqual(SmartServerResponse(('ok', '')),
             request.execute(''))
 
     def test_branch_reference(self):
         """When there is a branch reference, the reference URL is returned."""
-        self.vfs_transport_factory = test_server.LocalURLServer
+        self.vfs_transport_factory = local.LocalURLServer
         backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranch(backing)
+        request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('reference',lightweight=True)
-        reference_url = _mod_branch.BranchReferenceFormat().get_reference(
-            checkout.bzrdir)
+        reference_url = BranchReferenceFormat().get_reference(checkout.bzrdir)
         self.assertFileEqual(reference_url, 'reference/.bzr/branch/location')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', reference_url)),
+        self.assertEqual(SmartServerResponse(('ok', reference_url)),
             request.execute('reference'))
 
-    def test_notification_on_branch_from_repository(self):
-        """When there is a repository, the error should return details."""
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranch(backing)
-        repo = self.make_repository('.')
-        self.assertEqual(smart_req.SmartServerResponse(('nobranch',)),
-            request.execute(''))
-
 
 class TestSmartServerRequestOpenBranchV2(TestCaseWithChrootedTransport):
 
@@ -546,125 +531,49 @@
         """When there is no branch, ('nobranch', ) is returned."""
         backing = self.get_transport()
         self.make_bzrdir('.')
-        request = smart_dir.SmartServerRequestOpenBranchV2(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('nobranch', )),
-            request.execute(''))
-
-    def test_branch(self):
-        """When there is a branch, 'ok' is returned."""
-        backing = self.get_transport()
-        expected = self.make_branch('.')._format.network_name()
-        request = smart_dir.SmartServerRequestOpenBranchV2(backing)
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(
-                ('branch', expected)),
-                         request.execute(''))
-
-    def test_branch_reference(self):
-        """When there is a branch reference, the reference URL is returned."""
-        self.vfs_transport_factory = test_server.LocalURLServer
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranchV2(backing)
-        branch = self.make_branch('branch')
-        checkout = branch.create_checkout('reference',lightweight=True)
-        reference_url = _mod_branch.BranchReferenceFormat().get_reference(
-            checkout.bzrdir)
-        self.assertFileEqual(reference_url, 'reference/.bzr/branch/location')
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(
-                ('ref', reference_url)),
-                         request.execute('reference'))
-
-    def test_stacked_branch(self):
-        """Opening a stacked branch does not open the stacked-on branch."""
-        trunk = self.make_branch('trunk')
-        feature = self.make_branch('feature')
-        feature.set_stacked_on_url(trunk.base)
-        opened_branches = []
-        _mod_branch.Branch.hooks.install_named_hook(
-            'open', opened_branches.append, None)
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranchV2(backing)
-        request.setup_jail()
-        try:
-            response = request.execute('feature')
-        finally:
-            request.teardown_jail()
-        expected_format = feature._format.network_name()
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(
-                ('branch', expected_format)),
-                         response)
-        self.assertLength(1, opened_branches)
-
-    def test_notification_on_branch_from_repository(self):
-        """When there is a repository, the error should return details."""
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranchV2(backing)
-        repo = self.make_repository('.')
-        self.assertEqual(smart_req.SmartServerResponse(('nobranch',)),
-            request.execute(''))
-
-
-class TestSmartServerRequestOpenBranchV3(TestCaseWithChrootedTransport):
-
-    def test_no_branch(self):
-        """When there is no branch, ('nobranch', ) is returned."""
-        backing = self.get_transport()
-        self.make_bzrdir('.')
-        request = smart_dir.SmartServerRequestOpenBranchV3(backing)
-        self.assertEqual(smart_req.SmartServerResponse(('nobranch',)),
-            request.execute(''))
-
-    def test_branch(self):
-        """When there is a branch, 'ok' is returned."""
-        backing = self.get_transport()
-        expected = self.make_branch('.')._format.network_name()
-        request = smart_dir.SmartServerRequestOpenBranchV3(backing)
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(
-                ('branch', expected)),
-                         request.execute(''))
-
-    def test_branch_reference(self):
-        """When there is a branch reference, the reference URL is returned."""
-        self.vfs_transport_factory = test_server.LocalURLServer
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranchV3(backing)
-        branch = self.make_branch('branch')
-        checkout = branch.create_checkout('reference',lightweight=True)
-        reference_url = _mod_branch.BranchReferenceFormat().get_reference(
-            checkout.bzrdir)
-        self.assertFileEqual(reference_url, 'reference/.bzr/branch/location')
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(
-                ('ref', reference_url)),
-                         request.execute('reference'))
-
-    def test_stacked_branch(self):
-        """Opening a stacked branch does not open the stacked-on branch."""
-        trunk = self.make_branch('trunk')
-        feature = self.make_branch('feature')
-        feature.set_stacked_on_url(trunk.base)
-        opened_branches = []
-        _mod_branch.Branch.hooks.install_named_hook(
-            'open', opened_branches.append, None)
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranchV3(backing)
-        request.setup_jail()
-        try:
-            response = request.execute('feature')
-        finally:
-            request.teardown_jail()
-        expected_format = feature._format.network_name()
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(
-                ('branch', expected_format)),
-                         response)
-        self.assertLength(1, opened_branches)
-
-    def test_notification_on_branch_from_repository(self):
-        """When there is a repository, the error should return details."""
-        backing = self.get_transport()
-        request = smart_dir.SmartServerRequestOpenBranchV3(backing)
-        repo = self.make_repository('.')
-        self.assertEqual(smart_req.SmartServerResponse(
-                ('nobranch', 'location is a repository')),
-                         request.execute(''))
+        request = smart.bzrdir.SmartServerRequestOpenBranchV2(backing)
+        self.assertEqual(SmartServerResponse(('nobranch', )),
+            request.execute(''))
+
+    def test_branch(self):
+        """When there is a branch, 'ok' is returned."""
+        backing = self.get_transport()
+        expected = self.make_branch('.')._format.network_name()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV2(backing)
+        self.assertEqual(SuccessfulSmartServerResponse(('branch', expected)),
+            request.execute(''))
+
+    def test_branch_reference(self):
+        """When there is a branch reference, the reference URL is returned."""
+        self.vfs_transport_factory = local.LocalURLServer
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV2(backing)
+        branch = self.make_branch('branch')
+        checkout = branch.create_checkout('reference',lightweight=True)
+        reference_url = BranchReferenceFormat().get_reference(checkout.bzrdir)
+        self.assertFileEqual(reference_url, 'reference/.bzr/branch/location')
+        self.assertEqual(SuccessfulSmartServerResponse(('ref', reference_url)),
+            request.execute('reference'))
+
+    def test_stacked_branch(self):
+        """Opening a stacked branch does not open the stacked-on branch."""
+        trunk = self.make_branch('trunk')
+        feature = self.make_branch('feature')
+        feature.set_stacked_on_url(trunk.base)
+        opened_branches = []
+        Branch.hooks.install_named_hook('open', opened_branches.append, None)
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV2(backing)
+        request.setup_jail()
+        try:
+            response = request.execute('feature')
+        finally:
+            request.teardown_jail()
+        expected_format = feature._format.network_name()
+        self.assertEqual(
+            SuccessfulSmartServerResponse(('branch', expected_format)),
+            response)
+        self.assertLength(1, opened_branches)
 
 
 class TestSmartServerRequestRevisionHistory(tests.TestCaseWithMemoryTransport):
@@ -672,15 +581,15 @@
     def test_empty(self):
         """For an empty branch, the body is empty."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerRequestRevisionHistory(backing)
+        request = smart.branch.SmartServerRequestRevisionHistory(backing)
         self.make_branch('.')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), ''),
+        self.assertEqual(SmartServerResponse(('ok', ), ''),
             request.execute(''))
 
     def test_not_empty(self):
         """For a non-empty branch, the body is empty."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerRequestRevisionHistory(backing)
+        request = smart.branch.SmartServerRequestRevisionHistory(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -688,7 +597,7 @@
         r2 = tree.commit('2nd commit', rev_id=u'\xc8'.encode('utf-8'))
         tree.unlock()
         self.assertEqual(
-            smart_req.SmartServerResponse(('ok', ), ('\x00'.join([r1, r2]))),
+            SmartServerResponse(('ok', ), ('\x00'.join([r1, r2]))),
             request.execute(''))
 
 
@@ -697,7 +606,7 @@
     def test_no_branch(self):
         """When there is a bzrdir and no branch, NotBranchError is raised."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequest(backing)
+        request = smart.branch.SmartServerBranchRequest(backing)
         self.make_bzrdir('.')
         self.assertRaises(errors.NotBranchError,
             request.execute, '')
@@ -705,28 +614,27 @@
     def test_branch_reference(self):
         """When there is a branch reference, NotBranchError is raised."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequest(backing)
+        request = smart.branch.SmartServerBranchRequest(backing)
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('reference',lightweight=True)
         self.assertRaises(errors.NotBranchError,
             request.execute, 'checkout')
 
 
-class TestSmartServerBranchRequestLastRevisionInfo(
-    tests.TestCaseWithMemoryTransport):
+class TestSmartServerBranchRequestLastRevisionInfo(tests.TestCaseWithMemoryTransport):
 
     def test_empty(self):
         """For an empty branch, the result is ('ok', '0', 'null:')."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLastRevisionInfo(backing)
+        request = smart.branch.SmartServerBranchRequestLastRevisionInfo(backing)
         self.make_branch('.')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', '0', 'null:')),
+        self.assertEqual(SmartServerResponse(('ok', '0', 'null:')),
             request.execute(''))
 
     def test_not_empty(self):
         """For a non-empty branch, the result is ('ok', 'revno', 'revid')."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLastRevisionInfo(backing)
+        request = smart.branch.SmartServerBranchRequestLastRevisionInfo(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -735,21 +643,20 @@
         r2 = tree.commit('2nd commit', rev_id=rev_id_utf8)
         tree.unlock()
         self.assertEqual(
-            smart_req.SmartServerResponse(('ok', '2', rev_id_utf8)),
+            SmartServerResponse(('ok', '2', rev_id_utf8)),
             request.execute(''))
 
 
-class TestSmartServerBranchRequestGetConfigFile(
-    tests.TestCaseWithMemoryTransport):
+class TestSmartServerBranchRequestGetConfigFile(tests.TestCaseWithMemoryTransport):
 
     def test_default(self):
         """With no file, we get empty content."""
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchGetConfigFile(backing)
+        request = smart.branch.SmartServerBranchGetConfigFile(backing)
         branch = self.make_branch('.')
         # there should be no file by default
         content = ''
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), content),
+        self.assertEqual(SmartServerResponse(('ok', ), content),
             request.execute(''))
 
     def test_with_content(self):
@@ -757,10 +664,10 @@
         # branch.control_files.get('branch.conf') for now - in the future it may
         # perform more complex processing.
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchGetConfigFile(backing)
+        request = smart.branch.SmartServerBranchGetConfigFile(backing)
         branch = self.make_branch('.')
         branch._transport.put_bytes('branch.conf', 'foo bar baz')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), 'foo bar baz'),
+        self.assertEqual(SmartServerResponse(('ok', ), 'foo bar baz'),
             request.execute(''))
 
 
@@ -777,26 +684,26 @@
 
     def test_value_name(self):
         branch = self.make_branch('.')
-        request = smart_branch.SmartServerBranchRequestSetConfigOption(
+        request = smart.branch.SmartServerBranchRequestSetConfigOption(
             branch.bzrdir.root_transport)
         branch_token, repo_token = self.get_lock_tokens(branch)
         config = branch._get_config()
         result = request.execute('', branch_token, repo_token, 'bar', 'foo',
             '')
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(()), result)
+        self.assertEqual(SuccessfulSmartServerResponse(()), result)
         self.assertEqual('bar', config.get_option('foo'))
         # Cleanup
         branch.unlock()
 
     def test_value_name_section(self):
         branch = self.make_branch('.')
-        request = smart_branch.SmartServerBranchRequestSetConfigOption(
+        request = smart.branch.SmartServerBranchRequestSetConfigOption(
             branch.bzrdir.root_transport)
         branch_token, repo_token = self.get_lock_tokens(branch)
         config = branch._get_config()
         result = request.execute('', branch_token, repo_token, 'bar', 'foo',
             'gam')
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(()), result)
+        self.assertEqual(SuccessfulSmartServerResponse(()), result)
         self.assertEqual('bar', config.get_option('foo', 'gam'))
         # Cleanup
         branch.unlock()
@@ -811,7 +718,7 @@
         tag_bytes = base_branch._get_tags_bytes()
         # get_lock_tokens takes out a lock.
         branch_token, repo_token = self.get_lock_tokens(base_branch)
-        request = smart_branch.SmartServerBranchSetTagsBytes(
+        request = smart.branch.SmartServerBranchSetTagsBytes(
             self.get_transport())
         response = request.execute('base', branch_token, repo_token)
         self.assertEqual(None, response)
@@ -819,14 +726,14 @@
         self.assertEqual(None, response)
         response = request.do_end()
         self.assertEquals(
-            smart_req.SuccessfulSmartServerResponse(()), response)
+            SuccessfulSmartServerResponse(()), response)
         base_branch.unlock()
 
     def test_lock_failed(self):
         base_branch = self.make_branch('base')
         base_branch.lock_write()
         tag_bytes = base_branch._get_tags_bytes()
-        request = smart_branch.SmartServerBranchSetTagsBytes(
+        request = smart.branch.SmartServerBranchSetTagsBytes(
             self.get_transport())
         self.assertRaises(errors.TokenMismatch, request.execute,
             'base', 'wrong token', 'wrong token')
@@ -863,8 +770,7 @@
 
     def assertRequestSucceeds(self, revision_id, revno):
         response = self.set_last_revision(revision_id, revno)
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(('ok',)),
-                         response)
+        self.assertEqual(SuccessfulSmartServerResponse(('ok',)), response)
 
 
 class TestSetLastRevisionVerbMixin(object):
@@ -878,9 +784,9 @@
         """If the revision_id is not present, the verb returns NoSuchRevision.
         """
         revision_id = 'non-existent revision'
-        self.assertEqual(smart_req.FailedSmartServerResponse(('NoSuchRevision',
-                                                              revision_id)),
-                         self.set_last_revision(revision_id, 1))
+        self.assertEqual(
+            FailedSmartServerResponse(('NoSuchRevision', revision_id)),
+            self.set_last_revision(revision_id, 1))
 
     def make_tree_with_two_commits(self):
         self.tree.lock_write()
@@ -926,10 +832,10 @@
         rejection_message = u'rejection message\N{INTERROBANG}'
         def hook_that_rejects(params):
             raise errors.TipChangeRejected(rejection_message)
-        _mod_branch.Branch.hooks.install_named_hook(
+        Branch.hooks.install_named_hook(
             'pre_change_branch_tip', hook_that_rejects, None)
         self.assertEqual(
-            smart_req.FailedSmartServerResponse(
+            FailedSmartServerResponse(
                 ('TipChangeRejected', rejection_message.encode('utf-8'))),
             self.set_last_revision('null:', 0))
 
@@ -938,7 +844,7 @@
         SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):
     """Tests for Branch.set_last_revision verb."""
 
-    request_class = smart_branch.SmartServerBranchRequestSetLastRevision
+    request_class = smart.branch.SmartServerBranchRequestSetLastRevision
 
     def _set_last_revision(self, revision_id, revno, branch_token, repo_token):
         return self.request.execute(
@@ -949,7 +855,7 @@
         SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):
     """Tests for Branch.set_last_revision_info verb."""
 
-    request_class = smart_branch.SmartServerBranchRequestSetLastRevisionInfo
+    request_class = smart.branch.SmartServerBranchRequestSetLastRevisionInfo
 
     def _set_last_revision(self, revision_id, revno, branch_token, repo_token):
         return self.request.execute(
@@ -966,7 +872,7 @@
         SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):
     """Tests for Branch.set_last_revision_ex verb."""
 
-    request_class = smart_branch.SmartServerBranchRequestSetLastRevisionEx
+    request_class = smart.branch.SmartServerBranchRequestSetLastRevisionEx
 
     def _set_last_revision(self, revision_id, revno, branch_token, repo_token):
         return self.request.execute(
@@ -975,7 +881,7 @@
     def assertRequestSucceeds(self, revision_id, revno):
         response = self.set_last_revision(revision_id, revno)
         self.assertEqual(
-            smart_req.SuccessfulSmartServerResponse(('ok', revno, revision_id)),
+            SuccessfulSmartServerResponse(('ok', revno, revision_id)),
             response)
 
     def test_branch_last_revision_info_rewind(self):
@@ -992,7 +898,7 @@
         response = self.request.execute(
             '', branch_token, repo_token, rev_id_utf8, 0, 0)
         self.assertEqual(
-            smart_req.SuccessfulSmartServerResponse(('ok', 2, 'rev-2')),
+            SuccessfulSmartServerResponse(('ok', 2, 'rev-2')),
             response)
         self.assertEqual(
             (2, 'rev-2'), self.tree.branch.last_revision_info())
@@ -1002,7 +908,7 @@
         response = self.request.execute(
             '', branch_token, repo_token, rev_id_utf8, 0, 1)
         self.assertEqual(
-            smart_req.SuccessfulSmartServerResponse(('ok', 1, rev_id_utf8)),
+            SuccessfulSmartServerResponse(('ok', 1, rev_id_utf8)),
             response)
         self.unlock_branch()
         self.assertEqual(
@@ -1033,7 +939,7 @@
         """
         self.make_branch_with_divergent_history()
         self.assertEqual(
-            smart_req.FailedSmartServerResponse(('Diverged',)),
+            FailedSmartServerResponse(('Diverged',)),
             self.set_last_revision('child-1', 2))
         # The branch tip was not changed.
         self.assertEqual('child-2', self.tree.branch.last_revision())
@@ -1047,7 +953,7 @@
         response = self.request.execute(
             '', branch_token, repo_token, 'child-1', 1, 0)
         self.assertEqual(
-            smart_req.SuccessfulSmartServerResponse(('ok', 2, 'child-1')),
+            SuccessfulSmartServerResponse(('ok', 2, 'child-1')),
             response)
         self.unlock_branch()
         # The branch tip was changed.
@@ -1058,18 +964,18 @@
 
     def test_get_parent_none(self):
         base_branch = self.make_branch('base')
-        request = smart_branch.SmartServerBranchGetParent(self.get_transport())
+        request = smart.branch.SmartServerBranchGetParent(self.get_transport())
         response = request.execute('base')
         self.assertEquals(
-            smart_req.SuccessfulSmartServerResponse(('',)), response)
+            SuccessfulSmartServerResponse(('',)), response)
 
     def test_get_parent_something(self):
         base_branch = self.make_branch('base')
         base_branch.set_parent(self.get_url('foo'))
-        request = smart_branch.SmartServerBranchGetParent(self.get_transport())
+        request = smart.branch.SmartServerBranchGetParent(self.get_transport())
         response = request.execute('base')
         self.assertEquals(
-            smart_req.SuccessfulSmartServerResponse(("../foo",)),
+            SuccessfulSmartServerResponse(("../foo",)),
             response)
 
 
@@ -1080,7 +986,7 @@
         branch.lock_write()
         branch._set_parent_location('foo')
         branch.unlock()
-        request = smart_branch.SmartServerBranchRequestSetParentLocation(
+        request = smart.branch.SmartServerBranchRequestSetParentLocation(
             self.get_transport())
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
@@ -1089,12 +995,12 @@
         finally:
             branch.repository.unlock()
             branch.unlock()
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(()), response)
+        self.assertEqual(SuccessfulSmartServerResponse(()), response)
         self.assertEqual(None, branch.get_parent())
 
     def test_set_parent_something(self):
         branch = self.make_branch('base', format="1.9")
-        request = smart_branch.SmartServerBranchRequestSetParentLocation(
+        request = smart.branch.SmartServerBranchRequestSetParentLocation(
             self.get_transport())
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
@@ -1104,22 +1010,21 @@
         finally:
             branch.repository.unlock()
             branch.unlock()
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(()), response)
+        self.assertEqual(SuccessfulSmartServerResponse(()), response)
         self.assertEqual('http://bar/', branch.get_parent())
 
 
-class TestSmartServerBranchRequestGetTagsBytes(
-    tests.TestCaseWithMemoryTransport):
+class TestSmartServerBranchRequestGetTagsBytes(tests.TestCaseWithMemoryTransport):
     # Only called when the branch format and tags match [yay factory
     # methods] so only need to test straight forward cases.
 
     def test_get_bytes(self):
         base_branch = self.make_branch('base')
-        request = smart_branch.SmartServerBranchGetTagsBytes(
+        request = smart.branch.SmartServerBranchGetTagsBytes(
             self.get_transport())
         response = request.execute('base')
         self.assertEquals(
-            smart_req.SuccessfulSmartServerResponse(('',)), response)
+            SuccessfulSmartServerResponse(('',)), response)
 
 
 class TestSmartServerBranchRequestGetStackedOnURL(tests.TestCaseWithMemoryTransport):
@@ -1129,11 +1034,11 @@
         stacked_branch = self.make_branch('stacked', format='1.6')
         # typically should be relative
         stacked_branch.set_stacked_on_url('../base')
-        request = smart_branch.SmartServerBranchRequestGetStackedOnURL(
+        request = smart.branch.SmartServerBranchRequestGetStackedOnURL(
             self.get_transport())
         response = request.execute('stacked')
         self.assertEquals(
-            smart_req.SmartServerResponse(('ok', '../base')),
+            SmartServerResponse(('ok', '../base')),
             response)
 
 
@@ -1144,33 +1049,33 @@
 
     def test_lock_write_on_unlocked_branch(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLockWrite(backing)
+        request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.', format='knit')
         repository = branch.repository
         response = request.execute('')
         branch_nonce = branch.control_files._lock.peek().get('nonce')
         repository_nonce = repository.control_files._lock.peek().get('nonce')
-        self.assertEqual(smart_req.SmartServerResponse(
-                ('ok', branch_nonce, repository_nonce)),
-                         response)
+        self.assertEqual(
+            SmartServerResponse(('ok', branch_nonce, repository_nonce)),
+            response)
         # The branch (and associated repository) is now locked.  Verify that
         # with a new branch object.
         new_branch = repository.bzrdir.open_branch()
         self.assertRaises(errors.LockContention, new_branch.lock_write)
         # Cleanup
-        request = smart_branch.SmartServerBranchRequestUnlock(backing)
+        request = smart.branch.SmartServerBranchRequestUnlock(backing)
         response = request.execute('', branch_nonce, repository_nonce)
 
     def test_lock_write_on_locked_branch(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLockWrite(backing)
+        request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.')
         branch_token = branch.lock_write()
         branch.leave_lock_in_place()
         branch.unlock()
         response = request.execute('')
         self.assertEqual(
-            smart_req.SmartServerResponse(('LockContention',)), response)
+            SmartServerResponse(('LockContention',)), response)
         # Cleanup
         branch.lock_write(branch_token)
         branch.dont_leave_lock_in_place()
@@ -1178,7 +1083,7 @@
 
     def test_lock_write_with_tokens_on_locked_branch(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLockWrite(backing)
+        request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.', format='knit')
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
@@ -1189,8 +1094,7 @@
         response = request.execute('',
                                    branch_token, repo_token)
         self.assertEqual(
-            smart_req.SmartServerResponse(('ok', branch_token, repo_token)),
-            response)
+            SmartServerResponse(('ok', branch_token, repo_token)), response)
         # Cleanup
         branch.repository.lock_write(repo_token)
         branch.repository.dont_leave_lock_in_place()
@@ -1201,7 +1105,7 @@
 
     def test_lock_write_with_mismatched_tokens_on_locked_branch(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLockWrite(backing)
+        request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.', format='knit')
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
@@ -1212,7 +1116,7 @@
         response = request.execute('',
                                    branch_token+'xxx', repo_token)
         self.assertEqual(
-            smart_req.SmartServerResponse(('TokenMismatch',)), response)
+            SmartServerResponse(('TokenMismatch',)), response)
         # Cleanup
         branch.repository.lock_write(repo_token)
         branch.repository.dont_leave_lock_in_place()
@@ -1223,7 +1127,7 @@
 
     def test_lock_write_on_locked_repo(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestLockWrite(backing)
+        request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.', format='knit')
         repo = branch.repository
         repo_token = repo.lock_write()
@@ -1231,7 +1135,7 @@
         repo.unlock()
         response = request.execute('')
         self.assertEqual(
-            smart_req.SmartServerResponse(('LockContention',)), response)
+            SmartServerResponse(('LockContention',)), response)
         # Cleanup
         repo.lock_write(repo_token)
         repo.dont_leave_lock_in_place()
@@ -1239,7 +1143,7 @@
 
     def test_lock_write_on_readonly_transport(self):
         backing = self.get_readonly_transport()
-        request = smart_branch.SmartServerBranchRequestLockWrite(backing)
+        request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.')
         root = self.get_transport().clone('/')
         path = urlutils.relative_url(root.base, self.get_transport().base)
@@ -1256,7 +1160,7 @@
 
     def test_unlock_on_locked_branch_and_repo(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestUnlock(backing)
+        request = smart.branch.SmartServerBranchRequestUnlock(backing)
         branch = self.make_branch('.', format='knit')
         # Lock the branch
         branch_token = branch.lock_write()
@@ -1270,7 +1174,7 @@
         response = request.execute('',
                                    branch_token, repo_token)
         self.assertEqual(
-            smart_req.SmartServerResponse(('ok',)), response)
+            SmartServerResponse(('ok',)), response)
         # The branch is now unlocked.  Verify that with a new branch
         # object.
         new_branch = branch.bzrdir.open_branch()
@@ -1279,16 +1183,16 @@
 
     def test_unlock_on_unlocked_branch_unlocked_repo(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestUnlock(backing)
+        request = smart.branch.SmartServerBranchRequestUnlock(backing)
         branch = self.make_branch('.', format='knit')
         response = request.execute(
             '', 'branch token', 'repo token')
         self.assertEqual(
-            smart_req.SmartServerResponse(('TokenMismatch',)), response)
+            SmartServerResponse(('TokenMismatch',)), response)
 
     def test_unlock_on_unlocked_branch_locked_repo(self):
         backing = self.get_transport()
-        request = smart_branch.SmartServerBranchRequestUnlock(backing)
+        request = smart.branch.SmartServerBranchRequestUnlock(backing)
         branch = self.make_branch('.', format='knit')
         # Lock the repository.
         repo_token = branch.repository.lock_write()
@@ -1299,7 +1203,7 @@
         response = request.execute(
             '', 'branch token', repo_token)
         self.assertEqual(
-            smart_req.SmartServerResponse(('TokenMismatch',)), response)
+            SmartServerResponse(('TokenMismatch',)), response)
         # Cleanup
         branch.repository.lock_write(repo_token)
         branch.repository.dont_leave_lock_in_place()
@@ -1315,7 +1219,7 @@
         # its the exact path being looked at and the server is not
         # searching.
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryRequest(backing)
+        request = smart.repository.SmartServerRepositoryRequest(backing)
         self.make_repository('.', shared=True)
         self.make_bzrdir('subdir')
         self.assertRaises(errors.NoRepositoryPresent,
@@ -1327,35 +1231,34 @@
     def test_trivial_bzipped(self):
         # This tests that the wire encoding is actually bzipped
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetParentMap(backing)
+        request = smart.repository.SmartServerRepositoryGetParentMap(backing)
         tree = self.make_branch_and_memory_tree('.')
 
         self.assertEqual(None,
             request.execute('', 'missing-id'))
         # Note that it returns a body that is bzipped.
         self.assertEqual(
-            smart_req.SuccessfulSmartServerResponse(('ok', ), bz2.compress('')),
+            SuccessfulSmartServerResponse(('ok', ), bz2.compress('')),
             request.do_body('\n\n0\n'))
 
     def test_trivial_include_missing(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetParentMap(backing)
+        request = smart.repository.SmartServerRepositoryGetParentMap(backing)
         tree = self.make_branch_and_memory_tree('.')
 
         self.assertEqual(None,
             request.execute('', 'missing-id', 'include-missing:'))
         self.assertEqual(
-            smart_req.SuccessfulSmartServerResponse(('ok', ),
+            SuccessfulSmartServerResponse(('ok', ),
                 bz2.compress('missing:missing-id')),
             request.do_body('\n\n0\n'))
 
 
-class TestSmartServerRepositoryGetRevisionGraph(
-    tests.TestCaseWithMemoryTransport):
+class TestSmartServerRepositoryGetRevisionGraph(tests.TestCaseWithMemoryTransport):
 
     def test_none_argument(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetRevisionGraph(backing)
+        request = smart.repository.SmartServerRepositoryGetRevisionGraph(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1370,11 +1273,11 @@
         response.body = '\n'.join(sorted(response.body.split('\n')))
 
         self.assertEqual(
-            smart_req.SmartServerResponse(('ok', ), '\n'.join(lines)), response)
+            SmartServerResponse(('ok', ), '\n'.join(lines)), response)
 
     def test_specific_revision_argument(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetRevisionGraph(backing)
+        request = smart.repository.SmartServerRepositoryGetRevisionGraph(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1383,12 +1286,12 @@
         r2 = tree.commit('2nd commit', rev_id=u'\xc8'.encode('utf-8'))
         tree.unlock()
 
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), rev_id_utf8),
+        self.assertEqual(SmartServerResponse(('ok', ), rev_id_utf8),
             request.execute('', rev_id_utf8))
 
     def test_no_such_revision(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetRevisionGraph(backing)
+        request = smart.repository.SmartServerRepositoryGetRevisionGraph(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1396,17 +1299,16 @@
         tree.unlock()
 
         # Note that it still returns body (of zero bytes).
-        self.assertEqual(smart_req.SmartServerResponse(
-                ('nosuchrevision', 'missingrevision', ), ''),
-                         request.execute('', 'missingrevision'))
-
-
-class TestSmartServerRepositoryGetRevIdForRevno(
-    tests.TestCaseWithMemoryTransport):
+        self.assertEqual(
+            SmartServerResponse(('nosuchrevision', 'missingrevision', ), ''),
+            request.execute('', 'missingrevision'))
+
+
+class TestSmartServerRepositoryGetRevIdForRevno(tests.TestCaseWithMemoryTransport):
 
     def test_revno_found(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetRevIdForRevno(backing)
+        request = smart.repository.SmartServerRepositoryGetRevIdForRevno(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1416,20 +1318,20 @@
         tree.commit('2nd commit', rev_id=rev2_id_utf8)
         tree.unlock()
 
-        self.assertEqual(smart_req.SmartServerResponse(('ok', rev1_id_utf8)),
+        self.assertEqual(SmartServerResponse(('ok', rev1_id_utf8)),
             request.execute('', 1, (2, rev2_id_utf8)))
 
     def test_known_revid_missing(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetRevIdForRevno(backing)
+        request = smart.repository.SmartServerRepositoryGetRevIdForRevno(backing)
         repo = self.make_repository('.')
         self.assertEqual(
-            smart_req.FailedSmartServerResponse(('nosuchrevision', 'ghost')),
+            FailedSmartServerResponse(('nosuchrevision', 'ghost')),
             request.execute('', 1, (2, 'ghost')))
 
     def test_history_incomplete(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetRevIdForRevno(backing)
+        request = smart.repository.SmartServerRepositoryGetRevIdForRevno(backing)
         parent = self.make_branch_and_memory_tree('parent', format='1.9')
         parent.lock_write()
         parent.add([''], ['TREE_ROOT'])
@@ -1443,7 +1345,7 @@
         local.branch.create_clone_on_transport(
             self.get_transport('stacked'), stacked_on=self.get_url('parent'))
         self.assertEqual(
-            smart_req.SmartServerResponse(('history-incomplete', 2, r2)),
+            SmartServerResponse(('history-incomplete', 2, r2)),
             request.execute('stacked', 1, (3, r3)))
 
 
@@ -1462,7 +1364,7 @@
     def test_ancestry_of(self):
         """The search argument may be a 'ancestry-of' some heads'."""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetStream(backing)
+        request = smart.repository.SmartServerRepositoryGetStream(backing)
         repo, r1, r2 = self.make_two_commit_repo()
         fetch_spec = ['ancestry-of', r2]
         lines = '\n'.join(fetch_spec)
@@ -1475,7 +1377,7 @@
     def test_search(self):
         """The search argument may be a 'search' of some explicit keys."""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGetStream(backing)
+        request = smart.repository.SmartServerRepositoryGetStream(backing)
         repo, r1, r2 = self.make_two_commit_repo()
         fetch_spec = ['search', '%s %s' % (r1, r2), 'null:', '2']
         lines = '\n'.join(fetch_spec)
@@ -1491,15 +1393,15 @@
     def test_missing_revision(self):
         """For a missing revision, ('no', ) is returned."""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRequestHasRevision(backing)
+        request = smart.repository.SmartServerRequestHasRevision(backing)
         self.make_repository('.')
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('', 'revid'))
 
     def test_present_revision(self):
         """For a present revision, ('yes', ) is returned."""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRequestHasRevision(backing)
+        request = smart.repository.SmartServerRequestHasRevision(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1507,7 +1409,7 @@
         r1 = tree.commit('a commit', rev_id=rev_id_utf8)
         tree.unlock()
         self.assertTrue(tree.branch.repository.has_revision(rev_id_utf8))
-        self.assertEqual(smart_req.SmartServerResponse(('yes', )),
+        self.assertEqual(SmartServerResponse(('yes', )),
             request.execute('', rev_id_utf8))
 
 
@@ -1516,18 +1418,18 @@
     def test_empty_revid(self):
         """With an empty revid, we get only size an number and revisions"""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryGatherStats(backing)
+        request = smart.repository.SmartServerRepositoryGatherStats(backing)
         repository = self.make_repository('.')
         stats = repository.gather_stats()
         expected_body = 'revisions: 0\n'
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), expected_body),
+        self.assertEqual(SmartServerResponse(('ok', ), expected_body),
                          request.execute('', '', 'no'))
 
     def test_revid_with_committers(self):
         """For a revid we get more infos."""
         backing = self.get_transport()
         rev_id_utf8 = u'\xc8abc'.encode('utf-8')
-        request = smart_repo.SmartServerRepositoryGatherStats(backing)
+        request = smart.repository.SmartServerRepositoryGatherStats(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1541,7 +1443,7 @@
         expected_body = ('firstrev: 123456.200 3600\n'
                          'latestrev: 654321.400 0\n'
                          'revisions: 2\n')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), expected_body),
+        self.assertEqual(SmartServerResponse(('ok', ), expected_body),
                          request.execute('',
                                          rev_id_utf8, 'no'))
 
@@ -1549,7 +1451,7 @@
         """For a revid and requesting committers we get the whole thing."""
         backing = self.get_transport()
         rev_id_utf8 = u'\xc8abc'.encode('utf-8')
-        request = smart_repo.SmartServerRepositoryGatherStats(backing)
+        request = smart.repository.SmartServerRepositoryGatherStats(backing)
         tree = self.make_branch_and_memory_tree('.')
         tree.lock_write()
         tree.add('')
@@ -1565,7 +1467,7 @@
                          'firstrev: 123456.200 3600\n'
                          'latestrev: 654321.400 0\n'
                          'revisions: 2\n')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), expected_body),
+        self.assertEqual(SmartServerResponse(('ok', ), expected_body),
                          request.execute('',
                                          rev_id_utf8, 'yes'))
 
@@ -1575,17 +1477,17 @@
     def test_is_shared(self):
         """For a shared repository, ('yes', ) is returned."""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryIsShared(backing)
+        request = smart.repository.SmartServerRepositoryIsShared(backing)
         self.make_repository('.', shared=True)
-        self.assertEqual(smart_req.SmartServerResponse(('yes', )),
+        self.assertEqual(SmartServerResponse(('yes', )),
             request.execute('', ))
 
     def test_is_not_shared(self):
         """For a shared repository, ('no', ) is returned."""
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryIsShared(backing)
+        request = smart.repository.SmartServerRepositoryIsShared(backing)
         self.make_repository('.', shared=False)
-        self.assertEqual(smart_req.SmartServerResponse(('no', )),
+        self.assertEqual(SmartServerResponse(('no', )),
             request.execute('', ))
 
 
@@ -1593,29 +1495,29 @@
 
     def test_lock_write_on_unlocked_repo(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryLockWrite(backing)
+        request = smart.repository.SmartServerRepositoryLockWrite(backing)
         repository = self.make_repository('.', format='knit')
         response = request.execute('')
         nonce = repository.control_files._lock.peek().get('nonce')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', nonce)), response)
+        self.assertEqual(SmartServerResponse(('ok', nonce)), response)
         # The repository is now locked.  Verify that with a new repository
         # object.
         new_repo = repository.bzrdir.open_repository()
         self.assertRaises(errors.LockContention, new_repo.lock_write)
         # Cleanup
-        request = smart_repo.SmartServerRepositoryUnlock(backing)
+        request = smart.repository.SmartServerRepositoryUnlock(backing)
         response = request.execute('', nonce)
 
     def test_lock_write_on_locked_repo(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryLockWrite(backing)
+        request = smart.repository.SmartServerRepositoryLockWrite(backing)
         repository = self.make_repository('.', format='knit')
         repo_token = repository.lock_write()
         repository.leave_lock_in_place()
         repository.unlock()
         response = request.execute('')
         self.assertEqual(
-            smart_req.SmartServerResponse(('LockContention',)), response)
+            SmartServerResponse(('LockContention',)), response)
         # Cleanup
         repository.lock_write(repo_token)
         repository.dont_leave_lock_in_place()
@@ -1623,7 +1525,7 @@
 
     def test_lock_write_on_readonly_transport(self):
         backing = self.get_readonly_transport()
-        request = smart_repo.SmartServerRepositoryLockWrite(backing)
+        request = smart.repository.SmartServerRepositoryLockWrite(backing)
         repository = self.make_repository('.', format='knit')
         response = request.execute('')
         self.assertFalse(response.is_successful())
@@ -1633,7 +1535,7 @@
 class TestInsertStreamBase(tests.TestCaseWithMemoryTransport):
 
     def make_empty_byte_stream(self, repo):
-        byte_stream = smart_repo._stream_to_byte_stream([], repo._format)
+        byte_stream = smart.repository._stream_to_byte_stream([], repo._format)
         return ''.join(byte_stream)
 
 
@@ -1641,21 +1543,21 @@
 
     def test_insert_stream_empty(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryInsertStream(backing)
+        request = smart.repository.SmartServerRepositoryInsertStream(backing)
         repository = self.make_repository('.')
         response = request.execute('', '')
         self.assertEqual(None, response)
         response = request.do_chunk(self.make_empty_byte_stream(repository))
         self.assertEqual(None, response)
         response = request.do_end()
-        self.assertEqual(smart_req.SmartServerResponse(('ok', )), response)
-
+        self.assertEqual(SmartServerResponse(('ok', )), response)
+        
 
 class TestSmartServerRepositoryInsertStreamLocked(TestInsertStreamBase):
 
     def test_insert_stream_empty(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryInsertStreamLocked(
+        request = smart.repository.SmartServerRepositoryInsertStreamLocked(
             backing)
         repository = self.make_repository('.', format='knit')
         lock_token = repository.lock_write()
@@ -1664,12 +1566,12 @@
         response = request.do_chunk(self.make_empty_byte_stream(repository))
         self.assertEqual(None, response)
         response = request.do_end()
-        self.assertEqual(smart_req.SmartServerResponse(('ok', )), response)
+        self.assertEqual(SmartServerResponse(('ok', )), response)
         repository.unlock()
 
     def test_insert_stream_with_wrong_lock_token(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryInsertStreamLocked(
+        request = smart.repository.SmartServerRepositoryInsertStreamLocked(
             backing)
         repository = self.make_repository('.', format='knit')
         lock_token = repository.lock_write()
@@ -1685,14 +1587,14 @@
 
     def test_unlock_on_locked_repo(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryUnlock(backing)
+        request = smart.repository.SmartServerRepositoryUnlock(backing)
         repository = self.make_repository('.', format='knit')
         token = repository.lock_write()
         repository.leave_lock_in_place()
         repository.unlock()
         response = request.execute('', token)
         self.assertEqual(
-            smart_req.SmartServerResponse(('ok',)), response)
+            SmartServerResponse(('ok',)), response)
         # The repository is now unlocked.  Verify that with a new repository
         # object.
         new_repo = repository.bzrdir.open_repository()
@@ -1701,40 +1603,39 @@
 
     def test_unlock_on_unlocked_repo(self):
         backing = self.get_transport()
-        request = smart_repo.SmartServerRepositoryUnlock(backing)
+        request = smart.repository.SmartServerRepositoryUnlock(backing)
         repository = self.make_repository('.', format='knit')
         response = request.execute('', 'some token')
         self.assertEqual(
-            smart_req.SmartServerResponse(('TokenMismatch',)), response)
+            SmartServerResponse(('TokenMismatch',)), response)
 
 
 class TestSmartServerIsReadonly(tests.TestCaseWithMemoryTransport):
 
     def test_is_readonly_no(self):
         backing = self.get_transport()
-        request = smart_req.SmartServerIsReadonly(backing)
+        request = smart.request.SmartServerIsReadonly(backing)
         response = request.execute()
         self.assertEqual(
-            smart_req.SmartServerResponse(('no',)), response)
+            SmartServerResponse(('no',)), response)
 
     def test_is_readonly_yes(self):
         backing = self.get_readonly_transport()
-        request = smart_req.SmartServerIsReadonly(backing)
+        request = smart.request.SmartServerIsReadonly(backing)
         response = request.execute()
         self.assertEqual(
-            smart_req.SmartServerResponse(('yes',)), response)
-
-
-class TestSmartServerRepositorySetMakeWorkingTrees(
-    tests.TestCaseWithMemoryTransport):
+            SmartServerResponse(('yes',)), response)
+
+
+class TestSmartServerRepositorySetMakeWorkingTrees(tests.TestCaseWithMemoryTransport):
 
     def test_set_false(self):
         backing = self.get_transport()
         repo = self.make_repository('.', shared=True)
         repo.set_make_working_trees(True)
-        request_class = smart_repo.SmartServerRepositorySetMakeWorkingTrees
+        request_class = smart.repository.SmartServerRepositorySetMakeWorkingTrees
         request = request_class(backing)
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(('ok',)),
+        self.assertEqual(SuccessfulSmartServerResponse(('ok',)),
             request.execute('', 'False'))
         repo = repo.bzrdir.open_repository()
         self.assertFalse(repo.make_working_trees())
@@ -1743,9 +1644,9 @@
         backing = self.get_transport()
         repo = self.make_repository('.', shared=True)
         repo.set_make_working_trees(False)
-        request_class = smart_repo.SmartServerRepositorySetMakeWorkingTrees
+        request_class = smart.repository.SmartServerRepositorySetMakeWorkingTrees
         request = request_class(backing)
-        self.assertEqual(smart_req.SuccessfulSmartServerResponse(('ok',)),
+        self.assertEqual(SuccessfulSmartServerResponse(('ok',)),
             request.execute('', 'True'))
         repo = repo.bzrdir.open_repository()
         self.assertTrue(repo.make_working_trees())
@@ -1770,10 +1671,10 @@
         repo.lock_write()
         self.addCleanup(repo.unlock)
         backing = self.get_transport()
-        request = smart_packrepo.SmartServerPackRepositoryAutopack(
+        request = smart.packrepository.SmartServerPackRepositoryAutopack(
             backing)
         response = request.execute('')
-        self.assertEqual(smart_req.SmartServerResponse(('ok',)), response)
+        self.assertEqual(SmartServerResponse(('ok',)), response)
         repo._pack_collection.reload_pack_names()
         self.assertEqual(1, len(repo._pack_collection.names()))
 
@@ -1785,10 +1686,10 @@
         for x in range(9):
             tree.commit('commit %s' % x)
         backing = self.get_transport()
-        request = smart_packrepo.SmartServerPackRepositoryAutopack(
+        request = smart.packrepository.SmartServerPackRepositoryAutopack(
             backing)
         response = request.execute('')
-        self.assertEqual(smart_req.SmartServerResponse(('ok',)), response)
+        self.assertEqual(SmartServerResponse(('ok',)), response)
         repo._pack_collection.reload_pack_names()
         self.assertEqual(9, len(repo._pack_collection.names()))
 
@@ -1796,10 +1697,10 @@
         """A request to autopack a non-pack repo is a no-op."""
         repo = self.make_repository('.', format='knit')
         backing = self.get_transport()
-        request = smart_packrepo.SmartServerPackRepositoryAutopack(
+        request = smart.packrepository.SmartServerPackRepositoryAutopack(
             backing)
         response = request.execute('')
-        self.assertEqual(smart_req.SmartServerResponse(('ok',)), response)
+        self.assertEqual(SmartServerResponse(('ok',)), response)
 
 
 class TestSmartServerVfsGet(tests.TestCaseWithMemoryTransport):
@@ -1809,9 +1710,9 @@
         filename = u'foo\N{INTERROBANG}'
         filename_escaped = urlutils.escape(filename)
         backing = self.get_transport()
-        request = vfs.GetRequest(backing)
+        request = smart.vfs.GetRequest(backing)
         backing.put_bytes_non_atomic(filename_escaped, 'contents')
-        self.assertEqual(smart_req.SmartServerResponse(('ok', ), 'contents'),
+        self.assertEqual(SmartServerResponse(('ok', ), 'contents'),
             request.execute(filename_escaped))
 
 
@@ -1822,81 +1723,79 @@
         """All registered request_handlers can be found."""
         # If there's a typo in a register_lazy call, this loop will fail with
         # an AttributeError.
-        for key, item in smart_req.request_handlers.iteritems():
+        for key, item in smart.request.request_handlers.iteritems():
             pass
 
     def assertHandlerEqual(self, verb, handler):
-        self.assertEqual(smart_req.request_handlers.get(verb), handler)
+        self.assertEqual(smart.request.request_handlers.get(verb), handler)
 
     def test_registered_methods(self):
         """Test that known methods are registered to the correct object."""
         self.assertHandlerEqual('Branch.get_config_file',
-            smart_branch.SmartServerBranchGetConfigFile)
+            smart.branch.SmartServerBranchGetConfigFile)
         self.assertHandlerEqual('Branch.get_parent',
-            smart_branch.SmartServerBranchGetParent)
+            smart.branch.SmartServerBranchGetParent)
         self.assertHandlerEqual('Branch.get_tags_bytes',
-            smart_branch.SmartServerBranchGetTagsBytes)
+            smart.branch.SmartServerBranchGetTagsBytes)
         self.assertHandlerEqual('Branch.lock_write',
-            smart_branch.SmartServerBranchRequestLockWrite)
+            smart.branch.SmartServerBranchRequestLockWrite)
         self.assertHandlerEqual('Branch.last_revision_info',
-            smart_branch.SmartServerBranchRequestLastRevisionInfo)
+            smart.branch.SmartServerBranchRequestLastRevisionInfo)
         self.assertHandlerEqual('Branch.revision_history',
-            smart_branch.SmartServerRequestRevisionHistory)
+            smart.branch.SmartServerRequestRevisionHistory)
         self.assertHandlerEqual('Branch.set_config_option',
-            smart_branch.SmartServerBranchRequestSetConfigOption)
+            smart.branch.SmartServerBranchRequestSetConfigOption)
         self.assertHandlerEqual('Branch.set_last_revision',
-            smart_branch.SmartServerBranchRequestSetLastRevision)
+            smart.branch.SmartServerBranchRequestSetLastRevision)
         self.assertHandlerEqual('Branch.set_last_revision_info',
-            smart_branch.SmartServerBranchRequestSetLastRevisionInfo)
+            smart.branch.SmartServerBranchRequestSetLastRevisionInfo)
         self.assertHandlerEqual('Branch.set_last_revision_ex',
-            smart_branch.SmartServerBranchRequestSetLastRevisionEx)
+            smart.branch.SmartServerBranchRequestSetLastRevisionEx)
         self.assertHandlerEqual('Branch.set_parent_location',
-            smart_branch.SmartServerBranchRequestSetParentLocation)
+            smart.branch.SmartServerBranchRequestSetParentLocation)
         self.assertHandlerEqual('Branch.unlock',
-            smart_branch.SmartServerBranchRequestUnlock)
+            smart.branch.SmartServerBranchRequestUnlock)
         self.assertHandlerEqual('BzrDir.find_repository',
-            smart_dir.SmartServerRequestFindRepositoryV1)
+            smart.bzrdir.SmartServerRequestFindRepositoryV1)
         self.assertHandlerEqual('BzrDir.find_repositoryV2',
-            smart_dir.SmartServerRequestFindRepositoryV2)
+            smart.bzrdir.SmartServerRequestFindRepositoryV2)
         self.assertHandlerEqual('BzrDirFormat.initialize',
-            smart_dir.SmartServerRequestInitializeBzrDir)
+            smart.bzrdir.SmartServerRequestInitializeBzrDir)
         self.assertHandlerEqual('BzrDirFormat.initialize_ex_1.16',
-            smart_dir.SmartServerRequestBzrDirInitializeEx)
+            smart.bzrdir.SmartServerRequestBzrDirInitializeEx)
         self.assertHandlerEqual('BzrDir.cloning_metadir',
-            smart_dir.SmartServerBzrDirRequestCloningMetaDir)
+            smart.bzrdir.SmartServerBzrDirRequestCloningMetaDir)
         self.assertHandlerEqual('BzrDir.get_config_file',
-            smart_dir.SmartServerBzrDirRequestConfigFile)
+            smart.bzrdir.SmartServerBzrDirRequestConfigFile)
         self.assertHandlerEqual('BzrDir.open_branch',
-            smart_dir.SmartServerRequestOpenBranch)
+            smart.bzrdir.SmartServerRequestOpenBranch)
         self.assertHandlerEqual('BzrDir.open_branchV2',
-            smart_dir.SmartServerRequestOpenBranchV2)
-        self.assertHandlerEqual('BzrDir.open_branchV3',
-            smart_dir.SmartServerRequestOpenBranchV3)
+            smart.bzrdir.SmartServerRequestOpenBranchV2)
         self.assertHandlerEqual('PackRepository.autopack',
-            smart_packrepo.SmartServerPackRepositoryAutopack)
+            smart.packrepository.SmartServerPackRepositoryAutopack)
         self.assertHandlerEqual('Repository.gather_stats',
-            smart_repo.SmartServerRepositoryGatherStats)
+            smart.repository.SmartServerRepositoryGatherStats)
         self.assertHandlerEqual('Repository.get_parent_map',
-            smart_repo.SmartServerRepositoryGetParentMap)
+            smart.repository.SmartServerRepositoryGetParentMap)
         self.assertHandlerEqual('Repository.get_rev_id_for_revno',
-            smart_repo.SmartServerRepositoryGetRevIdForRevno)
+            smart.repository.SmartServerRepositoryGetRevIdForRevno)
         self.assertHandlerEqual('Repository.get_revision_graph',
-            smart_repo.SmartServerRepositoryGetRevisionGraph)
+            smart.repository.SmartServerRepositoryGetRevisionGraph)
         self.assertHandlerEqual('Repository.get_stream',
-            smart_repo.SmartServerRepositoryGetStream)
+            smart.repository.SmartServerRepositoryGetStream)
         self.assertHandlerEqual('Repository.has_revision',
-            smart_repo.SmartServerRequestHasRevision)
+            smart.repository.SmartServerRequestHasRevision)
         self.assertHandlerEqual('Repository.insert_stream',
-            smart_repo.SmartServerRepositoryInsertStream)
+            smart.repository.SmartServerRepositoryInsertStream)
         self.assertHandlerEqual('Repository.insert_stream_locked',
-            smart_repo.SmartServerRepositoryInsertStreamLocked)
+            smart.repository.SmartServerRepositoryInsertStreamLocked)
         self.assertHandlerEqual('Repository.is_shared',
-            smart_repo.SmartServerRepositoryIsShared)
+            smart.repository.SmartServerRepositoryIsShared)
         self.assertHandlerEqual('Repository.lock_write',
-            smart_repo.SmartServerRepositoryLockWrite)
+            smart.repository.SmartServerRepositoryLockWrite)
         self.assertHandlerEqual('Repository.tarball',
-            smart_repo.SmartServerRepositoryTarball)
+            smart.repository.SmartServerRepositoryTarball)
         self.assertHandlerEqual('Repository.unlock',
-            smart_repo.SmartServerRepositoryUnlock)
+            smart.repository.SmartServerRepositoryUnlock)
         self.assertHandlerEqual('Transport.is_readonly',
-            smart_req.SmartServerIsReadonly)
+            smart.request.SmartServerIsReadonly)

=== modified file 'bzrlib/tests/test_smart_add.py'
--- bzrlib/tests/test_smart_add.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/test_smart_add.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,15 +16,16 @@
 
 from cStringIO import StringIO
 
-from bzrlib import (
-    add,
-    inventory,
-    osutils,
-    tests,
+from bzrlib import osutils
+from bzrlib.add import (
+    AddAction,
+    AddFromBaseAction,
     )
-
-
-class AddCustomIDAction(add.AddAction):
+from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.inventory import Inventory
+
+
+class AddCustomIDAction(AddAction):
 
     def __call__(self, inv, parent_ie, path, kind):
         # The first part just logs if appropriate
@@ -38,7 +39,7 @@
         return file_id
 
 
-class TestAddFrom(tests.TestCaseWithTransport):
+class TestAddFrom(TestCaseWithTransport):
     """Tests for AddFromBaseAction"""
 
     def make_base_tree(self):
@@ -59,9 +60,9 @@
         try:
             new_tree.lock_write()
             try:
-                action = add.AddFromBaseAction(base_tree, base_path,
-                                               to_file=to_file,
-                                               should_print=should_print)
+                action = AddFromBaseAction(base_tree, base_path,
+                                           to_file=to_file,
+                                           should_print=should_print)
                 new_tree.smart_add(file_list, action=action)
             finally:
                 new_tree.unlock()
@@ -143,7 +144,7 @@
         self.failIf(a_id in self.base_tree)
 
 
-class TestAddActions(tests.TestCase):
+class TestAddActions(TestCase):
 
     def test_quiet(self):
         self.run_action("")
@@ -152,10 +153,11 @@
         self.run_action("adding path\n")
 
     def run_action(self, output):
+        from bzrlib.add import AddAction
         from bzrlib.mutabletree import _FastPath
-        inv = inventory.Inventory()
+        inv = Inventory()
         stdout = StringIO()
-        action = add.AddAction(to_file=stdout, should_print=bool(output))
+        action = AddAction(to_file=stdout, should_print=bool(output))
 
         self.apply_redirected(None, stdout, None, action, inv, None,
             _FastPath('path'), 'file')

=== modified file 'bzrlib/tests/test_smart_transport.py'
--- bzrlib/tests/test_smart_transport.py	2010-03-18 23:11:15 +0000
+++ bzrlib/tests/test_smart_transport.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,7 +28,6 @@
         errors,
         osutils,
         tests,
-        transport,
         urlutils,
         )
 from bzrlib.smart import (
@@ -40,13 +39,14 @@
         server,
         vfs,
 )
-from bzrlib.tests import test_smart
+from bzrlib.tests.test_smart import TestCaseWithSmartMedium
 from bzrlib.transport import (
-        http,
+        get_transport,
         local,
         memory,
         remote,
         )
+from bzrlib.transport.http import SmartClientHTTPMediumRequest
 
 
 class StringIOSSHVendor(object):
@@ -557,7 +557,7 @@
         self.assertRaises(errors.ReadingCompleted, request.read_bytes, None)
 
 
-class RemoteTransportTests(test_smart.TestCaseWithSmartMedium):
+class RemoteTransportTests(TestCaseWithSmartMedium):
 
     def test_plausible_url(self):
         self.assert_(self.get_url().startswith('bzr://'))
@@ -1003,14 +1003,12 @@
             mem_server.start_server()
             self.addCleanup(mem_server.stop_server)
             self.permit_url(mem_server.get_url())
-            self.backing_transport = transport.get_transport(
-                mem_server.get_url())
+            self.backing_transport = get_transport(mem_server.get_url())
         else:
             self.backing_transport = backing_transport
         if readonly:
             self.real_backing_transport = self.backing_transport
-            self.backing_transport = transport.get_transport(
-                "readonly+" + self.backing_transport.abspath('.'))
+            self.backing_transport = get_transport("readonly+" + self.backing_transport.abspath('.'))
         self.server = server.SmartTCPServer(self.backing_transport)
         self.server.start_background_thread('-' + self.id())
         self.transport = remote.RemoteTCPTransport(self.server.get_url())
@@ -1163,7 +1161,7 @@
         self.hook_calls = []
         server.SmartTCPServer.hooks.install_named_hook('server_started',
             self.capture_server_call, None)
-        self.start_server(backing_transport=transport.get_transport("."))
+        self.start_server(backing_transport=get_transport("."))
         # at this point, the server will be starting a thread up.
         # there is no indicator at the moment, so bodge it by doing a request.
         self.transport.has('.')
@@ -1196,7 +1194,7 @@
         self.hook_calls = []
         server.SmartTCPServer.hooks.install_named_hook('server_stopped',
             self.capture_server_call, None)
-        self.start_server(backing_transport=transport.get_transport("."))
+        self.start_server(backing_transport=get_transport("."))
         result = [(
             [self.backing_transport.base, self.backing_transport.external_url()]
             , self.transport.base)]
@@ -1341,13 +1339,13 @@
 class RemoteTransportRegistration(tests.TestCase):
 
     def test_registration(self):
-        t = transport.get_transport('bzr+ssh://example.com/path')
+        t = get_transport('bzr+ssh://example.com/path')
         self.assertIsInstance(t, remote.RemoteSSHTransport)
         self.assertEqual('example.com', t._host)
 
     def test_bzr_https(self):
         # https://bugs.launchpad.net/bzr/+bug/128456
-        t = transport.get_transport('bzr+https://example.com/path')
+        t = get_transport('bzr+https://example.com/path')
         self.assertIsInstance(t, remote.RemoteHTTPTransport)
         self.assertStartsWith(
             t._http_transport.base,
@@ -3518,7 +3516,7 @@
 
     def test_smart_http_medium_request_accept_bytes(self):
         medium = FakeHTTPMedium()
-        request = http.SmartClientHTTPMediumRequest(medium)
+        request = SmartClientHTTPMediumRequest(medium)
         request.accept_bytes('abc')
         request.accept_bytes('def')
         self.assertEqual(None, medium.written_request)

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_source.py	2009-09-17 19:16:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -372,53 +372,3 @@
             self.fail(
                 "these files contain an assert statement and should not:\n%s"
                 % '\n'.join(badfiles))
-
-    def test_extension_exceptions(self):
-        """Extension functions should propagate exceptions.
-
-        Either they should return an object, have an 'except' clause, or have a
-        "# cannot_raise" to indicate that we've audited them and defined them as not
-        raising exceptions.
-        """
-        both_exc_and_no_exc = []
-        missing_except = []
-        class_re = re.compile(r'^(cdef\s+)?(public\s+)?(api\s+)?class (\w+).*:',
-                              re.MULTILINE)
-        except_re = re.compile(r'cdef\s+' # start with cdef
-                               r'([\w *]*?)\s*' # this is the return signature
-                               r'(\w+)\s*\(' # the function name
-                               r'[^)]*\)\s*' # parameters
-                               r'(.*)\s*:' # the except clause
-                               r'\s*(#\s*cannot[- _]raise)?' # cannot raise comment
-                              )
-        for fname, text in self.get_source_file_contents(
-                extensions=('.pyx',)):
-            known_classes = set([m[-1] for m in class_re.findall(text)])
-            cdefs = except_re.findall(text)
-            for sig, func, exc_clause, no_exc_comment in cdefs:
-                if sig.startswith('api '):
-                    sig = sig[4:]
-                if not sig or sig in known_classes:
-                    sig = 'object'
-                if 'nogil' in exc_clause:
-                    exc_clause = exc_clause.replace('nogil', '').strip()
-                if exc_clause and no_exc_comment:
-                    both_exc_and_no_exc.append((fname, func))
-                if sig != 'object' and not (exc_clause or no_exc_comment):
-                    missing_except.append((fname, func))
-        error_msg = []
-        if both_exc_and_no_exc:
-            error_msg.append('The following functions had "cannot raise" comments'
-                             ' but did have an except clause set:')
-            for fname, func in both_exc_and_no_exc:
-                error_msg.append('%s:%s' % (fname, func))
-            error_msg.extend(('', ''))
-        if missing_except:
-            error_msg.append('The following functions have fixed return types,'
-                             ' but no except clause.')
-            error_msg.append('Either add an except or append "# cannot_raise".')
-            for fname, func in missing_except:
-                error_msg.append('%s:%s' % (fname, func))
-            error_msg.extend(('', ''))
-        if error_msg:
-            self.fail('\n'.join(error_msg))

=== modified file 'bzrlib/tests/test_ssh_transport.py'
--- bzrlib/tests/test_ssh_transport.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_ssh_transport.py	2009-11-07 08:02:13 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_switch.py'
--- bzrlib/tests/test_switch.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/test_switch.py	2009-05-07 05:08:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,13 +19,7 @@
 
 import os
 
-from bzrlib import (
-    branch,
-    errors,
-    merge as _mod_merge,
-    switch,
-    tests,
-)
+from bzrlib import branch, errors, switch, tests
 
 
 class TestSwitch(tests.TestCaseWithTransport):
@@ -106,53 +100,6 @@
         self.assertContainsRe(str(err),
             "Pending merges must be committed or reverted before using switch")
 
-    def test_switch_with_revision(self):
-        """Test switch when a revision is given."""
-        # Create a tree with 2 revisions
-        tree = self.make_branch_and_tree('branch-1')
-        self.build_tree(['branch-1/file-1'])
-        tree.add('file-1')
-        tree.commit(rev_id='rev1', message='rev1')
-        self.build_tree(['branch-1/file-2'])
-        tree.add('file-2')
-        tree.commit(rev_id='rev2', message='rev2')
-        # Check it out and switch to revision 1
-        checkout = tree.branch.create_checkout('checkout',
-            lightweight=self.lightweight)
-        switch.switch(checkout.bzrdir, tree.branch, revision_id="rev1")
-        self.failUnlessExists('checkout/file-1')
-        self.failIfExists('checkout/file-2')
-
-    def test_switch_changing_root_id(self):
-        tree = self._setup_tree()
-        tree2 = self.make_branch_and_tree('tree-2')
-        tree2.set_root_id('custom-root-id')
-        self.build_tree(['tree-2/file-2'])
-        tree2.add(['file-2'])
-        tree2.commit('rev1b')
-        checkout = tree.branch.create_checkout('checkout',
-            lightweight=self.lightweight)
-        switch.switch(checkout.bzrdir, tree2.branch)
-        self.assertEqual('custom-root-id', tree2.get_root_id())
-
-    def test_switch_configurable_file_merger(self):
-        class DummyMerger(_mod_merge.ConfigurableFileMerger):
-            name_prefix = 'file'
-
-        _mod_merge.Merger.hooks.install_named_hook(
-            'merge_file_content', DummyMerger,
-            'test factory')
-        foo = self.make_branch('foo')
-        checkout = foo.create_checkout('checkout', lightweight=True)
-        self.build_tree_contents([('checkout/file', 'a')])
-        checkout.add('file')
-        checkout.commit('a')
-        bar = foo.bzrdir.sprout('bar').open_workingtree()
-        self.build_tree_contents([('bar/file', 'b')])
-        bar.commit('b')
-        self.build_tree_contents([('checkout/file', 'c')])
-        switch.switch(checkout.bzrdir, bar.branch)
-
 
 class TestSwitchHeavyweight(TestSwitch):
 

=== modified file 'bzrlib/tests/test_symbol_versioning.py'
--- bzrlib/tests/test_symbol_versioning.py	2010-04-23 08:51:52 +0000
+++ bzrlib/tests/test_symbol_versioning.py	2009-09-15 01:43:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -179,9 +179,6 @@
     def check_deprecated_callable(self, expected_warning, expected_docstring,
                                   expected_name, expected_module,
                                   deprecated_callable):
-        if __doc__ is None:
-            # With -OO the docstring should just be the deprecated version
-            expected_docstring = expected_docstring.split('\n')[-2].lstrip()
         old_warning_method = symbol_versioning.warn
         try:
             symbol_versioning.set_warning_method(self.capture_warning)

=== modified file 'bzrlib/tests/test_tag.py'
--- bzrlib/tests/test_tag.py	2010-03-25 09:39:03 +0000
+++ bzrlib/tests/test_tag.py	2009-05-06 05:36:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,15 +14,16 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Tests for bzrlib.tag."""
-
 
 from bzrlib import (
+    branch,
     bzrdir,
     errors,
+    tag,
     )
 from bzrlib.tag import (
     BasicTags,
+    _merge_tags_if_possible,
     DisabledTags,
     )
 from bzrlib.tests import (
@@ -183,6 +184,3 @@
 
     def test_get_reverse_tag_dict(self):
         self.assertEqual(self.tags.get_reverse_tag_dict(), {})
-
-
-

=== modified file 'bzrlib/tests/test_trace.py'
--- bzrlib/tests/test_trace.py	2010-02-25 13:15:08 +0000
+++ bzrlib/tests/test_trace.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,7 +27,6 @@
 
 from bzrlib import (
     errors,
-    trace,
     )
 from bzrlib.tests import TestCaseInTempDir, TestCase
 from bzrlib.trace import (
@@ -36,7 +35,6 @@
     pop_log_file,
     push_log_file,
     _rollover_trace_maybe,
-    show_error,
     )
 
 
@@ -216,26 +214,6 @@
         # have to do a replaceent here as well.
         self.assertContainsRe(log, "ascii argument: \xb5".decode('utf8',
             'replace'))
-        
-    def test_show_error(self):
-        show_error('error1')
-        show_error(u'error2 \xb5 blah')
-        show_error('arg: %s', 'blah')
-        show_error('arg2: %(key)s', {'key':'stuff'})
-        try:
-            raise Exception("oops")
-        except:
-            show_error('kwarg', exc_info=True)
-        log = self.get_log()
-        self.assertContainsRe(log, 'error1')
-        self.assertContainsRe(log, u'error2 \xb5 blah')
-        self.assertContainsRe(log, 'arg: blah')
-        self.assertContainsRe(log, 'arg2: stuff')
-        self.assertContainsRe(log, 'kwarg')
-        self.assertContainsRe(log, 'Traceback \\(most recent call last\\):')
-        self.assertContainsRe(log, 'File ".*test_trace.py", line .*, in test_show_error')
-        self.assertContainsRe(log, 'raise Exception\\("oops"\\)')
-        self.assertContainsRe(log, 'Exception: oops')
 
     def test_push_log_file(self):
         """Can push and pop log file, and this catches mutter messages.
@@ -270,21 +248,6 @@
             tmp1.close()
             tmp2.close()
 
-    def test__open_bzr_log_uses_stderr_for_failures(self):
-        # If _open_bzr_log cannot open the file, then we should write the
-        # warning to stderr. Since this is normally happening before logging is
-        # set up.
-        self.overrideAttr(sys, 'stderr', StringIO())
-        # Set the log file to something that cannot exist
-        # FIXME: A bit dangerous: we are not in an isolated dir here -- vilajam
-        # 20100125
-        os.environ['BZR_LOG'] = os.getcwd() + '/no-dir/bzr.log'
-        self.overrideAttr(trace, '_bzr_log_filename')
-        logf = trace._open_bzr_log()
-        self.assertIs(None, logf)
-        self.assertContainsRe(sys.stderr.getvalue(),
-                              'failed to open trace file: .*/no-dir/bzr.log')
-
 
 class TestVerbosityLevel(TestCase):
 

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2010-03-12 10:52:01 +0000
+++ bzrlib/tests/test_transform.py	2009-12-04 06:13:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,7 +17,6 @@
 import os
 from StringIO import StringIO
 import sys
-import time
 
 from bzrlib import (
     bencode,
@@ -137,59 +136,6 @@
         transform.finalize()
         transform.finalize()
 
-    def test_create_files_same_timestamp(self):
-        transform, root = self.get_transform()
-        self.wt.lock_tree_write()
-        self.addCleanup(self.wt.unlock)
-        # Roll back the clock, so that we know everything is being set to the
-        # exact time
-        transform._creation_mtime = creation_mtime = time.time() - 20.0
-        transform.create_file('content-one',
-                              transform.create_path('one', root))
-        time.sleep(1) # *ugly*
-        transform.create_file('content-two',
-                              transform.create_path('two', root))
-        transform.apply()
-        fo, st1 = self.wt.get_file_with_stat(None, path='one', filtered=False)
-        fo.close()
-        fo, st2 = self.wt.get_file_with_stat(None, path='two', filtered=False)
-        fo.close()
-        # We only guarantee 2s resolution
-        self.assertTrue(abs(creation_mtime - st1.st_mtime) < 2.0,
-            "%s != %s within 2 seconds" % (creation_mtime, st1.st_mtime))
-        # But if we have more than that, all files should get the same result
-        self.assertEqual(st1.st_mtime, st2.st_mtime)
-
-    def test_change_root_id(self):
-        transform, root = self.get_transform()
-        self.assertNotEqual('new-root-id', self.wt.get_root_id())
-        transform.new_directory('', ROOT_PARENT, 'new-root-id')
-        transform.delete_contents(root)
-        transform.unversion_file(root)
-        transform.fixup_new_roots()
-        transform.apply()
-        self.assertEqual('new-root-id', self.wt.get_root_id())
-
-    def test_change_root_id_add_files(self):
-        transform, root = self.get_transform()
-        self.assertNotEqual('new-root-id', self.wt.get_root_id())
-        new_trans_id = transform.new_directory('', ROOT_PARENT, 'new-root-id')
-        transform.new_file('file', new_trans_id, ['new-contents\n'],
-                           'new-file-id')
-        transform.delete_contents(root)
-        transform.unversion_file(root)
-        transform.fixup_new_roots()
-        transform.apply()
-        self.assertEqual('new-root-id', self.wt.get_root_id())
-        self.assertEqual('new-file-id', self.wt.path2id('file'))
-        self.assertFileEqual('new-contents\n', self.wt.abspath('file'))
-
-    def test_add_two_roots(self):
-        transform, root = self.get_transform()
-        new_trans_id = transform.new_directory('', ROOT_PARENT, 'new-root-id')
-        new_trans_id = transform.new_directory('', ROOT_PARENT, 'alt-root-id')
-        self.assertRaises(ValueError, transform.fixup_new_roots)
-
     def test_hardlink(self):
         self.requireFeature(HardlinkFeature)
         transform, root = self.get_transform()
@@ -735,7 +681,7 @@
                                          ' versioned, but has versioned'
                                          ' children.  Versioned directory.')
         self.assertEqual(conflicts_s[6], 'Conflict moving oz/emeraldcity into'
-                                         ' oz/emeraldcity. Cancelled move.')
+                                         ' oz/emeraldcity.  Cancelled move.')
 
     def prepare_wrong_parent_kind(self):
         tt, root = self.get_transform()
@@ -812,7 +758,7 @@
         create.apply()
         transform, root = self.get_transform()
         transform.adjust_root_path('oldroot', fun)
-        new_root = transform.trans_id_tree_path('')
+        new_root=transform.trans_id_tree_path('')
         transform.version_file('new-root', new_root)
         transform.apply()
 
@@ -1923,10 +1869,6 @@
         self.assertTrue(source.is_executable('file1-id'))
 
     def install_rot13_content_filter(self, pattern):
-        # We could use
-        # self.addCleanup(filters._reset_registry, filters._reset_registry())
-        # below, but that looks a bit... hard to read even if it's exactly
-        # the same thing.
         original_registry = filters._reset_registry()
         def restore_registry():
             filters._reset_registry(original_registry)
@@ -2371,7 +2313,7 @@
     def test_ignore_pb(self):
         # pb could be supported, but TT.iter_changes doesn't support it.
         revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        preview_tree.iter_changes(revision_tree)
+        preview_tree.iter_changes(revision_tree, pb=progress.DummyProgress())
 
     def test_kind(self):
         revision_tree = self.create_tree()
@@ -2739,7 +2681,7 @@
         preview = self.get_empty_preview()
         root = preview.new_directory('', ROOT_PARENT, 'tree-root')
         # FIXME: new_directory should mark root.
-        preview.fixup_new_roots()
+        preview.adjust_path('', ROOT_PARENT, root)
         preview_tree = preview.get_preview_tree()
         file_trans_id = preview.new_file('a', preview.root, 'contents',
                                          'a-id')
@@ -2779,8 +2721,9 @@
         file_trans_id = preview.trans_id_file_id('file-id')
         preview.delete_contents(file_trans_id)
         preview.create_file('a\nb\n', file_trans_id)
+        pb = progress.DummyProgress()
         preview_tree = preview.get_preview_tree()
-        merger = Merger.from_revision_ids(None, preview_tree,
+        merger = Merger.from_revision_ids(pb, preview_tree,
                                           child_tree.branch.last_revision(),
                                           other_branch=child_tree.branch,
                                           tree_branch=work_tree.branch)
@@ -2798,8 +2741,9 @@
         tt.new_file('name', tt.root, 'content', 'file-id')
         tree2 = self.make_branch_and_tree('tree2')
         tree2.set_root_id('TREE_ROOT')
+        pb = progress.DummyProgress()
         merger = Merger.from_uncommitted(tree2, tt.get_preview_tree(),
-                                         None, tree.basis_tree())
+                                         pb, tree.basis_tree())
         merger.merge_type = Merge3Merger
         merger.do_merge()
 
@@ -2815,7 +2759,7 @@
         tt.create_file('baz', trans_id)
         tree2 = tree.bzrdir.sprout('tree2').open_workingtree()
         self.build_tree_contents([('tree2/foo', 'qux')])
-        pb = None
+        pb = progress.DummyProgress()
         merger = Merger.from_uncommitted(tree2, tt.get_preview_tree(),
                                          pb, tree.basis_tree())
         merger.merge_type = Merge3Merger

=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_transport.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,80 +21,89 @@
 import sys
 import threading
 
+import bzrlib
 from bzrlib import (
     errors,
     osutils,
     tests,
-    transport,
     urlutils,
     )
-from bzrlib.transport import (
-    chroot,
-    fakenfs,
-    local,
-    memory,
-    pathfilter,
-    readonly,
-    )
-from bzrlib.tests import (
-    features,
-    test_server,
-    )
+from bzrlib.errors import (DependencyNotPresent,
+                           FileExists,
+                           InvalidURLJoin,
+                           NoSuchFile,
+                           PathNotChild,
+                           ReadError,
+                           UnsupportedProtocol,
+                           )
+from bzrlib.tests import features, TestCase, TestCaseInTempDir
+from bzrlib.transport import (_clear_protocol_handlers,
+                              _CoalescedOffset,
+                              ConnectedTransport,
+                              _get_protocol_handlers,
+                              _set_protocol_handlers,
+                              _get_transport_modules,
+                              get_transport,
+                              LateReadError,
+                              register_lazy_transport,
+                              register_transport_proto,
+                              Transport,
+                              )
+from bzrlib.transport.chroot import ChrootServer
+from bzrlib.transport.memory import MemoryTransport
+from bzrlib.transport.local import (LocalTransport,
+                                    EmulatedWin32LocalTransport)
+from bzrlib.transport.pathfilter import PathFilteringServer
 
 
 # TODO: Should possibly split transport-specific tests into their own files.
 
 
-class TestTransport(tests.TestCase):
+class TestTransport(TestCase):
     """Test the non transport-concrete class functionality."""
 
-    # FIXME: These tests should use addCleanup() and/or overrideAttr() instead
-    # of try/finally -- vila 20100205
-
     def test__get_set_protocol_handlers(self):
-        handlers = transport._get_protocol_handlers()
+        handlers = _get_protocol_handlers()
         self.assertNotEqual([], handlers.keys( ))
         try:
-            transport._clear_protocol_handlers()
-            self.assertEqual([], transport._get_protocol_handlers().keys())
+            _clear_protocol_handlers()
+            self.assertEqual([], _get_protocol_handlers().keys())
         finally:
-            transport._set_protocol_handlers(handlers)
+            _set_protocol_handlers(handlers)
 
     def test_get_transport_modules(self):
-        handlers = transport._get_protocol_handlers()
+        handlers = _get_protocol_handlers()
         # don't pollute the current handlers
-        transport._clear_protocol_handlers()
+        _clear_protocol_handlers()
         class SampleHandler(object):
             """I exist, isnt that enough?"""
         try:
-            transport._clear_protocol_handlers()
-            transport.register_transport_proto('foo')
-            transport.register_lazy_transport('foo',
-                                              'bzrlib.tests.test_transport',
-                                              'TestTransport.SampleHandler')
-            transport.register_transport_proto('bar')
-            transport.register_lazy_transport('bar',
-                                              'bzrlib.tests.test_transport',
-                                              'TestTransport.SampleHandler')
+            _clear_protocol_handlers()
+            register_transport_proto('foo')
+            register_lazy_transport('foo', 'bzrlib.tests.test_transport',
+                                    'TestTransport.SampleHandler')
+            register_transport_proto('bar')
+            register_lazy_transport('bar', 'bzrlib.tests.test_transport',
+                                    'TestTransport.SampleHandler')
             self.assertEqual([SampleHandler.__module__,
                               'bzrlib.transport.chroot',
                               'bzrlib.transport.pathfilter'],
-                             transport._get_transport_modules())
+                             _get_transport_modules())
         finally:
-            transport._set_protocol_handlers(handlers)
+            _set_protocol_handlers(handlers)
 
     def test_transport_dependency(self):
         """Transport with missing dependency causes no error"""
-        saved_handlers = transport._get_protocol_handlers()
+        saved_handlers = _get_protocol_handlers()
         # don't pollute the current handlers
-        transport._clear_protocol_handlers()
+        _clear_protocol_handlers()
         try:
-            transport.register_transport_proto('foo')
-            transport.register_lazy_transport(
-                'foo', 'bzrlib.tests.test_transport', 'BadTransportHandler')
+            register_transport_proto('foo')
+            register_lazy_transport('foo', 'bzrlib.tests.test_transport',
+                    'BadTransportHandler')
             try:
-                transport.get_transport('foo://fooserver/foo')
-            except errors.UnsupportedProtocol, e:
+                get_transport('foo://fooserver/foo')
+            except UnsupportedProtocol, e:
                 e_str = str(e)
                 self.assertEquals('Unsupported protocol'
                                   ' for url "foo://fooserver/foo":'
@@ -104,49 +113,48 @@
                 self.fail('Did not raise UnsupportedProtocol')
         finally:
             # restore original values
-            transport._set_protocol_handlers(saved_handlers)
+            _set_protocol_handlers(saved_handlers)
 
     def test_transport_fallback(self):
         """Transport with missing dependency causes no error"""
-        saved_handlers = transport._get_protocol_handlers()
+        saved_handlers = _get_protocol_handlers()
         try:
-            transport._clear_protocol_handlers()
-            transport.register_transport_proto('foo')
-            transport.register_lazy_transport(
-                'foo', 'bzrlib.tests.test_transport', 'BackupTransportHandler')
-            transport.register_lazy_transport(
-                'foo', 'bzrlib.tests.test_transport', 'BadTransportHandler')
-            t = transport.get_transport('foo://fooserver/foo')
+            _clear_protocol_handlers()
+            register_transport_proto('foo')
+            register_lazy_transport('foo', 'bzrlib.tests.test_transport',
+                    'BackupTransportHandler')
+            register_lazy_transport('foo', 'bzrlib.tests.test_transport',
+                    'BadTransportHandler')
+            t = get_transport('foo://fooserver/foo')
             self.assertTrue(isinstance(t, BackupTransportHandler))
         finally:
-            transport._set_protocol_handlers(saved_handlers)
+            _set_protocol_handlers(saved_handlers)
 
     def test_ssh_hints(self):
         """Transport ssh:// should raise an error pointing out bzr+ssh://"""
         try:
-            transport.get_transport('ssh://fooserver/foo')
-        except errors.UnsupportedProtocol, e:
+            get_transport('ssh://fooserver/foo')
+        except UnsupportedProtocol, e:
             e_str = str(e)
             self.assertEquals('Unsupported protocol'
                               ' for url "ssh://fooserver/foo":'
-                              ' bzr supports bzr+ssh to operate over ssh,'
-                              ' use "bzr+ssh://fooserver/foo".',
+                              ' bzr supports bzr+ssh to operate over ssh, use "bzr+ssh://fooserver/foo".',
                               str(e))
         else:
             self.fail('Did not raise UnsupportedProtocol')
 
     def test_LateReadError(self):
         """The LateReadError helper should raise on read()."""
-        a_file = transport.LateReadError('a path')
+        a_file = LateReadError('a path')
         try:
             a_file.read()
-        except errors.ReadError, error:
+        except ReadError, error:
             self.assertEqual('a path', error.path)
-        self.assertRaises(errors.ReadError, a_file.read, 40)
+        self.assertRaises(ReadError, a_file.read, 40)
         a_file.close()
 
     def test__combine_paths(self):
-        t = transport.Transport('/')
+        t = Transport('/')
         self.assertEqual('/home/sarah/project/foo',
                          t._combine_paths('/home/sarah', 'project/foo'))
         self.assertEqual('/etc',
@@ -158,16 +166,16 @@
 
     def test_local_abspath_non_local_transport(self):
         # the base implementation should throw
-        t = memory.MemoryTransport()
+        t = MemoryTransport()
         e = self.assertRaises(errors.NotLocalUrl, t.local_abspath, 't')
         self.assertEqual('memory:///t is not a local path.', str(e))
 
 
-class TestCoalesceOffsets(tests.TestCase):
+class TestCoalesceOffsets(TestCase):
 
     def check(self, expected, offsets, limit=0, max_size=0, fudge=0):
-        coalesce = transport.Transport._coalesce_offsets
-        exp = [transport._CoalescedOffset(*x) for x in expected]
+        coalesce = Transport._coalesce_offsets
+        exp = [_CoalescedOffset(*x) for x in expected]
         out = list(coalesce(offsets, limit=limit, fudge_factor=fudge,
                             max_size=max_size))
         self.assertEqual(exp, out)
@@ -248,150 +256,134 @@
                    max_size=1*1024*1024*1024)
 
 
-class TestMemoryServer(tests.TestCase):
-
-    def test_create_server(self):
-        server = memory.MemoryServer()
-        server.start_server()
-        url = server.get_url()
-        self.assertTrue(url in transport.transport_list_registry)
-        t = transport.get_transport(url)
-        del t
-        server.stop_server()
-        self.assertFalse(url in transport.transport_list_registry)
-        self.assertRaises(errors.UnsupportedProtocol,
-                          transport.get_transport, url)
-
-
-class TestMemoryTransport(tests.TestCase):
+class TestMemoryTransport(TestCase):
 
     def test_get_transport(self):
-        memory.MemoryTransport()
+        MemoryTransport()
 
     def test_clone(self):
-        t = memory.MemoryTransport()
-        self.assertTrue(isinstance(t, memory.MemoryTransport))
-        self.assertEqual("memory:///", t.clone("/").base)
+        transport = MemoryTransport()
+        self.assertTrue(isinstance(transport, MemoryTransport))
+        self.assertEqual("memory:///", transport.clone("/").base)
 
     def test_abspath(self):
-        t = memory.MemoryTransport()
-        self.assertEqual("memory:///relpath", t.abspath('relpath'))
+        transport = MemoryTransport()
+        self.assertEqual("memory:///relpath", transport.abspath('relpath'))
 
     def test_abspath_of_root(self):
-        t = memory.MemoryTransport()
-        self.assertEqual("memory:///", t.base)
-        self.assertEqual("memory:///", t.abspath('/'))
+        transport = MemoryTransport()
+        self.assertEqual("memory:///", transport.base)
+        self.assertEqual("memory:///", transport.abspath('/'))
 
     def test_abspath_of_relpath_starting_at_root(self):
-        t = memory.MemoryTransport()
-        self.assertEqual("memory:///foo", t.abspath('/foo'))
+        transport = MemoryTransport()
+        self.assertEqual("memory:///foo", transport.abspath('/foo'))
 
     def test_append_and_get(self):
-        t = memory.MemoryTransport()
-        t.append_bytes('path', 'content')
-        self.assertEqual(t.get('path').read(), 'content')
-        t.append_file('path', StringIO('content'))
-        self.assertEqual(t.get('path').read(), 'contentcontent')
+        transport = MemoryTransport()
+        transport.append_bytes('path', 'content')
+        self.assertEqual(transport.get('path').read(), 'content')
+        transport.append_file('path', StringIO('content'))
+        self.assertEqual(transport.get('path').read(), 'contentcontent')
 
     def test_put_and_get(self):
-        t = memory.MemoryTransport()
-        t.put_file('path', StringIO('content'))
-        self.assertEqual(t.get('path').read(), 'content')
-        t.put_bytes('path', 'content')
-        self.assertEqual(t.get('path').read(), 'content')
+        transport = MemoryTransport()
+        transport.put_file('path', StringIO('content'))
+        self.assertEqual(transport.get('path').read(), 'content')
+        transport.put_bytes('path', 'content')
+        self.assertEqual(transport.get('path').read(), 'content')
 
     def test_append_without_dir_fails(self):
-        t = memory.MemoryTransport()
-        self.assertRaises(errors.NoSuchFile,
-                          t.append_bytes, 'dir/path', 'content')
+        transport = MemoryTransport()
+        self.assertRaises(NoSuchFile,
+                          transport.append_bytes, 'dir/path', 'content')
 
     def test_put_without_dir_fails(self):
-        t = memory.MemoryTransport()
-        self.assertRaises(errors.NoSuchFile,
-                          t.put_file, 'dir/path', StringIO('content'))
+        transport = MemoryTransport()
+        self.assertRaises(NoSuchFile,
+                          transport.put_file, 'dir/path', StringIO('content'))
 
     def test_get_missing(self):
-        transport = memory.MemoryTransport()
-        self.assertRaises(errors.NoSuchFile, transport.get, 'foo')
+        transport = MemoryTransport()
+        self.assertRaises(NoSuchFile, transport.get, 'foo')
 
     def test_has_missing(self):
-        t = memory.MemoryTransport()
-        self.assertEquals(False, t.has('foo'))
+        transport = MemoryTransport()
+        self.assertEquals(False, transport.has('foo'))
 
     def test_has_present(self):
-        t = memory.MemoryTransport()
-        t.append_bytes('foo', 'content')
-        self.assertEquals(True, t.has('foo'))
+        transport = MemoryTransport()
+        transport.append_bytes('foo', 'content')
+        self.assertEquals(True, transport.has('foo'))
 
     def test_list_dir(self):
-        t = memory.MemoryTransport()
-        t.put_bytes('foo', 'content')
-        t.mkdir('dir')
-        t.put_bytes('dir/subfoo', 'content')
-        t.put_bytes('dirlike', 'content')
+        transport = MemoryTransport()
+        transport.put_bytes('foo', 'content')
+        transport.mkdir('dir')
+        transport.put_bytes('dir/subfoo', 'content')
+        transport.put_bytes('dirlike', 'content')
 
-        self.assertEquals(['dir', 'dirlike', 'foo'], sorted(t.list_dir('.')))
-        self.assertEquals(['subfoo'], sorted(t.list_dir('dir')))
+        self.assertEquals(['dir', 'dirlike', 'foo'], sorted(transport.list_dir('.')))
+        self.assertEquals(['subfoo'], sorted(transport.list_dir('dir')))
 
     def test_mkdir(self):
-        t = memory.MemoryTransport()
-        t.mkdir('dir')
-        t.append_bytes('dir/path', 'content')
-        self.assertEqual(t.get('dir/path').read(), 'content')
+        transport = MemoryTransport()
+        transport.mkdir('dir')
+        transport.append_bytes('dir/path', 'content')
+        self.assertEqual(transport.get('dir/path').read(), 'content')
 
     def test_mkdir_missing_parent(self):
-        t = memory.MemoryTransport()
-        self.assertRaises(errors.NoSuchFile, t.mkdir, 'dir/dir')
+        transport = MemoryTransport()
+        self.assertRaises(NoSuchFile,
+                          transport.mkdir, 'dir/dir')
 
     def test_mkdir_twice(self):
-        t = memory.MemoryTransport()
-        t.mkdir('dir')
-        self.assertRaises(errors.FileExists, t.mkdir, 'dir')
+        transport = MemoryTransport()
+        transport.mkdir('dir')
+        self.assertRaises(FileExists, transport.mkdir, 'dir')
 
     def test_parameters(self):
-        t = memory.MemoryTransport()
-        self.assertEqual(True, t.listable())
-        self.assertEqual(False, t.is_readonly())
+        transport = MemoryTransport()
+        self.assertEqual(True, transport.listable())
+        self.assertEqual(False, transport.is_readonly())
 
     def test_iter_files_recursive(self):
-        t = memory.MemoryTransport()
-        t.mkdir('dir')
-        t.put_bytes('dir/foo', 'content')
-        t.put_bytes('dir/bar', 'content')
-        t.put_bytes('bar', 'content')
-        paths = set(t.iter_files_recursive())
+        transport = MemoryTransport()
+        transport.mkdir('dir')
+        transport.put_bytes('dir/foo', 'content')
+        transport.put_bytes('dir/bar', 'content')
+        transport.put_bytes('bar', 'content')
+        paths = set(transport.iter_files_recursive())
         self.assertEqual(set(['dir/foo', 'dir/bar', 'bar']), paths)
 
     def test_stat(self):
-        t = memory.MemoryTransport()
-        t.put_bytes('foo', 'content')
-        t.put_bytes('bar', 'phowar')
-        self.assertEqual(7, t.stat('foo').st_size)
-        self.assertEqual(6, t.stat('bar').st_size)
-
-
-class ChrootDecoratorTransportTest(tests.TestCase):
+        transport = MemoryTransport()
+        transport.put_bytes('foo', 'content')
+        transport.put_bytes('bar', 'phowar')
+        self.assertEqual(7, transport.stat('foo').st_size)
+        self.assertEqual(6, transport.stat('bar').st_size)
+
+
+class ChrootDecoratorTransportTest(TestCase):
     """Chroot decoration specific tests."""
 
     def test_abspath(self):
         # The abspath is always relative to the chroot_url.
-        server = chroot.ChrootServer(
-            transport.get_transport('memory:///foo/bar/'))
+        server = ChrootServer(get_transport('memory:///foo/bar/'))
         self.start_server(server)
-        t = transport.get_transport(server.get_url())
-        self.assertEqual(server.get_url(), t.abspath('/'))
+        transport = get_transport(server.get_url())
+        self.assertEqual(server.get_url(), transport.abspath('/'))
 
-        subdir_t = t.clone('subdir')
-        self.assertEqual(server.get_url(), subdir_t.abspath('/'))
+        subdir_transport = transport.clone('subdir')
+        self.assertEqual(server.get_url(), subdir_transport.abspath('/'))
 
     def test_clone(self):
-        server = chroot.ChrootServer(
-            transport.get_transport('memory:///foo/bar/'))
+        server = ChrootServer(get_transport('memory:///foo/bar/'))
         self.start_server(server)
-        t = transport.get_transport(server.get_url())
+        transport = get_transport(server.get_url())
         # relpath from root and root path are the same
-        relpath_cloned = t.clone('foo')
-        abspath_cloned = t.clone('/foo')
+        relpath_cloned = transport.clone('foo')
+        abspath_cloned = transport.clone('/foo')
         self.assertEqual(server, relpath_cloned.server)
         self.assertEqual(server, abspath_cloned.server)
 
@@ -403,15 +395,14 @@
         This is so that it is not possible to escape a chroot by doing::
             url = chroot_transport.base
             parent_url = urlutils.join(url, '..')
-            new_t = transport.get_transport(parent_url)
+            new_transport = get_transport(parent_url)
         """
-        server = chroot.ChrootServer(
-            transport.get_transport('memory:///path/subpath'))
+        server = ChrootServer(get_transport('memory:///path/subpath'))
         self.start_server(server)
-        t = transport.get_transport(server.get_url())
-        new_t = transport.get_transport(t.base)
-        self.assertEqual(t.server, new_t.server)
-        self.assertEqual(t.base, new_t.base)
+        transport = get_transport(server.get_url())
+        new_transport = get_transport(transport.base)
+        self.assertEqual(transport.server, new_transport.server)
+        self.assertEqual(transport.base, new_transport.base)
 
     def test_urljoin_preserves_chroot(self):
         """Using urlutils.join(url, '..') on a chroot URL should not produce a
@@ -420,43 +411,41 @@
         This is so that it is not possible to escape a chroot by doing::
             url = chroot_transport.base
             parent_url = urlutils.join(url, '..')
-            new_t = transport.get_transport(parent_url)
+            new_transport = get_transport(parent_url)
         """
-        server = chroot.ChrootServer(transport.get_transport('memory:///path/'))
+        server = ChrootServer(get_transport('memory:///path/'))
         self.start_server(server)
-        t = transport.get_transport(server.get_url())
+        transport = get_transport(server.get_url())
         self.assertRaises(
-            errors.InvalidURLJoin, urlutils.join, t.base, '..')
-
-
-class TestChrootServer(tests.TestCase):
+            InvalidURLJoin, urlutils.join, transport.base, '..')
+
+
+class ChrootServerTest(TestCase):
 
     def test_construct(self):
-        backing_transport = memory.MemoryTransport()
-        server = chroot.ChrootServer(backing_transport)
+        backing_transport = MemoryTransport()
+        server = ChrootServer(backing_transport)
         self.assertEqual(backing_transport, server.backing_transport)
 
     def test_setUp(self):
-        backing_transport = memory.MemoryTransport()
-        server = chroot.ChrootServer(backing_transport)
+        backing_transport = MemoryTransport()
+        server = ChrootServer(backing_transport)
         server.start_server()
         try:
-            self.assertTrue(server.scheme
-                            in transport._get_protocol_handlers().keys())
+            self.assertTrue(server.scheme in _get_protocol_handlers().keys())
         finally:
             server.stop_server()
 
     def test_stop_server(self):
-        backing_transport = memory.MemoryTransport()
-        server = chroot.ChrootServer(backing_transport)
+        backing_transport = MemoryTransport()
+        server = ChrootServer(backing_transport)
         server.start_server()
         server.stop_server()
-        self.assertFalse(server.scheme
-                         in transport._get_protocol_handlers().keys())
+        self.assertFalse(server.scheme in _get_protocol_handlers().keys())
 
     def test_get_url(self):
-        backing_transport = memory.MemoryTransport()
-        server = chroot.ChrootServer(backing_transport)
+        backing_transport = MemoryTransport()
+        server = ChrootServer(backing_transport)
         server.start_server()
         try:
             self.assertEqual('chroot-%d:///' % id(server), server.get_url())
@@ -464,20 +453,19 @@
             server.stop_server()
 
 
-class PathFilteringDecoratorTransportTest(tests.TestCase):
+class PathFilteringDecoratorTransportTest(TestCase):
     """Pathfilter decoration specific tests."""
 
     def test_abspath(self):
         # The abspath is always relative to the base of the backing transport.
-        server = pathfilter.PathFilteringServer(
-            transport.get_transport('memory:///foo/bar/'),
+        server = PathFilteringServer(get_transport('memory:///foo/bar/'),
             lambda x: x)
         server.start_server()
-        t = transport.get_transport(server.get_url())
-        self.assertEqual(server.get_url(), t.abspath('/'))
+        transport = get_transport(server.get_url())
+        self.assertEqual(server.get_url(), transport.abspath('/'))
 
-        subdir_t = t.clone('subdir')
-        self.assertEqual(server.get_url(), subdir_t.abspath('/'))
+        subdir_transport = transport.clone('subdir')
+        self.assertEqual(server.get_url(), subdir_transport.abspath('/'))
         server.stop_server()
 
     def make_pf_transport(self, filter_func=None):
@@ -487,49 +475,50 @@
             parameter to override it."""
         if filter_func is None:
             filter_func = lambda x: x
-        server = pathfilter.PathFilteringServer(
-            transport.get_transport('memory:///foo/bar/'), filter_func)
+        server = PathFilteringServer(
+            get_transport('memory:///foo/bar/'), filter_func)
         server.start_server()
         self.addCleanup(server.stop_server)
-        return transport.get_transport(server.get_url())
+        return get_transport(server.get_url())
 
     def test__filter(self):
         # _filter (with an identity func as filter_func) always returns
         # paths relative to the base of the backing transport.
-        t = self.make_pf_transport()
-        self.assertEqual('foo', t._filter('foo'))
-        self.assertEqual('foo/bar', t._filter('foo/bar'))
-        self.assertEqual('', t._filter('..'))
-        self.assertEqual('', t._filter('/'))
+        transport = self.make_pf_transport()
+        self.assertEqual('foo', transport._filter('foo'))
+        self.assertEqual('foo/bar', transport._filter('foo/bar'))
+        self.assertEqual('', transport._filter('..'))
+        self.assertEqual('', transport._filter('/'))
         # The base of the pathfiltering transport is taken into account too.
-        t = t.clone('subdir1/subdir2')
-        self.assertEqual('subdir1/subdir2/foo', t._filter('foo'))
-        self.assertEqual('subdir1/subdir2/foo/bar', t._filter('foo/bar'))
-        self.assertEqual('subdir1', t._filter('..'))
-        self.assertEqual('', t._filter('/'))
+        transport = transport.clone('subdir1/subdir2')
+        self.assertEqual('subdir1/subdir2/foo', transport._filter('foo'))
+        self.assertEqual(
+            'subdir1/subdir2/foo/bar', transport._filter('foo/bar'))
+        self.assertEqual('subdir1', transport._filter('..'))
+        self.assertEqual('', transport._filter('/'))
 
     def test_filter_invocation(self):
         filter_log = []
         def filter(path):
             filter_log.append(path)
             return path
-        t = self.make_pf_transport(filter)
-        t.has('abc')
+        transport = self.make_pf_transport(filter)
+        transport.has('abc')
         self.assertEqual(['abc'], filter_log)
         del filter_log[:]
-        t.clone('abc').has('xyz')
+        transport.clone('abc').has('xyz')
         self.assertEqual(['abc/xyz'], filter_log)
         del filter_log[:]
-        t.has('/abc')
+        transport.has('/abc')
         self.assertEqual(['abc'], filter_log)
 
     def test_clone(self):
-        t = self.make_pf_transport()
+        transport = self.make_pf_transport()
         # relpath from root and root path are the same
-        relpath_cloned = t.clone('foo')
-        abspath_cloned = t.clone('/foo')
-        self.assertEqual(t.server, relpath_cloned.server)
-        self.assertEqual(t.server, abspath_cloned.server)
+        relpath_cloned = transport.clone('foo')
+        abspath_cloned = transport.clone('/foo')
+        self.assertEqual(transport.server, relpath_cloned.server)
+        self.assertEqual(transport.server, abspath_cloned.server)
 
     def test_url_preserves_pathfiltering(self):
         """Calling get_transport on a pathfiltered transport's base should
@@ -540,47 +529,51 @@
         otherwise) the filtering by doing::
             url = filtered_transport.base
             parent_url = urlutils.join(url, '..')
-            new_t = transport.get_transport(parent_url)
+            new_transport = get_transport(parent_url)
         """
-        t = self.make_pf_transport()
-        new_t = transport.get_transport(t.base)
-        self.assertEqual(t.server, new_t.server)
-        self.assertEqual(t.base, new_t.base)
-
-
-class ReadonlyDecoratorTransportTest(tests.TestCase):
+        transport = self.make_pf_transport()
+        new_transport = get_transport(transport.base)
+        self.assertEqual(transport.server, new_transport.server)
+        self.assertEqual(transport.base, new_transport.base)
+
+
+class ReadonlyDecoratorTransportTest(TestCase):
     """Readonly decoration specific tests."""
 
     def test_local_parameters(self):
+        import bzrlib.transport.readonly as readonly
         # connect to . in readonly mode
-        t = readonly.ReadonlyTransportDecorator('readonly+.')
-        self.assertEqual(True, t.listable())
-        self.assertEqual(True, t.is_readonly())
+        transport = readonly.ReadonlyTransportDecorator('readonly+.')
+        self.assertEqual(True, transport.listable())
+        self.assertEqual(True, transport.is_readonly())
 
     def test_http_parameters(self):
         from bzrlib.tests.http_server import HttpServer
+        import bzrlib.transport.readonly as readonly
         # connect to '.' via http which is not listable
         server = HttpServer()
         self.start_server(server)
-        t = transport.get_transport('readonly+' + server.get_url())
-        self.failUnless(isinstance(t, readonly.ReadonlyTransportDecorator))
-        self.assertEqual(False, t.listable())
-        self.assertEqual(True, t.is_readonly())
-
-
-class FakeNFSDecoratorTests(tests.TestCaseInTempDir):
+        transport = get_transport('readonly+' + server.get_url())
+        self.failUnless(isinstance(transport,
+                                   readonly.ReadonlyTransportDecorator))
+        self.assertEqual(False, transport.listable())
+        self.assertEqual(True, transport.is_readonly())
+
+
+class FakeNFSDecoratorTests(TestCaseInTempDir):
     """NFS decorator specific tests."""
 
     def get_nfs_transport(self, url):
+        import bzrlib.transport.fakenfs as fakenfs
         # connect to url with nfs decoration
         return fakenfs.FakeNFSTransportDecorator('fakenfs+' + url)
 
     def test_local_parameters(self):
         # the listable and is_readonly parameters
         # are not changed by the fakenfs decorator
-        t = self.get_nfs_transport('.')
-        self.assertEqual(True, t.listable())
-        self.assertEqual(False, t.is_readonly())
+        transport = self.get_nfs_transport('.')
+        self.assertEqual(True, transport.listable())
+        self.assertEqual(False, transport.is_readonly())
 
     def test_http_parameters(self):
         # the listable and is_readonly parameters
@@ -589,32 +582,35 @@
         # connect to '.' via http which is not listable
         server = HttpServer()
         self.start_server(server)
-        t = self.get_nfs_transport(server.get_url())
-        self.assertIsInstance(t, fakenfs.FakeNFSTransportDecorator)
-        self.assertEqual(False, t.listable())
-        self.assertEqual(True, t.is_readonly())
+        transport = self.get_nfs_transport(server.get_url())
+        self.assertIsInstance(
+            transport, bzrlib.transport.fakenfs.FakeNFSTransportDecorator)
+        self.assertEqual(False, transport.listable())
+        self.assertEqual(True, transport.is_readonly())
 
     def test_fakenfs_server_default(self):
         # a FakeNFSServer() should bring up a local relpath server for itself
-        server = test_server.FakeNFSServer()
+        import bzrlib.transport.fakenfs as fakenfs
+        server = fakenfs.FakeNFSServer()
         self.start_server(server)
         # the url should be decorated appropriately
         self.assertStartsWith(server.get_url(), 'fakenfs+')
         # and we should be able to get a transport for it
-        t = transport.get_transport(server.get_url())
+        transport = get_transport(server.get_url())
         # which must be a FakeNFSTransportDecorator instance.
-        self.assertIsInstance(t, fakenfs.FakeNFSTransportDecorator)
+        self.assertIsInstance(transport, fakenfs.FakeNFSTransportDecorator)
 
     def test_fakenfs_rename_semantics(self):
         # a FakeNFS transport must mangle the way rename errors occur to
         # look like NFS problems.
-        t = self.get_nfs_transport('.')
+        transport = self.get_nfs_transport('.')
         self.build_tree(['from/', 'from/foo', 'to/', 'to/bar'],
-                        transport=t)
-        self.assertRaises(errors.ResourceBusy, t.rename, 'from', 'to')
-
-
-class FakeVFATDecoratorTests(tests.TestCaseInTempDir):
+                        transport=transport)
+        self.assertRaises(errors.ResourceBusy,
+                          transport.rename, 'from', 'to')
+
+
+class FakeVFATDecoratorTests(TestCaseInTempDir):
     """Tests for simulation of VFAT restrictions"""
 
     def get_vfat_transport(self, url):
@@ -624,32 +620,31 @@
 
     def test_transport_creation(self):
         from bzrlib.transport.fakevfat import FakeVFATTransportDecorator
-        t = self.get_vfat_transport('.')
-        self.assertIsInstance(t, FakeVFATTransportDecorator)
+        transport = self.get_vfat_transport('.')
+        self.assertIsInstance(transport, FakeVFATTransportDecorator)
 
     def test_transport_mkdir(self):
-        t = self.get_vfat_transport('.')
-        t.mkdir('HELLO')
-        self.assertTrue(t.has('hello'))
-        self.assertTrue(t.has('Hello'))
+        transport = self.get_vfat_transport('.')
+        transport.mkdir('HELLO')
+        self.assertTrue(transport.has('hello'))
+        self.assertTrue(transport.has('Hello'))
 
     def test_forbidden_chars(self):
-        t = self.get_vfat_transport('.')
-        self.assertRaises(ValueError, t.has, "<NU>")
-
-
-class BadTransportHandler(transport.Transport):
+        transport = self.get_vfat_transport('.')
+        self.assertRaises(ValueError, transport.has, "<NU>")
+
+
+class BadTransportHandler(Transport):
     def __init__(self, base_url):
-        raise errors.DependencyNotPresent('some_lib',
-                                          'testing missing dependency')
-
-
-class BackupTransportHandler(transport.Transport):
+        raise DependencyNotPresent('some_lib', 'testing missing dependency')
+
+
+class BackupTransportHandler(Transport):
     """Test transport that works as a backup for the BadTransportHandler"""
     pass
 
 
-class TestTransportImplementation(tests.TestCaseInTempDir):
+class TestTransportImplementation(TestCaseInTempDir):
     """Implementation verification for transports.
 
     To verify a transport we need a server factory, which is a callable
@@ -684,7 +679,7 @@
         base_url = self._server.get_url()
         url = self._adjust_url(base_url, relpath)
         # try getting the transport via the regular interface:
-        t = transport.get_transport(url)
+        t = get_transport(url)
         # vila--20070607 if the following are commented out the test suite
         # still pass. Is this really still needed or was it a forgotten
         # temporary fix ?
@@ -695,40 +690,40 @@
         return t
 
 
-class TestLocalTransports(tests.TestCase):
+class TestLocalTransports(TestCase):
 
     def test_get_transport_from_abspath(self):
         here = osutils.abspath('.')
-        t = transport.get_transport(here)
-        self.assertIsInstance(t, local.LocalTransport)
+        t = get_transport(here)
+        self.assertIsInstance(t, LocalTransport)
         self.assertEquals(t.base, urlutils.local_path_to_url(here) + '/')
 
     def test_get_transport_from_relpath(self):
         here = osutils.abspath('.')
-        t = transport.get_transport('.')
-        self.assertIsInstance(t, local.LocalTransport)
+        t = get_transport('.')
+        self.assertIsInstance(t, LocalTransport)
         self.assertEquals(t.base, urlutils.local_path_to_url('.') + '/')
 
     def test_get_transport_from_local_url(self):
         here = osutils.abspath('.')
         here_url = urlutils.local_path_to_url(here) + '/'
-        t = transport.get_transport(here_url)
-        self.assertIsInstance(t, local.LocalTransport)
+        t = get_transport(here_url)
+        self.assertIsInstance(t, LocalTransport)
         self.assertEquals(t.base, here_url)
 
     def test_local_abspath(self):
         here = osutils.abspath('.')
-        t = transport.get_transport(here)
+        t = get_transport(here)
         self.assertEquals(t.local_abspath(''), here)
 
 
-class TestWin32LocalTransport(tests.TestCase):
+class TestWin32LocalTransport(TestCase):
 
     def test_unc_clone_to_root(self):
         # Win32 UNC path like \\HOST\path
         # clone to root should stop at least at \\HOST part
         # not on \\
-        t = local.EmulatedWin32LocalTransport('file://HOST/path/to/some/dir/')
+        t = EmulatedWin32LocalTransport('file://HOST/path/to/some/dir/')
         for i in xrange(4):
             t = t.clone('..')
         self.assertEquals(t.base, 'file://HOST/')
@@ -737,12 +732,11 @@
         self.assertEquals(t.base, 'file://HOST/')
 
 
-class TestConnectedTransport(tests.TestCase):
+class TestConnectedTransport(TestCase):
     """Tests for connected to remote server transports"""
 
     def test_parse_url(self):
-        t = transport.ConnectedTransport(
-            'http://simple.example.com/home/source')
+        t = ConnectedTransport('http://simple.example.com/home/source')
         self.assertEquals(t._host, 'simple.example.com')
         self.assertEquals(t._port, None)
         self.assertEquals(t._path, '/home/source/')
@@ -753,12 +747,11 @@
 
     def test_parse_url_with_at_in_user(self):
         # Bug 228058
-        t = transport.ConnectedTransport('ftp://user@host.com@www.host.com/')
+        t = ConnectedTransport('ftp://user@host.com@www.host.com/')
         self.assertEquals(t._user, 'user@host.com')
 
     def test_parse_quoted_url(self):
-        t = transport.ConnectedTransport(
-            'http://ro%62ey:h%40t@ex%41mple.com:2222/path')
+        t = ConnectedTransport('http://ro%62ey:h%40t@ex%41mple.com:2222/path')
         self.assertEquals(t._host, 'exAmple.com')
         self.assertEquals(t._port, 2222)
         self.assertEquals(t._user, 'robey')
@@ -770,11 +763,11 @@
 
     def test_parse_invalid_url(self):
         self.assertRaises(errors.InvalidURL,
-                          transport.ConnectedTransport,
+                          ConnectedTransport,
                           'sftp://lily.org:~janneke/public/bzr/gub')
 
     def test_relpath(self):
-        t = transport.ConnectedTransport('sftp://user@host.com/abs/path')
+        t = ConnectedTransport('sftp://user@host.com/abs/path')
 
         self.assertEquals(t.relpath('sftp://user@host.com/abs/path/sub'), 'sub')
         self.assertRaises(errors.PathNotChild, t.relpath,
@@ -786,15 +779,15 @@
         self.assertRaises(errors.PathNotChild, t.relpath,
                           'sftp://user@host.com:33/abs/path/sub')
         # Make sure it works when we don't supply a username
-        t = transport.ConnectedTransport('sftp://host.com/abs/path')
+        t = ConnectedTransport('sftp://host.com/abs/path')
         self.assertEquals(t.relpath('sftp://host.com/abs/path/sub'), 'sub')
 
         # Make sure it works when parts of the path will be url encoded
-        t = transport.ConnectedTransport('sftp://host.com/dev/%path')
+        t = ConnectedTransport('sftp://host.com/dev/%path')
         self.assertEquals(t.relpath('sftp://host.com/dev/%path/sub'), 'sub')
 
     def test_connection_sharing_propagate_credentials(self):
-        t = transport.ConnectedTransport('ftp://user@host.com/abs/path')
+        t = ConnectedTransport('ftp://user@host.com/abs/path')
         self.assertEquals('user', t._user)
         self.assertEquals('host.com', t._host)
         self.assertIs(None, t._get_connection())
@@ -821,76 +814,73 @@
         self.assertIs(new_password, c._get_credentials())
 
 
-class TestReusedTransports(tests.TestCase):
+class TestReusedTransports(TestCase):
     """Tests for transport reuse"""
 
     def test_reuse_same_transport(self):
         possible_transports = []
-        t1 = transport.get_transport('http://foo/',
-                                     possible_transports=possible_transports)
+        t1 = get_transport('http://foo/',
+                           possible_transports=possible_transports)
         self.assertEqual([t1], possible_transports)
-        t2 = transport.get_transport('http://foo/',
-                                     possible_transports=[t1])
+        t2 = get_transport('http://foo/', possible_transports=[t1])
         self.assertIs(t1, t2)
 
         # Also check that final '/' are handled correctly
-        t3 = transport.get_transport('http://foo/path/')
-        t4 = transport.get_transport('http://foo/path',
-                                     possible_transports=[t3])
+        t3 = get_transport('http://foo/path/')
+        t4 = get_transport('http://foo/path', possible_transports=[t3])
         self.assertIs(t3, t4)
 
-        t5 = transport.get_transport('http://foo/path')
-        t6 = transport.get_transport('http://foo/path/',
-                                     possible_transports=[t5])
+        t5 = get_transport('http://foo/path')
+        t6 = get_transport('http://foo/path/', possible_transports=[t5])
         self.assertIs(t5, t6)
 
     def test_don_t_reuse_different_transport(self):
-        t1 = transport.get_transport('http://foo/path')
-        t2 = transport.get_transport('http://bar/path',
-                                     possible_transports=[t1])
+        t1 = get_transport('http://foo/path')
+        t2 = get_transport('http://bar/path', possible_transports=[t1])
         self.assertIsNot(t1, t2)
 
 
-class TestTransportTrace(tests.TestCase):
+class TestTransportTrace(TestCase):
 
     def test_get(self):
-        t = transport.get_transport('trace+memory://')
-        self.assertIsInstance(t, bzrlib.transport.trace.TransportTraceDecorator)
+        transport = get_transport('trace+memory://')
+        self.assertIsInstance(
+            transport, bzrlib.transport.trace.TransportTraceDecorator)
 
     def test_clone_preserves_activity(self):
-        t = transport.get_transport('trace+memory://')
-        t2 = t.clone('.')
-        self.assertTrue(t is not t2)
-        self.assertTrue(t._activity is t2._activity)
+        transport = get_transport('trace+memory://')
+        transport2 = transport.clone('.')
+        self.assertTrue(transport is not transport2)
+        self.assertTrue(transport._activity is transport2._activity)
 
     # the following specific tests are for the operations that have made use of
     # logging in tests; we could test every single operation but doing that
     # still won't cause a test failure when the top level Transport API
     # changes; so there is little return doing that.
     def test_get(self):
-        t = transport.get_transport('trace+memory:///')
-        t.put_bytes('foo', 'barish')
-        t.get('foo')
+        transport = get_transport('trace+memory:///')
+        transport.put_bytes('foo', 'barish')
+        transport.get('foo')
         expected_result = []
         # put_bytes records the bytes, not the content to avoid memory
         # pressure.
         expected_result.append(('put_bytes', 'foo', 6, None))
         # get records the file name only.
         expected_result.append(('get', 'foo'))
-        self.assertEqual(expected_result, t._activity)
+        self.assertEqual(expected_result, transport._activity)
 
     def test_readv(self):
-        t = transport.get_transport('trace+memory:///')
-        t.put_bytes('foo', 'barish')
-        list(t.readv('foo', [(0, 1), (3, 2)],
-                     adjust_for_latency=True, upper_limit=6))
+        transport = get_transport('trace+memory:///')
+        transport.put_bytes('foo', 'barish')
+        list(transport.readv('foo', [(0, 1), (3, 2)], adjust_for_latency=True,
+            upper_limit=6))
         expected_result = []
         # put_bytes records the bytes, not the content to avoid memory
         # pressure.
         expected_result.append(('put_bytes', 'foo', 6, None))
         # readv records the supplied offset request
         expected_result.append(('readv', 'foo', [(0, 1), (3, 2)], True, 6))
-        self.assertEqual(expected_result, t._activity)
+        self.assertEqual(expected_result, transport._activity)
 
 
 class TestSSHConnections(tests.TestCaseWithTransport):
@@ -909,7 +899,8 @@
         # SFTPFullAbsoluteServer has a get_url method, and doesn't
         # override the interface (doesn't change self._vendor).
         # Note that this does encryption, so can be slow.
-        from bzrlib.tests import stub_sftp
+        from bzrlib.transport.sftp import SFTPFullAbsoluteServer
+        from bzrlib.tests.stub_sftp import StubServer
 
         # Start an SSH server
         self.command_executed = []
@@ -918,7 +909,7 @@
         # SSH channel ourselves.  Surely this has already been implemented
         # elsewhere?
         started = []
-        class StubSSHServer(stub_sftp.StubServer):
+        class StubSSHServer(StubServer):
 
             test = self
 
@@ -952,7 +943,7 @@
 
                 return True
 
-        ssh_server = stub_sftp.SFTPFullAbsoluteServer(StubSSHServer)
+        ssh_server = SFTPFullAbsoluteServer(StubSSHServer)
         # We *don't* want to override the default SSH vendor: the detected one
         # is the one to use.
         self.start_server(ssh_server)
@@ -972,7 +963,7 @@
             # prefix a '/' to get the right path.
             path_to_branch = '/' + path_to_branch
         url = 'bzr+ssh://fred:secret@localhost:%d%s' % (port, path_to_branch)
-        t = transport.get_transport(url)
+        t = get_transport(url)
         self.permit_url(t.base)
         t.mkdir('foo')
 

=== modified file 'bzrlib/tests/test_transport_log.py'
--- bzrlib/tests/test_transport_log.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_transport_log.py	2009-12-16 22:29:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2010-04-26 13:51:08 +0000
+++ bzrlib/tests/test_ui.py	2009-12-10 16:54:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,12 +21,8 @@
 import re
 import time
 
-from StringIO import StringIO
-
 from bzrlib import (
     errors,
-    remote,
-    repository,
     tests,
     ui as _mod_ui,
     )
@@ -128,6 +124,20 @@
         finally:
             pb.finished()
 
+    def test_progress_nested(self):
+        # test factory based nested and popping.
+        ui = _mod_ui_text.TextUIFactory(None, None, None)
+        pb1 = ui.nested_progress_bar()
+        pb2 = ui.nested_progress_bar()
+        # You do get a warning if the outermost progress bar wasn't finished
+        # first - it's not clear if this is really useful or if it should just
+        # become orphaned -- mbp 20090120
+        warnings, _ = self.callCatchWarnings(pb1.finished)
+        if len(warnings) != 1:
+            self.fail("unexpected warnings: %r" % (warnings,))
+        pb2.finished()
+        pb1.finished()
+
     def test_text_ui_get_boolean(self):
         stdin = tests.StringIOWrapper("y\n" # True
                                       "n\n" # False
@@ -238,43 +248,6 @@
         finally:
             pb.finished()
 
-    def test_quietness(self):
-        os.environ['BZR_PROGRESS_BAR'] = 'text'
-        ui_factory = _mod_ui_text.TextUIFactory(None,
-            test_progress._TTYStringIO(),
-            test_progress._TTYStringIO())
-        self.assertIsInstance(ui_factory._progress_view,
-            _mod_ui_text.TextProgressView)
-        ui_factory.be_quiet(True)
-        self.assertIsInstance(ui_factory._progress_view,
-            _mod_ui_text.NullProgressView)
-
-    def test_text_ui_show_user_warning(self):
-        from bzrlib.repofmt.groupcompress_repo import RepositoryFormat2a
-        from bzrlib.repofmt.pack_repo import RepositoryFormatKnitPack5
-        err = StringIO()
-        out = StringIO()
-        ui = tests.TextUIFactory(stdin=None, stdout=out, stderr=err)
-        remote_fmt = remote.RemoteRepositoryFormat()
-        remote_fmt._network_name = RepositoryFormatKnitPack5().network_name()
-        ui.show_user_warning('cross_format_fetch', from_format=RepositoryFormat2a(),
-            to_format=remote_fmt)
-        self.assertEquals('', out.getvalue())
-        self.assertEquals("Doing on-the-fly conversion from RepositoryFormat2a() to "
-            "RemoteRepositoryFormat(_network_name='Bazaar RepositoryFormatKnitPack5 "
-            "(bzr 1.6)\\n').\nThis may take some time. Upgrade the repositories to "
-            "the same format for better performance.\n",
-            err.getvalue())
-        # and now with it suppressed please
-        err = StringIO()
-        out = StringIO()
-        ui = tests.TextUIFactory(stdin=None, stdout=out, stderr=err)
-        ui.suppressed_warnings.add('cross_format_fetch')
-        ui.show_user_warning('cross_format_fetch', from_format=RepositoryFormat2a(),
-            to_format=remote_fmt)
-        self.assertEquals('', out.getvalue())
-        self.assertEquals('', err.getvalue())
-
 
 class TestTextUIOutputStream(tests.TestCase):
     """Tests for output stream that synchronizes with progress bar."""

=== modified file 'bzrlib/tests/test_upgrade.py'
--- bzrlib/tests/test_upgrade.py	2010-02-15 10:46:49 +0000
+++ bzrlib/tests/test_upgrade.py	2009-05-07 05:08:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -79,28 +79,27 @@
         finally:
             rt.unlock()
         # check a backup was made:
-        backup_dir = 'backup.bzr.~1~'
         transport = get_transport(b.base)
-        transport.stat(backup_dir)
-        transport.stat(backup_dir + '/README')
-        transport.stat(backup_dir + '/branch-format')
-        transport.stat(backup_dir + '/revision-history')
-        transport.stat(backup_dir + '/merged-patches')
-        transport.stat(backup_dir + '/pending-merged-patches')
-        transport.stat(backup_dir + '/pending-merges')
-        transport.stat(backup_dir + '/branch-name')
-        transport.stat(backup_dir + '/branch-lock')
-        transport.stat(backup_dir + '/inventory')
-        transport.stat(backup_dir + '/stat-cache')
-        transport.stat(backup_dir + '/text-store')
-        transport.stat(backup_dir + '/text-store/foo-20051004035611-1591048e9dc7c2d4.gz')
-        transport.stat(backup_dir + '/text-store/foo-20051004035756-4081373d897c3453.gz')
-        transport.stat(backup_dir + '/inventory-store/')
-        transport.stat(backup_dir + '/inventory-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
-        transport.stat(backup_dir + '/inventory-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
-        transport.stat(backup_dir + '/revision-store/')
-        transport.stat(backup_dir + '/revision-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
-        transport.stat(backup_dir + '/revision-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
+        transport.stat('backup.bzr')
+        transport.stat('backup.bzr/README')
+        transport.stat('backup.bzr/branch-format')
+        transport.stat('backup.bzr/revision-history')
+        transport.stat('backup.bzr/merged-patches')
+        transport.stat('backup.bzr/pending-merged-patches')
+        transport.stat('backup.bzr/pending-merges')
+        transport.stat('backup.bzr/branch-name')
+        transport.stat('backup.bzr/branch-lock')
+        transport.stat('backup.bzr/inventory')
+        transport.stat('backup.bzr/stat-cache')
+        transport.stat('backup.bzr/text-store')
+        transport.stat('backup.bzr/text-store/foo-20051004035611-1591048e9dc7c2d4.gz')
+        transport.stat('backup.bzr/text-store/foo-20051004035756-4081373d897c3453.gz')
+        transport.stat('backup.bzr/inventory-store/')
+        transport.stat('backup.bzr/inventory-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
+        transport.stat('backup.bzr/inventory-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
+        transport.stat('backup.bzr/revision-store/')
+        transport.stat('backup.bzr/revision-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
+        transport.stat('backup.bzr/revision-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
 
     def test_upgrade_with_ghosts(self):
         """Upgrade v0.0.4 tree containing ghost references.
@@ -158,7 +157,7 @@
         self.assertFalse(transport.has('.bzr/stat-cache'))
         # XXX: upgrade fails if a backup.bzr is already present
         # -- David Allouche 2006-08-11
-        transport.delete_tree('backup.bzr.~1~')
+        transport.delete_tree('backup.bzr')
         # At this point, we have a format6 branch without checkout files.
         upgrade('.', bzrdir.BzrDirMetaFormat1())
         # The upgrade should not have set up a working tree.
@@ -186,7 +185,7 @@
         branch.set_push_location('file:///IJ')
         target = bzrdir.format_registry.make_bzrdir('dirstate-with-subtree')
         converter = branch.bzrdir._format.get_converter(target)
-        converter.convert(branch.bzrdir, None)
+        converter.convert(branch.bzrdir, progress.DummyProgress())
         new_branch = _mod_branch.Branch.open(self.get_url('branch'))
         self.assertIs(new_branch.__class__, _mod_branch.BzrBranch6)
         self.assertEqual('CD', new_branch.last_revision())
@@ -198,7 +197,7 @@
 
         branch2 = self.make_branch('branch2', format='knit')
         converter = branch2.bzrdir._format.get_converter(target)
-        converter.convert(branch2.bzrdir, None)
+        converter.convert(branch2.bzrdir, progress.DummyProgress())
         branch2 = _mod_branch.Branch.open(self.get_url('branch'))
         self.assertIs(branch2.__class__, _mod_branch.BzrBranch6)
 
@@ -207,7 +206,7 @@
         target = bzrdir.format_registry.make_bzrdir('1.9')
         target.set_branch_format(_mod_branch.BzrBranchFormat8())
         converter = branch.bzrdir._format.get_converter(target)
-        converter.convert(branch.bzrdir, None)
+        converter.convert(branch.bzrdir, progress.DummyProgress())
         branch = _mod_branch.Branch.open(self.get_url('branch'))
         self.assertIs(branch.__class__, _mod_branch.BzrBranch8)
         self.assertEqual({}, branch._get_all_reference_info())
@@ -217,7 +216,7 @@
         tree = self.make_branch_and_tree('tree', format='knit')
         target = bzrdir.format_registry.make_bzrdir('dirstate')
         converter = tree.bzrdir._format.get_converter(target)
-        converter.convert(tree.bzrdir, None)
+        converter.convert(tree.bzrdir, progress.DummyProgress())
         new_tree = workingtree.WorkingTree.open('tree')
         self.assertIs(new_tree.__class__, workingtree_4.WorkingTree4)
         self.assertEqual('null:', new_tree.last_revision())
@@ -230,7 +229,7 @@
         tree.add(['file'], ['file-id'])
         target = bzrdir.format_registry.make_bzrdir('dirstate')
         converter = tree.bzrdir._format.get_converter(target)
-        converter.convert(tree.bzrdir, None)
+        converter.convert(tree.bzrdir, progress.DummyProgress())
         new_tree = workingtree.WorkingTree.open('tree')
         self.assertIs(new_tree.__class__, workingtree_4.WorkingTree4)
         self.assertEqual('null:', new_tree.last_revision())
@@ -241,7 +240,7 @@
         rev_id = tree.commit('first post')
         target = bzrdir.format_registry.make_bzrdir('dirstate')
         converter = tree.bzrdir._format.get_converter(target)
-        converter.convert(tree.bzrdir, None)
+        converter.convert(tree.bzrdir, progress.DummyProgress())
         new_tree = workingtree.WorkingTree.open('tree')
         self.assertIs(new_tree.__class__, workingtree_4.WorkingTree4)
         self.assertEqual(rev_id, new_tree.last_revision())
@@ -258,7 +257,7 @@
         tree.merge_from_branch(merge_tree.branch)
         target = bzrdir.format_registry.make_bzrdir('dirstate')
         converter = tree.bzrdir._format.get_converter(target)
-        converter.convert(tree.bzrdir, None)
+        converter.convert(tree.bzrdir, progress.DummyProgress())
         new_tree = workingtree.WorkingTree.open('tree')
         self.assertIs(new_tree.__class__, workingtree_4.WorkingTree4)
         self.assertEqual(rev_id2, new_tree.last_revision())

=== modified file 'bzrlib/tests/test_urlutils.py'
--- bzrlib/tests/test_urlutils.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_urlutils.py	2009-11-26 04:01:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_version.py'
--- bzrlib/tests/test_version.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_version.py	2009-12-02 16:36:22 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2009, 2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/test_version_info.py'
--- bzrlib/tests/test_version_info.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/test_version_info.py	2009-08-12 21:27:50 +0000
@@ -23,7 +23,6 @@
 
 from bzrlib import (
     errors,
-    registry,
     symbol_versioning,
     tests,
     version_info_formats,
@@ -326,8 +325,20 @@
 
     def setUp(self):
         super(TestVersionInfoFormatRegistry, self).setUp()
-        self.overrideAttr(version_info_formats,
-                          'format_registry', registry.Registry())
+        registry = version_info_formats.format_registry
+        self._default_key = registry._default_key
+        self._dict = registry._dict.copy()
+        self._help_dict = registry._help_dict.copy()
+        self._info_dict = registry._info_dict.copy()
+        self.addCleanup(self._cleanup)
+
+    def _cleanup(self):
+        # Restore the registry to pristine state after the test runs
+        registry = version_info_formats.format_registry
+        registry._default_key = self._default_key
+        registry._dict = self._dict
+        registry._help_dict = self._help_dict
+        registry._info_dict = self._info_dict
 
     def test_register_remove(self):
         registry = version_info_formats.format_registry

=== modified file 'bzrlib/tests/test_win32utils.py'
--- bzrlib/tests/test_win32utils.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_win32utils.py	2009-11-20 16:42:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -266,8 +266,12 @@
         super(TestLocationsPywin32, self).setUp()
         # We perform the exact same tests after disabling the use of ctypes.
         # This causes the implementation to fall back to pywin32.
-        self.overrideAttr(win32utils, 'has_ctypes', False)
-        # FIXME: this should be done by parametrization -- vila 100123
+        self.old_ctypes = win32utils.has_ctypes
+        win32utils.has_ctypes = False
+        self.addCleanup(self.restoreCtypes)
+
+    def restoreCtypes(self):
+        win32utils.has_ctypes = self.old_ctypes
 
 
 class TestSetHidden(TestCaseInTempDir):
@@ -288,15 +292,70 @@
 
 
 
+class TestUnicodeShlex(tests.TestCase):
+
+    def assertAsTokens(self, expected, line):
+        s = win32utils.UnicodeShlex(line)
+        self.assertEqual(expected, list(s))
+
+    def test_simple(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar'), (False, u'baz')],
+                            u'foo bar baz')
+
+    def test_ignore_multiple_spaces(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'foo  bar')
+
+    def test_ignore_leading_space(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'  foo bar')
+
+    def test_ignore_trailing_space(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'foo bar  ')
+
+    def test_posix_quotations(self):
+        self.assertAsTokens([(True, u'foo bar')], u'"foo bar"')
+        self.assertAsTokens([(False, u"'fo''o"), (False, u"b''ar'")],
+            u"'fo''o b''ar'")
+        self.assertAsTokens([(True, u'foo bar')], u'"fo""o b""ar"')
+        self.assertAsTokens([(True, u"fo'o"), (True, u"b'ar")],
+            u'"fo"\'o b\'"ar"')
+
+    def test_nested_quotations(self):
+        self.assertAsTokens([(True, u'foo"" bar')], u"\"foo\\\"\\\" bar\"")
+        self.assertAsTokens([(True, u'foo\'\' bar')], u"\"foo'' bar\"")
+
+    def test_empty_result(self):
+        self.assertAsTokens([], u'')
+        self.assertAsTokens([], u'    ')
+
+    def test_quoted_empty(self):
+        self.assertAsTokens([(True, '')], u'""')
+        self.assertAsTokens([(False, u"''")], u"''")
+
+    def test_unicode_chars(self):
+        self.assertAsTokens([(False, u'f\xb5\xee'), (False, u'\u1234\u3456')],
+                             u'f\xb5\xee \u1234\u3456')
+
+    def test_newline_in_quoted_section(self):
+        self.assertAsTokens([(True, u'foo\nbar\nbaz\n')], u'"foo\nbar\nbaz\n"')
+
+    def test_escape_chars(self):
+        self.assertAsTokens([(False, u'foo\\bar')], u'foo\\bar')
+
+    def test_escape_quote(self):
+        self.assertAsTokens([(True, u'foo"bar')], u'"foo\\"bar"')
+
+    def test_double_escape(self):
+        self.assertAsTokens([(True, u'foo\\bar')], u'"foo\\\\bar"')
+        self.assertAsTokens([(False, u'foo\\\\bar')], u"foo\\\\bar")
+
 
 class Test_CommandLineToArgv(tests.TestCaseInTempDir):
 
-    def assertCommandLine(self, expected, line, single_quotes_allowed=False):
+    def assertCommandLine(self, expected, line):
         # Strictly speaking we should respect parameter order versus glob
         # expansions, but it's not really worth the effort here
-        argv = win32utils._command_line_to_argv(line,
-                single_quotes_allowed=single_quotes_allowed)
-        self.assertEqual(expected, sorted(argv))
+        self.assertEqual(expected,
+                         sorted(win32utils._command_line_to_argv(line)))
 
     def test_glob_paths(self):
         self.build_tree(['a/', 'a/b.c', 'a/c.c', 'a/c.h'])
@@ -312,25 +371,19 @@
         self.build_tree(['a/', 'a/b.c', 'a/c.c', 'a/c.h'])
         self.assertCommandLine([u'a/*.c'], '"a/*.c"')
         self.assertCommandLine([u"'a/*.c'"], "'a/*.c'")
-        self.assertCommandLine([u'a/*.c'], "'a/*.c'",
-            single_quotes_allowed=True)
 
     def test_slashes_changed(self):
         # Quoting doesn't change the supplied args
         self.assertCommandLine([u'a\\*.c'], '"a\\*.c"')
-        self.assertCommandLine([u'a\\*.c'], "'a\\*.c'",
-            single_quotes_allowed=True)
         # Expands the glob, but nothing matches, swaps slashes
         self.assertCommandLine([u'a/*.c'], 'a\\*.c')
         self.assertCommandLine([u'a/?.c'], 'a\\?.c')
         # No glob, doesn't touch slashes
         self.assertCommandLine([u'a\\foo.c'], 'a\\foo.c')
 
-    def test_single_quote_support(self):
+    def test_no_single_quote_supported(self):
         self.assertCommandLine(["add", "let's-do-it.txt"],
             "add let's-do-it.txt")
-        self.assertCommandLine(["add", "lets do it.txt"],
-            "add 'lets do it.txt'", single_quotes_allowed=True)
 
     def test_case_insensitive_globs(self):
         self.requireFeature(tests.CaseInsCasePresFilenameFeature)

=== modified file 'bzrlib/tests/test_workingtree.py'
--- bzrlib/tests/test_workingtree.py	2010-04-23 08:51:52 +0000
+++ bzrlib/tests/test_workingtree.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -303,9 +303,9 @@
         self.assertEqual(
             'method_with_tree_write_lock',
             tree.method_with_tree_write_lock.__name__)
-        self.assertDocstring(
+        self.assertEqual(
             "A lock_tree_write decorated method that returns its arguments.",
-            tree.method_with_tree_write_lock)
+            tree.method_with_tree_write_lock.__doc__)
         args = (1, 2, 3)
         kwargs = {'a':'b'}
         result = tree.method_with_tree_write_lock(1,2,3, a='b')

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/test_workingtree_4.py	2009-11-18 15:47:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -176,7 +176,7 @@
         repo = tree.branch.repository
         repo.get_revision = self.fail
         repo.get_inventory = self.fail
-        repo._get_inventory_xml = self.fail
+        repo.get_inventory_xml = self.fail
         # try to set the parent trees.
         tree.set_parent_trees([(rev1, rev1_tree)])
 
@@ -215,7 +215,7 @@
         # cache the parents of a parent tree at this point.
         #repo.get_revision = self.fail
         repo.get_inventory = self.fail
-        repo._get_inventory_xml = self.fail
+        repo.get_inventory_xml = self.fail
         # set the parent trees.
         tree.set_parent_trees([(rev1, rev1_tree), (rev2, rev2_tree)])
         # read the first tree
@@ -555,11 +555,15 @@
         tree.commit('one', rev_id='rev-1')
         # Trap osutils._walkdirs_utf8 to spy on what dirs have been accessed.
         returned = []
+        orig_walkdirs = osutils._walkdirs_utf8
+        def reset():
+            osutils._walkdirs_utf8 = orig_walkdirs
+        self.addCleanup(reset)
         def walkdirs_spy(*args, **kwargs):
-            for val in orig(*args, **kwargs):
+            for val in orig_walkdirs(*args, **kwargs):
                 returned.append(val[0][0])
                 yield val
-        orig = self.overrideAttr(osutils, '_walkdirs_utf8', walkdirs_spy)
+        osutils._walkdirs_utf8 = walkdirs_spy
 
         basis = tree.basis_tree()
         tree.lock_read()

=== modified file 'bzrlib/tests/test_xml.py'
--- bzrlib/tests/test_xml.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_xml.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/transport_util.py'
--- bzrlib/tests/transport_util.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/transport_util.py	2009-12-22 16:38:07 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -100,9 +100,12 @@
     def setUp(self):
         register_urlparse_netloc_protocol(_hooked_scheme)
         register_transport(_hooked_scheme, ConnectionHookedTransport)
-        self.addCleanup(unregister_transport, _hooked_scheme,
-                        ConnectionHookedTransport)
-        self.addCleanup(_unregister_urlparse_netloc_protocol, _hooked_scheme)
+
+        def unregister():
+            unregister_transport(_hooked_scheme, ConnectionHookedTransport)
+            _unregister_urlparse_netloc_protocol(_hooked_scheme)
+
+        self.addCleanup(unregister)
         super(TestCaseWithConnectionHookedTransport, self).setUp()
         self.reset_connections()
         # Add the 'hooked' url to the permitted url list.
@@ -125,10 +128,13 @@
         return url
 
     def start_logging_connections(self):
-        self.overrideAttr(InstrumentedTransport, 'hooks', TransportHooks())
-        # We preserved the hooks class attribute. Now we install our hook.
         ConnectionHookedTransport.hooks.install_named_hook(
             '_set_connection', self._collect_connection, None)
+        # uninstall our hooks when we are finished
+        self.addCleanup(self.reset_hooks)
+
+    def reset_hooks(self):
+        InstrumentedTransport.hooks = TransportHooks()
 
     def reset_connections(self):
         self.connections = []

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2010-04-30 11:03:59 +0000
+++ bzrlib/textinv.py	2009-03-23 14:59:43 +0000
@@ -16,7 +16,7 @@
 
 
 from bzrlib.errors import BzrError
-from bzrlib.inventory import Inventory
+from bzrlib.inventory import InventoryEntry, Inventory
 
 
 START_MARK = "# bzr inventory format 3\n"

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2010-03-30 14:44:30 +0000
+++ bzrlib/trace.py	2009-12-01 05:35:52 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Messages and logging.
+"""Messages and logging for bazaar-ng.
 
 Messages are supplied by callers as a string-formatting template, plus values
 to be inserted into it.  The actual %-formatting is deferred to the log
@@ -33,7 +33,8 @@
 
 Output to stderr depends on the mode chosen by the user.  By default, messages
 of info and above are sent out, which results in progress messages such as the
-list of files processed by add and commit.  In debug mode, stderr gets debug messages too.
+list of files processed by add and commit.  In quiet mode, only warnings and
+above are shown.  In debug mode, stderr gets debug messages too.
 
 Errors that terminate an operation are generally passed back as exceptions;
 others may be just emitted as messages.
@@ -82,7 +83,6 @@
     osutils,
     plugin,
     symbol_versioning,
-    ui,
     )
 """)
 
@@ -145,7 +145,7 @@
     _bzr_logger.error(*args, **kwargs)
 
 
-def show_error(*args, **kwargs):
+def show_error(msg):
     """Show an error message to the user.
 
     Don't use this for exceptions, use report_exception instead.
@@ -238,52 +238,19 @@
     This sets the global _bzr_log_filename.
     """
     global _bzr_log_filename
-
-    def _open_or_create_log_file(filename):
-        """Open existing log file, or create with ownership and permissions
-
-        It inherits the ownership and permissions (masked by umask) from
-        the containing directory to cope better with being run under sudo
-        with $HOME still set to the user's homedir.
-        """
-        flags = os.O_WRONLY | os.O_APPEND | osutils.O_TEXT
-        while True:
-            try:
-                fd = os.open(filename, flags)
-                break
-            except OSError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-            try:
-                fd = os.open(filename, flags | os.O_CREAT | os.O_EXCL, 0666)
-            except OSError, e:
-                if e.errno != errno.EEXIST:
-                    raise
-            else:
-                osutils.copy_ownership_from_path(filename)
-                break
-        return os.fdopen(fd, 'at', 0) # unbuffered
-
-
     _bzr_log_filename = _get_bzr_log_filename()
     _rollover_trace_maybe(_bzr_log_filename)
     try:
-        bzr_log_file = _open_or_create_log_file(_bzr_log_filename)
+        bzr_log_file = open(_bzr_log_filename, 'at', buffering=0) # unbuffered
+        # bzr_log_file.tell() on windows always return 0 until some writing done
         bzr_log_file.write('\n')
         if bzr_log_file.tell() <= 2:
             bzr_log_file.write("this is a debug log for diagnosing/reporting problems in bzr\n")
             bzr_log_file.write("you can delete or truncate this file, or include sections in\n")
             bzr_log_file.write("bug reports to https://bugs.launchpad.net/bzr/+filebug\n\n")
-
         return bzr_log_file
-
-    except EnvironmentError, e:
-        # If we are failing to open the log, then most likely logging has not
-        # been set up yet. So we just write to stderr rather than using
-        # 'warning()'. If we using warning(), users get the unhelpful 'no
-        # handlers registered for "bzr"' when something goes wrong on the
-        # server. (bug #503886)
-        sys.stderr.write("failed to open trace file: %s\n" % (e,))
+    except IOError, e:
+        warning("failed to open trace file: %s" % (e))
     # TODO: What should happen if we fail to open the trace file?  Maybe the
     # objects should be pointed at /dev/null or the equivalent?  Currently
     # returns None which will cause failures later.
@@ -393,7 +360,6 @@
     global _verbosity_level
     _verbosity_level = level
     _update_logging_level(level < 0)
-    ui.ui_factory.be_quiet(level < 0)
 
 
 def get_verbosity_level():
@@ -405,6 +371,7 @@
 
 
 def be_quiet(quiet=True):
+    # Perhaps this could be deprecated now ...
     if quiet:
         set_verbosity_level(-1)
     else:
@@ -529,23 +496,3 @@
     """Report an exception that probably indicates a bug in bzr"""
     from bzrlib.crash import report_bug
     report_bug(exc_info, err_file)
-
-
-def _flush_stdout_stderr():
-    # installed into an atexit hook by bzrlib.initialize()
-    try:
-        sys.stdout.flush()
-        sys.stderr.flush()
-    except IOError, e:
-        import errno
-        if e.errno in [errno.EINVAL, errno.EPIPE]:
-            pass
-        else:
-            raise
-
-
-def _flush_trace():
-    # run from atexit hook
-    global _trace_file
-    if _trace_file:
-        _trace_file.flush()

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2010-04-30 11:35:43 +0000
+++ bzrlib/transform.py	2009-12-03 05:57:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,7 +17,6 @@
 import os
 import errno
 from stat import S_ISREG, S_IEXEC
-import time
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -31,11 +30,10 @@
     multiparent,
     osutils,
     revision as _mod_revision,
-    ui,
     )
 """)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
-                           ReusingTransform, CantMoveRoot,
+                           ReusingTransform, NotVersionedError, CantMoveRoot,
                            ExistingLimbo, ImmortalLimbo, NoFinalPath,
                            UnableCreateSymlink)
 from bzrlib.filters import filtered_output_bytes, ContentFilterContext
@@ -50,7 +48,7 @@
     splitpath,
     supports_executable,
 )
-from bzrlib.progress import ProgressPhase
+from bzrlib.progress import DummyProgress, ProgressPhase
 from bzrlib.symbol_versioning import (
         deprecated_function,
         deprecated_in,
@@ -80,13 +78,13 @@
 class TreeTransformBase(object):
     """The base class for TreeTransform and its kin."""
 
-    def __init__(self, tree, pb=None,
+    def __init__(self, tree, pb=DummyProgress(),
                  case_sensitive=True):
         """Constructor.
 
         :param tree: The tree that will be transformed, but not necessarily
             the output tree.
-        :param pb: ignored
+        :param pb: A ProgressTask indicating how much progress is being made
         :param case_sensitive: If True, the target of the transform is
             case sensitive, not just case preserving.
         """
@@ -163,12 +161,14 @@
 
     def adjust_path(self, name, parent, trans_id):
         """Change the path that is assigned to a transaction id."""
-        if parent is None:
-            raise ValueError("Parent trans-id may not be None")
         if trans_id == self._new_root:
             raise CantMoveRoot
         self._new_name[trans_id] = name
         self._new_parent[trans_id] = parent
+        if parent == ROOT_PARENT:
+            if self._new_root is not None:
+                raise ValueError("Cannot have multiple roots.")
+            self._new_root = trans_id
 
     def adjust_root_path(self, name, parent):
         """Emulate moving the root by moving all children, instead.
@@ -202,67 +202,6 @@
         self.version_file(old_root_file_id, old_root)
         self.unversion_file(self._new_root)
 
-    def fixup_new_roots(self):
-        """Reinterpret requests to change the root directory
-
-        Instead of creating a root directory, or moving an existing directory,
-        all the attributes and children of the new root are applied to the
-        existing root directory.
-
-        This means that the old root trans-id becomes obsolete, so it is
-        recommended only to invoke this after the root trans-id has become
-        irrelevant.
-        """
-        new_roots = [k for k, v in self._new_parent.iteritems() if v is
-                     ROOT_PARENT]
-        if len(new_roots) < 1:
-            return
-        if len(new_roots) != 1:
-            raise ValueError('A tree cannot have two roots!')
-        if self._new_root is None:
-            self._new_root = new_roots[0]
-            return
-        old_new_root = new_roots[0]
-        # TODO: What to do if a old_new_root is present, but self._new_root is
-        #       not listed as being removed? This code explicitly unversions
-        #       the old root and versions it with the new file_id. Though that
-        #       seems like an incomplete delta
-
-        # unversion the new root's directory.
-        file_id = self.final_file_id(old_new_root)
-        if old_new_root in self._new_id:
-            self.cancel_versioning(old_new_root)
-        else:
-            self.unversion_file(old_new_root)
-        # if, at this stage, root still has an old file_id, zap it so we can
-        # stick a new one in.
-        if (self.tree_file_id(self._new_root) is not None and
-            self._new_root not in self._removed_id):
-            self.unversion_file(self._new_root)
-        self.version_file(file_id, self._new_root)
-
-        # Now move children of new root into old root directory.
-        # Ensure all children are registered with the transaction, but don't
-        # use directly-- some tree children have new parents
-        list(self.iter_tree_children(old_new_root))
-        # Move all children of new root into old root directory.
-        for child in self.by_parent().get(old_new_root, []):
-            self.adjust_path(self.final_name(child), self._new_root, child)
-
-        # Ensure old_new_root has no directory.
-        if old_new_root in self._new_contents:
-            self.cancel_creation(old_new_root)
-        else:
-            self.delete_contents(old_new_root)
-
-        # prevent deletion of root directory.
-        if self._new_root in self._removed_contents:
-            self.cancel_deletion(self._new_root)
-
-        # destroy path info for old_new_root.
-        del self._new_parent[old_new_root]
-        del self._new_name[old_new_root]
-
     def trans_id_tree_file_id(self, inventory_id):
         """Determine the transaction id of a working tree file.
 
@@ -314,8 +253,6 @@
 
     def delete_contents(self, trans_id):
         """Schedule the contents of a path entry for deletion"""
-        # Ensure that the object exists in the WorkingTree, this will raise an
-        # exception if there is a problem
         self.tree_kind(trans_id)
         self._removed_contents.add(trans_id)
 
@@ -1063,14 +1000,14 @@
 class DiskTreeTransform(TreeTransformBase):
     """Tree transform storing its contents on disk."""
 
-    def __init__(self, tree, limbodir, pb=None,
+    def __init__(self, tree, limbodir, pb=DummyProgress(),
                  case_sensitive=True):
         """Constructor.
         :param tree: The tree that will be transformed, but not necessarily
             the output tree.
         :param limbodir: A directory where new files can be stored until
             they are installed in their proper places
-        :param pb: ignored
+        :param pb: A ProgressBar indicating how much progress is being made
         :param case_sensitive: If True, the target of the transform is
             case sensitive, not just case preserving.
         """
@@ -1086,7 +1023,6 @@
         self._limbo_children_names = {}
         # List of transform ids that need to be renamed from limbo into place
         self._needs_rename = set()
-        self._creation_mtime = None
 
     def finalize(self):
         """Release the working tree lock, if held, clean up limbo dir.
@@ -1139,10 +1075,8 @@
         if (trans_id in self._limbo_files and
             trans_id not in self._needs_rename):
             self._rename_in_limbo([trans_id])
-            if previous_parent != parent:
-                self._limbo_children[previous_parent].remove(trans_id)
-            if previous_parent != parent or previous_name != name:
-                del self._limbo_children_names[previous_parent][previous_name]
+            self._limbo_children[previous_parent].remove(trans_id)
+            del self._limbo_children_names[previous_parent][previous_name]
 
     def _rename_in_limbo(self, trans_ids):
         """Fix limbo names so that the right final path is produced.
@@ -1160,7 +1094,7 @@
             if trans_id not in self._new_contents:
                 continue
             new_path = self._limbo_name(trans_id)
-            osutils.rename(old_path, new_path)
+            os.rename(old_path, new_path)
             for descendant in self._limbo_descendants(trans_id):
                 desc_path = self._limbo_files[descendant]
                 desc_path = new_path + desc_path[len(old_path):]
@@ -1199,7 +1133,6 @@
             f.writelines(contents)
         finally:
             f.close()
-        self._set_mtime(name)
         self._set_mode(trans_id, mode_id, S_ISREG)
 
     def _read_file_chunks(self, trans_id):
@@ -1212,15 +1145,6 @@
     def _read_symlink_target(self, trans_id):
         return os.readlink(self._limbo_name(trans_id))
 
-    def _set_mtime(self, path):
-        """All files that are created get the same mtime.
-
-        This time is set by the first object to be created.
-        """
-        if self._creation_mtime is None:
-            self._creation_mtime = time.time()
-        os.utime(path, (self._creation_mtime, self._creation_mtime))
-
     def create_hardlink(self, path, trans_id):
         """Schedule creation of a hard link"""
         name = self._limbo_name(trans_id)
@@ -1340,7 +1264,7 @@
     FileMover does not delete files until it is sure that a rollback will not
     happen.
     """
-    def __init__(self, tree, pb=None):
+    def __init__(self, tree, pb=DummyProgress()):
         """Note: a tree_write lock is taken on the tree.
 
         Use TreeTransform.finalize() to release the lock (can be omitted if
@@ -1629,10 +1553,10 @@
                 child_pb.update('removing file', num, len(tree_paths))
                 full_path = self._tree.abspath(path)
                 if trans_id in self._removed_contents:
-                    delete_path = os.path.join(self._deletiondir, trans_id)
-                    mover.pre_delete(full_path, delete_path)
-                elif (trans_id in self._new_name
-                      or trans_id in self._new_parent):
+                    mover.pre_delete(full_path, os.path.join(self._deletiondir,
+                                     trans_id))
+                elif trans_id in self._new_name or trans_id in \
+                    self._new_parent:
                     try:
                         mover.rename(full_path, self._limbo_name(trans_id))
                     except OSError, e:
@@ -1692,7 +1616,7 @@
     unversioned files in the input tree.
     """
 
-    def __init__(self, tree, pb=None, case_sensitive=True):
+    def __init__(self, tree, pb=DummyProgress(), case_sensitive=True):
         tree.lock_read()
         limbodir = osutils.mkdtemp(prefix='bzr-limbo-')
         DiskTreeTransform.__init__(self, tree, limbodir, pb, case_sensitive)
@@ -2590,10 +2514,9 @@
 
 
 def revert(working_tree, target_tree, filenames, backups=False,
-           pb=None, change_reporter=None):
+           pb=DummyProgress(), change_reporter=None):
     """Revert a working tree's contents to those of a target tree."""
     target_tree.lock_read()
-    pb = ui.ui_factory.nested_progress_bar()
     tt = TreeTransform(working_tree, pb)
     try:
         pp = ProgressPhase("Revert phase", 3, pb)
@@ -2618,6 +2541,7 @@
 def _prepare_revert_transform(working_tree, target_tree, tt, filenames,
                               backups, pp, basis_tree=None,
                               merge_modified=None):
+    pp.next_phase()
     child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
     try:
         if merge_modified is None:
@@ -2627,6 +2551,7 @@
                                       merge_modified, basis_tree)
     finally:
         child_pb.finished()
+    pp.next_phase()
     child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
     try:
         raw_conflicts = resolve_conflicts(tt, child_pb,
@@ -2725,10 +2650,7 @@
                     parent_trans = ROOT_PARENT
                 else:
                     parent_trans = tt.trans_id_file_id(parent[1])
-                if parent[0] is None and versioned[0]:
-                    tt.adjust_root_path(name[1], parent_trans)
-                else:
-                    tt.adjust_path(name[1], parent_trans, trans_id)
+                tt.adjust_path(name[1], parent_trans, trans_id)
             if executable[0] != executable[1] and kind[1] == "file":
                 tt.set_executability(executable[1], trans_id)
         if working_tree.supports_content_filtering():
@@ -2747,19 +2669,17 @@
             for (trans_id, mode_id), bytes in target_tree.iter_files_bytes(
                 deferred_files):
                 tt.create_file(bytes, trans_id, mode_id)
-        tt.fixup_new_roots()
     finally:
         if basis_tree is not None:
             basis_tree.unlock()
     return merge_modified
 
 
-def resolve_conflicts(tt, pb=None, pass_func=None):
+def resolve_conflicts(tt, pb=DummyProgress(), pass_func=None):
     """Make many conflict-resolution attempts, but die if they fail"""
     if pass_func is None:
         pass_func = conflict_pass
     new_conflicts = set()
-    pb = ui.ui_factory.nested_progress_bar()
     try:
         for n in range(10):
             pb.update('Resolution pass', n+1, 10)
@@ -2769,7 +2689,7 @@
             new_conflicts.update(pass_func(tt, conflicts))
         raise MalformedTransform(conflicts=conflicts)
     finally:
-        pb.finished()
+        pb.clear()
 
 
 def conflict_pass(tt, conflicts, path_tree=None):
@@ -2824,7 +2744,7 @@
                         # special-case the other tree root (move its
                         # children to current root)
                         if entry.parent_id is None:
-                            create = False
+                            create=False
                             moved = _reparent_transform_children(
                                 tt, trans_id, tt.root)
                             for child in moved:
@@ -2898,9 +2818,9 @@
         self.pending_deletions = []
 
     def rename(self, from_, to):
-        """Rename a file from one path to another."""
+        """Rename a file from one path to another.  Functions like os.rename"""
         try:
-            osutils.rename(from_, to)
+            os.rename(from_, to)
         except OSError, e:
             if e.errno in (errno.EEXIST, errno.ENOTEMPTY):
                 raise errors.FileExists(to, str(e))
@@ -2920,7 +2840,7 @@
     def rollback(self):
         """Reverse all renames that have been performed"""
         for from_, to in reversed(self.past_renames):
-            osutils.rename(to, from_)
+            os.rename(to, from_)
         # after rollback, don't reuse _FileMover
         past_renames = None
         pending_deletions = None

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2010-04-16 07:56:51 +0000
+++ bzrlib/transport/__init__.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1060,11 +1060,7 @@
         """
         source = self.clone(from_relpath)
         target = self.clone(to_relpath)
-
-        # create target directory with the same rwx bits as source.
-        # use mask to ensure that bits other than rwx are ignored.
-        stat = self.stat(from_relpath)
-        target.mkdir('.', stat.st_mode & 0777)
+        target.mkdir('.')
         source.copy_tree_to_transport(target)
 
     def copy_tree_to_transport(self, to_transport):
@@ -1206,18 +1202,6 @@
         count = self._iterate_over(relpaths, gather, pb, 'stat', expand=False)
         return stats
 
-    def readlink(self, relpath):
-        """Return a string representing the path to which the symbolic link points."""
-        raise errors.TransportNotPossible("Dereferencing symlinks is not supported on %s" % self)
-
-    def hardlink(self, source, link_name):
-        """Create a hardlink pointing to source named link_name."""
-        raise errors.TransportNotPossible("Hard links are not supported on %s" % self)
-
-    def symlink(self, source, link_name):
-        """Create a symlink pointing to source named link_name."""
-        raise errors.TransportNotPossible("Symlinks are not supported on %s" % self)
-
     def listable(self):
         """Return True if this store supports listing."""
         raise NotImplementedError(self.listable)
@@ -1679,7 +1663,13 @@
 class Server(object):
     """A Transport Server.
 
-    The Server interface provides a server for a given transport type.
+    The Server interface provides a server for a given transport. We use
+    these servers as loopback testing tools. For any given transport the
+    Servers it provides must either allow writing, or serve the contents
+    of os.getcwdu() at the time start_server is called.
+
+    Note that these are real servers - they must implement all the things
+    that we want bzr transports to take advantage of.
     """
 
     def start_server(self):
@@ -1688,6 +1678,27 @@
     def stop_server(self):
         """Remove the server and cleanup any resources it owns."""
 
+    def get_url(self):
+        """Return a url for this server.
+
+        If the transport does not represent a disk directory (i.e. it is
+        a database like svn, or a memory only transport, it should return
+        a connection to a newly established resource for this Server.
+        Otherwise it should return a url that will provide access to the path
+        that was os.getcwdu() when start_server() was called.
+
+        Subsequent calls will return the same resource.
+        """
+        raise NotImplementedError
+
+    def get_bogus_url(self):
+        """Return a url for this protocol, that will fail to connect.
+
+        This may raise NotImplementedError to indicate that this server cannot
+        provide bogus urls.
+        """
+        raise NotImplementedError
+
 
 # None is the default transport, for things with no url scheme
 register_transport_proto('file://',
@@ -1847,6 +1858,6 @@
 
 
 transport_server_registry = registry.Registry()
-transport_server_registry.register_lazy('bzr', 'bzrlib.smart.server',
+transport_server_registry.register_lazy('bzr', 'bzrlib.smart.server', 
     'serve_bzr', help="The Bazaar smart server protocol over TCP. (default port: 4155)")
 transport_server_registry.default_key = 'bzr'

=== modified file 'bzrlib/transport/brokenrename.py'
--- bzrlib/transport/brokenrename.py	2010-02-09 17:21:06 +0000
+++ bzrlib/transport/brokenrename.py	2009-03-23 14:59:43 +0000
@@ -23,10 +23,10 @@
         errors,
         urlutils,
         )
-from bzrlib.transport import decorator
-
-
-class BrokenRenameTransportDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
+
+
+class BrokenRenameTransportDecorator(TransportDecorator):
     """A transport that fails to detect clashing renames"""
 
     @classmethod
@@ -46,6 +46,13 @@
             return
 
 
+class BrokenRenameServer(DecoratorServer):
+    """Server for the BrokenRenameTransportDecorator for testing with."""
+
+    def get_decorator_class(self):
+        return BrokenRenameTransportDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
     # we don't use this for general testing, only for the tests that

=== modified file 'bzrlib/transport/chroot.py'
--- bzrlib/transport/chroot.py	2010-04-07 12:19:40 +0000
+++ bzrlib/transport/chroot.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006-2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,8 +19,12 @@
 """
 
 from bzrlib.transport import (
+    get_transport,
     pathfilter,
     register_transport,
+    Server,
+    Transport,
+    unregister_transport,
     )
 
 
@@ -61,7 +65,21 @@
         return self._relpath_from_server_root(relpath)
 
 
+class TestingChrootServer(ChrootServer):
+
+    def __init__(self):
+        """TestingChrootServer is not usable until start_server is called."""
+        ChrootServer.__init__(self, None)
+
+    def start_server(self, backing_server=None):
+        """Setup the Chroot on backing_server."""
+        if backing_server is not None:
+            self.backing_transport = get_transport(backing_server.get_url())
+        else:
+            self.backing_transport = get_transport('.')
+        ChrootServer.start_server(self)
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(ChrootTransport, test_server.TestingChrootServer)]
+    return [(ChrootTransport, TestingChrootServer)]

=== modified file 'bzrlib/transport/decorator.py'
--- bzrlib/transport/decorator.py	2010-02-23 07:43:11 +0000
+++ bzrlib/transport/decorator.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -177,6 +177,49 @@
             return None
 
 
+class DecoratorServer(Server):
+    """Server for the TransportDecorator for testing with.
+
+    To use this when subclassing TransportDecorator, override override the
+    get_decorator_class method.
+    """
+
+    def start_server(self, server=None):
+        """See bzrlib.transport.Server.start_server.
+
+        :server: decorate the urls given by server. If not provided a
+        LocalServer is created.
+        """
+        if server is not None:
+            self._made_server = False
+            self._server = server
+        else:
+            from bzrlib.transport.local import LocalURLServer
+            self._made_server = True
+            self._server = LocalURLServer()
+            self._server.start_server()
+
+    def stop_server(self):
+        if self._made_server:
+            self._server.stop_server()
+
+    def get_decorator_class(self):
+        """Return the class of the decorators we should be constructing."""
+        raise NotImplementedError(self.get_decorator_class)
+
+    def get_url_prefix(self):
+        """What URL prefix does this decorator produce?"""
+        return self.get_decorator_class()._get_url_prefix()
+
+    def get_bogus_url(self):
+        """See bzrlib.transport.Server.get_bogus_url."""
+        return self.get_url_prefix() + self._server.get_bogus_url()
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self.get_url_prefix() + self._server.get_url()
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing.
 

=== modified file 'bzrlib/transport/fakenfs.py'
--- bzrlib/transport/fakenfs.py	2010-02-09 17:19:50 +0000
+++ bzrlib/transport/fakenfs.py	2009-03-23 14:59:43 +0000
@@ -28,10 +28,10 @@
     errors,
     urlutils,
     )
-from bzrlib.transport import decorator
-
-
-class FakeNFSTransportDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
+
+
+class FakeNFSTransportDecorator(TransportDecorator):
     """A transport that behaves like NFS, for testing"""
 
     @classmethod
@@ -62,7 +62,14 @@
         return self._decorated.delete(relpath)
 
 
+class FakeNFSServer(DecoratorServer):
+    """Server for the FakeNFSTransportDecorator for testing with."""
+
+    def get_decorator_class(self):
+        return FakeNFSTransportDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(FakeNFSTransportDecorator, test_server.FakeNFSServer),]
+    return [(FakeNFSTransportDecorator, FakeNFSServer),
+            ]

=== modified file 'bzrlib/transport/fakevfat.py'
--- bzrlib/transport/fakevfat.py	2010-02-09 17:22:25 +0000
+++ bzrlib/transport/fakevfat.py	2009-03-23 14:59:43 +0000
@@ -41,7 +41,7 @@
 import re
 
 from bzrlib.errors import TransportNotPossible
-from bzrlib.transport import decorator
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
 
 
 # TODO: It might be nice if these hooks were available in a more general way
@@ -52,7 +52,7 @@
 # which are not implemented here fail by default?
 
 
-class FakeVFATTransportDecorator(decorator.TransportDecorator):
+class FakeVFATTransportDecorator(TransportDecorator):
     """A decorator that can convert any transport to be readonly.
 
     This is requested via the 'vfat+' prefix to get_transport().
@@ -99,7 +99,17 @@
         return self._decorated.put_file(self._squash_name(relpath), f, mode)
 
 
+class FakeVFATServer(DecoratorServer):
+    """A server that suggests connections through FakeVFATTransportDecorator
+
+    For use in testing.
+    """
+
+    def get_decorator_class(self):
+        return FakeVFATTransportDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(FakeVFATTransportDecorator, test_server.FakeVFATServer),]
+    return [(FakeVFATTransportDecorator, FakeVFATServer),
+            ]

=== modified file 'bzrlib/transport/ftp/__init__.py'
--- bzrlib/transport/ftp/__init__.py	2010-02-27 01:37:54 +0000
+++ bzrlib/transport/ftp/__init__.py	2009-10-06 08:24:14 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -13,7 +13,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
 """Implementation of Transport over ftp.
 
 Written by Daniel Silverstone <dsilvers@digital-scurf.org> with serious
@@ -164,9 +163,9 @@
         connection, credentials = self._create_connection(credentials)
         self._set_connection(connection, credentials)
 
-    def _translate_ftp_error(self, err, path, extra=None,
+    def _translate_perm_error(self, err, path, extra=None,
                               unknown_exc=FtpPathError):
-        """Try to translate an ftplib exception to a bzrlib exception.
+        """Try to translate an ftplib.error_perm exception.
 
         :param err: The error to translate into a bzr error
         :param path: The path which had problems
@@ -174,9 +173,6 @@
         :param unknown_exc: If None, we will just raise the original exception
                     otherwise we raise unknown_exc(path, extra=extra)
         """
-        # ftp error numbers are very generic, like "451: Requested action aborted,
-        # local error in processing" so unfortunately we have to match by
-        # strings.
         s = str(err).lower()
         if not extra:
             extra = str(err)
@@ -193,12 +189,10 @@
             or (s.startswith('550 ') and 'unable to rename to' in extra)
             ):
             raise errors.NoSuchFile(path, extra=extra)
-        elif ('file exists' in s):
+        if ('file exists' in s):
             raise errors.FileExists(path, extra=extra)
-        elif ('not a directory' in s):
+        if ('not a directory' in s):
             raise errors.PathError(path, extra=extra)
-        elif 'directory not empty' in s:
-            raise errors.DirectoryNotEmpty(path, extra=extra)
 
         mutter('unable to understand error for path: %s: %s', path, err)
 
@@ -211,6 +205,17 @@
         #raise TransportError(msg='Error for path: %s' % (path,), orig_error=e)
         raise
 
+    def _remote_path(self, relpath):
+        # XXX: It seems that ftplib does not handle Unicode paths
+        # at the same time, medusa won't handle utf8 paths So if
+        # we .encode(utf8) here (see ConnectedTransport
+        # implementation), then we get a Server failure.  while
+        # if we use str(), we get a UnicodeError, and the test
+        # suite just skips testing UnicodePaths.
+        relative = str(urlutils.unescape(relpath))
+        remote_path = self._combine_paths(self._path, relative)
+        return remote_path
+
     def has(self, relpath):
         """Does the target location exist?"""
         # FIXME jam 20060516 We *do* ask about directories in the test suite
@@ -324,7 +329,7 @@
                     raise e
                 raise
         except ftplib.error_perm, e:
-            self._translate_ftp_error(e, abspath, extra='could not store',
+            self._translate_perm_error(e, abspath, extra='could not store',
                                        unknown_exc=errors.NoSuchFile)
         except ftplib.error_temp, e:
             if retries > _number_of_retries:
@@ -353,7 +358,7 @@
             f.mkd(abspath)
             self._setmode(relpath, mode)
         except ftplib.error_perm, e:
-            self._translate_ftp_error(e, abspath,
+            self._translate_perm_error(e, abspath,
                 unknown_exc=errors.FileExists)
 
     def open_write_stream(self, relpath, mode=None):
@@ -379,7 +384,7 @@
             f = self._get_FTP()
             f.rmd(abspath)
         except ftplib.error_perm, e:
-            self._translate_ftp_error(e, abspath, unknown_exc=errors.PathError)
+            self._translate_perm_error(e, abspath, unknown_exc=errors.PathError)
 
     def append_file(self, relpath, f, mode=None):
         """Append the text in the file-like object into the final
@@ -425,7 +430,7 @@
                 self._has_append = False
                 self._fallback_append(relpath, text, mode)
             else:
-                self._translate_ftp_error(e, abspath, extra='error appending',
+                self._translate_perm_error(e, abspath, extra='error appending',
                     unknown_exc=errors.NoSuchFile)
         except ftplib.error_temp, e:
             if retries > _number_of_retries:
@@ -478,8 +483,8 @@
     def _rename(self, abs_from, abs_to, f):
         try:
             f.rename(abs_from, abs_to)
-        except (ftplib.error_temp, ftplib.error_perm), e:
-            self._translate_ftp_error(e, abs_from,
+        except ftplib.error_perm, e:
+            self._translate_perm_error(e, abs_from,
                 ': unable to rename to %r' % (abs_to))
 
     def move(self, rel_from, rel_to):
@@ -491,7 +496,7 @@
             f = self._get_FTP()
             self._rename_and_overwrite(abs_from, abs_to, f)
         except ftplib.error_perm, e:
-            self._translate_ftp_error(e, abs_from,
+            self._translate_perm_error(e, abs_from,
                 extra='unable to rename to %r' % (rel_to,),
                 unknown_exc=errors.PathError)
 
@@ -515,7 +520,7 @@
             mutter("FTP rm: %s", abspath)
             f.delete(abspath)
         except ftplib.error_perm, e:
-            self._translate_ftp_error(e, abspath, 'error deleting',
+            self._translate_perm_error(e, abspath, 'error deleting',
                 unknown_exc=errors.NoSuchFile)
 
     def external_url(self):
@@ -536,7 +541,7 @@
             try:
                 paths = f.nlst(basepath)
             except ftplib.error_perm, e:
-                self._translate_ftp_error(e, relpath,
+                self._translate_perm_error(e, relpath,
                                            extra='error with list_dir')
             except ftplib.error_temp, e:
                 # xs4all's ftp server raises a 450 temp error when listing an
@@ -585,7 +590,7 @@
             f = self._get_FTP()
             return FtpStatResult(f, abspath)
         except ftplib.error_perm, e:
-            self._translate_ftp_error(e, abspath, extra='error w/ stat')
+            self._translate_perm_error(e, abspath, extra='error w/ stat')
 
     def lock_read(self, relpath):
         """Lock the given file for shared (read) access.

=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/transport/http/__init__.py	2009-11-26 14:39:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2010-02-17 17:11:16 +0000
+++ bzrlib/transport/http/_urllib.py	2009-12-03 17:11:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/transport/http/_urllib2_wrappers.py'
--- bzrlib/transport/http/_urllib2_wrappers.py	2010-02-17 17:11:16 +0000
+++ bzrlib/transport/http/_urllib2_wrappers.py	2009-12-03 17:11:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/transport/http/wsgi.py'
--- bzrlib/transport/http/wsgi.py	2010-02-17 17:11:16 +0000
+++ bzrlib/transport/http/wsgi.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2010-04-28 07:53:34 +0000
+++ bzrlib/transport/local.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,14 +39,14 @@
 from bzrlib.transport import LateReadError
 """)
 
-from bzrlib import transport
-
-
-_append_flags = os.O_CREAT | os.O_APPEND | os.O_WRONLY | osutils.O_BINARY | osutils.O_NOINHERIT
-_put_non_atomic_flags = os.O_CREAT | os.O_TRUNC | os.O_WRONLY | osutils.O_BINARY | osutils.O_NOINHERIT
-
-
-class LocalTransport(transport.Transport):
+from bzrlib.transport import Transport, Server
+
+
+_append_flags = os.O_CREAT | os.O_APPEND | os.O_WRONLY | osutils.O_BINARY
+_put_non_atomic_flags = os.O_CREAT | os.O_TRUNC | os.O_WRONLY | osutils.O_BINARY
+
+
+class LocalTransport(Transport):
     """This is the transport agent for local filesystem access."""
 
     def __init__(self, base):
@@ -160,7 +160,7 @@
             transport._file_streams[canonical_url].flush()
         try:
             path = self._abspath(relpath)
-            return osutils.open_file(path, 'rb')
+            return open(path, 'rb')
         except (IOError, OSError),e:
             if e.errno == errno.EISDIR:
                 return LateReadError(relpath)
@@ -329,7 +329,7 @@
         # initialise the file
         self.put_bytes_non_atomic(relpath, "", mode=mode)
         abspath = self._abspath(relpath)
-        handle = osutils.open_file(abspath, 'wb')
+        handle = open(abspath, 'wb')
         if mode is not None:
             self._check_mode_and_size(abspath, handle.fileno(), mode)
         transport._file_streams[self.abspath(relpath)] = handle
@@ -399,18 +399,13 @@
 
     def rename(self, rel_from, rel_to):
         path_from = self._abspath(rel_from)
-        path_to = self._abspath(rel_to)
         try:
             # *don't* call bzrlib.osutils.rename, because we want to
-            # detect conflicting names on rename, and osutils.rename tries to
-            # mask cross-platform differences there; however we do update the
-            # exception to include the filenames
-            os.rename(path_from, path_to)
+            # detect errors on rename
+            os.rename(path_from, self._abspath(rel_to))
         except (IOError, OSError),e:
             # TODO: What about path_to?
-            self._translate_error(
-                osutils._add_rename_error_details(e, path_from, path_to),
-                path_from)
+            self._translate_error(e, path_from)
 
     def move(self, rel_from, rel_to):
         """Move the item at rel_from to the location at rel_to"""
@@ -486,7 +481,7 @@
         path = relpath
         try:
             path = self._abspath(relpath)
-            return os.lstat(path)
+            return os.stat(path)
         except (IOError, OSError),e:
             self._translate_error(e, path)
 
@@ -520,33 +515,6 @@
         except (IOError, OSError),e:
             self._translate_error(e, path)
 
-    if osutils.host_os_dereferences_symlinks():
-        def readlink(self, relpath):
-            """See Transport.readlink."""
-            return osutils.readlink(self._abspath(relpath))
-
-    if osutils.hardlinks_good():
-        def hardlink(self, source, link_name):
-            """See Transport.link."""
-            try:
-                os.link(self._abspath(source), self._abspath(link_name))
-            except (IOError, OSError), e:
-                self._translate_error(e, source)
-
-    if osutils.has_symlinks():
-        def symlink(self, source, link_name):
-            """See Transport.symlink."""
-            abs_link_dirpath = urlutils.dirname(self.abspath(link_name))
-            source_rel = urlutils.file_relpath(
-                urlutils.strip_trailing_slash(abs_link_dirpath),
-                urlutils.strip_trailing_slash(self.abspath(source))
-            )
-
-            try:
-                os.symlink(source_rel, self._abspath(link_name))
-            except (IOError, OSError), e:
-                self._translate_error(e, source_rel)
-
     def _can_roundtrip_unix_modebits(self):
         if sys.platform == 'win32':
             # anyone else?
@@ -586,7 +554,23 @@
             return EmulatedWin32LocalTransport(abspath)
 
 
+class LocalURLServer(Server):
+    """A pretend server for local transports, using file:// urls.
+
+    Of course no actual server is required to access the local filesystem, so
+    this just exists to tell the test code how to get to it.
+    """
+
+    def start_server(self):
+        pass
+
+    def get_url(self):
+        """See Transport.Server.get_url."""
+        return urlutils.local_path_to_url('')
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(LocalTransport, test_server.LocalURLServer),]
+    return [
+            (LocalTransport, LocalURLServer),
+            ]

=== modified file 'bzrlib/transport/log.py'
--- bzrlib/transport/log.py	2010-02-11 09:27:55 +0000
+++ bzrlib/transport/log.py	2009-07-01 07:29:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,10 +26,18 @@
 import types
 
 from bzrlib.trace import mutter
-from bzrlib.transport import decorator
-
-
-class TransportLogDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import (
+    TransportDecorator,
+    )
+from bzrlib.transport.trace import (
+    DecoratorServer,
+    TransportTraceDecorator,
+    )
+
+
+
+
+class TransportLogDecorator(TransportDecorator):
     """Decorator for Transports that logs interesting operations to .bzr.log.
 
     In general we want to log things that usually take a network round trip
@@ -128,10 +136,8 @@
         if False:
             elapsed = time.time() - before
             if result_len and elapsed > 0:
-                # this is the rate of higher-level data, not the raw network
-                # speed using base-10 units (see HACKING.txt).
-                mutter("      %9.03fs %8dkB/s"
-                       % (elapsed, result_len/elapsed/1000))
+                # this is the rate of higher-level data, not the raw network speed
+                mutter("      %9.03fs %8dKB/s" % (elapsed, result_len/elapsed/1024))
             else:
                 mutter("      %9.03fs" % (elapsed))
         return return_result
@@ -148,7 +154,13 @@
         return t
 
 
+class LogDecoratorServer(DecoratorServer):
+    """Server for testing."""
+
+    def get_decorator_class(self):
+        return TransportLogDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(TransportLogDecorator, test_server.LogDecoratorServer)]
+    return [(TransportLogDecorator, LogDecoratorServer)]

=== modified file 'bzrlib/transport/memory.py'
--- bzrlib/transport/memory.py	2010-02-23 07:43:11 +0000
+++ bzrlib/transport/memory.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,10 +27,6 @@
 from cStringIO import StringIO
 import warnings
 
-from bzrlib import (
-    transport,
-    urlutils,
-    )
 from bzrlib.errors import (
     FileExists,
     LockError,
@@ -43,7 +39,11 @@
     AppendBasedFileStream,
     _file_streams,
     LateReadError,
+    register_transport,
+    Server,
+    Transport,
     )
+import bzrlib.urlutils as urlutils
 
 
 
@@ -61,7 +61,7 @@
             self.st_mode = S_IFDIR | perms
 
 
-class MemoryTransport(transport.Transport):
+class MemoryTransport(Transport):
     """This is an in memory file system for transient data storage."""
 
     def __init__(self, url=""):
@@ -300,7 +300,7 @@
         self.transport = None
 
 
-class MemoryServer(transport.Server):
+class MemoryServer(Server):
     """Server for the MemoryTransport for testing with."""
 
     def start_server(self):
@@ -309,26 +309,22 @@
         self._locks = {}
         self._scheme = "memory+%s:///" % id(self)
         def memory_factory(url):
-            from bzrlib.transport import memory
-            result = memory.MemoryTransport(url)
+            result = MemoryTransport(url)
             result._dirs = self._dirs
             result._files = self._files
             result._locks = self._locks
             return result
-        self._memory_factory = memory_factory
-        transport.register_transport(self._scheme, self._memory_factory)
+        register_transport(self._scheme, memory_factory)
 
     def stop_server(self):
         # unregister this server
-        transport.unregister_transport(self._scheme, self._memory_factory)
+        # XXX: why isn't this done? -- mbp 20100106
+        pass
 
     def get_url(self):
         """See bzrlib.transport.Server.get_url."""
         return self._scheme
 
-    def get_bogus_url(self):
-        raise NotImplementedError
-
 
 def get_test_permutations():
     """Return the permutations to be used in testing."""

=== modified file 'bzrlib/transport/nosmart.py'
--- bzrlib/transport/nosmart.py	2010-02-09 17:27:46 +0000
+++ bzrlib/transport/nosmart.py	2009-03-23 14:59:43 +0000
@@ -22,10 +22,10 @@
 """
 
 from bzrlib import errors
-from bzrlib.transport import decorator
-
-
-class NoSmartTransportDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
+
+
+class NoSmartTransportDecorator(TransportDecorator):
     """A decorator for transports that disables get_smart_medium."""
 
     @classmethod
@@ -36,8 +36,14 @@
         raise errors.NoSmartMedium(self)
 
 
+class NoSmartTransportServer(DecoratorServer):
+    """Server for the NoSmartTransportDecorator for testing with."""
+
+    def get_decorator_class(self):
+        return NoSmartTransportDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(NoSmartTransportDecorator, test_server.NoSmartTransportServer)]
+    return [(NoSmartTransportDecorator, NoSmartTransportServer)]
 

=== modified file 'bzrlib/transport/pathfilter.py'
--- bzrlib/transport/pathfilter.py	2010-02-23 07:43:11 +0000
+++ bzrlib/transport/pathfilter.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
+# Copyright (C) 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -174,7 +174,22 @@
         return self._call('stat', relpath)
 
 
+class TestingPathFilteringServer(PathFilteringServer):
+
+    def __init__(self):
+        """TestingChrootServer is not usable until start_server is called."""
+
+    def start_server(self, backing_server=None):
+        """Setup the Chroot on backing_server."""
+        if backing_server is not None:
+            self.backing_transport = get_transport(backing_server.get_url())
+        else:
+            self.backing_transport = get_transport('.')
+        self.backing_transport.clone('added-by-filter').ensure_base()
+        self.filter_func = lambda x: 'added-by-filter/' + x
+        PathFilteringServer.start_server(self)
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(PathFilteringTransport, test_server.TestingPathFilteringServer)]
+    return [(PathFilteringTransport, TestingPathFilteringServer)]

=== modified file 'bzrlib/transport/readonly.py'
--- bzrlib/transport/readonly.py	2010-02-09 17:15:17 +0000
+++ bzrlib/transport/readonly.py	2009-03-24 01:53:42 +0000
@@ -17,10 +17,10 @@
 """Implementation of Transport that adapts another transport to be readonly."""
 
 from bzrlib.errors import TransportNotPossible, NoSmartMedium
-from bzrlib.transport import decorator
-
-
-class ReadonlyTransportDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
+
+
+class ReadonlyTransportDecorator(TransportDecorator):
     """A decorator that can convert any transport to be readonly.
 
     This is requested via the 'readonly+' prefix to get_transport().
@@ -78,7 +78,15 @@
         raise NoSmartMedium(self)
 
 
+
+class ReadonlyServer(DecoratorServer):
+    """Server for the ReadonlyTransportDecorator for testing with."""
+
+    def get_decorator_class(self):
+        return ReadonlyTransportDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(ReadonlyTransportDecorator, test_server.ReadonlyServer),]
+    return [(ReadonlyTransportDecorator, ReadonlyServer),
+            ]

=== modified file 'bzrlib/transport/remote.py'
--- bzrlib/transport/remote.py	2010-02-09 20:28:26 +0000
+++ bzrlib/transport/remote.py	2009-03-24 01:53:42 +0000
@@ -601,5 +601,5 @@
     """Return (transport, server) permutations for testing."""
     ### We may need a little more test framework support to construct an
     ### appropriate RemoteTransport in the future.
-    from bzrlib.tests import test_server
-    return [(RemoteTCPTransport, test_server.SmartTCPServer_for_testing)]
+    from bzrlib.smart import server
+    return [(RemoteTCPTransport, server.SmartTCPServer_for_testing)]

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2010-03-04 02:43:41 +0000
+++ bzrlib/transport/sftp.py	2010-01-07 03:03:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,6 +28,8 @@
 import itertools
 import os
 import random
+import select
+import socket
 import stat
 import sys
 import time
@@ -82,7 +84,7 @@
 else:
     from paramiko.sftp import (SFTP_FLAG_WRITE, SFTP_FLAG_CREATE,
                                SFTP_FLAG_EXCL, SFTP_FLAG_TRUNC,
-                               SFTP_OK, CMD_HANDLE, CMD_OPEN)
+                               CMD_HANDLE, CMD_OPEN)
     from paramiko.sftp_attr import SFTPAttributes
     from paramiko.sftp_file import SFTPFile
 
@@ -810,32 +812,10 @@
         """Return the stat information for a file."""
         path = self._remote_path(relpath)
         try:
-            return self._get_sftp().lstat(path)
+            return self._get_sftp().stat(path)
         except (IOError, paramiko.SSHException), e:
             self._translate_io_exception(e, path, ': unable to stat')
 
-    def readlink(self, relpath):
-        """See Transport.readlink."""
-        path = self._remote_path(relpath)
-        try:
-            return self._get_sftp().readlink(path)
-        except (IOError, paramiko.SSHException), e:
-            self._translate_io_exception(e, path, ': unable to readlink')
-
-    def symlink(self, source, link_name):
-        """See Transport.symlink."""
-        try:
-            conn = self._get_sftp()
-            sftp_retval = conn.symlink(source, link_name)
-            if SFTP_OK != sftp_retval:
-                raise TransportError(
-                    '%r: unable to create symlink to %r' % (link_name, source),
-                    sftp_retval
-                )
-        except (IOError, paramiko.SSHException), e:
-            self._translate_io_exception(e, link_name,
-                                         ': unable to create symlink to %r' % (source))
-
     def lock_read(self, relpath):
         """
         Lock the given file for shared (read) access.
@@ -904,11 +884,332 @@
         else:
             return True
 
+# ------------- server test implementation --------------
+import threading
+
+from bzrlib.tests.stub_sftp import StubServer, StubSFTPServer
+
+STUB_SERVER_KEY = """
+-----BEGIN RSA PRIVATE KEY-----
+MIICWgIBAAKBgQDTj1bqB4WmayWNPB+8jVSYpZYk80Ujvj680pOTh2bORBjbIAyz
+oWGW+GUjzKxTiiPvVmxFgx5wdsFvF03v34lEVVhMpouqPAYQ15N37K/ir5XY+9m/
+d8ufMCkjeXsQkKqFbAlQcnWMCRnOoPHS3I4vi6hmnDDeeYTSRvfLbW0fhwIBIwKB
+gBIiOqZYaoqbeD9OS9z2K9KR2atlTxGxOJPXiP4ESqP3NVScWNwyZ3NXHpyrJLa0
+EbVtzsQhLn6rF+TzXnOlcipFvjsem3iYzCpuChfGQ6SovTcOjHV9z+hnpXvQ/fon
+soVRZY65wKnF7IAoUwTmJS9opqgrN6kRgCd3DASAMd1bAkEA96SBVWFt/fJBNJ9H
+tYnBKZGw0VeHOYmVYbvMSstssn8un+pQpUm9vlG/bp7Oxd/m+b9KWEh2xPfv6zqU
+avNwHwJBANqzGZa/EpzF4J8pGti7oIAPUIDGMtfIcmqNXVMckrmzQ2vTfqtkEZsA
+4rE1IERRyiJQx6EJsz21wJmGV9WJQ5kCQQDwkS0uXqVdFzgHO6S++tjmjYcxwr3g
+H0CoFYSgbddOT6miqRskOQF3DZVkJT3kyuBgU2zKygz52ukQZMqxCb1fAkASvuTv
+qfpH87Qq5kQhNKdbbwbmd2NxlNabazPijWuphGTdW0VfJdWfklyS2Kr+iqrs/5wV
+HhathJt636Eg7oIjAkA8ht3MQ+XSl9yIJIS8gVpbPxSw5OMfw0PjVE7tBdQruiSc
+nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
+-----END RSA PRIVATE KEY-----
+"""
+
+
+class SocketListener(threading.Thread):
+
+    def __init__(self, callback):
+        threading.Thread.__init__(self)
+        self._callback = callback
+        self._socket = socket.socket()
+        self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
+        self._socket.bind(('localhost', 0))
+        self._socket.listen(1)
+        self.host, self.port = self._socket.getsockname()[:2]
+        self._stop_event = threading.Event()
+
+    def stop(self):
+        # called from outside this thread
+        self._stop_event.set()
+        # use a timeout here, because if the test fails, the server thread may
+        # never notice the stop_event.
+        self.join(5.0)
+        self._socket.close()
+
+    def run(self):
+        while True:
+            readable, writable_unused, exception_unused = \
+                select.select([self._socket], [], [], 0.1)
+            if self._stop_event.isSet():
+                return
+            if len(readable) == 0:
+                continue
+            try:
+                s, addr_unused = self._socket.accept()
+                # because the loopback socket is inline, and transports are
+                # never explicitly closed, best to launch a new thread.
+                threading.Thread(target=self._callback, args=(s,)).start()
+            except socket.error, x:
+                sys.excepthook(*sys.exc_info())
+                warning('Socket error during accept() within unit test server'
+                        ' thread: %r' % x)
+            except Exception, x:
+                # probably a failed test; unit test thread will log the
+                # failure/error
+                sys.excepthook(*sys.exc_info())
+                warning('Exception from within unit test server thread: %r' %
+                        x)
+
+
+class SocketDelay(object):
+    """A socket decorator to make TCP appear slower.
+
+    This changes recv, send, and sendall to add a fixed latency to each python
+    call if a new roundtrip is detected. That is, when a recv is called and the
+    flag new_roundtrip is set, latency is charged. Every send and send_all
+    sets this flag.
+
+    In addition every send, sendall and recv sleeps a bit per character send to
+    simulate bandwidth.
+
+    Not all methods are implemented, this is deliberate as this class is not a
+    replacement for the builtin sockets layer. fileno is not implemented to
+    prevent the proxy being bypassed.
+    """
+
+    simulated_time = 0
+    _proxied_arguments = dict.fromkeys([
+        "close", "getpeername", "getsockname", "getsockopt", "gettimeout",
+        "setblocking", "setsockopt", "settimeout", "shutdown"])
+
+    def __init__(self, sock, latency, bandwidth=1.0,
+                 really_sleep=True):
+        """
+        :param bandwith: simulated bandwith (MegaBit)
+        :param really_sleep: If set to false, the SocketDelay will just
+        increase a counter, instead of calling time.sleep. This is useful for
+        unittesting the SocketDelay.
+        """
+        self.sock = sock
+        self.latency = latency
+        self.really_sleep = really_sleep
+        self.time_per_byte = 1 / (bandwidth / 8.0 * 1024 * 1024)
+        self.new_roundtrip = False
+
+    def sleep(self, s):
+        if self.really_sleep:
+            time.sleep(s)
+        else:
+            SocketDelay.simulated_time += s
+
+    def __getattr__(self, attr):
+        if attr in SocketDelay._proxied_arguments:
+            return getattr(self.sock, attr)
+        raise AttributeError("'SocketDelay' object has no attribute %r" %
+                             attr)
+
+    def dup(self):
+        return SocketDelay(self.sock.dup(), self.latency, self.time_per_byte,
+                           self._sleep)
+
+    def recv(self, *args):
+        data = self.sock.recv(*args)
+        if data and self.new_roundtrip:
+            self.new_roundtrip = False
+            self.sleep(self.latency)
+        self.sleep(len(data) * self.time_per_byte)
+        return data
+
+    def sendall(self, data, flags=0):
+        if not self.new_roundtrip:
+            self.new_roundtrip = True
+            self.sleep(self.latency)
+        self.sleep(len(data) * self.time_per_byte)
+        return self.sock.sendall(data, flags)
+
+    def send(self, data, flags=0):
+        if not self.new_roundtrip:
+            self.new_roundtrip = True
+            self.sleep(self.latency)
+        bytes_sent = self.sock.send(data, flags)
+        self.sleep(bytes_sent * self.time_per_byte)
+        return bytes_sent
+
+
+class SFTPServer(Server):
+    """Common code for SFTP server facilities."""
+
+    def __init__(self, server_interface=StubServer):
+        self._original_vendor = None
+        self._homedir = None
+        self._server_homedir = None
+        self._listener = None
+        self._root = None
+        self._vendor = ssh.ParamikoVendor()
+        self._server_interface = server_interface
+        # sftp server logs
+        self.logs = []
+        self.add_latency = 0
+
+    def _get_sftp_url(self, path):
+        """Calculate an sftp url to this server for path."""
+        return 'sftp://foo:bar@%s:%d/%s' % (self._listener.host,
+                                            self._listener.port, path)
+
+    def log(self, message):
+        """StubServer uses this to log when a new server is created."""
+        self.logs.append(message)
+
+    def _run_server_entry(self, sock):
+        """Entry point for all implementations of _run_server.
+
+        If self.add_latency is > 0.000001 then sock is given a latency adding
+        decorator.
+        """
+        if self.add_latency > 0.000001:
+            sock = SocketDelay(sock, self.add_latency)
+        return self._run_server(sock)
+
+    def _run_server(self, s):
+        ssh_server = paramiko.Transport(s)
+        key_file = pathjoin(self._homedir, 'test_rsa.key')
+        f = open(key_file, 'w')
+        f.write(STUB_SERVER_KEY)
+        f.close()
+        host_key = paramiko.RSAKey.from_private_key_file(key_file)
+        ssh_server.add_server_key(host_key)
+        server = self._server_interface(self)
+        ssh_server.set_subsystem_handler('sftp', paramiko.SFTPServer,
+                                         StubSFTPServer, root=self._root,
+                                         home=self._server_homedir)
+        event = threading.Event()
+        ssh_server.start_server(event, server)
+        event.wait(5.0)
+
+    def start_server(self, backing_server=None):
+        # XXX: TODO: make sftpserver back onto backing_server rather than local
+        # disk.
+        if not (backing_server is None or
+                isinstance(backing_server, local.LocalURLServer)):
+            raise AssertionError(
+                "backing_server should not be %r, because this can only serve the "
+                "local current working directory." % (backing_server,))
+        self._original_vendor = ssh._ssh_vendor_manager._cached_ssh_vendor
+        ssh._ssh_vendor_manager._cached_ssh_vendor = self._vendor
+        if sys.platform == 'win32':
+            # Win32 needs to use the UNICODE api
+            self._homedir = getcwd()
+        else:
+            # But Linux SFTP servers should just deal in bytestreams
+            self._homedir = os.getcwd()
+        if self._server_homedir is None:
+            self._server_homedir = self._homedir
+        self._root = '/'
+        if sys.platform == 'win32':
+            self._root = ''
+        self._listener = SocketListener(self._run_server_entry)
+        self._listener.setDaemon(True)
+        self._listener.start()
+
+    def stop_server(self):
+        self._listener.stop()
+        ssh._ssh_vendor_manager._cached_ssh_vendor = self._original_vendor
+
+    def get_bogus_url(self):
+        """See bzrlib.transport.Server.get_bogus_url."""
+        # this is chosen to try to prevent trouble with proxies, wierd dns, etc
+        # we bind a random socket, so that we get a guaranteed unused port
+        # we just never listen on that port
+        s = socket.socket()
+        s.bind(('localhost', 0))
+        return 'sftp://%s:%s/' % s.getsockname()
+
+
+class SFTPFullAbsoluteServer(SFTPServer):
+    """A test server for sftp transports, using absolute urls and ssh."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        homedir = self._homedir
+        if sys.platform != 'win32':
+            # Remove the initial '/' on all platforms but win32
+            homedir = homedir[1:]
+        return self._get_sftp_url(urlutils.escape(homedir))
+
+
+class SFTPServerWithoutSSH(SFTPServer):
+    """An SFTP server that uses a simple TCP socket pair rather than SSH."""
+
+    def __init__(self):
+        super(SFTPServerWithoutSSH, self).__init__()
+        self._vendor = ssh.LoopbackVendor()
+
+    def _run_server(self, sock):
+        # Re-import these as locals, so that they're still accessible during
+        # interpreter shutdown (when all module globals get set to None, leading
+        # to confusing errors like "'NoneType' object has no attribute 'error'".
+        class FakeChannel(object):
+            def get_transport(self):
+                return self
+            def get_log_channel(self):
+                return 'paramiko'
+            def get_name(self):
+                return '1'
+            def get_hexdump(self):
+                return False
+            def close(self):
+                pass
+
+        server = paramiko.SFTPServer(
+            FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
+            root=self._root, home=self._server_homedir)
+        try:
+            server.start_subsystem(
+                'sftp', None, ssh.SocketAsChannelAdapter(sock))
+        except socket.error, e:
+            if (len(e.args) > 0) and (e.args[0] == errno.EPIPE):
+                # it's okay for the client to disconnect abruptly
+                # (bug in paramiko 1.6: it should absorb this exception)
+                pass
+            else:
+                raise
+        except Exception, e:
+            # This typically seems to happen during interpreter shutdown, so
+            # most of the useful ways to report this error are won't work.
+            # Writing the exception type, and then the text of the exception,
+            # seems to be the best we can do.
+            import sys
+            sys.stderr.write('\nEXCEPTION %r: ' % (e.__class__,))
+            sys.stderr.write('%s\n\n' % (e,))
+        server.finish_subsystem()
+
+
+class SFTPAbsoluteServer(SFTPServerWithoutSSH):
+    """A test server for sftp transports, using absolute urls."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        homedir = self._homedir
+        if sys.platform != 'win32':
+            # Remove the initial '/' on all platforms but win32
+            homedir = homedir[1:]
+        return self._get_sftp_url(urlutils.escape(homedir))
+
+
+class SFTPHomeDirServer(SFTPServerWithoutSSH):
+    """A test server for sftp transports, using homedir relative urls."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._get_sftp_url("~/")
+
+
+class SFTPSiblingAbsoluteServer(SFTPAbsoluteServer):
+    """A test server for sftp transports where only absolute paths will work.
+
+    It does this by serving from a deeply-nested directory that doesn't exist.
+    """
+
+    def start_server(self, backing_server=None):
+        self._server_homedir = '/dev/noone/runs/tests/here'
+        super(SFTPSiblingAbsoluteServer, self).start_server(backing_server)
+
 
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import stub_sftp
-    return [(SFTPTransport, stub_sftp.SFTPAbsoluteServer),
-            (SFTPTransport, stub_sftp.SFTPHomeDirServer),
-            (SFTPTransport, stub_sftp.SFTPSiblingAbsoluteServer),
+    return [(SFTPTransport, SFTPAbsoluteServer),
+            (SFTPTransport, SFTPHomeDirServer),
+            (SFTPTransport, SFTPSiblingAbsoluteServer),
             ]

=== modified file 'bzrlib/transport/ssh.py'
--- bzrlib/transport/ssh.py	2010-03-02 06:41:36 +0000
+++ bzrlib/transport/ssh.py	2009-11-25 07:27:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Robey Pointer <robey@lag.net>
+# Copyright (C) 2005 Robey Pointer <robey@lag.net>
 # Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
@@ -173,15 +173,12 @@
 register_ssh_vendor = _ssh_vendor_manager.register_vendor
 
 
-def _ignore_signals():
+def _ignore_sigint():
     # TODO: This should possibly ignore SIGHUP as well, but bzr currently
     # doesn't handle it itself.
     # <https://launchpad.net/products/bzr/+bug/41433/+index>
     import signal
     signal.signal(signal.SIGINT, signal.SIG_IGN)
-    # GZ 2010-02-19: Perhaps make this check if breakin is installed instead
-    if signal.getsignal(signal.SIGQUIT) != signal.SIG_DFL:
-        signal.signal(signal.SIGQUIT, signal.SIG_IGN)
 
 
 class SocketAsChannelAdapter(object):
@@ -637,7 +634,7 @@
         # Running it in a separate process group is not good because then it
         # can't get non-echoed input of a password or passphrase.
         # <https://launchpad.net/products/bzr/+bug/40508>
-        return {'preexec_fn': _ignore_signals,
+        return {'preexec_fn': _ignore_sigint,
                 'close_fds': True,
                 }
 

=== modified file 'bzrlib/transport/trace.py'
--- bzrlib/transport/trace.py	2010-02-09 20:33:43 +0000
+++ bzrlib/transport/trace.py	2009-07-02 03:48:56 +0000
@@ -20,10 +20,10 @@
 and then delegates it.
 """
 
-from bzrlib.transport import decorator
-
-
-class TransportTraceDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
+
+
+class TransportTraceDecorator(TransportDecorator):
     """A tracing decorator for Transports.
 
     Calls that potentially perform IO are logged to self._activity. The
@@ -43,7 +43,7 @@
 
         _decorated is a private parameter for cloning.
         """
-        super(TransportTraceDecorator, self).__init__(url, _decorated)
+        TransportDecorator.__init__(self, url, _decorated)
         if _from_transport is None:
             # newly created
             self._activity = []
@@ -169,7 +169,13 @@
         self._activity.append(operation_tuple)
 
 
+class TraceServer(DecoratorServer):
+    """Server for the TransportTraceDecorator for testing with."""
+
+    def get_decorator_class(self):
+        return TransportTraceDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(TransportTraceDecorator, test_server.TraceServer)]
+    return [(TransportTraceDecorator, TraceServer)]

=== modified file 'bzrlib/transport/unlistable.py'
--- bzrlib/transport/unlistable.py	2010-02-09 17:29:26 +0000
+++ bzrlib/transport/unlistable.py	2009-03-23 14:59:43 +0000
@@ -18,10 +18,10 @@
 
 import bzrlib.errors as errors
 from bzrlib.transport import Transport
-from bzrlib.transport import decorator
-
-
-class UnlistableTransportDecorator(decorator.TransportDecorator):
+from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
+
+
+class UnlistableTransportDecorator(TransportDecorator):
     """A transport that disables file listing for testing."""
 
     @classmethod
@@ -39,7 +39,14 @@
         Transport.list_dir(self, relpath)
 
 
+class UnlistableServer(DecoratorServer):
+    """Server for the UnlistableTransportDecorator for testing with."""
+
+    def get_decorator_class(self):
+        return UnlistableTransportDecorator
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests import test_server
-    return [(UnlistableTransportDecorator, test_server.UnlistableServer),]
+    return [(UnlistableTransportDecorator, UnlistableServer),
+            ]

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/tree.py	2009-11-27 23:21:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,6 +36,7 @@
 from bzrlib.inventory import InventoryFile
 from bzrlib.inter import InterObject
 from bzrlib.osutils import fingerprint_file
+import bzrlib.revision
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note
 
@@ -97,7 +98,6 @@
     def iter_changes(self, from_tree, include_unchanged=False,
                      specific_files=None, pb=None, extra_trees=None,
                      require_versioned=True, want_unversioned=False):
-        """See InterTree.iter_changes"""
         intertree = InterTree.get(from_tree, self)
         return intertree.iter_changes(include_unchanged, specific_files, pb,
             extra_trees, require_versioned, want_unversioned=want_unversioned)
@@ -404,34 +404,16 @@
             bit_iter = iter(path.split("/"))
             for elt in bit_iter:
                 lelt = elt.lower()
-                new_path = None
                 for child in self.iter_children(cur_id):
                     try:
-                        # XXX: it seem like if the child is known to be in the
-                        # tree, we shouldn't need to go from its id back to
-                        # its path -- mbp 2010-02-11
-                        #
-                        # XXX: it seems like we could be more efficient
-                        # by just directly looking up the original name and
-                        # only then searching all children; also by not
-                        # chopping paths so much. -- mbp 2010-02-11
                         child_base = os.path.basename(self.id2path(child))
-                        if (child_base == elt):
-                            # if we found an exact match, we can stop now; if
-                            # we found an approximate match we need to keep
-                            # searching because there might be an exact match
-                            # later.  
+                        if child_base.lower() == lelt:
                             cur_id = child
-                            new_path = osutils.pathjoin(cur_path, child_base)
+                            cur_path = osutils.pathjoin(cur_path, child_base)
                             break
-                        elif child_base.lower() == lelt:
-                            cur_id = child
-                            new_path = osutils.pathjoin(cur_path, child_base)
                     except NoSuchId:
                         # before a change is committed we can see this error...
                         continue
-                if new_path:
-                    cur_path = new_path
                 else:
                     # got to the end of this directory and no entries matched.
                     # Return what matched so far, plus the rest as specified.

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2010-03-25 07:34:15 +0000
+++ bzrlib/ui/__init__.py	2009-12-18 16:39:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -105,31 +105,10 @@
 
     This tells the library how to display things to the user.  Through this
     layer different applications can choose the style of UI.
-
-    :ivar suppressed_warnings: Identifiers for user warnings that should 
-        no be emitted.
     """
 
-    _user_warning_templates = dict(
-        cross_format_fetch=("Doing on-the-fly conversion from "
-            "%(from_format)s to %(to_format)s.\n"
-            "This may take some time. Upgrade the repositories to the "
-            "same format for better performance."
-            )
-        )
-
     def __init__(self):
         self._task_stack = []
-        self.suppressed_warnings = set()
-        self._quiet = False
-
-    def be_quiet(self, state):
-        """Tell the UI to be more quiet, or not.
-
-        Typically this suppresses progress bars; the application may also look
-        at ui_factory.is_quiet().
-        """
-        self._quiet = state
 
     def get_password(self, prompt='', **kwargs):
         """Prompt the user for a password.
@@ -146,9 +125,6 @@
         """
         raise NotImplementedError(self.get_password)
 
-    def is_quiet(self):
-        return self._quiet
-
     def make_output_stream(self, encoding=None, encoding_type=None):
         """Get a stream for sending out bulk text data.
 
@@ -195,11 +171,11 @@
         if not self._task_stack:
             warnings.warn("%r finished but nothing is active"
                 % (task,))
-        if task in self._task_stack:
-            self._task_stack.remove(task)
+        elif task != self._task_stack[-1]:
+            warnings.warn("%r is not the active task %r"
+                % (task, self._task_stack[-1]))
         else:
-            warnings.warn("%r is not in active stack %r"
-                % (task, self._task_stack))
+            del self._task_stack[-1]
         if not self._task_stack:
             self._progress_all_finished()
 
@@ -222,21 +198,6 @@
         """
         pass
 
-    def format_user_warning(self, warning_id, message_args):
-        try:
-            template = self._user_warning_templates[warning_id]
-        except KeyError:
-            fail = "failed to format warning %r, %r" % (warning_id, message_args)
-            warnings.warn(fail)   # so tests will fail etc
-            return fail
-        try:
-            return template % message_args
-        except ValueError, e:
-            fail = "failed to format warning %r, %r: %s" % (
-                warning_id, message_args, e)
-            warnings.warn(fail)   # so tests will fail etc
-            return fail
-
     def get_boolean(self, prompt):
         """Get a boolean question answered from the user.
 
@@ -267,11 +228,8 @@
     def recommend_upgrade(self,
         current_format_name,
         basedir):
-        # XXX: this should perhaps be in the TextUIFactory and the default can do
+        # this should perhaps be in the TextUIFactory and the default can do
         # nothing
-        #
-        # XXX: Change to show_user_warning - that will accomplish the previous
-        # xxx. -- mbp 2010-02-25
         trace.warning("%s is deprecated "
             "and a better format is available.\n"
             "It is recommended that you upgrade by "
@@ -301,29 +259,11 @@
         # Default implementation just does nothing
         pass
 
-    def show_user_warning(self, warning_id, **message_args):
-        """Show a warning to the user.
-
-        This is specifically for things that are under the user's control (eg
-        outdated formats), not for internal program warnings like deprecated
-        APIs.
-
-        This can be overridden by UIFactory subclasses to show it in some 
-        appropriate way; the default UIFactory is noninteractive and does
-        nothing.  format_user_warning maps it to a string, though other
-        presentations can be used for particular UIs.
-
-        :param warning_id: An identifier like 'cross_format_fetch' used to 
-            check if the message is suppressed and to look up the string.
-        :param message_args: Arguments to be interpolated into the message.
-        """
-        pass
-
     def show_error(self, msg):
         """Show an error message (not an exception) to the user.
         
         The message should not have an error prefix or trailing newline.  That
-        will be added by the factory if appropriate.
+        will be added by the factory if appropriate. 
         """
         raise NotImplementedError(self.show_error)
 
@@ -335,22 +275,6 @@
         """Show a warning to the user."""
         raise NotImplementedError(self.show_warning)
 
-    def warn_cross_format_fetch(self, from_format, to_format):
-        """Warn about a potentially slow cross-format transfer.
-        
-        This is deprecated in favor of show_user_warning, but retained for api
-        compatibility in 2.0 and 2.1.
-        """
-        self.show_user_warning('cross_format_fetch', from_format=from_format,
-            to_format=to_format)
-
-    def warn_experimental_format_fetch(self, inter):
-        """Warn about fetching into experimental repository formats."""
-        if inter.target._format.experimental:
-            trace.warning("Fetching into experimental format %s.\n"
-                "This format may be unreliable or change in the future "
-                "without an upgrade path.\n" % (inter.target._format,))
-
 
 
 class SilentUIFactory(UIFactory):
@@ -372,9 +296,6 @@
     def get_username(self, prompt, **kwargs):
         return None
 
-    def _make_output_stream_explicit(self, encoding, encoding_type):
-        return NullOutputStream(encoding)
-
     def show_error(self, msg):
         pass
 
@@ -440,19 +361,3 @@
 
     def log_transport_activity(self, display=False):
         pass
-
-
-class NullOutputStream(object):
-    """Acts like a file, but discard all output."""
-
-    def __init__(self, encoding):
-        self.encoding = encoding
-
-    def write(self, data):
-        pass
-
-    def writelines(self, data):
-        pass
-
-    def close(self):
-        pass

=== modified file 'bzrlib/ui/text.py'
--- bzrlib/ui/text.py	2010-03-25 07:34:15 +0000
+++ bzrlib/ui/text.py	2010-01-05 04:30:07 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -37,8 +37,6 @@
 
 """)
 
-from bzrlib.osutils import watch_sigwinch
-
 from bzrlib.ui import (
     UIFactory,
     NullProgressView,
@@ -62,15 +60,7 @@
         self.stderr = stderr
         # paints progress, network activity, etc
         self._progress_view = self.make_progress_view()
-        # hook up the signals to watch for terminal size changes
-        watch_sigwinch()
-
-    def be_quiet(self, state):
-        if state and not self._quiet:
-            self.clear_term()
-        UIFactory.be_quiet(self, state)
-        self._progress_view = self.make_progress_view()
-
+        
     def clear_term(self):
         """Prepare the terminal for output.
 
@@ -156,13 +146,9 @@
     def make_progress_view(self):
         """Construct and return a new ProgressView subclass for this UI.
         """
-        # with --quiet, never any progress view
-        # <https://bugs.edge.launchpad.net/bzr/+bug/320035>.  Otherwise if the
-        # user specifically requests either text or no progress bars, always
-        # do that.  otherwise, guess based on $TERM and tty presence.
-        if self.is_quiet():
-            return NullProgressView()
-        elif os.environ.get('BZR_PROGRESS_BAR') == 'text':
+        # if the user specifically requests either text or no progress bars,
+        # always do that.  otherwise, guess based on $TERM and tty presence.
+        if os.environ.get('BZR_PROGRESS_BAR') == 'text':
             return TextProgressView(self.stderr)
         elif os.environ.get('BZR_PROGRESS_BAR') == 'none':
             return NullProgressView()
@@ -242,29 +228,13 @@
             warnings.warn("%r updated but no tasks are active" %
                 (task,))
         elif task != self._task_stack[-1]:
-            # We used to check it was the top task, but it's hard to always
-            # get this right and it's not necessarily useful: any actual
-            # problems will be evident in use
-            #warnings.warn("%r is not the top progress task %r" %
-            #     (task, self._task_stack[-1]))
-            pass
+            warnings.warn("%r is not the top progress task %r" %
+                (task, self._task_stack[-1]))
         self._progress_view.show_progress(task)
 
     def _progress_all_finished(self):
         self._progress_view.clear()
 
-    def show_user_warning(self, warning_id, **message_args):
-        """Show a text message to the user.
-
-        Explicitly not for warnings about bzr apis, deprecations or internals.
-        """
-        # eventually trace.warning should migrate here, to avoid logging and
-        # be easier to test; that has a lot of test fallout so for now just
-        # new code can call this
-        if warning_id not in self.suppressed_warnings:
-            self.stderr.write(self.format_user_warning(warning_id, message_args) +
-                '\n')
-
 
 class TextProgressView(object):
     """Display of progress bar and other information on a tty.
@@ -437,11 +407,9 @@
         elif now >= (self._transport_update_time + 0.5):
             # guard against clock stepping backwards, and don't update too
             # often
-            rate = (self._bytes_since_update
-                    / (now - self._transport_update_time))
-            # using base-10 units (see HACKING.txt).
-            msg = ("%6dkB %5dkB/s" %
-                    (self._total_byte_count / 1000, int(rate) / 1000,))
+            rate = self._bytes_since_update / (now - self._transport_update_time)
+            msg = ("%6dKB %5dKB/s" %
+                    (self._total_byte_count>>10, int(rate)>>10,))
             self._transport_update_time = now
             self._last_repaint = now
             self._bytes_since_update = 0
@@ -457,17 +425,16 @@
                 transfer_time = 0.001
             bps = self._total_byte_count / transfer_time
 
-        # using base-10 units (see HACKING.txt).
-        msg = ('Transferred: %.0fkB'
-               ' (%.1fkB/s r:%.0fkB w:%.0fkB'
-               % (self._total_byte_count / 1000.,
-                  bps / 1000.,
-                  self._bytes_by_direction['read'] / 1000.,
-                  self._bytes_by_direction['write'] / 1000.,
+        msg = ('Transferred: %.0fKiB'
+               ' (%.1fK/s r:%.0fK w:%.0fK'
+               % (self._total_byte_count / 1024.,
+                  bps / 1024.,
+                  self._bytes_by_direction['read'] / 1024.,
+                  self._bytes_by_direction['write'] / 1024.,
                  ))
         if self._bytes_by_direction['unknown'] > 0:
-            msg += ' u:%.0fkB)' % (
-                self._bytes_by_direction['unknown'] / 1000.
+            msg += ' u:%.0fK)' % (
+                self._bytes_by_direction['unknown'] / 1024.
                 )
         else:
             msg += ')'

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2010-04-30 11:03:59 +0000
+++ bzrlib/uncommit.py	2009-03-23 14:59:43 +0000
@@ -18,6 +18,8 @@
 
 # TODO: make the guts of this methods on tree, branch.
 
+import os
+
 from bzrlib import (
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2010-04-21 11:27:04 +0000
+++ bzrlib/upgrade.py	2009-06-23 09:17:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,9 +17,10 @@
 """bzr upgrade logic."""
 
 
-from bzrlib.bzrdir import BzrDir, format_registry
+from bzrlib.bzrdir import BzrDir, BzrDirFormat, format_registry
 import bzrlib.errors as errors
 from bzrlib.remote import RemoteBzrDir
+from bzrlib.transport import get_transport
 import bzrlib.ui as ui
 
 
@@ -28,29 +29,26 @@
     def __init__(self, url, format=None):
         self.format = format
         self.bzrdir = BzrDir.open_unsupported(url)
-        # XXX: Change to cleanup
-        warning_id = 'cross_format_fetch'
-        saved_warning = warning_id in ui.ui_factory.suppressed_warnings
         if isinstance(self.bzrdir, RemoteBzrDir):
             self.bzrdir._ensure_real()
             self.bzrdir = self.bzrdir._real_bzrdir
         if self.bzrdir.root_transport.is_readonly():
             raise errors.UpgradeReadonly
         self.transport = self.bzrdir.root_transport
-        ui.ui_factory.suppressed_warnings.add(warning_id)
+        self.pb = ui.ui_factory.nested_progress_bar()
         try:
             self.convert()
         finally:
-            if not saved_warning:
-                ui.ui_factory.suppressed_warnings.remove(warning_id)
+            self.pb.finished()
 
     def convert(self):
         try:
             branch = self.bzrdir.open_branch()
-            if branch.user_url != self.bzrdir.user_url:
+            if branch.bzrdir.root_transport.base != \
+                self.bzrdir.root_transport.base:
                 ui.ui_factory.note("This is a checkout. The branch (%s) needs to be "
                              "upgraded separately." %
-                             branch.user_url)
+                             branch.bzrdir.root_transport.base)
             del branch
         except (errors.NotBranchError, errors.IncompatibleRepositories):
             # might not be a format we can open without upgrading; see e.g.
@@ -79,7 +77,7 @@
         self.bzrdir.backup_bzrdir()
         while self.bzrdir.needs_format_conversion(format):
             converter = self.bzrdir._format.get_converter(format)
-            self.bzrdir = converter.convert(self.bzrdir, None)
+            self.bzrdir = converter.convert(self.bzrdir, self.pb)
         ui.ui_factory.note("finished")
 
 

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2010-02-17 17:11:16 +0000
+++ bzrlib/urlutils.py	2009-11-26 04:01:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2010-04-30 11:03:59 +0000
+++ bzrlib/version.py	2009-12-10 00:13:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
     osutils,
     trace,
     )
+from bzrlib.branch import Branch
 
 
 def show_version(show_config=True, show_copyright=True, to_file=None):
@@ -82,7 +83,7 @@
     if show_copyright:
         to_file.write('\n')
         to_file.write(bzrlib.__copyright__ + '\n')
-        to_file.write("http://bazaar.canonical.com/\n")
+        to_file.write("http://bazaar-vcs.org/\n")
         to_file.write('\n')
         to_file.write("bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and\n")
         to_file.write("you may use, modify and redistribute it under the terms of the GNU\n")

=== modified file 'bzrlib/version_info_formats/format_rio.py'
--- bzrlib/version_info_formats/format_rio.py	2010-02-17 17:11:16 +0000
+++ bzrlib/version_info_formats/format_rio.py	2009-11-03 09:32:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2009, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/versionedfile.py	2009-12-10 17:16:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # Authors:
 #   Johan Rydberg <jrydberg@gnu.org>
@@ -45,6 +45,7 @@
 from bzrlib.graph import DictParentsProvider, Graph, StackedParentsProvider
 from bzrlib.transport.memory import MemoryTransport
 """)
+from bzrlib.inter import InterObject
 from bzrlib.registry import Registry
 from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2010-04-30 11:03:59 +0000
+++ bzrlib/weave.py	2009-06-10 03:56:49 +0000
@@ -69,6 +69,8 @@
 from copy import copy
 from cStringIO import StringIO
 import os
+import time
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -77,11 +79,14 @@
 from bzrlib import (
     errors,
     osutils,
+    progress,
     )
 from bzrlib.errors import (WeaveError, WeaveFormatError, WeaveParentMismatch,
         RevisionAlreadyPresent,
         RevisionNotPresent,
         UnavailableRepresentation,
+        WeaveRevisionAlreadyPresent,
+        WeaveRevisionNotPresent,
         )
 from bzrlib.osutils import dirname, sha, sha_strings, split_lines
 import bzrlib.patiencediff

=== added file 'bzrlib/weave_commands.py'
--- bzrlib/weave_commands.py	1970-01-01 00:00:00 +0000
+++ bzrlib/weave_commands.py	2009-03-23 14:59:43 +0000
@@ -0,0 +1,74 @@
+# Copyright (C) 2006 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""builtin bzr commands relating to individual weave files
+
+These should never normally need to be used by end users, but might be
+of interest in debugging or data recovery.
+"""
+
+import sys
+
+from bzrlib.commands import Command
+from bzrlib.trace import warning
+
+class cmd_versionedfile_list(Command):
+    """List the revision ids present in a versionedfile, alphabetically"""
+
+    hidden = True
+    takes_args = ['filename']
+    aliases = ['weave-list']
+
+    def run(self, filename):
+        from bzrlib.weavefile import read_weave
+        from bzrlib.transport import get_transport
+        from bzrlib import osutils
+        vf = read_weave(file(filename, 'rb'))
+        names = vf.versions()
+        names.sort()
+        print '\n'.join(names)
+
+
+class cmd_weave_plan_merge(Command):
+    """Show the plan for merging two versions within a weave"""
+    hidden = True
+    takes_args = ['weave_file', 'revision_a', 'revision_b']
+
+    def run(self, weave_file, revision_a, revision_b):
+        from bzrlib.weavefile import read_weave
+        w = read_weave(file(weave_file, 'rb'))
+        for state, line in w.plan_merge(revision_a, revision_b):
+            # make sure to print every line with a newline, even if it doesn't
+            # really have one
+            if not line:
+                continue
+            if line[-1] != '\n':
+                state += '!eol'
+                line += '\n'
+            if '\n' in line[:-1]:
+                warning("line in weave contains embedded newline: %r" % line)
+            print '%15s | %s' % (state, line),
+
+class cmd_weave_merge_text(Command):
+    """Debugging command to merge two texts of a weave"""
+    hidden = True
+    takes_args = ['weave_file', 'revision_a', 'revision_b']
+
+    def run(self, weave_file, revision_a, revision_b):
+        from bzrlib.weavefile import read_weave
+        w = read_weave(file(weave_file, 'rb'))
+        p = w.plan_merge(revision_a, revision_b)
+        sys.stdout.writelines(w.weave_merge(p))

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2010-04-30 11:03:59 +0000
+++ bzrlib/win32utils.py	2009-12-16 06:38:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,10 +21,10 @@
 
 import glob
 import os
+import re
 import struct
 import sys
 
-from bzrlib import cmdline
 
 # Windows version
 if sys.platform == 'win32':
@@ -135,8 +135,7 @@
                 'WorkingSetSize': mem_struct.WorkingSetSize,
                 'QuotaPeakPagedPoolUsage': mem_struct.QuotaPeakPagedPoolUsage,
                 'QuotaPagedPoolUsage': mem_struct.QuotaPagedPoolUsage,
-                'QuotaPeakNonPagedPoolUsage':
-                    mem_struct.QuotaPeakNonPagedPoolUsage,
+                'QuotaPeakNonPagedPoolUsage': mem_struct.QuotaPeakNonPagedPoolUsage,
                 'QuotaNonPagedPoolUsage': mem_struct.QuotaNonPagedPoolUsage,
                 'PagefileUsage': mem_struct.PagefileUsage,
                 'PeakPagefileUsage': mem_struct.PeakPagefileUsage,
@@ -153,21 +152,19 @@
                    ' or win32process')
         return
     if short:
-        # using base-2 units (see HACKING.txt).
-        trace.note('WorkingSize %7dKiB'
-                   '\tPeakWorking %7dKiB\t%s',
+        trace.note('WorkingSize %7dKB'
+                   '\tPeakWorking %7dKB\t%s',
                    info['WorkingSetSize'] / 1024,
                    info['PeakWorkingSetSize'] / 1024,
                    message)
         return
     if message:
         trace.note('%s', message)
-    trace.note('WorkingSize       %8d KiB', info['WorkingSetSize'] / 1024)
-    trace.note('PeakWorking       %8d KiB', info['PeakWorkingSetSize'] / 1024)
-    trace.note('PagefileUsage     %8d KiB', info.get('PagefileUsage', 0) / 1024)
-    trace.note('PeakPagefileUsage %8d KiB',
-               info.get('PeakPagefileUsage', 0) / 1024)
-    trace.note('PrivateUsage      %8d KiB', info.get('PrivateUsage', 0) / 1024)
+    trace.note('WorkingSize       %8d KB', info['WorkingSetSize'] / 1024)
+    trace.note('PeakWorking       %8d KB', info['PeakWorkingSetSize'] / 1024)
+    trace.note('PagefileUsage     %8d KB', info.get('PagefileUsage', 0) / 1024)
+    trace.note('PeakPagefileUsage %8d KB', info.get('PeakPagefileUsage', 0) / 1024)
+    trace.note('PrivateUsage      %8d KB', info.get('PrivateUsage', 0) / 1024)
     trace.note('PageFaultCount    %8d', info.get('PageFaultCount', 0))
 
 
@@ -190,8 +187,7 @@
 
     if res:
         (bufx, bufy, curx, cury, wattr,
-        left, top, right, bottom, maxx, maxy) = struct.unpack(
-            "hhhhHhhhhhh", csbi.raw)
+        left, top, right, bottom, maxx, maxy) = struct.unpack("hhhhHhhhhhh", csbi.raw)
         sizex = right - left + 1
         sizey = bottom - top + 1
         return (sizex, sizey)
@@ -414,8 +410,7 @@
 
 
 def _ensure_with_dir(path):
-    if (not os.path.split(path)[0] or path.startswith(u'*')
-        or path.startswith(u'?')):
+    if not os.path.split(path)[0] or path.startswith(u'*') or path.startswith(u'?'):
         return u'./' + path, True
     else:
         return path, False
@@ -522,21 +517,112 @@
             trace.mutter('Unable to set hidden attribute on %r: %s', path, e)
 
 
-def _command_line_to_argv(command_line, single_quotes_allowed=False):
-    """Convert a Unicode command line into a list of argv arguments.
-
-    It performs wildcard expansion to make wildcards act closer to how they
-    work in posix shells, versus how they work by default on Windows. Quoted
-    arguments are left untouched.
-
-    :param command_line: The unicode string to split into an arg list.
-    :param single_quotes_allowed: Whether single quotes are accepted as quoting
-                                  characters like double quotes. False by
-                                  default.
-    :return: A list of unicode strings.
-    """
-    s = cmdline.Splitter(command_line, single_quotes_allowed=single_quotes_allowed)
-    # Now that we've split the content, expand globs if necessary
+
+class UnicodeShlex(object):
+    """This is a very simplified version of shlex.shlex.
+
+    The main change is that it supports non-ascii input streams. The internal
+    structure is quite simplified relative to shlex.shlex, since we aren't
+    trying to handle multiple input streams, etc. In fact, we don't use a
+    file-like api either.
+    """
+
+    def __init__(self, uni_string):
+        self._input = uni_string
+        self._input_iter = iter(self._input)
+        self._whitespace_match = re.compile(u'\s').match
+        self._word_match = re.compile(u'\S').match
+        self._quote_chars = u'"'
+        # self._quote_match = re.compile(u'[\'"]').match
+        self._escape_match = lambda x: None # Never matches
+        self._escape = '\\'
+        # State can be
+        #   ' ' - after whitespace, starting a new token
+        #   'a' - after text, currently working on a token
+        #   '"' - after ", currently in a "-delimited quoted section
+        #   "\" - after '\', checking the next char
+        self._state = ' '
+        self._token = [] # Current token being parsed
+
+    def _get_token(self):
+        # Were there quote chars as part of this token?
+        quoted = False
+        quoted_state = None
+        for nextchar in self._input_iter:
+            if self._state == ' ':
+                if self._whitespace_match(nextchar):
+                    # if self._token: return token
+                    continue
+                elif nextchar in self._quote_chars:
+                    self._state = nextchar # quoted state
+                elif self._word_match(nextchar):
+                    self._token.append(nextchar)
+                    self._state = 'a'
+                else:
+                    raise AssertionError('wtttf?')
+            elif self._state in self._quote_chars:
+                quoted = True
+                if nextchar == self._state: # End of quote
+                    self._state = 'a' # posix allows 'foo'bar to translate to
+                                      # foobar
+                elif self._state == '"' and nextchar == self._escape:
+                    quoted_state = self._state
+                    self._state = nextchar
+                else:
+                    self._token.append(nextchar)
+            elif self._state == self._escape:
+                if nextchar == '\\':
+                    self._token.append('\\')
+                elif nextchar == '"':
+                    self._token.append(nextchar)
+                else:
+                    self._token.append('\\' + nextchar)
+                self._state = quoted_state
+            elif self._state == 'a':
+                if self._whitespace_match(nextchar):
+                    if self._token:
+                        break # emit this token
+                    else:
+                        continue # no token to emit
+                elif nextchar in self._quote_chars:
+                    # Start a new quoted section
+                    self._state = nextchar
+                # escape?
+                elif (self._word_match(nextchar)
+                      or nextchar in self._quote_chars
+                      # or whitespace_split?
+                      ):
+                    self._token.append(nextchar)
+                else:
+                    raise AssertionError('state == "a", char: %r'
+                                         % (nextchar,))
+            else:
+                raise AssertionError('unknown state: %r' % (self._state,))
+        result = ''.join(self._token)
+        self._token = []
+        if not quoted and result == '':
+            result = None
+        return quoted, result
+
+    def __iter__(self):
+        return self
+
+    def next(self):
+        quoted, token = self._get_token()
+        if token is None:
+            raise StopIteration
+        return quoted, token
+
+
+def _command_line_to_argv(command_line):
+    """Convert a Unicode command line into a set of argv arguments.
+
+    This does wildcard expansion, etc. It is intended to make wildcards act
+    closer to how they work in posix shells, versus how they work by default on
+    Windows.
+    """
+    s = UnicodeShlex(command_line)
+    # Now that we've split the content, expand globs
     # TODO: Use 'globbing' instead of 'glob.glob', this gives us stuff like
     #       '**/' style globs
     args = []
@@ -550,12 +636,14 @@
 
 if has_ctypes and winver != 'Windows 98':
     def get_unicode_argv():
-        prototype = ctypes.WINFUNCTYPE(ctypes.c_wchar_p)
-        GetCommandLineW = prototype(("GetCommandLineW",
-                                     ctypes.windll.kernel32))
-        command_line = GetCommandLineW()
-        if command_line is None:
-            raise ctypes.WinError()
+        LPCWSTR = ctypes.c_wchar_p
+        INT = ctypes.c_int
+        POINTER = ctypes.POINTER
+        prototype = ctypes.WINFUNCTYPE(LPCWSTR)
+        GetCommandLine = prototype(("GetCommandLineW",
+                                    ctypes.windll.kernel32))
+        prototype = ctypes.WINFUNCTYPE(POINTER(LPCWSTR), LPCWSTR, POINTER(INT))
+        command_line = GetCommandLine()
         # Skip the first argument, since we only care about parameters
         argv = _command_line_to_argv(command_line)[1:]
         if getattr(sys, 'frozen', None) is None:

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-04-30 11:35:43 +0000
+++ bzrlib/workingtree.py	2009-12-22 05:24:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,6 +29,12 @@
 WorkingTree.open(dir).
 """
 
+# TODO: Give the workingtree sole responsibility for the working inventory;
+# remove the variable and references to it from the branch.  This may require
+# updating the commit code so as to update the inventory within the working
+# copy, and making sure there's only one WorkingTree for any directory on disk.
+# At the moment they may alias the inventory and have old copies of it in
+# memory.  (Now done? -- mbp 20060309)
 
 from cStringIO import StringIO
 import os
@@ -95,6 +101,7 @@
 from bzrlib.filters import filtered_input_file
 from bzrlib.trace import mutter, note
 from bzrlib.transport.local import LocalTransport
+from bzrlib.progress import DummyProgress, ProgressPhase
 from bzrlib.revision import CURRENT_REVISION
 from bzrlib.rio import RioReader, rio_file, Stanza
 from bzrlib.symbol_versioning import (
@@ -104,9 +111,6 @@
 
 
 MERGE_MODIFIED_HEADER_1 = "BZR merge-modified list format 1"
-# TODO: Modifying the conflict objects or their type is currently nearly
-# impossible as there is no clear relationship between the working tree format
-# and the conflict list file format.
 CONFLICT_HEADER_1 = "BZR conflict list format 1"
 
 ERROR_PATH_NOT_FOUND = 3    # WindowsError errno code, equivalent to ENOENT
@@ -167,8 +171,7 @@
         return ''
 
 
-class WorkingTree(bzrlib.mutabletree.MutableTree,
-    bzrdir.ControlComponent):
+class WorkingTree(bzrlib.mutabletree.MutableTree):
     """Working copy tree.
 
     The inventory is held in the `Branch` working-inventory, and the
@@ -247,14 +250,6 @@
         self._rules_searcher = None
         self.views = self._make_views()
 
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
-    @property
-    def control_transport(self):
-        return self._transport
-
     def _detect_case_handling(self):
         wt_trans = self.bzrdir.get_workingtree_transport(None)
         try:
@@ -914,36 +909,43 @@
             branch.last_revision().
         """
         from bzrlib.merge import Merger, Merge3Merger
-        merger = Merger(self.branch, this_tree=self)
-        # check that there are no local alterations
-        if not force and self.has_changes():
-            raise errors.UncommittedChanges(self)
-        if to_revision is None:
-            to_revision = _mod_revision.ensure_null(branch.last_revision())
-        merger.other_rev_id = to_revision
-        if _mod_revision.is_null(merger.other_rev_id):
-            raise errors.NoCommits(branch)
-        self.branch.fetch(branch, last_revision=merger.other_rev_id)
-        merger.other_basis = merger.other_rev_id
-        merger.other_tree = self.branch.repository.revision_tree(
-            merger.other_rev_id)
-        merger.other_branch = branch
-        if from_revision is None:
-            merger.find_base()
-        else:
-            merger.set_base_revision(from_revision, branch)
-        if merger.base_rev_id == merger.other_rev_id:
-            raise errors.PointlessMerge
-        merger.backup_files = False
-        if merge_type is None:
-            merger.merge_type = Merge3Merger
-        else:
-            merger.merge_type = merge_type
-        merger.set_interesting_files(None)
-        merger.show_base = False
-        merger.reprocess = False
-        conflicts = merger.do_merge()
-        merger.set_pending()
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            merger = Merger(self.branch, this_tree=self, pb=pb)
+            merger.pp = ProgressPhase("Merge phase", 5, pb)
+            merger.pp.next_phase()
+            # check that there are no local alterations
+            if not force and self.has_changes():
+                raise errors.UncommittedChanges(self)
+            if to_revision is None:
+                to_revision = _mod_revision.ensure_null(branch.last_revision())
+            merger.other_rev_id = to_revision
+            if _mod_revision.is_null(merger.other_rev_id):
+                raise errors.NoCommits(branch)
+            self.branch.fetch(branch, last_revision=merger.other_rev_id)
+            merger.other_basis = merger.other_rev_id
+            merger.other_tree = self.branch.repository.revision_tree(
+                merger.other_rev_id)
+            merger.other_branch = branch
+            merger.pp.next_phase()
+            if from_revision is None:
+                merger.find_base()
+            else:
+                merger.set_base_revision(from_revision, branch)
+            if merger.base_rev_id == merger.other_rev_id:
+                raise errors.PointlessMerge
+            merger.backup_files = False
+            if merge_type is None:
+                merger.merge_type = Merge3Merger
+            else:
+                merger.merge_type = merge_type
+            merger.set_interesting_files(None)
+            merger.show_base = False
+            merger.reprocess = False
+            conflicts = merger.do_merge()
+            merger.set_pending()
+        finally:
+            pb.finished()
         return conflicts
 
     @needs_read_lock
@@ -1096,8 +1098,7 @@
         tree_transport = self.bzrdir.root_transport.clone(sub_path)
         if tree_transport.base != branch_transport.base:
             tree_bzrdir = format.initialize_on_transport(tree_transport)
-            branch.BranchReferenceFormat().initialize(tree_bzrdir,
-                target_branch=new_branch)
+            branch.BranchReferenceFormat().initialize(tree_bzrdir, new_branch)
         else:
             tree_bzrdir = branch_bzrdir
         wt = tree_bzrdir.create_workingtree(_mod_revision.NULL_REVISION)
@@ -1141,7 +1142,7 @@
         This does not include files that have been deleted in this
         tree. Skips the control directory.
 
-        :param include_root: if True, return an entry for the root
+        :param include_root: if True, do not return an entry for the root
         :param from_dir: start from this directory or None for the root
         :param recursive: whether to recurse into subdirectories or not
         """
@@ -1601,8 +1602,11 @@
     @needs_write_lock
     def pull(self, source, overwrite=False, stop_revision=None,
              change_reporter=None, possible_transports=None, local=False):
+        top_pb = ui.ui_factory.nested_progress_bar()
         source.lock_read()
         try:
+            pp = ProgressPhase("Pull phase", 2, top_pb)
+            pp.next_phase()
             old_revision_info = self.branch.last_revision_info()
             basis_tree = self.basis_tree()
             count = self.branch.pull(source, overwrite, stop_revision,
@@ -1610,7 +1614,9 @@
                                      local=local)
             new_revision_info = self.branch.last_revision_info()
             if new_revision_info != old_revision_info:
+                pp.next_phase()
                 repository = self.branch.repository
+                pb = ui.ui_factory.nested_progress_bar()
                 basis_tree.lock_read()
                 try:
                     new_basis_tree = self.branch.basis_tree()
@@ -1619,13 +1625,13 @@
                                 new_basis_tree,
                                 basis_tree,
                                 this_tree=self,
-                                pb=None,
+                                pb=pb,
                                 change_reporter=change_reporter)
-                    basis_root_id = basis_tree.get_root_id()
-                    new_root_id = new_basis_tree.get_root_id()
-                    if basis_root_id != new_root_id:
-                        self.set_root_id(new_root_id)
+                    if (basis_tree.inventory.root is None and
+                        new_basis_tree.inventory.root is not None):
+                        self.set_root_id(new_basis_tree.get_root_id())
                 finally:
+                    pb.finished()
                     basis_tree.unlock()
                 # TODO - dedup parents list with things merged by pull ?
                 # reuse the revisiontree we merged against to set the new
@@ -1644,6 +1650,7 @@
             return count
         finally:
             source.unlock()
+            top_pb.finished()
 
     @needs_write_lock
     def put_file_bytes_non_atomic(self, file_id, bytes):
@@ -1734,15 +1741,13 @@
         r"""Check whether the filename matches an ignore pattern.
 
         Patterns containing '/' or '\' need to match the whole path;
-        others match against only the last component.  Patterns starting
-        with '!' are ignore exceptions.  Exceptions take precedence
-        over regular patterns and cause the filename to not be ignored.
+        others match against only the last component.
 
         If the file is ignored, returns the pattern which caused it to
         be ignored, otherwise None.  So this can simply be used as a
         boolean if desired."""
         if getattr(self, '_ignoreglobster', None) is None:
-            self._ignoreglobster = globbing.ExceptionGlobster(self.get_ignore_list())
+            self._ignoreglobster = globbing.Globster(self.get_ignore_list())
         return self._ignoreglobster.match(filename)
 
     def kind(self, file_id):
@@ -1896,7 +1901,7 @@
             # revision_id is set. We must check for this full string, because a
             # root node id can legitimately look like 'revision_id' but cannot
             # contain a '"'.
-            xml = self.branch.repository._get_inventory_xml(new_revision)
+            xml = self.branch.repository.get_inventory_xml(new_revision)
             firstline = xml.split('\n', 1)[0]
             if (not 'revision_id="' in firstline or
                 'format="7"' not in firstline):
@@ -2058,7 +2063,7 @@
 
     @needs_tree_write_lock
     def revert(self, filenames=None, old_tree=None, backups=True,
-               pb=None, report_changes=False):
+               pb=DummyProgress(), report_changes=False):
         from bzrlib.conflicts import resolve
         if filenames == []:
             filenames = None
@@ -2253,55 +2258,34 @@
         # We MUST save it even if an error occurs, because otherwise the users
         # local work is unreferenced and will appear to have been lost.
         #
-        nb_conflicts = 0
+        result = 0
         try:
             last_rev = self.get_parent_ids()[0]
         except IndexError:
             last_rev = _mod_revision.NULL_REVISION
         if revision is None:
             revision = self.branch.last_revision()
-
-        old_tip = old_tip or _mod_revision.NULL_REVISION
-
-        if not _mod_revision.is_null(old_tip) and old_tip != last_rev:
-            # the branch we are bound to was updated
-            # merge those changes in first
-            base_tree  = self.basis_tree()
-            other_tree = self.branch.repository.revision_tree(old_tip)
-            nb_conflicts = merge.merge_inner(self.branch, other_tree,
-                                             base_tree, this_tree=self,
-                                             change_reporter=change_reporter)
-            if nb_conflicts:
-                self.add_parent_tree((old_tip, other_tree))
-                trace.note('Rerun update after fixing the conflicts.')
-                return nb_conflicts
-
+        else:
+            if revision not in self.branch.revision_history():
+                raise errors.NoSuchRevision(self.branch, revision)
         if last_rev != _mod_revision.ensure_null(revision):
-            # the working tree is up to date with the branch
-            # we can merge the specified revision from master
-            to_tree = self.branch.repository.revision_tree(revision)
-            to_root_id = to_tree.get_root_id()
-
+            # merge tree state up to specified revision.
             basis = self.basis_tree()
             basis.lock_read()
             try:
-                if (basis.inventory.root is None
-                    or basis.inventory.root.file_id != to_root_id):
-                    self.set_root_id(to_root_id)
+                to_tree = self.branch.repository.revision_tree(revision)
+                if basis.inventory.root is None:
+                    self.set_root_id(to_tree.get_root_id())
                     self.flush()
+                result += merge.merge_inner(
+                                      self.branch,
+                                      to_tree,
+                                      basis,
+                                      this_tree=self,
+                                      change_reporter=change_reporter)
+                self.set_last_revision(revision)
             finally:
                 basis.unlock()
-
-            # determine the branch point
-            graph = self.branch.repository.get_graph()
-            base_rev_id = graph.find_unique_lca(self.branch.last_revision(),
-                                                last_rev)
-            base_tree = self.branch.repository.revision_tree(base_rev_id)
-
-            nb_conflicts = merge.merge_inner(self.branch, to_tree, base_tree,
-                                             this_tree=self,
-                                             change_reporter=change_reporter)
-            self.set_last_revision(revision)
             # TODO - dedup parents list with things merged by pull ?
             # reuse the tree we've updated to to set the basis:
             parent_trees = [(revision, to_tree)]
@@ -2314,12 +2298,42 @@
             for parent in merges:
                 parent_trees.append(
                     (parent, self.branch.repository.revision_tree(parent)))
-            if not _mod_revision.is_null(old_tip):
+            if (old_tip is not None and not _mod_revision.is_null(old_tip)):
                 parent_trees.append(
                     (old_tip, self.branch.repository.revision_tree(old_tip)))
             self.set_parent_trees(parent_trees)
             last_rev = parent_trees[0][0]
-        return nb_conflicts
+        else:
+            # the working tree had the same last-revision as the master
+            # branch did. We may still have pivot local work from the local
+            # branch into old_tip:
+            if (old_tip is not None and not _mod_revision.is_null(old_tip)):
+                self.add_parent_tree_id(old_tip)
+        if (old_tip is not None and not _mod_revision.is_null(old_tip)
+            and old_tip != last_rev):
+            # our last revision was not the prior branch last revision
+            # and we have converted that last revision to a pending merge.
+            # base is somewhere between the branch tip now
+            # and the now pending merge
+
+            # Since we just modified the working tree and inventory, flush out
+            # the current state, before we modify it again.
+            # TODO: jam 20070214 WorkingTree3 doesn't require this, dirstate
+            #       requires it only because TreeTransform directly munges the
+            #       inventory and calls tree._write_inventory(). Ultimately we
+            #       should be able to remove this extra flush.
+            self.flush()
+            graph = self.branch.repository.get_graph()
+            base_rev_id = graph.find_unique_lca(revision, old_tip)
+            base_tree = self.branch.repository.revision_tree(base_rev_id)
+            other_tree = self.branch.repository.revision_tree(old_tip)
+            result += merge.merge_inner(
+                                  self.branch,
+                                  other_tree,
+                                  base_tree,
+                                  this_tree=self,
+                                  change_reporter=change_reporter)
+        return result
 
     def _write_hashcache_if_dirty(self):
         """Write out the hashcache if it is dirty."""

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/workingtree_4.py	2009-12-22 17:05:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -53,6 +53,7 @@
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.filters import filtered_input_file, internal_size_sha_file_byname
 from bzrlib.inventory import Inventory, ROOT_ID, entry_factory
+import bzrlib.mutabletree
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.osutils import (
     file_kind,
@@ -1371,7 +1372,6 @@
 
 
 class DirStateWorkingTreeFormat(WorkingTreeFormat3):
-
     def initialize(self, a_bzrdir, revision_id=None, from_branch=None,
                    accelerator_tree=None, hardlink=False):
         """See WorkingTreeFormat.initialize().
@@ -1755,11 +1755,7 @@
             return None
         parent_index = self._get_parent_index()
         last_changed_revision = entry[1][parent_index][4]
-        try:
-            rev = self._repository.get_revision(last_changed_revision)
-        except errors.NoSuchRevision:
-            raise errors.FileTimestampUnavailable(self.id2path(file_id))
-        return rev.timestamp
+        return self._repository.get_revision(last_changed_revision).timestamp
 
     def get_file_sha1(self, file_id, path=None, stat_value=None):
         entry = self._get_entry(file_id=file_id, path=path)
@@ -1832,8 +1828,7 @@
         entry = self._get_entry(file_id=file_id)[1]
         if entry is None:
             raise errors.NoSuchId(tree=self, file_id=file_id)
-        parent_index = self._get_parent_index()
-        return dirstate.DirState._minikind_to_kind[entry[parent_index][0]]
+        return dirstate.DirState._minikind_to_kind[entry[1][0]]
 
     def stored_kind(self, file_id):
         """See Tree.stored_kind"""

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml4.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,11 +16,12 @@
 
 from bzrlib.xml_serializer import (
     Element,
+    ElementTree,
     SubElement,
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import ROOT_ID, Inventory
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2010-02-17 17:11:16 +0000
+++ bzrlib/xml5.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/xml7.py'
--- bzrlib/xml7.py	2010-02-17 17:11:16 +0000
+++ bzrlib/xml7.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2010 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/xml8.py'
--- bzrlib/xml8.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml8.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,7 +30,7 @@
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import InventoryEntry
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError
 

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml_serializer.py	2009-12-03 04:55:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005-2010 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,7 +23,7 @@
 # ElementTree bits
 
 from bzrlib.serializer import Serializer
-from bzrlib.trace import mutter
+from bzrlib.trace import mutter, warning
 
 try:
     try:

=== added file 'contrib/fortune'
--- contrib/fortune	1970-01-01 00:00:00 +0000
+++ contrib/fortune	2005-09-19 06:05:19 +0000
@@ -0,0 +1,20 @@
+#! /bin/sh
+
+# Put this on your $BZRPATH to use it to demonstrate bzr external plugins
+
+
+if [ x$1 == x--bzr-usage ]
+then
+    # options
+    echo ""
+    # arguments
+    echo ""
+    exit 0
+elif [ x$1 == x--bzr-help ]
+then
+    echo "display a fortune cookie"
+    echo 
+    exit 0
+else
+    /usr/games/fortune
+fi

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2010-04-16 12:59:03 +0000
+++ doc/developers/HACKING.txt	2009-12-02 20:34:07 +0000
@@ -62,7 +62,7 @@
 to involving the community before you spend much time on a change.
 These include:
 
-* you get to build on the wisdom of others, saving time
+* you get to build on the wisdom on others, saving time
 
 * if others can direct you to similar code, it minimises the work to be done
 
@@ -120,20 +120,12 @@
 `your_lp_username`.  You can push your branch to Launchpad directly from
 Bazaar::
 
-  $ bzr push lp:~your_lp_username/bzr/meaningful_name_here
+  $ bzr push lp:~your_lp_username/bzr/giveback
 
 After you have pushed your branch, you will need to propose it for merging to
-the Bazaar trunk.  Go to
-<https://launchpad.net/your_lp_username/bzr/meaningful_name_here> and choose
-"Propose for merging into another branch".  Select "~bzr/bzr/trunk" to hand
-your changes off to the Bazaar developers for review and merging.
-
-Using a meaningful name for your branch will help you and the reviewer(s)
-better track the submission. Use a very succint description of your submission
-and prefix it with bug number if needed (lp:~mbp/bzr/484558-merge-directory
-for example). Alternatively, you can suffix with the bug number
-(lp:~jameinel/bzr/export-file-511987).
-
+the Bazaar trunk.  Go to <https://launchpad.net/your_lp_username/bzr/giveback>
+and choose "Propose for merging into another branch".  Select "~bzr/bzr/trunk"
+to hand your changes off to the Bazaar developers for review and merging.
 
 Why make a local copy of bzr.dev?
 ---------------------------------
@@ -688,7 +680,7 @@
 ``only_raises`` decorator (from ``bzrlib.decorators``) for methods that
 are typically called in ``finally`` blocks, such as ``unlock`` methods.
 For example, ``@only_raises(LockNotHeld, LockBroken)``.  All errors that
-are unlikely to be a knock-on failure from a previous failure should be
+are unlikely to be a knock-on failure from an previous failure should be
 allowed.
 
 
@@ -697,7 +689,7 @@
 
 In some places we have variables which point to callables that construct
 new instances.  That is to say, they can be used a lot like class objects,
-but they shouldn't be *named* like classes::
+but they shouldn't be *named* like classes:
 
 > I think that things named FooBar should create instances of FooBar when
 > called. Its plain confusing for them to do otherwise. When we have
@@ -731,8 +723,6 @@
 those parameters, and this instance then has methods for operations
 between the objects.
 
-::
-
   inter = InterRepository.get(source_repo, target_repo)
   inter.fetch(revision_id)
 
@@ -1021,30 +1011,6 @@
 time until the finally block runs.
 
 
-Message guidelines
-------------------
-
-When filenames or similar variables are presented inline within a message,
-they should be enclosed in double quotes (ascii 0x22, not chiral unicode
-quotes)::
-
-  bzr: ERROR: No such file "asdf"
-
-When we print just a list of filenames there should not be any quoting:
-see `bug 544297`_.
-
-.. _bug 544297: https://bugs.launchpad.net/bugs/544297
-
-https://wiki.ubuntu.com/UnitsPolicy provides a good explanation about
-which unit should be used when. Roughly speaking, IEC standard applies
-for base-2 units and SI standard applies for base-10 units:
-
-* for network bandwidth and disk sizes, use base-10 (Mbits/s, kB/s, GB)
-
-* for RAM sizes, use base-2 (GiB, TiB)
-
-
-
 Displaying help
 ===============
 
@@ -1053,8 +1019,7 @@
 and on other help topics.  (See ``help_topics.py``.)
 
 As for python docstrings, the first paragraph should be a single-sentence
-synopsis of the command. These are user-visible and should be prefixed with
-``__doc__ =`` so help works under ``python -OO`` with docstrings stripped.
+synopsis of the command.
 
 The help for options should be one or more proper sentences, starting with
 a capital letter and finishing with a full stop (period).
@@ -1182,16 +1147,13 @@
  * new features - should be brought to their attention
  * bug fixes - may be of interest if the bug was affecting them, and
    should include the bug number if any
- * major documentation changes, including fixed documentation bugs
+ * major documentation changes
  * changes to internal interfaces
 
 People who made significant contributions to each change are listed in
 parenthesis.  This can include reporting bugs (particularly with good
 details or reproduction recipes), submitting patches, etc.
 
-To help with merging, NEWS entries should be sorted lexicographically
-within each section.
-
 Commands
 --------
 

=== modified file 'doc/developers/_templates/layout.html'
--- doc/developers/_templates/layout.html	2010-03-02 10:21:39 +0000
+++ doc/developers/_templates/layout.html	2009-11-18 02:08:40 +0000
@@ -6,8 +6,27 @@
 {% endblock %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar.canonical.com/">
+<li><a href="http://bazaar-vcs.org/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Home</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar.canonical.com/en/">Documentation</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar-vcs.org/en/">Documentation</a>&nbsp;|&nbsp;</li>
+{{ super() }}
+{% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
 {{ super() }}
 {% endblock %}

=== modified file 'doc/developers/bug-handling.txt'
--- doc/developers/bug-handling.txt	2010-02-18 04:17:22 +0000
+++ doc/developers/bug-handling.txt	2009-12-02 20:34:07 +0000
@@ -28,8 +28,6 @@
 * `Open bugs most recently changed first
   <https://bugs.edge.launchpad.net/bzr/+bugs?field.searchtext=&orderby=-date_last_updated&search=Search&field.status%3Alist=NEW&field.status%3Alist=INCOMPLETE_WITH_RESPONSE&field.status%3Alist=INCOMPLETE_WITHOUT_RESPONSE&field.status%3Alist=CONFIRMED&field.status%3Alist=TRIAGED&field.status%3Alist=INPROGRESS&field.status%3Alist=FIXCOMMITTED&field.assignee=&field.bug_reporter=&field.omit_dupes=on&field.has_patch=&field.has_no_package=>`_.
 
-* `Most commonly duplicated bugs <http://tinyurl.com/bzr-bugs-by-dupes>`_.
-
 
 Generalities
 ************
@@ -138,26 +136,16 @@
     yet.
 Incomplete
     The bug requires more information from the reporter to make progress.
-
-    Only set this state if it's impossible or uneconomical to make
-    progress on the bug without that information.  The bug will expire if
-    it remains in this state for two months.
 Confirmed
     The bug report has been seen by a developer and we agree it's a bug.
-    You don't have to reproduce the bug to mark it Confirmed.  (Generally
+    You don't have to reproduce the bug to mark it confirmed.  (Generally
     it's not a good idea for a developer to spend time reproducing the bug
     until they're going to work on it.)
 Triaged
     We don't use this status.  If it is set, it means the same as
     Confirmed.
 In Progress
-    Someone has started working on this.  We can deliver the value of the
-    work already done by finishing and shipping the fix.  
-    
-    The bug keeps this state from the time someone does non-trivial
-    analysis, until the fix is merged to a release or trunk branch (when
-    it is Fix Released), or until they give up on it (back to New or
-    Confirmed) or decide it is Invalid or Incomplete.
+    Someone has started working on this.
 Won't Fix
     The behaviour complained about is intentional and we won't fix it.
     Needless to say, be thoughtful before using this status, and consider if
@@ -166,25 +154,20 @@
     The reporter was confused, and this is not actually a bug.
     Again, be sensitive in explaining this to the user.
 Fix Committed
-    Don't use this.  If set on old bug, it probably means In Progress,
-    with the fix waiting for review.  See Launchpad `bug 163694`_.
+    A fix for this bug exists in a branch somewhere.  Ideally the bug will
+    be linked to the branch.
 Fix Released
     The fix for this bug is now in the bzr branch that this task is for.
-    The branch for the default task on a bug is bzr.dev.  
-    
-    We use this value even though the fix may not have been been included
-    in a release yet because all the developer activity around it is
-    complete and we want to both avoid bug spam when releases happen, and
-    keep the list of bugs that developers see when they look at the bug
-    tracker trimmed to those that require action. 
-    
-    When setting a bug task to fix released, the bug target milestone
-    should be set to the release the fix will be included in (or was
-    included in, if you are updating an old bug). Don't spend too much
-    time updating this if you don't immediately know: its not critical
-    that it be set.
-
-.. _`bug 163694`: https://bugs.launchpad.net/malone/+bug/163694
+    The branch for the default task on a bug is bzr.dev.  We use this value
+    even though the fix may not have been been included in a release yet
+    because all the developer activity around it is complete and we want to
+    both avoid bug spam when releases happen, and keep the list of bugs that
+    developers see when they look at the bug tracker trimmed to those that
+    require action. When setting a bug task to fix released, the bug target
+    milestone should be set to the release the fix will be included in (or
+    was included in, if you are updating an old bug). Don't spend too much time
+    updating this if you don't immediately know: its not critical that it be
+    set.
 
 
 Bug Importance

=== modified file 'doc/developers/colocated-branches.txt'
--- doc/developers/colocated-branches.txt	2010-04-12 15:28:32 +0000
+++ doc/developers/colocated-branches.txt	2009-12-02 20:34:07 +0000
@@ -6,6 +6,11 @@
 branches there are several situations where it might be useful to also
 support multiple branches under the same file system directory.
 
+There is an experimental implementation for Bazaar available as a plugin
+at http://people.samba.org/bzr/jelmer/bzr-local-branches/trunk. This was
+the original proof-of-concept and doesn't yet use the API documented
+here.
+
 Rationale
 ---------
 
@@ -41,71 +46,57 @@
 UI Changes
 ~~~~~~~~~~
 
-Bazaar URLs need to have some way to address colocated branches in 
-directories that contain multiple branches. 
-
-Per RFC3986 we have picked the comma (",") to allow the specification of 
-colocated branch names. Comma's in path names would have to be 
-urlencoded at first to avoid ambiguity, though perhaps it would be 
-possible to support heuristics later when interpreting user-specified URLs.
-
-An example URL would be:
-
- bzr://bazaar.launchpad.net/~jelmer/bzr/bzr.dev,colo-urls
-
-The segment after the comma will initially be interpreted as a colocated 
-branch name but we would like to keep the option to allow 
-key=value style specifications in the future and DWIM for segments that 
-do not contain an =. Following the RFC the comma would be interpreted within
-the scope of a path segment. In other words, in the URL:
-
- git://git.debian.org/pkg-python-debian/python-debian.git,unstable/README
-
-unstable is interpreted as the colocated branch living in the python-debian.git
-control directory; README is a path inside of the branch.
-
-Control directories will also have the notion of an "active" branch. This is 
-the branch that is being used by a working tree, if present and the branch 
-that will be used if no explicit colocated branch is specified. The 
-active branch support makes it easier to deal with existing bzrdirs and 
-is useful when accessing foreign control directories that have the concept 
-as well.
-
-A new command 'bzr rmbranch' needs to be added to make it possible to 
-remove colocated branches, as this won't be possible by simple 
-directory removal, at least not of a user-visible directory.
+Bazaar URLs need to have some way to specify a colocated branch other
+than the current HEAD. Several options have been discussed, each with
+its own advantages and disadvantages: This was discussed on the mailing
+list, most notably the use of a ";branch=NAME" suffix as well as a special
+separation character (+, =, etc), but no final conclusion was reached.
+
+https://lists.ubuntu.com/archives/bazaar/2008q4/050105.html
 
 Code Changes
 ~~~~~~~~~~~~
 
-BzrDirFormat will need a supports_colocated_branches property that 
-indicates whether a format supports the creation, removal and accessing of 
-colocated branches.
-
-Several methods on BzrDir will need to be updated to take an option branch_name 
-parameter. If this parameter is not specified or None, the active branch 
-will be used.
-
-The methods that will have to be extended are:
-
- * BzrDir.open_branch()
- * BzrDir.create_branch()
- * BzrDir.destroy_branch()
- * BzrDir.get_branch_transport()
-
- * BranchFormat.initialise()
- * BranchFormat.open()
-
-A new BzrDir.list_branches() method will return all colocated branches 
-present in a control directory. 
-
-Any URL interpreting methods (e.g. Branch.open) will need to be updated 
-to extract a colocated branch name and need to pass that into the 
-relevant methods.
-
-Existing callers of BzrDir.{create,open,destroy}_branch() need to 
-be updated to pass in branch names and optionally be changed to use 
-BzrDir.list_branches().
+BzrDir should support a BzrDir.supports_colocated_branches() call as well as
+BzrDir.colocated_branches property that contains a colocated branch container,
+that can be used to add / remove colocated branches as well as change the
+currently active colocated branch.
+
+::
+
+	class ColocatedBranchContainer(object):
+
+	   def get_active_branch_name(self):
+		  """Returns the name of the currently active branch.
+
+		  This can be None if no branch is currently active.
+		  """
+
+	   def get_active_branch(self):
+		  """Returns the currently active branches' Branch object."""
+
+	   def get_branch(self, name):
+		  """Returns the Branch object for the specified branch."""
+
+	   def available_branches(self):
+		  """Returns a set with the names of the available branches."""
+
+	   def set_active_branch(self, name):
+		  """Set the currently active branch."""
+
+	   def destroy_branch(self, name):
+		 """Destroy the specified branch.
+			
+		This will remove the branch from disk."""
+
+If the particular BzrDir implementation doesn't support colocated
+branches, it can just return a dummy container that just contains a
+HEAD branch.
+
+Looms can of course return a container with all their threads.
+
+BzrDir.find_branches() should take into account the colocated branches
+when iterating over its branches.
 
 Schema Changes
 --------------
@@ -117,13 +108,11 @@
 Eventually, Bazaar could easily support colocated branches by just
 creating a new branch transport for each colocated branch and have a
 "regular" branch live there. This would require something like
-BzrDirMeta2 though. An example of this is implemented in the 
-lp:bzr-colocated plugin
-
-Further integration
--------------------
-
-Loggerhead and Launchpad need to be updated to show colocated branches
-(perhaps in a similar way as they would show tags?).
-
-qbzr/bzr-gtk need to be updated to support colocated branches.
+BzrDirMeta2 though.
+
+Unresolved Issues
+-----------------
+
+ * What about colocated looms ?
+ * What character to use to name colocated branches in URLs?
+

=== modified file 'doc/developers/contribution-quickstart.txt'
--- doc/developers/contribution-quickstart.txt	2010-02-23 02:32:52 +0000
+++ doc/developers/contribution-quickstart.txt	2009-11-19 02:03:12 +0000
@@ -1,120 +1,59 @@
-Contributing to Bazaar
-======================
-
-Talk to us
-----------
-
-If you want to fix or improve something in Bazaar, we want to help you.
-You can ask at any time for help, on the list, on irc, or through a merge
-proposal on Launchpad.
-
-In particular, the rostered
-`Patch Pilot <http://wiki.bazaar.canonical.com/PatchPilot>`_ 
-is an experienced developer who will help you get your changes in, through
-code review, advice, debugging, writing tests, or whatever it takes.
-
-* `Bazaar mailing list <http://lists.ubuntu.com/mailman/listinfo/bazaar>`_
-
-* IRC in channel ``#bzr`` on ``irc.ubuntu.com``
-
-
-Starting
---------
-
-Before starting on a change it's a good idea to either file a bug, find a
-relevant existing bug, or send a proposal to the list.  If there is a bug
-you should set it to "In Progress" and if you wish assign it to yourself.
-
-You might like to start with a bug tagged `easy
-<https://bugs.edge.launchpad.net/bzr/+bugs?field.tag=easy>`_.
-
-Making a branch
----------------
-
-First, get a local copy of Bazaar::
-
-   $ cd $HOME
-   $ bzr init-repo bzr
-   $ cd bzr
-   $ bzr branch lp:bzr bzr.dev
-
-Now make your own branch; we recommend you include the bug number and also
-a brief description::
-
-   $ bzr branch bzr.dev 123456-status-speed
-
-and go ahead and commit in there.  Normally you should fix only one bug or
-closely-related cluster of bugs per branch, to make reviews and merges
-flow more smoothly.
-
-For bugs that exist in older supported branches of bzr like 2.0 or 2.1,
-you might want to fix the bug there so it can go into a bugfix release,
-ie ::
-
-   $ bzr branch lp:bzr/2.1 bzr.2.1
-   $ bzr branch bzr.2.1 123458-2.1-status
-
-You probably want this configuration in ``~/.bazaar/locations.conf``::
-
-    [/home/USER/bzr]
-    push_location = lp:~LAUNCHPAD_USER/bzr/
-    push_location:policy = appendpath
-    public_branch = http://bazaar.launchpad.net/~LAUNCHPAD_USER/bzr/
-    public_branch:policy = appendpath
-
-with your local and Launchpad usernames inserted.
-
-
-Writing tests
--------------
-
-We value test coverage and generally all changes should have or update a
-test.  There is a powerful test framework but it can be hard to find the
-right place to put your test.  Don't hesitate to ask, or to propose a
-merge that does not yet have tests.
-
-Normally for command-line code you should look in
-``bzrlib.tests.blackbox`` and for library code in ``bzrlib.tests``.  For
-functions on an interface for which there are multiple implementations,
-like `Transport`, look in ``bzrlib.tests.per_transport``.
-
-It's a good idea to search the tests for something related to the thing
-you're changing and you may find a test you can modify or adapt.
-
-To run the tests::
-
-    $ ./bzr selftest
-
-Normally the tests will skip if some library dependencies are not present.
-On Ubuntu, you can install them with this command (you must have some
-repositories enabled in Software Sources)::
-
-    $ sudo apt-get build-dep bzr
-
-To build the binary extensions::
-
-    $ make
-
-For more information: `Testing Guide <testing.html>`_.
-
-
-Proposing a merge
------------------
-
-
-Then propose a merge into bzr; for bzr 2.2 and later you can use the ``bzr
-propose-merge`` command.  In the comment for your merge proposal please
-explain what you're trying to do and why.  For `example
-<https://code.launchpad.net/~ian-clatworthy/bzr/whats-new-in-2.1/+merge/19677>`_:
-
-  As discussed on the mailing list, this patch adds a What's New document
-  summarising the changes since 2.0.
-
-If you make additional changes to your branch you don't need to resubmit;
-they'll automatically show up in the merge proposal.
-
-* `Launchpad Code Review Help <http://help.launchpad.net/Code/Review>`_.
-
+Bazaar Contribution in Five Minutes
+===================================
+
+Contributing to Bazaar requires attention to quality.  To ensure
+high-quality commits, the "Bazaar process" involves you in our
+code review and improvement activities.
+
+In brief, a contribution should include:
+
+1.  A brief rationale, including expected audience and use cases,
+    for inclusion in Bazaar.
+
+2.  A branch registered as a branch on Launchpad, and submitted as
+    a merge proposal.
+
+3.  The branch should include:
+
+    a.  implementation of the feature,
+
+    b.  user documentation (if the feature is visible in the user
+        interface) and/or developer documentation (if new or
+        changed APIs are provided), and
+
+    c.  tests to ensure the specification is correctly
+        implemented.
+
+For more information, see the `Bazaar Developer Guide <HACKING.html>`_.
+
+If you are not an experienced Bazaar contributor, why not ask for
+mentoring?  When you submit your merge proposal on Launchpad, simply say
+"I'd like to be mentored, please" in your submission.  Or ask for help
+with your contribution on the IRC channel, mailing list, or on Launchpad
+(https://answers.launchpad.net/bzr).
+
+
+Current Bazaar Mentors
+----------------------
+
+See the roster at http://bazaar-vcs.org/PatchPilot, although other
+developers may help too!
+
+
+Bazaar Mentors FAQ
+------------------
+
+1.  Why is this "Bazaar process" in HACKING.txt so complicated?
+
+    Answer: If we knew *that*, we'd simplify it!  We are working
+    on streamlining many aspects, but quality comes first.
+
+1.  What sort of things can a mentor help with?
+
+    Anything that's getting in your way, time permitting.  This includes
+    guiding you through the ``bzrlib`` API, explaining how to use our test
+    infrastructure, discussing possible designs for your bug fix or
+    feature, and so on.
 
 ..
    vim: ft=rst tw=74 ai

=== modified file 'doc/developers/cycle.txt'
--- doc/developers/cycle.txt	2010-01-08 00:44:26 +0000
+++ doc/developers/cycle.txt	2009-12-14 08:41:19 +0000
@@ -21,6 +21,49 @@
 * `Releasing Bazaar <releasing.html>`_ -- the process for actually making
   a release or release candidate.
 
+The Problem Situation
+*********************
+
+Bazaar makes a release every month, preceded by a one-week
+release-candidate test.
+
+In any release we may fix bugs, add formats, change the default format,
+improve performance, add new commands or change command line behaviour,
+change the network protocol, or deprecate APIs.  We sometimes also
+introduce new bugs, regress existing behaviour or performance, remove
+existing features or formats, or break behaviour or APIs depended upon by
+plugins, external programs or users.
+
+Some users are happy upgrading every month and consider the overall
+positive balance of changes is worth some amount of churn.  But there are
+some serious problems:
+
+* You cannot get bug fixes without also getting disruptive changes.
+
+* Bazaar is seen as unstable.
+
+* Many releases cause some plugin breakage.
+
+* One month is not a very long window for dependent programs or systems
+  to catch up to changes in Bazaar before the release goes out of date.
+
+* There's no clear indication to distributions which version they should
+  package.
+
+* If people (or their distributions) just pick an arbitrary version, they
+  may all be on different arbitrary versions, therefore they will have
+  different behaviour and different bugs, and sometimes interoperation
+  problems.
+
+* Any effort we, or distributors, wanted to put into backporting fixes
+  would be dissipated across many possible backport target releases.
+
+* When in the past we've tried either stalling releases for particular
+  features, or having trunk frozen for some weeks, it causes churn and
+  waste.  People rush features in, or already landed features wait a long
+  time to be released, or branches go out of date because they cannot
+  land.
+
 
 The Process
 ************
@@ -378,52 +421,25 @@
 
 * Users like it.
 
-After doing this for the 2.0 cycle (September 2009 through to early
-2010), it seems to be going well.
-
 
 Reviewing for the Stable Branch
 *******************************
 
-These are guidelines and can be interpreted case-by-case.
-
 * All changes to the stable branch should fix a bug, even if you would not
   normally file a bug for the change.  The bug description should if at
   all possible explain how to manually verify the bug in a way that will
   fail before and pass after the change.  (These are requirements for the
   SRU process.)
 
-* The change should be reasonably small and conservative.  
-
-* Remember that the patch will be read during the SRU
-  process and so keeping the patch small is useful even beyond keeping the
-  logical changes small.  Avoid doing mechanical bulk changes on the
-  stable branch.
-
-* Use particular care for things that may behave differently across
-  platforms, encodings or locales.  It's harder to thoroughly test these
-  things before a release.
-
-* Generally speaking, just cleaning things up is not a sufficient reason
-  to make changes to the stable branch.  It has to actually fix a bug.
-
-* Changes to the stable branch should include tests as usual.  
-
-* Don't change or remove existing APIs that might be used by plugins, even
-  if they are underscore-prefixed.  Adding APIs that are also being added
-  to the trunk branch may make sense.
-
-* Keeping consistency with trunk is useful, but less important than
-  keeping the stable branch stable.
+* The change should be reasonably small and conservative.  Be extra
+  careful of things that could break on other platforms or locales.
 
 * (more items welcome)
 
 References
 **********
 
-#. List thread "`[rfc] six-month stable release cycles`__", July 2009.
-
-.. __: https://lists.ubuntu.com/archives/bazaar/2009q3/060882.html
+#. List thread "[rfc] six-month stable release cycles", July 2009.
 
 ..
    vim: filetype=rst textwidth=74 ai shiftwidth=4

=== modified file 'doc/developers/index-plain.txt'
--- doc/developers/index-plain.txt	2010-02-23 04:12:26 +0000
+++ doc/developers/index-plain.txt	2009-12-02 20:34:07 +0000
@@ -24,8 +24,8 @@
 
 * `Testing <testing.html>`_ |--| Guide to writing tests for Bazaar.
 
-* `Writing plugins <http://doc.bazaar.canonical.com/plugins/en/plugin-development.html>`_
-  |--| specific advice on writing Bazaar plugins. (web link)
+* `Writing plugins <http://bazaar-vcs.org/WritingPlugins>`_ (wiki)
+  |--| specific advice on writing Bazaar plugins.
 
 Process
 =======

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2010-02-23 04:12:26 +0000
+++ doc/developers/index.txt	2009-12-14 06:06:59 +0000
@@ -12,30 +12,17 @@
    contribution-quickstart
 
 
-Working on Bazaar
-=================
+Enhancing Bazaar
+================
 
 .. toctree::
    :maxdepth: 1
 
-   cycle
-   profiling
-   bug-handling
+   process
    HACKING
    testing
 
-* `Contributing to Bazaar Documentation <http://wiki.bazaar.canonical.com/ContributingToTheDocs>`_ (wiki)
-
-
-Releasing and Packaging
-=======================
-
-.. toctree::
-   :maxdepth: 1
-
-   releasing
-   ppa
-   ec2 
+* `Bazaar Writer Guide <http://bazaar-vcs.org/ContributingToTheDocs>`_ (web link)
 
 
 Developing using bzrlib
@@ -47,7 +34,7 @@
    overview
    integration
 
-* `Writing plugins for Bazaar <http://doc.bazaar.canonical.com/plugins/en/plugin-development.html>`_ (web link)
+* `Writing plugins for Bazaar <http://bazaar-vcs.org/WritingPlugins>`_ (web link)
 
 * `bzrlib API reference <http://starship.python.net/crew/mwh/bzrlibapi/>`_
   (web link)

=== modified file 'doc/developers/plugin-api.txt'
--- doc/developers/plugin-api.txt	2010-04-16 12:59:03 +0000
+++ doc/developers/plugin-api.txt	2009-12-02 20:34:07 +0000
@@ -22,9 +22,9 @@
 See also
 --------
 
- * `Bazaar Developer Documentation Catalog <../index.html>`_.
- * `Bazaar Plugins Guide <http://doc.bazaar.canonical.com/plugins/en/plugin-development.html>`_ for
-   more suggestions about particular APIs.
+ * `Bazaar Developer Documentation Catalog <index.html>`_.
+ * <http://bazaar-vcs.org/WritingPlugins> wiki page with many more
+   suggestions about particular APIs
 
 
 Structure of a plugin
@@ -186,8 +186,9 @@
 short complete sentence summarizing the plugin.  The full docstring is
 shown by ``bzr help PLUGIN_NAME``.
 
-This is a user-visible docstring so should be prefixed with ``__doc__ =``
-to ensure help works under ``python -OO`` with docstrings stripped.
+Remember that to be effective, the module docstring must be the first
+statement in the file.  It may come after comments but it must be before
+any import statements.
 
 API version
 -----------
@@ -241,7 +242,7 @@
 time other than register or override functions to be called later.
 
 The plugin can import bzrlib and call any function.
-Some interesting APIs are described in `Bazaar Plugins Guide <http://doc.bazaar.canonical.com/plugins/en/plugin-development.html>`_.
+Some interesting APIs are described in <http://bazaar-vcs.org/WritingPlugins>
 
 
 Publishing your plugin
@@ -254,7 +255,7 @@
    <https://launchpad.net/bzr-fastimport>
    and publish the branches or tarballs there
 
- * include the plugin in <http://wiki.bazaar.canonical.com/BzrPlugins>
+ * include the plugin in <http://bazaar-vcs.org/BzrPlugins>
 
  * post about it to the ``bazaar-announce`` list at ``lists.canonical.com``
 

=== added file 'doc/developers/process.txt'
--- doc/developers/process.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/process.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,39 @@
+Bazaar Development Processes
+============================
+
+.. toctree::
+   :hidden:
+
+   cycle
+   releasing
+   ppa
+   profiling
+   ec2
+   bug-handling
+
+
+* `The Bazaar Development Cycle <cycle.html>`_ |--| The monthly
+  development cycle and how to run it.
+
+* `Releasing Bazaar <releasing.html>`_ |--|
+  Checklist to make a release of Bazaar.
+
+* `Managing the Bazaar PPA <ppa.html>`_ |--| Packaging Bazaar for Ubuntu.
+
+* `Giving back <http://bazaar-vcs.org/BzrGivingBack>`_ (wiki) |--| How to get
+  your changes to Bazaar integrated into a release.
+
+* `Profiling notes <profiling.html>`_ |--| Instructions on how to profile
+  bzr code and visualize the results.
+
+* `EC2 resources <ec2.html>`_ |--| A team resource for
+  Windows packaging and testing, and Ubuntu testing.
+
+* `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug
+  tracker.
+
+
+.. |--| unicode:: U+2014
+
+..
+   vim: ft=rst tw=74 ai

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2010-03-17 02:58:08 +0000
+++ doc/developers/releasing.txt	2009-12-02 20:34:07 +0000
@@ -55,10 +55,6 @@
    ``bzrlib/__init__.py`` file. Make sure there is always a corresponding
    milestone when you change that version number.
 
-#. Add a new section at the top of ``NEWS`` about the new release,
-   including its version number and the headings from
-   ``NEWS-template.txt``.
-
 #. Send mail to the list with the key dates, who will be the release
    manager, and the main themes or targeted bugs.  Ask people to nominate
    objectives, or point out any high-risk things that are best done early,

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2010-04-16 07:56:51 +0000
+++ doc/developers/testing.txt	2009-12-23 05:04:12 +0000
@@ -39,24 +39,6 @@
 Running the Test Suite
 ======================
 
-As of Bazaar 2.1, you must have the testtools_ library installed to run
-the bzr test suite.
-
-.. _testtools: https://launchpad.net/testtools/
-
-To test all of Bazaar, just run::
-
-  bzr selftest 
-
-With ``--verbose`` bzr will print the name of every test as it is run.
-
-This should always pass, whether run from a source tree or an installed
-copy of Bazaar.  Please investigate and/or report any failures.
-
-
-Running particular tests
-------------------------
-
 Currently, bzr selftest is used to invoke tests.
 You can provide a pattern argument to run a subset. For example,
 to run just the blackbox tests, run::
@@ -104,27 +86,6 @@
 --load-list. The later is rarely used but allows to run a subset of a list of
 failing tests for example.
 
-Disabling plugins
------------------
-
-To test only the bzr core, ignoring any plugins you may have installed,
-use::
-
-  ./bzr --no-plugins selftest 
-
-Disabling crash reporting
--------------------------
-
-By default Bazaar uses apport_ to report program crashes.  In developing
-Bazaar it's normal and expected to have it crash from time to time, at
-least because a test failed if for no other reason.
-
-Therefore you should probably add ``debug_flags = no_apport`` to your
-``bazaar.conf`` file (in ``~/.bazaar/`` on Unix), so that failures just
-print a traceback rather than writing a crash file.
-
-.. _apport: https://launchpad.net/apport/
-
 
 Test suite debug flags
 ----------------------
@@ -136,60 +97,10 @@
   This can provide useful logging to help debug test failures when used
   with e.g. ``bzr -Dhpss selftest -E=allow_debug``
 
-  Note that this will probably cause some tests to fail, because they
-  don't expect to run with any debug flags on.
-
-
-Using subunit
--------------
-
-Bazaar can optionally produce output in the machine-readable subunit_
-format, so that test output can be post-processed by various tools. To
-generate a subunit test stream::
-
- $ ./bzr selftest --subunit
-
-Processing such a stream can be done using a variety of tools including:
-
-* The builtin ``subunit2pyunit``, ``subunit-filter``, ``subunit-ls``,
-  ``subunit2junitxml`` from the subunit project.
-
-* tribunal_, a GUI for showing test results.
-
-* testrepository_, a tool for gathering and managing test runs.
-
-.. _subunit: https://launchpad.net/subunit/
-.. _tribunal: https://launchpad.net/tribunal/
-
-
-Using testrepository
---------------------
-
-Bazaar ships with a config file for testrepository_. This can be very
-useful for keeping track of failing tests and doing general workflow
-support. To run tests using testrepository::
-
-  $ testr run
-
-To run only failing tests::
-
-  $ testr run --failing
-
-To run only some tests, without plugins::
-
-  $ test run test_selftest -- --no-plugins
-
-See the testrepository documentation for more details.
-
-.. _testrepository: https://launchpad.net/testrepository
 
 Writing Tests
 =============
 
-Normally you should add or update a test for all bug fixes or new features
-in Bazaar.
-
-
 Where should I put a new test?
 ------------------------------
 
@@ -401,96 +312,10 @@
         ''')
 
 
-Import tariff tests
--------------------
-
-`bzrlib.tests.test_import_tariff` has some tests that measure how many
-Python modules are loaded to run some representative commands.
-
-We want to avoid loading code unnecessarily, for reasons including:
-
-* Python modules are interpreted when they're loaded, either to define
-  classes or modules or perhaps to initialize some structures.
-
-* With a cold cache we may incur blocking real disk IO for each module.
-
-* Some modules depend on many others.
-
-* Some optional modules such as `testtools` are meant to be soft
-  dependencies and only needed for particular cases.  If they're loaded in
-  other cases then bzr may break for people who don't have those modules.
-  
-`test_import_tarrif` allows us to check that removal of imports doesn't
-regress.
-
-This is done by running the command in a subprocess with
-``--profile-imports``.  Starting a whole Python interpreter is pretty
-slow, so we don't want exhaustive testing here, but just enough to guard
-against distinct fixed problems.
-
-Assertions about precisely what is loaded tend to be brittle so we instead
-make assertions that particular things aren't loaded.
-
-Unless selftest is run with ``--no-plugins``, modules will be loaded in
-the usual way and checks made on what they cause to be loaded.  This is
-probably worth checking into, because many bzr users have at least some
-plugins installed (and they're included in binary installers).
-
-In theory, plugins might have a good reason to load almost anything:
-someone might write a plugin that opens a network connection or pops up a
-gui window every time you run 'bzr status'.  However, it's more likely
-that the code to do these things is just being loaded accidentally.  We
-might eventually need to have a way to make exceptions for particular
-plugins.
-
-Some things to check:
-
-* non-GUI commands shouldn't load GUI libraries
-
-* operations on bzr native formats sholudn't load foreign branch libraries
-
-* network code shouldn't be loaded for purely local operations
-
-* particularly expensive Python built-in modules shouldn't be loaded
-  unless there is a good reason
-
-
-Testing locking behaviour
--------------------------
-
-In order to test the locking behaviour of commands, it is possible to install
-a hook that is called when a write lock is: acquired, released or broken.
-(Read locks also exist, they cannot be discovered in this way.)
-
-A hook can be installed by calling bzrlib.lock.Lock.hooks.install_named_hook.
-The three valid hooks are: `lock_acquired`, `lock_released` and `lock_broken`.
-
-Example::
-
-    locks_acquired = []
-    locks_released = []
-
-    lock.Lock.hooks.install_named_hook('lock_acquired',
-        locks_acquired.append, None)
-    lock.Lock.hooks.install_named_hook('lock_released',
-        locks_released.append, None)
-
-`locks_acquired` will now receive a LockResult instance for all locks acquired
-since the time the hook is installed.
-
-The last part of the `lock_url` allows you to identify the type of object that is locked.
-
-- BzrDir: `/branch-lock`
-- Working tree: `/checkout/lock`
-- Branch: `/branch/lock`
-- Repository: `/repository/lock`
-
-To test if a lock is a write lock on a working tree, one can do the following::
-
-    self.assertEndsWith(locks_acquired[0].lock_url, "/checkout/lock")
-
-See bzrlib/tests/commands/test_revert.py for an example of how to use this for
-testing locks.
+
+.. Effort tests
+.. ~~~~~~~~~~~~
+
 
 
 Skipping tests
@@ -552,6 +377,19 @@
         KnownFailure should be used with care as we don't want a
         proliferation of quietly broken tests.
 
+ModuleAvailableFeature
+        A helper for handling running tests based on whether a python
+        module is available. This can handle 3rd-party dependencies (is
+        ``paramiko`` available?) as well as stdlib (``termios``) or
+        extension modules (``bzrlib._groupcompress_pyx``). You create a
+        new feature instance with::
+
+            MyModuleFeature = ModuleAvailableFeature('bzrlib.something')
+
+            ...
+            def test_something(self):
+                self.requireFeature(MyModuleFeature)
+                something = MyModuleFeature.module
 
 
 We plan to support three modes for running the test suite to control the
@@ -599,25 +437,14 @@
 
     self.requireFeature(StraceFeature)
 
-The old naming style for features is CamelCase, but because they're
-actually instances not classses they're now given instance-style names
-like ``apport``.
-
-Features already defined in ``bzrlib.tests`` and ``bzrlib.tests.features``
-include:
-
- - apport
- - paramiko
- - SymlinkFeature
- - HardlinkFeature
- - OsFifoFeature
- - UnicodeFilenameFeature
- - FTPServerFeature
+Features already defined in bzrlib.tests include:
+
+ - SymlinkFeature,
+ - HardlinkFeature,
+ - OsFifoFeature,
+ - UnicodeFilenameFeature,
+ - FTPServerFeature, and
  - CaseInsensitiveFilesystemFeature.
- - chown_feature: The test can rely on OS being POSIX and python
-   supporting os.chown.
- - posix_permissions_feature: The test can use POSIX-style
-   user/group/other permission bits.
 
 
 Defining a new feature that tests can require
@@ -637,21 +464,6 @@
 
     SymlinkFeature = _SymlinkFeature()
 
-A helper for handling running tests based on whether a python
-module is available. This can handle 3rd-party dependencies (is
-``paramiko`` available?) as well as stdlib (``termios``) or
-extension modules (``bzrlib._groupcompress_pyx``). You create a
-new feature instance with::
-
-    # in bzrlib/tests/features.py
-    apport = tests.ModuleAvailableFeature('apport')
-
-
-    # then in bzrlib/tests/test_apport.py
-    class TestApportReporting(TestCaseInTempDir):
-
-        _test_needs_features = [features.apport]
-
 
 Testing exceptions and errors
 -----------------------------

=== modified file 'doc/developers/win32_build_setup.txt'
--- doc/developers/win32_build_setup.txt	2010-01-25 10:18:24 +0000
+++ doc/developers/win32_build_setup.txt	2009-12-18 16:13:54 +0000
@@ -37,7 +37,6 @@
    g) zip
    h) unzip
    i) patch
-   j) gettext-devel # brings 'msgfmt'
 
 
 2) Download the supported versions of python from http://www.python.org
@@ -112,7 +111,6 @@
       http://launchpadlibrarian.net/16133025/win32_clock.patch
       This may not end up necessary w/ pycrypto 2.1, especially if paramiko can
       be taught to use the new functionality (avoiding the warning).
-   l) easy_install testtools
 
 5) Get Pageant, not strictly necessary, but it is a pretty good ssh-agent for
    Windows, and paramiko knows how to use keys from Pageant.

=== modified file 'doc/en/Makefile'
--- doc/en/Makefile	2010-03-25 10:09:32 +0000
+++ doc/en/Makefile	2009-09-08 12:33:30 +0000
@@ -11,22 +11,6 @@
 PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
 
-# Note that this assumes name of the output dir is same as name of the rule.
-define make_output_dirs
-# Create output directory (only needed for sphinx < 0.5)
-[ -d _build ] || mkdir _build
-[ -d "_build/$@" ] || mkdir "_build/$@"
-# Workaround for a bug in sphinx < 0.5 where it tries to delete
-# nonexistent static dirs and does not catch the exception.  This was
-# fixed in svn+ssh://pythondev@svn.python.org/doctools/branches/0.4.x
-# at r65551 and merged as 280b62246342 in hg branch released as 0.5.
-[ -d "_build/$@/_static" ] || mkdir "_build/$@/_static"
-for fn in _static/*; do \
-    [ ! -d "$$fn" ] && continue; \
-    [ -d "_build/$@/$$fn" ] || mkdir "_build/$@/$$fn"; \
-done
-endef
-
 .PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
 
 help:
@@ -46,38 +30,32 @@
 	-rm -rf _build/*
 
 html:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
 	@echo
 	@echo "Build finished. The HTML pages are in _build/html."
 
 dirhtml:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
 	@echo
 	@echo "Build finished. The HTML pages are in _build/dirhtml."
 
 pickle:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
 	@echo
 	@echo "Build finished; now you can process the pickle files."
 
 json:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
 	@echo
 	@echo "Build finished; now you can process the JSON files."
 
 htmlhelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
 	@echo
 	@echo "Build finished; now you can run HTML Help Workshop with the" \
 	      ".hhp project file in _build/htmlhelp."
 
 qthelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
 	@echo
 	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
@@ -87,7 +65,6 @@
 	@echo "# assistant -collectionFile _build/qthelp/Bazaar.qhc"
 
 latex:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
 	@echo
 	@echo "Build finished; the LaTeX files are in _build/latex."
@@ -95,20 +72,17 @@
 	      "run these through (pdf)latex."
 
 changes:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
 	@echo
 	@echo "The overview file is in _build/changes."
 
 linkcheck:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
 	@echo
 	@echo "Link check complete; look for any errors in the above output " \
 	      "or in _build/linkcheck/output.txt."
 
 doctest:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
 	@echo "Testing of doctests in the sources finished, look at the " \
 	      "results in _build/doctest/output.txt."

=== modified file 'doc/en/_static/en/bzr-en-quick-reference.svg'
--- doc/en/_static/en/bzr-en-quick-reference.svg	2010-01-29 10:36:23 +0000
+++ doc/en/_static/en/bzr-en-quick-reference.svg	2009-09-09 00:49:50 +0000
@@ -1579,7 +1579,7 @@
         <a
            id="a6316"
            style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar.canonical.com">
+           xlink:href="http://bazaar-vcs.org">
           <text
              sodipodi:linespacing="100%"
              id="text6302"
@@ -1590,7 +1590,7 @@
                y="97.901367"
                x="787.79535"
                id="tspan6304"
-               sodipodi:role="line">http://bazaar.canonical.com</tspan></text>
+               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
         </a>
       </g>
     </g>

=== modified file 'doc/en/_templates/index.html'
--- doc/en/_templates/index.html	2010-03-04 04:15:18 +0000
+++ doc/en/_templates/index.html	2009-12-08 01:15:55 +0000
@@ -7,11 +7,8 @@
 
   <table class="contentstable" align="center" style="margin-left: 30px"><tr>
     <td width="50%">
-        <p class="biglink"><a class="biglink" href="{{ pathto("whats-new/whats-new-in-2.2") }}">What's New in Bazaar 2.2?</a><br/>
-        <span class="linkdescr">what's new in this release</span>
-      </p>
         <p class="biglink"><a class="biglink" href="{{ pathto("user-guide/index") }}">User Guide</a><br/>
-        <span class="linkdescr">how to use the command line client</span>
+        <span class="linkdescr">how to use Bazaar effectively</span>
       </p>
       <p class="biglink"><a class="biglink" href="{{ pathto("tutorials/index") }}">Tutorials</a><br/>
       <span class="linkdescr">brief introductions</span>
@@ -21,7 +18,7 @@
       </p>
     </td><td width="50%">
     <p class="biglink"><a class="biglink" href="{{ pathto("release-notes/index") }}">Release Notes</a><br/>
-      <span class="linkdescr">a detailed log of changes</span>
+      <span class="linkdescr">what's new</span>
       </p>
       <p class="biglink"><a class="biglink" href="{{ pathto("upgrade-guide/index") }}">Upgrade Guide</a><br/>
       <span class="linkdescr">moving to Bazaar 2.x</span>
@@ -39,33 +36,23 @@
 
   <table class="contentstable" align="center" style="margin-left: 30px"><tr>
     <td width="50%">
-      <p class="biglink"><a class="biglink" href="http://doc.bazaar.canonical.com/explorer/en/guide/">Desktop Guide</a><br/>
-      <span class="linkdescr">how to use our GUI applications</span>
-      </p>
-        <p class="biglink"><a class="biglink" href="https://answers.launchpad.net/bzr/+faqs">FAQ</a><br/>
+        <p class="biglink"><a class="biglink" href="https://answers.launchpad.net/bzr">FAQ</a><br/>
       <span class="linkdescr">frequently asked questions</span>
       </p>
-      <p class="biglink"><a class="biglink" href="http://bazaar.canonical.com/BzrGlossary/">Glossary</a><br/>
+      <p class="biglink"><a class="biglink" href="http://bazaar-vcs.org/BzrGlossary/">Glossary</a><br/>
       <span class="linkdescr">help with terminology</span>
       </p>
-    </td>
-    <td width="50%">
-      <p class="biglink"><a class="biglink" href="../developers/">Developer Docs</a><br/>
-        <span class="linkdescr">improving and extending bzr</span>
-      </p>
-      <p class="biglink"><a class="biglink" href="http://doc.bazaar.canonical.com/migration/en/">Migration Docs</a><br/>
+    </td><td width="50%">
+      <p class="biglink"><a class="biglink" href="http://doc.bazaar-vcs.org/migration/en/">Migration Docs</a><br/>
       <span class="linkdescr">for refugees of other tools</span>
       </p>
-      <p class="biglink"><a class="biglink" href="http://doc.bazaar.canonical.com/plugins/en/">Plugins Guide</a><br/>
+      <p class="biglink"><a class="biglink" href="http://doc.bazaar-vcs.org/plugins/en/">Plugins Guide</a><br/>
       <span class="linkdescr">help on popular plugins</span>
       </p>
     </td></tr>
-
-    <tr><td colspan="2">
-	These documents are also available in <a href="../es/index.html">Spanish</a>,
-	<a href="../ja/index.html">Japanese</a>, 
-	and <a href="../ru/index.html">Russian</a>.
-    </td></tr>
   </table>
 
+  <p>Keen to help? See the <a href="http://doc.bazaar-vcs.org/developers/">Developer Docs</a>
+      for policies and tools on contributing code, tests and documentation.</p>
+
 {% endblock %}

=== modified file 'doc/en/_templates/layout.html'
--- doc/en/_templates/layout.html	2010-03-02 10:21:39 +0000
+++ doc/en/_templates/layout.html	2009-10-30 07:51:16 +0000
@@ -1,8 +1,27 @@
 {% extends "!layout.html" %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar.canonical.com/">
+<li><a href="http://bazaar-vcs.org/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Home</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar.canonical.com/en/">Documentation</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar-vcs.org/en/">Documentation</a>&nbsp;|&nbsp;</li>
+{{ super() }}
+{% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
 {{ super() }}
 {% endblock %}

=== modified file 'doc/en/admin-guide/hooks-plugins.txt'
--- doc/en/admin-guide/hooks-plugins.txt	2010-03-01 05:15:11 +0000
+++ doc/en/admin-guide/hooks-plugins.txt	2009-12-11 15:04:15 +0000
@@ -22,7 +22,7 @@
 purposes, as well as for backups and mirroring.
 
 Information on the whole range of Bazaar plugins is available at
-http://doc.bazaar.canonical.com/plugins/en/.  For purposes of installation,
+http://doc.bazaar-vcs.org/en/plugin-guide.  For purposes of installation,
 plugins are simply python packages.  They can be installed alongside Bazaar in
 the ``bzrlib.plugins`` package using each plugin's ``setup.py``.  They can
 also be installed in the plugin path which is the user's ``~/.bazaar/plugins``

=== modified file 'doc/en/conf.py'
--- doc/en/conf.py	2010-03-03 04:18:28 +0000
+++ doc/en/conf.py	2009-12-07 21:51:01 +0000
@@ -28,12 +28,10 @@
         u'Bazaar User Reference': None,
         u'Bazaar Release Notes': None,
         u'Bazaar Upgrade Guide': None,
-        u"Bazaar System Administrator's Guide": None,
         u'Bazaar in five minutes': None,
         u'Bazaar Tutorial': None,
         u'Using Bazaar With Launchpad': None,
         u'Centralized Workflow Tutorial': None,
-        u"What's New in Bazaar 2.1?": None,
     }
 def bzr_title(s):
     return bzr_titles.get(s) or s
@@ -60,8 +58,6 @@
     bzr_title(u'Bazaar Release Notes'), bzr_team, 'manual'),
   ('upgrade-guide/index', 'bzr-%s-upgrade-guide.tex' % (bzr_locale,),
     bzr_title(u'Bazaar Upgrade Guide'), bzr_team, 'manual'),
-  ('admin-guide/index', 'bzr-%s-admin-guide.tex' % (bzr_locale,),
-    bzr_title(u"Bazaar System Administrator's Guide"), bzr_team, 'manual'),
   # Tutorials
   ('mini-tutorial/index', 'bzr-%s-tutorial-mini.tex' % (bzr_locale,),
     bzr_title(u'Bazaar in five minutes'), bzr_team, 'howto'),
@@ -73,8 +69,6 @@
   ('tutorials/centralized_workflow',
     'bzr-%s-tutorial-centralized.tex' % (bzr_locale,),
     bzr_title(u'Centralized Workflow Tutorial'), bzr_team, 'howto'),
-  ('whats-new/whats-new-in-2.1', 'bzr-%s-whats-new.tex' % (bzr_locale,),
-    bzr_title(u"What's New in Bazaar 2.1?"), bzr_team, 'howto'),
 ]
 
 # List of documents that shouldn't be included in the build.

=== modified file 'doc/en/index.txt'
--- doc/en/index.txt	2010-03-04 04:15:18 +0000
+++ doc/en/index.txt	2009-12-07 18:12:21 +0000
@@ -10,7 +10,6 @@
 .. toctree::
    :maxdepth: 1
 
-   whats-new/whats-new-in-2.2
    user-guide/index
    tutorials/index
    quick-reference/index

=== modified file 'doc/en/user-guide/branching_a_project.txt'
--- doc/en/user-guide/branching_a_project.txt	2010-03-22 00:29:50 +0000
+++ doc/en/user-guide/branching_a_project.txt	2009-12-02 20:34:07 +0000
@@ -30,17 +30,6 @@
 `URL Identifiers <../user-reference/bzr_man.html#url-identifiers>`_
 section of the Bazaar User Reference.
 
-URLs are normally resolved relative to the root directory of the server,
-so ``ftp://example.com/repo/foo`` means the ``/repo/foo`` directory of
-that host.  (We say 'normally' because some server software like Apache
-can be configured to remap URLs arbitrarily, in which case you'll need to
-look at the server configuration to find out which URL corresponds to
-which directory.)
-
-To address a path relative to your home directory on the server, use a
-tilde like so: ``sftp://example.com/~/public_html`` should map to
-``public_html`` within your home directory.
-
 A reminder about shared repositories
 ------------------------------------
 

=== modified file 'doc/en/user-guide/hooks.txt'
--- doc/en/user-guide/hooks.txt	2010-04-22 07:35:06 +0000
+++ doc/en/user-guide/hooks.txt	2008-10-29 06:10:45 +0000
@@ -8,18 +8,18 @@
 perform actions before or after certain Bazaar operations.  The operations
 include ``commit``, ``push``, ``pull``, and ``uncommit``.
 For a complete list of hooks and their parameters, see `Hooks
-<../user-reference/hooks-help.html>`_ in the User Reference.
+<../user-reference/bzr_man.html#hooks>`_ in the User Reference.
 
 Most hooks are run on the client, but a few are run on the server.  (Also
-see the `push-and-update plugin`_ that handles one special case of
+see the `bzr-push-and-update`_ plugin that handles one special case of
 server-side operations.)
 
-.. _push-and-update plugin: http://doc.bazaar.canonical.com/plugins/en/push-and-update-plugin.html
+.. _bzr-push-and-update: https://launchpad.net/bzr-push-and-update/
 
 Using hooks
 -----------
 
-To use a hook, you should `write a plugin`_.  Instead of
+To use a hook, you should `write a plugin <#writing-a-plugin>`_.  Instead of
 creating a new command, this plugin will define and install the hook.  Here's
 an example::
 
@@ -33,8 +33,6 @@
     branch.Branch.hooks.install_named_hook('post_push', post_push_hook,
                                      'My post_push hook')
 
-.. _write a plugin: http://doc.bazaar.canonical.com/plugins/en/plugin-development.html
-
 To use this example, create a file named ``push_hook.py``, and stick it in
 ``plugins`` subdirectory of your configuration directory.  (If you have never
 installed any plugins, you may need to create the ``plugins`` directory).
@@ -57,45 +55,6 @@
 Debugging hooks
 ---------------
 
-To get a list of installed hooks (and available hook points), use the hidden
-``hooks`` command::
+To get a list of installed hooks, use the hidden ``hooks`` command::
 
     bzr hooks
-
-
-Example: a merge plugin
------------------------
-
-Here's a complete plugin that demonstrates the ``Merger.merge_file_content``
-hook.  It installs a hook that forces any merge of a file named ``*.xml``
-to be a conflict, even if Bazaar thinks it can merge it cleanly.
-
-``merge_xml.py``::
-
-  """Custom 'merge' logic for *.xml files.
-  
-  Always conflicts if both branches have changed the file.
-  """
-  
-  from bzrlib.merge import PerFileMerger, Merger
-  
-  def merge_xml_files_hook(merger):
-      """Hook to merge *.xml files"""
-      return MergeXMLFiles(merger)
-  
-  class AlwaysConflictXMLMerger(PerFileMerger):
-  
-      def file_matches(self, params):
-          filename = self.get_filename(params, self.merger.this_tree)
-          return filename.endswith('.xml')
-  
-      def merge_matching(self, params):
-          return 'conflicted', params.this_lines
-  
-  Merger.hooks.install_named_hook(
-      'merge_file_content', merge_xml_files_hook, '*.xml file merge')
-
-``merge_file_content`` hooks are executed for each file to be merged.  For
-a more a complex example look at the ``news_merge`` plugin that's bundled with
-Bazaar in the ``bzrlib/plugins`` directory.
-

=== modified file 'doc/en/user-guide/http_smart_server.txt'
--- doc/en/user-guide/http_smart_server.txt	2010-02-26 18:47:48 +0000
+++ doc/en/user-guide/http_smart_server.txt	2009-12-02 20:34:07 +0000
@@ -1,8 +1,8 @@
-Serving Bazaar with Apache
-==========================
+Serving Bazaar with FastCGI
+===========================
 
 This document describes one way to set up a Bazaar HTTP smart server,
-using Apache 2.0 and FastCGI or mod_python or mod_wsgi.
+using Apache 2.0 and FastCGI or mod_python.
 
 For more information on the smart server, and other ways to configure it
 see the main `smart server documentation`_.
@@ -117,32 +117,6 @@
 .. _mod_python: http://www.modpython.org/
 
 
-mod_wsgi
-~~~~~~~~
-
-First, configure mod_wsgi, e.g. enabling the mod with a2enmod wsgi.
-We need to change it to handle all requests for URLs ending in `.bzr/smart`.  It
-will look like::
-
-    WSGIScriptAliasMatch ^/code/.*/\.bzr/smart$ /srv/example.com/scripts/bzr.wsgi
-
-    #The three next lines allow regular GETs to work too
-    RewriteEngine On
-    RewriteCond %{REQUEST_URI} !^/code/.*/\.bzr/smart$
-    RewriteRule ^/code/(.*/\.bzr/.*)$ /srv/example.com/www/code/$1 [L]
-
-    <Directory /srv/example.com/www/code>
-        WSGIApplicationGroup %{GLOBAL}
-    </Directory>
-
-This instructs Apache to hand requests for any URL ending with `/.bzr/smart`
-inside `/code` to a Bazaar smart server via WSGI, and any other URL inside
-`/code` to be served directly by Apache.
-
-Refer to the mod_wsgi_ documentation for further information.
-
-.. _mod_wsgi: http://code.google.com/p/modwsgi/
-
 Configuring Bazaar
 ------------------
 
@@ -197,35 +171,16 @@
         return wsgi_server.run(request)
 
 The `modpywsgi` module can be found at
-http://ice.usq.edu.au/svn/ice/trunk/apps/ice-server/modpywsgi.py. It was
+http://dev.pocoo.org/projects/pocoo/browser/pocoo/wrappers/modpy.py. It is
 part of pocoo_. You sould make sure you place modpywsgi.py in the same
 directory as bzr-smart.py (ie. /srv/example.com/scripts/).
 
 .. _pocoo: http://dev.pocoo.org/projects/pocoo/
 
-
-mod_wsgi
-~~~~~~~~
-
-We've configured Apache to run the smart server at
-`/srv/example.com/scripts/bzr.wsgi`.  This is just a simple script we need
-to write to configure a smart server, and glue it to the WSGI gateway.
-Here's what it looks like::
-
-    from bzrlib.transport.http import wsgi
-
-    def application(environ, start_response):
-        app = wsgi.make_app(
-            root="/srv/example.com/www/code/",
-            prefix="/code",
-            readonly=True,
-            enable_logging=False)
-        return app(environ, start_response)
-
 Clients
 -------
 
-Now you can use `bzr+http://` URLs or just `http://` URLs, e.g.::
+Now you can use `bzr+http://` URLs, e.g.::
 
     bzr log bzr+http://example.com/code/my-branch
 
@@ -233,6 +188,7 @@
 
     bzr log http://example.com/code/my-branch
 
+
 Advanced configuration
 ----------------------
 
@@ -260,41 +216,21 @@
 .. _WSGI standard: http://www.python.org/dev/peps/pep-0333/
 
 
-Pushing over the http smart server
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+Pushing over ``bzr+http://``
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 It is possible to allow pushing data over the http smart server. The
 easiest way to do this, is to just supply ``readonly=False`` to the
 ``wsgi.make_app()`` call. But be careful, because the smart protocol does
 not contain any Authentication. So if you enable write support, you will
 want to restrict access to ``.bzr/smart`` URLs to restrict who can
-actually write data on your system, e.g. in apache it looks like::
-
-    <Location /code>
-        AuthType Basic
-        AuthName "example"
-        AuthUserFile /srv/example.com/conf/auth.passwd
-        <LimitExcept GET>
-            Require valid-user
-        </LimitExcept>
-    </Location>
-
-At this time, it is not possible to allow some people to have read-only
-access and others to have read-write access to the same urls. Because at
-the HTTP layer (which is doing the Authenticating), everything is just a
-POST request.  However, it would certainly be possible to have HTTPS
-require authentication and use a writable server, and plain HTTP allow
-read-only access.
-
-If bzr gives an error like this when accessing your HTTPS site::
-
-  bzr: ERROR: Connection error: curl connection error (server certificate verification failed.
-  CAfile:/etc/ssl/certs/ca-certificates.crt CRLfile: none)
-
-You can workaround it by using ``https+urllib`` rather than ``http`` in your
-URL, or by uninstalling pycurl.  See `bug 82086`_ for more details.
-
-.. _bug 82086: https://bugs.launchpad.net/bzr/+bug/82086
+actually write data on your system.  At this time, it is not possible to
+allow some people to have read-only access and others to have read-write
+access to the same urls. Because at the HTTP layer (which is doing the
+Authenticating), everything is just a POST request.  However, it would
+certainly be possible to have HTTPS require authentication and use a
+writable server, and plain HTTP allow read-only access.
+
 
 ..
    vim: ft=rst tw=74 et

=== modified file 'doc/en/user-guide/introducing_bazaar.txt'
--- doc/en/user-guide/introducing_bazaar.txt	2010-03-11 04:33:41 +0000
+++ doc/en/user-guide/introducing_bazaar.txt	2010-01-04 02:25:11 +0000
@@ -134,7 +134,7 @@
 details on the commands and options available.
 
 .. _Bazaar in five minutes: ../mini-tutorial/index.html
-.. _Bazaar Quick Start Card: ../quick-reference/index.html
+.. _Bazaar Quick Start Card: ../quick-reference/quick-start-summary.svg
 .. _Bazaar User Reference: ../user-reference/index.html
 
 We hope you find this manual useful. If you have suggestions on how it

=== modified file 'doc/en/user-guide/stacked.txt'
--- doc/en/user-guide/stacked.txt	2010-03-25 07:34:15 +0000
+++ doc/en/user-guide/stacked.txt	2009-12-02 20:34:07 +0000
@@ -1,28 +1,15 @@
 Using stacked branches
 ======================
 
-Motivation
-----------
-
-If you are working on a project, and you have read access to whose
-public repository but do not have write access to it, using stacked
-branches to backup/publish your work onto the same host of the public
-repository might be an option for you.
-
-Other scenarios for stacked branch usage include experimental branches
-and code hosting sites. For these scenarios, stacked branches are
-ideal because of the benefits it provides.
-
-
 What is a stacked branch?
 -------------------------
 
-A stacked branch is a branch that knows how to find revisions in
-another branch (the stacked-on branch). Stacked branches store just
-the unique revisions that are not in the stacked-on branch, making
-them faster to create and more storage efficient. In these respects,
-stacked branches are similar to shared repositories. However, stacked
-branches have additional benefits:
+A stacked branch is a branch that knows how to find revisions
+in another branch. Stacked branches store just the
+unique revisions, making them faster to create and more
+storage efficient. In these respects, stacked branches are
+similar to shared repositories. However, stacked branches have
+additional benefits:
 
 * The new branch can be in a completely different location to the
   branch being stacked on.
@@ -34,6 +21,9 @@
   repository can be physically readonly to developers committing to stacked
   branches.
 
+These benefits make stacked branches ideal for various scenarios
+including experimental branches and code hosting sites.
+
 
 Creating a stacked branch
 -------------------------
@@ -73,47 +63,27 @@
 
 This creates a new branch at ``my-url`` that is stacked on ``reference-url``
 and only contains the revisions in the current branch that are not already
-in the branch at ``reference-url``. In particular, ``my-url`` and
-``reference-url`` can be on the same host, and the ``--stacked`` option
-can be used additionally to inform ``push`` to reference the
-revisions in ``reference-url``. For example::
-
-  bzr push --stacked-on sftp://host/project --stacked sftp://host/user/stacked-branch
-
-This usage fits the scenario described in the Motivation section.
-
-
-.. The following text is hidden because bug 375013 breaks the example.
-   When bug 375013 is fixed, we should unhide this text.
-      - Andrew Bennetts, 10 March 2010
-
-.. If the local branch was created as a stacked branch, then you can
-.. use the ``--stacked`` option to ``push`` and the *stacked-on* location
-.. will be implicit. For example::
-.. 
-..   bzr branch --stacked source-url my-dir
-..   cd my-dir
-..   (hack, hack, hack)
-..   bzr commit -m "fix bug"
-..   bzr push --stacked
+in the branch at ``reference-url``.
+
+If the local branch was created as a stacked branch, then you can
+use the ``--stacked`` option to ``push`` and the *stacked-on* location
+will be implicit. For example::
+
+  bzr branch --stacked source-url my-dir
+  cd my-dir
+  (hack, hack, hack)
+  bzr commit -m "fix bug"
+  bzr push --stacked
 
 
 Limitations of stacked branches
 -------------------------------
 
-Currently, you cannot commit to a stacked branch, due to `bug 375013`_.
-
-.. _bug 375013: https://bugs.launchpad.net/bzr/+bug/375013
-
 The important thing to remember about a stacked branch is that the
 stacked-on branch needs to be available for almost all operations. This is
 not an issue when both branches are local or both branches are on the
 same server.
 
-Similarly, because most of the history is stored in the stacked-on repository,
-operations like ``bzr log`` can be slower when the stacked-on repository is
-accessed via a network.
-
 
 Changing branch stacking
 ------------------------

=== modified file 'doc/en/user-guide/writing_a_plugin.txt'
--- doc/en/user-guide/writing_a_plugin.txt	2010-04-21 07:52:31 +0000
+++ doc/en/user-guide/writing_a_plugin.txt	2009-08-20 13:26:36 +0000
@@ -22,14 +22,6 @@
 ``bzrlib.commands.register_command(cmd_foo)``.  You must register the
 command when your file is imported, otherwise bzr will not see it.
 
-Installing a hook
------------------
-
-See `Using hooks`_.
-
- .. _Using hooks: hooks.txt
-
-
 Specifying a plugin version number
 ----------------------------------
 Simply define ``version_info`` to be a tuple defining the current version

=== removed directory 'doc/en/whats-new'
=== removed file 'doc/en/whats-new/whats-new-in-2.1.txt'
--- doc/en/whats-new/whats-new-in-2.1.txt	2010-02-19 05:08:31 +0000
+++ doc/en/whats-new/whats-new-in-2.1.txt	1970-01-01 00:00:00 +0000
@@ -1,202 +0,0 @@
-What's New in Bazaar 2.1?
-=========================
-
-This document outlines the major improvements in Bazaar 2.1
-vs Bazaar 2.0. As well as summarizing improvements made to
-the core product, it highlights enhancements within the broader
-Bazaar world of potential interest to those upgrading.
-
-Bazaar 2.1.0 marks the start of our second long-term-stable series.
-This series will be supported with bug fixes for the next 12 months.
-All users are encouraged to upgrade from the 2.0.x stable series.
-
-
-Better efficiency
------------------
-
-Many operations now consume less memory. Several operations are
-also faster including branching, logging merged revisions and
-upgrading from pre-2a to 2a format.
-
-
-New command options
--------------------
-
-Several commands have new options. These include:
-
-===========     ==============  ======================================
-Command         Option            Description
-===========     ==============  ======================================
-branch          bind            Bind to the source location
-commit          commit-time     Give an explicit commit timestamp
-switch          revision        Switch to a particular revision
-unshelve        keep            Apply changes but don't delete them
-unshelve        preview         Show the diff that would result from
-                                unshelving
-update          revision        Update to a particular revision
-===========     ==============  ======================================
-
-Other command improvements include:
-
-* A :doc:`../user-reference/shelve-help` editor can be defined to provide shelf functionality at
-  a granularity finer than per-patch hunk.
-
-* :doc:`../user-reference/send-help` send now supports the OS X Mail application.
-
-See the help for the commands above for further details.
-
-
-Per-file merge hooks
---------------------
-
-Hooks can now be defined for smart merging of selected file types.
-This enables easier merging of ChangeLogs, Release Notes and other
-file that frequently conflict.
-
-
-DWIM revision identifiers
--------------------------
-
-Revision identifiers can now be given in a *Do-What-I-Mean* style.
-For example, you can now just give a tag (instead of saying ``tag:xxx``)
-or just say ``today`` (instead of saying ``date:today``). Prefixes
-are now only required if the revision spec could be ambiguous.
-
-
-New ignore patterns
--------------------
-
-Patterns prefixed with ``!`` are exceptions to ignore patterns and
-take precedence over regular ignores. Such exceptions are used to
-specify files that should be versioned which would otherwise be
-ignored. Patterns prefixed with ``!!`` act as regular ignore patterns,
-but have highest precedence, even over the ``!`` exception patterns. 
-
-
-Smart server home directory support
------------------------------------
-
-``bzr+ssh`` and ``bzr`` paths can now be relative to home directories
-specified in the URL.  Paths starting with a path segment of ``~`` are
-relative to the home directory of the user running the server, and paths
-starting with ``~user`` are relative to the home directory of the named
-user.  For example, for a user "bob" with a home directory of
-``/home/bob``, these URLs are all equivalent:
-
-* ``bzr+ssh://bob@host/~/repo``
-* ``bzr+ssh://bob@host/~bob/repo``
-* ``bzr+ssh://bob@host/home/bob/repo``
-
-If ``bzr serve`` was invoked with a ``--directory`` argument, then no
-home directories outside that directory will be accessible via this
-method.
-
-This is a feature of ``bzr serve``, so pre-2.1 clients will
-automatically benefit from this feature when ``bzr`` on the server is
-upgraded.
-
-
-Generalized glob support on Windows
------------------------------------
-
-On Windows, glob expansion is now handled in a universal way across
-all commands. In previous versions, it was explicitly handed by just
-a few commands, e.g. ``add``. A side effect of this change is that
-patterns now need to be quoted when passed to the ``ignore`` command,
-e.g. ``bzr ignore *.foo`` now needs to be given as ``bzr ignore "*.foo"``.
-
-
-Improved Git and Mercurial interoperability
--------------------------------------------
-
-Many improvements have been made to the git_ and hg_ plugins.
-With these plugins installed, most Git and Mercurial repositories
-can now be read by standard Bazaar clients. Changes can also
-be written back via the dpush command.
-
-.. _git: http://doc.bazaar.canonical.com/plugins/en/git-plugin.html
-.. _hg: http://doc.bazaar.canonical.com/plugins/en/hg-plugin.html
-
-
-Metaprojects
-------------
-
-New plugins are available for constructing larger projects
-from smaller ones. These include:
-
-* builder_ - construction of a branch using recipes
-* externals_ - Subversion-style external branches
-
-.. note::
-
-   The builder plugin has been designed to complement the builddeb_
-   plugin to streamline Debian source package management. It may also
-   be useful for building test images for a QA team or disk images
-   for installers, say.
-
-.. _builder: http://doc.bazaar.canonical.com/plugins/en/builder-plugin.html
-.. _externals: http://doc.bazaar.canonical.com/plugins/en/externals-plugin.html
-.. _builddeb: http://doc.bazaar.canonical.com/plugins/en/builddeb-plugin.html
-
-
-Colocated branch workspaces
----------------------------
-
-A colocated workspace is one where a single working tree is used
-across one or more branches managed at that same location. This
-is now supported by the new colo_ plugin and by Bazaar Explorer.
-
-.. _colo: http://doc.bazaar.canonical.com/plugins/en/colo-plugin.html
-
-
-Better documentation
---------------------
-
-A :doc:`../admin-guide/index` covering topics such as setting up servers,
-security, backups and email integration has been added.
-
-A large number of documentation bugs have been fixed, clarifying
-numerous issues and filling in some missing holes.
-
-The :doc:`../user-reference/index`
-has been organized into topics making it easier to
-navigate through and print selected sections of.
-
-To assist users migrating from other tools, a
-`Survival Guide <http://doc.bazaar.canonical.com/migration/en/survival/index.html>`_
-has been published explaining Bazaar to users of other tools in terms they
-already know. Sections are provided for existing users of 
-CVS, Subversion, ClearCase, Perforce, Visual SourceSafe, Git, Mercurial,
-Darcs and Monotone.
-
-Selected documents have also been translated to Japanese.
-
-
-Enhanced GUI clients
---------------------
-
-Numerous enhancements have been made to most of our GUIs including
-Bazaar Explorer, TortoiseBZR and the QBzr-Eclipse add-on. These
-applications all build on top of improvements made to QBzr. Bzr-gtk
-has also been improved.
-
-Bazaar Explorer has over a dozen new features including smart toolbars,
-support for all bzr commands (including those in plugins),
-a better working tree browser and a submit delta report showing the
-cumulative effect of a series of commits.
-See `What's New in Bazaar Explorer 1.0?
-<http://doc.bazaar.canonical.com/explorer/en/whats-new/whats-new-in-1.0.html>`_
-for more information.
-
-
-Further information
--------------------
-
-For more detailed information on the changes made, be sure to check
-the :doc:`../release-notes/index` for:
-
-* the interim bzr `milestones <https://launchpad.net/bzr/2.1>`_
-* the plugins you use.
-
-Enjoy,
-The Bazaar Development Team

=== removed file 'doc/en/whats-new/whats-new-in-2.2.txt'
--- doc/en/whats-new/whats-new-in-2.2.txt	2010-03-04 04:15:18 +0000
+++ doc/en/whats-new/whats-new-in-2.2.txt	1970-01-01 00:00:00 +0000
@@ -1,70 +0,0 @@
-What's New in Bazaar 2.2?
-=========================
-
-This document outlines the major improvements in Bazaar 2.2
-vs Bazaar 2.1. As well as summarizing improvements made to
-the core product, it highlights enhancements within the broader
-Bazaar world of potential interest to those upgrading.
-
-.. warning::
-
-   Bazaar 2.2.0 is currently in development. While less stable than
-   Bazaar 2.1.x, we aim to keep quality at a high level:
-
-   * Monthly beta releases should be suitable for early adopters of new
-     features.
-
-   * Nightly builds are suitable for users interested in assisting
-     with testing.
-
-   If it doubt, please use the latest 2.1 release instead.
-
-
-Improved conflict handling
---------------------------
-
-Tree-shape conflicts can be resolved by providing ``--take-this`` and
-``--take-other`` to the ``bzr resolve`` command. Just marking the conflict
-as resolved is still accessible via the ``--done`` default action.
-
-
-Improved Launchpad integration
-------------------------------
-
-Merges can be proposed on Launchpad with the new **lp-propose-merge**
-command.
-
-
-Notable plugin enhancements
----------------------------
-
-The grep plugin ...
-
-
-Better documentation
---------------------
-
-Numerous improvements have been made to the developer documentation.
-
-
-Enhanced GUI clients
---------------------
-
-(Details coming soon.)
-
-
-Further information
--------------------
-
-For more detailed information on the changes made, be sure to check
-the :doc:`../release-notes/index` for:
-
-* the interim bzr `milestones <https://launchpad.net/bzr/2.2>`_
-* the plugins you use.
-
-For a summary of changes made in earlier releases, see:
-
-* :doc:`whats-new-in-2.1`
-
-Enjoy,
-The Bazaar Development Team

=== modified file 'doc/es/_static/es/bzr-es-quick-reference.svg'
--- doc/es/_static/es/bzr-es-quick-reference.svg	2010-01-29 10:36:23 +0000
+++ doc/es/_static/es/bzr-es-quick-reference.svg	2009-09-09 00:49:50 +0000
@@ -1672,7 +1672,7 @@
         <a
            id="a6316"
            style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar.canonical.com">
+           xlink:href="http://bazaar-vcs.org">
           <text
              sodipodi:linespacing="100%"
              id="text6302"
@@ -1683,7 +1683,7 @@
                y="97.901367"
                x="787.79535"
                id="tspan6304"
-               sodipodi:role="line">http://bazaar.canonical.com</tspan></text>
+               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
         </a>
       </g>
     </g>

=== modified file 'doc/es/_templates/layout.html'
--- doc/es/_templates/layout.html	2010-03-02 10:21:39 +0000
+++ doc/es/_templates/layout.html	2009-10-30 07:51:16 +0000
@@ -1,8 +1,27 @@
 {% extends "!layout.html" %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar.canonical.com/">
+<li><a href="http://bazaar-vcs.org/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Inicio</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar.canonical.com/">Documentación</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar-vcs.org/en/">Documentación</a>&nbsp;|&nbsp;</li>
+{{ super() }}
+{% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
 {{ super() }}
 {% endblock %}

=== modified file 'doc/index.es.txt'
--- doc/index.es.txt	2010-02-23 03:06:44 +0000
+++ doc/index.es.txt	2009-12-02 20:34:07 +0000
@@ -3,7 +3,7 @@
 ==================================
 
 Las ultimas versiones de estos documentos se encuentran disponibles
-en la pagina de  Bazaar, http://doc.bazaar.canonical.com/.
+en la pagina de  Bazaar, http://doc.bazaar-vcs.org.
 
 Documentacion Principal
 =======================

=== modified file 'doc/index.ja.txt'
--- doc/index.ja.txt	2010-02-23 03:06:44 +0000
+++ doc/index.ja.txt	2009-10-29 10:01:19 +0000
@@ -2,7 +2,7 @@
 Bazaarのメインドキュメント
 ===========================
 
-これらのドキュメントの最新版はBazaarのドキュメントのサイト、 http://doc.bazaar.canonical.com/ から入手可能で、
+これらのドキュメントの最新版はBazaarのドキュメントのサイト、 http://doc.bazaar-vcs.org/ から入手可能で、
 詳しい情報は http://bazaar-vcs.org/Documentation のページからリンクされています。
 
 

=== modified file 'doc/index.ru.txt'
--- doc/index.ru.txt	2010-02-23 03:06:44 +0000
+++ doc/index.ru.txt	2009-12-02 20:34:07 +0000
@@ -3,7 +3,7 @@
 =================================
 
 Последняя версия этих документов доступа со страницы документации
-на сайте Bazaar, <http://doc.bazaar.canonical.com/>. Еще больше информации
+на сайте Bazaar, <http://doc.bazaar-vcs.org/>. Еще больше информации
 можно получить по адресу <http://bazaar-vcs.org/Documentation>.
 
 Основная документация

=== modified file 'doc/index.txt'
--- doc/index.txt	2010-02-23 03:06:44 +0000
+++ doc/index.txt	2009-10-29 10:01:19 +0000
@@ -3,7 +3,7 @@
 ============================
 
 The latest version of these documents are available from Bazaar's
-documentation site, <http://doc.bazaar.canonical.com/>, and more documentation
+documentation site, <http://doc.bazaar-vcs.org/>, and more documentation
 may be linked from <http://bazaar-vcs.org/Documentation>.
 
 Core Documentation

=== modified file 'doc/ja/tutorials/centralized_workflow.txt'
--- doc/ja/tutorials/centralized_workflow.txt	2010-02-17 07:15:12 +0000
+++ doc/ja/tutorials/centralized_workflow.txt	2009-10-29 16:52:18 +0000
@@ -72,7 +72,7 @@
   % bzr init-repo --no-trees sftp://centralhost/srv/bzr/
 
 この手順は、新しくcvsrootやSubversionのリポジトリを作るのと同じようなものだと考えることができます。
-``--no-tree`` オプションの指定によって、ワーキングツリーを作らないようになります。
+{{{--no-tree}}} オプションの指定によって、ワーキングツリーを作らないようになります。
 中央リポジトリ内のブランチを直接変更することは無いので、このオプションを指定しておくとよいでしょう。
 
 

=== modified file 'doc/ru/_static/ru/bzr-ru-quick-reference.svg'
--- doc/ru/_static/ru/bzr-ru-quick-reference.svg	2010-01-29 10:36:23 +0000
+++ doc/ru/_static/ru/bzr-ru-quick-reference.svg	2009-09-09 00:49:50 +0000
@@ -1582,7 +1582,7 @@
         <a
            id="a6316"
            style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar.canonical.com">
+           xlink:href="http://bazaar-vcs.org">
           <text
              sodipodi:linespacing="100%"
              id="text6302"
@@ -1593,7 +1593,7 @@
                y="97.901367"
                x="787.79535"
                id="tspan6304"
-               sodipodi:role="line">http://bazaar.canonical.com</tspan></text>
+               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
         </a>
       </g>
     </g>

=== modified file 'doc/ru/_templates/layout.html'
--- doc/ru/_templates/layout.html	2010-03-02 10:21:39 +0000
+++ doc/ru/_templates/layout.html	2009-10-30 07:51:16 +0000
@@ -1,8 +1,27 @@
 {% extends "!layout.html" %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar.canonical.com/">
+<li><a href="http://bazaar-vcs.org/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Главная</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar.canonical.com/ru/">Документация</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar-vcs.org/ru/">Документация</a>&nbsp;|&nbsp;</li>
+{{ super() }}
+{% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
 {{ super() }}
 {% endblock %}

=== modified file 'doc/ru/tutorials/centralized_workflow.txt'
--- doc/ru/tutorials/centralized_workflow.txt	2010-02-17 07:15:12 +0000
+++ doc/ru/tutorials/centralized_workflow.txt	2009-12-02 20:34:07 +0000
@@ -90,7 +90,7 @@
   % bzr init-repo --no-trees sftp://centralhost/srv/bzr/
 
 Можно рассматривать этот шаг как похожий на установку CVSROOT, или
-репозитория Subversion. Опция ``--no-trees`` указывает Bazaar не
+репозитория Subversion. Опция {{{--no-trees}}} указывает Bazaar не
 создавать рабочий каталог в репозитории. Нам это подходит, т.к. никто
 не будет напрямую что-то изменять на ветках в центральном репозитории.
 

=== modified file 'profile_imports.py'
--- profile_imports.py	2010-02-11 04:02:41 +0000
+++ profile_imports.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008, 2009, 2010 by Canonical Ltd
+# Copyright (C) 2006 by Canonical Ltd
 # Written by John Arbash Meinel <john@arbash-meinel.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -17,17 +17,11 @@
 
 """A custom importer and regex compiler which logs time spent."""
 
+import sre
 import sys
 import time
 
 
-if sys.version_info < (2, 5, 0):
-    import sre
-    re = sre
-else:
-    import re
-
-
 _parent_stack = []
 _total_stack = {}
 _info = {}
@@ -64,8 +58,7 @@
 
 def log_stack_info(out_file, sorted=True, hide_fast=True):
     # Find all of the roots with import = 0
-    out_file.write('%5s %5s %-40s @ %s:%s\n'
-        % ('cum', 'inline', 'name', 'file', 'line'))
+    out_file.write(' cum  inline name\t\t\t\t\t\tframe\n')
     todo = [(value[-1], key) for key,value in _info.iteritems() if value[0] == 0]
 
     if sorted:
@@ -90,10 +83,9 @@
 
         # indent, cum_time, mod_time, name,
         # scope_name, frame_name, frame_lineno
-        out_file.write('%5.1f %5.1f %-40s @ %s:%d\n'
-            % (info[-1]*1000., mod_time*1000.,
-               ('+'*info[0] + cur[1]),
-               info[1], info[2]))
+        out_file.write('%5.1f %5.1f %s %-35s\t@ %s:%d\n'
+            % (info[-1]*1000., mod_time*1000., '+'*info[0], 
+               cur[1][:35], info[1], info[2]))
 
         if sorted:
             c_times.sort()
@@ -104,32 +96,23 @@
 
 _real_import = __import__
 
-def timed_import(name, globals=None, locals=None, fromlist=None, level=None):
+def timed_import(name, globals, locals, fromlist):
     """Wrap around standard importer to log import time"""
-    # normally there are 4, but if this is called as __import__ eg by
-    # /usr/lib/python2.6/email/__init__.py then there may be only one
-    # parameter
-    # level is only passed by python2.6
 
-    if globals is None:
-        # can't determine the scope name afaics; we could peek up the stack to
-        # see where this is being called from, but it should be a rare case.
-        scope_name = None
+    scope_name = globals.get('__name__', None)
+    if scope_name is None:
+        scope_name = globals.get('__file__', None)
+    if scope_name is None:
+        scope_name = globals.keys()
     else:
-        scope_name = globals.get('__name__', None)
-        if scope_name is None:
-            scope_name = globals.get('__file__', None)
-        if scope_name is None:
-            scope_name = globals.keys()
-        else:
-            # Trim out paths before bzrlib
-            loc = scope_name.find('bzrlib')
-            if loc != -1:
-                scope_name = scope_name[loc:]
-            # For stdlib, trim out early paths
-            loc = scope_name.find('python2.4')
-            if loc != -1:
-                scope_name = scope_name[loc:]
+        # Trim out paths before bzrlib
+        loc = scope_name.find('bzrlib')
+        if loc != -1:
+            scope_name = scope_name[loc:]
+        # For stdlib, trim out early paths
+        loc = scope_name.find('python2.4')
+        if loc != -1:
+            scope_name = scope_name[loc:]
 
     # Figure out the frame that is doing the importing
     frame = sys._getframe(1)
@@ -162,8 +145,7 @@
     return mod
 
 
-_real_compile = re._compile
-
+_real_compile = sre._compile
 
 def timed_compile(*args, **kwargs):
     """Log how long it takes to compile a regex"""
@@ -195,11 +177,11 @@
 def install():
     """Install the hooks for measuring import and regex compile time."""
     __builtins__['__import__'] = timed_import
-    re._compile = timed_compile
+    sre._compile = timed_compile
 
 
 def uninstall():
     """Remove the import and regex compile timing hooks."""
     __builtins__['__import__'] = _real_import
-    re._compile = _real_compile
+    sre._compile = _real_compile
 

=== modified file 'setup.py'
--- setup.py	2010-04-08 04:34:03 +0000
+++ setup.py	2009-12-30 23:09:23 +0000
@@ -37,7 +37,7 @@
     'version':      bzrlib.__version__,
     'author':       'Canonical Ltd',
     'author_email': 'bazaar@lists.canonical.com',
-    'url':          'http://bazaar.canonical.com/',
+    'url':          'http://www.bazaar-vcs.org/',
     'description':  'Friendly distributed version control system',
     'license':      'GNU GPL v2',
     'download_url': 'https://launchpad.net/bzr/+download',
@@ -186,7 +186,6 @@
     from distutils.command.build_ext import build_ext
 else:
     have_pyrex = True
-    pyrex_version_info = tuple(map(int, pyrex_version.split('.')))
 
 
 class build_ext_if_possible(build_ext):
@@ -283,13 +282,11 @@
     add_pyrex_extension('bzrlib._walkdirs_win32')
     z_lib = 'zdll'
 else:
-    if have_pyrex and pyrex_version_info[:3] == (0,9,4):
+    if have_pyrex and pyrex_version == '0.9.4.1':
         # Pyrex 0.9.4.1 fails to compile this extension correctly
         # The code it generates re-uses a "local" pointer and
         # calls "PY_DECREF" after having set it to NULL. (It mixes PY_XDECREF
         # which is NULL safe with PY_DECREF which is not.)
-        # <https://bugs.edge.launchpad.net/bzr/+bug/449372>
-        # <https://bugs.edge.launchpad.net/bzr/+bug/276868>
         print 'Cannot build extension "bzrlib._dirstate_helpers_pyx" using'
         print 'your version of pyrex "%s". Please upgrade your pyrex' % (
             pyrex_version,)
@@ -302,20 +299,9 @@
 add_pyrex_extension('bzrlib._chk_map_pyx', libraries=[z_lib])
 ext_modules.append(Extension('bzrlib._patiencediff_c',
                              ['bzrlib/_patiencediff_c.c']))
-if have_pyrex and pyrex_version_info < (0, 9, 6, 3):
-    print
-    print 'Your Pyrex/Cython version %s is too old to build the simple_set' % (
-        pyrex_version)
-    print 'and static_tuple extensions.'
-    print 'Please upgrade to at least Pyrex 0.9.6.3'
-    print
-    # TODO: Should this be a fatal error?
-else:
-    # We only need 0.9.6.3 to build _simple_set_pyx, but static_tuple depends
-    # on simple_set
-    add_pyrex_extension('bzrlib._simple_set_pyx')
-    ext_modules.append(Extension('bzrlib._static_tuple_c',
-                                 ['bzrlib/_static_tuple_c.c']))
+add_pyrex_extension('bzrlib._simple_set_pyx')
+ext_modules.append(Extension('bzrlib._static_tuple_c',
+                             ['bzrlib/_static_tuple_c.c']))
 add_pyrex_extension('bzrlib._btree_serializer_pyx')
 
 
@@ -470,7 +456,6 @@
 
 def get_svn_py2exe_info(includes, excludes, packages):
     packages.append('subvertpy')
-    packages.append('sqlite3')
 
 
 if 'bdist_wininst' in sys.argv:
@@ -554,7 +539,7 @@
                                      version = version_str,
                                      description = META_INFO['description'],
                                      author = META_INFO['author'],
-                                     copyright = "(c) Canonical Ltd, 2005-2010",
+                                     copyright = "(c) Canonical Ltd, 2005-2009",
                                      company_name = "Canonical Ltd.",
                                      comments = META_INFO['description'],
                                     )
@@ -573,7 +558,7 @@
     if sys.version.startswith('2.4'):
         # adding elementtree package
         additional_packages.add('elementtree')
-    elif sys.version.startswith('2.6') or sys.version.startswith('2.5'):
+    elif sys.version.startswith('2.5'):
         additional_packages.add('xml.etree')
     else:
         import warnings
@@ -625,11 +610,7 @@
             excludes.extend(["bzrlib.plugins." + d for d in dirs])
         x = []
         for i in files:
-            # Throw away files we don't want packaged. Note that plugins may
-            # have data files with all sorts of extensions so we need to
-            # be conservative here about what we ditch.
-            ext = os.path.splitext(i)[1]
-            if ext.endswith('~') or ext in [".pyc", ".swp"]:
+            if os.path.splitext(i)[1] not in [".py", ".pyd", ".dll", ".mo"]:
                 continue
             if i == '__init__.py' and root == 'bzrlib/plugins':
                 continue
@@ -712,19 +693,6 @@
         # easy_install one
         DATA_FILES = [('man/man1', ['bzr.1'])]
 
-    if sys.platform != 'win32':
-        # see https://wiki.kubuntu.org/Apport/DeveloperHowTo
-        #
-        # checking the paths and hardcoding the check for root is a bit gross,
-        # but I don't see a cleaner way to find out the locations in a way
-        # that's going to align with the hardcoded paths in apport.
-        if os.geteuid() == 0:
-            DATA_FILES += [
-                ('/usr/share/apport/package-hooks',
-                    ['apport/source_bzr.py']),
-                ('/etc/apport/crashdb.conf.d/',
-                    ['apport/bzr-crashdb.conf']),]
-
     # std setup
     ARGS = {'scripts': ['bzr'],
             'data_files': DATA_FILES,

=== added file 'tools/biobench.py'
--- tools/biobench.py	1970-01-01 00:00:00 +0000
+++ tools/biobench.py	2005-11-04 01:46:31 +0000
@@ -0,0 +1,92 @@
+#! /usr/bin/env python
+
+# (C) 2005 Canonical Ltd
+
+"""Benchmark for basicio
+
+Tries serializing an inventory to basic_io repeatedly.
+"""
+
+if True:
+    import psyco
+    psyco.full()
+
+
+import sys
+from timeit import Timer
+from tempfile import TemporaryFile, NamedTemporaryFile
+
+from bzrlib.branch import Branch
+from bzrlib.xml5 import serializer_v5
+from bzrlib.basicio import write_inventory, BasicWriter, \
+        read_inventory
+from bzrlib.inventory import Inventory, InventoryEntry, InventoryFile, ROOT_ID
+
+## b = Branch.open('.')
+## inv = b.get_inventory(b.last_revision())
+
+nrepeats = 3
+ntimes = 5
+NFILES = 30000
+
+def make_inventory():
+    inv = Inventory()
+    for i in range(NFILES):
+        ie = InventoryFile('%08d-id' % i, '%08d-file' % i, ROOT_ID)
+        ie.text_sha1='1212121212121212121212121212121212121212'
+        ie.text_size=12312
+        inv.add(ie)
+    return inv
+
+inv = make_inventory()
+
+bio_tmp = NamedTemporaryFile()
+xml_tmp = NamedTemporaryFile()
+
+def bio_test():
+    bio_tmp.seek(0)
+    w = BasicWriter(bio_tmp)
+    write_inventory(w, inv)
+    bio_tmp.seek(0)
+    new_inv = read_inventory(bio_tmp)
+
+def xml_test():
+    xml_tmp.seek(0)
+    serializer_v5.write_inventory(inv, xml_tmp)
+    xml_tmp.seek(0)
+    new_inv = serializer_v5.read_inventory(xml_tmp)
+
+def run_benchmark(function_name, tmp_file):
+    t = Timer(function_name + '()', 
+              'from __main__ import ' + function_name)
+    times = t.repeat(nrepeats, ntimes)
+    tmp_file.seek(0, 2)
+    size = tmp_file.tell()
+    print 'wrote inventory to %10s %5d times, each %6d bytes, total %6dkB' \
+            % (function_name, ntimes, size, (size * ntimes)>>10), 
+    each = (min(times)/ntimes*1000)
+    print 'in %.1fms each' % each 
+    return each
+
+def profileit(fn): 
+    import hotshot, hotshot.stats
+    prof_f = NamedTemporaryFile()
+    prof = hotshot.Profile(prof_f.name)
+    prof.runcall(fn) 
+    prof.close()
+    stats = hotshot.stats.load(prof_f.name)
+    #stats.strip_dirs()
+    stats.sort_stats('time')
+    ## XXX: Might like to write to stderr or the trace file instead but
+    ## print_stats seems hardcoded to stdout
+    stats.print_stats(20)
+
+if '-p' in sys.argv[1:]:
+    profileit(bio_test)
+else:
+    bio_each = run_benchmark('bio_test', bio_tmp)
+    xml_each = run_benchmark('xml_test', xml_tmp)
+    print 'so bio is %.1f%% faster' % (100 * ((xml_each / bio_each) - 1))
+
+# make sure it was a fair comparison
+# assert 'cElementTree' in sys.modules

=== added file 'tools/history2revfiles.py'
--- tools/history2revfiles.py	1970-01-01 00:00:00 +0000
+++ tools/history2revfiles.py	2009-03-23 14:59:43 +0000
@@ -0,0 +1,99 @@
+#! /usr/bin/python
+
+# Copyright (C) 2005 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Experiment in converting existing bzr branches to weaves."""
+
+
+import bzrlib.branch
+from bzrlib.revfile import Revfile
+from bzrlib.progress import ProgressBar
+import tempfile
+import hotshot, hotshot.stats
+import sys
+
+def convert():
+    pb = ProgressBar()
+
+    inv_rf = Revfile('revfiles/inventory', 'w')
+    last_text_sha = {}
+    text_rfs = {}
+
+    b = bzrlib.branch.find_branch('.')
+
+    revno = 1
+    rev_history = b.revision_history()
+    last_idx = None
+    for rev_id in rev_history:
+        pb.update('converting inventory', revno, len(rev_history))
+        inv_xml = b.get_inventory_xml(rev_id).read()
+        new_idx = inv_rf.add(inv_xml, last_idx, compress=False)
+
+        tree = b.revision_tree(rev_id)
+        inv = tree.inventory
+
+        # for each file in the inventory, put it into its own revfile
+        for file_id in inv:
+            ie = inv[file_id]
+            if ie.kind != 'file':
+                continue
+            if last_text_sha.get(file_id) == ie.text_sha1:
+                # same as last time
+                continue
+            last_text_sha[file_id] = ie.text_sha1
+
+            # new text (though possibly already stored); need to store it
+            text = tree.get_file(file_id).read()
+            
+            if file_id not in text_rfs:
+                text_rfs[file_id] = Revfile('revfiles/' + file_id, 'w')
+            rf = text_rfs[file_id]
+
+            last = len(rf)
+            if last == 0:
+                last = None
+            else:
+                last -= 1
+            rf.add(text, last, compress=True)
+        
+        last_idx = new_idx
+        revno += 1
+
+    pb.clear()
+
+
+def profile_convert(): 
+    prof_f = tempfile.NamedTemporaryFile()
+
+    prof = hotshot.Profile(prof_f.name)
+
+    prof.runcall(convert) 
+    prof.close()
+
+    stats = hotshot.stats.load(prof_f.name)
+    #stats.strip_dirs()
+    stats.sort_stats('time')
+    ## XXX: Might like to write to stderr or the trace file instead but
+    ## print_stats seems hardcoded to stdout
+    stats.print_stats(20)
+            
+
+if '-p' in sys.argv[1:]:
+    profile_convert()
+else:
+    convert()
+    

=== modified file 'tools/win32/bzr_postinstall.py'
--- tools/win32/bzr_postinstall.py	2010-02-04 16:06:36 +0000
+++ tools/win32/bzr_postinstall.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009, 2010 by Canonical Ltd
+# Copyright (C) 2005 by Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -341,7 +341,7 @@
                          "this library manually and put it to directory\n"
                          "where Bzr installed.\n"
                          "For detailed instructions see:\n"
-                         "http://wiki.bazaar.canonical.com/BzrOnPureWindows"
+                         "http://bazaar-vcs.org/BzrOnPureWindows"
                         ),
                         "Warning",
                         MB_OK | MB_ICONEXCLAMATION)

=== modified file 'tools/win32/info.txt'
--- tools/win32/info.txt	2010-03-30 20:13:52 +0000
+++ tools/win32/info.txt	2006-10-14 08:51:07 +0000
@@ -1,3 +1,4 @@
+
 Bazaar is free software; you can redistribute and/or modify it under
 the terms of the GNU General Public License version 2. 
 

